// Dafny 2.3.0.10506
// Command Line Options: /compile:0 /timeLimit:1 /print:boogies/lib-Buckets-PackedKV.i.dfy.bpl /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type Ty;

type Bv0 = int;

const unique TBool: Ty;

const unique TChar: Ty;

const unique TInt: Ty;

const unique TReal: Ty;

const unique TORDINAL: Ty;

function TBitvector(int) : Ty;

function TSet(Ty) : Ty;

function TISet(Ty) : Ty;

function TMultiSet(Ty) : Ty;

function TSeq(Ty) : Ty;

function TMap(Ty, Ty) : Ty;

function TIMap(Ty, Ty) : Ty;

function Inv0_TBitvector(Ty) : int;

axiom (forall w: int :: { TBitvector(w) } Inv0_TBitvector(TBitvector(w)) == w);

function Inv0_TSet(Ty) : Ty;

axiom (forall t: Ty :: { TSet(t) } Inv0_TSet(TSet(t)) == t);

function Inv0_TISet(Ty) : Ty;

axiom (forall t: Ty :: { TISet(t) } Inv0_TISet(TISet(t)) == t);

function Inv0_TSeq(Ty) : Ty;

axiom (forall t: Ty :: { TSeq(t) } Inv0_TSeq(TSeq(t)) == t);

function Inv0_TMultiSet(Ty) : Ty;

axiom (forall t: Ty :: { TMultiSet(t) } Inv0_TMultiSet(TMultiSet(t)) == t);

function Inv0_TMap(Ty) : Ty;

function Inv1_TMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv0_TMap(TMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv1_TMap(TMap(t, u)) == u);

function Inv0_TIMap(Ty) : Ty;

function Inv1_TIMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv0_TIMap(TIMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv1_TIMap(TIMap(t, u)) == u);

type TyTag;

function Tag(Ty) : TyTag;

const unique TagBool: TyTag;

const unique TagChar: TyTag;

const unique TagInt: TyTag;

const unique TagReal: TyTag;

const unique TagORDINAL: TyTag;

const unique TagSet: TyTag;

const unique TagISet: TyTag;

const unique TagMultiSet: TyTag;

const unique TagSeq: TyTag;

const unique TagMap: TyTag;

const unique TagIMap: TyTag;

const unique TagClass: TyTag;

axiom Tag(TBool) == TagBool;

axiom Tag(TChar) == TagChar;

axiom Tag(TInt) == TagInt;

axiom Tag(TReal) == TagReal;

axiom Tag(TORDINAL) == TagORDINAL;

axiom (forall t: Ty :: { TSet(t) } Tag(TSet(t)) == TagSet);

axiom (forall t: Ty :: { TISet(t) } Tag(TISet(t)) == TagISet);

axiom (forall t: Ty :: { TMultiSet(t) } Tag(TMultiSet(t)) == TagMultiSet);

axiom (forall t: Ty :: { TSeq(t) } Tag(TSeq(t)) == TagSeq);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Tag(TMap(t, u)) == TagMap);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Tag(TIMap(t, u)) == TagIMap);

function {:identity} Lit<T>(x: T) : T;

axiom (forall<T> x: T :: {:identity} { Lit(x): T } Lit(x): T == x);

axiom (forall<T> x: T :: { $Box(Lit(x)) } $Box(Lit(x)) == Lit($Box(x)));

function {:identity} LitInt(x: int) : int;

axiom (forall x: int :: {:identity} { LitInt(x): int } LitInt(x): int == x);

axiom (forall x: int :: { $Box(LitInt(x)) } $Box(LitInt(x)) == Lit($Box(x)));

function {:identity} LitReal(x: real) : real;

axiom (forall x: real :: {:identity} { LitReal(x): real } LitReal(x): real == x);

axiom (forall x: real :: { $Box(LitReal(x)) } $Box(LitReal(x)) == Lit($Box(x)));

type char;

function char#FromInt(int) : char;

function char#ToInt(char) : int;

axiom (forall ch: char :: 
  { char#ToInt(ch) } 
  char#FromInt(char#ToInt(ch)) == ch
     && 0 <= char#ToInt(ch)
     && char#ToInt(ch) < 65536);

axiom (forall n: int :: 
  { char#FromInt(n) } 
  0 <= n && n < 65536 ==> char#ToInt(char#FromInt(n)) == n);

function char#Plus(char, char) : char;

function char#Minus(char, char) : char;

axiom (forall a: char, b: char :: 
  { char#Plus(a, b) } 
  char#Plus(a, b) == char#FromInt(char#ToInt(a) + char#ToInt(b)));

axiom (forall a: char, b: char :: 
  { char#Minus(a, b) } 
  char#Minus(a, b) == char#FromInt(char#ToInt(a) - char#ToInt(b)));

type ref;

const null: ref;

function IsTraitParent(classOrTrait: ClassName, traitParent: ClassName) : bool;

type Box;

const $ArbitraryBoxValue: Box;

function $Box<T>(T) : Box;

function $Unbox<T>(Box) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall bx: Box :: 
  { $IsBox(bx, TInt) } 
  $IsBox(bx, TInt) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, TInt));

axiom (forall bx: Box :: 
  { $IsBox(bx, TReal) } 
  $IsBox(bx, TReal)
     ==> $Box($Unbox(bx): real) == bx && $Is($Unbox(bx): real, TReal));

axiom (forall bx: Box :: 
  { $IsBox(bx, TBool) } 
  $IsBox(bx, TBool)
     ==> $Box($Unbox(bx): bool) == bx && $Is($Unbox(bx): bool, TBool));

axiom (forall bx: Box :: 
  { $IsBox(bx, TChar) } 
  $IsBox(bx, TChar)
     ==> $Box($Unbox(bx): char) == bx && $Is($Unbox(bx): char, TChar));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSet(t)) } 
  $IsBox(bx, TSet(t))
     ==> $Box($Unbox(bx): Set Box) == bx && $Is($Unbox(bx): Set Box, TSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TISet(t)) } 
  $IsBox(bx, TISet(t))
     ==> $Box($Unbox(bx): ISet Box) == bx && $Is($Unbox(bx): ISet Box, TISet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TMultiSet(t)) } 
  $IsBox(bx, TMultiSet(t))
     ==> $Box($Unbox(bx): MultiSet Box) == bx
       && $Is($Unbox(bx): MultiSet Box, TMultiSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSeq(t)) } 
  $IsBox(bx, TSeq(t))
     ==> $Box($Unbox(bx): Seq Box) == bx && $Is($Unbox(bx): Seq Box, TSeq(t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TMap(s, t)) } 
  $IsBox(bx, TMap(s, t))
     ==> $Box($Unbox(bx): Map Box Box) == bx && $Is($Unbox(bx): Map Box Box, TMap(s, t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TIMap(s, t)) } 
  $IsBox(bx, TIMap(s, t))
     ==> $Box($Unbox(bx): IMap Box Box) == bx
       && $Is($Unbox(bx): IMap Box Box, TIMap(s, t)));

axiom (forall<T> v: T, t: Ty :: 
  { $IsBox($Box(v), t) } 
  $IsBox($Box(v), t) <==> $Is(v, t));

axiom (forall<T> v: T, t: Ty, h: Heap :: 
  { $IsAllocBox($Box(v), t, h) } 
  $IsAllocBox($Box(v), t, h) <==> $IsAlloc(v, t, h));

function $Is<T>(T, Ty) : bool;

function $IsAlloc<T>(T, Ty, Heap) : bool;

function $IsBox<T>(T, Ty) : bool;

function $IsAllocBox<T>(T, Ty, Heap) : bool;

axiom (forall v: int :: { $Is(v, TInt) } $Is(v, TInt));

axiom (forall v: real :: { $Is(v, TReal) } $Is(v, TReal));

axiom (forall v: bool :: { $Is(v, TBool) } $Is(v, TBool));

axiom (forall v: char :: { $Is(v, TChar) } $Is(v, TChar));

axiom (forall v: ORDINAL :: { $Is(v, TORDINAL) } $Is(v, TORDINAL));

axiom (forall h: Heap, v: int :: { $IsAlloc(v, TInt, h) } $IsAlloc(v, TInt, h));

axiom (forall h: Heap, v: real :: { $IsAlloc(v, TReal, h) } $IsAlloc(v, TReal, h));

axiom (forall h: Heap, v: bool :: { $IsAlloc(v, TBool, h) } $IsAlloc(v, TBool, h));

axiom (forall h: Heap, v: char :: { $IsAlloc(v, TChar, h) } $IsAlloc(v, TChar, h));

axiom (forall h: Heap, v: ORDINAL :: 
  { $IsAlloc(v, TORDINAL, h) } 
  $IsAlloc(v, TORDINAL, h));

axiom (forall v: Set Box, t0: Ty :: 
  { $Is(v, TSet(t0)) } 
  $Is(v, TSet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: ISet Box, t0: Ty :: 
  { $Is(v, TISet(t0)) } 
  $Is(v, TISet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0))
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0)) ==> $IsGoodMultiSet(v));

axiom (forall v: Seq Box, t0: Ty :: 
  { $Is(v, TSeq(t0)) } 
  $Is(v, TSeq(t0))
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsBox(Seq#Index(v, i), t0)));

axiom (forall v: Set Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSet(t0), h) } 
  $IsAlloc(v, TSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: ISet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TISet(t0), h) } 
  $IsAlloc(v, TISet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: MultiSet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TMultiSet(t0), h) } 
  $IsAlloc(v, TMultiSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: Seq Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSeq(t0), h) } 
  $IsAlloc(v, TSeq(t0), h)
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsAllocBox(Seq#Index(v, i), t0, h)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TMap(t0, t1)) } 
  $Is(v, TMap(t0, t1))
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx] ==> $IsBox(Map#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TMap(t0, t1), h) } 
  $IsAlloc(v, TMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx]
         ==> $IsAllocBox(Map#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TIMap(t0, t1)) } 
  $Is(v, TIMap(t0, t1))
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx] ==> $IsBox(IMap#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TIMap(t0, t1), h) } 
  $IsAlloc(v, TIMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx]
         ==> $IsAllocBox(IMap#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

type ClassName;

const unique class._System.int: ClassName;

const unique class._System.bool: ClassName;

const unique class._System.set: ClassName;

const unique class._System.seq: ClassName;

const unique class._System.multiset: ClassName;

function Tclass._System.object?() : Ty;

function dtype(ref) : Ty;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: 
  { TypeTuple(a, b) } 
  TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type HandleType;

function SetRef_to_SetBox(s: [ref]bool) : Set Box;

axiom (forall s: [ref]bool, bx: Box :: 
  { SetRef_to_SetBox(s)[bx] } 
  SetRef_to_SetBox(s)[bx] == s[$Unbox(bx): ref]);

axiom (forall s: [ref]bool :: 
  { SetRef_to_SetBox(s) } 
  $Is(SetRef_to_SetBox(s), TSet(Tclass._System.object?())));

function Apply1(Ty, Ty, Heap, HandleType, Box) : Box;

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

function BoxRank(Box) : int;

axiom (forall d: DatatypeType :: { BoxRank($Box(d)) } BoxRank($Box(d)) == DtRank(d));

type ORDINAL = Box;

function ORD#IsNat(ORDINAL) : bool;

function ORD#Offset(ORDINAL) : int;

axiom (forall o: ORDINAL :: { ORD#Offset(o) } 0 <= ORD#Offset(o));

function {:inline} ORD#IsLimit(o: ORDINAL) : bool
{
  ORD#Offset(o) == 0
}

function {:inline} ORD#IsSucc(o: ORDINAL) : bool
{
  0 < ORD#Offset(o)
}

function ORD#FromNat(int) : ORDINAL;

axiom (forall n: int :: 
  { ORD#FromNat(n) } 
  0 <= n ==> ORD#IsNat(ORD#FromNat(n)) && ORD#Offset(ORD#FromNat(n)) == n);

axiom (forall o: ORDINAL :: 
  { ORD#Offset(o) } { ORD#IsNat(o) } 
  ORD#IsNat(o) ==> o == ORD#FromNat(ORD#Offset(o)));

function ORD#Less(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p) } 
  (ORD#Less(o, p) ==> o != p)
     && (ORD#IsNat(o) && !ORD#IsNat(p) ==> ORD#Less(o, p))
     && (ORD#IsNat(o) && ORD#IsNat(p)
       ==> ORD#Less(o, p) == (ORD#Offset(o) < ORD#Offset(p)))
     && (ORD#Less(o, p) && ORD#IsNat(p) ==> ORD#IsNat(o)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, o) } 
  ORD#Less(o, p) || o == p || ORD#Less(p, o));

axiom (forall o: ORDINAL, p: ORDINAL, r: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, r) } { ORD#Less(o, p), ORD#Less(o, r) } 
  ORD#Less(o, p) && ORD#Less(p, r) ==> ORD#Less(o, r));

function ORD#LessThanLimit(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#LessThanLimit(o, p) } 
  ORD#LessThanLimit(o, p) == ORD#Less(o, p));

function ORD#Plus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (ORD#IsNat(ORD#Plus(o, p)) ==> ORD#IsNat(o) && ORD#IsNat(p))
     && (ORD#IsNat(p)
       ==> ORD#IsNat(ORD#Plus(o, p)) == ORD#IsNat(o)
         && ORD#Offset(ORD#Plus(o, p)) == ORD#Offset(o) + ORD#Offset(p)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#Plus(o, p) || ORD#Less(o, ORD#Plus(o, p)))
     && (p == ORD#Plus(o, p) || ORD#Less(p, ORD#Plus(o, p))));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#FromNat(0) ==> ORD#Plus(o, p) == p)
     && (p == ORD#FromNat(0) ==> ORD#Plus(o, p) == o));

function ORD#Minus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> ORD#IsNat(ORD#Minus(o, p)) == ORD#IsNat(o)
       && ORD#Offset(ORD#Minus(o, p)) == ORD#Offset(o) - ORD#Offset(p));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> (p == ORD#FromNat(0) && ORD#Minus(o, p) == o)
       || (p != ORD#FromNat(0) && ORD#Less(ORD#Minus(o, p), o)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n
     ==> ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Plus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && m + n <= ORD#Offset(o)
     ==> ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Minus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(n - m))));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(n - m))));

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

type LayerType;

const $LZ: LayerType;

function $LS(LayerType) : LayerType;

function AsFuelBottom(LayerType) : LayerType;

function AtLayer<A>([LayerType]A, LayerType) : A;

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, ly) } 
  AtLayer(f, ly) == f[ly]);

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, $LS(ly)) } 
  AtLayer(f, $LS(ly)) == AtLayer(f, ly));

type Field _;

function FDim<T>(Field T) : int;

function IndexField(int) : Field Box;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field Box, int) : Field Box;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  MultiIndexField_Inverse0(MultiIndexField(f, i)) == f
     && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

type NameFamily;

function DeclName<T>(Field T) : NameFamily;

function FieldOfDecl<alpha>(ClassName, NameFamily) : Field alpha;

axiom (forall<T> cl: ClassName, nm: NameFamily :: 
  { FieldOfDecl(cl, nm): Field T } 
  DeclType(FieldOfDecl(cl, nm): Field T) == cl
     && DeclName(FieldOfDecl(cl, nm): Field T) == nm);

function $IsGhostField<T>(Field T) : bool;

axiom (forall<T> h: Heap, k: Heap, v: T, t: Ty :: 
  { $HeapSucc(h, k), $IsAlloc(v, t, h) } 
  $HeapSucc(h, k) ==> $IsAlloc(v, t, h) ==> $IsAlloc(v, t, k));

axiom (forall h: Heap, k: Heap, bx: Box, t: Ty :: 
  { $HeapSucc(h, k), $IsAllocBox(bx, t, h) } 
  $HeapSucc(h, k) ==> $IsAllocBox(bx, t, h) ==> $IsAllocBox(bx, t, k));

const unique alloc: Field bool;

const unique allocName: NameFamily;

axiom FDim(alloc) == 0 && DeclName(alloc) == allocName && !$IsGhostField(alloc);

function _System.array.Length(a: ref) : int;

axiom (forall o: ref :: 0 <= _System.array.Length(o));

function Int(x: real) : int;

axiom (forall x: real :: { Int(x): int } Int(x): int == int(x));

function Real(x: int) : real;

axiom (forall x: int :: { Real(x): real } Real(x): real == real(x));

axiom (forall i: int :: { Int(Real(i)) } Int(Real(i)) == i);

function {:inline} _System.real.Floor(x: real) : int
{
  Int(x)
}

type Heap = [ref]<alpha>[Field alpha]alpha;

function {:inline} read<alpha>(H: Heap, r: ref, f: Field alpha) : alpha
{
  H[r][f]
}

function {:inline} update<alpha>(H: Heap, r: ref, f: Field alpha, v: alpha) : Heap
{
  H[r := H[r][f := v]]
}

function $IsGoodHeap(Heap) : bool;

function $IsHeapAnchor(Heap) : bool;

var $Heap: Heap where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap);

const $OneHeap: Heap;

axiom $IsGoodHeap($OneHeap);

function $HeapSucc(Heap, Heap) : bool;

axiom (forall<alpha> h: Heap, r: ref, f: Field alpha, x: alpha :: 
  { update(h, r, f, x) } 
  $IsGoodHeap(update(h, r, f, x)) ==> $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: Heap, b: Heap, c: Heap :: 
  { $HeapSucc(a, b), $HeapSucc(b, c) } 
  a != c ==> $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: Heap, k: Heap :: 
  { $HeapSucc(h, k) } 
  $HeapSucc(h, k)
     ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

function $HeapSuccGhost(Heap, Heap) : bool;

axiom (forall h: Heap, k: Heap :: 
  { $HeapSuccGhost(h, k) } 
  $HeapSuccGhost(h, k)
     ==> $HeapSucc(h, k)
       && (forall<alpha> o: ref, f: Field alpha :: 
        { read(k, o, f) } 
        !$IsGhostField(f) ==> read(h, o, f) == read(k, o, f)));

type TickType;

var $Tick: TickType;

procedure $YieldHavoc(this: ref, rds: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      $o == this || rds[$Box($o)] || nw[$Box($o)]
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc0(this: ref, rds: Set Box, modi: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      rds[$Box($o)] && !modi[$Box($o)] && $o != this
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc1(this: ref, modi: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)
         || $o == this
         || modi[$Box($o)]
         || nw[$Box($o)]);
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterCollectNewObjects(prevHeap: Heap, newHeap: Heap, this: ref, NW: Field (Set Box))
   returns (s: Set Box);
  ensures (forall bx: Box :: 
    { s[bx] } 
    s[bx]
       <==> read(newHeap, this, NW)[bx]
         || (
          $Unbox(bx) != null
           && !read(prevHeap, $Unbox(bx): ref, alloc)
           && read(newHeap, $Unbox(bx): ref, alloc)));



type Set T = [T]bool;

function Set#Card<T>(Set T) : int;

axiom (forall<T> s: Set T :: { Set#Card(s) } 0 <= Set#Card(s));

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

axiom (forall<T> s: Set T :: 
  { Set#Card(s) } 
  (Set#Card(s) == 0 <==> s == Set#Empty())
     && (Set#Card(s) != 0 ==> (exists x: T :: s[x])));

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: 
  { Set#Singleton(r)[o] } 
  Set#Singleton(r)[o] <==> r == o);

axiom (forall<T> r: T :: 
  { Set#Card(Set#Singleton(r)) } 
  Set#Card(Set#Singleton(r)) == 1);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: 
  { Set#UnionOne(a, x)[o] } 
  Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: 
  { Set#UnionOne(a, x), a[y] } 
  a[y] ==> Set#UnionOne(a, x)[y]);

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a));

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  !a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a) + 1);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Union(a, b)[o] } 
  Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), a[y] } 
  a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), b[y] } 
  b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, b) } 
  Set#Disjoint(a, b)
     ==> Set#Difference(Set#Union(a, b), a) == b
       && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Intersection(a, b)[o] } 
  Set#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(Set#Union(a, b), b) } 
  Set#Union(Set#Union(a, b), b) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, Set#Union(a, b)) } 
  Set#Union(a, Set#Union(a, b)) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(Set#Intersection(a, b), b) } 
  Set#Intersection(Set#Intersection(a, b), b) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(a, Set#Intersection(a, b)) } 
  Set#Intersection(a, Set#Intersection(a, b)) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Union(a, b)) } { Set#Card(Set#Intersection(a, b)) } 
  Set#Card(Set#Union(a, b)) + Set#Card(Set#Intersection(a, b))
     == Set#Card(a) + Set#Card(b));

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Difference(a, b)[o] } 
  Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Difference(a, b), b[y] } 
  b[y] ==> !Set#Difference(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Difference(a, b)) } 
  Set#Card(Set#Difference(a, b))
         + Set#Card(Set#Difference(b, a))
         + Set#Card(Set#Intersection(a, b))
       == Set#Card(Set#Union(a, b))
     && Set#Card(Set#Difference(a, b)) == Set#Card(a) - Set#Card(Set#Intersection(a, b)));

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Subset(a, b) } 
  Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Equal(a, b) } 
  Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Disjoint(a, b) } 
  Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type ISet T = [T]bool;

function ISet#Empty<T>() : Set T;

axiom (forall<T> o: T :: { ISet#Empty()[o] } !ISet#Empty()[o]);

function ISet#UnionOne<T>(ISet T, T) : ISet T;

axiom (forall<T> a: ISet T, x: T, o: T :: 
  { ISet#UnionOne(a, x)[o] } 
  ISet#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: ISet T, x: T :: { ISet#UnionOne(a, x) } ISet#UnionOne(a, x)[x]);

axiom (forall<T> a: ISet T, x: T, y: T :: 
  { ISet#UnionOne(a, x), a[y] } 
  a[y] ==> ISet#UnionOne(a, x)[y]);

function ISet#Union<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Union(a, b)[o] } 
  ISet#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Union(a, b), a[y] } 
  a[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { ISet#Union(a, b), b[y] } 
  b[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(a, b) } 
  ISet#Disjoint(a, b)
     ==> ISet#Difference(ISet#Union(a, b), a) == b
       && ISet#Difference(ISet#Union(a, b), b) == a);

function ISet#Intersection<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Intersection(a, b)[o] } 
  ISet#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(ISet#Union(a, b), b) } 
  ISet#Union(ISet#Union(a, b), b) == ISet#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { ISet#Union(a, ISet#Union(a, b)) } 
  ISet#Union(a, ISet#Union(a, b)) == ISet#Union(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(ISet#Intersection(a, b), b) } 
  ISet#Intersection(ISet#Intersection(a, b), b) == ISet#Intersection(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(a, ISet#Intersection(a, b)) } 
  ISet#Intersection(a, ISet#Intersection(a, b)) == ISet#Intersection(a, b));

function ISet#Difference<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Difference(a, b)[o] } 
  ISet#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Difference(a, b), b[y] } 
  b[y] ==> !ISet#Difference(a, b)[y]);

function ISet#Subset<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Subset(a, b) } 
  ISet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function ISet#Equal<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) ==> a == b);

function ISet#Disjoint<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Disjoint(a, b) } 
  ISet#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

function Math#min(a: int, b: int) : int;

axiom (forall a: int, b: int :: { Math#min(a, b) } a <= b <==> Math#min(a, b) == a);

axiom (forall a: int, b: int :: { Math#min(a, b) } b <= a <==> Math#min(a, b) == b);

axiom (forall a: int, b: int :: 
  { Math#min(a, b) } 
  Math#min(a, b) == a || Math#min(a, b) == b);

function Math#clip(a: int) : int;

axiom (forall a: int :: { Math#clip(a) } 0 <= a ==> Math#clip(a) == a);

axiom (forall a: int :: { Math#clip(a) } a < 0 ==> Math#clip(a) == 0);

type MultiSet T = [T]int;

function $IsGoodMultiSet<T>(ms: MultiSet T) : bool;

axiom (forall<T> ms: MultiSet T :: 
  { $IsGoodMultiSet(ms) } 
  $IsGoodMultiSet(ms)
     <==> (forall bx: T :: { ms[bx] } 0 <= ms[bx] && ms[bx] <= MultiSet#Card(ms)));

function MultiSet#Card<T>(MultiSet T) : int;

axiom (forall<T> s: MultiSet T :: { MultiSet#Card(s) } 0 <= MultiSet#Card(s));

axiom (forall<T> s: MultiSet T, x: T, n: int :: 
  { MultiSet#Card(s[x := n]) } 
  0 <= n ==> MultiSet#Card(s[x := n]) == MultiSet#Card(s) - s[x] + n);

function MultiSet#Empty<T>() : MultiSet T;

axiom (forall<T> o: T :: { MultiSet#Empty()[o] } MultiSet#Empty()[o] == 0);

axiom (forall<T> s: MultiSet T :: 
  { MultiSet#Card(s) } 
  (MultiSet#Card(s) == 0 <==> s == MultiSet#Empty())
     && (MultiSet#Card(s) != 0 ==> (exists x: T :: 0 < s[x])));

function MultiSet#Singleton<T>(T) : MultiSet T;

axiom (forall<T> r: T, o: T :: 
  { MultiSet#Singleton(r)[o] } 
  (MultiSet#Singleton(r)[o] == 1 <==> r == o)
     && (MultiSet#Singleton(r)[o] == 0 <==> r != o));

axiom (forall<T> r: T :: 
  { MultiSet#Singleton(r) } 
  MultiSet#Singleton(r) == MultiSet#UnionOne(MultiSet#Empty(), r));

function MultiSet#UnionOne<T>(MultiSet T, T) : MultiSet T;

axiom (forall<T> a: MultiSet T, x: T, o: T :: 
  { MultiSet#UnionOne(a, x)[o] } 
  0 < MultiSet#UnionOne(a, x)[o] <==> o == x || 0 < a[o]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#UnionOne(a, x) } 
  MultiSet#UnionOne(a, x)[x] == a[x] + 1);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  0 < a[y] ==> 0 < MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  x != y ==> a[y] == MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#Card(MultiSet#UnionOne(a, x)) } 
  MultiSet#Card(MultiSet#UnionOne(a, x)) == MultiSet#Card(a) + 1);

function MultiSet#Union<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Union(a, b)[o] } 
  MultiSet#Union(a, b)[o] == a[o] + b[o]);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Union(a, b)) } 
  MultiSet#Card(MultiSet#Union(a, b)) == MultiSet#Card(a) + MultiSet#Card(b));

function MultiSet#Intersection<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Intersection(a, b)[o] } 
  MultiSet#Intersection(a, b)[o] == Math#min(a[o], b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(MultiSet#Intersection(a, b), b) } 
  MultiSet#Intersection(MultiSet#Intersection(a, b), b)
     == MultiSet#Intersection(a, b));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(a, MultiSet#Intersection(a, b)) } 
  MultiSet#Intersection(a, MultiSet#Intersection(a, b))
     == MultiSet#Intersection(a, b));

function MultiSet#Difference<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Difference(a, b)[o] } 
  MultiSet#Difference(a, b)[o] == Math#clip(a[o] - b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T, y: T :: 
  { MultiSet#Difference(a, b), b[y], a[y] } 
  a[y] <= b[y] ==> MultiSet#Difference(a, b)[y] == 0);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Difference(a, b)) } 
  MultiSet#Card(MultiSet#Difference(a, b))
         + MultiSet#Card(MultiSet#Difference(b, a))
         + 2 * MultiSet#Card(MultiSet#Intersection(a, b))
       == MultiSet#Card(MultiSet#Union(a, b))
     && MultiSet#Card(MultiSet#Difference(a, b))
       == MultiSet#Card(a) - MultiSet#Card(MultiSet#Intersection(a, b)));

function MultiSet#Subset<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Subset(a, b) } 
  MultiSet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <= b[o]));

function MultiSet#Equal<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] == b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) ==> a == b);

function MultiSet#Disjoint<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Disjoint(a, b) } 
  MultiSet#Disjoint(a, b)
     <==> (forall o: T :: { a[o] } { b[o] } a[o] == 0 || b[o] == 0));

function MultiSet#FromSet<T>(Set T) : MultiSet T;

axiom (forall<T> s: Set T, a: T :: 
  { MultiSet#FromSet(s)[a] } 
  (MultiSet#FromSet(s)[a] == 0 <==> !s[a])
     && (MultiSet#FromSet(s)[a] == 1 <==> s[a]));

axiom (forall<T> s: Set T :: 
  { MultiSet#Card(MultiSet#FromSet(s)) } 
  MultiSet#Card(MultiSet#FromSet(s)) == Set#Card(s));

function MultiSet#FromSeq<T>(Seq T) : MultiSet T;

axiom (forall<T> s: Seq T :: 
  { MultiSet#FromSeq(s) } 
  $IsGoodMultiSet(MultiSet#FromSeq(s)));

axiom (forall<T> s: Seq T :: 
  { MultiSet#Card(MultiSet#FromSeq(s)) } 
  MultiSet#Card(MultiSet#FromSeq(s)) == Seq#Length(s));

axiom (forall<T> s: Seq T, v: T :: 
  { MultiSet#FromSeq(Seq#Build(s, v)) } 
  MultiSet#FromSeq(Seq#Build(s, v)) == MultiSet#UnionOne(MultiSet#FromSeq(s), v));

axiom (forall<T>  :: 
  MultiSet#FromSeq(Seq#Empty(): Seq T) == MultiSet#Empty(): MultiSet T);

axiom (forall<T> a: Seq T, b: Seq T :: 
  { MultiSet#FromSeq(Seq#Append(a, b)) } 
  MultiSet#FromSeq(Seq#Append(a, b))
     == MultiSet#Union(MultiSet#FromSeq(a), MultiSet#FromSeq(b)));

axiom (forall<T> s: Seq T, i: int, v: T, x: T :: 
  { MultiSet#FromSeq(Seq#Update(s, i, v))[x] } 
  0 <= i && i < Seq#Length(s)
     ==> MultiSet#FromSeq(Seq#Update(s, i, v))[x]
       == MultiSet#Union(MultiSet#Difference(MultiSet#FromSeq(s), MultiSet#Singleton(Seq#Index(s, i))), 
        MultiSet#Singleton(v))[x]);

axiom (forall<T> s: Seq T, x: T :: 
  { MultiSet#FromSeq(s)[x] } 
  (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && x == Seq#Index(s, i))
     <==> 0 < MultiSet#FromSeq(s)[x]);

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: { Seq#Empty(): Seq T } Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: 
  { Seq#Length(s) } 
  Seq#Length(s) == 0 ==> s == Seq#Empty());

axiom (forall<T> t: Ty :: { $Is(Seq#Empty(): Seq T, t) } $Is(Seq#Empty(): Seq T, t));

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: 
  { Seq#Length(Seq#Singleton(t)) } 
  Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, val: T) : Seq T;

function Seq#Build_inv0<T>(s: Seq T) : Seq T;

function Seq#Build_inv1<T>(s: Seq T) : T;

axiom (forall<T> s: Seq T, val: T :: 
  { Seq#Build(s, val) } 
  Seq#Build_inv0(Seq#Build(s, val)) == s
     && Seq#Build_inv1(Seq#Build(s, val)) == val);

axiom (forall<T> s: Seq T, v: T :: 
  { Seq#Build(s, v) } 
  Seq#Length(Seq#Build(s, v)) == 1 + Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Index(Seq#Build(s, v), i) } 
  (i == Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == v)
     && (i != Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == Seq#Index(s, i)));

axiom (forall s: Seq Box, bx: Box, t: Ty :: 
  { $Is(Seq#Build(s, bx), TSeq(t)) } 
  $Is(s, TSeq(t)) && $IsBox(bx, t) ==> $Is(Seq#Build(s, bx), TSeq(t)));

function Seq#Create(ty: Ty, heap: Heap, len: int, init: HandleType) : Seq Box;

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType :: 
  { Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) } 
  $IsGoodHeap(heap) && 0 <= len
     ==> Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) == len);

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType, i: int :: 
  { Seq#Index(Seq#Create(ty, heap, len, init), i) } 
  $IsGoodHeap(heap) && 0 <= i && i < len
     ==> Seq#Index(Seq#Create(ty, heap, len, init), i)
       == Apply1(TInt, TSeq(ty), heap, init, $Box(i)));

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Length(Seq#Append(s0, s1)) } 
  Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

axiom (forall s0: Seq Box, s1: Seq Box, t: Ty :: 
  { $Is(Seq#Append(s0, s1), t) } 
  $Is(s0, t) && $Is(s1, t) ==> $Is(Seq#Append(s0, s1), t));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: 
  { Seq#Index(Seq#Singleton(t), 0) } 
  Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#Index(Seq#Append(s0, s1), n) } 
  (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n))
     && (Seq#Length(s0) <= n
       ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Length(Seq#Update(s, i, v)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Index(Seq#Update(s, i, v), n) } 
  0 <= n && n < Seq#Length(s)
     ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v)
       && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: 
  { Seq#Contains(s, x) } 
  Seq#Contains(s, x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> x: T :: 
  { Seq#Contains(Seq#Empty(), x) } 
  !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: 
  { Seq#Contains(Seq#Append(s0, s1), x) } 
  Seq#Contains(Seq#Append(s0, s1), x)
     <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, v: T, x: T :: 
  { Seq#Contains(Seq#Build(s, v), x) } 
  Seq#Contains(Seq#Build(s, v), x) <==> v == x || Seq#Contains(s, x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Take(s, n), x) } 
  Seq#Contains(Seq#Take(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Drop(s, n), x) } 
  Seq#Contains(Seq#Drop(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Equal(s0, s1) } 
  Seq#Equal(s0, s1)
     <==> Seq#Length(s0) == Seq#Length(s1)
       && (forall j: int :: 
        { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
        0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#SameUntil(s0, s1, n) } 
  Seq#SameUntil(s0, s1, n)
     <==> (forall j: int :: 
      { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
      0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Take(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Take(s, n), j) } { Seq#Index(s, j), Seq#Take(s, n) } 
  0 <= j && j < n && j < Seq#Length(s)
     ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Drop(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 
  0 <= n && 0 <= j && j < Seq#Length(s) - n
     ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, n: int, k: int :: 
  {:weight 25} { Seq#Index(s, k), Seq#Drop(s, n) } 
  0 <= n && n <= k && k < Seq#Length(s)
     ==> Seq#Index(Seq#Drop(s, n), k - n) == Seq#Index(s, k));

axiom (forall<T> s: Seq T, t: Seq T, n: int :: 
  { Seq#Take(Seq#Append(s, t), n) } { Seq#Drop(Seq#Append(s, t), n) } 
  n == Seq#Length(s)
     ==> Seq#Take(Seq#Append(s, t), n) == s && Seq#Drop(Seq#Append(s, t), n) == t);

function Seq#FromArray(h: Heap, a: ref) : Seq Box;

axiom (forall h: Heap, a: ref :: 
  { Seq#Length(Seq#FromArray(h, a)) } 
  Seq#Length(Seq#FromArray(h, a)) == _System.array.Length(a));

axiom (forall h: Heap, a: ref :: 
  { Seq#FromArray(h, a) } 
  (forall i: int :: 
    { read(h, a, IndexField(i)) } { Seq#Index(Seq#FromArray(h, a): Seq Box, i) } 
    0 <= i && i < Seq#Length(Seq#FromArray(h, a))
       ==> Seq#Index(Seq#FromArray(h, a), i) == read(h, a, IndexField(i))));

axiom (forall h0: Heap, h1: Heap, a: ref :: 
  { Seq#FromArray(h1, a), $HeapSucc(h0, h1) } 
  $IsGoodHeap(h0) && $IsGoodHeap(h1) && $HeapSucc(h0, h1) && h0[a] == h1[a]
     ==> Seq#FromArray(h0, a) == Seq#FromArray(h1, a));

axiom (forall h: Heap, i: int, v: Box, a: ref :: 
  { Seq#FromArray(update(h, a, IndexField(i), v), a) } 
  0 <= i && i < _System.array.Length(a)
     ==> Seq#FromArray(update(h, a, IndexField(i), v), a)
       == Seq#Update(Seq#FromArray(h, a), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n <= Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Update(Seq#Take(s, n), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  n <= i && i < Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Take(s, n));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= n && n <= i && i < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Update(Seq#Drop(s, n), i - n, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Drop(s, n));

axiom (forall h: Heap, a: ref, n0: int, n1: int :: 
  { Seq#Take(Seq#FromArray(h, a), n0), Seq#Take(Seq#FromArray(h, a), n1) } 
  n0 + 1 == n1 && 0 <= n0 && n1 <= _System.array.Length(a)
     ==> Seq#Take(Seq#FromArray(h, a), n1)
       == Seq#Build(Seq#Take(Seq#FromArray(h, a), n0), read(h, a, IndexField(n0): Field Box)));

axiom (forall<T> s: Seq T, v: T, n: int :: 
  { Seq#Drop(Seq#Build(s, v), n) } 
  0 <= n && n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Build(s, v), n) == Seq#Build(Seq#Drop(s, n), v));

function Seq#Rank<T>(Seq T) : int;

axiom (forall s: Seq Box, i: int :: 
  { DtRank($Unbox(Seq#Index(s, i)): DatatypeType) } 
  0 <= i && i < Seq#Length(s)
     ==> DtRank($Unbox(Seq#Index(s, i)): DatatypeType) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Drop(s, i)) } 
  0 < i && i <= Seq#Length(s) ==> Seq#Rank(Seq#Drop(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Take(s, i)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Rank(Seq#Take(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int, j: int :: 
  { Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) } 
  0 <= i && i < j && j <= Seq#Length(s)
     ==> Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) < Seq#Rank(s));

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Drop(s, n) } 
  n == 0 ==> Seq#Drop(s, n) == s);

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Take(s, n) } 
  n == 0 ==> Seq#Take(s, n) == Seq#Empty());

axiom (forall<T> s: Seq T, m: int, n: int :: 
  { Seq#Drop(Seq#Drop(s, m), n) } 
  0 <= m && 0 <= n && m + n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Drop(s, m), n) == Seq#Drop(s, m + n));

type Map _ _;

function Map#Domain<U,V>(Map U V) : Set U;

function Map#Elements<U,V>(Map U V) : [U]V;

function Map#Card<U,V>(Map U V) : int;

axiom (forall<U,V> m: Map U V :: { Map#Card(m) } 0 <= Map#Card(m));

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Domain(m)) } 
  Set#Card(Map#Domain(m)) == Map#Card(m));

function Map#Values<U,V>(Map U V) : Set V;

axiom (forall<U,V> m: Map U V, v: V :: 
  { Map#Values(m)[v] } 
  Map#Values(m)[v]
     == (exists u: U :: 
      { Map#Domain(m)[u] } { Map#Elements(m)[u] } 
      Map#Domain(m)[u] && v == Map#Elements(m)[u]));

function Map#Items<U,V>(Map U V) : Set Box;

function _System.Tuple2._0(DatatypeType) : Box;

function _System.Tuple2._1(DatatypeType) : Box;

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Items(m)) } 
  Set#Card(Map#Items(m)) == Map#Card(m));

axiom (forall m: Map Box Box, item: Box :: 
  { Map#Items(m)[item] } 
  Map#Items(m)[item]
     <==> Map#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && Map#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function Map#Empty<U,V>() : Map U V;

axiom (forall<U,V> u: U :: 
  { Map#Domain(Map#Empty(): Map U V)[u] } 
  !Map#Domain(Map#Empty(): Map U V)[u]);

axiom (forall<U,V> m: Map U V :: 
  { Map#Card(m) } 
  (Map#Card(m) == 0 <==> m == Map#Empty())
     && (Map#Card(m) != 0 ==> (exists x: U :: Map#Domain(m)[x])));

function Map#Glue<U,V>([U]bool, [U]V, Ty) : Map U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Domain(Map#Glue(a, b, t)) } 
  Map#Domain(Map#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Elements(Map#Glue(a, b, t)) } 
  Map#Elements(Map#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(Map#Glue(a, b, t), t) } 
  $Is(Map#Glue(a, b, t), t));

function Map#Build<U,V>(Map U V, U, V) : Map U V;

axiom (forall<U,V> m: Map U V, u: U, u': U, v: V :: 
  { Map#Domain(Map#Build(m, u, v))[u'] } { Map#Elements(Map#Build(m, u, v))[u'] } 
  (u' == u
       ==> Map#Domain(Map#Build(m, u, v))[u'] && Map#Elements(Map#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> Map#Domain(Map#Build(m, u, v))[u'] == Map#Domain(m)[u']
         && Map#Elements(Map#Build(m, u, v))[u'] == Map#Elements(m)[u']));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  !Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m) + 1);

function Map#Equal<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m')
     <==> (forall u: U :: Map#Domain(m)[u] == Map#Domain(m')[u])
       && (forall u: U :: Map#Domain(m)[u] ==> Map#Elements(m)[u] == Map#Elements(m')[u]));

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m') ==> m == m');

function Map#Disjoint<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Disjoint(m, m') } 
  Map#Disjoint(m, m')
     <==> (forall o: U :: 
      { Map#Domain(m)[o] } { Map#Domain(m')[o] } 
      !Map#Domain(m)[o] || !Map#Domain(m')[o]));

type IMap _ _;

function IMap#Domain<U,V>(IMap U V) : Set U;

function IMap#Elements<U,V>(IMap U V) : [U]V;

function IMap#Values<U,V>(IMap U V) : Set V;

axiom (forall<U,V> m: IMap U V, v: V :: 
  { IMap#Values(m)[v] } 
  IMap#Values(m)[v]
     == (exists u: U :: 
      { IMap#Domain(m)[u] } { IMap#Elements(m)[u] } 
      IMap#Domain(m)[u] && v == IMap#Elements(m)[u]));

function IMap#Items<U,V>(IMap U V) : Set Box;

axiom (forall m: IMap Box Box, item: Box :: 
  { IMap#Items(m)[item] } 
  IMap#Items(m)[item]
     <==> IMap#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && IMap#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function IMap#Empty<U,V>() : IMap U V;

axiom (forall<U,V> u: U :: 
  { IMap#Domain(IMap#Empty(): IMap U V)[u] } 
  !IMap#Domain(IMap#Empty(): IMap U V)[u]);

function IMap#Glue<U,V>([U]bool, [U]V, Ty) : IMap U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Domain(IMap#Glue(a, b, t)) } 
  IMap#Domain(IMap#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Elements(IMap#Glue(a, b, t)) } 
  IMap#Elements(IMap#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(IMap#Glue(a, b, t), t) } 
  $Is(IMap#Glue(a, b, t), t));

function IMap#Build<U,V>(IMap U V, U, V) : IMap U V;

axiom (forall<U,V> m: IMap U V, u: U, u': U, v: V :: 
  { IMap#Domain(IMap#Build(m, u, v))[u'] } 
    { IMap#Elements(IMap#Build(m, u, v))[u'] } 
  (u' == u
       ==> IMap#Domain(IMap#Build(m, u, v))[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> IMap#Domain(IMap#Build(m, u, v))[u'] == IMap#Domain(m)[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == IMap#Elements(m)[u']));

function IMap#Equal<U,V>(IMap U V, IMap U V) : bool;

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m')
     <==> (forall u: U :: IMap#Domain(m)[u] == IMap#Domain(m')[u])
       && (forall u: U :: 
        IMap#Domain(m)[u] ==> IMap#Elements(m)[u] == IMap#Elements(m')[u]));

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m') ==> m == m');

function INTERNAL_add_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_add_boogie(x, y): int } 
  INTERNAL_add_boogie(x, y): int == x + y);

function INTERNAL_sub_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_sub_boogie(x, y): int } 
  INTERNAL_sub_boogie(x, y): int == x - y);

function INTERNAL_mul_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mul_boogie(x, y): int } 
  INTERNAL_mul_boogie(x, y): int == x * y);

function INTERNAL_div_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_div_boogie(x, y): int } 
  INTERNAL_div_boogie(x, y): int == x div y);

function INTERNAL_mod_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mod_boogie(x, y): int } 
  INTERNAL_mod_boogie(x, y): int == x mod y);

function {:never_pattern true} INTERNAL_lt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_lt_boogie(x, y): bool } 
  INTERNAL_lt_boogie(x, y): bool == (x < y));

function {:never_pattern true} INTERNAL_le_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_le_boogie(x, y): bool } 
  INTERNAL_le_boogie(x, y): bool == (x <= y));

function {:never_pattern true} INTERNAL_gt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_gt_boogie(x, y): bool } 
  INTERNAL_gt_boogie(x, y): bool == (x > y));

function {:never_pattern true} INTERNAL_ge_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_ge_boogie(x, y): bool } 
  INTERNAL_ge_boogie(x, y): bool == (x >= y));

function Mul(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mul(x, y): int } Mul(x, y): int == x * y);

function Div(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Div(x, y): int } Div(x, y): int == x div y);

function Mod(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mod(x, y): int } Mod(x, y): int == x mod y);

function Add(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Add(x, y): int } Add(x, y): int == x + y);

function Sub(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Sub(x, y): int } Sub(x, y): int == x - y);

function _System.__default.rank__is__less__than(A: Ty, B: Ty, a: Box, b: Box) : bool;

axiom (forall A: Ty, B: Ty, a: Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, a, b) ==> BoxRank(a) < BoxRank(b));

axiom (forall A: Ty, B: Ty, a: Box, b: Seq Box :: 
  { _System.__default.rank__is__less__than(A, B, a, $Box(b)), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, $Box(b)), Seq#Rank(b) } 
  _System.__default.rank__is__less__than(A, B, a, $Box(b))
     ==> BoxRank(a) < Seq#Rank(b));

axiom (forall A: Ty, B: Ty, a: Seq Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, $Box(a), b), Seq#Rank(a) } 
    { _System.__default.rank__is__less__than(A, B, $Box(a), b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, $Box(a), b)
     ==> Seq#Rank(a) < BoxRank(b));

function Tclass._System.nat() : Ty;

// Tclass._System.nat Tag
axiom Tag(Tclass._System.nat()) == Tagclass._System.nat;

const unique Tagclass._System.nat: TyTag;

// Box/unbox axiom for Tclass._System.nat
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.nat()) } 
  $IsBox(bx, Tclass._System.nat())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass._System.nat()));

// _System.nat: subset type $Is
axiom (forall x#0: int :: 
  { $Is(x#0, Tclass._System.nat()) } 
  $Is(x#0, Tclass._System.nat()) <==> LitInt(0) <= x#0);

// _System.nat: subset type $IsAlloc
axiom (forall x#0: int, $h: Heap :: 
  { $IsAlloc(x#0, Tclass._System.nat(), $h) } 
  $IsAlloc(x#0, Tclass._System.nat(), $h));

const unique class._System.object?: ClassName;

// Tclass._System.object? Tag
axiom Tag(Tclass._System.object?()) == Tagclass._System.object?;

const unique Tagclass._System.object?: TyTag;

// Box/unbox axiom for Tclass._System.object?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object?()) } 
  $IsBox(bx, Tclass._System.object?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object?()));

// object: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.object?()) } 
  $Is($o, Tclass._System.object?()));

// object: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.object?(), $h) } 
  $IsAlloc($o, Tclass._System.object?(), $h)
     <==> $o == null || read($h, $o, alloc));

function implements$_System.object(Ty) : bool;

function Tclass._System.object() : Ty;

// Tclass._System.object Tag
axiom Tag(Tclass._System.object()) == Tagclass._System.object;

const unique Tagclass._System.object: TyTag;

// Box/unbox axiom for Tclass._System.object
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object()) } 
  $IsBox(bx, Tclass._System.object())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object()));

// _System.object: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass._System.object()) } 
  $Is(c#0, Tclass._System.object())
     <==> $Is(c#0, Tclass._System.object?()) && c#0 != null);

// _System.object: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.object(), $h) } 
  $IsAlloc(c#0, Tclass._System.object(), $h)
     <==> $IsAlloc(c#0, Tclass._System.object?(), $h));

const unique class._System.array?: ClassName;

function Tclass._System.array?(Ty) : Ty;

// Tclass._System.array? Tag
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tag(Tclass._System.array?(#$arg)) == Tagclass._System.array?);

const unique Tagclass._System.array?: TyTag;

// Tclass._System.array? injectivity 0
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tclass._System.array?_0(Tclass._System.array?(#$arg)) == #$arg);

function Tclass._System.array?_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array?
axiom (forall #$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array?(#$arg)) } 
  $IsBox(bx, Tclass._System.array?(#$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array?(#$arg)));

// array.: Type axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
     ==> $IsBox(read($h, $o, IndexField($i0)), #$arg));

// array.: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
       && read($h, $o, alloc)
     ==> $IsAllocBox(read($h, $o, IndexField($i0)), #$arg, $h));

// array: Class $Is
axiom (forall #$arg: Ty, $o: ref :: 
  { $Is($o, Tclass._System.array?(#$arg)) } 
  $Is($o, Tclass._System.array?(#$arg))
     <==> $o == null || dtype($o) == Tclass._System.array?(#$arg));

// array: Class $IsAlloc
axiom (forall #$arg: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.array?(#$arg), $h) } 
  $IsAlloc($o, Tclass._System.array?(#$arg), $h)
     <==> $o == null || read($h, $o, alloc));

// array.Length: Type axiom
axiom (forall #$arg: Ty, $o: ref :: 
  { _System.array.Length($o), Tclass._System.array?(#$arg) } 
  $o != null && dtype($o) == Tclass._System.array?(#$arg)
     ==> $Is(_System.array.Length($o), TInt));

// array.Length: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref :: 
  { _System.array.Length($o), read($h, $o, alloc), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && read($h, $o, alloc)
     ==> $IsAlloc(_System.array.Length($o), TInt, $h));

function Tclass._System.array(Ty) : Ty;

// Tclass._System.array Tag
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tag(Tclass._System.array(_System.array$arg)) == Tagclass._System.array);

const unique Tagclass._System.array: TyTag;

// Tclass._System.array injectivity 0
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tclass._System.array_0(Tclass._System.array(_System.array$arg))
     == _System.array$arg);

function Tclass._System.array_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array
axiom (forall _System.array$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array(_System.array$arg)) } 
  $IsBox(bx, Tclass._System.array(_System.array$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array(_System.array$arg)));

// _System.array: subset type $Is
axiom (forall _System.array$arg: Ty, c#0: ref :: 
  { $Is(c#0, Tclass._System.array(_System.array$arg)) } 
  $Is(c#0, Tclass._System.array(_System.array$arg))
     <==> $Is(c#0, Tclass._System.array?(_System.array$arg)) && c#0 != null);

// _System.array: subset type $IsAlloc
axiom (forall _System.array$arg: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) } 
  $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h)
     <==> $IsAlloc(c#0, Tclass._System.array?(_System.array$arg), $h));

function Tclass._System.___hFunc0(Ty) : Ty;

// Tclass._System.___hFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tag(Tclass._System.___hFunc0(#$R)) == Tagclass._System.___hFunc0);

const unique Tagclass._System.___hFunc0: TyTag;

// Tclass._System.___hFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tclass._System.___hFunc0_0(Tclass._System.___hFunc0(#$R)) == #$R);

function Tclass._System.___hFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc0(#$R)));

function Handle0([Heap]Box, [Heap]bool, [Heap]Set Box) : HandleType;

function Apply0(Ty, Heap, HandleType) : Box;

function Requires0(Ty, Heap, HandleType) : bool;

function Reads0(Ty, Heap, HandleType) : Set Box;

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Apply0(t0, heap, Handle0(h, r, rd)) } 
  Apply0(t0, heap, Handle0(h, r, rd)) == h[heap]);

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Requires0(t0, heap, Handle0(h, r, rd)) } 
  r[heap] ==> Requires0(t0, heap, Handle0(h, r, rd)));

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box, bx: Box :: 
  { Reads0(t0, heap, Handle0(h, r, rd))[bx] } 
  Reads0(t0, heap, Handle0(h, r, rd))[bx] == rd[heap][bx]);

function {:inline} Requires0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

function {:inline} Reads0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// empty-reads property for Reads0 
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Reads0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Reads0(t0, heap, f) } 
  $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0))
     ==> (Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
       <==> Set#Equal(Reads0(t0, heap, f), Set#Empty(): Set Box)));

// empty-reads property for Requires0
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Requires0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Requires0(t0, heap, f) } 
  $IsGoodHeap(heap)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
     ==> Requires0(t0, $OneHeap, f) == Requires0(t0, heap, f));

axiom (forall f: HandleType, t0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
     <==> (forall h: Heap :: 
      { Apply0(t0, h, f) } 
      $IsGoodHeap(h) && Requires0(t0, h, f) ==> $IsBox(Apply0(t0, h, f), t0)));

axiom (forall f: HandleType, t0: Ty, u0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)), $Is(f, Tclass._System.___hFunc0(u0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t0) } { $IsBox(bx, u0) } 
        $IsBox(bx, t0) ==> $IsBox(bx, u0))
     ==> $Is(f, Tclass._System.___hFunc0(u0)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc0(t0), h)
       <==> Requires0(t0, h, f)
         ==> (forall r: ref :: 
          { Reads0(t0, h, f)[$Box(r)] } 
          r != null && Reads0(t0, h, f)[$Box(r)] ==> read(h, r, alloc))));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc0(t0), h)
     ==> 
    Requires0(t0, h, f)
     ==> $IsAllocBox(Apply0(t0, h, f), t0, h));

function Tclass._System.___hPartialFunc0(Ty) : Ty;

// Tclass._System.___hPartialFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tag(Tclass._System.___hPartialFunc0(#$R)) == Tagclass._System.___hPartialFunc0);

const unique Tagclass._System.___hPartialFunc0: TyTag;

// Tclass._System.___hPartialFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tclass._System.___hPartialFunc0_0(Tclass._System.___hPartialFunc0(#$R)) == #$R);

function Tclass._System.___hPartialFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc0(#$R)));

// _System._#PartialFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hFunc0(#$R))
       && Set#Equal(Reads0(#$R, $OneHeap, f#0), Set#Empty(): Set Box));

// _System._#PartialFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc0(#$R), $h));

function Tclass._System.___hTotalFunc0(Ty) : Ty;

// Tclass._System.___hTotalFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tag(Tclass._System.___hTotalFunc0(#$R)) == Tagclass._System.___hTotalFunc0);

const unique Tagclass._System.___hTotalFunc0: TyTag;

// Tclass._System.___hTotalFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tclass._System.___hTotalFunc0_0(Tclass._System.___hTotalFunc0(#$R)) == #$R);

function Tclass._System.___hTotalFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc0(#$R)));

// _System._#TotalFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) && Requires0(#$R, $OneHeap, f#0));

// _System._#TotalFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h));

const unique class._System.__default: ClassName;

function Tclass._System.__default() : Ty;

// Tclass._System.__default Tag
axiom Tag(Tclass._System.__default()) == Tagclass._System.__default;

const unique Tagclass._System.__default: TyTag;

// Box/unbox axiom for Tclass._System.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.__default()) } 
  $IsBox(bx, Tclass._System.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.__default()) } 
  $Is($o, Tclass._System.__default())
     <==> $o == null || dtype($o) == Tclass._System.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.__default(), $h) } 
  $IsAlloc($o, Tclass._System.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function _System.__default.rank__is__less__than#canCall(#$A: Ty, #$B: Ty, a#0: Box, b#0: Box) : bool;

// consequence axiom for _System.__default.rank__is__less__than
axiom true
   ==> (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
    { _System.__default.rank__is__less__than(#$A, #$B, a#0, b#0) } 
    _System.__default.rank__is__less__than#canCall(#$A, #$B, a#0, b#0)
         || ($IsBox(a#0, #$A) && $IsBox(b#0, #$B))
       ==> true);

function _System.__default.rank__is__less__than#requires(Ty, Ty, Box, Box) : bool;

// #requires axiom for _System.__default.rank__is__less__than
axiom (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
  { _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) } 
  $IsBox(a#0, #$A) && $IsBox(b#0, #$B)
     ==> _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) == true);

function Tclass._System.___hFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hFunc2);

const unique Tagclass._System.___hFunc2: TyTag;

// Tclass._System.___hFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_0(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hFunc2_0(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_1(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hFunc2_1(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_2(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$R);

function Tclass._System.___hFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc2(#$T0, #$T1, #$R)));

function Handle2([Heap,Box,Box]Box, [Heap,Box,Box]bool, [Heap,Box,Box]Set Box) : HandleType;

function Apply2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Box;

function Requires2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : bool;

function Reads2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) == h[heap, bx0, bx1]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  r[heap, bx0, bx1] ==> Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx: Box :: 
  { Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] } 
  Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx]
     == rd[heap, bx0, bx1][bx]);

function {:inline} Requires2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

function {:inline} Reads2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// empty-reads property for Reads2 
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Reads2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     ==> (Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
       <==> Set#Equal(Reads2(t0, t1, t2, heap, f, bx0, bx1), Set#Empty(): Set Box)));

// empty-reads property for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Requires2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
     ==> Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1)
       == Requires2(t0, t1, t2, heap, f, bx0, bx1));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     <==> (forall h: Heap, bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, u0: Ty, u1: Ty, u2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)), $Is(f, Tclass._System.___hFunc2(u0, u1, u2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, t2) } { $IsBox(bx, u2) } 
        $IsBox(bx, t2) ==> $IsBox(bx, u2))
     ==> $Is(f, Tclass._System.___hFunc2(u0, u1, u2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
       <==> (forall bx0: Box, bx1: Box :: 
        { Apply2(t0, t1, t2, h, f, bx0, bx1) } { Reads2(t0, t1, t2, h, f, bx0, bx1) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && Requires2(t0, t1, t2, h, f, bx0, bx1)
           ==> (forall r: ref :: 
            { Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] } 
            r != null && Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
     ==> (forall bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsAllocBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2, h)));

function Tclass._System.___hPartialFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hPartialFunc2);

const unique Tagclass._System.___hPartialFunc2: TyTag;

// Tclass._System.___hPartialFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_0(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc2_0(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_1(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc2_1(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_2(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hPartialFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)));

// _System._#PartialFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Set#Equal(Reads2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0), Set#Empty(): Set Box)));

// _System._#PartialFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hTotalFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hTotalFunc2);

const unique Tagclass._System.___hTotalFunc2: TyTag;

// Tclass._System.___hTotalFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_0(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc2_0(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_1(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc2_1(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_2(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hTotalFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)));

// _System._#TotalFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Requires2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0)));

// _System._#TotalFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hFunc1(Ty, Ty) : Ty;

// Tclass._System.___hFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hFunc1(#$T0, #$R)) == Tagclass._System.___hFunc1);

const unique Tagclass._System.___hFunc1: TyTag;

// Tclass._System.___hFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_0(Tclass._System.___hFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hFunc1_0(Ty) : Ty;

// Tclass._System.___hFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_1(Tclass._System.___hFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc1(#$T0, #$R)));

function Handle1([Heap,Box]Box, [Heap,Box]bool, [Heap,Box]Set Box) : HandleType;

function Requires1(Ty, Ty, Heap, HandleType, Box) : bool;

function Reads1(Ty, Ty, Heap, HandleType, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) == h[heap, bx0]);

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Requires1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  r[heap, bx0] ==> Requires1(t0, t1, heap, Handle1(h, r, rd), bx0));

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box, 
    bx: Box :: 
  { Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] } 
  Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] == rd[heap, bx0][bx]);

function {:inline} Requires1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

function {:inline} Reads1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// empty-reads property for Reads1 
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Reads1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Reads1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1))
     ==> (Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
       <==> Set#Equal(Reads1(t0, t1, heap, f, bx0), Set#Empty(): Set Box)));

// empty-reads property for Requires1
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Requires1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Requires1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
     ==> Requires1(t0, t1, $OneHeap, f, bx0) == Requires1(t0, t1, heap, f, bx0));

axiom (forall f: HandleType, t0: Ty, t1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
     <==> (forall h: Heap, bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsGoodHeap(h) && $IsBox(bx0, t0) && Requires1(t0, t1, h, f, bx0)
         ==> $IsBox(Apply1(t0, t1, h, f, bx0), t1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, u0: Ty, u1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)), $Is(f, Tclass._System.___hFunc1(u0, u1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t1) } { $IsBox(bx, u1) } 
        $IsBox(bx, t1) ==> $IsBox(bx, u1))
     ==> $Is(f, Tclass._System.___hFunc1(u0, u1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
       <==> (forall bx0: Box :: 
        { Apply1(t0, t1, h, f, bx0) } { Reads1(t0, t1, h, f, bx0) } 
        $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
           ==> (forall r: ref :: 
            { Reads1(t0, t1, h, f, bx0)[$Box(r)] } 
            r != null && Reads1(t0, t1, h, f, bx0)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
     ==> (forall bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
         ==> $IsAllocBox(Apply1(t0, t1, h, f, bx0), t1, h)));

function Tclass._System.___hPartialFunc1(Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == Tagclass._System.___hPartialFunc1);

const unique Tagclass._System.___hPartialFunc1: TyTag;

// Tclass._System.___hPartialFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_0(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc1_0(Ty) : Ty;

// Tclass._System.___hPartialFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_1(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$R);

function Tclass._System.___hPartialFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc1(#$T0, #$R)));

// _System._#PartialFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0)
           ==> Set#Equal(Reads1(#$T0, #$R, $OneHeap, f#0, x0#0), Set#Empty(): Set Box)));

// _System._#PartialFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc1(#$T0, #$R), $h));

function Tclass._System.___hTotalFunc1(Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hTotalFunc1(#$T0, #$R)) == Tagclass._System.___hTotalFunc1);

const unique Tagclass._System.___hTotalFunc1: TyTag;

// Tclass._System.___hTotalFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_0(Tclass._System.___hTotalFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc1_0(Ty) : Ty;

// Tclass._System.___hTotalFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_1(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hTotalFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc1(#$T0, #$R)));

// _System._#TotalFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0) ==> Requires1(#$T0, #$R, $OneHeap, f#0, x0#0)));

// _System._#TotalFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h));

function Tclass._System.___hFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hFunc3);

const unique Tagclass._System.___hFunc3: TyTag;

// Tclass._System.___hFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_0(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hFunc3_0(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_1(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hFunc3_1(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_2(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hFunc3_2(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_3(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)));

function Handle3([Heap,Box,Box,Box]Box, [Heap,Box,Box,Box]bool, [Heap,Box,Box,Box]Set Box)
   : HandleType;

function Apply3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Box;

function Requires3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : bool;

function Reads3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)
     == h[heap, bx0, bx1, bx2]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  r[heap, bx0, bx1, bx2]
     ==> Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx: Box :: 
  { Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] } 
  Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx]
     == rd[heap, bx0, bx1, bx2][bx]);

function {:inline} Requires3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

function {:inline} Reads3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// empty-reads property for Reads3 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     ==> (Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
       <==> Set#Equal(Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2), Set#Empty(): Set Box)));

// empty-reads property for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
     ==> Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)), $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, t3) } { $IsBox(bx, u3) } 
        $IsBox(bx, t3) ==> $IsBox(bx, u3))
     ==> $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box :: 
        { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
          { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
           ==> (forall r: ref :: 
            { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] } 
            r != null && Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsAllocBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3, h)));

function Tclass._System.___hPartialFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hPartialFunc3);

const unique Tagclass._System.___hPartialFunc3: TyTag;

// Tclass._System.___hPartialFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_0(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc3_0(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_1(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc3_1(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_2(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc3_2(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_3(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hPartialFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#PartialFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Set#Equal(Reads3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hTotalFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hTotalFunc3);

const unique Tagclass._System.___hTotalFunc3: TyTag;

// Tclass._System.___hTotalFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_0(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc3_0(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_1(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc3_1(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_2(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc3_2(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_3(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hTotalFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#TotalFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Requires3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0)));

// _System._#TotalFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hFunc4);

const unique Tagclass._System.___hFunc4: TyTag;

// Tclass._System.___hFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_0(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hFunc4_0(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_1(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hFunc4_1(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_2(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hFunc4_2(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_3(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hFunc4_3(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_4(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

function Handle4([Heap,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Box;

function Requires4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : bool;

function Reads4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)
     == h[heap, bx0, bx1, bx2, bx3]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  r[heap, bx0, bx1, bx2, bx3]
     ==> Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx: Box :: 
  { Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] } 
  Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx]
     == rd[heap, bx0, bx1, bx2, bx3][bx]);

function {:inline} Requires4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

function {:inline} Reads4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// empty-reads property for Reads4 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     ==> (Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set Box)));

// empty-reads property for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
     ==> Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)), $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, t4) } { $IsBox(bx, u4) } 
        $IsBox(bx, t4) ==> $IsBox(bx, u4))
     ==> $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
        { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
          { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
           ==> (forall r: ref :: 
            { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] } 
            r != null && Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsAllocBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4, h)));

function Tclass._System.___hPartialFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hPartialFunc4);

const unique Tagclass._System.___hPartialFunc4: TyTag;

// Tclass._System.___hPartialFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_0(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc4_0(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_1(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc4_1(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_2(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc4_2(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_3(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc4_3(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_4(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hPartialFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#PartialFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Set#Equal(Reads4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hTotalFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hTotalFunc4);

const unique Tagclass._System.___hTotalFunc4: TyTag;

// Tclass._System.___hTotalFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_0(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc4_0(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_1(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc4_1(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_2(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc4_2(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_3(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc4_3(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_4(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hTotalFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#TotalFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Requires4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0)));

// _System._#TotalFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hFunc10(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc10 Tag
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tag(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == Tagclass._System.___hFunc10);

const unique Tagclass._System.___hFunc10: TyTag;

// Tclass._System.___hFunc10 injectivity 0
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_0(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T0);

function Tclass._System.___hFunc10_0(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 1
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_1(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T1);

function Tclass._System.___hFunc10_1(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 2
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_2(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T2);

function Tclass._System.___hFunc10_2(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 3
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_3(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T3);

function Tclass._System.___hFunc10_3(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 4
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_4(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T4);

function Tclass._System.___hFunc10_4(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 5
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_5(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T5);

function Tclass._System.___hFunc10_5(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 6
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_6(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T6);

function Tclass._System.___hFunc10_6(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_7(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T7);

function Tclass._System.___hFunc10_7(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 8
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_8(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T8);

function Tclass._System.___hFunc10_8(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 9
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_9(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T9);

function Tclass._System.___hFunc10_9(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_10(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$R);

function Tclass._System.___hFunc10_10(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)));

function Handle10([Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply10(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Box;

function Requires10(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : bool;

function Reads10(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { Apply10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  Apply10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6, bx7, bx8, bx9]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6, bx7, bx8, bx9]
     ==> Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box, 
    bx: Box :: 
  { Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9)[bx] } 
  Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6, bx7, bx8, bx9][bx]);

function {:inline} Requires10#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box)
   : bool
{
  true
}

function {:inline} Reads10#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box)
   : bool
{
  true
}

// frame axiom for Reads10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h0, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Reads10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Reads10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h1, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Reads10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Requires10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h0, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Requires10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h1, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Apply10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Apply10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h0, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Apply10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Apply10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Apply10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h1, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Apply10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// empty-reads property for Reads10 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      $OneHeap, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9), $IsGoodHeap(heap) } 
    { Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
     ==> (Set#Equal(Reads10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          $OneHeap, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          heap, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      $OneHeap, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9), $IsGoodHeap(heap) } 
    { Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && Set#Equal(Reads10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          $OneHeap, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9), 
        Set#Empty(): Set Box)
     ==> Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        $OneHeap, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        heap, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty :: 
  { $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10)) } 
  $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
     <==> (forall h: Heap, 
        bx0: Box, 
        bx1: Box, 
        bx2: Box, 
        bx3: Box, 
        bx4: Box, 
        bx5: Box, 
        bx6: Box, 
        bx7: Box, 
        bx8: Box, 
        bx9: Box :: 
      { Apply10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          h, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && $IsBox(bx6, t6)
           && $IsBox(bx7, t7)
           && $IsBox(bx8, t8)
           && $IsBox(bx9, t9)
           && Requires10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9)
         ==> $IsBox(Apply10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9), 
          t10)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty, 
    u7: Ty, 
    u8: Ty, 
    u9: Ty, 
    u10: Ty :: 
  { $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10)), $Is(f, Tclass._System.___hFunc10(u0, u1, u2, u3, u4, u5, u6, u7, u8, u9, u10)) } 
  $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u6) } { $IsBox(bx, t6) } 
        $IsBox(bx, u6) ==> $IsBox(bx, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, u7) } { $IsBox(bx, t7) } 
        $IsBox(bx, u7) ==> $IsBox(bx, t7))
       && (forall bx: Box :: 
        { $IsBox(bx, u8) } { $IsBox(bx, t8) } 
        $IsBox(bx, u8) ==> $IsBox(bx, t8))
       && (forall bx: Box :: 
        { $IsBox(bx, u9) } { $IsBox(bx, t9) } 
        $IsBox(bx, u9) ==> $IsBox(bx, t9))
       && (forall bx: Box :: 
        { $IsBox(bx, t10) } { $IsBox(bx, u10) } 
        $IsBox(bx, t10) ==> $IsBox(bx, u10))
     ==> $Is(f, Tclass._System.___hFunc10(u0, u1, u2, u3, u4, u5, u6, u7, u8, u9, u10)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10), h)
       <==> (forall bx0: Box, 
          bx1: Box, 
          bx2: Box, 
          bx3: Box, 
          bx4: Box, 
          bx5: Box, 
          bx6: Box, 
          bx7: Box, 
          bx8: Box, 
          bx9: Box :: 
        { Apply10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9) } 
          { Reads10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && 
            $IsBox(bx6, t6)
             && $IsAllocBox(bx6, t6, h)
             && 
            $IsBox(bx7, t7)
             && $IsAllocBox(bx7, t7, h)
             && 
            $IsBox(bx8, t8)
             && $IsAllocBox(bx8, t8, h)
             && 
            $IsBox(bx9, t9)
             && $IsAllocBox(bx9, t9, h)
             && Requires10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)
           ==> (forall r: ref :: 
            { Reads10(t0, 
                t1, 
                t2, 
                t3, 
                t4, 
                t5, 
                t6, 
                t7, 
                t8, 
                t9, 
                t10, 
                h, 
                f, 
                bx0, 
                bx1, 
                bx2, 
                bx3, 
                bx4, 
                bx5, 
                bx6, 
                bx7, 
                bx8, 
                bx9)[$Box(r)] } 
            r != null
                 && Reads10(t0, 
                  t1, 
                  t2, 
                  t3, 
                  t4, 
                  t5, 
                  t6, 
                  t7, 
                  t8, 
                  t9, 
                  t10, 
                  h, 
                  f, 
                  bx0, 
                  bx1, 
                  bx2, 
                  bx3, 
                  bx4, 
                  bx5, 
                  bx6, 
                  bx7, 
                  bx8, 
                  bx9)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10), h)
     ==> (forall bx0: Box, 
        bx1: Box, 
        bx2: Box, 
        bx3: Box, 
        bx4: Box, 
        bx5: Box, 
        bx6: Box, 
        bx7: Box, 
        bx8: Box, 
        bx9: Box :: 
      { Apply10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          h, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && $IsAllocBox(bx6, t6, h)
           && $IsAllocBox(bx7, t7, h)
           && $IsAllocBox(bx8, t8, h)
           && $IsAllocBox(bx9, t9, h)
           && Requires10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9)
         ==> $IsAllocBox(Apply10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9), 
          t10, 
          h)));

function Tclass._System.___hPartialFunc10(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc10 Tag
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tag(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == Tagclass._System.___hPartialFunc10);

const unique Tagclass._System.___hPartialFunc10: TyTag;

// Tclass._System.___hPartialFunc10 injectivity 0
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_0(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc10_0(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 1
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_1(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc10_1(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 2
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_2(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc10_2(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 3
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_3(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc10_3(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 4
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_4(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc10_4(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 5
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_5(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc10_5(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 6
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_6(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T6);

function Tclass._System.___hPartialFunc10_6(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_7(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T7);

function Tclass._System.___hPartialFunc10_7(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 8
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_8(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T8);

function Tclass._System.___hPartialFunc10_8(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 9
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_9(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T9);

function Tclass._System.___hPartialFunc10_9(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_10(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$R);

function Tclass._System.___hPartialFunc10_10(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)));

// _System._#PartialFunc10: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     <==> $Is(f#0, 
        Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
       && (forall x0#0: Box, 
          x1#0: Box, 
          x2#0: Box, 
          x3#0: Box, 
          x4#0: Box, 
          x5#0: Box, 
          x6#0: Box, 
          x7#0: Box, 
          x8#0: Box, 
          x9#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
             && $IsBox(x7#0, #$T7)
             && $IsBox(x8#0, #$T8)
             && $IsBox(x9#0, #$T9)
           ==> Set#Equal(Reads10(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$T6, 
              #$T7, 
              #$T8, 
              #$T9, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0, 
              x6#0, 
              x7#0, 
              x8#0, 
              x9#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc10: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h));

function Tclass._System.___hTotalFunc10(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc10 Tag
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tag(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == Tagclass._System.___hTotalFunc10);

const unique Tagclass._System.___hTotalFunc10: TyTag;

// Tclass._System.___hTotalFunc10 injectivity 0
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_0(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc10_0(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 1
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_1(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc10_1(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 2
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_2(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc10_2(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 3
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_3(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc10_3(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 4
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_4(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc10_4(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 5
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_5(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc10_5(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 6
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_6(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T6);

function Tclass._System.___hTotalFunc10_6(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_7(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T7);

function Tclass._System.___hTotalFunc10_7(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 8
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_8(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T8);

function Tclass._System.___hTotalFunc10_8(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 9
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_9(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T9);

function Tclass._System.___hTotalFunc10_9(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_10(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$R);

function Tclass._System.___hTotalFunc10_10(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)));

// _System._#TotalFunc10: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     <==> $Is(f#0, 
        Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
       && (forall x0#0: Box, 
          x1#0: Box, 
          x2#0: Box, 
          x3#0: Box, 
          x4#0: Box, 
          x5#0: Box, 
          x6#0: Box, 
          x7#0: Box, 
          x8#0: Box, 
          x9#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
             && $IsBox(x7#0, #$T7)
             && $IsBox(x8#0, #$T8)
             && $IsBox(x9#0, #$T9)
           ==> Requires10(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$T6, 
            #$T7, 
            #$T8, 
            #$T9, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0, 
            x6#0, 
            x7#0, 
            x8#0, 
            x9#0)));

// _System._#TotalFunc10: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h));

function Tclass._System.___hFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hFunc6);

const unique Tagclass._System.___hFunc6: TyTag;

// Tclass._System.___hFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_0(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hFunc6_0(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_1(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hFunc6_1(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_2(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hFunc6_2(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_3(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hFunc6_3(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_4(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hFunc6_4(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_5(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hFunc6_5(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_6(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

function Handle6([Heap,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : Box;

function Requires6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : bool;

function Reads6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Apply6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5) } 
  Apply6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Requires6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5]
     ==> Requires6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx: Box :: 
  { Reads6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)[bx] } 
  Reads6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5][bx]);

function {:inline} Requires6#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box)
   : bool
{
  true
}

function {:inline} Reads6#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box)
   : bool
{
  true
}

// frame axiom for Reads6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Reads6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Apply6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Apply6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// empty-reads property for Reads6 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } 
    { Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
     ==> (Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } 
    { Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty :: 
  { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) } 
  $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
      { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
         ==> $IsBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty :: 
  { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)), $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)) } 
  $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, t6) } { $IsBox(bx, u6) } 
        $IsBox(bx, t6) ==> $IsBox(bx, u6))
     ==> $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
        { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
          { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
           ==> (forall r: ref :: 
            { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)] } 
            r != null
                 && Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
      { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
         ==> $IsAllocBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6, h)));

function Tclass._System.___hPartialFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hPartialFunc6);

const unique Tagclass._System.___hPartialFunc6: TyTag;

// Tclass._System.___hPartialFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_0(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc6_0(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_1(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc6_1(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_2(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc6_2(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_3(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc6_3(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_4(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc6_4(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_5(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc6_5(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_6(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hPartialFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

// _System._#PartialFunc6: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
           ==> Set#Equal(Reads6(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc6: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h));

function Tclass._System.___hTotalFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hTotalFunc6);

const unique Tagclass._System.___hTotalFunc6: TyTag;

// Tclass._System.___hTotalFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_0(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc6_0(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_1(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc6_1(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_2(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc6_2(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_3(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc6_3(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_4(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc6_4(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_5(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc6_5(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_6(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hTotalFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

// _System._#TotalFunc6: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
           ==> Requires6(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0)));

// _System._#TotalFunc6: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h));

// Constructor function declaration
function #_System._tuple#2._#Make2(Box, Box) : DatatypeType;

const unique ##_System._tuple#2._#Make2: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#_System._tuple#2._#Make2(a#0#0#0, a#0#1#0))
     == ##_System._tuple#2._#Make2);

function _System.Tuple2.___hMake2_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#2._#Make2);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     ==> (exists a#1#0#0: Box, a#1#1#0: Box :: 
      d == #_System._tuple#2._#Make2(a#1#0#0, a#1#1#0)));

function Tclass._System.Tuple2(Ty, Ty) : Ty;

// Tclass._System.Tuple2 Tag
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tag(Tclass._System.Tuple2(#$T0, #$T1)) == Tagclass._System.Tuple2);

const unique Tagclass._System.Tuple2: TyTag;

// Tclass._System.Tuple2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_0(Tclass._System.Tuple2(#$T0, #$T1)) == #$T0);

function Tclass._System.Tuple2_0(Ty) : Ty;

// Tclass._System.Tuple2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_1(Tclass._System.Tuple2(#$T0, #$T1)) == #$T1);

function Tclass._System.Tuple2_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.Tuple2
axiom (forall #$T0: Ty, #$T1: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple2(#$T0, #$T1)));

// Constructor $Is
axiom (forall #$T0: Ty, #$T1: Ty, a#2#0#0: Box, a#2#1#0: Box :: 
  { $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1))
     <==> $IsBox(a#2#0#0, #$T0) && $IsBox(a#2#1#0, #$T1));

// Constructor $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, a#3#0#0: Box, a#3#1#0: Box, $h: Heap :: 
  { $IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
      Tclass._System.Tuple2(#$T0, #$T1), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
        Tclass._System.Tuple2(#$T0, #$T1), 
        $h)
       <==> $IsAllocBox(a#3#0#0, #$T0, $h) && $IsAllocBox(a#3#1#0, #$T1, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T0: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._0(d), #$T0, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T1: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._0(d), #$T0, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T1: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._1(d), #$T1, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T0: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._1(d), #$T1, $h));

// Constructor literal
axiom (forall a#4#0#0: Box, a#4#1#0: Box :: 
  { #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#_System._tuple#2._#Make2(a#4#0#0, a#4#1#0)));

// Constructor injectivity
axiom (forall a#5#0#0: Box, a#5#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#5#0#0, a#5#1#0) } 
  _System.Tuple2._0(#_System._tuple#2._#Make2(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: Box, a#6#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#6#0#0, a#6#1#0) } 
  BoxRank(a#6#0#0) < DtRank(#_System._tuple#2._#Make2(a#6#0#0, a#6#1#0)));

// Constructor injectivity
axiom (forall a#7#0#0: Box, a#7#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#7#0#0, a#7#1#0) } 
  _System.Tuple2._1(#_System._tuple#2._#Make2(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: Box, a#8#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#8#0#0, a#8#1#0) } 
  BoxRank(a#8#1#0) < DtRank(#_System._tuple#2._#Make2(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#_System.Tuple2(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple2(d) } 
  $IsA#_System.Tuple2(d) ==> _System.Tuple2.___hMake2_q(d));

// Questionmark data type disjunctivity
axiom (forall #$T0: Ty, #$T1: Ty, d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d), $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) ==> _System.Tuple2.___hMake2_q(d));

// Datatype extensional equality declaration
function _System.Tuple2#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#2._#Make2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  true
     ==> (_System.Tuple2#Equal(a, b)
       <==> _System.Tuple2._0(a) == _System.Tuple2._0(b)
         && _System.Tuple2._1(a) == _System.Tuple2._1(b)));

// Datatype extensionality axiom: _System._tuple#2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  _System.Tuple2#Equal(a, b) <==> a == b);

const unique class._System.Tuple2: ClassName;

function Tclass._System.___hFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hFunc7);

const unique Tagclass._System.___hFunc7: TyTag;

// Tclass._System.___hFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_0(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hFunc7_0(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_1(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hFunc7_1(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_2(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hFunc7_2(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_3(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hFunc7_3(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_4(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hFunc7_4(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_5(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hFunc7_5(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_6(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hFunc7_6(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_7(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

function Handle7([Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Box;

function Requires7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : bool;

function Reads7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Apply7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6) } 
  Apply7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Requires7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6]
     ==> Requires7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx: Box :: 
  { Reads7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)[bx] } 
  Reads7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6][bx]);

function {:inline} Requires7#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box)
   : bool
{
  true
}

function {:inline} Reads7#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box)
   : bool
{
  true
}

// frame axiom for Reads7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Reads7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Apply7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Apply7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// empty-reads property for Reads7 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), $IsGoodHeap(heap) } 
    { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
     ==> (Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Requires7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), $IsGoodHeap(heap) } 
    { Requires7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, t7: Ty :: 
  { $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7)) } 
  $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
      { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && $IsBox(bx6, t6)
           && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
         ==> $IsBox(Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
          t7)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty, 
    u7: Ty :: 
  { $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7)), $Is(f, Tclass._System.___hFunc7(u0, u1, u2, u3, u4, u5, u6, u7)) } 
  $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u6) } { $IsBox(bx, t6) } 
        $IsBox(bx, u6) ==> $IsBox(bx, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, t7) } { $IsBox(bx, u7) } 
        $IsBox(bx, t7) ==> $IsBox(bx, u7))
     ==> $Is(f, Tclass._System.___hFunc7(u0, u1, u2, u3, u4, u5, u6, u7)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
        { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
          { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && 
            $IsBox(bx6, t6)
             && $IsAllocBox(bx6, t6, h)
             && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
           ==> (forall r: ref :: 
            { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(r)] } 
            r != null
                 && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
      { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && $IsAllocBox(bx6, t6, h)
           && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
         ==> $IsAllocBox(Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
          t7, 
          h)));

function Tclass._System.___hPartialFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hPartialFunc7);

const unique Tagclass._System.___hPartialFunc7: TyTag;

// Tclass._System.___hPartialFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_0(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc7_0(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_1(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc7_1(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_2(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc7_2(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_3(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc7_3(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_4(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc7_4(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_5(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc7_5(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_6(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hPartialFunc7_6(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_7(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hPartialFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

// _System._#PartialFunc7: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box, x6#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
           ==> Set#Equal(Reads7(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$T6, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0, 
              x6#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc7: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), $h));

function Tclass._System.___hTotalFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hTotalFunc7);

const unique Tagclass._System.___hTotalFunc7: TyTag;

// Tclass._System.___hTotalFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_0(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc7_0(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_1(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc7_1(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_2(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc7_2(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_3(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc7_3(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_4(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc7_4(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_5(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc7_5(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_6(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hTotalFunc7_6(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_7(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hTotalFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

// _System._#TotalFunc7: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     <==> $Is(f#0, 
        Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box, x6#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
           ==> Requires7(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$T6, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0, 
            x6#0)));

// _System._#TotalFunc7: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h));

function Tclass._System.___hFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hFunc5);

const unique Tagclass._System.___hFunc5: TyTag;

// Tclass._System.___hFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_0(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hFunc5_0(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_1(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hFunc5_1(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_2(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hFunc5_2(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_3(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hFunc5_3(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_4(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hFunc5_4(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_5(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

function Handle5([Heap,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Box;

function Requires5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : bool;

function Reads5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } 
  Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)
     == h[heap, bx0, bx1, bx2, bx3, bx4]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } 
  r[heap, bx0, bx1, bx2, bx3, bx4]
     ==> Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx: Box :: 
  { Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx] } 
  Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4][bx]);

function {:inline} Requires5#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box)
   : bool
{
  true
}

function {:inline} Reads5#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box)
   : bool
{
  true
}

// frame axiom for Reads5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Reads5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Apply5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Apply5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// empty-reads property for Reads5 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } 
    { Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
     ==> (Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } 
    { Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)
     ==> Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty :: 
  { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) } 
  $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
      { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
         ==> $IsBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty :: 
  { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)), $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)) } 
  $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, t5) } { $IsBox(bx, u5) } 
        $IsBox(bx, t5) ==> $IsBox(bx, u5))
     ==> $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
        { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
          { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
           ==> (forall r: ref :: 
            { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)] } 
            r != null
                 && Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
      { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
         ==> $IsAllocBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5, h)));

function Tclass._System.___hPartialFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hPartialFunc5);

const unique Tagclass._System.___hPartialFunc5: TyTag;

// Tclass._System.___hPartialFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_0(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc5_0(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_1(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc5_1(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_2(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc5_2(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_3(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc5_3(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_4(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc5_4(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_5(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hPartialFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

// _System._#PartialFunc5: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
           ==> Set#Equal(Reads5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc5: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hTotalFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hTotalFunc5);

const unique Tagclass._System.___hTotalFunc5: TyTag;

// Tclass._System.___hTotalFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_0(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc5_0(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_1(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc5_1(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_2(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc5_2(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_3(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc5_3(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_4(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc5_4(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_5(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hTotalFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

// _System._#TotalFunc5: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
           ==> Requires5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0)));

// _System._#TotalFunc5: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

// Constructor function declaration
function #_System._tuple#0._#Make0() : DatatypeType;

const unique ##_System._tuple#0._#Make0: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;

function _System.Tuple0.___hMake0_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#0._#Make0);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d) ==> d == #_System._tuple#0._#Make0());

function Tclass._System.Tuple0() : Ty;

// Tclass._System.Tuple0 Tag
axiom Tag(Tclass._System.Tuple0()) == Tagclass._System.Tuple0;

const unique Tagclass._System.Tuple0: TyTag;

// Box/unbox axiom for Tclass._System.Tuple0
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple0()) } 
  $IsBox(bx, Tclass._System.Tuple0())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple0()));

// Constructor $Is
axiom $Is(#_System._tuple#0._#Make0(), Tclass._System.Tuple0());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h));

// Constructor literal
axiom #_System._tuple#0._#Make0() == Lit(#_System._tuple#0._#Make0());

// Depth-one case-split function
function $IsA#_System.Tuple0(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple0(d) } 
  $IsA#_System.Tuple0(d) ==> _System.Tuple0.___hMake0_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d), $Is(d, Tclass._System.Tuple0()) } 
  $Is(d, Tclass._System.Tuple0()) ==> _System.Tuple0.___hMake0_q(d));

// Datatype extensional equality declaration
function _System.Tuple0#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#0._#Make0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  true ==> (_System.Tuple0#Equal(a, b) <==> true));

// Datatype extensionality axiom: _System._tuple#0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  _System.Tuple0#Equal(a, b) <==> a == b);

const unique class._System.Tuple0: ClassName;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const BaseFuel_SeqComparison._default.lte: LayerType;

const StartFuel_SeqComparison._default.lte: LayerType;

const StartFuelAssert_SeqComparison._default.lte: LayerType;

const BaseFuel_Sequences._default.NoDupes: LayerType;

const StartFuel_Sequences._default.NoDupes: LayerType;

const StartFuelAssert_Sequences._default.NoDupes: LayerType;

const BaseFuel_Sequences._default.Range: LayerType;

const StartFuel_Sequences._default.Range: LayerType;

const StartFuelAssert_Sequences._default.Range: LayerType;

const BaseFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuelAssert_Sequences._default.ApplyOpaque: LayerType;

const BaseFuel_Sequences._default.remove: LayerType;

const StartFuel_Sequences._default.remove: LayerType;

const StartFuelAssert_Sequences._default.remove: LayerType;

const BaseFuel_Sequences._default.insert: LayerType;

const StartFuel_Sequences._default.insert: LayerType;

const StartFuelAssert_Sequences._default.insert: LayerType;

const BaseFuel_Sequences._default.replace1with2: LayerType;

const StartFuel_Sequences._default.replace1with2: LayerType;

const StartFuelAssert_Sequences._default.replace1with2: LayerType;

const BaseFuel_Sequences._default.replace2with1: LayerType;

const StartFuel_Sequences._default.replace2with1: LayerType;

const StartFuelAssert_Sequences._default.replace2with1: LayerType;

const BaseFuel_Sequences._default.concat: LayerType;

const StartFuel_Sequences._default.concat: LayerType;

const StartFuelAssert_Sequences._default.concat: LayerType;

const BaseFuel_Sequences._default.concat3: LayerType;

const StartFuel_Sequences._default.concat3: LayerType;

const StartFuelAssert_Sequences._default.concat3: LayerType;

const BaseFuel_Sequences._default.concatSeq: LayerType;

const StartFuel_Sequences._default.concatSeq: LayerType;

const StartFuelAssert_Sequences._default.concatSeq: LayerType;

const BaseFuel_Sequences._default.IsPrefix: LayerType;

const StartFuel_Sequences._default.IsPrefix: LayerType;

const StartFuelAssert_Sequences._default.IsPrefix: LayerType;

const BaseFuel_Sequences._default.IsSuffix: LayerType;

const StartFuel_Sequences._default.IsSuffix: LayerType;

const StartFuelAssert_Sequences._default.IsSuffix: LayerType;

const BaseFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexIterate: LayerType;

const BaseFuel_Sequences._default.SeqIndex: LayerType;

const StartFuel_Sequences._default.SeqIndex: LayerType;

const StartFuelAssert_Sequences._default.SeqIndex: LayerType;

const BaseFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuelAssert_Sequences._default.SeqOfLength: LayerType;

const BaseFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexUpdate: LayerType;

const BaseFuel_Sequences._default.Zip: LayerType;

const StartFuel_Sequences._default.Zip: LayerType;

const StartFuelAssert_Sequences._default.Zip: LayerType;

const BaseFuel_Sequences._default.Unzip: LayerType;

const StartFuel_Sequences._default.Unzip: LayerType;

const StartFuelAssert_Sequences._default.Unzip: LayerType;

const BaseFuel_Sequences._default.FlattenShape: LayerType;

const StartFuel_Sequences._default.FlattenShape: LayerType;

const StartFuelAssert_Sequences._default.FlattenShape: LayerType;

const BaseFuel_Sequences._default.FlattenLength: LayerType;

const StartFuel_Sequences._default.FlattenLength: LayerType;

const StartFuelAssert_Sequences._default.FlattenLength: LayerType;

const BaseFuel_Sequences._default.Flatten: LayerType;

const StartFuel_Sequences._default.Flatten: LayerType;

const StartFuelAssert_Sequences._default.Flatten: LayerType;

const BaseFuel_Sequences._default.fill: LayerType;

const StartFuel_Sequences._default.fill: LayerType;

const StartFuelAssert_Sequences._default.fill: LayerType;

const BaseFuel_Maps._default.MapRemove: LayerType;

const StartFuel_Maps._default.MapRemove: LayerType;

const StartFuelAssert_Maps._default.MapRemove: LayerType;

const BaseFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuelAssert_Maps._default.MapRemoveStrong: LayerType;

const BaseFuel_Maps._default.MapRemove1: LayerType;

const StartFuel_Maps._default.MapRemove1: LayerType;

const StartFuelAssert_Maps._default.MapRemove1: LayerType;

const BaseFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuelAssert_Maps._default.MapRemove1Strong: LayerType;

const BaseFuel_Maps._default.IMapRemove: LayerType;

const StartFuel_Maps._default.IMapRemove: LayerType;

const StartFuelAssert_Maps._default.IMapRemove: LayerType;

const BaseFuel_Maps._default.IMapRemove1: LayerType;

const StartFuel_Maps._default.IMapRemove1: LayerType;

const StartFuelAssert_Maps._default.IMapRemove1: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion: LayerType;

const BaseFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferA: LayerType;

const BaseFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferB: LayerType;

const BaseFuel_Maps._default.MapUnion: LayerType;

const StartFuel_Maps._default.MapUnion: LayerType;

const StartFuelAssert_Maps._default.MapUnion: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferA: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferB: LayerType;

const BaseFuel_Maps._default.IMapUnion: LayerType;

const StartFuel_Maps._default.IMapUnion: LayerType;

const StartFuelAssert_Maps._default.IMapUnion: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion3: LayerType;

const BaseFuel_Uint32_Order._default.ltedef: LayerType;

const StartFuel_Uint32_Order._default.ltedef: LayerType;

const StartFuelAssert_Uint32_Order._default.ltedef: LayerType;

const BaseFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Uint32_Order._default.NotMinimum: LayerType;

const StartFuel_Uint32_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Uint32_Order._default.NotMinimum: LayerType;

const BaseFuel_Uint32_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Uint32_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Uint32_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Uint32_Order._default.minimum: LayerType;

const StartFuel_Uint32_Order._default.minimum: LayerType;

const StartFuelAssert_Uint32_Order._default.minimum: LayerType;

const BaseFuel_Uint32_Order._default.minimumOpt: LayerType;

const StartFuel_Uint32_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Uint32_Order._default.minimumOpt: LayerType;

const BaseFuel_Uint32_Order._default.maximum: LayerType;

const StartFuel_Uint32_Order._default.maximum: LayerType;

const StartFuelAssert_Uint32_Order._default.maximum: LayerType;

const BaseFuel_Uint32_Order._default.maximumOpt: LayerType;

const StartFuel_Uint32_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Uint32_Order._default.maximumOpt: LayerType;

const BaseFuel_Uint32_Order._default.IsSorted: LayerType;

const StartFuel_Uint32_Order._default.IsSorted: LayerType;

const StartFuelAssert_Uint32_Order._default.IsSorted: LayerType;

const BaseFuel_Uint32_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Uint32_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Uint32_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_Byte_Order._default.lte: LayerType;

const StartFuel_Byte_Order._default.lte: LayerType;

const StartFuelAssert_Byte_Order._default.lte: LayerType;

const BaseFuel_Byte_Order._default.ltedef: LayerType;

const StartFuel_Byte_Order._default.ltedef: LayerType;

const StartFuelAssert_Byte_Order._default.ltedef: LayerType;

const BaseFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Byte_Order._default.NotMinimum: LayerType;

const StartFuel_Byte_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Byte_Order._default.NotMinimum: LayerType;

const BaseFuel_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Byte_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Byte_Order._default.minimum: LayerType;

const StartFuel_Byte_Order._default.minimum: LayerType;

const StartFuelAssert_Byte_Order._default.minimum: LayerType;

const BaseFuel_Byte_Order._default.minimumOpt: LayerType;

const StartFuel_Byte_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Byte_Order._default.minimumOpt: LayerType;

const BaseFuel_Byte_Order._default.maximum: LayerType;

const StartFuel_Byte_Order._default.maximum: LayerType;

const StartFuelAssert_Byte_Order._default.maximum: LayerType;

const BaseFuel_Byte_Order._default.maximumOpt: LayerType;

const StartFuel_Byte_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Byte_Order._default.maximumOpt: LayerType;

const BaseFuel_Byte_Order._default.IsSorted: LayerType;

const StartFuel_Byte_Order._default.IsSorted: LayerType;

const StartFuelAssert_Byte_Order._default.IsSorted: LayerType;

const BaseFuel_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Byte_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.minimum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.minimum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.minimum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.maximum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.maximum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.maximum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_PackedStringArray._default.psaSeq: LayerType;

const StartFuel_PackedStringArray._default.psaSeq: LayerType;

const StartFuelAssert_PackedStringArray._default.psaSeq: LayerType;

const BaseFuel_PivotsLib._default.CutoffForLeft: LayerType;

const StartFuel_PivotsLib._default.CutoffForLeft: LayerType;

const StartFuelAssert_PivotsLib._default.CutoffForLeft: LayerType;

const BaseFuel_PivotsLib._default.CutoffForRight: LayerType;

const StartFuel_PivotsLib._default.CutoffForRight: LayerType;

const StartFuelAssert_PivotsLib._default.CutoffForRight: LayerType;

const BaseFuel_Multisets._default.Choose: LayerType;

const StartFuel_Multisets._default.Choose: LayerType;

const StartFuelAssert_Multisets._default.Choose: LayerType;

const BaseFuel_Multisets._default.Apply: LayerType;

const StartFuel_Multisets._default.Apply: LayerType;

const StartFuelAssert_Multisets._default.Apply: LayerType;

const BaseFuel_Multisets._default.Fold: LayerType;

const StartFuel_Multisets._default.Fold: LayerType;

const StartFuelAssert_Multisets._default.Fold: LayerType;

const BaseFuel_Multisets._default.IsIdentity: LayerType;

const StartFuel_Multisets._default.IsIdentity: LayerType;

const StartFuelAssert_Multisets._default.IsIdentity: LayerType;

const BaseFuel_Multisets._default.IsCommutative: LayerType;

const StartFuel_Multisets._default.IsCommutative: LayerType;

const StartFuelAssert_Multisets._default.IsCommutative: LayerType;

const BaseFuel_Multisets._default.IsAssociative: LayerType;

const StartFuel_Multisets._default.IsAssociative: LayerType;

const StartFuelAssert_Multisets._default.IsAssociative: LayerType;

const BaseFuel_BucketsLib._default.BucketMapOfSeq: LayerType;

const StartFuel_BucketsLib._default.BucketMapOfSeq: LayerType;

const StartFuelAssert_BucketsLib._default.BucketMapOfSeq: LayerType;

const BaseFuel_BucketsLib._default.B: LayerType;

const StartFuel_BucketsLib._default.B: LayerType;

const StartFuelAssert_BucketsLib._default.B: LayerType;

const BaseFuel_BucketsLib._default.BucketIntersect: LayerType;

const StartFuel_BucketsLib._default.BucketIntersect: LayerType;

const StartFuelAssert_BucketsLib._default.BucketIntersect: LayerType;

const BaseFuel_BucketsLib._default.BucketComplement: LayerType;

const StartFuel_BucketsLib._default.BucketComplement: LayerType;

const StartFuelAssert_BucketsLib._default.BucketComplement: LayerType;

const BaseFuel_BucketsLib._default.Compose: LayerType;

const StartFuel_BucketsLib._default.Compose: LayerType;

const StartFuelAssert_BucketsLib._default.Compose: LayerType;

const BaseFuel_BucketsLib._default.ComposeSeq: LayerType;

const StartFuel_BucketsLib._default.ComposeSeq: LayerType;

const StartFuelAssert_BucketsLib._default.ComposeSeq: LayerType;

const BaseFuel_BucketsLib._default.ClampRange: LayerType;

const StartFuel_BucketsLib._default.ClampRange: LayerType;

const StartFuelAssert_BucketsLib._default.ClampRange: LayerType;

const BaseFuel_BucketsLib._default.ClampStart: LayerType;

const StartFuel_BucketsLib._default.ClampStart: LayerType;

const StartFuelAssert_BucketsLib._default.ClampStart: LayerType;

const BaseFuel_BucketsLib._default.ClampEnd: LayerType;

const StartFuel_BucketsLib._default.ClampEnd: LayerType;

const StartFuelAssert_BucketsLib._default.ClampEnd: LayerType;

const BaseFuel_BucketsLib._default.KeyValueMapOfBucket: LayerType;

const StartFuel_BucketsLib._default.KeyValueMapOfBucket: LayerType;

const StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket: LayerType;

const BaseFuel_BucketsLib._default.SortedSeqOfKeyValueMap: LayerType;

const StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap: LayerType;

const StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap: LayerType;

const BaseFuel_BucketsLib._default.SplitBucketLeft: LayerType;

const StartFuel_BucketsLib._default.SplitBucketLeft: LayerType;

const StartFuelAssert_BucketsLib._default.SplitBucketLeft: LayerType;

const BaseFuel_BucketsLib._default.SplitBucketRight: LayerType;

const StartFuel_BucketsLib._default.SplitBucketRight: LayerType;

const StartFuelAssert_BucketsLib._default.SplitBucketRight: LayerType;

const BaseFuel_BucketsLib._default.SplitBucketInList: LayerType;

const StartFuel_BucketsLib._default.SplitBucketInList: LayerType;

const StartFuelAssert_BucketsLib._default.SplitBucketInList: LayerType;

const BaseFuel_BucketsLib._default.MergeBuckets: LayerType;

const StartFuel_BucketsLib._default.MergeBuckets: LayerType;

const StartFuelAssert_BucketsLib._default.MergeBuckets: LayerType;

const BaseFuel_BucketsLib._default.MergeBucketsInList: LayerType;

const StartFuel_BucketsLib._default.MergeBucketsInList: LayerType;

const StartFuelAssert_BucketsLib._default.MergeBucketsInList: LayerType;

const BaseFuel_Integer_Order._default.ltedef: LayerType;

const StartFuel_Integer_Order._default.ltedef: LayerType;

const StartFuelAssert_Integer_Order._default.ltedef: LayerType;

const BaseFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Integer_Order._default.NotMinimum: LayerType;

const StartFuel_Integer_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Integer_Order._default.NotMinimum: LayerType;

const BaseFuel_Integer_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Integer_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Integer_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Integer_Order._default.minimum: LayerType;

const StartFuel_Integer_Order._default.minimum: LayerType;

const StartFuelAssert_Integer_Order._default.minimum: LayerType;

const BaseFuel_Integer_Order._default.minimumOpt: LayerType;

const StartFuel_Integer_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Integer_Order._default.minimumOpt: LayerType;

const BaseFuel_Integer_Order._default.maximum: LayerType;

const StartFuel_Integer_Order._default.maximum: LayerType;

const StartFuelAssert_Integer_Order._default.maximum: LayerType;

const BaseFuel_Integer_Order._default.maximumOpt: LayerType;

const StartFuel_Integer_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Integer_Order._default.maximumOpt: LayerType;

const BaseFuel_Integer_Order._default.IsSorted: LayerType;

const StartFuel_Integer_Order._default.IsSorted: LayerType;

const StartFuelAssert_Integer_Order._default.IsSorted: LayerType;

const BaseFuel_Integer_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Integer_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Integer_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_PackedKV._default.psaSeq_Messages: LayerType;

const StartFuel_PackedKV._default.psaSeq_Messages: LayerType;

const StartFuelAssert_PackedKV._default.psaSeq_Messages: LayerType;

const BaseFuel_Uint64_Order._default.ltedef: LayerType;

const StartFuel_Uint64_Order._default.ltedef: LayerType;

const StartFuelAssert_Uint64_Order._default.ltedef: LayerType;

const BaseFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Uint64_Order._default.NotMinimum: LayerType;

const StartFuel_Uint64_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Uint64_Order._default.NotMinimum: LayerType;

const BaseFuel_Uint64_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Uint64_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Uint64_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Uint64_Order._default.minimum: LayerType;

const StartFuel_Uint64_Order._default.minimum: LayerType;

const StartFuelAssert_Uint64_Order._default.minimum: LayerType;

const BaseFuel_Uint64_Order._default.minimumOpt: LayerType;

const StartFuel_Uint64_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Uint64_Order._default.minimumOpt: LayerType;

const BaseFuel_Uint64_Order._default.maximum: LayerType;

const StartFuel_Uint64_Order._default.maximum: LayerType;

const StartFuelAssert_Uint64_Order._default.maximum: LayerType;

const BaseFuel_Uint64_Order._default.maximumOpt: LayerType;

const StartFuel_Uint64_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Uint64_Order._default.maximumOpt: LayerType;

const BaseFuel_Uint64_Order._default.IsSorted: LayerType;

const StartFuel_Uint64_Order._default.IsSorted: LayerType;

const StartFuelAssert_Uint64_Order._default.IsSorted: LayerType;

const BaseFuel_Uint64_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Uint64_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Uint64_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_BucketWeights._default.WeightKeyMultiset: LayerType;

const StartFuel_BucketWeights._default.WeightKeyMultiset: LayerType;

const StartFuelAssert_BucketWeights._default.WeightKeyMultiset: LayerType;

const BaseFuel_BucketWeights._default.WeightKeySeq: LayerType;

const StartFuel_BucketWeights._default.WeightKeySeq: LayerType;

const StartFuelAssert_BucketWeights._default.WeightKeySeq: LayerType;

const BaseFuel_BucketWeights._default.WeightMessageMultiset: LayerType;

const StartFuel_BucketWeights._default.WeightMessageMultiset: LayerType;

const StartFuelAssert_BucketWeights._default.WeightMessageMultiset: LayerType;

const BaseFuel_BucketWeights._default.WeightMessageSeq: LayerType;

const StartFuel_BucketWeights._default.WeightMessageSeq: LayerType;

const StartFuelAssert_BucketWeights._default.WeightMessageSeq: LayerType;

const BaseFuel_BucketWeights._default.WeightBucketList: LayerType;

const StartFuel_BucketWeights._default.WeightBucketList: LayerType;

const StartFuelAssert_BucketWeights._default.WeightBucketList: LayerType;

const BaseFuel_BucketWeights._default.Image: LayerType;

const StartFuel_BucketWeights._default.Image: LayerType;

const StartFuelAssert_BucketWeights._default.Image: LayerType;

const BaseFuel_BucketModel._default.mergeToOneChild: LayerType;

const StartFuel_BucketModel._default.mergeToOneChild: LayerType;

const StartFuelAssert_BucketModel._default.mergeToOneChild: LayerType;

const BaseFuel_BucketModel._default.mergeToChildren: LayerType;

const StartFuel_BucketModel._default.mergeToChildren: LayerType;

const StartFuelAssert_BucketModel._default.mergeToChildren: LayerType;

const BaseFuel_BucketModel._default.partialFlush: LayerType;

const StartFuel_BucketModel._default.partialFlush: LayerType;

const StartFuelAssert_BucketModel._default.partialFlush: LayerType;

// Constructor function declaration
function #DynamicPkv.Capacity.Capacity(int, int, int) : DatatypeType;

const unique ##DynamicPkv.Capacity.Capacity: DtCtorId;

// Constructor identifier
axiom (forall a#14#0#0: int, a#14#1#0: int, a#14#2#0: int :: 
  { #DynamicPkv.Capacity.Capacity(a#14#0#0, a#14#1#0, a#14#2#0) } 
  DatatypeCtorId(#DynamicPkv.Capacity.Capacity(a#14#0#0, a#14#1#0, a#14#2#0))
     == ##DynamicPkv.Capacity.Capacity);

function DynamicPkv.Capacity.Capacity_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { DynamicPkv.Capacity.Capacity_q(d) } 
  DynamicPkv.Capacity.Capacity_q(d)
     <==> DatatypeCtorId(d) == ##DynamicPkv.Capacity.Capacity);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { DynamicPkv.Capacity.Capacity_q(d) } 
  DynamicPkv.Capacity.Capacity_q(d)
     ==> (exists a#15#0#0: int, a#15#1#0: int, a#15#2#0: int :: 
      d == #DynamicPkv.Capacity.Capacity(a#15#0#0, a#15#1#0, a#15#2#0)));

function Tclass.NativeTypes.uint32() : Ty;

// Tclass.NativeTypes.uint32 Tag
axiom Tag(Tclass.NativeTypes.uint32()) == Tagclass.NativeTypes.uint32;

const unique Tagclass.NativeTypes.uint32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint32()) } 
  $IsBox(bx, Tclass.NativeTypes.uint32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint32()));

function Tclass.DynamicPkv.Capacity() : Ty;

// Tclass.DynamicPkv.Capacity Tag
axiom Tag(Tclass.DynamicPkv.Capacity()) == Tagclass.DynamicPkv.Capacity;

const unique Tagclass.DynamicPkv.Capacity: TyTag;

// Box/unbox axiom for Tclass.DynamicPkv.Capacity
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DynamicPkv.Capacity()) } 
  $IsBox(bx, Tclass.DynamicPkv.Capacity())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.DynamicPkv.Capacity()));

// Constructor $Is
axiom (forall a#16#0#0: int, a#16#1#0: int, a#16#2#0: int :: 
  { $Is(#DynamicPkv.Capacity.Capacity(a#16#0#0, a#16#1#0, a#16#2#0), 
      Tclass.DynamicPkv.Capacity()) } 
  $Is(#DynamicPkv.Capacity.Capacity(a#16#0#0, a#16#1#0, a#16#2#0), 
      Tclass.DynamicPkv.Capacity())
     <==> $Is(a#16#0#0, Tclass.NativeTypes.uint32())
       && $Is(a#16#1#0, Tclass.NativeTypes.uint32())
       && $Is(a#16#2#0, Tclass.NativeTypes.uint32()));

// Constructor $IsAlloc
axiom (forall a#17#0#0: int, a#17#1#0: int, a#17#2#0: int, $h: Heap :: 
  { $IsAlloc(#DynamicPkv.Capacity.Capacity(a#17#0#0, a#17#1#0, a#17#2#0), 
      Tclass.DynamicPkv.Capacity(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#DynamicPkv.Capacity.Capacity(a#17#0#0, a#17#1#0, a#17#2#0), 
        Tclass.DynamicPkv.Capacity(), 
        $h)
       <==> $IsAlloc(a#17#0#0, Tclass.NativeTypes.uint32(), $h)
         && $IsAlloc(a#17#1#0, Tclass.NativeTypes.uint32(), $h)
         && $IsAlloc(a#17#2#0, Tclass.NativeTypes.uint32(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.Capacity.num__kv__pairs(d), Tclass.NativeTypes.uint32(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.Capacity.Capacity_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.Capacity(), $h)
     ==> $IsAlloc(DynamicPkv.Capacity.num__kv__pairs(d), Tclass.NativeTypes.uint32(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.Capacity.total__key__len(d), Tclass.NativeTypes.uint32(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.Capacity.Capacity_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.Capacity(), $h)
     ==> $IsAlloc(DynamicPkv.Capacity.total__key__len(d), Tclass.NativeTypes.uint32(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.Capacity.total__message__len(d), Tclass.NativeTypes.uint32(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.Capacity.Capacity_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.Capacity(), $h)
     ==> $IsAlloc(DynamicPkv.Capacity.total__message__len(d), Tclass.NativeTypes.uint32(), $h));

// Constructor literal
axiom (forall a#18#0#0: int, a#18#1#0: int, a#18#2#0: int :: 
  { #DynamicPkv.Capacity.Capacity(LitInt(a#18#0#0), LitInt(a#18#1#0), LitInt(a#18#2#0)) } 
  #DynamicPkv.Capacity.Capacity(LitInt(a#18#0#0), LitInt(a#18#1#0), LitInt(a#18#2#0))
     == Lit(#DynamicPkv.Capacity.Capacity(a#18#0#0, a#18#1#0, a#18#2#0)));

function DynamicPkv.Capacity.num__kv__pairs(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#19#0#0: int, a#19#1#0: int, a#19#2#0: int :: 
  { #DynamicPkv.Capacity.Capacity(a#19#0#0, a#19#1#0, a#19#2#0) } 
  DynamicPkv.Capacity.num__kv__pairs(#DynamicPkv.Capacity.Capacity(a#19#0#0, a#19#1#0, a#19#2#0))
     == a#19#0#0);

function DynamicPkv.Capacity.total__key__len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#20#0#0: int, a#20#1#0: int, a#20#2#0: int :: 
  { #DynamicPkv.Capacity.Capacity(a#20#0#0, a#20#1#0, a#20#2#0) } 
  DynamicPkv.Capacity.total__key__len(#DynamicPkv.Capacity.Capacity(a#20#0#0, a#20#1#0, a#20#2#0))
     == a#20#1#0);

function DynamicPkv.Capacity.total__message__len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#21#0#0: int, a#21#1#0: int, a#21#2#0: int :: 
  { #DynamicPkv.Capacity.Capacity(a#21#0#0, a#21#1#0, a#21#2#0) } 
  DynamicPkv.Capacity.total__message__len(#DynamicPkv.Capacity.Capacity(a#21#0#0, a#21#1#0, a#21#2#0))
     == a#21#2#0);

// Depth-one case-split function
function $IsA#DynamicPkv.Capacity(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#DynamicPkv.Capacity(d) } 
  $IsA#DynamicPkv.Capacity(d) ==> DynamicPkv.Capacity.Capacity_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { DynamicPkv.Capacity.Capacity_q(d), $Is(d, Tclass.DynamicPkv.Capacity()) } 
  $Is(d, Tclass.DynamicPkv.Capacity()) ==> DynamicPkv.Capacity.Capacity_q(d));

// Datatype extensional equality declaration
function DynamicPkv.Capacity#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #DynamicPkv.Capacity.Capacity
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.Capacity#Equal(a, b) } 
  true
     ==> (DynamicPkv.Capacity#Equal(a, b)
       <==> DynamicPkv.Capacity.num__kv__pairs(a) == DynamicPkv.Capacity.num__kv__pairs(b)
         && DynamicPkv.Capacity.total__key__len(a) == DynamicPkv.Capacity.total__key__len(b)
         && DynamicPkv.Capacity.total__message__len(a)
           == DynamicPkv.Capacity.total__message__len(b)));

// Datatype extensionality axiom: DynamicPkv.Capacity
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.Capacity#Equal(a, b) } 
  DynamicPkv.Capacity#Equal(a, b) <==> a == b);

const unique class.DynamicPkv.Capacity: ClassName;

const unique class.DynamicPkv.DynamicPkv?: ClassName;

function Tclass.DynamicPkv.DynamicPkv?() : Ty;

// Tclass.DynamicPkv.DynamicPkv? Tag
axiom Tag(Tclass.DynamicPkv.DynamicPkv?()) == Tagclass.DynamicPkv.DynamicPkv?;

const unique Tagclass.DynamicPkv.DynamicPkv?: TyTag;

// Box/unbox axiom for Tclass.DynamicPkv.DynamicPkv?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DynamicPkv.DynamicPkv?()) } 
  $IsBox(bx, Tclass.DynamicPkv.DynamicPkv?())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.DynamicPkv.DynamicPkv?()));

// DynamicPkv: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.DynamicPkv.DynamicPkv?()) } 
  $Is($o, Tclass.DynamicPkv.DynamicPkv?())
     <==> $o == null || dtype($o) == Tclass.DynamicPkv.DynamicPkv?());

// DynamicPkv: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.DynamicPkv.DynamicPkv?(), $h) } 
  $IsAlloc($o, Tclass.DynamicPkv.DynamicPkv?(), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(DynamicPkv.DynamicPkv.keys) == 0
   && FieldOfDecl(class.DynamicPkv.DynamicPkv?, field$keys)
     == DynamicPkv.DynamicPkv.keys
   && !$IsGhostField(DynamicPkv.DynamicPkv.keys);

const DynamicPkv.DynamicPkv.keys: Field ref;

function Tclass.PackedStringArray.DynamicPsa() : Ty;

// Tclass.PackedStringArray.DynamicPsa Tag
axiom Tag(Tclass.PackedStringArray.DynamicPsa())
   == Tagclass.PackedStringArray.DynamicPsa;

const unique Tagclass.PackedStringArray.DynamicPsa: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.DynamicPsa
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.DynamicPsa()) } 
  $IsBox(bx, Tclass.PackedStringArray.DynamicPsa())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.DynamicPsa()));

// DynamicPkv.keys: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DynamicPkv.DynamicPkv.keys) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.DynamicPkv.DynamicPkv?()
     ==> $Is(read($h, $o, DynamicPkv.DynamicPkv.keys), Tclass.PackedStringArray.DynamicPsa()));

// DynamicPkv.keys: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DynamicPkv.DynamicPkv.keys) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.DynamicPkv.DynamicPkv?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, DynamicPkv.DynamicPkv.keys), 
      Tclass.PackedStringArray.DynamicPsa(), 
      $h));

axiom FDim(DynamicPkv.DynamicPkv.messages) == 0
   && FieldOfDecl(class.DynamicPkv.DynamicPkv?, field$messages)
     == DynamicPkv.DynamicPkv.messages
   && !$IsGhostField(DynamicPkv.DynamicPkv.messages);

const DynamicPkv.DynamicPkv.messages: Field ref;

// DynamicPkv.messages: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DynamicPkv.DynamicPkv.messages) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.DynamicPkv.DynamicPkv?()
     ==> $Is(read($h, $o, DynamicPkv.DynamicPkv.messages), 
      Tclass.PackedStringArray.DynamicPsa()));

// DynamicPkv.messages: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DynamicPkv.DynamicPkv.messages) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.DynamicPkv.DynamicPkv?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, DynamicPkv.DynamicPkv.messages), 
      Tclass.PackedStringArray.DynamicPsa(), 
      $h));

axiom FDim(DynamicPkv.DynamicPkv.Repr) == 0
   && FieldOfDecl(class.DynamicPkv.DynamicPkv?, field$Repr)
     == DynamicPkv.DynamicPkv.Repr
   && $IsGhostField(DynamicPkv.DynamicPkv.Repr);

const DynamicPkv.DynamicPkv.Repr: Field (Set Box);

// DynamicPkv.Repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DynamicPkv.DynamicPkv.Repr) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.DynamicPkv.DynamicPkv?()
     ==> $Is(read($h, $o, DynamicPkv.DynamicPkv.Repr), TSet(Tclass._System.object())));

// DynamicPkv.Repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DynamicPkv.DynamicPkv.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.DynamicPkv.DynamicPkv?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, DynamicPkv.DynamicPkv.Repr), TSet(Tclass._System.object()), $h));

// function declaration for DynamicPkv.DynamicPkv.WF
function DynamicPkv.DynamicPkv.WF($heap: Heap, this: ref) : bool;

function DynamicPkv.DynamicPkv.WF#canCall($heap: Heap, this: ref) : bool;

function Tclass.DynamicPkv.DynamicPkv() : Ty;

// Tclass.DynamicPkv.DynamicPkv Tag
axiom Tag(Tclass.DynamicPkv.DynamicPkv()) == Tagclass.DynamicPkv.DynamicPkv;

const unique Tagclass.DynamicPkv.DynamicPkv: TyTag;

// Box/unbox axiom for Tclass.DynamicPkv.DynamicPkv
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DynamicPkv.DynamicPkv()) } 
  $IsBox(bx, Tclass.DynamicPkv.DynamicPkv())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.DynamicPkv.DynamicPkv()));

// frame axiom for DynamicPkv.DynamicPkv.WF
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DynamicPkv.DynamicPkv.WF($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.DynamicPkv.DynamicPkv())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> DynamicPkv.DynamicPkv.WF($h0, this) == DynamicPkv.DynamicPkv.WF($h1, this));

// consequence axiom for DynamicPkv.DynamicPkv.WF
axiom 3 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { DynamicPkv.DynamicPkv.WF($Heap, this) } 
    DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         || (3 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.DynamicPkv.DynamicPkv())
           && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap))
       ==> true);

function DynamicPkv.DynamicPkv.WF#requires(Heap, ref) : bool;

// #requires axiom for DynamicPkv.DynamicPkv.WF
axiom (forall $Heap: Heap, this: ref :: 
  { DynamicPkv.DynamicPkv.WF#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.DynamicPkv.DynamicPkv())
       && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
     ==> DynamicPkv.DynamicPkv.WF#requires($Heap, this) == true);

axiom FDim(PackedStringArray.DynamicPsa.Repr) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$Repr)
     == PackedStringArray.DynamicPsa.Repr
   && $IsGhostField(PackedStringArray.DynamicPsa.Repr);

// definition axiom for DynamicPkv.DynamicPkv.WF(revealed)
axiom 3 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { DynamicPkv.DynamicPkv.WF($Heap, this) } 
    DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         || (3 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.DynamicPkv.DynamicPkv())
           && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap))
       ==> (Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr))
             && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr))
             && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr))
           ==> PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)))
         && (PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)))
         && (PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             && PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             && PackedKV.__default.WF#canCall(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)))))
         && DynamicPkv.DynamicPkv.WF($Heap, this)
           == (
            read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
             && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
             && Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr))
             && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
             && Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr))
             && 
            Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr))
             && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr))
             && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr))
             && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))))));

procedure CheckWellformed$$DynamicPkv.DynamicPkv.WF(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap, $Tick;



axiom FDim(PackedStringArray.DynamicPsa.offsets) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$offsets)
     == PackedStringArray.DynamicPsa.offsets
   && !$IsGhostField(PackedStringArray.DynamicPsa.offsets);

axiom FDim(PackedStringArray.DynamicPsa.data) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$data)
     == PackedStringArray.DynamicPsa.data
   && !$IsGhostField(PackedStringArray.DynamicPsa.data);

axiom FDim(PackedStringArray.DynamicPsa.nstrings) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$nstrings)
     == PackedStringArray.DynamicPsa.nstrings
   && !$IsGhostField(PackedStringArray.DynamicPsa.nstrings);

function Tclass.PackedKV.Pkv() : Ty;

// Tclass.PackedKV.Pkv Tag
axiom Tag(Tclass.PackedKV.Pkv()) == Tagclass.PackedKV.Pkv;

const unique Tagclass.PackedKV.Pkv: TyTag;

// Box/unbox axiom for Tclass.PackedKV.Pkv
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedKV.Pkv()) } 
  $IsBox(bx, Tclass.PackedKV.Pkv())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PackedKV.Pkv()));

implementation CheckWellformed$$DynamicPkv.DynamicPkv.WF(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var ##pkv#0: DatatypeType;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;
  var b$reqreads#9: bool;
  var b$reqreads#10: bool;
  var b$reqreads#11: bool;
  var b$reqreads#12: bool;
  var b$reqreads#13: bool;
  var b$reqreads#14: bool;
  var b$reqreads#15: bool;
  var b$reqreads#16: bool;
  var b$reqreads#17: bool;
  var b$reqreads#18: bool;
  var b$reqreads#19: bool;
  var b$reqreads#20: bool;
  var b$reqreads#21: bool;
  var b$reqreads#22: bool;
  var b$reqreads#23: bool;
  var b$reqreads#24: bool;
  var b$reqreads#25: bool;
  var b$reqreads#26: bool;
  var b$reqreads#27: bool;
  var b$reqreads#28: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;
    b$reqreads#9 := true;
    b$reqreads#10 := true;
    b$reqreads#11 := true;
    b$reqreads#12 := true;
    b$reqreads#13 := true;
    b$reqreads#14 := true;
    b$reqreads#15 := true;
    b$reqreads#16 := true;
    b$reqreads#17 := true;
    b$reqreads#18 := true;
    b$reqreads#19 := true;
    b$reqreads#20 := true;
    b$reqreads#21 := true;
    b$reqreads#22 := true;
    b$reqreads#23 := true;
    b$reqreads#24 := true;
    b$reqreads#25 := true;
    b$reqreads#26 := true;
    b$reqreads#27 := true;
    b$reqreads#28 := true;

    // AddWellformednessCheck for function WF
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(644,14): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    b$reqreads#0 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
    assert b$reqreads#0;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
        b$reqreads#1 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
        if (read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)])
        {
            b$reqreads#2 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
            b$reqreads#3 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
        }

        if (read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))])
        {
            b$reqreads#4 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
            assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
            b$reqreads#5 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.keys), PackedStringArray.DynamicPsa.Repr];
            b$reqreads#6 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
        }

        if (read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr)))
        {
            b$reqreads#7 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
            b$reqreads#8 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
        }

        if (read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))])
        {
            b$reqreads#9 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
            assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
            b$reqreads#10 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.messages), PackedStringArray.DynamicPsa.Repr];
            b$reqreads#11 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
        }

        if (read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr)))
        {
            b$reqreads#12 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
            assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
            b$reqreads#13 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.keys), PackedStringArray.DynamicPsa.Repr];
            if (Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr)))
            {
                b$reqreads#14 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
                assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
                b$reqreads#15 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.keys), PackedStringArray.DynamicPsa.Repr];
            }

            if (Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr))
               && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)))
            {
                b$reqreads#16 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
                assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
                b$reqreads#17 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.keys), PackedStringArray.DynamicPsa.Repr];
                b$reqreads#18 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
                assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
                b$reqreads#19 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.messages), PackedStringArray.DynamicPsa.Repr];
            }
        }

        if (read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && 
          Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr)))
        {
            b$reqreads#20 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
            assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
            b$reqreads#21 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == read($Heap, this, DynamicPkv.DynamicPkv.keys)
                     || read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        }

        if (read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && 
          Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr))
           && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)))
        {
            b$reqreads#22 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
            assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
            b$reqreads#23 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == read($Heap, this, DynamicPkv.DynamicPkv.messages)
                     || read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        }

        if (read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && 
          Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr))
           && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)))
        {
            b$reqreads#24 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
            assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
                 || Set#Equal(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))), 
                      $Box(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                          PackedStringArray.DynamicPsa.offsets))), 
                    $Box(read($Heap, 
                        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                        PackedStringArray.DynamicPsa.data))));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
                 || _System.array.Length(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.offsets))
                   < NativeTypes.__default.Uint64UpperBound();
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
                 || _System.array.Length(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.data))
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
                 || read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.nstrings)
                   <= _System.array.Length(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.offsets));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
                 || read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.nstrings)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
                 || (0
                     < read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                          PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, 
                              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                              PackedStringArray.DynamicPsa.nstrings)
                             - 1))): int
                     < 4294967296);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
                 || (0
                     < read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                          PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, 
                              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                              PackedStringArray.DynamicPsa.nstrings)
                             - 1))): int
                     <= _System.array.Length(read($Heap, 
                        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                        PackedStringArray.DynamicPsa.data)));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  Seq#Take(Seq#FromArray($Heap, 
                      read($Heap, 
                        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                        PackedStringArray.DynamicPsa.offsets)), 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.nstrings)));
            assume PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
            b$reqreads#25 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == read($Heap, this, DynamicPkv.DynamicPkv.keys)
                     || read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)));
            b$reqreads#26 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
            assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
                 || Set#Equal(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))), 
                      $Box(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                          PackedStringArray.DynamicPsa.offsets))), 
                    $Box(read($Heap, 
                        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                        PackedStringArray.DynamicPsa.data))));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
                 || _System.array.Length(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.offsets))
                   < NativeTypes.__default.Uint64UpperBound();
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
                 || _System.array.Length(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.data))
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
                 || read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.nstrings)
                   <= _System.array.Length(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.offsets));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
                 || read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.nstrings)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
                 || (0
                     < read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                          PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, 
                              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                              PackedStringArray.DynamicPsa.nstrings)
                             - 1))): int
                     < 4294967296);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
                 || (0
                     < read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                          PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, 
                              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                              PackedStringArray.DynamicPsa.nstrings)
                             - 1))): int
                     <= _System.array.Length(read($Heap, 
                        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                        PackedStringArray.DynamicPsa.data)));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  Seq#Take(Seq#FromArray($Heap, 
                      read($Heap, 
                        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                        PackedStringArray.DynamicPsa.offsets)), 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.nstrings)));
            assume PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
            b$reqreads#27 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == read($Heap, this, DynamicPkv.DynamicPkv.messages)
                     || read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)));
            ##pkv#0 := #PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
              PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
            b$reqreads#28 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedKV.__default.WF#canCall(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
        }

        assume DynamicPkv.DynamicPkv.WF($Heap, this)
           == (
            read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
             && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
             && Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr))
             && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
             && Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr))
             && 
            Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr))
             && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr))
             && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr))
             && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)))));
        assume (Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr))
               && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr))
               && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.Repr))
             ==> PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)))
           && (PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             ==> PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)))
           && (PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
               && PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
               && PackedKV.__default.WF#canCall(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                  PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)))));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.DynamicPkv.WF($Heap, this), TBool);
        assert b$reqreads#1;
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
        assert b$reqreads#7;
        assert b$reqreads#8;
        assert b$reqreads#9;
        assert b$reqreads#10;
        assert b$reqreads#11;
        assert b$reqreads#12;
        assert b$reqreads#13;
        assert b$reqreads#14;
        assert b$reqreads#15;
        assert b$reqreads#16;
        assert b$reqreads#17;
        assert b$reqreads#18;
        assert b$reqreads#19;
        assert b$reqreads#20;
        assert b$reqreads#21;
        assert b$reqreads#22;
        assert b$reqreads#23;
        assert b$reqreads#24;
        assert b$reqreads#25;
        assert b$reqreads#26;
        assert b$reqreads#27;
        assert b$reqreads#28;
    }
}



// function declaration for DynamicPkv.DynamicPkv.toPkv
function DynamicPkv.DynamicPkv.toPkv($heap: Heap, this: ref) : DatatypeType;

function DynamicPkv.DynamicPkv.toPkv#canCall($heap: Heap, this: ref) : bool;

// frame axiom for DynamicPkv.DynamicPkv.toPkv
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DynamicPkv.DynamicPkv.toPkv($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.DynamicPkv.DynamicPkv())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> DynamicPkv.DynamicPkv.toPkv($h0, this) == DynamicPkv.DynamicPkv.toPkv($h1, this));

// consequence axiom for DynamicPkv.DynamicPkv.toPkv
axiom 4 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { DynamicPkv.DynamicPkv.toPkv($Heap, this) } 
    DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
         || (4 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.DynamicPkv.DynamicPkv())
           && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
           && DynamicPkv.DynamicPkv.WF($Heap, this))
       ==> $Is(DynamicPkv.DynamicPkv.toPkv($Heap, this), Tclass.PackedKV.Pkv()));

function DynamicPkv.DynamicPkv.toPkv#requires(Heap, ref) : bool;

// #requires axiom for DynamicPkv.DynamicPkv.toPkv
axiom (forall $Heap: Heap, this: ref :: 
  { DynamicPkv.DynamicPkv.toPkv#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.DynamicPkv.DynamicPkv())
       && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
     ==> DynamicPkv.DynamicPkv.toPkv#requires($Heap, this)
       == DynamicPkv.DynamicPkv.WF($Heap, this));

// definition axiom for DynamicPkv.DynamicPkv.toPkv(revealed)
axiom 4 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { DynamicPkv.DynamicPkv.toPkv($Heap, this) } 
    DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
         || (4 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.DynamicPkv.DynamicPkv())
           && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
           && DynamicPkv.DynamicPkv.WF($Heap, this))
       ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         && PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         && DynamicPkv.DynamicPkv.toPkv($Heap, this)
           == #PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));

procedure CheckWellformed$$DynamicPkv.DynamicPkv.toPkv(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.DynamicPkv.toPkv(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;

    // AddWellformednessCheck for function toPkv
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(658,20): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assert b$reqreads#0;
    b$reqreads#1 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(DynamicPkv.DynamicPkv.toPkv($Heap, this), Tclass.PackedKV.Pkv());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
        b$reqreads#2 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
        assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || Set#Equal(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))), 
                  $Box(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.nstrings)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || (0
                 < read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                          PackedStringArray.DynamicPsa.nstrings)
                         - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || (0
                 < read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                          PackedStringArray.DynamicPsa.nstrings)
                         - 1))): int
                 <= _System.array.Length(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == read($Heap, this, DynamicPkv.DynamicPkv.keys)
                 || read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)));
        b$reqreads#4 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
        assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || Set#Equal(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))), 
                  $Box(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.nstrings)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || (0
                 < read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                          PackedStringArray.DynamicPsa.nstrings)
                         - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || (0
                 < read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                          PackedStringArray.DynamicPsa.nstrings)
                         - 1))): int
                 <= _System.array.Length(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        b$reqreads#5 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == read($Heap, this, DynamicPkv.DynamicPkv.messages)
                 || read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)));
        assume DynamicPkv.DynamicPkv.toPkv($Heap, this)
           == #PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           && PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.DynamicPkv.toPkv($Heap, this), Tclass.PackedKV.Pkv());
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
    }
}



// function declaration for DynamicPkv.DynamicPkv.weight
function DynamicPkv.DynamicPkv.weight($heap: Heap, this: ref) : int;

function DynamicPkv.DynamicPkv.weight#canCall($heap: Heap, this: ref) : bool;

// frame axiom for DynamicPkv.DynamicPkv.weight
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DynamicPkv.DynamicPkv.weight($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.DynamicPkv.DynamicPkv())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> DynamicPkv.DynamicPkv.weight($h0, this)
       == DynamicPkv.DynamicPkv.weight($h1, this));

// consequence axiom for DynamicPkv.DynamicPkv.weight
axiom 6 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { DynamicPkv.DynamicPkv.weight($Heap, this) } 
    DynamicPkv.DynamicPkv.weight#canCall($Heap, this)
         || (6 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.DynamicPkv.DynamicPkv())
           && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
           && DynamicPkv.DynamicPkv.WF($Heap, this))
       ==> LitInt(0) <= DynamicPkv.DynamicPkv.weight($Heap, this)
         && DynamicPkv.DynamicPkv.weight($Heap, this) < 18446744073709551616);

function DynamicPkv.DynamicPkv.weight#requires(Heap, ref) : bool;

// #requires axiom for DynamicPkv.DynamicPkv.weight
axiom (forall $Heap: Heap, this: ref :: 
  { DynamicPkv.DynamicPkv.weight#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.DynamicPkv.DynamicPkv())
       && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
     ==> DynamicPkv.DynamicPkv.weight#requires($Heap, this)
       == DynamicPkv.DynamicPkv.WF($Heap, this));

// definition axiom for DynamicPkv.DynamicPkv.weight(revealed)
axiom 6 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { DynamicPkv.DynamicPkv.weight($Heap, this) } 
    DynamicPkv.DynamicPkv.weight#canCall($Heap, this)
         || (6 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.DynamicPkv.DynamicPkv())
           && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
           && DynamicPkv.DynamicPkv.WF($Heap, this))
       ==> PackedStringArray.DynamicPsa.weight#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         && PackedStringArray.DynamicPsa.weight#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         && DynamicPkv.DynamicPkv.weight($Heap, this)
           == PackedStringArray.DynamicPsa.weight($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             + PackedStringArray.DynamicPsa.weight($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)));

procedure CheckWellformed$$DynamicPkv.DynamicPkv.weight(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function Tclass.NativeTypes.uint64() : Ty;

// Tclass.NativeTypes.uint64 Tag
axiom Tag(Tclass.NativeTypes.uint64()) == Tagclass.NativeTypes.uint64;

const unique Tagclass.NativeTypes.uint64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint64()) } 
  $IsBox(bx, Tclass.NativeTypes.uint64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint64()));

implementation CheckWellformed$$DynamicPkv.DynamicPkv.weight(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var newtype$check#0: int;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;

    // AddWellformednessCheck for function weight
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(665,20): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assert b$reqreads#0;
    b$reqreads#1 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
    assert b$reqreads#1;
    if (*)
    {
        assume LitInt(0) <= DynamicPkv.DynamicPkv.weight($Heap, this)
           && DynamicPkv.DynamicPkv.weight($Heap, this) < 18446744073709551616;
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
        b$reqreads#2 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
        assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || Set#Equal(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))), 
                  $Box(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.nstrings)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || (0
                 < read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                          PackedStringArray.DynamicPsa.nstrings)
                         - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || (0
                 < read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                          PackedStringArray.DynamicPsa.nstrings)
                         - 1))): int
                 <= _System.array.Length(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == read($Heap, this, DynamicPkv.DynamicPkv.keys)
                 || read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume PackedStringArray.DynamicPsa.weight#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        b$reqreads#4 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
        assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || Set#Equal(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))), 
                  $Box(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.nstrings)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || (0
                 < read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                          PackedStringArray.DynamicPsa.nstrings)
                         - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || (0
                 < read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, 
                          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                          PackedStringArray.DynamicPsa.nstrings)
                         - 1))): int
                 <= _System.array.Length(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        b$reqreads#5 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == read($Heap, this, DynamicPkv.DynamicPkv.messages)
                 || read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume PackedStringArray.DynamicPsa.weight#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        newtype$check#0 := PackedStringArray.DynamicPsa.weight($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           + PackedStringArray.DynamicPsa.weight($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume DynamicPkv.DynamicPkv.weight($Heap, this)
           == PackedStringArray.DynamicPsa.weight($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
             + PackedStringArray.DynamicPsa.weight($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        assume PackedStringArray.DynamicPsa.weight#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           && PackedStringArray.DynamicPsa.weight#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.DynamicPkv.weight($Heap, this), Tclass.NativeTypes.uint64());
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
    }
}



function Tclass.KeyType.Key() : Ty;

// Tclass.KeyType.Key Tag
axiom Tag(Tclass.KeyType.Key()) == Tagclass.KeyType.Key;

const unique Tagclass.KeyType.Key: TyTag;

// Box/unbox axiom for Tclass.KeyType.Key
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KeyType.Key()) } 
  $IsBox(bx, Tclass.KeyType.Key())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.KeyType.Key()));

function Tclass.NativeTypes.byte() : Ty;

// Tclass.NativeTypes.byte Tag
axiom Tag(Tclass.NativeTypes.byte()) == Tagclass.NativeTypes.byte;

const unique Tagclass.NativeTypes.byte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.byte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.byte()) } 
  $IsBox(bx, Tclass.NativeTypes.byte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.byte()));

procedure CheckWellformed$$DynamicPkv.DynamicPkv.AppendEncodedMessage(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: Seq Box
       where $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(msg#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 9 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.DynamicPkv.AppendEncodedMessage(this: ref, key#0: Seq Box, msg#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var ##key#0: Seq Box;
  var ##msg#0: Seq Box;
  var ##pkv#1: DatatypeType;
  var ##key#1: Seq Box;
  var ##msg#1: Seq Box;

    // AddMethodImpl: AppendEncodedMessage, CheckWellformed$$DynamicPkv.DynamicPkv.AppendEncodedMessage
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(672,11): initial state"} true;
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##pkv#0 := DynamicPkv.DynamicPkv.toPkv($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, Tclass.KeyType.Key(), $Heap);
    ##msg#0 := msg#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), i#0)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
             || (forall i#1: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)), i#1)): Seq Box } 
              LitInt(0) <= i#1
                   && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)), i#1)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#0);
    assume PackedKV.__default.canAppend#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0);
    assume PackedKV.__default.canAppend(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == this
           || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(675,16): post-state"} true;
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read(old($Heap), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF(old($Heap), this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    ##pkv#1 := DynamicPkv.DynamicPkv.toPkv(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
    ##key#1 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#1, Tclass.KeyType.Key(), $Heap);
    ##msg#1 := msg#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#2)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#3)): Seq Box } 
              LitInt(0) <= i#3
                   && i#3 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#3)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#1);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#1, ##key#1, ##msg#1)
       ==> PackedKV.__default.canAppend(##pkv#1, ##key#1, ##msg#1)
         || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.keys(##pkv#1), ##key#1)
           ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(##pkv#1), ##key#1)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               < 4294967296 - 1);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#1, ##key#1, ##msg#1)
       ==> PackedKV.__default.canAppend(##pkv#1, ##key#1, ##msg#1)
         || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.keys(##pkv#1), ##key#1)
           ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(##pkv#1), ##key#1)
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                 + Seq#Length(##key#1)
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#1, ##key#1, ##msg#1)
       ==> PackedKV.__default.canAppend(##pkv#1, ##key#1, ##msg#1)
         || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(##pkv#1), ##msg#1)
           ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(##pkv#1), ##msg#1)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
               < 4294967296 - 1);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#1, ##key#1, ##msg#1)
       ==> PackedKV.__default.canAppend(##pkv#1, ##key#1, ##msg#1)
         || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(##pkv#1), ##msg#1)
           ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(##pkv#1), ##msg#1)
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                 + Seq#Length(##msg#1)
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#1, ##key#1, ##msg#1)
       ==> PackedKV.__default.canAppend(##pkv#1, ##key#1, ##msg#1)
         || (ValueType.__default.ValidMessageBytestring#canCall(##msg#1)
           ==> ValueType.__default.ValidMessageBytestring(##msg#1)
             || Seq#Length(##msg#1) <= LitInt(ValueType.__default.MaxLen()));
    assume PackedKV.__default.canAppend(##pkv#1, ##key#1, ##msg#1);
    assume PackedKV.__default.AppendEncodedMessage#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0);
    assume PackedKV.Pkv.Pkv_q(PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0));
    assume PackedKV.Pkv#Equal(DynamicPkv.DynamicPkv.toPkv($Heap, this), 
      PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
           && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$DynamicPkv.DynamicPkv.AppendEncodedMessage(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: Seq Box
       where $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(msg#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
          PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  requires PackedKV.__default.canAppend#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
     ==> PackedKV.__default.canAppend(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
       || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)), key#0)
         ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)), key#0)
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
             < 4294967296 - 1);
  requires PackedKV.__default.canAppend#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
     ==> PackedKV.__default.canAppend(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
       || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)), key#0)
         ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)), key#0)
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
               + Seq#Length(key#0)
             < 4294967296);
  requires PackedKV.__default.canAppend#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
     ==> PackedKV.__default.canAppend(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
       || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)), msg#0)
         ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)), msg#0)
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
             < 4294967296 - 1);
  requires PackedKV.__default.canAppend#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
     ==> PackedKV.__default.canAppend(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
       || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)), msg#0)
         ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)), msg#0)
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
               + Seq#Length(msg#0)
             < 4294967296);
  requires PackedKV.__default.canAppend#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
     ==> PackedKV.__default.canAppend(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
       || (ValueType.__default.ValidMessageBytestring#canCall(msg#0)
         ==> ValueType.__default.ValidMessageBytestring(msg#0)
           || Seq#Length(msg#0) <= LitInt(ValueType.__default.MaxLen()));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.WF($Heap, this)
     && 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && 
    Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
     && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
        PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free ensures $IsA#PackedKV.Pkv(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && $IsA#PackedKV.Pkv(PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.__default.AppendEncodedMessage#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0);
  ensures PackedKV.Pkv#Equal(DynamicPkv.DynamicPkv.toPkv($Heap, this), 
    PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.DynamicPkv.AppendEncodedMessage(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: Seq Box
       where $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(msg#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 9 == $FunctionContextHeight;
  // user-defined preconditions
  free requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.WF($Heap, this)
     && 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && 
    Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
     && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
        PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free requires PackedKV.__default.canAppend#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
     && 
    PackedKV.__default.canAppend(DynamicPkv.DynamicPkv.toPkv($Heap, this), key#0, msg#0)
     && 
    PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)), key#0)
     && PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)), msg#0)
     && ValueType.__default.ValidMessageBytestring(msg#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
          PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free ensures $IsA#PackedKV.Pkv(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && $IsA#PackedKV.Pkv(PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.__default.AppendEncodedMessage#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0);
  ensures PackedKV.Pkv#Equal(DynamicPkv.DynamicPkv.toPkv($Heap, this), 
    PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.DynamicPkv.AppendEncodedMessage(this: ref, key#0: Seq Box, msg#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var str##0: Seq Box;
  var str##1: Seq Box;
  var $rhs#0: Set Box where $Is($rhs#0, TSet(Tclass._System.object()));
  var ##pkv#2: DatatypeType;
  var ##key#2: Seq Box;
  var ##msg#2: Seq Box;

    // AddMethodImpl: AppendEncodedMessage, Impl$$DynamicPkv.DynamicPkv.AppendEncodedMessage
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(679,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(680,18)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    str##0 := key#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.DynamicPsa.Append(read($Heap, this, DynamicPkv.DynamicPkv.keys), str##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(680,22)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(681,22)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    str##1 := msg#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.DynamicPsa.Append(read($Heap, this, DynamicPkv.DynamicPkv.messages), str##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(681,26)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(682,12)
    assume true;
    assert $_Frame[this, DynamicPkv.DynamicPkv.Repr];
    assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
    assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
    assume true;
    $rhs#0 := Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr));
    $Heap := update($Heap, this, DynamicPkv.DynamicPkv.Repr, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(682,48)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(683,7)
    assert {:subsumption 0} read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         || Set#Equal(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))), 
              $Box(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         || _System.array.Length(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         || _System.array.Length(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         || read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         || read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.nstrings)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         || (0
             < read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.nstrings)
                     - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         || (0
             < read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.nstrings)
                     - 1))): int
             <= _System.array.Length(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)));
    assert {:subsumption 0} read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         || Set#Equal(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))), 
              $Box(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         || _System.array.Length(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         || _System.array.Length(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         || read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         || read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.nstrings)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         || (0
             < read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.nstrings)
                     - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         || (0
             < read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                      PackedStringArray.DynamicPsa.nstrings)
                     - 1))): int
             <= _System.array.Length(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       ==> PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages)));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read(old($Heap), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    ##pkv#2 := DynamicPkv.DynamicPkv.toPkv(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
    ##key#2 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#2, Tclass.KeyType.Key(), $Heap);
    ##msg#2 := msg#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#2, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#4: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#4)): Seq Box } 
                  LitInt(0) <= i#4
                       && i#4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#4)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
             || (forall i#5: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#5)): Seq Box } 
              LitInt(0) <= i#5
                   && i#5 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#5)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#2, ##key#2, ##msg#2)
       ==> PackedKV.__default.canAppend(##pkv#2, ##key#2, ##msg#2)
         || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.keys(##pkv#2), ##key#2)
           ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(##pkv#2), ##key#2)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296 - 1);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#2, ##key#2, ##msg#2)
       ==> PackedKV.__default.canAppend(##pkv#2, ##key#2, ##msg#2)
         || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.keys(##pkv#2), ##key#2)
           ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(##pkv#2), ##key#2)
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 + Seq#Length(##key#2)
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#2, ##key#2, ##msg#2)
       ==> PackedKV.__default.canAppend(##pkv#2, ##key#2, ##msg#2)
         || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(##pkv#2), ##msg#2)
           ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(##pkv#2), ##msg#2)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296 - 1);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#2, ##key#2, ##msg#2)
       ==> PackedKV.__default.canAppend(##pkv#2, ##key#2, ##msg#2)
         || (PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(##pkv#2), ##msg#2)
           ==> PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(##pkv#2), ##msg#2)
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 + Seq#Length(##msg#2)
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.canAppend#canCall(##pkv#2, ##key#2, ##msg#2)
       ==> PackedKV.__default.canAppend(##pkv#2, ##key#2, ##msg#2)
         || (ValueType.__default.ValidMessageBytestring#canCall(##msg#2)
           ==> ValueType.__default.ValidMessageBytestring(##msg#2)
             || Seq#Length(##msg#2) <= LitInt(ValueType.__default.MaxLen()));
    assume PackedKV.__default.AppendEncodedMessage#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0);
    assume PackedKV.Pkv.Pkv_q(PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0));
    assume $IsA#PackedKV.Pkv(PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0))
       && 
      PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
       && PackedStringArray.DynamicPsa.toPsa#canCall($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
       && 
      DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
       && PackedKV.__default.AppendEncodedMessage#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0);
    assert PackedKV.Pkv#Equal(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
        PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))), 
      PackedKV.__default.AppendEncodedMessage(DynamicPkv.DynamicPkv.toPkv(old($Heap), this), key#0, msg#0));
}



function Tclass.ValueMessage.Message() : Ty;

// Tclass.ValueMessage.Message Tag
axiom Tag(Tclass.ValueMessage.Message()) == Tagclass.ValueMessage.Message;

const unique Tagclass.ValueMessage.Message: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.Message
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.Message()) } 
  $IsBox(bx, Tclass.ValueMessage.Message())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ValueMessage.Message()));

procedure CheckWellformed$$DynamicPkv.DynamicPkv.Append(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0));
  free requires 14 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function Tclass.PackedStringArray.Psa() : Ty;

// Tclass.PackedStringArray.Psa Tag
axiom Tag(Tclass.PackedStringArray.Psa()) == Tagclass.PackedStringArray.Psa;

const unique Tagclass.PackedStringArray.Psa: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.Psa
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.Psa()) } 
  $IsBox(bx, Tclass.PackedStringArray.Psa())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PackedStringArray.Psa()));

implementation CheckWellformed$$DynamicPkv.DynamicPkv.Append(this: ref, key#0: Seq Box, msg#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##key#0: Seq Box;
  var ##msg#0: DatatypeType;
  var ##psa#0: DatatypeType;
  var ##keys#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##msgs#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;
  var ##psa#5: DatatypeType;

    // AddMethodImpl: Append, CheckWellformed$$DynamicPkv.DynamicPkv.Append
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(686,11): initial state"} true;
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume ValueMessage.Message.Define_q(msg#0);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##pkv#0 := DynamicPkv.DynamicPkv.toPkv($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), i#0)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
             || (forall i#1: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)), i#1)): Seq Box } 
              LitInt(0) <= i#1
                   && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)), i#1)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
       ==> PackedKV.__default.WF(##pkv#0)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#0);
    assume PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    newtype$check#0 := LitInt(4294967296);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := LitInt(4294967296 - 1);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, this))
       < 4294967296 - 1;
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, Tclass.KeyType.Key(), $Heap);
    assume BucketWeights.__default.WeightKey#canCall(key#0);
    ##msg#0 := msg#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#0, Tclass.ValueMessage.Message(), $Heap);
    assume BucketWeights.__default.WeightMessage#canCall(msg#0);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#0 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#0), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#0), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#2: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#2)): Seq Box } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(PackedStringArray.__default.I(##psa#0))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#2)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#0), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    ##keys#0 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#1 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    ##msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
    assume BucketWeights.__default.WeightKey(key#0)
         + BucketWeights.__default.WeightMessage(msg#0)
         + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
         + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       < 4294967296;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == this
           || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(691,16): post-state"} true;
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#2 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#2), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#2), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#3: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#3)): Seq Box } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(PackedStringArray.__default.I(##psa#2))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#3)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#2), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read(old($Heap), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF(old($Heap), this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    ##psa#3 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#3), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#3), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#4: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#3), i#4)): Seq Box } 
          LitInt(0) <= i#4 && i#4 < Seq#Length(PackedStringArray.__default.I(##psa#3))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#3), i#4)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#3), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
    assume Seq#Equal(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
      Seq#Append(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#4 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read(old($Heap), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF(old($Heap), this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    ##psa#5 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
    assume Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
      Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
           && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$DynamicPkv.DynamicPkv.Append(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0));
  // user-defined preconditions
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
          PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  requires ValueMessage.Message.Define_q(msg#0);
  requires PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     < 4294967296 - 1;
  requires BucketWeights.__default.WeightKey(key#0)
       + BucketWeights.__default.WeightMessage(msg#0)
       + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.WF($Heap, this)
     && 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && 
    Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
     && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
        PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
  ensures Seq#Equal(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
    Seq#Append(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
  ensures Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
    Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.DynamicPkv.Append(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0))
   returns ($_reverifyPost: bool);
  free requires 14 == $FunctionContextHeight;
  // user-defined preconditions
  free requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.WF($Heap, this)
     && 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && 
    Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
     && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
        PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  requires ValueMessage.Message.Define_q(msg#0);
  requires PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     < 4294967296 - 1;
  requires BucketWeights.__default.WeightKey(key#0)
       + BucketWeights.__default.WeightMessage(msg#0)
       + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
          PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
  ensures Seq#Equal(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
    Seq#Append(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
  ensures Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
    Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.DynamicPkv.Append(this: ref, key#0: Seq Box, msg#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var pkv##0: DatatypeType;
  var psa##0: DatatypeType;
  var key##0: Seq Box;
  var psa##1: DatatypeType;
  var key##1: Seq Box;
  var ##msg#1: DatatypeType;
  var key##2: Seq Box;
  var msg##0: Seq Box;
  var ##msg#2: DatatypeType;
  var ##psa#0_0_0: DatatypeType;
  var a#0_0_0: Seq Box
     where $Is(a#0_0_0, TSeq(Tclass.ValueMessage.Message()))
       && $IsAlloc(a#0_0_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
  var ##psa#0_0_1: DatatypeType;
  var b#0_0_0: Seq Box
     where $Is(b#0_0_0, TSeq(Tclass.ValueMessage.Message()))
       && $IsAlloc(b#0_0_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
  var ##psa#0_0_2: DatatypeType;
  var i#0_0_0: int;
  var ##psa#0_0_3: DatatypeType;
  var ##psa#0_0: DatatypeType;

    // AddMethodImpl: Append, Impl$$DynamicPkv.DynamicPkv.Append
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(698,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(699,35)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    // ProcessCallStmt: CheckSubrange
    pkv##0 := DynamicPkv.DynamicPkv.toPkv($Heap, this);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(699,43)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(700,27)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
       && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // ProcessCallStmt: CheckSubrange
    psa##0 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := key#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.__default.psaAppendIAppend(psa##0, key##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(700,45)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(701,27)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
       && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // ProcessCallStmt: CheckSubrange
    psa##1 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##msg#1 := msg#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#1, Tclass.ValueMessage.Message(), $Heap);
    assert {:subsumption 0} ValueMessage.Message.Define_q(##msg#1);
    assume ValueMessage.Message.Define_q(##msg#1);
    assume ValueMessage.__default.Message__to__bytestring#canCall(msg#0);
    assume ValueMessage.__default.Message__to__bytestring#canCall(msg#0);
    // ProcessCallStmt: CheckSubrange
    key##1 := ValueMessage.__default.Message__to__bytestring(msg#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.__default.psaAppendIAppend(psa##1, key##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(701,72)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(703,27)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##2 := key#0;
    ##msg#2 := msg#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#2, Tclass.ValueMessage.Message(), $Heap);
    assert {:subsumption 0} ValueMessage.Message.Define_q(##msg#2);
    assume ValueMessage.Message.Define_q(##msg#2);
    assume ValueMessage.__default.Message__to__bytestring#canCall(msg#0);
    assume ValueMessage.__default.Message__to__bytestring#canCall(msg#0);
    // ProcessCallStmt: CheckSubrange
    msg##0 := ValueMessage.__default.Message__to__bytestring(msg#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$DynamicPkv.DynamicPkv.AppendEncodedMessage(this, key##2, msg##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(703,59)"} true;
    // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(705,7)
    // Assume Fuel Constant
    if (*)
    {
        // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(705,7)
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        ##psa#0_0 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(705,7)
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr));
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr));
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr));
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        assume {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        ##psa#0_0_0 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_0, Tclass.PackedStringArray.Psa(), $Heap);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) == LitInt(0));
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) - 1)): int);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_0));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
        // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(705,7)
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(708,17)
        assume true;
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
        assume DynamicPkv.DynamicPkv.WF($Heap, this);
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        ##psa#0_0_1 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_1));
        assume PackedStringArray.__default.WF(##psa#0_0_1);
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
        a#0_0_0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(708,50)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(709,17)
        assume true;
        assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Subset(read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Subset(read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read(old($Heap), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
        assume DynamicPkv.DynamicPkv.WF(old($Heap), this);
        assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
        ##psa#0_0_2 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_2));
        assume PackedStringArray.__default.WF(##psa#0_0_2);
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
        assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
        b#0_0_0 := Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
          Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0)));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(709,63)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(710,11)
        assume true;
        assert Seq#Length(a#0_0_0) == Seq#Length(b#0_0_0);
        // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(711,11)
        if (*)
        {
            // Assume Fuel Constant
            havoc i#0_0_0;
            assume true;
            if (LitInt(0) <= i#0_0_0)
            {
            }

            assume true;
            assume LitInt(0) <= i#0_0_0 && i#0_0_0 < Seq#Length(a#0_0_0);
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(714,13)
            assume true;
            if (i#0_0_0 == Seq#Length(a#0_0_0) - 1)
            {
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(715,15)
                assert {:subsumption 0} 0 <= i#0_0_0 && i#0_0_0 < Seq#Length(a#0_0_0);
                assert {:subsumption 0} 0 <= i#0_0_0 && i#0_0_0 < Seq#Length(b#0_0_0);
                assume $IsA#ValueMessage.Message($Unbox(Seq#Index(a#0_0_0, i#0_0_0)): DatatypeType)
                   && $IsA#ValueMessage.Message($Unbox(Seq#Index(b#0_0_0, i#0_0_0)): DatatypeType);
                assert ValueMessage.Message#Equal($Unbox(Seq#Index(a#0_0_0, i#0_0_0)): DatatypeType, 
                  $Unbox(Seq#Index(b#0_0_0, i#0_0_0)): DatatypeType);
            }
            else
            {
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(717,15)
                assert {:subsumption 0} 0 <= i#0_0_0 && i#0_0_0 < Seq#Length(a#0_0_0);
                assert {:subsumption 0} 0 <= i#0_0_0 && i#0_0_0 < Seq#Length(b#0_0_0);
                assume $IsA#ValueMessage.Message($Unbox(Seq#Index(a#0_0_0, i#0_0_0)): DatatypeType)
                   && $IsA#ValueMessage.Message($Unbox(Seq#Index(b#0_0_0, i#0_0_0)): DatatypeType);
                assert ValueMessage.Message#Equal($Unbox(Seq#Index(a#0_0_0, i#0_0_0)): DatatypeType, 
                  $Unbox(Seq#Index(b#0_0_0, i#0_0_0)): DatatypeType);
            }

            assert ValueMessage.Message#Equal($Unbox(Seq#Index(a#0_0_0, i#0_0_0)): DatatypeType, 
              $Unbox(Seq#Index(b#0_0_0, i#0_0_0)): DatatypeType);
            assume false;
        }
        else
        {
            assume (forall i#0_0_1: int :: 
              { $Unbox(Seq#Index(b#0_0_0, i#0_0_1)): DatatypeType } 
                { $Unbox(Seq#Index(a#0_0_0, i#0_0_1)): DatatypeType } 
              LitInt(0) <= i#0_0_1 && i#0_0_1 < Seq#Length(a#0_0_0)
                 ==> ValueMessage.Message#Equal($Unbox(Seq#Index(a#0_0_0, i#0_0_1)): DatatypeType, 
                  $Unbox(Seq#Index(b#0_0_0, i#0_0_1)): DatatypeType));
        }

        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(719,10)"} true;
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(705,7)
        assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Subset(read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Subset(read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read(old($Heap), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read(old($Heap), 
                read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
           ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
        assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
        ##psa#0_0_3 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_3));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
        assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
        // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(705,7)
        assert {:subsumption 0} Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
          Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
            Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))));
        assume false;
    }

    assume Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
      Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))));
}



procedure CheckWellformed$$DynamicPkv.DynamicPkv.AppendPkv(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    end#0: int where LitInt(0) <= end#0 && end#0 < 18446744073709551616);
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.DynamicPkv.AppendPkv(this: ref, pkv#0: DatatypeType, start#0: int, end#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var newtype$check#0: int;
  var ##pkv#1: DatatypeType;
  var ##pkv#2: DatatypeType;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##psa#0: DatatypeType;
  var ##keys#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##keys#1: Seq Box;
  var ##psa#2: DatatypeType;
  var ##msgs#0: Seq Box;
  var ##psa#3: DatatypeType;
  var ##msgs#1: Seq Box;
  var ##psa#4: DatatypeType;
  var ##psa#5: DatatypeType;
  var ##psa#6: DatatypeType;
  var ##psa#7: DatatypeType;
  var ##psa#8: DatatypeType;
  var ##psa#9: DatatypeType;
  var ##psa#10: DatatypeType;
  var ##keys#2: Seq Box;
  var ##psa#11: DatatypeType;
  var ##keys#3: Seq Box;
  var ##psa#12: DatatypeType;
  var ##keys#4: Seq Box;
  var ##psa#13: DatatypeType;
  var ##msgs#2: Seq Box;
  var ##psa#14: DatatypeType;
  var ##msgs#3: Seq Box;
  var ##psa#15: DatatypeType;
  var ##msgs#4: Seq Box;

    // AddMethodImpl: AppendPkv, CheckWellformed$$DynamicPkv.DynamicPkv.AppendPkv
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(725,11): initial state"} true;
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    ##pkv#0 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(pkv#0);
    assume PackedKV.__default.WF(pkv#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= start#0)
    {
    }

    if (LitInt(0) <= start#0 && start#0 <= end#0)
    {
        ##pkv#1 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box } 
                      LitInt(0) <= i#0
                           && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#1);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    }

    assume LitInt(0) <= start#0
       && start#0 <= end#0
       && end#0 <= PackedKV.__default.NumKVPairs(pkv#0);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##pkv#2 := DynamicPkv.DynamicPkv.toPkv($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box } 
              LitInt(0) <= i#3
                   && i#3 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#2);
    assume PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    newtype$check#1 := PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, this)) + end#0;
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, this)) + end#0
       - start#0;
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := LitInt(4294967296);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := LitInt(1);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    newtype$check#5 := LitInt(4294967296 - 1);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assume PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, this)) + end#0
         - start#0
       <= LitInt(4294967296 - 1);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#0 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#0), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#0), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#4: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#4)): Seq Box } 
          LitInt(0) <= i#4 && i#4 < Seq#Length(PackedStringArray.__default.I(##psa#0))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#4)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#0), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    ##keys#0 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#1 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert 0 <= start#0
       && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert start#0 <= end#0
       && end#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
        start#0), 
      TSeq(Tclass.KeyType.Key()));
    ##keys#1 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
      start#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#1, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
        start#0));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#2 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    ##msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#3 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert 0 <= start#0
       && start#0
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assert start#0 <= end#0
       && end#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##msgs#1 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
      start#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#1, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
        start#0));
    assume BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
         + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
            start#0))
         + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
         + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
            start#0))
       < 4294967296;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == this
           || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(732,14): post-state"} true;
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
           && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#4 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read(old($Heap), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF(old($Heap), this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    ##psa#5 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#6 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert 0 <= start#0
       && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert start#0 <= end#0
       && end#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assume Seq#Equal(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
      Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
        Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
          start#0)));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#7 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#7));
    assume PackedStringArray.__default.WF(##psa#7);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read(old($Heap), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF(old($Heap), this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    ##psa#8 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || Seq#Length(PackedStringArray.Psa.data(##psa#8)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#8)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#8))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#8), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#8));
    assume PackedStringArray.__default.WF(##psa#8);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#9 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#9, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Seq#Length(PackedStringArray.Psa.data(##psa#9)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#9)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#9))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#9), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#9));
    assume PackedStringArray.__default.WF(##psa#9);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert 0 <= start#0
       && start#0
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assert start#0 <= end#0
       && end#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assume Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
      Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
        Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
          start#0)));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#10 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#10, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Seq#Length(PackedStringArray.Psa.data(##psa#10)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#10)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#10))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#10))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#10), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#10));
    assume PackedStringArray.__default.WF(##psa#10);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#10), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#10), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#5: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#10), i#5)): Seq Box } 
          LitInt(0) <= i#5 && i#5 < Seq#Length(PackedStringArray.__default.I(##psa#10))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#10), i#5)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#10), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    ##keys#2 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#2, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read(old($Heap), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF(old($Heap), this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    ##psa#11 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#11, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Seq#Length(PackedStringArray.Psa.data(##psa#11)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#11)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#11))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#11))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#11), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#11));
    assume PackedStringArray.__default.WF(##psa#11);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#11), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#11), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#6: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#11), i#6)): Seq Box } 
          LitInt(0) <= i#6 && i#6 < Seq#Length(PackedStringArray.__default.I(##psa#11))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#11), i#6)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#11), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
    ##keys#3 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#3, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#12 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#12, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
       ==> PackedStringArray.__default.WF(##psa#12)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
       ==> PackedStringArray.__default.WF(##psa#12)
         || Seq#Length(PackedStringArray.Psa.data(##psa#12)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
       ==> PackedStringArray.__default.WF(##psa#12)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#12)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
       ==> PackedStringArray.__default.WF(##psa#12)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#12))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#12))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#12), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
       ==> PackedStringArray.__default.WF(##psa#12)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#12));
    assume PackedStringArray.__default.WF(##psa#12);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert 0 <= start#0
       && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert start#0 <= end#0
       && end#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
        start#0), 
      TSeq(Tclass.KeyType.Key()));
    ##keys#4 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
      start#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#4, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
        start#0));
    assume BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       == BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
         + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
            start#0));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    ##psa#13 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#13, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
       ==> PackedStringArray.__default.WF(##psa#13)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
       ==> PackedStringArray.__default.WF(##psa#13)
         || Seq#Length(PackedStringArray.Psa.data(##psa#13)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
       ==> PackedStringArray.__default.WF(##psa#13)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#13)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
       ==> PackedStringArray.__default.WF(##psa#13)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#13))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#13))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#13), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
       ==> PackedStringArray.__default.WF(##psa#13)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#13));
    assume PackedStringArray.__default.WF(##psa#13);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    ##msgs#2 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#2, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
    assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Subset(read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read(old($Heap), 
              read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read(old($Heap), 
            read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
       ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF(old($Heap), this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    ##psa#14 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#14, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
       ==> PackedStringArray.__default.WF(##psa#14)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
       ==> PackedStringArray.__default.WF(##psa#14)
         || Seq#Length(PackedStringArray.Psa.data(##psa#14)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
       ==> PackedStringArray.__default.WF(##psa#14)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#14)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
       ==> PackedStringArray.__default.WF(##psa#14)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#14))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#14))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#14), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
       ==> PackedStringArray.__default.WF(##psa#14)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#14));
    assume PackedStringArray.__default.WF(##psa#14);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
    ##msgs#3 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#3, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#15 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#15, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
       ==> PackedStringArray.__default.WF(##psa#15)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#15)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
       ==> PackedStringArray.__default.WF(##psa#15)
         || Seq#Length(PackedStringArray.Psa.data(##psa#15)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
       ==> PackedStringArray.__default.WF(##psa#15)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#15)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#15)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
       ==> PackedStringArray.__default.WF(##psa#15)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#15))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#15))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#15), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#15)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
       ==> PackedStringArray.__default.WF(##psa#15)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#15));
    assume PackedStringArray.__default.WF(##psa#15);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert 0 <= start#0
       && start#0
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assert start#0 <= end#0
       && end#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##msgs#4 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
      start#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#4, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
        start#0));
    assume BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       == BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
         + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
            start#0));
}



procedure Call$$DynamicPkv.DynamicPkv.AppendPkv(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    end#0: int where LitInt(0) <= end#0 && end#0 < 18446744073709551616);
  // user-defined preconditions
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
  requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
          PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#7: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#7)): Seq Box } 
                LitInt(0) <= i#7
                     && i#7 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#7)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           || (forall i#8: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#8)): Seq Box } 
            LitInt(0) <= i#8
                 && i#8 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#8)): Seq Box)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= start#0;
  requires start#0 <= end#0;
  requires end#0 <= PackedKV.__default.NumKVPairs(pkv#0);
  requires PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, this)) + end#0
       - start#0
     <= LitInt(4294967296 - 1);
  requires BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
          start#0))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
          start#0))
     < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.WF($Heap, this)
     && 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && 
    Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
     && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
        PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
  ensures Seq#Equal(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
    Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
      Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
        start#0)));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
  ensures Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
    Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
      Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
        start#0)));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
        start#0));
  ensures BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     == BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
       + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
          start#0));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
        start#0));
  ensures BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     == BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
       + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
          start#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.DynamicPkv.AppendPkv(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    end#0: int where LitInt(0) <= end#0 && end#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 17 == $FunctionContextHeight;
  // user-defined preconditions
  free requires DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.WF($Heap, this)
     && 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && 
    Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
     && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
        PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free requires PackedKV.__default.WF#canCall(pkv#0)
     && 
    PackedKV.__default.WF(pkv#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= start#0;
  requires start#0 <= end#0;
  requires end#0 <= PackedKV.__default.NumKVPairs(pkv#0);
  requires PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, this)) + end#0
       - start#0
     <= LitInt(4294967296 - 1);
  requires BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
          start#0))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
       + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
          start#0))
     < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
          PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
  ensures Seq#Equal(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
    Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
      Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
        start#0)));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
  ensures Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
    Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
      Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
        start#0)));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
        start#0));
  ensures BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     == BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
       + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), end#0), 
          start#0));
  free ensures DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
     && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
        start#0));
  ensures BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
     == BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
       + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
          start#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.DynamicPkv.AppendPkv(this: ref, pkv#0: DatatypeType, start#0: int, end#0: int)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#11: int where LitInt(0) <= i#11 && i#11 < 18446744073709551616;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##pkv#3: DatatypeType;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var ##psa#16: DatatypeType;
  var ##psa#17: DatatypeType;
  var ##psa#18: DatatypeType;
  var ##psa#19: DatatypeType;
  var ##psa#20: DatatypeType;
  var ##psa#21: DatatypeType;
  var ##psa#22: DatatypeType;
  var ##keys#5: Seq Box;
  var ##psa#23: DatatypeType;
  var ##keys#6: Seq Box;
  var ##psa#24: DatatypeType;
  var ##msgs#5: Seq Box;
  var ##psa#25: DatatypeType;
  var ##msgs#6: Seq Box;
  var ##psa#26: DatatypeType;
  var ##keys#7: Seq Box;
  var ##psa#27: DatatypeType;
  var ##keys#8: Seq Box;
  var ##psa#28: DatatypeType;
  var ##keys#9: Seq Box;
  var ##psa#29: DatatypeType;
  var ##msgs#7: Seq Box;
  var ##psa#30: DatatypeType;
  var ##msgs#8: Seq Box;
  var ##psa#31: DatatypeType;
  var ##msgs#9: Seq Box;
  var $decr$loop#00: int;
  var key#0_0: Seq Box
     where $Is(key#0_0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(key#0_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var ##pkv#0_0: DatatypeType;
  var ##i#0_0: int;
  var msg#0_0: DatatypeType
     where $Is(msg#0_0, Tclass.ValueMessage.Message())
       && $IsAlloc(msg#0_0, Tclass.ValueMessage.Message(), $Heap);
  var ##pkv#0_1: DatatypeType;
  var ##i#0_1: int;
  var pkv##0_0: DatatypeType;
  var a##0_0: int;
  var b##0_0: int;
  var pkv##0_1: DatatypeType;
  var key##0_0: Seq Box;
  var msg##0_0: DatatypeType;
  var key##0_1: Seq Box;
  var msg##0_1: DatatypeType;
  var ##psa#0_0_0_0: DatatypeType;
  var newtype$check#0_0_0_0: int;
  var newtype$check#0_0_0_1: int;
  var ##psa#0_0_0_1: DatatypeType;
  var ##psa#0_0_0: DatatypeType;
  var newtype$check#0_0_0: int;
  var newtype$check#0_0_1: int;
  var ##psa#0_1_0_0: DatatypeType;
  var newtype$check#0_1_0_0: int;
  var newtype$check#0_1_0_1: int;
  var ##psa#0_1_0_1: DatatypeType;
  var ##psa#0_1_0: DatatypeType;
  var newtype$check#0_1_0: int;
  var newtype$check#0_1_1: int;
  var ##psa#0_2_0_0: DatatypeType;
  var newtype$check#0_2_0_0: int;
  var newtype$check#0_2_0_1: int;
  var ##keys#0_2_0_0: Seq Box;
  var keys##0_2_0_0: Seq Box;
  var ##psa#0_2_0_1: DatatypeType;
  var key##0_2_0_0: Seq Box;
  var ##psa#0_2_0_2: DatatypeType;
  var ##keys#0_2_0_1: Seq Box;
  var ##key#0_2_0_0: Seq Box;
  var ##psa#0_2_0: DatatypeType;
  var newtype$check#0_2_0: int;
  var newtype$check#0_2_1: int;
  var ##keys#0_2_0: Seq Box;
  var ##psa#0_3_0_0: DatatypeType;
  var newtype$check#0_3_0_0: int;
  var newtype$check#0_3_0_1: int;
  var ##msgs#0_3_0_0: Seq Box;
  var msgs##0_3_0_0: Seq Box;
  var ##psa#0_3_0_1: DatatypeType;
  var msg##0_3_0_0: DatatypeType;
  var ##psa#0_3_0_2: DatatypeType;
  var ##msgs#0_3_0_1: Seq Box;
  var ##msg#0_3_0_0: DatatypeType;
  var ##psa#0_3_0: DatatypeType;
  var newtype$check#0_3_0: int;
  var newtype$check#0_3_1: int;
  var ##msgs#0_3_0: Seq Box;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;

    // AddMethodImpl: AppendPkv, Impl$$DynamicPkv.DynamicPkv.AppendPkv
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(741,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(742,13)
    assume true;
    assume true;
    i#11 := start#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(742,20)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(743,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := end#0 - i#11;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> start#0 <= i#11;
      invariant $w$loop#0 ==> i#11 <= end#0;
      free invariant $w$loop#0 ==> DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
         ==> DynamicPkv.DynamicPkv.WF($Heap, this)
           || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
              PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           && 
          DynamicPkv.DynamicPkv.WF($Heap, this)
           && 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
           && Set#Subset(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, this, DynamicPkv.DynamicPkv.Repr))
           && 
          Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr))
           && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
           && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
           && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
              PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
      invariant $w$loop#0
         ==> PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
               + end#0
             - start#0
           <= LitInt(4294967296 - 1);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall $o: ref :: 
          { read(old($Heap), $o, alloc) } 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
               && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
      invariant $w$loop#0
         ==> Seq#Equal(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
          Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
            Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0)));
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
      invariant $w$loop#0
         ==> Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
          Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
            Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
              start#0)));
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), end#0), i#11))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
              i#11));
      invariant $w$loop#0
         ==> BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
             + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), end#0), i#11))
             + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
             + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
                i#11))
           < 4294967296;
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
           && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0));
      invariant $w$loop#0
         ==> BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           == BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
             + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0));
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
           && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
              start#0));
      invariant $w$loop#0
         ==> BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           == BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
             + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                start#0));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]
             || 
            $o == this
             || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant end#0 - i#11 <= $decr_init$loop#00
         && (end#0 - i#11 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(743,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            if (start#0 <= i#11)
            {
            }

            assume true;
            assume start#0 <= i#11 && i#11 <= end#0;
            assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
            assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
            assume DynamicPkv.DynamicPkv.WF($Heap, this);
            assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read(old($Heap), 
                      read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            ##pkv#3 := DynamicPkv.DynamicPkv.toPkv(old($Heap), this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#12: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#12)): Seq Box } 
                          LitInt(0) <= i#12
                               && i#12 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#12)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                     || (forall i#13: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#13)): Seq Box } 
                      LitInt(0) <= i#13
                           && i#13 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#13)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
               ==> PackedKV.__default.WF(##pkv#3)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            newtype$check#6 := PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
               + end#0;
            assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
            newtype$check#7 := PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
                 + end#0
               - start#0;
            assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
            newtype$check#8 := LitInt(4294967296);
            assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
            newtype$check#9 := LitInt(1);
            assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
            newtype$check#10 := LitInt(4294967296 - 1);
            assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
            assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
               && PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            assume PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
                   + end#0
                 - start#0
               <= LitInt(4294967296 - 1);
            assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
            assume true;
            assume (forall $o: ref :: 
              { read(old($Heap), $o, alloc) } 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
                   && !read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
                 ==> $o != null && !read(old($Heap), $o, alloc));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            ##psa#16 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#16, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#16)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#16)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#16)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#16)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#16))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#16))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#16), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#16)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#16));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read(old($Heap), 
                      read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            ##psa#17 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#17, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#17)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#17)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#17)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#17)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#17))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#17))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#17), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#17)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#17));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#18 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#18, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#18)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#18)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#18)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#18)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#18))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#18))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#18), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#18)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#18));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assert {:subsumption 0} start#0 <= i#11
               && i#11 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
               && 
              DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
               && 
              PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assume Seq#Equal(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
              Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
                Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0)));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            ##psa#19 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#19, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#19)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#19)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#19)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#19)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#19))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#19))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#19), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#19)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#19));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read(old($Heap), 
                      read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            ##psa#20 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#20, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#20)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#20)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#20)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#20)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#20))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#20))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#20), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#20)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#20));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#21 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#21, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#21)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#21)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#21)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#21)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#21))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#21))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#21), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#21)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#21));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assert {:subsumption 0} start#0 <= i#11
               && i#11 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
               && 
              DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
               && 
              PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assume Seq#Equal(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))), 
              Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))), 
                Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                  start#0)));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            ##psa#22 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#22, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#22)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#22)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#22)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#22)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#22))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#22))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#22), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#22)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#22));
            assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(##psa#22), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(##psa#22), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#14: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#22), i#14)): Seq Box } 
                  LitInt(0) <= i#14 && i#14 < Seq#Length(PackedStringArray.__default.I(##psa#22))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#22), i#14)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            ##keys#5 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#5, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#23 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#23, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#23)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#23)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#23)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#23)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#23))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#23))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#23), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#23)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#23));
            assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(##psa#23), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(##psa#23), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#15: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#23), i#15)): Seq Box } 
                  LitInt(0) <= i#15 && i#15 < Seq#Length(PackedStringArray.__default.I(##psa#23))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#23), i#15)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0));
            assert {:subsumption 0} 0 <= i#11
               && i#11 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)));
            assert {:subsumption 0} i#11 <= end#0
               && end#0 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)));
            ##keys#6 := Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), end#0), i#11);
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#6, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), end#0), i#11));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            ##psa#24 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#24, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#24)
               ==> PackedStringArray.__default.WF(##psa#24)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#24)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#24)
               ==> PackedStringArray.__default.WF(##psa#24)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#24)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#24)
               ==> PackedStringArray.__default.WF(##psa#24)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#24)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#24)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#24)
               ==> PackedStringArray.__default.WF(##psa#24)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#24))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#24))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#24), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#24)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#24)
               ==> PackedStringArray.__default.WF(##psa#24)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#24));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            ##msgs#5 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#5, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#25 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#25, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#25)
               ==> PackedStringArray.__default.WF(##psa#25)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#25)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#25)
               ==> PackedStringArray.__default.WF(##psa#25)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#25)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#25)
               ==> PackedStringArray.__default.WF(##psa#25)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#25)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#25)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#25)
               ==> PackedStringArray.__default.WF(##psa#25)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#25))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#25))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#25), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#25)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#25)
               ==> PackedStringArray.__default.WF(##psa#25)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#25));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= i#11
               && i#11 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assert {:subsumption 0} i#11 <= end#0
               && end#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            ##msgs#6 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
              i#11);
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#6, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
                i#11));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
               && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
               && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
               && 
              PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
               && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), end#0), i#11))
               && 
              DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
               && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
               && 
              PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
               && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
                  i#11));
            assume BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
                 + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), end#0), i#11))
                 + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
                 + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
                    i#11))
               < 4294967296;
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            ##psa#26 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#26, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#26)
               ==> PackedStringArray.__default.WF(##psa#26)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#26)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#26)
               ==> PackedStringArray.__default.WF(##psa#26)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#26)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#26)
               ==> PackedStringArray.__default.WF(##psa#26)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#26)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#26)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#26)
               ==> PackedStringArray.__default.WF(##psa#26)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#26))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#26))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#26), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#26)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#26)
               ==> PackedStringArray.__default.WF(##psa#26)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#26));
            assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(##psa#26), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(##psa#26), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#16: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#26), i#16)): Seq Box } 
                  LitInt(0) <= i#16 && i#16 < Seq#Length(PackedStringArray.__default.I(##psa#26))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#26), i#16)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            ##keys#7 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#7, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
            assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read(old($Heap), 
                      read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            ##psa#27 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#27, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#27)
               ==> PackedStringArray.__default.WF(##psa#27)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#27)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#27)
               ==> PackedStringArray.__default.WF(##psa#27)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#27)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#27)
               ==> PackedStringArray.__default.WF(##psa#27)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#27)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#27)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#27)
               ==> PackedStringArray.__default.WF(##psa#27)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#27))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#27))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#27), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#27)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#27)
               ==> PackedStringArray.__default.WF(##psa#27)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#27));
            assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(##psa#27), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(##psa#27), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#17: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#27), i#17)): Seq Box } 
                  LitInt(0) <= i#17 && i#17 < Seq#Length(PackedStringArray.__default.I(##psa#27))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#27), i#17)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
            ##keys#8 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#8, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))));
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#28 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#28, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#28)
               ==> PackedStringArray.__default.WF(##psa#28)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#28)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#28)
               ==> PackedStringArray.__default.WF(##psa#28)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#28)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#28)
               ==> PackedStringArray.__default.WF(##psa#28)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#28)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#28)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#28)
               ==> PackedStringArray.__default.WF(##psa#28)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#28))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#28))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#28), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#28)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#28)
               ==> PackedStringArray.__default.WF(##psa#28)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#28));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assert {:subsumption 0} start#0 <= i#11
               && i#11 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0), 
              TSeq(Tclass.KeyType.Key()));
            ##keys#9 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#9, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
               && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
               && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
               && 
              DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
               && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
               && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
               && 
              PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
               && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0));
            assume BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
               == BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
                 + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Subset(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read($Heap, 
                      read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
               ==> DynamicPkv.DynamicPkv.WF($Heap, this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            ##psa#29 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#29, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#29)
               ==> PackedStringArray.__default.WF(##psa#29)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#29)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#29)
               ==> PackedStringArray.__default.WF(##psa#29)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#29)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#29)
               ==> PackedStringArray.__default.WF(##psa#29)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#29)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#29)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#29)
               ==> PackedStringArray.__default.WF(##psa#29)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#29))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#29))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#29), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#29)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#29)
               ==> PackedStringArray.__default.WF(##psa#29)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#29));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            ##msgs#7 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#7, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))));
            assert $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), old($Heap));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || read(old($Heap), this, DynamicPkv.DynamicPkv.Repr)[$Box(read(old($Heap), this, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Subset(read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read(old($Heap), this, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    read(old($Heap), 
                      read(old($Heap), this, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read(old($Heap), 
                    read(old($Heap), this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedStringArray.DynamicPsa.WF(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall(old($Heap), this)
               ==> DynamicPkv.DynamicPkv.WF(old($Heap), this)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa(old($Heap), read(old($Heap), this, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            ##psa#30 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#30, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#30)
               ==> PackedStringArray.__default.WF(##psa#30)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#30)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#30)
               ==> PackedStringArray.__default.WF(##psa#30)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#30)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#30)
               ==> PackedStringArray.__default.WF(##psa#30)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#30)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#30)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#30)
               ==> PackedStringArray.__default.WF(##psa#30)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#30))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#30))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#30), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#30)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#30)
               ==> PackedStringArray.__default.WF(##psa#30)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#30));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
            ##msgs#8 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#8, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))));
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#31 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#31, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#31)
               ==> PackedStringArray.__default.WF(##psa#31)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#31)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#31)
               ==> PackedStringArray.__default.WF(##psa#31)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#31)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#31)
               ==> PackedStringArray.__default.WF(##psa#31)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#31)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#31)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#31)
               ==> PackedStringArray.__default.WF(##psa#31)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#31))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#31))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#31), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#31)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#31)
               ==> PackedStringArray.__default.WF(##psa#31)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#31));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assert {:subsumption 0} start#0 <= i#11
               && i#11 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            ##msgs#9 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
              start#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#9, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                start#0));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
               && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
               && 
              DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
               && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
               && 
              PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
               && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                  start#0));
            assume BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
               == BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
                 + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                    start#0));
            assume true;
            assume false;
        }

        assume true;
        if (end#0 <= i#11)
        {
            break;
        }

        $decr$loop#00 := end#0 - i#11;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(757,17)
        assume true;
        ##pkv#0_0 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0_0, Tclass.PackedKV.Pkv(), $Heap);
        ##i#0_0 := i#11;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0_0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), i#0_0)): Seq Box } 
                      LitInt(0) <= i#0_0
                           && i#0_0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), i#0_0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                 || (forall i#0_1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)), i#0_1)): Seq Box } 
                  LitInt(0) <= i#0_1
                       && i#0_1
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)), i#0_1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#0_0);
        assert {:subsumption 0} LitInt(0) <= ##i#0_0;
        assert {:subsumption 0} ##i#0_0
           < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)));
        assume LitInt(0) <= ##i#0_0
           && ##i#0_0
             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)));
        assume PackedKV.__default.GetKey#canCall(pkv#0, i#11);
        assume PackedKV.__default.GetKey#canCall(pkv#0, i#11);
        key#0_0 := PackedKV.__default.GetKey(pkv#0, i#11);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(757,37)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(758,17)
        assume true;
        ##pkv#0_1 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0_1, Tclass.PackedKV.Pkv(), $Heap);
        ##i#0_1 := i#11;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_1, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0_2: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)), i#0_2)): Seq Box } 
                      LitInt(0) <= i#0_2
                           && i#0_2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)), i#0_2)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)))
                 || (forall i#0_3: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)), i#0_3)): Seq Box } 
                  LitInt(0) <= i#0_3
                       && i#0_3
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)), i#0_3)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
           ==> PackedKV.__default.WF(##pkv#0_1)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_1)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#0_1);
        assert {:subsumption 0} LitInt(0) <= ##i#0_1;
        assert {:subsumption 0} ##i#0_1
           < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)));
        assume LitInt(0) <= ##i#0_1
           && ##i#0_1
             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)));
        assume PackedKV.__default.GetMessage#canCall(pkv#0, i#11);
        assume PackedKV.__default.GetMessage#canCall(pkv#0, i#11);
        msg#0_0 := PackedKV.__default.GetMessage(pkv#0, i#11);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(758,41)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(760,26)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        pkv##0_0 := pkv#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0_0 := i#11;
        assume true;
        // ProcessCallStmt: CheckSubrange
        b##0_0 := end#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$DynamicPkv.__default.PSAPopFrontWeight(pkv##0_0, a##0_0, b##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(760,38)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(761,26)
        // TrCallStmt: Before ProcessCallStmt
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Subset(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr), 
              read($Heap, this, DynamicPkv.DynamicPkv.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.Repr)), 
              read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.Repr));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
           ==> DynamicPkv.DynamicPkv.WF($Heap, this)
             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
        assume DynamicPkv.DynamicPkv.WF($Heap, this);
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
        // ProcessCallStmt: CheckSubrange
        pkv##0_1 := DynamicPkv.DynamicPkv.toPkv($Heap, this);
        assume true;
        // ProcessCallStmt: CheckSubrange
        assert $Is(key#0_0, Tclass.KeyType.Key());
        key##0_0 := key#0_0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        msg##0_0 := msg#0_0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$DynamicPkv.__default.PSAPushBackWeight(pkv##0_1, key##0_0, msg##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(761,44)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(763,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assume true;
        // ProcessCallStmt: CheckSubrange
        assert $Is(key#0_0, Tclass.KeyType.Key());
        key##0_1 := key#0_0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        msg##0_1 := msg#0_0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$DynamicPkv.DynamicPkv.Append(this, key##0_1, msg##0_1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(763,24)"} true;
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(765,9)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(765,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_0_0 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0_0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0_0));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            newtype$check#0_0_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_0 && newtype$check#0_0_0 < 18446744073709551616;
            newtype$check#0_0_1 := i#11 + 1;
            assert LitInt(0) <= newtype$check#0_0_1 && newtype$check#0_0_1 < 18446744073709551616;
            assert {:subsumption 0} start#0 <= i#11 + 1
               && i#11 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(765,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_0_0_0 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0_0_0, Tclass.PackedStringArray.Psa(), $Heap);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0)) == LitInt(0));
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0)) - 1)): int);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0_0_0));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assume {:subsumption 0} 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            newtype$check#0_0_0_0 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_0_0_0
               && newtype$check#0_0_0_0 < 18446744073709551616;
            newtype$check#0_0_0_1 := i#11 + 1;
            assume LitInt(0) <= newtype$check#0_0_0_1
               && newtype$check#0_0_0_1 < 18446744073709551616;
            assume {:subsumption 0} start#0 <= i#11 + 1
               && i#11 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(765,9)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(765,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_0_0_1 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0_0_1, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0_1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_0_1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0_0_1));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assert {:subsumption 0} start#0 <= i#11
               && i#11 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(765,9)
            assert {:subsumption 0} Seq#Equal(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
                start#0), 
              Seq#Append(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0), 
                Seq#Build(Seq#Empty(): Seq Box, $Box(key#0_0))));
            assume false;
        }

        assume Seq#Equal(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
            start#0), 
          Seq#Append(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0), 
            Seq#Build(Seq#Empty(): Seq Box, $Box(key#0_0))));
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(769,9)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(769,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_1_0 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_1_0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_1_0));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            newtype$check#0_1_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_1_0 && newtype$check#0_1_0 < 18446744073709551616;
            newtype$check#0_1_1 := i#11 + 1;
            assert LitInt(0) <= newtype$check#0_1_1 && newtype$check#0_1_1 < 18446744073709551616;
            assert {:subsumption 0} start#0 <= i#11 + 1
               && i#11 + 1
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(769,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_1_0_0 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_1_0_0, Tclass.PackedStringArray.Psa(), $Heap);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0_0)) == LitInt(0));
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_0_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0_0)) - 1)): int);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_1_0_0));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assume {:subsumption 0} 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            newtype$check#0_1_0_0 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_1_0_0
               && newtype$check#0_1_0_0 < 18446744073709551616;
            newtype$check#0_1_0_1 := i#11 + 1;
            assume LitInt(0) <= newtype$check#0_1_0_1
               && newtype$check#0_1_0_1 < 18446744073709551616;
            assume {:subsumption 0} start#0 <= i#11 + 1
               && i#11 + 1
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(769,9)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(769,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_1_0_1 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_1_0_1, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0_1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0_1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0_1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0_1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_0_1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0_1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_0_1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_1_0_1));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assert {:subsumption 0} start#0 <= i#11
               && i#11 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(769,9)
            assert {:subsumption 0} Seq#Equal(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
                start#0), 
              Seq#Append(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                  start#0), 
                Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0_0))));
            assume false;
        }

        assume Seq#Equal(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
            start#0), 
          Seq#Append(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
              start#0), 
            Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0_0))));
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(774,9)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(774,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_2_0 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_2_0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_2_0));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            newtype$check#0_2_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_2_0 && newtype$check#0_2_0 < 18446744073709551616;
            newtype$check#0_2_1 := i#11 + 1;
            assert LitInt(0) <= newtype$check#0_2_1 && newtype$check#0_2_1 < 18446744073709551616;
            assert {:subsumption 0} start#0 <= i#11 + 1
               && i#11 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
                start#0), 
              TSeq(Tclass.KeyType.Key()));
            ##keys#0_2_0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
              start#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#0_2_0, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
                start#0));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
               && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
                  start#0));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(774,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_2_0_0 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_2_0_0, Tclass.PackedStringArray.Psa(), $Heap);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_0)) == LitInt(0));
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_0_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_0)) - 1)): int);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_2_0_0));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assume {:subsumption 0} 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            newtype$check#0_2_0_0 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_2_0_0
               && newtype$check#0_2_0_0 < 18446744073709551616;
            newtype$check#0_2_0_1 := i#11 + 1;
            assume LitInt(0) <= newtype$check#0_2_0_1
               && newtype$check#0_2_0_1 < 18446744073709551616;
            assume {:subsumption 0} start#0 <= i#11 + 1
               && i#11 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assume $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
                start#0), 
              TSeq(Tclass.KeyType.Key()));
            ##keys#0_2_0_0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
              start#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#0_2_0_0, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
                start#0));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
               && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
                  start#0));
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(774,9)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(776,34)
            // TrCallStmt: Before ProcessCallStmt
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_2_0_1 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_2_0_1, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_0_1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_2_0_1));
            assume PackedStringArray.__default.WF(##psa#0_2_0_1);
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assert 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assert start#0 <= i#11
               && i#11 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            // ProcessCallStmt: CheckSubrange
            assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0), 
              TSeq(Tclass.KeyType.Key()));
            keys##0_2_0_0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            assert $Is(key#0_0, Tclass.KeyType.Key());
            key##0_2_0_0 := key#0_0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$BucketWeights.__default.WeightKeyListPushBack(keys##0_2_0_0, key##0_2_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(776,65)"} true;
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(774,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_2_0_2 := PackedKV.Pkv.keys(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_2_0_2, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_2)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_2)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_2)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_2)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_2))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0_2))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_0_2), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0_2)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_2_0_2)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_2_0_2));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assert {:subsumption 0} start#0 <= i#11
               && i#11 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
            assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0), 
              TSeq(Tclass.KeyType.Key()));
            ##keys#0_2_0_1 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#0_2_0_1, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0));
            assert $Is(key#0_0, Tclass.KeyType.Key());
            ##key#0_2_0_0 := key#0_0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#0_2_0_0, Tclass.KeyType.Key(), $Heap);
            assume BucketWeights.__default.WeightKey#canCall(key#0_0);
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
               && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0))
               && BucketWeights.__default.WeightKey#canCall(key#0_0);
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(774,9)
            assert {:subsumption 0} BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
                  start#0))
               == BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0))
                 + BucketWeights.__default.WeightKey(key#0_0);
            assume false;
        }

        assume BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11 + 1), 
              start#0))
           == BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0))
             + BucketWeights.__default.WeightKey(key#0_0);
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(779,9)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(779,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_3_0 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_3_0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_3_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_3_0));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            newtype$check#0_3_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_3_0 && newtype$check#0_3_0 < 18446744073709551616;
            newtype$check#0_3_1 := i#11 + 1;
            assert LitInt(0) <= newtype$check#0_3_1 && newtype$check#0_3_1 < 18446744073709551616;
            assert {:subsumption 0} start#0 <= i#11 + 1
               && i#11 + 1
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            ##msgs#0_3_0 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
              start#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#0_3_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
                start#0));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
               && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
                  start#0));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(779,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_3_0_0 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_3_0_0, Tclass.PackedStringArray.Psa(), $Heap);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_0)) == LitInt(0));
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_3_0_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_0)) - 1)): int);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_3_0_0));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assume {:subsumption 0} 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            newtype$check#0_3_0_0 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_3_0_0
               && newtype$check#0_3_0_0 < 18446744073709551616;
            newtype$check#0_3_0_1 := i#11 + 1;
            assume LitInt(0) <= newtype$check#0_3_0_1
               && newtype$check#0_3_0_1 < 18446744073709551616;
            assume {:subsumption 0} start#0 <= i#11 + 1
               && i#11 + 1
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            ##msgs#0_3_0_0 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
              start#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#0_3_0_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
                start#0));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
               && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
                  start#0));
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(779,9)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(781,38)
            // TrCallStmt: Before ProcessCallStmt
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_3_0_1 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_3_0_1, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_3_0_1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_3_0_1));
            assume PackedStringArray.__default.WF(##psa#0_3_0_1);
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assert start#0 <= i#11
               && i#11 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            // ProcessCallStmt: CheckSubrange
            msgs##0_3_0_0 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
              start#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            msg##0_3_0_0 := msg#0_0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$BucketWeights.__default.WeightMessageListPushBack(msgs##0_3_0_0, msg##0_3_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(781,81)"} true;
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(779,9)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_3_0_2 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_3_0_2, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_2)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_2)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_2))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_2))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_3_0_2), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_2)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_3_0_2));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= start#0
               && start#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assert {:subsumption 0} start#0 <= i#11
               && i#11 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            ##msgs#0_3_0_1 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
              start#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#0_3_0_1, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                start#0));
            ##msg#0_3_0_0 := msg#0_0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msg#0_3_0_0, Tclass.ValueMessage.Message(), $Heap);
            assume BucketWeights.__default.WeightMessage#canCall(msg#0_0);
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
               && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                  start#0))
               && BucketWeights.__default.WeightMessage#canCall(msg#0_0);
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(779,9)
            assert {:subsumption 0} BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
                  start#0))
               == BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                    start#0))
                 + BucketWeights.__default.WeightMessage(msg#0_0);
            assume false;
        }

        assume BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11 + 1), 
              start#0))
           == BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
                start#0))
             + BucketWeights.__default.WeightMessage(msg#0_0);
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(785,11)
        assume true;
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#11 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume true;
        i#11 := i#11 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(785,18)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(743,7)
        assert 0 <= $decr$loop#00 || end#0 - i#11 == $decr$loop#00;
        assert end#0 - i#11 < $decr$loop#00;
        assume true;
        assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
        assume DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv(old($Heap), this));
        assume true;
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), end#0), i#11))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), end#0), 
              i#11));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
           && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#11), start#0));
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this)))
           && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, this))))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall(old($Heap), this)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this)))
           && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv(old($Heap), this))))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), i#11), 
              start#0));
    }
}



// function declaration for DynamicPkv.DynamicPkv.hasCapacity
function DynamicPkv.DynamicPkv.hasCapacity($heap: Heap, this: ref, cap#0: DatatypeType) : bool;

function DynamicPkv.DynamicPkv.hasCapacity#canCall($heap: Heap, this: ref, cap#0: DatatypeType) : bool;

// frame axiom for DynamicPkv.DynamicPkv.hasCapacity
axiom (forall $h0: Heap, $h1: Heap, this: ref, cap#0: DatatypeType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DynamicPkv.DynamicPkv.hasCapacity($h1, this, cap#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.DynamicPkv.DynamicPkv())
       && (DynamicPkv.DynamicPkv.hasCapacity#canCall($h0, this, cap#0)
         || $Is(cap#0, Tclass.DynamicPkv.Capacity()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($h0, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> DynamicPkv.DynamicPkv.hasCapacity($h0, this, cap#0)
       == DynamicPkv.DynamicPkv.hasCapacity($h1, this, cap#0));

// consequence axiom for DynamicPkv.DynamicPkv.hasCapacity
axiom 18 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref, cap#0: DatatypeType :: 
    { DynamicPkv.DynamicPkv.hasCapacity($Heap, this, cap#0) } 
    DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, cap#0)
         || (18 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.DynamicPkv.DynamicPkv())
           && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
           && $Is(cap#0, Tclass.DynamicPkv.Capacity())
           && DynamicPkv.DynamicPkv.WF($Heap, this))
       ==> true);

function DynamicPkv.DynamicPkv.hasCapacity#requires(Heap, ref, DatatypeType) : bool;

// #requires axiom for DynamicPkv.DynamicPkv.hasCapacity
axiom (forall $Heap: Heap, this: ref, cap#0: DatatypeType :: 
  { DynamicPkv.DynamicPkv.hasCapacity#requires($Heap, this, cap#0) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.DynamicPkv.DynamicPkv())
       && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
       && $Is(cap#0, Tclass.DynamicPkv.Capacity())
     ==> DynamicPkv.DynamicPkv.hasCapacity#requires($Heap, this, cap#0)
       == DynamicPkv.DynamicPkv.WF($Heap, this));

// definition axiom for DynamicPkv.DynamicPkv.hasCapacity(revealed)
axiom 18 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref, cap#0: DatatypeType :: 
    { DynamicPkv.DynamicPkv.hasCapacity($Heap, this, cap#0) } 
    DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, cap#0)
         || (18 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.DynamicPkv.DynamicPkv())
           && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap)
           && $Is(cap#0, Tclass.DynamicPkv.Capacity())
           && DynamicPkv.DynamicPkv.WF($Heap, this))
       ==> DynamicPkv.Capacity.Capacity_q(cap#0)
         && (DynamicPkv.Capacity.num__kv__pairs(cap#0)
             <= _System.array.Length(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.offsets))
           ==> DynamicPkv.Capacity.Capacity_q(cap#0))
         && (DynamicPkv.Capacity.Capacity_q(cap#0)
             && DynamicPkv.Capacity.total__key__len(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.data))
           ==> DynamicPkv.Capacity.Capacity_q(cap#0))
         && (DynamicPkv.Capacity.Capacity_q(cap#0)
             && DynamicPkv.Capacity.num__kv__pairs(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets))
           ==> DynamicPkv.Capacity.Capacity_q(cap#0))
         && DynamicPkv.DynamicPkv.hasCapacity($Heap, this, cap#0)
           == (
            DynamicPkv.Capacity.num__kv__pairs(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets))
             && DynamicPkv.Capacity.total__key__len(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.data))
             && DynamicPkv.Capacity.num__kv__pairs(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets))
             && DynamicPkv.Capacity.total__message__len(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.data))));

procedure CheckWellformed$$DynamicPkv.DynamicPkv.hasCapacity(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    cap#0: DatatypeType where $Is(cap#0, Tclass.DynamicPkv.Capacity()));
  free requires 18 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.DynamicPkv.hasCapacity(this: ref, cap#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;
  var b$reqreads#9: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;
    b$reqreads#9 := true;

    // AddWellformednessCheck for function hasCapacity
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(789,14): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assert b$reqreads#0;
    b$reqreads#1 := $_Frame[this, DynamicPkv.DynamicPkv.Repr];
    assert b$reqreads#1;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]);
        assume DynamicPkv.Capacity.Capacity_q(cap#0);
        b$reqreads#2 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
        assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
        b$reqreads#3 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.keys), PackedStringArray.DynamicPsa.offsets];
        assert read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.offsets)
           != null;
        if (DynamicPkv.Capacity.num__kv__pairs(cap#0)
           <= _System.array.Length(read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.offsets)))
        {
            assume DynamicPkv.Capacity.Capacity_q(cap#0);
            b$reqreads#4 := $_Frame[this, DynamicPkv.DynamicPkv.keys];
            assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
            b$reqreads#5 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.keys), PackedStringArray.DynamicPsa.data];
            assert read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.data)
               != null;
        }

        if (DynamicPkv.Capacity.num__kv__pairs(cap#0)
             <= _System.array.Length(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.offsets))
           && DynamicPkv.Capacity.total__key__len(cap#0)
             <= _System.array.Length(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.data)))
        {
            assume DynamicPkv.Capacity.Capacity_q(cap#0);
            b$reqreads#6 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
            assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
            b$reqreads#7 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.messages), PackedStringArray.DynamicPsa.offsets];
            assert read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.offsets)
               != null;
        }

        if (DynamicPkv.Capacity.num__kv__pairs(cap#0)
             <= _System.array.Length(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.offsets))
           && DynamicPkv.Capacity.total__key__len(cap#0)
             <= _System.array.Length(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.data))
           && DynamicPkv.Capacity.num__kv__pairs(cap#0)
             <= _System.array.Length(read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.offsets)))
        {
            assume DynamicPkv.Capacity.Capacity_q(cap#0);
            b$reqreads#8 := $_Frame[this, DynamicPkv.DynamicPkv.messages];
            assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
            b$reqreads#9 := $_Frame[read($Heap, this, DynamicPkv.DynamicPkv.messages), PackedStringArray.DynamicPsa.data];
            assert read($Heap, 
                read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                PackedStringArray.DynamicPsa.data)
               != null;
        }

        assume DynamicPkv.DynamicPkv.hasCapacity($Heap, this, cap#0)
           == (
            DynamicPkv.Capacity.num__kv__pairs(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets))
             && DynamicPkv.Capacity.total__key__len(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.data))
             && DynamicPkv.Capacity.num__kv__pairs(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.offsets))
             && DynamicPkv.Capacity.total__message__len(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                  PackedStringArray.DynamicPsa.data)));
        assume DynamicPkv.Capacity.Capacity_q(cap#0)
           && (DynamicPkv.Capacity.num__kv__pairs(cap#0)
               <= _System.array.Length(read($Heap, 
                  read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                  PackedStringArray.DynamicPsa.offsets))
             ==> DynamicPkv.Capacity.Capacity_q(cap#0))
           && (DynamicPkv.Capacity.Capacity_q(cap#0)
               && DynamicPkv.Capacity.total__key__len(cap#0)
                 <= _System.array.Length(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.data))
             ==> DynamicPkv.Capacity.Capacity_q(cap#0))
           && (DynamicPkv.Capacity.Capacity_q(cap#0)
               && DynamicPkv.Capacity.num__kv__pairs(cap#0)
                 <= _System.array.Length(read($Heap, 
                    read($Heap, this, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.offsets))
             ==> DynamicPkv.Capacity.Capacity_q(cap#0));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.DynamicPkv.hasCapacity($Heap, this, cap#0), TBool);
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
        assert b$reqreads#7;
        assert b$reqreads#8;
        assert b$reqreads#9;
    }
}



procedure CheckWellformed$$DynamicPkv.DynamicPkv.PreSized(this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap), 
    capacity#0: DatatypeType
       where $Is(capacity#0, Tclass.DynamicPkv.Capacity())
         && $IsAlloc(capacity#0, Tclass.DynamicPkv.Capacity(), $Heap)
         && $IsA#DynamicPkv.Capacity(capacity#0));
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.DynamicPkv.PreSized(this: ref, capacity#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##cap#0: DatatypeType;

    // AddMethodImpl: PreSized, CheckWellformed$$DynamicPkv.DynamicPkv.PreSized
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(799,16): initial state"} true;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(800,16): post-state"} true;
    assume DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    ##cap#0 := capacity#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##cap#0, Tclass.DynamicPkv.Capacity(), $Heap);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, capacity#0);
    assume DynamicPkv.DynamicPkv.hasCapacity($Heap, this, capacity#0);
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Subset(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, this, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
       ==> DynamicPkv.DynamicPkv.WF($Heap, this)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.WF($Heap, this);
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, this));
    assume PackedKV.__default.EmptyPkv#canCall();
    assume PackedKV.Pkv.Pkv_q(Lit(PackedKV.__default.EmptyPkv()));
    assume PackedKV.Pkv#Equal(DynamicPkv.DynamicPkv.toPkv($Heap, this), PackedKV.__default.EmptyPkv());
    assume (forall $o: ref :: 
      { read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)] } 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$DynamicPkv.DynamicPkv.PreSized(capacity#0: DatatypeType
       where $Is(capacity#0, Tclass.DynamicPkv.Capacity())
         && $IsAlloc(capacity#0, Tclass.DynamicPkv.Capacity(), $Heap)
         && $IsA#DynamicPkv.Capacity(capacity#0))
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.DynamicPkv.DynamicPkv())
         && $IsAlloc(this, Tclass.DynamicPkv.DynamicPkv(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     && 
    DynamicPkv.DynamicPkv.WF($Heap, this)
     && 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)]
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))]
     && Set#Subset(read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr), 
      read($Heap, this, DynamicPkv.DynamicPkv.Repr))
     && 
    Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.keys), 
        PackedStringArray.DynamicPsa.Repr))
     && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys))
     && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))
     && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
        PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free ensures DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, capacity#0);
  free ensures DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, capacity#0)
     && 
    DynamicPkv.DynamicPkv.hasCapacity($Heap, this, capacity#0)
     && 
    DynamicPkv.Capacity.num__kv__pairs(capacity#0)
       <= _System.array.Length(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.offsets))
     && DynamicPkv.Capacity.total__key__len(capacity#0)
       <= _System.array.Length(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.data))
     && DynamicPkv.Capacity.num__kv__pairs(capacity#0)
       <= _System.array.Length(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.offsets))
     && DynamicPkv.Capacity.total__message__len(capacity#0)
       <= _System.array.Length(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.data));
  free ensures $IsA#PackedKV.Pkv(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && $IsA#PackedKV.Pkv(Lit(PackedKV.__default.EmptyPkv()))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.__default.EmptyPkv#canCall();
  ensures PackedKV.Pkv#Equal(DynamicPkv.DynamicPkv.toPkv($Heap, this), PackedKV.__default.EmptyPkv());
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)] } 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.DynamicPkv.PreSized(capacity#0: DatatypeType
       where $Is(capacity#0, Tclass.DynamicPkv.Capacity())
         && $IsAlloc(capacity#0, Tclass.DynamicPkv.Capacity(), $Heap)
         && $IsA#DynamicPkv.Capacity(capacity#0))
   returns (this: ref where this != null && $Is(this, Tclass.DynamicPkv.DynamicPkv()), 
    $_reverifyPost: bool);
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this);
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(this)];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.keys))];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, this, DynamicPkv.DynamicPkv.messages))];
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Subset(read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr), 
        read($Heap, this, DynamicPkv.DynamicPkv.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.messages), 
          PackedStringArray.DynamicPsa.Repr));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages));
  ensures DynamicPkv.DynamicPkv.WF#canCall($Heap, this)
     ==> DynamicPkv.DynamicPkv.WF($Heap, this)
       || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.keys)), 
          PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, this, DynamicPkv.DynamicPkv.messages))));
  free ensures DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, capacity#0);
  ensures DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, capacity#0)
     ==> DynamicPkv.DynamicPkv.hasCapacity($Heap, this, capacity#0)
       || DynamicPkv.Capacity.num__kv__pairs(capacity#0)
         <= _System.array.Length(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.offsets));
  ensures DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, capacity#0)
     ==> DynamicPkv.DynamicPkv.hasCapacity($Heap, this, capacity#0)
       || DynamicPkv.Capacity.total__key__len(capacity#0)
         <= _System.array.Length(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.data));
  ensures DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, capacity#0)
     ==> DynamicPkv.DynamicPkv.hasCapacity($Heap, this, capacity#0)
       || DynamicPkv.Capacity.num__kv__pairs(capacity#0)
         <= _System.array.Length(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.offsets));
  ensures DynamicPkv.DynamicPkv.hasCapacity#canCall($Heap, this, capacity#0)
     ==> DynamicPkv.DynamicPkv.hasCapacity($Heap, this, capacity#0)
       || DynamicPkv.Capacity.total__message__len(capacity#0)
         <= _System.array.Length(read($Heap, 
            read($Heap, this, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.data));
  free ensures $IsA#PackedKV.Pkv(DynamicPkv.DynamicPkv.toPkv($Heap, this))
     && $IsA#PackedKV.Pkv(Lit(PackedKV.__default.EmptyPkv()))
     && 
    DynamicPkv.DynamicPkv.toPkv#canCall($Heap, this)
     && PackedKV.__default.EmptyPkv#canCall();
  ensures PackedKV.Pkv#Equal(DynamicPkv.DynamicPkv.toPkv($Heap, this), PackedKV.__default.EmptyPkv());
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)] } 
    read($Heap, this, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.DynamicPkv.PreSized(capacity#0: DatatypeType) returns (this: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var this.keys: ref;
  var this.messages: ref;
  var this.Repr: Set Box;
  var defass#this.keys: bool;
  var defass#this.messages: bool;
  var $nw: ref;
  var num_strings##0: int;
  var total_len##0: int;
  var num_strings##1: int;
  var total_len##1: int;
  var $rhs#0: Set Box where $Is($rhs#0, TSet(Tclass._System.object()));

    // AddMethodImpl: PreSized, Impl$$DynamicPkv.DynamicPkv.PreSized
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(804,4): initial state"} true;
    $_reverifyPost := false;
    // ----- divided block before new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(804,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(805,12)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(805,38)
    // TrCallStmt: Before ProcessCallStmt
    assume DynamicPkv.Capacity.Capacity_q(capacity#0);
    assume DynamicPkv.Capacity.Capacity_q(capacity#0);
    // ProcessCallStmt: CheckSubrange
    num_strings##0 := DynamicPkv.Capacity.num__kv__pairs(capacity#0);
    assume DynamicPkv.Capacity.Capacity_q(capacity#0);
    assume DynamicPkv.Capacity.Capacity_q(capacity#0);
    // ProcessCallStmt: CheckSubrange
    total_len##0 := DynamicPkv.Capacity.total__key__len(capacity#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$PackedStringArray.DynamicPsa.PreSized(num_strings##0, total_len##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(805,92)"} true;
    this.keys := $nw;
    defass#this.keys := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(805,92)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(806,16)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(806,42)
    // TrCallStmt: Before ProcessCallStmt
    assume DynamicPkv.Capacity.Capacity_q(capacity#0);
    assume DynamicPkv.Capacity.Capacity_q(capacity#0);
    // ProcessCallStmt: CheckSubrange
    num_strings##1 := DynamicPkv.Capacity.num__kv__pairs(capacity#0);
    assume DynamicPkv.Capacity.Capacity_q(capacity#0);
    assume DynamicPkv.Capacity.Capacity_q(capacity#0);
    // ProcessCallStmt: CheckSubrange
    total_len##1 := DynamicPkv.Capacity.total__message__len(capacity#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$PackedStringArray.DynamicPsa.PreSized(num_strings##1, total_len##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(806,100)"} true;
    this.messages := $nw;
    defass#this.messages := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(806,100)"} true;
    // ----- new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(804,5)
    assert defass#this.keys;
    assert defass#this.messages;
    assume !read($Heap, this, alloc);
    assume read($Heap, this, DynamicPkv.DynamicPkv.keys) == this.keys;
    assume read($Heap, this, DynamicPkv.DynamicPkv.messages) == this.messages;
    assume read($Heap, this, DynamicPkv.DynamicPkv.Repr) == this.Repr;
    $Heap := update($Heap, this, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    // ----- divided block after new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(804,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(808,12)
    assume true;
    assert $_Frame[this, DynamicPkv.DynamicPkv.Repr];
    assert read($Heap, this, DynamicPkv.DynamicPkv.keys) != null;
    assert read($Heap, this, DynamicPkv.DynamicPkv.messages) != null;
    assume true;
    $rhs#0 := Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, DynamicPkv.DynamicPkv.keys), 
          PackedStringArray.DynamicPsa.Repr)), 
      read($Heap, 
        read($Heap, this, DynamicPkv.DynamicPkv.messages), 
        PackedStringArray.DynamicPsa.Repr));
    $Heap := update($Heap, this, DynamicPkv.DynamicPkv.Repr, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(808,48)"} true;
}



// DynamicPkv.DynamicPkv: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.DynamicPkv.DynamicPkv()) } 
  $Is(c#0, Tclass.DynamicPkv.DynamicPkv())
     <==> $Is(c#0, Tclass.DynamicPkv.DynamicPkv?()) && c#0 != null);

// DynamicPkv.DynamicPkv: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.DynamicPkv.DynamicPkv(), $h) } 
  $IsAlloc(c#0, Tclass.DynamicPkv.DynamicPkv(), $h)
     <==> $IsAlloc(c#0, Tclass.DynamicPkv.DynamicPkv?(), $h));

// Constructor function declaration
function #DynamicPkv.SingleMergeResult.MergeCompleted(DatatypeType, int) : DatatypeType;

const unique ##DynamicPkv.SingleMergeResult.MergeCompleted: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: int :: 
  { #DynamicPkv.SingleMergeResult.MergeCompleted(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#DynamicPkv.SingleMergeResult.MergeCompleted(a#0#0#0, a#0#1#0))
     == ##DynamicPkv.SingleMergeResult.MergeCompleted);

function DynamicPkv.SingleMergeResult.MergeCompleted_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { DynamicPkv.SingleMergeResult.MergeCompleted_q(d) } 
  DynamicPkv.SingleMergeResult.MergeCompleted_q(d)
     <==> DatatypeCtorId(d) == ##DynamicPkv.SingleMergeResult.MergeCompleted);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { DynamicPkv.SingleMergeResult.MergeCompleted_q(d) } 
  DynamicPkv.SingleMergeResult.MergeCompleted_q(d)
     ==> (exists a#1#0#0: DatatypeType, a#1#1#0: int :: 
      d == #DynamicPkv.SingleMergeResult.MergeCompleted(a#1#0#0, a#1#1#0)));

function Tclass.DynamicPkv.SingleMergeResult() : Ty;

// Tclass.DynamicPkv.SingleMergeResult Tag
axiom Tag(Tclass.DynamicPkv.SingleMergeResult())
   == Tagclass.DynamicPkv.SingleMergeResult;

const unique Tagclass.DynamicPkv.SingleMergeResult: TyTag;

// Box/unbox axiom for Tclass.DynamicPkv.SingleMergeResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DynamicPkv.SingleMergeResult()) } 
  $IsBox(bx, Tclass.DynamicPkv.SingleMergeResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.DynamicPkv.SingleMergeResult()));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType, a#2#1#0: int :: 
  { $Is(#DynamicPkv.SingleMergeResult.MergeCompleted(a#2#0#0, a#2#1#0), 
      Tclass.DynamicPkv.SingleMergeResult()) } 
  $Is(#DynamicPkv.SingleMergeResult.MergeCompleted(a#2#0#0, a#2#1#0), 
      Tclass.DynamicPkv.SingleMergeResult())
     <==> $Is(a#2#0#0, Tclass.PackedKV.Pkv()) && $Is(a#2#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, a#3#1#0: int, $h: Heap :: 
  { $IsAlloc(#DynamicPkv.SingleMergeResult.MergeCompleted(a#3#0#0, a#3#1#0), 
      Tclass.DynamicPkv.SingleMergeResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#DynamicPkv.SingleMergeResult.MergeCompleted(a#3#0#0, a#3#1#0), 
        Tclass.DynamicPkv.SingleMergeResult(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.PackedKV.Pkv(), $h)
         && $IsAlloc(a#3#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.SingleMergeResult.bot(d), Tclass.PackedKV.Pkv(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.SingleMergeResult.MergeCompleted_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.SingleMergeResult(), $h)
     ==> $IsAlloc(DynamicPkv.SingleMergeResult.bot(d), Tclass.PackedKV.Pkv(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.SingleMergeResult.slack(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.SingleMergeResult.MergeCompleted_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.SingleMergeResult(), $h)
     ==> $IsAlloc(DynamicPkv.SingleMergeResult.slack(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType, a#4#1#0: int :: 
  { #DynamicPkv.SingleMergeResult.MergeCompleted(Lit(a#4#0#0), LitInt(a#4#1#0)) } 
  #DynamicPkv.SingleMergeResult.MergeCompleted(Lit(a#4#0#0), LitInt(a#4#1#0))
     == Lit(#DynamicPkv.SingleMergeResult.MergeCompleted(a#4#0#0, a#4#1#0)));

function DynamicPkv.SingleMergeResult.bot(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType, a#5#1#0: int :: 
  { #DynamicPkv.SingleMergeResult.MergeCompleted(a#5#0#0, a#5#1#0) } 
  DynamicPkv.SingleMergeResult.bot(#DynamicPkv.SingleMergeResult.MergeCompleted(a#5#0#0, a#5#1#0))
     == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType, a#6#1#0: int :: 
  { #DynamicPkv.SingleMergeResult.MergeCompleted(a#6#0#0, a#6#1#0) } 
  DtRank(a#6#0#0)
     < DtRank(#DynamicPkv.SingleMergeResult.MergeCompleted(a#6#0#0, a#6#1#0)));

function DynamicPkv.SingleMergeResult.slack(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#7#0#0: DatatypeType, a#7#1#0: int :: 
  { #DynamicPkv.SingleMergeResult.MergeCompleted(a#7#0#0, a#7#1#0) } 
  DynamicPkv.SingleMergeResult.slack(#DynamicPkv.SingleMergeResult.MergeCompleted(a#7#0#0, a#7#1#0))
     == a#7#1#0);

// Constructor function declaration
function #DynamicPkv.SingleMergeResult.SlackExhausted(DatatypeType, int, int) : DatatypeType;

const unique ##DynamicPkv.SingleMergeResult.SlackExhausted: DtCtorId;

// Constructor identifier
axiom (forall a#8#0#0: DatatypeType, a#8#1#0: int, a#8#2#0: int :: 
  { #DynamicPkv.SingleMergeResult.SlackExhausted(a#8#0#0, a#8#1#0, a#8#2#0) } 
  DatatypeCtorId(#DynamicPkv.SingleMergeResult.SlackExhausted(a#8#0#0, a#8#1#0, a#8#2#0))
     == ##DynamicPkv.SingleMergeResult.SlackExhausted);

function DynamicPkv.SingleMergeResult.SlackExhausted_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { DynamicPkv.SingleMergeResult.SlackExhausted_q(d) } 
  DynamicPkv.SingleMergeResult.SlackExhausted_q(d)
     <==> DatatypeCtorId(d) == ##DynamicPkv.SingleMergeResult.SlackExhausted);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { DynamicPkv.SingleMergeResult.SlackExhausted_q(d) } 
  DynamicPkv.SingleMergeResult.SlackExhausted_q(d)
     ==> (exists a#9#0#0: DatatypeType, a#9#1#0: int, a#9#2#0: int :: 
      d == #DynamicPkv.SingleMergeResult.SlackExhausted(a#9#0#0, a#9#1#0, a#9#2#0)));

// Constructor $Is
axiom (forall a#10#0#0: DatatypeType, a#10#1#0: int, a#10#2#0: int :: 
  { $Is(#DynamicPkv.SingleMergeResult.SlackExhausted(a#10#0#0, a#10#1#0, a#10#2#0), 
      Tclass.DynamicPkv.SingleMergeResult()) } 
  $Is(#DynamicPkv.SingleMergeResult.SlackExhausted(a#10#0#0, a#10#1#0, a#10#2#0), 
      Tclass.DynamicPkv.SingleMergeResult())
     <==> $Is(a#10#0#0, Tclass.PackedKV.Pkv())
       && $Is(a#10#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#10#2#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#11#0#0: DatatypeType, a#11#1#0: int, a#11#2#0: int, $h: Heap :: 
  { $IsAlloc(#DynamicPkv.SingleMergeResult.SlackExhausted(a#11#0#0, a#11#1#0, a#11#2#0), 
      Tclass.DynamicPkv.SingleMergeResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#DynamicPkv.SingleMergeResult.SlackExhausted(a#11#0#0, a#11#1#0, a#11#2#0), 
        Tclass.DynamicPkv.SingleMergeResult(), 
        $h)
       <==> $IsAlloc(a#11#0#0, Tclass.PackedKV.Pkv(), $h)
         && $IsAlloc(a#11#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#11#2#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.SingleMergeResult.bot(d), Tclass.PackedKV.Pkv(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.SingleMergeResult.SlackExhausted_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.SingleMergeResult(), $h)
     ==> $IsAlloc(DynamicPkv.SingleMergeResult.bot(d), Tclass.PackedKV.Pkv(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.SingleMergeResult.end(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.SingleMergeResult.SlackExhausted_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.SingleMergeResult(), $h)
     ==> $IsAlloc(DynamicPkv.SingleMergeResult.end(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.SingleMergeResult.slack(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.SingleMergeResult.SlackExhausted_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.SingleMergeResult(), $h)
     ==> $IsAlloc(DynamicPkv.SingleMergeResult.slack(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#12#0#0: DatatypeType, a#12#1#0: int, a#12#2#0: int :: 
  { #DynamicPkv.SingleMergeResult.SlackExhausted(Lit(a#12#0#0), LitInt(a#12#1#0), LitInt(a#12#2#0)) } 
  #DynamicPkv.SingleMergeResult.SlackExhausted(Lit(a#12#0#0), LitInt(a#12#1#0), LitInt(a#12#2#0))
     == Lit(#DynamicPkv.SingleMergeResult.SlackExhausted(a#12#0#0, a#12#1#0, a#12#2#0)));

// Constructor injectivity
axiom (forall a#13#0#0: DatatypeType, a#13#1#0: int, a#13#2#0: int :: 
  { #DynamicPkv.SingleMergeResult.SlackExhausted(a#13#0#0, a#13#1#0, a#13#2#0) } 
  DynamicPkv.SingleMergeResult.bot(#DynamicPkv.SingleMergeResult.SlackExhausted(a#13#0#0, a#13#1#0, a#13#2#0))
     == a#13#0#0);

// Inductive rank
axiom (forall a#14#0#0: DatatypeType, a#14#1#0: int, a#14#2#0: int :: 
  { #DynamicPkv.SingleMergeResult.SlackExhausted(a#14#0#0, a#14#1#0, a#14#2#0) } 
  DtRank(a#14#0#0)
     < DtRank(#DynamicPkv.SingleMergeResult.SlackExhausted(a#14#0#0, a#14#1#0, a#14#2#0)));

function DynamicPkv.SingleMergeResult.end(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#15#0#0: DatatypeType, a#15#1#0: int, a#15#2#0: int :: 
  { #DynamicPkv.SingleMergeResult.SlackExhausted(a#15#0#0, a#15#1#0, a#15#2#0) } 
  DynamicPkv.SingleMergeResult.end(#DynamicPkv.SingleMergeResult.SlackExhausted(a#15#0#0, a#15#1#0, a#15#2#0))
     == a#15#1#0);

// Constructor injectivity
axiom (forall a#16#0#0: DatatypeType, a#16#1#0: int, a#16#2#0: int :: 
  { #DynamicPkv.SingleMergeResult.SlackExhausted(a#16#0#0, a#16#1#0, a#16#2#0) } 
  DynamicPkv.SingleMergeResult.slack(#DynamicPkv.SingleMergeResult.SlackExhausted(a#16#0#0, a#16#1#0, a#16#2#0))
     == a#16#2#0);

// Depth-one case-split function
function $IsA#DynamicPkv.SingleMergeResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#DynamicPkv.SingleMergeResult(d) } 
  $IsA#DynamicPkv.SingleMergeResult(d)
     ==> DynamicPkv.SingleMergeResult.MergeCompleted_q(d)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { DynamicPkv.SingleMergeResult.SlackExhausted_q(d), $Is(d, Tclass.DynamicPkv.SingleMergeResult()) } 
    { DynamicPkv.SingleMergeResult.MergeCompleted_q(d), $Is(d, Tclass.DynamicPkv.SingleMergeResult()) } 
  $Is(d, Tclass.DynamicPkv.SingleMergeResult())
     ==> DynamicPkv.SingleMergeResult.MergeCompleted_q(d)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(d));

// Datatype extensional equality declaration
function DynamicPkv.SingleMergeResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #DynamicPkv.SingleMergeResult.MergeCompleted
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.SingleMergeResult#Equal(a, b), DynamicPkv.SingleMergeResult.MergeCompleted_q(a) } 
    { DynamicPkv.SingleMergeResult#Equal(a, b), DynamicPkv.SingleMergeResult.MergeCompleted_q(b) } 
  DynamicPkv.SingleMergeResult.MergeCompleted_q(a)
       && DynamicPkv.SingleMergeResult.MergeCompleted_q(b)
     ==> (DynamicPkv.SingleMergeResult#Equal(a, b)
       <==> PackedKV.Pkv#Equal(DynamicPkv.SingleMergeResult.bot(a), DynamicPkv.SingleMergeResult.bot(b))
         && DynamicPkv.SingleMergeResult.slack(a) == DynamicPkv.SingleMergeResult.slack(b)));

// Datatype extensional equality definition: #DynamicPkv.SingleMergeResult.SlackExhausted
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.SingleMergeResult#Equal(a, b), DynamicPkv.SingleMergeResult.SlackExhausted_q(a) } 
    { DynamicPkv.SingleMergeResult#Equal(a, b), DynamicPkv.SingleMergeResult.SlackExhausted_q(b) } 
  DynamicPkv.SingleMergeResult.SlackExhausted_q(a)
       && DynamicPkv.SingleMergeResult.SlackExhausted_q(b)
     ==> (DynamicPkv.SingleMergeResult#Equal(a, b)
       <==> PackedKV.Pkv#Equal(DynamicPkv.SingleMergeResult.bot(a), DynamicPkv.SingleMergeResult.bot(b))
         && DynamicPkv.SingleMergeResult.end(a) == DynamicPkv.SingleMergeResult.end(b)
         && DynamicPkv.SingleMergeResult.slack(a) == DynamicPkv.SingleMergeResult.slack(b)));

// Datatype extensionality axiom: DynamicPkv.SingleMergeResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.SingleMergeResult#Equal(a, b) } 
  DynamicPkv.SingleMergeResult#Equal(a, b) <==> a == b);

const unique class.DynamicPkv.SingleMergeResult: ClassName;

// function declaration for DynamicPkv.SingleMergeResult.WF
function DynamicPkv.SingleMergeResult.WF(this: DatatypeType) : bool;

function DynamicPkv.SingleMergeResult.WF#canCall(this: DatatypeType) : bool;

// consequence axiom for DynamicPkv.SingleMergeResult.WF
axiom 22 <= $FunctionContextHeight
   ==> (forall this: DatatypeType :: 
    { DynamicPkv.SingleMergeResult.WF(this) } 
    DynamicPkv.SingleMergeResult.WF#canCall(this)
         || (22 != $FunctionContextHeight
           && $Is(this, Tclass.DynamicPkv.SingleMergeResult()))
       ==> true);

function DynamicPkv.SingleMergeResult.WF#requires(DatatypeType) : bool;

// #requires axiom for DynamicPkv.SingleMergeResult.WF
axiom (forall $Heap: Heap, this: DatatypeType :: 
  { DynamicPkv.SingleMergeResult.WF#requires(this), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.DynamicPkv.SingleMergeResult())
       && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap)
     ==> DynamicPkv.SingleMergeResult.WF#requires(this) == true);

// definition axiom for DynamicPkv.SingleMergeResult.WF(revealed)
axiom 22 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.SingleMergeResult.WF(this), $IsGoodHeap($Heap) } 
    DynamicPkv.SingleMergeResult.WF#canCall(this)
         || (22 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.SingleMergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap))
       ==> (Lit(true)
           ==> (DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(this))
             && PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(this)))
         && DynamicPkv.SingleMergeResult.WF(this)
           == (true && PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(this))));

// definition axiom for DynamicPkv.SingleMergeResult.WF for all literals(revealed)
axiom 22 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    {:weight 3} { DynamicPkv.SingleMergeResult.WF(Lit(this)), $IsGoodHeap($Heap) } 
    DynamicPkv.SingleMergeResult.WF#canCall(Lit(this))
         || (22 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.SingleMergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap))
       ==> (Lit(true)
           ==> (DynamicPkv.SingleMergeResult.MergeCompleted_q(Lit(this))
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(Lit(this)))
             && PackedKV.__default.WF#canCall(Lit(DynamicPkv.SingleMergeResult.bot(Lit(this)))))
         && DynamicPkv.SingleMergeResult.WF(Lit(this))
           == Lit(true && PackedKV.__default.WF(Lit(DynamicPkv.SingleMergeResult.bot(Lit(this))))));

procedure CheckWellformed$$DynamicPkv.SingleMergeResult.WF(this: DatatypeType
       where $Is(this, Tclass.DynamicPkv.SingleMergeResult())
         && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap));
  free requires 22 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.SingleMergeResult.WF(this: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var b$reqreads#0: bool;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function WF
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(822,14): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        if (Lit(true))
        {
            assume DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(this);
            ##pkv#0 := DynamicPkv.SingleMergeResult.bot(this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
            b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(this));
        }

        assume DynamicPkv.SingleMergeResult.WF(this)
           == (true && PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(this)));
        assume Lit(true)
           ==> (DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(this))
             && PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(this));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.SingleMergeResult.WF(this), TBool);
        assert b$reqreads#0;
    }
}



// function declaration for DynamicPkv.SingleMergeResult.I
function DynamicPkv.SingleMergeResult.I(this: DatatypeType) : DatatypeType;

function DynamicPkv.SingleMergeResult.I#canCall(this: DatatypeType) : bool;

function Tclass.BucketModel.singleMergeResult() : Ty;

// Tclass.BucketModel.singleMergeResult Tag
axiom Tag(Tclass.BucketModel.singleMergeResult())
   == Tagclass.BucketModel.singleMergeResult;

const unique Tagclass.BucketModel.singleMergeResult: TyTag;

// Box/unbox axiom for Tclass.BucketModel.singleMergeResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketModel.singleMergeResult()) } 
  $IsBox(bx, Tclass.BucketModel.singleMergeResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BucketModel.singleMergeResult()));

// consequence axiom for DynamicPkv.SingleMergeResult.I
axiom 24 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.SingleMergeResult.I(this), $IsGoodHeap($Heap) } 
    DynamicPkv.SingleMergeResult.I#canCall(this)
         || (24 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.SingleMergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap)
           && Lit(DynamicPkv.SingleMergeResult.WF(this)))
       ==> $Is(DynamicPkv.SingleMergeResult.I(this), Tclass.BucketModel.singleMergeResult()));

function DynamicPkv.SingleMergeResult.I#requires(DatatypeType) : bool;

// #requires axiom for DynamicPkv.SingleMergeResult.I
axiom (forall $Heap: Heap, this: DatatypeType :: 
  { DynamicPkv.SingleMergeResult.I#requires(this), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.DynamicPkv.SingleMergeResult())
       && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap)
     ==> DynamicPkv.SingleMergeResult.I#requires(this)
       == Lit(DynamicPkv.SingleMergeResult.WF(this)));

// definition axiom for DynamicPkv.SingleMergeResult.I(revealed)
axiom 24 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.SingleMergeResult.I(this), $IsGoodHeap($Heap) } 
    DynamicPkv.SingleMergeResult.I#canCall(this)
         || (24 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.SingleMergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap)
           && Lit(DynamicPkv.SingleMergeResult.WF(this)))
       ==> (DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
           ==> (DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(this))
             && 
            (DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(this))
             && (var bot#0 := DynamicPkv.SingleMergeResult.bot(this); 
              PackedKV.Pkv.Pkv_q(bot#0)
                 && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
                 && 
                PackedKV.Pkv.Pkv_q(bot#0)
                 && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))))
         && (!DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
           ==> (DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(this))
             && 
            (DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(this))
             && (var bot#1 := DynamicPkv.SingleMergeResult.bot(this); 
              PackedKV.Pkv.Pkv_q(bot#1)
                 && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#1))
                 && 
                PackedKV.Pkv.Pkv_q(bot#1)
                 && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#1))))
         && DynamicPkv.SingleMergeResult.I(this)
           == (if DynamicPkv.SingleMergeResult.MergeCompleted_q(this)
             then (var slack#2 := DynamicPkv.SingleMergeResult.slack(this); 
              (var bot#2 := DynamicPkv.SingleMergeResult.bot(this); 
                #BucketModel.singleMergeResult.MergeCompleted(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#2)), 
                  PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#2)), 
                  slack#2)))
             else (var slack#3 := DynamicPkv.SingleMergeResult.slack(this); 
              (var end#1 := DynamicPkv.SingleMergeResult.end(this); 
                (var bot#3 := DynamicPkv.SingleMergeResult.bot(this); 
                  #BucketModel.singleMergeResult.SlackExhausted(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#3)), 
                    PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#3)), 
                    end#1, 
                    slack#3))))));

// definition axiom for DynamicPkv.SingleMergeResult.I for all literals(revealed)
axiom 24 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    {:weight 3} { DynamicPkv.SingleMergeResult.I(Lit(this)), $IsGoodHeap($Heap) } 
    DynamicPkv.SingleMergeResult.I#canCall(Lit(this))
         || (24 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.SingleMergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap)
           && Lit(DynamicPkv.SingleMergeResult.WF(Lit(this))))
       ==> (Lit(DynamicPkv.SingleMergeResult.MergeCompleted_q(Lit(this)))
           ==> (DynamicPkv.SingleMergeResult.MergeCompleted_q(Lit(this))
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(Lit(this)))
             && 
            (DynamicPkv.SingleMergeResult.MergeCompleted_q(Lit(this))
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(Lit(this)))
             && (var bot#4 := Lit(DynamicPkv.SingleMergeResult.bot(Lit(this))); 
              PackedKV.Pkv.Pkv_q(bot#4)
                 && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#4))
                 && 
                PackedKV.Pkv.Pkv_q(bot#4)
                 && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#4))))
         && (!Lit(DynamicPkv.SingleMergeResult.MergeCompleted_q(Lit(this)))
           ==> (DynamicPkv.SingleMergeResult.MergeCompleted_q(Lit(this))
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(Lit(this)))
             && 
            (DynamicPkv.SingleMergeResult.MergeCompleted_q(Lit(this))
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(Lit(this)))
             && (var bot#5 := Lit(DynamicPkv.SingleMergeResult.bot(Lit(this))); 
              PackedKV.Pkv.Pkv_q(bot#5)
                 && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#5))
                 && 
                PackedKV.Pkv.Pkv_q(bot#5)
                 && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#5))))
         && DynamicPkv.SingleMergeResult.I(Lit(this))
           == (if DynamicPkv.SingleMergeResult.MergeCompleted_q(Lit(this))
             then (var slack#6 := LitInt(DynamicPkv.SingleMergeResult.slack(Lit(this))); 
              (var bot#6 := Lit(DynamicPkv.SingleMergeResult.bot(Lit(this))); 
                Lit(#BucketModel.singleMergeResult.MergeCompleted(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(bot#6)))), 
                    Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(bot#6)))), 
                    slack#6))))
             else (var slack#7 := LitInt(DynamicPkv.SingleMergeResult.slack(Lit(this))); 
              (var end#3 := LitInt(DynamicPkv.SingleMergeResult.end(Lit(this))); 
                (var bot#7 := Lit(DynamicPkv.SingleMergeResult.bot(Lit(this))); 
                  Lit(#BucketModel.singleMergeResult.SlackExhausted(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(bot#7)))), 
                      Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(bot#7)))), 
                      end#3, 
                      slack#7)))))));

procedure CheckWellformed$$DynamicPkv.SingleMergeResult.I(this: DatatypeType
       where $Is(this, Tclass.DynamicPkv.SingleMergeResult())
         && $IsAlloc(this, Tclass.DynamicPkv.SingleMergeResult(), $Heap));
  free requires 24 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.SingleMergeResult.I(this: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var _mcc#2#0: DatatypeType;
  var _mcc#3#0: int;
  var _mcc#4#0: int;
  var slack#8: int;
  var let#0#0#0: int;
  var end#4: int;
  var let#1#0#0: int;
  var bot#8: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var _mcc#0#0: DatatypeType;
  var _mcc#1#0: int;
  var slack#9: int;
  var let#3#0#0: int;
  var bot#9: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var newtype$check#2: int;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;

    // AddWellformednessCheck for function I
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(827,13): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume DynamicPkv.SingleMergeResult.WF#canCall(this);
    assume DynamicPkv.SingleMergeResult.WF(this);
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(DynamicPkv.SingleMergeResult.I(this), Tclass.BucketModel.singleMergeResult());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        if (this == #DynamicPkv.SingleMergeResult.MergeCompleted(_mcc#0#0, _mcc#1#0))
        {
            assume $Is(_mcc#0#0, Tclass.PackedKV.Pkv());
            assume LitInt(0) <= _mcc#1#0 && _mcc#1#0 < 18446744073709551616;
            havoc slack#9;
            assume LitInt(0) <= slack#9 && slack#9 < 18446744073709551616;
            assume let#3#0#0 == _mcc#1#0;
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(let#3#0#0, Tclass.NativeTypes.uint64());
            assume slack#9 == let#3#0#0;
            havoc bot#9;
            assume $Is(bot#9, Tclass.PackedKV.Pkv());
            assume let#4#0#0 == _mcc#0#0;
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(let#4#0#0, Tclass.PackedKV.Pkv());
            assume bot#9 == let#4#0#0;
            assume PackedKV.Pkv.Pkv_q(bot#9);
            ##psa#2 := PackedKV.Pkv.keys(bot#9);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#2));
            assume PackedStringArray.__default.WF(##psa#2);
            b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#9));
            assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#9)), 
              TSeq(Tclass.KeyType.Key()));
            assume PackedKV.Pkv.Pkv_q(bot#9);
            ##psa#3 := PackedKV.Pkv.messages(bot#9);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#3));
            assume PackedStringArray.__default.WF(##psa#3);
            b$reqreads#4 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#9));
            newtype$check#2 := slack#9;
            assert LitInt(0) <= newtype$check#2;
            assume DynamicPkv.SingleMergeResult.I(this)
               == #BucketModel.singleMergeResult.MergeCompleted(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#9)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#9)), 
                slack#9);
            assume PackedKV.Pkv.Pkv_q(bot#9)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#9))
               && 
              PackedKV.Pkv.Pkv_q(bot#9)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#9));
            // CheckWellformedWithResult: any expression
            assume $Is(DynamicPkv.SingleMergeResult.I(this), Tclass.BucketModel.singleMergeResult());
        }
        else if (this
           == #DynamicPkv.SingleMergeResult.SlackExhausted(_mcc#2#0, _mcc#3#0, _mcc#4#0))
        {
            assume $Is(_mcc#2#0, Tclass.PackedKV.Pkv());
            assume LitInt(0) <= _mcc#3#0 && _mcc#3#0 < 18446744073709551616;
            assume LitInt(0) <= _mcc#4#0 && _mcc#4#0 < 18446744073709551616;
            havoc slack#8;
            assume LitInt(0) <= slack#8 && slack#8 < 18446744073709551616;
            assume let#0#0#0 == _mcc#4#0;
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(let#0#0#0, Tclass.NativeTypes.uint64());
            assume slack#8 == let#0#0#0;
            havoc end#4;
            assume LitInt(0) <= end#4 && end#4 < 18446744073709551616;
            assume let#1#0#0 == _mcc#3#0;
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(let#1#0#0, Tclass.NativeTypes.uint64());
            assume end#4 == let#1#0#0;
            havoc bot#8;
            assume $Is(bot#8, Tclass.PackedKV.Pkv());
            assume let#2#0#0 == _mcc#2#0;
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(let#2#0#0, Tclass.PackedKV.Pkv());
            assume bot#8 == let#2#0#0;
            assume PackedKV.Pkv.Pkv_q(bot#8);
            ##psa#0 := PackedKV.Pkv.keys(bot#8);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
               ==> PackedStringArray.__default.WF(##psa#0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
               ==> PackedStringArray.__default.WF(##psa#0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
               ==> PackedStringArray.__default.WF(##psa#0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
               ==> PackedStringArray.__default.WF(##psa#0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
               ==> PackedStringArray.__default.WF(##psa#0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0));
            assume PackedStringArray.__default.WF(##psa#0);
            b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#8));
            assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#8)), 
              TSeq(Tclass.KeyType.Key()));
            assume PackedKV.Pkv.Pkv_q(bot#8);
            ##psa#1 := PackedKV.Pkv.messages(bot#8);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#1));
            assume PackedStringArray.__default.WF(##psa#1);
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#8));
            newtype$check#0 := end#4;
            assert LitInt(0) <= newtype$check#0;
            newtype$check#1 := slack#8;
            assert LitInt(0) <= newtype$check#1;
            assume DynamicPkv.SingleMergeResult.I(this)
               == #BucketModel.singleMergeResult.SlackExhausted(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#8)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#8)), 
                end#4, 
                slack#8);
            assume PackedKV.Pkv.Pkv_q(bot#8)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#8))
               && 
              PackedKV.Pkv.Pkv_q(bot#8)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#8));
            // CheckWellformedWithResult: any expression
            assume $Is(DynamicPkv.SingleMergeResult.I(this), Tclass.BucketModel.singleMergeResult());
        }
        else
        {
            assume false;
        }

        assert b$reqreads#1;
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
    }
}



// Constructor function declaration
function #DynamicPkv.MergeResult.MergeResult(DatatypeType, Seq Box, int) : DatatypeType;

const unique ##DynamicPkv.MergeResult.MergeResult: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: Seq Box, a#0#2#0: int :: 
  { #DynamicPkv.MergeResult.MergeResult(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#DynamicPkv.MergeResult.MergeResult(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##DynamicPkv.MergeResult.MergeResult);

function DynamicPkv.MergeResult.MergeResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { DynamicPkv.MergeResult.MergeResult_q(d) } 
  DynamicPkv.MergeResult.MergeResult_q(d)
     <==> DatatypeCtorId(d) == ##DynamicPkv.MergeResult.MergeResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { DynamicPkv.MergeResult.MergeResult_q(d) } 
  DynamicPkv.MergeResult.MergeResult_q(d)
     ==> (exists a#1#0#0: DatatypeType, a#1#1#0: Seq Box, a#1#2#0: int :: 
      d == #DynamicPkv.MergeResult.MergeResult(a#1#0#0, a#1#1#0, a#1#2#0)));

function Tclass.DynamicPkv.MergeResult() : Ty;

// Tclass.DynamicPkv.MergeResult Tag
axiom Tag(Tclass.DynamicPkv.MergeResult()) == Tagclass.DynamicPkv.MergeResult;

const unique Tagclass.DynamicPkv.MergeResult: TyTag;

// Box/unbox axiom for Tclass.DynamicPkv.MergeResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DynamicPkv.MergeResult()) } 
  $IsBox(bx, Tclass.DynamicPkv.MergeResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.DynamicPkv.MergeResult()));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType, a#2#1#0: Seq Box, a#2#2#0: int :: 
  { $Is(#DynamicPkv.MergeResult.MergeResult(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.DynamicPkv.MergeResult()) } 
  $Is(#DynamicPkv.MergeResult.MergeResult(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.DynamicPkv.MergeResult())
     <==> $Is(a#2#0#0, Tclass.PackedKV.Pkv())
       && $Is(a#2#1#0, TSeq(Tclass.PackedKV.Pkv()))
       && $Is(a#2#2#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Seq Box, a#3#2#0: int, $h: Heap :: 
  { $IsAlloc(#DynamicPkv.MergeResult.MergeResult(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.DynamicPkv.MergeResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#DynamicPkv.MergeResult.MergeResult(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.DynamicPkv.MergeResult(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.PackedKV.Pkv(), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.PackedKV.Pkv()), $h)
         && $IsAlloc(a#3#2#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.MergeResult.top(d), Tclass.PackedKV.Pkv(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.MergeResult.MergeResult_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.MergeResult(), $h)
     ==> $IsAlloc(DynamicPkv.MergeResult.top(d), Tclass.PackedKV.Pkv(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.MergeResult.bots(d), TSeq(Tclass.PackedKV.Pkv()), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.MergeResult.MergeResult_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.MergeResult(), $h)
     ==> $IsAlloc(DynamicPkv.MergeResult.bots(d), TSeq(Tclass.PackedKV.Pkv()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.MergeResult.slack(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.MergeResult.MergeResult_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.MergeResult(), $h)
     ==> $IsAlloc(DynamicPkv.MergeResult.slack(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Seq Box, a#4#2#0: int :: 
  { #DynamicPkv.MergeResult.MergeResult(Lit(a#4#0#0), Lit(a#4#1#0), LitInt(a#4#2#0)) } 
  #DynamicPkv.MergeResult.MergeResult(Lit(a#4#0#0), Lit(a#4#1#0), LitInt(a#4#2#0))
     == Lit(#DynamicPkv.MergeResult.MergeResult(a#4#0#0, a#4#1#0, a#4#2#0)));

function DynamicPkv.MergeResult.top(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Seq Box, a#5#2#0: int :: 
  { #DynamicPkv.MergeResult.MergeResult(a#5#0#0, a#5#1#0, a#5#2#0) } 
  DynamicPkv.MergeResult.top(#DynamicPkv.MergeResult.MergeResult(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Seq Box, a#6#2#0: int :: 
  { #DynamicPkv.MergeResult.MergeResult(a#6#0#0, a#6#1#0, a#6#2#0) } 
  DtRank(a#6#0#0)
     < DtRank(#DynamicPkv.MergeResult.MergeResult(a#6#0#0, a#6#1#0, a#6#2#0)));

function DynamicPkv.MergeResult.bots(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Seq Box, a#7#2#0: int :: 
  { #DynamicPkv.MergeResult.MergeResult(a#7#0#0, a#7#1#0, a#7#2#0) } 
  DynamicPkv.MergeResult.bots(#DynamicPkv.MergeResult.MergeResult(a#7#0#0, a#7#1#0, a#7#2#0))
     == a#7#1#0);

// Inductive seq element rank
axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Seq Box, a#8#2#0: int, i: int :: 
  { Seq#Index(a#8#1#0, i), #DynamicPkv.MergeResult.MergeResult(a#8#0#0, a#8#1#0, a#8#2#0) } 
  0 <= i && i < Seq#Length(a#8#1#0)
     ==> DtRank($Unbox(Seq#Index(a#8#1#0, i)): DatatypeType)
       < DtRank(#DynamicPkv.MergeResult.MergeResult(a#8#0#0, a#8#1#0, a#8#2#0)));

// Inductive seq rank
axiom (forall a#9#0#0: DatatypeType, a#9#1#0: Seq Box, a#9#2#0: int :: 
  { #DynamicPkv.MergeResult.MergeResult(a#9#0#0, a#9#1#0, a#9#2#0) } 
  Seq#Rank(a#9#1#0)
     < DtRank(#DynamicPkv.MergeResult.MergeResult(a#9#0#0, a#9#1#0, a#9#2#0)));

function DynamicPkv.MergeResult.slack(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#10#0#0: DatatypeType, a#10#1#0: Seq Box, a#10#2#0: int :: 
  { #DynamicPkv.MergeResult.MergeResult(a#10#0#0, a#10#1#0, a#10#2#0) } 
  DynamicPkv.MergeResult.slack(#DynamicPkv.MergeResult.MergeResult(a#10#0#0, a#10#1#0, a#10#2#0))
     == a#10#2#0);

// Depth-one case-split function
function $IsA#DynamicPkv.MergeResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#DynamicPkv.MergeResult(d) } 
  $IsA#DynamicPkv.MergeResult(d) ==> DynamicPkv.MergeResult.MergeResult_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { DynamicPkv.MergeResult.MergeResult_q(d), $Is(d, Tclass.DynamicPkv.MergeResult()) } 
  $Is(d, Tclass.DynamicPkv.MergeResult())
     ==> DynamicPkv.MergeResult.MergeResult_q(d));

// Datatype extensional equality declaration
function DynamicPkv.MergeResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #DynamicPkv.MergeResult.MergeResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.MergeResult#Equal(a, b) } 
  true
     ==> (DynamicPkv.MergeResult#Equal(a, b)
       <==> PackedKV.Pkv#Equal(DynamicPkv.MergeResult.top(a), DynamicPkv.MergeResult.top(b))
         && Seq#Equal(DynamicPkv.MergeResult.bots(a), DynamicPkv.MergeResult.bots(b))
         && DynamicPkv.MergeResult.slack(a) == DynamicPkv.MergeResult.slack(b)));

// Datatype extensionality axiom: DynamicPkv.MergeResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.MergeResult#Equal(a, b) } 
  DynamicPkv.MergeResult#Equal(a, b) <==> a == b);

const unique class.DynamicPkv.MergeResult: ClassName;

// function declaration for DynamicPkv.MergeResult.WF
function DynamicPkv.MergeResult.WF(this: DatatypeType) : bool;

function DynamicPkv.MergeResult.WF#canCall(this: DatatypeType) : bool;

// consequence axiom for DynamicPkv.MergeResult.WF
axiom 27 <= $FunctionContextHeight
   ==> (forall this: DatatypeType :: 
    { DynamicPkv.MergeResult.WF(this) } 
    DynamicPkv.MergeResult.WF#canCall(this)
         || (27 != $FunctionContextHeight && $Is(this, Tclass.DynamicPkv.MergeResult()))
       ==> true);

function DynamicPkv.MergeResult.WF#requires(DatatypeType) : bool;

// #requires axiom for DynamicPkv.MergeResult.WF
axiom (forall $Heap: Heap, this: DatatypeType :: 
  { DynamicPkv.MergeResult.WF#requires(this), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.DynamicPkv.MergeResult())
       && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap)
     ==> DynamicPkv.MergeResult.WF#requires(this) == true);

// definition axiom for DynamicPkv.MergeResult.WF(revealed)
axiom 27 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.MergeResult.WF(this), $IsGoodHeap($Heap) } 
    DynamicPkv.MergeResult.WF#canCall(this)
         || (27 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.MergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap))
       ==> DynamicPkv.MergeResult.MergeResult_q(this)
         && PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(this))
         && (PackedKV.__default.WF(DynamicPkv.MergeResult.top(this))
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#0)): DatatypeType } 
            (LitInt(0) <= i#0 ==> DynamicPkv.MergeResult.MergeResult_q(this))
               && (LitInt(0) <= i#0 && i#0 < Seq#Length(DynamicPkv.MergeResult.bots(this))
                 ==> DynamicPkv.MergeResult.MergeResult_q(this)
                   && PackedKV.__default.WF#canCall($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#0)): DatatypeType))))
         && DynamicPkv.MergeResult.WF(this)
           == (PackedKV.__default.WF(DynamicPkv.MergeResult.top(this))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(DynamicPkv.MergeResult.bots(this))
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#0)): DatatypeType))));

// definition axiom for DynamicPkv.MergeResult.WF for all literals(revealed)
axiom 27 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    {:weight 3} { DynamicPkv.MergeResult.WF(Lit(this)), $IsGoodHeap($Heap) } 
    DynamicPkv.MergeResult.WF#canCall(Lit(this))
         || (27 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.MergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap))
       ==> DynamicPkv.MergeResult.MergeResult_q(Lit(this))
         && PackedKV.__default.WF#canCall(Lit(DynamicPkv.MergeResult.top(Lit(this))))
         && (Lit(PackedKV.__default.WF(Lit(DynamicPkv.MergeResult.top(Lit(this)))))
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#1)): DatatypeType } 
            (LitInt(0) <= i#1 ==> DynamicPkv.MergeResult.MergeResult_q(Lit(this)))
               && (LitInt(0) <= i#1
                   && i#1 < Seq#Length(Lit(DynamicPkv.MergeResult.bots(Lit(this))))
                 ==> DynamicPkv.MergeResult.MergeResult_q(Lit(this))
                   && PackedKV.__default.WF#canCall($Unbox(Seq#Index(Lit(DynamicPkv.MergeResult.bots(Lit(this))), i#1)): DatatypeType))))
         && DynamicPkv.MergeResult.WF(Lit(this))
           == (PackedKV.__default.WF(Lit(DynamicPkv.MergeResult.top(Lit(this))))
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#1)): DatatypeType } 
              LitInt(0) <= i#1
                   && i#1 < Seq#Length(Lit(DynamicPkv.MergeResult.bots(Lit(this))))
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(Lit(DynamicPkv.MergeResult.bots(Lit(this))), i#1)): DatatypeType))));

procedure CheckWellformed$$DynamicPkv.MergeResult.WF(this: DatatypeType
       where $Is(this, Tclass.DynamicPkv.MergeResult())
         && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap));
  free requires 27 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.MergeResult.WF(this: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var i#2: int;
  var ##pkv#1: DatatypeType;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function WF
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1030,14): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume DynamicPkv.MergeResult.MergeResult_q(this);
        ##pkv#0 := DynamicPkv.MergeResult.top(this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
        b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(this));
        if (PackedKV.__default.WF(DynamicPkv.MergeResult.top(this)))
        {
            havoc i#2;
            // Begin Comprehension WF check
            if (LitInt(0) <= i#2)
            {
                assume DynamicPkv.MergeResult.MergeResult_q(this);
            }

            if (LitInt(0) <= i#2 && i#2 < Seq#Length(DynamicPkv.MergeResult.bots(this)))
            {
                assume DynamicPkv.MergeResult.MergeResult_q(this);
                assert 0 <= i#2 && i#2 < Seq#Length(DynamicPkv.MergeResult.bots(this));
                ##pkv#1 := $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#2)): DatatypeType;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
                b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#2)): DatatypeType);
            }

            // End Comprehension WF check
        }

        assume DynamicPkv.MergeResult.WF(this)
           == (PackedKV.__default.WF(DynamicPkv.MergeResult.top(this))
             && (forall i#3: int :: 
              { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(DynamicPkv.MergeResult.bots(this))
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#3)): DatatypeType)));
        assume DynamicPkv.MergeResult.MergeResult_q(this)
           && PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(this))
           && (PackedKV.__default.WF(DynamicPkv.MergeResult.top(this))
             ==> (forall i#3: int :: 
              { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#3)): DatatypeType } 
              (LitInt(0) <= i#3 ==> DynamicPkv.MergeResult.MergeResult_q(this))
                 && (LitInt(0) <= i#3 && i#3 < Seq#Length(DynamicPkv.MergeResult.bots(this))
                   ==> DynamicPkv.MergeResult.MergeResult_q(this)
                     && PackedKV.__default.WF#canCall($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(this), i#3)): DatatypeType))));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.MergeResult.WF(this), TBool);
        assert b$reqreads#0;
        assert b$reqreads#1;
    }
}



// function declaration for DynamicPkv.MergeResult.I
function DynamicPkv.MergeResult.I(this: DatatypeType) : DatatypeType;

function DynamicPkv.MergeResult.I#canCall(this: DatatypeType) : bool;

function Tclass.BucketModel.mergeResult() : Ty;

// Tclass.BucketModel.mergeResult Tag
axiom Tag(Tclass.BucketModel.mergeResult()) == Tagclass.BucketModel.mergeResult;

const unique Tagclass.BucketModel.mergeResult: TyTag;

// Box/unbox axiom for Tclass.BucketModel.mergeResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketModel.mergeResult()) } 
  $IsBox(bx, Tclass.BucketModel.mergeResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BucketModel.mergeResult()));

// consequence axiom for DynamicPkv.MergeResult.I
axiom 30 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.MergeResult.I(this), $IsGoodHeap($Heap) } 
    DynamicPkv.MergeResult.I#canCall(this)
         || (30 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.MergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap)
           && Lit(DynamicPkv.MergeResult.WF(this)))
       ==> $Is(DynamicPkv.MergeResult.I(this), Tclass.BucketModel.mergeResult()));

function DynamicPkv.MergeResult.I#requires(DatatypeType) : bool;

// #requires axiom for DynamicPkv.MergeResult.I
axiom (forall $Heap: Heap, this: DatatypeType :: 
  { DynamicPkv.MergeResult.I#requires(this), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.DynamicPkv.MergeResult())
       && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap)
     ==> DynamicPkv.MergeResult.I#requires(this) == Lit(DynamicPkv.MergeResult.WF(this)));

// definition axiom for DynamicPkv.MergeResult.I(revealed)
axiom 30 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.MergeResult.I(this), $IsGoodHeap($Heap) } 
    DynamicPkv.MergeResult.I#canCall(this)
         || (30 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.MergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap)
           && Lit(DynamicPkv.MergeResult.WF(this)))
       ==> DynamicPkv.MergeResult.MergeResult_q(this)
         && PackedKV.__default.I#canCall(DynamicPkv.MergeResult.top(this))
         && 
        DynamicPkv.MergeResult.MergeResult_q(this)
         && DynamicPkv.__default.PKVISeq#canCall(DynamicPkv.MergeResult.bots(this))
         && DynamicPkv.MergeResult.MergeResult_q(this)
         && DynamicPkv.MergeResult.I(this)
           == #BucketModel.mergeResult.mergeResult(PackedKV.__default.I(DynamicPkv.MergeResult.top(this)), 
            DynamicPkv.__default.PKVISeq($LS($LZ), DynamicPkv.MergeResult.bots(this)), 
            DynamicPkv.MergeResult.slack(this)));

// definition axiom for DynamicPkv.MergeResult.I for all literals(revealed)
axiom 30 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    {:weight 3} { DynamicPkv.MergeResult.I(Lit(this)), $IsGoodHeap($Heap) } 
    DynamicPkv.MergeResult.I#canCall(Lit(this))
         || (30 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.MergeResult())
           && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap)
           && Lit(DynamicPkv.MergeResult.WF(Lit(this))))
       ==> DynamicPkv.MergeResult.MergeResult_q(Lit(this))
         && PackedKV.__default.I#canCall(Lit(DynamicPkv.MergeResult.top(Lit(this))))
         && 
        DynamicPkv.MergeResult.MergeResult_q(Lit(this))
         && DynamicPkv.__default.PKVISeq#canCall(Lit(DynamicPkv.MergeResult.bots(Lit(this))))
         && DynamicPkv.MergeResult.MergeResult_q(Lit(this))
         && DynamicPkv.MergeResult.I(Lit(this))
           == Lit(#BucketModel.mergeResult.mergeResult(Lit(PackedKV.__default.I(Lit(DynamicPkv.MergeResult.top(Lit(this))))), 
              Lit(DynamicPkv.__default.PKVISeq($LS($LZ), Lit(DynamicPkv.MergeResult.bots(Lit(this))))), 
              LitInt(DynamicPkv.MergeResult.slack(Lit(this))))));

procedure CheckWellformed$$DynamicPkv.MergeResult.I(this: DatatypeType
       where $Is(this, Tclass.DynamicPkv.MergeResult())
         && $IsAlloc(this, Tclass.DynamicPkv.MergeResult(), $Heap));
  free requires 30 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.MergeResult.I(this: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var ##pkv#0: DatatypeType;
  var ##s#0: Seq Box;
  var newtype$check#0: int;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;

    // AddWellformednessCheck for function I
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1036,13): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume DynamicPkv.MergeResult.WF#canCall(this);
    assume DynamicPkv.MergeResult.WF(this);
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(DynamicPkv.MergeResult.I(this), Tclass.BucketModel.mergeResult());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume DynamicPkv.MergeResult.MergeResult_q(this);
        ##pkv#0 := DynamicPkv.MergeResult.top(this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), i#0)): Seq Box } 
                      LitInt(0) <= i#0
                           && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), i#0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)), i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)), i#1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#0);
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedKV.__default.I#canCall(DynamicPkv.MergeResult.top(this));
        assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(DynamicPkv.MergeResult.top(this)));
        assume DynamicPkv.MergeResult.MergeResult_q(this);
        ##s#0 := DynamicPkv.MergeResult.bots(this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
        assert {:subsumption 0} (forall i#2: int :: 
          { $Unbox(Seq#Index(##s#0, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(##s#0)
             ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#2)): DatatypeType));
        assume (forall i#2: int :: 
          { $Unbox(Seq#Index(##s#0, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(##s#0)
             ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#2)): DatatypeType));
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume DynamicPkv.__default.PKVISeq#canCall(DynamicPkv.MergeResult.bots(this));
        assume DynamicPkv.MergeResult.MergeResult_q(this);
        newtype$check#0 := DynamicPkv.MergeResult.slack(this);
        assert LitInt(0) <= newtype$check#0;
        assume DynamicPkv.MergeResult.I(this)
           == #BucketModel.mergeResult.mergeResult(PackedKV.__default.I(DynamicPkv.MergeResult.top(this)), 
            DynamicPkv.__default.PKVISeq($LS($LZ), DynamicPkv.MergeResult.bots(this)), 
            DynamicPkv.MergeResult.slack(this));
        assume DynamicPkv.MergeResult.MergeResult_q(this)
           && PackedKV.__default.I#canCall(DynamicPkv.MergeResult.top(this))
           && 
          DynamicPkv.MergeResult.MergeResult_q(this)
           && DynamicPkv.__default.PKVISeq#canCall(DynamicPkv.MergeResult.bots(this))
           && DynamicPkv.MergeResult.MergeResult_q(this);
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.MergeResult.I(this), Tclass.BucketModel.mergeResult());
        assert b$reqreads#1;
        assert b$reqreads#2;
    }
}



// Constructor function declaration
function #DynamicPkv.PartialFlushResult.PartialFlushResult(DatatypeType, Seq Box) : DatatypeType;

const unique ##DynamicPkv.PartialFlushResult.PartialFlushResult: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: Seq Box :: 
  { #DynamicPkv.PartialFlushResult.PartialFlushResult(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#0#0#0, a#0#1#0))
     == ##DynamicPkv.PartialFlushResult.PartialFlushResult);

function DynamicPkv.PartialFlushResult.PartialFlushResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { DynamicPkv.PartialFlushResult.PartialFlushResult_q(d) } 
  DynamicPkv.PartialFlushResult.PartialFlushResult_q(d)
     <==> DatatypeCtorId(d) == ##DynamicPkv.PartialFlushResult.PartialFlushResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { DynamicPkv.PartialFlushResult.PartialFlushResult_q(d) } 
  DynamicPkv.PartialFlushResult.PartialFlushResult_q(d)
     ==> (exists a#1#0#0: DatatypeType, a#1#1#0: Seq Box :: 
      d == #DynamicPkv.PartialFlushResult.PartialFlushResult(a#1#0#0, a#1#1#0)));

function Tclass.DynamicPkv.PartialFlushResult() : Ty;

// Tclass.DynamicPkv.PartialFlushResult Tag
axiom Tag(Tclass.DynamicPkv.PartialFlushResult())
   == Tagclass.DynamicPkv.PartialFlushResult;

const unique Tagclass.DynamicPkv.PartialFlushResult: TyTag;

// Box/unbox axiom for Tclass.DynamicPkv.PartialFlushResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DynamicPkv.PartialFlushResult()) } 
  $IsBox(bx, Tclass.DynamicPkv.PartialFlushResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.DynamicPkv.PartialFlushResult()));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType, a#2#1#0: Seq Box :: 
  { $Is(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#2#0#0, a#2#1#0), 
      Tclass.DynamicPkv.PartialFlushResult()) } 
  $Is(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#2#0#0, a#2#1#0), 
      Tclass.DynamicPkv.PartialFlushResult())
     <==> $Is(a#2#0#0, Tclass.PackedKV.Pkv()) && $Is(a#2#1#0, TSeq(Tclass.PackedKV.Pkv())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#3#0#0, a#3#1#0), 
      Tclass.DynamicPkv.PartialFlushResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#3#0#0, a#3#1#0), 
        Tclass.DynamicPkv.PartialFlushResult(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.PackedKV.Pkv(), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.PackedKV.Pkv()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.PartialFlushResult.top(d), Tclass.PackedKV.Pkv(), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.PartialFlushResult.PartialFlushResult_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.PartialFlushResult(), $h)
     ==> $IsAlloc(DynamicPkv.PartialFlushResult.top(d), Tclass.PackedKV.Pkv(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DynamicPkv.PartialFlushResult.bots(d), TSeq(Tclass.PackedKV.Pkv()), $h) } 
  $IsGoodHeap($h)
       && 
      DynamicPkv.PartialFlushResult.PartialFlushResult_q(d)
       && $IsAlloc(d, Tclass.DynamicPkv.PartialFlushResult(), $h)
     ==> $IsAlloc(DynamicPkv.PartialFlushResult.bots(d), TSeq(Tclass.PackedKV.Pkv()), $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Seq Box :: 
  { #DynamicPkv.PartialFlushResult.PartialFlushResult(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #DynamicPkv.PartialFlushResult.PartialFlushResult(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#4#0#0, a#4#1#0)));

function DynamicPkv.PartialFlushResult.top(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Seq Box :: 
  { #DynamicPkv.PartialFlushResult.PartialFlushResult(a#5#0#0, a#5#1#0) } 
  DynamicPkv.PartialFlushResult.top(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#5#0#0, a#5#1#0))
     == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Seq Box :: 
  { #DynamicPkv.PartialFlushResult.PartialFlushResult(a#6#0#0, a#6#1#0) } 
  DtRank(a#6#0#0)
     < DtRank(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#6#0#0, a#6#1#0)));

function DynamicPkv.PartialFlushResult.bots(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Seq Box :: 
  { #DynamicPkv.PartialFlushResult.PartialFlushResult(a#7#0#0, a#7#1#0) } 
  DynamicPkv.PartialFlushResult.bots(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#7#0#0, a#7#1#0))
     == a#7#1#0);

// Inductive seq element rank
axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Seq Box, i: int :: 
  { Seq#Index(a#8#1#0, i), #DynamicPkv.PartialFlushResult.PartialFlushResult(a#8#0#0, a#8#1#0) } 
  0 <= i && i < Seq#Length(a#8#1#0)
     ==> DtRank($Unbox(Seq#Index(a#8#1#0, i)): DatatypeType)
       < DtRank(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#8#0#0, a#8#1#0)));

// Inductive seq rank
axiom (forall a#9#0#0: DatatypeType, a#9#1#0: Seq Box :: 
  { #DynamicPkv.PartialFlushResult.PartialFlushResult(a#9#0#0, a#9#1#0) } 
  Seq#Rank(a#9#1#0)
     < DtRank(#DynamicPkv.PartialFlushResult.PartialFlushResult(a#9#0#0, a#9#1#0)));

// Depth-one case-split function
function $IsA#DynamicPkv.PartialFlushResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#DynamicPkv.PartialFlushResult(d) } 
  $IsA#DynamicPkv.PartialFlushResult(d)
     ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { DynamicPkv.PartialFlushResult.PartialFlushResult_q(d), $Is(d, Tclass.DynamicPkv.PartialFlushResult()) } 
  $Is(d, Tclass.DynamicPkv.PartialFlushResult())
     ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(d));

// Datatype extensional equality declaration
function DynamicPkv.PartialFlushResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #DynamicPkv.PartialFlushResult.PartialFlushResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.PartialFlushResult#Equal(a, b) } 
  true
     ==> (DynamicPkv.PartialFlushResult#Equal(a, b)
       <==> PackedKV.Pkv#Equal(DynamicPkv.PartialFlushResult.top(a), DynamicPkv.PartialFlushResult.top(b))
         && Seq#Equal(DynamicPkv.PartialFlushResult.bots(a), DynamicPkv.PartialFlushResult.bots(b))));

// Datatype extensionality axiom: DynamicPkv.PartialFlushResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DynamicPkv.PartialFlushResult#Equal(a, b) } 
  DynamicPkv.PartialFlushResult#Equal(a, b) <==> a == b);

const unique class.DynamicPkv.PartialFlushResult: ClassName;

// function declaration for DynamicPkv.PartialFlushResult.WF
function DynamicPkv.PartialFlushResult.WF(this: DatatypeType) : bool;

function DynamicPkv.PartialFlushResult.WF#canCall(this: DatatypeType) : bool;

// consequence axiom for DynamicPkv.PartialFlushResult.WF
axiom 33 <= $FunctionContextHeight
   ==> (forall this: DatatypeType :: 
    { DynamicPkv.PartialFlushResult.WF(this) } 
    DynamicPkv.PartialFlushResult.WF#canCall(this)
         || (33 != $FunctionContextHeight
           && $Is(this, Tclass.DynamicPkv.PartialFlushResult()))
       ==> true);

function DynamicPkv.PartialFlushResult.WF#requires(DatatypeType) : bool;

// #requires axiom for DynamicPkv.PartialFlushResult.WF
axiom (forall $Heap: Heap, this: DatatypeType :: 
  { DynamicPkv.PartialFlushResult.WF#requires(this), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.DynamicPkv.PartialFlushResult())
       && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap)
     ==> DynamicPkv.PartialFlushResult.WF#requires(this) == true);

// definition axiom for DynamicPkv.PartialFlushResult.WF(revealed)
axiom 33 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.PartialFlushResult.WF(this), $IsGoodHeap($Heap) } 
    DynamicPkv.PartialFlushResult.WF#canCall(this)
         || (33 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.PartialFlushResult())
           && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap))
       ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(this)
         && PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(this))
         && (PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(this))
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#0)): DatatypeType } 
            (LitInt(0) <= i#0 ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(this))
               && (LitInt(0) <= i#0 && i#0 < Seq#Length(DynamicPkv.PartialFlushResult.bots(this))
                 ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(this)
                   && PackedKV.__default.WF#canCall($Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#0)): DatatypeType))))
         && DynamicPkv.PartialFlushResult.WF(this)
           == (PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(this))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(DynamicPkv.PartialFlushResult.bots(this))
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#0)): DatatypeType))));

// definition axiom for DynamicPkv.PartialFlushResult.WF for all literals(revealed)
axiom 33 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    {:weight 3} { DynamicPkv.PartialFlushResult.WF(Lit(this)), $IsGoodHeap($Heap) } 
    DynamicPkv.PartialFlushResult.WF#canCall(Lit(this))
         || (33 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.PartialFlushResult())
           && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap))
       ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(Lit(this))
         && PackedKV.__default.WF#canCall(Lit(DynamicPkv.PartialFlushResult.top(Lit(this))))
         && (Lit(PackedKV.__default.WF(Lit(DynamicPkv.PartialFlushResult.top(Lit(this)))))
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#1)): DatatypeType } 
            (LitInt(0) <= i#1
                 ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(Lit(this)))
               && (LitInt(0) <= i#1
                   && i#1 < Seq#Length(Lit(DynamicPkv.PartialFlushResult.bots(Lit(this))))
                 ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(Lit(this))
                   && PackedKV.__default.WF#canCall($Unbox(Seq#Index(Lit(DynamicPkv.PartialFlushResult.bots(Lit(this))), i#1)): DatatypeType))))
         && DynamicPkv.PartialFlushResult.WF(Lit(this))
           == (PackedKV.__default.WF(Lit(DynamicPkv.PartialFlushResult.top(Lit(this))))
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#1)): DatatypeType } 
              LitInt(0) <= i#1
                   && i#1 < Seq#Length(Lit(DynamicPkv.PartialFlushResult.bots(Lit(this))))
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(Lit(DynamicPkv.PartialFlushResult.bots(Lit(this))), i#1)): DatatypeType))));

procedure CheckWellformed$$DynamicPkv.PartialFlushResult.WF(this: DatatypeType
       where $Is(this, Tclass.DynamicPkv.PartialFlushResult())
         && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap));
  free requires 33 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.PartialFlushResult.WF(this: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var i#2: int;
  var ##pkv#1: DatatypeType;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function WF
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1281,14): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume DynamicPkv.PartialFlushResult.PartialFlushResult_q(this);
        ##pkv#0 := DynamicPkv.PartialFlushResult.top(this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
        b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(this));
        if (PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(this)))
        {
            havoc i#2;
            // Begin Comprehension WF check
            if (LitInt(0) <= i#2)
            {
                assume DynamicPkv.PartialFlushResult.PartialFlushResult_q(this);
            }

            if (LitInt(0) <= i#2 && i#2 < Seq#Length(DynamicPkv.PartialFlushResult.bots(this)))
            {
                assume DynamicPkv.PartialFlushResult.PartialFlushResult_q(this);
                assert 0 <= i#2 && i#2 < Seq#Length(DynamicPkv.PartialFlushResult.bots(this));
                ##pkv#1 := $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#2)): DatatypeType;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
                b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#2)): DatatypeType);
            }

            // End Comprehension WF check
        }

        assume DynamicPkv.PartialFlushResult.WF(this)
           == (PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(this))
             && (forall i#3: int :: 
              { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(DynamicPkv.PartialFlushResult.bots(this))
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#3)): DatatypeType)));
        assume DynamicPkv.PartialFlushResult.PartialFlushResult_q(this)
           && PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(this))
           && (PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(this))
             ==> (forall i#3: int :: 
              { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#3)): DatatypeType } 
              (LitInt(0) <= i#3 ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(this))
                 && (LitInt(0) <= i#3 && i#3 < Seq#Length(DynamicPkv.PartialFlushResult.bots(this))
                   ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(this)
                     && PackedKV.__default.WF#canCall($Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(this), i#3)): DatatypeType))));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.PartialFlushResult.WF(this), TBool);
        assert b$reqreads#0;
        assert b$reqreads#1;
    }
}



// function declaration for DynamicPkv.PartialFlushResult.I
function DynamicPkv.PartialFlushResult.I(this: DatatypeType) : DatatypeType;

function DynamicPkv.PartialFlushResult.I#canCall(this: DatatypeType) : bool;

function Tclass.BucketModel.partialFlushResult() : Ty;

// Tclass.BucketModel.partialFlushResult Tag
axiom Tag(Tclass.BucketModel.partialFlushResult())
   == Tagclass.BucketModel.partialFlushResult;

const unique Tagclass.BucketModel.partialFlushResult: TyTag;

// Box/unbox axiom for Tclass.BucketModel.partialFlushResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketModel.partialFlushResult()) } 
  $IsBox(bx, Tclass.BucketModel.partialFlushResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BucketModel.partialFlushResult()));

// consequence axiom for DynamicPkv.PartialFlushResult.I
axiom 34 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.PartialFlushResult.I(this), $IsGoodHeap($Heap) } 
    DynamicPkv.PartialFlushResult.I#canCall(this)
         || (34 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.PartialFlushResult())
           && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap)
           && Lit(DynamicPkv.PartialFlushResult.WF(this)))
       ==> $Is(DynamicPkv.PartialFlushResult.I(this), Tclass.BucketModel.partialFlushResult()));

function DynamicPkv.PartialFlushResult.I#requires(DatatypeType) : bool;

// #requires axiom for DynamicPkv.PartialFlushResult.I
axiom (forall $Heap: Heap, this: DatatypeType :: 
  { DynamicPkv.PartialFlushResult.I#requires(this), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.DynamicPkv.PartialFlushResult())
       && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap)
     ==> DynamicPkv.PartialFlushResult.I#requires(this)
       == Lit(DynamicPkv.PartialFlushResult.WF(this)));

// definition axiom for DynamicPkv.PartialFlushResult.I(revealed)
axiom 34 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { DynamicPkv.PartialFlushResult.I(this), $IsGoodHeap($Heap) } 
    DynamicPkv.PartialFlushResult.I#canCall(this)
         || (34 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.PartialFlushResult())
           && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap)
           && Lit(DynamicPkv.PartialFlushResult.WF(this)))
       ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(this)
         && PackedKV.__default.I#canCall(DynamicPkv.PartialFlushResult.top(this))
         && 
        DynamicPkv.PartialFlushResult.PartialFlushResult_q(this)
         && DynamicPkv.__default.PKVISeq#canCall(DynamicPkv.PartialFlushResult.bots(this))
         && DynamicPkv.PartialFlushResult.I(this)
           == #BucketModel.partialFlushResult.partialFlushResult(PackedKV.__default.I(DynamicPkv.PartialFlushResult.top(this)), 
            DynamicPkv.__default.PKVISeq($LS($LZ), DynamicPkv.PartialFlushResult.bots(this))));

// definition axiom for DynamicPkv.PartialFlushResult.I for all literals(revealed)
axiom 34 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    {:weight 3} { DynamicPkv.PartialFlushResult.I(Lit(this)), $IsGoodHeap($Heap) } 
    DynamicPkv.PartialFlushResult.I#canCall(Lit(this))
         || (34 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.DynamicPkv.PartialFlushResult())
           && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap)
           && Lit(DynamicPkv.PartialFlushResult.WF(Lit(this))))
       ==> DynamicPkv.PartialFlushResult.PartialFlushResult_q(Lit(this))
         && PackedKV.__default.I#canCall(Lit(DynamicPkv.PartialFlushResult.top(Lit(this))))
         && 
        DynamicPkv.PartialFlushResult.PartialFlushResult_q(Lit(this))
         && DynamicPkv.__default.PKVISeq#canCall(Lit(DynamicPkv.PartialFlushResult.bots(Lit(this))))
         && DynamicPkv.PartialFlushResult.I(Lit(this))
           == Lit(#BucketModel.partialFlushResult.partialFlushResult(Lit(PackedKV.__default.I(Lit(DynamicPkv.PartialFlushResult.top(Lit(this))))), 
              Lit(DynamicPkv.__default.PKVISeq($LS($LZ), Lit(DynamicPkv.PartialFlushResult.bots(Lit(this))))))));

procedure CheckWellformed$$DynamicPkv.PartialFlushResult.I(this: DatatypeType
       where $Is(this, Tclass.DynamicPkv.PartialFlushResult())
         && $IsAlloc(this, Tclass.DynamicPkv.PartialFlushResult(), $Heap));
  free requires 34 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.PartialFlushResult.I(this: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var ##pkv#0: DatatypeType;
  var ##s#0: Seq Box;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;

    // AddWellformednessCheck for function I
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1287,13): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume DynamicPkv.PartialFlushResult.WF#canCall(this);
    assume DynamicPkv.PartialFlushResult.WF(this);
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(DynamicPkv.PartialFlushResult.I(this), Tclass.BucketModel.partialFlushResult());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume DynamicPkv.PartialFlushResult.PartialFlushResult_q(this);
        ##pkv#0 := DynamicPkv.PartialFlushResult.top(this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), i#0)): Seq Box } 
                      LitInt(0) <= i#0
                           && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0)), i#0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)), i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0)), i#1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0)
           ==> PackedKV.__default.WF(##pkv#0)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#0);
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedKV.__default.I#canCall(DynamicPkv.PartialFlushResult.top(this));
        assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(DynamicPkv.PartialFlushResult.top(this)));
        assume DynamicPkv.PartialFlushResult.PartialFlushResult_q(this);
        ##s#0 := DynamicPkv.PartialFlushResult.bots(this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
        assert {:subsumption 0} (forall i#2: int :: 
          { $Unbox(Seq#Index(##s#0, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(##s#0)
             ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#2)): DatatypeType));
        assume (forall i#2: int :: 
          { $Unbox(Seq#Index(##s#0, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(##s#0)
             ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#2)): DatatypeType));
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume DynamicPkv.__default.PKVISeq#canCall(DynamicPkv.PartialFlushResult.bots(this));
        assume DynamicPkv.PartialFlushResult.I(this)
           == #BucketModel.partialFlushResult.partialFlushResult(PackedKV.__default.I(DynamicPkv.PartialFlushResult.top(this)), 
            DynamicPkv.__default.PKVISeq($LS($LZ), DynamicPkv.PartialFlushResult.bots(this)));
        assume DynamicPkv.PartialFlushResult.PartialFlushResult_q(this)
           && PackedKV.__default.I#canCall(DynamicPkv.PartialFlushResult.top(this))
           && 
          DynamicPkv.PartialFlushResult.PartialFlushResult_q(this)
           && DynamicPkv.__default.PKVISeq#canCall(DynamicPkv.PartialFlushResult.bots(this));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.PartialFlushResult.I(this), Tclass.BucketModel.partialFlushResult());
        assert b$reqreads#1;
        assert b$reqreads#2;
    }
}



const unique class.DynamicPkv.__default: ClassName;

function Tclass.DynamicPkv.__default() : Ty;

// Tclass.DynamicPkv.__default Tag
axiom Tag(Tclass.DynamicPkv.__default()) == Tagclass.DynamicPkv.__default;

const unique Tagclass.DynamicPkv.__default: TyTag;

// Box/unbox axiom for Tclass.DynamicPkv.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DynamicPkv.__default()) } 
  $IsBox(bx, Tclass.DynamicPkv.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.DynamicPkv.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.DynamicPkv.__default()) } 
  $Is($o, Tclass.DynamicPkv.__default())
     <==> $o == null || dtype($o) == Tclass.DynamicPkv.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.DynamicPkv.__default(), $h) } 
  $IsAlloc($o, Tclass.DynamicPkv.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for DynamicPkv._default.EmptyCapacity
function DynamicPkv.__default.EmptyCapacity() : DatatypeType;

function DynamicPkv.__default.EmptyCapacity#canCall() : bool;

// consequence axiom for DynamicPkv.__default.EmptyCapacity
axiom 35 <= $FunctionContextHeight
   ==> 
  DynamicPkv.__default.EmptyCapacity#canCall() || 35 != $FunctionContextHeight
   ==> $Is(DynamicPkv.__default.EmptyCapacity(), Tclass.DynamicPkv.Capacity());

function DynamicPkv.__default.EmptyCapacity#requires() : bool;

// #requires axiom for DynamicPkv.__default.EmptyCapacity
axiom DynamicPkv.__default.EmptyCapacity#requires() == true;

// definition axiom for DynamicPkv.__default.EmptyCapacity(revealed)
axiom 35 <= $FunctionContextHeight
   ==> 
  DynamicPkv.__default.EmptyCapacity#canCall() || 35 != $FunctionContextHeight
   ==> DynamicPkv.__default.EmptyCapacity()
     == Lit(#DynamicPkv.Capacity.Capacity(LitInt(0), LitInt(0), LitInt(0)));

// definition axiom for DynamicPkv.__default.EmptyCapacity for all literals(revealed)
axiom 35 <= $FunctionContextHeight
   ==> 
  DynamicPkv.__default.EmptyCapacity#canCall() || 35 != $FunctionContextHeight
   ==> DynamicPkv.__default.EmptyCapacity()
     == Lit(#DynamicPkv.Capacity.Capacity(LitInt(0), LitInt(0), LitInt(0)));

procedure CheckWellformed$$DynamicPkv.__default.EmptyCapacity();
  free requires 35 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.EmptyCapacity()
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;


    // AddWellformednessCheck for function EmptyCapacity
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(498,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    if (*)
    {
        assume $Is(DynamicPkv.__default.EmptyCapacity(), Tclass.DynamicPkv.Capacity());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 4294967296;
        newtype$check#1 := LitInt(0);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 4294967296;
        newtype$check#2 := LitInt(0);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 4294967296;
        assume DynamicPkv.__default.EmptyCapacity()
           == Lit(#DynamicPkv.Capacity.Capacity(LitInt(0), LitInt(0), LitInt(0)));
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.__default.EmptyCapacity(), Tclass.DynamicPkv.Capacity());
    }
}



procedure CheckWellformed$$DynamicPkv.__default.PSAPushBackWeight(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0));
  free requires 16 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.PSAPushBackWeight(pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var ##psa#0: DatatypeType;
  var ##keys#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##keys#1: Seq Box;
  var ##key#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##msgs#0: Seq Box;
  var ##psa#3: DatatypeType;
  var ##msgs#1: Seq Box;
  var ##msg#0: DatatypeType;

    // AddMethodImpl: PSAPushBackWeight, CheckWellformed$$DynamicPkv.__default.PSAPushBackWeight
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(503,8): initial state"} true;
    ##pkv#0 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(pkv#0);
    assume PackedKV.__default.WF(pkv#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(506,6): post-state"} true;
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#0 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert $Is(Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))), 
      TSeq(Tclass.KeyType.Key()));
    ##keys#0 := Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(key#0)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#1 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
      TSeq(Tclass.KeyType.Key()));
    ##keys#1 := PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#1, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, Tclass.KeyType.Key(), $Heap);
    assume BucketWeights.__default.WeightKey#canCall(key#0);
    assume BucketWeights.__default.WeightKeyList(Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
          Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
       == BucketWeights.__default.WeightKeyList(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         + BucketWeights.__default.WeightKey(key#0);
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#2 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    ##msgs#0 := Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#3 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    ##msgs#1 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#1, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##msg#0 := msg#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#0, Tclass.ValueMessage.Message(), $Heap);
    assume BucketWeights.__default.WeightMessage#canCall(msg#0);
    assume BucketWeights.__default.WeightMessageList(Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
          Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))))
       == BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)))
         + BucketWeights.__default.WeightMessage(msg#0);
}



procedure Call$$DynamicPkv.__default.PSAPushBackWeight(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0));
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#0: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#0)): Seq Box } 
                LitInt(0) <= i#0
                     && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#0)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           || (forall i#1: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#1)): Seq Box } 
            LitInt(0) <= i#1
                 && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#1)): Seq Box)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
     && BucketWeights.__default.WeightKey#canCall(key#0);
  ensures BucketWeights.__default.WeightKeyList(Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
     == BucketWeights.__default.WeightKeyList(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
       + BucketWeights.__default.WeightKey(key#0);
  free ensures PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)))
     && BucketWeights.__default.WeightMessage#canCall(msg#0);
  ensures BucketWeights.__default.WeightMessageList(Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))))
     == BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)))
       + BucketWeights.__default.WeightMessage(msg#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.PSAPushBackWeight(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0))
   returns ($_reverifyPost: bool);
  free requires 16 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(pkv#0)
     && 
    PackedKV.__default.WF(pkv#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
     && BucketWeights.__default.WeightKey#canCall(key#0);
  ensures BucketWeights.__default.WeightKeyList(Seq#Append(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
     == BucketWeights.__default.WeightKeyList(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
       + BucketWeights.__default.WeightKey(key#0);
  free ensures PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)))
     && BucketWeights.__default.WeightMessage#canCall(msg#0);
  ensures BucketWeights.__default.WeightMessageList(Seq#Append(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))))
     == BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)))
       + BucketWeights.__default.WeightMessage(msg#0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.PSAPushBackWeight(pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var keys##0: Seq Box;
  var ##psa#4: DatatypeType;
  var key##0: Seq Box;
  var msgs##0: Seq Box;
  var ##psa#5: DatatypeType;
  var msg##0: DatatypeType;

    // AddMethodImpl: PSAPushBackWeight, Impl$$DynamicPkv.__default.PSAPushBackWeight
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(509,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(510,26)
    // TrCallStmt: Before ProcessCallStmt
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#4 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assume PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    // ProcessCallStmt: CheckSubrange
    assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
      TSeq(Tclass.KeyType.Key()));
    keys##0 := PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0));
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := key#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$BucketWeights.__default.WeightKeyListPushBack(keys##0, key##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(510,47)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(511,30)
    // TrCallStmt: Before ProcessCallStmt
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#5 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assume PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    // ProcessCallStmt: CheckSubrange
    msgs##0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0));
    assume true;
    // ProcessCallStmt: CheckSubrange
    msg##0 := msg#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$BucketWeights.__default.WeightMessageListPushBack(msgs##0, msg##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(511,63)"} true;
}



procedure CheckWellformed$$DynamicPkv.__default.PSAPopFrontWeight(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616);
  free requires 15 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.PSAPopFrontWeight(pkv#0: DatatypeType, a#0: int, b#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var newtype$check#0: int;
  var ##pkv#1: DatatypeType;
  var ##pkv#2: DatatypeType;
  var ##i#0: int;
  var ##key#0: Seq Box;
  var ##psa#0: DatatypeType;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##keys#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##keys#1: Seq Box;
  var ##pkv#3: DatatypeType;
  var ##i#1: int;
  var ##msg#0: DatatypeType;
  var ##psa#2: DatatypeType;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##msgs#0: Seq Box;
  var ##psa#3: DatatypeType;
  var ##msgs#1: Seq Box;

    // AddMethodImpl: PSAPopFrontWeight, CheckWellformed$$DynamicPkv.__default.PSAPopFrontWeight
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(514,8): initial state"} true;
    ##pkv#0 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(pkv#0);
    assume PackedKV.__default.WF(pkv#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= a#0)
    {
    }

    if (LitInt(0) <= a#0 && a#0 < b#0)
    {
        ##pkv#1 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box } 
                      LitInt(0) <= i#0
                           && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#1);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    }

    assume LitInt(0) <= a#0 && a#0 < b#0 && b#0 <= PackedKV.__default.NumKVPairs(pkv#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(519,6): post-state"} true;
    ##pkv#2 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
    ##i#0 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box } 
              LitInt(0) <= i#3
                   && i#3 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#2);
    assert {:subsumption 0} LitInt(0) <= ##i#0;
    assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)));
    assume LitInt(0) <= ##i#0
       && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)));
    assume PackedKV.__default.GetKey#canCall(pkv#0, a#0);
    ##key#0 := PackedKV.__default.GetKey(pkv#0, a#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, Tclass.KeyType.Key(), $Heap);
    assume BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#0 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := a#0 + 1;
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assert 0 <= a#0 + 1
       && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert a#0 + 1 <= b#0
       && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1), 
      TSeq(Tclass.KeyType.Key()));
    ##keys#0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#1 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert 0 <= a#0
       && a#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert a#0 <= b#0
       && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0), 
      TSeq(Tclass.KeyType.Key()));
    ##keys#1 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#1, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
    assume BucketWeights.__default.WeightKey(PackedKV.__default.GetKey(pkv#0, a#0))
         + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1))
       == BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
    ##pkv#3 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    ##i#1 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#4: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#4)): Seq Box } 
                  LitInt(0) <= i#4
                       && i#4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#4)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#5: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#5)): Seq Box } 
              LitInt(0) <= i#5
                   && i#5 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#5)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#3);
    assert {:subsumption 0} LitInt(0) <= ##i#1;
    assert {:subsumption 0} ##i#1
       < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assume LitInt(0) <= ##i#1
       && ##i#1
         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assume PackedKV.__default.GetMessage#canCall(pkv#0, a#0);
    ##msg#0 := PackedKV.__default.GetMessage(pkv#0, a#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#0, Tclass.ValueMessage.Message(), $Heap);
    assume BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#2 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    newtype$check#3 := LitInt(1);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := a#0 + 1;
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assert 0 <= a#0 + 1
       && a#0 + 1
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assert a#0 + 1 <= b#0
       && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##msgs#0 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
      a#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
        a#0 + 1));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#3 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert 0 <= a#0
       && a#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assert a#0 <= b#0
       && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##msgs#1 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#1, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
    assume BucketWeights.__default.WeightMessage(PackedKV.__default.GetMessage(pkv#0, a#0))
         + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
            a#0 + 1))
       == BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
}



procedure Call$$DynamicPkv.__default.PSAPopFrontWeight(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#6: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#6)): Seq Box } 
                LitInt(0) <= i#6
                     && i#6 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#6)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           || (forall i#7: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#7)): Seq Box } 
            LitInt(0) <= i#7
                 && i#7 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#7)): Seq Box)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= a#0;
  requires a#0 < b#0;
  requires b#0 <= PackedKV.__default.NumKVPairs(pkv#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.__default.GetKey#canCall(pkv#0, a#0)
     && BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
  ensures BucketWeights.__default.WeightKey(PackedKV.__default.GetKey(pkv#0, a#0))
       + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1))
     == BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
  free ensures PackedKV.__default.GetMessage#canCall(pkv#0, a#0)
     && BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
        a#0 + 1))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
  ensures BucketWeights.__default.WeightMessage(PackedKV.__default.GetMessage(pkv#0, a#0))
       + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
          a#0 + 1))
     == BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.PSAPopFrontWeight(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 15 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(pkv#0)
     && 
    PackedKV.__default.WF(pkv#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= a#0;
  requires a#0 < b#0;
  requires b#0 <= PackedKV.__default.NumKVPairs(pkv#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.__default.GetKey#canCall(pkv#0, a#0)
     && BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
  ensures BucketWeights.__default.WeightKey(PackedKV.__default.GetKey(pkv#0, a#0))
       + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1))
     == BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
  free ensures PackedKV.__default.GetMessage#canCall(pkv#0, a#0)
     && BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
        a#0 + 1))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
  ensures BucketWeights.__default.WeightMessage(PackedKV.__default.GetMessage(pkv#0, a#0))
       + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
          a#0 + 1))
     == BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.PSAPopFrontWeight(pkv#0: DatatypeType, a#0: int, b#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0_0_0: DatatypeType;
  var ##key#0_0_0: Seq Box;
  var ##psa#0_0_1: DatatypeType;
  var newtype$check#0_0_0: int;
  var newtype$check#0_0_1: int;
  var ##keys#0_0_0: Seq Box;
  var key##0_0_0: Seq Box;
  var ##psa#0_0_2: DatatypeType;
  var keys##0_0_0: Seq Box;
  var ##psa#0_0_3: DatatypeType;
  var newtype$check#0_0_2: int;
  var newtype$check#0_0_3: int;
  var ##psa#0_0_4: DatatypeType;
  var ##psa#0_0_5: DatatypeType;
  var newtype$check#0_0_4: int;
  var newtype$check#0_0_5: int;
  var ##psa#0_0_6: DatatypeType;
  var ##psa#0_0_7: DatatypeType;
  var ##keys#0_0_1: Seq Box;
  var ##pkv#0_1_0: DatatypeType;
  var ##i#0_1_0: int;
  var ##key#0_1_0: Seq Box;
  var ##psa#0_1_0: DatatypeType;
  var newtype$check#0_1_0: int;
  var newtype$check#0_1_1: int;
  var ##keys#0_1_0: Seq Box;
  var ##psa#0_1_1: DatatypeType;
  var ##key#0_1_1: Seq Box;
  var ##psa#0_1_2: DatatypeType;
  var newtype$check#0_1_2: int;
  var newtype$check#0_1_3: int;
  var ##keys#0_1_1: Seq Box;
  var ##pkv#0_0: DatatypeType;
  var ##i#0_0: int;
  var ##key#0_0: Seq Box;
  var ##psa#0_0: DatatypeType;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var ##keys#0_0: Seq Box;
  var ##pkv#1_0_0: DatatypeType;
  var ##i#1_0_0: int;
  var ##msg#1_0_0: DatatypeType;
  var ##psa#1_0_0: DatatypeType;
  var newtype$check#1_0_0: int;
  var newtype$check#1_0_1: int;
  var ##msgs#1_0_0: Seq Box;
  var msg##1_0_0: DatatypeType;
  var ##psa#1_0_1: DatatypeType;
  var msgs##1_0_0: Seq Box;
  var ##psa#1_0_2: DatatypeType;
  var newtype$check#1_0_2: int;
  var newtype$check#1_0_3: int;
  var ##psa#1_0_3: DatatypeType;
  var ##psa#1_0_4: DatatypeType;
  var newtype$check#1_0_4: int;
  var newtype$check#1_0_5: int;
  var ##psa#1_0_5: DatatypeType;
  var ##psa#1_0_6: DatatypeType;
  var ##msgs#1_0_1: Seq Box;
  var ##pkv#1_0: DatatypeType;
  var ##i#1_0: int;
  var ##msg#1_0: DatatypeType;
  var ##psa#1_0: DatatypeType;
  var newtype$check#1_0: int;
  var newtype$check#1_1: int;
  var ##msgs#1_0: Seq Box;

    // AddMethodImpl: PSAPopFrontWeight, Impl$$DynamicPkv.__default.PSAPopFrontWeight
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(523,2): initial state"} true;
    $_reverifyPost := false;
    // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
    // Assume Fuel Constant
    if (*)
    {
        // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        ##pkv#0_0 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0_0, Tclass.PackedKV.Pkv(), $Heap);
        ##i#0_0 := a#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0_0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), i#0_0)): Seq Box } 
                      LitInt(0) <= i#0_0
                           && i#0_0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), i#0_0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                 || (forall i#0_1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)), i#0_1)): Seq Box } 
                  LitInt(0) <= i#0_1
                       && i#0_1
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)), i#0_1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assert {:subsumption 0} LitInt(0) <= ##i#0_0;
        assert {:subsumption 0} ##i#0_0
           < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)));
        assume PackedKV.__default.GetKey#canCall(pkv#0, a#0);
        ##key#0_0 := PackedKV.__default.GetKey(pkv#0, a#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##key#0_0, Tclass.KeyType.Key(), $Heap);
        assume BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := a#0 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert {:subsumption 0} 0 <= a#0 + 1
           && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert {:subsumption 0} a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1), 
          TSeq(Tclass.KeyType.Key()));
        ##keys#0_0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##keys#0_0, TSeq(Tclass.KeyType.Key()), $Heap);
        assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        assume PackedKV.__default.GetKey#canCall(pkv#0, a#0)
           && BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        ##pkv#0_1_0 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0_1_0, Tclass.PackedKV.Pkv(), $Heap);
        ##i#0_1_0 := a#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_1_0, Tclass.NativeTypes.uint64(), $Heap);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1_0)))
                   < 4294967296);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1_0)))
                   < 4294967296);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1_0)))
                     == LitInt(0)));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1_0))) - 1)): int));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1_0))));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1_0)))
                   < 4294967296);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1_0)))
                   < 4294967296);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1_0)))
                     == LitInt(0)));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1_0))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1_0)))
                           - 1)): int));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1_0))));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1_0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1_0)));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1_0)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1_0)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1_0)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1_0)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0_1_0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1_0)), i#0_1_0)): Seq Box } 
                      LitInt(0) <= i#0_1_0
                           && i#0_1_0
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1_0)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1_0)), i#0_1_0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1_0)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1_0)))
                 || (forall i#0_1_1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1_0)), i#0_1_1)): Seq Box } 
                  LitInt(0) <= i#0_1_1
                       && i#0_1_1
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1_0)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1_0)), i#0_1_1)): Seq Box)));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1_0)
           ==> PackedKV.__default.WF(##pkv#0_1_0)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_1_0)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume {:subsumption 0} LitInt(0) <= ##i#0_1_0;
        assume {:subsumption 0} ##i#0_1_0
           < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1_0)));
        assume PackedKV.__default.GetKey#canCall(pkv#0, a#0);
        ##key#0_1_0 := PackedKV.__default.GetKey(pkv#0, a#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##key#0_1_0, Tclass.KeyType.Key(), $Heap);
        assume BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_1_0 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_1_0, Tclass.PackedStringArray.Psa(), $Heap);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
           ==> PackedStringArray.__default.WF(##psa#0_1_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
           ==> PackedStringArray.__default.WF(##psa#0_1_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
           ==> PackedStringArray.__default.WF(##psa#0_1_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0)) == LitInt(0));
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
           ==> PackedStringArray.__default.WF(##psa#0_1_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) - 1)): int);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
           ==> PackedStringArray.__default.WF(##psa#0_1_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_1_0));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        newtype$check#0_1_0 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_1_0 && newtype$check#0_1_0 < 18446744073709551616;
        newtype$check#0_1_1 := a#0 + 1;
        assume LitInt(0) <= newtype$check#0_1_1 && newtype$check#0_1_1 < 18446744073709551616;
        assume {:subsumption 0} 0 <= a#0 + 1
           && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume {:subsumption 0} a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1), 
          TSeq(Tclass.KeyType.Key()));
        ##keys#0_1_0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##keys#0_1_0, TSeq(Tclass.KeyType.Key()), $Heap);
        assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        assume PackedKV.__default.GetKey#canCall(pkv#0, a#0)
           && BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_1_1 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_1_1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
           ==> PackedStringArray.__default.WF(##psa#0_1_1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
           ==> PackedStringArray.__default.WF(##psa#0_1_1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
           ==> PackedStringArray.__default.WF(##psa#0_1_1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
           ==> PackedStringArray.__default.WF(##psa#0_1_1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
           ==> PackedStringArray.__default.WF(##psa#0_1_1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_1_1));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assert {:subsumption 0} 0 <= a#0
           && a#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert $Is($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box, 
          Tclass.KeyType.Key());
        ##key#0_1_1 := $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box;
        // assume allocatedness for argument to function
        assume $IsAlloc(##key#0_1_1, Tclass.KeyType.Key(), $Heap);
        assume BucketWeights.__default.WeightKey#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box);
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_1_2 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_1_2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_2)
           ==> PackedStringArray.__default.WF(##psa#0_1_2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_2)
           ==> PackedStringArray.__default.WF(##psa#0_1_2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_2)
           ==> PackedStringArray.__default.WF(##psa#0_1_2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_2)
           ==> PackedStringArray.__default.WF(##psa#0_1_2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_2)
           ==> PackedStringArray.__default.WF(##psa#0_1_2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_1_2));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        newtype$check#0_1_2 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_1_2 && newtype$check#0_1_2 < 18446744073709551616;
        newtype$check#0_1_3 := a#0 + 1;
        assert LitInt(0) <= newtype$check#0_1_3 && newtype$check#0_1_3 < 18446744073709551616;
        assert {:subsumption 0} 0 <= a#0 + 1
           && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert {:subsumption 0} a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1), 
          TSeq(Tclass.KeyType.Key()));
        ##keys#0_1_1 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##keys#0_1_1, TSeq(Tclass.KeyType.Key()), $Heap);
        assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKey#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box)
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        assert {:subsumption 0} BucketWeights.__default.WeightKey(PackedKV.__default.GetKey(pkv#0, a#0))
             + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1))
           == BucketWeights.__default.WeightKey($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box)
             + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0_0 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_0, Tclass.PackedStringArray.Psa(), $Heap);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) == LitInt(0));
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) - 1)): int);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_0));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assume {:subsumption 0} 0 <= a#0
           && a#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume $Is($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box, 
          Tclass.KeyType.Key());
        ##key#0_0_0 := $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box;
        // assume allocatedness for argument to function
        assume $IsAlloc(##key#0_0_0, Tclass.KeyType.Key(), $Heap);
        assume BucketWeights.__default.WeightKey#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box);
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0_1 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_1, Tclass.PackedStringArray.Psa(), $Heap);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1)) == LitInt(0));
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) - 1)): int);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
           ==> PackedStringArray.__default.WF(##psa#0_0_1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_1));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        newtype$check#0_0_0 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_0_0 && newtype$check#0_0_0 < 18446744073709551616;
        newtype$check#0_0_1 := a#0 + 1;
        assume LitInt(0) <= newtype$check#0_0_1 && newtype$check#0_0_1 < 18446744073709551616;
        assume {:subsumption 0} 0 <= a#0 + 1
           && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume {:subsumption 0} a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1), 
          TSeq(Tclass.KeyType.Key()));
        ##keys#0_0_0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##keys#0_0_0, TSeq(Tclass.KeyType.Key()), $Heap);
        assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKey#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box)
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1));
        // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(528,31)
        // TrCallStmt: Before ProcessCallStmt
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0_2 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
           ==> PackedStringArray.__default.WF(##psa#0_0_2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_2));
        assume PackedStringArray.__default.WF(##psa#0_0_2);
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assert 0 <= a#0
           && a#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        // ProcessCallStmt: CheckSubrange
        assert $Is($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box, 
          Tclass.KeyType.Key());
        key##0_0_0 := $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box;
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0_3 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
           ==> PackedStringArray.__default.WF(##psa#0_0_3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_3));
        assume PackedStringArray.__default.WF(##psa#0_0_3);
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        newtype$check#0_0_2 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0_2 && newtype$check#0_0_2 < 18446744073709551616;
        newtype$check#0_0_3 := a#0 + 1;
        assert LitInt(0) <= newtype$check#0_0_3 && newtype$check#0_0_3 < 18446744073709551616;
        assert 0 <= a#0 + 1
           && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        // ProcessCallStmt: CheckSubrange
        assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1), 
          TSeq(Tclass.KeyType.Key()));
        keys##0_0_0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$BucketWeights.__default.WeightKeyListPushFront(key##0_0_0, keys##0_0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(529,36)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(530,9)
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0_4 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_4, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_4)
           ==> PackedStringArray.__default.WF(##psa#0_0_4)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_4)
           ==> PackedStringArray.__default.WF(##psa#0_0_4)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_4)
           ==> PackedStringArray.__default.WF(##psa#0_0_4)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_4)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_4)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_4)
           ==> PackedStringArray.__default.WF(##psa#0_0_4)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_4))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_4))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_4), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_4)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_4)
           ==> PackedStringArray.__default.WF(##psa#0_0_4)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_4));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assert {:subsumption 0} 0 <= a#0
           && a#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0_5 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_5, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_5)
           ==> PackedStringArray.__default.WF(##psa#0_0_5)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_5)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_5)
           ==> PackedStringArray.__default.WF(##psa#0_0_5)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_5)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_5)
           ==> PackedStringArray.__default.WF(##psa#0_0_5)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_5)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_5)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_5)
           ==> PackedStringArray.__default.WF(##psa#0_0_5)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_5))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_5))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_5), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_5)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_5)
           ==> PackedStringArray.__default.WF(##psa#0_0_5)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_5));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        newtype$check#0_0_4 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0_4 && newtype$check#0_0_4 < 18446744073709551616;
        newtype$check#0_0_5 := a#0 + 1;
        assert LitInt(0) <= newtype$check#0_0_5 && newtype$check#0_0_5 < 18446744073709551616;
        assert {:subsumption 0} 0 <= a#0 + 1
           && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert {:subsumption 0} a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0_6 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_6, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_6)
           ==> PackedStringArray.__default.WF(##psa#0_0_6)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_6)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_6)
           ==> PackedStringArray.__default.WF(##psa#0_0_6)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_6)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_6)
           ==> PackedStringArray.__default.WF(##psa#0_0_6)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_6)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_6)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_6)
           ==> PackedStringArray.__default.WF(##psa#0_0_6)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_6))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_6))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_6), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_6)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_6)
           ==> PackedStringArray.__default.WF(##psa#0_0_6)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_6));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assert {:subsumption 0} 0 <= a#0
           && a#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert {:subsumption 0} a#0 <= b#0
           && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assert Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
              Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)), 
            Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1)), 
          Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0_0_7 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0_7, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_7)
           ==> PackedStringArray.__default.WF(##psa#0_0_7)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_7)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_7)
           ==> PackedStringArray.__default.WF(##psa#0_0_7)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_7)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_7)
           ==> PackedStringArray.__default.WF(##psa#0_0_7)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_7)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_7)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_7)
           ==> PackedStringArray.__default.WF(##psa#0_0_7)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_7))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_7))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_7), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_7)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_7)
           ==> PackedStringArray.__default.WF(##psa#0_0_7)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0_7));
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assert {:subsumption 0} 0 <= a#0
           && a#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert {:subsumption 0} a#0 <= b#0
           && b#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assert $Is(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0), 
          TSeq(Tclass.KeyType.Key()));
        ##keys#0_0_1 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##keys#0_0_1, TSeq(Tclass.KeyType.Key()), $Heap);
        assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
        // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(524,5)
        assert {:subsumption 0} BucketWeights.__default.WeightKey($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0)): Seq Box)
             + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1))
           == BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
        assume false;
    }

    assume BucketWeights.__default.WeightKey(PackedKV.__default.GetKey(pkv#0, a#0))
         + BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0 + 1))
       == BucketWeights.__default.WeightKeyList(Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), b#0), a#0));
    // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(535,5)
    // Assume Fuel Constant
    if (*)
    {
        // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(535,5)
        ##pkv#1_0 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1_0, Tclass.PackedKV.Pkv(), $Heap);
        ##i#1_0 := a#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#1_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#1_0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), i#1_0)): Seq Box } 
                      LitInt(0) <= i#1_0
                           && i#1_0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), i#1_0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
                 || (forall i#1_1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)), i#1_1)): Seq Box } 
                  LitInt(0) <= i#1_1
                       && i#1_1
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)), i#1_1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
           ==> PackedKV.__default.WF(##pkv#1_0)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_0)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assert {:subsumption 0} LitInt(0) <= ##i#1_0;
        assert {:subsumption 0} ##i#1_0
           < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)));
        assume PackedKV.__default.GetMessage#canCall(pkv#0, a#0);
        ##msg#1_0 := PackedKV.__default.GetMessage(pkv#0, a#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##msg#1_0, Tclass.ValueMessage.Message(), $Heap);
        assume BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1_0 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        newtype$check#1_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < 18446744073709551616;
        newtype$check#1_1 := a#0 + 1;
        assert LitInt(0) <= newtype$check#1_1 && newtype$check#1_1 < 18446744073709551616;
        assert {:subsumption 0} 0 <= a#0 + 1
           && a#0 + 1
             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assert {:subsumption 0} a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        ##msgs#1_0 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
          a#0 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##msgs#1_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
        assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
            a#0 + 1));
        assume PackedKV.__default.GetMessage#canCall(pkv#0, a#0)
           && BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
              a#0 + 1));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(535,5)
        ##pkv#1_0_0 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1_0_0, Tclass.PackedKV.Pkv(), $Heap);
        ##i#1_0_0 := a#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#1_0_0, Tclass.NativeTypes.uint64(), $Heap);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)))
                   < 4294967296);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0_0)))
                   < 4294967296);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0_0)))
                     == LitInt(0)));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0))) - 1)): int));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0))));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)))
                   < 4294967296);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0_0)))
                   < 4294967296);
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0_0)))
                     == LitInt(0)));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)))
                           - 1)): int));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0))));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#1_0_0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)), i#1_0_0)): Seq Box } 
                      LitInt(0) <= i#1_0_0
                           && i#1_0_0
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)), i#1_0_0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)))
                 || (forall i#1_0_1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)), i#1_0_1)): Seq Box } 
                  LitInt(0) <= i#1_0_1
                       && i#1_0_1
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)), i#1_0_1)): Seq Box)));
        assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
           ==> PackedKV.__default.WF(##pkv#1_0_0)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_0_0)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume {:subsumption 0} LitInt(0) <= ##i#1_0_0;
        assume {:subsumption 0} ##i#1_0_0
           < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)));
        assume PackedKV.__default.GetMessage#canCall(pkv#0, a#0);
        ##msg#1_0_0 := PackedKV.__default.GetMessage(pkv#0, a#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##msg#1_0_0, Tclass.ValueMessage.Message(), $Heap);
        assume BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1_0_0 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0_0, Tclass.PackedStringArray.Psa(), $Heap);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_0)
           ==> PackedStringArray.__default.WF(##psa#1_0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_0)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_0)
           ==> PackedStringArray.__default.WF(##psa#1_0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0_0)) < 4294967296;
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_0)
           ==> PackedStringArray.__default.WF(##psa#1_0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_0)) == LitInt(0));
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_0)
           ==> PackedStringArray.__default.WF(##psa#1_0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_0)) - 1)): int);
        assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_0)
           ==> PackedStringArray.__default.WF(##psa#1_0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0_0));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        newtype$check#1_0_0 := LitInt(1);
        assume LitInt(0) <= newtype$check#1_0_0 && newtype$check#1_0_0 < 18446744073709551616;
        newtype$check#1_0_1 := a#0 + 1;
        assume LitInt(0) <= newtype$check#1_0_1 && newtype$check#1_0_1 < 18446744073709551616;
        assume {:subsumption 0} 0 <= a#0 + 1
           && a#0 + 1
             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assume {:subsumption 0} a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        ##msgs#1_0_0 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
          a#0 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##msgs#1_0_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
        assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
            a#0 + 1));
        assume PackedKV.__default.GetMessage#canCall(pkv#0, a#0)
           && BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
              a#0 + 1));
        // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(535,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(538,35)
        // TrCallStmt: Before ProcessCallStmt
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1_0_1 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0_1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_1)
           ==> PackedStringArray.__default.WF(##psa#1_0_1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_1)
           ==> PackedStringArray.__default.WF(##psa#1_0_1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0_1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_1)
           ==> PackedStringArray.__default.WF(##psa#1_0_1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_1)
           ==> PackedStringArray.__default.WF(##psa#1_0_1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0_1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_1)
           ==> PackedStringArray.__default.WF(##psa#1_0_1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0_1));
        assume PackedStringArray.__default.WF(##psa#1_0_1);
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        assert 0 <= a#0
           && a#0 < Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        // ProcessCallStmt: CheckSubrange
        msg##1_0_0 := $Unbox(Seq#Index(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0)): DatatypeType;
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1_0_2 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0_2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_2)
           ==> PackedStringArray.__default.WF(##psa#1_0_2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_2)
           ==> PackedStringArray.__default.WF(##psa#1_0_2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0_2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_2)
           ==> PackedStringArray.__default.WF(##psa#1_0_2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_2)
           ==> PackedStringArray.__default.WF(##psa#1_0_2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0_2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_2)
           ==> PackedStringArray.__default.WF(##psa#1_0_2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0_2));
        assume PackedStringArray.__default.WF(##psa#1_0_2);
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        newtype$check#1_0_2 := LitInt(1);
        assert LitInt(0) <= newtype$check#1_0_2 && newtype$check#1_0_2 < 18446744073709551616;
        newtype$check#1_0_3 := a#0 + 1;
        assert LitInt(0) <= newtype$check#1_0_3 && newtype$check#1_0_3 < 18446744073709551616;
        assert 0 <= a#0 + 1
           && a#0 + 1
             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assert a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        // ProcessCallStmt: CheckSubrange
        msgs##1_0_0 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
          a#0 + 1);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$BucketWeights.__default.WeightMessageListPushFront(msg##1_0_0, msgs##1_0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(539,48)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(540,9)
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1_0_3 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0_3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_3)
           ==> PackedStringArray.__default.WF(##psa#1_0_3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_3)
           ==> PackedStringArray.__default.WF(##psa#1_0_3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0_3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_3)
           ==> PackedStringArray.__default.WF(##psa#1_0_3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_3)
           ==> PackedStringArray.__default.WF(##psa#1_0_3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0_3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_3)
           ==> PackedStringArray.__default.WF(##psa#1_0_3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0_3));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        assert {:subsumption 0} 0 <= a#0
           && a#0 < Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1_0_4 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0_4, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_4)
           ==> PackedStringArray.__default.WF(##psa#1_0_4)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_4)
           ==> PackedStringArray.__default.WF(##psa#1_0_4)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0_4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_4)
           ==> PackedStringArray.__default.WF(##psa#1_0_4)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_4)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_4)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_4)
           ==> PackedStringArray.__default.WF(##psa#1_0_4)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_4))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_4))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0_4), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_4)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_4)
           ==> PackedStringArray.__default.WF(##psa#1_0_4)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0_4));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        newtype$check#1_0_4 := LitInt(1);
        assert LitInt(0) <= newtype$check#1_0_4 && newtype$check#1_0_4 < 18446744073709551616;
        newtype$check#1_0_5 := a#0 + 1;
        assert LitInt(0) <= newtype$check#1_0_5 && newtype$check#1_0_5 < 18446744073709551616;
        assert {:subsumption 0} 0 <= a#0 + 1
           && a#0 + 1
             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assert {:subsumption 0} a#0 + 1 <= b#0
           && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1_0_5 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0_5, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_5)
           ==> PackedStringArray.__default.WF(##psa#1_0_5)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_5)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_5)
           ==> PackedStringArray.__default.WF(##psa#1_0_5)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0_5)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_5)
           ==> PackedStringArray.__default.WF(##psa#1_0_5)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_5)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_5)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_5)
           ==> PackedStringArray.__default.WF(##psa#1_0_5)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_5))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_5))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0_5), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_5)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_5)
           ==> PackedStringArray.__default.WF(##psa#1_0_5)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0_5));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        assert {:subsumption 0} 0 <= a#0
           && a#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assert {:subsumption 0} a#0 <= b#0
           && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        assert Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
              Seq#Index(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0)), 
            Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
              a#0 + 1)), 
          Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(535,5)
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1_0_6 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0_6, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_6)
           ==> PackedStringArray.__default.WF(##psa#1_0_6)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_6)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_6)
           ==> PackedStringArray.__default.WF(##psa#1_0_6)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0_6)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_6)
           ==> PackedStringArray.__default.WF(##psa#1_0_6)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_6)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_6)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_6)
           ==> PackedStringArray.__default.WF(##psa#1_0_6)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_6))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0_6))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0_6), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0_6)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0_6)
           ==> PackedStringArray.__default.WF(##psa#1_0_6)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0_6));
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        assert {:subsumption 0} 0 <= a#0
           && a#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assert {:subsumption 0} a#0 <= b#0
           && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        ##msgs#1_0_1 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##msgs#1_0_1, TSeq(Tclass.ValueMessage.Message()), $Heap);
        assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
        // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(535,5)
        assert {:subsumption 0} BucketWeights.__default.WeightMessage(PackedKV.__default.GetMessage(pkv#0, a#0))
             + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
                a#0 + 1))
           == BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
        assume false;
    }

    assume BucketWeights.__default.WeightMessage(PackedKV.__default.GetMessage(pkv#0, a#0))
         + BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), 
            a#0 + 1))
       == BucketWeights.__default.WeightMessageList(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0));
}



procedure CheckWellformed$$DynamicPkv.__default.PSAPopFrontWeightSuffix(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616);
  free requires 36 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.PSAPopFrontWeightSuffix(pkv#0: DatatypeType, a#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var newtype$check#0: int;
  var ##pkv#1: DatatypeType;
  var ##pkv#2: DatatypeType;
  var ##i#0: int;
  var ##key#0: Seq Box;
  var ##psa#0: DatatypeType;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##keys#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##keys#1: Seq Box;
  var ##pkv#3: DatatypeType;
  var ##i#1: int;
  var ##msg#0: DatatypeType;
  var ##psa#2: DatatypeType;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##msgs#0: Seq Box;
  var ##psa#3: DatatypeType;
  var ##msgs#1: Seq Box;

    // AddMethodImpl: PSAPopFrontWeightSuffix, CheckWellformed$$DynamicPkv.__default.PSAPopFrontWeightSuffix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(547,8): initial state"} true;
    ##pkv#0 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(pkv#0);
    assume PackedKV.__default.WF(pkv#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= a#0)
    {
        ##pkv#1 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box } 
                      LitInt(0) <= i#0
                           && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#1);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    }

    assume LitInt(0) <= a#0 && a#0 < PackedKV.__default.NumKVPairs(pkv#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(552,6): post-state"} true;
    ##pkv#2 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
    ##i#0 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box } 
              LitInt(0) <= i#3
                   && i#3 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#2);
    assert {:subsumption 0} LitInt(0) <= ##i#0;
    assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)));
    assume LitInt(0) <= ##i#0
       && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)));
    assume PackedKV.__default.GetKey#canCall(pkv#0, a#0);
    ##key#0 := PackedKV.__default.GetKey(pkv#0, a#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, Tclass.KeyType.Key(), $Heap);
    assume BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#0 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := a#0 + 1;
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assert 0 <= a#0 + 1
       && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert $Is(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1), 
      TSeq(Tclass.KeyType.Key()));
    ##keys#0 := Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#1 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert 0 <= a#0
       && a#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assert $Is(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0), 
      TSeq(Tclass.KeyType.Key()));
    ##keys#1 := Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#1, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0));
    assume BucketWeights.__default.WeightKey(PackedKV.__default.GetKey(pkv#0, a#0))
         + BucketWeights.__default.WeightKeyList(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1))
       == BucketWeights.__default.WeightKeyList(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0));
    ##pkv#3 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    ##i#1 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#4: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#4)): Seq Box } 
                  LitInt(0) <= i#4
                       && i#4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#4)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#5: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#5)): Seq Box } 
              LitInt(0) <= i#5
                   && i#5 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#5)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#3);
    assert {:subsumption 0} LitInt(0) <= ##i#1;
    assert {:subsumption 0} ##i#1
       < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assume LitInt(0) <= ##i#1
       && ##i#1
         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assume PackedKV.__default.GetMessage#canCall(pkv#0, a#0);
    ##msg#0 := PackedKV.__default.GetMessage(pkv#0, a#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##msg#0, Tclass.ValueMessage.Message(), $Heap);
    assume BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#2 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    newtype$check#3 := LitInt(1);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := a#0 + 1;
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assert 0 <= a#0 + 1
       && a#0 + 1
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##msgs#0 := Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + 1));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#3 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert 0 <= a#0
       && a#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##msgs#1 := Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#1, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0));
    assume BucketWeights.__default.WeightMessage(PackedKV.__default.GetMessage(pkv#0, a#0))
         + BucketWeights.__default.WeightMessageList(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + 1))
       == BucketWeights.__default.WeightMessageList(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0));
}



procedure Call$$DynamicPkv.__default.PSAPopFrontWeightSuffix(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#6: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#6)): Seq Box } 
                LitInt(0) <= i#6
                     && i#6 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#6)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           || (forall i#7: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#7)): Seq Box } 
            LitInt(0) <= i#7
                 && i#7 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#7)): Seq Box)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= a#0;
  requires a#0 < PackedKV.__default.NumKVPairs(pkv#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.__default.GetKey#canCall(pkv#0, a#0)
     && BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0));
  ensures BucketWeights.__default.WeightKey(PackedKV.__default.GetKey(pkv#0, a#0))
       + BucketWeights.__default.WeightKeyList(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1))
     == BucketWeights.__default.WeightKeyList(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0));
  free ensures PackedKV.__default.GetMessage#canCall(pkv#0, a#0)
     && BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + 1))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0));
  ensures BucketWeights.__default.WeightMessage(PackedKV.__default.GetMessage(pkv#0, a#0))
       + BucketWeights.__default.WeightMessageList(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + 1))
     == BucketWeights.__default.WeightMessageList(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.PSAPopFrontWeightSuffix(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 36 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(pkv#0)
     && 
    PackedKV.__default.WF(pkv#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= a#0;
  requires a#0 < PackedKV.__default.NumKVPairs(pkv#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.__default.GetKey#canCall(pkv#0, a#0)
     && BucketWeights.__default.WeightKey#canCall(PackedKV.__default.GetKey(pkv#0, a#0))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
     && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0));
  ensures BucketWeights.__default.WeightKey(PackedKV.__default.GetKey(pkv#0, a#0))
       + BucketWeights.__default.WeightKeyList(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1))
     == BucketWeights.__default.WeightKeyList(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0));
  free ensures PackedKV.__default.GetMessage#canCall(pkv#0, a#0)
     && BucketWeights.__default.WeightMessage#canCall(PackedKV.__default.GetMessage(pkv#0, a#0))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + 1))
     && 
    PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0));
  ensures BucketWeights.__default.WeightMessage(PackedKV.__default.GetMessage(pkv#0, a#0))
       + BucketWeights.__default.WeightMessageList(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + 1))
     == BucketWeights.__default.WeightMessageList(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.PSAPopFrontWeightSuffix(pkv#0: DatatypeType, a#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var pkv##0: DatatypeType;
  var a##0: int;
  var b##0: int;
  var ##pkv#4: DatatypeType;
  var ##psa#4: DatatypeType;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var ##psa#5: DatatypeType;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var ##pkv#5: DatatypeType;
  var ##psa#6: DatatypeType;
  var ##psa#7: DatatypeType;
  var ##pkv#6: DatatypeType;
  var ##psa#8: DatatypeType;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var ##psa#9: DatatypeType;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var ##pkv#7: DatatypeType;
  var ##psa#10: DatatypeType;
  var ##psa#11: DatatypeType;
  var ##pkv#8: DatatypeType;

    // AddMethodImpl: PSAPopFrontWeightSuffix, Impl$$DynamicPkv.__default.PSAPopFrontWeightSuffix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(556,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(557,22)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    pkv##0 := pkv#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    a##0 := a#0;
    ##pkv#4 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#4, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#10: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#10)): Seq Box } 
                  LitInt(0) <= i#10
                       && i#10 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#10)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
             || (forall i#11: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#11)): Seq Box } 
              LitInt(0) <= i#11
                   && i#11 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#11)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#4)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#4);
    assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    // ProcessCallStmt: CheckSubrange
    b##0 := PackedKV.__default.NumKVPairs(pkv#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$DynamicPkv.__default.PSAPopFrontWeight(pkv##0, a##0, b##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(557,50)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(558,5)
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#4 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    newtype$check#5 := LitInt(1);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    newtype$check#6 := a#0 + 1;
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assert {:subsumption 0} 0 <= a#0 + 1
       && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#5 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    newtype$check#7 := LitInt(1);
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    newtype$check#8 := a#0 + 1;
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    assert {:subsumption 0} 0 <= a#0 + 1
       && a#0 + 1 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    ##pkv#5 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#5, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#12: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#12)): Seq Box } 
                  LitInt(0) <= i#12
                       && i#12 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#12)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
             || (forall i#13: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#13)): Seq Box } 
              LitInt(0) <= i#13
                   && i#13 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#13)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#5)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assert {:subsumption 0} a#0 + 1 <= PackedKV.__default.NumKVPairs(pkv#0)
       && PackedKV.__default.NumKVPairs(pkv#0)
         <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
       && 
      PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
       && PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assert Seq#Equal(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0 + 1), 
      Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
          PackedKV.__default.NumKVPairs(pkv#0)), 
        a#0 + 1));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(560,5)
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#6 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert {:subsumption 0} 0 <= a#0
       && a#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#7 := PackedKV.Pkv.keys(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#7));
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
    assert {:subsumption 0} 0 <= a#0
       && a#0 <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    ##pkv#6 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#6, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#14: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#14)): Seq Box } 
                  LitInt(0) <= i#14
                       && i#14 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#14)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
             || (forall i#15: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#15)): Seq Box } 
              LitInt(0) <= i#15
                   && i#15 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#15)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#6)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assert {:subsumption 0} a#0 <= PackedKV.__default.NumKVPairs(pkv#0)
       && PackedKV.__default.NumKVPairs(pkv#0)
         <= Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
       && 
      PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
       && PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assert Seq#Equal(Seq#Drop(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), a#0), 
      Seq#Drop(Seq#Take(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
          PackedKV.__default.NumKVPairs(pkv#0)), 
        a#0));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(562,5)
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#8 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || Seq#Length(PackedStringArray.Psa.data(##psa#8)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#8)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#8))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#8), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
       ==> PackedStringArray.__default.WF(##psa#8)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#8));
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    newtype$check#9 := LitInt(1);
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    newtype$check#10 := a#0 + 1;
    assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
    assert {:subsumption 0} 0 <= a#0 + 1
       && a#0 + 1
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#9 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#9, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Seq#Length(PackedStringArray.Psa.data(##psa#9)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#9)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#9))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#9), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#9));
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    newtype$check#11 := LitInt(1);
    assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
    newtype$check#12 := a#0 + 1;
    assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 18446744073709551616;
    assert {:subsumption 0} 0 <= a#0 + 1
       && a#0 + 1
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##pkv#7 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#7, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#16: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), i#16)): Seq Box } 
                  LitInt(0) <= i#16
                       && i#16 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), i#16)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
             || (forall i#17: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)), i#17)): Seq Box } 
              LitInt(0) <= i#17
                   && i#17 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)), i#17)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#7)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assert {:subsumption 0} a#0 + 1 <= PackedKV.__default.NumKVPairs(pkv#0)
       && PackedKV.__default.NumKVPairs(pkv#0)
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
       && 
      PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
       && PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assert Seq#Equal(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + 1), 
      Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
          PackedKV.__default.NumKVPairs(pkv#0)), 
        a#0 + 1));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(564,5)
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#10 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#10, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Seq#Length(PackedStringArray.Psa.data(##psa#10)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#10)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#10))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#10))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#10), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#10));
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert {:subsumption 0} 0 <= a#0
       && a#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#11 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#11, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Seq#Length(PackedStringArray.Psa.data(##psa#11)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#11)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#11))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#11))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#11), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#11));
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert {:subsumption 0} 0 <= a#0
       && a#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##pkv#8 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#8, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#18: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), i#18)): Seq Box } 
                  LitInt(0) <= i#18
                       && i#18 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), i#18)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
             || (forall i#19: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)), i#19)): Seq Box } 
              LitInt(0) <= i#19
                   && i#19 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)), i#19)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#8)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assert {:subsumption 0} a#0 <= PackedKV.__default.NumKVPairs(pkv#0)
       && PackedKV.__default.NumKVPairs(pkv#0)
         <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
       && 
      PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
       && PackedKV.__default.NumKVPairs#canCall(pkv#0);
    assert Seq#Equal(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0), 
      Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
          PackedKV.__default.NumKVPairs(pkv#0)), 
        a#0));
}



// function declaration for DynamicPkv._default.WeightBucketPkv
function DynamicPkv.__default.WeightBucketPkv(pkv#0: DatatypeType) : int;

function DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for DynamicPkv.__default.WeightBucketPkv
axiom 11 <= $FunctionContextHeight
   ==> (forall pkv#0: DatatypeType :: 
    { DynamicPkv.__default.WeightBucketPkv(pkv#0) } 
    DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0)
         || (11 != $FunctionContextHeight
           && 
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && PackedKV.__default.WF(pkv#0))
       ==> true);

function DynamicPkv.__default.WeightBucketPkv#requires(DatatypeType) : bool;

// #requires axiom for DynamicPkv.__default.WeightBucketPkv
axiom (forall pkv#0: DatatypeType :: 
  { DynamicPkv.__default.WeightBucketPkv#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> DynamicPkv.__default.WeightBucketPkv#requires(pkv#0)
       == PackedKV.__default.WF(pkv#0));

// definition axiom for DynamicPkv.__default.WeightBucketPkv(revealed)
axiom 11 <= $FunctionContextHeight
   ==> (forall pkv#0: DatatypeType :: 
    { DynamicPkv.__default.WeightBucketPkv(pkv#0) } 
    DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0)
         || (11 != $FunctionContextHeight
           && 
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
         && BucketWeights.__default.WeightKeyList#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
         && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)))
         && DynamicPkv.__default.WeightBucketPkv(pkv#0)
           == BucketWeights.__default.WeightKeyList(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
             + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0))));

// definition axiom for DynamicPkv.__default.WeightBucketPkv for all literals(revealed)
axiom 11 <= $FunctionContextHeight
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { DynamicPkv.__default.WeightBucketPkv(Lit(pkv#0)) } 
    DynamicPkv.__default.WeightBucketPkv#canCall(Lit(pkv#0))
         || (11 != $FunctionContextHeight
           && 
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && BucketWeights.__default.WeightKeyList#canCall(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IMessages#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && BucketWeights.__default.WeightMessageList#canCall(Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
         && DynamicPkv.__default.WeightBucketPkv(Lit(pkv#0))
           == LitInt(BucketWeights.__default.WeightKeyList(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
               + BucketWeights.__default.WeightMessageList(Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))));

procedure CheckWellformed$$DynamicPkv.__default.WeightBucketPkv(pkv#0: DatatypeType where $Is(pkv#0, Tclass.PackedKV.Pkv()));
  free requires 11 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.WeightBucketPkv(pkv#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var b$reqreads#0: bool;
  var ##psa#0: DatatypeType;
  var ##keys#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##msgs#0: Seq Box;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;

    // AddWellformednessCheck for function WeightBucketPkv
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(568,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    ##pkv#0 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedKV.__default.WF#canCall(pkv#0);
    assume PackedKV.__default.WF(pkv#0);
    assert b$reqreads#0;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#0 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0));
        assume PackedStringArray.__default.WF(##psa#0);
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0));
        assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
          TSeq(Tclass.KeyType.Key()));
        ##keys#0 := PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0));
        // assume allocatedness for argument to function
        assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume BucketWeights.__default.WeightKeyList#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#1 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        ##msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0));
        // assume allocatedness for argument to function
        assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
        b$reqreads#4 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assume DynamicPkv.__default.WeightBucketPkv(pkv#0)
           == BucketWeights.__default.WeightKeyList(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
             + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
           && BucketWeights.__default.WeightKeyList#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           && 
          PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
           && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.__default.WeightBucketPkv(pkv#0), TInt);
        assert b$reqreads#1;
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
    }
}



procedure CheckWellformed$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var ##pkv#1: DatatypeType;
  var ##pkv#2: DatatypeType;
  var ##pkv#3: DatatypeType;

    // AddMethodImpl: WeightBucketPkv_eq_WeightPkv, CheckWellformed$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(575,8): initial state"} true;
    ##pkv#0 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(pkv#0);
    assume PackedKV.__default.WF(pkv#0);
    ##pkv#1 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
             || (forall i#1: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box } 
              LitInt(0) <= i#1
                   && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#1);
    assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(578,36): post-state"} true;
    ##pkv#2 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box } 
              LitInt(0) <= i#3
                   && i#3 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#2);
    assume PackedKV.__default.WeightPkv#canCall(pkv#0);
    ##pkv#3 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#4: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#4)): Seq Box } 
                  LitInt(0) <= i#4
                       && i#4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#4)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#5: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#5)): Seq Box } 
              LitInt(0) <= i#5
                   && i#5 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#5)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#3);
    assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0);
    assume PackedKV.__default.WeightPkv(pkv#0)
       == DynamicPkv.__default.WeightBucketPkv(pkv#0);
}



procedure Call$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0));
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#6: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#6)): Seq Box } 
                LitInt(0) <= i#6
                     && i#6 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#6)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           || (forall i#7: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#7)): Seq Box } 
            LitInt(0) <= i#7
                 && i#7 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#7)): Seq Box)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.__default.WeightPkv#canCall(pkv#0)
     && DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0);
  ensures PackedKV.__default.WeightPkv(pkv#0)
     == DynamicPkv.__default.WeightBucketPkv(pkv#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0))
   returns ($_reverifyPost: bool);
  free requires 13 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(pkv#0)
     && 
    PackedKV.__default.WF(pkv#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.__default.WeightPkv#canCall(pkv#0)
     && DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0);
  ensures PackedKV.__default.WeightPkv(pkv#0)
     == DynamicPkv.__default.WeightBucketPkv(pkv#0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0_0_0_0: DatatypeType;
  var ##pkv#0_0_1_0: DatatypeType;
  var ##pkv#0_0_0: DatatypeType;
  var pkv'#0: DatatypeType
     where $Is(pkv'#0, Tclass.PackedKV.Pkv())
       && $IsAlloc(pkv'#0, Tclass.PackedKV.Pkv(), $Heap);
  var newtype$check#0: int;
  var ##pkv#4: DatatypeType;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##pkv#5: DatatypeType;
  var ##from#0: int;
  var ##to#0: int;
  var key#0: Seq Box
     where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap);
  var ##pkv#6: DatatypeType;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##pkv#7: DatatypeType;
  var ##i#0: int;
  var msg#0: DatatypeType
     where $Is(msg#0, Tclass.ValueMessage.Message())
       && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap);
  var ##pkv#8: DatatypeType;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var ##pkv#9: DatatypeType;
  var ##i#1: int;
  var keys'#0: Seq Box
     where $Is(keys'#0, TSeq(Tclass.KeyType.Key()))
       && $IsAlloc(keys'#0, TSeq(Tclass.KeyType.Key()), $Heap);
  var ##psa#0: DatatypeType;
  var msgs'#0: Seq Box
     where $Is(msgs'#0, TSeq(Tclass.ValueMessage.Message()))
       && $IsAlloc(msgs'#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
  var ##psa#1: DatatypeType;
  var keys#0: Seq Box
     where $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       && $IsAlloc(keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
  var ##psa#2: DatatypeType;
  var msgs#0: Seq Box
     where $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       && $IsAlloc(msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
  var ##psa#3: DatatypeType;
  var ##keys#1_0_0: Seq Box;
  var ##msgs#1_0_0: Seq Box;
  var ##pkv#1_0_0: DatatypeType;
  var ##keys#1_1_0: Seq Box;
  var ##msgs#1_1_0: Seq Box;
  var ##key#1_1_0: Seq Box;
  var ##msg#1_1_0: DatatypeType;
  var pkv##1_1_0: DatatypeType;
  var a##1_1_0: int;
  var newtype$check#1_1_0: int;
  var b##1_1_0: int;
  var ##pkv#1_1_0: DatatypeType;
  var newtype$check#1_1_1: int;
  var newtype$check#1_1_2: int;
  var keys##1_1_0: Seq Box;
  var key##1_1_0: Seq Box;
  var msgs##1_1_0: Seq Box;
  var msg##1_1_0: DatatypeType;
  var ##keys#1_1_1: Seq Box;
  var ##msgs#1_1_1: Seq Box;
  var ##pkv#1_2_0: DatatypeType;
  var ##key#1_2_0: Seq Box;
  var ##msg#1_2_0: DatatypeType;
  var ##keys#1_2_0: Seq Box;
  var ##msgs#1_2_0: Seq Box;
  var ##key#1_2_1: Seq Box;
  var ##msg#1_2_1: DatatypeType;
  var ##pkv#1_3_0: DatatypeType;
  var ##key#1_3_0: Seq Box;
  var ##msg#1_3_0: DatatypeType;
  var pkv##1_3_0: DatatypeType;
  var ##pkv#1_3_1: DatatypeType;
  var ##key#1_3_1: Seq Box;
  var ##msg#1_3_1: DatatypeType;
  var ##pkv#1_4_0: DatatypeType;
  var ##psa#1_4_0: DatatypeType;
  var ##pkv#1_4_1: DatatypeType;
  var newtype$check#1_4_0: int;
  var newtype$check#1_4_1: int;
  var ##pkv#1_4_2: DatatypeType;
  var ##key#1_4_0: Seq Box;
  var ##msg#1_4_0: DatatypeType;
  var ##pkv#1_0: DatatypeType;

    // AddMethodImpl: WeightBucketPkv_eq_WeightPkv, Impl$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(579,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(580,5)
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    assume PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0));
    assume PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0));
    if (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) == LitInt(0))
    {
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            ##pkv#0_0_0 := pkv#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), i#0_0_0)): Seq Box } 
                          LitInt(0) <= i#0_0_0
                               && i#0_0_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), i#0_0_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                     || (forall i#0_0_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)), i#0_0_1)): Seq Box } 
                      LitInt(0) <= i#0_0_1
                           && i#0_0_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)), i#0_0_1)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WeightPkv#canCall(pkv#0);
            assume PackedKV.__default.WeightPkv#canCall(pkv#0);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            ##pkv#0_0_1_0 := pkv#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_1_0, Tclass.PackedKV.Pkv(), $Heap);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                         == LitInt(0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1_0))) - 1)): int));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1_0))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                         == LitInt(0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                               - 1)): int));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1_0))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1_0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_1_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1_0)), i#0_0_1_0)): Seq Box } 
                          LitInt(0) <= i#0_0_1_0
                               && i#0_0_1_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1_0)), i#0_0_1_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                     || (forall i#0_0_1_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1_0)), i#0_0_1_1)): Seq Box } 
                      LitInt(0) <= i#0_0_1_1
                           && i#0_0_1_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1_0)), i#0_0_1_1)): Seq Box)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1_0)
               ==> PackedKV.__default.WF(##pkv#0_0_1_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_1_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WeightPkv#canCall(pkv#0);
            assume PackedKV.__default.WeightPkv#canCall(pkv#0);
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            assume true;
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            assert {:subsumption 0} PackedKV.__default.WeightPkv(pkv#0) == LitInt(0);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            assume true;
            // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            ##pkv#0_0_0_0 := pkv#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_0_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_0_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)), i#0_0_0_0)): Seq Box } 
                          LitInt(0) <= i#0_0_0_0
                               && i#0_0_0_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)), i#0_0_0_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                     || (forall i#0_0_0_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)), i#0_0_0_1)): Seq Box } 
                      LitInt(0) <= i#0_0_0_1
                           && i#0_0_0_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)), i#0_0_0_1)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0);
            assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0);
            // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(581,7)
            assert {:subsumption 0} LitInt(0) == DynamicPkv.__default.WeightBucketPkv(pkv#0);
            assume false;
        }

        assume PackedKV.__default.WeightPkv(pkv#0)
           == DynamicPkv.__default.WeightBucketPkv(pkv#0);
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(587,16)
        assume true;
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        ##pkv#4 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#4, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#10: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#10)): Seq Box } 
                      LitInt(0) <= i#10
                           && i#10 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#10)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
                 || (forall i#11: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#11)): Seq Box } 
                  LitInt(0) <= i#11
                       && i#11 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#11)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#4)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#4);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
        newtype$check#1 := LitInt(1);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        newtype$check#2 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        ##pkv#5 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#5, Tclass.PackedKV.Pkv(), $Heap);
        ##from#0 := LitInt(0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
        ##to#0 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#12: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#12)): Seq Box } 
                      LitInt(0) <= i#12
                           && i#12 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#12)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
                 || (forall i#13: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#13)): Seq Box } 
                  LitInt(0) <= i#13
                       && i#13 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#13)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
           ==> PackedKV.__default.WF(##pkv#5)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#5)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#5);
        assert {:subsumption 0} LitInt(0) <= ##from#0;
        assert {:subsumption 0} ##from#0 <= ##to#0;
        assert {:subsumption 0} ##to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(##pkv#5));
        assume LitInt(0) <= ##from#0
           && ##from#0 <= ##to#0
           && ##to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(##pkv#5));
        assume PackedKV.__default.subPkv#canCall(pkv#0, LitInt(0), PackedKV.__default.NumKVPairs(pkv#0) - 1);
        assume PackedKV.Pkv.Pkv_q(PackedKV.__default.subPkv(pkv#0, LitInt(0), PackedKV.__default.NumKVPairs(pkv#0) - 1));
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0)
           && PackedKV.__default.subPkv#canCall(pkv#0, LitInt(0), PackedKV.__default.NumKVPairs(pkv#0) - 1);
        pkv'#0 := PackedKV.__default.subPkv(pkv#0, LitInt(0), PackedKV.__default.NumKVPairs(pkv#0) - 1);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(587,61)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(588,15)
        assume true;
        ##pkv#6 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#6, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#14: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#14)): Seq Box } 
                      LitInt(0) <= i#14
                           && i#14 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#14)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
                 || (forall i#15: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#15)): Seq Box } 
                  LitInt(0) <= i#15
                       && i#15 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#15)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#6)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#6);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
        newtype$check#3 := LitInt(1);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        newtype$check#4 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        ##pkv#7 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#7, Tclass.PackedKV.Pkv(), $Heap);
        ##i#0 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#16: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), i#16)): Seq Box } 
                      LitInt(0) <= i#16
                           && i#16 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), i#16)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
                 || (forall i#17: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)), i#17)): Seq Box } 
                  LitInt(0) <= i#17
                       && i#17 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)), i#17)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
           ==> PackedKV.__default.WF(##pkv#7)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#7)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#7);
        assert {:subsumption 0} LitInt(0) <= ##i#0;
        assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)));
        assume LitInt(0) <= ##i#0
           && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)));
        assume PackedKV.__default.GetKey#canCall(pkv#0, PackedKV.__default.NumKVPairs(pkv#0) - 1);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0)
           && PackedKV.__default.GetKey#canCall(pkv#0, PackedKV.__default.NumKVPairs(pkv#0) - 1);
        key#0 := PackedKV.__default.GetKey(pkv#0, PackedKV.__default.NumKVPairs(pkv#0) - 1);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(588,58)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(589,15)
        assume true;
        ##pkv#8 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#8, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#18: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), i#18)): Seq Box } 
                      LitInt(0) <= i#18
                           && i#18 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), i#18)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
                 || (forall i#19: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)), i#19)): Seq Box } 
                  LitInt(0) <= i#19
                       && i#19 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)), i#19)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
           ==> PackedKV.__default.WF(##pkv#8)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#8)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#8);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
        newtype$check#5 := LitInt(1);
        assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        newtype$check#6 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        ##pkv#9 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#9, Tclass.PackedKV.Pkv(), $Heap);
        ##i#1 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#1, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#9))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#9))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#9)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#9)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#9)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#9)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#20: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)), i#20)): Seq Box } 
                      LitInt(0) <= i#20
                           && i#20 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)), i#20)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)))
                 || (forall i#21: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)), i#21)): Seq Box } 
                  LitInt(0) <= i#21
                       && i#21 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)), i#21)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
           ==> PackedKV.__default.WF(##pkv#9)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#9)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#9);
        assert {:subsumption 0} LitInt(0) <= ##i#1;
        assert {:subsumption 0} ##i#1
           < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)));
        assume LitInt(0) <= ##i#1
           && ##i#1
             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)));
        assume PackedKV.__default.GetMessage#canCall(pkv#0, PackedKV.__default.NumKVPairs(pkv#0) - 1);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0)
           && PackedKV.__default.GetMessage#canCall(pkv#0, PackedKV.__default.NumKVPairs(pkv#0) - 1);
        msg#0 := PackedKV.__default.GetMessage(pkv#0, PackedKV.__default.NumKVPairs(pkv#0) - 1);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(589,61)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(590,17)
        assume true;
        assume PackedKV.Pkv.Pkv_q(pkv'#0);
        ##psa#0 := PackedKV.Pkv.keys(pkv'#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
           ==> PackedStringArray.__default.WF(##psa#0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0));
        assume PackedStringArray.__default.WF(##psa#0);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#0), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#0), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#22: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#22)): Seq Box } 
              LitInt(0) <= i#22 && i#22 < Seq#Length(PackedStringArray.__default.I(##psa#0))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#22)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#0), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv'#0));
        assume PackedKV.Pkv.Pkv_q(pkv'#0)
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv'#0));
        keys'#0 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv'#0));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(590,39)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(591,17)
        assume true;
        assume PackedKV.Pkv.Pkv_q(pkv'#0);
        ##psa#1 := PackedKV.Pkv.messages(pkv'#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv'#0));
        assume PackedKV.Pkv.Pkv_q(pkv'#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv'#0));
        msgs'#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv'#0));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(591,47)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(592,16)
        assume true;
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#2 := PackedKV.Pkv.keys(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#2), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#2), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#23: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#23)): Seq Box } 
              LitInt(0) <= i#23 && i#23 < Seq#Length(PackedStringArray.__default.I(##psa#2))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#23)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#2), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0));
        keys#0 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(592,37)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(593,16)
        assume true;
        assume PackedKV.Pkv.Pkv_q(pkv#0);
        ##psa#3 := PackedKV.Pkv.messages(pkv#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#3));
        assume PackedStringArray.__default.WF(##psa#3);
        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        assume PackedKV.Pkv.Pkv_q(pkv#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
        msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(593,45)"} true;
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##pkv#1_0 := pkv#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), i#1_0)): Seq Box } 
                          LitInt(0) <= i#1_0
                               && i#1_0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), i#1_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
                     || (forall i#1_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)), i#1_1)): Seq Box } 
                      LitInt(0) <= i#1_1
                           && i#1_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)), i#1_1)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
               ==> PackedKV.__default.WF(##pkv#1_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WeightPkv#canCall(pkv#0);
            assume PackedKV.__default.WeightPkv#canCall(pkv#0);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##pkv#1_4_0 := pkv#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_4_0, Tclass.PackedKV.Pkv(), $Heap);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_0)))
                         == LitInt(0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_0))) - 1)): int));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_0))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_0)))
                         == LitInt(0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_0)))
                               - 1)): int));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_0))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_4_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_0)), i#1_4_0)): Seq Box } 
                          LitInt(0) <= i#1_4_0
                               && i#1_4_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_0)), i#1_4_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_0)))
                     || (forall i#1_4_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_0)), i#1_4_1)): Seq Box } 
                      LitInt(0) <= i#1_4_1
                           && i#1_4_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_0)), i#1_4_1)): Seq Box)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_0)
               ==> PackedKV.__default.WF(##pkv#1_4_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_4_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WeightPkv#canCall(pkv#0);
            assume PackedKV.__default.WeightPkv#canCall(pkv#0);
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(600,11)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#1_4_0 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#1_4_0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_4_0)
               ==> PackedStringArray.__default.WF(##psa#1_4_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_4_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_4_0)
               ==> PackedStringArray.__default.WF(##psa#1_4_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#1_4_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_4_0)
               ==> PackedStringArray.__default.WF(##psa#1_4_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_4_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_4_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_4_0)
               ==> PackedStringArray.__default.WF(##psa#1_4_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_4_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_4_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_4_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#1_4_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_4_0)
               ==> PackedStringArray.__default.WF(##psa#1_4_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#1_4_0));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0));
            ##pkv#1_4_1 := pkv#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_4_1, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_1))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_1))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_1))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_1)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_1)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_1)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_1)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_1)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_1)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_1)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_4_2: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_1)), i#1_4_2)): Seq Box } 
                          LitInt(0) <= i#1_4_2
                               && i#1_4_2
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_1)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_1)), i#1_4_2)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_1)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_1)))
                     || (forall i#1_4_3: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_1)), i#1_4_3)): Seq Box } 
                      LitInt(0) <= i#1_4_3
                           && i#1_4_3
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_1)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_1)), i#1_4_3)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_1)
               ==> PackedKV.__default.WF(##pkv#1_4_1)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_4_1)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
            newtype$check#1_4_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#1_4_0 && newtype$check#1_4_0 < 18446744073709551616;
            newtype$check#1_4_1 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
            assert LitInt(0) <= newtype$check#1_4_1 && newtype$check#1_4_1 < 18446744073709551616;
            assert {:subsumption 0} 0 <= PackedKV.__default.NumKVPairs(pkv#0) - 1
               && PackedKV.__default.NumKVPairs(pkv#0) - 1
                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)));
            assume ValueType.__default.MaxLen#canCall();
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0))
               && PackedKV.__default.NumKVPairs#canCall(pkv#0)
               && ValueType.__default.MaxLen#canCall();
            assert Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), 
                    PackedKV.__default.NumKVPairs(pkv#0) - 1)): Seq Box)
               <= LitInt(ValueType.__default.MaxLen());
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##pkv#1_4_2 := pkv'#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_4_2, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_2))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_2))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_2))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_2)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_2)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_2))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_2)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_4_2)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_2)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_2))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_4_2))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_2))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_2))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_2))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_2))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_2)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_2)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_2))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_2)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_4_2)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_2)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_2)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_4_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_4_2))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_2))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_4_2)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_4_2)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_2)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_2)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_2)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_2)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_4_4: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_2)), i#1_4_4)): Seq Box } 
                          LitInt(0) <= i#1_4_4
                               && i#1_4_4
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_2)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_4_2)), i#1_4_4)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_2)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_2)))
                     || (forall i#1_4_5: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_2)), i#1_4_5)): Seq Box } 
                      LitInt(0) <= i#1_4_5
                           && i#1_4_5
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_2)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_4_2)), i#1_4_5)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_4_2)
               ==> PackedKV.__default.WF(##pkv#1_4_2)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_4_2)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WeightPkv#canCall(pkv'#0);
            ##key#1_4_0 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#1_4_0, Tclass.KeyType.Key(), $Heap);
            assume BucketWeights.__default.WeightKey#canCall(key#0);
            ##msg#1_4_0 := msg#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msg#1_4_0, Tclass.ValueMessage.Message(), $Heap);
            assume BucketWeights.__default.WeightMessage#canCall(msg#0);
            assume PackedKV.__default.WeightPkv#canCall(pkv'#0)
               && BucketWeights.__default.WeightKey#canCall(key#0)
               && BucketWeights.__default.WeightMessage#canCall(msg#0);
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            assert {:subsumption 0} PackedKV.__default.WeightPkv(pkv#0)
               == PackedKV.__default.WeightPkv(pkv'#0)
                 + BucketWeights.__default.WeightKey(key#0)
                 + BucketWeights.__default.WeightMessage(msg#0);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##pkv#1_3_0 := pkv'#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_3_0, Tclass.PackedKV.Pkv(), $Heap);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_3_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_3_0)))
                         == LitInt(0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_3_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_0))) - 1)): int));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_0))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_3_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_3_0)))
                         == LitInt(0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_3_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_0)))
                               - 1)): int));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_0))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_3_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_0)), i#1_3_0)): Seq Box } 
                          LitInt(0) <= i#1_3_0
                               && i#1_3_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_0)), i#1_3_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_0)))
                     || (forall i#1_3_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_0)), i#1_3_1)): Seq Box } 
                      LitInt(0) <= i#1_3_1
                           && i#1_3_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_0)), i#1_3_1)): Seq Box)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_0)
               ==> PackedKV.__default.WF(##pkv#1_3_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_3_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WeightPkv#canCall(pkv'#0);
            ##key#1_3_0 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#1_3_0, Tclass.KeyType.Key(), $Heap);
            assume BucketWeights.__default.WeightKey#canCall(key#0);
            ##msg#1_3_0 := msg#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msg#1_3_0, Tclass.ValueMessage.Message(), $Heap);
            assume BucketWeights.__default.WeightMessage#canCall(msg#0);
            assume PackedKV.__default.WeightPkv#canCall(pkv'#0)
               && BucketWeights.__default.WeightKey#canCall(key#0)
               && BucketWeights.__default.WeightMessage#canCall(msg#0);
            // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(611,39)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            pkv##1_3_0 := pkv'#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert 0 <= PackedKV.__default.NumKVPairs(pkv#0)
               || PackedKV.__default.NumKVPairs(pkv##1_3_0)
                 == PackedKV.__default.NumKVPairs(pkv#0);
            assert PackedKV.__default.NumKVPairs(pkv##1_3_0) < PackedKV.__default.NumKVPairs(pkv#0);
            // ProcessCallStmt: Make the call
            call Call$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv##1_3_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(611,44)"} true;
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##pkv#1_3_1 := pkv'#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_3_1, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_3_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_3_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_1))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_3_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_1))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_3_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_3_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_3_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_1))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_3_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_1)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_3_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_3_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_3_1)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_3_1)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_1)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_1)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_1)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_1)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_3_2: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_1)), i#1_3_2)): Seq Box } 
                          LitInt(0) <= i#1_3_2
                               && i#1_3_2
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_1)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_3_1)), i#1_3_2)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_1)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_1)))
                     || (forall i#1_3_3: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_1)), i#1_3_3)): Seq Box } 
                      LitInt(0) <= i#1_3_3
                           && i#1_3_3
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_1)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_3_1)), i#1_3_3)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_3_1)
               ==> PackedKV.__default.WF(##pkv#1_3_1)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_3_1)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv'#0);
            ##key#1_3_1 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#1_3_1, Tclass.KeyType.Key(), $Heap);
            assume BucketWeights.__default.WeightKey#canCall(key#0);
            ##msg#1_3_1 := msg#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msg#1_3_1, Tclass.ValueMessage.Message(), $Heap);
            assume BucketWeights.__default.WeightMessage#canCall(msg#0);
            assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv'#0)
               && BucketWeights.__default.WeightKey#canCall(key#0)
               && BucketWeights.__default.WeightMessage#canCall(msg#0);
            // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            assert {:subsumption 0} PackedKV.__default.WeightPkv(pkv'#0)
                 + BucketWeights.__default.WeightKey(key#0)
                 + BucketWeights.__default.WeightMessage(msg#0)
               == DynamicPkv.__default.WeightBucketPkv(pkv'#0)
                 + BucketWeights.__default.WeightKey(key#0)
                 + BucketWeights.__default.WeightMessage(msg#0);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##pkv#1_2_0 := pkv'#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_2_0, Tclass.PackedKV.Pkv(), $Heap);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_2_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_2_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_2_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_2_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_2_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_2_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_2_0)))
                         == LitInt(0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_2_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_2_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_2_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_2_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_2_0))) - 1)): int));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_2_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_2_0))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_2_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_2_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_2_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_2_0)))
                       < 4294967296);
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_2_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_2_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_2_0)))
                         == LitInt(0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_2_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_2_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_2_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_2_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_2_0)))
                               - 1)): int));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_2_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_2_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_2_0))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_2_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_2_0)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_2_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_2_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_2_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_2_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_2_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_2_0)), i#1_2_0)): Seq Box } 
                          LitInt(0) <= i#1_2_0
                               && i#1_2_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_2_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_2_0)), i#1_2_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_2_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_2_0)))
                     || (forall i#1_2_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_2_0)), i#1_2_1)): Seq Box } 
                      LitInt(0) <= i#1_2_1
                           && i#1_2_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_2_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_2_0)), i#1_2_1)): Seq Box)));
            assume {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_2_0)
               ==> PackedKV.__default.WF(##pkv#1_2_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_2_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv'#0);
            ##key#1_2_0 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#1_2_0, Tclass.KeyType.Key(), $Heap);
            assume BucketWeights.__default.WeightKey#canCall(key#0);
            ##msg#1_2_0 := msg#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msg#1_2_0, Tclass.ValueMessage.Message(), $Heap);
            assume BucketWeights.__default.WeightMessage#canCall(msg#0);
            assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv'#0)
               && BucketWeights.__default.WeightKey#canCall(key#0)
               && BucketWeights.__default.WeightMessage#canCall(msg#0);
            // ----- Hint2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##keys#1_2_0 := keys'#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#1_2_0, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(keys'#0);
            ##msgs#1_2_0 := msgs'#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#1_2_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(msgs'#0);
            ##key#1_2_1 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#1_2_1, Tclass.KeyType.Key(), $Heap);
            assume BucketWeights.__default.WeightKey#canCall(key#0);
            ##msg#1_2_1 := msg#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msg#1_2_1, Tclass.ValueMessage.Message(), $Heap);
            assume BucketWeights.__default.WeightMessage#canCall(msg#0);
            assume BucketWeights.__default.WeightKeyList#canCall(keys'#0)
               && BucketWeights.__default.WeightMessageList#canCall(msgs'#0)
               && BucketWeights.__default.WeightKey#canCall(key#0)
               && BucketWeights.__default.WeightMessage#canCall(msg#0);
            // ----- assert line2 == line3 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            assert {:subsumption 0} DynamicPkv.__default.WeightBucketPkv(pkv'#0)
                 + BucketWeights.__default.WeightKey(key#0)
                 + BucketWeights.__default.WeightMessage(msg#0)
               == BucketWeights.__default.WeightKeyList(keys'#0)
                 + BucketWeights.__default.WeightMessageList(msgs'#0)
                 + BucketWeights.__default.WeightKey(key#0)
                 + BucketWeights.__default.WeightMessage(msg#0);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##keys#1_1_0 := keys'#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#1_1_0, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(keys'#0);
            ##msgs#1_1_0 := msgs'#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#1_1_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(msgs'#0);
            ##key#1_1_0 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#1_1_0, Tclass.KeyType.Key(), $Heap);
            assume BucketWeights.__default.WeightKey#canCall(key#0);
            ##msg#1_1_0 := msg#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msg#1_1_0, Tclass.ValueMessage.Message(), $Heap);
            assume BucketWeights.__default.WeightMessage#canCall(msg#0);
            assume BucketWeights.__default.WeightKeyList#canCall(keys'#0)
               && BucketWeights.__default.WeightMessageList#canCall(msgs'#0)
               && BucketWeights.__default.WeightKey#canCall(key#0)
               && BucketWeights.__default.WeightMessage#canCall(msg#0);
            // ----- Hint3 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(615,25)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            pkv##1_1_0 := pkv#0;
            newtype$check#1_1_0 := LitInt(0);
            assert LitInt(0) <= newtype$check#1_1_0 && newtype$check#1_1_0 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            a##1_1_0 := LitInt(0);
            ##pkv#1_1_0 := pkv#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_1_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_1_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_1_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_1_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_1_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_1_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_1_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_1_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_1_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_1_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_1_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_1_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_1_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_1_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_1_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_1_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_1_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_1_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_1_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_1_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_1_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_1_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_1_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_1_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_1_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_1_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_1_0)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_1_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_1_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_1_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_1_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_1_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_1_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_1_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_1_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_1_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_1_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_1_0)), i#1_1_0)): Seq Box } 
                          LitInt(0) <= i#1_1_0
                               && i#1_1_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_1_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_1_0)), i#1_1_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_1_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_1_0)))
                     || (forall i#1_1_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_1_0)), i#1_1_1)): Seq Box } 
                      LitInt(0) <= i#1_1_1
                           && i#1_1_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_1_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_1_0)), i#1_1_1)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_1_0)
               ==> PackedKV.__default.WF(##pkv#1_1_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_1_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#1_1_0);
            assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
            newtype$check#1_1_1 := LitInt(1);
            assert LitInt(0) <= newtype$check#1_1_1 && newtype$check#1_1_1 < 18446744073709551616;
            newtype$check#1_1_2 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
            assert LitInt(0) <= newtype$check#1_1_2 && newtype$check#1_1_2 < 18446744073709551616;
            assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
            // ProcessCallStmt: CheckSubrange
            b##1_1_0 := PackedKV.__default.NumKVPairs(pkv#0) - 1;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$DynamicPkv.__default.IMessagesSlice(pkv##1_1_0, a##1_1_0, b##1_1_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(615,58)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(616,11)
            assume true;
            assert Seq#Equal(Seq#Append(keys'#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))), keys#0);
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(617,11)
            assume true;
            assert Seq#Equal(Seq#Append(msgs'#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))), msgs#0);
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(618,32)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            keys##1_1_0 := keys'#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            key##1_1_0 := key#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$BucketWeights.__default.WeightKeyListPushBack(keys##1_1_0, key##1_1_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(618,43)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(619,36)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            msgs##1_1_0 := msgs'#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            msg##1_1_0 := msg#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$BucketWeights.__default.WeightMessageListPushBack(msgs##1_1_0, msg##1_1_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(619,47)"} true;
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##keys#1_1_1 := keys#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#1_1_1, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(keys#0);
            ##msgs#1_1_1 := msgs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#1_1_1, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(msgs#0);
            assume BucketWeights.__default.WeightKeyList#canCall(keys#0)
               && BucketWeights.__default.WeightMessageList#canCall(msgs#0);
            // ----- assert line3 == line4 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            assert {:subsumption 0} BucketWeights.__default.WeightKeyList(keys'#0)
                 + BucketWeights.__default.WeightMessageList(msgs'#0)
                 + BucketWeights.__default.WeightKey(key#0)
                 + BucketWeights.__default.WeightMessage(msg#0)
               == BucketWeights.__default.WeightKeyList(keys#0)
                 + BucketWeights.__default.WeightMessageList(msgs#0);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##keys#1_0_0 := keys#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#1_0_0, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(keys#0);
            ##msgs#1_0_0 := msgs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#1_0_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(msgs#0);
            assume BucketWeights.__default.WeightKeyList#canCall(keys#0)
               && BucketWeights.__default.WeightMessageList#canCall(msgs#0);
            // ----- Hint4 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            ##pkv#1_0_0 := pkv#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1_0_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#1_0_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)), i#1_0_0)): Seq Box } 
                          LitInt(0) <= i#1_0_0
                               && i#1_0_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0_0)), i#1_0_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)))
                     || (forall i#1_0_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)), i#1_0_1)): Seq Box } 
                      LitInt(0) <= i#1_0_1
                           && i#1_0_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0_0)), i#1_0_1)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0_0)
               ==> PackedKV.__default.WF(##pkv#1_0_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_0_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0);
            assume DynamicPkv.__default.WeightBucketPkv#canCall(pkv#0);
            // ----- assert line4 == line5 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(594,7)
            assert {:subsumption 0} BucketWeights.__default.WeightKeyList(keys#0)
                 + BucketWeights.__default.WeightMessageList(msgs#0)
               == DynamicPkv.__default.WeightBucketPkv(pkv#0);
            assume false;
        }

        assume PackedKV.__default.WeightPkv(pkv#0)
           == DynamicPkv.__default.WeightBucketPkv(pkv#0);
    }
}



// function declaration for DynamicPkv._default.PkvWeightBound
function DynamicPkv.__default.PkvWeightBound() : int;

function DynamicPkv.__default.PkvWeightBound#canCall() : bool;

// consequence axiom for DynamicPkv.__default.PkvWeightBound
axiom 49 <= $FunctionContextHeight
   ==> 
  DynamicPkv.__default.PkvWeightBound#canCall() || 49 != $FunctionContextHeight
   ==> true;

function DynamicPkv.__default.PkvWeightBound#requires() : bool;

// #requires axiom for DynamicPkv.__default.PkvWeightBound
axiom DynamicPkv.__default.PkvWeightBound#requires() == true;

// definition axiom for DynamicPkv.__default.PkvWeightBound(revealed)
axiom 49 <= $FunctionContextHeight
   ==> 
  DynamicPkv.__default.PkvWeightBound#canCall() || 49 != $FunctionContextHeight
   ==> NativeTypes.__default.Uint32UpperBound#canCall()
     && DynamicPkv.__default.PkvWeightBound()
       == LitInt(Mul(LitInt(10), LitInt(NativeTypes.__default.Uint32UpperBound() - 1)));

// definition axiom for DynamicPkv.__default.PkvWeightBound for all literals(revealed)
axiom 49 <= $FunctionContextHeight
   ==> 
  DynamicPkv.__default.PkvWeightBound#canCall() || 49 != $FunctionContextHeight
   ==> NativeTypes.__default.Uint32UpperBound#canCall()
     && DynamicPkv.__default.PkvWeightBound()
       == LitInt(Mul(LitInt(10), LitInt(NativeTypes.__default.Uint32UpperBound() - 1)));

procedure CheckWellformed$$DynamicPkv.__default.PkvWeightBound();
  free requires 49 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.PkvWeightBound()
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function PkvWeightBound
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(627,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume NativeTypes.__default.Uint32UpperBound#canCall();
        assume DynamicPkv.__default.PkvWeightBound()
           == LitInt(Mul(LitInt(10), LitInt(NativeTypes.__default.Uint32UpperBound() - 1)));
        assume NativeTypes.__default.Uint32UpperBound#canCall();
        // CheckWellformedWithResult: any expression
        assume $Is(DynamicPkv.__default.PkvWeightBound(), TInt);
        assert b$reqreads#0;
    }
}



procedure CheckWellformed$$DynamicPkv.__default.WeightEmptySeq();
  free requires 37 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$DynamicPkv.__default.WeightEmptySeq();
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightKeyList#canCall(Lit(Seq#Empty(): Seq Box));
  ensures LitInt(BucketWeights.__default.WeightKeyList(Lit(Seq#Empty(): Seq Box)))
     == LitInt(0);
  free ensures BucketWeights.__default.WeightMessageList#canCall(Lit(Seq#Empty(): Seq Box));
  ensures LitInt(BucketWeights.__default.WeightMessageList(Lit(Seq#Empty(): Seq Box)))
     == LitInt(0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.WeightEmptySeq() returns ($_reverifyPost: bool);
  free requires 37 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightKeyList#canCall(Lit(Seq#Empty(): Seq Box));
  ensures LitInt(BucketWeights.__default.WeightKeyList(Lit(Seq#Empty(): Seq Box)))
     == LitInt(0);
  free ensures BucketWeights.__default.WeightMessageList#canCall(Lit(Seq#Empty(): Seq Box));
  ensures LitInt(BucketWeights.__default.WeightMessageList(Lit(Seq#Empty(): Seq Box)))
     == LitInt(0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.WeightEmptySeq() returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: WeightEmptySeq, Impl$$DynamicPkv.__default.WeightEmptySeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(815,2): initial state"} true;
    $_reverifyPost := false;
}



procedure CheckWellformed$$DynamicPkv.__default.MergeToOneChild(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    from0#0: int where LitInt(0) <= from0#0 && from0#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616, 
    bot#0: DatatypeType
       where $Is(bot#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(bot#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(bot#0), 
    slack0#0: int where LitInt(0) <= slack0#0 && slack0#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.SingleMergeResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.SingleMergeResult(), $Heap));
  free requires 38 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.MergeToOneChild(top#0: DatatypeType, from0#0: int, to#0: int, bot#0: DatatypeType, slack0#0: int)
   returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var ##pkv#1: DatatypeType;
  var ##pkv#2: DatatypeType;
  var newtype$check#0: int;
  var ##pkv#3: DatatypeType;
  var ##pkv#4: DatatypeType;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##pkv#5: DatatypeType;
  var ##pkv#6: DatatypeType;
  var newtype$check#3: int;
  var ##pkv#7: DatatypeType;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var newtype$check#6: int;
  var ##top_keys#0: Seq Box;
  var ##top_msgs#0: Seq Box;
  var ##from#0: int;
  var ##to#0: int;
  var ##bot_keys#0: Seq Box;
  var ##bot_msgs#0: Seq Box;
  var ##bot_from#0: int;
  var ##acc_keys#0: Seq Box;
  var ##acc_msgs#0: Seq Box;
  var ##slack#0: int;
  var ##psa#4: DatatypeType;
  var ##keys#0: Seq Box;
  var ##psa#5: DatatypeType;
  var ##msgs#0: Seq Box;
  var ##psa#6: DatatypeType;
  var ##keys#1: Seq Box;
  var ##psa#7: DatatypeType;
  var ##msgs#1: Seq Box;

    // AddMethodImpl: MergeToOneChild, CheckWellformed$$DynamicPkv.__default.MergeToOneChild
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(846,9): initial state"} true;
    ##pkv#0 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(top#0);
    assume PackedKV.__default.WF(top#0);
    ##pkv#1 := bot#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(bot#0);
    assume PackedKV.__default.WF(bot#0);
    if (from0#0 <= to#0)
    {
        ##pkv#2 := top#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#0)): Seq Box } 
                      LitInt(0) <= i#0
                           && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
           ==> PackedKV.__default.WF(##pkv#2)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#2);
        assume PackedKV.__default.NumKVPairs#canCall(top#0);
    }

    assume from0#0 <= to#0 && to#0 <= PackedKV.__default.NumKVPairs(top#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    ##pkv#3 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#2)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#3)): Seq Box } 
              LitInt(0) <= i#3
                   && i#3 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#3)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#3);
    assume PackedKV.__default.NumKVPairs#canCall(top#0);
    if (LitInt(0) <= PackedKV.__default.NumKVPairs(top#0))
    {
        ##pkv#4 := top#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#4, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#4: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#4)): Seq Box } 
                      LitInt(0) <= i#4
                           && i#4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#4)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
                 || (forall i#5: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#5)): Seq Box } 
                  LitInt(0) <= i#5
                       && i#5 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#5)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
           ==> PackedKV.__default.WF(##pkv#4)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#4)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#4);
        assume PackedKV.__default.NumKVPairs#canCall(top#0);
        newtype$check#1 := LitInt(268435456);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    }

    assume LitInt(0) <= PackedKV.__default.NumKVPairs(top#0)
       && PackedKV.__default.NumKVPairs(top#0) < 268435456;
    newtype$check#2 := LitInt(0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    ##pkv#5 := bot#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#5, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#6: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#6)): Seq Box } 
                  LitInt(0) <= i#6
                       && i#6 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#6)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
             || (forall i#7: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#7)): Seq Box } 
              LitInt(0) <= i#7
                   && i#7 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#7)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#5)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#5);
    assume PackedKV.__default.NumKVPairs#canCall(bot#0);
    if (LitInt(0) <= PackedKV.__default.NumKVPairs(bot#0))
    {
        ##pkv#6 := bot#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#6, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#8: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#8)): Seq Box } 
                      LitInt(0) <= i#8
                           && i#8 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#8)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
                 || (forall i#9: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#9)): Seq Box } 
                  LitInt(0) <= i#9
                       && i#9 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#9)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
           ==> PackedKV.__default.WF(##pkv#6)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#6)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#6);
        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
        newtype$check#3 := LitInt(268435456);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    }

    assume LitInt(0) <= PackedKV.__default.NumKVPairs(bot#0)
       && PackedKV.__default.NumKVPairs(bot#0) < 268435456;
    ##pkv#7 := bot#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#7, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#7)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#7))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#7)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#7))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#7))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#7)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#7)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#10: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), i#10)): Seq Box } 
                  LitInt(0) <= i#10
                       && i#10 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#7)), i#10)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
             || (forall i#11: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)), i#11)): Seq Box } 
              LitInt(0) <= i#11
                   && i#11 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#7)), i#11)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#7)
       ==> PackedKV.__default.WF(##pkv#7)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#7)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#7);
    assume DynamicPkv.__default.WeightBucketPkv#canCall(bot#0);
    assume Bounds.__default.MaxTotalBucketWeight#canCall();
    assume DynamicPkv.__default.WeightBucketPkv(bot#0) + slack0#0
       <= LitInt(Bounds.__default.MaxTotalBucketWeight());
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(855,21): post-state"} true;
    assume DynamicPkv.SingleMergeResult.WF#canCall(result#0);
    assume DynamicPkv.SingleMergeResult.WF(result#0);
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0)) || Lit(true);
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#12: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                            i#12)): Seq Box } 
                      LitInt(0) <= i#12
                           && i#12
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                                i#12)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen())))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                 || (forall i#13: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))), 
                        i#13)): Seq Box } 
                  LitInt(0) <= i#13
                       && i#13
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))), 
                          i#13)): Seq Box))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))), 
              $Box(ValueMessage.__default.IdentityMessage())));
    assume DynamicPkv.SingleMergeResult.WF(result#0);
    assume DynamicPkv.SingleMergeResult.I#canCall(result#0);
    assume PackedKV.Pkv.Pkv_q(top#0);
    ##psa#0 := PackedKV.Pkv.keys(top#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0));
    assume PackedKV.Pkv.Pkv_q(top#0);
    ##psa#1 := PackedKV.Pkv.messages(top#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0));
    newtype$check#4 := from0#0;
    assert LitInt(0) <= newtype$check#4;
    newtype$check#5 := to#0;
    assert LitInt(0) <= newtype$check#5;
    assume PackedKV.Pkv.Pkv_q(bot#0);
    ##psa#2 := PackedKV.Pkv.keys(bot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0));
    assume PackedKV.Pkv.Pkv_q(bot#0);
    ##psa#3 := PackedKV.Pkv.messages(bot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
    newtype$check#6 := slack0#0;
    assert LitInt(0) <= newtype$check#6;
    assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
      TSeq(Tclass.KeyType.Key()));
    ##top_keys#0 := PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##top_keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    ##top_msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##top_msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    ##from#0 := from0#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#0, Tclass._System.nat(), $Heap);
    ##to#0 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#0, Tclass._System.nat(), $Heap);
    assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
      TSeq(Tclass.KeyType.Key()));
    ##bot_keys#0 := PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##bot_keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    ##bot_msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##bot_msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assert $Is(LitInt(0), Tclass._System.nat());
    ##bot_from#0 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bot_from#0, Tclass._System.nat(), $Heap);
    ##acc_keys#0 := Lit(Seq#Empty(): Seq Box);
    // assume allocatedness for argument to function
    assume $IsAlloc(##acc_keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    ##acc_msgs#0 := Lit(Seq#Empty(): Seq Box);
    // assume allocatedness for argument to function
    assume $IsAlloc(##acc_msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    ##slack#0 := slack0#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##slack#0, Tclass._System.nat(), $Heap);
    assert {:subsumption 0} Seq#Length(##top_keys#0) == Seq#Length(##top_msgs#0);
    assume Seq#Length(##top_keys#0) == Seq#Length(##top_msgs#0);
    assert {:subsumption 0} Seq#Length(##bot_keys#0) == Seq#Length(##bot_msgs#0);
    assume Seq#Length(##bot_keys#0) == Seq#Length(##bot_msgs#0);
    assert {:subsumption 0} Seq#Length(##acc_keys#0) == Seq#Length(##acc_msgs#0);
    assume Seq#Length(##acc_keys#0) == Seq#Length(##acc_msgs#0);
    assert {:subsumption 0} ##from#0 <= ##to#0;
    assert {:subsumption 0} ##to#0 <= Seq#Length(##top_keys#0);
    assume ##from#0 <= ##to#0 && ##to#0 <= Seq#Length(##top_keys#0);
    assert {:subsumption 0} ##bot_from#0 <= Seq#Length(##bot_keys#0);
    assume ##bot_from#0 <= Seq#Length(##bot_keys#0);
    assume BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      from0#0, 
      to#0, 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
      LitInt(0), 
      Lit(Seq#Empty(): Seq Box), 
      Lit(Seq#Empty(): Seq Box), 
      slack0#0);
    assume BucketModel.singleMergeResult#Equal(DynamicPkv.SingleMergeResult.I(result#0), 
      BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
        PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
        PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
        from0#0, 
        to#0, 
        PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
        PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
        LitInt(0), 
        Lit(Seq#Empty(): Seq Box), 
        Lit(Seq#Empty(): Seq Box), 
        slack0#0));
    assume DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(result#0));
    ##psa#4 := PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#4), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#4), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#14: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#4), i#14)): Seq Box } 
          LitInt(0) <= i#14 && i#14 < Seq#Length(PackedStringArray.__default.I(##psa#4))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#4), i#14)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#4), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)));
    ##keys#0 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))));
    assume DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(result#0));
    ##psa#5 := PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)));
    ##msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))));
    assume DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0);
    assume PackedKV.Pkv.Pkv_q(bot#0);
    ##psa#6 := PackedKV.Pkv.keys(bot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#6), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#6), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#15: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#6), i#15)): Seq Box } 
          LitInt(0) <= i#15 && i#15 < Seq#Length(PackedStringArray.__default.I(##psa#6))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#6), i#15)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#6), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0));
    ##keys#1 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#1, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
    assume PackedKV.Pkv.Pkv_q(bot#0);
    ##psa#7 := PackedKV.Pkv.messages(bot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#7));
    assume PackedStringArray.__default.WF(##psa#7);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
    ##msgs#1 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#1, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
    assume BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
         + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
         + DynamicPkv.SingleMergeResult.slack(result#0)
       == BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)))
         + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)))
         + slack0#0;
}



procedure Call$$DynamicPkv.__default.MergeToOneChild(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    from0#0: int where LitInt(0) <= from0#0 && from0#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616, 
    bot#0: DatatypeType
       where $Is(bot#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(bot#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(bot#0), 
    slack0#0: int where LitInt(0) <= slack0#0 && slack0#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.SingleMergeResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.SingleMergeResult(), $Heap));
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#16: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), i#16)): Seq Box } 
                LitInt(0) <= i#16
                     && i#16 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), i#16)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
           || (forall i#17: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)), i#17)): Seq Box } 
            LitInt(0) <= i#17
                 && i#17 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)), i#17)): Seq Box)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(bot#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(bot#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(bot#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(bot#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(bot#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(bot#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(bot#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(bot#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(bot#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(bot#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(bot#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(bot#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(bot#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(bot#0))));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(bot#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(bot#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(bot#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(bot#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(bot#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(bot#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(bot#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(bot#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(bot#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(bot#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(bot#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(bot#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(bot#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(bot#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(bot#0))));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(bot#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(bot#0)));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#18: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), i#18)): Seq Box } 
                LitInt(0) <= i#18
                     && i#18 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), i#18)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(bot#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(bot#0)))
           || (forall i#19: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(bot#0)), i#19)): Seq Box } 
            LitInt(0) <= i#19
                 && i#19 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(bot#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(bot#0)), i#19)): Seq Box)));
  requires PackedKV.__default.WF#canCall(bot#0)
     ==> PackedKV.__default.WF(bot#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires from0#0 <= to#0;
  requires to#0 <= PackedKV.__default.NumKVPairs(top#0);
  requires LitInt(0) <= PackedKV.__default.NumKVPairs(top#0);
  requires PackedKV.__default.NumKVPairs(top#0) < 268435456;
  requires LitInt(0) <= PackedKV.__default.NumKVPairs(bot#0);
  requires PackedKV.__default.NumKVPairs(bot#0) < 268435456;
  requires DynamicPkv.__default.WeightBucketPkv(bot#0) + slack0#0
     <= LitInt(Bounds.__default.MaxTotalBucketWeight());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0);
  free ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     && 
    Lit(DynamicPkv.SingleMergeResult.WF(result#0))
     && 
    true
     && PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0));
  free ensures $IsA#BucketModel.singleMergeResult(Lit(DynamicPkv.SingleMergeResult.I(result#0)))
     && $IsA#BucketModel.singleMergeResult(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
        PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
        PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
        from0#0, 
        to#0, 
        PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
        PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
        LitInt(0), 
        Lit(Seq#Empty(): Seq Box), 
        Lit(Seq#Empty(): Seq Box), 
        slack0#0))
     && 
    DynamicPkv.SingleMergeResult.I#canCall(result#0)
     && 
    PackedKV.Pkv.Pkv_q(top#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0))
     && 
    PackedKV.Pkv.Pkv_q(top#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
     && 
    PackedKV.Pkv.Pkv_q(bot#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
     && 
    PackedKV.Pkv.Pkv_q(bot#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
     && BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      from0#0, 
      to#0, 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
      LitInt(0), 
      Lit(Seq#Empty(): Seq Box), 
      Lit(Seq#Empty(): Seq Box), 
      slack0#0);
  ensures BucketModel.singleMergeResult#Equal(DynamicPkv.SingleMergeResult.I(result#0), 
    BucketModel.__default.mergeToOneChild(StartFuelAssert_BucketModel._default.mergeToOneChild, 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      from0#0, 
      to#0, 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
      LitInt(0), 
      Lit(Seq#Empty(): Seq Box), 
      Lit(Seq#Empty(): Seq Box), 
      slack0#0));
  free ensures (DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0))
     && PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(result#0))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
     && 
    (DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0))
     && PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(result#0))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
     && (DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0))
     && 
    PackedKV.Pkv.Pkv_q(bot#0)
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)))
     && 
    PackedKV.Pkv.Pkv_q(bot#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
  ensures BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
       + DynamicPkv.SingleMergeResult.slack(result#0)
     == BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)))
       + slack0#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.__default.MergeToOneChild(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    from0#0: int where LitInt(0) <= from0#0 && from0#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616, 
    bot#0: DatatypeType
       where $Is(bot#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(bot#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(bot#0), 
    slack0#0: int where LitInt(0) <= slack0#0 && slack0#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.SingleMergeResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.SingleMergeResult(), $Heap), 
    $_reverifyPost: bool);
  free requires 38 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(top#0)
     && 
    PackedKV.__default.WF(top#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  free requires PackedKV.__default.WF#canCall(bot#0)
     && 
    PackedKV.__default.WF(bot#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(bot#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(bot#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(bot#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(bot#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(bot#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  requires from0#0 <= to#0;
  requires to#0 <= PackedKV.__default.NumKVPairs(top#0);
  requires LitInt(0) <= PackedKV.__default.NumKVPairs(top#0);
  requires PackedKV.__default.NumKVPairs(top#0) < 268435456;
  requires LitInt(0) <= PackedKV.__default.NumKVPairs(bot#0);
  requires PackedKV.__default.NumKVPairs(bot#0) < 268435456;
  requires DynamicPkv.__default.WeightBucketPkv(bot#0) + slack0#0
     <= LitInt(Bounds.__default.MaxTotalBucketWeight());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0);
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0)) || Lit(true);
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                 < 4294967296));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                 < 4294967296));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                   == LitInt(0))));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                         - 1)): int)));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                 < 4294967296));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                 < 4294967296));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                   == LitInt(0))));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                         - 1)): int)));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
             == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
             ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
               || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                  LitInt(KeyType.__default.MaxLen()))
                 ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   || (forall i#26: int :: 
                    { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                          i#26)): Seq Box } 
                    LitInt(0) <= i#26
                         && i#26
                           < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
                       ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))), 
                              i#26)): Seq Box)
                         <= LitInt(KeyType.__default.MaxLen())))));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
             ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
               || (forall i#27: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))), 
                      i#27)): Seq Box } 
                LitInt(0) <= i#27
                     && i#27
                       < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
                   ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))), 
                        i#27)): Seq Box))));
  ensures DynamicPkv.SingleMergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(result#0))
           || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))), 
            $Box(ValueMessage.__default.IdentityMessage())));
  free ensures $IsA#BucketModel.singleMergeResult(Lit(DynamicPkv.SingleMergeResult.I(result#0)))
     && $IsA#BucketModel.singleMergeResult(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
        PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
        PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
        from0#0, 
        to#0, 
        PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
        PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
        LitInt(0), 
        Lit(Seq#Empty(): Seq Box), 
        Lit(Seq#Empty(): Seq Box), 
        slack0#0))
     && 
    DynamicPkv.SingleMergeResult.I#canCall(result#0)
     && 
    PackedKV.Pkv.Pkv_q(top#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0))
     && 
    PackedKV.Pkv.Pkv_q(top#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
     && 
    PackedKV.Pkv.Pkv_q(bot#0)
     && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
     && 
    PackedKV.Pkv.Pkv_q(bot#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
     && BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      from0#0, 
      to#0, 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
      LitInt(0), 
      Lit(Seq#Empty(): Seq Box), 
      Lit(Seq#Empty(): Seq Box), 
      slack0#0);
  ensures BucketModel.singleMergeResult#Equal(DynamicPkv.SingleMergeResult.I(result#0), 
    BucketModel.__default.mergeToOneChild(StartFuelAssert_BucketModel._default.mergeToOneChild, 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      from0#0, 
      to#0, 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
      LitInt(0), 
      Lit(Seq#Empty(): Seq Box), 
      Lit(Seq#Empty(): Seq Box), 
      slack0#0));
  free ensures (DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0))
     && PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(result#0))
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0)))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
     && 
    (DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0))
     && PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(result#0))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0)))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
     && (DynamicPkv.SingleMergeResult.MergeCompleted_q(result#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(result#0))
     && 
    PackedKV.Pkv.Pkv_q(bot#0)
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)))
     && 
    PackedKV.Pkv.Pkv_q(bot#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
  ensures BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(result#0))))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(result#0))))
       + DynamicPkv.SingleMergeResult.slack(result#0)
     == BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)))
       + slack0#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.__default.MergeToOneChild(top#0: DatatypeType, from0#0: int, to#0: int, bot#0: DatatypeType, slack0#0: int)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616;
  var slack#0: int where LitInt(0) <= slack#0 && slack#0 < 18446744073709551616;
  var bot_from#0: int
     where LitInt(0) <= bot_from#0 && bot_from#0 < 18446744073709551616;
  var newtype$check#7: int;
  var ##psa#8: DatatypeType;
  var pkv##0: DatatypeType;
  var ##psa#9: DatatypeType;
  var pkv##1: DatatypeType;
  var maxkeys#0: int where LitInt(0) <= maxkeys#0 && maxkeys#0 < 4294967296;
  var newtype$check#8: int;
  var ##pkv#8: DatatypeType;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var maxkeyspace#0: int
     where LitInt(0) <= maxkeyspace#0 && maxkeyspace#0 < 4294967296;
  var ##psa#10: DatatypeType;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var maxmsgspace#0: int
     where LitInt(0) <= maxmsgspace#0 && maxmsgspace#0 < 4294967296;
  var ##psa#11: DatatypeType;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var cap#0: DatatypeType
     where $Is(cap#0, Tclass.DynamicPkv.Capacity())
       && $IsAlloc(cap#0, Tclass.DynamicPkv.Capacity(), $Heap);
  var dresult#0: ref
     where $Is(dresult#0, Tclass.DynamicPkv.DynamicPkv())
       && $IsAlloc(dresult#0, Tclass.DynamicPkv.DynamicPkv(), $Heap);
  var $nw: ref;
  var capacity##0: DatatypeType;
  var ##pkv#9: DatatypeType;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##pkv#10: DatatypeType;
  var ##psa#12: DatatypeType;
  var ##psa#13: DatatypeType;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var ##psa#14: DatatypeType;
  var ##psa#15: DatatypeType;
  var newtype$check#17: int;
  var ##top_keys#1: Seq Box;
  var ##top_msgs#1: Seq Box;
  var ##from#1: int;
  var ##to#1: int;
  var ##bot_keys#1: Seq Box;
  var ##bot_msgs#1: Seq Box;
  var ##bot_from#1: int;
  var ##acc_keys#1: Seq Box;
  var ##acc_msgs#1: Seq Box;
  var ##slack#1: int;
  var ##psa#16: DatatypeType;
  var ##psa#17: DatatypeType;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var ##psa#18: DatatypeType;
  var ##psa#19: DatatypeType;
  var newtype$check#20: int;
  var ##psa#20: DatatypeType;
  var ##psa#21: DatatypeType;
  var newtype$check#21: int;
  var ##top_keys#2: Seq Box;
  var ##top_msgs#2: Seq Box;
  var ##from#2: int;
  var ##to#2: int;
  var ##bot_keys#2: Seq Box;
  var ##bot_msgs#2: Seq Box;
  var ##bot_from#2: int;
  var ##acc_keys#2: Seq Box;
  var ##acc_msgs#2: Seq Box;
  var ##slack#2: int;
  var ##pkv#11: DatatypeType;
  var ##pkv#12: DatatypeType;
  var ##pkv#13: DatatypeType;
  var ##psa#22: DatatypeType;
  var ##keys#2: Seq Box;
  var ##psa#23: DatatypeType;
  var ##msgs#2: Seq Box;
  var ##pkv#14: DatatypeType;
  var ##pkv#15: DatatypeType;
  var $decr$loop#00: int;
  var ##psa#0_0_0: DatatypeType;
  var ##psa#0_0_1: DatatypeType;
  var ##pkv#0_0_0: DatatypeType;
  var ##psa#0_0_2: DatatypeType;
  var ##psa#0_0_3: DatatypeType;
  var ##pkv#0_0_1: DatatypeType;
  var pkv##0_0_0: DatatypeType;
  var start##0_0_0: int;
  var end##0_0_0: int;
  var ##pkv#0_0_2: DatatypeType;
  var topkey#0_0: Seq Box
     where $Is(topkey#0_0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(topkey#0_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var ##psa#0_0: DatatypeType;
  var ##i#0_0: int;
  var botkey#0_0: Seq Box
     where $Is(botkey#0_0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(botkey#0_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var c#0_0: int where LitInt(0 - 2147483648) <= c#0_0 && c#0_0 < 2147483648;
  var ##pkv#0_0: DatatypeType;
  var ##psa#0_1_0: DatatypeType;
  var ##i#0_1_0: int;
  var $rhs##0_1_0: int
     where LitInt(0 - 2147483648) <= $rhs##0_1_0 && $rhs##0_1_0 < 2147483648;
  var a##0_1_0: Seq Box;
  var b##0_1_0: Seq Box;
  var ##pkv#0_1: DatatypeType;
  var newtype$check#0_0: int;
  var key#0_2_0: Seq Box
     where $Is(key#0_2_0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(key#0_2_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var topmsg#0_2_0: DatatypeType
     where $Is(topmsg#0_2_0, Tclass.ValueMessage.Message())
       && $IsAlloc(topmsg#0_2_0, Tclass.ValueMessage.Message(), $Heap);
  var ##pkv#0_2_0: DatatypeType;
  var ##i#0_2_0: int;
  var botmsg#0_2_0: DatatypeType
     where $Is(botmsg#0_2_0, Tclass.ValueMessage.Message())
       && $IsAlloc(botmsg#0_2_0, Tclass.ValueMessage.Message(), $Heap);
  var ##pkv#0_2_1: DatatypeType;
  var ##i#0_2_1: int;
  var msg#0_2_0: DatatypeType
     where $Is(msg#0_2_0, Tclass.ValueMessage.Message())
       && $IsAlloc(msg#0_2_0, Tclass.ValueMessage.Message(), $Heap);
  var ##newmessage#0_2_0: DatatypeType;
  var ##oldmessage#0_2_0: DatatypeType;
  var newtype$check#0_2_0_0: int;
  var newtype$check#0_2_0_1: int;
  var newtype$check#0_2_0_2: int;
  var newtype$check#0_2_0_3: int;
  var ##key#0_2_0_0: Seq Box;
  var newtype$check#0_2_0_4: int;
  var ##msg#0_2_0_0: DatatypeType;
  var newtype$check#0_2_0_5: int;
  var wm1#0_2_0: int where LitInt(0) <= wm1#0_2_0 && wm1#0_2_0 < 18446744073709551616;
  var ##msg#0_2_0: DatatypeType;
  var wm2#0_2_0: int where LitInt(0) <= wm2#0_2_0 && wm2#0_2_0 < 18446744073709551616;
  var ##msg#0_2_1: DatatypeType;
  var newtype$check#0_2_0: int;
  var ##psa#0_2_1_0: DatatypeType;
  var ##psa#0_2_1_1: DatatypeType;
  var ##pkv#0_2_1_0: DatatypeType;
  var ##psa#0_2_1_2: DatatypeType;
  var ##psa#0_2_1_3: DatatypeType;
  var ##pkv#0_2_1_1: DatatypeType;
  var pkv##0_2_1_0: DatatypeType;
  var start##0_2_1_0: int;
  var end##0_2_1_0: int;
  var ##pkv#0_2_1_2: DatatypeType;
  var pkv##0_2_0: DatatypeType;
  var a##0_2_0: int;
  var b##0_2_0: int;
  var pkv##0_2_1: DatatypeType;
  var a##0_2_1: int;
  var pkv##0_2_2: DatatypeType;
  var key##0_2_0: Seq Box;
  var msg##0_2_0: DatatypeType;
  var key##0_2_1: Seq Box;
  var msg##0_2_1: DatatypeType;
  var newtype$check#0_2_1: int;
  var newtype$check#0_2_2: int;
  var newtype$check#0_2_3: int;
  var newtype$check#0_2_4: int;
  var newtype$check#0_2_5: int;
  var newtype$check#0_2_6: int;
  var ##pkv#0_2: DatatypeType;
  var newtype$check#0_1: int;
  var key#0_3_0: Seq Box
     where $Is(key#0_3_0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(key#0_3_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var msg#0_3_0: DatatypeType
     where $Is(msg#0_3_0, Tclass.ValueMessage.Message())
       && $IsAlloc(msg#0_3_0, Tclass.ValueMessage.Message(), $Heap);
  var ##pkv#0_3_0: DatatypeType;
  var ##i#0_3_0: int;
  var delta#0_3_0: int
     where LitInt(0) <= delta#0_3_0 && delta#0_3_0 < 18446744073709551616;
  var ##key#0_3_0: Seq Box;
  var ##msg#0_3_0: DatatypeType;
  var newtype$check#0_3_0: int;
  var ##psa#0_3_0_0: DatatypeType;
  var ##psa#0_3_0_1: DatatypeType;
  var ##pkv#0_3_0_0: DatatypeType;
  var ##psa#0_3_0_2: DatatypeType;
  var ##psa#0_3_0_3: DatatypeType;
  var ##pkv#0_3_0_1: DatatypeType;
  var pkv##0_3_0_0: DatatypeType;
  var start##0_3_0_0: int;
  var end##0_3_0_0: int;
  var ##pkv#0_3_0_2: DatatypeType;
  var pkv##0_3_0: DatatypeType;
  var a##0_3_0: int;
  var b##0_3_0: int;
  var pkv##0_3_1: DatatypeType;
  var key##0_3_0: Seq Box;
  var msg##0_3_0: DatatypeType;
  var key##0_3_1: Seq Box;
  var msg##0_3_1: DatatypeType;
  var newtype$check#0_3_1: int;
  var newtype$check#0_3_2: int;
  var newtype$check#0_3_3: int;
  var key#0_0: Seq Box
     where $Is(key#0_0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(key#0_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var msg#0_0: DatatypeType
     where $Is(msg#0_0, Tclass.ValueMessage.Message())
       && $IsAlloc(msg#0_0, Tclass.ValueMessage.Message(), $Heap);
  var ##pkv#0_3: DatatypeType;
  var ##i#0_1: int;
  var pkv##0_0: DatatypeType;
  var key##0_0: Seq Box;
  var msg##0_0: DatatypeType;
  var pkv##0_1: DatatypeType;
  var a##0_0: int;
  var key##0_1: Seq Box;
  var msg##0_1: DatatypeType;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;

    // AddMethodImpl: MergeToOneChild, Impl$$DynamicPkv.__default.MergeToOneChild
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(868,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(869,39)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$BucketModel.__default.reveal__mergeToOneChild();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(869,40)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(871,22)
    assume true;
    assume true;
    from#0 := from0#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(871,29)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(872,23)
    assume true;
    assume true;
    slack#0 := slack0#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(872,31)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(873,26)
    assume true;
    newtype$check#7 := LitInt(0);
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume true;
    bot_from#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(873,29)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(875,5)
    assume PackedKV.Pkv.Pkv_q(bot#0);
    ##psa#8 := PackedKV.Pkv.keys(bot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#8))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedKV.Pkv.keys(bot#0));
    assume Bounds.__default.MaxTotalBucketWeight#canCall();
    assume PackedKV.Pkv.Pkv_q(bot#0)
       && PackedStringArray.__default.psaTotalLength#canCall(PackedKV.Pkv.keys(bot#0))
       && Bounds.__default.MaxTotalBucketWeight#canCall();
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(875,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(876,35)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        pkv##0 := bot#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(876,39)"} true;
        assert PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.keys(bot#0))
           <= LitInt(Bounds.__default.MaxTotalBucketWeight());
        assume false;
    }

    assume PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.keys(bot#0))
       <= LitInt(Bounds.__default.MaxTotalBucketWeight());
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(878,5)
    assume PackedKV.Pkv.Pkv_q(bot#0);
    ##psa#9 := PackedKV.Pkv.messages(bot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#9, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#9))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedKV.Pkv.messages(bot#0));
    assume Bounds.__default.MaxTotalBucketWeight#canCall();
    assume PackedKV.Pkv.Pkv_q(bot#0)
       && PackedStringArray.__default.psaTotalLength#canCall(PackedKV.Pkv.messages(bot#0))
       && Bounds.__default.MaxTotalBucketWeight#canCall();
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(878,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(879,35)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        pkv##1 := bot#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv##1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(879,39)"} true;
        assert PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.messages(bot#0))
           <= LitInt(Bounds.__default.MaxTotalBucketWeight());
        assume false;
    }

    assume PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.messages(bot#0))
       <= LitInt(Bounds.__default.MaxTotalBucketWeight());
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(882,25)
    assume true;
    newtype$check#8 := to#0 - from#0;
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    ##pkv#8 := bot#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#8, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#8)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#8))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#8)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#8))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#8))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#8)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#8)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#28: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), i#28)): Seq Box } 
                  LitInt(0) <= i#28
                       && i#28 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#8)), i#28)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
             || (forall i#29: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)), i#29)): Seq Box } 
              LitInt(0) <= i#29
                   && i#29 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#8)), i#29)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#8)
       ==> PackedKV.__default.WF(##pkv#8)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#8)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#8);
    assume PackedKV.__default.NumKVPairs#canCall(bot#0);
    newtype$check#9 := to#0 - from#0 + PackedKV.__default.NumKVPairs(bot#0);
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    newtype$check#10 := to#0 - from#0 + PackedKV.__default.NumKVPairs(bot#0);
    assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 4294967296;
    assume PackedKV.__default.NumKVPairs#canCall(bot#0);
    maxkeys#0 := to#0 - from#0 + PackedKV.__default.NumKVPairs(bot#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(882,70)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(883,29)
    assume true;
    assume PackedKV.Pkv.Pkv_q(bot#0);
    ##psa#10 := PackedKV.Pkv.keys(bot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#10, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#10))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#10))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedKV.Pkv.keys(bot#0));
    newtype$check#11 := PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.keys(bot#0)) + slack#0;
    assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
    newtype$check#12 := PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.keys(bot#0)) + slack#0;
    assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 4294967296;
    assume PackedKV.Pkv.Pkv_q(bot#0)
       && PackedStringArray.__default.psaTotalLength#canCall(PackedKV.Pkv.keys(bot#0));
    maxkeyspace#0 := PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.keys(bot#0)) + slack#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(883,79)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(884,29)
    assume true;
    assume PackedKV.Pkv.Pkv_q(bot#0);
    ##psa#11 := PackedKV.Pkv.messages(bot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#11, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#11))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#11))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedKV.Pkv.messages(bot#0));
    newtype$check#13 := PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.messages(bot#0))
       + slack#0;
    assert LitInt(0) <= newtype$check#13 && newtype$check#13 < 18446744073709551616;
    newtype$check#14 := PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.messages(bot#0))
       + slack#0;
    assert LitInt(0) <= newtype$check#14 && newtype$check#14 < 4294967296;
    assume PackedKV.Pkv.Pkv_q(bot#0)
       && PackedStringArray.__default.psaTotalLength#canCall(PackedKV.Pkv.messages(bot#0));
    maxmsgspace#0 := PackedStringArray.__default.psaTotalLength(PackedKV.Pkv.messages(bot#0))
       + slack#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(884,83)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(885,13)
    assume true;
    assume true;
    cap#0 := #DynamicPkv.Capacity.Capacity(maxkeys#0, maxkeyspace#0, maxmsgspace#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(885,58)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(886,17)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(886,35)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    capacity##0 := cap#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$DynamicPkv.DynamicPkv.PreSized(capacity##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(886,47)"} true;
    dresult#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(886,47)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(891,19)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$DynamicPkv.__default.WeightEmptySeq();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(891,20)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(892,5)
    assert {:subsumption 0} dresult#0 != null;
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || Set#Subset(read($Heap, 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || Set#Subset(read($Heap, 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr), 
          read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
          read($Heap, 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
          read($Heap, 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
            read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr)), 
          read($Heap, 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
            PackedStringArray.DynamicPsa.Repr));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
    ##pkv#9 := DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#9, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#9))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#9))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#9)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#9))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#9)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#9)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#9)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#9))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#9))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#9)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#9)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#30: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)), i#30)): Seq Box } 
                  LitInt(0) <= i#30
                       && i#30 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#9)), i#30)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)))
             || (forall i#31: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)), i#31)): Seq Box } 
              LitInt(0) <= i#31
                   && i#31 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#9)), i#31)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#9)
       ==> PackedKV.__default.WF(##pkv#9)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#9)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume DynamicPkv.__default.WeightBucketPkv#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
       && DynamicPkv.__default.WeightBucketPkv#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
    assert DynamicPkv.__default.WeightBucketPkv(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
       == LitInt(0);
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(894,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := PackedKV.__default.NumKVPairs(top#0) + PackedKV.__default.NumKVPairs(bot#0)
       - from#0
       - bot_from#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> from#0 <= to#0;
      free invariant $w$loop#0 ==> PackedKV.__default.NumKVPairs#canCall(bot#0);
      invariant $w$loop#0 ==> bot_from#0 <= PackedKV.__default.NumKVPairs(bot#0);
      free invariant $w$loop#0 ==> DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0);
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || Set#Subset(read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || Set#Subset(read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
            read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
            read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
              read($Heap, 
                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr)), 
            read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
      invariant $w$loop#0
         ==> 
        DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
         ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
              PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
           && 
          DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
           && 
          read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)]
           && read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))]
           && Set#Subset(read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr))
           && read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))]
           && Set#Subset(read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr), 
            read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr))
           && 
          Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
            read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
            read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
              PackedStringArray.DynamicPsa.Repr))
           && Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
              read($Heap, 
                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                PackedStringArray.DynamicPsa.Repr)), 
            read($Heap, 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
              PackedStringArray.DynamicPsa.Repr))
           && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))
           && PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))
           && PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
              PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall $o: ref :: 
          { read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)] } 
          read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
      free invariant $w$loop#0
         ==> $IsA#BucketModel.singleMergeResult(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
              from0#0, 
              to#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
              LitInt(0), 
              Lit(Seq#Empty(): Seq Box), 
              Lit(Seq#Empty(): Seq Box), 
              slack0#0))
           && $IsA#BucketModel.singleMergeResult(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
              from#0, 
              to#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
              bot_from#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
              slack#0))
           && 
          PackedKV.Pkv.Pkv_q(top#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0))
           && 
          PackedKV.Pkv.Pkv_q(top#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
           && BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
            from0#0, 
            to#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
            LitInt(0), 
            Lit(Seq#Empty(): Seq Box), 
            Lit(Seq#Empty(): Seq Box), 
            slack0#0)
           && 
          PackedKV.Pkv.Pkv_q(top#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0))
           && 
          PackedKV.Pkv.Pkv_q(top#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)))
           && BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
            from#0, 
            to#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
            bot_from#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
            slack#0);
      invariant $w$loop#0
         ==> BucketModel.singleMergeResult#Equal(BucketModel.__default.mergeToOneChild(StartFuelAssert_BucketModel._default.mergeToOneChild, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
            from0#0, 
            to#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
            LitInt(0), 
            Lit(Seq#Empty(): Seq Box), 
            Lit(Seq#Empty(): Seq Box), 
            slack0#0), 
          BucketModel.__default.mergeToOneChild(StartFuelAssert_BucketModel._default.mergeToOneChild, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
            from#0, 
            to#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
            bot_from#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
            slack#0));
      free invariant $w$loop#0
         ==> DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
           && PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
      invariant $w$loop#0
         ==> PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
           <= bot_from#0 + from#0 - from0#0;
      free invariant $w$loop#0
         ==> DynamicPkv.__default.WeightBucketPkv#canCall(bot#0)
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
           && DynamicPkv.__default.WeightBucketPkv#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0));
      invariant $w$loop#0
         ==> DynamicPkv.__default.WeightBucketPkv(bot#0) + slack0#0
           == DynamicPkv.__default.WeightBucketPkv(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
             + BucketWeights.__default.WeightKeyList(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0))
             + BucketWeights.__default.WeightMessageList(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0))
             + slack#0;
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant PackedKV.__default.NumKVPairs(top#0) + PackedKV.__default.NumKVPairs(bot#0)
             - from#0
             - bot_from#0
           <= $decr_init$loop#00
         && (PackedKV.__default.NumKVPairs(top#0) + PackedKV.__default.NumKVPairs(bot#0)
               - from#0
               - bot_from#0
             == $decr_init$loop#00
           ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(894,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume true;
            assume from#0 <= to#0;
            ##pkv#10 := bot#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#10, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#10))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#10)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#10))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#10))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#10))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#10)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#10))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#10))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#10)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#10)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#10)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#10))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#10))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#10))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#10))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#10)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#10))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#10)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#10))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#10)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#10)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#10))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#10)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#10)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#10)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#10))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#10))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#10))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#10))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#10)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#10)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#10)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#10)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#10)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#10)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#32: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#10)), i#32)): Seq Box } 
                          LitInt(0) <= i#32
                               && i#32 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#10)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#10)), i#32)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#10)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#10)))
                     || (forall i#33: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#10)), i#33)): Seq Box } 
                      LitInt(0) <= i#33
                           && i#33
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#10)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#10)), i#33)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#10)
               ==> PackedKV.__default.WF(##pkv#10)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#10)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            assume bot_from#0 <= PackedKV.__default.NumKVPairs(bot#0);
            assert {:subsumption 0} dresult#0 != null;
            assume DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0);
            assume DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0);
            assume DynamicPkv.DynamicPkv.WF($Heap, dresult#0);
            assert {:subsumption 0} dresult#0 != null;
            assume true;
            assume (forall $o: ref :: 
              { read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)] } 
              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)]
                 ==> $o != null && !read(old($Heap), $o, alloc));
            assume PackedKV.Pkv.Pkv_q(top#0);
            ##psa#12 := PackedKV.Pkv.keys(top#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#12, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
               ==> PackedStringArray.__default.WF(##psa#12)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
               ==> PackedStringArray.__default.WF(##psa#12)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#12)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
               ==> PackedStringArray.__default.WF(##psa#12)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#12)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
               ==> PackedStringArray.__default.WF(##psa#12)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#12))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#12))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#12), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
               ==> PackedStringArray.__default.WF(##psa#12)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#12));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0));
            assume PackedKV.Pkv.Pkv_q(top#0);
            ##psa#13 := PackedKV.Pkv.messages(top#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#13, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
               ==> PackedStringArray.__default.WF(##psa#13)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
               ==> PackedStringArray.__default.WF(##psa#13)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#13)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
               ==> PackedStringArray.__default.WF(##psa#13)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#13)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
               ==> PackedStringArray.__default.WF(##psa#13)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#13))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#13))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#13), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
               ==> PackedStringArray.__default.WF(##psa#13)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#13));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0));
            newtype$check#15 := from0#0;
            assert LitInt(0) <= newtype$check#15;
            newtype$check#16 := to#0;
            assert LitInt(0) <= newtype$check#16;
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#14 := PackedKV.Pkv.keys(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#14, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
               ==> PackedStringArray.__default.WF(##psa#14)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
               ==> PackedStringArray.__default.WF(##psa#14)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#14)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
               ==> PackedStringArray.__default.WF(##psa#14)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#14)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
               ==> PackedStringArray.__default.WF(##psa#14)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#14))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#14))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#14), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
               ==> PackedStringArray.__default.WF(##psa#14)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#14));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0));
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#15 := PackedKV.Pkv.messages(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#15, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
               ==> PackedStringArray.__default.WF(##psa#15)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#15)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
               ==> PackedStringArray.__default.WF(##psa#15)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#15)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
               ==> PackedStringArray.__default.WF(##psa#15)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#15)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#15)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
               ==> PackedStringArray.__default.WF(##psa#15)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#15))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#15))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#15), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#15)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#15)
               ==> PackedStringArray.__default.WF(##psa#15)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#15));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
            newtype$check#17 := slack0#0;
            assert LitInt(0) <= newtype$check#17;
            assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              TSeq(Tclass.KeyType.Key()));
            ##top_keys#1 := PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##top_keys#1, TSeq(Tclass.KeyType.Key()), $Heap);
            ##top_msgs#1 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##top_msgs#1, TSeq(Tclass.ValueMessage.Message()), $Heap);
            ##from#1 := from0#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##from#1, Tclass._System.nat(), $Heap);
            ##to#1 := to#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##to#1, Tclass._System.nat(), $Heap);
            assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              TSeq(Tclass.KeyType.Key()));
            ##bot_keys#1 := PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##bot_keys#1, TSeq(Tclass.KeyType.Key()), $Heap);
            ##bot_msgs#1 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##bot_msgs#1, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assert $Is(LitInt(0), Tclass._System.nat());
            ##bot_from#1 := LitInt(0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##bot_from#1, Tclass._System.nat(), $Heap);
            ##acc_keys#1 := Lit(Seq#Empty(): Seq Box);
            // assume allocatedness for argument to function
            assume $IsAlloc(##acc_keys#1, TSeq(Tclass.KeyType.Key()), $Heap);
            ##acc_msgs#1 := Lit(Seq#Empty(): Seq Box);
            // assume allocatedness for argument to function
            assume $IsAlloc(##acc_msgs#1, TSeq(Tclass.ValueMessage.Message()), $Heap);
            ##slack#1 := slack0#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##slack#1, Tclass._System.nat(), $Heap);
            assert {:subsumption 0} Seq#Length(##top_keys#1) == Seq#Length(##top_msgs#1);
            assert {:subsumption 0} Seq#Length(##bot_keys#1) == Seq#Length(##bot_msgs#1);
            assert {:subsumption 0} Seq#Length(##acc_keys#1) == Seq#Length(##acc_msgs#1);
            assert {:subsumption 0} ##from#1 <= ##to#1;
            assert {:subsumption 0} ##to#1 <= Seq#Length(##top_keys#1);
            assert {:subsumption 0} ##bot_from#1 <= Seq#Length(##bot_keys#1);
            assume BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
              from0#0, 
              to#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
              LitInt(0), 
              Lit(Seq#Empty(): Seq Box), 
              Lit(Seq#Empty(): Seq Box), 
              slack0#0);
            assume PackedKV.Pkv.Pkv_q(top#0);
            ##psa#16 := PackedKV.Pkv.keys(top#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#16, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#16)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#16)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#16)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#16)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#16))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#16))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#16), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#16)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#16)
               ==> PackedStringArray.__default.WF(##psa#16)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#16));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0));
            assume PackedKV.Pkv.Pkv_q(top#0);
            ##psa#17 := PackedKV.Pkv.messages(top#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#17, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#17)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#17)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#17)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#17)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#17))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#17))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#17), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#17)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#17)
               ==> PackedStringArray.__default.WF(##psa#17)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#17));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0));
            newtype$check#18 := from#0;
            assert LitInt(0) <= newtype$check#18;
            newtype$check#19 := to#0;
            assert LitInt(0) <= newtype$check#19;
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#18 := PackedKV.Pkv.keys(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#18, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#18)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#18)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#18)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#18)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#18))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#18))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#18), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#18)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#18)
               ==> PackedStringArray.__default.WF(##psa#18)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#18));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0));
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#19 := PackedKV.Pkv.messages(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#19, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#19)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#19)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#19)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#19)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#19))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#19))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#19), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#19)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#19)
               ==> PackedStringArray.__default.WF(##psa#19)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#19));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
            newtype$check#20 := bot_from#0;
            assert LitInt(0) <= newtype$check#20;
            assert {:subsumption 0} dresult#0 != null;
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                    read($Heap, 
                      read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            ##psa#20 := PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#20, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#20)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#20)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#20)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#20)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#20))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#20))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#20), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#20)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#20)
               ==> PackedStringArray.__default.WF(##psa#20)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#20));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)));
            assert {:subsumption 0} dresult#0 != null;
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                    read($Heap, 
                      read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            ##psa#21 := PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#21, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#21)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#21)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#21)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#21)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#21))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#21))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#21), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#21)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#21)
               ==> PackedStringArray.__default.WF(##psa#21)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#21));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)));
            newtype$check#21 := slack#0;
            assert LitInt(0) <= newtype$check#21;
            assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              TSeq(Tclass.KeyType.Key()));
            ##top_keys#2 := PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##top_keys#2, TSeq(Tclass.KeyType.Key()), $Heap);
            ##top_msgs#2 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##top_msgs#2, TSeq(Tclass.ValueMessage.Message()), $Heap);
            ##from#2 := from#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##from#2, Tclass._System.nat(), $Heap);
            ##to#2 := to#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##to#2, Tclass._System.nat(), $Heap);
            assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              TSeq(Tclass.KeyType.Key()));
            ##bot_keys#2 := PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##bot_keys#2, TSeq(Tclass.KeyType.Key()), $Heap);
            ##bot_msgs#2 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##bot_msgs#2, TSeq(Tclass.ValueMessage.Message()), $Heap);
            ##bot_from#2 := bot_from#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##bot_from#2, Tclass._System.nat(), $Heap);
            assert $Is(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
              TSeq(Tclass.KeyType.Key()));
            ##acc_keys#2 := PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##acc_keys#2, TSeq(Tclass.KeyType.Key()), $Heap);
            ##acc_msgs#2 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##acc_msgs#2, TSeq(Tclass.ValueMessage.Message()), $Heap);
            ##slack#2 := slack#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##slack#2, Tclass._System.nat(), $Heap);
            assert {:subsumption 0} Seq#Length(##top_keys#2) == Seq#Length(##top_msgs#2);
            assert {:subsumption 0} Seq#Length(##bot_keys#2) == Seq#Length(##bot_msgs#2);
            assert {:subsumption 0} Seq#Length(##acc_keys#2) == Seq#Length(##acc_msgs#2);
            assert {:subsumption 0} ##from#2 <= ##to#2;
            assert {:subsumption 0} ##to#2 <= Seq#Length(##top_keys#2);
            assert {:subsumption 0} ##bot_from#2 <= Seq#Length(##bot_keys#2);
            assume BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
              from#0, 
              to#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
              bot_from#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
              slack#0);
            assume $IsA#BucketModel.singleMergeResult(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                  PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
                  from0#0, 
                  to#0, 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
                  PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                  LitInt(0), 
                  Lit(Seq#Empty(): Seq Box), 
                  Lit(Seq#Empty(): Seq Box), 
                  slack0#0))
               && $IsA#BucketModel.singleMergeResult(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                  PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
                  from#0, 
                  to#0, 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
                  PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                  bot_from#0, 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
                  PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
                  slack#0))
               && 
              PackedKV.Pkv.Pkv_q(top#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0))
               && 
              PackedKV.Pkv.Pkv_q(top#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
               && 
              PackedKV.Pkv.Pkv_q(bot#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
               && 
              PackedKV.Pkv.Pkv_q(bot#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
               && BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
                from0#0, 
                to#0, 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                LitInt(0), 
                Lit(Seq#Empty(): Seq Box), 
                Lit(Seq#Empty(): Seq Box), 
                slack0#0)
               && 
              PackedKV.Pkv.Pkv_q(top#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0))
               && 
              PackedKV.Pkv.Pkv_q(top#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
               && 
              PackedKV.Pkv.Pkv_q(bot#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
               && 
              PackedKV.Pkv.Pkv_q(bot#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
               && 
              DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)))
               && 
              DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
               && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)))
               && BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
                from#0, 
                to#0, 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                bot_from#0, 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
                slack#0);
            assume BucketModel.singleMergeResult#Equal(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
                from0#0, 
                to#0, 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                LitInt(0), 
                Lit(Seq#Empty(): Seq Box), 
                Lit(Seq#Empty(): Seq Box), 
                slack0#0), 
              BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
                from#0, 
                to#0, 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                bot_from#0, 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
                PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
                slack#0));
            assert {:subsumption 0} dresult#0 != null;
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                    read($Heap, 
                      read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            ##pkv#11 := DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#11, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#11))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#11)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#11))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#11))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#11))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#11)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#11))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#11))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#11)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#11)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#11)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#11))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#11))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#11))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#11))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#11)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#11))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#11)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#11))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#11)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#11)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#11))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#11)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#11)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#11)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#11))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#11))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#11))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#11))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#11)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#11)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#11)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#11)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#11)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#11)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#34: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#11)), i#34)): Seq Box } 
                          LitInt(0) <= i#34
                               && i#34 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#11)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#11)), i#34)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#11)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#11)))
                     || (forall i#35: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#11)), i#35)): Seq Box } 
                      LitInt(0) <= i#35
                           && i#35
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#11)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#11)), i#35)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#11)
               ==> PackedKV.__default.WF(##pkv#11)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#11)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
               && PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            assume PackedKV.__default.NumKVPairs(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
               <= bot_from#0 + from#0 - from0#0;
            ##pkv#12 := bot#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#12, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#12))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#12)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#12))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#12))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#12))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#12)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#12))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#12))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#12)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#12)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#12)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#12))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#12))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#12))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#12))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#12)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#12))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#12)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#12))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#12)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#12)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#12))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#12)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#12)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#12)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#12))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#12))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#12))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#12))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#12)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#12)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#12)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#12)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#12)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#12)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#36: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#12)), i#36)): Seq Box } 
                          LitInt(0) <= i#36
                               && i#36 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#12)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#12)), i#36)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#12)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#12)))
                     || (forall i#37: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#12)), i#37)): Seq Box } 
                      LitInt(0) <= i#37
                           && i#37
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#12)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#12)), i#37)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#12)
               ==> PackedKV.__default.WF(##pkv#12)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#12)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume DynamicPkv.__default.WeightBucketPkv#canCall(bot#0);
            assert {:subsumption 0} dresult#0 != null;
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                    read($Heap, 
                      read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            ##pkv#13 := DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#13, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#13))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#13)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#13))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#13))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#13))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#13)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#13))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#13))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#13)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#13)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#13)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#13))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#13))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#13))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#13))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#13)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#13))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#13)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#13))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#13)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#13)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#13))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#13)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#13)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#13)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#13))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#13))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#13))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#13))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#13)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#13)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#13)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#13)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#13)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#13)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#38: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#13)), i#38)): Seq Box } 
                          LitInt(0) <= i#38
                               && i#38 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#13)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#13)), i#38)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#13)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#13)))
                     || (forall i#39: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#13)), i#39)): Seq Box } 
                      LitInt(0) <= i#39
                           && i#39
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#13)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#13)), i#39)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#13)
               ==> PackedKV.__default.WF(##pkv#13)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#13)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume DynamicPkv.__default.WeightBucketPkv#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#22 := PackedKV.Pkv.keys(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#22, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#22)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#22)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#22)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#22)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#22))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#22))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#22), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#22)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#22)
               ==> PackedStringArray.__default.WF(##psa#22)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#22));
            assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(##psa#22), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(##psa#22), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#40: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#22), i#40)): Seq Box } 
                  LitInt(0) <= i#40 && i#40 < Seq#Length(PackedStringArray.__default.I(##psa#22))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#22), i#40)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0));
            assert {:subsumption 0} 0 <= bot_from#0
               && bot_from#0 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
            ##keys#2 := Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##keys#2, TSeq(Tclass.KeyType.Key()), $Heap);
            assume BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0));
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#23 := PackedKV.Pkv.messages(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#23, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#23)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#23)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#23)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#23)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#23))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#23))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#23), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#23)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#23)
               ==> PackedStringArray.__default.WF(##psa#23)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#23));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
            assert {:subsumption 0} 0 <= bot_from#0
               && bot_from#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
            ##msgs#2 := Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##msgs#2, TSeq(Tclass.ValueMessage.Message()), $Heap);
            assume BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0));
            assume DynamicPkv.__default.WeightBucketPkv#canCall(bot#0)
               && 
              DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
               && DynamicPkv.__default.WeightBucketPkv#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
               && 
              PackedKV.Pkv.Pkv_q(bot#0)
               && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
               && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0))
               && 
              PackedKV.Pkv.Pkv_q(bot#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
               && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0));
            assume DynamicPkv.__default.WeightBucketPkv(bot#0) + slack0#0
               == DynamicPkv.__default.WeightBucketPkv(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
                 + BucketWeights.__default.WeightKeyList(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0))
                 + BucketWeights.__default.WeightMessageList(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0))
                 + slack#0;
            ##pkv#14 := top#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#14, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#14))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#14)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#14))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#14))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#14))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#14)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#14))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#14))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#14)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#14)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#14)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#14))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#14))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#14))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#14))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#14)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#14))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#14)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#14))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#14)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#14)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#14))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#14)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#14)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#14)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#14))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#14))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#14))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#14))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#14)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#14)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#14)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#14)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#14)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#14)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#41: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#14)), i#41)): Seq Box } 
                          LitInt(0) <= i#41
                               && i#41 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#14)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#14)), i#41)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#14)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#14)))
                     || (forall i#42: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#14)), i#42)): Seq Box } 
                      LitInt(0) <= i#42
                           && i#42
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#14)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#14)), i#42)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#14)
               ==> PackedKV.__default.WF(##pkv#14)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#14)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#14);
            assume PackedKV.__default.NumKVPairs#canCall(top#0);
            ##pkv#15 := bot#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#15, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#15))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#15)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#15))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#15))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#15))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#15)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#15))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#15))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#15)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#15)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#15)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#15))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#15))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#15))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#15))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#15)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#15))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#15)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#15))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#15)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#15)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#15))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#15)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#15)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#15)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#15))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#15))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#15))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#15))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#15)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#15)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#15)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#15)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#15)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#15)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#43: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#15)), i#43)): Seq Box } 
                          LitInt(0) <= i#43
                               && i#43 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#15)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#15)), i#43)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#15)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#15)))
                     || (forall i#44: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#15)), i#44)): Seq Box } 
                      LitInt(0) <= i#44
                           && i#44
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#15)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#15)), i#44)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#15)
               ==> PackedKV.__default.WF(##pkv#15)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#15)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#15);
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            assume PackedKV.__default.NumKVPairs#canCall(top#0)
               && PackedKV.__default.NumKVPairs#canCall(bot#0);
            assume false;
        }

        assume true;
        if (!Lit(true))
        {
            break;
        }

        $decr$loop#00 := PackedKV.__default.NumKVPairs(top#0) + PackedKV.__default.NumKVPairs(bot#0)
           - from#0
           - bot_from#0;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(926,7)
        assume true;
        if (from#0 == to#0)
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(927,9)
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#0_0_0 := PackedKV.Pkv.keys(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0_0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0_0));
            assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(##psa#0_0_0), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(##psa#0_0_0), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#0_0_0: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_0_0), i#0_0_0)): Seq Box } 
                  LitInt(0) <= i#0_0_0
                       && i#0_0_0 < Seq#Length(PackedStringArray.__default.I(##psa#0_0_0))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_0_0), i#0_0_0)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0));
            assert {:subsumption 0} 0 <= bot_from#0
               && bot_from#0 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#0_0_1 := PackedKV.Pkv.keys(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0_1, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_1)
               ==> PackedStringArray.__default.WF(##psa#0_0_1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0_1));
            assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(##psa#0_0_1), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(##psa#0_0_1), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#0_0_1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_0_1), i#0_0_1)): Seq Box } 
                  LitInt(0) <= i#0_0_1
                       && i#0_0_1 < Seq#Length(PackedStringArray.__default.I(##psa#0_0_1))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_0_1), i#0_0_1)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0));
            assert {:subsumption 0} 0 <= bot_from#0
               && bot_from#0 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
            ##pkv#0_0_0 := bot#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_2: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), i#0_0_2)): Seq Box } 
                          LitInt(0) <= i#0_0_2
                               && i#0_0_2
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), i#0_0_2)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                     || (forall i#0_0_3: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)), i#0_0_3)): Seq Box } 
                      LitInt(0) <= i#0_0_3
                           && i#0_0_3
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)), i#0_0_3)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            assert {:subsumption 0} bot_from#0 <= PackedKV.__default.NumKVPairs(bot#0)
               && PackedKV.__default.NumKVPairs(bot#0)
                 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
            assume PackedKV.Pkv.Pkv_q(bot#0)
               && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
               && 
              PackedKV.Pkv.Pkv_q(bot#0)
               && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
               && PackedKV.__default.NumKVPairs#canCall(bot#0);
            assert Seq#Equal(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0), 
              Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), 
                  PackedKV.__default.NumKVPairs(bot#0)), 
                bot_from#0));
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(929,9)
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#0_0_2 := PackedKV.Pkv.messages(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0_2, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_0_2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_0_2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_0_2)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_0_2)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_2))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_2), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_2)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_2)
               ==> PackedStringArray.__default.WF(##psa#0_0_2)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0_2));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
            assert {:subsumption 0} 0 <= bot_from#0
               && bot_from#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
            assume PackedKV.Pkv.Pkv_q(bot#0);
            ##psa#0_0_3 := PackedKV.Pkv.messages(bot#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0_3, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
               ==> PackedStringArray.__default.WF(##psa#0_0_3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
               ==> PackedStringArray.__default.WF(##psa#0_0_3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
               ==> PackedStringArray.__default.WF(##psa#0_0_3)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
               ==> PackedStringArray.__default.WF(##psa#0_0_3)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_3))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_3), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_3)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_3)
               ==> PackedStringArray.__default.WF(##psa#0_0_3)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0_3));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
            assert {:subsumption 0} 0 <= bot_from#0
               && bot_from#0
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
            ##pkv#0_0_1 := bot#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_1, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_4: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)), i#0_0_4)): Seq Box } 
                          LitInt(0) <= i#0_0_4
                               && i#0_0_4
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)), i#0_0_4)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)))
                     || (forall i#0_0_5: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)), i#0_0_5)): Seq Box } 
                      LitInt(0) <= i#0_0_5
                           && i#0_0_5
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)), i#0_0_5)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_1)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            assert {:subsumption 0} bot_from#0 <= PackedKV.__default.NumKVPairs(bot#0)
               && PackedKV.__default.NumKVPairs(bot#0)
                 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
            assume PackedKV.Pkv.Pkv_q(bot#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
               && 
              PackedKV.Pkv.Pkv_q(bot#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
               && PackedKV.__default.NumKVPairs#canCall(bot#0);
            assert Seq#Equal(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0), 
              Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                  PackedKV.__default.NumKVPairs(bot#0)), 
                bot_from#0));
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(932,26)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            assert dresult#0 != null;
            assume true;
            // ProcessCallStmt: CheckSubrange
            pkv##0_0_0 := bot#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            start##0_0_0 := bot_from#0;
            ##pkv#0_0_2 := bot#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_2, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_2))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_2))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_2))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_2)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_2)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_2))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_2)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_2)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_2)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_2))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_2))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_2))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_2))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_2))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_2))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_2)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_2)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_2))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_2)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_2)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_2)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_2)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_2))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_2))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_2)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_2)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_2)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_2)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_2)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_2)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_6: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_2)), i#0_0_6)): Seq Box } 
                          LitInt(0) <= i#0_0_6
                               && i#0_0_6
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_2)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_2)), i#0_0_6)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_2)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_2)))
                     || (forall i#0_0_7: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_2)), i#0_0_7)): Seq Box } 
                      LitInt(0) <= i#0_0_7
                           && i#0_0_7
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_2)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_2)), i#0_0_7)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_2)
               ==> PackedKV.__default.WF(##pkv#0_0_2)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_2)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#0_0_2);
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            // ProcessCallStmt: CheckSubrange
            end##0_0_0 := PackedKV.__default.NumKVPairs(bot#0);
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == dresult#0
                     || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$DynamicPkv.DynamicPkv.AppendPkv(dresult#0, pkv##0_0_0, start##0_0_0, end##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(932,61)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(933,16)
            assume true;
            assert dresult#0 != null;
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Subset(read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr), 
                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                    read($Heap, 
                      read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                      PackedStringArray.DynamicPsa.Repr)), 
                  read($Heap, 
                    read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                    PackedStringArray.DynamicPsa.Repr));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
            assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
               ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                 || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
            assume DynamicPkv.DynamicPkv.WF($Heap, dresult#0);
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
            assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
            assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
            result#0 := #DynamicPkv.SingleMergeResult.MergeCompleted(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0), slack#0);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(933,56)"} true;
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(934,9)
            return;
        }
        else
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(936,20)
            assume true;
            assume PackedKV.Pkv.Pkv_q(top#0);
            ##psa#0_0 := PackedKV.Pkv.keys(top#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
            ##i#0_0 := from#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0));
            assume PackedStringArray.__default.WF(##psa#0_0);
            assert {:subsumption 0} LitInt(0) <= ##i#0_0;
            assert {:subsumption 0} ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
            assume LitInt(0) <= ##i#0_0
               && ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
            assume PackedStringArray.__default.psaElement#canCall(PackedKV.Pkv.keys(top#0), from#0);
            assume PackedKV.Pkv.Pkv_q(top#0)
               && PackedStringArray.__default.psaElement#canCall(PackedKV.Pkv.keys(top#0), from#0);
            topkey#0_0 := PackedStringArray.__default.psaElement(PackedKV.Pkv.keys(top#0), from#0);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(936,52)"} true;
            havoc botkey#0_0 /* where $Is(botkey#0_0, TSeq(Tclass.NativeTypes.byte()))
               && $IsAlloc(botkey#0_0, TSeq(Tclass.NativeTypes.byte()), $Heap) */;
            havoc c#0_0 /* where LitInt(0 - 2147483648) <= c#0_0 && c#0_0 < 2147483648 */;
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(939,9)
            ##pkv#0_0 := bot#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), i#0_0)): Seq Box } 
                          LitInt(0) <= i#0_0
                               && i#0_0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), i#0_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                     || (forall i#0_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)), i#0_1)): Seq Box } 
                      LitInt(0) <= i#0_1
                           && i#0_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)), i#0_1)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
               ==> PackedKV.__default.WF(##pkv#0_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#0_0);
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            if (bot_from#0 < PackedKV.__default.NumKVPairs(bot#0))
            {
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(940,18)
                assume true;
                assume PackedKV.Pkv.Pkv_q(bot#0);
                ##psa#0_1_0 := PackedKV.Pkv.keys(bot#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#0_1_0, Tclass.PackedStringArray.Psa(), $Heap);
                ##i#0_1_0 := bot_from#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##i#0_1_0, Tclass.NativeTypes.uint64(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
                   ==> PackedStringArray.__default.WF(##psa#0_1_0)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
                   ==> PackedStringArray.__default.WF(##psa#0_1_0)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
                   ==> PackedStringArray.__default.WF(##psa#0_1_0)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
                   ==> PackedStringArray.__default.WF(##psa#0_1_0)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_0), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
                   ==> PackedStringArray.__default.WF(##psa#0_1_0)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#0_1_0));
                assume PackedStringArray.__default.WF(##psa#0_1_0);
                assert {:subsumption 0} LitInt(0) <= ##i#0_1_0;
                assert {:subsumption 0} ##i#0_1_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0));
                assume LitInt(0) <= ##i#0_1_0
                   && ##i#0_1_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0));
                assume PackedStringArray.__default.psaElement#canCall(PackedKV.Pkv.keys(bot#0), bot_from#0);
                assume PackedKV.Pkv.Pkv_q(bot#0)
                   && PackedStringArray.__default.psaElement#canCall(PackedKV.Pkv.keys(bot#0), bot_from#0);
                botkey#0_0 := PackedStringArray.__default.psaElement(PackedKV.Pkv.keys(bot#0), bot_from#0);
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(940,54)"} true;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(941,32)
                assume true;
                // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type int32
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                a##0_1_0 := topkey#0_0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                b##0_1_0 := botkey#0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call $rhs##0_1_0 := Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a##0_1_0, b##0_1_0);
                // TrCallStmt: After ProcessCallStmt
                c#0_0 := $rhs##0_1_0;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(941,47)"} true;
            }
            else
            {
            }

            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(944,9)
            ##pkv#0_1 := bot#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_1, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_1)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_1)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_2: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)), i#0_2)): Seq Box } 
                          LitInt(0) <= i#0_2
                               && i#0_2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_1)), i#0_2)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)))
                     || (forall i#0_3: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)), i#0_3)): Seq Box } 
                      LitInt(0) <= i#0_3
                           && i#0_3
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_1)), i#0_3)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_1)
               ==> PackedKV.__default.WF(##pkv#0_1)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_1)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#0_1);
            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            if (bot_from#0 < PackedKV.__default.NumKVPairs(bot#0))
            {
                newtype$check#0_0 := LitInt(0);
                assert LitInt(0 - 2147483648) <= newtype$check#0_0 && newtype$check#0_0 < 2147483648;
            }

            assume PackedKV.__default.NumKVPairs#canCall(bot#0);
            if (bot_from#0 < PackedKV.__default.NumKVPairs(bot#0) && c#0_0 == LitInt(0))
            {
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(945,19)
                assume true;
                assume true;
                key#0_2_0 := topkey#0_0;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(945,27)"} true;
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(946,22)
                assume true;
                ##pkv#0_2_0 := top#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_2_0, Tclass.PackedKV.Pkv(), $Heap);
                ##i#0_2_0 := from#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##i#0_2_0, Tclass.NativeTypes.uint64(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_0))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_0))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_0))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_0)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_0)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_0))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_0)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_0)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_0)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_0))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_0))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_0))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_0))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_0))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_0))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_0)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_0))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_0)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_0))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_0)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_0)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_0)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_0)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_0)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_2_0: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_0)), i#0_2_0)): Seq Box } 
                              LitInt(0) <= i#0_2_0
                                   && i#0_2_0
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_0)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_0)), i#0_2_0)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_0)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_0)))
                         || (forall i#0_2_1: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_0)), i#0_2_1)): Seq Box } 
                          LitInt(0) <= i#0_2_1
                               && i#0_2_1
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_0)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_0)), i#0_2_1)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_0)
                   ==> PackedKV.__default.WF(##pkv#0_2_0)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_2_0)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.WF(##pkv#0_2_0);
                assert {:subsumption 0} LitInt(0) <= ##i#0_2_0;
                assert {:subsumption 0} ##i#0_2_0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0)));
                assume LitInt(0) <= ##i#0_2_0
                   && ##i#0_2_0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_0)));
                assume PackedKV.__default.GetMessage#canCall(top#0, from#0);
                assume PackedKV.__default.GetMessage#canCall(top#0, from#0);
                topmsg#0_2_0 := PackedKV.__default.GetMessage(top#0, from#0);
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(946,49)"} true;
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(947,22)
                assume true;
                ##pkv#0_2_1 := bot#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_2_1, Tclass.PackedKV.Pkv(), $Heap);
                ##i#0_2_1 := bot_from#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##i#0_2_1, Tclass.NativeTypes.uint64(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_2_2: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1)), i#0_2_2)): Seq Box } 
                              LitInt(0) <= i#0_2_2
                                   && i#0_2_2
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1)), i#0_2_2)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1)))
                         || (forall i#0_2_3: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1)), i#0_2_3)): Seq Box } 
                          LitInt(0) <= i#0_2_3
                               && i#0_2_3
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1)), i#0_2_3)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1)
                   ==> PackedKV.__default.WF(##pkv#0_2_1)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_2_1)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.WF(##pkv#0_2_1);
                assert {:subsumption 0} LitInt(0) <= ##i#0_2_1;
                assert {:subsumption 0} ##i#0_2_1
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1)));
                assume LitInt(0) <= ##i#0_2_1
                   && ##i#0_2_1
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1)));
                assume PackedKV.__default.GetMessage#canCall(bot#0, bot_from#0);
                assume PackedKV.__default.GetMessage#canCall(bot#0, bot_from#0);
                botmsg#0_2_0 := PackedKV.__default.GetMessage(bot#0, bot_from#0);
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(947,53)"} true;
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(948,19)
                assume true;
                ##newmessage#0_2_0 := topmsg#0_2_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##newmessage#0_2_0, Tclass.ValueMessage.Message(), $Heap);
                ##oldmessage#0_2_0 := botmsg#0_2_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##oldmessage#0_2_0, Tclass.ValueMessage.Message(), $Heap);
                assume ValueMessage.__default.Merge#canCall(topmsg#0_2_0, botmsg#0_2_0);
                assume ValueMessage.__default.Merge#canCall(topmsg#0_2_0, botmsg#0_2_0);
                msg#0_2_0 := ValueMessage.__default.Merge(topmsg#0_2_0, botmsg#0_2_0);
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(948,55)"} true;
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(949,11)
                assume ValueMessage.__default.IdentityMessage#canCall();
                assume $IsA#ValueMessage.Message(msg#0_2_0)
                   && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                   && ValueMessage.__default.IdentityMessage#canCall();
                if (ValueMessage.Message#Equal(msg#0_2_0, ValueMessage.__default.IdentityMessage()))
                {
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(950,18)
                    assume true;
                    newtype$check#0_2_0_0 := LitInt(1);
                    assert LitInt(0) <= newtype$check#0_2_0_0
                       && newtype$check#0_2_0_0 < 18446744073709551616;
                    newtype$check#0_2_0_1 := from#0 + 1;
                    assert LitInt(0) <= newtype$check#0_2_0_1
                       && newtype$check#0_2_0_1 < 18446744073709551616;
                    assume true;
                    from#0 := from#0 + 1;
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(950,28)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(951,22)
                    assume true;
                    newtype$check#0_2_0_2 := LitInt(1);
                    assert LitInt(0) <= newtype$check#0_2_0_2
                       && newtype$check#0_2_0_2 < 18446744073709551616;
                    newtype$check#0_2_0_3 := bot_from#0 + 1;
                    assert LitInt(0) <= newtype$check#0_2_0_3
                       && newtype$check#0_2_0_3 < 18446744073709551616;
                    assume true;
                    bot_from#0 := bot_from#0 + 1;
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(951,36)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(952,19)
                    assume true;
                    assert $Is(key#0_2_0, Tclass.KeyType.Key());
                    ##key#0_2_0_0 := key#0_2_0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##key#0_2_0_0, Tclass.KeyType.Key(), $Heap);
                    assume BucketWeights.__default.WeightKeyUint64#canCall(key#0_2_0);
                    newtype$check#0_2_0_4 := slack#0 + BucketWeights.__default.WeightKeyUint64(key#0_2_0);
                    assert LitInt(0) <= newtype$check#0_2_0_4
                       && newtype$check#0_2_0_4 < 18446744073709551616;
                    ##msg#0_2_0_0 := botmsg#0_2_0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##msg#0_2_0_0, Tclass.ValueMessage.Message(), $Heap);
                    assume BucketWeights.__default.WeightMessageUint64#canCall(botmsg#0_2_0);
                    newtype$check#0_2_0_5 := slack#0
                       + BucketWeights.__default.WeightKeyUint64(key#0_2_0)
                       + BucketWeights.__default.WeightMessageUint64(botmsg#0_2_0);
                    assert LitInt(0) <= newtype$check#0_2_0_5
                       && newtype$check#0_2_0_5 < 18446744073709551616;
                    assume BucketWeights.__default.WeightKeyUint64#canCall(key#0_2_0)
                       && BucketWeights.__default.WeightMessageUint64#canCall(botmsg#0_2_0);
                    slack#0 := slack#0
                       + BucketWeights.__default.WeightKeyUint64(key#0_2_0)
                       + BucketWeights.__default.WeightMessageUint64(botmsg#0_2_0);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(954,45)"} true;
                }
                else
                {
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(956,21)
                    assume true;
                    ##msg#0_2_0 := msg#0_2_0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##msg#0_2_0, Tclass.ValueMessage.Message(), $Heap);
                    assume BucketWeights.__default.WeightMessageUint64#canCall(msg#0_2_0);
                    assume BucketWeights.__default.WeightMessageUint64#canCall(msg#0_2_0);
                    wm1#0_2_0 := BucketWeights.__default.WeightMessageUint64(msg#0_2_0);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(956,47)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(957,21)
                    assume true;
                    ##msg#0_2_1 := botmsg#0_2_0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##msg#0_2_1, Tclass.ValueMessage.Message(), $Heap);
                    assume BucketWeights.__default.WeightMessageUint64#canCall(botmsg#0_2_0);
                    assume BucketWeights.__default.WeightMessageUint64#canCall(botmsg#0_2_0);
                    wm2#0_2_0 := BucketWeights.__default.WeightMessageUint64(botmsg#0_2_0);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(957,50)"} true;
                    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(958,13)
                    newtype$check#0_2_0 := slack#0 + wm2#0_2_0;
                    assert LitInt(0) <= newtype$check#0_2_0 && newtype$check#0_2_0 < 18446744073709551616;
                    assume true;
                    if (wm1#0_2_0 > slack#0 + wm2#0_2_0)
                    {
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(959,15)
                        assume PackedKV.Pkv.Pkv_q(bot#0);
                        ##psa#0_2_1_0 := PackedKV.Pkv.keys(bot#0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##psa#0_2_1_0, Tclass.PackedStringArray.Psa(), $Heap);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_0)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_0)
                             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_0)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_0)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_0)
                             || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_0)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_0)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_0)
                             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_0)) == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_0)) == LitInt(0));
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_0)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_0)
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_0))
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_0))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_1_0), 
                                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_0)) - 1)): int);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_0)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_0)
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(##psa#0_2_1_0));
                        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(##psa#0_2_1_0), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(##psa#0_2_1_0), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_2_1_0: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_2_1_0), i#0_2_1_0)): Seq Box } 
                              LitInt(0) <= i#0_2_1_0
                                   && i#0_2_1_0 < Seq#Length(PackedStringArray.__default.I(##psa#0_2_1_0))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_2_1_0), i#0_2_1_0)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()));
                        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0));
                        assert {:subsumption 0} 0 <= bot_from#0
                           && bot_from#0 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
                        assume PackedKV.Pkv.Pkv_q(bot#0);
                        ##psa#0_2_1_1 := PackedKV.Pkv.keys(bot#0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##psa#0_2_1_1, Tclass.PackedStringArray.Psa(), $Heap);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_1)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_1)
                             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_1)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_1)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_1)
                             || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_1)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_1)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_1)
                             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_1)) == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_1)) == LitInt(0));
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_1)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_1)
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_1))
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_1))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_1_1), 
                                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_1)) - 1)): int);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_1)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_1)
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(##psa#0_2_1_1));
                        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(##psa#0_2_1_1), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(##psa#0_2_1_1), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_2_1_1: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_2_1_1), i#0_2_1_1)): Seq Box } 
                              LitInt(0) <= i#0_2_1_1
                                   && i#0_2_1_1 < Seq#Length(PackedStringArray.__default.I(##psa#0_2_1_1))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_2_1_1), i#0_2_1_1)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()));
                        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0));
                        assert {:subsumption 0} 0 <= bot_from#0
                           && bot_from#0 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
                        ##pkv#0_2_1_0 := bot#0;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##pkv#0_2_1_0, Tclass.PackedKV.Pkv(), $Heap);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_0)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_0))) - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_0))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_0))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                                 || (0
                                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_0)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                           - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_0))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_0))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_0)), 
                                    LitInt(KeyType.__default.MaxLen()))
                                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_0)), 
                                      LitInt(KeyType.__default.MaxLen()))
                                     || (forall i#0_2_1_2: int :: 
                                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_0)), i#0_2_1_2)): Seq Box } 
                                      LitInt(0) <= i#0_2_1_2
                                           && i#0_2_1_2
                                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_0)))
                                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_0)), i#0_2_1_2)): Seq Box)
                                           <= LitInt(KeyType.__default.MaxLen()))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                 || (forall i#0_2_1_3: int :: 
                                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_0)), i#0_2_1_3)): Seq Box } 
                                  LitInt(0) <= i#0_2_1_3
                                       && i#0_2_1_3
                                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_0)))
                                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_0)), i#0_2_1_3)): Seq Box)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_0)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_0)
                             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_2_1_0)), 
                              $Box(ValueMessage.__default.IdentityMessage()));
                        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assert {:subsumption 0} bot_from#0 <= PackedKV.__default.NumKVPairs(bot#0)
                           && PackedKV.__default.NumKVPairs(bot#0)
                             <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
                        assume PackedKV.Pkv.Pkv_q(bot#0)
                           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
                           && 
                          PackedKV.Pkv.Pkv_q(bot#0)
                           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
                           && PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assert Seq#Equal(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0), 
                          Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), 
                              PackedKV.__default.NumKVPairs(bot#0)), 
                            bot_from#0));
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(961,15)
                        assume PackedKV.Pkv.Pkv_q(bot#0);
                        ##psa#0_2_1_2 := PackedKV.Pkv.messages(bot#0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##psa#0_2_1_2, Tclass.PackedStringArray.Psa(), $Heap);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_2)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_2)
                             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_2)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_2)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_2)
                             || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_2)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_2)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_2)
                             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_2)) == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_2)) == LitInt(0));
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_2)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_2)
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_2))
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_2))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_1_2), 
                                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_2)) - 1)): int);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_2)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_2)
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(##psa#0_2_1_2));
                        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
                        assert {:subsumption 0} 0 <= bot_from#0
                           && bot_from#0
                             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
                        assume PackedKV.Pkv.Pkv_q(bot#0);
                        ##psa#0_2_1_3 := PackedKV.Pkv.messages(bot#0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##psa#0_2_1_3, Tclass.PackedStringArray.Psa(), $Heap);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_3)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_3)
                             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_3)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_3)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_3)
                             || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_3)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_3)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_3)
                             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_3)) == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_3)) == LitInt(0));
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_3)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_3)
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_3))
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_1_3))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_1_3), 
                                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_1_3)) - 1)): int);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_1_3)
                           ==> PackedStringArray.__default.WF(##psa#0_2_1_3)
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(##psa#0_2_1_3));
                        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
                        assert {:subsumption 0} 0 <= bot_from#0
                           && bot_from#0
                             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
                        ##pkv#0_2_1_1 := bot#0;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##pkv#0_2_1_1, Tclass.PackedKV.Pkv(), $Heap);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_1)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_1))) - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_1))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_1))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                                 || (0
                                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_1)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                           - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_1))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_1))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_1)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_1)), 
                                    LitInt(KeyType.__default.MaxLen()))
                                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_1)), 
                                      LitInt(KeyType.__default.MaxLen()))
                                     || (forall i#0_2_1_4: int :: 
                                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_1)), i#0_2_1_4)): Seq Box } 
                                      LitInt(0) <= i#0_2_1_4
                                           && i#0_2_1_4
                                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_1)))
                                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_1)), i#0_2_1_4)): Seq Box)
                                           <= LitInt(KeyType.__default.MaxLen()))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                 || (forall i#0_2_1_5: int :: 
                                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_1)), i#0_2_1_5)): Seq Box } 
                                  LitInt(0) <= i#0_2_1_5
                                       && i#0_2_1_5
                                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_1)))
                                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_1)), i#0_2_1_5)): Seq Box)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_1)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_1)
                             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_2_1_1)), 
                              $Box(ValueMessage.__default.IdentityMessage()));
                        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assert {:subsumption 0} bot_from#0 <= PackedKV.__default.NumKVPairs(bot#0)
                           && PackedKV.__default.NumKVPairs(bot#0)
                             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
                        assume PackedKV.Pkv.Pkv_q(bot#0)
                           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
                           && 
                          PackedKV.Pkv.Pkv_q(bot#0)
                           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
                           && PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assert Seq#Equal(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0), 
                          Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                              PackedKV.__default.NumKVPairs(bot#0)), 
                            bot_from#0));
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(964,32)
                        // TrCallStmt: Before ProcessCallStmt
                        assume true;
                        assert dresult#0 != null;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        pkv##0_2_1_0 := bot#0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        start##0_2_1_0 := bot_from#0;
                        ##pkv#0_2_1_2 := bot#0;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##pkv#0_2_1_2, Tclass.PackedKV.Pkv(), $Heap);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_2)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_2))) - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2_1_2))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_2))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                                 || (0
                                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_2)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                           - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2_1_2))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_2))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2_1_2)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_2)), 
                                    LitInt(KeyType.__default.MaxLen()))
                                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_2)), 
                                      LitInt(KeyType.__default.MaxLen()))
                                     || (forall i#0_2_1_6: int :: 
                                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_2)), i#0_2_1_6)): Seq Box } 
                                      LitInt(0) <= i#0_2_1_6
                                           && i#0_2_1_6
                                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_2)))
                                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2_1_2)), i#0_2_1_6)): Seq Box)
                                           <= LitInt(KeyType.__default.MaxLen()))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                 || (forall i#0_2_1_7: int :: 
                                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_2)), i#0_2_1_7)): Seq Box } 
                                  LitInt(0) <= i#0_2_1_7
                                       && i#0_2_1_7
                                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_2)))
                                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2_1_2)), i#0_2_1_7)): Seq Box)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2_1_2)
                           ==> PackedKV.__default.WF(##pkv#0_2_1_2)
                             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_2_1_2)), 
                              $Box(ValueMessage.__default.IdentityMessage()));
                        assume PackedKV.__default.WF(##pkv#0_2_1_2);
                        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                        // ProcessCallStmt: CheckSubrange
                        end##0_2_1_0 := PackedKV.__default.NumKVPairs(bot#0);
                        assert (forall<alpha> $o: ref, $f: Field alpha :: 
                          $o != null
                               && read($Heap, $o, alloc)
                               && ($o == dresult#0
                                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
                             ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.DynamicPkv.AppendPkv(dresult#0, pkv##0_2_1_0, start##0_2_1_0, end##0_2_1_0);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(964,67)"} true;
                        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(965,22)
                        assume true;
                        assert dresult#0 != null;
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Subset(read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr), 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Subset(read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                                PackedStringArray.DynamicPsa.Repr), 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                                read($Heap, 
                                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                  PackedStringArray.DynamicPsa.Repr)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
                        assume DynamicPkv.DynamicPkv.WF($Heap, dresult#0);
                        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
                        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                        result#0 := #DynamicPkv.SingleMergeResult.SlackExhausted(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0), from#0, slack#0);
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(965,68)"} true;
                        // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(966,15)
                        return;
                    }
                    else
                    {
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(968,32)
                        // TrCallStmt: Before ProcessCallStmt
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        pkv##0_2_0 := top#0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        a##0_2_0 := from#0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        b##0_2_0 := to#0;
                        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.__default.PSAPopFrontWeight(pkv##0_2_0, a##0_2_0, b##0_2_0);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(968,46)"} true;
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(969,38)
                        // TrCallStmt: Before ProcessCallStmt
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        pkv##0_2_1 := bot#0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        a##0_2_1 := bot_from#0;
                        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.__default.PSAPopFrontWeightSuffix(pkv##0_2_1, a##0_2_1);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(969,52)"} true;
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(970,32)
                        // TrCallStmt: Before ProcessCallStmt
                        assert dresult#0 != null;
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Subset(read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr), 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Subset(read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                                PackedStringArray.DynamicPsa.Repr), 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                                read($Heap, 
                                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                  PackedStringArray.DynamicPsa.Repr)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
                        assume DynamicPkv.DynamicPkv.WF($Heap, dresult#0);
                        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
                        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                        // ProcessCallStmt: CheckSubrange
                        pkv##0_2_2 := DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0);
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        assert $Is(key#0_2_0, Tclass.KeyType.Key());
                        key##0_2_0 := key#0_2_0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        msg##0_2_0 := msg#0_2_0;
                        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.__default.PSAPushBackWeight(pkv##0_2_2, key##0_2_0, msg##0_2_0);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(970,58)"} true;
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(972,29)
                        // TrCallStmt: Before ProcessCallStmt
                        assume true;
                        assert dresult#0 != null;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        assert $Is(key#0_2_0, Tclass.KeyType.Key());
                        key##0_2_1 := key#0_2_0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        msg##0_2_1 := msg#0_2_0;
                        assert (forall<alpha> $o: ref, $f: Field alpha :: 
                          $o != null
                               && read($Heap, $o, alloc)
                               && ($o == dresult#0
                                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
                             ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.DynamicPkv.Append(dresult#0, key##0_2_1, msg##0_2_1);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(972,38)"} true;
                        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(973,20)
                        assume true;
                        newtype$check#0_2_1 := LitInt(1);
                        assert LitInt(0) <= newtype$check#0_2_1 && newtype$check#0_2_1 < 18446744073709551616;
                        newtype$check#0_2_2 := from#0 + 1;
                        assert LitInt(0) <= newtype$check#0_2_2 && newtype$check#0_2_2 < 18446744073709551616;
                        assume true;
                        from#0 := from#0 + 1;
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(973,30)"} true;
                        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(974,24)
                        assume true;
                        newtype$check#0_2_3 := LitInt(1);
                        assert LitInt(0) <= newtype$check#0_2_3 && newtype$check#0_2_3 < 18446744073709551616;
                        newtype$check#0_2_4 := bot_from#0 + 1;
                        assert LitInt(0) <= newtype$check#0_2_4 && newtype$check#0_2_4 < 18446744073709551616;
                        assume true;
                        bot_from#0 := bot_from#0 + 1;
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(974,38)"} true;
                        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(975,21)
                        assume true;
                        newtype$check#0_2_5 := slack#0 + wm2#0_2_0;
                        assert LitInt(0) <= newtype$check#0_2_5 && newtype$check#0_2_5 < 18446744073709551616;
                        newtype$check#0_2_6 := slack#0 + wm2#0_2_0 - wm1#0_2_0;
                        assert LitInt(0) <= newtype$check#0_2_6 && newtype$check#0_2_6 < 18446744073709551616;
                        assume true;
                        slack#0 := slack#0 + wm2#0_2_0 - wm1#0_2_0;
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(975,40)"} true;
                    }
                }
            }
            else
            {
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(978,16)
                ##pkv#0_2 := bot#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_2, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_2)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_2))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_2)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_2))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_2)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_2)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_4: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2)), i#0_4)): Seq Box } 
                              LitInt(0) <= i#0_4
                                   && i#0_4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_2)), i#0_4)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2)))
                         || (forall i#0_5: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2)), i#0_5)): Seq Box } 
                          LitInt(0) <= i#0_5
                               && i#0_5
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_2)), i#0_5)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_2)
                   ==> PackedKV.__default.WF(##pkv#0_2)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_2)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.WF(##pkv#0_2);
                assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                if (bot_from#0 != PackedKV.__default.NumKVPairs(bot#0))
                {
                    newtype$check#0_1 := LitInt(0);
                    assert LitInt(0 - 2147483648) <= newtype$check#0_1 && newtype$check#0_1 < 2147483648;
                }

                assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                if (bot_from#0 == PackedKV.__default.NumKVPairs(bot#0) || c#0_0 < 0)
                {
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(979,19)
                    assume true;
                    assume true;
                    key#0_3_0 := topkey#0_0;
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(979,27)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(980,19)
                    assume true;
                    ##pkv#0_3_0 := top#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##pkv#0_3_0, Tclass.PackedKV.Pkv(), $Heap);
                    ##i#0_3_0 := from#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##i#0_3_0, Tclass.NativeTypes.uint64(), $Heap);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0))
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0)))
                               < 4294967296);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0))
                             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0)))
                               < 4294967296);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0))
                             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0)))
                                 == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0)))
                                 == LitInt(0)));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0))
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0)))
                               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0)))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0)), 
                                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0))) - 1)): int));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0))
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0))));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0))
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0)))
                               < 4294967296);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0))
                             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0)))
                               < 4294967296);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0))
                             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0)))
                                 == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0)))
                                 == LitInt(0)));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0))
                             || (0
                                 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0)))
                               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0)))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0)), 
                                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0)))
                                       - 1)): int));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0))
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0))));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0)))
                           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0)));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0)))
                           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0)))
                             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0)), 
                                LitInt(KeyType.__default.MaxLen()))
                               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0)), 
                                  LitInt(KeyType.__default.MaxLen()))
                                 || (forall i#0_3_0: int :: 
                                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0)), i#0_3_0)): Seq Box } 
                                  LitInt(0) <= i#0_3_0
                                       && i#0_3_0
                                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0)))
                                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0)), i#0_3_0)): Seq Box)
                                       <= LitInt(KeyType.__default.MaxLen()))));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0)))
                           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0)))
                             || (forall i#0_3_1: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0)), i#0_3_1)): Seq Box } 
                              LitInt(0) <= i#0_3_1
                                   && i#0_3_1
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0)))
                                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0)), i#0_3_1)): Seq Box)));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0)
                       ==> PackedKV.__default.WF(##pkv#0_3_0)
                         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_3_0)), 
                          $Box(ValueMessage.__default.IdentityMessage()));
                    assume PackedKV.__default.WF(##pkv#0_3_0);
                    assert {:subsumption 0} LitInt(0) <= ##i#0_3_0;
                    assert {:subsumption 0} ##i#0_3_0
                       < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0)));
                    assume LitInt(0) <= ##i#0_3_0
                       && ##i#0_3_0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0)));
                    assume PackedKV.__default.GetMessage#canCall(top#0, from#0);
                    assume PackedKV.__default.GetMessage#canCall(top#0, from#0);
                    msg#0_3_0 := PackedKV.__default.GetMessage(top#0, from#0);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(980,46)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(981,21)
                    assume true;
                    assert $Is(key#0_3_0, Tclass.KeyType.Key());
                    ##key#0_3_0 := key#0_3_0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##key#0_3_0, Tclass.KeyType.Key(), $Heap);
                    assume BucketWeights.__default.WeightKeyUint64#canCall(key#0_3_0);
                    ##msg#0_3_0 := msg#0_3_0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##msg#0_3_0, Tclass.ValueMessage.Message(), $Heap);
                    assume BucketWeights.__default.WeightMessageUint64#canCall(msg#0_3_0);
                    newtype$check#0_3_0 := BucketWeights.__default.WeightKeyUint64(key#0_3_0)
                       + BucketWeights.__default.WeightMessageUint64(msg#0_3_0);
                    assert LitInt(0) <= newtype$check#0_3_0 && newtype$check#0_3_0 < 18446744073709551616;
                    assume BucketWeights.__default.WeightKeyUint64#canCall(key#0_3_0)
                       && BucketWeights.__default.WeightMessageUint64#canCall(msg#0_3_0);
                    delta#0_3_0 := BucketWeights.__default.WeightKeyUint64(key#0_3_0)
                       + BucketWeights.__default.WeightMessageUint64(msg#0_3_0);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(981,70)"} true;
                    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(982,11)
                    assume true;
                    if (delta#0_3_0 > slack#0)
                    {
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(983,13)
                        assume PackedKV.Pkv.Pkv_q(bot#0);
                        ##psa#0_3_0_0 := PackedKV.Pkv.keys(bot#0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##psa#0_3_0_0, Tclass.PackedStringArray.Psa(), $Heap);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_0)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                             || Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_0)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_0)) == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_0)) == LitInt(0));
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_0))
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_0))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_3_0_0), 
                                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_0)) - 1)): int);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_0)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_0)
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(##psa#0_3_0_0));
                        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(##psa#0_3_0_0), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(##psa#0_3_0_0), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_3_0_0: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_3_0_0), i#0_3_0_0)): Seq Box } 
                              LitInt(0) <= i#0_3_0_0
                                   && i#0_3_0_0 < Seq#Length(PackedStringArray.__default.I(##psa#0_3_0_0))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_3_0_0), i#0_3_0_0)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()));
                        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0));
                        assert {:subsumption 0} 0 <= bot_from#0
                           && bot_from#0 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
                        assume PackedKV.Pkv.Pkv_q(bot#0);
                        ##psa#0_3_0_1 := PackedKV.Pkv.keys(bot#0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##psa#0_3_0_1, Tclass.PackedStringArray.Psa(), $Heap);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_1)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                             || Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_1)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_1)) == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_1)) == LitInt(0));
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_1))
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_1))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_3_0_1), 
                                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_1)) - 1)): int);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_1)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_1)
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(##psa#0_3_0_1));
                        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(##psa#0_3_0_1), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(##psa#0_3_0_1), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_3_0_1: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_3_0_1), i#0_3_0_1)): Seq Box } 
                              LitInt(0) <= i#0_3_0_1
                                   && i#0_3_0_1 < Seq#Length(PackedStringArray.__default.I(##psa#0_3_0_1))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_3_0_1), i#0_3_0_1)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()));
                        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0));
                        assert {:subsumption 0} 0 <= bot_from#0
                           && bot_from#0 <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
                        ##pkv#0_3_0_0 := bot#0;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##pkv#0_3_0_0, Tclass.PackedKV.Pkv(), $Heap);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_0)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_0))) - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_0))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_0))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                                 || (0
                                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_0)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                           - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_0))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_0))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_0)), 
                                    LitInt(KeyType.__default.MaxLen()))
                                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_0)), 
                                      LitInt(KeyType.__default.MaxLen()))
                                     || (forall i#0_3_0_2: int :: 
                                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_0)), i#0_3_0_2)): Seq Box } 
                                      LitInt(0) <= i#0_3_0_2
                                           && i#0_3_0_2
                                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_0)))
                                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_0)), i#0_3_0_2)): Seq Box)
                                           <= LitInt(KeyType.__default.MaxLen()))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                 || (forall i#0_3_0_3: int :: 
                                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_0)), i#0_3_0_3)): Seq Box } 
                                  LitInt(0) <= i#0_3_0_3
                                       && i#0_3_0_3
                                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_0)))
                                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_0)), i#0_3_0_3)): Seq Box)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_0)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_0)
                             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_3_0_0)), 
                              $Box(ValueMessage.__default.IdentityMessage()));
                        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assert {:subsumption 0} bot_from#0 <= PackedKV.__default.NumKVPairs(bot#0)
                           && PackedKV.__default.NumKVPairs(bot#0)
                             <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)));
                        assume PackedKV.Pkv.Pkv_q(bot#0)
                           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
                           && 
                          PackedKV.Pkv.Pkv_q(bot#0)
                           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
                           && PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assert Seq#Equal(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0), 
                          Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), 
                              PackedKV.__default.NumKVPairs(bot#0)), 
                            bot_from#0));
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(985,13)
                        assume PackedKV.Pkv.Pkv_q(bot#0);
                        ##psa#0_3_0_2 := PackedKV.Pkv.messages(bot#0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##psa#0_3_0_2, Tclass.PackedStringArray.Psa(), $Heap);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_2)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                             || Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_2)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_2)) == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_2)) == LitInt(0));
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_2))
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_2))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_3_0_2), 
                                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_2)) - 1)): int);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_2)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_2)
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(##psa#0_3_0_2));
                        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
                        assert {:subsumption 0} 0 <= bot_from#0
                           && bot_from#0
                             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
                        assume PackedKV.Pkv.Pkv_q(bot#0);
                        ##psa#0_3_0_3 := PackedKV.Pkv.messages(bot#0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##psa#0_3_0_3, Tclass.PackedStringArray.Psa(), $Heap);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_3)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_3)
                             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_3)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_3)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_3)
                             || Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_3)) < 4294967296;
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_3)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_3)
                             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_3)) == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_3)) == LitInt(0));
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_3)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_3)
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_3))
                               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_3_0_3))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_3_0_3), 
                                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_3_0_3)) - 1)): int);
                        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_3_0_3)
                           ==> PackedStringArray.__default.WF(##psa#0_3_0_3)
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(##psa#0_3_0_3));
                        assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0));
                        assert {:subsumption 0} 0 <= bot_from#0
                           && bot_from#0
                             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
                        ##pkv#0_3_0_1 := bot#0;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##pkv#0_3_0_1, Tclass.PackedKV.Pkv(), $Heap);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_1)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_1))) - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_1))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_1))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                                 || (0
                                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_1)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                           - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_1))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_1))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_1)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_1)), 
                                    LitInt(KeyType.__default.MaxLen()))
                                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_1)), 
                                      LitInt(KeyType.__default.MaxLen()))
                                     || (forall i#0_3_0_4: int :: 
                                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_1)), i#0_3_0_4)): Seq Box } 
                                      LitInt(0) <= i#0_3_0_4
                                           && i#0_3_0_4
                                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_1)))
                                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_1)), i#0_3_0_4)): Seq Box)
                                           <= LitInt(KeyType.__default.MaxLen()))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                 || (forall i#0_3_0_5: int :: 
                                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_1)), i#0_3_0_5)): Seq Box } 
                                  LitInt(0) <= i#0_3_0_5
                                       && i#0_3_0_5
                                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_1)))
                                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_1)), i#0_3_0_5)): Seq Box)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_1)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_1)
                             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_3_0_1)), 
                              $Box(ValueMessage.__default.IdentityMessage()));
                        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assert {:subsumption 0} bot_from#0 <= PackedKV.__default.NumKVPairs(bot#0)
                           && PackedKV.__default.NumKVPairs(bot#0)
                             <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)));
                        assume PackedKV.Pkv.Pkv_q(bot#0)
                           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
                           && 
                          PackedKV.Pkv.Pkv_q(bot#0)
                           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
                           && PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assert Seq#Equal(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0), 
                          Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
                              PackedKV.__default.NumKVPairs(bot#0)), 
                            bot_from#0));
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(988,30)
                        // TrCallStmt: Before ProcessCallStmt
                        assume true;
                        assert dresult#0 != null;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        pkv##0_3_0_0 := bot#0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        start##0_3_0_0 := bot_from#0;
                        ##pkv#0_3_0_2 := bot#0;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##pkv#0_3_0_2, Tclass.PackedKV.Pkv(), $Heap);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_2)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_2))) - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3_0_2))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_2))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                   < 4294967296);
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                     == LitInt(0)
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                     == LitInt(0)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                                 || (0
                                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_2)), 
                                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                           - 1)): int));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3_0_2))
                                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_2))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3_0_2)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_2)), 
                                    LitInt(KeyType.__default.MaxLen()))
                                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_2)), 
                                      LitInt(KeyType.__default.MaxLen()))
                                     || (forall i#0_3_0_6: int :: 
                                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_2)), i#0_3_0_6)): Seq Box } 
                                      LitInt(0) <= i#0_3_0_6
                                           && i#0_3_0_6
                                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_2)))
                                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3_0_2)), i#0_3_0_6)): Seq Box)
                                           <= LitInt(KeyType.__default.MaxLen()))));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                 || (forall i#0_3_0_7: int :: 
                                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_2)), i#0_3_0_7)): Seq Box } 
                                  LitInt(0) <= i#0_3_0_7
                                       && i#0_3_0_7
                                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_2)))
                                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3_0_2)), i#0_3_0_7)): Seq Box)));
                        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3_0_2)
                           ==> PackedKV.__default.WF(##pkv#0_3_0_2)
                             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_3_0_2)), 
                              $Box(ValueMessage.__default.IdentityMessage()));
                        assume PackedKV.__default.WF(##pkv#0_3_0_2);
                        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
                        // ProcessCallStmt: CheckSubrange
                        end##0_3_0_0 := PackedKV.__default.NumKVPairs(bot#0);
                        assert (forall<alpha> $o: ref, $f: Field alpha :: 
                          $o != null
                               && read($Heap, $o, alloc)
                               && ($o == dresult#0
                                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
                             ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.DynamicPkv.AppendPkv(dresult#0, pkv##0_3_0_0, start##0_3_0_0, end##0_3_0_0);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(988,65)"} true;
                        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(989,20)
                        assume true;
                        assert dresult#0 != null;
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Subset(read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr), 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Subset(read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                                PackedStringArray.DynamicPsa.Repr), 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                                read($Heap, 
                                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                  PackedStringArray.DynamicPsa.Repr)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
                        assume DynamicPkv.DynamicPkv.WF($Heap, dresult#0);
                        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
                        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                        result#0 := #DynamicPkv.SingleMergeResult.SlackExhausted(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0), from#0, slack#0);
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(989,66)"} true;
                        // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(990,13)
                        return;
                    }
                    else
                    {
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(992,30)
                        // TrCallStmt: Before ProcessCallStmt
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        pkv##0_3_0 := top#0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        a##0_3_0 := from#0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        b##0_3_0 := to#0;
                        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.__default.PSAPopFrontWeight(pkv##0_3_0, a##0_3_0, b##0_3_0);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(992,44)"} true;
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(993,30)
                        // TrCallStmt: Before ProcessCallStmt
                        assert dresult#0 != null;
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Subset(read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr), 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Subset(read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                                PackedStringArray.DynamicPsa.Repr), 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                                read($Heap, 
                                  read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                                  PackedStringArray.DynamicPsa.Repr)), 
                              read($Heap, 
                                read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                                PackedStringArray.DynamicPsa.Repr));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
                        assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                           ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                             || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                                PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
                        assume DynamicPkv.DynamicPkv.WF($Heap, dresult#0);
                        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                        assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
                        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                        // ProcessCallStmt: CheckSubrange
                        pkv##0_3_1 := DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0);
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        assert $Is(key#0_3_0, Tclass.KeyType.Key());
                        key##0_3_0 := key#0_3_0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        msg##0_3_0 := msg#0_3_0;
                        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.__default.PSAPushBackWeight(pkv##0_3_1, key##0_3_0, msg##0_3_0);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(993,56)"} true;
                        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(995,27)
                        // TrCallStmt: Before ProcessCallStmt
                        assume true;
                        assert dresult#0 != null;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        assert $Is(key#0_3_0, Tclass.KeyType.Key());
                        key##0_3_1 := key#0_3_0;
                        assume true;
                        // ProcessCallStmt: CheckSubrange
                        msg##0_3_1 := msg#0_3_0;
                        assert (forall<alpha> $o: ref, $f: Field alpha :: 
                          $o != null
                               && read($Heap, $o, alloc)
                               && ($o == dresult#0
                                 || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
                             ==> $_Frame[$o, $f]);
                        // ProcessCallStmt: Make the call
                        call Call$$DynamicPkv.DynamicPkv.Append(dresult#0, key##0_3_1, msg##0_3_1);
                        // TrCallStmt: After ProcessCallStmt
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(995,36)"} true;
                        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(996,18)
                        assume true;
                        newtype$check#0_3_1 := LitInt(1);
                        assert LitInt(0) <= newtype$check#0_3_1 && newtype$check#0_3_1 < 18446744073709551616;
                        newtype$check#0_3_2 := from#0 + 1;
                        assert LitInt(0) <= newtype$check#0_3_2 && newtype$check#0_3_2 < 18446744073709551616;
                        assume true;
                        from#0 := from#0 + 1;
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(996,28)"} true;
                        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(997,19)
                        assume true;
                        newtype$check#0_3_3 := slack#0 - delta#0_3_0;
                        assert LitInt(0) <= newtype$check#0_3_3 && newtype$check#0_3_3 < 18446744073709551616;
                        assume true;
                        slack#0 := slack#0 - delta#0_3_0;
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(997,34)"} true;
                    }
                }
                else
                {
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1000,19)
                    assume true;
                    assume true;
                    key#0_0 := botkey#0_0;
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1000,27)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1001,19)
                    assume true;
                    ##pkv#0_3 := bot#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##pkv#0_3, Tclass.PackedKV.Pkv(), $Heap);
                    ##i#0_1 := bot_from#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##i#0_1, Tclass.NativeTypes.uint64(), $Heap);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3))
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3)))
                               < 4294967296);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3))
                             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3)))
                               < 4294967296);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3))
                             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3)))
                                 == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3)))
                                 == LitInt(0)));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3))
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3)))
                               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_3)))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3)), 
                                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3))) - 1)): int));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_3))
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3))));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3))
                             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3)))
                               < 4294967296);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3))
                             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3)))
                               < 4294967296);
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3))
                             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3)))
                                 == LitInt(0)
                               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3)))
                                 == LitInt(0)));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3))
                             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3)))
                               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_3)))
                                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3)), 
                                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3))) - 1)): int));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_3))
                           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_3))
                             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3))));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_3)))
                           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3)));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3)))
                           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3)))
                             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3)), 
                                LitInt(KeyType.__default.MaxLen()))
                               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3)), 
                                  LitInt(KeyType.__default.MaxLen()))
                                 || (forall i#0_6: int :: 
                                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3)), i#0_6)): Seq Box } 
                                  LitInt(0) <= i#0_6
                                       && i#0_6 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3)))
                                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_3)), i#0_6)): Seq Box)
                                       <= LitInt(KeyType.__default.MaxLen()))));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3)))
                           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3)))
                             || (forall i#0_7: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3)), i#0_7)): Seq Box } 
                              LitInt(0) <= i#0_7
                                   && i#0_7
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3)))
                                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_3)), i#0_7)): Seq Box)));
                    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_3)
                       ==> PackedKV.__default.WF(##pkv#0_3)
                         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_3)), 
                          $Box(ValueMessage.__default.IdentityMessage()));
                    assume PackedKV.__default.WF(##pkv#0_3);
                    assert {:subsumption 0} LitInt(0) <= ##i#0_1;
                    assert {:subsumption 0} ##i#0_1
                       < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3)));
                    assume LitInt(0) <= ##i#0_1
                       && ##i#0_1
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_3)));
                    assume PackedKV.__default.GetMessage#canCall(bot#0, bot_from#0);
                    assume PackedKV.__default.GetMessage#canCall(bot#0, bot_from#0);
                    msg#0_0 := PackedKV.__default.GetMessage(bot#0, bot_from#0);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1001,50)"} true;
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1003,28)
                    // TrCallStmt: Before ProcessCallStmt
                    assert dresult#0 != null;
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(dresult#0)];
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys))];
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || Set#Subset(read($Heap, 
                            read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                            PackedStringArray.DynamicPsa.Repr), 
                          read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box(read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))];
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || Set#Subset(read($Heap, 
                            read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                            PackedStringArray.DynamicPsa.Repr), 
                          read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr));
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                          read($Heap, 
                            read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                            PackedStringArray.DynamicPsa.Repr));
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || Set#Disjoint(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                          read($Heap, 
                            read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                            PackedStringArray.DynamicPsa.Repr));
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || Set#Disjoint(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(dresult#0)), 
                            read($Heap, 
                              read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys), 
                              PackedStringArray.DynamicPsa.Repr)), 
                          read($Heap, 
                            read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages), 
                            PackedStringArray.DynamicPsa.Repr));
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys));
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || PackedStringArray.DynamicPsa.WF($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages));
                    assert {:subsumption 0} DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0)
                       ==> DynamicPkv.DynamicPkv.WF($Heap, dresult#0)
                         || PackedKV.__default.WF(#PackedKV.Pkv.Pkv(PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.keys)), 
                            PackedStringArray.DynamicPsa.toPsa($Heap, read($Heap, dresult#0, DynamicPkv.DynamicPkv.messages))));
                    assume DynamicPkv.DynamicPkv.WF($Heap, dresult#0);
                    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                    assume PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
                    assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0);
                    // ProcessCallStmt: CheckSubrange
                    pkv##0_0 := DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0);
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    assert $Is(key#0_0, Tclass.KeyType.Key());
                    key##0_0 := key#0_0;
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    msg##0_0 := msg#0_0;
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call Call$$DynamicPkv.__default.PSAPushBackWeight(pkv##0_0, key##0_0, msg##0_0);
                    // TrCallStmt: After ProcessCallStmt
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1003,54)"} true;
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1004,34)
                    // TrCallStmt: Before ProcessCallStmt
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    pkv##0_1 := bot#0;
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    a##0_0 := bot_from#0;
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call Call$$DynamicPkv.__default.PSAPopFrontWeightSuffix(pkv##0_1, a##0_0);
                    // TrCallStmt: After ProcessCallStmt
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1004,48)"} true;
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1006,25)
                    // TrCallStmt: Before ProcessCallStmt
                    assume true;
                    assert dresult#0 != null;
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    assert $Is(key#0_0, Tclass.KeyType.Key());
                    key##0_1 := key#0_0;
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    msg##0_1 := msg#0_0;
                    assert (forall<alpha> $o: ref, $f: Field alpha :: 
                      $o != null
                           && read($Heap, $o, alloc)
                           && ($o == dresult#0
                             || read($Heap, dresult#0, DynamicPkv.DynamicPkv.Repr)[$Box($o)])
                         ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call Call$$DynamicPkv.DynamicPkv.Append(dresult#0, key##0_1, msg##0_1);
                    // TrCallStmt: After ProcessCallStmt
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1006,34)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1007,20)
                    assume true;
                    newtype$check#0_2 := LitInt(1);
                    assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
                    newtype$check#0_3 := bot_from#0 + 1;
                    assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
                    assume true;
                    bot_from#0 := bot_from#0 + 1;
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1007,34)"} true;
                }
            }
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(894,5)
        assert 0 <= $decr$loop#00
           || PackedKV.__default.NumKVPairs(top#0) + PackedKV.__default.NumKVPairs(bot#0)
               - from#0
               - bot_from#0
             == $decr$loop#00;
        assert PackedKV.__default.NumKVPairs(top#0) + PackedKV.__default.NumKVPairs(bot#0)
             - from#0
             - bot_from#0
           < $decr$loop#00;
        assume true;
        assume PackedKV.__default.NumKVPairs#canCall(bot#0);
        assume DynamicPkv.DynamicPkv.WF#canCall($Heap, dresult#0);
        assume true;
        assume $IsA#BucketModel.singleMergeResult(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
              from0#0, 
              to#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
              LitInt(0), 
              Lit(Seq#Empty(): Seq Box), 
              Lit(Seq#Empty(): Seq Box), 
              slack0#0))
           && $IsA#BucketModel.singleMergeResult(BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
              from#0, 
              to#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
              bot_from#0, 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
              PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
              slack#0))
           && 
          PackedKV.Pkv.Pkv_q(top#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0))
           && 
          PackedKV.Pkv.Pkv_q(top#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
           && BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
            from0#0, 
            to#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
            LitInt(0), 
            Lit(Seq#Empty(): Seq Box), 
            Lit(Seq#Empty(): Seq Box), 
            slack0#0)
           && 
          PackedKV.Pkv.Pkv_q(top#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(top#0))
           && 
          PackedKV.Pkv.Pkv_q(top#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(bot#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
           && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)))
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
           && PackedKV.Pkv.Pkv_q(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0)))
           && BucketModel.__default.mergeToOneChild#canCall(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
            from#0, 
            to#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(bot#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), 
            bot_from#0, 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))), 
            slack#0);
        assume DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
           && PackedKV.__default.NumKVPairs#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0));
        assume DynamicPkv.__default.WeightBucketPkv#canCall(bot#0)
           && 
          DynamicPkv.DynamicPkv.toPkv#canCall($Heap, dresult#0)
           && DynamicPkv.__default.WeightBucketPkv#canCall(DynamicPkv.DynamicPkv.toPkv($Heap, dresult#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(bot#0))
           && BucketWeights.__default.WeightKeyList#canCall(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(bot#0)), bot_from#0))
           && 
          PackedKV.Pkv.Pkv_q(bot#0)
           && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(bot#0))
           && BucketWeights.__default.WeightMessageList#canCall(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(bot#0)), bot_from#0));
    }
}



// function declaration for DynamicPkv._default.PKVISeq
function DynamicPkv.__default.PKVISeq($ly: LayerType, s#0: Seq Box) : Seq Box;

function DynamicPkv.__default.PKVISeq#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { DynamicPkv.__default.PKVISeq($LS($ly), s#0) } 
  DynamicPkv.__default.PKVISeq($LS($ly), s#0)
     == DynamicPkv.__default.PKVISeq($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { DynamicPkv.__default.PKVISeq(AsFuelBottom($ly), s#0) } 
  DynamicPkv.__default.PKVISeq($ly, s#0) == DynamicPkv.__default.PKVISeq($LZ, s#0));

function Tclass.BucketsLib.Bucket() : Ty;

// Tclass.BucketsLib.Bucket Tag
axiom Tag(Tclass.BucketsLib.Bucket()) == Tagclass.BucketsLib.Bucket;

const unique Tagclass.BucketsLib.Bucket: TyTag;

// Box/unbox axiom for Tclass.BucketsLib.Bucket
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketsLib.Bucket()) } 
  $IsBox(bx, Tclass.BucketsLib.Bucket())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BucketsLib.Bucket()));

// consequence axiom for DynamicPkv.__default.PKVISeq
axiom 29 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { DynamicPkv.__default.PKVISeq($ly, s#0) } 
    DynamicPkv.__default.PKVISeq#canCall(s#0)
         || (29 != $FunctionContextHeight
           && 
          $Is(s#0, TSeq(Tclass.PackedKV.Pkv()))
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
               ==> PackedKV.__default.WF($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
       ==> Seq#Length(DynamicPkv.__default.PKVISeq($ly, s#0)) == Seq#Length(s#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($ly, s#0), i#1)): DatatypeType } 
            { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(s#0)
             ==> BucketsLib.Bucket#Equal(PackedKV.__default.I($Unbox(Seq#Index(s#0, i#1)): DatatypeType), 
              $Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($ly, s#0), i#1)): DatatypeType))
         && $Is(DynamicPkv.__default.PKVISeq($ly, s#0), TSeq(Tclass.BucketsLib.Bucket())));

function DynamicPkv.__default.PKVISeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for DynamicPkv.__default.PKVISeq
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { DynamicPkv.__default.PKVISeq#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.PackedKV.Pkv()))
     ==> DynamicPkv.__default.PKVISeq#requires($ly, s#0)
       == (forall i#2: int :: 
        { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
        LitInt(0) <= i#2 && i#2 < Seq#Length(s#0)
           ==> PackedKV.__default.WF($Unbox(Seq#Index(s#0, i#2)): DatatypeType)));

// definition axiom for DynamicPkv.__default.PKVISeq(revealed)
axiom 29 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { DynamicPkv.__default.PKVISeq($LS($ly), s#0) } 
    DynamicPkv.__default.PKVISeq#canCall(s#0)
         || (29 != $FunctionContextHeight
           && 
          $Is(s#0, TSeq(Tclass.PackedKV.Pkv()))
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(s#0)
               ==> PackedKV.__default.WF($Unbox(Seq#Index(s#0, i#2)): DatatypeType)))
       ==> (Seq#Length(s#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.PackedKV.Pkv(), s#0)
             && DynamicPkv.__default.PKVISeq#canCall(Sequences.__default.DropLast(Tclass.PackedKV.Pkv(), s#0))
             && 
            Sequences.__default.Last#canCall(Tclass.PackedKV.Pkv(), s#0)
             && PackedKV.__default.I#canCall($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), s#0)): DatatypeType))
         && DynamicPkv.__default.PKVISeq($LS($ly), s#0)
           == (if Seq#Length(s#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(DynamicPkv.__default.PKVISeq($ly, Sequences.__default.DropLast(Tclass.PackedKV.Pkv(), s#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(PackedKV.__default.I($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), s#0)): DatatypeType))))));

// definition axiom for DynamicPkv.__default.PKVISeq for all literals(revealed)
axiom 29 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { DynamicPkv.__default.PKVISeq($LS($ly), Lit(s#0)) } 
    DynamicPkv.__default.PKVISeq#canCall(Lit(s#0))
         || (29 != $FunctionContextHeight
           && 
          $Is(s#0, TSeq(Tclass.PackedKV.Pkv()))
           && (forall i#3: int :: 
            { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(s#0))
               ==> PackedKV.__default.WF($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))
       ==> (Seq#Length(Lit(s#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.PackedKV.Pkv(), Lit(s#0))
             && DynamicPkv.__default.PKVISeq#canCall(Lit(Sequences.__default.DropLast(Tclass.PackedKV.Pkv(), Lit(s#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.PackedKV.Pkv(), Lit(s#0))
             && PackedKV.__default.I#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), Lit(s#0))): DatatypeType)))
         && DynamicPkv.__default.PKVISeq($LS($ly), Lit(s#0))
           == (if Seq#Length(Lit(s#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(DynamicPkv.__default.PKVISeq($LS($ly), Lit(Sequences.__default.DropLast(Tclass.PackedKV.Pkv(), Lit(s#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(PackedKV.__default.I(Lit($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), Lit(s#0))): DatatypeType))))))));

procedure CheckWellformed$$DynamicPkv.__default.PKVISeq(s#0: Seq Box where $Is(s#0, TSeq(Tclass.PackedKV.Pkv())))
   returns (res#0: Seq Box where $Is(res#0, TSeq(Tclass.BucketsLib.Bucket())));
  free requires 29 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures Seq#Length(res#0) == Seq#Length(s#0);
  ensures (forall i#4: int :: 
    { $Unbox(Seq#Index(res#0, i#4)): DatatypeType } 
      { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
    LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
       ==> BucketsLib.Bucket#Equal(PackedKV.__default.I($Unbox(Seq#Index(s#0, i#4)): DatatypeType), 
        $Unbox(Seq#Index(res#0, i#4)): DatatypeType));



implementation CheckWellformed$$DynamicPkv.__default.PKVISeq(s#0: Seq Box) returns (res#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#5: int;
  var ##pkv#0: DatatypeType;
  var b$reqreads#0: bool;
  var i#7: int;
  var ##pkv#1: DatatypeType;
  var ##run#0: Seq Box;
  var ##s#0: Seq Box;
  var ##run#1: Seq Box;
  var ##pkv#2: DatatypeType;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;

    // AddWellformednessCheck for function PKVISeq
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1013,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    havoc i#5;
    if (*)
    {
        assume LitInt(0) <= i#5;
        assume i#5 < Seq#Length(s#0);
        assert 0 <= i#5 && i#5 < Seq#Length(s#0);
        ##pkv#0 := $Unbox(Seq#Index(s#0, i#5)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
        b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(s#0, i#5)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(s#0, i#5)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= i#5 && i#5 < Seq#Length(s#0)
           ==> PackedKV.__default.WF($Unbox(Seq#Index(s#0, i#5)): DatatypeType);
    }

    assume (forall i#6: int :: 
      { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
      LitInt(0) <= i#6 && i#6 < Seq#Length(s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(s#0, i#6)): DatatypeType));
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(DynamicPkv.__default.PKVISeq($LS($LZ), s#0), TSeq(Tclass.BucketsLib.Bucket()));
        assume Seq#Length(res#0) == Seq#Length(s#0);
        havoc i#7;
        if (*)
        {
            assume LitInt(0) <= i#7;
            assume i#7 < Seq#Length(s#0);
            assert 0 <= i#7 && i#7 < Seq#Length(s#0);
            ##pkv#1 := $Unbox(Seq#Index(s#0, i#7)): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#8: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#8)): Seq Box } 
                          LitInt(0) <= i#8
                               && i#8 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#8)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                     || (forall i#9: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#9)): Seq Box } 
                      LitInt(0) <= i#9
                           && i#9 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#9)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
               ==> PackedKV.__default.WF(##pkv#1)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#1);
            assume PackedKV.__default.I#canCall($Unbox(Seq#Index(s#0, i#7)): DatatypeType);
            assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Seq#Index(s#0, i#7)): DatatypeType));
            assert 0 <= i#7 && i#7 < Seq#Length(res#0);
            assume BucketsLib.Bucket#Equal(PackedKV.__default.I($Unbox(Seq#Index(s#0, i#7)): DatatypeType), 
              $Unbox(Seq#Index(res#0, i#7)): DatatypeType);
        }
        else
        {
            assume LitInt(0) <= i#7 && i#7 < Seq#Length(s#0)
               ==> BucketsLib.Bucket#Equal(PackedKV.__default.I($Unbox(Seq#Index(s#0, i#7)): DatatypeType), 
                $Unbox(Seq#Index(res#0, i#7)): DatatypeType);
        }

        assume (forall i#4: int :: 
          { $Unbox(Seq#Index(res#0, i#4)): DatatypeType } 
            { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
          LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
             ==> BucketsLib.Bucket#Equal(PackedKV.__default.I($Unbox(Seq#Index(s#0, i#4)): DatatypeType), 
              $Unbox(Seq#Index(res#0, i#4)): DatatypeType));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        if (Seq#Length(s#0) == LitInt(0))
        {
            assume DynamicPkv.__default.PKVISeq($LS($LZ), s#0) == Lit(Seq#Empty(): Seq Box);
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(DynamicPkv.__default.PKVISeq($LS($LZ), s#0), TSeq(Tclass.BucketsLib.Bucket()));
        }
        else
        {
            ##run#0 := s#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0) > 0;
            assume Seq#Length(##run#0) > 0;
            b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.DropLast#canCall(Tclass.PackedKV.Pkv(), s#0);
            ##s#0 := Sequences.__default.DropLast(Tclass.PackedKV.Pkv(), s#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#10: int :: 
              { $Unbox(Seq#Index(##s#0, i#10)): DatatypeType } 
              LitInt(0) <= i#10 && i#10 < Seq#Length(##s#0)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#10)): DatatypeType));
            assume (forall i#10: int :: 
              { $Unbox(Seq#Index(##s#0, i#10)): DatatypeType } 
              LitInt(0) <= i#10 && i#10 < Seq#Length(##s#0)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#10)): DatatypeType));
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert Seq#Rank(##s#0) < Seq#Rank(s#0);
            assume DynamicPkv.__default.PKVISeq#canCall(Sequences.__default.DropLast(Tclass.PackedKV.Pkv(), s#0));
            ##run#1 := s#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1) > 0;
            assume Seq#Length(##run#1) > 0;
            b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.Last#canCall(Tclass.PackedKV.Pkv(), s#0);
            assume PackedKV.Pkv.Pkv_q($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), s#0)): DatatypeType);
            ##pkv#2 := $Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), s#0)): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#11: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#11)): Seq Box } 
                          LitInt(0) <= i#11
                               && i#11 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#11)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                     || (forall i#12: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#12)): Seq Box } 
                      LitInt(0) <= i#12
                           && i#12 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#12)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
               ==> PackedKV.__default.WF(##pkv#2)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#2);
            b$reqreads#4 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedKV.__default.I#canCall($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), s#0)): DatatypeType);
            assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), s#0)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq($LS($LZ), s#0)
               == Seq#Append(DynamicPkv.__default.PKVISeq($LS($LZ), Sequences.__default.DropLast(Tclass.PackedKV.Pkv(), s#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(PackedKV.__default.I($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), s#0)): DatatypeType))));
            assume Sequences.__default.DropLast#canCall(Tclass.PackedKV.Pkv(), s#0)
               && DynamicPkv.__default.PKVISeq#canCall(Sequences.__default.DropLast(Tclass.PackedKV.Pkv(), s#0))
               && 
              Sequences.__default.Last#canCall(Tclass.PackedKV.Pkv(), s#0)
               && PackedKV.__default.I#canCall($Unbox(Sequences.__default.Last(Tclass.PackedKV.Pkv(), s#0)): DatatypeType);
            // CheckWellformedWithResult: any expression
            assume $Is(DynamicPkv.__default.PKVISeq($LS($LZ), s#0), TSeq(Tclass.BucketsLib.Bucket()));
        }

        assume DynamicPkv.__default.PKVISeq($LS($LZ), s#0) == res#0;
        assert b$reqreads#1;
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
    }
}



// function declaration for DynamicPkv._default.seqInt
function DynamicPkv.__default.seqInt($ly: LayerType, s#0: Seq Box) : Seq Box;

function DynamicPkv.__default.seqInt#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { DynamicPkv.__default.seqInt($LS($ly), s#0) } 
  DynamicPkv.__default.seqInt($LS($ly), s#0)
     == DynamicPkv.__default.seqInt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { DynamicPkv.__default.seqInt(AsFuelBottom($ly), s#0) } 
  DynamicPkv.__default.seqInt($ly, s#0) == DynamicPkv.__default.seqInt($LZ, s#0));

// consequence axiom for DynamicPkv.__default.seqInt
axiom 39 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { DynamicPkv.__default.seqInt($ly, s#0) } 
    DynamicPkv.__default.seqInt#canCall(s#0)
         || (39 != $FunctionContextHeight && $Is(s#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> Seq#Length(DynamicPkv.__default.seqInt($ly, s#0)) == Seq#Length(s#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(s#0, i#0)): int } 
            { $Unbox(Seq#Index(DynamicPkv.__default.seqInt($ly, s#0), i#0)): int } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
             ==> $Unbox(Seq#Index(DynamicPkv.__default.seqInt($ly, s#0), i#0)): int
               == $Unbox(Seq#Index(s#0, i#0)): int)
         && $Is(DynamicPkv.__default.seqInt($ly, s#0), TSeq(TInt)));

function DynamicPkv.__default.seqInt#requires(LayerType, Seq Box) : bool;

// #requires axiom for DynamicPkv.__default.seqInt
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { DynamicPkv.__default.seqInt#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> DynamicPkv.__default.seqInt#requires($ly, s#0) == true);

// definition axiom for DynamicPkv.__default.seqInt(revealed)
axiom 39 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { DynamicPkv.__default.seqInt($LS($ly), s#0) } 
    DynamicPkv.__default.seqInt#canCall(s#0)
         || (39 != $FunctionContextHeight && $Is(s#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> (Seq#Length(s#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), s#0)
             && DynamicPkv.__default.seqInt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), s#0))
             && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), s#0))
         && DynamicPkv.__default.seqInt($LS($ly), s#0)
           == (if Seq#Length(s#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(DynamicPkv.__default.seqInt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), s#0)), 
              Seq#Build(Seq#Empty(): Seq Box, Sequences.__default.Last(Tclass.NativeTypes.uint64(), s#0)))));

// definition axiom for DynamicPkv.__default.seqInt for all literals(revealed)
axiom 39 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { DynamicPkv.__default.seqInt($LS($ly), Lit(s#0)) } 
    DynamicPkv.__default.seqInt#canCall(Lit(s#0))
         || (39 != $FunctionContextHeight && $Is(s#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> (Seq#Length(Lit(s#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), Lit(s#0))
             && DynamicPkv.__default.seqInt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(s#0))))
             && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(s#0)))
         && DynamicPkv.__default.seqInt($LS($ly), Lit(s#0))
           == (if Seq#Length(Lit(s#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(DynamicPkv.__default.seqInt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(s#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(s#0))): int))))));

procedure CheckWellformed$$DynamicPkv.__default.seqInt(s#0: Seq Box where $Is(s#0, TSeq(Tclass.NativeTypes.uint64())))
   returns (res#0: Seq Box where $Is(res#0, TSeq(TInt)));
  free requires 39 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures Seq#Length(res#0) == Seq#Length(s#0);
  ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(s#0, i#1)): int } { $Unbox(Seq#Index(res#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(s#0)
       ==> $Unbox(Seq#Index(res#0, i#1)): int == $Unbox(Seq#Index(s#0, i#1)): int);



implementation CheckWellformed$$DynamicPkv.__default.seqInt(s#0: Seq Box) returns (res#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#2: int;
  var ##run#0: Seq Box;
  var ##s#0: Seq Box;
  var ##run#1: Seq Box;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;

    // AddWellformednessCheck for function seqInt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1021,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    if (*)
    {
        assume $Is(DynamicPkv.__default.seqInt($LS($LZ), s#0), TSeq(TInt));
        assume Seq#Length(res#0) == Seq#Length(s#0);
        havoc i#2;
        if (*)
        {
            assume LitInt(0) <= i#2;
            assume i#2 < Seq#Length(s#0);
            assert 0 <= i#2 && i#2 < Seq#Length(res#0);
            assert 0 <= i#2 && i#2 < Seq#Length(s#0);
            assume $Unbox(Seq#Index(res#0, i#2)): int == $Unbox(Seq#Index(s#0, i#2)): int;
        }
        else
        {
            assume LitInt(0) <= i#2 && i#2 < Seq#Length(s#0)
               ==> $Unbox(Seq#Index(res#0, i#2)): int == $Unbox(Seq#Index(s#0, i#2)): int;
        }

        assume (forall i#1: int :: 
          { $Unbox(Seq#Index(s#0, i#1)): int } { $Unbox(Seq#Index(res#0, i#1)): int } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(s#0)
             ==> $Unbox(Seq#Index(res#0, i#1)): int == $Unbox(Seq#Index(s#0, i#1)): int);
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        if (Seq#Length(s#0) == LitInt(0))
        {
            assume DynamicPkv.__default.seqInt($LS($LZ), s#0) == Lit(Seq#Empty(): Seq Box);
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(DynamicPkv.__default.seqInt($LS($LZ), s#0), TSeq(TInt));
        }
        else
        {
            ##run#0 := s#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0) > 0;
            assume Seq#Length(##run#0) > 0;
            b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), s#0);
            ##s#0 := Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), s#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert Seq#Rank(##s#0) < Seq#Rank(s#0);
            assume DynamicPkv.__default.seqInt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), s#0));
            ##run#1 := s#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1) > 0;
            assume Seq#Length(##run#1) > 0;
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), s#0);
            assume DynamicPkv.__default.seqInt($LS($LZ), s#0)
               == Seq#Append(DynamicPkv.__default.seqInt($LS($LZ), Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), s#0)), 
                Seq#Build(Seq#Empty(): Seq Box, Sequences.__default.Last(Tclass.NativeTypes.uint64(), s#0)));
            assume Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), s#0)
               && DynamicPkv.__default.seqInt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), s#0))
               && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), s#0);
            // CheckWellformedWithResult: any expression
            assume $Is(DynamicPkv.__default.seqInt($LS($LZ), s#0), TSeq(TInt));
        }

        assume DynamicPkv.__default.seqInt($LS($LZ), s#0) == res#0;
        assert b$reqreads#0;
        assert b$reqreads#1;
        assert b$reqreads#2;
    }
}



procedure CheckWellformed$$DynamicPkv.__default.WeightIthBucketLe(bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616);
  free requires 40 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.WeightIthBucketLe(bots#0: Seq Box, i#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#1: int;
  var ##pkv#0: DatatypeType;
  var ##pkv#1: DatatypeType;
  var ##s#0: Seq Box;
  var ##buckets#0: Seq Box;

    // AddMethodImpl: WeightIthBucketLe, CheckWellformed$$DynamicPkv.__default.WeightIthBucketLe
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1047,8): initial state"} true;
    havoc i#1;
    if (*)
    {
        assume LitInt(0) <= i#1;
        assume i#1 < Seq#Length(bots#0);
        assert 0 <= i#1 && i#1 < Seq#Length(bots#0);
        ##pkv#0 := $Unbox(Seq#Index(bots#0, i#1)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(bots#0, i#1)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
           ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType);
    }

    assume (forall i#2: int :: 
      { $Unbox(Seq#Index(bots#0, i#2)): DatatypeType } 
      LitInt(0) <= i#2 && i#2 < Seq#Length(bots#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#2)): DatatypeType));
    if (LitInt(0) <= i#0)
    {
    }

    assume LitInt(0) <= i#0 && i#0 < Seq#Length(bots#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1051,6): post-state"} true;
    assert 0 <= i#0 && i#0 < Seq#Length(bots#0);
    ##pkv#1 := $Unbox(Seq#Index(bots#0, i#0)): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#3)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
             || (forall i#4: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#4)): Seq Box } 
              LitInt(0) <= i#4
                   && i#4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#4)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
       ==> PackedKV.__default.WF(##pkv#1)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#1);
    assume DynamicPkv.__default.WeightBucketPkv#canCall($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
    assert 0 <= i#0 && i#0 <= Seq#Length(bots#0);
    ##s#0 := Seq#Drop(bots#0, i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#5: int :: 
      { $Unbox(Seq#Index(##s#0, i#5)): DatatypeType } 
      LitInt(0) <= i#5 && i#5 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#5)): DatatypeType));
    assume (forall i#5: int :: 
      { $Unbox(Seq#Index(##s#0, i#5)): DatatypeType } 
      LitInt(0) <= i#5 && i#5 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#5)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0));
    ##buckets#0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
    assume DynamicPkv.__default.WeightBucketPkv($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)
       <= BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
}



procedure Call$$DynamicPkv.__default.WeightIthBucketLe(bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616);
  // user-defined preconditions
  requires (forall i#2: int :: 
    { $Unbox(Seq#Index(bots#0, i#2)): DatatypeType } 
    LitInt(0) <= i#2 && i#2 < Seq#Length(bots#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#2)): DatatypeType));
  requires LitInt(0) <= i#0;
  requires i#0 < Seq#Length(bots#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.__default.WeightBucketPkv#canCall($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)
     && 
    DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
  ensures DynamicPkv.__default.WeightBucketPkv($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)
     <= BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(bots#0, i#0)));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.WeightIthBucketLe(bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 40 == $FunctionContextHeight;
  // user-defined preconditions
  requires (forall i#2: int :: 
    { $Unbox(Seq#Index(bots#0, i#2)): DatatypeType } 
    LitInt(0) <= i#2 && i#2 < Seq#Length(bots#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#2)): DatatypeType));
  requires LitInt(0) <= i#0;
  requires i#0 < Seq#Length(bots#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.__default.WeightBucketPkv#canCall($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)
     && 
    DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
  ensures DynamicPkv.__default.WeightBucketPkv($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)
     <= BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(bots#0, i#0)));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.WeightIthBucketLe(bots#0: Seq Box, i#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var blist##0: Seq Box;
  var ##s#1: Seq Box;
  var i##0: int;

    // AddMethodImpl: WeightIthBucketLe, Impl$$DynamicPkv.__default.WeightIthBucketLe
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1052,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1053,29)
    // TrCallStmt: Before ProcessCallStmt
    assert 0 <= i#0 && i#0 <= Seq#Length(bots#0);
    ##s#1 := Seq#Drop(bots#0, i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#6: int :: 
      { $Unbox(Seq#Index(##s#1, i#6)): DatatypeType } 
      LitInt(0) <= i#6 && i#6 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#6)): DatatypeType));
    assume (forall i#6: int :: 
      { $Unbox(Seq#Index(##s#1, i#6)): DatatypeType } 
      LitInt(0) <= i#6 && i#6 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#6)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0));
    // ProcessCallStmt: CheckSubrange
    blist##0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0));
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##0 := LitInt(0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$BucketWeights.__default.WeightBucketLeBucketList(blist##0, i##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1053,51)"} true;
}



procedure CheckWellformed$$DynamicPkv.__default.IMessagesSlice(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616);
  free requires 12 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.IMessagesSlice(pkv#0: DatatypeType, a#0: int, b#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var newtype$check#0: int;
  var ##pkv#1: DatatypeType;
  var ##psa#0: DatatypeType;
  var ##pkv#2: DatatypeType;
  var ##from#0: int;
  var ##to#0: int;
  var ##psa#1: DatatypeType;

    // AddMethodImpl: IMessagesSlice, CheckWellformed$$DynamicPkv.__default.IMessagesSlice
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1056,8): initial state"} true;
    ##pkv#0 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(pkv#0);
    assume PackedKV.__default.WF(pkv#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= a#0)
    {
    }

    if (LitInt(0) <= a#0 && a#0 <= b#0)
    {
        ##pkv#1 := pkv#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1))) == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box } 
                      LitInt(0) <= i#0
                           && i#0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1)), i#0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1)), i#1)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1)
           ==> PackedKV.__default.WF(##pkv#1)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#1);
        assume PackedKV.__default.NumKVPairs#canCall(pkv#0);
    }

    assume LitInt(0) <= a#0 && a#0 <= b#0 && b#0 <= PackedKV.__default.NumKVPairs(pkv#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1060,6): post-state"} true;
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#0 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert 0 <= a#0
       && a#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assert a#0 <= b#0
       && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    ##pkv#2 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
    ##from#0 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
    ##to#0 := b#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#2)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box } 
              LitInt(0) <= i#3
                   && i#3 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#3)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#2);
    assert {:subsumption 0} LitInt(0) <= ##from#0;
    assert {:subsumption 0} ##from#0 <= ##to#0;
    assert {:subsumption 0} ##to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(##pkv#2));
    assume LitInt(0) <= ##from#0
       && ##from#0 <= ##to#0
       && ##to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(##pkv#2));
    assume PackedKV.__default.subPkv#canCall(pkv#0, a#0, b#0);
    assume PackedKV.Pkv.Pkv_q(PackedKV.__default.subPkv(pkv#0, a#0, b#0));
    assume PackedKV.Pkv.Pkv_q(PackedKV.__default.subPkv(pkv#0, a#0, b#0));
    ##psa#1 := PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0)));
    assume Seq#Equal(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0), 
      PackedKV.__default.IMessages(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0))));
}



procedure Call$$DynamicPkv.__default.IMessagesSlice(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#4: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#4)): Seq Box } 
                LitInt(0) <= i#4
                     && i#4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#4)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           || (forall i#5: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#5)): Seq Box } 
            LitInt(0) <= i#5
                 && i#5 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#5)): Seq Box)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= a#0;
  requires a#0 <= b#0;
  requires b#0 <= PackedKV.__default.NumKVPairs(pkv#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && 
    PackedKV.__default.subPkv#canCall(pkv#0, a#0, b#0)
     && PackedKV.Pkv.Pkv_q(PackedKV.__default.subPkv(pkv#0, a#0, b#0))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0)));
  ensures Seq#Equal(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0), 
    PackedKV.__default.IMessages(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.IMessagesSlice(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 12 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(pkv#0)
     && 
    PackedKV.__default.WF(pkv#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= a#0;
  requires a#0 <= b#0;
  requires b#0 <= PackedKV.__default.NumKVPairs(pkv#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedKV.Pkv.Pkv_q(pkv#0)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
     && 
    PackedKV.__default.subPkv#canCall(pkv#0, a#0, b#0)
     && PackedKV.Pkv.Pkv_q(PackedKV.__default.subPkv(pkv#0, a#0, b#0))
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0)));
  ensures Seq#Equal(Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0), 
    PackedKV.__default.IMessages(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.IMessagesSlice(pkv#0: DatatypeType, a#0: int, b#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var x#0: Seq Box
     where $Is(x#0, TSeq(Tclass.ValueMessage.Message()))
       && $IsAlloc(x#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
  var ##psa#2: DatatypeType;
  var y#0: Seq Box
     where $Is(y#0, TSeq(Tclass.ValueMessage.Message()))
       && $IsAlloc(y#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
  var ##pkv#3: DatatypeType;
  var ##from#1: int;
  var ##to#1: int;
  var ##psa#3: DatatypeType;
  var i#10: int;
  var ##psa#0_0_0: DatatypeType;
  var ##s#0_0_0: Seq Box;
  var ##psa#0_1_0: DatatypeType;
  var ##psa#0_1_1: DatatypeType;
  var ##s#0_1_0: Seq Box;
  var ##psa#0_2_0: DatatypeType;

    // AddMethodImpl: IMessagesSlice, Impl$$DynamicPkv.__default.IMessagesSlice
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1061,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1062,11)
    assume true;
    assume PackedKV.Pkv.Pkv_q(pkv#0);
    ##psa#2 := PackedKV.Pkv.messages(pkv#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    assert 0 <= a#0
       && a#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assert a#0 <= b#0
       && b#0 <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
    assume PackedKV.Pkv.Pkv_q(pkv#0)
       && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
    x#0 := Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), b#0), a#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1062,46)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1063,11)
    assume true;
    ##pkv#3 := pkv#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    ##from#1 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#1, Tclass.NativeTypes.uint64(), $Heap);
    ##to#1 := b#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#8: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#8)): Seq Box } 
                  LitInt(0) <= i#8
                       && i#8 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#8)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#9: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#9)): Seq Box } 
              LitInt(0) <= i#9
                   && i#9 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#9)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#3);
    assert {:subsumption 0} LitInt(0) <= ##from#1;
    assert {:subsumption 0} ##from#1 <= ##to#1;
    assert {:subsumption 0} ##to#1 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(##pkv#3));
    assume LitInt(0) <= ##from#1
       && ##from#1 <= ##to#1
       && ##to#1 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(##pkv#3));
    assume PackedKV.__default.subPkv#canCall(pkv#0, a#0, b#0);
    assume PackedKV.Pkv.Pkv_q(PackedKV.__default.subPkv(pkv#0, a#0, b#0));
    assume PackedKV.Pkv.Pkv_q(PackedKV.__default.subPkv(pkv#0, a#0, b#0));
    ##psa#3 := PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0)));
    assume PackedKV.__default.subPkv#canCall(pkv#0, a#0, b#0)
       && PackedKV.Pkv.Pkv_q(PackedKV.__default.subPkv(pkv#0, a#0, b#0))
       && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0)));
    y#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(PackedKV.__default.subPkv(pkv#0, a#0, b#0)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1063,58)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1064,5)
    assume true;
    assert Seq#Length(x#0) == Seq#Length(y#0);
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1065,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#10;
        assume true;
        if (LitInt(0) <= i#10)
        {
        }

        assume true;
        assume LitInt(0) <= i#10 && i#10 < Seq#Length(x#0);
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assert {:subsumption 0} 0 <= i#10 && i#10 < Seq#Length(x#0);
            assume true;
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assume {:subsumption 0} 0 <= i#10 && i#10 < Seq#Length(x#0);
            assume true;
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_2_0 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_2_0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_2_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_2_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_2_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_2_0)
               ==> PackedStringArray.__default.WF(##psa#0_2_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_2_0));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= a#0 + i#10
               && a#0 + i#10
                 < Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assert {:subsumption 0} ValueMessage.Message#Equal($Unbox(Seq#Index(x#0, i#10)): DatatypeType, 
              $Unbox(Seq#Index(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): DatatypeType);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_1_0 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_1_0, Tclass.PackedStringArray.Psa(), $Heap);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0)) == LitInt(0));
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_0)) - 1)): int);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_0)
               ==> PackedStringArray.__default.WF(##psa#0_1_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_1_0));
            assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            assume {:subsumption 0} 0 <= a#0 + i#10
               && a#0 + i#10
                 < Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)));
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0));
            // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_1_1 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_1_1, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_1_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_1_1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_1_1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_1_1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_1_1)
               ==> PackedStringArray.__default.WF(##psa#0_1_1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_1_1));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0));
            assert {:subsumption 0} 0 <= a#0 + i#10
               && a#0 + i#10
                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)));
            ##s#0_1_0 := $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): Seq Box;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_1_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
            assert {:subsumption 0} Seq#Length(##s#0_1_0) < 4294967296;
            assume ValueMessage.__default.bytestring__to__Message#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): Seq Box);
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0))
               && ValueMessage.__default.bytestring__to__Message#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): Seq Box);
            // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assert {:subsumption 0} ValueMessage.Message#Equal($Unbox(Seq#Index(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): DatatypeType, 
              ValueMessage.__default.bytestring__to__Message($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): Seq Box));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assume PackedKV.Pkv.Pkv_q(pkv#0);
            ##psa#0_0_0 := PackedKV.Pkv.messages(pkv#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#0_0_0, Tclass.PackedStringArray.Psa(), $Heap);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) < 4294967296;
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0)) == LitInt(0));
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0)) - 1)): int);
            assume {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0)
               ==> PackedStringArray.__default.WF(##psa#0_0_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#0_0_0));
            assume PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0));
            assume {:subsumption 0} 0 <= a#0 + i#10
               && a#0 + i#10
                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)));
            ##s#0_0_0 := $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): Seq Box;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
            assume {:subsumption 0} Seq#Length(##s#0_0_0) < 4294967296;
            assume ValueMessage.__default.bytestring__to__Message#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): Seq Box);
            assume PackedKV.Pkv.Pkv_q(pkv#0)
               && PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0))
               && ValueMessage.__default.bytestring__to__Message#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): Seq Box);
            // ----- Hint2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assert {:subsumption 0} 0 <= i#10 && i#10 < Seq#Length(y#0);
            assume true;
            // ----- assert line2 == line3 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1068,7)
            assert {:subsumption 0} ValueMessage.Message#Equal(ValueMessage.__default.bytestring__to__Message($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), a#0 + i#10)): Seq Box), 
              $Unbox(Seq#Index(y#0, i#10)): DatatypeType);
            assume false;
        }

        assume ValueMessage.Message#Equal($Unbox(Seq#Index(x#0, i#10)): DatatypeType, 
          $Unbox(Seq#Index(y#0, i#10)): DatatypeType);
        assert ValueMessage.Message#Equal($Unbox(Seq#Index(x#0, i#10)): DatatypeType, 
          $Unbox(Seq#Index(y#0, i#10)): DatatypeType);
        assume false;
    }
    else
    {
        assume (forall i#11: int :: 
          { $Unbox(Seq#Index(y#0, i#11)): DatatypeType } 
            { $Unbox(Seq#Index(x#0, i#11)): DatatypeType } 
          LitInt(0) <= i#11 && i#11 < Seq#Length(x#0)
             ==> ValueMessage.Message#Equal($Unbox(Seq#Index(x#0, i#11)): DatatypeType, 
              $Unbox(Seq#Index(y#0, i#11)): DatatypeType));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1074,4)"} true;
}



procedure CheckWellformed$$DynamicPkv.__default.WeightPKVListPopFront(pkvs#0: Seq Box
       where $Is(pkvs#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(pkvs#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int);
  free requires 41 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.WeightPKVListPopFront(pkvs#0: Seq Box, i#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#0: int;
  var ##pkv#0: DatatypeType;
  var j#2: int;
  var ##pkv#1: DatatypeType;
  var j#4: int;
  var ##pkv#2: DatatypeType;
  var ##s#0: Seq Box;
  var ##buckets#0: Seq Box;
  var ##s#1: Seq Box;
  var ##buckets#1: Seq Box;
  var ##psa#0: DatatypeType;
  var ##keys#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##msgs#0: Seq Box;

    // AddMethodImpl: WeightPKVListPopFront, CheckWellformed$$DynamicPkv.__default.WeightPKVListPopFront
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1077,8): initial state"} true;
    havoc j#0;
    if (*)
    {
        assume LitInt(0) <= j#0;
        assume j#0 < Seq#Length(pkvs#0);
        assert 0 <= j#0 && j#0 < Seq#Length(pkvs#0);
        ##pkv#0 := $Unbox(Seq#Index(pkvs#0, j#0)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(pkvs#0, j#0)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(pkvs#0, j#0)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= j#0 && j#0 < Seq#Length(pkvs#0)
           ==> PackedKV.__default.WF($Unbox(Seq#Index(pkvs#0, j#0)): DatatypeType);
    }

    assume (forall j#1: int :: 
      { $Unbox(Seq#Index(pkvs#0, j#1)): DatatypeType } 
      LitInt(0) <= j#1 && j#1 < Seq#Length(pkvs#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(pkvs#0, j#1)): DatatypeType));
    if (LitInt(0) <= i#0)
    {
    }

    assume LitInt(0) <= i#0 && i#0 < Seq#Length(pkvs#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1080,10): post-state"} true;
    havoc j#2;
    if (*)
    {
        assume LitInt(0) <= j#2;
        assert 0 <= i#0 && i#0 <= Seq#Length(pkvs#0);
        assume j#2 < Seq#Length(Seq#Drop(pkvs#0, i#0));
        assert 0 <= i#0 && i#0 <= Seq#Length(pkvs#0);
        assert 0 <= j#2 && j#2 < Seq#Length(Seq#Drop(pkvs#0, i#0));
        ##pkv#1 := $Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#2)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#2)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#2)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= j#2 && j#2 < Seq#Length(Seq#Drop(pkvs#0, i#0))
           ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#2)): DatatypeType);
    }

    assume (forall j#3: int :: 
      { $Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType } 
      LitInt(0) <= j#3 && j#3 < Seq#Length(Seq#Drop(pkvs#0, i#0))
         ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType));
    havoc j#4;
    if (*)
    {
        assume LitInt(0) <= j#4;
        assert 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(pkvs#0);
        assume j#4 < Seq#Length(Seq#Drop(pkvs#0, i#0 + 1));
        assert 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(pkvs#0);
        assert 0 <= j#4 && j#4 < Seq#Length(Seq#Drop(pkvs#0, i#0 + 1));
        ##pkv#2 := $Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#4)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#4)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#4)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= j#4 && j#4 < Seq#Length(Seq#Drop(pkvs#0, i#0 + 1))
           ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#4)): DatatypeType);
    }

    assume (forall j#5: int :: 
      LitInt(0) <= j#5 && j#5 < Seq#Length(Seq#Drop(pkvs#0, i#0 + 1))
         ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#5)): DatatypeType));
    assert 0 <= i#0 && i#0 <= Seq#Length(pkvs#0);
    ##s#0 := Seq#Drop(pkvs#0, i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#1: int :: 
      { $Unbox(Seq#Index(##s#0, i#1)): DatatypeType } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#1)): DatatypeType));
    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(##s#0, i#1)): DatatypeType } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#1)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0));
    ##buckets#0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0)));
    assert 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(pkvs#0);
    ##s#1 := Seq#Drop(pkvs#0, i#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#2: int :: 
      { $Unbox(Seq#Index(##s#1, i#2)): DatatypeType } 
      LitInt(0) <= i#2 && i#2 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#2)): DatatypeType));
    assume (forall i#2: int :: 
      { $Unbox(Seq#Index(##s#1, i#2)): DatatypeType } 
      LitInt(0) <= i#2 && i#2 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#2)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0 + 1));
    ##buckets#1 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0 + 1));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0 + 1)));
    assert 0 <= i#0 && i#0 < Seq#Length(pkvs#0);
    assume PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    ##psa#0 := PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#0), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#0), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#3: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#3)): Seq Box } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(PackedStringArray.__default.I(##psa#0))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#3)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#0), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    ##keys#0 := PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
    assert 0 <= i#0 && i#0 < Seq#Length(pkvs#0);
    assume PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    ##psa#1 := PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    ##msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0)))
       == BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
          DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0 + 1)))
         + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)))
         + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
}



procedure Call$$DynamicPkv.__default.WeightPKVListPopFront(pkvs#0: Seq Box
       where $Is(pkvs#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(pkvs#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int);
  // user-defined preconditions
  requires (forall j#1: int :: 
    { $Unbox(Seq#Index(pkvs#0, j#1)): DatatypeType } 
    LitInt(0) <= j#1 && j#1 < Seq#Length(pkvs#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(pkvs#0, j#1)): DatatypeType));
  requires LitInt(0) <= i#0;
  requires i#0 < Seq#Length(pkvs#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures (forall j#3: int :: 
    { $Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType } 
    LitInt(0) <= j#3 && j#3 < Seq#Length(Seq#Drop(pkvs#0, i#0))
       ==> PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType));
  ensures (forall j#3: int :: 
    { $Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType } 
    LitInt(0) <= j#3 && j#3 < Seq#Length(Seq#Drop(pkvs#0, i#0))
       ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType));
  free ensures (forall j#5: int :: 
    LitInt(0) <= j#5 && j#5 < Seq#Length(Seq#Drop(pkvs#0, i#0 + 1))
       ==> PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#5)): DatatypeType));
  ensures (forall j#5: int :: 
    LitInt(0) <= j#5 && j#5 < Seq#Length(Seq#Drop(pkvs#0, i#0 + 1))
       ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#5)): DatatypeType));
  free ensures DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0)))
     && 
    DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0 + 1))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0 + 1)))
     && 
    PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)))
     && 
    PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
  ensures BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(pkvs#0, i#0)))
     == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(pkvs#0, i#0 + 1)))
       + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.WeightPKVListPopFront(pkvs#0: Seq Box
       where $Is(pkvs#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(pkvs#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int)
   returns ($_reverifyPost: bool);
  free requires 41 == $FunctionContextHeight;
  // user-defined preconditions
  requires (forall j#1: int :: 
    { $Unbox(Seq#Index(pkvs#0, j#1)): DatatypeType } 
    LitInt(0) <= j#1 && j#1 < Seq#Length(pkvs#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(pkvs#0, j#1)): DatatypeType));
  requires LitInt(0) <= i#0;
  requires i#0 < Seq#Length(pkvs#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures (forall j#3: int :: 
    { $Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType } 
    LitInt(0) <= j#3 && j#3 < Seq#Length(Seq#Drop(pkvs#0, i#0))
       ==> PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType));
  ensures (forall j#3: int :: 
    { $Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType } 
    LitInt(0) <= j#3 && j#3 < Seq#Length(Seq#Drop(pkvs#0, i#0))
       ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0), j#3)): DatatypeType));
  free ensures (forall j#5: int :: 
    LitInt(0) <= j#5 && j#5 < Seq#Length(Seq#Drop(pkvs#0, i#0 + 1))
       ==> PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#5)): DatatypeType));
  ensures (forall j#5: int :: 
    LitInt(0) <= j#5 && j#5 < Seq#Length(Seq#Drop(pkvs#0, i#0 + 1))
       ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Drop(pkvs#0, i#0 + 1), j#5)): DatatypeType));
  free ensures DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0)))
     && 
    DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0 + 1))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0 + 1)))
     && 
    PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)))
     && 
    PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
  ensures BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(pkvs#0, i#0)))
     == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(pkvs#0, i#0 + 1)))
       + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.WeightPKVListPopFront(pkvs#0: Seq Box, i#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var left##0: Seq Box;
  var ##pkv#3: DatatypeType;
  var right##0: Seq Box;
  var ##s#2: Seq Box;
  var ##pkv#4: DatatypeType;
  var ##s#3: Seq Box;
  var ##s#4: Seq Box;
  var ##pkv#5: DatatypeType;
  var ##buckets#2: Seq Box;
  var ##pkv#6: DatatypeType;
  var ##bucket#0: DatatypeType;

    // AddMethodImpl: WeightPKVListPopFront, Impl$$DynamicPkv.__default.WeightPKVListPopFront
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1086,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1087,27)
    // TrCallStmt: Before ProcessCallStmt
    assert 0 <= i#0 && i#0 < Seq#Length(pkvs#0);
    ##pkv#3 := $Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#4: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#4)): Seq Box } 
                  LitInt(0) <= i#4
                       && i#4 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#4)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#5: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#5)): Seq Box } 
              LitInt(0) <= i#5
                   && i#5 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#5)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#3);
    assume PackedKV.__default.I#canCall($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    assume PackedKV.__default.I#canCall($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    // ProcessCallStmt: CheckSubrange
    left##0 := Seq#Build(Seq#Empty(): Seq Box, 
      $Box(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
    assert 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(pkvs#0);
    ##s#2 := Seq#Drop(pkvs#0, i#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#6: int :: 
      { $Unbox(Seq#Index(##s#2, i#6)): DatatypeType } 
      LitInt(0) <= i#6 && i#6 < Seq#Length(##s#2)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2, i#6)): DatatypeType));
    assume (forall i#6: int :: 
      { $Unbox(Seq#Index(##s#2, i#6)): DatatypeType } 
      LitInt(0) <= i#6 && i#6 < Seq#Length(##s#2)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2, i#6)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0 + 1));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0 + 1));
    // ProcessCallStmt: CheckSubrange
    right##0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0 + 1));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$BucketWeights.__default.WeightBucketListConcat(left##0, right##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1087,66)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1088,5)
    assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(pkvs#0);
    ##pkv#4 := $Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#4, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#7: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#7)): Seq Box } 
                  LitInt(0) <= i#7
                       && i#7 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#7)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
             || (forall i#8: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#8)): Seq Box } 
              LitInt(0) <= i#8
                   && i#8 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#8)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#4)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.I#canCall($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(pkvs#0);
    ##s#3 := Seq#Drop(pkvs#0, i#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#3, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#9: int :: 
      { $Unbox(Seq#Index(##s#3, i#9)): DatatypeType } 
      LitInt(0) <= i#9 && i#9 < Seq#Length(##s#3)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#3, i#9)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0 + 1));
    assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(pkvs#0);
    ##s#4 := Seq#Drop(pkvs#0, i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#4, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#10: int :: 
      { $Unbox(Seq#Index(##s#4, i#10)): DatatypeType } 
      LitInt(0) <= i#10 && i#10 < Seq#Length(##s#4)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#4, i#10)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0));
    assume PackedKV.__default.I#canCall($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)
       && DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0 + 1))
       && DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(pkvs#0, i#0));
    assert {:subsumption 0} Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
          $Box(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))), 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(pkvs#0, i#0 + 1))), 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(pkvs#0, i#0)));
    assume Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
          $Box(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))), 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(pkvs#0, i#0 + 1))), 
      DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(pkvs#0, i#0)));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1090,5)
    assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(pkvs#0);
    ##pkv#5 := $Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#5, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#11: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#11)): Seq Box } 
                  LitInt(0) <= i#11
                       && i#11 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#11)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
             || (forall i#12: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#12)): Seq Box } 
              LitInt(0) <= i#12
                   && i#12 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#12)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#5)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.I#canCall($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    ##buckets#2 := Seq#Build(Seq#Empty(): Seq Box, 
      $Box(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#2, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(Seq#Build(Seq#Empty(): Seq Box, 
        $Box(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))));
    assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(pkvs#0);
    ##pkv#6 := $Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#6, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#13: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#13)): Seq Box } 
                  LitInt(0) <= i#13
                       && i#13 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#13)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
             || (forall i#14: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#14)): Seq Box } 
              LitInt(0) <= i#14
                   && i#14 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#14)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#6)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.I#canCall($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    ##bucket#0 := PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bucket#0, Tclass.BucketsLib.Bucket(), $Heap);
    assume BucketWeights.__default.WeightBucket#canCall(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    assume PackedKV.__default.I#canCall($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)
       && BucketWeights.__default.WeightBucketList#canCall(Seq#Build(Seq#Empty(): Seq Box, 
          $Box(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))))
       && 
      PackedKV.__default.I#canCall($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType)
       && BucketWeights.__default.WeightBucket#canCall(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1090,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1091,30)
        // TrCallStmt: Before ProcessCallStmt
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$BucketWeights.__default.reveal__WeightBucketList();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1091,31)"} true;
        assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
            Seq#Build(Seq#Empty(): Seq Box, 
              $Box(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))))
           == BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
        assume false;
    }

    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
        Seq#Build(Seq#Empty(): Seq Box, 
          $Box(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType))))
       == BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(Seq#Index(pkvs#0, i#0)): DatatypeType));
}



procedure CheckWellformed$$DynamicPkv.__default.WeightPKVArrayPushBack(pkvs#0: ref
       where $Is(pkvs#0, Tclass._System.array(Tclass.PackedKV.Pkv()))
         && $IsAlloc(pkvs#0, Tclass._System.array(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int);
  free requires 43 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.WeightPKVArrayPushBack(pkvs#0: ref, i#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var j#0: int;
  var ##pkv#0: DatatypeType;
  var j#2: int;
  var ##pkv#1: DatatypeType;
  var j#4: int;
  var ##pkv#2: DatatypeType;
  var ##s#0: Seq Box;
  var ##buckets#0: Seq Box;
  var ##psa#0: DatatypeType;
  var ##keys#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##msgs#0: Seq Box;
  var ##s#1: Seq Box;
  var ##buckets#1: Seq Box;

    // AddMethodImpl: WeightPKVArrayPushBack, CheckWellformed$$DynamicPkv.__default.WeightPKVArrayPushBack
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1095,8): initial state"} true;
    if (LitInt(0) <= i#0)
    {
        assert pkvs#0 != null;
    }

    assume LitInt(0) <= i#0 && i#0 < _System.array.Length(pkvs#0);
    havoc j#0;
    if (*)
    {
        assume LitInt(0) <= j#0;
        assume j#0 < i#0 + 1;
        assert pkvs#0 != null;
        assert 0 <= j#0 && j#0 < _System.array.Length(pkvs#0);
        ##pkv#0 := $Unbox(read($Heap, pkvs#0, IndexField(j#0))): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(read($Heap, pkvs#0, IndexField(j#0))): DatatypeType);
        assume PackedKV.__default.WF($Unbox(read($Heap, pkvs#0, IndexField(j#0))): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= j#0 && j#0 < i#0 + 1
           ==> PackedKV.__default.WF($Unbox(read($Heap, pkvs#0, IndexField(j#0))): DatatypeType);
    }

    assume (forall j#1: int :: 
      { $Unbox(read($Heap, pkvs#0, IndexField(j#1))): DatatypeType } 
      LitInt(0) <= j#1 && j#1 < i#0 + 1
         ==> PackedKV.__default.WF($Unbox(read($Heap, pkvs#0, IndexField(j#1))): DatatypeType));
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1098,10): post-state"} true;
    havoc j#2;
    if (*)
    {
        assume LitInt(0) <= j#2;
        assert pkvs#0 != null;
        assert 0 <= i#0 && i#0 <= _System.array.Length(pkvs#0);
        assume j#2 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0));
        assert pkvs#0 != null;
        assert 0 <= i#0 && i#0 <= _System.array.Length(pkvs#0);
        assert 0 <= j#2 && j#2 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0));
        ##pkv#1 := $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#2)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#2)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#2)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= j#2
             && j#2 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
           ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#2)): DatatypeType);
    }

    assume (forall j#3: int :: 
      { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType } 
      LitInt(0) <= j#3
           && j#3 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
         ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType));
    havoc j#4;
    if (*)
    {
        assume LitInt(0) <= j#4;
        assert pkvs#0 != null;
        assert 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(pkvs#0);
        assume j#4 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1));
        assert pkvs#0 != null;
        assert 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(pkvs#0);
        assert 0 <= j#4 && j#4 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1));
        ##pkv#2 := $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#4)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#4)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#4)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= j#4
             && j#4 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1))
           ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#4)): DatatypeType);
    }

    assume (forall j#5: int :: 
      LitInt(0) <= j#5
           && j#5 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1))
         ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#5)): DatatypeType));
    assert pkvs#0 != null;
    assert 0 <= i#0 && i#0 <= _System.array.Length(pkvs#0);
    ##s#0 := Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#1: int :: 
      { $Unbox(Seq#Index(##s#0, i#1)): DatatypeType } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#1)): DatatypeType));
    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(##s#0, i#1)): DatatypeType } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#1)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0));
    ##buckets#0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0)));
    assert pkvs#0 != null;
    assert 0 <= i#0 && i#0 < _System.array.Length(pkvs#0);
    assume PackedKV.Pkv.Pkv_q($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    ##psa#0 := PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#0), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#0), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#2: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#2)): Seq Box } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(PackedStringArray.__default.I(##psa#0))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#2)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#0), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    ##keys#0 := PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    // assume allocatedness for argument to function
    assume $IsAlloc(##keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)));
    assert pkvs#0 != null;
    assert 0 <= i#0 && i#0 < _System.array.Length(pkvs#0);
    assume PackedKV.Pkv.Pkv_q($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    ##psa#1 := PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    ##msgs#0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    // assume allocatedness for argument to function
    assume $IsAlloc(##msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap);
    assume BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)));
    assert pkvs#0 != null;
    assert 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(pkvs#0);
    ##s#1 := Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#3: int :: 
      { $Unbox(Seq#Index(##s#1, i#3)): DatatypeType } 
      LitInt(0) <= i#3 && i#3 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#3)): DatatypeType));
    assume (forall i#3: int :: 
      { $Unbox(Seq#Index(##s#1, i#3)): DatatypeType } 
      LitInt(0) <= i#3 && i#3 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#3)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1));
    ##buckets#1 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1)));
    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
          DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0)))
         + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
         + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
       == BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1)));
}



procedure Call$$DynamicPkv.__default.WeightPKVArrayPushBack(pkvs#0: ref
       where $Is(pkvs#0, Tclass._System.array(Tclass.PackedKV.Pkv()))
         && $IsAlloc(pkvs#0, Tclass._System.array(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int);
  // user-defined preconditions
  requires LitInt(0) <= i#0;
  requires i#0 < _System.array.Length(pkvs#0);
  requires (forall j#1: int :: 
    { $Unbox(read($Heap, pkvs#0, IndexField(j#1))): DatatypeType } 
    LitInt(0) <= j#1 && j#1 < i#0 + 1
       ==> PackedKV.__default.WF($Unbox(read($Heap, pkvs#0, IndexField(j#1))): DatatypeType));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures (forall j#3: int :: 
    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType } 
    LitInt(0) <= j#3
         && j#3 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
       ==> PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType));
  ensures (forall j#3: int :: 
    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType } 
    LitInt(0) <= j#3
         && j#3 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
       ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType));
  free ensures (forall j#5: int :: 
    LitInt(0) <= j#5
         && j#5 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1))
       ==> PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#5)): DatatypeType));
  ensures (forall j#5: int :: 
    LitInt(0) <= j#5
         && j#5 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1))
       ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#5)): DatatypeType));
  free ensures DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0)))
     && 
    PackedKV.Pkv.Pkv_q($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
     && 
    PackedKV.Pkv.Pkv_q($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
     && 
    DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1)));
  ensures BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0)))
       + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
     == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1)));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$DynamicPkv.__default.WeightPKVArrayPushBack(pkvs#0: ref
       where $Is(pkvs#0, Tclass._System.array(Tclass.PackedKV.Pkv()))
         && $IsAlloc(pkvs#0, Tclass._System.array(Tclass.PackedKV.Pkv()), $Heap), 
    i#0: int)
   returns ($_reverifyPost: bool);
  free requires 43 == $FunctionContextHeight;
  // user-defined preconditions
  requires LitInt(0) <= i#0;
  requires i#0 < _System.array.Length(pkvs#0);
  requires (forall j#1: int :: 
    { $Unbox(read($Heap, pkvs#0, IndexField(j#1))): DatatypeType } 
    LitInt(0) <= j#1 && j#1 < i#0 + 1
       ==> PackedKV.__default.WF($Unbox(read($Heap, pkvs#0, IndexField(j#1))): DatatypeType));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures (forall j#3: int :: 
    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType } 
    LitInt(0) <= j#3
         && j#3 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
       ==> PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType));
  ensures (forall j#3: int :: 
    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType } 
    LitInt(0) <= j#3
         && j#3 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
       ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0), j#3)): DatatypeType));
  free ensures (forall j#5: int :: 
    LitInt(0) <= j#5
         && j#5 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1))
       ==> PackedKV.__default.WF#canCall($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#5)): DatatypeType));
  ensures (forall j#5: int :: 
    LitInt(0) <= j#5
         && j#5 < Seq#Length(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1))
       ==> PackedKV.__default.WF($Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1), j#5)): DatatypeType));
  free ensures DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0)))
     && 
    PackedKV.Pkv.Pkv_q($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)
     && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType))
     && BucketWeights.__default.WeightKeyList#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
     && 
    PackedKV.Pkv.Pkv_q($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)
     && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType))
     && BucketWeights.__default.WeightMessageList#canCall(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
     && 
    DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1))
     && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1)));
  ensures BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0)))
       + BucketWeights.__default.WeightKeyList(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
       + BucketWeights.__default.WeightMessageList(PackedKV.__default.IMessages(PackedKV.Pkv.messages($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))
     == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1)));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$DynamicPkv.__default.WeightPKVArrayPushBack(pkvs#0: ref, i#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var left##0: Seq Box;
  var ##s#2: Seq Box;
  var right##0: Seq Box;
  var ##pkv#3: DatatypeType;
  var ##s#3: Seq Box;
  var ##pkv#4: DatatypeType;
  var ##s#4: Seq Box;
  var ##pkv#5: DatatypeType;
  var ##buckets#2: Seq Box;
  var ##pkv#6: DatatypeType;
  var ##bucket#0: DatatypeType;

    // AddMethodImpl: WeightPKVArrayPushBack, Impl$$DynamicPkv.__default.WeightPKVArrayPushBack
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1104,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1105,27)
    // TrCallStmt: Before ProcessCallStmt
    assert pkvs#0 != null;
    assert 0 <= i#0 && i#0 <= _System.array.Length(pkvs#0);
    ##s#2 := Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#4: int :: 
      { $Unbox(Seq#Index(##s#2, i#4)): DatatypeType } 
      LitInt(0) <= i#4 && i#4 < Seq#Length(##s#2)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2, i#4)): DatatypeType));
    assume (forall i#4: int :: 
      { $Unbox(Seq#Index(##s#2, i#4)): DatatypeType } 
      LitInt(0) <= i#4 && i#4 < Seq#Length(##s#2)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2, i#4)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0));
    // ProcessCallStmt: CheckSubrange
    left##0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0));
    assert pkvs#0 != null;
    assert 0 <= i#0 && i#0 < _System.array.Length(pkvs#0);
    ##pkv#3 := $Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#5: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#5)): Seq Box } 
                  LitInt(0) <= i#5
                       && i#5 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#5)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#6: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#6)): Seq Box } 
              LitInt(0) <= i#6
                   && i#6 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#6)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#3);
    assume PackedKV.__default.I#canCall($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    assume PackedKV.__default.I#canCall($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    // ProcessCallStmt: CheckSubrange
    right##0 := Seq#Build(Seq#Empty(): Seq Box, 
      $Box(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$BucketWeights.__default.WeightBucketListConcat(left##0, right##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1105,64)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1106,5)
    assert pkvs#0 != null;
    assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(pkvs#0);
    ##s#3 := Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#3, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#7: int :: 
      { $Unbox(Seq#Index(##s#3, i#7)): DatatypeType } 
      LitInt(0) <= i#7 && i#7 < Seq#Length(##s#3)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#3, i#7)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0));
    assert pkvs#0 != null;
    assert {:subsumption 0} 0 <= i#0 && i#0 < _System.array.Length(pkvs#0);
    ##pkv#4 := $Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#4, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#4)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#4))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#4)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#4))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#4))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#4)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#4)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#8: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#8)): Seq Box } 
                  LitInt(0) <= i#8
                       && i#8 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#4)), i#8)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
             || (forall i#9: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#9)): Seq Box } 
              LitInt(0) <= i#9
                   && i#9 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#4)), i#9)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#4)
       ==> PackedKV.__default.WF(##pkv#4)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#4)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.I#canCall($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    assert pkvs#0 != null;
    assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(pkvs#0);
    ##s#4 := Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#4, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#10: int :: 
      { $Unbox(Seq#Index(##s#4, i#10)): DatatypeType } 
      LitInt(0) <= i#10 && i#10 < Seq#Length(##s#4)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#4, i#10)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0))
       && PackedKV.__default.I#canCall($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)
       && DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1));
    assert {:subsumption 0} Seq#Equal(Seq#Append(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0)), 
        Seq#Build(Seq#Empty(): Seq Box, 
          $Box(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))), 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1)));
    assume Seq#Equal(Seq#Append(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0)), 
        Seq#Build(Seq#Empty(): Seq Box, 
          $Box(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)))), 
      DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, pkvs#0), i#0 + 1)));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1108,5)
    assert pkvs#0 != null;
    assert {:subsumption 0} 0 <= i#0 && i#0 < _System.array.Length(pkvs#0);
    ##pkv#5 := $Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#5, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#5)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#5))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#5)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#5))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#5))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#5)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#5)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#11: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#11)): Seq Box } 
                  LitInt(0) <= i#11
                       && i#11 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#5)), i#11)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
             || (forall i#12: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#12)): Seq Box } 
              LitInt(0) <= i#12
                   && i#12 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#5)), i#12)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#5)
       ==> PackedKV.__default.WF(##pkv#5)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#5)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.I#canCall($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    ##buckets#2 := Seq#Build(Seq#Empty(): Seq Box, 
      $Box(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#2, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(Seq#Build(Seq#Empty(): Seq Box, 
        $Box(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType))));
    assert pkvs#0 != null;
    assert {:subsumption 0} 0 <= i#0 && i#0 < _System.array.Length(pkvs#0);
    ##pkv#6 := $Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#6, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#6)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#6))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#6)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#6))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#6))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#6)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#6)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#13: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#13)): Seq Box } 
                  LitInt(0) <= i#13
                       && i#13 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#6)), i#13)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
             || (forall i#14: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#14)): Seq Box } 
              LitInt(0) <= i#14
                   && i#14 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#6)), i#14)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#6)
       ==> PackedKV.__default.WF(##pkv#6)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#6)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.I#canCall($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    ##bucket#0 := PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bucket#0, Tclass.BucketsLib.Bucket(), $Heap);
    assume BucketWeights.__default.WeightBucket#canCall(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    assume PackedKV.__default.I#canCall($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)
       && BucketWeights.__default.WeightBucketList#canCall(Seq#Build(Seq#Empty(): Seq Box, 
          $Box(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType))))
       && 
      PackedKV.__default.I#canCall($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType)
       && BucketWeights.__default.WeightBucket#canCall(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1108,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1109,30)
        // TrCallStmt: Before ProcessCallStmt
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$BucketWeights.__default.reveal__WeightBucketList();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1109,31)"} true;
        assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
            Seq#Build(Seq#Empty(): Seq Box, 
              $Box(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType))))
           == BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
        assume false;
    }

    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
        Seq#Build(Seq#Empty(): Seq Box, 
          $Box(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType))))
       == BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(read($Heap, pkvs#0, IndexField(i#0))): DatatypeType));
}



procedure CheckWellformed$$DynamicPkv.__default.MergeToChildrenIter(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    idxs#0: Seq Box
       where $Is(idxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(idxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    tmp#0: DatatypeType
       where $Is(tmp#0, Tclass.DynamicPkv.SingleMergeResult())
         && $IsAlloc(tmp#0, Tclass.DynamicPkv.SingleMergeResult(), $Heap)
         && $IsA#DynamicPkv.SingleMergeResult(tmp#0), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    results#0: ref
       where $Is(results#0, Tclass._System.array(Tclass.PackedKV.Pkv()))
         && $IsAlloc(results#0, Tclass._System.array(Tclass.PackedKV.Pkv()), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.DynamicPkv.MergeResult())
         && $IsAlloc(res#0, Tclass.DynamicPkv.MergeResult(), $Heap));
  free requires 44 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.MergeToChildrenIter(top#0: DatatypeType, 
    bots#0: Seq Box, 
    idxs#0: Seq Box, 
    tmp#0: DatatypeType, 
    i#0: int, 
    results#0: ref)
   returns (res#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var i#1: int;
  var ##pkv#1: DatatypeType;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var i#5: int;
  var ##psa#2: DatatypeType;
  var i#8: int;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;
  var j#0: int;
  var newtype$check#0: int;
  var ##pkv#2: DatatypeType;
  var ##s#0: Seq Box;
  var ##buckets#0: Seq Box;
  var ##s#1: Seq Box;
  var ##buckets#1: Seq Box;
  var ##pkv#3: DatatypeType;
  var ##s#2: Seq Box;
  var ##s#3: Seq Box;
  var ##s#4: Seq Box;
  var ##top#0: DatatypeType;
  var ##bots#0: Seq Box;
  var ##idxs#0: Seq Box;
  var ##tmp#0: DatatypeType;
  var ##i#0: int;
  var ##results#0: Seq Box;

    // AddMethodImpl: MergeToChildrenIter, CheckWellformed$$DynamicPkv.__default.MergeToChildrenIter
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == results#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1113,9): initial state"} true;
    ##pkv#0 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(top#0);
    assume PackedKV.__default.WF(top#0);
    havoc i#1;
    if (*)
    {
        assume LitInt(0) <= i#1;
        assume i#1 < Seq#Length(bots#0);
        assert 0 <= i#1 && i#1 < Seq#Length(bots#0);
        ##pkv#1 := $Unbox(Seq#Index(bots#0, i#1)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(bots#0, i#1)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
           ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType);
    }

    assume (forall i#2: int :: 
      { $Unbox(Seq#Index(bots#0, i#2)): DatatypeType } 
      LitInt(0) <= i#2 && i#2 < Seq#Length(bots#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#2)): DatatypeType));
    assume Seq#Length(bots#0) < 18446744073709551616;
    assume PackedKV.Pkv.Pkv_q(top#0);
    ##psa#0 := PackedKV.Pkv.keys(top#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#0), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#0), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#3: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#3)): Seq Box } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(PackedStringArray.__default.I(##psa#0))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#3)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#0), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
    if (LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))))
    {
        assume PackedKV.Pkv.Pkv_q(top#0);
        ##psa#1 := PackedKV.Pkv.keys(top#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#1), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#1), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#4: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#1), i#4)): Seq Box } 
              LitInt(0) <= i#4 && i#4 < Seq#Length(PackedStringArray.__default.I(##psa#1))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#1), i#4)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#1), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
    }

    assume LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)))
       && Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
    havoc i#5;
    if (*)
    {
        assume LitInt(0) <= i#5;
        assume i#5 < Seq#Length(bots#0);
        assert 0 <= i#5 && i#5 < Seq#Length(bots#0);
        assume PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(bots#0, i#5)): DatatypeType);
        ##psa#2 := PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#5)): DatatypeType);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#2), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#2), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#6: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#6)): Seq Box } 
              LitInt(0) <= i#6 && i#6 < Seq#Length(PackedStringArray.__default.I(##psa#2))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#6)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#2), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#5)): DatatypeType));
        assume Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#5)): DatatypeType)))
           < 268435456;
    }
    else
    {
        assume LitInt(0) <= i#5 && i#5 < Seq#Length(bots#0)
           ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#5)): DatatypeType)))
             < 268435456;
    }

    assume (forall i#7: int :: 
      { $Unbox(Seq#Index(bots#0, i#7)): DatatypeType } 
      LitInt(0) <= i#7 && i#7 < Seq#Length(bots#0)
         ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#7)): DatatypeType)))
           < 268435456);
    assume 0 < Seq#Length(bots#0);
    assert results#0 != null;
    assume _System.array.Length(results#0) == Seq#Length(bots#0);
    if (LitInt(0) <= i#0)
    {
    }

    assume LitInt(0) <= i#0 && i#0 <= Seq#Length(bots#0);
    assume Seq#Length(idxs#0) == Seq#Length(bots#0) - 1;
    havoc i#8;
    if (*)
    {
        assume LitInt(0) <= i#8;
        assume i#8 < Seq#Length(idxs#0);
        assert 0 <= i#8 && i#8 < Seq#Length(idxs#0);
        assume LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#8)): int;
        assert 0 <= i#8 && i#8 < Seq#Length(idxs#0);
        assume PackedKV.Pkv.Pkv_q(top#0);
        ##psa#3 := PackedKV.Pkv.keys(top#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#3));
        assume PackedStringArray.__default.WF(##psa#3);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#3), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#3), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#9: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#3), i#9)): Seq Box } 
              LitInt(0) <= i#9 && i#9 < Seq#Length(PackedStringArray.__default.I(##psa#3))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#3), i#9)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#3), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
        assume $Unbox(Seq#Index(idxs#0, i#8)): int
           <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
    }
    else
    {
        assume LitInt(0) <= i#8 && i#8 < Seq#Length(idxs#0)
           ==> LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#8)): int
             && $Unbox(Seq#Index(idxs#0, i#8)): int
               <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
    }

    assume (forall i#10: int :: 
      { $Unbox(Seq#Index(idxs#0, i#10)): int } 
      LitInt(0) <= i#10 && i#10 < Seq#Length(idxs#0)
         ==> LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#10)): int
           && $Unbox(Seq#Index(idxs#0, i#10)): int
             <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))));
    if (*)
    {
        assume DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
        assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
        if (LitInt(0) <= DynamicPkv.SingleMergeResult.end(tmp#0))
        {
            assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
            assume PackedKV.Pkv.Pkv_q(top#0);
            ##psa#4 := PackedKV.Pkv.keys(top#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#4));
            assume PackedStringArray.__default.WF(##psa#4);
            assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(##psa#4), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(##psa#4), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#11: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#4), i#11)): Seq Box } 
                  LitInt(0) <= i#11 && i#11 < Seq#Length(PackedStringArray.__default.I(##psa#4))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#4), i#11)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#4), 
              LitInt(KeyType.__default.MaxLen()));
            assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
        }

        assume LitInt(0) <= DynamicPkv.SingleMergeResult.end(tmp#0)
           && DynamicPkv.SingleMergeResult.end(tmp#0)
             <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
    }
    else
    {
        assume DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0)
           ==> LitInt(0) <= DynamicPkv.SingleMergeResult.end(tmp#0)
             && DynamicPkv.SingleMergeResult.end(tmp#0)
               <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
    }

    assume DynamicPkv.SingleMergeResult.WF#canCall(tmp#0);
    assume DynamicPkv.SingleMergeResult.WF(tmp#0);
    havoc j#0;
    assume LitInt(0) <= j#0 && j#0 < 18446744073709551616;
    if (*)
    {
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume LitInt(0) <= j#0;
        assume j#0 < i#0;
        assert results#0 != null;
        assert 0 <= j#0 && j#0 < _System.array.Length(results#0);
        ##pkv#2 := $Unbox(read($Heap, results#0, IndexField(j#0))): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(read($Heap, results#0, IndexField(j#0))): DatatypeType);
        assume PackedKV.__default.WF($Unbox(read($Heap, results#0, IndexField(j#0))): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= j#0 && j#0 < i#0
           ==> PackedKV.__default.WF($Unbox(read($Heap, results#0, IndexField(j#0))): DatatypeType);
    }

    assume (forall j#1: int :: 
      { $Unbox(read($Heap, results#0, IndexField(j#1))): DatatypeType } 
      LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#0
         ==> PackedKV.__default.WF($Unbox(read($Heap, results#0, IndexField(j#1))): DatatypeType));
    assert results#0 != null;
    assert 0 <= i#0 && i#0 <= _System.array.Length(results#0);
    ##s#0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#12: int :: 
      { $Unbox(Seq#Index(##s#0, i#12)): DatatypeType } 
      LitInt(0) <= i#12 && i#12 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#12)): DatatypeType));
    assume (forall i#12: int :: 
      { $Unbox(Seq#Index(##s#0, i#12)): DatatypeType } 
      LitInt(0) <= i#12 && i#12 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#12)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0));
    ##buckets#0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)));
    assert 0 <= i#0 && i#0 <= Seq#Length(bots#0);
    ##s#1 := Seq#Drop(bots#0, i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#13: int :: 
      { $Unbox(Seq#Index(##s#1, i#13)): DatatypeType } 
      LitInt(0) <= i#13 && i#13 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#13)): DatatypeType));
    assume (forall i#13: int :: 
      { $Unbox(Seq#Index(##s#1, i#13)): DatatypeType } 
      LitInt(0) <= i#13 && i#13 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#13)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0));
    ##buckets#1 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
    assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
       || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
    assume Bounds.__default.MaxTotalBucketWeight#canCall();
    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
          DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
         + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
          DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)))
         + DynamicPkv.SingleMergeResult.slack(tmp#0)
       == LitInt(Bounds.__default.MaxTotalBucketWeight());
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o] || $o == results#0);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1139,16): post-state"} true;
    assume DynamicPkv.MergeResult.WF#canCall(res#0);
    assume DynamicPkv.MergeResult.WF(res#0);
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#14: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                            i#14)): Seq Box } 
                      LitInt(0) <= i#14
                           && i#14
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                                i#14)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen())))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                 || (forall i#15: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))), 
                        i#15)): Seq Box } 
                  LitInt(0) <= i#15
                       && i#15
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))), 
                          i#15)): Seq Box))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))), 
              $Box(ValueMessage.__default.IdentityMessage())));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(res#0)
       ==> Lit(DynamicPkv.MergeResult.WF(res#0))
         || (forall i#16: int :: 
          { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(res#0), i#16)): DatatypeType } 
          LitInt(0) <= i#16 && i#16 < Seq#Length(DynamicPkv.MergeResult.bots(res#0))
             ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(res#0), i#16)): DatatypeType));
    assume DynamicPkv.MergeResult.WF(res#0);
    assume DynamicPkv.MergeResult.I#canCall(res#0);
    assume BucketModel.mergeResult.mergeResult_q(Lit(DynamicPkv.MergeResult.I(res#0)));
    ##pkv#3 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#17: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#17)): Seq Box } 
                  LitInt(0) <= i#17
                       && i#17 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#17)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#18: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#18)): Seq Box } 
              LitInt(0) <= i#18
                   && i#18 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#18)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#3);
    assume PackedKV.__default.I#canCall(top#0);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(top#0));
    ##s#2 := bots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#19: int :: 
      { $Unbox(Seq#Index(##s#2, i#19)): DatatypeType } 
      LitInt(0) <= i#19 && i#19 < Seq#Length(##s#2)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2, i#19)): DatatypeType));
    assume (forall i#19: int :: 
      { $Unbox(Seq#Index(##s#2, i#19)): DatatypeType } 
      LitInt(0) <= i#19 && i#19 < Seq#Length(##s#2)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2, i#19)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
    ##s#3 := idxs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#3, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    assume DynamicPkv.__default.seqInt#canCall(idxs#0);
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0)) || Lit(true);
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#20: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                            i#20)): Seq Box } 
                      LitInt(0) <= i#20
                           && i#20
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                                i#20)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen())))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                 || (forall i#21: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                        i#21)): Seq Box } 
                  LitInt(0) <= i#21
                       && i#21
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                          i#21)): Seq Box))));
    assert {:subsumption 0} DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
       ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
           ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
              $Box(ValueMessage.__default.IdentityMessage())));
    assume DynamicPkv.SingleMergeResult.WF(tmp#0);
    assume DynamicPkv.SingleMergeResult.I#canCall(tmp#0);
    assert results#0 != null;
    assert 0 <= i#0 && i#0 <= _System.array.Length(results#0);
    ##s#4 := Seq#Take(Seq#FromArray(old($Heap), results#0), i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#4, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#22: int :: 
      { $Unbox(Seq#Index(##s#4, i#22)): DatatypeType } 
      LitInt(0) <= i#22 && i#22 < Seq#Length(##s#4)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#4, i#22)): DatatypeType));
    assume (forall i#22: int :: 
      { $Unbox(Seq#Index(##s#4, i#22)): DatatypeType } 
      LitInt(0) <= i#22 && i#22 < Seq#Length(##s#4)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#4, i#22)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray(old($Heap), results#0), i#0));
    ##top#0 := PackedKV.__default.I(top#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##top#0, Tclass.BucketsLib.Bucket(), $Heap);
    ##bots#0 := DynamicPkv.__default.PKVISeq($LS($LZ), bots#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bots#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    ##idxs#0 := DynamicPkv.__default.seqInt($LS($LZ), idxs#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##idxs#0, TSeq(TInt), $Heap);
    ##tmp#0 := Lit(DynamicPkv.SingleMergeResult.I(tmp#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##tmp#0, Tclass.BucketModel.singleMergeResult(), $Heap);
    ##i#0 := i#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#0, TInt, $Heap);
    ##results#0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##results#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.PreWFBucket#canCall(##top#0)
           ==> BucketsLib.__default.PreWFBucket(##top#0)
             || Seq#Length(BucketsLib.Bucket.keys(##top#0))
               == Seq#Length(BucketsLib.Bucket.msgs(##top#0)));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.PreWFBucket#canCall(##top#0)
           ==> BucketsLib.__default.PreWFBucket(##top#0)
             || Map#Equal(BucketsLib.__default.BucketMapOfSeq(StartFuelAssert_BucketsLib._default.BucketMapOfSeq, 
                BucketsLib.Bucket.keys(##top#0), 
                BucketsLib.Bucket.msgs(##top#0)), 
              BucketsLib.Bucket.b(##top#0)));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.WFBucketMap#canCall(BucketsLib.Bucket.b(##top#0))
           ==> BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(##top#0))
             || (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(##top#0))[$Box(key#0)] } 
              $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage())));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.WFMessageSeq#canCall(BucketsLib.Bucket.msgs(##top#0))
           ==> BucketsLib.__default.WFMessageSeq(BucketsLib.Bucket.msgs(##top#0))
             || (forall i#23: int :: 
              { $Unbox(Seq#Index(BucketsLib.Bucket.msgs(##top#0), i#23)): DatatypeType } 
              LitInt(0) <= i#23 && i#23 < Seq#Length(BucketsLib.Bucket.msgs(##top#0))
                 ==> !ValueMessage.Message#Equal($Unbox(Seq#Index(BucketsLib.Bucket.msgs(##top#0), i#23)): DatatypeType, 
                  ValueMessage.__default.IdentityMessage())));
    assume BucketsLib.__default.WFBucket(##top#0);
    assert {:subsumption 0} (forall i#24: int :: 
      { $Unbox(Seq#Index(##bots#0, i#24)): DatatypeType } 
      LitInt(0) <= i#24 && i#24 < Seq#Length(##bots#0)
         ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(##bots#0, i#24)): DatatypeType));
    assume (forall i#24: int :: 
      { $Unbox(Seq#Index(##bots#0, i#24)): DatatypeType } 
      LitInt(0) <= i#24 && i#24 < Seq#Length(##bots#0)
         ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(##bots#0, i#24)): DatatypeType));
    assert {:subsumption 0} 0 < Seq#Length(##bots#0);
    assume 0 < Seq#Length(##bots#0);
    assert {:subsumption 0} Seq#Length(##results#0) == ##i#0;
    assume Seq#Length(##results#0) == ##i#0;
    assert {:subsumption 0} LitInt(0) <= ##i#0;
    assert {:subsumption 0} ##i#0 <= Seq#Length(##bots#0);
    assume LitInt(0) <= ##i#0 && ##i#0 <= Seq#Length(##bots#0);
    assert {:subsumption 0} Seq#Length(##idxs#0) == Seq#Length(##bots#0) - 1;
    assume Seq#Length(##idxs#0) == Seq#Length(##bots#0) - 1;
    assert {:subsumption 0} (forall i#25: int :: 
      { $Unbox(Seq#Index(##idxs#0, i#25)): int } 
      LitInt(0) <= i#25 && i#25 < Seq#Length(##idxs#0)
         ==> LitInt(0) <= $Unbox(Seq#Index(##idxs#0, i#25)): int
           && $Unbox(Seq#Index(##idxs#0, i#25)): int
             <= Seq#Length(BucketsLib.Bucket.keys(##top#0)));
    assume (forall i#25: int :: 
      { $Unbox(Seq#Index(##idxs#0, i#25)): int } 
      LitInt(0) <= i#25 && i#25 < Seq#Length(##idxs#0)
         ==> LitInt(0) <= $Unbox(Seq#Index(##idxs#0, i#25)): int
           && $Unbox(Seq#Index(##idxs#0, i#25)): int
             <= Seq#Length(BucketsLib.Bucket.keys(##top#0)));
    assert {:subsumption 0} BucketModel.singleMergeResult.SlackExhausted_q(##tmp#0)
       ==> LitInt(0) <= BucketModel.singleMergeResult.end(##tmp#0);
    assert {:subsumption 0} BucketModel.singleMergeResult.SlackExhausted_q(##tmp#0)
       ==> BucketModel.singleMergeResult.end(##tmp#0)
         <= Seq#Length(BucketsLib.Bucket.keys(##top#0));
    assume BucketModel.singleMergeResult.SlackExhausted_q(##tmp#0)
       ==> LitInt(0) <= BucketModel.singleMergeResult.end(##tmp#0)
         && BucketModel.singleMergeResult.end(##tmp#0)
           <= Seq#Length(BucketsLib.Bucket.keys(##top#0));
    assume BucketModel.__default.mergeToChildrenIter#canCall(PackedKV.__default.I(top#0), 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
      DynamicPkv.__default.seqInt($LS($LZ), idxs#0), 
      Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
      i#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0)));
    assume BucketModel.mergeResult.mergeResult_q(BucketModel.__default.mergeToChildrenIter($LS($LZ), 
        PackedKV.__default.I(top#0), 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
        DynamicPkv.__default.seqInt($LS($LZ), idxs#0), 
        Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
        i#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))));
    assume BucketModel.mergeResult#Equal(DynamicPkv.MergeResult.I(res#0), 
      BucketModel.__default.mergeToChildrenIter($LS($LZ), 
        PackedKV.__default.I(top#0), 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
        DynamicPkv.__default.seqInt($LS($LZ), idxs#0), 
        Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
        i#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))));
}



procedure Call$$DynamicPkv.__default.MergeToChildrenIter(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    idxs#0: Seq Box
       where $Is(idxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(idxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    tmp#0: DatatypeType
       where $Is(tmp#0, Tclass.DynamicPkv.SingleMergeResult())
         && $IsAlloc(tmp#0, Tclass.DynamicPkv.SingleMergeResult(), $Heap)
         && $IsA#DynamicPkv.SingleMergeResult(tmp#0), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    results#0: ref
       where $Is(results#0, Tclass._System.array(Tclass.PackedKV.Pkv()))
         && $IsAlloc(results#0, Tclass._System.array(Tclass.PackedKV.Pkv()), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.DynamicPkv.MergeResult())
         && $IsAlloc(res#0, Tclass.DynamicPkv.MergeResult(), $Heap));
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#26: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), i#26)): Seq Box } 
                LitInt(0) <= i#26
                     && i#26 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), i#26)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
           || (forall i#27: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)), i#27)): Seq Box } 
            LitInt(0) <= i#27
                 && i#27 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)), i#27)): Seq Box)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires (forall i#2: int :: 
    { $Unbox(Seq#Index(bots#0, i#2)): DatatypeType } 
    LitInt(0) <= i#2 && i#2 < Seq#Length(bots#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#2)): DatatypeType));
  requires Seq#Length(bots#0) < 18446744073709551616;
  requires LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
  requires Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
  requires (forall i#7: int :: 
    { $Unbox(Seq#Index(bots#0, i#7)): DatatypeType } 
    LitInt(0) <= i#7 && i#7 < Seq#Length(bots#0)
       ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#7)): DatatypeType)))
         < 268435456);
  requires 0 < Seq#Length(bots#0);
  requires _System.array.Length(results#0) == Seq#Length(bots#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= Seq#Length(bots#0);
  requires Seq#Length(idxs#0) == Seq#Length(bots#0) - 1;
  requires (forall i#10: int :: 
    { $Unbox(Seq#Index(idxs#0, i#10)): int } 
    LitInt(0) <= i#10 && i#10 < Seq#Length(idxs#0)
       ==> LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#10)): int
         && $Unbox(Seq#Index(idxs#0, i#10)): int
           <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))));
  requires DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0)
     ==> LitInt(0) <= DynamicPkv.SingleMergeResult.end(tmp#0);
  requires DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0)
     ==> DynamicPkv.SingleMergeResult.end(tmp#0)
       <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0)) || Lit(true);
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                 < 4294967296));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                 < 4294967296));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   == LitInt(0))));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                         - 1)): int)));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                 < 4294967296));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                 < 4294967296));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   == LitInt(0))));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                         - 1)): int)));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
             == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0)))));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
             ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
               || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                  LitInt(KeyType.__default.MaxLen()))
                 ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   || (forall i#28: int :: 
                    { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                          i#28)): Seq Box } 
                    LitInt(0) <= i#28
                         && i#28
                           < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                       ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                              i#28)): Seq Box)
                         <= LitInt(KeyType.__default.MaxLen())))));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
             ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
               || (forall i#29: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                      i#29)): Seq Box } 
                LitInt(0) <= i#29
                     && i#29
                       < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))))
                   ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
                        i#29)): Seq Box))));
  requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     ==> Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.SingleMergeResult.bot(tmp#0))
         ==> PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0))
           || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp#0))), 
            $Box(ValueMessage.__default.IdentityMessage())));
  requires (forall j#1: int :: 
    { $Unbox(read($Heap, results#0, IndexField(j#1))): DatatypeType } 
    LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#0
       ==> PackedKV.__default.WF($Unbox(read($Heap, results#0, IndexField(j#1))): DatatypeType));
  requires BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
       + BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(bots#0, i#0)))
       + DynamicPkv.SingleMergeResult.slack(tmp#0)
     == LitInt(Bounds.__default.MaxTotalBucketWeight());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.MergeResult.WF#canCall(res#0);
  free ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     && 
    Lit(DynamicPkv.MergeResult.WF(res#0))
     && 
    PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
     && (forall i#32: int :: 
      { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(res#0), i#32)): DatatypeType } 
      LitInt(0) <= i#32 && i#32 < Seq#Length(DynamicPkv.MergeResult.bots(res#0))
         ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(res#0), i#32)): DatatypeType));
  free ensures $IsA#BucketModel.mergeResult(Lit(DynamicPkv.MergeResult.I(res#0)))
     && $IsA#BucketModel.mergeResult(BucketModel.__default.mergeToChildrenIter($LS($LZ), 
        PackedKV.__default.I(top#0), 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
        DynamicPkv.__default.seqInt($LS($LZ), idxs#0), 
        Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
        i#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))))
     && 
    DynamicPkv.MergeResult.I#canCall(res#0)
     && 
    PackedKV.__default.I#canCall(top#0)
     && DynamicPkv.__default.PKVISeq#canCall(bots#0)
     && DynamicPkv.__default.seqInt#canCall(idxs#0)
     && DynamicPkv.SingleMergeResult.I#canCall(tmp#0)
     && DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))
     && BucketModel.__default.mergeToChildrenIter#canCall(PackedKV.__default.I(top#0), 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
      DynamicPkv.__default.seqInt($LS($LZ), idxs#0), 
      Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
      i#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0)));
  ensures BucketModel.mergeResult#Equal(DynamicPkv.MergeResult.I(res#0), 
    BucketModel.__default.mergeToChildrenIter($LS($LS($LZ)), 
      PackedKV.__default.I(top#0), 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), 
      DynamicPkv.__default.seqInt($LS($LS($LZ)), idxs#0), 
      Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
      i#0, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == results#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.__default.MergeToChildrenIter(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    idxs#0: Seq Box
       where $Is(idxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(idxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    tmp#0: DatatypeType
       where $Is(tmp#0, Tclass.DynamicPkv.SingleMergeResult())
         && $IsAlloc(tmp#0, Tclass.DynamicPkv.SingleMergeResult(), $Heap)
         && $IsA#DynamicPkv.SingleMergeResult(tmp#0), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    results#0: ref
       where $Is(results#0, Tclass._System.array(Tclass.PackedKV.Pkv()))
         && $IsAlloc(results#0, Tclass._System.array(Tclass.PackedKV.Pkv()), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.DynamicPkv.MergeResult())
         && $IsAlloc(res#0, Tclass.DynamicPkv.MergeResult(), $Heap), 
    $_reverifyPost: bool);
  free requires 44 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(top#0)
     && 
    PackedKV.__default.WF(top#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  requires (forall i#2: int :: 
    { $Unbox(Seq#Index(bots#0, i#2)): DatatypeType } 
    LitInt(0) <= i#2 && i#2 < Seq#Length(bots#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#2)): DatatypeType));
  requires Seq#Length(bots#0) < 18446744073709551616;
  requires LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
  requires Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
  requires (forall i#7: int :: 
    { $Unbox(Seq#Index(bots#0, i#7)): DatatypeType } 
    LitInt(0) <= i#7 && i#7 < Seq#Length(bots#0)
       ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#7)): DatatypeType)))
         < 268435456);
  requires 0 < Seq#Length(bots#0);
  requires _System.array.Length(results#0) == Seq#Length(bots#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= Seq#Length(bots#0);
  requires Seq#Length(idxs#0) == Seq#Length(bots#0) - 1;
  requires (forall i#10: int :: 
    { $Unbox(Seq#Index(idxs#0, i#10)): int } 
    LitInt(0) <= i#10 && i#10 < Seq#Length(idxs#0)
       ==> LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#10)): int
         && $Unbox(Seq#Index(idxs#0, i#10)): int
           <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))));
  requires DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0)
     ==> LitInt(0) <= DynamicPkv.SingleMergeResult.end(tmp#0);
  requires DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0)
     ==> DynamicPkv.SingleMergeResult.end(tmp#0)
       <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
  free requires DynamicPkv.SingleMergeResult.WF#canCall(tmp#0)
     && 
    Lit(DynamicPkv.SingleMergeResult.WF(tmp#0))
     && 
    true
     && PackedKV.__default.WF(DynamicPkv.SingleMergeResult.bot(tmp#0));
  requires (forall j#1: int :: 
    { $Unbox(read($Heap, results#0, IndexField(j#1))): DatatypeType } 
    LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#0
       ==> PackedKV.__default.WF($Unbox(read($Heap, results#0, IndexField(j#1))): DatatypeType));
  requires BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
       + BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(bots#0, i#0)))
       + DynamicPkv.SingleMergeResult.slack(tmp#0)
     == LitInt(Bounds.__default.MaxTotalBucketWeight());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.MergeResult.WF#canCall(res#0);
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                 < 4294967296));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                 < 4294967296));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                   == LitInt(0))));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                         - 1)): int)));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                 < 4294967296));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                 < 4294967296));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                   == LitInt(0))));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                         - 1)): int)));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
             == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0)))));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
             ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
               || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                  LitInt(KeyType.__default.MaxLen()))
                 ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   || (forall i#37: int :: 
                    { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                          i#37)): Seq Box } 
                    LitInt(0) <= i#37
                         && i#37
                           < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))))
                       ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(res#0))), 
                              i#37)): Seq Box)
                         <= LitInt(KeyType.__default.MaxLen())))));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
             ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
               || (forall i#38: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))), 
                      i#38)): Seq Box } 
                LitInt(0) <= i#38
                     && i#38
                       < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))))
                   ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))), 
                        i#38)): Seq Box))));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(res#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(res#0))
           || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(res#0))), 
            $Box(ValueMessage.__default.IdentityMessage())));
  ensures DynamicPkv.MergeResult.WF#canCall(res#0)
     ==> Lit(DynamicPkv.MergeResult.WF(res#0))
       || (forall i#39: int :: 
        { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(res#0), i#39)): DatatypeType } 
        LitInt(0) <= i#39 && i#39 < Seq#Length(DynamicPkv.MergeResult.bots(res#0))
           ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(res#0), i#39)): DatatypeType));
  free ensures $IsA#BucketModel.mergeResult(Lit(DynamicPkv.MergeResult.I(res#0)))
     && $IsA#BucketModel.mergeResult(BucketModel.__default.mergeToChildrenIter($LS($LZ), 
        PackedKV.__default.I(top#0), 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
        DynamicPkv.__default.seqInt($LS($LZ), idxs#0), 
        Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
        i#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))))
     && 
    DynamicPkv.MergeResult.I#canCall(res#0)
     && 
    PackedKV.__default.I#canCall(top#0)
     && DynamicPkv.__default.PKVISeq#canCall(bots#0)
     && DynamicPkv.__default.seqInt#canCall(idxs#0)
     && DynamicPkv.SingleMergeResult.I#canCall(tmp#0)
     && DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))
     && BucketModel.__default.mergeToChildrenIter#canCall(PackedKV.__default.I(top#0), 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
      DynamicPkv.__default.seqInt($LS($LZ), idxs#0), 
      Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
      i#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0)));
  ensures BucketModel.mergeResult#Equal(DynamicPkv.MergeResult.I(res#0), 
    BucketModel.__default.mergeToChildrenIter($LS($LS($LZ)), 
      PackedKV.__default.I(top#0), 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), 
      DynamicPkv.__default.seqInt($LS($LS($LZ)), idxs#0), 
      Lit(DynamicPkv.SingleMergeResult.I(tmp#0)), 
      i#0, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == results#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.__default.MergeToChildrenIter(top#0: DatatypeType, 
    bots#0: Seq Box, 
    idxs#0: Seq Box, 
    tmp#0: DatatypeType, 
    i#0: int, 
    results#0: ref)
   returns (res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#1: int;
  var leftover_top#0_0_0: DatatypeType
     where $Is(leftover_top#0_0_0, Tclass.PackedKV.Pkv())
       && $IsAlloc(leftover_top#0_0_0, Tclass.PackedKV.Pkv(), $Heap);
  var $rhs##0_0_0: DatatypeType
     where $Is($rhs##0_0_0, Tclass.PackedKV.Pkv())
       && $IsAlloc($rhs##0_0_0, Tclass.PackedKV.Pkv(), $Heap);
  var pkv##0_0_0: DatatypeType;
  var from##0_0_0: int;
  var to##0_0_0: int;
  var ##pkv#0_0_0: DatatypeType;
  var topb#0_0_0: DatatypeType
     where $Is(topb#0_0_0, Tclass.BucketsLib.Bucket())
       && $IsAlloc(topb#0_0_0, Tclass.BucketsLib.Bucket(), $Heap);
  var ##pkv#0_0_1: DatatypeType;
  var ##keys#0_0_0_0_0: Seq Box;
  var ##msgs#0_0_0_0_0: Seq Box;
  var ##psa#0_0_0_0_0: DatatypeType;
  var ##psa#0_0_0_0_1: DatatypeType;
  var ##pkv#0_0_0_0_0: DatatypeType;
  var ##psa#0_0_0_0_2: DatatypeType;
  var ##psa#0_0_0_0_3: DatatypeType;
  var ##pkv#0_0_0_0_1: DatatypeType;
  var ##pkv#0_0_0_0_2: DatatypeType;
  var pkv##0_0_0_0_0: DatatypeType;
  var a##0_0_0_0_0: int;
  var b##0_0_0_0_0: int;
  var ##pkv#0_0_0_0_3: DatatypeType;
  var ##pkv#0_0_0_0_4: DatatypeType;
  var ##pkv#0_0_0_0_5: DatatypeType;
  var ##keys#0_0_0_0: Seq Box;
  var ##msgs#0_0_0_0: Seq Box;
  var from#1_0: int where LitInt(0) <= from#1_0 && from#1_0 < 18446744073709551616;
  var newtype$check#1_0: int;
  var newtype$check#1_1: int;
  var newtype$check#1_2: int;
  var newtype$check#1_3: int;
  var to1#1_0: int where LitInt(0) <= to1#1_0 && to1#1_0 < 18446744073709551616;
  var newtype$check#1_4: int;
  var ##pkv#1_0: DatatypeType;
  var to#1_0: int where LitInt(0) <= to#1_0 && to#1_0 < 18446744073709551616;
  var bots##1_0: Seq Box;
  var i##1_0: int;
  var tmp'#1_0: DatatypeType
     where $Is(tmp'#1_0, Tclass.DynamicPkv.SingleMergeResult())
       && $IsAlloc(tmp'#1_0, Tclass.DynamicPkv.SingleMergeResult(), $Heap);
  var $rhs##1_0: DatatypeType
     where $Is($rhs##1_0, Tclass.DynamicPkv.SingleMergeResult())
       && $IsAlloc($rhs##1_0, Tclass.DynamicPkv.SingleMergeResult(), $Heap);
  var top##1_0: DatatypeType;
  var from0##1_0: int;
  var to##1_0: int;
  var bot##1_0: DatatypeType;
  var slack0##1_0: int;
  var $rhs#1_0: DatatypeType where $Is($rhs#1_0, Tclass.PackedKV.Pkv());
  var ##s#1_0_0_0: Seq Box;
  var ##buckets#1_0_0_0: Seq Box;
  var ##s#1_0_0_1: Seq Box;
  var ##buckets#1_0_0_1: Seq Box;
  var pkvs##1_0_0_0: Seq Box;
  var i##1_0_0_0: int;
  var pkvs##1_0_0_1: ref;
  var i##1_0_0_1: int;
  var newtype$check#1_0_0_0: int;
  var newtype$check#1_0_0_1: int;
  var ##s#1_0_0_2: Seq Box;
  var ##buckets#1_0_0_2: Seq Box;
  var newtype$check#1_0_0_2: int;
  var newtype$check#1_0_0_3: int;
  var ##s#1_0_0_3: Seq Box;
  var ##buckets#1_0_0_3: Seq Box;
  var ##s#1_0_0: Seq Box;
  var ##buckets#1_0_0: Seq Box;
  var ##s#1_0_1: Seq Box;
  var ##buckets#1_0_1: Seq Box;
  var newtype$check#1_1_0_0: int;
  var newtype$check#1_1_0_1: int;
  var ##s#1_1_0_0: Seq Box;
  var ##s#1_1_0_1: Seq Box;
  var ##psa#1_1_0_0: DatatypeType;
  var ##psa#1_1_0_1: DatatypeType;
  var ##keys#1_1_0_0: Seq Box;
  var ##msgs#1_1_0_0: Seq Box;
  var newtype$check#1_1_0: int;
  var newtype$check#1_1_1: int;
  var ##s#1_1_0: Seq Box;
  var $rhs##1_1: DatatypeType
     where $Is($rhs##1_1, Tclass.DynamicPkv.MergeResult())
       && $IsAlloc($rhs##1_1, Tclass.DynamicPkv.MergeResult(), $Heap);
  var top##1_1: DatatypeType;
  var bots##1_1: Seq Box;
  var idxs##1_0: Seq Box;
  var tmp##1_0: DatatypeType;
  var i##1_1: int;
  var newtype$check#1_5: int;
  var newtype$check#1_6: int;
  var results##1_0: ref;
  var $rhs#0: DatatypeType where $Is($rhs#0, Tclass.PackedKV.Pkv());
  var ##s#2_0_0: Seq Box;
  var ##buckets#2_0_0: Seq Box;
  var ##s#2_0_1: Seq Box;
  var ##buckets#2_0_1: Seq Box;
  var pkvs##2_0_0: Seq Box;
  var i##2_0_0: int;
  var pkvs##2_0_1: ref;
  var i##2_0_1: int;
  var newtype$check#2_0_0: int;
  var newtype$check#2_0_1: int;
  var ##s#2_0_2: Seq Box;
  var ##buckets#2_0_2: Seq Box;
  var newtype$check#2_0_2: int;
  var newtype$check#2_0_3: int;
  var ##s#2_0_3: Seq Box;
  var ##buckets#2_0_3: Seq Box;
  var ##s#2_0: Seq Box;
  var ##buckets#2_0: Seq Box;
  var ##s#2_1: Seq Box;
  var ##buckets#2_1: Seq Box;
  var newtype$check#3_0_0: int;
  var newtype$check#3_0_1: int;
  var ##s#3_0_0: Seq Box;
  var ##s#3_0_1: Seq Box;
  var ##pkv#3_0_0: DatatypeType;
  var newtype$check#3_0: int;
  var newtype$check#3_1: int;
  var ##s#3_0: Seq Box;
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.DynamicPkv.MergeResult())
       && $IsAlloc($rhs##0, Tclass.DynamicPkv.MergeResult(), $Heap);
  var top##0: DatatypeType;
  var bots##0: Seq Box;
  var idxs##0: Seq Box;
  var tmp##0: DatatypeType;
  var i##0: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var results##0: ref;

    // AddMethodImpl: MergeToChildrenIter, Impl$$DynamicPkv.__default.MergeToChildrenIter
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == results#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1143,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1144,5)
    newtype$check#1 := Seq#Length(bots#0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    if (i#0 == Seq#Length(bots#0))
    {
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1145,7)
        assume true;
        if (DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0))
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1146,39)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Pkv
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            pkv##0_0_0 := top#0;
            assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            from##0_0_0 := DynamicPkv.SingleMergeResult.end(tmp#0);
            ##pkv#0_0_0 := top#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_0: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), i#0_0_0)): Seq Box } 
                          LitInt(0) <= i#0_0_0
                               && i#0_0_0
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0)), i#0_0_0)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                     || (forall i#0_0_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)), i#0_0_1)): Seq Box } 
                      LitInt(0) <= i#0_0_1
                           && i#0_0_1
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0)), i#0_0_1)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#0_0_0);
            assume PackedKV.__default.NumKVPairs#canCall(top#0);
            assume PackedKV.__default.NumKVPairs#canCall(top#0);
            // ProcessCallStmt: CheckSubrange
            to##0_0_0 := PackedKV.__default.NumKVPairs(top#0);
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call $rhs##0_0_0 := Call$$PackedKV.__default.SubPkv(pkv##0_0_0, from##0_0_0, to##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            leftover_top#0_0_0 := $rhs##0_0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1146,73)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1148,24)
            assume true;
            ##pkv#0_0_1 := top#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_1, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_1)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_1))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_1))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_1)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_1)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_2: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)), i#0_0_2)): Seq Box } 
                          LitInt(0) <= i#0_0_2
                               && i#0_0_2
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_1)), i#0_0_2)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)))
                     || (forall i#0_0_3: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)), i#0_0_3)): Seq Box } 
                      LitInt(0) <= i#0_0_3
                           && i#0_0_3
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_1)), i#0_0_3)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_1)
               ==> PackedKV.__default.WF(##pkv#0_0_1)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_1)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WF(##pkv#0_0_1);
            assume PackedKV.__default.I#canCall(top#0);
            assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(top#0));
            assume PackedKV.__default.I#canCall(top#0);
            topb#0_0_0 := PackedKV.__default.I(top#0);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1148,36)"} true;
            // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1149,9)
            // Assume Fuel Constant
            if (*)
            {
                // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1149,9)
                assume BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0);
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assert {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(BucketsLib.Bucket.keys(topb#0_0_0));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0);
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assert {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(BucketsLib.Bucket.msgs(topb#0_0_0));
                ##keys#0_0_0_0 := Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##keys#0_0_0_0, TSeq(Tclass.KeyType.Key()), $Heap);
                ##msgs#0_0_0_0 := Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##msgs#0_0_0_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
                assert {:subsumption 0} Seq#Length(##keys#0_0_0_0) == Seq#Length(##msgs#0_0_0_0);
                assume BucketsLib.__default.BucketOfSeq#canCall(Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)), 
                  Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(BucketsLib.__default.BucketOfSeq(Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)), 
                    Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0))));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0)
                   && BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0)
                   && BucketsLib.__default.BucketOfSeq#canCall(Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)), 
                    Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)));
                assume false;
            }
            else if (*)
            {
                // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1149,9)
                assume BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0);
                assume DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assume {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(BucketsLib.Bucket.keys(topb#0_0_0));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0);
                assume DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assume {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(BucketsLib.Bucket.msgs(topb#0_0_0));
                ##keys#0_0_0_0_0 := Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##keys#0_0_0_0_0, TSeq(Tclass.KeyType.Key()), $Heap);
                ##msgs#0_0_0_0_0 := Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##msgs#0_0_0_0_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
                assume {:subsumption 0} Seq#Length(##keys#0_0_0_0_0) == Seq#Length(##msgs#0_0_0_0_0);
                assume BucketsLib.__default.BucketOfSeq#canCall(Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)), 
                  Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(BucketsLib.__default.BucketOfSeq(Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)), 
                    Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0))));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0)
                   && BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0)
                   && BucketsLib.__default.BucketOfSeq#canCall(Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)), 
                    Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)));
                // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1149,9)
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1153,13)
                assume PackedKV.Pkv.Pkv_q(top#0);
                ##psa#0_0_0_0_0 := PackedKV.Pkv.keys(top#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#0_0_0_0_0, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_0)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_0)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_0)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_0)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_0)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_0)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_0)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_0)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_0)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_0)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_0)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_0)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_0))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_0))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0_0_0), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_0)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_0)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_0)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#0_0_0_0_0));
                assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(##psa#0_0_0_0_0), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(##psa#0_0_0_0_0), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0_0_0_0_0: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_0_0_0_0), i#0_0_0_0_0)): Seq Box } 
                      LitInt(0) <= i#0_0_0_0_0
                           && i#0_0_0_0_0 < Seq#Length(PackedStringArray.__default.I(##psa#0_0_0_0_0))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_0_0_0_0), i#0_0_0_0_0)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()));
                assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assert {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
                assume PackedKV.Pkv.Pkv_q(top#0);
                ##psa#0_0_0_0_1 := PackedKV.Pkv.keys(top#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#0_0_0_0_1, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_1)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_1)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_1)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_1)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_1)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_1)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_1)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_1)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_1)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_1)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_1)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_1)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_1))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_1))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0_0_1), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_1)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_1)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_1)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#0_0_0_0_1));
                assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(##psa#0_0_0_0_1), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(##psa#0_0_0_0_1), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0_0_0_0_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_0_0_0_1), i#0_0_0_0_1)): Seq Box } 
                      LitInt(0) <= i#0_0_0_0_1
                           && i#0_0_0_0_1 < Seq#Length(PackedStringArray.__default.I(##psa#0_0_0_0_1))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0_0_0_0_1), i#0_0_0_0_1)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()));
                assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assert {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
                ##pkv#0_0_0_0_0 := top#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_0_0_0_0, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_0))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_0))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_0_0_0_2: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)), i#0_0_0_0_2)): Seq Box } 
                              LitInt(0) <= i#0_0_0_0_2
                                   && i#0_0_0_0_2
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_0)), i#0_0_0_0_2)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                         || (forall i#0_0_0_0_3: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)), 
                                i#0_0_0_0_3)): Seq Box } 
                          LitInt(0) <= i#0_0_0_0_3
                               && i#0_0_0_0_3
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)), 
                                  i#0_0_0_0_3)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_0)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_0)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_0_0)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.NumKVPairs#canCall(top#0);
                assert {:subsumption 0} DynamicPkv.SingleMergeResult.end(tmp#0) <= PackedKV.__default.NumKVPairs(top#0)
                   && PackedKV.__default.NumKVPairs(top#0)
                     <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
                assume PackedKV.Pkv.Pkv_q(top#0)
                   && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0))
                   && 
                  PackedKV.Pkv.Pkv_q(top#0)
                   && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0))
                   && PackedKV.__default.NumKVPairs#canCall(top#0);
                assert Seq#Equal(Seq#Drop(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)), 
                    DynamicPkv.SingleMergeResult.end(tmp#0)), 
                  Seq#Drop(Seq#Take(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)), 
                      PackedKV.__default.NumKVPairs(top#0)), 
                    DynamicPkv.SingleMergeResult.end(tmp#0)));
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1155,13)
                assume PackedKV.Pkv.Pkv_q(top#0);
                ##psa#0_0_0_0_2 := PackedKV.Pkv.messages(top#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#0_0_0_0_2, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_2)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_2)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_2)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_2)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_2)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_2)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_2)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_2)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_2)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_2)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_2)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_2)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_2))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_2))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0_0_2), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_2)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_2)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_2)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#0_0_0_0_2));
                assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0));
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assert {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)));
                assume PackedKV.Pkv.Pkv_q(top#0);
                ##psa#0_0_0_0_3 := PackedKV.Pkv.messages(top#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#0_0_0_0_3, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_3)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_3)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_3)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_3)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_3)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_3)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_3)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_3)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_3)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_3)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_3)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_3)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_3))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0_0_0_3))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0_0_0_3), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0_0_0_3)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0_0_0_3)
                   ==> PackedStringArray.__default.WF(##psa#0_0_0_0_3)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#0_0_0_0_3));
                assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0));
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assert {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)));
                ##pkv#0_0_0_0_1 := top#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_0_0_0_1, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_1))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_1))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_0_0_0_4: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)), i#0_0_0_0_4)): Seq Box } 
                              LitInt(0) <= i#0_0_0_0_4
                                   && i#0_0_0_0_4
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_1)), i#0_0_0_0_4)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                         || (forall i#0_0_0_0_5: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)), 
                                i#0_0_0_0_5)): Seq Box } 
                          LitInt(0) <= i#0_0_0_0_5
                               && i#0_0_0_0_5
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)), 
                                  i#0_0_0_0_5)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_1)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_0_1)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.NumKVPairs#canCall(top#0);
                assert {:subsumption 0} DynamicPkv.SingleMergeResult.end(tmp#0) <= PackedKV.__default.NumKVPairs(top#0)
                   && PackedKV.__default.NumKVPairs(top#0)
                     <= Seq#Length(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)));
                assume PackedKV.Pkv.Pkv_q(top#0)
                   && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
                   && 
                  PackedKV.Pkv.Pkv_q(top#0)
                   && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(top#0))
                   && PackedKV.__default.NumKVPairs#canCall(top#0);
                assert Seq#Equal(Seq#Drop(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
                    DynamicPkv.SingleMergeResult.end(tmp#0)), 
                  Seq#Drop(Seq#Take(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
                      PackedKV.__default.NumKVPairs(top#0)), 
                    DynamicPkv.SingleMergeResult.end(tmp#0)));
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1157,13)
                ##pkv#0_0_0_0_2 := leftover_top#0_0_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_0_0_0_2, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_2))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_2))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_0_0_0_6: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)), i#0_0_0_0_6)): Seq Box } 
                              LitInt(0) <= i#0_0_0_0_6
                                   && i#0_0_0_0_6
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_2)), i#0_0_0_0_6)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                         || (forall i#0_0_0_0_7: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)), 
                                i#0_0_0_0_7)): Seq Box } 
                          LitInt(0) <= i#0_0_0_0_7
                               && i#0_0_0_0_7
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)), 
                                  i#0_0_0_0_7)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_2)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_0_2)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.I#canCall(leftover_top#0_0_0);
                assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(leftover_top#0_0_0));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(leftover_top#0_0_0));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0);
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assert {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(BucketsLib.Bucket.keys(topb#0_0_0));
                assume PackedKV.__default.I#canCall(leftover_top#0_0_0)
                   && BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(leftover_top#0_0_0))
                   && BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0);
                assert Seq#Equal(BucketsLib.Bucket.keys(PackedKV.__default.I(leftover_top#0_0_0)), 
                  Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)));
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1158,27)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                pkv##0_0_0_0_0 := top#0;
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assume true;
                // ProcessCallStmt: CheckSubrange
                a##0_0_0_0_0 := DynamicPkv.SingleMergeResult.end(tmp#0);
                ##pkv#0_0_0_0_3 := top#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_0_0_0_3, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_3))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_3))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_0_0_0_8: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)), i#0_0_0_0_8)): Seq Box } 
                              LitInt(0) <= i#0_0_0_0_8
                                   && i#0_0_0_0_8
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_3)), i#0_0_0_0_8)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                         || (forall i#0_0_0_0_9: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)), 
                                i#0_0_0_0_9)): Seq Box } 
                          LitInt(0) <= i#0_0_0_0_9
                               && i#0_0_0_0_9
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)), 
                                  i#0_0_0_0_9)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_3)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_3)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_0_3)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.WF(##pkv#0_0_0_0_3);
                assume PackedKV.__default.NumKVPairs#canCall(top#0);
                assume PackedKV.__default.NumKVPairs#canCall(top#0);
                // ProcessCallStmt: CheckSubrange
                b##0_0_0_0_0 := PackedKV.__default.NumKVPairs(top#0);
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$DynamicPkv.__default.IMessagesSlice(pkv##0_0_0_0_0, a##0_0_0_0_0, b##0_0_0_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1158,61)"} true;
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1159,13)
                ##pkv#0_0_0_0_4 := leftover_top#0_0_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_0_0_0_4, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_4))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_4))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_0_0_0_10: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)), i#0_0_0_0_10)): Seq Box } 
                              LitInt(0) <= i#0_0_0_0_10
                                   && i#0_0_0_0_10
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_4)), i#0_0_0_0_10)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                         || (forall i#0_0_0_0_11: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)), 
                                i#0_0_0_0_11)): Seq Box } 
                          LitInt(0) <= i#0_0_0_0_11
                               && i#0_0_0_0_11
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)), 
                                  i#0_0_0_0_11)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_4)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_4)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_0_4)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.I#canCall(leftover_top#0_0_0);
                assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(leftover_top#0_0_0));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(leftover_top#0_0_0));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0);
                assert DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assert {:subsumption 0} 0 <= DynamicPkv.SingleMergeResult.end(tmp#0)
                   && DynamicPkv.SingleMergeResult.end(tmp#0)
                     <= Seq#Length(BucketsLib.Bucket.msgs(topb#0_0_0));
                assume PackedKV.__default.I#canCall(leftover_top#0_0_0)
                   && BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(leftover_top#0_0_0))
                   && BucketsLib.Bucket.BucketMapWithSeq_q(topb#0_0_0);
                assert Seq#Equal(BucketsLib.Bucket.msgs(PackedKV.__default.I(leftover_top#0_0_0)), 
                  Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)));
                // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1149,9)
                ##pkv#0_0_0_0_5 := leftover_top#0_0_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_0_0_0_5, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_5))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_5))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_0_0_0_12: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)), i#0_0_0_0_12)): Seq Box } 
                              LitInt(0) <= i#0_0_0_0_12
                                   && i#0_0_0_0_12
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0_5)), i#0_0_0_0_12)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                         || (forall i#0_0_0_0_13: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)), 
                                i#0_0_0_0_13)): Seq Box } 
                          LitInt(0) <= i#0_0_0_0_13
                               && i#0_0_0_0_13
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)), 
                                  i#0_0_0_0_13)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0_5)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_0_5)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_0_5)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.I#canCall(leftover_top#0_0_0);
                assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(leftover_top#0_0_0));
                assume PackedKV.__default.I#canCall(leftover_top#0_0_0);
                // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1149,9)
                assert {:subsumption 0} BucketsLib.Bucket#Equal(BucketsLib.__default.BucketOfSeq(Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)), 
                    Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0))), 
                  PackedKV.__default.I(leftover_top#0_0_0));
                assume false;
            }

            assume BucketsLib.Bucket#Equal(BucketsLib.__default.BucketOfSeq(Seq#Drop(BucketsLib.Bucket.keys(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0)), 
                Seq#Drop(BucketsLib.Bucket.msgs(topb#0_0_0), DynamicPkv.SingleMergeResult.end(tmp#0))), 
              PackedKV.__default.I(leftover_top#0_0_0));
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1164,9)
            assert results#0 != null;
            assert results#0 != null;
            assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(results#0);
            assume true;
            assert Seq#Equal(Seq#FromArray($Heap, results#0), Seq#Take(Seq#FromArray($Heap, results#0), i#0));
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1166,9)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1166,9)
            assume true;
            assert results#0 != null;
            assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
            assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
            res#0 := #DynamicPkv.MergeResult.MergeResult(leftover_top#0_0_0, 
              Seq#FromArray($Heap, results#0), 
              DynamicPkv.SingleMergeResult.slack(tmp#0));
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1166,64)"} true;
            return;
        }
        else
        {
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1168,9)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1168,9)
            assume true;
            assume PackedKV.__default.EmptyPkv#canCall();
            assume PackedKV.Pkv.Pkv_q(Lit(PackedKV.__default.EmptyPkv()));
            assert results#0 != null;
            assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
            assume PackedKV.__default.EmptyPkv#canCall()
               && (DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
                 || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0));
            res#0 := #DynamicPkv.MergeResult.MergeResult(Lit(PackedKV.__default.EmptyPkv()), 
              Seq#FromArray($Heap, results#0), 
              DynamicPkv.SingleMergeResult.slack(tmp#0));
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1168,66)"} true;
            return;
        }
    }
    else
    {
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1171,7)
        assume true;
        if (DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0))
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1172,18)
            assume true;
            newtype$check#1_0 := LitInt(0);
            assert LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < 18446744073709551616;
            if (i#0 == LitInt(0))
            {
                newtype$check#1_1 := LitInt(0);
                assert LitInt(0) <= newtype$check#1_1 && newtype$check#1_1 < 18446744073709551616;
            }
            else
            {
                newtype$check#1_2 := LitInt(1);
                assert LitInt(0) <= newtype$check#1_2 && newtype$check#1_2 < 18446744073709551616;
                newtype$check#1_3 := i#0 - 1;
                assert LitInt(0) <= newtype$check#1_3 && newtype$check#1_3 < 18446744073709551616;
                assert 0 <= i#0 - 1 && i#0 - 1 < Seq#Length(idxs#0);
            }

            assume true;
            from#1_0 := (if i#0 == LitInt(0) then 0 else $Unbox(Seq#Index(idxs#0, i#0 - 1)): int);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1172,51)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1173,17)
            assume true;
            newtype$check#1_4 := Seq#Length(idxs#0);
            assert LitInt(0) <= newtype$check#1_4 && newtype$check#1_4 < 18446744073709551616;
            if (i#0 == Seq#Length(idxs#0))
            {
                ##pkv#1_0 := top#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#1_0, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#1_0)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#1_0))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#1_0)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#1_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#1_0))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#1_0)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#1_0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#1_0: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), i#1_0)): Seq Box } 
                              LitInt(0) <= i#1_0
                                   && i#1_0 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#1_0)), i#1_0)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
                         || (forall i#1_1: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)), i#1_1)): Seq Box } 
                          LitInt(0) <= i#1_1
                               && i#1_1
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#1_0)), i#1_1)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#1_0)
                   ==> PackedKV.__default.WF(##pkv#1_0)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#1_0)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.WF(##pkv#1_0);
                assume PackedKV.__default.NumKVPairs#canCall(top#0);
            }
            else
            {
                assert 0 <= i#0 && i#0 < Seq#Length(idxs#0);
            }

            assume i#0 == Seq#Length(idxs#0) ==> PackedKV.__default.NumKVPairs#canCall(top#0);
            to1#1_0 := (if i#0 == Seq#Length(idxs#0)
               then PackedKV.__default.NumKVPairs(top#0)
               else $Unbox(Seq#Index(idxs#0, i#0)): int);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1173,81)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1174,16)
            assume true;
            if (to1#1_0 < from#1_0)
            {
            }
            else
            {
            }

            assume true;
            to#1_0 := (if to1#1_0 < from#1_0 then from#1_0 else to1#1_0);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1174,50)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1176,26)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            bots##1_0 := bots#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##1_0 := i#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$DynamicPkv.__default.WeightIthBucketLe(bots##1_0, i##1_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1176,34)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1178,36)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type SingleMergeResult
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            top##1_0 := top#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            from0##1_0 := from#1_0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            to##1_0 := to#1_0;
            assert 0 <= i#0 && i#0 < Seq#Length(bots#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            bot##1_0 := $Unbox(Seq#Index(bots#0, i#0)): DatatypeType;
            assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
            assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
            // ProcessCallStmt: CheckSubrange
            slack0##1_0 := DynamicPkv.SingleMergeResult.slack(tmp#0);
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call $rhs##1_0 := Call$$DynamicPkv.__default.MergeToOneChild(top##1_0, from0##1_0, to##1_0, bot##1_0, slack0##1_0);
            // TrCallStmt: After ProcessCallStmt
            tmp'#1_0 := $rhs##1_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1178,70)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1179,20)
            assert results#0 != null;
            assert 0 <= i#0 && i#0 < _System.array.Length(results#0);
            assume true;
            assert $_Frame[results#0, IndexField(i#0)];
            assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp'#1_0)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp'#1_0);
            assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp'#1_0)
               || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp'#1_0);
            $rhs#1_0 := DynamicPkv.SingleMergeResult.bot(tmp'#1_0);
            $Heap := update($Heap, results#0, IndexField(i#0), $Box($rhs#1_0));
            assume $IsGoodHeap($Heap);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1179,30)"} true;
            // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1181,9)
            // Assume Fuel Constant
            if (*)
            {
                // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1181,9)
                assert results#0 != null;
                assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(results#0);
                ##s#1_0_0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_0_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#1_0_0: int :: 
                  { $Unbox(Seq#Index(##s#1_0_0, i#1_0_0)): DatatypeType } 
                  LitInt(0) <= i#1_0_0 && i#1_0_0 < Seq#Length(##s#1_0_0)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_0_0, i#1_0_0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0));
                ##buckets#1_0_0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#1_0_0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)));
                assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(bots#0);
                ##s#1_0_1 := Seq#Drop(bots#0, i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_0_1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#1_0_1: int :: 
                  { $Unbox(Seq#Index(##s#1_0_1, i#1_0_1)): DatatypeType } 
                  LitInt(0) <= i#1_0_1 && i#1_0_1 < Seq#Length(##s#1_0_1)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_0_1, i#1_0_1)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0));
                ##buckets#1_0_1 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#1_0_1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
                assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
                   || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
                   && 
                  DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)))
                   && (DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
                     || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0));
                assume false;
            }
            else if (*)
            {
                // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1181,9)
                assume results#0 != null;
                assume {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(results#0);
                ##s#1_0_0_0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_0_0_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assume {:subsumption 0} (forall i#1_0_0_0: int :: 
                  { $Unbox(Seq#Index(##s#1_0_0_0, i#1_0_0_0)): DatatypeType } 
                  LitInt(0) <= i#1_0_0_0 && i#1_0_0_0 < Seq#Length(##s#1_0_0_0)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_0_0_0, i#1_0_0_0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0));
                ##buckets#1_0_0_0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#1_0_0_0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)));
                assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(bots#0);
                ##s#1_0_0_1 := Seq#Drop(bots#0, i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_0_0_1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assume {:subsumption 0} (forall i#1_0_0_1: int :: 
                  { $Unbox(Seq#Index(##s#1_0_0_1, i#1_0_0_1)): DatatypeType } 
                  LitInt(0) <= i#1_0_0_1 && i#1_0_0_1 < Seq#Length(##s#1_0_0_1)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_0_0_1, i#1_0_0_1)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0));
                ##buckets#1_0_0_1 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#1_0_0_1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
                assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
                   || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0);
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
                   && 
                  DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)))
                   && (DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp#0)
                     || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp#0));
                // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1181,9)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1186,34)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                pkvs##1_0_0_0 := bots#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##1_0_0_0 := i#0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$DynamicPkv.__default.WeightPKVListPopFront(pkvs##1_0_0_0, i##1_0_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1186,49)"} true;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1187,35)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                pkvs##1_0_0_1 := results#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##1_0_0_1 := i#0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$DynamicPkv.__default.WeightPKVArrayPushBack(pkvs##1_0_0_1, i##1_0_0_1);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1187,53)"} true;
                // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1181,9)
                assert results#0 != null;
                newtype$check#1_0_0_0 := LitInt(1);
                assert LitInt(0) <= newtype$check#1_0_0_0
                   && newtype$check#1_0_0_0 < 18446744073709551616;
                newtype$check#1_0_0_1 := i#0 + 1;
                assert LitInt(0) <= newtype$check#1_0_0_1
                   && newtype$check#1_0_0_1 < 18446744073709551616;
                assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(results#0);
                ##s#1_0_0_2 := Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_0_0_2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#1_0_0_2: int :: 
                  { $Unbox(Seq#Index(##s#1_0_0_2, i#1_0_0_2)): DatatypeType } 
                  LitInt(0) <= i#1_0_0_2 && i#1_0_0_2 < Seq#Length(##s#1_0_0_2)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_0_0_2, i#1_0_0_2)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                ##buckets#1_0_0_2 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#1_0_0_2, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)));
                newtype$check#1_0_0_2 := LitInt(1);
                assert LitInt(0) <= newtype$check#1_0_0_2
                   && newtype$check#1_0_0_2 < 18446744073709551616;
                newtype$check#1_0_0_3 := i#0 + 1;
                assert LitInt(0) <= newtype$check#1_0_0_3
                   && newtype$check#1_0_0_3 < 18446744073709551616;
                assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(bots#0);
                ##s#1_0_0_3 := Seq#Drop(bots#0, i#0 + 1);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_0_0_3, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#1_0_0_3: int :: 
                  { $Unbox(Seq#Index(##s#1_0_0_3, i#1_0_0_3)): DatatypeType } 
                  LitInt(0) <= i#1_0_0_3 && i#1_0_0_3 < Seq#Length(##s#1_0_0_3)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_0_0_3, i#1_0_0_3)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0 + 1));
                ##buckets#1_0_0_3 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0 + 1));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#1_0_0_3, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0 + 1)));
                assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp'#1_0)
                   || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp'#1_0);
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)))
                   && 
                  DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0 + 1))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0 + 1)))
                   && (DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp'#1_0)
                     || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp'#1_0));
                // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1181,9)
                assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
                     + BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(bots#0, i#0)))
                     + DynamicPkv.SingleMergeResult.slack(tmp#0)
                   == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)))
                     + BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(bots#0, i#0 + 1)))
                     + DynamicPkv.SingleMergeResult.slack(tmp'#1_0);
                assume false;
            }

            assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
                 + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)))
                 + DynamicPkv.SingleMergeResult.slack(tmp#0)
               == BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)))
                 + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0 + 1)))
                 + DynamicPkv.SingleMergeResult.slack(tmp'#1_0);
            // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1194,9)
            // Assume Fuel Constant
            if (*)
            {
                // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1194,9)
                assert results#0 != null;
                newtype$check#1_1_0 := LitInt(1);
                assert LitInt(0) <= newtype$check#1_1_0 && newtype$check#1_1_0 < 18446744073709551616;
                newtype$check#1_1_1 := i#0 + 1;
                assert LitInt(0) <= newtype$check#1_1_1 && newtype$check#1_1_1 < 18446744073709551616;
                assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(results#0);
                ##s#1_1_0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_1_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#1_1_0: int :: 
                  { $Unbox(Seq#Index(##s#1_1_0, i#1_1_0)): DatatypeType } 
                  LitInt(0) <= i#1_1_0 && i#1_1_0 < Seq#Length(##s#1_1_0)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_1_0, i#1_1_0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                assume false;
            }
            else if (*)
            {
                // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1194,9)
                assume results#0 != null;
                newtype$check#1_1_0_0 := LitInt(1);
                assume LitInt(0) <= newtype$check#1_1_0_0
                   && newtype$check#1_1_0_0 < 18446744073709551616;
                newtype$check#1_1_0_1 := i#0 + 1;
                assume LitInt(0) <= newtype$check#1_1_0_1
                   && newtype$check#1_1_0_1 < 18446744073709551616;
                assume {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(results#0);
                ##s#1_1_0_0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_1_0_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assume {:subsumption 0} (forall i#1_1_0_0: int :: 
                  { $Unbox(Seq#Index(##s#1_1_0_0, i#1_1_0_0)): DatatypeType } 
                  LitInt(0) <= i#1_1_0_0 && i#1_1_0_0 < Seq#Length(##s#1_1_0_0)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_1_0_0, i#1_1_0_0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1194,9)
                // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1194,9)
                assert results#0 != null;
                assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(results#0);
                ##s#1_1_0_1 := Seq#Take(Seq#FromArray(old($Heap), results#0), i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1_1_0_1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#1_1_0_1: int :: 
                  { $Unbox(Seq#Index(##s#1_1_0_1, i#1_1_0_1)): DatatypeType } 
                  LitInt(0) <= i#1_1_0_1 && i#1_1_0_1 < Seq#Length(##s#1_1_0_1)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1_1_0_1, i#1_1_0_1)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray(old($Heap), results#0), i#0));
                assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp'#1_0)
                   || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp'#1_0);
                assume PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(tmp'#1_0));
                ##psa#1_1_0_0 := PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#1_1_0_0, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_0)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_0)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1_0_0)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_0)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_0)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#1_1_0_0)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_0)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_0)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1_0_0)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_1_0_0)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_0)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_0)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1_0_0))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_1_0_0))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_1_0_0), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1_0_0)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_0)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_0)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#1_1_0_0));
                assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(##psa#1_1_0_0), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(##psa#1_1_0_0), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#1_1_0_2: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#1_1_0_0), i#1_1_0_2)): Seq Box } 
                      LitInt(0) <= i#1_1_0_2
                           && i#1_1_0_2 < Seq#Length(PackedStringArray.__default.I(##psa#1_1_0_0))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#1_1_0_0), i#1_1_0_2)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()));
                assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0)));
                assume DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp'#1_0)
                   || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp'#1_0);
                assume PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(tmp'#1_0));
                ##psa#1_1_0_1 := PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#1_1_0_1, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_1)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_1)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1_0_1)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_1)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_1)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#1_1_0_1)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_1)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_1)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1_0_1)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_1_0_1)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_1)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_1)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1_0_1))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_1_0_1))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_1_0_1), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1_0_1)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1_0_1)
                   ==> PackedStringArray.__default.WF(##psa#1_1_0_1)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#1_1_0_1));
                assume PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0)));
                ##keys#1_1_0_0 := PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0)));
                // assume allocatedness for argument to function
                assume $IsAlloc(##keys#1_1_0_0, TSeq(Tclass.KeyType.Key()), $Heap);
                ##msgs#1_1_0_0 := PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0)));
                // assume allocatedness for argument to function
                assume $IsAlloc(##msgs#1_1_0_0, TSeq(Tclass.ValueMessage.Message()), $Heap);
                assert {:subsumption 0} Seq#Length(##keys#1_1_0_0) == Seq#Length(##msgs#1_1_0_0);
                assume BucketsLib.__default.BucketOfSeq#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))), 
                  PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))));
                assume BucketsLib.Bucket.BucketMapWithSeq_q(BucketsLib.__default.BucketOfSeq(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))), 
                    PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0)))));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))
                   && 
                  (DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp'#1_0)
                     || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp'#1_0))
                   && PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))
                   && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0)))
                   && 
                  (DynamicPkv.SingleMergeResult.MergeCompleted_q(tmp'#1_0)
                     || DynamicPkv.SingleMergeResult.SlackExhausted_q(tmp'#1_0))
                   && PackedKV.Pkv.Pkv_q(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))
                   && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0)))
                   && BucketsLib.__default.BucketOfSeq#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))), 
                    PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))));
                // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1194,9)
                assert {:subsumption 0} Seq#Equal(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)), 
                  Seq#Append(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0)), 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      $Box(BucketsLib.__default.BucketOfSeq(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))), 
                          PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))))))));
                assume false;
            }

            assume Seq#Equal(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)), 
              Seq#Append(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(BucketsLib.__default.BucketOfSeq(PackedKV.__default.IKeys(PackedKV.Pkv.keys(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))), 
                      PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.SingleMergeResult.bot(tmp'#1_0))))))));
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1199,35)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type MergeResult
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            top##1_1 := top#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            bots##1_1 := bots#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            idxs##1_0 := idxs#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            tmp##1_0 := tmp'#1_0;
            newtype$check#1_5 := LitInt(1);
            assert LitInt(0) <= newtype$check#1_5 && newtype$check#1_5 < 18446744073709551616;
            newtype$check#1_6 := i#0 + 1;
            assert LitInt(0) <= newtype$check#1_6 && newtype$check#1_6 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##1_1 := i#0 + 1;
            assume true;
            // ProcessCallStmt: CheckSubrange
            results##1_0 := results#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null && read($Heap, $o, alloc) && $o == results##1_0 ==> $_Frame[$o, $f]);
            assert 0 <= Seq#Length(bots#0) - i#0
               || Seq#Length(bots##1_1) - i##1_1 == Seq#Length(bots#0) - i#0;
            assert Seq#Length(bots##1_1) - i##1_1 < Seq#Length(bots#0) - i#0;
            // ProcessCallStmt: Make the call
            call $rhs##1_1 := Call$$DynamicPkv.__default.MergeToChildrenIter(top##1_1, bots##1_1, idxs##1_0, tmp##1_0, i##1_1, results##1_0);
            // TrCallStmt: After ProcessCallStmt
            res#0 := $rhs##1_1;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1199,71)"} true;
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1200,9)
            return;
        }
        else
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1202,20)
            assert results#0 != null;
            assert 0 <= i#0 && i#0 < _System.array.Length(results#0);
            assume true;
            assert $_Frame[results#0, IndexField(i#0)];
            assert 0 <= i#0 && i#0 < Seq#Length(bots#0);
            assume true;
            $rhs#0 := $Unbox(Seq#Index(bots#0, i#0)): DatatypeType;
            $Heap := update($Heap, results#0, IndexField(i#0), $Box($rhs#0));
            assume $IsGoodHeap($Heap);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1202,29)"} true;
            // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1204,9)
            // Assume Fuel Constant
            if (*)
            {
                // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1204,9)
                assert results#0 != null;
                assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(results#0);
                ##s#2_0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#2_0: int :: 
                  { $Unbox(Seq#Index(##s#2_0, i#2_0)): DatatypeType } 
                  LitInt(0) <= i#2_0 && i#2_0 < Seq#Length(##s#2_0)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2_0, i#2_0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0));
                ##buckets#2_0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#2_0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)));
                assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(bots#0);
                ##s#2_1 := Seq#Drop(bots#0, i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#2_1: int :: 
                  { $Unbox(Seq#Index(##s#2_1, i#2_1)): DatatypeType } 
                  LitInt(0) <= i#2_1 && i#2_1 < Seq#Length(##s#2_1)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2_1, i#2_1)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0));
                ##buckets#2_1 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#2_1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
                   && 
                  DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
                assume false;
            }
            else if (*)
            {
                // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1204,9)
                assume results#0 != null;
                assume {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(results#0);
                ##s#2_0_0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_0_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assume {:subsumption 0} (forall i#2_0_0: int :: 
                  { $Unbox(Seq#Index(##s#2_0_0, i#2_0_0)): DatatypeType } 
                  LitInt(0) <= i#2_0_0 && i#2_0_0 < Seq#Length(##s#2_0_0)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2_0_0, i#2_0_0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0));
                ##buckets#2_0_0 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#2_0_0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)));
                assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(bots#0);
                ##s#2_0_1 := Seq#Drop(bots#0, i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_0_1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assume {:subsumption 0} (forall i#2_0_1: int :: 
                  { $Unbox(Seq#Index(##s#2_0_1, i#2_0_1)): DatatypeType } 
                  LitInt(0) <= i#2_0_1 && i#2_0_1 < Seq#Length(##s#2_0_1)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2_0_1, i#2_0_1)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0));
                ##buckets#2_0_1 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#2_0_1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
                   && 
                  DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)));
                // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1204,9)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1208,34)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                pkvs##2_0_0 := bots#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##2_0_0 := i#0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$DynamicPkv.__default.WeightPKVListPopFront(pkvs##2_0_0, i##2_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1208,49)"} true;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1209,35)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                pkvs##2_0_1 := results#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##2_0_1 := i#0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$DynamicPkv.__default.WeightPKVArrayPushBack(pkvs##2_0_1, i##2_0_1);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1209,53)"} true;
                // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1204,9)
                assert results#0 != null;
                newtype$check#2_0_0 := LitInt(1);
                assert LitInt(0) <= newtype$check#2_0_0 && newtype$check#2_0_0 < 18446744073709551616;
                newtype$check#2_0_1 := i#0 + 1;
                assert LitInt(0) <= newtype$check#2_0_1 && newtype$check#2_0_1 < 18446744073709551616;
                assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(results#0);
                ##s#2_0_2 := Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_0_2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#2_0_2: int :: 
                  { $Unbox(Seq#Index(##s#2_0_2, i#2_0_2)): DatatypeType } 
                  LitInt(0) <= i#2_0_2 && i#2_0_2 < Seq#Length(##s#2_0_2)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2_0_2, i#2_0_2)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                ##buckets#2_0_2 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#2_0_2, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)));
                newtype$check#2_0_2 := LitInt(1);
                assert LitInt(0) <= newtype$check#2_0_2 && newtype$check#2_0_2 < 18446744073709551616;
                newtype$check#2_0_3 := i#0 + 1;
                assert LitInt(0) <= newtype$check#2_0_3 && newtype$check#2_0_3 < 18446744073709551616;
                assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(bots#0);
                ##s#2_0_3 := Seq#Drop(bots#0, i#0 + 1);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_0_3, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#2_0_3: int :: 
                  { $Unbox(Seq#Index(##s#2_0_3, i#2_0_3)): DatatypeType } 
                  LitInt(0) <= i#2_0_3 && i#2_0_3 < Seq#Length(##s#2_0_3)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2_0_3, i#2_0_3)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0 + 1));
                ##buckets#2_0_3 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0 + 1));
                // assume allocatedness for argument to function
                assume $IsAlloc(##buckets#2_0_3, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
                assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0 + 1)));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)))
                   && 
                  DynamicPkv.__default.PKVISeq#canCall(Seq#Drop(bots#0, i#0 + 1))
                   && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0 + 1)));
                // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1204,9)
                assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
                     + BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(bots#0, i#0)))
                   == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)))
                     + BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Drop(bots#0, i#0 + 1)));
                assume false;
            }

            assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0)))
                 + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0)))
               == BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)))
                 + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Drop(bots#0, i#0 + 1)));
            // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1215,9)
            // Assume Fuel Constant
            if (*)
            {
                // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1215,9)
                assert results#0 != null;
                newtype$check#3_0 := LitInt(1);
                assert LitInt(0) <= newtype$check#3_0 && newtype$check#3_0 < 18446744073709551616;
                newtype$check#3_1 := i#0 + 1;
                assert LitInt(0) <= newtype$check#3_1 && newtype$check#3_1 < 18446744073709551616;
                assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(results#0);
                ##s#3_0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#3_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#3_0: int :: 
                  { $Unbox(Seq#Index(##s#3_0, i#3_0)): DatatypeType } 
                  LitInt(0) <= i#3_0 && i#3_0 < Seq#Length(##s#3_0)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#3_0, i#3_0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                assume false;
            }
            else if (*)
            {
                // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1215,9)
                assume results#0 != null;
                newtype$check#3_0_0 := LitInt(1);
                assume LitInt(0) <= newtype$check#3_0_0 && newtype$check#3_0_0 < 18446744073709551616;
                newtype$check#3_0_1 := i#0 + 1;
                assume LitInt(0) <= newtype$check#3_0_1 && newtype$check#3_0_1 < 18446744073709551616;
                assume {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= _System.array.Length(results#0);
                ##s#3_0_0 := Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#3_0_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assume {:subsumption 0} (forall i#3_0_0: int :: 
                  { $Unbox(Seq#Index(##s#3_0_0, i#3_0_0)): DatatypeType } 
                  LitInt(0) <= i#3_0_0 && i#3_0_0 < Seq#Length(##s#3_0_0)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#3_0_0, i#3_0_0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1));
                // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1215,9)
                // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1215,9)
                assert results#0 != null;
                assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(results#0);
                ##s#3_0_1 := Seq#Take(Seq#FromArray(old($Heap), results#0), i#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#3_0_1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
                assert {:subsumption 0} (forall i#3_0_1: int :: 
                  { $Unbox(Seq#Index(##s#3_0_1, i#3_0_1)): DatatypeType } 
                  LitInt(0) <= i#3_0_1 && i#3_0_1 < Seq#Length(##s#3_0_1)
                     ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#3_0_1, i#3_0_1)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray(old($Heap), results#0), i#0));
                assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(bots#0);
                ##pkv#3_0_0 := $Unbox(Seq#Index(bots#0, i#0)): DatatypeType;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#3_0_0, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3_0_0))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3_0_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3_0_0))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3_0_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3_0_0))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3_0_0)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3_0_0)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3_0_0))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3_0_0)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3_0_0)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3_0_0)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3_0_0))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3_0_0))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3_0_0))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3_0_0))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3_0_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3_0_0))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3_0_0)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3_0_0))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3_0_0)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3_0_0)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3_0_0))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3_0_0)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3_0_0)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3_0_0)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3_0_0)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3_0_0))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3_0_0))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3_0_0))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3_0_0)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3_0_0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3_0_0)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3_0_0)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3_0_0)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3_0_0)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#3_0_2: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3_0_0)), i#3_0_2)): Seq Box } 
                              LitInt(0) <= i#3_0_2
                                   && i#3_0_2
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3_0_0)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3_0_0)), i#3_0_2)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3_0_0)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3_0_0)))
                         || (forall i#3_0_3: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3_0_0)), i#3_0_3)): Seq Box } 
                          LitInt(0) <= i#3_0_3
                               && i#3_0_3
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3_0_0)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3_0_0)), i#3_0_3)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3_0_0)
                   ==> PackedKV.__default.WF(##pkv#3_0_0)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3_0_0)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.I#canCall($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
                assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#0)): DatatypeType));
                assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray(old($Heap), results#0), i#0))
                   && PackedKV.__default.I#canCall($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
                // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1215,9)
                assert {:subsumption 0} Seq#Equal(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)), 
                  Seq#Append(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0)), 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      $Box(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)))));
                assume false;
            }

            assume Seq#Equal(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, results#0), i#0 + 1)), 
              Seq#Append(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray(old($Heap), results#0), i#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)))));
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1220,35)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type MergeResult
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            top##0 := top#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            bots##0 := bots#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            idxs##0 := idxs#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            tmp##0 := tmp#0;
            newtype$check#2 := LitInt(1);
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
            newtype$check#3 := i#0 + 1;
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##0 := i#0 + 1;
            assume true;
            // ProcessCallStmt: CheckSubrange
            results##0 := results#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null && read($Heap, $o, alloc) && $o == results##0 ==> $_Frame[$o, $f]);
            assert 0 <= Seq#Length(bots#0) - i#0
               || Seq#Length(bots##0) - i##0 == Seq#Length(bots#0) - i#0;
            assert Seq#Length(bots##0) - i##0 < Seq#Length(bots#0) - i#0;
            // ProcessCallStmt: Make the call
            call $rhs##0 := Call$$DynamicPkv.__default.MergeToChildrenIter(top##0, bots##0, idxs##0, tmp##0, i##0, results##0);
            // TrCallStmt: After ProcessCallStmt
            res#0 := $rhs##0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1220,70)"} true;
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1221,9)
            return;
        }
    }
}



procedure CheckWellformed$$DynamicPkv.__default.computePivotIndexes(keys#0: DatatypeType
       where $Is(keys#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(keys#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(keys#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap))
   returns (pivotIdxs#0: Seq Box
       where $Is(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  free requires 46 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.computePivotIndexes(keys#0: DatatypeType, pivots#0: Seq Box) returns (pivotIdxs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var i#0: int;
  var newtype$check#0: int;
  var ##psa#2: DatatypeType;
  var ##s#0: Seq Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: computePivotIndexes, CheckWellformed$$DynamicPkv.__default.computePivotIndexes
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1226,9): initial state"} true;
    ##psa#0 := keys#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(keys#0);
    assume PackedStringArray.__default.WF(keys#0);
    ##psa#1 := keys#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(keys#0);
    assume NativeTypes.__default.Uint64UpperBound#canCall();
    assume Seq#Length(PackedStringArray.__default.I(keys#0))
       < NativeTypes.__default.Uint64UpperBound();
    assume NativeTypes.__default.Uint64UpperBound#canCall();
    assume Seq#Length(pivots#0) < NativeTypes.__default.Uint64UpperBound() - 1;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc pivotIdxs#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1231,24): post-state"} true;
    assume Seq#Length(pivotIdxs#0) == Seq#Length(pivots#0);
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(pivots#0);
        assert 0 <= i#0 && i#0 < Seq#Length(pivotIdxs#0);
        newtype$check#0 := $Unbox(Seq#Index(pivotIdxs#0, i#0)): int;
        assert LitInt(0) <= newtype$check#0;
        ##psa#2 := keys#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assume PackedStringArray.__default.I#canCall(keys#0);
        assert 0 <= i#0 && i#0 < Seq#Length(pivots#0);
        ##s#0 := PackedStringArray.__default.I(keys#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        ##key#0 := $Unbox(Seq#Index(pivots#0, i#0)): Seq Box;
        // assume allocatedness for argument to function
        assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, i#0)): Seq Box);
        assume $Unbox(Seq#Index(pivotIdxs#0, i#0)): int
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
            PackedStringArray.__default.I(keys#0), 
            $Unbox(Seq#Index(pivots#0, i#0)): Seq Box);
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(pivots#0)
           ==> $Unbox(Seq#Index(pivotIdxs#0, i#0)): int
             == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
              PackedStringArray.__default.I(keys#0), 
              $Unbox(Seq#Index(pivots#0, i#0)): Seq Box);
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
        { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
         ==> $Unbox(Seq#Index(pivotIdxs#0, i#1)): int
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
            PackedStringArray.__default.I(keys#0), 
            $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
}



procedure Call$$DynamicPkv.__default.computePivotIndexes(keys#0: DatatypeType
       where $Is(keys#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(keys#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(keys#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap))
   returns (pivotIdxs#0: Seq Box
       where $Is(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || Seq#Length(PackedStringArray.Psa.offsets(keys#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || Seq#Length(PackedStringArray.Psa.data(keys#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(keys#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(keys#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(keys#0))
         ==> Seq#Length(PackedStringArray.Psa.data(keys#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(keys#0), 
              Seq#Length(PackedStringArray.Psa.offsets(keys#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(keys#0));
  requires Seq#Length(PackedStringArray.__default.I(keys#0))
     < NativeTypes.__default.Uint64UpperBound();
  requires Seq#Length(pivots#0) < NativeTypes.__default.Uint64UpperBound() - 1;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Seq#Length(pivotIdxs#0) == Seq#Length(pivots#0);
  free ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
      { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
       ==> PackedStringArray.__default.I#canCall(keys#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
  free ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
      { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
       ==> $Unbox(Seq#Index(pivotIdxs#0, i#1)): int
         == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
          PackedStringArray.__default.I(keys#0), 
          $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.__default.computePivotIndexes(keys#0: DatatypeType
       where $Is(keys#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(keys#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(keys#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap))
   returns (pivotIdxs#0: Seq Box
       where $Is(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    $_reverifyPost: bool);
  free requires 46 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(keys#0)
     && 
    PackedStringArray.__default.WF(keys#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(keys#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(keys#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(keys#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(keys#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(keys#0))
       ==> Seq#Length(PackedStringArray.Psa.data(keys#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(keys#0), 
            Seq#Length(PackedStringArray.Psa.offsets(keys#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(keys#0));
  requires Seq#Length(PackedStringArray.__default.I(keys#0))
     < NativeTypes.__default.Uint64UpperBound();
  requires Seq#Length(pivots#0) < NativeTypes.__default.Uint64UpperBound() - 1;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Seq#Length(pivotIdxs#0) == Seq#Length(pivots#0);
  free ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
      { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
       ==> PackedStringArray.__default.I#canCall(keys#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
  ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
      { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
       ==> $Unbox(Seq#Index(pivotIdxs#0, i#1)): int
         == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
          PackedStringArray.__default.I(keys#0), 
          $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.__default.computePivotIndexes(keys#0: DatatypeType, pivots#0: Seq Box)
   returns (pivotIdxs#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var results#0: ref
     where $Is(results#0, Tclass._System.array?(Tclass.NativeTypes.uint64()))
       && $IsAlloc(results#0, Tclass._System.array?(Tclass.NativeTypes.uint64()), $Heap);
  var newtype$check#1: int;
  var $nw: ref;
  var i#2: int where LitInt(0) <= i#2 && i#2 < 18446744073709551616;
  var newtype$check#2: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var newtype$check#3: int;
  var j#0: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##psa#3: DatatypeType;
  var ##s#1: Seq Box;
  var ##key#1: Seq Box;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var $decr$loop#00: int;
  var $obj0: ref;
  var $index0: Field Box;
  var $rhs##0_0: int where LitInt(0) <= $rhs##0_0 && $rhs##0_0 < 18446744073709551616;
  var psa##0_0: DatatypeType;
  var key##0_0: Seq Box;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;

    // AddMethodImpl: computePivotIndexes, Impl$$DynamicPkv.__default.computePivotIndexes
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1234,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1235,17)
    assume true;
    newtype$check#1 := Seq#Length(pivots#0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assert 0 <= Seq#Length(pivots#0);
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.uint64());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == Seq#Length(pivots#0);
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    results#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1235,49)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1236,20)
    assume true;
    newtype$check#2 := LitInt(0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    i#2 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1236,23)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1237,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(pivots#0) - i#2;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#2 <= Seq#Length(pivots#0);
      free invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
            { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616
             ==> 
            LitInt(0) <= j#1 && j#1 < i#2
             ==> PackedStringArray.__default.I#canCall(keys#0)
               && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
      invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
            { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#2
             ==> $Unbox(read($Heap, results#0, IndexField(j#1))): int
               == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
                PackedStringArray.__default.I(keys#0), 
                $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
      free invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
            { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#2
             ==> $Unbox(read($Heap, results#0, IndexField(j#1))): int
               == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
                PackedStringArray.__default.I(keys#0), 
                $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(pivots#0) - i#2 <= $decr_init$loop#00
         && (Seq#Length(pivots#0) - i#2 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1237,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            newtype$check#3 := Seq#Length(pivots#0);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            assume true;
            assume i#2 <= Seq#Length(pivots#0);
            havoc j#0;
            assume LitInt(0) <= j#0 && j#0 < 18446744073709551616;
            // Begin Comprehension WF check
            newtype$check#4 := LitInt(0);
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            if (LitInt(0) <= j#0)
            {
            }

            if (LitInt(0) <= j#0 && j#0 < i#2)
            {
                assert results#0 != null;
                assert {:subsumption 0} 0 <= j#0 && j#0 < _System.array.Length(results#0);
                newtype$check#5 := $Unbox(read($Heap, results#0, IndexField(j#0))): int;
                assert LitInt(0) <= newtype$check#5;
                ##psa#3 := keys#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#3));
                assume PackedStringArray.__default.I#canCall(keys#0);
                assert {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(pivots#0);
                ##s#1 := PackedStringArray.__default.I(keys#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
                ##key#1 := $Unbox(Seq#Index(pivots#0, j#0)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##key#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, j#0)): Seq Box);
            }

            // End Comprehension WF check
            assume (forall j#1: int :: 
              { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
                { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
              LitInt(0) <= j#1 && j#1 < 18446744073709551616
                 ==> 
                LitInt(0) <= j#1 && j#1 < i#2
                 ==> PackedStringArray.__default.I#canCall(keys#0)
                   && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
            assume (forall j#1: int :: 
              { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
                { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
              LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#2
                 ==> $Unbox(read($Heap, results#0, IndexField(j#1))): int
                   == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
                    PackedStringArray.__default.I(keys#0), 
                    $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
            newtype$check#6 := Seq#Length(pivots#0);
            assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#7 := Seq#Length(pivots#0);
        assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
        assume true;
        if (Seq#Length(pivots#0) <= i#2)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(pivots#0) - i#2;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1242,55)
        assert results#0 != null;
        assert 0 <= i#2 && i#2 < _System.array.Length(results#0);
        assume true;
        $obj0 := results#0;
        $index0 := IndexField(i#2);
        assert $_Frame[$obj0, $index0];
        // TrCallStmt: Adding lhs Microsoft.Dafny.SeqSelectExpr with type uint64
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        psa##0_0 := keys#0;
        assert 0 <= i#2 && i#2 < Seq#Length(pivots#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##0_0 := $Unbox(Seq#Index(pivots#0, i#2)): Seq Box;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte(psa##0_0, key##0_0);
        // TrCallStmt: After ProcessCallStmt
        $Heap := update($Heap, $obj0, $index0, $Box($rhs##0_0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1242,71)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1243,9)
        assume true;
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#2 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume true;
        i#2 := i#2 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1243,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1237,5)
        assert 0 <= $decr$loop#00 || Seq#Length(pivots#0) - i#2 == $decr$loop#00;
        assert Seq#Length(pivots#0) - i#2 < $decr$loop#00;
        assume true;
        assume (forall j#1: int :: 
          { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
            { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616
             ==> 
            LitInt(0) <= j#1 && j#1 < i#2
             ==> PackedStringArray.__default.I#canCall(keys#0)
               && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1246,15)
    assume true;
    assert results#0 != null;
    assume true;
    pivotIdxs#0 := Seq#FromArray($Heap, results#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1246,28)"} true;
}



procedure CheckWellformed$$DynamicPkv.__default.MergeToChildren(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    slack#0: int where LitInt(0) <= slack#0 && slack#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.MergeResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.MergeResult(), $Heap));
  free requires 47 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.MergeToChildren(top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box, slack#0: int)
   returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var i#0: int;
  var ##pkv#1: DatatypeType;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var i#4: int;
  var ##psa#2: DatatypeType;
  var ##s#0: Seq Box;
  var ##buckets#0: Seq Box;
  var ##pkv#2: DatatypeType;
  var ##s#1: Seq Box;
  var ##top#0: DatatypeType;
  var ##pivots#0: Seq Box;
  var ##bots#0: Seq Box;
  var ##slack#0: int;

    // AddMethodImpl: MergeToChildren, CheckWellformed$$DynamicPkv.__default.MergeToChildren
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1249,9): initial state"} true;
    ##pkv#0 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(top#0);
    assume PackedKV.__default.WF(top#0);
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(bots#0);
        assert 0 <= i#0 && i#0 < Seq#Length(bots#0);
        ##pkv#1 := $Unbox(Seq#Index(bots#0, i#0)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(bots#0)
           ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType));
    assume PackedKV.Pkv.Pkv_q(top#0);
    ##psa#0 := PackedKV.Pkv.keys(top#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#0), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#0), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#2: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#2)): Seq Box } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(PackedStringArray.__default.I(##psa#0))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#2)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#0), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
    if (LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))))
    {
        assume PackedKV.Pkv.Pkv_q(top#0);
        ##psa#1 := PackedKV.Pkv.keys(top#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#1), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#1), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#1), i#3)): Seq Box } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(PackedStringArray.__default.I(##psa#1))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#1), i#3)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#1), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
    }

    assume LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)))
       && Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
    havoc i#4;
    if (*)
    {
        assume LitInt(0) <= i#4;
        assume i#4 < Seq#Length(bots#0);
        assert 0 <= i#4 && i#4 < Seq#Length(bots#0);
        assume PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(bots#0, i#4)): DatatypeType);
        ##psa#2 := PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#4)): DatatypeType);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#2), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#2), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#5: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#5)): Seq Box } 
              LitInt(0) <= i#5 && i#5 < Seq#Length(PackedStringArray.__default.I(##psa#2))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#5)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#2), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#4)): DatatypeType));
        assume Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#4)): DatatypeType)))
           < 268435456;
    }
    else
    {
        assume LitInt(0) <= i#4 && i#4 < Seq#Length(bots#0)
           ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#4)): DatatypeType)))
             < 268435456;
    }

    assume (forall i#6: int :: 
      { $Unbox(Seq#Index(bots#0, i#6)): DatatypeType } 
      LitInt(0) <= i#6 && i#6 < Seq#Length(bots#0)
         ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#6)): DatatypeType)))
           < 268435456);
    if (0 < Seq#Length(bots#0))
    {
    }

    if (0 < Seq#Length(bots#0) && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1)
    {
        assume NativeTypes.__default.Uint64UpperBound#canCall();
    }

    assume 0 < Seq#Length(bots#0)
       && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1
       && Seq#Length(pivots#0) + 1 < NativeTypes.__default.Uint64UpperBound();
    ##s#0 := bots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#7: int :: 
      { $Unbox(Seq#Index(##s#0, i#7)): DatatypeType } 
      LitInt(0) <= i#7 && i#7 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#7)): DatatypeType));
    assume (forall i#7: int :: 
      { $Unbox(Seq#Index(##s#0, i#7)): DatatypeType } 
      LitInt(0) <= i#7 && i#7 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#7)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
    ##buckets#0 := DynamicPkv.__default.PKVISeq($LS($LZ), bots#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
    assume Bounds.__default.MaxTotalBucketWeight#canCall();
    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
          DynamicPkv.__default.PKVISeq($LS($LZ), bots#0))
         + slack#0
       == LitInt(Bounds.__default.MaxTotalBucketWeight());
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1262,19): post-state"} true;
    assume DynamicPkv.MergeResult.WF#canCall(result#0);
    assume DynamicPkv.MergeResult.WF(result#0);
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#8: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                            i#8)): Seq Box } 
                      LitInt(0) <= i#8
                           && i#8
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                                i#8)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen())))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                 || (forall i#9: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))), 
                        i#9)): Seq Box } 
                  LitInt(0) <= i#9
                       && i#9
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))), 
                          i#9)): Seq Box))));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))), 
              $Box(ValueMessage.__default.IdentityMessage())));
    assert {:subsumption 0} DynamicPkv.MergeResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.MergeResult.WF(result#0))
         || (forall i#10: int :: 
          { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(result#0), i#10)): DatatypeType } 
          LitInt(0) <= i#10 && i#10 < Seq#Length(DynamicPkv.MergeResult.bots(result#0))
             ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(result#0), i#10)): DatatypeType));
    assume DynamicPkv.MergeResult.WF(result#0);
    assume DynamicPkv.MergeResult.I#canCall(result#0);
    assume BucketModel.mergeResult.mergeResult_q(Lit(DynamicPkv.MergeResult.I(result#0)));
    ##pkv#2 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#11: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#11)): Seq Box } 
                  LitInt(0) <= i#11
                       && i#11 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#11)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
             || (forall i#12: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#12)): Seq Box } 
              LitInt(0) <= i#12
                   && i#12 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#12)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#2);
    assume PackedKV.__default.I#canCall(top#0);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(top#0));
    ##s#1 := bots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#13: int :: 
      { $Unbox(Seq#Index(##s#1, i#13)): DatatypeType } 
      LitInt(0) <= i#13 && i#13 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#13)): DatatypeType));
    assume (forall i#13: int :: 
      { $Unbox(Seq#Index(##s#1, i#13)): DatatypeType } 
      LitInt(0) <= i#13 && i#13 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#13)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
    ##top#0 := PackedKV.__default.I(top#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##top#0, Tclass.BucketsLib.Bucket(), $Heap);
    ##pivots#0 := pivots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pivots#0, TSeq(Tclass.KeyType.Key()), $Heap);
    ##bots#0 := DynamicPkv.__default.PKVISeq($LS($LZ), bots#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bots#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assert $Is(slack#0, Tclass._System.nat());
    ##slack#0 := slack#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##slack#0, Tclass._System.nat(), $Heap);
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.PreWFBucket#canCall(##top#0)
           ==> BucketsLib.__default.PreWFBucket(##top#0)
             || Seq#Length(BucketsLib.Bucket.keys(##top#0))
               == Seq#Length(BucketsLib.Bucket.msgs(##top#0)));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.PreWFBucket#canCall(##top#0)
           ==> BucketsLib.__default.PreWFBucket(##top#0)
             || Map#Equal(BucketsLib.__default.BucketMapOfSeq(StartFuelAssert_BucketsLib._default.BucketMapOfSeq, 
                BucketsLib.Bucket.keys(##top#0), 
                BucketsLib.Bucket.msgs(##top#0)), 
              BucketsLib.Bucket.b(##top#0)));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.WFBucketMap#canCall(BucketsLib.Bucket.b(##top#0))
           ==> BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(##top#0))
             || (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(##top#0))[$Box(key#0)] } 
              $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage())));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.WFMessageSeq#canCall(BucketsLib.Bucket.msgs(##top#0))
           ==> BucketsLib.__default.WFMessageSeq(BucketsLib.Bucket.msgs(##top#0))
             || (forall i#14: int :: 
              { $Unbox(Seq#Index(BucketsLib.Bucket.msgs(##top#0), i#14)): DatatypeType } 
              LitInt(0) <= i#14 && i#14 < Seq#Length(BucketsLib.Bucket.msgs(##top#0))
                 ==> !ValueMessage.Message#Equal($Unbox(Seq#Index(BucketsLib.Bucket.msgs(##top#0), i#14)): DatatypeType, 
                  ValueMessage.__default.IdentityMessage())));
    assume BucketsLib.__default.WFBucket(##top#0);
    assert {:subsumption 0} (forall i#15: int :: 
      { $Unbox(Seq#Index(##bots#0, i#15)): DatatypeType } 
      LitInt(0) <= i#15 && i#15 < Seq#Length(##bots#0)
         ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(##bots#0, i#15)): DatatypeType));
    assume (forall i#15: int :: 
      { $Unbox(Seq#Index(##bots#0, i#15)): DatatypeType } 
      LitInt(0) <= i#15 && i#15 < Seq#Length(##bots#0)
         ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(##bots#0, i#15)): DatatypeType));
    assert {:subsumption 0} 0 < Seq#Length(##bots#0);
    assert {:subsumption 0} Seq#Length(##bots#0) == Seq#Length(##pivots#0) + 1;
    assume 0 < Seq#Length(##bots#0) && Seq#Length(##bots#0) == Seq#Length(##pivots#0) + 1;
    assume BucketModel.__default.mergeToChildren#canCall(PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
      slack#0);
    assume BucketModel.mergeResult.mergeResult_q(BucketModel.__default.mergeToChildren(StartFuel_BucketModel._default.mergeToChildren, 
        PackedKV.__default.I(top#0), 
        pivots#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
        slack#0));
    assume BucketModel.mergeResult#Equal(DynamicPkv.MergeResult.I(result#0), 
      BucketModel.__default.mergeToChildren(StartFuel_BucketModel._default.mergeToChildren, 
        PackedKV.__default.I(top#0), 
        pivots#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
        slack#0));
}



procedure Call$$DynamicPkv.__default.MergeToChildren(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    slack#0: int where LitInt(0) <= slack#0 && slack#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.MergeResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.MergeResult(), $Heap));
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#16: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), i#16)): Seq Box } 
                LitInt(0) <= i#16
                     && i#16 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), i#16)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
           || (forall i#17: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)), i#17)): Seq Box } 
            LitInt(0) <= i#17
                 && i#17 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)), i#17)): Seq Box)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType));
  requires LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
  requires Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
  requires (forall i#6: int :: 
    { $Unbox(Seq#Index(bots#0, i#6)): DatatypeType } 
    LitInt(0) <= i#6 && i#6 < Seq#Length(bots#0)
       ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#6)): DatatypeType)))
         < 268435456);
  requires 0 < Seq#Length(bots#0);
  requires Seq#Length(bots#0) == Seq#Length(pivots#0) + 1;
  requires Seq#Length(pivots#0) + 1 < NativeTypes.__default.Uint64UpperBound();
  requires BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0))
       + slack#0
     == LitInt(Bounds.__default.MaxTotalBucketWeight());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.MergeResult.WF#canCall(result#0);
  free ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     && 
    Lit(DynamicPkv.MergeResult.WF(result#0))
     && 
    PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
     && (forall i#20: int :: 
      { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(result#0), i#20)): DatatypeType } 
      LitInt(0) <= i#20 && i#20 < Seq#Length(DynamicPkv.MergeResult.bots(result#0))
         ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(result#0), i#20)): DatatypeType));
  free ensures $IsA#BucketModel.mergeResult(Lit(DynamicPkv.MergeResult.I(result#0)))
     && $IsA#BucketModel.mergeResult(BucketModel.__default.mergeToChildren(StartFuel_BucketModel._default.mergeToChildren, 
        PackedKV.__default.I(top#0), 
        pivots#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
        slack#0))
     && 
    DynamicPkv.MergeResult.I#canCall(result#0)
     && 
    PackedKV.__default.I#canCall(top#0)
     && DynamicPkv.__default.PKVISeq#canCall(bots#0)
     && BucketModel.__default.mergeToChildren#canCall(PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
      slack#0);
  ensures BucketModel.mergeResult#Equal(DynamicPkv.MergeResult.I(result#0), 
    BucketModel.__default.mergeToChildren(StartFuelAssert_BucketModel._default.mergeToChildren, 
      PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), 
      slack#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.__default.MergeToChildren(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap), 
    slack#0: int where LitInt(0) <= slack#0 && slack#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.MergeResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.MergeResult(), $Heap), 
    $_reverifyPost: bool);
  free requires 47 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(top#0)
     && 
    PackedKV.__default.WF(top#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType));
  requires LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
  requires Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
  requires (forall i#6: int :: 
    { $Unbox(Seq#Index(bots#0, i#6)): DatatypeType } 
    LitInt(0) <= i#6 && i#6 < Seq#Length(bots#0)
       ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#6)): DatatypeType)))
         < 268435456);
  requires 0 < Seq#Length(bots#0);
  requires Seq#Length(bots#0) == Seq#Length(pivots#0) + 1;
  requires Seq#Length(pivots#0) + 1 < NativeTypes.__default.Uint64UpperBound();
  requires BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0))
       + slack#0
     == LitInt(Bounds.__default.MaxTotalBucketWeight());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.MergeResult.WF#canCall(result#0);
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                 < 4294967296));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                 < 4294967296));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                   == LitInt(0))));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                         - 1)): int)));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                 < 4294967296));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                 < 4294967296));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                   == LitInt(0))));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                         - 1)): int)));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
             == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0)))));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
             ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
               || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                  LitInt(KeyType.__default.MaxLen()))
                 ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   || (forall i#23: int :: 
                    { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                          i#23)): Seq Box } 
                    LitInt(0) <= i#23
                         && i#23
                           < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))))
                       ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.MergeResult.top(result#0))), 
                              i#23)): Seq Box)
                         <= LitInt(KeyType.__default.MaxLen())))));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
             ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
               || (forall i#24: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))), 
                      i#24)): Seq Box } 
                LitInt(0) <= i#24
                     && i#24
                       < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))))
                   ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))), 
                        i#24)): Seq Box))));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.MergeResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.MergeResult.top(result#0))
           || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.MergeResult.top(result#0))), 
            $Box(ValueMessage.__default.IdentityMessage())));
  ensures DynamicPkv.MergeResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.MergeResult.WF(result#0))
       || (forall i#25: int :: 
        { $Unbox(Seq#Index(DynamicPkv.MergeResult.bots(result#0), i#25)): DatatypeType } 
        LitInt(0) <= i#25 && i#25 < Seq#Length(DynamicPkv.MergeResult.bots(result#0))
           ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.MergeResult.bots(result#0), i#25)): DatatypeType));
  free ensures $IsA#BucketModel.mergeResult(Lit(DynamicPkv.MergeResult.I(result#0)))
     && $IsA#BucketModel.mergeResult(BucketModel.__default.mergeToChildren(StartFuel_BucketModel._default.mergeToChildren, 
        PackedKV.__default.I(top#0), 
        pivots#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
        slack#0))
     && 
    DynamicPkv.MergeResult.I#canCall(result#0)
     && 
    PackedKV.__default.I#canCall(top#0)
     && DynamicPkv.__default.PKVISeq#canCall(bots#0)
     && BucketModel.__default.mergeToChildren#canCall(PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), 
      slack#0);
  ensures BucketModel.mergeResult#Equal(DynamicPkv.MergeResult.I(result#0), 
    BucketModel.__default.mergeToChildren(StartFuelAssert_BucketModel._default.mergeToChildren, 
      PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), 
      slack#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.__default.MergeToChildren(top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box, slack#0: int)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var idxs#0: Seq Box
     where $Is(idxs#0, TSeq(Tclass.NativeTypes.uint64()))
       && $IsAlloc(idxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.uint64()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
  var keys##0: DatatypeType;
  var pivots##0: Seq Box;
  var tmp#0: DatatypeType
     where $Is(tmp#0, Tclass.DynamicPkv.SingleMergeResult())
       && $IsAlloc(tmp#0, Tclass.DynamicPkv.SingleMergeResult(), $Heap);
  var ar#0: ref
     where $Is(ar#0, Tclass._System.array?(Tclass.PackedKV.Pkv()))
       && $IsAlloc(ar#0, Tclass._System.array?(Tclass.PackedKV.Pkv()), $Heap);
  var newtype$check#0: int;
  var $nw: ref;
  var ##s#2: Seq Box;
  var ##buckets#1: Seq Box;
  var ##pkv#3: DatatypeType;
  var ##top_keys#0: Seq Box;
  var ##pivots#1: Seq Box;
  var ##s#3: Seq Box;
  var $rhs##1: DatatypeType
     where $Is($rhs##1, Tclass.DynamicPkv.MergeResult())
       && $IsAlloc($rhs##1, Tclass.DynamicPkv.MergeResult(), $Heap);
  var top##0: DatatypeType;
  var bots##0: Seq Box;
  var idxs##0: Seq Box;
  var tmp##0: DatatypeType;
  var i##0: int;
  var newtype$check#1: int;
  var results##0: ref;

    // AddMethodImpl: MergeToChildren, Impl$$DynamicPkv.__default.MergeToChildren
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1265,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1266,39)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$BucketModel.__default.reveal__mergeToChildren();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1266,40)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1268,36)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type seq<uint64>
    // TrCallStmt: Before ProcessCallStmt
    assume PackedKV.Pkv.Pkv_q(top#0);
    assume PackedKV.Pkv.Pkv_q(top#0);
    // ProcessCallStmt: CheckSubrange
    keys##0 := PackedKV.Pkv.keys(top#0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    pivots##0 := pivots#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$DynamicPkv.__default.computePivotIndexes(keys##0, pivots##0);
    // TrCallStmt: After ProcessCallStmt
    idxs#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1268,53)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1269,13)
    assume true;
    assume PackedKV.__default.EmptyPkv#canCall();
    assume PackedKV.Pkv.Pkv_q(Lit(PackedKV.__default.EmptyPkv()));
    assume PackedKV.__default.EmptyPkv#canCall();
    tmp#0 := #DynamicPkv.SingleMergeResult.MergeCompleted(Lit(PackedKV.__default.EmptyPkv()), slack#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1269,52)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1270,12)
    assume true;
    newtype$check#0 := Seq#Length(bots#0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assert 0 <= Seq#Length(bots#0);
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.PackedKV.Pkv());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == Seq#Length(bots#0);
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    ar#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1270,43)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1272,5)
    assert ar#0 != null;
    assert {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= _System.array.Length(ar#0);
    ##s#2 := Seq#Take(Seq#FromArray($Heap, ar#0), LitInt(0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#26: int :: 
      { $Unbox(Seq#Index(##s#2, i#26)): DatatypeType } 
      LitInt(0) <= i#26 && i#26 < Seq#Length(##s#2)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2, i#26)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, ar#0), LitInt(0)));
    ##buckets#1 := DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, ar#0), LitInt(0)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, ar#0), LitInt(0))));
    assume DynamicPkv.__default.PKVISeq#canCall(Seq#Take(Seq#FromArray($Heap, ar#0), LitInt(0)))
       && BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), Seq#Take(Seq#FromArray($Heap, ar#0), LitInt(0))));
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1272,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1272,80)
        // TrCallStmt: Before ProcessCallStmt
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$BucketWeights.__default.reveal__WeightBucketList();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1272,81)"} true;
        assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
            DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, ar#0), LitInt(0))))
           == LitInt(0);
        assume false;
    }

    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, ar#0), LitInt(0))))
       == LitInt(0);
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1273,5)
    assert {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= Seq#Length(bots#0);
    assume true;
    assert Seq#Equal(Seq#Drop(bots#0, LitInt(0)), bots#0);
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1274,5)
    ##pkv#3 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#3, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#3)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#3))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#3))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#3)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#3)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#27: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#27)): Seq Box } 
                  LitInt(0) <= i#27
                       && i#27 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#3)), i#27)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
             || (forall i#28: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#28)): Seq Box } 
              LitInt(0) <= i#28
                   && i#28 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#3)), i#28)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#3)
       ==> PackedKV.__default.WF(##pkv#3)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#3)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.I#canCall(top#0);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(top#0));
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(top#0));
    ##top_keys#0 := BucketsLib.Bucket.keys(PackedKV.__default.I(top#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##top_keys#0, TSeq(Tclass.KeyType.Key()), $Heap);
    ##pivots#1 := pivots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pivots#1, TSeq(Tclass.KeyType.Key()), $Heap);
    assume BucketModel.__default.pivotIndexes#canCall(BucketsLib.Bucket.keys(PackedKV.__default.I(top#0)), pivots#0);
    ##s#3 := idxs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#3, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    assume DynamicPkv.__default.seqInt#canCall(idxs#0);
    assume PackedKV.__default.I#canCall(top#0)
       && BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(top#0))
       && BucketModel.__default.pivotIndexes#canCall(BucketsLib.Bucket.keys(PackedKV.__default.I(top#0)), pivots#0)
       && DynamicPkv.__default.seqInt#canCall(idxs#0);
    assert {:subsumption 0} Seq#Equal(BucketModel.__default.pivotIndexes($LS($LS($LZ)), BucketsLib.Bucket.keys(PackedKV.__default.I(top#0)), pivots#0), 
      DynamicPkv.__default.seqInt($LS($LS($LZ)), idxs#0));
    assume Seq#Equal(BucketModel.__default.pivotIndexes($LS($LS($LZ)), BucketsLib.Bucket.keys(PackedKV.__default.I(top#0)), pivots#0), 
      DynamicPkv.__default.seqInt($LS($LZ), idxs#0));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1276,34)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type MergeResult
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    top##0 := top#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    bots##0 := bots#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    idxs##0 := idxs#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    tmp##0 := tmp#0;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    assert $Is(ar#0, Tclass._System.array(Tclass.PackedKV.Pkv()));
    results##0 := ar#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == results##0 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##1 := Call$$DynamicPkv.__default.MergeToChildrenIter(top##0, bots##0, idxs##0, tmp##0, i##0, results##0);
    // TrCallStmt: After ProcessCallStmt
    result#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1276,62)"} true;
}



procedure CheckWellformed$$DynamicPkv.__default.PartialFlush(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.PartialFlushResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.PartialFlushResult(), $Heap));
  free requires 48 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$DynamicPkv.__default.PartialFlush(top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box)
   returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##pkv#0: DatatypeType;
  var i#0: int;
  var ##pkv#1: DatatypeType;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var i#4: int;
  var ##psa#2: DatatypeType;
  var ##s#0: Seq Box;
  var ##buckets#0: Seq Box;
  var ##pkv#2: DatatypeType;
  var ##s#1: Seq Box;
  var ##top#0: DatatypeType;
  var ##pivots#0: Seq Box;
  var ##bots#0: Seq Box;

    // AddMethodImpl: PartialFlush, CheckWellformed$$DynamicPkv.__default.PartialFlush
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1294,9): initial state"} true;
    ##pkv#0 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#0, Tclass.PackedKV.Pkv(), $Heap);
    assume PackedKV.__default.WF#canCall(top#0);
    assume PackedKV.__default.WF(top#0);
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(bots#0);
        assert 0 <= i#0 && i#0 < Seq#Length(bots#0);
        ##pkv#1 := $Unbox(Seq#Index(bots#0, i#0)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#1, Tclass.PackedKV.Pkv(), $Heap);
        assume PackedKV.__default.WF#canCall($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
        assume PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(bots#0)
           ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#0)): DatatypeType);
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType));
    assume PackedKV.Pkv.Pkv_q(top#0);
    ##psa#0 := PackedKV.Pkv.keys(top#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
        PackedStringArray.__default.I(##psa#0), 
        LitInt(KeyType.__default.MaxLen()))
       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#0), 
          LitInt(KeyType.__default.MaxLen()))
         || (forall i#2: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#2)): Seq Box } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(PackedStringArray.__default.I(##psa#0))
             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#0), i#2)): Seq Box)
               <= LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(##psa#0), 
      LitInt(KeyType.__default.MaxLen()));
    assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
    if (LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))))
    {
        assume PackedKV.Pkv.Pkv_q(top#0);
        ##psa#1 := PackedKV.Pkv.keys(top#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#1), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#1), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#3: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#1), i#3)): Seq Box } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(PackedStringArray.__default.I(##psa#1))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#1), i#3)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#1), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(top#0));
    }

    assume LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)))
       && Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
    havoc i#4;
    if (*)
    {
        assume LitInt(0) <= i#4;
        assume i#4 < Seq#Length(bots#0);
        assert 0 <= i#4 && i#4 < Seq#Length(bots#0);
        assume PackedKV.Pkv.Pkv_q($Unbox(Seq#Index(bots#0, i#4)): DatatypeType);
        ##psa#2 := PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#4)): DatatypeType);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assert {:subsumption 0} PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(##psa#2), 
            LitInt(KeyType.__default.MaxLen()))
           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(##psa#2), 
              LitInt(KeyType.__default.MaxLen()))
             || (forall i#5: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#5)): Seq Box } 
              LitInt(0) <= i#5 && i#5 < Seq#Length(PackedStringArray.__default.I(##psa#2))
                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(##psa#2), i#5)): Seq Box)
                   <= LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(##psa#2), 
          LitInt(KeyType.__default.MaxLen()));
        assume PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#4)): DatatypeType));
        assume Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#4)): DatatypeType)))
           < 268435456;
    }
    else
    {
        assume LitInt(0) <= i#4 && i#4 < Seq#Length(bots#0)
           ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#4)): DatatypeType)))
             < 268435456;
    }

    assume (forall i#6: int :: 
      { $Unbox(Seq#Index(bots#0, i#6)): DatatypeType } 
      LitInt(0) <= i#6 && i#6 < Seq#Length(bots#0)
         ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#6)): DatatypeType)))
           < 268435456);
    if (0 < Seq#Length(bots#0))
    {
    }

    if (0 < Seq#Length(bots#0) && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1)
    {
        assume NativeTypes.__default.Uint64UpperBound#canCall();
    }

    assume 0 < Seq#Length(bots#0)
       && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1
       && Seq#Length(pivots#0) + 1 < NativeTypes.__default.Uint64UpperBound();
    ##s#0 := bots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#7: int :: 
      { $Unbox(Seq#Index(##s#0, i#7)): DatatypeType } 
      LitInt(0) <= i#7 && i#7 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#7)): DatatypeType));
    assume (forall i#7: int :: 
      { $Unbox(Seq#Index(##s#0, i#7)): DatatypeType } 
      LitInt(0) <= i#7 && i#7 < Seq#Length(##s#0)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0, i#7)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
    ##buckets#0 := DynamicPkv.__default.PKVISeq($LS($LZ), bots#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
    assume Bounds.__default.MaxTotalBucketWeight#canCall();
    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0))
       <= LitInt(Bounds.__default.MaxTotalBucketWeight());
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1305,19): post-state"} true;
    assume DynamicPkv.PartialFlushResult.WF#canCall(result#0);
    assume DynamicPkv.PartialFlushResult.WF(result#0);
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                   < 4294967296));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                     == LitInt(0))));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
                 || (0
                     < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                           - 1)): int)));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#8: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                            i#8)): Seq Box } 
                      LitInt(0) <= i#8
                           && i#8
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                                i#8)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen())))));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                 || (forall i#9: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))), 
                        i#9)): Seq Box } 
                  LitInt(0) <= i#9
                       && i#9
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))), 
                          i#9)): Seq Box))));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
           ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))), 
              $Box(ValueMessage.__default.IdentityMessage())));
    assert {:subsumption 0} DynamicPkv.PartialFlushResult.WF#canCall(result#0)
       ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
         || (forall i#10: int :: 
          { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(result#0), i#10)): DatatypeType } 
          LitInt(0) <= i#10
               && i#10 < Seq#Length(DynamicPkv.PartialFlushResult.bots(result#0))
             ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(result#0), i#10)): DatatypeType));
    assume DynamicPkv.PartialFlushResult.WF(result#0);
    assume DynamicPkv.PartialFlushResult.I#canCall(result#0);
    assume BucketModel.partialFlushResult.partialFlushResult_q(Lit(DynamicPkv.PartialFlushResult.I(result#0)));
    ##pkv#2 := top#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pkv#2, Tclass.PackedKV.Pkv(), $Heap);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2))) == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
               < 4294967296);
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == LitInt(0)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)))
               ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#2)))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)), 
                    Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))) - 1)): int));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#2))
           ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#2))
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#2)))
           == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#2)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
           ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
             || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                LitInt(KeyType.__default.MaxLen()))
               ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), 
                  LitInt(KeyType.__default.MaxLen()))
                 || (forall i#11: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#11)): Seq Box } 
                  LitInt(0) <= i#11
                       && i#11 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)))
                     ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#2)), i#11)): Seq Box)
                       <= LitInt(KeyType.__default.MaxLen()))));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
           ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
             || (forall i#12: int :: 
              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#12)): Seq Box } 
              LitInt(0) <= i#12
                   && i#12 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)))
                 ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#2)), i#12)): Seq Box)));
    assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#2)
       ==> PackedKV.__default.WF(##pkv#2)
         || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#2)), 
          $Box(ValueMessage.__default.IdentityMessage()));
    assume PackedKV.__default.WF(##pkv#2);
    assume PackedKV.__default.I#canCall(top#0);
    assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I(top#0));
    ##s#1 := bots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#13: int :: 
      { $Unbox(Seq#Index(##s#1, i#13)): DatatypeType } 
      LitInt(0) <= i#13 && i#13 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#13)): DatatypeType));
    assume (forall i#13: int :: 
      { $Unbox(Seq#Index(##s#1, i#13)): DatatypeType } 
      LitInt(0) <= i#13 && i#13 < Seq#Length(##s#1)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#1, i#13)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
    ##top#0 := PackedKV.__default.I(top#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##top#0, Tclass.BucketsLib.Bucket(), $Heap);
    ##pivots#0 := pivots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pivots#0, TSeq(Tclass.KeyType.Key()), $Heap);
    ##bots#0 := DynamicPkv.__default.PKVISeq($LS($LZ), bots#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bots#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.PreWFBucket#canCall(##top#0)
           ==> BucketsLib.__default.PreWFBucket(##top#0)
             || Seq#Length(BucketsLib.Bucket.keys(##top#0))
               == Seq#Length(BucketsLib.Bucket.msgs(##top#0)));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.PreWFBucket#canCall(##top#0)
           ==> BucketsLib.__default.PreWFBucket(##top#0)
             || Map#Equal(BucketsLib.__default.BucketMapOfSeq(StartFuelAssert_BucketsLib._default.BucketMapOfSeq, 
                BucketsLib.Bucket.keys(##top#0), 
                BucketsLib.Bucket.msgs(##top#0)), 
              BucketsLib.Bucket.b(##top#0)));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.WFBucketMap#canCall(BucketsLib.Bucket.b(##top#0))
           ==> BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(##top#0))
             || (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(##top#0))[$Box(key#0)] } 
              $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(##top#0))[$Box(key#0)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage())));
    assert {:subsumption 0} BucketsLib.__default.WFBucket#canCall(##top#0)
       ==> BucketsLib.__default.WFBucket(##top#0)
         || (BucketsLib.__default.WFMessageSeq#canCall(BucketsLib.Bucket.msgs(##top#0))
           ==> BucketsLib.__default.WFMessageSeq(BucketsLib.Bucket.msgs(##top#0))
             || (forall i#14: int :: 
              { $Unbox(Seq#Index(BucketsLib.Bucket.msgs(##top#0), i#14)): DatatypeType } 
              LitInt(0) <= i#14 && i#14 < Seq#Length(BucketsLib.Bucket.msgs(##top#0))
                 ==> !ValueMessage.Message#Equal($Unbox(Seq#Index(BucketsLib.Bucket.msgs(##top#0), i#14)): DatatypeType, 
                  ValueMessage.__default.IdentityMessage())));
    assume BucketsLib.__default.WFBucket(##top#0);
    assert {:subsumption 0} (forall i#15: int :: 
      { $Unbox(Seq#Index(##bots#0, i#15)): DatatypeType } 
      LitInt(0) <= i#15 && i#15 < Seq#Length(##bots#0)
         ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(##bots#0, i#15)): DatatypeType));
    assume (forall i#15: int :: 
      { $Unbox(Seq#Index(##bots#0, i#15)): DatatypeType } 
      LitInt(0) <= i#15 && i#15 < Seq#Length(##bots#0)
         ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(##bots#0, i#15)): DatatypeType));
    assert {:subsumption 0} 0 < Seq#Length(##bots#0);
    assert {:subsumption 0} Seq#Length(##bots#0) == Seq#Length(##pivots#0) + 1;
    assume 0 < Seq#Length(##bots#0) && Seq#Length(##bots#0) == Seq#Length(##pivots#0) + 1;
    assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, ##bots#0)
       <= LitInt(Bounds.__default.MaxTotalBucketWeight());
    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, ##bots#0)
       <= LitInt(Bounds.__default.MaxTotalBucketWeight());
    assume BucketModel.__default.partialFlush#canCall(PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
    assume BucketModel.partialFlushResult.partialFlushResult_q(BucketModel.__default.partialFlush(StartFuel_BucketModel._default.partialFlush, 
        PackedKV.__default.I(top#0), 
        pivots#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0)));
    assume BucketModel.partialFlushResult#Equal(DynamicPkv.PartialFlushResult.I(result#0), 
      BucketModel.__default.partialFlush(StartFuel_BucketModel._default.partialFlush, 
        PackedKV.__default.I(top#0), 
        pivots#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0)));
}



procedure Call$$DynamicPkv.__default.PartialFlush(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.PartialFlushResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.PartialFlushResult(), $Heap));
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(top#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(top#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(top#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#16: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), i#16)): Seq Box } 
                LitInt(0) <= i#16
                     && i#16 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)), i#16)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
           || (forall i#17: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)), i#17)): Seq Box } 
            LitInt(0) <= i#17
                 && i#17 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)), i#17)): Seq Box)));
  requires PackedKV.__default.WF#canCall(top#0)
     ==> PackedKV.__default.WF(top#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType));
  requires LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
  requires Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
  requires (forall i#6: int :: 
    { $Unbox(Seq#Index(bots#0, i#6)): DatatypeType } 
    LitInt(0) <= i#6 && i#6 < Seq#Length(bots#0)
       ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#6)): DatatypeType)))
         < 268435456);
  requires 0 < Seq#Length(bots#0);
  requires Seq#Length(bots#0) == Seq#Length(pivots#0) + 1;
  requires Seq#Length(pivots#0) + 1 < NativeTypes.__default.Uint64UpperBound();
  requires BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0))
     <= LitInt(Bounds.__default.MaxTotalBucketWeight());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0);
  free ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     && 
    Lit(DynamicPkv.PartialFlushResult.WF(result#0))
     && 
    PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
     && (forall i#20: int :: 
      { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(result#0), i#20)): DatatypeType } 
      LitInt(0) <= i#20
           && i#20 < Seq#Length(DynamicPkv.PartialFlushResult.bots(result#0))
         ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(result#0), i#20)): DatatypeType));
  free ensures $IsA#BucketModel.partialFlushResult(Lit(DynamicPkv.PartialFlushResult.I(result#0)))
     && $IsA#BucketModel.partialFlushResult(BucketModel.__default.partialFlush(StartFuel_BucketModel._default.partialFlush, 
        PackedKV.__default.I(top#0), 
        pivots#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0)))
     && 
    DynamicPkv.PartialFlushResult.I#canCall(result#0)
     && 
    PackedKV.__default.I#canCall(top#0)
     && DynamicPkv.__default.PKVISeq#canCall(bots#0)
     && BucketModel.__default.partialFlush#canCall(PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
  ensures BucketModel.partialFlushResult#Equal(DynamicPkv.PartialFlushResult.I(result#0), 
    BucketModel.__default.partialFlush(StartFuelAssert_BucketModel._default.partialFlush, 
      PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$DynamicPkv.__default.PartialFlush(top#0: DatatypeType
       where $Is(top#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(top#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(top#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(pivots#0, TSeq(Tclass.KeyType.Key()), $Heap), 
    bots#0: Seq Box
       where $Is(bots#0, TSeq(Tclass.PackedKV.Pkv()))
         && $IsAlloc(bots#0, TSeq(Tclass.PackedKV.Pkv()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.DynamicPkv.PartialFlushResult())
         && $IsAlloc(result#0, Tclass.DynamicPkv.PartialFlushResult(), $Heap), 
    $_reverifyPost: bool);
  free requires 48 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedKV.__default.WF#canCall(top#0)
     && 
    PackedKV.__default.WF(top#0)
     && 
    PackedStringArray.__default.WF(PackedKV.Pkv.keys(top#0))
     && PackedStringArray.__default.WF(PackedKV.Pkv.messages(top#0))
     && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(top#0)))
       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(top#0)))
     && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
      PackedStringArray.__default.I(PackedKV.Pkv.keys(top#0)))
     && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(top#0)))
     && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(top#0)), 
      $Box(ValueMessage.__default.IdentityMessage()));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
       ==> PackedKV.__default.WF($Unbox(Seq#Index(bots#0, i#1)): DatatypeType));
  requires LitInt(0) <= Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0)));
  requires Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys(top#0))) < 268435456;
  requires (forall i#6: int :: 
    { $Unbox(Seq#Index(bots#0, i#6)): DatatypeType } 
    LitInt(0) <= i#6 && i#6 < Seq#Length(bots#0)
       ==> Seq#Length(PackedKV.__default.IKeys(PackedKV.Pkv.keys($Unbox(Seq#Index(bots#0, i#6)): DatatypeType)))
         < 268435456);
  requires 0 < Seq#Length(bots#0);
  requires Seq#Length(bots#0) == Seq#Length(pivots#0) + 1;
  requires Seq#Length(pivots#0) + 1 < NativeTypes.__default.Uint64UpperBound();
  requires BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0))
     <= LitInt(Bounds.__default.MaxTotalBucketWeight());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0);
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                 < 4294967296));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                 < 4294967296));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                   == LitInt(0))));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                         - 1)): int)));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                 < 4294967296));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                 < 4294967296));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                   == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                   == LitInt(0))));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               || (0
                   < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                 ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))), 
                      Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                         - 1)): int)));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
             ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))
               || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
             == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0)))));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
             ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
               || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                  LitInt(KeyType.__default.MaxLen()))
                 ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                    LitInt(KeyType.__default.MaxLen()))
                   || (forall i#23: int :: 
                    { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                          i#23)): Seq Box } 
                    LitInt(0) <= i#23
                         && i#23
                           < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))))
                       ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(DynamicPkv.PartialFlushResult.top(result#0))), 
                              i#23)): Seq Box)
                         <= LitInt(KeyType.__default.MaxLen())))));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
             ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
               || (forall i#24: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))), 
                      i#24)): Seq Box } 
                LitInt(0) <= i#24
                     && i#24
                       < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))))
                   ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))), 
                        i#24)): Seq Box))));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (PackedKV.__default.WF#canCall(DynamicPkv.PartialFlushResult.top(result#0))
         ==> PackedKV.__default.WF(DynamicPkv.PartialFlushResult.top(result#0))
           || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(DynamicPkv.PartialFlushResult.top(result#0))), 
            $Box(ValueMessage.__default.IdentityMessage())));
  ensures DynamicPkv.PartialFlushResult.WF#canCall(result#0)
     ==> Lit(DynamicPkv.PartialFlushResult.WF(result#0))
       || (forall i#25: int :: 
        { $Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(result#0), i#25)): DatatypeType } 
        LitInt(0) <= i#25
             && i#25 < Seq#Length(DynamicPkv.PartialFlushResult.bots(result#0))
           ==> PackedKV.__default.WF($Unbox(Seq#Index(DynamicPkv.PartialFlushResult.bots(result#0), i#25)): DatatypeType));
  free ensures $IsA#BucketModel.partialFlushResult(Lit(DynamicPkv.PartialFlushResult.I(result#0)))
     && $IsA#BucketModel.partialFlushResult(BucketModel.__default.partialFlush(StartFuel_BucketModel._default.partialFlush, 
        PackedKV.__default.I(top#0), 
        pivots#0, 
        DynamicPkv.__default.PKVISeq($LS($LZ), bots#0)))
     && 
    DynamicPkv.PartialFlushResult.I#canCall(result#0)
     && 
    PackedKV.__default.I#canCall(top#0)
     && DynamicPkv.__default.PKVISeq#canCall(bots#0)
     && BucketModel.__default.partialFlush#canCall(PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
  ensures BucketModel.partialFlushResult#Equal(DynamicPkv.PartialFlushResult.I(result#0), 
    BucketModel.__default.partialFlush(StartFuelAssert_BucketModel._default.partialFlush, 
      PackedKV.__default.I(top#0), 
      pivots#0, 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$DynamicPkv.__default.PartialFlush(top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var slack#0: int where LitInt(0) <= slack#0 && slack#0 < 18446744073709551616;
  var i#26: int where LitInt(0) <= i#26 && i#26 < 18446744073709551616;
  var newtype$check#0: int;
  var ##s#2: Seq Box;
  var ##buckets#1: Seq Box;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##s#3: Seq Box;
  var ##buckets#2: Seq Box;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $decr$loop#00: int;
  var ##s#0_0_0_0: Seq Box;
  var ##buckets#0_0_0_0: Seq Box;
  var ##s#0_0_0_1: Seq Box;
  var ##bucket#0_0_0_0: DatatypeType;
  var pkv##0_0_0_0: DatatypeType;
  var ##s#0_0_0_2: Seq Box;
  var ##bucket#0_0_0_1: DatatypeType;
  var ##pkv#0_0_0_0: DatatypeType;
  var ##bucket#0_0_0_2: DatatypeType;
  var ##pkv#0_0_0_1: DatatypeType;
  var ##bucket#0_0_0_3: DatatypeType;
  var ##pkv#0_0_0_2: DatatypeType;
  var ##s#0_0_0_3: Seq Box;
  var ##buckets#0_0_0_1: Seq Box;
  var ##pkv#0_0_0_3: DatatypeType;
  var ##s#0_0_1_0: Seq Box;
  var newtype$check#0_0_1_0: int;
  var newtype$check#0_0_1_1: int;
  var ##buckets#0_0_1_0: Seq Box;
  var ##s#0_0_1_1: Seq Box;
  var newtype$check#0_0_1_2: int;
  var newtype$check#0_0_1_3: int;
  var ##run#0_0_1_0: Seq Box;
  var ##s#0_0_1_2: Seq Box;
  var ##s#0_0_1_3: Seq Box;
  var newtype$check#0_0_1_4: int;
  var newtype$check#0_0_1_5: int;
  var ##run#0_0_1_1: Seq Box;
  var ##s#0_0_1_4: Seq Box;
  var ##s#0_0_1_5: Seq Box;
  var ##buckets#0_0_1_1: Seq Box;
  var ##s#0_0_1_6: Seq Box;
  var ##bucket#0_0_1_0: DatatypeType;
  var ##s#0_0_0: Seq Box;
  var newtype$check#0_0_0: int;
  var newtype$check#0_0_1: int;
  var ##buckets#0_0_0: Seq Box;
  var blist##0_0: Seq Box;
  var ##s#0_0: Seq Box;
  var a##0_0: int;
  var b##0_0: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var ##pkv#0_0: DatatypeType;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var ##s#4: Seq Box;
  var ##s#5: Seq Box;
  var res#0: DatatypeType
     where $Is(res#0, Tclass.DynamicPkv.MergeResult())
       && $IsAlloc(res#0, Tclass.DynamicPkv.MergeResult(), $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.DynamicPkv.MergeResult())
       && $IsAlloc($rhs##0, Tclass.DynamicPkv.MergeResult(), $Heap);
  var top##0: DatatypeType;
  var pivots##0: Seq Box;
  var bots##0: Seq Box;
  var slack##0: int;

    // AddMethodImpl: PartialFlush, Impl$$DynamicPkv.__default.PartialFlush
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.ltedef)
       == StartFuel_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.ltedef)
       == StartFuelAssert_Uint64_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint64_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.NotMinimum)
       == StartFuel_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.NotMinimum)
       == StartFuelAssert_Uint64_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.SortedSeqForMap)
       == StartFuel_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint64_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimum)
       == StartFuel_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimum)
       == StartFuelAssert_Uint64_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.minimumOpt)
       == StartFuel_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.minimumOpt)
       == StartFuelAssert_Uint64_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximum)
       == StartFuel_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximum)
       == StartFuelAssert_Uint64_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.maximumOpt)
       == StartFuel_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.maximumOpt)
       == StartFuelAssert_Uint64_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsSorted)
       == StartFuel_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsSorted)
       == StartFuelAssert_Uint64_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint64_Order._default.IsStrictlySorted)
       == StartFuel_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint64_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint64_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToOneChild)
       == StartFuel_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToOneChild)
       == StartFuelAssert_BucketModel._default.mergeToOneChild;
    assume AsFuelBottom(StartFuel_BucketModel._default.mergeToChildren)
       == StartFuel_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.mergeToChildren)
       == StartFuelAssert_BucketModel._default.mergeToChildren;
    assume AsFuelBottom(StartFuel_BucketModel._default.partialFlush)
       == StartFuel_BucketModel._default.partialFlush;
    assume AsFuelBottom(StartFuelAssert_BucketModel._default.partialFlush)
       == StartFuelAssert_BucketModel._default.partialFlush;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1308,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1309,15)
    assume true;
    assume Bounds.__default.MaxTotalBucketWeightUint64#canCall();
    assume Bounds.__default.MaxTotalBucketWeightUint64#canCall();
    slack#0 := LitInt(Bounds.__default.MaxTotalBucketWeightUint64());
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1309,45)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1310,11)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    i#26 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1310,14)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1312,5)
    ##s#2 := bots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#27: int :: 
      { $Unbox(Seq#Index(##s#2, i#27)): DatatypeType } 
      LitInt(0) <= i#27 && i#27 < Seq#Length(##s#2)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#2, i#27)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
    assert {:subsumption 0} 0 <= i#26 && i#26 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
    ##buckets#1 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26);
    // assume allocatedness for argument to function
    assume $IsAlloc(##buckets#1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
    assume BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
       && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1312,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1312,82)
        // TrCallStmt: Before ProcessCallStmt
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$BucketWeights.__default.reveal__WeightBucketList();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1312,83)"} true;
        assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
            Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26))
           == LitInt(0);
        assume false;
    }

    assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
        Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26))
       == LitInt(0);
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1314,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(bots#0) - i#26;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= i#26;
      invariant $w$loop#0 ==> i#26 <= Seq#Length(bots#0);
      free invariant $w$loop#0
         ==> Bounds.__default.MaxTotalBucketWeight#canCall()
           && 
          DynamicPkv.__default.PKVISeq#canCall(bots#0)
           && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
      invariant $w$loop#0
         ==> slack#0
           == Bounds.__default.MaxTotalBucketWeight()
             - BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
              Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(bots#0) - i#26 <= $decr_init$loop#00
         && (Seq#Length(bots#0) - i#26 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1314,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            if (LitInt(0) <= i#26)
            {
            }

            assume true;
            assume LitInt(0) <= i#26 && i#26 <= Seq#Length(bots#0);
            assume Bounds.__default.MaxTotalBucketWeight#canCall();
            ##s#3 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#3, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#28: int :: 
              { $Unbox(Seq#Index(##s#3, i#28)): DatatypeType } 
              LitInt(0) <= i#28 && i#28 < Seq#Length(##s#3)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#3, i#28)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} 0 <= i#26 && i#26 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##buckets#2 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26);
            // assume allocatedness for argument to function
            assume $IsAlloc(##buckets#2, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
            assume BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
            assume Bounds.__default.MaxTotalBucketWeight#canCall()
               && 
              DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
            assume slack#0
               == Bounds.__default.MaxTotalBucketWeight()
                 - BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
            newtype$check#1 := Seq#Length(bots#0);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#2 := Seq#Length(bots#0);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        assume true;
        if (Seq#Length(bots#0) <= i#26)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(bots#0) - i#26;
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            ##s#0_0_0 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_0: int :: 
              { $Unbox(Seq#Index(##s#0_0_0, i#0_0_0)): DatatypeType } 
              LitInt(0) <= i#0_0_0 && i#0_0_0 < Seq#Length(##s#0_0_0)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_0, i#0_0_0)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            newtype$check#0_0_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_0 && newtype$check#0_0_0 < 18446744073709551616;
            newtype$check#0_0_1 := i#26 + 1;
            assert LitInt(0) <= newtype$check#0_0_1 && newtype$check#0_0_1 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#26 + 1
               && i#26 + 1 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##buckets#0_0_0 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##buckets#0_0_0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
            assume BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            ##s#0_0_1_0 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_1_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assume {:subsumption 0} (forall i#0_0_1_0: int :: 
              { $Unbox(Seq#Index(##s#0_0_1_0, i#0_0_1_0)): DatatypeType } 
              LitInt(0) <= i#0_0_1_0 && i#0_0_1_0 < Seq#Length(##s#0_0_1_0)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_1_0, i#0_0_1_0)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            newtype$check#0_0_1_0 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_0_1_0
               && newtype$check#0_0_1_0 < 18446744073709551616;
            newtype$check#0_0_1_1 := i#26 + 1;
            assume LitInt(0) <= newtype$check#0_0_1_1
               && newtype$check#0_0_1_1 < 18446744073709551616;
            assume {:subsumption 0} 0 <= i#26 + 1
               && i#26 + 1 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##buckets#0_0_1_0 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##buckets#0_0_1_0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
            assume BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1));
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1321,11)
            ##s#0_0_1_1 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_1_1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_1_1: int :: 
              { $Unbox(Seq#Index(##s#0_0_1_1, i#0_0_1_1)): DatatypeType } 
              LitInt(0) <= i#0_0_1_1 && i#0_0_1_1 < Seq#Length(##s#0_0_1_1)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_1_1, i#0_0_1_1)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            newtype$check#0_0_1_2 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_1_2
               && newtype$check#0_0_1_2 < 18446744073709551616;
            newtype$check#0_0_1_3 := i#26 + 1;
            assert LitInt(0) <= newtype$check#0_0_1_3
               && newtype$check#0_0_1_3 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#26 + 1
               && i#26 + 1 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##run#0_0_1_0 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0_0_1_0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0_0_1_0) > 0;
            assume Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), 
              Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1));
            ##s#0_0_1_2 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_1_2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_1_2: int :: 
              { $Unbox(Seq#Index(##s#0_0_1_2, i#0_0_1_2)): DatatypeType } 
              LitInt(0) <= i#0_0_1_2 && i#0_0_1_2 < Seq#Length(##s#0_0_1_2)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_1_2, i#0_0_1_2)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} 0 <= i#26 && i#26 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), 
                Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1))
               && DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} Seq#Equal(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), 
                Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26 + 1)), 
              Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26));
            assume Seq#Equal(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), 
                Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26 + 1)), 
              Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1322,11)
            ##s#0_0_1_3 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_1_3, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_1_3: int :: 
              { $Unbox(Seq#Index(##s#0_0_1_3, i#0_0_1_3)): DatatypeType } 
              LitInt(0) <= i#0_0_1_3 && i#0_0_1_3 < Seq#Length(##s#0_0_1_3)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_1_3, i#0_0_1_3)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            newtype$check#0_0_1_4 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_1_4
               && newtype$check#0_0_1_4 < 18446744073709551616;
            newtype$check#0_0_1_5 := i#26 + 1;
            assert LitInt(0) <= newtype$check#0_0_1_5
               && newtype$check#0_0_1_5 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#26 + 1
               && i#26 + 1 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##run#0_0_1_1 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0_0_1_1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0_0_1_1) > 0;
            assume Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), 
              Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1));
            assume BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), 
                  Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1))): DatatypeType);
            ##s#0_0_1_4 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_1_4, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_1_4: int :: 
              { $Unbox(Seq#Index(##s#0_0_1_4, i#0_0_1_4)): DatatypeType } 
              LitInt(0) <= i#0_0_1_4 && i#0_0_1_4 < Seq#Length(##s#0_0_1_4)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_1_4, i#0_0_1_4)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} 0 <= i#26 && i#26 < Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            assume $IsA#BucketsLib.Bucket($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), 
                    Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1))): DatatypeType)
               && $IsA#BucketsLib.Bucket($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType)
               && 
              DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), 
                Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1))
               && DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} BucketsLib.Bucket#Equal($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), 
                  Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26 + 1))): DatatypeType, 
              $Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26)): DatatypeType);
            assume BucketsLib.Bucket#Equal($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), 
                  Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26 + 1))): DatatypeType, 
              $Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType);
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1323,34)
            // TrCallStmt: Before ProcessCallStmt
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$BucketWeights.__default.reveal__WeightBucketList();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1323,35)"} true;
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            ##s#0_0_1_5 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_1_5, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_1_5: int :: 
              { $Unbox(Seq#Index(##s#0_0_1_5, i#0_0_1_5)): DatatypeType } 
              LitInt(0) <= i#0_0_1_5 && i#0_0_1_5 < Seq#Length(##s#0_0_1_5)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_1_5, i#0_0_1_5)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} 0 <= i#26 && i#26 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##buckets#0_0_1_1 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26);
            // assume allocatedness for argument to function
            assume $IsAlloc(##buckets#0_0_1_1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
            assume BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
            ##s#0_0_1_6 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_1_6, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_1_6: int :: 
              { $Unbox(Seq#Index(##s#0_0_1_6, i#0_0_1_6)): DatatypeType } 
              LitInt(0) <= i#0_0_1_6 && i#0_0_1_6 < Seq#Length(##s#0_0_1_6)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_1_6, i#0_0_1_6)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} 0 <= i#26 && i#26 < Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##bucket#0_0_1_0 := $Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##bucket#0_0_1_0, Tclass.BucketsLib.Bucket(), $Heap);
            assume BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType);
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26))
               && 
              DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType);
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26 + 1))
               == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                  Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26))
                 + BucketWeights.__default.WeightBucket($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26)): DatatypeType);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            ##s#0_0_0_0 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_0_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assume {:subsumption 0} (forall i#0_0_0_0: int :: 
              { $Unbox(Seq#Index(##s#0_0_0_0, i#0_0_0_0)): DatatypeType } 
              LitInt(0) <= i#0_0_0_0 && i#0_0_0_0 < Seq#Length(##s#0_0_0_0)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_0_0, i#0_0_0_0)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assume {:subsumption 0} 0 <= i#26 && i#26 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##buckets#0_0_0_0 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26);
            // assume allocatedness for argument to function
            assume $IsAlloc(##buckets#0_0_0_0, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
            assume BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
            ##s#0_0_0_1 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_0_1, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assume {:subsumption 0} (forall i#0_0_0_1: int :: 
              { $Unbox(Seq#Index(##s#0_0_0_1, i#0_0_0_1)): DatatypeType } 
              LitInt(0) <= i#0_0_0_1 && i#0_0_0_1 < Seq#Length(##s#0_0_0_1)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_0_1, i#0_0_0_1)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assume {:subsumption 0} 0 <= i#26 && i#26 < Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##bucket#0_0_0_0 := $Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##bucket#0_0_0_0, Tclass.BucketsLib.Bucket(), $Heap);
            assume BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType);
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26))
               && 
              DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType);
            // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1327,39)
            // TrCallStmt: Before ProcessCallStmt
            assert 0 <= i#26 && i#26 < Seq#Length(bots#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            pkv##0_0_0_0 := $Unbox(Seq#Index(bots#0, i#26)): DatatypeType;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$DynamicPkv.__default.WeightBucketPkv__eq__WeightPkv(pkv##0_0_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1327,47)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1329,11)
            ##s#0_0_0_2 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_0_2, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_0_2: int :: 
              { $Unbox(Seq#Index(##s#0_0_0_2, i#0_0_0_2)): DatatypeType } 
              LitInt(0) <= i#0_0_0_2 && i#0_0_0_2 < Seq#Length(##s#0_0_0_2)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_0_2, i#0_0_0_2)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} 0 <= i#26 && i#26 < Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##bucket#0_0_0_1 := $Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##bucket#0_0_0_1, Tclass.BucketsLib.Bucket(), $Heap);
            assume BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType);
            assert {:subsumption 0} 0 <= i#26 && i#26 < Seq#Length(bots#0);
            ##pkv#0_0_0_0 := $Unbox(Seq#Index(bots#0, i#26)): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_0_0, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_0))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_0_3: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)), i#0_0_0_3)): Seq Box } 
                          LitInt(0) <= i#0_0_0_3
                               && i#0_0_0_3
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_0)), i#0_0_0_3)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                     || (forall i#0_0_0_4: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)), i#0_0_0_4)): Seq Box } 
                      LitInt(0) <= i#0_0_0_4
                           && i#0_0_0_4
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_0)), i#0_0_0_4)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_0)
               ==> PackedKV.__default.WF(##pkv#0_0_0_0)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_0)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.I#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
            assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType));
            ##bucket#0_0_0_2 := PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
            // assume allocatedness for argument to function
            assume $IsAlloc(##bucket#0_0_0_2, Tclass.BucketsLib.Bucket(), $Heap);
            assume BucketWeights.__default.WeightBucket#canCall(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType));
            if (BucketWeights.__default.WeightBucket($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType)
               == BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType)))
            {
                assert {:subsumption 0} 0 <= i#26 && i#26 < Seq#Length(bots#0);
                ##pkv#0_0_0_1 := $Unbox(Seq#Index(bots#0, i#26)): DatatypeType;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_0_0_1, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_1)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_1))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_1))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_1))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_1)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_1))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_1))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_1)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_1)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_1)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_0_0_5: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_1)), i#0_0_0_5)): Seq Box } 
                              LitInt(0) <= i#0_0_0_5
                                   && i#0_0_0_5
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_1)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_1)), i#0_0_0_5)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                         || (forall i#0_0_0_6: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_1)), i#0_0_0_6)): Seq Box } 
                          LitInt(0) <= i#0_0_0_6
                               && i#0_0_0_6
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_1)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_1)), i#0_0_0_6)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_1)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_1)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_1)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.I#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
                assume BucketsLib.Bucket.BucketMapWithSeq_q(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType));
                ##bucket#0_0_0_3 := PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
                // assume allocatedness for argument to function
                assume $IsAlloc(##bucket#0_0_0_3, Tclass.BucketsLib.Bucket(), $Heap);
                assume BucketWeights.__default.WeightBucket#canCall(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType));
                assert {:subsumption 0} 0 <= i#26 && i#26 < Seq#Length(bots#0);
                ##pkv#0_0_0_2 := $Unbox(Seq#Index(bots#0, i#26)): DatatypeType;
                // assume allocatedness for argument to function
                assume $IsAlloc(##pkv#0_0_0_2, Tclass.PackedKV.Pkv(), $Heap);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                         || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_2)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_2))) - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_2))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_2))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                         || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                         || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                           < 4294967296);
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                         || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                             == LitInt(0)
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                             == LitInt(0)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                         || (0
                             < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                           ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_2)), 
                                Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                                   - 1)): int));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                       ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_2))
                         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                          PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_2))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                       == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_2)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                       ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                         || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                            PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_2)), 
                            LitInt(KeyType.__default.MaxLen()))
                           ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                              PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_2)), 
                              LitInt(KeyType.__default.MaxLen()))
                             || (forall i#0_0_0_7: int :: 
                              { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_2)), i#0_0_0_7)): Seq Box } 
                              LitInt(0) <= i#0_0_0_7
                                   && i#0_0_0_7
                                     < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_2)))
                                 ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_2)), i#0_0_0_7)): Seq Box)
                                   <= LitInt(KeyType.__default.MaxLen()))));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                       ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                         || (forall i#0_0_0_8: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_2)), i#0_0_0_8)): Seq Box } 
                          LitInt(0) <= i#0_0_0_8
                               && i#0_0_0_8
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_2)))
                             ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_2)), i#0_0_0_8)): Seq Box)));
                assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_2)
                   ==> PackedKV.__default.WF(##pkv#0_0_0_2)
                     || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_2)), 
                      $Box(ValueMessage.__default.IdentityMessage()));
                assume PackedKV.__default.WeightPkv#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
            }

            assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType)
               && 
              PackedKV.__default.I#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType)
               && BucketWeights.__default.WeightBucket#canCall(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType))
               && (BucketWeights.__default.WeightBucket($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26)): DatatypeType)
                   == BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType))
                 ==> PackedKV.__default.I#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType)
                   && BucketWeights.__default.WeightBucket#canCall(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType))
                   && PackedKV.__default.WeightPkv#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType));
            assert {:subsumption 0} BucketWeights.__default.WeightBucket($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26)): DatatypeType)
               == BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType));
            assert {:subsumption 0} BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType))
               == PackedKV.__default.WeightPkv($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
            assume BucketWeights.__default.WeightBucket($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26)): DatatypeType)
                 == BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType))
               && BucketWeights.__default.WeightBucket(PackedKV.__default.I($Unbox(Seq#Index(bots#0, i#26)): DatatypeType))
                 == PackedKV.__default.WeightPkv($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            ##s#0_0_0_3 := bots#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#0_0_0_3, TSeq(Tclass.PackedKV.Pkv()), $Heap);
            assert {:subsumption 0} (forall i#0_0_0_9: int :: 
              { $Unbox(Seq#Index(##s#0_0_0_3, i#0_0_0_9)): DatatypeType } 
              LitInt(0) <= i#0_0_0_9 && i#0_0_0_9 < Seq#Length(##s#0_0_0_3)
                 ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0_0_3, i#0_0_0_9)): DatatypeType));
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
            assert {:subsumption 0} 0 <= i#26 && i#26 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
            ##buckets#0_0_0_1 := Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26);
            // assume allocatedness for argument to function
            assume $IsAlloc(##buckets#0_0_0_1, TSeq(Tclass.BucketsLib.Bucket()), $Heap);
            assume BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
            assert {:subsumption 0} 0 <= i#26 && i#26 < Seq#Length(bots#0);
            ##pkv#0_0_0_3 := $Unbox(Seq#Index(bots#0, i#26)): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##pkv#0_0_0_3, Tclass.PackedKV.Pkv(), $Heap);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_3)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_3))) - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0_0_3))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_3))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                     || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                     || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                       < 4294967296);
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                     || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                         == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                         == LitInt(0)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                     || (0
                         < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                       ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_3)), 
                            Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                               - 1)): int));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                   ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0_0_3))
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_3))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                   == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0_0_3)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                   ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                     || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                        PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_3)), 
                        LitInt(KeyType.__default.MaxLen()))
                       ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                          PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_3)), 
                          LitInt(KeyType.__default.MaxLen()))
                         || (forall i#0_0_0_10: int :: 
                          { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_3)), i#0_0_0_10)): Seq Box } 
                          LitInt(0) <= i#0_0_0_10
                               && i#0_0_0_10
                                 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_3)))
                             ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0_0_3)), i#0_0_0_10)): Seq Box)
                               <= LitInt(KeyType.__default.MaxLen()))));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                   ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                     || (forall i#0_0_0_11: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_3)), i#0_0_0_11)): Seq Box } 
                      LitInt(0) <= i#0_0_0_11
                           && i#0_0_0_11
                             < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_3)))
                         ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0_0_3)), i#0_0_0_11)): Seq Box)));
            assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0_0_3)
               ==> PackedKV.__default.WF(##pkv#0_0_0_3)
                 || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0_0_3)), 
                  $Box(ValueMessage.__default.IdentityMessage()));
            assume PackedKV.__default.WeightPkv#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
            assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
               && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26))
               && PackedKV.__default.WeightPkv#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
            // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1318,7)
            assert {:subsumption 0} BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                  Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26))
                 + BucketWeights.__default.WeightBucket($Unbox(Seq#Index(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26)): DatatypeType)
               == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
                  Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26))
                 + PackedKV.__default.WeightPkv($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
            assume false;
        }

        assume BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
            Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26 + 1))
           == BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
              Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26))
             + PackedKV.__default.WeightPkv($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1335,28)
        // TrCallStmt: Before ProcessCallStmt
        ##s#0_0 := bots#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#0_0, TSeq(Tclass.PackedKV.Pkv()), $Heap);
        assert {:subsumption 0} (forall i#0_0: int :: 
          { $Unbox(Seq#Index(##s#0_0, i#0_0)): DatatypeType } 
          LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(##s#0_0)
             ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0, i#0_0)): DatatypeType));
        assume (forall i#0_0: int :: 
          { $Unbox(Seq#Index(##s#0_0, i#0_0)): DatatypeType } 
          LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(##s#0_0)
             ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#0_0, i#0_0)): DatatypeType));
        assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
        assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
        // ProcessCallStmt: CheckSubrange
        blist##0_0 := DynamicPkv.__default.PKVISeq($LS($LZ), bots#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0_0 := LitInt(0);
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#26 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        b##0_0 := i#26 + 1;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$BucketWeights.__default.WeightBucketListSlice(blist##0_0, a##0_0, b##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1335,59)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1337,13)
        assume true;
        assert 0 <= i#26 && i#26 < Seq#Length(bots#0);
        ##pkv#0_0 := $Unbox(Seq#Index(bots#0, i#26)): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##pkv#0_0, Tclass.PackedKV.Pkv(), $Heap);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(##pkv#0_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(##pkv#0_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                   < 4294967296);
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                     == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                     == LitInt(0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)))
                   ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(##pkv#0_0)))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)), 
                        Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0))) - 1)): int));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(##pkv#0_0))
               ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(##pkv#0_0))
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(##pkv#0_0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(##pkv#0_0)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
               ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                  PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                 || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
                    PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), 
                    LitInt(KeyType.__default.MaxLen()))
                   ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                      PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), 
                      LitInt(KeyType.__default.MaxLen()))
                     || (forall i#0_1: int :: 
                      { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), i#0_1)): Seq Box } 
                      LitInt(0) <= i#0_1
                           && i#0_1 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)))
                         ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(##pkv#0_0)), i#0_1)): Seq Box)
                           <= LitInt(KeyType.__default.MaxLen()))));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
               ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                 || (forall i#0_2: int :: 
                  { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)), i#0_2)): Seq Box } 
                  LitInt(0) <= i#0_2
                       && i#0_2
                         < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)))
                     ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(##pkv#0_0)), i#0_2)): Seq Box)));
        assert {:subsumption 0} PackedKV.__default.WF#canCall(##pkv#0_0)
           ==> PackedKV.__default.WF(##pkv#0_0)
             || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(##pkv#0_0)), 
              $Box(ValueMessage.__default.IdentityMessage()));
        assume PackedKV.__default.WF(##pkv#0_0);
        assume PackedKV.__default.WeightPkv#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
        newtype$check#0_2 := slack#0
           - PackedKV.__default.WeightPkv($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume PackedKV.__default.WeightPkv#canCall($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
        slack#0 := slack#0
           - PackedKV.__default.WeightPkv($Unbox(Seq#Index(bots#0, i#26)): DatatypeType);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1337,45)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1338,9)
        assume true;
        newtype$check#0_3 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        newtype$check#0_4 := i#26 + 1;
        assert LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        assume true;
        i#26 := i#26 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1338,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1314,5)
        assert 0 <= $decr$loop#00 || Seq#Length(bots#0) - i#26 == $decr$loop#00;
        assert Seq#Length(bots#0) - i#26 < $decr$loop#00;
        assume true;
        assume Bounds.__default.MaxTotalBucketWeight#canCall()
           && 
          DynamicPkv.__default.PKVISeq#canCall(bots#0)
           && BucketWeights.__default.WeightBucketList#canCall(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0), i#26));
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1340,5)
    ##s#4 := bots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#4, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#29: int :: 
      { $Unbox(Seq#Index(##s#4, i#29)): DatatypeType } 
      LitInt(0) <= i#29 && i#29 < Seq#Length(##s#4)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#4, i#29)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
    assert {:subsumption 0} 0 <= i#26 && i#26 <= Seq#Length(DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
    ##s#5 := bots#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#5, TSeq(Tclass.PackedKV.Pkv()), $Heap);
    assert {:subsumption 0} (forall i#30: int :: 
      { $Unbox(Seq#Index(##s#5, i#30)): DatatypeType } 
      LitInt(0) <= i#30 && i#30 < Seq#Length(##s#5)
         ==> PackedKV.__default.WF($Unbox(Seq#Index(##s#5, i#30)): DatatypeType));
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0);
    assume DynamicPkv.__default.PKVISeq#canCall(bots#0)
       && DynamicPkv.__default.PKVISeq#canCall(bots#0);
    assert {:subsumption 0} Seq#Equal(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26), 
      DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0));
    assume Seq#Equal(Seq#Take(DynamicPkv.__default.PKVISeq($LS($LS($LZ)), bots#0), i#26), 
      DynamicPkv.__default.PKVISeq($LS($LZ), bots#0));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1342,36)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$BucketModel.__default.reveal__partialFlush();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1342,37)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1343,31)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type MergeResult
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    top##0 := top#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    pivots##0 := pivots#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    bots##0 := bots#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    slack##0 := slack#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$DynamicPkv.__default.MergeToChildren(top##0, pivots##0, bots##0, slack##0);
    // TrCallStmt: After ProcessCallStmt
    res#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1343,56)"} true;
    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1344,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1344,5)
    assume true;
    assume DynamicPkv.MergeResult.MergeResult_q(res#0);
    assume DynamicPkv.MergeResult.MergeResult_q(res#0);
    assume DynamicPkv.MergeResult.MergeResult_q(res#0)
       && DynamicPkv.MergeResult.MergeResult_q(res#0);
    result#0 := #DynamicPkv.PartialFlushResult.PartialFlushResult(DynamicPkv.MergeResult.top(res#0), DynamicPkv.MergeResult.bots(res#0));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedKV.i.dfy(1344,48)"} true;
    return;
}



function Tclass.NativeTypes.sbyte() : Ty;

// Tclass.NativeTypes.sbyte Tag
axiom Tag(Tclass.NativeTypes.sbyte()) == Tagclass.NativeTypes.sbyte;

const unique Tagclass.NativeTypes.sbyte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.sbyte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.sbyte()) } 
  $IsBox(bx, Tclass.NativeTypes.sbyte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.sbyte()));

// NativeTypes.sbyte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.sbyte()) } 
  $Is(i#0, Tclass.NativeTypes.sbyte()) <==> LitInt(0 - 128) <= i#0 && i#0 < 128);

// NativeTypes.sbyte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h));

const unique class.NativeTypes.sbyte: ClassName;

// NativeTypes.byte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.byte()) } 
  $Is(i#0, Tclass.NativeTypes.byte()) <==> LitInt(0) <= i#0 && i#0 < 256);

// NativeTypes.byte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h));

const unique class.NativeTypes.byte: ClassName;

function Tclass.NativeTypes.int16() : Ty;

// Tclass.NativeTypes.int16 Tag
axiom Tag(Tclass.NativeTypes.int16()) == Tagclass.NativeTypes.int16;

const unique Tagclass.NativeTypes.int16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int16()) } 
  $IsBox(bx, Tclass.NativeTypes.int16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int16()));

// NativeTypes.int16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int16()) } 
  $Is(i#0, Tclass.NativeTypes.int16())
     <==> LitInt(0 - 32768) <= i#0 && i#0 < 32768);

// NativeTypes.int16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h));

const unique class.NativeTypes.int16: ClassName;

function Tclass.NativeTypes.uint16() : Ty;

// Tclass.NativeTypes.uint16 Tag
axiom Tag(Tclass.NativeTypes.uint16()) == Tagclass.NativeTypes.uint16;

const unique Tagclass.NativeTypes.uint16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint16()) } 
  $IsBox(bx, Tclass.NativeTypes.uint16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint16()));

// NativeTypes.uint16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint16()) } 
  $Is(i#0, Tclass.NativeTypes.uint16()) <==> LitInt(0) <= i#0 && i#0 < 65536);

// NativeTypes.uint16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h));

const unique class.NativeTypes.uint16: ClassName;

function Tclass.NativeTypes.int32() : Ty;

// Tclass.NativeTypes.int32 Tag
axiom Tag(Tclass.NativeTypes.int32()) == Tagclass.NativeTypes.int32;

const unique Tagclass.NativeTypes.int32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int32()) } 
  $IsBox(bx, Tclass.NativeTypes.int32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int32()));

// NativeTypes.int32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int32()) } 
  $Is(i#0, Tclass.NativeTypes.int32())
     <==> LitInt(0 - 2147483648) <= i#0 && i#0 < 2147483648);

// NativeTypes.int32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h));

const unique class.NativeTypes.int32: ClassName;

// NativeTypes.uint32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint32()) } 
  $Is(i#0, Tclass.NativeTypes.uint32()) <==> LitInt(0) <= i#0 && i#0 < 4294967296);

// NativeTypes.uint32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h));

const unique class.NativeTypes.uint32: ClassName;

function Tclass.NativeTypes.int64() : Ty;

// Tclass.NativeTypes.int64 Tag
axiom Tag(Tclass.NativeTypes.int64()) == Tagclass.NativeTypes.int64;

const unique Tagclass.NativeTypes.int64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int64()) } 
  $IsBox(bx, Tclass.NativeTypes.int64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int64()));

// NativeTypes.int64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int64()) } 
  $Is(i#0, Tclass.NativeTypes.int64())
     <==> LitInt(0 - 9223372036854775808) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.int64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h));

const unique class.NativeTypes.int64: ClassName;

// NativeTypes.uint64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint64()) } 
  $Is(i#0, Tclass.NativeTypes.uint64())
     <==> LitInt(0) <= i#0 && i#0 < 18446744073709551616);

// NativeTypes.uint64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h));

const unique class.NativeTypes.uint64: ClassName;

function Tclass.NativeTypes.nat8() : Ty;

// Tclass.NativeTypes.nat8 Tag
axiom Tag(Tclass.NativeTypes.nat8()) == Tagclass.NativeTypes.nat8;

const unique Tagclass.NativeTypes.nat8: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat8
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat8()) } 
  $IsBox(bx, Tclass.NativeTypes.nat8())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat8()));

// NativeTypes.nat8: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat8()) } 
  $Is(i#0, Tclass.NativeTypes.nat8()) <==> LitInt(0) <= i#0 && i#0 < 128);

// NativeTypes.nat8: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h));

const unique class.NativeTypes.nat8: ClassName;

function Tclass.NativeTypes.nat16() : Ty;

// Tclass.NativeTypes.nat16 Tag
axiom Tag(Tclass.NativeTypes.nat16()) == Tagclass.NativeTypes.nat16;

const unique Tagclass.NativeTypes.nat16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat16()) } 
  $IsBox(bx, Tclass.NativeTypes.nat16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat16()));

// NativeTypes.nat16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat16()) } 
  $Is(i#0, Tclass.NativeTypes.nat16()) <==> LitInt(0) <= i#0 && i#0 < 32768);

// NativeTypes.nat16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h));

const unique class.NativeTypes.nat16: ClassName;

function Tclass.NativeTypes.nat32() : Ty;

// Tclass.NativeTypes.nat32 Tag
axiom Tag(Tclass.NativeTypes.nat32()) == Tagclass.NativeTypes.nat32;

const unique Tagclass.NativeTypes.nat32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat32()) } 
  $IsBox(bx, Tclass.NativeTypes.nat32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat32()));

// NativeTypes.nat32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat32()) } 
  $Is(i#0, Tclass.NativeTypes.nat32()) <==> LitInt(0) <= i#0 && i#0 < 2147483648);

// NativeTypes.nat32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h));

const unique class.NativeTypes.nat32: ClassName;

function Tclass.NativeTypes.nat64() : Ty;

// Tclass.NativeTypes.nat64 Tag
axiom Tag(Tclass.NativeTypes.nat64()) == Tagclass.NativeTypes.nat64;

const unique Tagclass.NativeTypes.nat64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat64()) } 
  $IsBox(bx, Tclass.NativeTypes.nat64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat64()));

// NativeTypes.nat64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat64()) } 
  $Is(i#0, Tclass.NativeTypes.nat64())
     <==> LitInt(0) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.nat64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h));

const unique class.NativeTypes.nat64: ClassName;

const unique class.NativeTypes.__default: ClassName;

function Tclass.NativeTypes.__default() : Ty;

// Tclass.NativeTypes.__default Tag
axiom Tag(Tclass.NativeTypes.__default()) == Tagclass.NativeTypes.__default;

const unique Tagclass.NativeTypes.__default: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.__default()) } 
  $IsBox(bx, Tclass.NativeTypes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeTypes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeTypes.__default()) } 
  $Is($o, Tclass.NativeTypes.__default())
     <==> $o == null || dtype($o) == Tclass.NativeTypes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeTypes.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeTypes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativeTypes._default.Uint64Size
function NativeTypes.__default.Uint64Size() : int;

function NativeTypes.__default.Uint64Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint64Size()
     && NativeTypes.__default.Uint64Size() < 18446744073709551616;

function NativeTypes.__default.Uint64Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64Size
axiom NativeTypes.__default.Uint64Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint64Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// definition axiom for NativeTypes.__default.Uint64Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// function declaration for NativeTypes._default.Uint32Size
function NativeTypes.__default.Uint32Size() : int;

function NativeTypes.__default.Uint32Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint32Size()
     && NativeTypes.__default.Uint32Size() < 18446744073709551616;

function NativeTypes.__default.Uint32Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32Size
axiom NativeTypes.__default.Uint32Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint32Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// definition axiom for NativeTypes.__default.Uint32Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// function declaration for NativeTypes._default.Uint16Size
function NativeTypes.__default.Uint16Size() : int;

function NativeTypes.__default.Uint16Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint16Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint16Size()
     && NativeTypes.__default.Uint16Size() < 18446744073709551616;

function NativeTypes.__default.Uint16Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint16Size
axiom NativeTypes.__default.Uint16Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint16Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// definition axiom for NativeTypes.__default.Uint16Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// function declaration for NativeTypes._default.Uint64UpperBound
function NativeTypes.__default.Uint64UpperBound() : int;

function NativeTypes.__default.Uint64UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint64UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64UpperBound
axiom NativeTypes.__default.Uint64UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint64UpperBound(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// definition axiom for NativeTypes.__default.Uint64UpperBound for all literals(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// function declaration for NativeTypes._default.Uint32UpperBound
function NativeTypes.__default.Uint32UpperBound() : int;

function NativeTypes.__default.Uint32UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint32UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32UpperBound
axiom NativeTypes.__default.Uint32UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint32UpperBound(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// definition axiom for NativeTypes.__default.Uint32UpperBound for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// Constructor function declaration
function #Options.Option.None() : DatatypeType;

const unique ##Options.Option.None: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#Options.Option.None()) == ##Options.Option.None;

function Options.Option.None_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) <==> DatatypeCtorId(d) == ##Options.Option.None);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) ==> d == #Options.Option.None());

function Tclass.Options.Option(Ty) : Ty;

// Tclass.Options.Option Tag
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tag(Tclass.Options.Option(Options.Option$V)) == Tagclass.Options.Option);

const unique Tagclass.Options.Option: TyTag;

// Tclass.Options.Option injectivity 0
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tclass.Options.Option_0(Tclass.Options.Option(Options.Option$V))
     == Options.Option$V);

function Tclass.Options.Option_0(Ty) : Ty;

// Box/unbox axiom for Tclass.Options.Option
axiom (forall Options.Option$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.Options.Option(Options.Option$V)) } 
  $IsBox(bx, Tclass.Options.Option(Options.Option$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Options.Option(Options.Option$V)));

// Constructor $Is
axiom (forall Options.Option$V: Ty :: 
  { $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, $h: Heap :: 
  { $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h));

// Constructor literal
axiom #Options.Option.None() == Lit(#Options.Option.None());

// Constructor function declaration
function #Options.Option.Some(Box) : DatatypeType;

const unique ##Options.Option.Some: DtCtorId;

// Constructor identifier
axiom (forall a#5#0#0: Box :: 
  { #Options.Option.Some(a#5#0#0) } 
  DatatypeCtorId(#Options.Option.Some(a#5#0#0)) == ##Options.Option.Some);

function Options.Option.Some_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d) <==> DatatypeCtorId(d) == ##Options.Option.Some);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d)
     ==> (exists a#6#0#0: Box :: d == #Options.Option.Some(a#6#0#0)));

// Constructor $Is
axiom (forall Options.Option$V: Ty, a#7#0#0: Box :: 
  { $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V))
     <==> $IsBox(a#7#0#0, Options.Option$V));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, a#8#0#0: Box, $h: Heap :: 
  { $IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h)
       <==> $IsAllocBox(a#8#0#0, Options.Option$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, Options.Option$V: Ty, $h: Heap :: 
  { $IsAllocBox(Options.Option.value(d), Options.Option$V, $h) } 
  $IsGoodHeap($h)
       && 
      Options.Option.Some_q(d)
       && $IsAlloc(d, Tclass.Options.Option(Options.Option$V), $h)
     ==> $IsAllocBox(Options.Option.value(d), Options.Option$V, $h));

// Constructor literal
axiom (forall a#9#0#0: Box :: 
  { #Options.Option.Some(Lit(a#9#0#0)) } 
  #Options.Option.Some(Lit(a#9#0#0)) == Lit(#Options.Option.Some(a#9#0#0)));

function Options.Option.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#10#0#0: Box :: 
  { #Options.Option.Some(a#10#0#0) } 
  Options.Option.value(#Options.Option.Some(a#10#0#0)) == a#10#0#0);

// Inductive rank
axiom (forall a#11#0#0: Box :: 
  { #Options.Option.Some(a#11#0#0) } 
  BoxRank(a#11#0#0) < DtRank(#Options.Option.Some(a#11#0#0)));

// Depth-one case-split function
function $IsA#Options.Option(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Options.Option(d) } 
  $IsA#Options.Option(d) ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Questionmark data type disjunctivity
axiom (forall Options.Option$V: Ty, d: DatatypeType :: 
  { Options.Option.Some_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
    { Options.Option.None_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
  $Is(d, Tclass.Options.Option(Options.Option$V))
     ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Datatype extensional equality declaration
function Options.Option#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Options.Option.None
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.None_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.None_q(b) } 
  Options.Option.None_q(a) && Options.Option.None_q(b)
     ==> (Options.Option#Equal(a, b) <==> true));

// Datatype extensional equality definition: #Options.Option.Some
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.Some_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.Some_q(b) } 
  Options.Option.Some_q(a) && Options.Option.Some_q(b)
     ==> (Options.Option#Equal(a, b)
       <==> Options.Option.value(a) == Options.Option.value(b)));

// Datatype extensionality axiom: Options.Option
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b) } 
  Options.Option#Equal(a, b) <==> a == b);

const unique class.Options.Option: ClassName;

const unique class.Options.__default: ClassName;

function Tclass.Options.__default() : Ty;

// Tclass.Options.__default Tag
axiom Tag(Tclass.Options.__default()) == Tagclass.Options.__default;

const unique Tagclass.Options.__default: TyTag;

// Box/unbox axiom for Tclass.Options.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Options.__default()) } 
  $IsBox(bx, Tclass.Options.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Options.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Options.__default()) } 
  $Is($o, Tclass.Options.__default())
     <==> $o == null || dtype($o) == Tclass.Options.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Options.__default(), $h) } 
  $IsAlloc($o, Tclass.Options.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Options._default.MapOption
function Options.__default.MapOption(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.MapOption#canCall(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
       == Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0));

// consequence axiom for Options.__default.MapOption
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
           <==> Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)))
         && (Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
           ==> Options.Option.value(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
             == Apply1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0)))
         && $Is(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0), 
          Tclass.Options.Option(Options._default.MapOption$V1)));

function Options.__default.MapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
     ==> Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.MapOption$V0, 
          Options._default.MapOption$V1, 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.MapOption(revealed)
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#3 := Options.Option.value(opt#0); 
            #Options.Option.Some(Apply1(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, f#0, v#3)))));

// function declaration for Options._default.FlatMapOption
function Options.__default.FlatMapOption(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $h1, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $h0, 
          opt#0, 
          f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h0, 
        opt#0, 
        f#0)
       == Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h1, 
        opt#0, 
        f#0));

// consequence axiom for Options.__default.FlatMapOption
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.Some_q(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
              Options._default.FlatMapOption$V1, 
              $Heap, 
              opt#0, 
              f#0)))
         && (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.value(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
                Options._default.FlatMapOption$V1, 
                $Heap, 
                opt#0, 
                f#0))
             == Options.Option.value($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType))
         && $Is(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
            Options._default.FlatMapOption$V1, 
            $Heap, 
            opt#0, 
            f#0), 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)));

function Options.__default.FlatMapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $Heap, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)))
     ==> Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1), 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.FlatMapOption(revealed)
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#3 := Options.Option.value(opt#0); 
            $Unbox(Apply1(Options._default.FlatMapOption$V0, 
                Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                $Heap, 
                f#0, 
                v#3)): DatatypeType)));

const unique class.NativePackedInts.__default: ClassName;

function Tclass.NativePackedInts.__default() : Ty;

// Tclass.NativePackedInts.__default Tag
axiom Tag(Tclass.NativePackedInts.__default()) == Tagclass.NativePackedInts.__default;

const unique Tagclass.NativePackedInts.__default: TyTag;

// Box/unbox axiom for Tclass.NativePackedInts.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativePackedInts.__default()) } 
  $IsBox(bx, Tclass.NativePackedInts.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativePackedInts.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativePackedInts.__default()) } 
  $Is($o, Tclass.NativePackedInts.__default())
     <==> $o == null || dtype($o) == Tclass.NativePackedInts.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativePackedInts.__default(), $h) } 
  $IsAlloc($o, Tclass.NativePackedInts.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32
function NativePackedInts.__default.unpack__LittleEndian__Uint32($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) < 4294967296);

function NativePackedInts.__default.unpack__LittleEndian__Uint32#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(4)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64
function NativePackedInts.__default.unpack__LittleEndian__Uint64($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
           < 18446744073709551616);

function NativePackedInts.__default.unpack__LittleEndian__Uint64#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(8)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(7))): int, LitInt(72057594037927936)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                i#1)): int } 
          LitInt(0) <= i#1 && i#1 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                  i#1)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), i#1) + 4), Mul(LitInt(4), i#1))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint32())));

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(4))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(4))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))))));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                i#1)): int } 
          LitInt(0) <= i#1 && i#1 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                  i#1)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), i#1) + 8), Mul(LitInt(8), i#1))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint64())));

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(8))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(8))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))))));

const unique class.SeqComparison.__default: ClassName;

function Tclass.SeqComparison.__default() : Ty;

// Tclass.SeqComparison.__default Tag
axiom Tag(Tclass.SeqComparison.__default()) == Tagclass.SeqComparison.__default;

const unique Tagclass.SeqComparison.__default: TyTag;

// Box/unbox axiom for Tclass.SeqComparison.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SeqComparison.__default()) } 
  $IsBox(bx, Tclass.SeqComparison.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.SeqComparison.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.SeqComparison.__default()) } 
  $Is($o, Tclass.SeqComparison.__default())
     <==> $o == null || dtype($o) == Tclass.SeqComparison.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.SeqComparison.__default(), $h) } 
  $IsAlloc($o, Tclass.SeqComparison.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for SeqComparison._default.lte
function SeqComparison.__default.lte($ly: LayerType, a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
  SeqComparison.__default.lte($LS($ly), a#0, b#0)
     == SeqComparison.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  SeqComparison.__default.lte($ly, a#0, b#0)
     == SeqComparison.__default.lte($LZ, a#0, b#0));

// consequence axiom for SeqComparison.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($ly, a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lte
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte#requires($ly, a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lte#requires($ly, a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int <= $Unbox(Seq#Index(a#0, LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(a#0, LitInt(0))): int <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(a#0, LitInt(0))): int < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int < $Unbox(Seq#Index(a#0, LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($ly, Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0)
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(Lit(b#0)) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(Lit(b#0)) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))))));

// function declaration for SeqComparison._default.lt
function SeqComparison.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for SeqComparison.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lt#requires(a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && SeqComparison.__default.lt(a#0, b#0)
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0)
             && !Seq#Equal(a#0, b#0)));

// definition axiom for SeqComparison.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lt(Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && SeqComparison.__default.lt(Lit(a#0), Lit(b#0))
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

const unique class.NativeArrays.__default: ClassName;

function Tclass.NativeArrays.__default() : Ty;

// Tclass.NativeArrays.__default Tag
axiom Tag(Tclass.NativeArrays.__default()) == Tagclass.NativeArrays.__default;

const unique Tagclass.NativeArrays.__default: TyTag;

// Box/unbox axiom for Tclass.NativeArrays.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeArrays.__default()) } 
  $IsBox(bx, Tclass.NativeArrays.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeArrays.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeArrays.__default()) } 
  $Is($o, Tclass.NativeArrays.__default())
     <==> $o == null || dtype($o) == Tclass.NativeArrays.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeArrays.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeArrays.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

const unique class.Sequences.__default: ClassName;

function Tclass.Sequences.__default() : Ty;

// Tclass.Sequences.__default Tag
axiom Tag(Tclass.Sequences.__default()) == Tagclass.Sequences.__default;

const unique Tagclass.Sequences.__default: TyTag;

// Box/unbox axiom for Tclass.Sequences.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sequences.__default()) } 
  $IsBox(bx, Tclass.Sequences.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Sequences.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sequences.__default()) } 
  $Is($o, Tclass.Sequences.__default())
     <==> $o == null || dtype($o) == Tclass.Sequences.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sequences.__default(), $h) } 
  $IsAlloc($o, Tclass.Sequences.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Sequences._default.Last
function Sequences.__default.Last(Sequences._default.Last$E: Ty, run#0: Seq Box) : Box;

function Sequences.__default.Last#canCall(Sequences._default.Last$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Last
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> $IsBox(Sequences.__default.Last(Sequences._default.Last$E, run#0), 
        Sequences._default.Last$E));

function Sequences.__default.Last#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Last
axiom (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.Last#requires(Sequences._default.Last$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Last$E))
     ==> Sequences.__default.Last#requires(Sequences._default.Last$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.Last(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, run#0)
         == Seq#Index(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.Last for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0)) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0))
         == Seq#Index(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.DropLast
function Sequences.__default.DropLast(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : Seq Box;

function Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.DropLast
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> $Is(Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0), 
        TSeq(Sequences._default.DropLast$E)));

function Sequences.__default.DropLast#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.DropLast
axiom (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.DropLast$E))
     ==> Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.DropLast(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0)
         == Seq#Take(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0)) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0))
         == Seq#Take(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.Set
function Sequences.__default.Set(Sequences._default.Set$T: Ty, run#0: Seq Box) : Set Box;

function Sequences.__default.Set#canCall(Sequences._default.Set$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Set
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> $Is(Sequences.__default.Set(Sequences._default.Set$T, run#0), 
        TSet(Sequences._default.Set$T)));

function Sequences.__default.Set#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Set
axiom (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Set$T))
     ==> Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) == true);

// definition axiom for Sequences.__default.Set(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, run#0)
         == (lambda $y#2: Box :: 
          $IsBox($y#2, Sequences._default.Set$T) && MultiSet#FromSeq(run#0)[$y#2] > 0));

// definition axiom for Sequences.__default.Set for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0)) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0))
         == (lambda $y#3: Box :: 
          $IsBox($y#3, Sequences._default.Set$T) && MultiSet#FromSeq(Lit(run#0))[$y#3] > 0));

// function declaration for Sequences._default.ISet
function Sequences.__default.ISet(Sequences._default.ISet$T: Ty, run#0: Seq Box) : ISet Box;

function Sequences.__default.ISet#canCall(Sequences._default.ISet$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.ISet
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> $Is(Sequences.__default.ISet(Sequences._default.ISet$T, run#0), 
        TISet(Sequences._default.ISet$T)));

function Sequences.__default.ISet#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.ISet
axiom (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.ISet$T))
     ==> Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) == true);

// definition axiom for Sequences.__default.ISet(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, run#0)
         == (lambda $y#2: Box :: 
          $IsBox($y#2, Sequences._default.ISet$T) && MultiSet#FromSeq(run#0)[$y#2] > 0));

// definition axiom for Sequences.__default.ISet for all literals(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0)) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0))
         == (lambda $y#3: Box :: 
          $IsBox($y#3, Sequences._default.ISet$T)
             && MultiSet#FromSeq(Lit(run#0))[$y#3] > 0));

// function declaration for Sequences._default.NoDupes
function Sequences.__default.NoDupes(Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box) : bool;

function Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, AsFuelBottom($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LZ, a#0));

// consequence axiom for Sequences.__default.NoDupes
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> true);

function Sequences.__default.NoDupes#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.NoDupes
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0) } 
  $Is(a#0, TSeq(Sequences._default.NoDupes$T))
     ==> Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.NoDupes(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
         == (forall i#2: int, j#2: int :: 
          { Seq#Index(a#0, j#2), Seq#Index(a#0, i#2) } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 < Seq#Length(a#0)
               && 
              LitInt(0) <= j#2
               && j#2 < Seq#Length(a#0)
               && i#2 != j#2
             ==> Seq#Index(a#0, i#2) != Seq#Index(a#0, j#2)));

// definition axiom for Sequences.__default.NoDupes for all literals(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0)) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, Lit(a#0))
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0))
         == (forall i#3: int, j#3: int :: 
          { Seq#Index(a#0, j#3), Seq#Index(a#0, i#3) } 
          true
             ==> 
            LitInt(0) <= i#3
               && i#3 < Seq#Length(Lit(a#0))
               && 
              LitInt(0) <= j#3
               && j#3 < Seq#Length(Lit(a#0))
               && i#3 != j#3
             ==> Seq#Index(Lit(a#0), i#3) != Seq#Index(Lit(a#0), j#3)));

// function declaration for Sequences._default.IndexOf
function Sequences.__default.IndexOf(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : int;

function Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : bool;

// consequence axiom for Sequences.__default.IndexOf
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> LitInt(0) <= Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           < Seq#Length(s#0)
         && Seq#Index(s#0, Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0))
           == e#0);

function Sequences.__default.IndexOf#requires(Ty, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.IndexOf
axiom (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
  { Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
       && $IsBox(e#0, Sequences._default.IndexOf$T)
     ==> Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0)
       == Seq#Contains(s#0, e#0));

function $let#0_i(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : int;

function $let#0$canCall(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : bool;

axiom (forall Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box :: 
  { $let#0_i(Sequences._default.IndexOf$T, s, e) } 
  $let#0$canCall(Sequences._default.IndexOf$T, s, e)
     ==> LitInt(0) <= $let#0_i(Sequences._default.IndexOf$T, s, e)
       && $let#0_i(Sequences._default.IndexOf$T, s, e) < Seq#Length(s)
       && Seq#Index(s, $let#0_i(Sequences._default.IndexOf$T, s, e)) == e);

// definition axiom for Sequences.__default.IndexOf(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           == (var i#3 := $let#0_i(Sequences._default.IndexOf$T, s#0, e#0); i#3));

// definition axiom for Sequences.__default.IndexOf for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0)
           == (var i#4 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), e#0); i#4));

// definition axiom for Sequences.__default.IndexOf for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
           == (var i#5 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)); i#5));

// function declaration for Sequences._default.Range
function Sequences.__default.Range($ly: LayerType, n#0: int) : Seq Box;

function Sequences.__default.Range#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range($LS($ly), n#0) } 
  Sequences.__default.Range($LS($ly), n#0) == Sequences.__default.Range($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range(AsFuelBottom($ly), n#0) } 
  Sequences.__default.Range($ly, n#0) == Sequences.__default.Range($LZ, n#0));

// consequence axiom for Sequences.__default.Range
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($ly, n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(Sequences.__default.Range($ly, n#0)) == n#0
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#1)): int } 
          LitInt(0) <= i#1 && i#1 < n#0
             ==> $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#1)): int == i#1)
         && $Is(Sequences.__default.Range($ly, n#0), TSeq(TInt)));

function Sequences.__default.Range#requires(LayerType, int) : bool;

// #requires axiom for Sequences.__default.Range
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range#requires($ly, n#0) } 
  Sequences.__default.Range#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.Range(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($LS($ly), n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0) ==> Sequences.__default.Range#canCall(n#0 - 1))
         && Sequences.__default.Range($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(n#0 - 1)))));

// definition axiom for Sequences.__default.Range for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { Sequences.__default.Range($LS($ly), LitInt(n#0)) } 
    Sequences.__default.Range#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.Range#canCall(LitInt(n#0 - 1)))
         && Sequences.__default.Range($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(n#0 - 1))))));

// function declaration for Sequences._default.Apply
function Sequences.__default.Apply(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Apply#canCall(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $h0, f#0, run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h0, f#0, run#0)
       == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Apply
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#4: int :: 
            { Seq#Index(run#0, i#4) } 
            true
               ==> 
              LitInt(0) <= i#4 && i#4 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#4))))
       ==> Seq#Length(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0))
           == Seq#Length(run#0)
         && (forall i#5: int :: 
          { Seq#Index(run#0, i#5) } 
            { Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
              i#5) } 
          true
             ==> 
            LitInt(0) <= i#5 && i#5 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
                i#5)
               == Apply1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#5)))
         && $Is(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Apply$R)));

function Sequences.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
       && $Is(run#0, TSeq(Sequences._default.Apply$E))
     ==> Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
       == (forall i#6: int :: 
        { Seq#Index(run#0, i#6) } 
        true
           ==> 
          LitInt(0) <= i#6 && i#6 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#6))));

// definition axiom for Sequences.__default.Apply(revealed)
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, 
        Sequences._default.Apply$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#6: int :: 
            { Seq#Index(run#0, i#6) } 
            true
               ==> 
              LitInt(0) <= i#6 && i#6 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#6))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Apply#canCall(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Apply(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                Apply1(Sequences._default.Apply$E, 
                  Sequences._default.Apply$R, 
                  $Heap, 
                  f#0, 
                  Seq#Index(run#0, LitInt(0)))), 
              Sequences.__default.Apply(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $ly, 
                $Heap, 
                f#0, 
                Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.ApplyOpaque
function Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LZ, 
      $Heap, 
      f#0, 
      run#0));

// frame axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $h1, 
      f#0, 
      run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $h0, 
          f#0, 
          run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h0, 
        f#0, 
        run#0)
       == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h1, 
        f#0, 
        run#0));

// consequence axiom for Sequences.__default.ApplyOpaque
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#4: int :: 
            { Seq#Index(run#0, i#4) } 
            true
               ==> 
              LitInt(0) <= i#4 && i#4 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#4))))
       ==> Seq#Length(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
              Sequences._default.ApplyOpaque$R, 
              $ly, 
              $Heap, 
              f#0, 
              run#0))
           == Seq#Length(run#0)
         && (forall i#5: int :: 
          { Seq#Index(run#0, i#5) } 
            { Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $ly, 
                $Heap, 
                f#0, 
                run#0), 
              i#5) } 
          true
             ==> 
            LitInt(0) <= i#5 && i#5 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                  Sequences._default.ApplyOpaque$R, 
                  $ly, 
                  $Heap, 
                  f#0, 
                  run#0), 
                i#5)
               == Apply1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#5)))
         && $Is(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $ly, 
            $Heap, 
            f#0, 
            run#0), 
          TSeq(Sequences._default.ApplyOpaque$R)));

function Sequences.__default.ApplyOpaque#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
       && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
     ==> Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0)
       == (forall i#6: int :: 
        { Seq#Index(run#0, i#6) } 
        true
           ==> 
          LitInt(0) <= i#6 && i#6 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#6))));

// definition axiom for Sequences.__default.ApplyOpaque(revealed)
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#6: int :: 
            { Seq#Index(run#0, i#6) } 
            true
               ==> 
              LitInt(0) <= i#6 && i#6 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#6))))
       ==> Sequences.__default.Apply#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         && Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == Sequences.__default.Apply(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($LZ), 
            $Heap, 
            f#0, 
            run#0));

// function declaration for Sequences._default.Filter
function Sequences.__default.Filter(Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Filter#canCall(Sequences._default.Filter$E: Ty, $heap: Heap, f#0: HandleType, run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, AsFuelBottom($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $h0, f#0, run#0)
         || ($Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists _x1#0: Box, _o1#0: ref :: 
            $IsBox(_x1#0, Sequences._default.Filter$E)
               && $Is(_o1#0, Tclass._System.object?())
               && Reads1(Sequences._default.Filter$E, TBool, $h0, f#0, _x1#0)[$Box(_o1#0)]
               && $Box($o) == $Box(_o1#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h0, f#0, run#0)
       == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Filter
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#3))))
       ==> Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
           <= Seq#Length(run#0)
         && (forall i#4: int :: 
          { Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
              i#4) } 
          LitInt(0) <= i#4
             ==> 
            i#4
                 < Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
               && Requires1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#4))
             ==> $Unbox(Apply1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#4))): bool)
         && $Is(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Filter$E)));

function Sequences.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
       && $Is(run#0, TSeq(Sequences._default.Filter$E))
     ==> Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
       == (forall i#5: int :: 
        { Seq#Index(run#0, i#5) } 
        true
           ==> 
          LitInt(0) <= i#5 && i#5 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#5))));

// definition axiom for Sequences.__default.Filter(revealed)
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#5: int :: 
            { Seq#Index(run#0, i#5) } 
            true
               ==> 
              LitInt(0) <= i#5 && i#5 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#5))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append((if $Unbox(Apply1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, LitInt(0)))): bool
                 then Seq#Build(Seq#Empty(): Seq Box, Seq#Index(run#0, LitInt(0)))
                 else Seq#Empty(): Seq Box), 
              Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.FoldLeft
function Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldLeft
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> $IsBox(Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldLeft$A));

function Sequences.__default.FoldLeft#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldLeft
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Sequences._default.FoldLeft$A))
       && $IsBox(init#0, Sequences._default.FoldLeft$A)
       && $Is(run#0, TSeq(Sequences._default.FoldLeft$E))
     ==> Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldLeft(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(run#0, LitInt(0))), 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $ly, 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(run#0, LitInt(0))), 
              Seq#Drop(run#0, LitInt(1)))));

// definition axiom for Sequences.__default.FoldLeft for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// definition axiom for Sequences.__default.FoldLeft for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            Lit(f#0), 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              Lit(f#0), 
              Lit(init#0), 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              Lit(f#0), 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                Lit(f#0), 
                Lit(init#0), 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// function declaration for Sequences._default.FoldRight
function Sequences.__default.FoldRight(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldRight
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> $IsBox(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldRight$A));

function Sequences.__default.FoldRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldRight
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Sequences._default.FoldRight$A))
       && $IsBox(init#0, Sequences._default.FoldRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldRight$E))
     ==> Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Seq#Drop(run#0, LitInt(1))), 
              Seq#Index(run#0, LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Seq#Drop(Lit(run#0), LitInt(1)))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            Lit(f#0), 
            Lit(init#0), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                  Sequences._default.FoldRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Seq#Drop(Lit(run#0), LitInt(1))))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// function declaration for Sequences._default.FoldFromRight
function Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldFromRight
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> $IsBox(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldFromRight$A));

function Sequences.__default.FoldFromRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldFromRight
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Sequences._default.FoldFromRight$A))
       && $IsBox(init#0, Sequences._default.FoldFromRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E))
     ==> Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldFromRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, run#0)
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, run#0))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0)), 
              Sequences.__default.Last(Sequences._default.FoldFromRight$E, run#0))));

// definition axiom for Sequences.__default.FoldFromRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0)))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// definition axiom for Sequences.__default.FoldFromRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Lit(f#0), 
              Lit(init#0), 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                  Sequences._default.FoldFromRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// function declaration for Sequences._default.remove
function Sequences.__default.remove(Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int)
   : Seq Box;

function Sequences.__default.remove#canCall(Sequences._default.remove$A: Ty, s#0: Seq Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, AsFuelBottom($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $LZ, s#0, pos#0));

// consequence axiom for Sequences.__default.remove
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#2: int :: 
          { Seq#Index(s#0, i#2) } 
            { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#2) } 
          LitInt(0) <= i#2 && i#2 < pos#0
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#2)
               == Seq#Index(s#0, i#2))
         && (forall i#3: int :: 
          { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#3) } 
          pos#0 <= i#3 && i#3 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#3)
               == Seq#Index(s#0, i#3 + 1))
         && $Is(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), 
          TSeq(Sequences._default.remove$A)));

function Sequences.__default.remove#requires(Ty, LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.remove
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.remove$A))
     ==> Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.remove(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
         == Seq#Append(Seq#Take(s#0, pos#0), Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.remove for all literals(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    {:weight 3} { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0)) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, Lit(s#0), LitInt(pos#0))
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0))
         == Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.insert
function Sequences.__default.insert(Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.insert#canCall(Sequences._default.insert$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.insert
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#2: int :: 
          { Seq#Index(s#0, i#2) } 
            { Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < pos#0
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#2)
               == Seq#Index(s#0, i#2))
         && (forall i#3: int :: 
          { Seq#Index(s#0, i#3) } 
          true
             ==> 
            pos#0 <= i#3 && i#3 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#3 + 1)
               == Seq#Index(s#0, i#3))
         && Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.insert$A)));

function Sequences.__default.insert#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.insert
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.insert$A))
       && $IsBox(a#0, Sequences._default.insert$A)
     ==> Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 <= Seq#Length(s#0)));

// definition axiom for Sequences.__default.insert(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0)));

// definition axiom for Sequences.__default.insert for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// definition axiom for Sequences.__default.insert for all literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// function declaration for Sequences._default.replace1with2
function Sequences.__default.replace1with2(Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A: Ty, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, AsFuelBottom($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LZ, s#0, a#0, b#0, pos#0));

// consequence axiom for Sequences.__default.replace1with2
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#2: int :: 
          { Seq#Index(s#0, i#2) } 
            { Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < pos#0
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#2)
               == Seq#Index(s#0, i#2))
         && (forall i#3: int :: 
          { Seq#Index(s#0, i#3) } 
          true
             ==> 
            pos#0 < i#3 && i#3 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#3 + 1)
               == Seq#Index(s#0, i#3))
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0)
           == a#0
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0 + 1)
           == b#0
         && $Is(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
          TSeq(Sequences._default.replace1with2$A)));

function Sequences.__default.replace1with2#requires(Ty, LayerType, Seq Box, Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace1with2
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace1with2$A))
       && $IsBox(a#0, Sequences._default.replace1with2$A)
       && $IsBox(b#0, Sequences._default.replace1with2$A)
     ==> Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.replace1with2(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.replace1with2 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), a#0, b#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// definition axiom for Sequences.__default.replace1with2 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
        $LS($ly), 
        Lit(s#0), 
        Lit(a#0), 
        Lit(b#0), 
        LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), Lit(a#0), Lit(b#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
          $LS($ly), 
          Lit(s#0), 
          Lit(a#0), 
          Lit(b#0), 
          LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, Lit(a#0)), Lit(b#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.replace2with1
function Sequences.__default.replace2with1(Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.replace2with1
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Seq#Length(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#2: int :: 
          { Seq#Index(s#0, i#2) } 
            { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < pos#0
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#2)
               == Seq#Index(s#0, i#2))
         && (forall i#3: int :: 
          { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#3) } 
          true
             ==> 
            pos#0 < i#3 && i#3 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#3)
               == Seq#Index(s#0, i#3 + 1))
         && Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.replace2with1$A)));

function Sequences.__default.replace2with1#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace2with1
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace2with1$A))
       && $IsBox(a#0, Sequences._default.replace2with1$A)
     ==> Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0) - 1));

// definition axiom for Sequences.__default.replace2with1(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0 + 2)));

// definition axiom for Sequences.__default.replace2with1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// definition axiom for Sequences.__default.replace2with1 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// function declaration for Sequences._default.concat
function Sequences.__default.concat(Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat#canCall(Sequences._default.concat$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.concat
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Seq#Length(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0))
           == Seq#Length(a#0) + Seq#Length(b#0)
         && (forall i#2: int :: 
          { Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#2) } 
            { Seq#Index(a#0, i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#2)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#2))
         && (forall i#3: int :: 
          { Seq#Index(b#0, i#3) } 
          true
             ==> 
            LitInt(0) <= i#3 && i#3 < Seq#Length(b#0)
             ==> Seq#Index(b#0, i#3)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
                Seq#Length(a#0) + i#3))
         && $Is(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
          TSeq(Sequences._default.concat$A)));

function Sequences.__default.concat#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.concat$A))
       && $Is(b#0, TSeq(Sequences._default.concat$A))
     ==> Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.concat(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
         == Seq#Append(a#0, b#0));

// definition axiom for Sequences.__default.concat for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0))
         == Seq#Append(a#0, b#0));

// function declaration for Sequences._default.concat3
function Sequences.__default.concat3(Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat3#canCall(Sequences._default.concat3$A: Ty, a#0: Seq Box, b#0: Box, c#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, AsFuelBottom($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $LZ, a#0, b#0, c#0));

// consequence axiom for Sequences.__default.concat3
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Seq#Length(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0))
           == Seq#Length(a#0) + Seq#Length(c#0) + 1
         && (forall i#2: int :: 
          { Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
              i#2) } 
            { Seq#Index(a#0, i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#2)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                i#2))
         && Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
            Seq#Length(a#0))
           == b#0
         && (forall i#3: int :: 
          { Seq#Index(c#0, i#3) } 
          true
             ==> 
            LitInt(0) <= i#3 && i#3 < Seq#Length(c#0)
             ==> Seq#Index(c#0, i#3)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                Seq#Length(a#0) + 1 + i#3))
         && $Is(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
          TSeq(Sequences._default.concat3$A)));

function Sequences.__default.concat3#requires(Ty, LayerType, Seq Box, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat3
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
  $Is(a#0, TSeq(Sequences._default.concat3$A))
       && $IsBox(b#0, Sequences._default.concat3$A)
       && $Is(c#0, TSeq(Sequences._default.concat3$A))
     ==> Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
       == true);

// definition axiom for Sequences.__default.concat3(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), b#0, Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), Lit(b#0), Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, Lit(b#0))), c#0));

// function declaration for Sequences._default.concatSeq
function Sequences.__default.concatSeq(Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box) : Seq Box;

function Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, AsFuelBottom($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LZ, a#0));

// consequence axiom for Sequences.__default.concatSeq
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> $Is(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0), 
        TSeq(Sequences._default.concatSeq$A)));

function Sequences.__default.concatSeq#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.concatSeq
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0) } 
  $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
     ==> Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.concatSeq(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), a#0)
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), a#0))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), a#0)): Seq Box)));

// definition axiom for Sequences.__default.concatSeq for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0)) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, Lit(a#0))
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0))
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), Lit(a#0))): Seq Box)));

// function declaration for Sequences._default.IsPrefix
function Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsPrefix
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> 
      Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       ==> Seq#Length(a#0) <= Seq#Length(b#0));

function Sequences.__default.IsPrefix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsPrefix
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsPrefix$A))
       && $Is(b#0, TSeq(Sequences._default.IsPrefix$A))
     ==> Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsPrefix(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Take(b#0, Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsPrefix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Take(Lit(b#0), Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.IsSuffix
function Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsSuffix
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> true);

function Sequences.__default.IsSuffix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsSuffix
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsSuffix$A))
       && $Is(b#0, TSeq(Sequences._default.IsSuffix$A))
     ==> Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsSuffix(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Drop(b#0, Seq#Length(b#0) - Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsSuffix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.SeqIndexIterate
function Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : DatatypeType;

function Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A: Ty, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, AsFuelBottom($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LZ, run#0, needle#0, i#0));

// consequence axiom for Sequences.__default.SeqIndexIterate
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> (forall j#1: int :: 
            { Seq#Index(run#0, j#1) } 
            i#0 <= j#1 && j#1 < Seq#Length(run#0) ==> Seq#Index(run#0, j#1) != needle#0))
         && $Is(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndexIterate#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.SeqIndexIterate
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
       && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
     ==> Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(run#0)));

// definition axiom for Sequences.__default.SeqIndexIterate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (i#0 != Seq#Length(run#0)
           ==> 
          Seq#Index(run#0, i#0) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0 + 1))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
           == (if i#0 == Seq#Length(run#0)
             then #Options.Option.None()
             else (if Seq#Index(run#0, i#0) == needle#0
               then #Options.Option.Some($Box(i#0))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        needle#0, 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            needle#0, 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == needle#0
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                needle#0, 
                LitInt(i#0 + 1)))));

// definition axiom for Sequences.__default.SeqIndexIterate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        Lit(needle#0), 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != Lit(needle#0)
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == Lit(needle#0)
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                Lit(needle#0), 
                LitInt(i#0 + 1)))));

// function declaration for Sequences._default.SeqIndex
function Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box)
   : DatatypeType;

function Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A: Ty, run#0: Seq Box, needle#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, AsFuelBottom($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LZ, run#0, needle#0));

// consequence axiom for Sequences.__default.SeqIndex
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Seq#Index(run#0, i#1) != needle#0))
         && $Is(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndex#requires(Ty, LayerType, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndex
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndex$A))
       && $IsBox(needle#0, Sequences._default.SeqIndex$A)
     ==> Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
       == true);

// definition axiom for Sequences.__default.SeqIndex(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, run#0, needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            run#0, 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0)) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0))
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0), LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0))
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(0)));

// function declaration for Sequences._default.SeqOfLength
function Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box)
   : Seq Box;

function Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V: Ty, length#0: int, v#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, AsFuelBottom($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LZ, length#0, v#0));

// consequence axiom for Sequences.__default.SeqOfLength
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
           == length#0
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
              i#1) } 
          LitInt(0) <= i#1
               && i#1
                 < Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
             ==> Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
                i#1)
               == v#0)
         && $Is(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
          TSeq(Sequences._default.SeqOfLength$V)));

function Sequences.__default.SeqOfLength#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqOfLength
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
  LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V)
     ==> Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
       == true);

// definition axiom for Sequences.__default.SeqOfLength(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (length#0 != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0 - 1, v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
           == (if length#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0 - 1, v#0))));

// definition axiom for Sequences.__default.SeqOfLength for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0)
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), v#0))));

// definition axiom for Sequences.__default.SeqOfLength for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0)) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), Lit(v#0))
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), Lit(v#0)))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0))
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Lit(v#0)), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), Lit(v#0)))));

// function declaration for Sequences._default.SeqIndexUpdate
function Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box)
   : Seq Box;

function Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T: Ty, s#0: Seq Box, i#0: int, t#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, AsFuelBottom($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LZ, s#0, i#0, t#0));

// consequence axiom for Sequences.__default.SeqIndexUpdate
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Seq#Equal(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          Seq#Update(s#0, i#0, t#0))
         && $Is(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          TSeq(Sequences._default.SeqIndexUpdate$T)));

function Sequences.__default.SeqIndexUpdate#requires(Ty, LayerType, Seq Box, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndexUpdate
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
  $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
     ==> Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
       == (i#0 + 1 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.SeqIndexUpdate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(s#0, i#0 + 1)));

// definition axiom for Sequences.__default.SeqIndexUpdate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0)
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexUpdate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0)) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), Lit(t#0))
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(t#0))), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// function declaration for Sequences._default.Zip
function Sequences.__default.Zip(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : Seq Box;

function Sequences.__default.Zip#canCall(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.Zip
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
           == Seq#Length(a#0)
         && (forall i#1: int :: 
          { Seq#Index(b#0, i#1) } 
            { Seq#Index(a#0, i#1) } 
            { $Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                i#1)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1
                 < Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
             ==> _System.Tuple2#Equal($Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                  i#1)): DatatypeType, 
              #_System._tuple#2._#Make2(Seq#Index(a#0, i#1), Seq#Index(b#0, i#1))))
         && $Is(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
          TSeq(Tclass._System.Tuple2(Sequences._default.Zip$A, Sequences._default.Zip$B))));

function Sequences.__default.Zip#requires(Ty, Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.Zip
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.Zip$A))
       && $Is(b#0, TSeq(Sequences._default.Zip$B))
     ==> Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
       == 
      (Seq#Length(a#0)
       == Seq#Length(b#0)));

// definition axiom for Sequences.__default.Zip(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, b#0)
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
              Sequences.__default.DropLast(Sequences._default.Zip$B, b#0))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, b#0))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $ly, 
                Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
                Sequences.__default.DropLast(Sequences._default.Zip$B, b#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#_System._tuple#2._#Make2(Sequences.__default.Last(Sequences._default.Zip$A, a#0), 
                    Sequences.__default.Last(Sequences._default.Zip$B, b#0)))))));

// definition axiom for Sequences.__default.Zip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(Lit(a#0)) == Seq#Length(Lit(b#0)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, Lit(b#0))
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0))))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, Lit(b#0)))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#_System._tuple#2._#Make2(Lit(Sequences.__default.Last(Sequences._default.Zip$A, Lit(a#0))), 
                      Lit(Sequences.__default.Last(Sequences._default.Zip$B, Lit(b#0))))))))));

// function declaration for Sequences._default.Unzip
function Sequences.__default.Unzip(Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box)
   : DatatypeType;

function Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A: Ty, Sequences._default.Unzip$B: Ty, z#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0));

// fuel synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, AsFuelBottom($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LZ, z#0));

// consequence axiom for Sequences.__default.Unzip
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> Seq#Length($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
         && Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length(z#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(z#0, i#1)): DatatypeType } 
            { Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#1) } 
            { Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(z#0)
             ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#1), 
                Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#1)), 
              $Unbox(Seq#Index(z#0, i#1)): DatatypeType))
         && $Is(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0), 
          Tclass._System.Tuple2(TSeq(Sequences._default.Unzip$A), TSeq(Sequences._default.Unzip$B))));

function Sequences.__default.Unzip#requires(Ty, Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Unzip
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
  $Is(z#0, 
      TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
     ==> Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
       == true);

// definition axiom for Sequences.__default.Unzip(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(z#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                z#0))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType)
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
           == (if Seq#Length(z#0) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#2, b#2 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#2, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._0($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType)))), 
                $Box(Seq#Append(b#2, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._1($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType))))))));

// definition axiom for Sequences.__default.Unzip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0)) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, Lit(z#0))
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(Lit(z#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  Lit(z#0))))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType)))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0))
           == (if Seq#Length(Lit(z#0)) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#3, b#3 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#3, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._0(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType)))))), 
                $Box(Seq#Append(b#3, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._1(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType))))))))));

// function declaration for Sequences._default.FlattenShape
function Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box)
   : Seq Box;

function Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.FlattenShape
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
           == Seq#Length(seqs#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(seqs#0, i#1)): Seq Box } 
            { $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                i#1)): int } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1
                 < Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
             ==> $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                  i#1)): int
               == Seq#Length($Unbox(Seq#Index(seqs#0, i#1)): Seq Box))
         && $Is(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
          TSeq(Tclass._System.nat())));

function Sequences.__default.FlattenShape#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenShape
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
     ==> Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0)
       == true);

// definition axiom for Sequences.__default.FlattenShape(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0)
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), seqs#0)): Seq Box))))));

// definition axiom for Sequences.__default.FlattenShape for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length(Lit($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))): Seq Box)))))));

// function declaration for Sequences._default.FlattenLength
function Sequences.__default.FlattenLength($ly: LayerType, shape#0: Seq Box) : int;

function Sequences.__default.FlattenLength#canCall(shape#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
  Sequences.__default.FlattenLength($LS($ly), shape#0)
     == Sequences.__default.FlattenLength($ly, shape#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength(AsFuelBottom($ly), shape#0) } 
  Sequences.__default.FlattenLength($ly, shape#0)
     == Sequences.__default.FlattenLength($LZ, shape#0));

// consequence axiom for Sequences.__default.FlattenLength
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($ly, shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) == LitInt(0)
           ==> Sequences.__default.FlattenLength($ly, shape#0) == LitInt(0))
         && LitInt(0) <= Sequences.__default.FlattenLength($ly, shape#0));

function Sequences.__default.FlattenLength#requires(LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenLength
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength#requires($ly, shape#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat()))
     ==> Sequences.__default.FlattenLength#requires($ly, shape#0) == true);

// definition axiom for Sequences.__default.FlattenLength(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), shape#0))
         && Sequences.__default.FlattenLength($LS($ly), shape#0)
           == (if Seq#Length(shape#0) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), shape#0)): int));

// definition axiom for Sequences.__default.FlattenLength for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenLength($LS($ly), Lit(shape#0)) } 
    Sequences.__default.FlattenLength#canCall(Lit(shape#0))
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(Lit(shape#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), Lit(shape#0)))
         && Sequences.__default.FlattenLength($LS($ly), Lit(shape#0))
           == (if Seq#Length(Lit(shape#0)) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($LS($ly), Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), Lit(shape#0))): int));

// function declaration for Sequences._default.Flatten
function Sequences.__default.Flatten(Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box) : Seq Box;

function Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.Flatten
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Sequences._default.Flatten$A, StartFuel_Sequences._default.FlattenShape, seqs#0))
         && (Seq#Length(seqs#0) == LitInt(0)
           ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
             == LitInt(0))
         && $Is(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0), 
          TSeq(Sequences._default.Flatten$A)));

function Sequences.__default.Flatten#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Flatten
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
     ==> Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0)
       == true);

const MoreFuel_Sequences._default.FlattenShape2: LayerType;

// definition axiom for Sequences.__default.Flatten(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), seqs#0)
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), seqs#0))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape2)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape2))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape2)
           == MoreFuel_Sequences._default.FlattenShape2
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), seqs#0)): Seq Box)));

const MoreFuel_Sequences._default.FlattenShape3: LayerType;

// definition axiom for Sequences.__default.Flatten for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape3)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape3))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape3)
           == MoreFuel_Sequences._default.FlattenShape3
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))): Seq Box)));

// function declaration for Sequences._default.FlattenIndex
function Sequences.__default.FlattenIndex(shape#0: Seq Box, i#0: int, j#0: int) : int;

function Sequences.__default.FlattenIndex#canCall(shape#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for Sequences.__default.FlattenIndex
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> LitInt(0) <= Sequences.__default.FlattenIndex(shape#0, i#0, j#0));

function Sequences.__default.FlattenIndex#requires(Seq Box, int, int) : bool;

// #requires axiom for Sequences.__default.FlattenIndex
axiom (forall shape#0: Seq Box, i#0: int, j#0: int :: 
  { Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0 && LitInt(0) <= j#0
     ==> Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0)
       == (i#0 < Seq#Length(shape#0) && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int));

// definition axiom for Sequences.__default.FlattenIndex(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> Sequences.__default.FlattenLength#canCall(Seq#Take(shape#0, i#0))
         && Sequences.__default.FlattenIndex(shape#0, i#0, j#0)
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Seq#Take(shape#0, i#0))
             + j#0);

// definition axiom for Sequences.__default.FlattenIndex for all literals(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0)) } 
    Sequences.__default.FlattenIndex#canCall(Lit(shape#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(Lit(shape#0))
           && j#0 < $Unbox(Seq#Index(Lit(shape#0), LitInt(i#0))): int)
       ==> Sequences.__default.FlattenLength#canCall(Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
         && Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
             + j#0);

// function declaration for Sequences._default.UnflattenIndex
function Sequences.__default.UnflattenIndex($ly: LayerType, shape#0: Seq Box, i#0: int) : DatatypeType;

function Sequences.__default.UnflattenIndex#canCall(shape#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
     == Sequences.__default.UnflattenIndex($ly, shape#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex(AsFuelBottom($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($ly, shape#0, i#0)
     == Sequences.__default.UnflattenIndex($LZ, shape#0, i#0));

// consequence axiom for Sequences.__default.UnflattenIndex
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($ly, shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> $Is(Sequences.__default.UnflattenIndex($ly, shape#0, i#0), 
        Tclass._System.Tuple2(Tclass._System.nat(), Tclass._System.nat())));

function Sequences.__default.UnflattenIndex#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.UnflattenIndex
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0
     ==> Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0)
       == (i#0
         < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0)));

const MoreFuel_Sequences._default.FlattenLength2: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
         && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.UnflattenIndex#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0)))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength2)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength2))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength2)
           == MoreFuel_Sequences._default.FlattenLength2
         && Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             then Sequences.__default.UnflattenIndex($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0)
             else #_System._tuple#2._#Make2($Box(Seq#Length(shape#0) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Sequences.__default.DropLast(Tclass._System.nat(), shape#0))))));

const MoreFuel_Sequences._default.FlattenLength3: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    {:weight 3} { Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0)) } 
    Sequences.__default.UnflattenIndex#canCall(Lit(shape#0), LitInt(i#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Lit(shape#0)))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
         && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.UnflattenIndex#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0)))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0)))))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength3)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength3))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength3)
           == MoreFuel_Sequences._default.FlattenLength3
         && Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0))
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             then Sequences.__default.UnflattenIndex($LS($ly), 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0))
             else #_System._tuple#2._#Make2($Box(Seq#Length(Lit(shape#0)) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))))));

// function declaration for Sequences._default.fill
function Sequences.__default.fill(Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box) : Seq Box;

function Sequences.__default.fill#canCall(Sequences._default.fill$T: Ty, n#0: int, t#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, AsFuelBottom($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $LZ, n#0, t#0));

// consequence axiom for Sequences.__default.fill
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> Seq#Length(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0))
           == n#0
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#1) } 
          LitInt(0) <= i#1 && i#1 < n#0
             ==> Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#1)
               == t#0)
         && $Is(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), 
          TSeq(Sequences._default.fill$T)));

function Sequences.__default.fill#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.fill
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0) } 
  $IsBox(t#0, Sequences._default.fill$T)
     ==> Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0)
       == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.fill(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> (n#0 != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0 - 1, t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0 - 1, t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0)
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for all literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0)) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), Lit(t#0))
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), Lit(t#0)))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), Lit(t#0)), 
              Seq#Build(Seq#Empty(): Seq Box, Lit(t#0)))));

const unique class.Maps.__default: ClassName;

function Tclass.Maps.__default() : Ty;

// Tclass.Maps.__default Tag
axiom Tag(Tclass.Maps.__default()) == Tagclass.Maps.__default;

const unique Tagclass.Maps.__default: TyTag;

// Box/unbox axiom for Tclass.Maps.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Maps.__default()) } 
  $IsBox(bx, Tclass.Maps.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Maps.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Maps.__default()) } 
  $Is($o, Tclass.Maps.__default())
     <==> $o == null || dtype($o) == Tclass.Maps.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Maps.__default(), $h) } 
  $IsAlloc($o, Tclass.Maps.__default(), $h) <==> $o == null || read($h, $o, alloc));

// function declaration for Maps._default.IMapsTo
function Maps.__default.IMapsTo(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsTo
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> true);

function Maps.__default.IMapsTo#requires(Ty, Ty, IMap Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsTo
axiom (forall Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
       && $IsBox(k#0, Maps._default.IMapsTo$K)
       && $IsBox(v#0, Maps._default.IMapsTo$V)
     ==> Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.IMapsTo(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.IMapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsTo
function Maps.__default.MapsTo(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsTo
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> true);

function Maps.__default.MapsTo#requires(Ty, Ty, Map Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.MapsTo
axiom (forall Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
       && $IsBox(k#0, Maps._default.MapsTo$K)
       && $IsBox(v#0, Maps._default.MapsTo$V)
     ==> Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.MapsTo(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsAgreeOnKey
function Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsAgreeOnKey
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> true);

function Maps.__default.MapsAgreeOnKey#requires(Ty, Ty, Map Box Box, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapsAgreeOnKey
axiom (forall Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K)
     ==> Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.MapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(m#0)[k#0] == Map#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[k#0] == Map#Elements(Lit(m'#0))[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[Lit(k#0)] == Map#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IMapsAgreeOnKey
function Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsAgreeOnKey
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> true);

function Maps.__default.IMapsAgreeOnKey#requires(Ty, Ty, IMap Box Box, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsAgreeOnKey
axiom (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K)
     ==> Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(m#0)[k#0] == IMap#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.IMapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
        Maps._default.IMapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(Lit(m#0))[Lit(k#0)] == IMap#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IsSubIMap
function Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

function Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubIMap
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> true);

function Maps.__default.IsSubIMap#requires(Ty, Ty, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IsSubIMap
axiom (forall Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box :: 
  { Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
  $Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
       && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
     ==> Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubIMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
           ==> (forall key#2: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#2) } 
              { IMap#Domain(sub#0)[key#2] } 
            $IsBox(key#2, Maps._default.IsSubIMap$K)
               ==> 
              IMap#Domain(sub#0)[key#2]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#2)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
           == (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
             && (forall key#2: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#2) } 
                { IMap#Domain(sub#0)[key#2] } 
              $IsBox(key#2, Maps._default.IsSubIMap$K)
                 ==> 
                IMap#Domain(sub#0)[key#2]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#2))));

// definition axiom for Maps.__default.IsSubIMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
           ==> (forall key#3: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#3) } 
              { IMap#Domain(sub#0)[key#3] } 
            $IsBox(key#3, Maps._default.IsSubIMap$K)
               ==> 
              Lit(IMap#Domain(Lit(sub#0)))[key#3]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, 
                Maps._default.IsSubIMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#3)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
           == (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
             && (forall key#3: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#3) } 
                { IMap#Domain(sub#0)[key#3] } 
              $IsBox(key#3, Maps._default.IsSubIMap$K)
                 ==> 
                Lit(IMap#Domain(Lit(sub#0)))[key#3]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, 
                  Maps._default.IsSubIMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#3))));

// function declaration for Maps._default.IsSubMap
function Maps.__default.IsSubMap(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

function Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubMap
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> true);

function Maps.__default.IsSubMap#requires(Ty, Ty, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.IsSubMap
axiom (forall Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box :: 
  { Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
  $Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
       && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
     ==> Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
           ==> (forall key#2: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#2) } 
              { Map#Domain(sub#0)[key#2] } 
            $IsBox(key#2, Maps._default.IsSubMap$K)
               ==> 
              Map#Domain(sub#0)[key#2]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#2)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
           == (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
             && (forall key#2: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#2) } 
                { Map#Domain(sub#0)[key#2] } 
              $IsBox(key#2, Maps._default.IsSubMap$K)
                 ==> 
                Map#Domain(sub#0)[key#2]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#2))));

// definition axiom for Maps.__default.IsSubMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    {:weight 3} { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
           ==> (forall key#3: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#3) } 
              { Map#Domain(sub#0)[key#3] } 
            $IsBox(key#3, Maps._default.IsSubMap$K)
               ==> 
              Lit(Map#Domain(Lit(sub#0)))[key#3]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, 
                Maps._default.IsSubMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#3)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
           == (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
             && (forall key#3: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#3) } 
                { Map#Domain(sub#0)[key#3] } 
              $IsBox(key#3, Maps._default.IsSubMap$K)
                 ==> 
                Lit(Map#Domain(Lit(sub#0)))[key#3]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, 
                  Maps._default.IsSubMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#3))));

// function declaration for Maps._default.MapRemove
function Maps.__default.MapRemove(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
      Maps._default.MapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemove
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> (forall k#2: Box :: 
          { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#2] } 
            { ks#0[k#2] } 
            { Map#Domain(m#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(m#0)[k#2] && !ks#0[k#2]
             ==> Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#2])
         && (forall k#3: Box :: 
          { ks#0[k#3] } 
            { Map#Domain(m#0)[k#3] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#3] } 
          $IsBox(k#3, Maps._default.MapRemove$K)
             ==> (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#3]
                 ==> Map#Domain(m#0)[k#3])
               && (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#3]
                 ==> !ks#0[k#3]))
         && (forall j#2: Box :: 
          { Map#Elements(m#0)[j#2] } 
            { Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#2] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#2] } 
          $IsBox(j#2, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#2]
             ==> Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#2]
               == Map#Elements(m#0)[j#2])
         && Set#Card(Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)));

function Maps.__default.MapRemove#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemove
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
       && $Is(ks#0, TSet(Maps._default.MapRemove$K))
     ==> Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRemove(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
         == (var m'#2 := Map#Glue((lambda $w#5: Box :: 
                $IsBox($w#5, Maps._default.MapRemove$K) && Map#Domain(m#0)[$w#5] && !ks#0[$w#5]), 
              (lambda $w#5: Box :: Map#Elements(m#0)[$w#5]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#2));

// definition axiom for Maps.__default.MapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
        Maps._default.MapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, 
          Maps._default.MapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == (var m'#3 := Map#Glue((lambda $w#7: Box :: 
                $IsBox($w#7, Maps._default.MapRemove$K)
                   && 
                  Map#Domain(m#0)[$w#7]
                   && !Lit(ks#0)[$w#7]), 
              (lambda $w#7: Box :: Map#Elements(Lit(m#0))[$w#7]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#3));

// function declaration for Maps._default.MapRemoveStrong
function Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemoveStrong
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)), 
          Set#Difference(Map#Domain(m#0), ks#0))
         && (forall j#1: Box :: 
          { Map#Elements(m#0)[j#1] } 
            { Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#1] } 
            { Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#1] } 
          $IsBox(j#1, Maps._default.MapRemoveStrong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#1]
             ==> Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#1]
               == Map#Elements(m#0)[j#1])
         && Set#Card(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V)));

function Maps.__default.MapRemoveStrong#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemoveStrong
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
       && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K))
     ==> Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
       == true);

const MoreFuel_Maps._default.MapRemove2: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        m#0, 
        ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove2)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove2))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove2)
           == MoreFuel_Maps._default.MapRemove2
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            m#0, 
            ks#0)
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            m#0, 
            ks#0));

const MoreFuel_Maps._default.MapRemove3: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove3)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove3))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove3)
           == MoreFuel_Maps._default.MapRemove3
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(ks#0))
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            Lit(m#0), 
            Lit(ks#0)));

// function declaration for Maps._default.MapRemove1
function Maps.__default.MapRemove1(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
      Maps._default.MapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.MapRemove1
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> (forall j#4: Box :: 
          { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#4] } 
            { Map#Domain(m#0)[j#4] } 
          $IsBox(j#4, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(m#0)[j#4] && j#4 != k#0
             ==> Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#4])
         && (forall j#5: Box :: 
          { Map#Domain(m#0)[j#5] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#5] } 
          $IsBox(j#5, Maps._default.MapRemove1$K)
             ==> (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#5]
                 ==> Map#Domain(m#0)[j#5])
               && (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#5]
                 ==> j#5 != k#0))
         && (forall j#6: Box :: 
          { Map#Elements(m#0)[j#6] } 
            { Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#6] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#6] } 
          $IsBox(j#6, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#6]
             ==> Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#6]
               == Map#Elements(m#0)[j#6])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)))
           <= Set#Card(Map#Domain(m#0))
         && (Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0) - 1)
         && (!Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0))
         && $Is(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0), 
          TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)));

function Maps.__default.MapRemove1#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
       && $IsBox(k#0, Maps._default.MapRemove1$K)
     ==> Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.MapRemove1(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
         == (var m'#3 := Map#Glue((lambda $w#7: Box :: 
                $IsBox($w#7, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#7] && $w#7 != k#0), 
              (lambda $w#7: Box :: Map#Elements(m#0)[$w#7]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#3));

// definition axiom for Maps.__default.MapRemove1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0)
         == (var m'#4 := Map#Glue((lambda $w#9: Box :: 
                $IsBox($w#9, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#9] && $w#9 != k#0), 
              (lambda $w#9: Box :: Map#Elements(Lit(m#0))[$w#9]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#4));

// definition axiom for Maps.__default.MapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
        Maps._default.MapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
          Maps._default.MapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == (var m'#5 := Map#Glue((lambda $w#11: Box :: 
                $IsBox($w#11, Maps._default.MapRemove1$K)
                   && 
                  Map#Domain(m#0)[$w#11]
                   && $w#11 != k#0), 
              (lambda $w#11: Box :: Map#Elements(Lit(m#0))[$w#11]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#5));

// function declaration for Maps._default.MapRemove1Strong
function Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LZ, 
      m#0, 
      k#0));

// consequence axiom for Maps.__default.MapRemove1Strong
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0)), 
          Set#Difference(Map#Domain(m#0), Set#UnionOne(Set#Empty(): Set Box, k#0)))
         && (forall j#1: Box :: 
          { Map#Elements(m#0)[j#1] } 
            { Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#1] } 
            { Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#1] } 
          $IsBox(j#1, Maps._default.MapRemove1Strong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#1]
             ==> Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                  Maps._default.MapRemove1Strong$V, 
                  $ly, 
                  m#0, 
                  k#0))[j#1]
               == Map#Elements(m#0)[j#1])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $ly, 
            m#0, 
            k#0), 
          TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V)));

function Maps.__default.MapRemove1Strong#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1Strong
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
       && $IsBox(k#0, Maps._default.MapRemove1Strong$K)
     ==> Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0)
       == true);

const MoreFuel_Maps._default.MapRemove13: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove13)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove13))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove13)
           == MoreFuel_Maps._default.MapRemove13
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            m#0, 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            m#0, 
            k#0));

const MoreFuel_Maps._default.MapRemove14: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove14)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove14))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove14)
           == MoreFuel_Maps._default.MapRemove14
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            k#0));

const MoreFuel_Maps._default.MapRemove15: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove15)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove15))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove15)
           == MoreFuel_Maps._default.MapRemove15
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(k#0))
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            Lit(k#0)));

// function declaration for Maps._default.IMapRemove
function Maps.__default.IMapRemove(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
      Maps._default.IMapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.IMapRemove
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)), 
          ISet#Difference(IMap#Domain(m#0), ks#0))
         && (forall j#2: Box :: 
          { IMap#Elements(m#0)[j#2] } 
            { IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#2] } 
            { IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#2] } 
          $IsBox(j#2, Maps._default.IMapRemove$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#2]
             ==> IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#2]
               == IMap#Elements(m#0)[j#2])
         && $Is(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

function Maps.__default.IMapRemove#requires(Ty, Ty, LayerType, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRemove
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
       && $Is(ks#0, TISet(Maps._default.IMapRemove$K))
     ==> Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRemove(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#2]
               && !ks#0[$w#2]), 
          (lambda $w#2: Box :: IMap#Elements(m#0)[$w#2]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// definition axiom for Maps.__default.IMapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
        Maps._default.IMapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
          Maps._default.IMapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#3]
               && !Lit(ks#0)[$w#3]), 
          (lambda $w#3: Box :: IMap#Elements(Lit(m#0))[$w#3]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// function declaration for Maps._default.IMapRemove1
function Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box)
   : IMap Box Box;

function Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
      Maps._default.IMapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.IMapRemove1
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)), 
          ISet#Difference(IMap#Domain(m#0), ISet#UnionOne(ISet#Empty(): ISet Box, k#0)))
         && (forall j#2: Box :: 
          { IMap#Elements(m#0)[j#2] } 
            { IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#2] } 
            { IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#2] } 
          $IsBox(j#2, Maps._default.IMapRemove1$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#2]
             ==> IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#2]
               == IMap#Elements(m#0)[j#2])
         && $Is(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

function Maps.__default.IMapRemove1#requires(Ty, Ty, LayerType, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapRemove1
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
       && $IsBox(k#0, Maps._default.IMapRemove1$K)
     ==> Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapRemove1(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#2]
               && $w#2 != k#0), 
          (lambda $w#2: Box :: IMap#Elements(m#0)[$w#2]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// definition axiom for Maps.__default.IMapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
        Maps._default.IMapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
          Maps._default.IMapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#3]
               && $w#3 != k#0), 
          (lambda $w#3: Box :: IMap#Elements(Lit(m#0))[$w#3]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// function declaration for Maps._default.MapRestrict
function Maps.__default.MapRestrict(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// consequence axiom for Maps.__default.MapRestrict
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> $Is(Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

function Maps.__default.MapRestrict#requires(Ty, Ty, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRestrict
axiom (forall Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
       && $Is(ks#0, TSet(Maps._default.MapRestrict$K))
     ==> Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapRestrict$K) && ks#0[$w#2] && Map#Domain(m#0)[$w#2]), 
          (lambda $w#2: Box :: Map#Elements(m#0)[$w#2]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// definition axiom for Maps.__default.MapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapRestrict$K)
               && 
              Lit(ks#0)[$w#3]
               && Map#Domain(m#0)[$w#3]), 
          (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// function declaration for Maps._default.MapIRestrict
function Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : Map Box Box;

function Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.MapIRestrict
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> $Is(Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

function Maps.__default.MapIRestrict#requires(Ty, Ty, Map Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.MapIRestrict
axiom (forall Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
       && $Is(ks#0, TISet(Maps._default.MapIRestrict$K))
     ==> Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapIRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#3]
               && ks#0[$w#3]), 
          (lambda $w#3: Box :: Map#Elements(m#0)[$w#3]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         == Map#Glue((lambda $w#4: Box :: 
            $IsBox($w#4, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#4]
               && ks#0[$w#4]), 
          (lambda $w#4: Box :: Map#Elements(Lit(m#0))[$w#4]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#5: Box :: 
            $IsBox($w#5, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#5]
               && Lit(ks#0)[$w#5]), 
          (lambda $w#5: Box :: Map#Elements(Lit(m#0))[$w#5]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// function declaration for Maps._default.IMapRestrict
function Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.IMapRestrict
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> $Is(Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0), 
        TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

function Maps.__default.IMapRestrict#requires(Ty, Ty, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRestrict
axiom (forall Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
       && $Is(ks#0, TISet(Maps._default.IMapRestrict$K))
     ==> Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRestrict(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapRestrict$K)
               && 
              ks#0[$w#2]
               && IMap#Domain(m#0)[$w#2]), 
          (lambda $w#2: Box :: IMap#Elements(m#0)[$w#2]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// definition axiom for Maps.__default.IMapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapRestrict$K)
               && 
              Lit(ks#0)[$w#3]
               && IMap#Domain(m#0)[$w#3]), 
          (lambda $w#3: Box :: IMap#Elements(Lit(m#0))[$w#3]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// function declaration for Maps._default.MapDisjointUnion
function Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapDisjointUnion
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
              Maps._default.MapDisjointUnion$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#2: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Elements(mapa#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#2]
             ==> Map#Elements(mapa#0)[k#2]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2])
         && (forall k#3: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { Map#Elements(mapb#0)[k#3] } 
            { Map#Domain(mapb#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#3]
             ==> Map#Elements(mapb#0)[k#3]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3])
         && $Is(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
            Maps._default.MapDisjointUnion$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

function Maps.__default.MapDisjointUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
     ==> Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)));

// definition axiom for Maps.__default.MapDisjointUnion(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapDisjointUnion$U)
               && (Map#Domain(mapa#0)[$w#2] || Map#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if Map#Domain(mapa#0)[$w#2]
               then Map#Elements(mapa#0)[$w#2]
               else Map#Elements(mapb#0)[$w#2])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// definition axiom for Maps.__default.MapDisjointUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapDisjointUnion$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#3] || Lit(Map#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if Map#Domain(mapa#0)[$w#3]
               then Map#Elements(Lit(mapa#0))[$w#3]
               else Map#Elements(Lit(mapb#0))[$w#3])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// function declaration for Maps._default.MapUnionPreferA
function Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferA
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
              Maps._default.MapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { Map#Elements(mapa#0)[k#3] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { Map#Domain(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#3]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3]
               == Map#Elements(mapa#0)[k#3])
         && (forall k#4: Box :: 
          { Map#Elements(mapb#0)[k#4] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#4] } 
          $IsBox(k#4, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapb#0)[k#4] && !Map#Domain(mapa#0)[k#4]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#4]
               == Map#Elements(mapb#0)[k#4])
         && (forall k#5: Box :: 
          { Map#Elements(mapa#0)[k#5] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#5] } 
            { Map#Domain(mapb#0)[k#5] } 
            { Map#Domain(mapa#0)[k#5] } 
          $IsBox(k#5, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#5] && !Map#Domain(mapb#0)[k#5]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#5]
               == Map#Elements(mapa#0)[k#5])
         && $Is(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
            Maps._default.MapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

function Maps.__default.MapUnionPreferA#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferA
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
     ==> Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapUnionPreferA$U)
               && (Map#Domain(mapa#0)[$w#2] || Map#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if Map#Domain(mapa#0)[$w#2]
               then Map#Elements(mapa#0)[$w#2]
               else Map#Elements(mapb#0)[$w#2])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// definition axiom for Maps.__default.MapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapUnionPreferA$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#3] || Lit(Map#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if Map#Domain(mapa#0)[$w#3]
               then Map#Elements(Lit(mapa#0))[$w#3]
               else Map#Elements(Lit(mapb#0))[$w#3])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// function declaration for Maps._default.MapUnionPreferB
function Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferB
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
              Maps._default.MapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { Map#Elements(mapb#0)[k#3] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { Map#Domain(mapb#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapb#0)[k#3]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3]
               == Map#Elements(mapb#0)[k#3])
         && (forall k#4: Box :: 
          { Map#Elements(mapa#0)[k#4] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#4] } 
          $IsBox(k#4, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#4] && !Map#Domain(mapb#0)[k#4]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#4]
               == Map#Elements(mapa#0)[k#4])
         && (forall k#5: Box :: 
          { Map#Elements(mapa#0)[k#5] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#5] } 
            { Map#Domain(mapb#0)[k#5] } 
            { Map#Domain(mapa#0)[k#5] } 
          $IsBox(k#5, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#5] && !Map#Domain(mapb#0)[k#5]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#5]
               == Map#Elements(mapa#0)[k#5])
         && $Is(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
            Maps._default.MapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

function Maps.__default.MapUnionPreferB#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferB
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
     ==> Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapUnionPreferB$U)
               && (Map#Domain(mapa#0)[$w#2] || Map#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if Map#Domain(mapb#0)[$w#2]
               then Map#Elements(mapb#0)[$w#2]
               else Map#Elements(mapa#0)[$w#2])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// definition axiom for Maps.__default.MapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapUnionPreferB$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#3] || Lit(Map#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if Map#Domain(mapb#0)[$w#3]
               then Map#Elements(Lit(mapb#0))[$w#3]
               else Map#Elements(Lit(mapa#0))[$w#3])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// function declaration for Maps._default.MapUnion
function Maps.__default.MapUnion(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
      Maps._default.MapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.MapUnion
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#3] } 
            { Map#Elements(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#3] && !Map#Domain(mapb#0)[k#3]
             ==> Map#Elements(mapa#0)[k#3]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#3])
         && (forall k#4: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#4] } 
            { Map#Elements(mapb#0)[k#4] } 
          $IsBox(k#4, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#4] && !Map#Domain(mapa#0)[k#4]
             ==> Map#Elements(mapb#0)[k#4]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#4])
         && (forall k#5: Box :: 
          { Map#Elements(mapa#0)[k#5] } 
            { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#5] } 
            { Map#Elements(mapb#0)[k#5] } 
          $IsBox(k#5, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#5] && Map#Domain(mapb#0)[k#5]
             ==> Map#Elements(mapb#0)[k#5]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#5]
               || Map#Elements(mapa#0)[k#5]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#5])
         && $Is(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0), 
          TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)));

function Maps.__default.MapUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnion
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
     ==> Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnion(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.MapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
        Maps._default.MapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.IMapUnionPreferA
function Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferA
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
              Maps._default.IMapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { IMap#Elements(mapa#0)[k#3] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { IMap#Domain(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapa#0)[k#3]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3]
               == IMap#Elements(mapa#0)[k#3])
         && (forall k#4: Box :: 
          { IMap#Elements(mapb#0)[k#4] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#4] } 
          $IsBox(k#4, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#4] && !IMap#Domain(mapa#0)[k#4]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#4]
               == IMap#Elements(mapb#0)[k#4])
         && (forall k#5: Box :: 
          { IMap#Elements(mapb#0)[k#5] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#5] } 
            { IMap#Domain(mapa#0)[k#5] } 
            { IMap#Domain(mapb#0)[k#5] } 
          $IsBox(k#5, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#5] && !IMap#Domain(mapa#0)[k#5]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#5]
               == IMap#Elements(mapb#0)[k#5])
         && $Is(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
            Maps._default.IMapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

function Maps.__default.IMapUnionPreferA#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferA
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
     ==> Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapUnionPreferA$U)
               && (IMap#Domain(mapa#0)[$w#2] || IMap#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if IMap#Domain(mapa#0)[$w#2]
               then IMap#Elements(mapa#0)[$w#2]
               else IMap#Elements(mapb#0)[$w#2])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// definition axiom for Maps.__default.IMapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapUnionPreferA$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#3] || Lit(IMap#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if IMap#Domain(mapa#0)[$w#3]
               then IMap#Elements(Lit(mapa#0))[$w#3]
               else IMap#Elements(Lit(mapb#0))[$w#3])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// function declaration for Maps._default.IMapUnionPreferB
function Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferB
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
              Maps._default.IMapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { IMap#Elements(mapb#0)[k#3] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { IMap#Domain(mapb#0)[k#3] } 
          $IsBox(k#3, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapb#0)[k#3]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3]
               == IMap#Elements(mapb#0)[k#3])
         && (forall k#4: Box :: 
          { IMap#Elements(mapa#0)[k#4] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#4] } 
          $IsBox(k#4, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#4] && !IMap#Domain(mapb#0)[k#4]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#4]
               == IMap#Elements(mapa#0)[k#4])
         && (forall k#5: Box :: 
          { IMap#Elements(mapa#0)[k#5] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#5] } 
            { IMap#Domain(mapb#0)[k#5] } 
            { IMap#Domain(mapa#0)[k#5] } 
          $IsBox(k#5, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#5] && !IMap#Domain(mapb#0)[k#5]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#5]
               == IMap#Elements(mapa#0)[k#5])
         && $Is(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
            Maps._default.IMapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

function Maps.__default.IMapUnionPreferB#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferB
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
     ==> Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapUnionPreferB$U)
               && (IMap#Domain(mapa#0)[$w#2] || IMap#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if IMap#Domain(mapb#0)[$w#2]
               then IMap#Elements(mapb#0)[$w#2]
               else IMap#Elements(mapa#0)[$w#2])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// definition axiom for Maps.__default.IMapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapUnionPreferB$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#3] || Lit(IMap#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if IMap#Domain(mapb#0)[$w#3]
               then IMap#Elements(Lit(mapb#0))[$w#3]
               else IMap#Elements(Lit(mapa#0))[$w#3])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// function declaration for Maps._default.IMapUnion
function Maps.__default.IMapUnion(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
      Maps._default.IMapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.IMapUnion
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#3] } 
            { IMap#Elements(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#3] && !IMap#Domain(mapb#0)[k#3]
             ==> IMap#Elements(mapa#0)[k#3]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#3])
         && (forall k#4: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#4] } 
            { IMap#Elements(mapb#0)[k#4] } 
          $IsBox(k#4, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapb#0)[k#4] && !IMap#Domain(mapa#0)[k#4]
             ==> IMap#Elements(mapb#0)[k#4]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#4])
         && (forall k#5: Box :: 
          { IMap#Elements(mapa#0)[k#5] } 
            { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#5] } 
            { IMap#Elements(mapb#0)[k#5] } 
          $IsBox(k#5, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#5] && IMap#Domain(mapb#0)[k#5]
             ==> IMap#Elements(mapb#0)[k#5]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#5]
               || IMap#Elements(mapa#0)[k#5]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#5])
         && $Is(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0), 
          TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)));

function Maps.__default.IMapUnion#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnion
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
       && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
     ==> Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnion(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.IMapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
        Maps._default.IMapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.MapDisjointUnion3
function Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LZ, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// consequence axiom for Maps.__default.MapDisjointUnion3
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              $ly, 
              mapa#0, 
              mapb#0, 
              mapc#0)), 
          Set#Union(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
         && (!Set#Equal(Map#Domain(mapa#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapb#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapc#0), Set#Empty(): Set Box)
           ==> !Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0)), 
            Set#Empty(): Set Box))
         && (forall k#3: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#3] } 
            { Map#Elements(mapa#0)[k#3] } 
            { Map#Domain(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapa#0)[k#3]
             ==> Map#Elements(mapa#0)[k#3]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#3])
         && (forall k#4: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#4] } 
            { Map#Elements(mapb#0)[k#4] } 
            { Map#Domain(mapb#0)[k#4] } 
          $IsBox(k#4, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapb#0)[k#4]
             ==> Map#Elements(mapb#0)[k#4]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#4])
         && (forall k#5: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#5] } 
            { Map#Elements(mapc#0)[k#5] } 
            { Map#Domain(mapc#0)[k#5] } 
          $IsBox(k#5, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapc#0)[k#5]
             ==> Map#Elements(mapc#0)[k#5]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#5])
         && 
        Map#Equal(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)))
         && Map#Equal(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapa#0, 
              mapb#0), 
            mapc#0))
         && $Is(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

function Maps.__default.MapDisjointUnion3#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion3
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  $Is(mapa#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapb#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapc#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
     ==> Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0)
       == (
        Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0))));

// definition axiom for Maps.__default.MapDisjointUnion3(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0, 
          mapc#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapDisjointUnion3$U)
               && (
                Map#Domain(mapa#0)[$w#2]
                 || Map#Domain(mapb#0)[$w#2]
                 || Map#Domain(mapc#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if Map#Domain(mapa#0)[$w#2]
               then Map#Elements(mapa#0)[$w#2]
               else (if Map#Domain(mapb#0)[$w#2]
                 then Map#Elements(mapb#0)[$w#2]
                 else Map#Elements(mapc#0)[$w#2]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// definition axiom for Maps.__default.MapDisjointUnion3 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0), 
        Lit(mapc#0)) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Set#Union(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))), 
            Map#Domain(Lit(mapc#0))))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapDisjointUnion3$U)
               && (
                Lit(Map#Domain(Lit(mapa#0)))[$w#3]
                 || Lit(Map#Domain(Lit(mapb#0)))[$w#3]
                 || Lit(Map#Domain(Lit(mapc#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if Map#Domain(mapa#0)[$w#3]
               then Map#Elements(Lit(mapa#0))[$w#3]
               else (if Map#Domain(mapb#0)[$w#3]
                 then Map#Elements(Lit(mapb#0))[$w#3]
                 else Map#Elements(Lit(mapc#0))[$w#3]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// function declaration for Maps._default.MapToImap
function Maps.__default.MapToImap(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : IMap Box Box;

function Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.MapToImap
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> $Is(Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0), 
        TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

function Maps.__default.MapToImap#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapToImap
axiom (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
  { Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
  $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
     ==> Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
       == true);

// definition axiom for Maps.__default.MapToImap(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#2]), 
          (lambda $w#2: Box :: Map#Elements(m#0)[$w#2]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// definition axiom for Maps.__default.MapToImap for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0)) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#3]), 
          (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// function declaration for Maps._default.MapLookupOption
function Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapLookupOption
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> $Is(Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.MapLookupOption$V)));

function Maps.__default.MapLookupOption#requires(Ty, Ty, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapLookupOption
axiom (forall Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box :: 
  { Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
       && $IsBox(key#0, Maps._default.MapLookupOption$K)
     ==> Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.MapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

// function declaration for Maps._default.ImapLookupOption
function Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.ImapLookupOption
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> $Is(Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.ImapLookupOption$V)));

function Maps.__default.ImapLookupOption#requires(Ty, Ty, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.ImapLookupOption
axiom (forall Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box :: 
  { Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
       && $IsBox(key#0, Maps._default.ImapLookupOption$K)
     ==> Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.ImapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.ImapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
        Maps._default.ImapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

const unique class.Uint32__Order.__default: ClassName;

function Tclass.Uint32__Order.__default() : Ty;

// Tclass.Uint32__Order.__default Tag
axiom Tag(Tclass.Uint32__Order.__default()) == Tagclass.Uint32__Order.__default;

const unique Tagclass.Uint32__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Uint32__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Uint32__Order.__default()) } 
  $IsBox(bx, Tclass.Uint32__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Uint32__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Uint32__Order.__default()) } 
  $Is($o, Tclass.Uint32__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Uint32__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Uint32__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Uint32__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Uint32_Order._default.SomeElement
function Uint32__Order.__default.SomeElement() : int;

function Uint32__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Uint32__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> LitInt(0) <= Uint32__Order.__default.SomeElement()
     && Uint32__Order.__default.SomeElement() < 4294967296;

function Uint32__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Uint32__Order.__default.SomeElement
axiom Uint32__Order.__default.SomeElement#requires() == true;

// definition axiom for Uint32__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Uint32__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Uint32__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Uint32__Order.__default.SomeElement() == LitInt(0);

// function declaration for Uint32_Order._default.lte
function Uint32__Order.__default.lte(a#0: int, b#0: int) : bool;

function Uint32__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.lte
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lte(a#0, b#0) } 
    Uint32__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
           || Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0))
         && (forall a#3: int, b#3: int, c#2: int :: 
          { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#3, c#2), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#3, c#2) } 
            { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#3, c#2), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#3, b#3) } 
          LitInt(0) <= a#3
               && a#3 < 4294967296
               && 
              LitInt(0) <= b#3
               && b#3 < 4294967296
               && 
              LitInt(0) <= c#2
               && c#2 < 4294967296
             ==> 
            Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#3, b#3)
               && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#3, c#2)
             ==> Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#3, c#2))
         && Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
           || Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0))
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
             && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#4: int, b#4: int, c#3: int :: 
          { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#4, c#3), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#4, c#3) } 
            { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#4, c#3), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#4, b#4) } 
          LitInt(0) <= a#4
               && a#4 < 4294967296
               && 
              LitInt(0) <= b#4
               && b#4 < 4294967296
               && 
              LitInt(0) <= c#3
               && c#3 < 4294967296
             ==> 
            Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#4, b#4)
               && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#4, c#3)
             ==> Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#4, c#3)));

function Uint32__Order.__default.lte#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.lte
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.lte#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.lte#requires(a#0, b#0) == true);

const MoreFuel_Uint32_Order._default.ltedef2: LayerType;

// definition axiom for Uint32__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lte(a#0, b#0) } 
    Uint32__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         && 
        StartFuel_Uint32_Order._default.ltedef
           == $LS(MoreFuel_Uint32_Order._default.ltedef2)
         && StartFuelAssert_Uint32_Order._default.ltedef
           == $LS($LS(MoreFuel_Uint32_Order._default.ltedef2))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.ltedef2)
           == MoreFuel_Uint32_Order._default.ltedef2
         && Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0));

const MoreFuel_Uint32_Order._default.ltedef3: LayerType;

// definition axiom for Uint32__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         && 
        StartFuel_Uint32_Order._default.ltedef
           == $LS(MoreFuel_Uint32_Order._default.ltedef3)
         && StartFuelAssert_Uint32_Order._default.ltedef
           == $LS($LS(MoreFuel_Uint32_Order._default.ltedef3))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.ltedef3)
           == MoreFuel_Uint32_Order._default.ltedef3
         && Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0))
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, LitInt(a#0), LitInt(b#0)));

// function declaration for Uint32_Order._default.ltedef
function Uint32__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Uint32__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Uint32__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Uint32__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Uint32__Order.__default.ltedef($ly, a#0, b#0)
     == Uint32__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Uint32__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Uint32__Order.__default.ltedef($ly, a#0, b#0) } 
    Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Uint32__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Uint32__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Uint32_Order._default.LargestLte
function Uint32__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
     == Uint32__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Uint32__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
         && Uint32__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Uint32__Order.__default.LargestLte($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Uint32__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Uint32__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted8: LayerType;

// definition axiom for Uint32__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Uint32__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted8)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted8))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted8)
           == MoreFuel_Uint32_Order._default.IsSorted8
         && Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Uint32_Order._default.IsSorted9: LayerType;

// definition axiom for Uint32__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Uint32__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Uint32__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted9)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted9))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted9)
           == MoreFuel_Uint32_Order._default.IsSorted9
         && Uint32__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Uint32__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Uint32_Order._default.LargestLt
function Uint32__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
     == Uint32__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Uint32__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
         && Uint32__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Uint32__Order.__default.LargestLt($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Uint32__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Uint32__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Uint32__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted10: LayerType;

// definition axiom for Uint32__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Uint32__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted10)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted10))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted10)
           == MoreFuel_Uint32_Order._default.IsSorted10
         && Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Uint32__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Uint32_Order._default.IsSorted11: LayerType;

// definition axiom for Uint32__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Uint32__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Uint32__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted11)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted11))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted11)
           == MoreFuel_Uint32_Order._default.IsSorted11
         && Uint32__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Uint32__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Uint32_Order._default.IndexOfFirstGte
function Uint32__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Uint32__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted12: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), run#0)
             && Uint32__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
              needle#0)
             && (!Uint32__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), run#0)
                 && Uint32__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted12)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted12))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted12)
           == MoreFuel_Uint32_Order._default.IsSorted12
         && Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Uint32__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0))));

const MoreFuel_Uint32_Order._default.IsSorted13: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
             && Uint32__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Uint32__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
                 && Uint32__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted13)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted13))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted13)
           == MoreFuel_Uint32_Order._default.IsSorted13
         && Uint32__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Uint32__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGteIter
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#3, hi#0)
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Uint32__Order.__default.lte(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, LitInt(key#0))
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGte
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Uint32_Order._default.IndexOfFirstGt
function Uint32__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Uint32__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted14: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), run#0)
             && Uint32__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
              needle#0)
             && (!Uint32__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), run#0)
                 && Uint32__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted14)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted14))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted14)
           == MoreFuel_Uint32_Order._default.IsSorted14
         && Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Uint32__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0))));

const MoreFuel_Uint32_Order._default.IsSorted15: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
             && Uint32__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Uint32__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
                 && Uint32__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted15)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted15))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted15)
           == MoreFuel_Uint32_Order._default.IsSorted15
         && Uint32__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Uint32__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGtIter
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#3, hi#0)
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Uint32__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, LitInt(key#0))
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGt
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Uint32_Order._default.SetAllLte
function Uint32__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Uint32__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Uint32__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLte(a#0, b#0) } 
    Uint32__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> true);

function Uint32__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Uint32__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.uint32()))
       && $Is(b#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLte(a#0, b#0) } 
    Uint32__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#2: int, y#2: int :: 
          { Uint32__Order.__default.lte(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          LitInt(0) <= x#2 && x#2 < 4294967296 && LitInt(0) <= y#2 && y#2 < 4294967296
             ==> 
            b#0[$Box(y#2)]
             ==> Uint32__Order.__default.lte#canCall(x#2, y#2))
         && Uint32__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Uint32__Order.__default.lte(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            LitInt(0) <= x#2 && x#2 < 4294967296 && LitInt(0) <= y#2 && y#2 < 4294967296
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Uint32__Order.__default.lte(x#2, y#2)));

// definition axiom for Uint32__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Uint32__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#3: int, y#3: int :: 
          { Uint32__Order.__default.lte(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          LitInt(0) <= x#3 && x#3 < 4294967296 && LitInt(0) <= y#3 && y#3 < 4294967296
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Uint32__Order.__default.lte#canCall(x#3, y#3))
         && Uint32__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Uint32__Order.__default.lte(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            LitInt(0) <= x#3 && x#3 < 4294967296 && LitInt(0) <= y#3 && y#3 < 4294967296
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Uint32__Order.__default.lte(x#3, y#3)));

// function declaration for Uint32_Order._default.SetAllLt
function Uint32__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Uint32__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Uint32__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLt(a#0, b#0) } 
    Uint32__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> true);

function Uint32__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Uint32__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.uint32()))
       && $Is(b#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLt(a#0, b#0) } 
    Uint32__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#2: int, y#2: int :: 
          { Uint32__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          LitInt(0) <= x#2 && x#2 < 4294967296 && LitInt(0) <= y#2 && y#2 < 4294967296
             ==> 
            b#0[$Box(y#2)]
             ==> Uint32__Order.__default.lt#canCall(x#2, y#2))
         && Uint32__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Uint32__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            LitInt(0) <= x#2 && x#2 < 4294967296 && LitInt(0) <= y#2 && y#2 < 4294967296
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Uint32__Order.__default.lt(x#2, y#2)));

// definition axiom for Uint32__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Uint32__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#3: int, y#3: int :: 
          { Uint32__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          LitInt(0) <= x#3 && x#3 < 4294967296 && LitInt(0) <= y#3 && y#3 < 4294967296
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Uint32__Order.__default.lt#canCall(x#3, y#3))
         && Uint32__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Uint32__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            LitInt(0) <= x#3 && x#3 < 4294967296 && LitInt(0) <= y#3 && y#3 < 4294967296
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Uint32__Order.__default.lt(x#3, y#3)));

// function declaration for Uint32_Order._default.NotMinimum
function Uint32__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Uint32__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum($LS($ly), a#0) } 
  Uint32__Order.__default.NotMinimum($LS($ly), a#0)
     == Uint32__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Uint32__Order.__default.NotMinimum($ly, a#0)
     == Uint32__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Uint32__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Uint32__Order.__default.NotMinimum($ly, a#0) } 
    Uint32__Order.__default.NotMinimum#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Uint32__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296
     ==> Uint32__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Uint32__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Uint32__Order.__default.NotMinimum($LS($ly), a#0) } 
    Uint32__Order.__default.NotMinimum#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> (forall b#2: int :: 
          { Uint32__Order.__default.lt(b#2, a#0) } 
          LitInt(0) <= b#2 && b#2 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(b#2, a#0))
         && Uint32__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#2: int :: 
            { Uint32__Order.__default.lt(b#2, a#0) } 
            LitInt(0) <= b#2 && b#2 < 4294967296 && Uint32__Order.__default.lt(b#2, a#0)));

// definition axiom for Uint32__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Uint32__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    Uint32__Order.__default.NotMinimum#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> (forall b#3: int :: 
          { Uint32__Order.__default.lt(b#3, a#0) } 
          LitInt(0) <= b#3 && b#3 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(b#3, LitInt(a#0)))
         && Uint32__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#3: int :: 
            { Uint32__Order.__default.lt(b#3, a#0) } 
            LitInt(0) <= b#3
               && b#3 < 4294967296
               && Uint32__Order.__default.lt(b#3, LitInt(a#0))));

// function declaration for Uint32_Order._default.MapPivotedUnion
function Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Uint32__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)));

function Uint32__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Uint32__Order.__default.MapPivotedUnion
axiom (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Uint32__Order.__default.MapPivotedUnion#requires(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
       && 
      LitInt(0) <= pivot#0
       && pivot#0 < 4294967296
       && $Is(right#0, 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
     ==> Uint32__Order.__default.MapPivotedUnion#requires(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Uint32__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#4: int :: 
          { Uint32__Order.__default.lt(k#4, pivot#0) } 
          LitInt(0) <= k#4 && k#4 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(k#4, pivot#0))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
          Uint32_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#12: Box :: 
            $IsBox($y#12, Tclass.NativeTypes.uint32())
               && Uint32__Order.__default.lt($Unbox($y#12): int, pivot#0)))
         && (var restricted_left#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#15: Box :: 
                $IsBox($y#15, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lt($Unbox($y#15): int, pivot#0))); 
          (forall k#5: int :: 
              { Uint32__Order.__default.lte(pivot#0, k#5) } 
              LitInt(0) <= k#5 && k#5 < 4294967296
                 ==> Uint32__Order.__default.lte#canCall(pivot#0, k#5))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#13: Box :: 
                $IsBox($y#13, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lte(pivot#0, $Unbox($y#13): int)))
             && (var restricted_right#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#14: Box :: 
                    $IsBox($y#14, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(pivot#0, $Unbox($y#14): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                restricted_left#2, 
                restricted_right#2)))
         && Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#16: Box :: 
                  $IsBox($y#16, Tclass.NativeTypes.uint32())
                     && Uint32__Order.__default.lt($Unbox($y#16): int, pivot#0))); 
            (var restricted_right#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#17: Box :: 
                    $IsBox($y#17, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(pivot#0, $Unbox($y#17): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#2, 
                restricted_right#2))));

// definition axiom for Uint32__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#6: int :: 
          { Uint32__Order.__default.lt(k#6, pivot#0) } 
          LitInt(0) <= k#6 && k#6 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(k#6, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
          Uint32_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#18: Box :: 
            $IsBox($y#18, Tclass.NativeTypes.uint32())
               && Uint32__Order.__default.lt($Unbox($y#18): int, LitInt(pivot#0))))
         && (var restricted_left#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#21: Box :: 
                $IsBox($y#21, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lt($Unbox($y#21): int, LitInt(pivot#0)))); 
          (forall k#7: int :: 
              { Uint32__Order.__default.lte(pivot#0, k#7) } 
              LitInt(0) <= k#7 && k#7 < 4294967296
                 ==> Uint32__Order.__default.lte#canCall(LitInt(pivot#0), k#7))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#19: Box :: 
                $IsBox($y#19, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#19): int)))
             && (var restricted_right#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#20: Box :: 
                    $IsBox($y#20, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#20): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                restricted_left#3, 
                restricted_right#3)))
         && Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#22: Box :: 
                  $IsBox($y#22, Tclass.NativeTypes.uint32())
                     && Uint32__Order.__default.lt($Unbox($y#22): int, LitInt(pivot#0)))); 
            (var restricted_right#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#23: Box :: 
                    $IsBox($y#23, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#23): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#3, 
                restricted_right#3))));

// function declaration for Uint32_Order._default.SetSuccessor
function Uint32__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Uint32__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Uint32__Order.__default.SetSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Uint32__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Uint32__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#4_next(m: Set Box, key: int) : int;

function $let#4$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#4_next(m, key) } 
  $let#4$canCall(m, key)
     ==> LitInt(0) <= $let#4_next(m, key)
       && $let#4_next(m, key) < 4294967296
       && 
      m[$Box($let#4_next(m, key))]
       && Uint32__Order.__default.lt(key, $let#4_next(m, key))
       && (forall other#4: int :: 
        { Uint32__Order.__default.lt($let#4_next(m, key), other#4) } 
          { Uint32__Order.__default.lt(key, other#4) } 
          { m[$Box(other#4)] } 
        LitInt(0) <= other#4 && other#4 < 4294967296
           ==> 
          m[$Box(other#4)]
             && other#4 != $let#4_next(m, key)
             && Uint32__Order.__default.lt(key, other#4)
           ==> Uint32__Order.__default.lt($let#4_next(m, key), other#4)));

// definition axiom for Uint32__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Uint32__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> (forall next#4: int :: 
          { Uint32__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
          LitInt(0) <= next#4 && next#4 < 4294967296
             ==> (m#0[$Box(next#4)] ==> Uint32__Order.__default.lt#canCall(key#0, next#4))
               && (Uint32__Order.__default.lt#canCall(key#0, next#4)
                   && Uint32__Order.__default.lt(key#0, next#4)
                 ==> (forall other#3: int :: 
                  { Uint32__Order.__default.lt(next#4, other#3) } 
                    { Uint32__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  LitInt(0) <= other#3 && other#3 < 4294967296
                     ==> (other#3 != next#4 ==> Uint32__Order.__default.lt#canCall(key#0, other#3))
                       && (Uint32__Order.__default.lt#canCall(key#0, other#3)
                           && Uint32__Order.__default.lt(key#0, other#3)
                         ==> Uint32__Order.__default.lt#canCall(next#4, other#3)))))
         && ((exists next#4: int :: 
            { Uint32__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
            LitInt(0) <= next#4
               && next#4 < 4294967296
               && 
              m#0[$Box(next#4)]
               && Uint32__Order.__default.lt(key#0, next#4)
               && (forall other#3: int :: 
                { Uint32__Order.__default.lt(next#4, other#3) } 
                  { Uint32__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                LitInt(0) <= other#3 && other#3 < 4294967296
                   ==> 
                  m#0[$Box(other#3)]
                     && other#3 != next#4
                     && Uint32__Order.__default.lt(key#0, other#3)
                   ==> Uint32__Order.__default.lt(next#4, other#3)))
           ==> $let#4$canCall(m#0, key#0))
         && Uint32__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#4: int :: 
              { Uint32__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
              LitInt(0) <= next#4
                 && next#4 < 4294967296
                 && 
                m#0[$Box(next#4)]
                 && Uint32__Order.__default.lt(key#0, next#4)
                 && (forall other#3: int :: 
                  { Uint32__Order.__default.lt(next#4, other#3) } 
                    { Uint32__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  LitInt(0) <= other#3 && other#3 < 4294967296
                     ==> 
                    m#0[$Box(other#3)]
                       && other#3 != next#4
                       && Uint32__Order.__default.lt(key#0, other#3)
                     ==> Uint32__Order.__default.lt(next#4, other#3)))
             then (var next#5 := $let#4_next(m#0, key#0); #Options.Option.Some($Box(next#5)))
             else #Options.Option.None()));

// definition axiom for Uint32__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> (forall next#6: int :: 
          { Uint32__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
          LitInt(0) <= next#6 && next#6 < 4294967296
             ==> (Lit(m#0)[$Box(next#6)]
                 ==> Uint32__Order.__default.lt#canCall(LitInt(key#0), next#6))
               && (Uint32__Order.__default.lt#canCall(LitInt(key#0), next#6)
                   && Uint32__Order.__default.lt(LitInt(key#0), next#6)
                 ==> (forall other#5: int :: 
                  { Uint32__Order.__default.lt(next#6, other#5) } 
                    { Uint32__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  LitInt(0) <= other#5 && other#5 < 4294967296
                     ==> (other#5 != next#6
                         ==> Uint32__Order.__default.lt#canCall(LitInt(key#0), other#5))
                       && (Uint32__Order.__default.lt#canCall(LitInt(key#0), other#5)
                           && Uint32__Order.__default.lt(LitInt(key#0), other#5)
                         ==> Uint32__Order.__default.lt#canCall(next#6, other#5)))))
         && ((exists next#6: int :: 
            { Uint32__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
            LitInt(0) <= next#6
               && next#6 < 4294967296
               && 
              Lit(m#0)[$Box(next#6)]
               && Uint32__Order.__default.lt(LitInt(key#0), next#6)
               && (forall other#5: int :: 
                { Uint32__Order.__default.lt(next#6, other#5) } 
                  { Uint32__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                LitInt(0) <= other#5 && other#5 < 4294967296
                   ==> 
                  Lit(m#0)[$Box(other#5)]
                     && other#5 != next#6
                     && Uint32__Order.__default.lt(LitInt(key#0), other#5)
                   ==> Uint32__Order.__default.lt(next#6, other#5)))
           ==> $let#4$canCall(Lit(m#0), LitInt(key#0)))
         && Uint32__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#6: int :: 
              { Uint32__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
              LitInt(0) <= next#6
                 && next#6 < 4294967296
                 && 
                Lit(m#0)[$Box(next#6)]
                 && Uint32__Order.__default.lt(LitInt(key#0), next#6)
                 && (forall other#5: int :: 
                  { Uint32__Order.__default.lt(next#6, other#5) } 
                    { Uint32__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  LitInt(0) <= other#5 && other#5 < 4294967296
                     ==> 
                    Lit(m#0)[$Box(other#5)]
                       && other#5 != next#6
                       && Uint32__Order.__default.lt(LitInt(key#0), other#5)
                     ==> Uint32__Order.__default.lt(next#6, other#5)))
             then (var next#7 := $let#4_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#7)))
             else #Options.Option.None()));

// function declaration for Uint32_Order._default.MapSuccessor
function Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.MapSuccessor
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Uint32__Order.__default.MapSuccessor
axiom (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Uint32__Order.__default.MapSuccessor#requires(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.MapSuccessor#requires(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
           == Uint32__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Uint32__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Uint32__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Uint32_Order._default.SeqSuccessor
function Uint32__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Uint32__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.SeqSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Uint32__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.SeqSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall((lambda $y#4: Box :: 
            $IsBox($y#4, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#4)), 
          key#0)
         && Uint32__Order.__default.SeqSuccessor(m#0, key#0)
           == Uint32__Order.__default.SetSuccessor((lambda $y#5: Box :: 
              $IsBox($y#5, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#5)), 
            key#0));

// definition axiom for Uint32__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Uint32__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall((lambda $y#6: Box :: 
            $IsBox($y#6, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#6)), 
          LitInt(key#0))
         && Uint32__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Uint32__Order.__default.SetSuccessor((lambda $y#7: Box :: 
              $IsBox($y#7, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#7)), 
            LitInt(key#0)));

// function declaration for Uint32_Order._default.SortedSeqForMap
function Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Uint32__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> true);

function Uint32__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Uint32__Order.__default.SortedSeqForMap
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap#requires(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V))
     ==> Uint32__Order.__default.SortedSeqForMap#requires(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Uint32__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
            Uint32_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Uint32__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#4: int :: 
            { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
            (i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                 ==> 
                i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))))
         && ((forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              (i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                   ==> 
                  i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
           ==> (forall key#2: int :: 
            { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
            LitInt(0) <= key#2 && key#2 < 4294967296
               ==> 
              Map#Domain(m#0)[$Box(key#2)]
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                (i#5 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                         == key#2
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)))))
         && Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                    Uint32_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall key#2: int :: 
              { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
              LitInt(0) <= key#2 && key#2 < 4294967296
                 ==> 
                Map#Domain(m#0)[$Box(key#2)]
                 ==> (exists i#5: int :: 
                  { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                  LitInt(0) <= i#5
                     && i#5 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                       == key#2
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#2)]))));

// definition axiom for Uint32__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
            Uint32_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Uint32__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#6: int :: 
            { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
            (i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                 ==> 
                i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))))
         && ((forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              (i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                   ==> 
                  i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
           ==> (forall key#3: int :: 
            { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
            LitInt(0) <= key#3 && key#3 < 4294967296
               ==> 
              Map#Domain(m#0)[$Box(key#3)]
               ==> (forall i#7: int :: 
                { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                (i#7 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                         == key#3
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)))))
         && Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                    Uint32_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall key#3: int :: 
              { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
              LitInt(0) <= key#3 && key#3 < 4294967296
                 ==> 
                Map#Domain(m#0)[$Box(key#3)]
                 ==> (exists i#7: int :: 
                  { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                  LitInt(0) <= i#7
                     && i#7 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                       == key#3
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#3)]))));

// function declaration for Uint32_Order._default.minimum
function Uint32__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Uint32__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimum($LS($ly), s#0) } 
  Uint32__Order.__default.minimum($LS($ly), s#0)
     == Uint32__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.minimum($ly, s#0)
     == Uint32__Order.__default.minimum($LZ, s#0));

// consequence axiom for Uint32__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimum($ly, s#0) } 
    Uint32__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.uint32())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Uint32__Order.__default.minimum($ly, s#0))]
         && (forall y#1: int :: 
          { Uint32__Order.__default.lte(Uint32__Order.__default.minimum($ly, s#0), y#1) } 
            { s#0[$Box(y#1)] } 
          LitInt(0) <= y#1 && y#1 < 4294967296 && s#0[$Box(y#1)]
             ==> Uint32__Order.__default.lte(Uint32__Order.__default.minimum($ly, s#0), y#1))
         && 
        LitInt(0) <= Uint32__Order.__default.minimum($ly, s#0)
         && Uint32__Order.__default.minimum($ly, s#0) < 4294967296);

function Uint32__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Uint32__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#7_a(s: Set Box) : int;

function $let#7$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#7_a(s) } 
  $let#7$canCall(s)
     ==> LitInt(0) <= $let#7_a(s) && $let#7_a(s) < 4294967296 && s[$Box($let#7_a(s))]);

// definition axiom for Uint32__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Uint32__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#7$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#7_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.minimum#canCall(s'#4)
               && (var m'#4 := Uint32__Order.__default.minimum($ly, s'#4); 
                Uint32__Order.__default.lt#canCall($let#7_a(s#0), m'#4)))
         && Uint32__Order.__default.minimum($LS($ly), s#0)
           == (var a#2 := $let#7_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Uint32__Order.__default.minimum($ly, s'#5); 
                  (if Uint32__Order.__default.lt(a#2, m'#5) then a#2 else m'#5))))));

// definition axiom for Uint32__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#7$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#7_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.minimum#canCall(s'#6)
               && (var m'#6 := Uint32__Order.__default.minimum($LS($ly), s'#6); 
                Uint32__Order.__default.lt#canCall($let#7_a(Lit(s#0)), m'#6)))
         && Uint32__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#3 := $let#7_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Uint32__Order.__default.minimum($LS($ly), s'#7); 
                  (if Uint32__Order.__default.lt(a#3, m'#7) then a#3 else m'#7))))));

// function declaration for Uint32_Order._default.minimumOpt
function Uint32__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Uint32__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt($LS($ly), s#0) } 
  Uint32__Order.__default.minimumOpt($LS($ly), s#0)
     == Uint32__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.minimumOpt($ly, s#0)
     == Uint32__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Uint32__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimumOpt($ly, s#0) } 
    Uint32__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (Options.Option.Some_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Uint32__Order.__default.lte($Unbox(Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1) } 
              { s#0[$Box(y#1)] } 
            LitInt(0) <= y#1 && y#1 < 4294967296 && s#0[$Box(y#1)]
               ==> Uint32__Order.__default.lte($Unbox(Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1)))
         && (Options.Option.None_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Uint32__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Uint32__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimumOpt($LS($ly), s#0) } 
    Uint32__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.minimum#canCall(s#0))
         && Uint32__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.minimum(StartFuel_Uint32_Order._default.minimum, s#0)))));

// definition axiom for Uint32__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Uint32__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.minimum#canCall(Lit(s#0)))
         && Uint32__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.minimum(StartFuel_Uint32_Order._default.minimum, Lit(s#0))))));

// function declaration for Uint32_Order._default.maximum
function Uint32__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Uint32__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximum($LS($ly), s#0) } 
  Uint32__Order.__default.maximum($LS($ly), s#0)
     == Uint32__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.maximum($ly, s#0)
     == Uint32__Order.__default.maximum($LZ, s#0));

// consequence axiom for Uint32__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximum($ly, s#0) } 
    Uint32__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.uint32())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Uint32__Order.__default.maximum($ly, s#0))]
         && (forall y#1: int :: 
          { Uint32__Order.__default.lte(y#1, Uint32__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#1)] } 
          LitInt(0) <= y#1 && y#1 < 4294967296 && s#0[$Box(y#1)]
             ==> Uint32__Order.__default.lte(y#1, Uint32__Order.__default.maximum($ly, s#0)))
         && 
        LitInt(0) <= Uint32__Order.__default.maximum($ly, s#0)
         && Uint32__Order.__default.maximum($ly, s#0) < 4294967296);

function Uint32__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Uint32__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#10_a(s: Set Box) : int;

function $let#10$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#10_a(s) } 
  $let#10$canCall(s)
     ==> LitInt(0) <= $let#10_a(s) && $let#10_a(s) < 4294967296 && s[$Box($let#10_a(s))]);

// definition axiom for Uint32__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Uint32__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#10$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#10_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.maximum#canCall(s'#4)
               && (var m'#4 := Uint32__Order.__default.maximum($ly, s'#4); 
                Uint32__Order.__default.lt#canCall(m'#4, $let#10_a(s#0))))
         && Uint32__Order.__default.maximum($LS($ly), s#0)
           == (var a#2 := $let#10_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Uint32__Order.__default.maximum($ly, s'#5); 
                  (if Uint32__Order.__default.lt(m'#5, a#2) then a#2 else m'#5))))));

// definition axiom for Uint32__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#10$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#10_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.maximum#canCall(s'#6)
               && (var m'#6 := Uint32__Order.__default.maximum($LS($ly), s'#6); 
                Uint32__Order.__default.lt#canCall(m'#6, $let#10_a(Lit(s#0)))))
         && Uint32__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#3 := $let#10_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Uint32__Order.__default.maximum($LS($ly), s'#7); 
                  (if Uint32__Order.__default.lt(m'#7, a#3) then a#3 else m'#7))))));

// function declaration for Uint32_Order._default.maximumOpt
function Uint32__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Uint32__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt($LS($ly), s#0) } 
  Uint32__Order.__default.maximumOpt($LS($ly), s#0)
     == Uint32__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.maximumOpt($ly, s#0)
     == Uint32__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Uint32__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximumOpt($ly, s#0) } 
    Uint32__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (Options.Option.Some_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Uint32__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#1)] } 
            LitInt(0) <= y#1 && y#1 < 4294967296 && s#0[$Box(y#1)]
               ==> Uint32__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Uint32__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Uint32__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximumOpt($LS($ly), s#0) } 
    Uint32__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.maximum#canCall(s#0))
         && Uint32__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.maximum(StartFuel_Uint32_Order._default.maximum, s#0)))));

// definition axiom for Uint32__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Uint32__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.maximum#canCall(Lit(s#0)))
         && Uint32__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.maximum(StartFuel_Uint32_Order._default.maximum, Lit(s#0))))));

// function declaration for Uint32_Order._default.lt
function Uint32__Order.__default.lt(a#0: int, b#0: int) : bool;

function Uint32__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lt(a#0, b#0) } 
    Uint32__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.lt#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lt(a#0, b#0) } 
    Uint32__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.lt(a#0, b#0)
           == (Uint32__Order.__default.lte(a#0, b#0) && a#0 != b#0));

// definition axiom for Uint32__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.lt#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == Lit(Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) && a#0 != b#0));

// function declaration for Uint32_Order._default.Min
function Uint32__Order.__default.Min(a#0: int, b#0: int) : int;

function Uint32__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Min(a#0, b#0) } 
    Uint32__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> LitInt(0) <= Uint32__Order.__default.Min(a#0, b#0)
         && Uint32__Order.__default.Min(a#0, b#0) < 4294967296);

function Uint32__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.Min#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Min(a#0, b#0) } 
    Uint32__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.Min(a#0, b#0)
           == (if Uint32__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Uint32__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.Min#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then a#0 else b#0));

// function declaration for Uint32_Order._default.Max
function Uint32__Order.__default.Max(a#0: int, b#0: int) : int;

function Uint32__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Max(a#0, b#0) } 
    Uint32__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> LitInt(0) <= Uint32__Order.__default.Max(a#0, b#0)
         && Uint32__Order.__default.Max(a#0, b#0) < 4294967296);

function Uint32__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.Max#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Max(a#0, b#0) } 
    Uint32__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.Max(a#0, b#0)
           == (if Uint32__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Uint32__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.Max#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then b#0 else a#0));

// function declaration for Uint32_Order._default.IsSorted
function Uint32__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Uint32__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted($LS($ly), run#0) } 
  Uint32__Order.__default.IsSorted($LS($ly), run#0)
     == Uint32__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Uint32__Order.__default.IsSorted($ly, run#0)
     == Uint32__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Uint32__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsSorted($ly, run#0) } 
    Uint32__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Uint32__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Uint32__Order.__default.IsSorted($ly, run#0)));

function Uint32__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Uint32__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsSorted($LS($ly), run#0) } 
    Uint32__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Uint32__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 <= j#2 && j#2 < Seq#Length(run#0)
               ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Uint32__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Uint32__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Uint32__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 <= j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Uint32_Order._default.IsStrictlySortedInternal
function Uint32__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Uint32__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySortedInternal(run#0) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> true);

function Uint32__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Uint32__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySortedInternal(run#0) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Uint32__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(run#0)
               ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Uint32__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Uint32_Order._default.IsStrictlySorted
function Uint32__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Uint32__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Uint32__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Uint32__Order.__default.IsStrictlySorted($ly, run#0)
     == Uint32__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Uint32__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySorted($ly, run#0) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Uint32__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Uint32__Order.__default.IsStrictlySorted($ly, run#0))
         && (Uint32__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0)));

function Uint32__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Uint32__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#2 := Uint32__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#2 then b#2 else b#2)));

// definition axiom for Uint32__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> Uint32__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Uint32__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#3 := Lit(Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#3 then b#3 else b#3)));

const unique class.Byte__Order.__default: ClassName;

function Tclass.Byte__Order.__default() : Ty;

// Tclass.Byte__Order.__default Tag
axiom Tag(Tclass.Byte__Order.__default()) == Tagclass.Byte__Order.__default;

const unique Tagclass.Byte__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Byte__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Byte__Order.__default()) } 
  $IsBox(bx, Tclass.Byte__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Byte__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Byte__Order.__default()) } 
  $Is($o, Tclass.Byte__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Byte__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Byte__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Byte__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Byte_Order._default.SomeElement
function Byte__Order.__default.SomeElement() : int;

function Byte__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Byte__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> LitInt(0) <= Byte__Order.__default.SomeElement()
     && Byte__Order.__default.SomeElement() < 256;

function Byte__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Byte__Order.__default.SomeElement
axiom Byte__Order.__default.SomeElement#requires() == true;

// definition axiom for Byte__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Byte__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Byte__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Byte__Order.__default.SomeElement() == LitInt(0);

// function declaration for Byte_Order._default.lte
function Byte__Order.__default.lte($ly: LayerType, a#0: int, b#0: int) : bool;

function Byte__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte($LS($ly), a#0, b#0) } 
  Byte__Order.__default.lte($LS($ly), a#0, b#0)
     == Byte__Order.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  Byte__Order.__default.lte($ly, a#0, b#0)
     == Byte__Order.__default.lte($LZ, a#0, b#0));

// consequence axiom for Byte__Order.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.lte($ly, a#0, b#0) } 
    Byte__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte($ly, a#0, b#0)
           == Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
           || Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0))
         && (forall a#3: int, b#3: int, c#2: int :: 
          { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#3, c#2), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#3, c#2) } 
            { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#3, c#2), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#3, b#3) } 
          LitInt(0) <= a#3
               && a#3 < 256
               && 
              LitInt(0) <= b#3
               && b#3 < 256
               && 
              LitInt(0) <= c#2
               && c#2 < 256
             ==> 
            Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#3, b#3)
               && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#3, c#2)
             ==> Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#3, c#2))
         && Byte__Order.__default.lte($ly, a#0, b#0)
           == Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
           || Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0))
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
             && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#4: int, b#4: int, c#3: int :: 
          { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#4, c#3), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#4, c#3) } 
            { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#4, c#3), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#4, b#4) } 
          LitInt(0) <= a#4
               && a#4 < 256
               && 
              LitInt(0) <= b#4
               && b#4 < 256
               && 
              LitInt(0) <= c#3
               && c#3 < 256
             ==> 
            Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#4, b#4)
               && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#4, c#3)
             ==> Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#4, c#3)));

function Byte__Order.__default.lte#requires(LayerType, int, int) : bool;

// #requires axiom for Byte__Order.__default.lte
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.lte#requires($ly, a#0, b#0) == true);

const MoreFuel_Byte_Order._default.ltedef2: LayerType;

// definition axiom for Byte__Order.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.lte($LS($ly), a#0, b#0) } 
    Byte__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> StartFuel_Byte_Order._default.ltedef
           == $LS(MoreFuel_Byte_Order._default.ltedef2)
         && StartFuelAssert_Byte_Order._default.ltedef
           == $LS($LS(MoreFuel_Byte_Order._default.ltedef2))
         && AsFuelBottom(MoreFuel_Byte_Order._default.ltedef2)
           == MoreFuel_Byte_Order._default.ltedef2
         && Byte__Order.__default.lte($LS($ly), a#0, b#0) == (a#0 <= b#0));

const MoreFuel_Byte_Order._default.ltedef3: LayerType;

// definition axiom for Byte__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.lte($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> StartFuel_Byte_Order._default.ltedef
           == $LS(MoreFuel_Byte_Order._default.ltedef3)
         && StartFuelAssert_Byte_Order._default.ltedef
           == $LS($LS(MoreFuel_Byte_Order._default.ltedef3))
         && AsFuelBottom(MoreFuel_Byte_Order._default.ltedef3)
           == MoreFuel_Byte_Order._default.ltedef3
         && Byte__Order.__default.lte($LS($ly), LitInt(a#0), LitInt(b#0))
           == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Byte_Order._default.ltedef
function Byte__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Byte__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Byte__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Byte__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Byte__Order.__default.ltedef($ly, a#0, b#0)
     == Byte__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Byte__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.ltedef($ly, a#0, b#0) } 
    Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> true);

function Byte__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Byte__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Byte__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Byte__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Byte_Order._default.LargestLte
function Byte__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Byte__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLte($ly, run#0, needle#0)
     == Byte__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
         && Byte__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Byte__Order.__default.LargestLte($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Byte__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Byte__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted8: LayerType;

// definition axiom for Byte__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Byte__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Byte__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted8)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted8))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted8)
           == MoreFuel_Byte_Order._default.IsSorted8
         && Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Byte__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Byte_Order._default.IsSorted9: LayerType;

// definition axiom for Byte__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Byte__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Byte__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Byte__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted9)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted9))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted9)
           == MoreFuel_Byte_Order._default.IsSorted9
         && Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Byte__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Byte__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Byte_Order._default.LargestLt
function Byte__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Byte__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLt($ly, run#0, needle#0)
     == Byte__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Byte__Order.__default.LargestLt($ly, run#0, needle#0)
         && Byte__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 <= Byte__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Byte__Order.__default.LargestLt($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Byte__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted10: LayerType;

// definition axiom for Byte__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Byte__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              needle#0, 
              $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Byte__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted10)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted10))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted10)
           == MoreFuel_Byte_Order._default.IsSorted10
         && Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                needle#0, 
                $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Byte__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Byte_Order._default.IsSorted11: LayerType;

// definition axiom for Byte__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Byte__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              LitInt(needle#0), 
              $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Byte__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted11)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted11))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted11)
           == MoreFuel_Byte_Order._default.IsSorted11
         && Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt(needle#0), 
                $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Byte__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Byte_Order._default.IndexOfFirstGte
function Byte__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Byte__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted12: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), run#0)
             && Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
              needle#0)
             && (!Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), run#0)
                 && Byte__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted12)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted12))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted12)
           == MoreFuel_Byte_Order._default.IsSorted12
         && Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Byte__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0))));

const MoreFuel_Byte_Order._default.IsSorted13: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
             && Byte__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Byte__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
                 && Byte__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted13)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted13))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted13)
           == MoreFuel_Byte_Order._default.IsSorted13
         && Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Byte__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGteIter
function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            key#0, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#3, hi#0)
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              key#0, 
              $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              LitInt(key#0), 
              $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, LitInt(key#0))
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGte
function Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            key#0, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Byte_Order._default.IndexOfFirstGt
function Byte__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Byte__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted14: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), run#0)
             && Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
              needle#0)
             && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), run#0)
                 && Byte__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted14)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted14))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted14)
           == MoreFuel_Byte_Order._default.IsSorted14
         && Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Byte__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0))));

const MoreFuel_Byte_Order._default.IsSorted15: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
             && Byte__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
                 && Byte__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted15)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted15))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted15)
           == MoreFuel_Byte_Order._default.IsSorted15
         && Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Byte__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGtIter
function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#3, hi#0)
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              $Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, 
              key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, 
                  key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              $Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, 
              LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Byte__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, 
                  LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, 
                  LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, 
                  LitInt(key#0))
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGt
function Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Byte_Order._default.SetAllLte
function Byte__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Byte__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Byte__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> true);

function Byte__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Byte__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Byte__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#2: int, y#2: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#2, y#2) } 
            { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          LitInt(0) <= x#2 && x#2 < 256 && LitInt(0) <= y#2 && y#2 < 256
             ==> 
            b#0[$Box(y#2)]
             ==> Byte__Order.__default.lte#canCall(x#2, y#2))
         && Byte__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#2, y#2) } 
              { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            LitInt(0) <= x#2 && x#2 < 256 && LitInt(0) <= y#2 && y#2 < 256
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#2, y#2)));

// definition axiom for Byte__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Byte__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#3: int, y#3: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#3, y#3) } 
            { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          LitInt(0) <= x#3 && x#3 < 256 && LitInt(0) <= y#3 && y#3 < 256
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Byte__Order.__default.lte#canCall(x#3, y#3))
         && Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#3, y#3) } 
              { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            LitInt(0) <= x#3 && x#3 < 256 && LitInt(0) <= y#3 && y#3 < 256
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#3, y#3)));

// function declaration for Byte_Order._default.SetAllLt
function Byte__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Byte__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Byte__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> true);

function Byte__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Byte__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Byte__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#2: int, y#2: int :: 
          { Byte__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          LitInt(0) <= x#2 && x#2 < 256 && LitInt(0) <= y#2 && y#2 < 256
             ==> 
            b#0[$Box(y#2)]
             ==> Byte__Order.__default.lt#canCall(x#2, y#2))
         && Byte__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Byte__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            LitInt(0) <= x#2 && x#2 < 256 && LitInt(0) <= y#2 && y#2 < 256
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Byte__Order.__default.lt(x#2, y#2)));

// definition axiom for Byte__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Byte__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#3: int, y#3: int :: 
          { Byte__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          LitInt(0) <= x#3 && x#3 < 256 && LitInt(0) <= y#3 && y#3 < 256
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Byte__Order.__default.lt#canCall(x#3, y#3))
         && Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Byte__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            LitInt(0) <= x#3 && x#3 < 256 && LitInt(0) <= y#3 && y#3 < 256
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Byte__Order.__default.lt(x#3, y#3)));

// function declaration for Byte_Order._default.NotMinimum
function Byte__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Byte__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
  Byte__Order.__default.NotMinimum($LS($ly), a#0)
     == Byte__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Byte__Order.__default.NotMinimum($ly, a#0)
     == Byte__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Byte__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Byte__Order.__default.NotMinimum($ly, a#0) } 
    Byte__Order.__default.NotMinimum#canCall(a#0) || (LitInt(0) <= a#0 && a#0 < 256)
       ==> true);

function Byte__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Byte__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 256
     ==> Byte__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Byte__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
    Byte__Order.__default.NotMinimum#canCall(a#0) || (LitInt(0) <= a#0 && a#0 < 256)
       ==> (forall b#2: int :: 
          { Byte__Order.__default.lt(b#2, a#0) } 
          LitInt(0) <= b#2 && b#2 < 256 ==> Byte__Order.__default.lt#canCall(b#2, a#0))
         && Byte__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#2: int :: 
            { Byte__Order.__default.lt(b#2, a#0) } 
            LitInt(0) <= b#2 && b#2 < 256 && Byte__Order.__default.lt(b#2, a#0)));

// definition axiom for Byte__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Byte__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    Byte__Order.__default.NotMinimum#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 256)
       ==> (forall b#3: int :: 
          { Byte__Order.__default.lt(b#3, a#0) } 
          LitInt(0) <= b#3 && b#3 < 256
             ==> Byte__Order.__default.lt#canCall(b#3, LitInt(a#0)))
         && Byte__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#3: int :: 
            { Byte__Order.__default.lt(b#3, a#0) } 
            LitInt(0) <= b#3 && b#3 < 256 && Byte__Order.__default.lt(b#3, LitInt(a#0))));

// function declaration for Byte_Order._default.MapPivotedUnion
function Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Byte__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)));

function Byte__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Byte__Order.__default.MapPivotedUnion
axiom (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Byte__Order.__default.MapPivotedUnion#requires(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
       && 
      LitInt(0) <= pivot#0
       && pivot#0 < 256
       && $Is(right#0, 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
     ==> Byte__Order.__default.MapPivotedUnion#requires(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Byte__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#4: int :: 
          { Byte__Order.__default.lt(k#4, pivot#0) } 
          LitInt(0) <= k#4 && k#4 < 256 ==> Byte__Order.__default.lt#canCall(k#4, pivot#0))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
          Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#12: Box :: 
            $IsBox($y#12, Tclass.NativeTypes.byte())
               && Byte__Order.__default.lt($Unbox($y#12): int, pivot#0)))
         && (var restricted_left#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#15: Box :: 
                $IsBox($y#15, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lt($Unbox($y#15): int, pivot#0))); 
          (forall k#5: int :: 
              { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, k#5) } 
              LitInt(0) <= k#5 && k#5 < 256
                 ==> Byte__Order.__default.lte#canCall(pivot#0, k#5))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#13: Box :: 
                $IsBox($y#13, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#13): int)))
             && (var restricted_right#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#14: Box :: 
                    $IsBox($y#14, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#14): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#2, 
                restricted_right#2)))
         && Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#16: Box :: 
                  $IsBox($y#16, Tclass.NativeTypes.byte())
                     && Byte__Order.__default.lt($Unbox($y#16): int, pivot#0))); 
            (var restricted_right#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#17: Box :: 
                    $IsBox($y#17, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#17): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#2, 
                restricted_right#2))));

// definition axiom for Byte__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#6: int :: 
          { Byte__Order.__default.lt(k#6, pivot#0) } 
          LitInt(0) <= k#6 && k#6 < 256
             ==> Byte__Order.__default.lt#canCall(k#6, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
          Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#18: Box :: 
            $IsBox($y#18, Tclass.NativeTypes.byte())
               && Byte__Order.__default.lt($Unbox($y#18): int, LitInt(pivot#0))))
         && (var restricted_left#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#21: Box :: 
                $IsBox($y#21, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lt($Unbox($y#21): int, LitInt(pivot#0)))); 
          (forall k#7: int :: 
              { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, k#7) } 
              LitInt(0) <= k#7 && k#7 < 256
                 ==> Byte__Order.__default.lte#canCall(LitInt(pivot#0), k#7))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#19: Box :: 
                $IsBox($y#19, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#19): int)))
             && (var restricted_right#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#20: Box :: 
                    $IsBox($y#20, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#20): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#3, 
                restricted_right#3)))
         && Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#22: Box :: 
                  $IsBox($y#22, Tclass.NativeTypes.byte())
                     && Byte__Order.__default.lt($Unbox($y#22): int, LitInt(pivot#0)))); 
            (var restricted_right#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#23: Box :: 
                    $IsBox($y#23, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#23): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#3, 
                restricted_right#3))));

// function declaration for Byte_Order._default.SetSuccessor
function Byte__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Byte__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Byte__Order.__default.SetSuccessor(m#0, key#0) } 
    Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> $Is(Byte__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Byte__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Byte__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= key#0
       && key#0 < 256
     ==> Byte__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#13_next(m: Set Box, key: int) : int;

function $let#13$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#13_next(m, key) } 
  $let#13$canCall(m, key)
     ==> LitInt(0) <= $let#13_next(m, key)
       && $let#13_next(m, key) < 256
       && 
      m[$Box($let#13_next(m, key))]
       && Byte__Order.__default.lt(key, $let#13_next(m, key))
       && (forall other#4: int :: 
        { Byte__Order.__default.lt($let#13_next(m, key), other#4) } 
          { Byte__Order.__default.lt(key, other#4) } 
          { m[$Box(other#4)] } 
        LitInt(0) <= other#4 && other#4 < 256
           ==> 
          m[$Box(other#4)]
             && other#4 != $let#13_next(m, key)
             && Byte__Order.__default.lt(key, other#4)
           ==> Byte__Order.__default.lt($let#13_next(m, key), other#4)));

// definition axiom for Byte__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Byte__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> (forall next#4: int :: 
          { Byte__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
          LitInt(0) <= next#4 && next#4 < 256
             ==> (m#0[$Box(next#4)] ==> Byte__Order.__default.lt#canCall(key#0, next#4))
               && (Byte__Order.__default.lt#canCall(key#0, next#4)
                   && Byte__Order.__default.lt(key#0, next#4)
                 ==> (forall other#3: int :: 
                  { Byte__Order.__default.lt(next#4, other#3) } 
                    { Byte__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  LitInt(0) <= other#3 && other#3 < 256
                     ==> (other#3 != next#4 ==> Byte__Order.__default.lt#canCall(key#0, other#3))
                       && (Byte__Order.__default.lt#canCall(key#0, other#3)
                           && Byte__Order.__default.lt(key#0, other#3)
                         ==> Byte__Order.__default.lt#canCall(next#4, other#3)))))
         && ((exists next#4: int :: 
            { Byte__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
            LitInt(0) <= next#4
               && next#4 < 256
               && 
              m#0[$Box(next#4)]
               && Byte__Order.__default.lt(key#0, next#4)
               && (forall other#3: int :: 
                { Byte__Order.__default.lt(next#4, other#3) } 
                  { Byte__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                LitInt(0) <= other#3 && other#3 < 256
                   ==> 
                  m#0[$Box(other#3)]
                     && other#3 != next#4
                     && Byte__Order.__default.lt(key#0, other#3)
                   ==> Byte__Order.__default.lt(next#4, other#3)))
           ==> $let#13$canCall(m#0, key#0))
         && Byte__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#4: int :: 
              { Byte__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
              LitInt(0) <= next#4
                 && next#4 < 256
                 && 
                m#0[$Box(next#4)]
                 && Byte__Order.__default.lt(key#0, next#4)
                 && (forall other#3: int :: 
                  { Byte__Order.__default.lt(next#4, other#3) } 
                    { Byte__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  LitInt(0) <= other#3 && other#3 < 256
                     ==> 
                    m#0[$Box(other#3)]
                       && other#3 != next#4
                       && Byte__Order.__default.lt(key#0, other#3)
                     ==> Byte__Order.__default.lt(next#4, other#3)))
             then (var next#5 := $let#13_next(m#0, key#0); #Options.Option.Some($Box(next#5)))
             else #Options.Option.None()));

// definition axiom for Byte__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> (forall next#6: int :: 
          { Byte__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
          LitInt(0) <= next#6 && next#6 < 256
             ==> (Lit(m#0)[$Box(next#6)]
                 ==> Byte__Order.__default.lt#canCall(LitInt(key#0), next#6))
               && (Byte__Order.__default.lt#canCall(LitInt(key#0), next#6)
                   && Byte__Order.__default.lt(LitInt(key#0), next#6)
                 ==> (forall other#5: int :: 
                  { Byte__Order.__default.lt(next#6, other#5) } 
                    { Byte__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  LitInt(0) <= other#5 && other#5 < 256
                     ==> (other#5 != next#6 ==> Byte__Order.__default.lt#canCall(LitInt(key#0), other#5))
                       && (Byte__Order.__default.lt#canCall(LitInt(key#0), other#5)
                           && Byte__Order.__default.lt(LitInt(key#0), other#5)
                         ==> Byte__Order.__default.lt#canCall(next#6, other#5)))))
         && ((exists next#6: int :: 
            { Byte__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
            LitInt(0) <= next#6
               && next#6 < 256
               && 
              Lit(m#0)[$Box(next#6)]
               && Byte__Order.__default.lt(LitInt(key#0), next#6)
               && (forall other#5: int :: 
                { Byte__Order.__default.lt(next#6, other#5) } 
                  { Byte__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                LitInt(0) <= other#5 && other#5 < 256
                   ==> 
                  Lit(m#0)[$Box(other#5)]
                     && other#5 != next#6
                     && Byte__Order.__default.lt(LitInt(key#0), other#5)
                   ==> Byte__Order.__default.lt(next#6, other#5)))
           ==> $let#13$canCall(Lit(m#0), LitInt(key#0)))
         && Byte__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#6: int :: 
              { Byte__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
              LitInt(0) <= next#6
                 && next#6 < 256
                 && 
                Lit(m#0)[$Box(next#6)]
                 && Byte__Order.__default.lt(LitInt(key#0), next#6)
                 && (forall other#5: int :: 
                  { Byte__Order.__default.lt(next#6, other#5) } 
                    { Byte__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  LitInt(0) <= other#5 && other#5 < 256
                     ==> 
                    Lit(m#0)[$Box(other#5)]
                       && other#5 != next#6
                       && Byte__Order.__default.lt(LitInt(key#0), other#5)
                     ==> Byte__Order.__default.lt(next#6, other#5)))
             then (var next#7 := $let#13_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#7)))
             else #Options.Option.None()));

// function declaration for Byte_Order._default.MapSuccessor
function Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.MapSuccessor
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> $Is(Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Byte__Order.__default.MapSuccessor
axiom (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Byte__Order.__default.MapSuccessor#requires(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 256
     ==> Byte__Order.__default.MapSuccessor#requires(Byte_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0)
           == Byte__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Byte__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Byte__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Byte_Order._default.SeqSuccessor
function Byte__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Byte__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> $Is(Byte__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Byte__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall((lambda $y#4: Box :: 
            $IsBox($y#4, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#4)), 
          key#0)
         && Byte__Order.__default.SeqSuccessor(m#0, key#0)
           == Byte__Order.__default.SetSuccessor((lambda $y#5: Box :: 
              $IsBox($y#5, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#5)), 
            key#0));

// definition axiom for Byte__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Byte__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall((lambda $y#6: Box :: 
            $IsBox($y#6, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#6)), 
          LitInt(key#0))
         && Byte__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Byte__Order.__default.SetSuccessor((lambda $y#7: Box :: 
              $IsBox($y#7, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#7)), 
            LitInt(key#0)));

// function declaration for Byte_Order._default.SortedSeqForMap
function Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Byte__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> true);

function Byte__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Byte__Order.__default.SortedSeqForMap
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap#requires(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V))
     ==> Byte__Order.__default.SortedSeqForMap#requires(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Byte__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
            Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#4: int :: 
            { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
            (i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                 ==> 
                i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))))
         && ((forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              (i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                   ==> 
                  i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
           ==> (forall key#2: int :: 
            { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
            LitInt(0) <= key#2 && key#2 < 256
               ==> 
              Map#Domain(m#0)[$Box(key#2)]
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                (i#5 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                         == key#2
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)))))
         && Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                    Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall key#2: int :: 
              { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
              LitInt(0) <= key#2 && key#2 < 256
                 ==> 
                Map#Domain(m#0)[$Box(key#2)]
                 ==> (exists i#5: int :: 
                  { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                  LitInt(0) <= i#5
                     && i#5 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                       == key#2
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#2)]))));

// definition axiom for Byte__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
            Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#6: int :: 
            { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
            (i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                 ==> 
                i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))))
         && ((forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              (i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                   ==> 
                  i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
           ==> (forall key#3: int :: 
            { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
            LitInt(0) <= key#3 && key#3 < 256
               ==> 
              Map#Domain(m#0)[$Box(key#3)]
               ==> (forall i#7: int :: 
                { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                (i#7 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                         == key#3
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)))))
         && Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                    Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall key#3: int :: 
              { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
              LitInt(0) <= key#3 && key#3 < 256
                 ==> 
                Map#Domain(m#0)[$Box(key#3)]
                 ==> (exists i#7: int :: 
                  { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                  LitInt(0) <= i#7
                     && i#7 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                       == key#3
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#3)]))));

// function declaration for Byte_Order._default.minimum
function Byte__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Byte__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimum($LS($ly), s#0) } 
  Byte__Order.__default.minimum($LS($ly), s#0)
     == Byte__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.minimum($ly, s#0)
     == Byte__Order.__default.minimum($LZ, s#0));

// consequence axiom for Byte__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimum($ly, s#0) } 
    Byte__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.byte())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Byte__Order.__default.minimum($ly, s#0))]
         && (forall y#1: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, Byte__Order.__default.minimum($ly, s#0), y#1) } 
            { s#0[$Box(y#1)] } 
          LitInt(0) <= y#1 && y#1 < 256 && s#0[$Box(y#1)]
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, Byte__Order.__default.minimum($ly, s#0), y#1))
         && 
        LitInt(0) <= Byte__Order.__default.minimum($ly, s#0)
         && Byte__Order.__default.minimum($ly, s#0) < 256);

function Byte__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Byte__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.minimum#requires($ly, s#0) == (Set#Card(s#0) >= LitInt(1)));

function $let#16_a(s: Set Box) : int;

function $let#16$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#16_a(s) } 
  $let#16$canCall(s)
     ==> LitInt(0) <= $let#16_a(s) && $let#16_a(s) < 256 && s[$Box($let#16_a(s))]);

// definition axiom for Byte__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Byte__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#16$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#16_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Byte__Order.__default.minimum#canCall(s'#4)
               && (var m'#4 := Byte__Order.__default.minimum($ly, s'#4); 
                Byte__Order.__default.lt#canCall($let#16_a(s#0), m'#4)))
         && Byte__Order.__default.minimum($LS($ly), s#0)
           == (var a#2 := $let#16_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Byte__Order.__default.minimum($ly, s'#5); 
                  (if Byte__Order.__default.lt(a#2, m'#5) then a#2 else m'#5))))));

// definition axiom for Byte__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#16$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#16_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Byte__Order.__default.minimum#canCall(s'#6)
               && (var m'#6 := Byte__Order.__default.minimum($LS($ly), s'#6); 
                Byte__Order.__default.lt#canCall($let#16_a(Lit(s#0)), m'#6)))
         && Byte__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#3 := $let#16_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Byte__Order.__default.minimum($LS($ly), s'#7); 
                  (if Byte__Order.__default.lt(a#3, m'#7) then a#3 else m'#7))))));

// function declaration for Byte_Order._default.minimumOpt
function Byte__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Byte__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
  Byte__Order.__default.minimumOpt($LS($ly), s#0)
     == Byte__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.minimumOpt($ly, s#0)
     == Byte__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Byte__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimumOpt($ly, s#0) } 
    Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1) } 
              { s#0[$Box(y#1)] } 
            LitInt(0) <= y#1 && y#1 < 256 && s#0[$Box(y#1)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1)))
         && (Options.Option.None_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Byte__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Byte__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
    Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.minimum#canCall(s#0))
         && Byte__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.minimum(StartFuel_Byte_Order._default.minimum, s#0)))));

// definition axiom for Byte__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Byte__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.minimum#canCall(Lit(s#0)))
         && Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.minimum(StartFuel_Byte_Order._default.minimum, Lit(s#0))))));

// function declaration for Byte_Order._default.maximum
function Byte__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Byte__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximum($LS($ly), s#0) } 
  Byte__Order.__default.maximum($LS($ly), s#0)
     == Byte__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.maximum($ly, s#0)
     == Byte__Order.__default.maximum($LZ, s#0));

// consequence axiom for Byte__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximum($ly, s#0) } 
    Byte__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.byte())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Byte__Order.__default.maximum($ly, s#0))]
         && (forall y#1: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, y#1, Byte__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#1)] } 
          LitInt(0) <= y#1 && y#1 < 256 && s#0[$Box(y#1)]
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, y#1, Byte__Order.__default.maximum($ly, s#0)))
         && 
        LitInt(0) <= Byte__Order.__default.maximum($ly, s#0)
         && Byte__Order.__default.maximum($ly, s#0) < 256);

function Byte__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Byte__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.maximum#requires($ly, s#0) == (Set#Card(s#0) >= LitInt(1)));

function $let#19_a(s: Set Box) : int;

function $let#19$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#19_a(s) } 
  $let#19$canCall(s)
     ==> LitInt(0) <= $let#19_a(s) && $let#19_a(s) < 256 && s[$Box($let#19_a(s))]);

// definition axiom for Byte__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Byte__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#19$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#19_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Byte__Order.__default.maximum#canCall(s'#4)
               && (var m'#4 := Byte__Order.__default.maximum($ly, s'#4); 
                Byte__Order.__default.lt#canCall(m'#4, $let#19_a(s#0))))
         && Byte__Order.__default.maximum($LS($ly), s#0)
           == (var a#2 := $let#19_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Byte__Order.__default.maximum($ly, s'#5); 
                  (if Byte__Order.__default.lt(m'#5, a#2) then a#2 else m'#5))))));

// definition axiom for Byte__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#19$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#19_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Byte__Order.__default.maximum#canCall(s'#6)
               && (var m'#6 := Byte__Order.__default.maximum($LS($ly), s'#6); 
                Byte__Order.__default.lt#canCall(m'#6, $let#19_a(Lit(s#0)))))
         && Byte__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#3 := $let#19_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Byte__Order.__default.maximum($LS($ly), s'#7); 
                  (if Byte__Order.__default.lt(m'#7, a#3) then a#3 else m'#7))))));

// function declaration for Byte_Order._default.maximumOpt
function Byte__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Byte__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
  Byte__Order.__default.maximumOpt($LS($ly), s#0)
     == Byte__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.maximumOpt($ly, s#0)
     == Byte__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Byte__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximumOpt($ly, s#0) } 
    Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                y#1, 
                $Unbox(Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#1)] } 
            LitInt(0) <= y#1 && y#1 < 256 && s#0[$Box(y#1)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                y#1, 
                $Unbox(Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Byte__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Byte__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
    Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.maximum#canCall(s#0))
         && Byte__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.maximum(StartFuel_Byte_Order._default.maximum, s#0)))));

// definition axiom for Byte__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Byte__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.maximum#canCall(Lit(s#0)))
         && Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.maximum(StartFuel_Byte_Order._default.maximum, Lit(s#0))))));

// function declaration for Byte_Order._default.lt
function Byte__Order.__default.lt(a#0: int, b#0: int) : bool;

function Byte__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.lt(a#0, b#0) } 
    Byte__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> true);

function Byte__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.lt#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.lt(a#0, b#0) } 
    Byte__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.lt(a#0, b#0)
           == (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             && a#0 != b#0));

// definition axiom for Byte__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.lt#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             && a#0 != b#0));

// function declaration for Byte_Order._default.Min
function Byte__Order.__default.Min(a#0: int, b#0: int) : int;

function Byte__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Min(a#0, b#0) } 
    Byte__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> LitInt(0) <= Byte__Order.__default.Min(a#0, b#0)
         && Byte__Order.__default.Min(a#0, b#0) < 256);

function Byte__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.Min#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Min(a#0, b#0) } 
    Byte__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.Min(a#0, b#0)
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             then a#0
             else b#0));

// definition axiom for Byte__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.Min#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             then a#0
             else b#0));

// function declaration for Byte_Order._default.Max
function Byte__Order.__default.Max(a#0: int, b#0: int) : int;

function Byte__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Max(a#0, b#0) } 
    Byte__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> LitInt(0) <= Byte__Order.__default.Max(a#0, b#0)
         && Byte__Order.__default.Max(a#0, b#0) < 256);

function Byte__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.Max#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Max(a#0, b#0) } 
    Byte__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.Max(a#0, b#0)
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             then b#0
             else a#0));

// definition axiom for Byte__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.Max#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             then b#0
             else a#0));

// function declaration for Byte_Order._default.IsSorted
function Byte__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Byte__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted($LS($ly), run#0) } 
  Byte__Order.__default.IsSorted($LS($ly), run#0)
     == Byte__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Byte__Order.__default.IsSorted($ly, run#0)
     == Byte__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Byte__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsSorted($ly, run#0) } 
    Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(run#0) == LitInt(0) ==> Byte__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1) ==> Byte__Order.__default.IsSorted($ly, run#0)));

function Byte__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Byte__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsSorted($LS($ly), run#0) } 
    Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Byte__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 <= j#2 && j#2 < Seq#Length(run#0)
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Seq#Index(run#0, i#2)): int, 
                $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Byte__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Byte__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Byte__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 <= j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Seq#Index(Lit(run#0), i#3)): int, 
                $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Byte_Order._default.IsStrictlySortedInternal
function Byte__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Byte__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function Byte__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Byte__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Byte__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(run#0)
               ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Byte__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Byte__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Byte_Order._default.IsStrictlySorted
function Byte__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Byte__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Byte__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Byte__Order.__default.IsStrictlySorted($ly, run#0)
     == Byte__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Byte__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySorted($ly, run#0) } 
    Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Byte__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0)));

function Byte__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Byte__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#2 := Byte__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#2 then b#2 else b#2)));

// definition axiom for Byte__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Byte__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#3 := Lit(Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#3 then b#3 else b#3)));

const unique class.Lexicographic__Byte__Order.__default: ClassName;

function Tclass.Lexicographic__Byte__Order.__default() : Ty;

// Tclass.Lexicographic__Byte__Order.__default Tag
axiom Tag(Tclass.Lexicographic__Byte__Order.__default())
   == Tagclass.Lexicographic__Byte__Order.__default;

const unique Tagclass.Lexicographic__Byte__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Lexicographic__Byte__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Lexicographic__Byte__Order.__default()) } 
  $IsBox(bx, Tclass.Lexicographic__Byte__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Lexicographic__Byte__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Lexicographic__Byte__Order.__default()) } 
  $Is($o, Tclass.Lexicographic__Byte__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Lexicographic__Byte__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Lexicographic__Byte__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Lexicographic__Byte__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Lexicographic_Byte_Order._default.SomeElement
function Lexicographic__Byte__Order.__default.SomeElement() : Seq Box;

function Lexicographic__Byte__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> $Is(Lexicographic__Byte__Order.__default.SomeElement(), 
    TSeq(Tclass.NativeTypes.byte()));

function Lexicographic__Byte__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SomeElement
axiom Lexicographic__Byte__Order.__default.SomeElement#requires() == true;

// definition axiom for Lexicographic__Byte__Order.__default.SomeElement(revealed)
axiom true
   ==> 
  true
   ==> Lexicographic__Byte__Order.__default.SomeElement() == Lit(Seq#Empty(): Seq Box);

// definition axiom for Lexicographic__Byte__Order.__default.SomeElement for all literals(revealed)
axiom true
   ==> 
  true
   ==> Lexicographic__Byte__Order.__default.SomeElement() == Lit(Seq#Empty(): Seq Box);

// function declaration for Lexicographic_Byte_Order._default.lte
function Lexicographic__Byte__Order.__default.lte(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.lte
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           || Lexicographic__Byte__Order.__default.ltedef(b#0, a#0))
         && (forall a#3: Seq Box, b#3: Seq Box, c#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.ltedef(a#3, c#2), Lexicographic__Byte__Order.__default.ltedef(b#3, c#2) } 
            { Lexicographic__Byte__Order.__default.ltedef(b#3, c#2), Lexicographic__Byte__Order.__default.ltedef(a#3, b#3) } 
          $Is(a#3, TSeq(Tclass.NativeTypes.byte()))
               && $Is(b#3, TSeq(Tclass.NativeTypes.byte()))
               && $Is(c#2, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lexicographic__Byte__Order.__default.ltedef(a#3, b#3)
               && Lexicographic__Byte__Order.__default.ltedef(b#3, c#2)
             ==> Lexicographic__Byte__Order.__default.ltedef(a#3, c#2))
         && Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           || Lexicographic__Byte__Order.__default.ltedef(b#0, a#0))
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
             && Lexicographic__Byte__Order.__default.ltedef(b#0, a#0)
           ==> Seq#Equal(a#0, b#0))
         && (forall a#4: Seq Box, b#4: Seq Box, c#3: Seq Box :: 
          { Lexicographic__Byte__Order.__default.ltedef(a#4, c#3), Lexicographic__Byte__Order.__default.ltedef(b#4, c#3) } 
            { Lexicographic__Byte__Order.__default.ltedef(b#4, c#3), Lexicographic__Byte__Order.__default.ltedef(a#4, b#4) } 
          $Is(a#4, TSeq(Tclass.NativeTypes.byte()))
               && $Is(b#4, TSeq(Tclass.NativeTypes.byte()))
               && $Is(c#3, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lexicographic__Byte__Order.__default.ltedef(a#4, b#4)
               && Lexicographic__Byte__Order.__default.ltedef(b#4, c#3)
             ==> Lexicographic__Byte__Order.__default.ltedef(a#4, c#3)));

function Lexicographic__Byte__Order.__default.lte#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.lte
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.lte#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.lte#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0));

// definition axiom for Lexicographic__Byte__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0)));

// function declaration for Lexicographic_Byte_Order._default.ltedef
function Lexicographic__Byte__Order.__default.ltedef(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.ltedef#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.ltedef
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.ltedef(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.ltedef#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.ltedef
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.ltedef#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.ltedef#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.ltedef(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.ltedef(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0));

// definition axiom for Lexicographic__Byte__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.ltedef(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.ltedef(Lit(a#0), Lit(b#0))
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0)));

// function declaration for Lexicographic_Byte_Order._default.LargestLte
function Lexicographic__Byte__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1)
           <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
         && Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
           < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): Seq Box, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          true
             ==> 
            Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): Seq Box))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0)
               <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             && Seq#Equal($Unbox(Seq#Index(run#0, Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0))): Seq Box, 
              needle#0)));

function Lexicographic__Byte__Order.__default.LargestLte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted8: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted8)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted8))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted8)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted8
         && Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted9: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lt(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted9)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted9))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted9)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted9
         && Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lt(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0))));

// function declaration for Lexicographic_Byte_Order._default.LargestLt
function Lexicographic__Byte__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1)
           <= Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
         && Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
           < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): Seq Box, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          true
             ==> 
            Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): Seq Box))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1
               < Seq#Length(run#0)
             && Seq#Equal($Unbox(Seq#Index(run#0, Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): Seq Box, 
              needle#0)));

function Lexicographic__Byte__Order.__default.LargestLt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted10: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted10)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted10))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted10)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted10
         && Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted11: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lte(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted11)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted11))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted11)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted11
         && Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lte(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0))));

// function declaration for Lexicographic_Byte_Order._default.IndexOfFirstGte
function Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          LitInt(0) <= i#2
               && i#2 < Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): Seq Box, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
                 <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): Seq Box))
         && LitInt(0)
           <= Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted12: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
             && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
              needle#0)
             && (!Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted12)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted12))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted12)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted12
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               then Seq#Length(run#0)
               else Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), 
                needle#0))));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted13: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
             && Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
              Lit(needle#0))
             && (!Lit(Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                  Lit(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                  Lit(needle#0))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted13)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted13))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted13)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted13
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                Lit(needle#0))
               then Seq#Length(Lit(run#0))
               else Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                Lit(needle#0)))));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGteIter
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box))));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#3, hi#0)
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): Seq Box, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): Seq Box, Lit(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Lexicographic__Byte__Order.__default.lte(Lit(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), mid#5, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), mid#5))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): Seq Box, Lit(key#0))
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), mid#5, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), Lit(key#0))
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Lexicographic_Byte_Order._default.IndexOfFirstGt
function Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          LitInt(0) <= i#2
               && i#2 < Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): Seq Box, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): Seq Box))
         && LitInt(0)
           <= Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted14: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
             && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
              needle#0)
             && (!Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted14)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted14))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted14)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted14
         && Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               then Seq#Length(run#0)
               else Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), 
                needle#0))));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted15: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
             && Lexicographic__Byte__Order.__default.lte#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
              Lit(needle#0))
             && (!Lit(Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                  Lit(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                  Lit(needle#0))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted15)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted15))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted15)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted15
         && Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                Lit(needle#0))
               then Seq#Length(Lit(run#0))
               else Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                Lit(needle#0)))));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGtIter
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box))));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#3, hi#0)
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): Seq Box, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): Seq Box, Lit(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), mid#5, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), mid#5))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): Seq Box, Lit(key#0))
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), mid#5, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), Lit(key#0))
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Lexicographic_Byte_Order._default.SetAllLte
function Lexicographic__Byte__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> true);

function Lexicographic__Byte__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#2: Seq Box, y#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(x#2, y#2) } 
            { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          $Is(x#2, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#2, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            b#0[$Box(y#2)]
             ==> Lexicographic__Byte__Order.__default.lte#canCall(x#2, y#2))
         && Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#2: Seq Box, y#2: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(x#2, y#2) } 
              { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            $Is(x#2, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#2, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Lexicographic__Byte__Order.__default.lte(x#2, y#2)));

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#3: Seq Box, y#3: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(x#3, y#3) } 
            { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          $Is(x#3, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#3, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Lexicographic__Byte__Order.__default.lte#canCall(x#3, y#3))
         && Lexicographic__Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#3: Seq Box, y#3: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(x#3, y#3) } 
              { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            $Is(x#3, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#3, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Lexicographic__Byte__Order.__default.lte(x#3, y#3)));

// function declaration for Lexicographic_Byte_Order._default.SetAllLt
function Lexicographic__Byte__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> true);

function Lexicographic__Byte__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#2: Seq Box, y#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(x#2, y#2) } 
            { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          $Is(x#2, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#2, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            b#0[$Box(y#2)]
             ==> Lexicographic__Byte__Order.__default.lt#canCall(x#2, y#2))
         && Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#2: Seq Box, y#2: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(x#2, y#2) } 
              { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            $Is(x#2, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#2, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Lexicographic__Byte__Order.__default.lt(x#2, y#2)));

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#3: Seq Box, y#3: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(x#3, y#3) } 
            { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          $Is(x#3, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#3, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Lexicographic__Byte__Order.__default.lt#canCall(x#3, y#3))
         && Lexicographic__Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#3: Seq Box, y#3: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(x#3, y#3) } 
              { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            $Is(x#3, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#3, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Lexicographic__Byte__Order.__default.lt(x#3, y#3)));

// function declaration for Lexicographic_Byte_Order._default.NotMinimum
function Lexicographic__Byte__Order.__default.NotMinimum($ly: LayerType, a#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
  Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0)
     == Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0)
     == Lexicographic__Byte__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Lexicographic__Byte__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function Lexicographic__Byte__Order.__default.NotMinimum#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum#requires($ly, a#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall b#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(b#2, a#0) } 
          $Is(b#2, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(b#2, a#0))
         && Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#2: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(b#2, a#0) } 
            $Is(b#2, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt(b#2, a#0)));

// definition axiom for Lexicographic__Byte__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), Lit(a#0)) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(Lit(a#0))
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall b#3: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(b#3, a#0) } 
          $Is(b#3, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(b#3, Lit(a#0)))
         && Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), Lit(a#0))
           == (exists b#3: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(b#3, a#0) } 
            $Is(b#3, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt(b#3, Lit(a#0))));

// function declaration for Lexicographic_Byte_Order._default.MapPivotedUnion
function Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box)
   : Map Box Box;

function Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0)
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0), 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value)));

function Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, Seq Box, Map Box Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion
axiom (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
      left#0, 
      pivot#0, 
      right#0) } 
  $Is(left#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
       && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(right#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
     ==> Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0)
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#4: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#4, pivot#0) } 
          $Is(k#4, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#4, pivot#0))
         && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#12: Box :: 
            $IsBox($y#12, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#12): Seq Box, pivot#0)))
         && (var restricted_left#2 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#15: Box :: 
                $IsBox($y#15, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lt($Unbox($y#15): Seq Box, pivot#0))); 
          (forall k#5: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, k#5) } 
              $Is(k#5, TSeq(Tclass.NativeTypes.byte()))
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, k#5))
             && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#13: Box :: 
                $IsBox($y#13, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#13): Seq Box)))
             && (var restricted_right#2 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#14: Box :: 
                    $IsBox($y#14, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#14): Seq Box))); 
              Maps.__default.MapDisjointUnion#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#2, 
                restricted_right#2)))
         && Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
            left#0, 
            pivot#0, 
            right#0)
           == (var restricted_left#2 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#16: Box :: 
                  $IsBox($y#16, TSeq(Tclass.NativeTypes.byte()))
                     && Lexicographic__Byte__Order.__default.lt($Unbox($y#16): Seq Box, pivot#0))); 
            (var restricted_right#2 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#17: Box :: 
                    $IsBox($y#17, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#17): Seq Box))); 
              Maps.__default.MapDisjointUnion(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#2, 
                restricted_right#2))));

// definition axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        Lit(pivot#0), 
        Lit(right#0)) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          Lit(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#6: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#6, pivot#0) } 
          $Is(k#6, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#6, Lit(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#18: Box :: 
            $IsBox($y#18, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#18): Seq Box, Lit(pivot#0))))
         && (var restricted_left#3 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#21: Box :: 
                $IsBox($y#21, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lt($Unbox($y#21): Seq Box, Lit(pivot#0)))); 
          (forall k#7: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, k#7) } 
              $Is(k#7, TSeq(Tclass.NativeTypes.byte()))
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), k#7))
             && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#19: Box :: 
                $IsBox($y#19, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#19): Seq Box)))
             && (var restricted_right#3 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#20: Box :: 
                    $IsBox($y#20, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#20): Seq Box))); 
              Maps.__default.MapDisjointUnion#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#3, 
                restricted_right#3)))
         && Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            Lit(pivot#0), 
            Lit(right#0))
           == (var restricted_left#3 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#22: Box :: 
                  $IsBox($y#22, TSeq(Tclass.NativeTypes.byte()))
                     && Lexicographic__Byte__Order.__default.lt($Unbox($y#22): Seq Box, Lit(pivot#0)))); 
            (var restricted_right#3 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#23: Box :: 
                    $IsBox($y#23, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#23): Seq Box))); 
              Maps.__default.MapDisjointUnion(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#3, 
                restricted_right#3))));

// function declaration for Lexicographic_Byte_Order._default.SetSuccessor
function Lexicographic__Byte__Order.__default.SetSuccessor(m#0: Set Box, key#0: Seq Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.SetSuccessor#requires(Set Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#22_next(m: Set Box, key: Seq Box) : Seq Box;

function $let#22$canCall(m: Set Box, key: Seq Box) : bool;

axiom (forall m: Set Box, key: Seq Box :: 
  { $let#22_next(m, key) } 
  $let#22$canCall(m, key)
     ==> $Is($let#22_next(m, key), TSeq(Tclass.NativeTypes.byte()))
       && 
      m[$Box($let#22_next(m, key))]
       && Lexicographic__Byte__Order.__default.lt(key, $let#22_next(m, key))
       && (forall other#4: Seq Box :: 
        { Lexicographic__Byte__Order.__default.lt($let#22_next(m, key), other#4) } 
          { Lexicographic__Byte__Order.__default.lt(key, other#4) } 
          { m[$Box(other#4)] } 
        $Is(other#4, TSeq(Tclass.NativeTypes.byte()))
           ==> 
          m[$Box(other#4)]
             && !Seq#Equal(other#4, $let#22_next(m, key))
             && Lexicographic__Byte__Order.__default.lt(key, other#4)
           ==> Lexicographic__Byte__Order.__default.lt($let#22_next(m, key), other#4)));

// definition axiom for Lexicographic__Byte__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (forall next#4: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, next#4) } 
            { m#0[$Box(next#4)] } 
          $Is(next#4, TSeq(Tclass.NativeTypes.byte()))
             ==> (m#0[$Box(next#4)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, next#4))
               && (Lexicographic__Byte__Order.__default.lt#canCall(key#0, next#4)
                   && Lexicographic__Byte__Order.__default.lt(key#0, next#4)
                 ==> (forall other#3: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#4, other#3) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  $Is(other#3, TSeq(Tclass.NativeTypes.byte()))
                     ==> (!Seq#Equal(other#3, next#4)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, other#3))
                       && (Lexicographic__Byte__Order.__default.lt#canCall(key#0, other#3)
                           && Lexicographic__Byte__Order.__default.lt(key#0, other#3)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(next#4, other#3)))))
         && ((exists next#4: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#0, next#4) } 
              { m#0[$Box(next#4)] } 
            $Is(next#4, TSeq(Tclass.NativeTypes.byte()))
               && 
              m#0[$Box(next#4)]
               && Lexicographic__Byte__Order.__default.lt(key#0, next#4)
               && (forall other#3: Seq Box :: 
                { Lexicographic__Byte__Order.__default.lt(next#4, other#3) } 
                  { Lexicographic__Byte__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                $Is(other#3, TSeq(Tclass.NativeTypes.byte()))
                   ==> 
                  m#0[$Box(other#3)]
                     && !Seq#Equal(other#3, next#4)
                     && Lexicographic__Byte__Order.__default.lt(key#0, other#3)
                   ==> Lexicographic__Byte__Order.__default.lt(next#4, other#3)))
           ==> $let#22$canCall(m#0, key#0))
         && Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#4: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#0, next#4) } 
                { m#0[$Box(next#4)] } 
              $Is(next#4, TSeq(Tclass.NativeTypes.byte()))
                 && 
                m#0[$Box(next#4)]
                 && Lexicographic__Byte__Order.__default.lt(key#0, next#4)
                 && (forall other#3: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#4, other#3) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  $Is(other#3, TSeq(Tclass.NativeTypes.byte()))
                     ==> 
                    m#0[$Box(other#3)]
                       && !Seq#Equal(other#3, next#4)
                       && Lexicographic__Byte__Order.__default.lt(key#0, other#3)
                     ==> Lexicographic__Byte__Order.__default.lt(next#4, other#3)))
             then (var next#5 := $let#22_next(m#0, key#0); #Options.Option.Some($Box(next#5)))
             else #Options.Option.None()));

// definition axiom for Lexicographic__Byte__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetSuccessor(Lit(m#0), Lit(key#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Lit(m#0), Lit(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (forall next#6: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, next#6) } 
            { m#0[$Box(next#6)] } 
          $Is(next#6, TSeq(Tclass.NativeTypes.byte()))
             ==> (Lit(m#0)[$Box(next#6)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), next#6))
               && (Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), next#6)
                   && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#6)
                 ==> (forall other#5: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#6, other#5) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  $Is(other#5, TSeq(Tclass.NativeTypes.byte()))
                     ==> (!Seq#Equal(other#5, next#6)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), other#5))
                       && (Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), other#5)
                           && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#5)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(next#6, other#5)))))
         && ((exists next#6: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#0, next#6) } 
              { m#0[$Box(next#6)] } 
            $Is(next#6, TSeq(Tclass.NativeTypes.byte()))
               && 
              Lit(m#0)[$Box(next#6)]
               && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#6)
               && (forall other#5: Seq Box :: 
                { Lexicographic__Byte__Order.__default.lt(next#6, other#5) } 
                  { Lexicographic__Byte__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                $Is(other#5, TSeq(Tclass.NativeTypes.byte()))
                   ==> 
                  Lit(m#0)[$Box(other#5)]
                     && !Seq#Equal(other#5, next#6)
                     && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#5)
                   ==> Lexicographic__Byte__Order.__default.lt(next#6, other#5)))
           ==> $let#22$canCall(Lit(m#0), Lit(key#0)))
         && Lexicographic__Byte__Order.__default.SetSuccessor(Lit(m#0), Lit(key#0))
           == (if (exists next#6: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#0, next#6) } 
                { m#0[$Box(next#6)] } 
              $Is(next#6, TSeq(Tclass.NativeTypes.byte()))
                 && 
                Lit(m#0)[$Box(next#6)]
                 && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#6)
                 && (forall other#5: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#6, other#5) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  $Is(other#5, TSeq(Tclass.NativeTypes.byte()))
                     ==> 
                    Lit(m#0)[$Box(other#5)]
                       && !Seq#Equal(other#5, next#6)
                       && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#5)
                     ==> Lexicographic__Byte__Order.__default.lt(next#6, other#5)))
             then (var next#7 := $let#22_next(Lit(m#0), Lit(key#0)); 
              #Options.Option.Some($Box(next#7)))
             else #Options.Option.None()));

// function declaration for Lexicographic_Byte_Order._default.MapSuccessor
function Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box)
   : DatatypeType;

function Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box)
   : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.MapSuccessor
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.MapSuccessor#requires(Ty, Map Box Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.MapSuccessor
axiom (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.MapSuccessor#requires(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapSuccessor$V))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.MapSuccessor#requires(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
           == Lexicographic__Byte__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Lexicographic__Byte__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0))
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), Lit(key#0))
         && Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0))
           == Lit(Lexicographic__Byte__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), Lit(key#0))));

// function declaration for Lexicographic_Byte_Order._default.SeqSuccessor
function Lexicographic__Byte__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: Seq Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.SeqSuccessor#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall((lambda $y#4: Box :: 
            $IsBox($y#4, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#4)), 
          key#0)
         && Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0)
           == Lexicographic__Byte__Order.__default.SetSuccessor((lambda $y#5: Box :: 
              $IsBox($y#5, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#5)), 
            key#0));

// definition axiom for Lexicographic__Byte__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SeqSuccessor(Lit(m#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(Lit(m#0), Lit(key#0))
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall((lambda $y#6: Box :: 
            $IsBox($y#6, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#6)), 
          Lit(key#0))
         && Lexicographic__Byte__Order.__default.SeqSuccessor(Lit(m#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.SetSuccessor((lambda $y#7: Box :: 
              $IsBox($y#7, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#7)), 
            Lit(key#0)));

// function declaration for Lexicographic_Byte_Order._default.SortedSeqForMap
function Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> true);

function Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V))
     ==> Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
          s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#4: int :: 
            { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
            (i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                 ==> 
                i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))))
         && ((forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              (i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                   ==> 
                  i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
           ==> (forall key#2: Seq Box :: 
            { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
            $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Map#Domain(m#0)[$Box(key#2)]
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                (i#5 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): Seq Box, 
                        key#2)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)))))
         && Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                    Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall key#2: Seq Box :: 
              { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
              $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                Map#Domain(m#0)[$Box(key#2)]
                 ==> (exists i#5: int :: 
                  { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                  LitInt(0) <= i#5
                     && i#5 < Seq#Length(s#0)
                     && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): Seq Box, 
                      key#2)
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#2)]))));

// definition axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
        $LS($ly), 
        Lit(s#0), 
        Lit(m#0)) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
          Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#6: int :: 
            { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
            (i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                 ==> 
                i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))))
         && ((forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              (i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                   ==> 
                  i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
           ==> (forall key#3: Seq Box :: 
            { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
            $Is(key#3, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Map#Domain(m#0)[$Box(key#3)]
               ==> (forall i#7: int :: 
                { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                (i#7 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): Seq Box, 
                        key#3)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)))))
         && Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            $LS($ly), 
            Lit(s#0), 
            Lit(m#0))
           == (
            Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                    Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall key#3: Seq Box :: 
              { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
              $Is(key#3, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                Map#Domain(m#0)[$Box(key#3)]
                 ==> (exists i#7: int :: 
                  { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                  LitInt(0) <= i#7
                     && i#7 < Seq#Length(Lit(s#0))
                     && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): Seq Box, 
                      key#3)
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#3)]))));

// function declaration for Lexicographic_Byte_Order._default.minimum
function Lexicographic__Byte__Order.__default.minimum($ly: LayerType, s#0: Set Box) : Seq Box;

function Lexicographic__Byte__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimum($ly, s#0)
     == Lexicographic__Byte__Order.__default.minimum($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimum($ly, s#0) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte()))) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Lexicographic__Byte__Order.__default.minimum($ly, s#0))]
         && (forall y#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(Lexicographic__Byte__Order.__default.minimum($ly, s#0), y#1) } 
            { s#0[$Box(y#1)] } 
          $Is(y#1, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#1)]
             ==> Lexicographic__Byte__Order.__default.lte(Lexicographic__Byte__Order.__default.minimum($ly, s#0), y#1))
         && $Is(Lexicographic__Byte__Order.__default.minimum($ly, s#0), 
          TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#25_a(s: Set Box) : Seq Box;

function $let#25$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#25_a(s) } 
  $let#25$canCall(s)
     ==> $Is($let#25_a(s), TSeq(Tclass.NativeTypes.byte())) && s[$Box($let#25_a(s))]);

// definition axiom for Lexicographic__Byte__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#25$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#25_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.minimum#canCall(s'#4)
               && (var m'#4 := Lexicographic__Byte__Order.__default.minimum($ly, s'#4); 
                Lexicographic__Byte__Order.__default.lt#canCall($let#25_a(s#0), m'#4)))
         && Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0)
           == (var a#2 := $let#25_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Lexicographic__Byte__Order.__default.minimum($ly, s'#5); 
                  (if Lexicographic__Byte__Order.__default.lt(a#2, m'#5) then a#2 else m'#5))))));

// definition axiom for Lexicographic__Byte__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#25$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#25_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.minimum#canCall(s'#6)
               && (var m'#6 := Lexicographic__Byte__Order.__default.minimum($LS($ly), s'#6); 
                Lexicographic__Byte__Order.__default.lt#canCall($let#25_a(Lit(s#0)), m'#6)))
         && Lexicographic__Byte__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#3 := $let#25_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Lexicographic__Byte__Order.__default.minimum($LS($ly), s'#7); 
                  (if Lexicographic__Byte__Order.__default.lt(a#3, m'#7) then a#3 else m'#7))))));

// function declaration for Lexicographic_Byte_Order._default.minimumOpt
function Lexicographic__Byte__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0)
     == Lexicographic__Byte__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (Options.Option.Some_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))): Seq Box, 
                y#1) } 
              { s#0[$Box(y#1)] } 
            $Is(y#1, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#1)]
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))): Seq Box, 
                y#1)))
         && (Options.Option.None_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.minimum#canCall(s#0))
         && Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.minimum(StartFuel_Lexicographic_Byte_Order._default.minimum, s#0)))));

// definition axiom for Lexicographic__Byte__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.minimum#canCall(Lit(s#0)))
         && Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.minimum(StartFuel_Lexicographic_Byte_Order._default.minimum, Lit(s#0))))));

// function declaration for Lexicographic_Byte_Order._default.maximum
function Lexicographic__Byte__Order.__default.maximum($ly: LayerType, s#0: Set Box) : Seq Box;

function Lexicographic__Byte__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximum($ly, s#0)
     == Lexicographic__Byte__Order.__default.maximum($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximum($ly, s#0) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte()))) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Lexicographic__Byte__Order.__default.maximum($ly, s#0))]
         && (forall y#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(y#1, Lexicographic__Byte__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#1)] } 
          $Is(y#1, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#1)]
             ==> Lexicographic__Byte__Order.__default.lte(y#1, Lexicographic__Byte__Order.__default.maximum($ly, s#0)))
         && $Is(Lexicographic__Byte__Order.__default.maximum($ly, s#0), 
          TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#28_a(s: Set Box) : Seq Box;

function $let#28$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#28_a(s) } 
  $let#28$canCall(s)
     ==> $Is($let#28_a(s), TSeq(Tclass.NativeTypes.byte())) && s[$Box($let#28_a(s))]);

// definition axiom for Lexicographic__Byte__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#28$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#28_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.maximum#canCall(s'#4)
               && (var m'#4 := Lexicographic__Byte__Order.__default.maximum($ly, s'#4); 
                Lexicographic__Byte__Order.__default.lt#canCall(m'#4, $let#28_a(s#0))))
         && Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0)
           == (var a#2 := $let#28_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Lexicographic__Byte__Order.__default.maximum($ly, s'#5); 
                  (if Lexicographic__Byte__Order.__default.lt(m'#5, a#2) then a#2 else m'#5))))));

// definition axiom for Lexicographic__Byte__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#28$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#28_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.maximum#canCall(s'#6)
               && (var m'#6 := Lexicographic__Byte__Order.__default.maximum($LS($ly), s'#6); 
                Lexicographic__Byte__Order.__default.lt#canCall(m'#6, $let#28_a(Lit(s#0)))))
         && Lexicographic__Byte__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#3 := $let#28_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Lexicographic__Byte__Order.__default.maximum($LS($ly), s'#7); 
                  (if Lexicographic__Byte__Order.__default.lt(m'#7, a#3) then a#3 else m'#7))))));

// function declaration for Lexicographic_Byte_Order._default.maximumOpt
function Lexicographic__Byte__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0)
     == Lexicographic__Byte__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (Options.Option.Some_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))): Seq Box) } 
              { s#0[$Box(y#1)] } 
            $Is(y#1, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#1)]
               ==> Lexicographic__Byte__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))): Seq Box)))
         && (Options.Option.None_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(s#0))
         && Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, s#0)))));

// definition axiom for Lexicographic__Byte__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(Lit(s#0)))
         && Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Lit(s#0))))));

// function declaration for Lexicographic_Byte_Order._default.lt
function Lexicographic__Byte__Order.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.lt(a#0, b#0)
           == (Lexicographic__Byte__Order.__default.lte(a#0, b#0) && !Seq#Equal(a#0, b#0)));

// definition axiom for Lexicographic__Byte__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.lt(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.lt(Lit(a#0), Lit(b#0))
           == (Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

// function declaration for Lexicographic_Byte_Order._default.Min
function Lexicographic__Byte__Order.__default.Min(a#0: Seq Box, b#0: Seq Box) : Seq Box;

function Lexicographic__Byte__Order.__default.Min#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.Min
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Min(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Min#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.Min(a#0, b#0), 
        TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.Min#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.Min
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.Min#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Min(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Min#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.Min(a#0, b#0)
           == (if Lexicographic__Byte__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Lexicographic__Byte__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.Min(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.Min#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.Min(Lit(a#0), Lit(b#0))
           == (if Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             then a#0
             else b#0));

// function declaration for Lexicographic_Byte_Order._default.Max
function Lexicographic__Byte__Order.__default.Max(a#0: Seq Box, b#0: Seq Box) : Seq Box;

function Lexicographic__Byte__Order.__default.Max#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.Max
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Max(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Max#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.Max(a#0, b#0), 
        TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.Max#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.Max
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.Max#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Max(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Max#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.Max(a#0, b#0)
           == (if Lexicographic__Byte__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Lexicographic__Byte__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.Max(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.Max#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.Max(Lit(a#0), Lit(b#0))
           == (if Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             then b#0
             else a#0));

// function declaration for Lexicographic_Byte_Order._default.IsSorted
function Lexicographic__Byte__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0)
     == Lexicographic__Byte__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsSorted($ly, run#0)
     == Lexicographic__Byte__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsSorted($ly, run#0) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Lexicographic__Byte__Order.__default.IsSorted($ly, run#0)));

function Lexicographic__Byte__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): Seq Box, $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          j#2 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#2)): Seq Box, $Unbox(Seq#Index(run#0, j#2)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): Seq Box, $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 <= j#2 && j#2 < Seq#Length(run#0)
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): Seq Box, $Unbox(Seq#Index(run#0, j#2)): Seq Box)));

// definition axiom for Lexicographic__Byte__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): Seq Box, $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): Seq Box, 
              $Unbox(Seq#Index(Lit(run#0), j#3)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): Seq Box, $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 <= j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#3)): Seq Box, 
                $Unbox(Seq#Index(Lit(run#0), j#3)): Seq Box)));

// function declaration for Lexicographic_Byte_Order._default.IsStrictlySortedInternal
function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(run#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): Seq Box, $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          j#2 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#2)): Seq Box, $Unbox(Seq#Index(run#0, j#2)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): Seq Box, $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(run#0)
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): Seq Box, $Unbox(Seq#Index(run#0, j#2)): Seq Box)));

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): Seq Box, $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): Seq Box, 
              $Unbox(Seq#Index(Lit(run#0), j#3)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): Seq Box, $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#3)): Seq Box, 
                $Unbox(Seq#Index(Lit(run#0), j#3)): Seq Box)));

// function declaration for Lexicographic_Byte_Order._default.IsStrictlySorted
function Lexicographic__Byte__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0)
     == Lexicographic__Byte__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0)));

function Lexicographic__Byte__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#requires($ly, run#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#2 := Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#2 then b#2 else b#2)));

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#3 := Lit(Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#3 then b#3 else b#3)));

const unique class.Lexicographic__Byte__Order__Impl.__default: ClassName;

function Tclass.Lexicographic__Byte__Order__Impl.__default() : Ty;

// Tclass.Lexicographic__Byte__Order__Impl.__default Tag
axiom Tag(Tclass.Lexicographic__Byte__Order__Impl.__default())
   == Tagclass.Lexicographic__Byte__Order__Impl.__default;

const unique Tagclass.Lexicographic__Byte__Order__Impl.__default: TyTag;

// Box/unbox axiom for Tclass.Lexicographic__Byte__Order__Impl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Lexicographic__Byte__Order__Impl.__default()) } 
  $IsBox(bx, Tclass.Lexicographic__Byte__Order__Impl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Lexicographic__Byte__Order__Impl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Lexicographic__Byte__Order__Impl.__default()) } 
  $Is($o, Tclass.Lexicographic__Byte__Order__Impl.__default())
     <==> $o == null || dtype($o) == Tclass.Lexicographic__Byte__Order__Impl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Lexicographic__Byte__Order__Impl.__default(), $h) } 
  $IsAlloc($o, Tclass.Lexicographic__Byte__Order__Impl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure CheckWellformed$$Lexicographic__Byte__Order__Impl.__default.cmp(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(a#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    b#0: Seq Box
       where $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(b#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (c#0: int where LitInt(0 - 2147483648) <= c#0 && c#0 < 2147483648);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(a#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    b#0: Seq Box
       where $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(b#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (c#0: int where LitInt(0 - 2147483648) <= c#0 && c#0 < 2147483648);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures c#0 < 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0);
  free ensures c#0 < 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lt(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lte(a#0, b#0)
       && !Seq#Equal(a#0, b#0);
  free ensures c#0 > 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0);
  free ensures c#0 > 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lt(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lte(b#0, a#0)
       && !Seq#Equal(b#0, a#0);
  free ensures true;
  ensures c#0 == LitInt(0) ==> Seq#Equal(a#0, b#0);
  free ensures c#0 < 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0);
  free ensures c#0 < 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lt(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lte(a#0, b#0)
       && !Seq#Equal(a#0, b#0);
  free ensures c#0 > 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0);
  free ensures c#0 > 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lt(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lte(b#0, a#0)
       && !Seq#Equal(b#0, a#0);
  free ensures true;
  ensures c#0 == LitInt(0) ==> Seq#Equal(a#0, b#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// Constructor function declaration
function #PackedStringArray.Psa.Psa(Seq Box, Seq Box) : DatatypeType;

const unique ##PackedStringArray.Psa.Psa: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box, a#0#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#PackedStringArray.Psa.Psa(a#0#0#0, a#0#1#0))
     == ##PackedStringArray.Psa.Psa);

function PackedStringArray.Psa.Psa_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d) } 
  PackedStringArray.Psa.Psa_q(d)
     <==> DatatypeCtorId(d) == ##PackedStringArray.Psa.Psa);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d) } 
  PackedStringArray.Psa.Psa_q(d)
     ==> (exists a#1#0#0: Seq Box, a#1#1#0: Seq Box :: 
      d == #PackedStringArray.Psa.Psa(a#1#0#0, a#1#1#0)));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box, a#2#1#0: Seq Box :: 
  { $Is(#PackedStringArray.Psa.Psa(a#2#0#0, a#2#1#0), Tclass.PackedStringArray.Psa()) } 
  $Is(#PackedStringArray.Psa.Psa(a#2#0#0, a#2#1#0), Tclass.PackedStringArray.Psa())
     <==> $Is(a#2#0#0, TSeq(Tclass.NativeTypes.uint32()))
       && $Is(a#2#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, a#3#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#PackedStringArray.Psa.Psa(a#3#0#0, a#3#1#0), Tclass.PackedStringArray.Psa(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PackedStringArray.Psa.Psa(a#3#0#0, a#3#1#0), Tclass.PackedStringArray.Psa(), $h)
       <==> $IsAlloc(a#3#0#0, TSeq(Tclass.NativeTypes.uint32()), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedStringArray.Psa.offsets(d), TSeq(Tclass.NativeTypes.uint32()), $h) } 
  $IsGoodHeap($h)
       && 
      PackedStringArray.Psa.Psa_q(d)
       && $IsAlloc(d, Tclass.PackedStringArray.Psa(), $h)
     ==> $IsAlloc(PackedStringArray.Psa.offsets(d), TSeq(Tclass.NativeTypes.uint32()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedStringArray.Psa.data(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      PackedStringArray.Psa.Psa_q(d)
       && $IsAlloc(d, Tclass.PackedStringArray.Psa(), $h)
     ==> $IsAlloc(PackedStringArray.Psa.data(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box, a#4#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #PackedStringArray.Psa.Psa(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#PackedStringArray.Psa.Psa(a#4#0#0, a#4#1#0)));

function PackedStringArray.Psa.offsets(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box, a#5#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#5#0#0, a#5#1#0) } 
  PackedStringArray.Psa.offsets(#PackedStringArray.Psa.Psa(a#5#0#0, a#5#1#0))
     == a#5#0#0);

// Inductive seq element rank
axiom (forall a#6#0#0: Seq Box, a#6#1#0: Seq Box, i: int :: 
  { Seq#Index(a#6#0#0, i), #PackedStringArray.Psa.Psa(a#6#0#0, a#6#1#0) } 
  0 <= i && i < Seq#Length(a#6#0#0)
     ==> DtRank($Unbox(Seq#Index(a#6#0#0, i)): DatatypeType)
       < DtRank(#PackedStringArray.Psa.Psa(a#6#0#0, a#6#1#0)));

// Inductive seq rank
axiom (forall a#7#0#0: Seq Box, a#7#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#7#0#0, a#7#1#0) } 
  Seq#Rank(a#7#0#0) < DtRank(#PackedStringArray.Psa.Psa(a#7#0#0, a#7#1#0)));

function PackedStringArray.Psa.data(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#8#0#0: Seq Box, a#8#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#8#0#0, a#8#1#0) } 
  PackedStringArray.Psa.data(#PackedStringArray.Psa.Psa(a#8#0#0, a#8#1#0))
     == a#8#1#0);

// Inductive seq element rank
axiom (forall a#9#0#0: Seq Box, a#9#1#0: Seq Box, i: int :: 
  { Seq#Index(a#9#1#0, i), #PackedStringArray.Psa.Psa(a#9#0#0, a#9#1#0) } 
  0 <= i && i < Seq#Length(a#9#1#0)
     ==> DtRank($Unbox(Seq#Index(a#9#1#0, i)): DatatypeType)
       < DtRank(#PackedStringArray.Psa.Psa(a#9#0#0, a#9#1#0)));

// Inductive seq rank
axiom (forall a#10#0#0: Seq Box, a#10#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#10#0#0, a#10#1#0) } 
  Seq#Rank(a#10#1#0) < DtRank(#PackedStringArray.Psa.Psa(a#10#0#0, a#10#1#0)));

// Depth-one case-split function
function $IsA#PackedStringArray.Psa(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PackedStringArray.Psa(d) } 
  $IsA#PackedStringArray.Psa(d) ==> PackedStringArray.Psa.Psa_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d), $Is(d, Tclass.PackedStringArray.Psa()) } 
  $Is(d, Tclass.PackedStringArray.Psa()) ==> PackedStringArray.Psa.Psa_q(d));

// Datatype extensional equality declaration
function PackedStringArray.Psa#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PackedStringArray.Psa.Psa
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedStringArray.Psa#Equal(a, b) } 
  true
     ==> (PackedStringArray.Psa#Equal(a, b)
       <==> Seq#Equal(PackedStringArray.Psa.offsets(a), PackedStringArray.Psa.offsets(b))
         && Seq#Equal(PackedStringArray.Psa.data(a), PackedStringArray.Psa.data(b))));

// Datatype extensionality axiom: PackedStringArray.Psa
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedStringArray.Psa#Equal(a, b) } 
  PackedStringArray.Psa#Equal(a, b) <==> a == b);

const unique class.PackedStringArray.Psa: ClassName;

const unique class.PackedStringArray.DynamicPsa?: ClassName;

function Tclass.PackedStringArray.DynamicPsa?() : Ty;

// Tclass.PackedStringArray.DynamicPsa? Tag
axiom Tag(Tclass.PackedStringArray.DynamicPsa?())
   == Tagclass.PackedStringArray.DynamicPsa?;

const unique Tagclass.PackedStringArray.DynamicPsa?: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.DynamicPsa?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.DynamicPsa?()) } 
  $IsBox(bx, Tclass.PackedStringArray.DynamicPsa?())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.DynamicPsa?()));

// DynamicPsa: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedStringArray.DynamicPsa?()) } 
  $Is($o, Tclass.PackedStringArray.DynamicPsa?())
     <==> $o == null || dtype($o) == Tclass.PackedStringArray.DynamicPsa?());

// DynamicPsa: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedStringArray.DynamicPsa?(), $h) } 
  $IsAlloc($o, Tclass.PackedStringArray.DynamicPsa?(), $h)
     <==> $o == null || read($h, $o, alloc));

const PackedStringArray.DynamicPsa.nstrings: Field int;

// DynamicPsa.nstrings: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.nstrings) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.nstrings), Tclass.NativeTypes.uint64()));

// DynamicPsa.nstrings: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.nstrings) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.nstrings), 
      Tclass.NativeTypes.uint64(), 
      $h));

const PackedStringArray.DynamicPsa.offsets: Field ref;

// DynamicPsa.offsets: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.offsets) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.offsets), 
      Tclass._System.array(Tclass.NativeTypes.uint32())));

// DynamicPsa.offsets: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.offsets) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.offsets), 
      Tclass._System.array(Tclass.NativeTypes.uint32()), 
      $h));

const PackedStringArray.DynamicPsa.data: Field ref;

// DynamicPsa.data: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.data) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.data), 
      Tclass._System.array(Tclass.NativeTypes.byte())));

// DynamicPsa.data: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.data) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.data), 
      Tclass._System.array(Tclass.NativeTypes.byte()), 
      $h));

const PackedStringArray.DynamicPsa.Repr: Field (Set Box);

// DynamicPsa.Repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.Repr), TSet(Tclass._System.object())));

// DynamicPsa.Repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.Repr), 
      TSet(Tclass._System.object()), 
      $h));

// function declaration for PackedStringArray.DynamicPsa.WF
function PackedStringArray.DynamicPsa.WF($heap: Heap, this: ref) : bool;

function PackedStringArray.DynamicPsa.WF#canCall($heap: Heap, this: ref) : bool;

// frame axiom for PackedStringArray.DynamicPsa.WF
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.WF($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.WF($h0, this)
       == PackedStringArray.DynamicPsa.WF($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.WF
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.WF($Heap, this) } 
    PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
       ==> true);

function PackedStringArray.DynamicPsa.WF#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.WF
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.WF#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.WF#requires($Heap, this) == true);

// definition axiom for PackedStringArray.DynamicPsa.WF(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.WF($Heap, this) } 
    PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
       ==> (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           ==> NativeTypes.__default.Uint64UpperBound#canCall())
         && (
          (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
           ==> Uint32__Order.__default.IsSorted#canCall(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
              read($Heap, this, PackedStringArray.DynamicPsa.nstrings))))
         && PackedStringArray.DynamicPsa.WF($Heap, this)
           == (
            Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
             && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound()
             && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
             && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296)
             && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)))));

// function declaration for PackedStringArray.DynamicPsa.toPsa
function PackedStringArray.DynamicPsa.toPsa($heap: Heap, this: ref) : DatatypeType;

function PackedStringArray.DynamicPsa.toPsa#canCall($heap: Heap, this: ref) : bool;

// frame axiom for PackedStringArray.DynamicPsa.toPsa
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.toPsa($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.toPsa($h0, this)
       == PackedStringArray.DynamicPsa.toPsa($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.toPsa
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.toPsa($Heap, this) } 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> $Is(PackedStringArray.DynamicPsa.toPsa($Heap, this), Tclass.PackedStringArray.Psa()));

function PackedStringArray.DynamicPsa.toPsa#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.toPsa
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.toPsa#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.toPsa#requires($Heap, this)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.toPsa(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.toPsa($Heap, this) } 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> (LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> PackedStringArray.__default.EmptyPsa#canCall())
         && PackedStringArray.DynamicPsa.toPsa($Heap, this)
           == (if LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             then PackedStringArray.__default.EmptyPsa()
             else #PackedStringArray.Psa.Psa(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)), 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.data)), 
                $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int))));

// function declaration for PackedStringArray.DynamicPsa.weight
function PackedStringArray.DynamicPsa.weight($heap: Heap, this: ref) : int;

function PackedStringArray.DynamicPsa.weight#canCall($heap: Heap, this: ref) : bool;

// frame axiom for PackedStringArray.DynamicPsa.weight
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.weight($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.weight($h0, this)
       == PackedStringArray.DynamicPsa.weight($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.weight
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.weight($Heap, this) } 
    PackedStringArray.DynamicPsa.weight#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> LitInt(0) <= PackedStringArray.DynamicPsa.weight($Heap, this)
         && PackedStringArray.DynamicPsa.weight($Heap, this) < 18446744073709551616);

function PackedStringArray.DynamicPsa.weight#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.weight
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.weight#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.weight#requires($Heap, this)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.weight(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.weight($Heap, this) } 
    PackedStringArray.DynamicPsa.weight#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> PackedStringArray.DynamicPsa.weight($Heap, this)
         == Mul(LitInt(4), read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
           + (if read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0)
             then 0
             else $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int));

// function declaration for PackedStringArray.DynamicPsa.canAppend
function PackedStringArray.DynamicPsa.canAppend($heap: Heap, this: ref, str#0: Seq Box) : bool;

function PackedStringArray.DynamicPsa.canAppend#canCall($heap: Heap, this: ref, str#0: Seq Box) : bool;

// frame axiom for PackedStringArray.DynamicPsa.canAppend
axiom (forall $h0: Heap, $h1: Heap, this: ref, str#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.canAppend($h1, this, str#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && (PackedStringArray.DynamicPsa.canAppend#canCall($h0, this, str#0)
         || $Is(str#0, TSeq(Tclass.NativeTypes.byte())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.canAppend($h0, this, str#0)
       == PackedStringArray.DynamicPsa.canAppend($h1, this, str#0));

// consequence axiom for PackedStringArray.DynamicPsa.canAppend
axiom true
   ==> (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
    { PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0) } 
    PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> true);

function PackedStringArray.DynamicPsa.canAppend#requires(Heap, ref, Seq Box) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.canAppend
axiom (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
  { PackedStringArray.DynamicPsa.canAppend#requires($Heap, this, str#0) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
       && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.DynamicPsa.canAppend#requires($Heap, this, str#0)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.canAppend(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
    { PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0) } 
    PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         && PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
         && (read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
             && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         && PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
           == (
            PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             && PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
                 + Seq#Length(str#0)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))));

procedure CheckWellformed$$PackedStringArray.DynamicPsa.Append(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$PackedStringArray.DynamicPsa.Append(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         < 4294967296 - 1;
  requires PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Seq#Length(str#0)
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$PackedStringArray.DynamicPsa.PreSized(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    num_strings#0: int
       where LitInt(0) <= num_strings#0 && num_strings#0 < 4294967296, 
    total_len#0: int where LitInt(0) <= total_len#0 && total_len#0 < 4294967296);
  free requires 45 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$PackedStringArray.DynamicPsa.PreSized(num_strings#0: int
       where LitInt(0) <= num_strings#0 && num_strings#0 < 4294967296, 
    total_len#0: int where LitInt(0) <= total_len#0 && total_len#0 < 4294967296)
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     == num_strings#0;
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
     == total_len#0;
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(Lit(PackedStringArray.__default.EmptyPsa()))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.EmptyPsa#canCall();
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.EmptyPsa());
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)] } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// PackedStringArray.DynamicPsa: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.PackedStringArray.DynamicPsa()) } 
  $Is(c#0, Tclass.PackedStringArray.DynamicPsa())
     <==> $Is(c#0, Tclass.PackedStringArray.DynamicPsa?()) && c#0 != null);

// PackedStringArray.DynamicPsa: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa(), $h) } 
  $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa(), $h)
     <==> $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa?(), $h));

const unique class.PackedStringArray.__default: ClassName;

function Tclass.PackedStringArray.__default() : Ty;

// Tclass.PackedStringArray.__default Tag
axiom Tag(Tclass.PackedStringArray.__default())
   == Tagclass.PackedStringArray.__default;

const unique Tagclass.PackedStringArray.__default: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.__default()) } 
  $IsBox(bx, Tclass.PackedStringArray.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedStringArray.__default()) } 
  $Is($o, Tclass.PackedStringArray.__default())
     <==> $o == null || dtype($o) == Tclass.PackedStringArray.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedStringArray.__default(), $h) } 
  $IsAlloc($o, Tclass.PackedStringArray.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PackedStringArray._default.WF
function PackedStringArray.__default.WF(psa#0: DatatypeType) : bool;

function PackedStringArray.__default.WF#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.WF
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.WF(psa#0) } 
    PackedStringArray.__default.WF#canCall(psa#0)
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> true);

function PackedStringArray.__default.WF#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.WF
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.WF#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.WF#requires(psa#0) == true);

// definition axiom for PackedStringArray.__default.WF(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.WF(psa#0) } 
    PackedStringArray.__default.WF#canCall(psa#0)
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(psa#0)))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(psa#0))
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> PackedStringArray.Psa.Psa_q(psa#0)
                 && 
                PackedStringArray.Psa.Psa_q(psa#0)
                 && PackedStringArray.Psa.Psa_q(psa#0)))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> PackedStringArray.Psa.Psa_q(psa#0)
                 && 
                PackedStringArray.Psa.Psa_q(psa#0)
                 && PackedStringArray.Psa.Psa_q(psa#0))
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && Uint32__Order.__default.IsSorted#canCall(PackedStringArray.Psa.offsets(psa#0)))
         && PackedStringArray.__default.WF(psa#0)
           == (
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.WF for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.WF(Lit(psa#0)) } 
    PackedStringArray.__default.WF#canCall(Lit(psa#0))
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) == LitInt(0))
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && 
                PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && PackedStringArray.Psa.Psa_q(Lit(psa#0))))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && 
                PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && PackedStringArray.Psa.Psa_q(Lit(psa#0)))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 == $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), 
                    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)): int)
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && Uint32__Order.__default.IsSorted#canCall(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
         && PackedStringArray.__default.WF(Lit(psa#0))
           == (
            Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) < 4294967296
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) == LitInt(0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 == $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), 
                    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)): int)
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
              Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))));

// function declaration for PackedStringArray._default.psaNumStrings
function PackedStringArray.__default.psaNumStrings(psa#0: DatatypeType) : int;

function PackedStringArray.__default.psaNumStrings#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaNumStrings
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaNumStrings(psa#0) } 
    PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> LitInt(0) <= PackedStringArray.__default.psaNumStrings(psa#0)
         && PackedStringArray.__default.psaNumStrings(psa#0) < 18446744073709551616);

function PackedStringArray.__default.psaNumStrings#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaNumStrings
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaNumStrings#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaNumStrings#requires(psa#0)
       == (Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         < NativeTypes.__default.Uint64UpperBound()));

// definition axiom for PackedStringArray.__default.psaNumStrings(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaNumStrings(psa#0) } 
    PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaNumStrings(psa#0)
           == Seq#Length(PackedStringArray.Psa.offsets(psa#0)));

// definition axiom for PackedStringArray.__default.psaNumStrings for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaNumStrings(Lit(psa#0)) } 
    PackedStringArray.__default.psaNumStrings#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaNumStrings(Lit(psa#0))
           == Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))));

// function declaration for PackedStringArray._default.psaTotalLength
function PackedStringArray.__default.psaTotalLength(psa#0: DatatypeType) : int;

function PackedStringArray.__default.psaTotalLength#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaTotalLength
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaTotalLength(psa#0) } 
    PackedStringArray.__default.psaTotalLength#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.data(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> LitInt(0) <= PackedStringArray.__default.psaTotalLength(psa#0)
         && PackedStringArray.__default.psaTotalLength(psa#0) < 18446744073709551616);

function PackedStringArray.__default.psaTotalLength#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaTotalLength
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaTotalLength#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaTotalLength#requires(psa#0)
       == (Seq#Length(PackedStringArray.Psa.data(psa#0))
         < NativeTypes.__default.Uint64UpperBound()));

// definition axiom for PackedStringArray.__default.psaTotalLength(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaTotalLength(psa#0) } 
    PackedStringArray.__default.psaTotalLength#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.data(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaTotalLength(psa#0)
           == Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.psaTotalLength for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaTotalLength(Lit(psa#0)) } 
    PackedStringArray.__default.psaTotalLength#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaTotalLength(Lit(psa#0))
           == Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

// function declaration for PackedStringArray._default.psaStart
function PackedStringArray.__default.psaStart(psa#0: DatatypeType, i#0: int) : int;

function PackedStringArray.__default.psaStart#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaStart
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaStart(psa#0, i#0) } 
    PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> LitInt(0) <= PackedStringArray.__default.psaStart(psa#0, i#0)
         && PackedStringArray.__default.psaStart(psa#0, i#0)
           <= Seq#Length(PackedStringArray.Psa.data(psa#0))
         && 
        LitInt(0) <= PackedStringArray.__default.psaStart(psa#0, i#0)
         && PackedStringArray.__default.psaStart(psa#0, i#0) < 4294967296);

function PackedStringArray.__default.psaStart#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaStart
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaStart#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaStart#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaStart(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaStart(psa#0, i#0) } 
    PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> (i#0 != LitInt(0) ==> PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaStart(psa#0, i#0)
           == (if i#0 == LitInt(0)
             then 0
             else $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), i#0 - 1)): int));

// definition axiom for PackedStringArray.__default.psaStart for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(i#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> (LitInt(i#0) != LitInt(0) ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then 0
             else $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(i#0 - 1))): int));

// function declaration for PackedStringArray._default.psaEnd
function PackedStringArray.__default.psaEnd(psa#0: DatatypeType, i#0: int) : int;

function PackedStringArray.__default.psaEnd#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaEnd
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaEnd(psa#0, i#0) } 
    PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.__default.psaStart(psa#0, i#0)
           <= PackedStringArray.__default.psaEnd(psa#0, i#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0)
           <= Seq#Length(PackedStringArray.Psa.data(psa#0))
         && 
        LitInt(0) <= PackedStringArray.__default.psaEnd(psa#0, i#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0) < 4294967296);

function PackedStringArray.__default.psaEnd#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaEnd
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaEnd#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaEnd#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaEnd(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaEnd(psa#0, i#0) } 
    PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0)
           == (var _v0#2 := (if i#0 > 0 then false else false); 
            $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), i#0)): int));

// definition axiom for PackedStringArray.__default.psaEnd for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(i#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0))
           == (var _v0#3 := (if i#0 > 0 then false else false); 
            $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(i#0))): int));

// function declaration for PackedStringArray._default.psaElement
function PackedStringArray.__default.psaElement(psa#0: DatatypeType, i#0: int) : Seq Box;

function PackedStringArray.__default.psaElement#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaElement
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaElement(psa#0, i#0) } 
    PackedStringArray.__default.psaElement#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> $Is(PackedStringArray.__default.psaElement(psa#0, i#0), 
        TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.psaElement#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaElement
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaElement#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaElement#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaElement(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaElement(psa#0, i#0) } 
    PackedStringArray.__default.psaElement#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         && PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         && PackedStringArray.__default.psaElement(psa#0, i#0)
           == Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), 
              PackedStringArray.__default.psaEnd(psa#0, i#0)), 
            PackedStringArray.__default.psaStart(psa#0, i#0)));

// definition axiom for PackedStringArray.__default.psaElement for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(i#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(i#0))
         && PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(i#0))
         && PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0))
           == Lit(Seq#Drop(Seq#Take(Lit(PackedStringArray.Psa.data(Lit(psa#0))), 
                LitInt(PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0)))), 
              LitInt(PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0))))));

// function declaration for PackedStringArray._default.psaSeq
function PackedStringArray.__default.psaSeq($ly: LayerType, psa#0: DatatypeType, i#0: int) : Seq Box;

function PackedStringArray.__default.psaSeq#canCall(psa#0: DatatypeType, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0) } 
  PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0)
     == PackedStringArray.__default.psaSeq($ly, psa#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq(AsFuelBottom($ly), psa#0, i#0) } 
  PackedStringArray.__default.psaSeq($ly, psa#0, i#0)
     == PackedStringArray.__default.psaSeq($LZ, psa#0, i#0));

// consequence axiom for PackedStringArray.__default.psaSeq
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaSeq($ly, psa#0, i#0) } 
    PackedStringArray.__default.psaSeq#canCall(psa#0, i#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> Seq#Length(PackedStringArray.__default.psaSeq($ly, psa#0, i#0)) == i#0
         && (forall j#1: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), j#1)): Seq Box } 
          LitInt(0) <= j#1 && j#1 < i#0
             ==> Seq#Equal($Unbox(Seq#Index(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), j#1)): Seq Box, 
              PackedStringArray.__default.psaElement(psa#0, j#1)))
         && $Is(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function PackedStringArray.__default.psaSeq#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSeq
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq#requires($ly, psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaSeq#requires($ly, psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0) } 
    PackedStringArray.__default.psaSeq#canCall(psa#0, i#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> (i#0 != LitInt(0)
           ==> PackedStringArray.__default.psaSeq#canCall(psa#0, i#0 - 1)
             && PackedStringArray.__default.psaElement#canCall(psa#0, i#0 - 1))
         && PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.psaSeq($ly, psa#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(PackedStringArray.__default.psaElement(psa#0, i#0 - 1))))));

// definition axiom for PackedStringArray.__default.psaSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), LitInt(i#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> (LitInt(i#0) != LitInt(0)
           ==> PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), LitInt(i#0 - 1))
             && PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(i#0 - 1)))
         && PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0 - 1))))))));

// function declaration for PackedStringArray._default.I
function PackedStringArray.__default.I(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.I#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.I
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.I(psa#0) } 
    PackedStringArray.__default.I#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> $Is(PackedStringArray.__default.I(psa#0), TSeq(TSeq(Tclass.NativeTypes.byte()))));

function PackedStringArray.__default.I#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.I
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.I#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.I#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.I(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.I(psa#0) } 
    PackedStringArray.__default.I#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaSeq#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
         && PackedStringArray.__default.I(psa#0)
           == PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, 
            psa#0, 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.I for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.I(Lit(psa#0)) } 
    PackedStringArray.__default.I#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
         && PackedStringArray.__default.I(Lit(psa#0))
           == PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, 
            Lit(psa#0), 
            Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))));

// function declaration for PackedStringArray._default.EmptyPsa
function PackedStringArray.__default.EmptyPsa() : DatatypeType;

function PackedStringArray.__default.EmptyPsa#canCall() : bool;

// consequence axiom for PackedStringArray.__default.EmptyPsa
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.WF(PackedStringArray.__default.EmptyPsa())
     && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.EmptyPsa()), 
      Seq#Empty(): Seq Box)
     && $Is(PackedStringArray.__default.EmptyPsa(), Tclass.PackedStringArray.Psa());

function PackedStringArray.__default.EmptyPsa#requires() : bool;

// #requires axiom for PackedStringArray.__default.EmptyPsa
axiom PackedStringArray.__default.EmptyPsa#requires() == true;

// definition axiom for PackedStringArray.__default.EmptyPsa(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.EmptyPsa()
     == Lit(#PackedStringArray.Psa.Psa(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)));

// definition axiom for PackedStringArray.__default.EmptyPsa for all literals(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.EmptyPsa()
     == Lit(#PackedStringArray.Psa.Psa(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)));

// function declaration for PackedStringArray._default.SizeOfPsa
function PackedStringArray.__default.SizeOfPsa(psa#0: DatatypeType) : int;

function PackedStringArray.__default.SizeOfPsa#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.SizeOfPsa
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsa(psa#0) } 
    PackedStringArray.__default.SizeOfPsa#canCall(psa#0)
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> true);

function PackedStringArray.__default.SizeOfPsa#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.SizeOfPsa
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.SizeOfPsa#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.SizeOfPsa#requires(psa#0) == true);

// definition axiom for PackedStringArray.__default.SizeOfPsa(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsa(psa#0) } 
    PackedStringArray.__default.SizeOfPsa#canCall(psa#0)
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.SizeOfPsa(psa#0)
           == 4
             + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
             + Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.SizeOfPsa for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.SizeOfPsa(Lit(psa#0)) } 
    PackedStringArray.__default.SizeOfPsa#canCall(Lit(psa#0))
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.SizeOfPsa(Lit(psa#0))
           == 4
             + Mul(LitInt(4), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

// function declaration for PackedStringArray._default.SizeOfPsaUint64
function PackedStringArray.__default.SizeOfPsaUint64(psa#0: DatatypeType) : int;

function PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.SizeOfPsaUint64
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsaUint64(psa#0) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> LitInt(0) <= PackedStringArray.__default.SizeOfPsaUint64(psa#0)
         && PackedStringArray.__default.SizeOfPsaUint64(psa#0) < 18446744073709551616);

function PackedStringArray.__default.SizeOfPsaUint64#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.SizeOfPsaUint64
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.SizeOfPsaUint64#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.SizeOfPsaUint64#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.SizeOfPsaUint64(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsaUint64(psa#0) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.SizeOfPsaUint64(psa#0)
           == 4
             + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
             + Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.SizeOfPsaUint64 for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.SizeOfPsaUint64(Lit(psa#0)) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.SizeOfPsaUint64(Lit(psa#0))
           == 4
             + Mul(LitInt(4), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

// function declaration for PackedStringArray._default.FirstElement
function PackedStringArray.__default.FirstElement(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.FirstElement#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.FirstElement
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.FirstElement(psa#0) } 
    PackedStringArray.__default.FirstElement#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> $Is(PackedStringArray.__default.FirstElement(psa#0), TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.FirstElement#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.FirstElement
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.FirstElement#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.FirstElement#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0));

// definition axiom for PackedStringArray.__default.FirstElement(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.FirstElement(psa#0) } 
    PackedStringArray.__default.FirstElement#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> PackedStringArray.__default.psaElement#canCall(psa#0, LitInt(0))
         && PackedStringArray.__default.FirstElement(psa#0)
           == PackedStringArray.__default.psaElement(psa#0, LitInt(0)));

// definition axiom for PackedStringArray.__default.FirstElement for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.FirstElement(Lit(psa#0)) } 
    PackedStringArray.__default.FirstElement#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) > 0)
       ==> PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(0))
         && PackedStringArray.__default.FirstElement(Lit(psa#0))
           == Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(0))));

// function declaration for PackedStringArray._default.LastElement
function PackedStringArray.__default.LastElement(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.LastElement#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.LastElement
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.LastElement(psa#0) } 
    PackedStringArray.__default.LastElement#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> $Is(PackedStringArray.__default.LastElement(psa#0), TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.LastElement#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.LastElement
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.LastElement#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.LastElement#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0));

// definition axiom for PackedStringArray.__default.LastElement(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.LastElement(psa#0) } 
    PackedStringArray.__default.LastElement#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaElement#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)
         && PackedStringArray.__default.LastElement(psa#0)
           == PackedStringArray.__default.psaElement(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1));

// definition axiom for PackedStringArray.__default.LastElement for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.LastElement(Lit(psa#0)) } 
    PackedStringArray.__default.LastElement#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) > 0)
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaElement#canCall(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)
         && PackedStringArray.__default.LastElement(Lit(psa#0))
           == PackedStringArray.__default.psaElement(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1));

// function declaration for PackedStringArray._default.subtractConstant
function PackedStringArray.__default.subtractConstant($ly: LayerType, nums#0: Seq Box, subtrahend#0: int) : Seq Box;

function PackedStringArray.__default.subtractConstant#canCall(nums#0: Seq Box, subtrahend#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0) } 
  PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0)
     == PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant(AsFuelBottom($ly), nums#0, subtrahend#0) } 
  PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0)
     == PackedStringArray.__default.subtractConstant($LZ, nums#0, subtrahend#0));

// consequence axiom for PackedStringArray.__default.subtractConstant
axiom true
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    { PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0) } 
    PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0)
         || (
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#4: int :: 
            { $Unbox(Seq#Index(nums#0, i#4)): int } 
            true
               ==> 
              LitInt(0) <= i#4 && i#4 < Seq#Length(nums#0)
               ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#4)): int))
       ==> Seq#Length(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0))
           == Seq#Length(nums#0)
         && (forall i#5: int :: 
          { $Unbox(Seq#Index(nums#0, i#5)): int } 
            { $Unbox(Seq#Index(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), i#5)): int } 
          true
             ==> 
            LitInt(0) <= i#5
               && i#5
                 < Seq#Length(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0))
             ==> $Unbox(Seq#Index(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), i#5)): int
               == $Unbox(Seq#Index(nums#0, i#5)): int - subtrahend#0)
         && $Is(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), 
          TSeq(Tclass.NativeTypes.uint32())));

function PackedStringArray.__default.subtractConstant#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for PackedStringArray.__default.subtractConstant
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant#requires($ly, nums#0, subtrahend#0) } 
  $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= subtrahend#0
       && subtrahend#0 < 4294967296
     ==> PackedStringArray.__default.subtractConstant#requires($ly, nums#0, subtrahend#0)
       == (forall i#6: int :: 
        { $Unbox(Seq#Index(nums#0, i#6)): int } 
        true
           ==> 
          LitInt(0) <= i#6 && i#6 < Seq#Length(nums#0)
           ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#6)): int));

// definition axiom for PackedStringArray.__default.subtractConstant(revealed)
axiom true
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    { PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0) } 
    PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0)
         || (
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#6: int :: 
            { $Unbox(Seq#Index(nums#0, i#6)): int } 
            true
               ==> 
              LitInt(0) <= i#6 && i#6 < Seq#Length(nums#0)
               ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#6)): int))
       ==> (Seq#Length(nums#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), nums#0)
             && PackedStringArray.__default.subtractConstant#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), subtrahend#0)
             && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), nums#0))
         && PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0)
           == (if Seq#Length(nums#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.subtractConstant($ly, 
                Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), 
                subtrahend#0), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), nums#0)): int
                     - subtrahend#0)))));

// definition axiom for PackedStringArray.__default.subtractConstant for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    {:weight 3} { PackedStringArray.__default.subtractConstant($LS($ly), Lit(nums#0), LitInt(subtrahend#0)) } 
    PackedStringArray.__default.subtractConstant#canCall(Lit(nums#0), LitInt(subtrahend#0))
         || (
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#7: int :: 
            { $Unbox(Seq#Index(nums#0, i#7)): int } 
            true
               ==> 
              LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(nums#0))
               ==> LitInt(subtrahend#0) <= $Unbox(Seq#Index(Lit(nums#0), i#7)): int))
       ==> (Seq#Length(Lit(nums#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(nums#0))
             && PackedStringArray.__default.subtractConstant#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(nums#0))), 
              LitInt(subtrahend#0))
             && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(nums#0)))
         && PackedStringArray.__default.subtractConstant($LS($ly), Lit(nums#0), LitInt(subtrahend#0))
           == (if Seq#Length(Lit(nums#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.subtractConstant($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(nums#0))), 
                LitInt(subtrahend#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(nums#0))): int
                       - subtrahend#0))))));

// function declaration for PackedStringArray._default.subOffsets
function PackedStringArray.__default.subOffsets(offsets#0: Seq Box, from#0: int, to#0: int) : Seq Box;

function PackedStringArray.__default.subOffsets#canCall(offsets#0: Seq Box, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.subOffsets
axiom true
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    { PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0) } 
    PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0)
         || (
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(offsets#0))
       ==> $Is(PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0), 
        TSeq(Tclass.NativeTypes.uint32())));

function PackedStringArray.__default.subOffsets#requires(Seq Box, int, int) : bool;

// #requires axiom for PackedStringArray.__default.subOffsets
axiom (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
  { PackedStringArray.__default.subOffsets#requires(offsets#0, from#0, to#0) } 
  $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.subOffsets#requires(offsets#0, from#0, to#0)
       == (Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= Seq#Length(offsets#0)));

// definition axiom for PackedStringArray.__default.subOffsets(revealed)
axiom true
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    { PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0) } 
    PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0)
         || (
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(offsets#0))
       ==> (var suboffsets#2 := Seq#Drop(Seq#Take(offsets#0, to#0), from#0); 
          from#0 != LitInt(0)
             ==> PackedStringArray.__default.subtractConstant#canCall(suboffsets#2, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int))
         && PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0)
           == (var suboffsets#2 := Seq#Drop(Seq#Take(offsets#0, to#0), from#0); 
            (if from#0 == LitInt(0)
               then suboffsets#2
               else PackedStringArray.__default.subtractConstant($LS($LZ), suboffsets#2, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int))));

// definition axiom for PackedStringArray.__default.subOffsets for all literals(revealed)
axiom true
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.subOffsets(Lit(offsets#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.subOffsets#canCall(Lit(offsets#0), LitInt(from#0), LitInt(to#0))
         || (
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(offsets#0))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= Seq#Length(Lit(offsets#0)))
       ==> (var suboffsets#3 := Lit(Seq#Drop(Seq#Take(Lit(offsets#0), LitInt(to#0)), LitInt(from#0))); 
          LitInt(from#0) != LitInt(0)
             ==> PackedStringArray.__default.subtractConstant#canCall(suboffsets#3, $Unbox(Seq#Index(Lit(offsets#0), LitInt(from#0 - 1))): int))
         && PackedStringArray.__default.subOffsets(Lit(offsets#0), LitInt(from#0), LitInt(to#0))
           == (var suboffsets#3 := Lit(Seq#Drop(Seq#Take(Lit(offsets#0), LitInt(to#0)), LitInt(from#0))); 
            (if LitInt(from#0) == LitInt(0)
               then suboffsets#3
               else PackedStringArray.__default.subtractConstant($LS($LZ), 
                suboffsets#3, 
                $Unbox(Seq#Index(Lit(offsets#0), LitInt(from#0 - 1))): int))));

// function declaration for PackedStringArray._default.psaSubSeqInternal
function PackedStringArray.__default.psaSubSeqInternal(psa#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaSubSeqInternal
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> $Is(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0), 
        Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaSubSeqInternal#requires(DatatypeType, int, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSubSeqInternal
axiom (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
  { PackedStringArray.__default.psaSubSeqInternal#requires(psa#0, from#0, to#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaSubSeqInternal#requires(psa#0, from#0, to#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaSubSeqInternal(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> (from#0 == to#0 ==> PackedStringArray.__default.EmptyPsa#canCall())
         && (from#0 != to#0
           ==> PackedStringArray.__default.psaStart#canCall(psa#0, from#0)
             && 
            PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1)
             && 
            PackedStringArray.Psa.Psa_q(psa#0)
             && PackedStringArray.__default.subOffsets#canCall(PackedStringArray.Psa.offsets(psa#0), from#0, to#0)
             && PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)
           == (if from#0 == to#0
             then PackedStringArray.__default.EmptyPsa()
             else (var dataStart#2 := PackedStringArray.__default.psaStart(psa#0, from#0); 
              (var dataEnd#2 := PackedStringArray.__default.psaEnd(psa#0, to#0 - 1); 
                #PackedStringArray.Psa.Psa(PackedStringArray.__default.subOffsets(PackedStringArray.Psa.offsets(psa#0), from#0, to#0), 
                  Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#2), dataStart#2))))));

// definition axiom for PackedStringArray.__default.psaSubSeqInternal for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> (LitInt(from#0) == LitInt(to#0)
           ==> PackedStringArray.__default.EmptyPsa#canCall())
         && (LitInt(from#0) != LitInt(to#0)
           ==> PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(from#0))
             && 
            PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(to#0 - 1))
             && 
            PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && PackedStringArray.__default.subOffsets#canCall(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(from#0), LitInt(to#0))
             && PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0))
           == (if LitInt(from#0) == LitInt(to#0)
             then PackedStringArray.__default.EmptyPsa()
             else (var dataStart#3 := LitInt(PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(from#0))); 
              (var dataEnd#3 := LitInt(PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(to#0 - 1))); 
                Lit(#PackedStringArray.Psa.Psa(Lit(PackedStringArray.__default.subOffsets(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(from#0), LitInt(to#0))), 
                    Lit(Seq#Drop(Seq#Take(Lit(PackedStringArray.Psa.data(Lit(psa#0))), dataEnd#3), dataStart#3))))))));

// function declaration for PackedStringArray._default.psaSubSeq
function PackedStringArray.__default.psaSubSeq(psa#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function PackedStringArray.__default.psaSubSeq#canCall(psa#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaSubSeq
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)), 
          Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0))
         && $Is(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaSubSeq#requires(DatatypeType, int, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSubSeq
axiom (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
  { PackedStringArray.__default.psaSubSeq#requires(psa#0, from#0, to#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaSubSeq#requires(psa#0, from#0, to#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaSubSeq(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         && PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)
           == PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));

// definition axiom for PackedStringArray.__default.psaSubSeq for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSubSeq(Lit(psa#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.psaSubSeq#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> PackedStringArray.__default.psaSubSeqInternal#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         && PackedStringArray.__default.psaSubSeq(Lit(psa#0), LitInt(from#0), LitInt(to#0))
           == Lit(PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0))));

// function declaration for PackedStringArray._default.psaDropLast
function PackedStringArray.__default.psaDropLast(psa#0: DatatypeType) : DatatypeType;

function PackedStringArray.__default.psaDropLast#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaDropLast
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaDropLast(psa#0) } 
    PackedStringArray.__default.psaDropLast#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 0 < PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaDropLast(psa#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaDropLast(psa#0)), 
          Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa#0)))
         && $Is(PackedStringArray.__default.psaDropLast(psa#0), Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaDropLast#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaDropLast
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaDropLast#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaDropLast#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 0 < PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaDropLast(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaDropLast(psa#0) } 
    PackedStringArray.__default.psaDropLast#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 0 < PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         && PackedStringArray.__default.psaSubSeq#canCall(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1)
         && PackedStringArray.__default.psaDropLast(psa#0)
           == PackedStringArray.__default.psaSubSeq(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1));

// definition axiom for PackedStringArray.__default.psaDropLast for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaDropLast(Lit(psa#0)) } 
    PackedStringArray.__default.psaDropLast#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(0 < PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> PackedStringArray.__default.psaNumStrings#canCall(Lit(psa#0))
         && PackedStringArray.__default.psaSubSeq#canCall(Lit(psa#0), 
          LitInt(0), 
          LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0)) - 1))
         && PackedStringArray.__default.psaDropLast(Lit(psa#0))
           == Lit(PackedStringArray.__default.psaSubSeq(Lit(psa#0), 
              LitInt(0), 
              LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0)) - 1))));

// function declaration for PackedStringArray._default.psaCanAppend
function PackedStringArray.__default.psaCanAppend(psa#0: DatatypeType, key#0: Seq Box) : bool;

function PackedStringArray.__default.psaCanAppend#canCall(psa#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaCanAppend
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function PackedStringArray.__default.psaCanAppend#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaCanAppend
axiom (forall psa#0: DatatypeType, key#0: Seq Box :: 
  { PackedStringArray.__default.psaCanAppend#requires(psa#0, key#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.__default.psaCanAppend#requires(psa#0, key#0) == true);

// definition axiom for PackedStringArray.__default.psaCanAppend(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
           ==> PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaCanAppend(psa#0, key#0)
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppend for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0)) } 
    PackedStringArray.__default.psaCanAppend#canCall(Lit(psa#0), Lit(key#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296 - 1
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0))
           == (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296 - 1
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) + Seq#Length(Lit(key#0))
               < 4294967296));

// function declaration for PackedStringArray._default.psaAppend
function PackedStringArray.__default.psaAppend(psa#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaAppend#canCall(psa#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaAppend
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppend(psa#0, key#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaAppend(psa#0, key#0))
         && $Is(PackedStringArray.__default.psaAppend(psa#0, key#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaAppend#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaAppend
axiom (forall psa#0: DatatypeType, key#0: Seq Box :: 
  { PackedStringArray.__default.psaAppend#requires(psa#0, key#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.__default.psaAppend#requires(psa#0, key#0)
       == (PackedStringArray.__default.WF(psa#0)
         && PackedStringArray.__default.psaCanAppend(psa#0, key#0)));

// definition axiom for PackedStringArray.__default.psaAppend(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppend(psa#0, key#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaAppend(psa#0, key#0)
           == (var newdata#2 := Seq#Append(PackedStringArray.Psa.data(psa#0), key#0); 
            #PackedStringArray.Psa.Psa(Seq#Append(PackedStringArray.Psa.offsets(psa#0), 
                Seq#Build(Seq#Empty(): Seq Box, $Box(Seq#Length(newdata#2)))), 
              newdata#2)));

// definition axiom for PackedStringArray.__default.psaAppend for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppend(Lit(psa#0), Lit(key#0)) } 
    PackedStringArray.__default.psaAppend#canCall(Lit(psa#0), Lit(key#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaAppend(Lit(psa#0), Lit(key#0))
           == (var newdata#3 := Seq#Append(PackedStringArray.Psa.data(Lit(psa#0)), key#0); 
            #PackedStringArray.Psa.Psa(Seq#Append(PackedStringArray.Psa.offsets(Lit(psa#0)), 
                Seq#Build(Seq#Empty(): Seq Box, $Box(Seq#Length(newdata#3)))), 
              newdata#3)));

procedure CheckWellformed$$PackedStringArray.__default.psaAppendIAppend(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 28 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$PackedStringArray.__default.psaAppendIAppend(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
     ==> PackedStringArray.__default.psaCanAppend(psa#0, key#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1;
  requires PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
     ==> PackedStringArray.__default.psaCanAppend(psa#0, key#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
     && PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0))
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaAppend(psa#0, key#0)), 
    Seq#Append(PackedStringArray.__default.I(psa#0), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for PackedStringArray._default.psaCanAppendSeq
function PackedStringArray.__default.psaCanAppendSeq(psa#0: DatatypeType, strs#0: Seq Box) : bool;

function PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0: DatatypeType, strs#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaCanAppendSeq
axiom true
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> true);

function PackedStringArray.__default.psaCanAppendSeq#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaCanAppendSeq
axiom (forall psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaCanAppendSeq#requires(psa#0, strs#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaCanAppendSeq#requires(psa#0, strs#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0)))
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0)
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
               < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
               < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq for decreasing-related literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0)) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Lit(strs#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(Lit(strs#0))
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), Lit(strs#0))
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.FlattenShape, 
                Lit(strs#0))))
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0))
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(Lit(strs#0))
               < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuel_Sequences._default.FlattenShape, 
                    Lit(strs#0)))
               < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0)) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(psa#0), Lit(strs#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               + Seq#Length(Lit(strs#0))
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), Lit(strs#0))
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.FlattenShape, 
                Lit(strs#0))))
         && PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0))
           == (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
                 + Seq#Length(Lit(strs#0))
               < 4294967296
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuel_Sequences._default.FlattenShape, 
                    Lit(strs#0)))
               < 4294967296));

// function declaration for PackedStringArray._default.psaAppendSeq
function PackedStringArray.__default.psaAppendSeq($ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaAppendSeq#canCall(psa#0: DatatypeType, strs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0) } 
  PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0)
     == PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq(AsFuelBottom($ly), psa#0, strs#0) } 
  PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0)
     == PackedStringArray.__default.psaAppendSeq($LZ, psa#0, strs#0));

// consequence axiom for PackedStringArray.__default.psaAppendSeq
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0)), 
          Seq#Append(PackedStringArray.__default.I(psa#0), strs#0))
         && PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0))
           == PackedStringArray.__default.psaTotalLength(psa#0)
             + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
         && $Is(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaAppendSeq#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaAppendSeq
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq#requires($ly, psa#0, strs#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaAppendSeq#requires($ly, psa#0, strs#0)
       == (PackedStringArray.__default.WF(psa#0)
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0)));

// definition axiom for PackedStringArray.__default.psaAppendSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0))
       ==> (Seq#Length(strs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
             && PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
             && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.__default.psaAppendSeq($ly, 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0)
           == (if Seq#Length(strs#0) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(PackedStringArray.__default.psaAppendSeq($ly, 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box)));

// definition axiom for PackedStringArray.__default.psaAppendSeq for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, Lit(strs#0)) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Lit(strs#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0)))
       ==> (Seq#Length(Lit(strs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppendSeq#canCall(psa#0, 
              Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                psa#0, 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0)))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box)))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, Lit(strs#0))
           == (if Seq#Length(Lit(strs#0)) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                psa#0, 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0)))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box))));

// definition axiom for PackedStringArray.__default.psaAppendSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppendSeq($LS($ly), Lit(psa#0), Lit(strs#0)) } 
    PackedStringArray.__default.psaAppendSeq#canCall(Lit(psa#0), Lit(strs#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0))))
       ==> (Seq#Length(Lit(strs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppendSeq#canCall(Lit(psa#0), 
              Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppend#canCall(Lit(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                  Lit(psa#0), 
                  Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box)))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), Lit(psa#0), Lit(strs#0))
           == (if Seq#Length(Lit(strs#0)) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(Lit(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                  Lit(psa#0), 
                  Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box))));

// function declaration for PackedStringArray._default.psaFromSeq
function PackedStringArray.__default.psaFromSeq(strs#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaFromSeq#canCall(strs#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaFromSeq
axiom true
   ==> (forall strs#0: Seq Box :: 
    { PackedStringArray.__default.psaFromSeq(strs#0) } 
    PackedStringArray.__default.psaFromSeq#canCall(strs#0)
         || ($Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaFromSeq(strs#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaFromSeq(strs#0)), 
          strs#0)
         && $Is(PackedStringArray.__default.psaFromSeq(strs#0), Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaFromSeq#requires(Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaFromSeq
axiom (forall strs#0: Seq Box :: 
  { PackedStringArray.__default.psaFromSeq#requires(strs#0) } 
  $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaFromSeq#requires(strs#0)
       == PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0));

// definition axiom for PackedStringArray.__default.psaFromSeq(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    { PackedStringArray.__default.psaFromSeq(strs#0) } 
    PackedStringArray.__default.psaFromSeq#canCall(strs#0)
         || ($Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0))
       ==> PackedStringArray.__default.EmptyPsa#canCall()
         && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
         && PackedStringArray.__default.psaFromSeq(strs#0)
           == PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));

// definition axiom for PackedStringArray.__default.psaFromSeq for all literals(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaFromSeq(Lit(strs#0)) } 
    PackedStringArray.__default.psaFromSeq#canCall(Lit(strs#0))
         || ($Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && Lit(PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))))
       ==> PackedStringArray.__default.EmptyPsa#canCall()
         && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))
         && PackedStringArray.__default.psaFromSeq(Lit(strs#0))
           == Lit(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))));

procedure CheckWellformed$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  free requires 64 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
      PackedStringArray.__default.I(psa#0), 
      key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// KeyType.Key: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.KeyType.Key()) } 
  $Is(s#0, Tclass.KeyType.Key())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// KeyType.Key: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.KeyType.Key(), $h) } 
  $IsAlloc(s#0, Tclass.KeyType.Key(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.KeyType.__default: ClassName;

function Tclass.KeyType.__default() : Ty;

// Tclass.KeyType.__default Tag
axiom Tag(Tclass.KeyType.__default()) == Tagclass.KeyType.__default;

const unique Tagclass.KeyType.__default: TyTag;

// Box/unbox axiom for Tclass.KeyType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KeyType.__default()) } 
  $IsBox(bx, Tclass.KeyType.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.KeyType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.KeyType.__default()) } 
  $Is($o, Tclass.KeyType.__default())
     <==> $o == null || dtype($o) == Tclass.KeyType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.KeyType.__default(), $h) } 
  $IsAlloc($o, Tclass.KeyType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for KeyType._default.MaxLen
function KeyType.__default.MaxLen() : int;

function KeyType.__default.MaxLen#canCall() : bool;

// consequence axiom for KeyType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= KeyType.__default.MaxLen()
     && KeyType.__default.MaxLen() < 18446744073709551616;

function KeyType.__default.MaxLen#requires() : bool;

// #requires axiom for KeyType.__default.MaxLen
axiom KeyType.__default.MaxLen#requires() == true;

// definition axiom for KeyType.__default.MaxLen(revealed)
axiom true ==> true ==> KeyType.__default.MaxLen() == LitInt(1024);

// definition axiom for KeyType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> KeyType.__default.MaxLen() == LitInt(1024);

function Tclass.ValueType.Value() : Ty;

// Tclass.ValueType.Value Tag
axiom Tag(Tclass.ValueType.Value()) == Tagclass.ValueType.Value;

const unique Tagclass.ValueType.Value: TyTag;

// Box/unbox axiom for Tclass.ValueType.Value
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.Value()) } 
  $IsBox(bx, Tclass.ValueType.Value())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.ValueType.Value()));

// ValueType.Value: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.ValueType.Value()) } 
  $Is(s#0, Tclass.ValueType.Value())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// ValueType.Value: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.ValueType.Value(), $h) } 
  $IsAlloc(s#0, Tclass.ValueType.Value(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.ValueType.__default: ClassName;

function Tclass.ValueType.__default() : Ty;

// Tclass.ValueType.__default Tag
axiom Tag(Tclass.ValueType.__default()) == Tagclass.ValueType.__default;

const unique Tagclass.ValueType.__default: TyTag;

// Box/unbox axiom for Tclass.ValueType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.__default()) } 
  $IsBox(bx, Tclass.ValueType.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueType.__default()) } 
  $Is($o, Tclass.ValueType.__default())
     <==> $o == null || dtype($o) == Tclass.ValueType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueType.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueType._default.MaxLen
function ValueType.__default.MaxLen() : int;

function ValueType.__default.MaxLen#canCall() : bool;

// consequence axiom for ValueType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= ValueType.__default.MaxLen()
     && ValueType.__default.MaxLen() < 18446744073709551616;

function ValueType.__default.MaxLen#requires() : bool;

// #requires axiom for ValueType.__default.MaxLen
axiom ValueType.__default.MaxLen#requires() == true;

// definition axiom for ValueType.__default.MaxLen(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// definition axiom for ValueType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// function declaration for ValueType._default.DefaultValue
function ValueType.__default.DefaultValue() : Seq Box;

function ValueType.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueType.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueType.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueType.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueType.__default.DefaultValue
axiom ValueType.__default.DefaultValue#requires() == true;

// definition axiom for ValueType.__default.DefaultValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// definition axiom for ValueType.__default.DefaultValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// function declaration for ValueType._default.Len
function ValueType.__default.Len(v#0: Seq Box) : int;

function ValueType.__default.Len#canCall(v#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.Len
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> LitInt(0) <= ValueType.__default.Len(v#0));

function ValueType.__default.Len#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.Len
axiom (forall v#0: Seq Box :: 
  { ValueType.__default.Len#requires(v#0) } 
  $Is(v#0, Tclass.ValueType.Value())
     ==> ValueType.__default.Len#requires(v#0) == true);

// definition axiom for ValueType.__default.Len(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(v#0) == Seq#Length(v#0));

// definition axiom for ValueType.__default.Len for all literals(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    {:weight 3} { ValueType.__default.Len(Lit(v#0)) } 
    ValueType.__default.Len#canCall(Lit(v#0)) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(Lit(v#0)) == Seq#Length(Lit(v#0)));

// function declaration for ValueType._default.ValidMessageBytestring
function ValueType.__default.ValidMessageBytestring(s#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestring#canCall(s#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestring
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function ValueType.__default.ValidMessageBytestring#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestring
axiom (forall s#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestring#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueType.__default.ValidMessageBytestring#requires(s#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestring(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(s#0)
           == (Seq#Length(s#0) <= LitInt(ValueType.__default.MaxLen())));

// definition axiom for ValueType.__default.ValidMessageBytestring for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestring(Lit(s#0)) } 
    ValueType.__default.ValidMessageBytestring#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(Lit(s#0))
           == (Seq#Length(Lit(s#0)) <= LitInt(ValueType.__default.MaxLen())));

// function declaration for ValueType._default.ValidMessageBytestrings
function ValueType.__default.ValidMessageBytestrings(strs#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestrings#canCall(strs#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestrings
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function ValueType.__default.ValidMessageBytestrings#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestrings
axiom (forall strs#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestrings#requires(strs#0) } 
  $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueType.__default.ValidMessageBytestrings#requires(strs#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestrings(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#2: int :: 
          { $Unbox(Seq#Index(strs#0, i#2)): Seq Box } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(strs#0)
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(strs#0, i#2)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(strs#0)
           == (forall i#2: int :: 
            { $Unbox(Seq#Index(strs#0, i#2)): Seq Box } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(strs#0)
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(strs#0, i#2)): Seq Box)));

// definition axiom for ValueType.__default.ValidMessageBytestrings for all literals(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestrings(Lit(strs#0)) } 
    ValueType.__default.ValidMessageBytestrings#canCall(Lit(strs#0))
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#3: int :: 
          { $Unbox(Seq#Index(strs#0, i#3)): Seq Box } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(strs#0))
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(Lit(strs#0), i#3)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(Lit(strs#0))
           == (forall i#3: int :: 
            { $Unbox(Seq#Index(strs#0, i#3)): Seq Box } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(strs#0))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(Lit(strs#0), i#3)): Seq Box)));

// Constructor function declaration
function #ValueMessage.Delta.NoDelta() : DatatypeType;

const unique ##ValueMessage.Delta.NoDelta: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#ValueMessage.Delta.NoDelta()) == ##ValueMessage.Delta.NoDelta;

function ValueMessage.Delta.NoDelta_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d) } 
  ValueMessage.Delta.NoDelta_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Delta.NoDelta);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d) } 
  ValueMessage.Delta.NoDelta_q(d) ==> d == #ValueMessage.Delta.NoDelta());

function Tclass.ValueMessage.Delta() : Ty;

// Tclass.ValueMessage.Delta Tag
axiom Tag(Tclass.ValueMessage.Delta()) == Tagclass.ValueMessage.Delta;

const unique Tagclass.ValueMessage.Delta: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.Delta
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.Delta()) } 
  $IsBox(bx, Tclass.ValueMessage.Delta())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ValueMessage.Delta()));

// Constructor $Is
axiom $Is(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta(), $h));

// Constructor literal
axiom #ValueMessage.Delta.NoDelta() == Lit(#ValueMessage.Delta.NoDelta());

// Depth-one case-split function
function $IsA#ValueMessage.Delta(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ValueMessage.Delta(d) } 
  $IsA#ValueMessage.Delta(d) ==> ValueMessage.Delta.NoDelta_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d), $Is(d, Tclass.ValueMessage.Delta()) } 
  $Is(d, Tclass.ValueMessage.Delta()) ==> ValueMessage.Delta.NoDelta_q(d));

// Datatype extensional equality declaration
function ValueMessage.Delta#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ValueMessage.Delta.NoDelta
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Delta#Equal(a, b) } 
  true ==> (ValueMessage.Delta#Equal(a, b) <==> true));

// Datatype extensionality axiom: ValueMessage.Delta
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Delta#Equal(a, b) } 
  ValueMessage.Delta#Equal(a, b) <==> a == b);

const unique class.ValueMessage.Delta: ClassName;

const unique class.ValueMessage.__default: ClassName;

function Tclass.ValueMessage.__default() : Ty;

// Tclass.ValueMessage.__default Tag
axiom Tag(Tclass.ValueMessage.__default()) == Tagclass.ValueMessage.__default;

const unique Tagclass.ValueMessage.__default: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.__default()) } 
  $IsBox(bx, Tclass.ValueMessage.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueMessage.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueMessage.__default()) } 
  $Is($o, Tclass.ValueMessage.__default())
     <==> $o == null || dtype($o) == Tclass.ValueMessage.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueMessage.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueMessage.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueMessage._default.NopDelta
function ValueMessage.__default.NopDelta() : DatatypeType;

function ValueMessage.__default.NopDelta#canCall() : bool;

// consequence axiom for ValueMessage.__default.NopDelta
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.NopDelta(), Tclass.ValueMessage.Delta());

function ValueMessage.__default.NopDelta#requires() : bool;

// #requires axiom for ValueMessage.__default.NopDelta
axiom ValueMessage.__default.NopDelta#requires() == true;

// definition axiom for ValueMessage.__default.NopDelta(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta() == Lit(#ValueMessage.Delta.NoDelta());

// definition axiom for ValueMessage.__default.NopDelta for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta() == Lit(#ValueMessage.Delta.NoDelta());

// function declaration for ValueMessage._default.DefaultValue
function ValueMessage.__default.DefaultValue() : Seq Box;

function ValueMessage.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueMessage.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueMessage.__default.DefaultValue
axiom ValueMessage.__default.DefaultValue#requires() == true;

// definition axiom for ValueMessage.__default.DefaultValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefaultValue() == Lit(ValueType.__default.DefaultValue());

// definition axiom for ValueMessage.__default.DefaultValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefaultValue() == Lit(ValueType.__default.DefaultValue());

// function declaration for ValueMessage._default.CombineDeltas
function ValueMessage.__default.CombineDeltas(newdelta#0: DatatypeType, olddelta#0: DatatypeType) : DatatypeType;

function ValueMessage.__default.CombineDeltas#canCall(newdelta#0: DatatypeType, olddelta#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.CombineDeltas
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    { ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) } 
    ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> (ValueMessage.Delta#Equal(newdelta#0, ValueMessage.__default.NopDelta())
           ==> ValueMessage.Delta#Equal(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), olddelta#0))
         && (ValueMessage.Delta#Equal(olddelta#0, ValueMessage.__default.NopDelta())
           ==> ValueMessage.Delta#Equal(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), newdelta#0))
         && $Is(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), 
          Tclass.ValueMessage.Delta()));

function ValueMessage.__default.CombineDeltas#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.CombineDeltas
axiom (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
  { ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) } 
  $Is(newdelta#0, Tclass.ValueMessage.Delta())
       && $Is(olddelta#0, Tclass.ValueMessage.Delta())
     ==> ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) == true);

// definition axiom for ValueMessage.__default.CombineDeltas(revealed)
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    { ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) } 
    ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0)
         == Lit(#ValueMessage.Delta.NoDelta()));

// definition axiom for ValueMessage.__default.CombineDeltas for all literals(revealed)
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.CombineDeltas(Lit(newdelta#0), Lit(olddelta#0)) } 
    ValueMessage.__default.CombineDeltas#canCall(Lit(newdelta#0), Lit(olddelta#0))
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> ValueMessage.__default.CombineDeltas(Lit(newdelta#0), Lit(olddelta#0))
         == Lit(#ValueMessage.Delta.NoDelta()));

// function declaration for ValueMessage._default.ApplyDelta
function ValueMessage.__default.ApplyDelta(delta#0: DatatypeType, value#0: Seq Box) : Seq Box;

function ValueMessage.__default.ApplyDelta#canCall(delta#0: DatatypeType, value#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.ApplyDelta
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    { ValueMessage.__default.ApplyDelta(delta#0, value#0) } 
    ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0)
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> (ValueMessage.Delta#Equal(delta#0, ValueMessage.__default.NopDelta())
           ==> Seq#Equal(ValueMessage.__default.ApplyDelta(delta#0, value#0), value#0))
         && $Is(ValueMessage.__default.ApplyDelta(delta#0, value#0), Tclass.ValueType.Value()));

function ValueMessage.__default.ApplyDelta#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.ApplyDelta
axiom (forall delta#0: DatatypeType, value#0: Seq Box :: 
  { ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) } 
  $Is(delta#0, Tclass.ValueMessage.Delta())
       && $Is(value#0, Tclass.ValueType.Value())
     ==> ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) == true);

// definition axiom for ValueMessage.__default.ApplyDelta(revealed)
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    { ValueMessage.__default.ApplyDelta(delta#0, value#0) } 
    ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0)
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> ValueMessage.__default.ApplyDelta(delta#0, value#0) == value#0);

// definition axiom for ValueMessage.__default.ApplyDelta for all literals(revealed)
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.ApplyDelta(Lit(delta#0), Lit(value#0)) } 
    ValueMessage.__default.ApplyDelta#canCall(Lit(delta#0), Lit(value#0))
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> ValueMessage.__default.ApplyDelta(Lit(delta#0), Lit(value#0)) == Lit(value#0));

// function declaration for ValueMessage._default.bytestring_to_Message
function ValueMessage.__default.bytestring__to__Message(s#0: Seq Box) : DatatypeType;

function ValueMessage.__default.bytestring__to__Message#canCall(s#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.bytestring__to__Message
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueMessage.__default.bytestring__to__Message(s#0) } 
    ValueMessage.__default.bytestring__to__Message#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) < 4294967296)
       ==> $Is(ValueMessage.__default.bytestring__to__Message(s#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.bytestring__to__Message#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestring__to__Message
axiom (forall s#0: Seq Box :: 
  { ValueMessage.__default.bytestring__to__Message#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueMessage.__default.bytestring__to__Message#requires(s#0)
       == (Seq#Length(s#0) < 4294967296));

// definition axiom for ValueMessage.__default.bytestring__to__Message(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueMessage.__default.bytestring__to__Message(s#0) } 
    ValueMessage.__default.bytestring__to__Message#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) < 4294967296)
       ==> ValueType.__default.MaxLen#canCall()
         && (LitInt(ValueType.__default.MaxLen()) < Seq#Length(s#0)
           ==> ValueType.__default.DefaultValue#canCall())
         && ValueMessage.__default.bytestring__to__Message(s#0)
           == (if Seq#Length(s#0) <= LitInt(ValueType.__default.MaxLen())
             then #ValueMessage.Message.Define(s#0)
             else #ValueMessage.Message.Define(Lit(ValueType.__default.DefaultValue()))));

// definition axiom for ValueMessage.__default.bytestring__to__Message for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.bytestring__to__Message(Lit(s#0)) } 
    ValueMessage.__default.bytestring__to__Message#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) < 4294967296)
       ==> ValueType.__default.MaxLen#canCall()
         && (LitInt(ValueType.__default.MaxLen()) < Seq#Length(Lit(s#0))
           ==> ValueType.__default.DefaultValue#canCall())
         && ValueMessage.__default.bytestring__to__Message(Lit(s#0))
           == (if Seq#Length(Lit(s#0)) <= LitInt(ValueType.__default.MaxLen())
             then #ValueMessage.Message.Define(Lit(s#0))
             else #ValueMessage.Message.Define(Lit(ValueType.__default.DefaultValue()))));

// function declaration for ValueMessage._default.EncodableMessage
function ValueMessage.__default.EncodableMessage(msg#0: DatatypeType) : bool;

function ValueMessage.__default.EncodableMessage#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessage
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.EncodableMessage(msg#0) } 
    ValueMessage.__default.EncodableMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> true);

function ValueMessage.__default.EncodableMessage#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessage
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.EncodableMessage#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.EncodableMessage#requires(msg#0) == true);

// definition axiom for ValueMessage.__default.EncodableMessage(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.EncodableMessage(msg#0) } 
    ValueMessage.__default.EncodableMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> ValueMessage.__default.EncodableMessage(msg#0)
         == (true && ValueMessage.Message.Define_q(msg#0)));

// definition axiom for ValueMessage.__default.EncodableMessage for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.EncodableMessage(Lit(msg#0)) } 
    ValueMessage.__default.EncodableMessage#canCall(Lit(msg#0))
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> ValueMessage.__default.EncodableMessage(Lit(msg#0))
         == Lit(true && ValueMessage.Message.Define_q(Lit(msg#0))));

// function declaration for ValueMessage._default.EncodableMessageSeq
function ValueMessage.__default.EncodableMessageSeq(msgs#0: Seq Box) : bool;

function ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessageSeq
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { ValueMessage.__default.EncodableMessageSeq(msgs#0) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> true);

function ValueMessage.__default.EncodableMessageSeq#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessageSeq
axiom (forall msgs#0: Seq Box :: 
  { ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) == true);

// definition axiom for ValueMessage.__default.EncodableMessageSeq(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { ValueMessage.__default.EncodableMessageSeq(msgs#0) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (Lit(true)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(msgs#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(msgs#0)
               ==> ValueMessage.__default.EncodableMessage#canCall($Unbox(Seq#Index(msgs#0, i#2)): DatatypeType)))
         && ValueMessage.__default.EncodableMessageSeq(msgs#0)
           == (true
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(msgs#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(msgs#0)
                 ==> ValueMessage.__default.EncodableMessage($Unbox(Seq#Index(msgs#0, i#2)): DatatypeType))));

// definition axiom for ValueMessage.__default.EncodableMessageSeq for all literals(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0)) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(Lit(msgs#0))
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (Lit(true)
           ==> (forall i#3: int :: 
            { $Unbox(Seq#Index(msgs#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(msgs#0))
               ==> ValueMessage.__default.EncodableMessage#canCall($Unbox(Seq#Index(Lit(msgs#0), i#3)): DatatypeType)))
         && ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0))
           == (true
             && (forall i#3: int :: 
              { $Unbox(Seq#Index(msgs#0, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(msgs#0))
                 ==> ValueMessage.__default.EncodableMessage($Unbox(Seq#Index(Lit(msgs#0), i#3)): DatatypeType))));

// function declaration for ValueMessage._default.Message_to_bytestring
function ValueMessage.__default.Message__to__bytestring(msg#0: DatatypeType) : Seq Box;

function ValueMessage.__default.Message__to__bytestring#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Message__to__bytestring
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.Message__to__bytestring(msg#0) } 
    ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && ValueMessage.Message.Define_q(msg#0))
       ==> $Is(ValueMessage.__default.Message__to__bytestring(msg#0), 
        TSeq(Tclass.NativeTypes.byte())));

function ValueMessage.__default.Message__to__bytestring#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Message__to__bytestring
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.Message__to__bytestring#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Message__to__bytestring#requires(msg#0)
       == ValueMessage.Message.Define_q(msg#0));

// definition axiom for ValueMessage.__default.Message__to__bytestring(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.Message__to__bytestring(msg#0) } 
    ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && ValueMessage.Message.Define_q(msg#0))
       ==> ValueMessage.__default.Message__to__bytestring(msg#0)
         == ValueMessage.Message.value(msg#0));

// definition axiom for ValueMessage.__default.Message__to__bytestring for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.Message__to__bytestring(Lit(msg#0)) } 
    ValueMessage.__default.Message__to__bytestring#canCall(Lit(msg#0))
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && Lit(ValueMessage.Message.Define_q(Lit(msg#0))))
       ==> ValueMessage.__default.Message__to__bytestring(Lit(msg#0))
         == Lit(ValueMessage.Message.value(Lit(msg#0))));

// function declaration for ValueMessage._default.messageSeq_to_bytestringSeq
function ValueMessage.__default.messageSeq__to__bytestringSeq($ly: LayerType, msgs#0: Seq Box) : Seq Box;

function ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq(AsFuelBottom($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($LZ, msgs#0));

// consequence axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0)
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && ValueMessage.__default.EncodableMessageSeq(msgs#0))
       ==> Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
           == Seq#Length(msgs#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(msgs#0, i#1)): DatatypeType } 
            { $Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#1)): Seq Box } 
          LitInt(0) <= i#1
               && i#1
                 < Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
             ==> Seq#Equal($Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#1)): Seq Box, 
              ValueMessage.__default.Message__to__bytestring($Unbox(Seq#Index(msgs#0, i#1)): DatatypeType)))
         && $Is(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function ValueMessage.__default.messageSeq__to__bytestringSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0)
       == ValueMessage.__default.EncodableMessageSeq(msgs#0));

// definition axiom for ValueMessage.__default.messageSeq__to__bytestringSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0)
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && ValueMessage.__default.EncodableMessageSeq(msgs#0))
       ==> (Seq#Length(msgs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), msgs#0)
             && ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0))
             && 
            Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), msgs#0)
             && ValueMessage.__default.Message__to__bytestring#canCall($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), msgs#0)): DatatypeType))
         && ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0)
           == (if Seq#Length(msgs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(ValueMessage.__default.Message__to__bytestring($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), msgs#0)): DatatypeType))))));

// definition axiom for ValueMessage.__default.messageSeq__to__bytestringSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), Lit(msgs#0)) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Lit(msgs#0))
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Lit(ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0))))
       ==> (Seq#Length(Lit(msgs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0))
             && ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0))
             && ValueMessage.__default.Message__to__bytestring#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), Lit(msgs#0))): DatatypeType)))
         && ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), Lit(msgs#0))
           == (if Seq#Length(Lit(msgs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(ValueMessage.__default.Message__to__bytestring(Lit($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), Lit(msgs#0))): DatatypeType))))))));

// function declaration for ValueMessage._default.bytestringSeq_to_MessageSeq
function ValueMessage.__default.bytestringSeq__to__MessageSeq($ly: LayerType, strings#0: Seq Box) : Seq Box;

function ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq(AsFuelBottom($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($LZ, strings#0));

// consequence axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    { ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0)
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#4: int :: 
            { $Unbox(Seq#Index(strings#0, i#4)): Seq Box } 
            LitInt(0) <= i#4 && i#4 < Seq#Length(strings#0)
               ==> Seq#Length($Unbox(Seq#Index(strings#0, i#4)): Seq Box) < 4294967296))
       ==> Seq#Length(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0))
           == Seq#Length(strings#0)
         && (forall i#5: int :: 
          { $Unbox(Seq#Index(strings#0, i#5)): Seq Box } 
            { $Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#5)): DatatypeType } 
          LitInt(0) <= i#5 && i#5 < Seq#Length(strings#0)
             ==> ValueMessage.Message#Equal($Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#5)): DatatypeType, 
              ValueMessage.__default.bytestring__to__Message($Unbox(Seq#Index(strings#0, i#5)): Seq Box)))
         && $Is(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), 
          TSeq(Tclass.ValueMessage.Message())));

function ValueMessage.__default.bytestringSeq__to__MessageSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0) } 
  $Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0)
       == (forall i#6: int :: 
        { $Unbox(Seq#Index(strings#0, i#6)): Seq Box } 
        LitInt(0) <= i#6 && i#6 < Seq#Length(strings#0)
           ==> Seq#Length($Unbox(Seq#Index(strings#0, i#6)): Seq Box) < 4294967296));

// definition axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0)
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#6: int :: 
            { $Unbox(Seq#Index(strings#0, i#6)): Seq Box } 
            LitInt(0) <= i#6 && i#6 < Seq#Length(strings#0)
               ==> Seq#Length($Unbox(Seq#Index(strings#0, i#6)): Seq Box) < 4294967296))
       ==> (Seq#Length(strings#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strings#0)
             && ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strings#0))
             && 
            Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strings#0)
             && ValueMessage.__default.bytestring__to__Message#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strings#0)): Seq Box))
         && ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0)
           == (if Seq#Length(strings#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strings#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(ValueMessage.__default.bytestring__to__Message($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strings#0)): Seq Box))))));

// definition axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), Lit(strings#0)) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Lit(strings#0))
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#7: int :: 
            { $Unbox(Seq#Index(strings#0, i#7)): Seq Box } 
            LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(strings#0))
               ==> Seq#Length($Unbox(Seq#Index(Lit(strings#0), i#7)): Seq Box) < 4294967296))
       ==> (Seq#Length(Lit(strings#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))
             && ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))))
             && 
            Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))
             && ValueMessage.__default.bytestring__to__Message#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))): Seq Box)))
         && ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), Lit(strings#0))
           == (if Seq#Length(Lit(strings#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(ValueMessage.__default.bytestring__to__Message(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))): Seq Box))))))));

// function declaration for ValueMessage._default.Merge
function ValueMessage.__default.Merge(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : DatatypeType;

function ValueMessage.__default.Merge#canCall(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Merge
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> $Is(ValueMessage.__default.Merge(newmessage#0, oldmessage#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.Merge#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Merge
axiom (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
  { ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) } 
  $Is(newmessage#0, Tclass.ValueMessage.Message())
       && $Is(oldmessage#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) == true);

// definition axiom for ValueMessage.__default.Merge(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
         && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0))))
         && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
             && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var value#4 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var delta#4 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#4, value#4))))
             && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var olddelta#4 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var newdelta#4 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#4, olddelta#4)))))
         && ValueMessage.__default.Merge(newmessage#0, oldmessage#0)
           == (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
             then (var newvalue#5 := ValueMessage.Message.value($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
              #ValueMessage.Message.Define(newvalue#5))
             else (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               then (var value#5 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var delta#5 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Define(ValueMessage.__default.ApplyDelta(delta#5, value#5))))
               else (var olddelta#5 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var newdelta#5 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Update(ValueMessage.__default.CombineDeltas(newdelta#5, olddelta#5)))))));

// definition axiom for ValueMessage.__default.Merge for all literals(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0)) } 
    ValueMessage.__default.Merge#canCall(Lit(newmessage#0), Lit(oldmessage#0))
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
         && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0))))))
         && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
             && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var value#6 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var delta#6 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#6, value#6))))
             && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var olddelta#6 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var newdelta#6 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#6, olddelta#6)))))
         && ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0))
           == (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
             then (var newvalue#7 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
              Lit(#ValueMessage.Message.Define(newvalue#7)))
             else (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
               then (var value#7 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var delta#7 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.ApplyDelta(delta#7, value#7))))))
               else (var olddelta#7 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var newdelta#7 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.CombineDeltas(newdelta#7, olddelta#7)))))))));

// function declaration for ValueMessage._default.IdentityMessage
function ValueMessage.__default.IdentityMessage() : DatatypeType;

function ValueMessage.__default.IdentityMessage#canCall() : bool;

// consequence axiom for ValueMessage.__default.IdentityMessage
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.IdentityMessage(), Tclass.ValueMessage.Message());

function ValueMessage.__default.IdentityMessage#requires() : bool;

// #requires axiom for ValueMessage.__default.IdentityMessage
axiom ValueMessage.__default.IdentityMessage#requires() == true;

// definition axiom for ValueMessage.__default.IdentityMessage(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta())));

// definition axiom for ValueMessage.__default.IdentityMessage for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta())));

// function declaration for ValueMessage._default.DefineDefault
function ValueMessage.__default.DefineDefault() : DatatypeType;

function ValueMessage.__default.DefineDefault#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefineDefault
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefineDefault(), Tclass.ValueMessage.Message());

function ValueMessage.__default.DefineDefault#requires() : bool;

// #requires axiom for ValueMessage.__default.DefineDefault
axiom ValueMessage.__default.DefineDefault#requires() == true;

// definition axiom for ValueMessage.__default.DefineDefault(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.DefaultValue())));

// definition axiom for ValueMessage.__default.DefineDefault for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.DefaultValue())));

// Constructor function declaration
function #ValueMessage.Message.Define(Seq Box) : DatatypeType;

const unique ##ValueMessage.Message.Define: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#0#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Define(a#0#0#0))
     == ##ValueMessage.Message.Define);

function ValueMessage.Message.Define_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Define);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     ==> (exists a#1#0#0: Seq Box :: d == #ValueMessage.Message.Define(a#1#0#0)));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box :: 
  { $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message())
     <==> $Is(a#2#0#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Define_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(Lit(a#4#0#0)) } 
  #ValueMessage.Message.Define(Lit(a#4#0#0))
     == Lit(#ValueMessage.Message.Define(a#4#0#0)));

function ValueMessage.Message.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#5#0#0) } 
  ValueMessage.Message.value(#ValueMessage.Message.Define(a#5#0#0)) == a#5#0#0);

// Constructor function declaration
function #ValueMessage.Message.Update(DatatypeType) : DatatypeType;

const unique ##ValueMessage.Message.Update: DtCtorId;

// Constructor identifier
axiom (forall a#6#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#6#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Update(a#6#0#0))
     == ##ValueMessage.Message.Update);

function ValueMessage.Message.Update_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Update);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     ==> (exists a#7#0#0: DatatypeType :: d == #ValueMessage.Message.Update(a#7#0#0)));

// Constructor $Is
axiom (forall a#8#0#0: DatatypeType :: 
  { $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message())
     <==> $Is(a#8#0#0, Tclass.ValueMessage.Delta()));

// Constructor $IsAlloc
axiom (forall a#9#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAlloc(a#9#0#0, Tclass.ValueMessage.Delta(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Update_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAlloc(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h));

// Constructor literal
axiom (forall a#10#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(Lit(a#10#0#0)) } 
  #ValueMessage.Message.Update(Lit(a#10#0#0))
     == Lit(#ValueMessage.Message.Update(a#10#0#0)));

function ValueMessage.Message.delta(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#11#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#11#0#0) } 
  ValueMessage.Message.delta(#ValueMessage.Message.Update(a#11#0#0)) == a#11#0#0);

// Inductive rank
axiom (forall a#12#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#12#0#0) } 
  DtRank(a#12#0#0) < DtRank(#ValueMessage.Message.Update(a#12#0#0)));

// Depth-one case-split function
function $IsA#ValueMessage.Message(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ValueMessage.Message(d) } 
  $IsA#ValueMessage.Message(d)
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
    { ValueMessage.Message.Define_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
  $Is(d, Tclass.ValueMessage.Message())
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Datatype extensional equality declaration
function ValueMessage.Message#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ValueMessage.Message.Define
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(b) } 
  ValueMessage.Message.Define_q(a) && ValueMessage.Message.Define_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> Seq#Equal(ValueMessage.Message.value(a), ValueMessage.Message.value(b))));

// Datatype extensional equality definition: #ValueMessage.Message.Update
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(b) } 
  ValueMessage.Message.Update_q(a) && ValueMessage.Message.Update_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> ValueMessage.Delta#Equal(ValueMessage.Message.delta(a), ValueMessage.Message.delta(b))));

// Datatype extensionality axiom: ValueMessage.Message
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b) } 
  ValueMessage.Message#Equal(a, b) <==> a == b);

const unique class.ValueMessage.Message: ClassName;

const unique class.PivotsLib.__default: ClassName;

function Tclass.PivotsLib.__default() : Ty;

// Tclass.PivotsLib.__default Tag
axiom Tag(Tclass.PivotsLib.__default()) == Tagclass.PivotsLib.__default;

const unique Tagclass.PivotsLib.__default: TyTag;

// Box/unbox axiom for Tclass.PivotsLib.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotsLib.__default()) } 
  $IsBox(bx, Tclass.PivotsLib.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PivotsLib.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PivotsLib.__default()) } 
  $Is($o, Tclass.PivotsLib.__default())
     <==> $o == null || dtype($o) == Tclass.PivotsLib.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PivotsLib.__default(), $h) } 
  $IsAlloc($o, Tclass.PivotsLib.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PivotsLib._default.WFPivots
function PivotsLib.__default.WFPivots(pt#0: Seq Box) : bool;

function PivotsLib.__default.WFPivots#canCall(pt#0: Seq Box) : bool;

// consequence axiom for PivotsLib.__default.WFPivots
axiom true
   ==> (forall pt#0: Seq Box :: 
    { PivotsLib.__default.WFPivots(pt#0) } 
    PivotsLib.__default.WFPivots#canCall(pt#0)
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> true);

function PivotsLib.__default.WFPivots#requires(Seq Box) : bool;

// #requires axiom for PivotsLib.__default.WFPivots
axiom (forall pt#0: Seq Box :: 
  { PivotsLib.__default.WFPivots#requires(pt#0) } 
  $Is(pt#0, TSeq(Tclass.KeyType.Key()))
     ==> PivotsLib.__default.WFPivots#requires(pt#0) == true);

// definition axiom for PivotsLib.__default.WFPivots(revealed)
axiom true
   ==> (forall pt#0: Seq Box :: 
    { PivotsLib.__default.WFPivots(pt#0) } 
    PivotsLib.__default.WFPivots#canCall(pt#0)
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(pt#0)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, pt#0)
           ==> 
          Seq#Length(pt#0) > 0
           ==> Lexicographic__Byte__Order.__default.NotMinimum#canCall($Unbox(Seq#Index(pt#0, LitInt(0))): Seq Box))
         && PivotsLib.__default.WFPivots(pt#0)
           == (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, pt#0)
             && (Seq#Length(pt#0) > 0
               ==> Lexicographic__Byte__Order.__default.NotMinimum(StartFuel_Lexicographic_Byte_Order._default.NotMinimum, 
                $Unbox(Seq#Index(pt#0, LitInt(0))): Seq Box))));

// definition axiom for PivotsLib.__default.WFPivots for all literals(revealed)
axiom true
   ==> (forall pt#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.WFPivots(Lit(pt#0)) } 
    PivotsLib.__default.WFPivots#canCall(Lit(pt#0))
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(pt#0))
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, Lit(pt#0))
           ==> 
          Seq#Length(Lit(pt#0)) > 0
           ==> Lexicographic__Byte__Order.__default.NotMinimum#canCall($Unbox(Seq#Index(Lit(pt#0), LitInt(0))): Seq Box))
         && PivotsLib.__default.WFPivots(Lit(pt#0))
           == (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, Lit(pt#0))
             && (Seq#Length(Lit(pt#0)) > 0
               ==> Lexicographic__Byte__Order.__default.NotMinimum(StartFuel_Lexicographic_Byte_Order._default.NotMinimum, 
                $Unbox(Seq#Index(Lit(pt#0), LitInt(0))): Seq Box))));

// function declaration for PivotsLib._default.NumBuckets
function PivotsLib.__default.NumBuckets(pt#0: Seq Box) : int;

function PivotsLib.__default.NumBuckets#canCall(pt#0: Seq Box) : bool;

// consequence axiom for PivotsLib.__default.NumBuckets
axiom true
   ==> (forall pt#0: Seq Box :: 
    { PivotsLib.__default.NumBuckets(pt#0) } 
    PivotsLib.__default.NumBuckets#canCall(pt#0)
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> true);

function PivotsLib.__default.NumBuckets#requires(Seq Box) : bool;

// #requires axiom for PivotsLib.__default.NumBuckets
axiom (forall pt#0: Seq Box :: 
  { PivotsLib.__default.NumBuckets#requires(pt#0) } 
  $Is(pt#0, TSeq(Tclass.KeyType.Key()))
     ==> PivotsLib.__default.NumBuckets#requires(pt#0) == true);

// definition axiom for PivotsLib.__default.NumBuckets(revealed)
axiom true
   ==> (forall pt#0: Seq Box :: 
    { PivotsLib.__default.NumBuckets(pt#0) } 
    PivotsLib.__default.NumBuckets#canCall(pt#0)
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> PivotsLib.__default.NumBuckets(pt#0) == Seq#Length(pt#0) + 1);

// definition axiom for PivotsLib.__default.NumBuckets for all literals(revealed)
axiom true
   ==> (forall pt#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.NumBuckets(Lit(pt#0)) } 
    PivotsLib.__default.NumBuckets#canCall(Lit(pt#0))
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> PivotsLib.__default.NumBuckets(Lit(pt#0)) == Seq#Length(Lit(pt#0)) + 1);

// function declaration for PivotsLib._default.Route
function PivotsLib.__default.Route(pt#0: Seq Box, key#0: Seq Box) : int;

function PivotsLib.__default.Route#canCall(pt#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for PivotsLib.__default.Route
axiom true
   ==> (forall pt#0: Seq Box, key#0: Seq Box :: 
    { PivotsLib.__default.Route(pt#0, key#0) } 
    PivotsLib.__default.Route#canCall(pt#0, key#0)
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pt#0))
       ==> LitInt(0) <= PivotsLib.__default.Route(pt#0, key#0)
         && PivotsLib.__default.Route(pt#0, key#0) < PivotsLib.__default.NumBuckets(pt#0));

function PivotsLib.__default.Route#requires(Seq Box, Seq Box) : bool;

// #requires axiom for PivotsLib.__default.Route
axiom (forall pt#0: Seq Box, key#0: Seq Box :: 
  { PivotsLib.__default.Route#requires(pt#0, key#0) } 
  $Is(pt#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotsLib.__default.Route#requires(pt#0, key#0)
       == PivotsLib.__default.WFPivots(pt#0));

// definition axiom for PivotsLib.__default.Route(revealed)
axiom true
   ==> (forall pt#0: Seq Box, key#0: Seq Box :: 
    { PivotsLib.__default.Route(pt#0, key#0) } 
    PivotsLib.__default.Route#canCall(pt#0, key#0)
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pt#0))
       ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(pt#0, key#0)
         && PivotsLib.__default.Route(pt#0, key#0)
           == Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), pt#0, key#0) + 1);

// definition axiom for PivotsLib.__default.Route for all literals(revealed)
axiom true
   ==> (forall pt#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.Route(Lit(pt#0), Lit(key#0)) } 
    PivotsLib.__default.Route#canCall(Lit(pt#0), Lit(key#0))
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(PivotsLib.__default.WFPivots(Lit(pt#0))))
       ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(pt#0), Lit(key#0))
         && PivotsLib.__default.Route(Lit(pt#0), Lit(key#0))
           == LitInt(Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(pt#0), Lit(key#0))
               + 1));

// function declaration for PivotsLib._default.PivotInsertable
function PivotsLib.__default.PivotInsertable(pt#0: Seq Box, idx#0: int, key#0: Seq Box) : bool;

function PivotsLib.__default.PivotInsertable#canCall(pt#0: Seq Box, idx#0: int, key#0: Seq Box) : bool;

// consequence axiom for PivotsLib.__default.PivotInsertable
axiom true
   ==> (forall pt#0: Seq Box, idx#0: int, key#0: Seq Box :: 
    { PivotsLib.__default.PivotInsertable(pt#0, idx#0, key#0) } 
    PivotsLib.__default.PivotInsertable#canCall(pt#0, idx#0, key#0)
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pt#0))
       ==> true);

function PivotsLib.__default.PivotInsertable#requires(Seq Box, int, Seq Box) : bool;

// #requires axiom for PivotsLib.__default.PivotInsertable
axiom (forall pt#0: Seq Box, idx#0: int, key#0: Seq Box :: 
  { PivotsLib.__default.PivotInsertable#requires(pt#0, idx#0, key#0) } 
  $Is(pt#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotsLib.__default.PivotInsertable#requires(pt#0, idx#0, key#0)
       == PivotsLib.__default.WFPivots(pt#0));

// definition axiom for PivotsLib.__default.PivotInsertable(revealed)
axiom true
   ==> (forall pt#0: Seq Box, idx#0: int, key#0: Seq Box :: 
    { PivotsLib.__default.PivotInsertable(pt#0, idx#0, key#0) } 
    PivotsLib.__default.PivotInsertable#canCall(pt#0, idx#0, key#0)
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pt#0))
       ==> (idx#0 <= Seq#Length(pt#0) ==> PivotsLib.__default.Route#canCall(pt#0, key#0))
         && (
          (idx#0 > 0
           ==> !Seq#Equal(key#0, $Unbox(Seq#Index(pt#0, idx#0 - 1)): Seq Box))
           ==> 
          idx#0 == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.NotMinimum#canCall(key#0))
         && PivotsLib.__default.PivotInsertable(pt#0, idx#0, key#0)
           == (
            LitInt(0) <= idx#0
             && idx#0 <= Seq#Length(pt#0)
             && PivotsLib.__default.Route(pt#0, key#0) == idx#0
             && (idx#0 > 0 ==> !Seq#Equal(key#0, $Unbox(Seq#Index(pt#0, idx#0 - 1)): Seq Box))
             && (idx#0 == LitInt(0)
               ==> Lexicographic__Byte__Order.__default.NotMinimum(StartFuel_Lexicographic_Byte_Order._default.NotMinimum, key#0))));

// definition axiom for PivotsLib.__default.PivotInsertable for all literals(revealed)
axiom true
   ==> (forall pt#0: Seq Box, idx#0: int, key#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.PivotInsertable(Lit(pt#0), LitInt(idx#0), Lit(key#0)) } 
    PivotsLib.__default.PivotInsertable#canCall(Lit(pt#0), LitInt(idx#0), Lit(key#0))
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(PivotsLib.__default.WFPivots(Lit(pt#0))))
       ==> (LitInt(idx#0) <= Seq#Length(Lit(pt#0))
           ==> PivotsLib.__default.Route#canCall(Lit(pt#0), Lit(key#0)))
         && (
          (idx#0 > 0
           ==> !Seq#Equal(key#0, $Unbox(Seq#Index(Lit(pt#0), LitInt(idx#0 - 1))): Seq Box))
           ==> 
          LitInt(idx#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.NotMinimum#canCall(Lit(key#0)))
         && PivotsLib.__default.PivotInsertable(Lit(pt#0), LitInt(idx#0), Lit(key#0))
           == (
            LitInt(0) <= LitInt(idx#0)
             && LitInt(idx#0) <= Seq#Length(Lit(pt#0))
             && LitInt(PivotsLib.__default.Route(Lit(pt#0), Lit(key#0))) == LitInt(idx#0)
             && (idx#0 > 0
               ==> !Seq#Equal(key#0, $Unbox(Seq#Index(Lit(pt#0), LitInt(idx#0 - 1))): Seq Box))
             && (LitInt(idx#0) == LitInt(0)
               ==> Lexicographic__Byte__Order.__default.NotMinimum(StartFuel_Lexicographic_Byte_Order._default.NotMinimum, Lit(key#0)))));

// function declaration for PivotsLib._default.CutoffForLeft
function PivotsLib.__default.CutoffForLeft($ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box) : int;

function PivotsLib.__default.CutoffForLeft#canCall(pivots#0: Seq Box, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForLeft($LS($ly), pivots#0, pivot#0) } 
  PivotsLib.__default.CutoffForLeft($LS($ly), pivots#0, pivot#0)
     == PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForLeft(AsFuelBottom($ly), pivots#0, pivot#0) } 
  PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0)
     == PivotsLib.__default.CutoffForLeft($LZ, pivots#0, pivot#0));

// consequence axiom for PivotsLib.__default.CutoffForLeft
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    { PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0) } 
    PivotsLib.__default.CutoffForLeft#canCall(pivots#0, pivot#0)
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> LitInt(0) <= PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0)
         && PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0)
           <= Seq#Length(pivots#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(pivots#0, i#2)): Seq Box } 
          LitInt(0) <= i#2
               && i#2 < PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(pivots#0, i#2)): Seq Box, pivot#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(pivots#0, i#3)): Seq Box } 
          PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0) <= i#3
               && i#3 < Seq#Length(pivots#0)
             ==> Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox(Seq#Index(pivots#0, i#3)): Seq Box)));

function PivotsLib.__default.CutoffForLeft#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for PivotsLib.__default.CutoffForLeft
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForLeft#requires($ly, pivots#0, pivot#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key())) && $Is(pivot#0, Tclass.KeyType.Key())
     ==> PivotsLib.__default.CutoffForLeft#requires($ly, pivots#0, pivot#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for PivotsLib.__default.CutoffForLeft(revealed)
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    { PivotsLib.__default.CutoffForLeft($LS($ly), pivots#0, pivot#0) } 
    PivotsLib.__default.CutoffForLeft#canCall(pivots#0, pivot#0)
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(pivots#0, pivot#0)
         && PivotsLib.__default.CutoffForLeft($LS($ly), pivots#0, pivot#0)
           == Lexicographic__Byte__Order.__default.LargestLt($LS($LZ), pivots#0, pivot#0) + 1);

// definition axiom for PivotsLib.__default.CutoffForLeft for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.CutoffForLeft($LS($ly), Lit(pivots#0), Lit(pivot#0)) } 
    PivotsLib.__default.CutoffForLeft#canCall(Lit(pivots#0), Lit(pivot#0))
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(pivots#0), Lit(pivot#0))
         && PivotsLib.__default.CutoffForLeft($LS($ly), Lit(pivots#0), Lit(pivot#0))
           == LitInt(Lexicographic__Byte__Order.__default.LargestLt($LS($LZ), Lit(pivots#0), Lit(pivot#0))
               + 1));

// function declaration for PivotsLib._default.CutoffForRight
function PivotsLib.__default.CutoffForRight($ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box) : int;

function PivotsLib.__default.CutoffForRight#canCall(pivots#0: Seq Box, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForRight($LS($ly), pivots#0, pivot#0) } 
  PivotsLib.__default.CutoffForRight($LS($ly), pivots#0, pivot#0)
     == PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForRight(AsFuelBottom($ly), pivots#0, pivot#0) } 
  PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0)
     == PivotsLib.__default.CutoffForRight($LZ, pivots#0, pivot#0));

// consequence axiom for PivotsLib.__default.CutoffForRight
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    { PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0) } 
    PivotsLib.__default.CutoffForRight#canCall(pivots#0, pivot#0)
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> LitInt(0) <= PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0)
         && PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0)
           <= Seq#Length(pivots#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(pivots#0, i#2)): Seq Box } 
          LitInt(0) <= i#2
               && i#2 < PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(pivots#0, i#2)): Seq Box, pivot#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(pivots#0, i#3)): Seq Box } 
          PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0) <= i#3
               && i#3 < Seq#Length(pivots#0)
             ==> Lexicographic__Byte__Order.__default.lt(pivot#0, $Unbox(Seq#Index(pivots#0, i#3)): Seq Box)));

function PivotsLib.__default.CutoffForRight#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for PivotsLib.__default.CutoffForRight
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForRight#requires($ly, pivots#0, pivot#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key())) && $Is(pivot#0, Tclass.KeyType.Key())
     ==> PivotsLib.__default.CutoffForRight#requires($ly, pivots#0, pivot#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for PivotsLib.__default.CutoffForRight(revealed)
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    { PivotsLib.__default.CutoffForRight($LS($ly), pivots#0, pivot#0) } 
    PivotsLib.__default.CutoffForRight#canCall(pivots#0, pivot#0)
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> PivotsLib.__default.Route#canCall(pivots#0, pivot#0)
         && PivotsLib.__default.CutoffForRight($LS($ly), pivots#0, pivot#0)
           == PivotsLib.__default.Route(pivots#0, pivot#0));

// definition axiom for PivotsLib.__default.CutoffForRight for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.CutoffForRight($LS($ly), Lit(pivots#0), Lit(pivot#0)) } 
    PivotsLib.__default.CutoffForRight#canCall(Lit(pivots#0), Lit(pivot#0))
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), Lit(pivot#0))
         && PivotsLib.__default.CutoffForRight($LS($ly), Lit(pivots#0), Lit(pivot#0))
           == LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(pivot#0))));

// function declaration for PivotsLib._default.PivotTableBucketKeySet
function PivotsLib.__default.PivotTableBucketKeySet(pivots#0: Seq Box, i#0: int) : ISet Box;

function PivotsLib.__default.PivotTableBucketKeySet#canCall(pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for PivotsLib.__default.PivotTableBucketKeySet
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { PivotsLib.__default.PivotTableBucketKeySet(pivots#0, i#0) } 
    PivotsLib.__default.PivotTableBucketKeySet#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(PivotsLib.__default.PivotTableBucketKeySet(pivots#0, i#0), 
        TISet(Tclass.KeyType.Key())));

function PivotsLib.__default.PivotTableBucketKeySet#requires(Seq Box, int) : bool;

// #requires axiom for PivotsLib.__default.PivotTableBucketKeySet
axiom (forall pivots#0: Seq Box, i#0: int :: 
  { PivotsLib.__default.PivotTableBucketKeySet#requires(pivots#0, i#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> PivotsLib.__default.PivotTableBucketKeySet#requires(pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for PivotsLib.__default.PivotTableBucketKeySet(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { PivotsLib.__default.PivotTableBucketKeySet(pivots#0, i#0) } 
    PivotsLib.__default.PivotTableBucketKeySet#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall key#2: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, key#2) } 
          $Is(key#2, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(pivots#0, key#2))
         && PivotsLib.__default.PivotTableBucketKeySet(pivots#0, i#0)
           == (lambda $y#2: Box :: 
            $IsBox($y#2, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(pivots#0, $Unbox($y#2): Seq Box) == i#0));

// definition axiom for PivotsLib.__default.PivotTableBucketKeySet for all literals(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { PivotsLib.__default.PivotTableBucketKeySet(Lit(pivots#0), LitInt(i#0)) } 
    PivotsLib.__default.PivotTableBucketKeySet#canCall(Lit(pivots#0), LitInt(i#0))
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall key#3: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, key#3) } 
          $Is(key#3, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), key#3))
         && PivotsLib.__default.PivotTableBucketKeySet(Lit(pivots#0), LitInt(i#0))
           == (lambda $y#3: Box :: 
            $IsBox($y#3, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($y#3): Seq Box) == LitInt(i#0)));

// Constructor function declaration
function #UI.RangeStart.SInclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeStart.SInclusive: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(a#0#0#0) } 
  DatatypeCtorId(#UI.RangeStart.SInclusive(a#0#0#0)) == ##UI.RangeStart.SInclusive);

function UI.RangeStart.SInclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SInclusive_q(d) } 
  UI.RangeStart.SInclusive_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.SInclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SInclusive_q(d) } 
  UI.RangeStart.SInclusive_q(d)
     ==> (exists a#1#0#0: Seq Box :: d == #UI.RangeStart.SInclusive(a#1#0#0)));

function Tclass.UI.RangeStart() : Ty;

// Tclass.UI.RangeStart Tag
axiom Tag(Tclass.UI.RangeStart()) == Tagclass.UI.RangeStart;

const unique Tagclass.UI.RangeStart: TyTag;

// Box/unbox axiom for Tclass.UI.RangeStart
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.RangeStart()) } 
  $IsBox(bx, Tclass.UI.RangeStart())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.RangeStart()));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box :: 
  { $Is(#UI.RangeStart.SInclusive(a#2#0#0), Tclass.UI.RangeStart()) } 
  $Is(#UI.RangeStart.SInclusive(a#2#0#0), Tclass.UI.RangeStart())
     <==> $Is(a#2#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.SInclusive(a#3#0#0), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeStart.SInclusive(a#3#0#0), Tclass.UI.RangeStart(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeStart.SInclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeStart(), $h)
     ==> $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(Lit(a#4#0#0)) } 
  #UI.RangeStart.SInclusive(Lit(a#4#0#0))
     == Lit(#UI.RangeStart.SInclusive(a#4#0#0)));

function UI.RangeStart.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(a#5#0#0) } 
  UI.RangeStart.key(#UI.RangeStart.SInclusive(a#5#0#0)) == a#5#0#0);

// Constructor function declaration
function #UI.RangeStart.SExclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeStart.SExclusive: DtCtorId;

// Constructor identifier
axiom (forall a#6#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(a#6#0#0) } 
  DatatypeCtorId(#UI.RangeStart.SExclusive(a#6#0#0)) == ##UI.RangeStart.SExclusive);

function UI.RangeStart.SExclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SExclusive_q(d) } 
  UI.RangeStart.SExclusive_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.SExclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SExclusive_q(d) } 
  UI.RangeStart.SExclusive_q(d)
     ==> (exists a#7#0#0: Seq Box :: d == #UI.RangeStart.SExclusive(a#7#0#0)));

// Constructor $Is
axiom (forall a#8#0#0: Seq Box :: 
  { $Is(#UI.RangeStart.SExclusive(a#8#0#0), Tclass.UI.RangeStart()) } 
  $Is(#UI.RangeStart.SExclusive(a#8#0#0), Tclass.UI.RangeStart())
     <==> $Is(a#8#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#9#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.SExclusive(a#9#0#0), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeStart.SExclusive(a#9#0#0), Tclass.UI.RangeStart(), $h)
       <==> $IsAlloc(a#9#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeStart.SExclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeStart(), $h)
     ==> $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#10#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(Lit(a#10#0#0)) } 
  #UI.RangeStart.SExclusive(Lit(a#10#0#0))
     == Lit(#UI.RangeStart.SExclusive(a#10#0#0)));

// Constructor injectivity
axiom (forall a#11#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(a#11#0#0) } 
  UI.RangeStart.key(#UI.RangeStart.SExclusive(a#11#0#0)) == a#11#0#0);

// Constructor function declaration
function #UI.RangeStart.NegativeInf() : DatatypeType;

const unique ##UI.RangeStart.NegativeInf: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.RangeStart.NegativeInf()) == ##UI.RangeStart.NegativeInf;

function UI.RangeStart.NegativeInf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d) } 
  UI.RangeStart.NegativeInf_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.NegativeInf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d) } 
  UI.RangeStart.NegativeInf_q(d) ==> d == #UI.RangeStart.NegativeInf());

// Constructor $Is
axiom $Is(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart(), $h));

// Constructor literal
axiom #UI.RangeStart.NegativeInf() == Lit(#UI.RangeStart.NegativeInf());

// Depth-one case-split function
function $IsA#UI.RangeStart(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.RangeStart(d) } 
  $IsA#UI.RangeStart(d)
     ==> UI.RangeStart.SInclusive_q(d)
       || UI.RangeStart.SExclusive_q(d)
       || UI.RangeStart.NegativeInf_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d), $Is(d, Tclass.UI.RangeStart()) } 
    { UI.RangeStart.SExclusive_q(d), $Is(d, Tclass.UI.RangeStart()) } 
    { UI.RangeStart.SInclusive_q(d), $Is(d, Tclass.UI.RangeStart()) } 
  $Is(d, Tclass.UI.RangeStart())
     ==> UI.RangeStart.SInclusive_q(d)
       || UI.RangeStart.SExclusive_q(d)
       || UI.RangeStart.NegativeInf_q(d));

// Datatype extensional equality declaration
function UI.RangeStart#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.RangeStart.SInclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.SInclusive_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.SInclusive_q(b) } 
  UI.RangeStart.SInclusive_q(a) && UI.RangeStart.SInclusive_q(b)
     ==> (UI.RangeStart#Equal(a, b)
       <==> Seq#Equal(UI.RangeStart.key(a), UI.RangeStart.key(b))));

// Datatype extensional equality definition: #UI.RangeStart.SExclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.SExclusive_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.SExclusive_q(b) } 
  UI.RangeStart.SExclusive_q(a) && UI.RangeStart.SExclusive_q(b)
     ==> (UI.RangeStart#Equal(a, b)
       <==> Seq#Equal(UI.RangeStart.key(a), UI.RangeStart.key(b))));

// Datatype extensional equality definition: #UI.RangeStart.NegativeInf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.NegativeInf_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.NegativeInf_q(b) } 
  UI.RangeStart.NegativeInf_q(a) && UI.RangeStart.NegativeInf_q(b)
     ==> (UI.RangeStart#Equal(a, b) <==> true));

// Datatype extensionality axiom: UI.RangeStart
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b) } 
  UI.RangeStart#Equal(a, b) <==> a == b);

const unique class.UI.RangeStart: ClassName;

// Constructor function declaration
function #UI.RangeEnd.EInclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeEnd.EInclusive: DtCtorId;

// Constructor identifier
axiom (forall a#17#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(a#17#0#0) } 
  DatatypeCtorId(#UI.RangeEnd.EInclusive(a#17#0#0)) == ##UI.RangeEnd.EInclusive);

function UI.RangeEnd.EInclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EInclusive_q(d) } 
  UI.RangeEnd.EInclusive_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.EInclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EInclusive_q(d) } 
  UI.RangeEnd.EInclusive_q(d)
     ==> (exists a#18#0#0: Seq Box :: d == #UI.RangeEnd.EInclusive(a#18#0#0)));

function Tclass.UI.RangeEnd() : Ty;

// Tclass.UI.RangeEnd Tag
axiom Tag(Tclass.UI.RangeEnd()) == Tagclass.UI.RangeEnd;

const unique Tagclass.UI.RangeEnd: TyTag;

// Box/unbox axiom for Tclass.UI.RangeEnd
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.RangeEnd()) } 
  $IsBox(bx, Tclass.UI.RangeEnd())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.RangeEnd()));

// Constructor $Is
axiom (forall a#19#0#0: Seq Box :: 
  { $Is(#UI.RangeEnd.EInclusive(a#19#0#0), Tclass.UI.RangeEnd()) } 
  $Is(#UI.RangeEnd.EInclusive(a#19#0#0), Tclass.UI.RangeEnd())
     <==> $Is(a#19#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#20#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.EInclusive(a#20#0#0), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeEnd.EInclusive(a#20#0#0), Tclass.UI.RangeEnd(), $h)
       <==> $IsAlloc(a#20#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeEnd.EInclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeEnd(), $h)
     ==> $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#21#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(Lit(a#21#0#0)) } 
  #UI.RangeEnd.EInclusive(Lit(a#21#0#0)) == Lit(#UI.RangeEnd.EInclusive(a#21#0#0)));

function UI.RangeEnd.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#22#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(a#22#0#0) } 
  UI.RangeEnd.key(#UI.RangeEnd.EInclusive(a#22#0#0)) == a#22#0#0);

// Constructor function declaration
function #UI.RangeEnd.EExclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeEnd.EExclusive: DtCtorId;

// Constructor identifier
axiom (forall a#23#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(a#23#0#0) } 
  DatatypeCtorId(#UI.RangeEnd.EExclusive(a#23#0#0)) == ##UI.RangeEnd.EExclusive);

function UI.RangeEnd.EExclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EExclusive_q(d) } 
  UI.RangeEnd.EExclusive_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.EExclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EExclusive_q(d) } 
  UI.RangeEnd.EExclusive_q(d)
     ==> (exists a#24#0#0: Seq Box :: d == #UI.RangeEnd.EExclusive(a#24#0#0)));

// Constructor $Is
axiom (forall a#25#0#0: Seq Box :: 
  { $Is(#UI.RangeEnd.EExclusive(a#25#0#0), Tclass.UI.RangeEnd()) } 
  $Is(#UI.RangeEnd.EExclusive(a#25#0#0), Tclass.UI.RangeEnd())
     <==> $Is(a#25#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#26#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.EExclusive(a#26#0#0), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeEnd.EExclusive(a#26#0#0), Tclass.UI.RangeEnd(), $h)
       <==> $IsAlloc(a#26#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeEnd.EExclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeEnd(), $h)
     ==> $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#27#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(Lit(a#27#0#0)) } 
  #UI.RangeEnd.EExclusive(Lit(a#27#0#0)) == Lit(#UI.RangeEnd.EExclusive(a#27#0#0)));

// Constructor injectivity
axiom (forall a#28#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(a#28#0#0) } 
  UI.RangeEnd.key(#UI.RangeEnd.EExclusive(a#28#0#0)) == a#28#0#0);

// Constructor function declaration
function #UI.RangeEnd.PositiveInf() : DatatypeType;

const unique ##UI.RangeEnd.PositiveInf: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.RangeEnd.PositiveInf()) == ##UI.RangeEnd.PositiveInf;

function UI.RangeEnd.PositiveInf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d) } 
  UI.RangeEnd.PositiveInf_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.PositiveInf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d) } 
  UI.RangeEnd.PositiveInf_q(d) ==> d == #UI.RangeEnd.PositiveInf());

// Constructor $Is
axiom $Is(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom #UI.RangeEnd.PositiveInf() == Lit(#UI.RangeEnd.PositiveInf());

// Depth-one case-split function
function $IsA#UI.RangeEnd(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.RangeEnd(d) } 
  $IsA#UI.RangeEnd(d)
     ==> UI.RangeEnd.EInclusive_q(d)
       || UI.RangeEnd.EExclusive_q(d)
       || UI.RangeEnd.PositiveInf_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
    { UI.RangeEnd.EExclusive_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
    { UI.RangeEnd.EInclusive_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
  $Is(d, Tclass.UI.RangeEnd())
     ==> UI.RangeEnd.EInclusive_q(d)
       || UI.RangeEnd.EExclusive_q(d)
       || UI.RangeEnd.PositiveInf_q(d));

// Datatype extensional equality declaration
function UI.RangeEnd#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.RangeEnd.EInclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EInclusive_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EInclusive_q(b) } 
  UI.RangeEnd.EInclusive_q(a) && UI.RangeEnd.EInclusive_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> Seq#Equal(UI.RangeEnd.key(a), UI.RangeEnd.key(b))));

// Datatype extensional equality definition: #UI.RangeEnd.EExclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EExclusive_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EExclusive_q(b) } 
  UI.RangeEnd.EExclusive_q(a) && UI.RangeEnd.EExclusive_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> Seq#Equal(UI.RangeEnd.key(a), UI.RangeEnd.key(b))));

// Datatype extensional equality definition: #UI.RangeEnd.PositiveInf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.PositiveInf_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.PositiveInf_q(b) } 
  UI.RangeEnd.PositiveInf_q(a) && UI.RangeEnd.PositiveInf_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> true));

// Datatype extensionality axiom: UI.RangeEnd
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b) } 
  UI.RangeEnd#Equal(a, b) <==> a == b);

const unique class.UI.RangeEnd: ClassName;

// Constructor function declaration
function #UI.SuccResult.SuccResult(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.SuccResult.SuccResult: DtCtorId;

// Constructor identifier
axiom (forall a#34#0#0: Seq Box, a#34#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#34#0#0, a#34#1#0) } 
  DatatypeCtorId(#UI.SuccResult.SuccResult(a#34#0#0, a#34#1#0))
     == ##UI.SuccResult.SuccResult);

function UI.SuccResult.SuccResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d) } 
  UI.SuccResult.SuccResult_q(d)
     <==> DatatypeCtorId(d) == ##UI.SuccResult.SuccResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d) } 
  UI.SuccResult.SuccResult_q(d)
     ==> (exists a#35#0#0: Seq Box, a#35#1#0: Seq Box :: 
      d == #UI.SuccResult.SuccResult(a#35#0#0, a#35#1#0)));

function Tclass.UI.SuccResult() : Ty;

// Tclass.UI.SuccResult Tag
axiom Tag(Tclass.UI.SuccResult()) == Tagclass.UI.SuccResult;

const unique Tagclass.UI.SuccResult: TyTag;

// Box/unbox axiom for Tclass.UI.SuccResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.SuccResult()) } 
  $IsBox(bx, Tclass.UI.SuccResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.SuccResult()));

// Constructor $Is
axiom (forall a#36#0#0: Seq Box, a#36#1#0: Seq Box :: 
  { $Is(#UI.SuccResult.SuccResult(a#36#0#0, a#36#1#0), Tclass.UI.SuccResult()) } 
  $Is(#UI.SuccResult.SuccResult(a#36#0#0, a#36#1#0), Tclass.UI.SuccResult())
     <==> $Is(a#36#0#0, Tclass.KeyType.Key()) && $Is(a#36#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#37#0#0: Seq Box, a#37#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.SuccResult.SuccResult(a#37#0#0, a#37#1#0), Tclass.UI.SuccResult(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.SuccResult.SuccResult(a#37#0#0, a#37#1#0), Tclass.UI.SuccResult(), $h)
       <==> $IsAlloc(a#37#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#37#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResult.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResult.SuccResult_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResult(), $h)
     ==> $IsAlloc(UI.SuccResult.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResult.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResult.SuccResult_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResult(), $h)
     ==> $IsAlloc(UI.SuccResult.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#38#0#0: Seq Box, a#38#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(Lit(a#38#0#0), Lit(a#38#1#0)) } 
  #UI.SuccResult.SuccResult(Lit(a#38#0#0), Lit(a#38#1#0))
     == Lit(#UI.SuccResult.SuccResult(a#38#0#0, a#38#1#0)));

function UI.SuccResult.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#39#0#0: Seq Box, a#39#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#39#0#0, a#39#1#0) } 
  UI.SuccResult.key(#UI.SuccResult.SuccResult(a#39#0#0, a#39#1#0)) == a#39#0#0);

function UI.SuccResult.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#40#0#0: Seq Box, a#40#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#40#0#0, a#40#1#0) } 
  UI.SuccResult.value(#UI.SuccResult.SuccResult(a#40#0#0, a#40#1#0)) == a#40#1#0);

// Depth-one case-split function
function $IsA#UI.SuccResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.SuccResult(d) } 
  $IsA#UI.SuccResult(d) ==> UI.SuccResult.SuccResult_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d), $Is(d, Tclass.UI.SuccResult()) } 
  $Is(d, Tclass.UI.SuccResult()) ==> UI.SuccResult.SuccResult_q(d));

// Datatype extensional equality declaration
function UI.SuccResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.SuccResult.SuccResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResult#Equal(a, b) } 
  true
     ==> (UI.SuccResult#Equal(a, b)
       <==> Seq#Equal(UI.SuccResult.key(a), UI.SuccResult.key(b))
         && Seq#Equal(UI.SuccResult.value(a), UI.SuccResult.value(b))));

// Datatype extensionality axiom: UI.SuccResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResult#Equal(a, b) } 
  UI.SuccResult#Equal(a, b) <==> a == b);

const unique class.UI.SuccResult: ClassName;

// Constructor function declaration
function #UI.SuccResultList.SuccResultList(Seq Box, DatatypeType) : DatatypeType;

const unique ##UI.SuccResultList.SuccResultList: DtCtorId;

// Constructor identifier
axiom (forall a#41#0#0: Seq Box, a#41#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#41#0#0, a#41#1#0) } 
  DatatypeCtorId(#UI.SuccResultList.SuccResultList(a#41#0#0, a#41#1#0))
     == ##UI.SuccResultList.SuccResultList);

function UI.SuccResultList.SuccResultList_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d) } 
  UI.SuccResultList.SuccResultList_q(d)
     <==> DatatypeCtorId(d) == ##UI.SuccResultList.SuccResultList);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d) } 
  UI.SuccResultList.SuccResultList_q(d)
     ==> (exists a#42#0#0: Seq Box, a#42#1#0: DatatypeType :: 
      d == #UI.SuccResultList.SuccResultList(a#42#0#0, a#42#1#0)));

function Tclass.UI.SuccResultList() : Ty;

// Tclass.UI.SuccResultList Tag
axiom Tag(Tclass.UI.SuccResultList()) == Tagclass.UI.SuccResultList;

const unique Tagclass.UI.SuccResultList: TyTag;

// Box/unbox axiom for Tclass.UI.SuccResultList
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.SuccResultList()) } 
  $IsBox(bx, Tclass.UI.SuccResultList())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.SuccResultList()));

// Constructor $Is
axiom (forall a#43#0#0: Seq Box, a#43#1#0: DatatypeType :: 
  { $Is(#UI.SuccResultList.SuccResultList(a#43#0#0, a#43#1#0), 
      Tclass.UI.SuccResultList()) } 
  $Is(#UI.SuccResultList.SuccResultList(a#43#0#0, a#43#1#0), 
      Tclass.UI.SuccResultList())
     <==> $Is(a#43#0#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#43#1#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#44#0#0: Seq Box, a#44#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#UI.SuccResultList.SuccResultList(a#44#0#0, a#44#1#0), 
      Tclass.UI.SuccResultList(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.SuccResultList.SuccResultList(a#44#0#0, a#44#1#0), 
        Tclass.UI.SuccResultList(), 
        $h)
       <==> $IsAlloc(a#44#0#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#44#1#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResultList.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResultList.SuccResultList_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResultList(), $h)
     ==> $IsAlloc(UI.SuccResultList.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResultList.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResultList.SuccResultList_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResultList(), $h)
     ==> $IsAlloc(UI.SuccResultList.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#45#0#0: Seq Box, a#45#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(Lit(a#45#0#0), Lit(a#45#1#0)) } 
  #UI.SuccResultList.SuccResultList(Lit(a#45#0#0), Lit(a#45#1#0))
     == Lit(#UI.SuccResultList.SuccResultList(a#45#0#0, a#45#1#0)));

function UI.SuccResultList.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#46#0#0: Seq Box, a#46#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#46#0#0, a#46#1#0) } 
  UI.SuccResultList.results(#UI.SuccResultList.SuccResultList(a#46#0#0, a#46#1#0))
     == a#46#0#0);

// Inductive seq element rank
axiom (forall a#47#0#0: Seq Box, a#47#1#0: DatatypeType, i: int :: 
  { Seq#Index(a#47#0#0, i), #UI.SuccResultList.SuccResultList(a#47#0#0, a#47#1#0) } 
  0 <= i && i < Seq#Length(a#47#0#0)
     ==> DtRank($Unbox(Seq#Index(a#47#0#0, i)): DatatypeType)
       < DtRank(#UI.SuccResultList.SuccResultList(a#47#0#0, a#47#1#0)));

// Inductive seq rank
axiom (forall a#48#0#0: Seq Box, a#48#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#48#0#0, a#48#1#0) } 
  Seq#Rank(a#48#0#0)
     < DtRank(#UI.SuccResultList.SuccResultList(a#48#0#0, a#48#1#0)));

function UI.SuccResultList.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#49#0#0: Seq Box, a#49#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#49#0#0, a#49#1#0) } 
  UI.SuccResultList.end(#UI.SuccResultList.SuccResultList(a#49#0#0, a#49#1#0))
     == a#49#1#0);

// Inductive rank
axiom (forall a#50#0#0: Seq Box, a#50#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#50#0#0, a#50#1#0) } 
  DtRank(a#50#1#0) < DtRank(#UI.SuccResultList.SuccResultList(a#50#0#0, a#50#1#0)));

// Depth-one case-split function
function $IsA#UI.SuccResultList(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.SuccResultList(d) } 
  $IsA#UI.SuccResultList(d) ==> UI.SuccResultList.SuccResultList_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d), $Is(d, Tclass.UI.SuccResultList()) } 
  $Is(d, Tclass.UI.SuccResultList()) ==> UI.SuccResultList.SuccResultList_q(d));

// Datatype extensional equality declaration
function UI.SuccResultList#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.SuccResultList.SuccResultList
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResultList#Equal(a, b) } 
  true
     ==> (UI.SuccResultList#Equal(a, b)
       <==> Seq#Equal(UI.SuccResultList.results(a), UI.SuccResultList.results(b))
         && UI.RangeEnd#Equal(UI.SuccResultList.end(a), UI.SuccResultList.end(b))));

// Datatype extensionality axiom: UI.SuccResultList
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResultList#Equal(a, b) } 
  UI.SuccResultList#Equal(a, b) <==> a == b);

const unique class.UI.SuccResultList: ClassName;

// Constructor function declaration
function #UI.Op.NoOp() : DatatypeType;

const unique ##UI.Op.NoOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.NoOp()) == ##UI.Op.NoOp;

function UI.Op.NoOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.NoOp_q(d) } 
  UI.Op.NoOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.NoOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.NoOp_q(d) } 
  UI.Op.NoOp_q(d) ==> d == #UI.Op.NoOp());

function Tclass.UI.Op() : Ty;

// Tclass.UI.Op Tag
axiom Tag(Tclass.UI.Op()) == Tagclass.UI.Op;

const unique Tagclass.UI.Op: TyTag;

// Box/unbox axiom for Tclass.UI.Op
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.Op()) } 
  $IsBox(bx, Tclass.UI.Op())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.Op()));

// Constructor $Is
axiom $Is(#UI.Op.NoOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.NoOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.NoOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.NoOp() == Lit(#UI.Op.NoOp());

// Constructor function declaration
function #UI.Op.SyncOp() : DatatypeType;

const unique ##UI.Op.SyncOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.SyncOp()) == ##UI.Op.SyncOp;

function UI.Op.SyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.SyncOp_q(d) } 
  UI.Op.SyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.SyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.SyncOp_q(d) } 
  UI.Op.SyncOp_q(d) ==> d == #UI.Op.SyncOp());

// Constructor $Is
axiom $Is(#UI.Op.SyncOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.SyncOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.SyncOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.SyncOp() == Lit(#UI.Op.SyncOp());

// Constructor function declaration
function #UI.Op.CrashOp() : DatatypeType;

const unique ##UI.Op.CrashOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.CrashOp()) == ##UI.Op.CrashOp;

function UI.Op.CrashOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.CrashOp_q(d) } 
  UI.Op.CrashOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.CrashOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.CrashOp_q(d) } 
  UI.Op.CrashOp_q(d) ==> d == #UI.Op.CrashOp());

// Constructor $Is
axiom $Is(#UI.Op.CrashOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.CrashOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.CrashOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.CrashOp() == Lit(#UI.Op.CrashOp());

// Constructor function declaration
function #UI.Op.PushSyncOp(int) : DatatypeType;

const unique ##UI.Op.PushSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#66#0#0: int :: 
  { #UI.Op.PushSyncOp(a#66#0#0) } 
  DatatypeCtorId(#UI.Op.PushSyncOp(a#66#0#0)) == ##UI.Op.PushSyncOp);

function UI.Op.PushSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PushSyncOp_q(d) } 
  UI.Op.PushSyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PushSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PushSyncOp_q(d) } 
  UI.Op.PushSyncOp_q(d)
     ==> (exists a#67#0#0: int :: d == #UI.Op.PushSyncOp(a#67#0#0)));

// Constructor $Is
axiom (forall a#68#0#0: int :: 
  { $Is(#UI.Op.PushSyncOp(a#68#0#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PushSyncOp(a#68#0#0), Tclass.UI.Op()) <==> $Is(a#68#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#69#0#0: int, $h: Heap :: 
  { $IsAlloc(#UI.Op.PushSyncOp(a#69#0#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PushSyncOp(a#69#0#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#69#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.id(d), TInt, $h) } 
  $IsGoodHeap($h) && UI.Op.PushSyncOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.id(d), TInt, $h));

// Constructor literal
axiom (forall a#70#0#0: int :: 
  { #UI.Op.PushSyncOp(LitInt(a#70#0#0)) } 
  #UI.Op.PushSyncOp(LitInt(a#70#0#0)) == Lit(#UI.Op.PushSyncOp(a#70#0#0)));

function UI.Op.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#71#0#0: int :: 
  { #UI.Op.PushSyncOp(a#71#0#0) } 
  UI.Op.id(#UI.Op.PushSyncOp(a#71#0#0)) == a#71#0#0);

// Constructor function declaration
function #UI.Op.PopSyncOp(int) : DatatypeType;

const unique ##UI.Op.PopSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#72#0#0: int :: 
  { #UI.Op.PopSyncOp(a#72#0#0) } 
  DatatypeCtorId(#UI.Op.PopSyncOp(a#72#0#0)) == ##UI.Op.PopSyncOp);

function UI.Op.PopSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PopSyncOp_q(d) } 
  UI.Op.PopSyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PopSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PopSyncOp_q(d) } 
  UI.Op.PopSyncOp_q(d)
     ==> (exists a#73#0#0: int :: d == #UI.Op.PopSyncOp(a#73#0#0)));

// Constructor $Is
axiom (forall a#74#0#0: int :: 
  { $Is(#UI.Op.PopSyncOp(a#74#0#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PopSyncOp(a#74#0#0), Tclass.UI.Op()) <==> $Is(a#74#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#75#0#0: int, $h: Heap :: 
  { $IsAlloc(#UI.Op.PopSyncOp(a#75#0#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PopSyncOp(a#75#0#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#75#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.id(d), TInt, $h) } 
  $IsGoodHeap($h) && UI.Op.PopSyncOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.id(d), TInt, $h));

// Constructor literal
axiom (forall a#76#0#0: int :: 
  { #UI.Op.PopSyncOp(LitInt(a#76#0#0)) } 
  #UI.Op.PopSyncOp(LitInt(a#76#0#0)) == Lit(#UI.Op.PopSyncOp(a#76#0#0)));

// Constructor injectivity
axiom (forall a#77#0#0: int :: 
  { #UI.Op.PopSyncOp(a#77#0#0) } 
  UI.Op.id(#UI.Op.PopSyncOp(a#77#0#0)) == a#77#0#0);

// Constructor function declaration
function #UI.Op.GetOp(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.Op.GetOp: DtCtorId;

// Constructor identifier
axiom (forall a#78#0#0: Seq Box, a#78#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#78#0#0, a#78#1#0) } 
  DatatypeCtorId(#UI.Op.GetOp(a#78#0#0, a#78#1#0)) == ##UI.Op.GetOp);

function UI.Op.GetOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.GetOp_q(d) } 
  UI.Op.GetOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.GetOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.GetOp_q(d) } 
  UI.Op.GetOp_q(d)
     ==> (exists a#79#0#0: Seq Box, a#79#1#0: Seq Box :: 
      d == #UI.Op.GetOp(a#79#0#0, a#79#1#0)));

// Constructor $Is
axiom (forall a#80#0#0: Seq Box, a#80#1#0: Seq Box :: 
  { $Is(#UI.Op.GetOp(a#80#0#0, a#80#1#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.GetOp(a#80#0#0, a#80#1#0), Tclass.UI.Op())
     <==> $Is(a#80#0#0, Tclass.KeyType.Key()) && $Is(a#80#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#81#0#0: Seq Box, a#81#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.Op.GetOp(a#81#0#0, a#81#1#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.GetOp(a#81#0#0, a#81#1#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#81#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#81#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h) && UI.Op.GetOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h) && UI.Op.GetOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#82#0#0: Seq Box, a#82#1#0: Seq Box :: 
  { #UI.Op.GetOp(Lit(a#82#0#0), Lit(a#82#1#0)) } 
  #UI.Op.GetOp(Lit(a#82#0#0), Lit(a#82#1#0))
     == Lit(#UI.Op.GetOp(a#82#0#0, a#82#1#0)));

function UI.Op.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#83#0#0: Seq Box, a#83#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#83#0#0, a#83#1#0) } 
  UI.Op.key(#UI.Op.GetOp(a#83#0#0, a#83#1#0)) == a#83#0#0);

function UI.Op.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#84#0#0: Seq Box, a#84#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#84#0#0, a#84#1#0) } 
  UI.Op.value(#UI.Op.GetOp(a#84#0#0, a#84#1#0)) == a#84#1#0);

// Constructor function declaration
function #UI.Op.PutOp(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.Op.PutOp: DtCtorId;

// Constructor identifier
axiom (forall a#85#0#0: Seq Box, a#85#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#85#0#0, a#85#1#0) } 
  DatatypeCtorId(#UI.Op.PutOp(a#85#0#0, a#85#1#0)) == ##UI.Op.PutOp);

function UI.Op.PutOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PutOp_q(d) } 
  UI.Op.PutOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PutOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PutOp_q(d) } 
  UI.Op.PutOp_q(d)
     ==> (exists a#86#0#0: Seq Box, a#86#1#0: Seq Box :: 
      d == #UI.Op.PutOp(a#86#0#0, a#86#1#0)));

// Constructor $Is
axiom (forall a#87#0#0: Seq Box, a#87#1#0: Seq Box :: 
  { $Is(#UI.Op.PutOp(a#87#0#0, a#87#1#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PutOp(a#87#0#0, a#87#1#0), Tclass.UI.Op())
     <==> $Is(a#87#0#0, Tclass.KeyType.Key()) && $Is(a#87#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#88#0#0: Seq Box, a#88#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.Op.PutOp(a#88#0#0, a#88#1#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PutOp(a#88#0#0, a#88#1#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#88#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#88#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h) && UI.Op.PutOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h) && UI.Op.PutOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#89#0#0: Seq Box, a#89#1#0: Seq Box :: 
  { #UI.Op.PutOp(Lit(a#89#0#0), Lit(a#89#1#0)) } 
  #UI.Op.PutOp(Lit(a#89#0#0), Lit(a#89#1#0))
     == Lit(#UI.Op.PutOp(a#89#0#0, a#89#1#0)));

// Constructor injectivity
axiom (forall a#90#0#0: Seq Box, a#90#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#90#0#0, a#90#1#0) } 
  UI.Op.key(#UI.Op.PutOp(a#90#0#0, a#90#1#0)) == a#90#0#0);

// Constructor injectivity
axiom (forall a#91#0#0: Seq Box, a#91#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#91#0#0, a#91#1#0) } 
  UI.Op.value(#UI.Op.PutOp(a#91#0#0, a#91#1#0)) == a#91#1#0);

// Constructor function declaration
function #UI.Op.SuccOp(DatatypeType, Seq Box, DatatypeType) : DatatypeType;

const unique ##UI.Op.SuccOp: DtCtorId;

// Constructor identifier
axiom (forall a#92#0#0: DatatypeType, a#92#1#0: Seq Box, a#92#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#92#0#0, a#92#1#0, a#92#2#0) } 
  DatatypeCtorId(#UI.Op.SuccOp(a#92#0#0, a#92#1#0, a#92#2#0)) == ##UI.Op.SuccOp);

function UI.Op.SuccOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d) } 
  UI.Op.SuccOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.SuccOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d) } 
  UI.Op.SuccOp_q(d)
     ==> (exists a#93#0#0: DatatypeType, a#93#1#0: Seq Box, a#93#2#0: DatatypeType :: 
      d == #UI.Op.SuccOp(a#93#0#0, a#93#1#0, a#93#2#0)));

// Constructor $Is
axiom (forall a#94#0#0: DatatypeType, a#94#1#0: Seq Box, a#94#2#0: DatatypeType :: 
  { $Is(#UI.Op.SuccOp(a#94#0#0, a#94#1#0, a#94#2#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.SuccOp(a#94#0#0, a#94#1#0, a#94#2#0), Tclass.UI.Op())
     <==> $Is(a#94#0#0, Tclass.UI.RangeStart())
       && $Is(a#94#1#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#94#2#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#95#0#0: DatatypeType, a#95#1#0: Seq Box, a#95#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#UI.Op.SuccOp(a#95#0#0, a#95#1#0, a#95#2#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.SuccOp(a#95#0#0, a#95#1#0, a#95#2#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#95#0#0, Tclass.UI.RangeStart(), $h)
         && $IsAlloc(a#95#1#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#95#2#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.start(d), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.start(d), Tclass.UI.RangeStart(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#96#0#0: DatatypeType, a#96#1#0: Seq Box, a#96#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(Lit(a#96#0#0), Lit(a#96#1#0), Lit(a#96#2#0)) } 
  #UI.Op.SuccOp(Lit(a#96#0#0), Lit(a#96#1#0), Lit(a#96#2#0))
     == Lit(#UI.Op.SuccOp(a#96#0#0, a#96#1#0, a#96#2#0)));

function UI.Op.start(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#97#0#0: DatatypeType, a#97#1#0: Seq Box, a#97#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#97#0#0, a#97#1#0, a#97#2#0) } 
  UI.Op.start(#UI.Op.SuccOp(a#97#0#0, a#97#1#0, a#97#2#0)) == a#97#0#0);

// Inductive rank
axiom (forall a#98#0#0: DatatypeType, a#98#1#0: Seq Box, a#98#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#98#0#0, a#98#1#0, a#98#2#0) } 
  DtRank(a#98#0#0) < DtRank(#UI.Op.SuccOp(a#98#0#0, a#98#1#0, a#98#2#0)));

function UI.Op.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#99#0#0: DatatypeType, a#99#1#0: Seq Box, a#99#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#99#0#0, a#99#1#0, a#99#2#0) } 
  UI.Op.results(#UI.Op.SuccOp(a#99#0#0, a#99#1#0, a#99#2#0)) == a#99#1#0);

// Inductive seq element rank
axiom (forall a#100#0#0: DatatypeType, a#100#1#0: Seq Box, a#100#2#0: DatatypeType, i: int :: 
  { Seq#Index(a#100#1#0, i), #UI.Op.SuccOp(a#100#0#0, a#100#1#0, a#100#2#0) } 
  0 <= i && i < Seq#Length(a#100#1#0)
     ==> DtRank($Unbox(Seq#Index(a#100#1#0, i)): DatatypeType)
       < DtRank(#UI.Op.SuccOp(a#100#0#0, a#100#1#0, a#100#2#0)));

// Inductive seq rank
axiom (forall a#101#0#0: DatatypeType, a#101#1#0: Seq Box, a#101#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#101#0#0, a#101#1#0, a#101#2#0) } 
  Seq#Rank(a#101#1#0) < DtRank(#UI.Op.SuccOp(a#101#0#0, a#101#1#0, a#101#2#0)));

function UI.Op.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#102#0#0: DatatypeType, a#102#1#0: Seq Box, a#102#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#102#0#0, a#102#1#0, a#102#2#0) } 
  UI.Op.end(#UI.Op.SuccOp(a#102#0#0, a#102#1#0, a#102#2#0)) == a#102#2#0);

// Inductive rank
axiom (forall a#103#0#0: DatatypeType, a#103#1#0: Seq Box, a#103#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#103#0#0, a#103#1#0, a#103#2#0) } 
  DtRank(a#103#2#0) < DtRank(#UI.Op.SuccOp(a#103#0#0, a#103#1#0, a#103#2#0)));

// Depth-one case-split function
function $IsA#UI.Op(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.Op(d) } 
  $IsA#UI.Op(d)
     ==> UI.Op.NoOp_q(d)
       || UI.Op.SyncOp_q(d)
       || UI.Op.CrashOp_q(d)
       || UI.Op.PushSyncOp_q(d)
       || UI.Op.PopSyncOp_q(d)
       || UI.Op.GetOp_q(d)
       || UI.Op.PutOp_q(d)
       || UI.Op.SuccOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PutOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.GetOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PopSyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PushSyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.CrashOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.SyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.NoOp_q(d), $Is(d, Tclass.UI.Op()) } 
  $Is(d, Tclass.UI.Op())
     ==> UI.Op.NoOp_q(d)
       || UI.Op.SyncOp_q(d)
       || UI.Op.CrashOp_q(d)
       || UI.Op.PushSyncOp_q(d)
       || UI.Op.PopSyncOp_q(d)
       || UI.Op.GetOp_q(d)
       || UI.Op.PutOp_q(d)
       || UI.Op.SuccOp_q(d));

// Datatype extensional equality declaration
function UI.Op#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.Op.NoOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.NoOp_q(a) } { UI.Op#Equal(a, b), UI.Op.NoOp_q(b) } 
  UI.Op.NoOp_q(a) && UI.Op.NoOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.SyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.SyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.SyncOp_q(b) } 
  UI.Op.SyncOp_q(a) && UI.Op.SyncOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.CrashOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.CrashOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.CrashOp_q(b) } 
  UI.Op.CrashOp_q(a) && UI.Op.CrashOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.PushSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PushSyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.PushSyncOp_q(b) } 
  UI.Op.PushSyncOp_q(a) && UI.Op.PushSyncOp_q(b)
     ==> (UI.Op#Equal(a, b) <==> UI.Op.id(a) == UI.Op.id(b)));

// Datatype extensional equality definition: #UI.Op.PopSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PopSyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.PopSyncOp_q(b) } 
  UI.Op.PopSyncOp_q(a) && UI.Op.PopSyncOp_q(b)
     ==> (UI.Op#Equal(a, b) <==> UI.Op.id(a) == UI.Op.id(b)));

// Datatype extensional equality definition: #UI.Op.GetOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.GetOp_q(a) } { UI.Op#Equal(a, b), UI.Op.GetOp_q(b) } 
  UI.Op.GetOp_q(a) && UI.Op.GetOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> Seq#Equal(UI.Op.key(a), UI.Op.key(b))
         && Seq#Equal(UI.Op.value(a), UI.Op.value(b))));

// Datatype extensional equality definition: #UI.Op.PutOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PutOp_q(a) } { UI.Op#Equal(a, b), UI.Op.PutOp_q(b) } 
  UI.Op.PutOp_q(a) && UI.Op.PutOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> Seq#Equal(UI.Op.key(a), UI.Op.key(b))
         && Seq#Equal(UI.Op.value(a), UI.Op.value(b))));

// Datatype extensional equality definition: #UI.Op.SuccOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.SuccOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.SuccOp_q(b) } 
  UI.Op.SuccOp_q(a) && UI.Op.SuccOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> UI.RangeStart#Equal(UI.Op.start(a), UI.Op.start(b))
         && Seq#Equal(UI.Op.results(a), UI.Op.results(b))
         && UI.RangeEnd#Equal(UI.Op.end(a), UI.Op.end(b))));

// Datatype extensionality axiom: UI.Op
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b) } 
  UI.Op#Equal(a, b) <==> a == b);

const unique class.UI.Op: ClassName;

const unique class.UI.__default: ClassName;

function Tclass.UI.__default() : Ty;

// Tclass.UI.__default Tag
axiom Tag(Tclass.UI.__default()) == Tagclass.UI.__default;

const unique Tagclass.UI.__default: TyTag;

// Box/unbox axiom for Tclass.UI.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.__default()) } 
  $IsBox(bx, Tclass.UI.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.UI.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.UI.__default()) } 
  $Is($o, Tclass.UI.__default())
     <==> $o == null || dtype($o) == Tclass.UI.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.UI.__default(), $h) } 
  $IsAlloc($o, Tclass.UI.__default(), $h) <==> $o == null || read($h, $o, alloc));

// Constructor function declaration
function #MapSpec.Constants.Constants() : DatatypeType;

const unique ##MapSpec.Constants.Constants: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#MapSpec.Constants.Constants()) == ##MapSpec.Constants.Constants;

function MapSpec.Constants.Constants_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Constants.Constants_q(d) } 
  MapSpec.Constants.Constants_q(d)
     <==> DatatypeCtorId(d) == ##MapSpec.Constants.Constants);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Constants.Constants_q(d) } 
  MapSpec.Constants.Constants_q(d) ==> d == #MapSpec.Constants.Constants());

function Tclass.MapSpec.Constants() : Ty;

// Tclass.MapSpec.Constants Tag
axiom Tag(Tclass.MapSpec.Constants()) == Tagclass.MapSpec.Constants;

const unique Tagclass.MapSpec.Constants: TyTag;

// Box/unbox axiom for Tclass.MapSpec.Constants
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MapSpec.Constants()) } 
  $IsBox(bx, Tclass.MapSpec.Constants())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MapSpec.Constants()));

// Constructor $Is
axiom $Is(#MapSpec.Constants.Constants(), Tclass.MapSpec.Constants());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#MapSpec.Constants.Constants(), Tclass.MapSpec.Constants(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#MapSpec.Constants.Constants(), Tclass.MapSpec.Constants(), $h));

// Constructor literal
axiom #MapSpec.Constants.Constants() == Lit(#MapSpec.Constants.Constants());

// Depth-one case-split function
function $IsA#MapSpec.Constants(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MapSpec.Constants(d) } 
  $IsA#MapSpec.Constants(d) ==> MapSpec.Constants.Constants_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { MapSpec.Constants.Constants_q(d), $Is(d, Tclass.MapSpec.Constants()) } 
  $Is(d, Tclass.MapSpec.Constants()) ==> MapSpec.Constants.Constants_q(d));

// Datatype extensional equality declaration
function MapSpec.Constants#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MapSpec.Constants.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Constants#Equal(a, b) } 
  true ==> (MapSpec.Constants#Equal(a, b) <==> true));

// Datatype extensionality axiom: MapSpec.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Constants#Equal(a, b) } 
  MapSpec.Constants#Equal(a, b) <==> a == b);

const unique class.MapSpec.Constants: ClassName;

// Constructor function declaration
function #MapSpec.Variables.Variables(IMap Box Box) : DatatypeType;

const unique ##MapSpec.Variables.Variables: DtCtorId;

// Constructor identifier
axiom (forall a#109#0#0: IMap Box Box :: 
  { #MapSpec.Variables.Variables(a#109#0#0) } 
  DatatypeCtorId(#MapSpec.Variables.Variables(a#109#0#0))
     == ##MapSpec.Variables.Variables);

function MapSpec.Variables.Variables_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Variables.Variables_q(d) } 
  MapSpec.Variables.Variables_q(d)
     <==> DatatypeCtorId(d) == ##MapSpec.Variables.Variables);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Variables.Variables_q(d) } 
  MapSpec.Variables.Variables_q(d)
     ==> (exists a#110#0#0: IMap Box Box :: d == #MapSpec.Variables.Variables(a#110#0#0)));

function Tclass.MapSpec.Variables() : Ty;

// Tclass.MapSpec.Variables Tag
axiom Tag(Tclass.MapSpec.Variables()) == Tagclass.MapSpec.Variables;

const unique Tagclass.MapSpec.Variables: TyTag;

// Box/unbox axiom for Tclass.MapSpec.Variables
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MapSpec.Variables()) } 
  $IsBox(bx, Tclass.MapSpec.Variables())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MapSpec.Variables()));

// Constructor $Is
axiom (forall a#111#0#0: IMap Box Box :: 
  { $Is(#MapSpec.Variables.Variables(a#111#0#0), Tclass.MapSpec.Variables()) } 
  $Is(#MapSpec.Variables.Variables(a#111#0#0), Tclass.MapSpec.Variables())
     <==> $Is(a#111#0#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value())));

// Constructor $IsAlloc
axiom (forall a#112#0#0: IMap Box Box, $h: Heap :: 
  { $IsAlloc(#MapSpec.Variables.Variables(a#112#0#0), Tclass.MapSpec.Variables(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MapSpec.Variables.Variables(a#112#0#0), Tclass.MapSpec.Variables(), $h)
       <==> $IsAlloc(a#112#0#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Variables.view(d), 
      TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Variables(), $h)
     ==> $IsAlloc(MapSpec.Variables.view(d), 
      TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()), 
      $h));

// Constructor literal
axiom (forall a#113#0#0: IMap Box Box :: 
  { #MapSpec.Variables.Variables(Lit(a#113#0#0)) } 
  #MapSpec.Variables.Variables(Lit(a#113#0#0))
     == Lit(#MapSpec.Variables.Variables(a#113#0#0)));

function MapSpec.Variables.view(DatatypeType) : IMap Box Box;

// Constructor injectivity
axiom (forall a#114#0#0: IMap Box Box :: 
  { #MapSpec.Variables.Variables(a#114#0#0) } 
  MapSpec.Variables.view(#MapSpec.Variables.Variables(a#114#0#0)) == a#114#0#0);

// Inductive map key rank
axiom (forall a#115#0#0: IMap Box Box, d: DatatypeType :: 
  { IMap#Domain(a#115#0#0)[$Box(d)], #MapSpec.Variables.Variables(a#115#0#0) } 
  IMap#Domain(a#115#0#0)[$Box(d)]
     ==> DtRank(d) < DtRank(#MapSpec.Variables.Variables(a#115#0#0)));

// Inductive map value rank
axiom (forall a#116#0#0: IMap Box Box, bx: Box :: 
  { IMap#Domain(a#116#0#0)[bx], #MapSpec.Variables.Variables(a#116#0#0) } 
  IMap#Domain(a#116#0#0)[bx]
     ==> DtRank($Unbox(IMap#Elements(a#116#0#0)[bx]): DatatypeType)
       < DtRank(#MapSpec.Variables.Variables(a#116#0#0)));

// Depth-one case-split function
function $IsA#MapSpec.Variables(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MapSpec.Variables(d) } 
  $IsA#MapSpec.Variables(d) ==> MapSpec.Variables.Variables_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { MapSpec.Variables.Variables_q(d), $Is(d, Tclass.MapSpec.Variables()) } 
  $Is(d, Tclass.MapSpec.Variables()) ==> MapSpec.Variables.Variables_q(d));

// Datatype extensional equality declaration
function MapSpec.Variables#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MapSpec.Variables.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Variables#Equal(a, b) } 
  true
     ==> (MapSpec.Variables#Equal(a, b)
       <==> IMap#Equal(MapSpec.Variables.view(a), MapSpec.Variables.view(b))));

// Datatype extensionality axiom: MapSpec.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Variables#Equal(a, b) } 
  MapSpec.Variables#Equal(a, b) <==> a == b);

const unique class.MapSpec.Variables: ClassName;

// Constructor function declaration
function #MapSpec.Step.QueryStep(Seq Box, Seq Box) : DatatypeType;

const unique ##MapSpec.Step.QueryStep: DtCtorId;

// Constructor identifier
axiom (forall a#117#0#0: Seq Box, a#117#1#0: Seq Box :: 
  { #MapSpec.Step.QueryStep(a#117#0#0, a#117#1#0) } 
  DatatypeCtorId(#MapSpec.Step.QueryStep(a#117#0#0, a#117#1#0))
     == ##MapSpec.Step.QueryStep);

function MapSpec.Step.QueryStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.QueryStep_q(d) } 
  MapSpec.Step.QueryStep_q(d) <==> DatatypeCtorId(d) == ##MapSpec.Step.QueryStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.QueryStep_q(d) } 
  MapSpec.Step.QueryStep_q(d)
     ==> (exists a#118#0#0: Seq Box, a#118#1#0: Seq Box :: 
      d == #MapSpec.Step.QueryStep(a#118#0#0, a#118#1#0)));

function Tclass.MapSpec.Step() : Ty;

// Tclass.MapSpec.Step Tag
axiom Tag(Tclass.MapSpec.Step()) == Tagclass.MapSpec.Step;

const unique Tagclass.MapSpec.Step: TyTag;

// Box/unbox axiom for Tclass.MapSpec.Step
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MapSpec.Step()) } 
  $IsBox(bx, Tclass.MapSpec.Step())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MapSpec.Step()));

// Constructor $Is
axiom (forall a#119#0#0: Seq Box, a#119#1#0: Seq Box :: 
  { $Is(#MapSpec.Step.QueryStep(a#119#0#0, a#119#1#0), Tclass.MapSpec.Step()) } 
  $Is(#MapSpec.Step.QueryStep(a#119#0#0, a#119#1#0), Tclass.MapSpec.Step())
     <==> $Is(a#119#0#0, Tclass.KeyType.Key()) && $Is(a#119#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#120#0#0: Seq Box, a#120#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#MapSpec.Step.QueryStep(a#120#0#0, a#120#1#0), Tclass.MapSpec.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MapSpec.Step.QueryStep(a#120#0#0, a#120#1#0), Tclass.MapSpec.Step(), $h)
       <==> $IsAlloc(a#120#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#120#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.QueryStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.result(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.QueryStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.result(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#121#0#0: Seq Box, a#121#1#0: Seq Box :: 
  { #MapSpec.Step.QueryStep(Lit(a#121#0#0), Lit(a#121#1#0)) } 
  #MapSpec.Step.QueryStep(Lit(a#121#0#0), Lit(a#121#1#0))
     == Lit(#MapSpec.Step.QueryStep(a#121#0#0, a#121#1#0)));

function MapSpec.Step.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#122#0#0: Seq Box, a#122#1#0: Seq Box :: 
  { #MapSpec.Step.QueryStep(a#122#0#0, a#122#1#0) } 
  MapSpec.Step.key(#MapSpec.Step.QueryStep(a#122#0#0, a#122#1#0)) == a#122#0#0);

function MapSpec.Step.result(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#123#0#0: Seq Box, a#123#1#0: Seq Box :: 
  { #MapSpec.Step.QueryStep(a#123#0#0, a#123#1#0) } 
  MapSpec.Step.result(#MapSpec.Step.QueryStep(a#123#0#0, a#123#1#0)) == a#123#1#0);

// Constructor function declaration
function #MapSpec.Step.WriteStep(Seq Box, Seq Box) : DatatypeType;

const unique ##MapSpec.Step.WriteStep: DtCtorId;

// Constructor identifier
axiom (forall a#124#0#0: Seq Box, a#124#1#0: Seq Box :: 
  { #MapSpec.Step.WriteStep(a#124#0#0, a#124#1#0) } 
  DatatypeCtorId(#MapSpec.Step.WriteStep(a#124#0#0, a#124#1#0))
     == ##MapSpec.Step.WriteStep);

function MapSpec.Step.WriteStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.WriteStep_q(d) } 
  MapSpec.Step.WriteStep_q(d) <==> DatatypeCtorId(d) == ##MapSpec.Step.WriteStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.WriteStep_q(d) } 
  MapSpec.Step.WriteStep_q(d)
     ==> (exists a#125#0#0: Seq Box, a#125#1#0: Seq Box :: 
      d == #MapSpec.Step.WriteStep(a#125#0#0, a#125#1#0)));

// Constructor $Is
axiom (forall a#126#0#0: Seq Box, a#126#1#0: Seq Box :: 
  { $Is(#MapSpec.Step.WriteStep(a#126#0#0, a#126#1#0), Tclass.MapSpec.Step()) } 
  $Is(#MapSpec.Step.WriteStep(a#126#0#0, a#126#1#0), Tclass.MapSpec.Step())
     <==> $Is(a#126#0#0, Tclass.KeyType.Key()) && $Is(a#126#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#127#0#0: Seq Box, a#127#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#MapSpec.Step.WriteStep(a#127#0#0, a#127#1#0), Tclass.MapSpec.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MapSpec.Step.WriteStep(a#127#0#0, a#127#1#0), Tclass.MapSpec.Step(), $h)
       <==> $IsAlloc(a#127#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#127#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.WriteStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.new__value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.WriteStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.new__value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#128#0#0: Seq Box, a#128#1#0: Seq Box :: 
  { #MapSpec.Step.WriteStep(Lit(a#128#0#0), Lit(a#128#1#0)) } 
  #MapSpec.Step.WriteStep(Lit(a#128#0#0), Lit(a#128#1#0))
     == Lit(#MapSpec.Step.WriteStep(a#128#0#0, a#128#1#0)));

// Constructor injectivity
axiom (forall a#129#0#0: Seq Box, a#129#1#0: Seq Box :: 
  { #MapSpec.Step.WriteStep(a#129#0#0, a#129#1#0) } 
  MapSpec.Step.key(#MapSpec.Step.WriteStep(a#129#0#0, a#129#1#0)) == a#129#0#0);

function MapSpec.Step.new__value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#130#0#0: Seq Box, a#130#1#0: Seq Box :: 
  { #MapSpec.Step.WriteStep(a#130#0#0, a#130#1#0) } 
  MapSpec.Step.new__value(#MapSpec.Step.WriteStep(a#130#0#0, a#130#1#0))
     == a#130#1#0);

// Constructor function declaration
function #MapSpec.Step.SuccStep(DatatypeType, Seq Box, DatatypeType) : DatatypeType;

const unique ##MapSpec.Step.SuccStep: DtCtorId;

// Constructor identifier
axiom (forall a#131#0#0: DatatypeType, a#131#1#0: Seq Box, a#131#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#131#0#0, a#131#1#0, a#131#2#0) } 
  DatatypeCtorId(#MapSpec.Step.SuccStep(a#131#0#0, a#131#1#0, a#131#2#0))
     == ##MapSpec.Step.SuccStep);

function MapSpec.Step.SuccStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.SuccStep_q(d) } 
  MapSpec.Step.SuccStep_q(d) <==> DatatypeCtorId(d) == ##MapSpec.Step.SuccStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.SuccStep_q(d) } 
  MapSpec.Step.SuccStep_q(d)
     ==> (exists a#132#0#0: DatatypeType, a#132#1#0: Seq Box, a#132#2#0: DatatypeType :: 
      d == #MapSpec.Step.SuccStep(a#132#0#0, a#132#1#0, a#132#2#0)));

// Constructor $Is
axiom (forall a#133#0#0: DatatypeType, a#133#1#0: Seq Box, a#133#2#0: DatatypeType :: 
  { $Is(#MapSpec.Step.SuccStep(a#133#0#0, a#133#1#0, a#133#2#0), Tclass.MapSpec.Step()) } 
  $Is(#MapSpec.Step.SuccStep(a#133#0#0, a#133#1#0, a#133#2#0), Tclass.MapSpec.Step())
     <==> $Is(a#133#0#0, Tclass.UI.RangeStart())
       && $Is(a#133#1#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#133#2#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#134#0#0: DatatypeType, a#134#1#0: Seq Box, a#134#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#MapSpec.Step.SuccStep(a#134#0#0, a#134#1#0, a#134#2#0), 
      Tclass.MapSpec.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MapSpec.Step.SuccStep(a#134#0#0, a#134#1#0, a#134#2#0), 
        Tclass.MapSpec.Step(), 
        $h)
       <==> $IsAlloc(a#134#0#0, Tclass.UI.RangeStart(), $h)
         && $IsAlloc(a#134#1#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#134#2#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.start(d), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.SuccStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.start(d), Tclass.UI.RangeStart(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.SuccStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.SuccStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#135#0#0: DatatypeType, a#135#1#0: Seq Box, a#135#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(Lit(a#135#0#0), Lit(a#135#1#0), Lit(a#135#2#0)) } 
  #MapSpec.Step.SuccStep(Lit(a#135#0#0), Lit(a#135#1#0), Lit(a#135#2#0))
     == Lit(#MapSpec.Step.SuccStep(a#135#0#0, a#135#1#0, a#135#2#0)));

function MapSpec.Step.start(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#136#0#0: DatatypeType, a#136#1#0: Seq Box, a#136#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#136#0#0, a#136#1#0, a#136#2#0) } 
  MapSpec.Step.start(#MapSpec.Step.SuccStep(a#136#0#0, a#136#1#0, a#136#2#0))
     == a#136#0#0);

// Inductive rank
axiom (forall a#137#0#0: DatatypeType, a#137#1#0: Seq Box, a#137#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#137#0#0, a#137#1#0, a#137#2#0) } 
  DtRank(a#137#0#0)
     < DtRank(#MapSpec.Step.SuccStep(a#137#0#0, a#137#1#0, a#137#2#0)));

function MapSpec.Step.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#138#0#0: DatatypeType, a#138#1#0: Seq Box, a#138#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#138#0#0, a#138#1#0, a#138#2#0) } 
  MapSpec.Step.results(#MapSpec.Step.SuccStep(a#138#0#0, a#138#1#0, a#138#2#0))
     == a#138#1#0);

// Inductive seq element rank
axiom (forall a#139#0#0: DatatypeType, a#139#1#0: Seq Box, a#139#2#0: DatatypeType, i: int :: 
  { Seq#Index(a#139#1#0, i), #MapSpec.Step.SuccStep(a#139#0#0, a#139#1#0, a#139#2#0) } 
  0 <= i && i < Seq#Length(a#139#1#0)
     ==> DtRank($Unbox(Seq#Index(a#139#1#0, i)): DatatypeType)
       < DtRank(#MapSpec.Step.SuccStep(a#139#0#0, a#139#1#0, a#139#2#0)));

// Inductive seq rank
axiom (forall a#140#0#0: DatatypeType, a#140#1#0: Seq Box, a#140#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#140#0#0, a#140#1#0, a#140#2#0) } 
  Seq#Rank(a#140#1#0)
     < DtRank(#MapSpec.Step.SuccStep(a#140#0#0, a#140#1#0, a#140#2#0)));

function MapSpec.Step.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#141#0#0: DatatypeType, a#141#1#0: Seq Box, a#141#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#141#0#0, a#141#1#0, a#141#2#0) } 
  MapSpec.Step.end(#MapSpec.Step.SuccStep(a#141#0#0, a#141#1#0, a#141#2#0))
     == a#141#2#0);

// Inductive rank
axiom (forall a#142#0#0: DatatypeType, a#142#1#0: Seq Box, a#142#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#142#0#0, a#142#1#0, a#142#2#0) } 
  DtRank(a#142#2#0)
     < DtRank(#MapSpec.Step.SuccStep(a#142#0#0, a#142#1#0, a#142#2#0)));

// Constructor function declaration
function #MapSpec.Step.StutterStep() : DatatypeType;

const unique ##MapSpec.Step.StutterStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#MapSpec.Step.StutterStep()) == ##MapSpec.Step.StutterStep;

function MapSpec.Step.StutterStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.StutterStep_q(d) } 
  MapSpec.Step.StutterStep_q(d)
     <==> DatatypeCtorId(d) == ##MapSpec.Step.StutterStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.StutterStep_q(d) } 
  MapSpec.Step.StutterStep_q(d) ==> d == #MapSpec.Step.StutterStep());

// Constructor $Is
axiom $Is(#MapSpec.Step.StutterStep(), Tclass.MapSpec.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#MapSpec.Step.StutterStep(), Tclass.MapSpec.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#MapSpec.Step.StutterStep(), Tclass.MapSpec.Step(), $h));

// Constructor literal
axiom #MapSpec.Step.StutterStep() == Lit(#MapSpec.Step.StutterStep());

// Depth-one case-split function
function $IsA#MapSpec.Step(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MapSpec.Step(d) } 
  $IsA#MapSpec.Step(d)
     ==> MapSpec.Step.QueryStep_q(d)
       || MapSpec.Step.WriteStep_q(d)
       || MapSpec.Step.SuccStep_q(d)
       || MapSpec.Step.StutterStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.StutterStep_q(d), $Is(d, Tclass.MapSpec.Step()) } 
    { MapSpec.Step.SuccStep_q(d), $Is(d, Tclass.MapSpec.Step()) } 
    { MapSpec.Step.WriteStep_q(d), $Is(d, Tclass.MapSpec.Step()) } 
    { MapSpec.Step.QueryStep_q(d), $Is(d, Tclass.MapSpec.Step()) } 
  $Is(d, Tclass.MapSpec.Step())
     ==> MapSpec.Step.QueryStep_q(d)
       || MapSpec.Step.WriteStep_q(d)
       || MapSpec.Step.SuccStep_q(d)
       || MapSpec.Step.StutterStep_q(d));

// Datatype extensional equality declaration
function MapSpec.Step#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MapSpec.Step.QueryStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b), MapSpec.Step.QueryStep_q(a) } 
    { MapSpec.Step#Equal(a, b), MapSpec.Step.QueryStep_q(b) } 
  MapSpec.Step.QueryStep_q(a) && MapSpec.Step.QueryStep_q(b)
     ==> (MapSpec.Step#Equal(a, b)
       <==> Seq#Equal(MapSpec.Step.key(a), MapSpec.Step.key(b))
         && Seq#Equal(MapSpec.Step.result(a), MapSpec.Step.result(b))));

// Datatype extensional equality definition: #MapSpec.Step.WriteStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b), MapSpec.Step.WriteStep_q(a) } 
    { MapSpec.Step#Equal(a, b), MapSpec.Step.WriteStep_q(b) } 
  MapSpec.Step.WriteStep_q(a) && MapSpec.Step.WriteStep_q(b)
     ==> (MapSpec.Step#Equal(a, b)
       <==> Seq#Equal(MapSpec.Step.key(a), MapSpec.Step.key(b))
         && Seq#Equal(MapSpec.Step.new__value(a), MapSpec.Step.new__value(b))));

// Datatype extensional equality definition: #MapSpec.Step.SuccStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b), MapSpec.Step.SuccStep_q(a) } 
    { MapSpec.Step#Equal(a, b), MapSpec.Step.SuccStep_q(b) } 
  MapSpec.Step.SuccStep_q(a) && MapSpec.Step.SuccStep_q(b)
     ==> (MapSpec.Step#Equal(a, b)
       <==> UI.RangeStart#Equal(MapSpec.Step.start(a), MapSpec.Step.start(b))
         && Seq#Equal(MapSpec.Step.results(a), MapSpec.Step.results(b))
         && UI.RangeEnd#Equal(MapSpec.Step.end(a), MapSpec.Step.end(b))));

// Datatype extensional equality definition: #MapSpec.Step.StutterStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b), MapSpec.Step.StutterStep_q(a) } 
    { MapSpec.Step#Equal(a, b), MapSpec.Step.StutterStep_q(b) } 
  MapSpec.Step.StutterStep_q(a) && MapSpec.Step.StutterStep_q(b)
     ==> (MapSpec.Step#Equal(a, b) <==> true));

// Datatype extensionality axiom: MapSpec.Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b) } 
  MapSpec.Step#Equal(a, b) <==> a == b);

const unique class.MapSpec.Step: ClassName;

const unique class.MapSpec.__default: ClassName;

function Tclass.MapSpec.__default() : Ty;

// Tclass.MapSpec.__default Tag
axiom Tag(Tclass.MapSpec.__default()) == Tagclass.MapSpec.__default;

const unique Tagclass.MapSpec.__default: TyTag;

// Box/unbox axiom for Tclass.MapSpec.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MapSpec.__default()) } 
  $IsBox(bx, Tclass.MapSpec.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.MapSpec.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.MapSpec.__default()) } 
  $Is($o, Tclass.MapSpec.__default())
     <==> $o == null || dtype($o) == Tclass.MapSpec.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.MapSpec.__default(), $h) } 
  $IsAlloc($o, Tclass.MapSpec.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for MapSpec._default.EmptyValue
function MapSpec.__default.EmptyValue() : Seq Box;

function MapSpec.__default.EmptyValue#canCall() : bool;

// consequence axiom for MapSpec.__default.EmptyValue
axiom true ==> true ==> $Is(MapSpec.__default.EmptyValue(), Tclass.ValueType.Value());

function MapSpec.__default.EmptyValue#requires() : bool;

// #requires axiom for MapSpec.__default.EmptyValue
axiom MapSpec.__default.EmptyValue#requires() == true;

// definition axiom for MapSpec.__default.EmptyValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && MapSpec.__default.EmptyValue() == Lit(ValueType.__default.DefaultValue());

// definition axiom for MapSpec.__default.EmptyValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && MapSpec.__default.EmptyValue() == Lit(ValueType.__default.DefaultValue());

// function declaration for MapSpec._default.ViewComplete
function MapSpec.__default.ViewComplete(view#0: IMap Box Box) : bool;

function MapSpec.__default.ViewComplete#canCall(view#0: IMap Box Box) : bool;

// consequence axiom for MapSpec.__default.ViewComplete
axiom true
   ==> (forall view#0: IMap Box Box :: 
    { MapSpec.__default.ViewComplete(view#0) } 
    MapSpec.__default.ViewComplete#canCall(view#0)
         || $Is(view#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> true);

function MapSpec.__default.ViewComplete#requires(IMap Box Box) : bool;

// #requires axiom for MapSpec.__default.ViewComplete
axiom (forall view#0: IMap Box Box :: 
  { MapSpec.__default.ViewComplete#requires(view#0) } 
  $Is(view#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
     ==> MapSpec.__default.ViewComplete#requires(view#0) == true);

// definition axiom for MapSpec.__default.ViewComplete(revealed)
axiom true
   ==> (forall view#0: IMap Box Box :: 
    { MapSpec.__default.ViewComplete(view#0) } 
    MapSpec.__default.ViewComplete#canCall(view#0)
         || $Is(view#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> MapSpec.__default.ViewComplete(view#0)
         == (forall k#2: Seq Box :: 
          { IMap#Domain(view#0)[$Box(k#2)] } 
          $Is(k#2, Tclass.KeyType.Key()) ==> IMap#Domain(view#0)[$Box(k#2)]));

// definition axiom for MapSpec.__default.ViewComplete for all literals(revealed)
axiom true
   ==> (forall view#0: IMap Box Box :: 
    {:weight 3} { MapSpec.__default.ViewComplete(Lit(view#0)) } 
    MapSpec.__default.ViewComplete#canCall(Lit(view#0))
         || $Is(view#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> MapSpec.__default.ViewComplete(Lit(view#0))
         == (forall k#3: Seq Box :: 
          { IMap#Domain(view#0)[$Box(k#3)] } 
          $Is(k#3, Tclass.KeyType.Key()) ==> IMap#Domain(view#0)[$Box(k#3)]));

// function declaration for MapSpec._default.WF
function MapSpec.__default.WF(s#0: DatatypeType) : bool;

function MapSpec.__default.WF#canCall(s#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.WF
axiom true
   ==> (forall s#0: DatatypeType :: 
    { MapSpec.__default.WF(s#0) } 
    MapSpec.__default.WF#canCall(s#0) || $Is(s#0, Tclass.MapSpec.Variables())
       ==> true);

function MapSpec.__default.WF#requires(DatatypeType) : bool;

// #requires axiom for MapSpec.__default.WF
axiom (forall s#0: DatatypeType :: 
  { MapSpec.__default.WF#requires(s#0) } 
  $Is(s#0, Tclass.MapSpec.Variables())
     ==> MapSpec.__default.WF#requires(s#0) == true);

// definition axiom for MapSpec.__default.WF(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    { MapSpec.__default.WF(s#0) } 
    MapSpec.__default.WF#canCall(s#0) || $Is(s#0, Tclass.MapSpec.Variables())
       ==> (Lit(true)
           ==> MapSpec.Variables.Variables_q(s#0)
             && MapSpec.__default.ViewComplete#canCall(MapSpec.Variables.view(s#0)))
         && MapSpec.__default.WF(s#0)
           == (true && MapSpec.__default.ViewComplete(MapSpec.Variables.view(s#0))));

// definition axiom for MapSpec.__default.WF for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.WF(Lit(s#0)) } 
    MapSpec.__default.WF#canCall(Lit(s#0)) || $Is(s#0, Tclass.MapSpec.Variables())
       ==> (Lit(true)
           ==> MapSpec.Variables.Variables_q(Lit(s#0))
             && MapSpec.__default.ViewComplete#canCall(Lit(MapSpec.Variables.view(Lit(s#0)))))
         && MapSpec.__default.WF(Lit(s#0))
           == Lit(true && MapSpec.__default.ViewComplete(Lit(MapSpec.Variables.view(Lit(s#0))))));

// function declaration for MapSpec._default.InDomain
function MapSpec.__default.InDomain(k#0: Seq Box) : bool;

function MapSpec.__default.InDomain#canCall(k#0: Seq Box) : bool;

// consequence axiom for MapSpec.__default.InDomain
axiom true
   ==> (forall k#0: Seq Box :: 
    { MapSpec.__default.InDomain(k#0) } 
    MapSpec.__default.InDomain#canCall(k#0) || $Is(k#0, Tclass.KeyType.Key())
       ==> true);

function MapSpec.__default.InDomain#requires(Seq Box) : bool;

// #requires axiom for MapSpec.__default.InDomain
axiom (forall k#0: Seq Box :: 
  { MapSpec.__default.InDomain#requires(k#0) } 
  $Is(k#0, Tclass.KeyType.Key())
     ==> MapSpec.__default.InDomain#requires(k#0) == true);

// definition axiom for MapSpec.__default.InDomain(revealed)
axiom true
   ==> (forall k#0: Seq Box :: 
    { MapSpec.__default.InDomain(k#0) } 
    MapSpec.__default.InDomain#canCall(k#0) || $Is(k#0, Tclass.KeyType.Key())
       ==> MapSpec.__default.InDomain(k#0) == Lit(true));

// definition axiom for MapSpec.__default.InDomain for all literals(revealed)
axiom true
   ==> (forall k#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.InDomain(Lit(k#0)) } 
    MapSpec.__default.InDomain#canCall(Lit(k#0)) || $Is(k#0, Tclass.KeyType.Key())
       ==> MapSpec.__default.InDomain(Lit(k#0)) == Lit(true));

// function declaration for MapSpec._default.EmptyMap
function MapSpec.__default.EmptyMap() : IMap Box Box;

function MapSpec.__default.EmptyMap#canCall() : bool;

// consequence axiom for MapSpec.__default.EmptyMap
axiom true
   ==> 
  true
   ==> MapSpec.__default.ViewComplete(MapSpec.__default.EmptyMap())
     && $Is(MapSpec.__default.EmptyMap(), 
      TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()));

function MapSpec.__default.EmptyMap#requires() : bool;

// #requires axiom for MapSpec.__default.EmptyMap
axiom MapSpec.__default.EmptyMap#requires() == true;

// definition axiom for MapSpec.__default.EmptyMap(revealed)
axiom true
   ==> 
  true
   ==> (forall k#0: Seq Box :: 
      { MapSpec.__default.InDomain(k#0) } 
      $Is(k#0, Tclass.KeyType.Key())
         ==> MapSpec.__default.InDomain#canCall(k#0)
           && (MapSpec.__default.InDomain(k#0) ==> MapSpec.__default.EmptyValue#canCall()))
     && MapSpec.__default.EmptyMap()
       == IMap#Glue((lambda $w#2: Box :: 
          $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
             && MapSpec.__default.InDomain($Unbox($w#2): Seq Box)), 
        (lambda $w#2: Box :: $Box(Lit(MapSpec.__default.EmptyValue()))), 
        TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()));

// definition axiom for MapSpec.__default.EmptyMap for all literals(revealed)
axiom true
   ==> 
  true
   ==> (forall k#0: Seq Box :: 
      { MapSpec.__default.InDomain(k#0) } 
      $Is(k#0, Tclass.KeyType.Key())
         ==> MapSpec.__default.InDomain#canCall(k#0)
           && (MapSpec.__default.InDomain(k#0) ==> MapSpec.__default.EmptyValue#canCall()))
     && MapSpec.__default.EmptyMap()
       == IMap#Glue((lambda $w#3: Box :: 
          $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
             && MapSpec.__default.InDomain($Unbox($w#3): Seq Box)), 
        (lambda $w#3: Box :: $Box(Lit(MapSpec.__default.EmptyValue()))), 
        TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()));

// function declaration for MapSpec._default.Init
function MapSpec.__default.Init(k#0: DatatypeType, s#0: DatatypeType) : bool;

function MapSpec.__default.Init#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.Init
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { MapSpec.__default.Init(k#0, s#0) } 
    MapSpec.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> 
      MapSpec.__default.Init(k#0, s#0)
       ==> MapSpec.__default.WF(s#0));

function MapSpec.__default.Init#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.Init
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { MapSpec.__default.Init#requires(k#0, s#0) } 
  $Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables())
     ==> MapSpec.__default.Init#requires(k#0, s#0) == true);

// definition axiom for MapSpec.__default.Init(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { MapSpec.__default.Init(k#0, s#0) } 
    MapSpec.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> $IsA#MapSpec.Variables(s#0)
         && MapSpec.__default.EmptyMap#canCall()
         && MapSpec.__default.Init(k#0, s#0)
           == MapSpec.Variables#Equal(s#0, #MapSpec.Variables.Variables(Lit(MapSpec.__default.EmptyMap()))));

// definition axiom for MapSpec.__default.Init for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Init(Lit(k#0), Lit(s#0)) } 
    MapSpec.__default.Init#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> $IsA#MapSpec.Variables(Lit(s#0))
         && MapSpec.__default.EmptyMap#canCall()
         && MapSpec.__default.Init(Lit(k#0), Lit(s#0))
           == MapSpec.Variables#Equal(s#0, #MapSpec.Variables.Variables(Lit(MapSpec.__default.EmptyMap()))));

// function declaration for MapSpec._default.Query
function MapSpec.__default.Query(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    result#0: Seq Box)
   : bool;

function MapSpec.__default.Query#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    result#0: Seq Box)
   : bool;

// consequence axiom for MapSpec.__default.Query
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      result#0: Seq Box :: 
    { MapSpec.__default.Query(k#0, s#0, s'#0, uiop#0, key#0, result#0) } 
    MapSpec.__default.Query#canCall(k#0, s#0, s'#0, uiop#0, key#0, result#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(result#0, Tclass.ValueType.Value()))
       ==> true);

function MapSpec.__default.Query#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for MapSpec.__default.Query
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    result#0: Seq Box :: 
  { MapSpec.__default.Query#requires(k#0, s#0, s'#0, uiop#0, key#0, result#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(result#0, Tclass.ValueType.Value())
     ==> MapSpec.__default.Query#requires(k#0, s#0, s'#0, uiop#0, key#0, result#0)
       == true);

// definition axiom for MapSpec.__default.Query(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      result#0: Seq Box :: 
    { MapSpec.__default.Query(k#0, s#0, s'#0, uiop#0, key#0, result#0) } 
    MapSpec.__default.Query#canCall(k#0, s#0, s'#0, uiop#0, key#0, result#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(result#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(uiop#0)
         && (UI.Op#Equal(uiop#0, #UI.Op.GetOp(key#0, result#0))
           ==> MapSpec.__default.WF#canCall(s#0))
         && (MapSpec.__default.WF#canCall(s#0) && MapSpec.__default.WF(s#0)
           ==> MapSpec.Variables.Variables_q(s#0))
         && (MapSpec.Variables.Variables_q(s#0)
             && result#0
               == $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#0)]): Seq Box
           ==> $IsA#MapSpec.Variables(s'#0) && $IsA#MapSpec.Variables(s#0))
         && MapSpec.__default.Query(k#0, s#0, s'#0, uiop#0, key#0, result#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.GetOp(key#0, result#0))
             && MapSpec.__default.WF(s#0)
             && result#0
               == $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#0)]): Seq Box
             && MapSpec.Variables#Equal(s'#0, s#0)));

// definition axiom for MapSpec.__default.Query for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      result#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), result#0) } 
    MapSpec.__default.Query#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), result#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(result#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.GetOp(Lit(key#0), result#0))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> MapSpec.Variables.Variables_q(Lit(s#0)))
         && (MapSpec.Variables.Variables_q(Lit(s#0))
             && result#0
               == $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(Lit(key#0))]): Seq Box
           ==> $IsA#MapSpec.Variables(Lit(s'#0)) && $IsA#MapSpec.Variables(Lit(s#0)))
         && MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), result#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.GetOp(Lit(key#0), result#0))
             && MapSpec.__default.WF(Lit(s#0))
             && result#0
               == $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(Lit(key#0))]): Seq Box
             && MapSpec.Variables#Equal(s'#0, s#0)));

// definition axiom for MapSpec.__default.Query for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      result#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(result#0)) } 
    MapSpec.__default.Query#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(result#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(result#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.GetOp(Lit(key#0), Lit(result#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> MapSpec.Variables.Variables_q(Lit(s#0)))
         && (MapSpec.Variables.Variables_q(Lit(s#0))
             && Lit(result#0)
               == $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(Lit(key#0))]): Seq Box
           ==> $IsA#MapSpec.Variables(Lit(s'#0)) && $IsA#MapSpec.Variables(Lit(s#0)))
         && MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(result#0))
           == (
            UI.Op#Equal(uiop#0, #UI.Op.GetOp(Lit(key#0), Lit(result#0)))
             && MapSpec.__default.WF(Lit(s#0))
             && Lit(result#0)
               == $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(Lit(key#0))]): Seq Box
             && MapSpec.Variables#Equal(s'#0, s#0)));

// function declaration for MapSpec._default.LowerBound
function MapSpec.__default.LowerBound(start#0: DatatypeType, key#0: Seq Box) : bool;

function MapSpec.__default.LowerBound#canCall(start#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for MapSpec.__default.LowerBound
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box :: 
    { MapSpec.__default.LowerBound(start#0, key#0) } 
    MapSpec.__default.LowerBound#canCall(start#0, key#0)
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> true);

function MapSpec.__default.LowerBound#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for MapSpec.__default.LowerBound
axiom (forall start#0: DatatypeType, key#0: Seq Box :: 
  { MapSpec.__default.LowerBound#requires(start#0, key#0) } 
  $Is(start#0, Tclass.UI.RangeStart()) && $Is(key#0, Tclass.KeyType.Key())
     ==> MapSpec.__default.LowerBound#requires(start#0, key#0) == true);

// definition axiom for MapSpec.__default.LowerBound(revealed)
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box :: 
    { MapSpec.__default.LowerBound(start#0, key#0) } 
    MapSpec.__default.LowerBound#canCall(start#0, key#0)
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (UI.RangeStart.SInclusive_q(start#0)
           ==> SeqComparison.__default.lte#canCall(UI.RangeStart.key(start#0), key#0))
         && (SeqComparison.__default.lte#canCall(UI.RangeStart.key(start#0), key#0)
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, UI.RangeStart.key(start#0), key#0)
           ==> 
          UI.RangeStart.SExclusive_q(start#0)
           ==> SeqComparison.__default.lt#canCall(UI.RangeStart.key(start#0), key#0))
         && MapSpec.__default.LowerBound(start#0, key#0)
           == ((UI.RangeStart.SInclusive_q(start#0)
               ==> SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, UI.RangeStart.key(start#0), key#0))
             && (UI.RangeStart.SExclusive_q(start#0)
               ==> SeqComparison.__default.lt(UI.RangeStart.key(start#0), key#0))));

// definition axiom for MapSpec.__default.LowerBound for all literals(revealed)
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.LowerBound(Lit(start#0), Lit(key#0)) } 
    MapSpec.__default.LowerBound#canCall(Lit(start#0), Lit(key#0))
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Lit(UI.RangeStart.SInclusive_q(Lit(start#0)))
           ==> SeqComparison.__default.lte#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(key#0)))
         && (SeqComparison.__default.lte#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(key#0))
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
              Lit(UI.RangeStart.key(Lit(start#0))), 
              Lit(key#0))
           ==> 
          Lit(UI.RangeStart.SExclusive_q(Lit(start#0)))
           ==> SeqComparison.__default.lt#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(key#0)))
         && MapSpec.__default.LowerBound(Lit(start#0), Lit(key#0))
           == ((UI.RangeStart.SInclusive_q(Lit(start#0))
               ==> SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
                Lit(UI.RangeStart.key(Lit(start#0))), 
                Lit(key#0)))
             && (UI.RangeStart.SExclusive_q(Lit(start#0))
               ==> SeqComparison.__default.lt(Lit(UI.RangeStart.key(Lit(start#0))), Lit(key#0)))));

// function declaration for MapSpec._default.UpperBound
function MapSpec.__default.UpperBound(key#0: Seq Box, end#0: DatatypeType) : bool;

function MapSpec.__default.UpperBound#canCall(key#0: Seq Box, end#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.UpperBound
axiom true
   ==> (forall key#0: Seq Box, end#0: DatatypeType :: 
    { MapSpec.__default.UpperBound(key#0, end#0) } 
    MapSpec.__default.UpperBound#canCall(key#0, end#0)
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> true);

function MapSpec.__default.UpperBound#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.UpperBound
axiom (forall key#0: Seq Box, end#0: DatatypeType :: 
  { MapSpec.__default.UpperBound#requires(key#0, end#0) } 
  $Is(key#0, Tclass.KeyType.Key()) && $Is(end#0, Tclass.UI.RangeEnd())
     ==> MapSpec.__default.UpperBound#requires(key#0, end#0) == true);

// definition axiom for MapSpec.__default.UpperBound(revealed)
axiom true
   ==> (forall key#0: Seq Box, end#0: DatatypeType :: 
    { MapSpec.__default.UpperBound(key#0, end#0) } 
    MapSpec.__default.UpperBound#canCall(key#0, end#0)
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (UI.RangeEnd.EInclusive_q(end#0)
           ==> SeqComparison.__default.lte#canCall(key#0, UI.RangeEnd.key(end#0)))
         && (SeqComparison.__default.lte#canCall(key#0, UI.RangeEnd.key(end#0))
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, key#0, UI.RangeEnd.key(end#0))
           ==> 
          UI.RangeEnd.EExclusive_q(end#0)
           ==> SeqComparison.__default.lt#canCall(key#0, UI.RangeEnd.key(end#0)))
         && MapSpec.__default.UpperBound(key#0, end#0)
           == ((UI.RangeEnd.EInclusive_q(end#0)
               ==> SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, key#0, UI.RangeEnd.key(end#0)))
             && (UI.RangeEnd.EExclusive_q(end#0)
               ==> SeqComparison.__default.lt(key#0, UI.RangeEnd.key(end#0)))));

// definition axiom for MapSpec.__default.UpperBound for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box, end#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.UpperBound(Lit(key#0), Lit(end#0)) } 
    MapSpec.__default.UpperBound#canCall(Lit(key#0), Lit(end#0))
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (Lit(UI.RangeEnd.EInclusive_q(Lit(end#0)))
           ==> SeqComparison.__default.lte#canCall(Lit(key#0), Lit(UI.RangeEnd.key(Lit(end#0)))))
         && (SeqComparison.__default.lte#canCall(Lit(key#0), Lit(UI.RangeEnd.key(Lit(end#0))))
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
              Lit(key#0), 
              Lit(UI.RangeEnd.key(Lit(end#0))))
           ==> 
          Lit(UI.RangeEnd.EExclusive_q(Lit(end#0)))
           ==> SeqComparison.__default.lt#canCall(Lit(key#0), Lit(UI.RangeEnd.key(Lit(end#0)))))
         && MapSpec.__default.UpperBound(Lit(key#0), Lit(end#0))
           == ((UI.RangeEnd.EInclusive_q(Lit(end#0))
               ==> SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
                Lit(key#0), 
                Lit(UI.RangeEnd.key(Lit(end#0)))))
             && (UI.RangeEnd.EExclusive_q(Lit(end#0))
               ==> SeqComparison.__default.lt(Lit(key#0), Lit(UI.RangeEnd.key(Lit(end#0)))))));

// function declaration for MapSpec._default.InRange
function MapSpec.__default.InRange(start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType) : bool;

function MapSpec.__default.InRange#canCall(start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.InRange
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType :: 
    { MapSpec.__default.InRange(start#0, key#0, end#0) } 
    MapSpec.__default.InRange#canCall(start#0, key#0, end#0)
         || (
          $Is(start#0, Tclass.UI.RangeStart())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> true);

function MapSpec.__default.InRange#requires(DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.InRange
axiom (forall start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType :: 
  { MapSpec.__default.InRange#requires(start#0, key#0, end#0) } 
  $Is(start#0, Tclass.UI.RangeStart())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(end#0, Tclass.UI.RangeEnd())
     ==> MapSpec.__default.InRange#requires(start#0, key#0, end#0) == true);

// definition axiom for MapSpec.__default.InRange(revealed)
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType :: 
    { MapSpec.__default.InRange(start#0, key#0, end#0) } 
    MapSpec.__default.InRange#canCall(start#0, key#0, end#0)
         || (
          $Is(start#0, Tclass.UI.RangeStart())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> MapSpec.__default.LowerBound#canCall(start#0, key#0)
         && (MapSpec.__default.LowerBound(start#0, key#0)
           ==> MapSpec.__default.UpperBound#canCall(key#0, end#0))
         && MapSpec.__default.InRange(start#0, key#0, end#0)
           == (MapSpec.__default.LowerBound(start#0, key#0)
             && MapSpec.__default.UpperBound(key#0, end#0)));

// definition axiom for MapSpec.__default.InRange for all literals(revealed)
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.InRange(Lit(start#0), Lit(key#0), Lit(end#0)) } 
    MapSpec.__default.InRange#canCall(Lit(start#0), Lit(key#0), Lit(end#0))
         || (
          $Is(start#0, Tclass.UI.RangeStart())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> MapSpec.__default.LowerBound#canCall(Lit(start#0), Lit(key#0))
         && (Lit(MapSpec.__default.LowerBound(Lit(start#0), Lit(key#0)))
           ==> MapSpec.__default.UpperBound#canCall(Lit(key#0), Lit(end#0)))
         && MapSpec.__default.InRange(Lit(start#0), Lit(key#0), Lit(end#0))
           == Lit(MapSpec.__default.LowerBound(Lit(start#0), Lit(key#0))
               && MapSpec.__default.UpperBound(Lit(key#0), Lit(end#0))));

// function declaration for MapSpec._default.NonEmptyRange
function MapSpec.__default.NonEmptyRange(start#0: DatatypeType, end#0: DatatypeType) : bool;

function MapSpec.__default.NonEmptyRange#canCall(start#0: DatatypeType, end#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.NonEmptyRange
axiom true
   ==> (forall start#0: DatatypeType, end#0: DatatypeType :: 
    { MapSpec.__default.NonEmptyRange(start#0, end#0) } 
    MapSpec.__default.NonEmptyRange#canCall(start#0, end#0)
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> true);

function MapSpec.__default.NonEmptyRange#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.NonEmptyRange
axiom (forall start#0: DatatypeType, end#0: DatatypeType :: 
  { MapSpec.__default.NonEmptyRange#requires(start#0, end#0) } 
  $Is(start#0, Tclass.UI.RangeStart()) && $Is(end#0, Tclass.UI.RangeEnd())
     ==> MapSpec.__default.NonEmptyRange#requires(start#0, end#0) == true);

// definition axiom for MapSpec.__default.NonEmptyRange(revealed)
axiom true
   ==> (forall start#0: DatatypeType, end#0: DatatypeType :: 
    { MapSpec.__default.NonEmptyRange(start#0, end#0) } 
    MapSpec.__default.NonEmptyRange#canCall(start#0, end#0)
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (!UI.RangeEnd.PositiveInf_q(end#0)
           ==> 
          UI.RangeEnd.EInclusive_q(end#0)
           ==> SeqComparison.__default.lte#canCall(UI.RangeStart.key(start#0), UI.RangeEnd.key(end#0)))
         && ((UI.RangeEnd.EInclusive_q(end#0)
               ==> SeqComparison.__default.lte#canCall(UI.RangeStart.key(start#0), UI.RangeEnd.key(end#0)))
             && !
            (
            UI.RangeStart.SInclusive_q(start#0)
             && UI.RangeEnd.EInclusive_q(end#0)
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
              UI.RangeStart.key(start#0), 
              UI.RangeEnd.key(end#0)))
           ==> SeqComparison.__default.lt#canCall(UI.RangeStart.key(start#0), UI.RangeEnd.key(end#0)))
         && MapSpec.__default.NonEmptyRange(start#0, end#0)
           == (
            UI.RangeStart.NegativeInf_q(start#0)
             || UI.RangeEnd.PositiveInf_q(end#0)
             || (
              UI.RangeStart.SInclusive_q(start#0)
               && UI.RangeEnd.EInclusive_q(end#0)
               && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
                UI.RangeStart.key(start#0), 
                UI.RangeEnd.key(end#0)))
             || SeqComparison.__default.lt(UI.RangeStart.key(start#0), UI.RangeEnd.key(end#0))));

// definition axiom for MapSpec.__default.NonEmptyRange for all literals(revealed)
axiom true
   ==> (forall start#0: DatatypeType, end#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.NonEmptyRange(Lit(start#0), Lit(end#0)) } 
    MapSpec.__default.NonEmptyRange#canCall(Lit(start#0), Lit(end#0))
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (!Lit(UI.RangeEnd.PositiveInf_q(Lit(end#0)))
           ==> 
          Lit(UI.RangeEnd.EInclusive_q(Lit(end#0)))
           ==> SeqComparison.__default.lte#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(UI.RangeEnd.key(Lit(end#0)))))
         && ((Lit(UI.RangeEnd.EInclusive_q(Lit(end#0)))
               ==> SeqComparison.__default.lte#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(UI.RangeEnd.key(Lit(end#0)))))
             && !
            (
            UI.RangeStart.SInclusive_q(Lit(start#0))
             && UI.RangeEnd.EInclusive_q(Lit(end#0))
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
              Lit(UI.RangeStart.key(Lit(start#0))), 
              Lit(UI.RangeEnd.key(Lit(end#0)))))
           ==> SeqComparison.__default.lt#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(UI.RangeEnd.key(Lit(end#0)))))
         && MapSpec.__default.NonEmptyRange(Lit(start#0), Lit(end#0))
           == (
            UI.RangeStart.NegativeInf_q(Lit(start#0))
             || UI.RangeEnd.PositiveInf_q(Lit(end#0))
             || (
              UI.RangeStart.SInclusive_q(Lit(start#0))
               && UI.RangeEnd.EInclusive_q(Lit(end#0))
               && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
                Lit(UI.RangeStart.key(Lit(start#0))), 
                Lit(UI.RangeEnd.key(Lit(end#0)))))
             || SeqComparison.__default.lt(Lit(UI.RangeStart.key(Lit(start#0))), Lit(UI.RangeEnd.key(Lit(end#0))))));

// function declaration for MapSpec._default.Succ
function MapSpec.__default.Succ(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    start#0: DatatypeType, 
    results#0: Seq Box, 
    end#0: DatatypeType)
   : bool;

function MapSpec.__default.Succ#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    start#0: DatatypeType, 
    results#0: Seq Box, 
    end#0: DatatypeType)
   : bool;

// consequence axiom for MapSpec.__default.Succ
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      start#0: DatatypeType, 
      results#0: Seq Box, 
      end#0: DatatypeType :: 
    { MapSpec.__default.Succ(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0) } 
    MapSpec.__default.Succ#canCall(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(results#0, TSeq(Tclass.UI.SuccResult()))
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> true);

function MapSpec.__default.Succ#requires(DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    Seq Box, 
    DatatypeType)
   : bool;

// #requires axiom for MapSpec.__default.Succ
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    start#0: DatatypeType, 
    results#0: Seq Box, 
    end#0: DatatypeType :: 
  { MapSpec.__default.Succ#requires(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
       && $Is(start#0, Tclass.UI.RangeStart())
       && $Is(results#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(end#0, Tclass.UI.RangeEnd())
     ==> MapSpec.__default.Succ#requires(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)
       == true);

// definition axiom for MapSpec.__default.Succ(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      start#0: DatatypeType, 
      results#0: Seq Box, 
      end#0: DatatypeType :: 
    { MapSpec.__default.Succ(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0) } 
    MapSpec.__default.Succ#canCall(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(results#0, TSeq(Tclass.UI.SuccResult()))
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> $IsA#UI.Op(uiop#0)
         && (UI.Op#Equal(uiop#0, #UI.Op.SuccOp(start#0, results#0, end#0))
           ==> MapSpec.__default.WF#canCall(s#0))
         && (MapSpec.__default.WF#canCall(s#0) && MapSpec.__default.WF(s#0)
           ==> $IsA#MapSpec.Variables(s'#0) && $IsA#MapSpec.Variables(s#0))
         && ($IsA#MapSpec.Variables(s'#0)
             && $IsA#MapSpec.Variables(s#0)
             && MapSpec.Variables#Equal(s'#0, s#0)
           ==> MapSpec.__default.NonEmptyRange#canCall(start#0, end#0))
         && (MapSpec.__default.NonEmptyRange#canCall(start#0, end#0)
             && MapSpec.__default.NonEmptyRange(start#0, end#0)
           ==> (forall i#10: int :: 
            { $Unbox(Seq#Index(results#0, i#10)): DatatypeType } 
            LitInt(0) <= i#10 && i#10 < Seq#Length(results#0)
               ==> MapSpec.Variables.Variables_q(s#0)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#10)): DatatypeType)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#10)): DatatypeType)))
         && ((forall i#10: int :: 
              { $Unbox(Seq#Index(results#0, i#10)): DatatypeType } 
              LitInt(0) <= i#10 && i#10 < Seq#Length(results#0)
                 ==> MapSpec.Variables.Variables_q(s#0)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#10)): DatatypeType)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#10)): DatatypeType))
             && (forall i#10: int :: 
              { $Unbox(Seq#Index(results#0, i#10)): DatatypeType } 
              LitInt(0) <= i#10 && i#10 < Seq#Length(results#0)
                 ==> $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#10)): DatatypeType))]): Seq Box
                   == UI.SuccResult.value($Unbox(Seq#Index(results#0, i#10)): DatatypeType))
           ==> (forall i#11: int :: 
            { $Unbox(Seq#Index(results#0, i#11)): DatatypeType } 
            LitInt(0) <= i#11 && i#11 < Seq#Length(results#0)
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#11)): DatatypeType)
                 && MapSpec.__default.EmptyValue#canCall()))
         && ((forall i#11: int :: 
              { $Unbox(Seq#Index(results#0, i#11)): DatatypeType } 
              LitInt(0) <= i#11 && i#11 < Seq#Length(results#0)
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#11)): DatatypeType)
                   && MapSpec.__default.EmptyValue#canCall())
             && (forall i#11: int :: 
              { $Unbox(Seq#Index(results#0, i#11)): DatatypeType } 
              LitInt(0) <= i#11 && i#11 < Seq#Length(results#0)
                 ==> UI.SuccResult.value($Unbox(Seq#Index(results#0, i#11)): DatatypeType)
                   != MapSpec.__default.EmptyValue())
           ==> (forall i#12: int :: 
            { $Unbox(Seq#Index(results#0, i#12)): DatatypeType } 
            LitInt(0) <= i#12 && i#12 < Seq#Length(results#0)
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#12)): DatatypeType)
                 && MapSpec.__default.InRange#canCall(start#0, 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, i#12)): DatatypeType), 
                  end#0)))
         && ((forall i#12: int :: 
              { $Unbox(Seq#Index(results#0, i#12)): DatatypeType } 
              LitInt(0) <= i#12 && i#12 < Seq#Length(results#0)
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#12)): DatatypeType)
                   && MapSpec.__default.InRange#canCall(start#0, 
                    UI.SuccResult.key($Unbox(Seq#Index(results#0, i#12)): DatatypeType), 
                    end#0))
             && (forall i#12: int :: 
              { $Unbox(Seq#Index(results#0, i#12)): DatatypeType } 
              LitInt(0) <= i#12 && i#12 < Seq#Length(results#0)
                 ==> MapSpec.__default.InRange(start#0, 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, i#12)): DatatypeType), 
                  end#0))
           ==> (forall i#13: int, j#2: int :: 
            { $Unbox(Seq#Index(results#0, j#2)): DatatypeType, $Unbox(Seq#Index(results#0, i#13)): DatatypeType } 
            LitInt(0) <= i#13 && i#13 < j#2 && j#2 < Seq#Length(results#0)
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#13)): DatatypeType)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, j#2)): DatatypeType)
                 && SeqComparison.__default.lt#canCall(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#13)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, j#2)): DatatypeType))))
         && ((forall i#13: int, j#2: int :: 
              { $Unbox(Seq#Index(results#0, j#2)): DatatypeType, $Unbox(Seq#Index(results#0, i#13)): DatatypeType } 
              LitInt(0) <= i#13 && i#13 < j#2 && j#2 < Seq#Length(results#0)
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#13)): DatatypeType)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, j#2)): DatatypeType)
                   && SeqComparison.__default.lt#canCall(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#13)): DatatypeType), 
                    UI.SuccResult.key($Unbox(Seq#Index(results#0, j#2)): DatatypeType)))
             && (forall i#13: int, j#2: int :: 
              { $Unbox(Seq#Index(results#0, j#2)): DatatypeType, $Unbox(Seq#Index(results#0, i#13)): DatatypeType } 
              LitInt(0) <= i#13 && i#13 < j#2 && j#2 < Seq#Length(results#0)
                 ==> SeqComparison.__default.lt(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#13)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, j#2)): DatatypeType)))
           ==> (forall key#2: Seq Box :: 
            { $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#2)]): Seq Box } 
              { MapSpec.__default.InRange(start#0, key#2, end#0) } 
            $Is(key#2, Tclass.KeyType.Key())
               ==> MapSpec.__default.InRange#canCall(start#0, key#2, end#0)
                 && (MapSpec.__default.InRange(start#0, key#2, end#0)
                   ==> MapSpec.Variables.Variables_q(s#0) && MapSpec.__default.EmptyValue#canCall())
                 && (MapSpec.__default.InRange(start#0, key#2, end#0)
                     && $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#2)]): Seq Box
                       != MapSpec.__default.EmptyValue()
                   ==> (forall i#14: int :: 
                    { $Unbox(Seq#Index(results#0, i#14)): DatatypeType } 
                    i#14 < Seq#Length(results#0)
                       ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#14)): DatatypeType)))))
         && MapSpec.__default.Succ(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.SuccOp(start#0, results#0, end#0))
             && MapSpec.__default.WF(s#0)
             && MapSpec.Variables#Equal(s'#0, s#0)
             && MapSpec.__default.NonEmptyRange(start#0, end#0)
             && (forall i#10: int :: 
              { $Unbox(Seq#Index(results#0, i#10)): DatatypeType } 
              LitInt(0) <= i#10 && i#10 < Seq#Length(results#0)
                 ==> $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#10)): DatatypeType))]): Seq Box
                   == UI.SuccResult.value($Unbox(Seq#Index(results#0, i#10)): DatatypeType))
             && (forall i#11: int :: 
              { $Unbox(Seq#Index(results#0, i#11)): DatatypeType } 
              LitInt(0) <= i#11 && i#11 < Seq#Length(results#0)
                 ==> UI.SuccResult.value($Unbox(Seq#Index(results#0, i#11)): DatatypeType)
                   != MapSpec.__default.EmptyValue())
             && (forall i#12: int :: 
              { $Unbox(Seq#Index(results#0, i#12)): DatatypeType } 
              LitInt(0) <= i#12 && i#12 < Seq#Length(results#0)
                 ==> MapSpec.__default.InRange(start#0, 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, i#12)): DatatypeType), 
                  end#0))
             && (forall i#13: int, j#2: int :: 
              { $Unbox(Seq#Index(results#0, j#2)): DatatypeType, $Unbox(Seq#Index(results#0, i#13)): DatatypeType } 
              LitInt(0) <= i#13 && i#13 < j#2 && j#2 < Seq#Length(results#0)
                 ==> SeqComparison.__default.lt(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#13)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, j#2)): DatatypeType)))
             && (forall key#2: Seq Box :: 
              { $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#2)]): Seq Box } 
                { MapSpec.__default.InRange(start#0, key#2, end#0) } 
              $Is(key#2, Tclass.KeyType.Key())
                   && 
                  MapSpec.__default.InRange(start#0, key#2, end#0)
                   && $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#2)]): Seq Box
                     != MapSpec.__default.EmptyValue()
                 ==> (exists i#14: int :: 
                  { $Unbox(Seq#Index(results#0, i#14)): DatatypeType } 
                  LitInt(0) <= i#14
                     && i#14 < Seq#Length(results#0)
                     && Seq#Equal(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#14)): DatatypeType), key#2)))));

// definition axiom for MapSpec.__default.Succ for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      start#0: DatatypeType, 
      results#0: Seq Box, 
      end#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Succ(Lit(k#0), 
        Lit(s#0), 
        Lit(s'#0), 
        Lit(uiop#0), 
        Lit(start#0), 
        Lit(results#0), 
        Lit(end#0)) } 
    MapSpec.__default.Succ#canCall(Lit(k#0), 
          Lit(s#0), 
          Lit(s'#0), 
          Lit(uiop#0), 
          Lit(start#0), 
          Lit(results#0), 
          Lit(end#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(results#0, TSeq(Tclass.UI.SuccResult()))
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.SuccOp(Lit(start#0), Lit(results#0), Lit(end#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> $IsA#MapSpec.Variables(Lit(s'#0)) && $IsA#MapSpec.Variables(Lit(s#0)))
         && ($IsA#MapSpec.Variables(Lit(s'#0))
             && $IsA#MapSpec.Variables(Lit(s#0))
             && MapSpec.Variables#Equal(s'#0, s#0)
           ==> MapSpec.__default.NonEmptyRange#canCall(Lit(start#0), Lit(end#0)))
         && (MapSpec.__default.NonEmptyRange#canCall(Lit(start#0), Lit(end#0))
             && Lit(MapSpec.__default.NonEmptyRange(Lit(start#0), Lit(end#0)))
           ==> (forall i#15: int :: 
            { $Unbox(Seq#Index(results#0, i#15)): DatatypeType } 
            LitInt(0) <= i#15 && i#15 < Seq#Length(Lit(results#0))
               ==> MapSpec.Variables.Variables_q(Lit(s#0))
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#15)): DatatypeType)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#15)): DatatypeType)))
         && ((forall i#15: int :: 
              { $Unbox(Seq#Index(results#0, i#15)): DatatypeType } 
              LitInt(0) <= i#15 && i#15 < Seq#Length(Lit(results#0))
                 ==> MapSpec.Variables.Variables_q(Lit(s#0))
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#15)): DatatypeType)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#15)): DatatypeType))
             && (forall i#15: int :: 
              { $Unbox(Seq#Index(results#0, i#15)): DatatypeType } 
              LitInt(0) <= i#15 && i#15 < Seq#Length(Lit(results#0))
                 ==> $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#15)): DatatypeType))]): Seq Box
                   == UI.SuccResult.value($Unbox(Seq#Index(Lit(results#0), i#15)): DatatypeType))
           ==> (forall i#16: int :: 
            { $Unbox(Seq#Index(results#0, i#16)): DatatypeType } 
            LitInt(0) <= i#16 && i#16 < Seq#Length(Lit(results#0))
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#16)): DatatypeType)
                 && MapSpec.__default.EmptyValue#canCall()))
         && ((forall i#16: int :: 
              { $Unbox(Seq#Index(results#0, i#16)): DatatypeType } 
              LitInt(0) <= i#16 && i#16 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#16)): DatatypeType)
                   && MapSpec.__default.EmptyValue#canCall())
             && (forall i#16: int :: 
              { $Unbox(Seq#Index(results#0, i#16)): DatatypeType } 
              LitInt(0) <= i#16 && i#16 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.value($Unbox(Seq#Index(Lit(results#0), i#16)): DatatypeType)
                   != MapSpec.__default.EmptyValue())
           ==> (forall i#17: int :: 
            { $Unbox(Seq#Index(results#0, i#17)): DatatypeType } 
            LitInt(0) <= i#17 && i#17 < Seq#Length(Lit(results#0))
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#17)): DatatypeType)
                 && MapSpec.__default.InRange#canCall(Lit(start#0), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#17)): DatatypeType), 
                  Lit(end#0))))
         && ((forall i#17: int :: 
              { $Unbox(Seq#Index(results#0, i#17)): DatatypeType } 
              LitInt(0) <= i#17 && i#17 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#17)): DatatypeType)
                   && MapSpec.__default.InRange#canCall(Lit(start#0), 
                    UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#17)): DatatypeType), 
                    Lit(end#0)))
             && (forall i#17: int :: 
              { $Unbox(Seq#Index(results#0, i#17)): DatatypeType } 
              LitInt(0) <= i#17 && i#17 < Seq#Length(Lit(results#0))
                 ==> MapSpec.__default.InRange(Lit(start#0), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#17)): DatatypeType), 
                  Lit(end#0)))
           ==> (forall i#18: int, j#3: int :: 
            { $Unbox(Seq#Index(results#0, j#3)): DatatypeType, $Unbox(Seq#Index(results#0, i#18)): DatatypeType } 
            LitInt(0) <= i#18 && i#18 < j#3 && j#3 < Seq#Length(Lit(results#0))
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#18)): DatatypeType)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), j#3)): DatatypeType)
                 && SeqComparison.__default.lt#canCall(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#18)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), j#3)): DatatypeType))))
         && ((forall i#18: int, j#3: int :: 
              { $Unbox(Seq#Index(results#0, j#3)): DatatypeType, $Unbox(Seq#Index(results#0, i#18)): DatatypeType } 
              LitInt(0) <= i#18 && i#18 < j#3 && j#3 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#18)): DatatypeType)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), j#3)): DatatypeType)
                   && SeqComparison.__default.lt#canCall(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#18)): DatatypeType), 
                    UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), j#3)): DatatypeType)))
             && (forall i#18: int, j#3: int :: 
              { $Unbox(Seq#Index(results#0, j#3)): DatatypeType, $Unbox(Seq#Index(results#0, i#18)): DatatypeType } 
              LitInt(0) <= i#18 && i#18 < j#3 && j#3 < Seq#Length(Lit(results#0))
                 ==> SeqComparison.__default.lt(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#18)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), j#3)): DatatypeType)))
           ==> (forall key#3: Seq Box :: 
            { $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#3)]): Seq Box } 
              { MapSpec.__default.InRange(start#0, key#3, end#0) } 
            $Is(key#3, Tclass.KeyType.Key())
               ==> MapSpec.__default.InRange#canCall(Lit(start#0), key#3, Lit(end#0))
                 && (MapSpec.__default.InRange(Lit(start#0), key#3, Lit(end#0))
                   ==> MapSpec.Variables.Variables_q(Lit(s#0))
                     && MapSpec.__default.EmptyValue#canCall())
                 && (MapSpec.__default.InRange(Lit(start#0), key#3, Lit(end#0))
                     && $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(key#3)]): Seq Box
                       != MapSpec.__default.EmptyValue()
                   ==> (forall i#19: int :: 
                    { $Unbox(Seq#Index(results#0, i#19)): DatatypeType } 
                    i#19 < Seq#Length(Lit(results#0))
                       ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#19)): DatatypeType)))))
         && MapSpec.__default.Succ(Lit(k#0), 
            Lit(s#0), 
            Lit(s'#0), 
            Lit(uiop#0), 
            Lit(start#0), 
            Lit(results#0), 
            Lit(end#0))
           == (
            UI.Op#Equal(uiop#0, #UI.Op.SuccOp(Lit(start#0), Lit(results#0), Lit(end#0)))
             && MapSpec.__default.WF(Lit(s#0))
             && MapSpec.Variables#Equal(s'#0, s#0)
             && MapSpec.__default.NonEmptyRange(Lit(start#0), Lit(end#0))
             && (forall i#15: int :: 
              { $Unbox(Seq#Index(results#0, i#15)): DatatypeType } 
              LitInt(0) <= i#15 && i#15 < Seq#Length(Lit(results#0))
                 ==> $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#15)): DatatypeType))]): Seq Box
                   == UI.SuccResult.value($Unbox(Seq#Index(Lit(results#0), i#15)): DatatypeType))
             && (forall i#16: int :: 
              { $Unbox(Seq#Index(results#0, i#16)): DatatypeType } 
              LitInt(0) <= i#16 && i#16 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.value($Unbox(Seq#Index(Lit(results#0), i#16)): DatatypeType)
                   != MapSpec.__default.EmptyValue())
             && (forall i#17: int :: 
              { $Unbox(Seq#Index(results#0, i#17)): DatatypeType } 
              LitInt(0) <= i#17 && i#17 < Seq#Length(Lit(results#0))
                 ==> MapSpec.__default.InRange(Lit(start#0), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#17)): DatatypeType), 
                  Lit(end#0)))
             && (forall i#18: int, j#3: int :: 
              { $Unbox(Seq#Index(results#0, j#3)): DatatypeType, $Unbox(Seq#Index(results#0, i#18)): DatatypeType } 
              LitInt(0) <= i#18 && i#18 < j#3 && j#3 < Seq#Length(Lit(results#0))
                 ==> SeqComparison.__default.lt(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#18)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), j#3)): DatatypeType)))
             && (forall key#3: Seq Box :: 
              { $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#3)]): Seq Box } 
                { MapSpec.__default.InRange(start#0, key#3, end#0) } 
              $Is(key#3, Tclass.KeyType.Key())
                   && 
                  MapSpec.__default.InRange(Lit(start#0), key#3, Lit(end#0))
                   && $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(key#3)]): Seq Box
                     != MapSpec.__default.EmptyValue()
                 ==> (exists i#19: int :: 
                  { $Unbox(Seq#Index(results#0, i#19)): DatatypeType } 
                  LitInt(0) <= i#19
                     && i#19 < Seq#Length(Lit(results#0))
                     && Seq#Equal(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#19)): DatatypeType), key#3)))));

// function declaration for MapSpec._default.Write
function MapSpec.__default.Write(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    new_value#0: Seq Box)
   : bool;

function MapSpec.__default.Write#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    new_value#0: Seq Box)
   : bool;

// consequence axiom for MapSpec.__default.Write
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      new_value#0: Seq Box :: 
    { MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#0, new_value#0) } 
    MapSpec.__default.Write#canCall(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(new_value#0, Tclass.ValueType.Value()))
       ==> 
      MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
       ==> MapSpec.__default.WF(s'#0));

function MapSpec.__default.Write#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for MapSpec.__default.Write
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    new_value#0: Seq Box :: 
  { MapSpec.__default.Write#requires(k#0, s#0, s'#0, uiop#0, key#0, new_value#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(new_value#0, Tclass.ValueType.Value())
     ==> MapSpec.__default.Write#requires(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
       == true);

// definition axiom for MapSpec.__default.Write(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      new_value#0: Seq Box :: 
    { MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#0, new_value#0) } 
    MapSpec.__default.Write#canCall(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(new_value#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(uiop#0)
         && (UI.Op#Equal(uiop#0, #UI.Op.PutOp(key#0, new_value#0))
           ==> MapSpec.__default.WF#canCall(s#0))
         && (MapSpec.__default.WF#canCall(s#0) && MapSpec.__default.WF(s#0)
           ==> MapSpec.__default.WF#canCall(s'#0))
         && (MapSpec.__default.WF#canCall(s'#0) && MapSpec.__default.WF(s'#0)
           ==> MapSpec.Variables.Variables_q(s'#0) && MapSpec.Variables.Variables_q(s#0))
         && MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.PutOp(key#0, new_value#0))
             && MapSpec.__default.WF(s#0)
             && MapSpec.__default.WF(s'#0)
             && IMap#Equal(MapSpec.Variables.view(s'#0), 
              IMap#Build(MapSpec.Variables.view(s#0), $Box(key#0), $Box(new_value#0)))));

// definition axiom for MapSpec.__default.Write for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      new_value#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), new_value#0) } 
    MapSpec.__default.Write#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), new_value#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(new_value#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.PutOp(Lit(key#0), new_value#0))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s'#0)))
         && (MapSpec.__default.WF#canCall(Lit(s'#0)) && Lit(MapSpec.__default.WF(Lit(s'#0)))
           ==> MapSpec.Variables.Variables_q(Lit(s'#0))
             && MapSpec.Variables.Variables_q(Lit(s#0)))
         && MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), new_value#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.PutOp(Lit(key#0), new_value#0))
             && MapSpec.__default.WF(Lit(s#0))
             && MapSpec.__default.WF(Lit(s'#0))
             && IMap#Equal(MapSpec.Variables.view(Lit(s'#0)), 
              IMap#Build(Lit(MapSpec.Variables.view(Lit(s#0))), $Box(Lit(key#0)), $Box(new_value#0)))));

// definition axiom for MapSpec.__default.Write for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      new_value#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(new_value#0)) } 
    MapSpec.__default.Write#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(new_value#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(new_value#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.PutOp(Lit(key#0), Lit(new_value#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s'#0)))
         && (MapSpec.__default.WF#canCall(Lit(s'#0)) && Lit(MapSpec.__default.WF(Lit(s'#0)))
           ==> MapSpec.Variables.Variables_q(Lit(s'#0))
             && MapSpec.Variables.Variables_q(Lit(s#0)))
         && MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(new_value#0))
           == (
            UI.Op#Equal(uiop#0, #UI.Op.PutOp(Lit(key#0), Lit(new_value#0)))
             && MapSpec.__default.WF(Lit(s#0))
             && MapSpec.__default.WF(Lit(s'#0))
             && IMap#Equal(MapSpec.Variables.view(Lit(s'#0)), 
              IMap#Build(Lit(MapSpec.Variables.view(Lit(s#0))), $Box(Lit(key#0)), $Box(Lit(new_value#0))))));

// function declaration for MapSpec._default.Stutter
function MapSpec.__default.Stutter(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType)
   : bool;

function MapSpec.__default.Stutter#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType)
   : bool;

// consequence axiom for MapSpec.__default.Stutter
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    { MapSpec.__default.Stutter(k#0, s#0, s'#0, uiop#0) } 
    MapSpec.__default.Stutter#canCall(k#0, s#0, s'#0, uiop#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> true);

function MapSpec.__default.Stutter#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.Stutter
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
  { MapSpec.__default.Stutter#requires(k#0, s#0, s'#0, uiop#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
     ==> MapSpec.__default.Stutter#requires(k#0, s#0, s'#0, uiop#0) == true);

// definition axiom for MapSpec.__default.Stutter(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    { MapSpec.__default.Stutter(k#0, s#0, s'#0, uiop#0) } 
    MapSpec.__default.Stutter#canCall(k#0, s#0, s'#0, uiop#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (UI.Op.NoOp_q(uiop#0)
           ==> $IsA#MapSpec.Variables(s'#0) && $IsA#MapSpec.Variables(s#0))
         && MapSpec.__default.Stutter(k#0, s#0, s'#0, uiop#0)
           == (UI.Op.NoOp_q(uiop#0) && MapSpec.Variables#Equal(s'#0, s#0)));

// definition axiom for MapSpec.__default.Stutter for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0)) } 
    MapSpec.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (Lit(UI.Op.NoOp_q(Lit(uiop#0)))
           ==> $IsA#MapSpec.Variables(Lit(s'#0)) && $IsA#MapSpec.Variables(Lit(s#0)))
         && MapSpec.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))
           == (UI.Op.NoOp_q(Lit(uiop#0)) && MapSpec.Variables#Equal(s'#0, s#0)));

// function declaration for MapSpec._default.NextStep
function MapSpec.__default.NextStep(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

function MapSpec.__default.NextStep#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

// consequence axiom for MapSpec.__default.NextStep
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0) } 
    MapSpec.__default.NextStep#canCall(k#0, s#0, s'#0, uiop#0, step#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(step#0, Tclass.MapSpec.Step()))
       ==> true);

function MapSpec.__default.NextStep#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.NextStep
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    step#0: DatatypeType :: 
  { MapSpec.__default.NextStep#requires(k#0, s#0, s'#0, uiop#0, step#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
       && $Is(step#0, Tclass.MapSpec.Step())
     ==> MapSpec.__default.NextStep#requires(k#0, s#0, s'#0, uiop#0, step#0) == true);

// definition axiom for MapSpec.__default.NextStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0) } 
    MapSpec.__default.NextStep#canCall(k#0, s#0, s'#0, uiop#0, step#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(step#0, Tclass.MapSpec.Step()))
       ==> (MapSpec.Step.QueryStep_q(step#0)
           ==> (var result#4 := MapSpec.Step.result(step#0); 
            (var key#8 := MapSpec.Step.key(step#0); 
              MapSpec.__default.Query#canCall(k#0, s#0, s'#0, uiop#0, key#8, result#4))))
         && (!MapSpec.Step.QueryStep_q(step#0)
           ==> (MapSpec.Step.WriteStep_q(step#0)
               ==> (var new_value#4 := MapSpec.Step.new__value(step#0); 
                (var key#9 := MapSpec.Step.key(step#0); 
                  MapSpec.__default.Write#canCall(k#0, s#0, s'#0, uiop#0, key#9, new_value#4))))
             && (!MapSpec.Step.WriteStep_q(step#0)
               ==> (MapSpec.Step.SuccStep_q(step#0)
                   ==> (var end#4 := MapSpec.Step.end(step#0); 
                    (var results#4 := MapSpec.Step.results(step#0); 
                      (var start#4 := MapSpec.Step.start(step#0); 
                        MapSpec.__default.Succ#canCall(k#0, s#0, s'#0, uiop#0, start#4, results#4, end#4)))))
                 && (!MapSpec.Step.SuccStep_q(step#0)
                   ==> MapSpec.__default.Stutter#canCall(k#0, s#0, s'#0, uiop#0))))
         && MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0)
           == (if MapSpec.Step.QueryStep_q(step#0)
             then (var result#5 := MapSpec.Step.result(step#0); 
              (var key#10 := MapSpec.Step.key(step#0); 
                MapSpec.__default.Query(k#0, s#0, s'#0, uiop#0, key#10, result#5)))
             else (if MapSpec.Step.WriteStep_q(step#0)
               then (var new_value#5 := MapSpec.Step.new__value(step#0); 
                (var key#11 := MapSpec.Step.key(step#0); 
                  MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#11, new_value#5)))
               else (if MapSpec.Step.SuccStep_q(step#0)
                 then (var end#5 := MapSpec.Step.end(step#0); 
                  (var results#5 := MapSpec.Step.results(step#0); 
                    (var start#5 := MapSpec.Step.start(step#0); 
                      MapSpec.__default.Succ(k#0, s#0, s'#0, uiop#0, start#5, results#5, end#5))))
                 else MapSpec.__default.Stutter(k#0, s#0, s'#0, uiop#0)))));

// definition axiom for MapSpec.__default.NextStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      step#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(step#0)) } 
    MapSpec.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(step#0, Tclass.MapSpec.Step()))
       ==> (Lit(MapSpec.Step.QueryStep_q(Lit(step#0)))
           ==> (var result#6 := Lit(MapSpec.Step.result(Lit(step#0))); 
            (var key#12 := Lit(MapSpec.Step.key(Lit(step#0))); 
              MapSpec.__default.Query#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), key#12, result#6))))
         && (!Lit(MapSpec.Step.QueryStep_q(Lit(step#0)))
           ==> (Lit(MapSpec.Step.WriteStep_q(Lit(step#0)))
               ==> (var new_value#6 := Lit(MapSpec.Step.new__value(Lit(step#0))); 
                (var key#13 := Lit(MapSpec.Step.key(Lit(step#0))); 
                  MapSpec.__default.Write#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), key#13, new_value#6))))
             && (!Lit(MapSpec.Step.WriteStep_q(Lit(step#0)))
               ==> (Lit(MapSpec.Step.SuccStep_q(Lit(step#0)))
                   ==> (var end#6 := Lit(MapSpec.Step.end(Lit(step#0))); 
                    (var results#6 := Lit(MapSpec.Step.results(Lit(step#0))); 
                      (var start#6 := Lit(MapSpec.Step.start(Lit(step#0))); 
                        MapSpec.__default.Succ#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), start#6, results#6, end#6)))))
                 && (!Lit(MapSpec.Step.SuccStep_q(Lit(step#0)))
                   ==> MapSpec.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0)))))
         && MapSpec.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(step#0))
           == (if MapSpec.Step.QueryStep_q(Lit(step#0))
             then (var result#7 := Lit(MapSpec.Step.result(Lit(step#0))); 
              (var key#14 := Lit(MapSpec.Step.key(Lit(step#0))); 
                Lit(MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), key#14, result#7))))
             else (if MapSpec.Step.WriteStep_q(Lit(step#0))
               then (var new_value#7 := Lit(MapSpec.Step.new__value(Lit(step#0))); 
                (var key#15 := Lit(MapSpec.Step.key(Lit(step#0))); 
                  Lit(MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), key#15, new_value#7))))
               else (if MapSpec.Step.SuccStep_q(Lit(step#0))
                 then (var end#7 := Lit(MapSpec.Step.end(Lit(step#0))); 
                  (var results#7 := Lit(MapSpec.Step.results(Lit(step#0))); 
                    (var start#7 := Lit(MapSpec.Step.start(Lit(step#0))); 
                      Lit(MapSpec.__default.Succ(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), start#7, results#7, end#7)))))
                 else MapSpec.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))))));

// function declaration for MapSpec._default.Next
function MapSpec.__default.Next(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType)
   : bool;

function MapSpec.__default.Next#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType)
   : bool;

// consequence axiom for MapSpec.__default.Next
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    { MapSpec.__default.Next(k#0, s#0, s'#0, uiop#0) } 
    MapSpec.__default.Next#canCall(k#0, s#0, s'#0, uiop#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> true);

function MapSpec.__default.Next#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.Next
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
  { MapSpec.__default.Next#requires(k#0, s#0, s'#0, uiop#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
     ==> MapSpec.__default.Next#requires(k#0, s#0, s'#0, uiop#0) == true);

// definition axiom for MapSpec.__default.Next(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    { MapSpec.__default.Next(k#0, s#0, s'#0, uiop#0) } 
    MapSpec.__default.Next#canCall(k#0, s#0, s'#0, uiop#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (forall step#2: DatatypeType :: 
          { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#2) } 
          $Is(step#2, Tclass.MapSpec.Step())
             ==> MapSpec.__default.NextStep#canCall(k#0, s#0, s'#0, uiop#0, step#2))
         && MapSpec.__default.Next(k#0, s#0, s'#0, uiop#0)
           == (exists step#2: DatatypeType :: 
            { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#2) } 
            $Is(step#2, Tclass.MapSpec.Step())
               && MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#2)));

// definition axiom for MapSpec.__default.Next for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0)) } 
    MapSpec.__default.Next#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (forall step#3: DatatypeType :: 
          { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#3) } 
          $Is(step#3, Tclass.MapSpec.Step())
             ==> MapSpec.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), step#3))
         && MapSpec.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))
           == (exists step#3: DatatypeType :: 
            { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#3) } 
            $Is(step#3, Tclass.MapSpec.Step())
               && MapSpec.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), step#3)));

// function declaration for MapSpec._default.Inv
function MapSpec.__default.Inv(k#0: DatatypeType, s#0: DatatypeType) : bool;

function MapSpec.__default.Inv#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.Inv
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { MapSpec.__default.Inv(k#0, s#0) } 
    MapSpec.__default.Inv#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> true);

function MapSpec.__default.Inv#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.Inv
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { MapSpec.__default.Inv#requires(k#0, s#0) } 
  $Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables())
     ==> MapSpec.__default.Inv#requires(k#0, s#0) == true);

// definition axiom for MapSpec.__default.Inv(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { MapSpec.__default.Inv(k#0, s#0) } 
    MapSpec.__default.Inv#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> MapSpec.__default.WF#canCall(s#0)
         && MapSpec.__default.Inv(k#0, s#0) == MapSpec.__default.WF(s#0));

// definition axiom for MapSpec.__default.Inv for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Inv(Lit(k#0), Lit(s#0)) } 
    MapSpec.__default.Inv#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> MapSpec.__default.WF#canCall(Lit(s#0))
         && MapSpec.__default.Inv(Lit(k#0), Lit(s#0)) == Lit(MapSpec.__default.WF(Lit(s#0))));

const unique class.Multisets.__default: ClassName;

function Tclass.Multisets.__default() : Ty;

// Tclass.Multisets.__default Tag
axiom Tag(Tclass.Multisets.__default()) == Tagclass.Multisets.__default;

const unique Tagclass.Multisets.__default: TyTag;

// Box/unbox axiom for Tclass.Multisets.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Multisets.__default()) } 
  $IsBox(bx, Tclass.Multisets.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Multisets.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Multisets.__default()) } 
  $Is($o, Tclass.Multisets.__default())
     <==> $o == null || dtype($o) == Tclass.Multisets.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Multisets.__default(), $h) } 
  $IsAlloc($o, Tclass.Multisets.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Multisets._default.Choose
function Multisets.__default.Choose(Multisets._default.Choose$A: Ty, $ly: LayerType, s#0: MultiSet Box) : Box;

function Multisets.__default.Choose#canCall(Multisets._default.Choose$A: Ty, s#0: MultiSet Box) : bool;

// layer synonym axiom
axiom (forall Multisets._default.Choose$A: Ty, $ly: LayerType, s#0: MultiSet Box :: 
  { Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), s#0) } 
  Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), s#0)
     == Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0));

// fuel synonym axiom
axiom (forall Multisets._default.Choose$A: Ty, $ly: LayerType, s#0: MultiSet Box :: 
  { Multisets.__default.Choose(Multisets._default.Choose$A, AsFuelBottom($ly), s#0) } 
  Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0)
     == Multisets.__default.Choose(Multisets._default.Choose$A, $LZ, s#0));

// consequence axiom for Multisets.__default.Choose
axiom true
   ==> (forall Multisets._default.Choose$A: Ty, $ly: LayerType, s#0: MultiSet Box :: 
    { Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0) } 
    Multisets.__default.Choose#canCall(Multisets._default.Choose$A, s#0)
         || ($Is(s#0, TMultiSet(Multisets._default.Choose$A)) && 0 < MultiSet#Card(s#0))
       ==> s#0[Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0)] > 0
         && $IsBox(Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0), 
          Multisets._default.Choose$A));

function Multisets.__default.Choose#requires(Ty, LayerType, MultiSet Box) : bool;

// #requires axiom for Multisets.__default.Choose
axiom (forall Multisets._default.Choose$A: Ty, $ly: LayerType, $Heap: Heap, s#0: MultiSet Box :: 
  { Multisets.__default.Choose#requires(Multisets._default.Choose$A, $ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TMultiSet(Multisets._default.Choose$A))
     ==> Multisets.__default.Choose#requires(Multisets._default.Choose$A, $ly, s#0)
       == (0 < MultiSet#Card(s#0)));

function $let#31_a(Multisets._default.Choose$A: Ty, s: MultiSet Box) : Box;

function $let#31$canCall(Multisets._default.Choose$A: Ty, s: MultiSet Box) : bool;

axiom (forall Multisets._default.Choose$A: Ty, s: MultiSet Box :: 
  { $let#31_a(Multisets._default.Choose$A, s) } 
  $let#31$canCall(Multisets._default.Choose$A, s)
     ==> s[$let#31_a(Multisets._default.Choose$A, s)] > 0);

// definition axiom for Multisets.__default.Choose(revealed)
axiom true
   ==> (forall Multisets._default.Choose$A: Ty, $ly: LayerType, $Heap: Heap, s#0: MultiSet Box :: 
    { Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), s#0), $IsGoodHeap($Heap) } 
    Multisets.__default.Choose#canCall(Multisets._default.Choose$A, s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TMultiSet(Multisets._default.Choose$A))
           && 0 < MultiSet#Card(s#0))
       ==> $let#31$canCall(Multisets._default.Choose$A, s#0)
         && Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), s#0)
           == (var a#2 := $let#31_a(Multisets._default.Choose$A, s#0); a#2));

// definition axiom for Multisets.__default.Choose for all literals(revealed)
axiom true
   ==> (forall Multisets._default.Choose$A: Ty, $ly: LayerType, $Heap: Heap, s#0: MultiSet Box :: 
    {:weight 3} { Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.Choose#canCall(Multisets._default.Choose$A, Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TMultiSet(Multisets._default.Choose$A))
           && 0 < MultiSet#Card(Lit(s#0)))
       ==> $let#31$canCall(Multisets._default.Choose$A, Lit(s#0))
         && Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), Lit(s#0))
           == (var a#3 := $let#31_a(Multisets._default.Choose$A, Lit(s#0)); a#3));

// function declaration for Multisets._default.Apply
function Multisets.__default.Apply(Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box)
   : MultiSet Box;

function Multisets.__default.Apply#canCall(Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Apply(Multisets._default.Apply$A, 
      Multisets._default.Apply$B, 
      $LS($ly), 
      $Heap, 
      fn#0, 
      s#0) } 
  Multisets.__default.Apply(Multisets._default.Apply$A, 
      Multisets._default.Apply$B, 
      $LS($ly), 
      $Heap, 
      fn#0, 
      s#0)
     == Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0));

// fuel synonym axiom
axiom (forall Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Apply(Multisets._default.Apply$A, 
      Multisets._default.Apply$B, 
      AsFuelBottom($ly), 
      $Heap, 
      fn#0, 
      s#0) } 
  Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0)
     == Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $LZ, $Heap, fn#0, s#0));

// frame axiom for Multisets.__default.Apply
axiom (forall Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $h1, fn#0, s#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.Apply#canCall(Multisets._default.Apply$A, Multisets._default.Apply$B, $h0, fn#0, s#0)
         || ($Is(fn#0, 
            Tclass._System.___hFunc1(Multisets._default.Apply$A, Multisets._default.Apply$B))
           && $Is(s#0, TMultiSet(Multisets._default.Apply$A))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, o#0: ref :: 
            { Reads1(Multisets._default.Apply$A, Multisets._default.Apply$B, $h0, fn#0, x#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.Apply$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              s#0[x#0] > 0
               && Reads1(Multisets._default.Apply$A, Multisets._default.Apply$B, $h0, fn#0, x#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $h0, fn#0, s#0)
       == Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $h1, fn#0, s#0));

// consequence axiom for Multisets.__default.Apply
axiom true
   ==> (forall Multisets._default.Apply$A: Ty, 
      Multisets._default.Apply$B: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      fn#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0) } 
    Multisets.__default.Apply#canCall(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(fn#0, 
            Tclass._System.___hFunc1(Multisets._default.Apply$A, Multisets._default.Apply$B))
           && $Is(s#0, TMultiSet(Multisets._default.Apply$A))
           && (forall x#4: Box :: 
            { Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#4) } 
              { s#0[x#4] } 
            $IsBox(x#4, Multisets._default.Apply$A) && s#0[x#4] > 0
               ==> Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#4)))
       ==> MultiSet#Card(Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0))
           == MultiSet#Card(s#0)
         && $Is(Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0), 
          TMultiSet(Multisets._default.Apply$B)));

function Multisets.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, MultiSet Box) : bool;

// #requires axiom for Multisets.__default.Apply
axiom (forall Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Apply#requires(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0) } 
  $IsGoodHeap($Heap)
       && $Is(fn#0, 
        Tclass._System.___hFunc1(Multisets._default.Apply$A, Multisets._default.Apply$B))
       && $Is(s#0, TMultiSet(Multisets._default.Apply$A))
     ==> Multisets.__default.Apply#requires(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0)
       == (forall x#5: Box :: 
        { Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#5) } 
          { s#0[x#5] } 
        $IsBox(x#5, Multisets._default.Apply$A) && s#0[x#5] > 0
           ==> Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#5)));

// definition axiom for Multisets.__default.Apply(revealed)
axiom true
   ==> (forall Multisets._default.Apply$A: Ty, 
      Multisets._default.Apply$B: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      fn#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.Apply(Multisets._default.Apply$A, 
        Multisets._default.Apply$B, 
        $LS($ly), 
        $Heap, 
        fn#0, 
        s#0) } 
    Multisets.__default.Apply#canCall(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(fn#0, 
            Tclass._System.___hFunc1(Multisets._default.Apply$A, Multisets._default.Apply$B))
           && $Is(s#0, TMultiSet(Multisets._default.Apply$A))
           && (forall x#5: Box :: 
            { Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#5) } 
              { s#0[x#5] } 
            $IsBox(x#5, Multisets._default.Apply$A) && s#0[x#5] > 0
               ==> Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#5)))
       ==> (MultiSet#Card(s#0) != LitInt(0)
           ==> Multisets.__default.Choose#canCall(Multisets._default.Apply$A, s#0)
             && (var x#6 := Multisets.__default.Choose(Multisets._default.Apply$A, StartFuel_Multisets._default.Choose, s#0); 
              Multisets.__default.Apply#canCall(Multisets._default.Apply$A, 
                Multisets._default.Apply$B, 
                $Heap, 
                fn#0, 
                MultiSet#Difference(s#0, MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, x#6)))))
         && Multisets.__default.Apply(Multisets._default.Apply$A, 
            Multisets._default.Apply$B, 
            $LS($ly), 
            $Heap, 
            fn#0, 
            s#0)
           == (if MultiSet#Card(s#0) == LitInt(0)
             then MultiSet#Empty(): MultiSet Box
             else (var x#6 := Multisets.__default.Choose(Multisets._default.Apply$A, StartFuel_Multisets._default.Choose, s#0); 
              MultiSet#Union(MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, 
                  Apply1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#6)), 
                Multisets.__default.Apply(Multisets._default.Apply$A, 
                  Multisets._default.Apply$B, 
                  $ly, 
                  $Heap, 
                  fn#0, 
                  MultiSet#Difference(s#0, MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, x#6)))))));

// function declaration for Multisets._default.Foldable
function Multisets.__default.Foldable(Multisets._default.Foldable$A: Ty, 
    $heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

function Multisets.__default.Foldable#canCall(Multisets._default.Foldable$A: Ty, 
    $heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

// frame axiom for Multisets.__default.Foldable
axiom (forall Multisets._default.Foldable$A: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.Foldable(Multisets._default.Foldable$A, $h1, zero#0, add#0, inv#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.Foldable#canCall(Multisets._default.Foldable$A, $h0, zero#0, add#0, inv#0)
         || (
          $IsBox(zero#0, Multisets._default.Foldable$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Foldable$A, TBool))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.Foldable$A)
               && $IsBox(y#0, Multisets._default.Foldable$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.Foldable(Multisets._default.Foldable$A, $h0, zero#0, add#0, inv#0)
       == Multisets.__default.Foldable(Multisets._default.Foldable$A, $h1, zero#0, add#0, inv#0));

// consequence axiom for Multisets.__default.Foldable
axiom true
   ==> (forall Multisets._default.Foldable$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.Foldable(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0) } 
    Multisets.__default.Foldable#canCall(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.Foldable$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Foldable$A, TBool)))
       ==> true);

function Multisets.__default.Foldable#requires(Ty, Heap, Box, HandleType, HandleType) : bool;

// #requires axiom for Multisets.__default.Foldable
axiom (forall Multisets._default.Foldable$A: Ty, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.Foldable#requires(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0) } 
  $IsGoodHeap($Heap)
       && $IsBox(zero#0, Multisets._default.Foldable$A)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.Foldable$A, 
          Multisets._default.Foldable$A, 
          Multisets._default.Foldable$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Foldable$A, TBool))
     ==> Multisets.__default.Foldable#requires(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0)
       == true);

// definition axiom for Multisets.__default.Foldable(revealed)
axiom true
   ==> (forall Multisets._default.Foldable$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.Foldable(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0) } 
    Multisets.__default.Foldable#canCall(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.Foldable$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Foldable$A, TBool)))
       ==> ($Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, zero#0)): bool
           ==> (forall x#3: Box, y#3: Box :: 
            { Requires2(Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                $Heap, 
                add#0, 
                x#3, 
                y#3) } 
              { $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#3)): bool, $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#3)): bool } 
            $IsBox(x#3, Multisets._default.Foldable$A)
                 && $IsBox(y#3, Multisets._default.Foldable$A)
               ==> 
              $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#3)): bool
                 && $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#3)): bool
               ==> Requires2#canCall(Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                $Heap, 
                add#0, 
                x#3, 
                y#3)))
         && Multisets.__default.Foldable(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0)
           == ($Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, zero#0)): bool
             && 
            (forall x#3: Box, y#3: Box :: 
              { Requires2(Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  $Heap, 
                  add#0, 
                  x#3, 
                  y#3) } 
                { $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#3)): bool, $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#3)): bool } 
              $IsBox(x#3, Multisets._default.Foldable$A)
                   && $IsBox(y#3, Multisets._default.Foldable$A)
                   && 
                  $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#3)): bool
                   && $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#3)): bool
                 ==> Requires2(Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  $Heap, 
                  add#0, 
                  x#3, 
                  y#3))
             && (forall x#4: Box, y#4: Box :: 
              { Apply2(Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  $Heap, 
                  add#0, 
                  x#4, 
                  y#4) } 
              $IsBox(x#4, Multisets._default.Foldable$A)
                   && $IsBox(y#4, Multisets._default.Foldable$A)
                   && 
                  $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#4)): bool
                   && $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#4)): bool
                 ==> $Unbox(Apply1(Multisets._default.Foldable$A, 
                    TBool, 
                    $Heap, 
                    inv#0, 
                    Apply2(Multisets._default.Foldable$A, 
                      Multisets._default.Foldable$A, 
                      Multisets._default.Foldable$A, 
                      $Heap, 
                      add#0, 
                      x#4, 
                      y#4))): bool)));

// function declaration for Multisets._default.Fold
function Multisets.__default.Fold(Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box)
   : Box;

function Multisets.__default.Fold#canCall(Multisets._default.Fold$A: Ty, 
    $heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Fold(Multisets._default.Fold$A, $LS($ly), $Heap, zero#0, add#0, inv#0, s#0) } 
  Multisets.__default.Fold(Multisets._default.Fold$A, $LS($ly), $Heap, zero#0, add#0, inv#0, s#0)
     == Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0));

// fuel synonym axiom
axiom (forall Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Fold(Multisets._default.Fold$A, AsFuelBottom($ly), $Heap, zero#0, add#0, inv#0, s#0) } 
  Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0)
     == Multisets.__default.Fold(Multisets._default.Fold$A, $LZ, $Heap, zero#0, add#0, inv#0, s#0));

// frame axiom for Multisets.__default.Fold
axiom (forall Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $h1, zero#0, add#0, inv#0, s#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.Fold#canCall(Multisets._default.Fold$A, $h0, zero#0, add#0, inv#0, s#0)
         || (
          $IsBox(zero#0, Multisets._default.Fold$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Fold$A, Multisets._default.Fold$A, Multisets._default.Fold$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Fold$A, TBool))
           && $Is(s#0, TMultiSet(Multisets._default.Fold$A))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.Fold$A)
               && $IsBox(y#0, Multisets._default.Fold$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.Fold$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.Fold$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $h0, zero#0, add#0, inv#0, s#0)
       == Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $h1, zero#0, add#0, inv#0, s#0));

// consequence axiom for Multisets.__default.Fold
axiom true
   ==> (forall Multisets._default.Fold$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      inv#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0) } 
    Multisets.__default.Fold#canCall(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.Fold$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Fold$A, Multisets._default.Fold$A, Multisets._default.Fold$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Fold$A, TBool))
           && $Is(s#0, TMultiSet(Multisets._default.Fold$A))
           && 
          Multisets.__default.Foldable(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0)
           && (forall x#3: Box :: 
            { $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#3)): bool } 
              { s#0[x#3] } 
            $IsBox(x#3, Multisets._default.Fold$A) && s#0[x#3] > 0
               ==> $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#3)): bool))
       ==> (MultiSet#Card(s#0) == LitInt(0)
           ==> Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0)
             == zero#0)
         && $Unbox(Apply1(Multisets._default.Fold$A, 
            TBool, 
            $Heap, 
            inv#0, 
            Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0))): bool
         && $IsBox(Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0), 
          Multisets._default.Fold$A));

function Multisets.__default.Fold#requires(Ty, LayerType, Heap, Box, HandleType, HandleType, MultiSet Box) : bool;

// #requires axiom for Multisets.__default.Fold
axiom (forall Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Fold#requires(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0) } 
  $IsGoodHeap($Heap)
       && $IsBox(zero#0, Multisets._default.Fold$A)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.Fold$A, Multisets._default.Fold$A, Multisets._default.Fold$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Fold$A, TBool))
       && $Is(s#0, TMultiSet(Multisets._default.Fold$A))
     ==> Multisets.__default.Fold#requires(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0)
       == (Multisets.__default.Foldable(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0)
         && (forall x#4: Box :: 
          { $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#4)): bool } 
            { s#0[x#4] } 
          $IsBox(x#4, Multisets._default.Fold$A) && s#0[x#4] > 0
             ==> $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#4)): bool)));

// definition axiom for Multisets.__default.Fold(revealed)
axiom true
   ==> (forall Multisets._default.Fold$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      inv#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.Fold(Multisets._default.Fold$A, $LS($ly), $Heap, zero#0, add#0, inv#0, s#0) } 
    Multisets.__default.Fold#canCall(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.Fold$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Fold$A, Multisets._default.Fold$A, Multisets._default.Fold$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Fold$A, TBool))
           && $Is(s#0, TMultiSet(Multisets._default.Fold$A))
           && 
          Multisets.__default.Foldable(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0)
           && (forall x#4: Box :: 
            { $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#4)): bool } 
              { s#0[x#4] } 
            $IsBox(x#4, Multisets._default.Fold$A) && s#0[x#4] > 0
               ==> $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#4)): bool))
       ==> (MultiSet#Card(s#0) != LitInt(0)
           ==> Multisets.__default.Choose#canCall(Multisets._default.Fold$A, s#0)
             && (var a#1 := Multisets.__default.Choose(Multisets._default.Fold$A, StartFuel_Multisets._default.Choose, s#0); 
              Multisets.__default.Fold#canCall(Multisets._default.Fold$A, 
                $Heap, 
                zero#0, 
                add#0, 
                inv#0, 
                MultiSet#Difference(s#0, MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, a#1)))))
         && Multisets.__default.Fold(Multisets._default.Fold$A, $LS($ly), $Heap, zero#0, add#0, inv#0, s#0)
           == (if MultiSet#Card(s#0) == LitInt(0)
             then zero#0
             else (var a#1 := Multisets.__default.Choose(Multisets._default.Fold$A, StartFuel_Multisets._default.Choose, s#0); 
              Apply2(Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                $Heap, 
                add#0, 
                a#1, 
                Multisets.__default.Fold(Multisets._default.Fold$A, 
                  $ly, 
                  $Heap, 
                  zero#0, 
                  add#0, 
                  inv#0, 
                  MultiSet#Difference(s#0, MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, a#1)))))));

// function declaration for Multisets._default.FoldSimple
function Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A: Ty, 
    zero#0: Box, 
    add#0: HandleType, 
    s#0: MultiSet Box)
   : Box;

function Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A: Ty, 
    zero#0: Box, 
    add#0: HandleType, 
    s#0: MultiSet Box)
   : bool;

// consequence axiom for Multisets.__default.FoldSimple
axiom true
   ==> (forall Multisets._default.FoldSimple$A: Ty, 
      zero#0: Box, 
      add#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0) } 
    Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
         || (
          $IsBox(zero#0, Multisets._default.FoldSimple$A)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A))
           && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A)))
       ==> (MultiSet#Card(s#0) == LitInt(0)
           ==> Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
             == zero#0)
         && $IsBox(Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0), 
          Multisets._default.FoldSimple$A));

function Multisets.__default.FoldSimple#requires(Ty, Box, HandleType, MultiSet Box) : bool;

// #requires axiom for Multisets.__default.FoldSimple
axiom (forall Multisets._default.FoldSimple$A: Ty, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.FoldSimple#requires(Multisets._default.FoldSimple$A, zero#0, add#0, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $IsBox(zero#0, Multisets._default.FoldSimple$A)
       && $Is(add#0, 
        Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
          Multisets._default.FoldSimple$A, 
          Multisets._default.FoldSimple$A))
       && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A))
     ==> Multisets.__default.FoldSimple#requires(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
       == true);

// definition axiom for Multisets.__default.FoldSimple(revealed)
axiom true
   ==> (forall Multisets._default.FoldSimple$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0), $IsGoodHeap($Heap) } 
    Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.FoldSimple$A)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A))
           && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A)))
       ==> Multisets.__default.Fold#canCall(Multisets._default.FoldSimple$A, 
          $Heap, 
          zero#0, 
          add#0, 
          Lit(AtLayer((lambda $l#10#ly#0: LayerType :: 
                Handle1((lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: 
                    $IsBox($l#10#x#0, Multisets._default.FoldSimple$A)), 
                  (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), 
              $LS($LZ))), 
          s#0)
         && Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
           == Multisets.__default.Fold(Multisets._default.FoldSimple$A, 
            StartFuel_Multisets._default.Fold, 
            $Heap, 
            zero#0, 
            add#0, 
            Lit(AtLayer((lambda $l#11#ly#0: LayerType :: 
                  Handle1((lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: 
                      $IsBox($l#11#x#0, Multisets._default.FoldSimple$A)), 
                    (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), 
                $LS($LZ))), 
            s#0));

// definition axiom for Multisets.__default.FoldSimple for decreasing-related literals(revealed)
axiom true
   ==> (forall Multisets._default.FoldSimple$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      s#0: MultiSet Box :: 
    {:weight 3} { Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, Lit(s#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A, zero#0, add#0, Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.FoldSimple$A)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A))
           && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A)))
       ==> Multisets.__default.Fold#canCall(Multisets._default.FoldSimple$A, 
          $Heap, 
          zero#0, 
          add#0, 
          Lit(AtLayer((lambda $l#13#ly#0: LayerType :: 
                Handle1((lambda $l#13#heap#0: Heap, $l#13#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#13#heap#0: Heap, $l#13#x#0: Box :: 
                    $IsBox($l#13#x#0, Multisets._default.FoldSimple$A)), 
                  (lambda $l#13#heap#0: Heap, $l#13#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), 
              $LS($LZ))), 
          Lit(s#0))
         && Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, Lit(s#0))
           == Multisets.__default.Fold(Multisets._default.FoldSimple$A, 
            StartFuel_Multisets._default.Fold, 
            $Heap, 
            zero#0, 
            add#0, 
            Lit(AtLayer((lambda $l#14#ly#0: LayerType :: 
                  Handle1((lambda $l#14#heap#0: Heap, $l#14#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#14#heap#0: Heap, $l#14#x#0: Box :: 
                      $IsBox($l#14#x#0, Multisets._default.FoldSimple$A)), 
                    (lambda $l#14#heap#0: Heap, $l#14#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), 
                $LS($LZ))), 
            Lit(s#0)));

// definition axiom for Multisets.__default.FoldSimple for all literals(revealed)
axiom true
   ==> (forall Multisets._default.FoldSimple$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      s#0: MultiSet Box :: 
    {:weight 3} { Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, Lit(zero#0), Lit(add#0), Lit(s#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A, Lit(zero#0), Lit(add#0), Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.FoldSimple$A)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A))
           && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A)))
       ==> Multisets.__default.Fold#canCall(Multisets._default.FoldSimple$A, 
          $Heap, 
          Lit(zero#0), 
          Lit(add#0), 
          Lit(AtLayer((lambda $l#16#ly#0: LayerType :: 
                Handle1((lambda $l#16#heap#0: Heap, $l#16#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#16#heap#0: Heap, $l#16#x#0: Box :: 
                    $IsBox($l#16#x#0, Multisets._default.FoldSimple$A)), 
                  (lambda $l#16#heap#0: Heap, $l#16#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), 
              $LS($LZ))), 
          Lit(s#0))
         && Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, Lit(zero#0), Lit(add#0), Lit(s#0))
           == Multisets.__default.Fold(Multisets._default.FoldSimple$A, 
            StartFuel_Multisets._default.Fold, 
            $Heap, 
            Lit(zero#0), 
            Lit(add#0), 
            Lit(AtLayer((lambda $l#17#ly#0: LayerType :: 
                  Handle1((lambda $l#17#heap#0: Heap, $l#17#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#17#heap#0: Heap, $l#17#x#0: Box :: 
                      $IsBox($l#17#x#0, Multisets._default.FoldSimple$A)), 
                    (lambda $l#17#heap#0: Heap, $l#17#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), 
                $LS($LZ))), 
            Lit(s#0)));

// function declaration for Multisets._default.IsIdentity
function Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box)
   : bool;

function Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentity$A: Ty, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box :: 
  { Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LS($ly), $Heap, add#0, inv#0, zero#0) } 
  Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LS($ly), $Heap, add#0, inv#0, zero#0)
     == Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0));

// fuel synonym axiom
axiom (forall Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box :: 
  { Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, AsFuelBottom($ly), $Heap, add#0, inv#0, zero#0) } 
  Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0)
     == Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LZ, $Heap, add#0, inv#0, zero#0));

// frame axiom for Multisets.__default.IsIdentity
axiom (forall Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $h1, add#0, inv#0, zero#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentity$A, $h0, add#0, inv#0, zero#0)
         || (
          $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsIdentity$A, TBool))
           && $IsBox(zero#0, Multisets._default.IsIdentity$A)))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.IsIdentity$A, 
                Multisets._default.IsIdentity$A, 
                Multisets._default.IsIdentity$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.IsIdentity$A)
               && $IsBox(y#0, Multisets._default.IsIdentity$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.IsIdentity$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.IsIdentity$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.IsIdentity$A, 
                Multisets._default.IsIdentity$A, 
                Multisets._default.IsIdentity$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $h0, add#0, inv#0, zero#0)
       == Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $h1, add#0, inv#0, zero#0));

// consequence axiom for Multisets.__default.IsIdentity
axiom true
   ==> (forall Multisets._default.IsIdentity$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType, 
      zero#0: Box :: 
    { Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0) } 
    Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentity$A, $Heap, add#0, inv#0, zero#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsIdentity$A, TBool))
           && $IsBox(zero#0, Multisets._default.IsIdentity$A))
       ==> true);

function Multisets.__default.IsIdentity#requires(Ty, LayerType, Heap, HandleType, HandleType, Box) : bool;

// #requires axiom for Multisets.__default.IsIdentity
axiom (forall Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box :: 
  { Multisets.__default.IsIdentity#requires(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.IsIdentity$A, 
          Multisets._default.IsIdentity$A, 
          Multisets._default.IsIdentity$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsIdentity$A, TBool))
       && $IsBox(zero#0, Multisets._default.IsIdentity$A)
     ==> Multisets.__default.IsIdentity#requires(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0)
       == true);

// definition axiom for Multisets.__default.IsIdentity(revealed)
axiom true
   ==> (forall Multisets._default.IsIdentity$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType, 
      zero#0: Box :: 
    { Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LS($ly), $Heap, add#0, inv#0, zero#0) } 
    Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentity$A, $Heap, add#0, inv#0, zero#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsIdentity$A, TBool))
           && $IsBox(zero#0, Multisets._default.IsIdentity$A))
       ==> Multisets.__default.Foldable#canCall(Multisets._default.IsIdentity$A, $Heap, zero#0, add#0, inv#0)
         && Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LS($ly), $Heap, add#0, inv#0, zero#0)
           == (Multisets.__default.Foldable(Multisets._default.IsIdentity$A, $Heap, zero#0, add#0, inv#0)
             && (forall a#1: Box :: 
              { Apply2(Multisets._default.IsIdentity$A, 
                  Multisets._default.IsIdentity$A, 
                  Multisets._default.IsIdentity$A, 
                  $Heap, 
                  add#0, 
                  a#1, 
                  zero#0) } 
                { Apply2(Multisets._default.IsIdentity$A, 
                  Multisets._default.IsIdentity$A, 
                  Multisets._default.IsIdentity$A, 
                  $Heap, 
                  add#0, 
                  zero#0, 
                  a#1) } 
                { $Unbox(Apply1(Multisets._default.IsIdentity$A, TBool, $Heap, inv#0, a#1)): bool } 
              $IsBox(a#1, Multisets._default.IsIdentity$A)
                   && $Unbox(Apply1(Multisets._default.IsIdentity$A, TBool, $Heap, inv#0, a#1)): bool
                 ==> Apply2(Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      $Heap, 
                      add#0, 
                      zero#0, 
                      a#1)
                     == Apply2(Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      $Heap, 
                      add#0, 
                      a#1, 
                      zero#0)
                   && Apply2(Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      $Heap, 
                      add#0, 
                      a#1, 
                      zero#0)
                     == a#1)));

// function declaration for Multisets._default.IsCommutative
function Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

function Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutative$A: Ty, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LS($ly), $Heap, add#0, inv#0) } 
  Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LS($ly), $Heap, add#0, inv#0)
     == Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0));

// fuel synonym axiom
axiom (forall Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, AsFuelBottom($ly), $Heap, add#0, inv#0) } 
  Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0)
     == Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LZ, $Heap, add#0, inv#0));

// frame axiom for Multisets.__default.IsCommutative
axiom (forall Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $h1, add#0, inv#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutative$A, $h0, add#0, inv#0)
         || ($Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsCommutative$A, TBool))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.IsCommutative$A)
               && $IsBox(y#0, Multisets._default.IsCommutative$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $h0, add#0, inv#0)
       == Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $h1, add#0, inv#0));

// consequence axiom for Multisets.__default.IsCommutative
axiom true
   ==> (forall Multisets._default.IsCommutative$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0) } 
    Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutative$A, $Heap, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsCommutative$A, TBool))
           && (forall x#3: Box, y#3: Box :: 
            { Requires2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                x#3, 
                y#3) } 
              { $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#3)): bool, $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#3)): bool } 
            $IsBox(x#3, Multisets._default.IsCommutative$A)
                 && $IsBox(y#3, Multisets._default.IsCommutative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#3)): bool
                 && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#3)): bool
               ==> Requires2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                x#3, 
                y#3)))
       ==> true);

function Multisets.__default.IsCommutative#requires(Ty, LayerType, Heap, HandleType, HandleType) : bool;

// #requires axiom for Multisets.__default.IsCommutative
axiom (forall Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsCommutative#requires(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.IsCommutative$A, 
          Multisets._default.IsCommutative$A, 
          Multisets._default.IsCommutative$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsCommutative$A, TBool))
     ==> Multisets.__default.IsCommutative#requires(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0)
       == (forall x#4: Box, y#4: Box :: 
        { Requires2(Multisets._default.IsCommutative$A, 
            Multisets._default.IsCommutative$A, 
            Multisets._default.IsCommutative$A, 
            $Heap, 
            add#0, 
            x#4, 
            y#4) } 
          { $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#4)): bool, $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#4)): bool } 
        $IsBox(x#4, Multisets._default.IsCommutative$A)
             && $IsBox(y#4, Multisets._default.IsCommutative$A)
             && 
            $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#4)): bool
             && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#4)): bool
           ==> Requires2(Multisets._default.IsCommutative$A, 
            Multisets._default.IsCommutative$A, 
            Multisets._default.IsCommutative$A, 
            $Heap, 
            add#0, 
            x#4, 
            y#4)));

// definition axiom for Multisets.__default.IsCommutative(revealed)
axiom true
   ==> (forall Multisets._default.IsCommutative$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LS($ly), $Heap, add#0, inv#0) } 
    Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutative$A, $Heap, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsCommutative$A, TBool))
           && (forall x#4: Box, y#4: Box :: 
            { Requires2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                x#4, 
                y#4) } 
              { $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#4)): bool, $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#4)): bool } 
            $IsBox(x#4, Multisets._default.IsCommutative$A)
                 && $IsBox(y#4, Multisets._default.IsCommutative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#4)): bool
                 && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#4)): bool
               ==> Requires2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                x#4, 
                y#4)))
       ==> Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LS($ly), $Heap, add#0, inv#0)
         == (forall a#1: Box, b#1: Box :: 
          { Apply2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              $Heap, 
              add#0, 
              b#1, 
              a#1) } 
            { Apply2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              $Heap, 
              add#0, 
              a#1, 
              b#1) } 
            { $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, b#1)): bool, $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, a#1)): bool } 
          $IsBox(a#1, Multisets._default.IsCommutative$A)
               && $IsBox(b#1, Multisets._default.IsCommutative$A)
               && 
              $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, a#1)): bool
               && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, b#1)): bool
             ==> Apply2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                a#1, 
                b#1)
               == Apply2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                b#1, 
                a#1)));

// function declaration for Multisets._default.IsAssociative
function Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

function Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociative$A: Ty, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LS($ly), $Heap, add#0, inv#0) } 
  Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LS($ly), $Heap, add#0, inv#0)
     == Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0));

// fuel synonym axiom
axiom (forall Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, AsFuelBottom($ly), $Heap, add#0, inv#0) } 
  Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0)
     == Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LZ, $Heap, add#0, inv#0));

// frame axiom for Multisets.__default.IsAssociative
axiom (forall Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $h1, add#0, inv#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociative$A, $h0, add#0, inv#0)
         || ($Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsAssociative$A, TBool))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.IsAssociative$A)
               && $IsBox(y#0, Multisets._default.IsAssociative$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $h0, add#0, inv#0)
       == Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $h1, add#0, inv#0));

// consequence axiom for Multisets.__default.IsAssociative
axiom true
   ==> (forall Multisets._default.IsAssociative$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0) } 
    Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociative$A, $Heap, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsAssociative$A, TBool))
           && 
          (forall x#5: Box, y#5: Box :: 
            { Requires2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#5, 
                y#5) } 
              { $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#5)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#5)): bool } 
            $IsBox(x#5, Multisets._default.IsAssociative$A)
                 && $IsBox(y#5, Multisets._default.IsAssociative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#5)): bool
                 && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#5)): bool
               ==> Requires2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#5, 
                y#5))
           && (forall x#6: Box, y#6: Box :: 
            { Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#6, 
                y#6) } 
            $IsBox(x#6, Multisets._default.IsAssociative$A)
                 && $IsBox(y#6, Multisets._default.IsAssociative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#6)): bool
                 && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#6)): bool
               ==> $Unbox(Apply1(Multisets._default.IsAssociative$A, 
                  TBool, 
                  $Heap, 
                  inv#0, 
                  Apply2(Multisets._default.IsAssociative$A, 
                    Multisets._default.IsAssociative$A, 
                    Multisets._default.IsAssociative$A, 
                    $Heap, 
                    add#0, 
                    x#6, 
                    y#6))): bool))
       ==> true);

function Multisets.__default.IsAssociative#requires(Ty, LayerType, Heap, HandleType, HandleType) : bool;

// #requires axiom for Multisets.__default.IsAssociative
axiom (forall Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsAssociative#requires(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.IsAssociative$A, 
          Multisets._default.IsAssociative$A, 
          Multisets._default.IsAssociative$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsAssociative$A, TBool))
     ==> Multisets.__default.IsAssociative#requires(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0)
       == ((forall x#7: Box, y#7: Box :: 
          { Requires2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              x#7, 
              y#7) } 
            { $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#7)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#7)): bool } 
          $IsBox(x#7, Multisets._default.IsAssociative$A)
               && $IsBox(y#7, Multisets._default.IsAssociative$A)
               && 
              $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#7)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#7)): bool
             ==> Requires2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              x#7, 
              y#7))
         && (forall x#8: Box, y#8: Box :: 
          { Apply2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              x#8, 
              y#8) } 
          $IsBox(x#8, Multisets._default.IsAssociative$A)
               && $IsBox(y#8, Multisets._default.IsAssociative$A)
               && 
              $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#8)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#8)): bool
             ==> $Unbox(Apply1(Multisets._default.IsAssociative$A, 
                TBool, 
                $Heap, 
                inv#0, 
                Apply2(Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  $Heap, 
                  add#0, 
                  x#8, 
                  y#8))): bool)));

// definition axiom for Multisets.__default.IsAssociative(revealed)
axiom true
   ==> (forall Multisets._default.IsAssociative$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LS($ly), $Heap, add#0, inv#0) } 
    Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociative$A, $Heap, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsAssociative$A, TBool))
           && 
          (forall x#7: Box, y#7: Box :: 
            { Requires2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#7, 
                y#7) } 
              { $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#7)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#7)): bool } 
            $IsBox(x#7, Multisets._default.IsAssociative$A)
                 && $IsBox(y#7, Multisets._default.IsAssociative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#7)): bool
                 && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#7)): bool
               ==> Requires2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#7, 
                y#7))
           && (forall x#8: Box, y#8: Box :: 
            { Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#8, 
                y#8) } 
            $IsBox(x#8, Multisets._default.IsAssociative$A)
                 && $IsBox(y#8, Multisets._default.IsAssociative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#8)): bool
                 && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#8)): bool
               ==> $Unbox(Apply1(Multisets._default.IsAssociative$A, 
                  TBool, 
                  $Heap, 
                  inv#0, 
                  Apply2(Multisets._default.IsAssociative$A, 
                    Multisets._default.IsAssociative$A, 
                    Multisets._default.IsAssociative$A, 
                    $Heap, 
                    add#0, 
                    x#8, 
                    y#8))): bool))
       ==> Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LS($ly), $Heap, add#0, inv#0)
         == (forall a#1: Box, b#1: Box, c#1: Box :: 
          { Apply2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              a#1, 
              Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                b#1, 
                c#1)) } 
            { Apply2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                a#1, 
                b#1), 
              c#1) } 
            { $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, c#1)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, b#1)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, a#1)): bool } 
          $IsBox(a#1, Multisets._default.IsAssociative$A)
               && $IsBox(b#1, Multisets._default.IsAssociative$A)
               && $IsBox(c#1, Multisets._default.IsAssociative$A)
               && 
              $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, a#1)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, b#1)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, c#1)): bool
             ==> Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                Apply2(Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  $Heap, 
                  add#0, 
                  a#1, 
                  b#1), 
                c#1)
               == Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                a#1, 
                Apply2(Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  $Heap, 
                  add#0, 
                  b#1, 
                  c#1))));

// function declaration for Multisets._default.IsIdentitySimple
function Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A: Ty, add#0: HandleType, zero#0: Box)
   : bool;

function Multisets.__default.IsIdentitySimple#canCall(Multisets._default.IsIdentitySimple$A: Ty, add#0: HandleType, zero#0: Box)
   : bool;

// consequence axiom for Multisets.__default.IsIdentitySimple
axiom true
   ==> (forall Multisets._default.IsIdentitySimple$A: Ty, add#0: HandleType, zero#0: Box :: 
    { Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, add#0, zero#0) } 
    Multisets.__default.IsIdentitySimple#canCall(Multisets._default.IsIdentitySimple$A, add#0, zero#0)
         || ($Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A))
           && $IsBox(zero#0, Multisets._default.IsIdentitySimple$A))
       ==> true);

function Multisets.__default.IsIdentitySimple#requires(Ty, HandleType, Box) : bool;

// #requires axiom for Multisets.__default.IsIdentitySimple
axiom (forall Multisets._default.IsIdentitySimple$A: Ty, 
    $Heap: Heap, 
    add#0: HandleType, 
    zero#0: Box :: 
  { Multisets.__default.IsIdentitySimple#requires(Multisets._default.IsIdentitySimple$A, add#0, zero#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hTotalFunc2(Multisets._default.IsIdentitySimple$A, 
          Multisets._default.IsIdentitySimple$A, 
          Multisets._default.IsIdentitySimple$A))
       && $IsBox(zero#0, Multisets._default.IsIdentitySimple$A)
     ==> Multisets.__default.IsIdentitySimple#requires(Multisets._default.IsIdentitySimple$A, add#0, zero#0)
       == true);

// definition axiom for Multisets.__default.IsIdentitySimple(revealed)
axiom true
   ==> (forall Multisets._default.IsIdentitySimple$A: Ty, 
      $Heap: Heap, 
      add#0: HandleType, 
      zero#0: Box :: 
    { Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, add#0, zero#0), $IsGoodHeap($Heap) } 
    Multisets.__default.IsIdentitySimple#canCall(Multisets._default.IsIdentitySimple$A, add#0, zero#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A))
           && $IsBox(zero#0, Multisets._default.IsIdentitySimple$A))
       ==> Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentitySimple$A, 
          $Heap, 
          add#0, 
          Lit(AtLayer((lambda $l#7#ly#0: LayerType :: 
                Handle1((lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                    $IsBox($l#7#x#0, Multisets._default.IsIdentitySimple$A)), 
                  (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), 
              $LS($LZ))), 
          zero#0)
         && Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, add#0, zero#0)
           == Multisets.__default.IsIdentity(Multisets._default.IsIdentitySimple$A, 
            StartFuel_Multisets._default.IsIdentity, 
            $Heap, 
            add#0, 
            Lit(AtLayer((lambda $l#8#ly#0: LayerType :: 
                  Handle1((lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: 
                      $IsBox($l#8#x#0, Multisets._default.IsIdentitySimple$A)), 
                    (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), 
                $LS($LZ))), 
            zero#0));

// definition axiom for Multisets.__default.IsIdentitySimple for all literals(revealed)
axiom true
   ==> (forall Multisets._default.IsIdentitySimple$A: Ty, 
      $Heap: Heap, 
      add#0: HandleType, 
      zero#0: Box :: 
    {:weight 3} { Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, Lit(add#0), Lit(zero#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.IsIdentitySimple#canCall(Multisets._default.IsIdentitySimple$A, Lit(add#0), Lit(zero#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A))
           && $IsBox(zero#0, Multisets._default.IsIdentitySimple$A))
       ==> Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentitySimple$A, 
          $Heap, 
          Lit(add#0), 
          Lit(AtLayer((lambda $l#10#ly#0: LayerType :: 
                Handle1((lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: 
                    $IsBox($l#10#x#0, Multisets._default.IsIdentitySimple$A)), 
                  (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), 
              $LS($LZ))), 
          Lit(zero#0))
         && Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, Lit(add#0), Lit(zero#0))
           == Multisets.__default.IsIdentity(Multisets._default.IsIdentitySimple$A, 
            StartFuel_Multisets._default.IsIdentity, 
            $Heap, 
            Lit(add#0), 
            Lit(AtLayer((lambda $l#11#ly#0: LayerType :: 
                  Handle1((lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: 
                      $IsBox($l#11#x#0, Multisets._default.IsIdentitySimple$A)), 
                    (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), 
                $LS($LZ))), 
            Lit(zero#0)));

// function declaration for Multisets._default.IsCommutativeSimple
function Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A: Ty, add#0: HandleType) : bool;

function Multisets.__default.IsCommutativeSimple#canCall(Multisets._default.IsCommutativeSimple$A: Ty, add#0: HandleType) : bool;

// consequence axiom for Multisets.__default.IsCommutativeSimple
axiom true
   ==> (forall Multisets._default.IsCommutativeSimple$A: Ty, add#0: HandleType :: 
    { Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, add#0) } 
    Multisets.__default.IsCommutativeSimple#canCall(Multisets._default.IsCommutativeSimple$A, add#0)
         || $Is(add#0, 
          Tclass._System.___hTotalFunc2(Multisets._default.IsCommutativeSimple$A, 
            Multisets._default.IsCommutativeSimple$A, 
            Multisets._default.IsCommutativeSimple$A))
       ==> true);

function Multisets.__default.IsCommutativeSimple#requires(Ty, HandleType) : bool;

// #requires axiom for Multisets.__default.IsCommutativeSimple
axiom (forall Multisets._default.IsCommutativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
  { Multisets.__default.IsCommutativeSimple#requires(Multisets._default.IsCommutativeSimple$A, add#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hTotalFunc2(Multisets._default.IsCommutativeSimple$A, 
          Multisets._default.IsCommutativeSimple$A, 
          Multisets._default.IsCommutativeSimple$A))
     ==> Multisets.__default.IsCommutativeSimple#requires(Multisets._default.IsCommutativeSimple$A, add#0)
       == true);

// definition axiom for Multisets.__default.IsCommutativeSimple(revealed)
axiom true
   ==> (forall Multisets._default.IsCommutativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
    { Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, add#0), $IsGoodHeap($Heap) } 
    Multisets.__default.IsCommutativeSimple#canCall(Multisets._default.IsCommutativeSimple$A, add#0)
         || ($IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsCommutativeSimple$A, 
              Multisets._default.IsCommutativeSimple$A, 
              Multisets._default.IsCommutativeSimple$A)))
       ==> Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutativeSimple$A, 
          $Heap, 
          add#0, 
          Lit(AtLayer((lambda $l#7#ly#0: LayerType :: 
                Handle1((lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                    $IsBox($l#7#x#0, Multisets._default.IsCommutativeSimple$A)), 
                  (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), 
              $LS($LZ))))
         && Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, add#0)
           == Multisets.__default.IsCommutative(Multisets._default.IsCommutativeSimple$A, 
            StartFuel_Multisets._default.IsCommutative, 
            $Heap, 
            add#0, 
            Lit(AtLayer((lambda $l#8#ly#0: LayerType :: 
                  Handle1((lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: 
                      $IsBox($l#8#x#0, Multisets._default.IsCommutativeSimple$A)), 
                    (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), 
                $LS($LZ)))));

// definition axiom for Multisets.__default.IsCommutativeSimple for all literals(revealed)
axiom true
   ==> (forall Multisets._default.IsCommutativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
    {:weight 3} { Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, Lit(add#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.IsCommutativeSimple#canCall(Multisets._default.IsCommutativeSimple$A, Lit(add#0))
         || ($IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsCommutativeSimple$A, 
              Multisets._default.IsCommutativeSimple$A, 
              Multisets._default.IsCommutativeSimple$A)))
       ==> Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutativeSimple$A, 
          $Heap, 
          Lit(add#0), 
          Lit(AtLayer((lambda $l#10#ly#0: LayerType :: 
                Handle1((lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: 
                    $IsBox($l#10#x#0, Multisets._default.IsCommutativeSimple$A)), 
                  (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), 
              $LS($LZ))))
         && Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, Lit(add#0))
           == Multisets.__default.IsCommutative(Multisets._default.IsCommutativeSimple$A, 
            StartFuel_Multisets._default.IsCommutative, 
            $Heap, 
            Lit(add#0), 
            Lit(AtLayer((lambda $l#11#ly#0: LayerType :: 
                  Handle1((lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: 
                      $IsBox($l#11#x#0, Multisets._default.IsCommutativeSimple$A)), 
                    (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), 
                $LS($LZ)))));

// function declaration for Multisets._default.IsAssociativeSimple
function Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A: Ty, add#0: HandleType) : bool;

function Multisets.__default.IsAssociativeSimple#canCall(Multisets._default.IsAssociativeSimple$A: Ty, add#0: HandleType) : bool;

// consequence axiom for Multisets.__default.IsAssociativeSimple
axiom true
   ==> (forall Multisets._default.IsAssociativeSimple$A: Ty, add#0: HandleType :: 
    { Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, add#0) } 
    Multisets.__default.IsAssociativeSimple#canCall(Multisets._default.IsAssociativeSimple$A, add#0)
         || $Is(add#0, 
          Tclass._System.___hTotalFunc2(Multisets._default.IsAssociativeSimple$A, 
            Multisets._default.IsAssociativeSimple$A, 
            Multisets._default.IsAssociativeSimple$A))
       ==> true);

function Multisets.__default.IsAssociativeSimple#requires(Ty, HandleType) : bool;

// #requires axiom for Multisets.__default.IsAssociativeSimple
axiom (forall Multisets._default.IsAssociativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
  { Multisets.__default.IsAssociativeSimple#requires(Multisets._default.IsAssociativeSimple$A, add#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hTotalFunc2(Multisets._default.IsAssociativeSimple$A, 
          Multisets._default.IsAssociativeSimple$A, 
          Multisets._default.IsAssociativeSimple$A))
     ==> Multisets.__default.IsAssociativeSimple#requires(Multisets._default.IsAssociativeSimple$A, add#0)
       == true);

// definition axiom for Multisets.__default.IsAssociativeSimple(revealed)
axiom true
   ==> (forall Multisets._default.IsAssociativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
    { Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, add#0), $IsGoodHeap($Heap) } 
    Multisets.__default.IsAssociativeSimple#canCall(Multisets._default.IsAssociativeSimple$A, add#0)
         || ($IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsAssociativeSimple$A, 
              Multisets._default.IsAssociativeSimple$A, 
              Multisets._default.IsAssociativeSimple$A)))
       ==> Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociativeSimple$A, 
          $Heap, 
          add#0, 
          Lit(AtLayer((lambda $l#7#ly#0: LayerType :: 
                Handle1((lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                    $IsBox($l#7#x#0, Multisets._default.IsAssociativeSimple$A)), 
                  (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), 
              $LS($LZ))))
         && Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, add#0)
           == Multisets.__default.IsAssociative(Multisets._default.IsAssociativeSimple$A, 
            StartFuel_Multisets._default.IsAssociative, 
            $Heap, 
            add#0, 
            Lit(AtLayer((lambda $l#8#ly#0: LayerType :: 
                  Handle1((lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: 
                      $IsBox($l#8#x#0, Multisets._default.IsAssociativeSimple$A)), 
                    (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), 
                $LS($LZ)))));

// definition axiom for Multisets.__default.IsAssociativeSimple for all literals(revealed)
axiom true
   ==> (forall Multisets._default.IsAssociativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
    {:weight 3} { Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, Lit(add#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.IsAssociativeSimple#canCall(Multisets._default.IsAssociativeSimple$A, Lit(add#0))
         || ($IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsAssociativeSimple$A, 
              Multisets._default.IsAssociativeSimple$A, 
              Multisets._default.IsAssociativeSimple$A)))
       ==> Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociativeSimple$A, 
          $Heap, 
          Lit(add#0), 
          Lit(AtLayer((lambda $l#10#ly#0: LayerType :: 
                Handle1((lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: 
                    $IsBox($l#10#x#0, Multisets._default.IsAssociativeSimple$A)), 
                  (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), 
              $LS($LZ))))
         && Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, Lit(add#0))
           == Multisets.__default.IsAssociative(Multisets._default.IsAssociativeSimple$A, 
            StartFuel_Multisets._default.IsAssociative, 
            $Heap, 
            Lit(add#0), 
            Lit(AtLayer((lambda $l#11#ly#0: LayerType :: 
                  Handle1((lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: 
                      $IsBox($l#11#x#0, Multisets._default.IsAssociativeSimple$A)), 
                    (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), 
                $LS($LZ)))));

// function declaration for Multisets._default.AddNat
function Multisets.__default.AddNat(x#0: int, y#0: int) : int;

function Multisets.__default.AddNat#canCall(x#0: int, y#0: int) : bool;

// consequence axiom for Multisets.__default.AddNat
axiom true
   ==> (forall x#0: int, y#0: int :: 
    { Multisets.__default.AddNat(x#0, y#0) } 
    Multisets.__default.AddNat#canCall(x#0, y#0)
         || (LitInt(0) <= x#0 && LitInt(0) <= y#0)
       ==> LitInt(0) <= Multisets.__default.AddNat(x#0, y#0));

function Multisets.__default.AddNat#requires(int, int) : bool;

// #requires axiom for Multisets.__default.AddNat
axiom (forall x#0: int, y#0: int :: 
  { Multisets.__default.AddNat#requires(x#0, y#0) } 
  LitInt(0) <= x#0 && LitInt(0) <= y#0
     ==> Multisets.__default.AddNat#requires(x#0, y#0) == true);

// definition axiom for Multisets.__default.AddNat(revealed)
axiom true
   ==> (forall x#0: int, y#0: int :: 
    { Multisets.__default.AddNat(x#0, y#0) } 
    Multisets.__default.AddNat#canCall(x#0, y#0)
         || (LitInt(0) <= x#0 && LitInt(0) <= y#0)
       ==> Multisets.__default.AddNat(x#0, y#0) == x#0 + y#0);

// definition axiom for Multisets.__default.AddNat for all literals(revealed)
axiom true
   ==> (forall x#0: int, y#0: int :: 
    {:weight 3} { Multisets.__default.AddNat(LitInt(x#0), LitInt(y#0)) } 
    Multisets.__default.AddNat#canCall(LitInt(x#0), LitInt(y#0))
         || (LitInt(0) <= x#0 && LitInt(0) <= y#0)
       ==> Multisets.__default.AddNat(LitInt(x#0), LitInt(y#0)) == LitInt(x#0 + y#0));

// function declaration for Multisets._default.ValueMultisetFn
function Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A: Ty, 
    Multisets._default.ValueMultisetFn$B: Ty, 
    m#0: Map Box Box)
   : HandleType;

function Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultisetFn$A: Ty, 
    Multisets._default.ValueMultisetFn$B: Ty, 
    m#0: Map Box Box)
   : bool;

// consequence axiom for Multisets.__default.ValueMultisetFn
axiom true
   ==> (forall Multisets._default.ValueMultisetFn$A: Ty, 
      Multisets._default.ValueMultisetFn$B: Ty, 
      m#0: Map Box Box :: 
    { Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0) } 
    Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0)
         || $Is(m#0, 
          TMap(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B))
       ==> $Is(Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0), 
        Tclass._System.___hFunc1(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B)));

function Multisets.__default.ValueMultisetFn#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Multisets.__default.ValueMultisetFn
axiom (forall Multisets._default.ValueMultisetFn$A: Ty, 
    Multisets._default.ValueMultisetFn$B: Ty, 
    m#0: Map Box Box :: 
  { Multisets.__default.ValueMultisetFn#requires(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0) } 
  $Is(m#0, 
      TMap(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B))
     ==> Multisets.__default.ValueMultisetFn#requires(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0)
       == true);

// definition axiom for Multisets.__default.ValueMultisetFn(revealed)
axiom true
   ==> (forall Multisets._default.ValueMultisetFn$A: Ty, 
      Multisets._default.ValueMultisetFn$B: Ty, 
      m#0: Map Box Box :: 
    { Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0) } 
    Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0)
         || $Is(m#0, 
          TMap(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B))
       ==> Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0)
         == Lit(AtLayer((lambda $l#5#ly#0: LayerType :: 
              Handle1((lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: Map#Elements(m#0)[$l#5#x#0]), 
                (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                  $IsBox($l#5#x#0, Multisets._default.ValueMultisetFn$A)
                     && Map#Domain(m#0)[$l#5#x#0]), 
                (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                  SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), 
            $LS($LZ))));

// definition axiom for Multisets.__default.ValueMultisetFn for all literals(revealed)
axiom true
   ==> (forall Multisets._default.ValueMultisetFn$A: Ty, 
      Multisets._default.ValueMultisetFn$B: Ty, 
      m#0: Map Box Box :: 
    {:weight 3} { Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, 
        Multisets._default.ValueMultisetFn$B, 
        Lit(m#0)) } 
    Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultisetFn$A, 
          Multisets._default.ValueMultisetFn$B, 
          Lit(m#0))
         || $Is(m#0, 
          TMap(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B))
       ==> Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, 
          Multisets._default.ValueMultisetFn$B, 
          Lit(m#0))
         == Lit(AtLayer((lambda $l#7#ly#0: LayerType :: 
              Handle1((lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: Map#Elements(Lit(m#0))[$l#7#x#0]), 
                (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                  $IsBox($l#7#x#0, Multisets._default.ValueMultisetFn$A)
                     && Map#Domain(m#0)[$l#7#x#0]), 
                (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                  SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), 
            $LS($LZ))));

// function declaration for Multisets._default.ValueMultiset
function Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A: Ty, 
    Multisets._default.ValueMultiset$B: Ty, 
    m#0: Map Box Box)
   : MultiSet Box;

function Multisets.__default.ValueMultiset#canCall(Multisets._default.ValueMultiset$A: Ty, 
    Multisets._default.ValueMultiset$B: Ty, 
    m#0: Map Box Box)
   : bool;

// consequence axiom for Multisets.__default.ValueMultiset
axiom true
   ==> (forall Multisets._default.ValueMultiset$A: Ty, 
      Multisets._default.ValueMultiset$B: Ty, 
      m#0: Map Box Box :: 
    { Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0) } 
    Multisets.__default.ValueMultiset#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
         || $Is(m#0, 
          TMap(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B))
       ==> $Is(Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), 
        TMultiSet(Multisets._default.ValueMultiset$B)));

function Multisets.__default.ValueMultiset#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Multisets.__default.ValueMultiset
axiom (forall Multisets._default.ValueMultiset$A: Ty, 
    Multisets._default.ValueMultiset$B: Ty, 
    $Heap: Heap, 
    m#0: Map Box Box :: 
  { Multisets.__default.ValueMultiset#requires(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, 
        TMap(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B))
     ==> Multisets.__default.ValueMultiset#requires(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
       == true);

// definition axiom for Multisets.__default.ValueMultiset(revealed)
axiom true
   ==> (forall Multisets._default.ValueMultiset$A: Ty, 
      Multisets._default.ValueMultiset$B: Ty, 
      $Heap: Heap, 
      m#0: Map Box Box :: 
    { Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), $IsGoodHeap($Heap) } 
    Multisets.__default.ValueMultiset#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
         || ($IsGoodHeap($Heap)
           && $Is(m#0, 
            TMap(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B)))
       ==> Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
         && Multisets.__default.Apply#canCall(Multisets._default.ValueMultiset$A, 
          Multisets._default.ValueMultiset$B, 
          $Heap, 
          Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), 
          MultiSet#FromSet(Map#Domain(m#0)))
         && Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
           == Multisets.__default.Apply(Multisets._default.ValueMultiset$A, 
            Multisets._default.ValueMultiset$B, 
            StartFuel_Multisets._default.Apply, 
            $Heap, 
            Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), 
            MultiSet#FromSet(Map#Domain(m#0))));

// definition axiom for Multisets.__default.ValueMultiset for all literals(revealed)
axiom true
   ==> (forall Multisets._default.ValueMultiset$A: Ty, 
      Multisets._default.ValueMultiset$B: Ty, 
      $Heap: Heap, 
      m#0: Map Box Box :: 
    {:weight 3} { Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.ValueMultiset#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))
         || ($IsGoodHeap($Heap)
           && $Is(m#0, 
            TMap(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B)))
       ==> Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))
         && Multisets.__default.Apply#canCall(Multisets._default.ValueMultiset$A, 
          Multisets._default.ValueMultiset$B, 
          $Heap, 
          Lit(Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))), 
          MultiSet#FromSet(Lit(Map#Domain(Lit(m#0)))))
         && Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))
           == Multisets.__default.Apply(Multisets._default.ValueMultiset$A, 
            Multisets._default.ValueMultiset$B, 
            StartFuel_Multisets._default.Apply, 
            $Heap, 
            Lit(Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))), 
            MultiSet#FromSet(Lit(Map#Domain(Lit(m#0))))));

// Constructor function declaration
function #BucketsLib.Bucket.BucketMapWithSeq(Map Box Box, Seq Box, Seq Box) : DatatypeType;

const unique ##BucketsLib.Bucket.BucketMapWithSeq: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Map Box Box, a#0#1#0: Seq Box, a#0#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#BucketsLib.Bucket.BucketMapWithSeq(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##BucketsLib.Bucket.BucketMapWithSeq);

function BucketsLib.Bucket.BucketMapWithSeq_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BucketsLib.Bucket.BucketMapWithSeq_q(d) } 
  BucketsLib.Bucket.BucketMapWithSeq_q(d)
     <==> DatatypeCtorId(d) == ##BucketsLib.Bucket.BucketMapWithSeq);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BucketsLib.Bucket.BucketMapWithSeq_q(d) } 
  BucketsLib.Bucket.BucketMapWithSeq_q(d)
     ==> (exists a#1#0#0: Map Box Box, a#1#1#0: Seq Box, a#1#2#0: Seq Box :: 
      d == #BucketsLib.Bucket.BucketMapWithSeq(a#1#0#0, a#1#1#0, a#1#2#0)));

// Constructor $Is
axiom (forall a#2#0#0: Map Box Box, a#2#1#0: Seq Box, a#2#2#0: Seq Box :: 
  { $Is(#BucketsLib.Bucket.BucketMapWithSeq(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.BucketsLib.Bucket()) } 
  $Is(#BucketsLib.Bucket.BucketMapWithSeq(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.BucketsLib.Bucket())
     <==> $Is(a#2#0#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       && $Is(a#2#1#0, TSeq(Tclass.KeyType.Key()))
       && $Is(a#2#2#0, TSeq(Tclass.ValueMessage.Message())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Map Box Box, a#3#1#0: Seq Box, a#3#2#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#BucketsLib.Bucket.BucketMapWithSeq(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.BucketsLib.Bucket(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BucketsLib.Bucket.BucketMapWithSeq(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.BucketsLib.Bucket(), 
        $h)
       <==> $IsAlloc(a#3#0#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.KeyType.Key()), $h)
         && $IsAlloc(a#3#2#0, TSeq(Tclass.ValueMessage.Message()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketsLib.Bucket.b(d), 
      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BucketsLib.Bucket.BucketMapWithSeq_q(d)
       && $IsAlloc(d, Tclass.BucketsLib.Bucket(), $h)
     ==> $IsAlloc(BucketsLib.Bucket.b(d), 
      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketsLib.Bucket.keys(d), TSeq(Tclass.KeyType.Key()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketsLib.Bucket.BucketMapWithSeq_q(d)
       && $IsAlloc(d, Tclass.BucketsLib.Bucket(), $h)
     ==> $IsAlloc(BucketsLib.Bucket.keys(d), TSeq(Tclass.KeyType.Key()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketsLib.Bucket.msgs(d), TSeq(Tclass.ValueMessage.Message()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketsLib.Bucket.BucketMapWithSeq_q(d)
       && $IsAlloc(d, Tclass.BucketsLib.Bucket(), $h)
     ==> $IsAlloc(BucketsLib.Bucket.msgs(d), TSeq(Tclass.ValueMessage.Message()), $h));

// Constructor literal
axiom (forall a#4#0#0: Map Box Box, a#4#1#0: Seq Box, a#4#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(Lit(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0)) } 
  #BucketsLib.Bucket.BucketMapWithSeq(Lit(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0))
     == Lit(#BucketsLib.Bucket.BucketMapWithSeq(a#4#0#0, a#4#1#0, a#4#2#0)));

function BucketsLib.Bucket.b(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#5#0#0: Map Box Box, a#5#1#0: Seq Box, a#5#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#5#0#0, a#5#1#0, a#5#2#0) } 
  BucketsLib.Bucket.b(#BucketsLib.Bucket.BucketMapWithSeq(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

// Inductive map key rank
axiom (forall a#6#0#0: Map Box Box, a#6#1#0: Seq Box, a#6#2#0: Seq Box, d: DatatypeType :: 
  { Map#Domain(a#6#0#0)[$Box(d)], #BucketsLib.Bucket.BucketMapWithSeq(a#6#0#0, a#6#1#0, a#6#2#0) } 
  Map#Domain(a#6#0#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#6#0#0, a#6#1#0, a#6#2#0)));

// Inductive map value rank
axiom (forall a#7#0#0: Map Box Box, a#7#1#0: Seq Box, a#7#2#0: Seq Box, bx: Box :: 
  { Map#Domain(a#7#0#0)[bx], #BucketsLib.Bucket.BucketMapWithSeq(a#7#0#0, a#7#1#0, a#7#2#0) } 
  Map#Domain(a#7#0#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#7#0#0)[bx]): DatatypeType)
       < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#7#0#0, a#7#1#0, a#7#2#0)));

function BucketsLib.Bucket.keys(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#8#0#0: Map Box Box, a#8#1#0: Seq Box, a#8#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#8#0#0, a#8#1#0, a#8#2#0) } 
  BucketsLib.Bucket.keys(#BucketsLib.Bucket.BucketMapWithSeq(a#8#0#0, a#8#1#0, a#8#2#0))
     == a#8#1#0);

// Inductive seq element rank
axiom (forall a#9#0#0: Map Box Box, a#9#1#0: Seq Box, a#9#2#0: Seq Box, i: int :: 
  { Seq#Index(a#9#1#0, i), #BucketsLib.Bucket.BucketMapWithSeq(a#9#0#0, a#9#1#0, a#9#2#0) } 
  0 <= i && i < Seq#Length(a#9#1#0)
     ==> DtRank($Unbox(Seq#Index(a#9#1#0, i)): DatatypeType)
       < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#9#0#0, a#9#1#0, a#9#2#0)));

// Inductive seq rank
axiom (forall a#10#0#0: Map Box Box, a#10#1#0: Seq Box, a#10#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#10#0#0, a#10#1#0, a#10#2#0) } 
  Seq#Rank(a#10#1#0)
     < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#10#0#0, a#10#1#0, a#10#2#0)));

function BucketsLib.Bucket.msgs(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#11#0#0: Map Box Box, a#11#1#0: Seq Box, a#11#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#11#0#0, a#11#1#0, a#11#2#0) } 
  BucketsLib.Bucket.msgs(#BucketsLib.Bucket.BucketMapWithSeq(a#11#0#0, a#11#1#0, a#11#2#0))
     == a#11#2#0);

// Inductive seq element rank
axiom (forall a#12#0#0: Map Box Box, a#12#1#0: Seq Box, a#12#2#0: Seq Box, i: int :: 
  { Seq#Index(a#12#2#0, i), #BucketsLib.Bucket.BucketMapWithSeq(a#12#0#0, a#12#1#0, a#12#2#0) } 
  0 <= i && i < Seq#Length(a#12#2#0)
     ==> DtRank($Unbox(Seq#Index(a#12#2#0, i)): DatatypeType)
       < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#12#0#0, a#12#1#0, a#12#2#0)));

// Inductive seq rank
axiom (forall a#13#0#0: Map Box Box, a#13#1#0: Seq Box, a#13#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#13#0#0, a#13#1#0, a#13#2#0) } 
  Seq#Rank(a#13#2#0)
     < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#13#0#0, a#13#1#0, a#13#2#0)));

// Depth-one case-split function
function $IsA#BucketsLib.Bucket(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BucketsLib.Bucket(d) } 
  $IsA#BucketsLib.Bucket(d) ==> BucketsLib.Bucket.BucketMapWithSeq_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BucketsLib.Bucket.BucketMapWithSeq_q(d), $Is(d, Tclass.BucketsLib.Bucket()) } 
  $Is(d, Tclass.BucketsLib.Bucket()) ==> BucketsLib.Bucket.BucketMapWithSeq_q(d));

// Datatype extensional equality declaration
function BucketsLib.Bucket#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BucketsLib.Bucket.BucketMapWithSeq
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketsLib.Bucket#Equal(a, b) } 
  true
     ==> (BucketsLib.Bucket#Equal(a, b)
       <==> Map#Equal(BucketsLib.Bucket.b(a), BucketsLib.Bucket.b(b))
         && Seq#Equal(BucketsLib.Bucket.keys(a), BucketsLib.Bucket.keys(b))
         && Seq#Equal(BucketsLib.Bucket.msgs(a), BucketsLib.Bucket.msgs(b))));

// Datatype extensionality axiom: BucketsLib.Bucket
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketsLib.Bucket#Equal(a, b) } 
  BucketsLib.Bucket#Equal(a, b) <==> a == b);

const unique class.BucketsLib.Bucket: ClassName;

const unique class.BucketsLib.__default: ClassName;

function Tclass.BucketsLib.__default() : Ty;

// Tclass.BucketsLib.__default Tag
axiom Tag(Tclass.BucketsLib.__default()) == Tagclass.BucketsLib.__default;

const unique Tagclass.BucketsLib.__default: TyTag;

// Box/unbox axiom for Tclass.BucketsLib.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketsLib.__default()) } 
  $IsBox(bx, Tclass.BucketsLib.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BucketsLib.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BucketsLib.__default()) } 
  $Is($o, Tclass.BucketsLib.__default())
     <==> $o == null || dtype($o) == Tclass.BucketsLib.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BucketsLib.__default(), $h) } 
  $IsAlloc($o, Tclass.BucketsLib.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BucketsLib._default.maximumKey
function BucketsLib.__default.maximumKey(b#0: Set Box) : DatatypeType;

function BucketsLib.__default.maximumKey#canCall(b#0: Set Box) : bool;

// consequence axiom for BucketsLib.__default.maximumKey
axiom true
   ==> (forall b#0: Set Box :: 
    { BucketsLib.__default.maximumKey(b#0) } 
    BucketsLib.__default.maximumKey#canCall(b#0)
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> $Is(BucketsLib.__default.maximumKey(b#0), 
        Tclass.Options.Option(Tclass.KeyType.Key())));

function BucketsLib.__default.maximumKey#requires(Set Box) : bool;

// #requires axiom for BucketsLib.__default.maximumKey
axiom (forall b#0: Set Box :: 
  { BucketsLib.__default.maximumKey#requires(b#0) } 
  $Is(b#0, TSet(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.maximumKey#requires(b#0) == true);

// definition axiom for BucketsLib.__default.maximumKey(revealed)
axiom true
   ==> (forall b#0: Set Box :: 
    { BucketsLib.__default.maximumKey(b#0) } 
    BucketsLib.__default.maximumKey#canCall(b#0)
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.maximumOpt#canCall(b#0)
         && BucketsLib.__default.maximumKey(b#0)
           == (var m#2 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, b#0); 
            (if Options.Option.Some_q(m#2)
               then (var k#2 := $Unbox(Options.Option.value(m#2)): Seq Box; 
                #Options.Option.Some($Box(k#2)))
               else #Options.Option.None())));

// definition axiom for BucketsLib.__default.maximumKey for all literals(revealed)
axiom true
   ==> (forall b#0: Set Box :: 
    {:weight 3} { BucketsLib.__default.maximumKey(Lit(b#0)) } 
    BucketsLib.__default.maximumKey#canCall(Lit(b#0))
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.maximumOpt#canCall(Lit(b#0))
         && BucketsLib.__default.maximumKey(Lit(b#0))
           == (var m#3 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, Lit(b#0)); 
            (if Options.Option.Some_q(m#3)
               then (var k#3 := $Unbox(Options.Option.value(m#3)): Seq Box; 
                #Options.Option.Some($Box(k#3)))
               else #Options.Option.None())));

// function declaration for BucketsLib._default.minimumKey
function BucketsLib.__default.minimumKey(b#0: Set Box) : DatatypeType;

function BucketsLib.__default.minimumKey#canCall(b#0: Set Box) : bool;

// consequence axiom for BucketsLib.__default.minimumKey
axiom true
   ==> (forall b#0: Set Box :: 
    { BucketsLib.__default.minimumKey(b#0) } 
    BucketsLib.__default.minimumKey#canCall(b#0)
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> $Is(BucketsLib.__default.minimumKey(b#0), 
        Tclass.Options.Option(Tclass.KeyType.Key())));

function BucketsLib.__default.minimumKey#requires(Set Box) : bool;

// #requires axiom for BucketsLib.__default.minimumKey
axiom (forall b#0: Set Box :: 
  { BucketsLib.__default.minimumKey#requires(b#0) } 
  $Is(b#0, TSet(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.minimumKey#requires(b#0) == true);

// definition axiom for BucketsLib.__default.minimumKey(revealed)
axiom true
   ==> (forall b#0: Set Box :: 
    { BucketsLib.__default.minimumKey(b#0) } 
    BucketsLib.__default.minimumKey#canCall(b#0)
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.minimumOpt#canCall(b#0)
         && BucketsLib.__default.minimumKey(b#0)
           == (var m#2 := Lexicographic__Byte__Order.__default.minimumOpt(StartFuel_Lexicographic_Byte_Order._default.minimumOpt, b#0); 
            (if Options.Option.Some_q(m#2)
               then (var k#2 := $Unbox(Options.Option.value(m#2)): Seq Box; 
                #Options.Option.Some($Box(k#2)))
               else #Options.Option.None())));

// definition axiom for BucketsLib.__default.minimumKey for all literals(revealed)
axiom true
   ==> (forall b#0: Set Box :: 
    {:weight 3} { BucketsLib.__default.minimumKey(Lit(b#0)) } 
    BucketsLib.__default.minimumKey#canCall(Lit(b#0))
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.minimumOpt#canCall(Lit(b#0))
         && BucketsLib.__default.minimumKey(Lit(b#0))
           == (var m#3 := Lexicographic__Byte__Order.__default.minimumOpt(StartFuel_Lexicographic_Byte_Order._default.minimumOpt, Lit(b#0)); 
            (if Options.Option.Some_q(m#3)
               then (var k#3 := $Unbox(Options.Option.value(m#3)): Seq Box; 
                #Options.Option.Some($Box(k#3)))
               else #Options.Option.None())));

// function declaration for BucketsLib._default.BucketMapOfSeq
function BucketsLib.__default.BucketMapOfSeq($ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box) : Map Box Box;

function BucketsLib.__default.BucketMapOfSeq#canCall(keys#0: Seq Box, msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
  { BucketsLib.__default.BucketMapOfSeq($LS($ly), keys#0, msgs#0) } 
  BucketsLib.__default.BucketMapOfSeq($LS($ly), keys#0, msgs#0)
     == BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
  { BucketsLib.__default.BucketMapOfSeq(AsFuelBottom($ly), keys#0, msgs#0) } 
  BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0)
     == BucketsLib.__default.BucketMapOfSeq($LZ, keys#0, msgs#0));

// consequence axiom for BucketsLib.__default.BucketMapOfSeq
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
    { BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0) } 
    BucketsLib.__default.BucketMapOfSeq#canCall(keys#0, msgs#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(keys#0) == Seq#Length(msgs#0))
       ==> Set#Equal(Map#Domain(BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0)), 
          Sequences.__default.Set(Tclass.KeyType.Key(), keys#0))
         && Set#Subset(Map#Values(BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0)), 
          Sequences.__default.Set(Tclass.ValueMessage.Message(), msgs#0))
         && $Is(BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0), 
          TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

function BucketsLib.__default.BucketMapOfSeq#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketMapOfSeq
axiom (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
  { BucketsLib.__default.BucketMapOfSeq#requires($ly, keys#0, msgs#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.BucketMapOfSeq#requires($ly, keys#0, msgs#0)
       == 
      (Seq#Length(keys#0)
       == Seq#Length(msgs#0)));

// definition axiom for BucketsLib.__default.BucketMapOfSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
    { BucketsLib.__default.BucketMapOfSeq($LS($ly), keys#0, msgs#0) } 
    BucketsLib.__default.BucketMapOfSeq#canCall(keys#0, msgs#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(keys#0) == Seq#Length(msgs#0))
       ==> (Seq#Length(keys#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), keys#0)
             && Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), msgs#0)
             && BucketsLib.__default.BucketMapOfSeq#canCall(Sequences.__default.DropLast(Tclass.KeyType.Key(), keys#0), 
              Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), keys#0)
             && Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), msgs#0))
         && BucketsLib.__default.BucketMapOfSeq($LS($ly), keys#0, msgs#0)
           == (if Seq#Length(keys#0) == LitInt(0)
             then Map#Empty(): Map Box Box
             else (var r'#2 := BucketsLib.__default.BucketMapOfSeq($ly, 
                  Sequences.__default.DropLast(Tclass.KeyType.Key(), keys#0), 
                  Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0)); 
              (var r#2 := Map#Build(r'#2, 
                    Sequences.__default.Last(Tclass.KeyType.Key(), keys#0), 
                    Sequences.__default.Last(Tclass.ValueMessage.Message(), msgs#0)); 
                r#2))));

// definition axiom for BucketsLib.__default.BucketMapOfSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketMapOfSeq($LS($ly), Lit(keys#0), Lit(msgs#0)) } 
    BucketsLib.__default.BucketMapOfSeq#canCall(Lit(keys#0), Lit(msgs#0))
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(Lit(keys#0)) == Seq#Length(Lit(msgs#0)))
       ==> (Seq#Length(Lit(keys#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(keys#0))
             && Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0))
             && BucketsLib.__default.BucketMapOfSeq#canCall(Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(keys#0))), 
              Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(keys#0))
             && Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0)))
         && BucketsLib.__default.BucketMapOfSeq($LS($ly), Lit(keys#0), Lit(msgs#0))
           == (if Seq#Length(Lit(keys#0)) == LitInt(0)
             then Map#Empty(): Map Box Box
             else (var r'#3 := BucketsLib.__default.BucketMapOfSeq($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(keys#0))), 
                  Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0)))); 
              (var r#3 := Map#Build(r'#3, 
                    $Box(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(keys#0))): Seq Box)), 
                    $Box(Lit($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), Lit(msgs#0))): DatatypeType))); 
                r#3))));

// function declaration for BucketsLib._default.BucketOfSeq
function BucketsLib.__default.BucketOfSeq(keys#0: Seq Box, msgs#0: Seq Box) : DatatypeType;

function BucketsLib.__default.BucketOfSeq#canCall(keys#0: Seq Box, msgs#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketOfSeq
axiom true
   ==> (forall keys#0: Seq Box, msgs#0: Seq Box :: 
    { BucketsLib.__default.BucketOfSeq(keys#0, msgs#0) } 
    BucketsLib.__default.BucketOfSeq#canCall(keys#0, msgs#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(keys#0) == Seq#Length(msgs#0))
       ==> $Is(BucketsLib.__default.BucketOfSeq(keys#0, msgs#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketOfSeq#requires(Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketOfSeq
axiom (forall keys#0: Seq Box, msgs#0: Seq Box :: 
  { BucketsLib.__default.BucketOfSeq#requires(keys#0, msgs#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.BucketOfSeq#requires(keys#0, msgs#0)
       == 
      (Seq#Length(keys#0)
       == Seq#Length(msgs#0)));

// definition axiom for BucketsLib.__default.BucketOfSeq(revealed)
axiom true
   ==> (forall keys#0: Seq Box, msgs#0: Seq Box :: 
    { BucketsLib.__default.BucketOfSeq(keys#0, msgs#0) } 
    BucketsLib.__default.BucketOfSeq#canCall(keys#0, msgs#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(keys#0) == Seq#Length(msgs#0))
       ==> BucketsLib.__default.BucketMapOfSeq#canCall(keys#0, msgs#0)
         && BucketsLib.__default.BucketOfSeq(keys#0, msgs#0)
           == #BucketsLib.Bucket.BucketMapWithSeq(BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, keys#0, msgs#0), 
            keys#0, 
            msgs#0));

// definition axiom for BucketsLib.__default.BucketOfSeq for all literals(revealed)
axiom true
   ==> (forall keys#0: Seq Box, msgs#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketOfSeq(Lit(keys#0), Lit(msgs#0)) } 
    BucketsLib.__default.BucketOfSeq#canCall(Lit(keys#0), Lit(msgs#0))
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(Lit(keys#0)) == Seq#Length(Lit(msgs#0)))
       ==> BucketsLib.__default.BucketMapOfSeq#canCall(Lit(keys#0), Lit(msgs#0))
         && BucketsLib.__default.BucketOfSeq(Lit(keys#0), Lit(msgs#0))
           == #BucketsLib.Bucket.BucketMapWithSeq(BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, Lit(keys#0), Lit(msgs#0)), 
            Lit(keys#0), 
            Lit(msgs#0)));

// function declaration for BucketsLib._default.WFBucketMap
function BucketsLib.__default.WFBucketMap(bucket#0: Map Box Box) : bool;

function BucketsLib.__default.WFBucketMap#canCall(bucket#0: Map Box Box) : bool;

// consequence axiom for BucketsLib.__default.WFBucketMap
axiom true
   ==> (forall bucket#0: Map Box Box :: 
    { BucketsLib.__default.WFBucketMap(bucket#0) } 
    BucketsLib.__default.WFBucketMap#canCall(bucket#0)
         || $Is(bucket#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> true);

function BucketsLib.__default.WFBucketMap#requires(Map Box Box) : bool;

// #requires axiom for BucketsLib.__default.WFBucketMap
axiom (forall bucket#0: Map Box Box :: 
  { BucketsLib.__default.WFBucketMap#requires(bucket#0) } 
  $Is(bucket#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.WFBucketMap#requires(bucket#0) == true);

// definition axiom for BucketsLib.__default.WFBucketMap(revealed)
axiom true
   ==> (forall bucket#0: Map Box Box :: 
    { BucketsLib.__default.WFBucketMap(bucket#0) } 
    BucketsLib.__default.WFBucketMap#canCall(bucket#0)
         || $Is(bucket#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> (forall key#2: Seq Box :: 
          { $Unbox(Map#Elements(bucket#0)[$Box(key#2)]): DatatypeType } 
            { Map#Domain(bucket#0)[$Box(key#2)] } 
          $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Map#Domain(bucket#0)[$Box(key#2)]
             ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(bucket#0)[$Box(key#2)]): DatatypeType)
               && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
               && ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.WFBucketMap(bucket#0)
           == (forall key#2: Seq Box :: 
            { $Unbox(Map#Elements(bucket#0)[$Box(key#2)]): DatatypeType } 
              { Map#Domain(bucket#0)[$Box(key#2)] } 
            $Is(key#2, TSeq(Tclass.NativeTypes.byte())) && Map#Domain(bucket#0)[$Box(key#2)]
               ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(bucket#0)[$Box(key#2)]): DatatypeType, 
                ValueMessage.__default.IdentityMessage())));

// definition axiom for BucketsLib.__default.WFBucketMap for all literals(revealed)
axiom true
   ==> (forall bucket#0: Map Box Box :: 
    {:weight 3} { BucketsLib.__default.WFBucketMap(Lit(bucket#0)) } 
    BucketsLib.__default.WFBucketMap#canCall(Lit(bucket#0))
         || $Is(bucket#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> (forall key#3: Seq Box :: 
          { $Unbox(Map#Elements(bucket#0)[$Box(key#3)]): DatatypeType } 
            { Map#Domain(bucket#0)[$Box(key#3)] } 
          $Is(key#3, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Map#Domain(bucket#0)[$Box(key#3)]
             ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(Lit(bucket#0))[$Box(key#3)]): DatatypeType)
               && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
               && ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.WFBucketMap(Lit(bucket#0))
           == (forall key#3: Seq Box :: 
            { $Unbox(Map#Elements(bucket#0)[$Box(key#3)]): DatatypeType } 
              { Map#Domain(bucket#0)[$Box(key#3)] } 
            $Is(key#3, TSeq(Tclass.NativeTypes.byte())) && Map#Domain(bucket#0)[$Box(key#3)]
               ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(Lit(bucket#0))[$Box(key#3)]): DatatypeType, 
                ValueMessage.__default.IdentityMessage())));

// function declaration for BucketsLib._default.WFMessageSeq
function BucketsLib.__default.WFMessageSeq(messages#0: Seq Box) : bool;

function BucketsLib.__default.WFMessageSeq#canCall(messages#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.WFMessageSeq
axiom true
   ==> (forall messages#0: Seq Box :: 
    { BucketsLib.__default.WFMessageSeq(messages#0) } 
    BucketsLib.__default.WFMessageSeq#canCall(messages#0)
         || $Is(messages#0, TSeq(Tclass.ValueMessage.Message()))
       ==> true);

function BucketsLib.__default.WFMessageSeq#requires(Seq Box) : bool;

// #requires axiom for BucketsLib.__default.WFMessageSeq
axiom (forall messages#0: Seq Box :: 
  { BucketsLib.__default.WFMessageSeq#requires(messages#0) } 
  $Is(messages#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.WFMessageSeq#requires(messages#0) == true);

// definition axiom for BucketsLib.__default.WFMessageSeq(revealed)
axiom true
   ==> (forall messages#0: Seq Box :: 
    { BucketsLib.__default.WFMessageSeq(messages#0) } 
    BucketsLib.__default.WFMessageSeq#canCall(messages#0)
         || $Is(messages#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (forall i#2: int :: 
          { $Unbox(Seq#Index(messages#0, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(messages#0)
             ==> $IsA#ValueMessage.Message($Unbox(Seq#Index(messages#0, i#2)): DatatypeType)
               && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
               && ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.WFMessageSeq(messages#0)
           == (forall i#2: int :: 
            { $Unbox(Seq#Index(messages#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(messages#0)
               ==> !ValueMessage.Message#Equal($Unbox(Seq#Index(messages#0, i#2)): DatatypeType, 
                ValueMessage.__default.IdentityMessage())));

// definition axiom for BucketsLib.__default.WFMessageSeq for all literals(revealed)
axiom true
   ==> (forall messages#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.WFMessageSeq(Lit(messages#0)) } 
    BucketsLib.__default.WFMessageSeq#canCall(Lit(messages#0))
         || $Is(messages#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (forall i#3: int :: 
          { $Unbox(Seq#Index(messages#0, i#3)): DatatypeType } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(messages#0))
             ==> $IsA#ValueMessage.Message($Unbox(Seq#Index(Lit(messages#0), i#3)): DatatypeType)
               && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
               && ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.WFMessageSeq(Lit(messages#0))
           == (forall i#3: int :: 
            { $Unbox(Seq#Index(messages#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(messages#0))
               ==> !ValueMessage.Message#Equal($Unbox(Seq#Index(Lit(messages#0), i#3)): DatatypeType, 
                ValueMessage.__default.IdentityMessage())));

// function declaration for BucketsLib._default.PreWFBucket
function BucketsLib.__default.PreWFBucket(bucket#0: DatatypeType) : bool;

function BucketsLib.__default.PreWFBucket#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.PreWFBucket
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.PreWFBucket(bucket#0) } 
    BucketsLib.__default.PreWFBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> true);

function BucketsLib.__default.PreWFBucket#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.PreWFBucket
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.PreWFBucket#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.PreWFBucket#requires(bucket#0) == true);

// definition axiom for BucketsLib.__default.PreWFBucket(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.PreWFBucket(bucket#0) } 
    BucketsLib.__default.PreWFBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && (Seq#Length(BucketsLib.Bucket.keys(bucket#0))
             == Seq#Length(BucketsLib.Bucket.msgs(bucket#0))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.BucketMapOfSeq#canCall(BucketsLib.Bucket.keys(bucket#0), BucketsLib.Bucket.msgs(bucket#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0))
         && BucketsLib.__default.PreWFBucket(bucket#0)
           == (Seq#Length(BucketsLib.Bucket.keys(bucket#0))
               == Seq#Length(BucketsLib.Bucket.msgs(bucket#0))
             && Map#Equal(BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
                BucketsLib.Bucket.keys(bucket#0), 
                BucketsLib.Bucket.msgs(bucket#0)), 
              BucketsLib.Bucket.b(bucket#0))));

// definition axiom for BucketsLib.__default.PreWFBucket for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.PreWFBucket(Lit(bucket#0)) } 
    BucketsLib.__default.PreWFBucket#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && (Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
             == Seq#Length(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.BucketMapOfSeq#canCall(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), 
              Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0)))
         && BucketsLib.__default.PreWFBucket(Lit(bucket#0))
           == (Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
               == Seq#Length(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
             && Map#Equal(BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
                Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), 
                Lit(BucketsLib.Bucket.msgs(Lit(bucket#0)))), 
              BucketsLib.Bucket.b(Lit(bucket#0)))));

// function declaration for BucketsLib._default.WFBucket
function BucketsLib.__default.WFBucket(bucket#0: DatatypeType) : bool;

function BucketsLib.__default.WFBucket#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.WFBucket
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.WFBucket(bucket#0) } 
    BucketsLib.__default.WFBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> true);

function BucketsLib.__default.WFBucket#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.WFBucket
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.WFBucket#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.WFBucket#requires(bucket#0) == true);

// definition axiom for BucketsLib.__default.WFBucket(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.WFBucket(bucket#0) } 
    BucketsLib.__default.WFBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.__default.PreWFBucket#canCall(bucket#0)
         && (BucketsLib.__default.PreWFBucket(bucket#0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.WFBucketMap#canCall(BucketsLib.Bucket.b(bucket#0)))
         && (BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.WFBucketMap#canCall(BucketsLib.Bucket.b(bucket#0))
             && BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.WFMessageSeq#canCall(BucketsLib.Bucket.msgs(bucket#0)))
         && BucketsLib.__default.WFBucket(bucket#0)
           == (
            BucketsLib.__default.PreWFBucket(bucket#0)
             && BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
             && BucketsLib.__default.WFMessageSeq(BucketsLib.Bucket.msgs(bucket#0))));

// definition axiom for BucketsLib.__default.WFBucket for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.WFBucket(Lit(bucket#0)) } 
    BucketsLib.__default.WFBucket#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.__default.PreWFBucket#canCall(Lit(bucket#0))
         && (Lit(BucketsLib.__default.PreWFBucket(Lit(bucket#0)))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.WFBucketMap#canCall(Lit(BucketsLib.Bucket.b(Lit(bucket#0)))))
         && (BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.WFBucketMap#canCall(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))
             && Lit(BucketsLib.__default.WFBucketMap(Lit(BucketsLib.Bucket.b(Lit(bucket#0)))))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.WFMessageSeq#canCall(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0)))))
         && BucketsLib.__default.WFBucket(Lit(bucket#0))
           == Lit(BucketsLib.__default.PreWFBucket(Lit(bucket#0))
               && BucketsLib.__default.WFBucketMap(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))
               && BucketsLib.__default.WFMessageSeq(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))));

// function declaration for BucketsLib._default.BucketWellMarshalled
function BucketsLib.__default.BucketWellMarshalled(bucket#0: DatatypeType) : bool;

function BucketsLib.__default.BucketWellMarshalled#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketWellMarshalled
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.BucketWellMarshalled(bucket#0) } 
    BucketsLib.__default.BucketWellMarshalled#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> true);

function BucketsLib.__default.BucketWellMarshalled#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketWellMarshalled
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.BucketWellMarshalled#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.BucketWellMarshalled#requires(bucket#0) == true);

// definition axiom for BucketsLib.__default.BucketWellMarshalled(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.BucketWellMarshalled(bucket#0) } 
    BucketsLib.__default.BucketWellMarshalled#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(BucketsLib.Bucket.keys(bucket#0))
         && BucketsLib.__default.BucketWellMarshalled(bucket#0)
           == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            BucketsLib.Bucket.keys(bucket#0)));

// definition axiom for BucketsLib.__default.BucketWellMarshalled for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0)) } 
    BucketsLib.__default.BucketWellMarshalled#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
         && BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0))
           == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))));

// function declaration for BucketsLib._default.BucketListWellMarshalled
function BucketsLib.__default.BucketListWellMarshalled(blist#0: Seq Box) : bool;

function BucketsLib.__default.BucketListWellMarshalled#canCall(blist#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketListWellMarshalled
axiom true
   ==> (forall blist#0: Seq Box :: 
    { BucketsLib.__default.BucketListWellMarshalled(blist#0) } 
    BucketsLib.__default.BucketListWellMarshalled#canCall(blist#0)
         || $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> true);

function BucketsLib.__default.BucketListWellMarshalled#requires(Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketListWellMarshalled
axiom (forall blist#0: Seq Box :: 
  { BucketsLib.__default.BucketListWellMarshalled#requires(blist#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.BucketListWellMarshalled#requires(blist#0) == true);

// definition axiom for BucketsLib.__default.BucketListWellMarshalled(revealed)
axiom true
   ==> (forall blist#0: Seq Box :: 
    { BucketsLib.__default.BucketListWellMarshalled(blist#0) } 
    BucketsLib.__default.BucketListWellMarshalled#canCall(blist#0)
         || $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (forall i#2: int :: 
          { $Unbox(Seq#Index(blist#0, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(blist#0)
             ==> BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(blist#0, i#2)): DatatypeType))
         && BucketsLib.__default.BucketListWellMarshalled(blist#0)
           == (forall i#2: int :: 
            { $Unbox(Seq#Index(blist#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(blist#0)
               ==> BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(blist#0, i#2)): DatatypeType)));

// definition axiom for BucketsLib.__default.BucketListWellMarshalled for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketListWellMarshalled(Lit(blist#0)) } 
    BucketsLib.__default.BucketListWellMarshalled#canCall(Lit(blist#0))
         || $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (forall i#3: int :: 
          { $Unbox(Seq#Index(blist#0, i#3)): DatatypeType } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(blist#0))
             ==> BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(Lit(blist#0), i#3)): DatatypeType))
         && BucketsLib.__default.BucketListWellMarshalled(Lit(blist#0))
           == (forall i#3: int :: 
            { $Unbox(Seq#Index(blist#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(blist#0))
               ==> BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(Lit(blist#0), i#3)): DatatypeType)));

// function declaration for BucketsLib._default.BInternal
function BucketsLib.__default.BInternal($ly: LayerType, m#0: Map Box Box) : DatatypeType;

function BucketsLib.__default.BInternal#canCall(m#0: Map Box Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.BInternal($LS($ly), m#0) } 
  BucketsLib.__default.BInternal($LS($ly), m#0)
     == BucketsLib.__default.BInternal($ly, m#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.BInternal(AsFuelBottom($ly), m#0) } 
  BucketsLib.__default.BInternal($ly, m#0)
     == BucketsLib.__default.BInternal($LZ, m#0));

// consequence axiom for BucketsLib.__default.BInternal
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.BInternal($ly, m#0) } 
    BucketsLib.__default.BInternal#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> Map#Equal(BucketsLib.Bucket.b(BucketsLib.__default.BInternal($ly, m#0)), m#0)
         && Seq#Length(BucketsLib.Bucket.keys(BucketsLib.__default.BInternal($ly, m#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketsLib.__default.BInternal($ly, m#0)))
         && $Is(BucketsLib.__default.BInternal($ly, m#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BInternal#requires(LayerType, Map Box Box) : bool;

// #requires axiom for BucketsLib.__default.BInternal
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.BInternal#requires($ly, m#0) } 
  $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.BInternal#requires($ly, m#0) == true);

// definition axiom for BucketsLib.__default.BInternal(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.BInternal($LS($ly), m#0) } 
    BucketsLib.__default.BInternal#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> (Set#Card(Map#Domain(m#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(Map#Domain(m#0))
             && (var maxkey#2 := Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Map#Domain(m#0)); 
              Maps.__default.MapRemove1#canCall(TSeq(Tclass.NativeTypes.byte()), 
                  Tclass.ValueMessage.Message(), 
                  m#0, 
                  $Box(maxkey#2))
                 && (var subm#2 := Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                      Tclass.ValueMessage.Message(), 
                      StartFuel_Maps._default.MapRemove1, 
                      m#0, 
                      $Box(maxkey#2)); 
                  BucketsLib.__default.BInternal#canCall(subm#2)
                     && (var subbucket#2 := BucketsLib.__default.BInternal($ly, subm#2); 
                      BucketsLib.Bucket.BucketMapWithSeq_q(subbucket#2)
                         && BucketsLib.Bucket.BucketMapWithSeq_q(subbucket#2)))))
         && BucketsLib.__default.BInternal($LS($ly), m#0)
           == (if Set#Card(Map#Domain(m#0)) == LitInt(0)
             then #BucketsLib.Bucket.BucketMapWithSeq(m#0, Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box))
             else (var maxkey#2 := Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Map#Domain(m#0)); 
              (var maxmsg#2 := $Unbox(Map#Elements(m#0)[$Box(maxkey#2)]): DatatypeType; 
                (var subm#2 := Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                      Tclass.ValueMessage.Message(), 
                      StartFuel_Maps._default.MapRemove1, 
                      m#0, 
                      $Box(maxkey#2)); 
                  (var subbucket#2 := BucketsLib.__default.BInternal($ly, subm#2); 
                    #BucketsLib.Bucket.BucketMapWithSeq(m#0, 
                      Seq#Append(BucketsLib.Bucket.keys(subbucket#2), 
                        Seq#Build(Seq#Empty(): Seq Box, $Box(maxkey#2))), 
                      Seq#Append(BucketsLib.Bucket.msgs(subbucket#2), 
                        Seq#Build(Seq#Empty(): Seq Box, $Box(maxmsg#2))))))))));

// definition axiom for BucketsLib.__default.BInternal for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    {:weight 3} { BucketsLib.__default.BInternal($LS($ly), Lit(m#0)) } 
    BucketsLib.__default.BInternal#canCall(Lit(m#0))
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> (Set#Card(Lit(Map#Domain(Lit(m#0)))) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(Lit(Map#Domain(Lit(m#0))))
             && (var maxkey#3 := Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Lit(Map#Domain(Lit(m#0)))); 
              Maps.__default.MapRemove1#canCall(TSeq(Tclass.NativeTypes.byte()), 
                  Tclass.ValueMessage.Message(), 
                  Lit(m#0), 
                  $Box(maxkey#3))
                 && (var subm#3 := Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                      Tclass.ValueMessage.Message(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(m#0), 
                      $Box(maxkey#3)); 
                  BucketsLib.__default.BInternal#canCall(subm#3)
                     && (var subbucket#3 := BucketsLib.__default.BInternal($LS($ly), subm#3); 
                      BucketsLib.Bucket.BucketMapWithSeq_q(subbucket#3)
                         && BucketsLib.Bucket.BucketMapWithSeq_q(subbucket#3)))))
         && BucketsLib.__default.BInternal($LS($ly), Lit(m#0))
           == (if Set#Card(Lit(Map#Domain(Lit(m#0)))) == LitInt(0)
             then #BucketsLib.Bucket.BucketMapWithSeq(Lit(m#0), Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box))
             else (var maxkey#3 := Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Lit(Map#Domain(Lit(m#0)))); 
              (var maxmsg#3 := $Unbox(Map#Elements(Lit(m#0))[$Box(maxkey#3)]): DatatypeType; 
                (var subm#3 := Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                      Tclass.ValueMessage.Message(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(m#0), 
                      $Box(maxkey#3)); 
                  (var subbucket#3 := BucketsLib.__default.BInternal($LS($ly), subm#3); 
                    #BucketsLib.Bucket.BucketMapWithSeq(Lit(m#0), 
                      Seq#Append(BucketsLib.Bucket.keys(subbucket#3), 
                        Seq#Build(Seq#Empty(): Seq Box, $Box(maxkey#3))), 
                      Seq#Append(BucketsLib.Bucket.msgs(subbucket#3), 
                        Seq#Build(Seq#Empty(): Seq Box, $Box(maxmsg#3))))))))));

// function declaration for BucketsLib._default.B
function BucketsLib.__default.B($ly: LayerType, m#0: Map Box Box) : DatatypeType;

function BucketsLib.__default.B#canCall(m#0: Map Box Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.B($LS($ly), m#0) } 
  BucketsLib.__default.B($LS($ly), m#0) == BucketsLib.__default.B($ly, m#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.B(AsFuelBottom($ly), m#0) } 
  BucketsLib.__default.B($ly, m#0) == BucketsLib.__default.B($LZ, m#0));

// consequence axiom for BucketsLib.__default.B
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.B($ly, m#0) } 
    BucketsLib.__default.B#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> Map#Equal(BucketsLib.Bucket.b(BucketsLib.__default.B($ly, m#0)), m#0)
         && BucketsLib.__default.PreWFBucket(BucketsLib.__default.B($ly, m#0))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.B($ly, m#0))
         && Seq#Length(BucketsLib.Bucket.keys(BucketsLib.__default.B($ly, m#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketsLib.__default.B($ly, m#0)))
         && (BucketsLib.__default.WFBucketMap(m#0)
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.B($ly, m#0)))
         && $Is(BucketsLib.__default.B($ly, m#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.B#requires(LayerType, Map Box Box) : bool;

// #requires axiom for BucketsLib.__default.B
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.B#requires($ly, m#0) } 
  $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.B#requires($ly, m#0) == true);

// definition axiom for BucketsLib.__default.B(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.B($LS($ly), m#0) } 
    BucketsLib.__default.B#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.WFBucketMap#canCall(m#0)
         && (BucketsLib.__default.WFBucketMap(m#0)
           ==> BucketsLib.__default.BInternal#canCall(m#0))
         && (!BucketsLib.__default.WFBucketMap(m#0)
           ==> BucketsLib.__default.BInternal#canCall(m#0))
         && BucketsLib.__default.B($LS($ly), m#0)
           == (if BucketsLib.__default.WFBucketMap(m#0)
             then BucketsLib.__default.BInternal($LS($LZ), m#0)
             else BucketsLib.__default.BInternal($LS($LZ), m#0)));

// definition axiom for BucketsLib.__default.B for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    {:weight 3} { BucketsLib.__default.B($LS($ly), Lit(m#0)) } 
    BucketsLib.__default.B#canCall(Lit(m#0))
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.WFBucketMap#canCall(Lit(m#0))
         && (Lit(BucketsLib.__default.WFBucketMap(Lit(m#0)))
           ==> BucketsLib.__default.BInternal#canCall(Lit(m#0)))
         && (!Lit(BucketsLib.__default.WFBucketMap(Lit(m#0)))
           ==> BucketsLib.__default.BInternal#canCall(Lit(m#0)))
         && BucketsLib.__default.B($LS($ly), Lit(m#0))
           == (if BucketsLib.__default.WFBucketMap(Lit(m#0))
             then BucketsLib.__default.BInternal($LS($LZ), Lit(m#0))
             else BucketsLib.__default.BInternal($LS($LZ), Lit(m#0))));

// function declaration for BucketsLib._default.EmptyBucket
function BucketsLib.__default.EmptyBucket() : DatatypeType;

function BucketsLib.__default.EmptyBucket#canCall() : bool;

// consequence axiom for BucketsLib.__default.EmptyBucket
axiom true
   ==> 
  true
   ==> BucketsLib.Bucket#Equal(BucketsLib.__default.EmptyBucket(), 
      BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)))
     && BucketsLib.__default.WFBucket(BucketsLib.__default.EmptyBucket())
     && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.EmptyBucket())
     && $Is(BucketsLib.__default.EmptyBucket(), Tclass.BucketsLib.Bucket());

function BucketsLib.__default.EmptyBucket#requires() : bool;

// #requires axiom for BucketsLib.__default.EmptyBucket
axiom BucketsLib.__default.EmptyBucket#requires() == true;

// definition axiom for BucketsLib.__default.EmptyBucket(revealed)
axiom true
   ==> 
  true
   ==> BucketsLib.__default.EmptyBucket()
     == (var b#2 := Lit(#BucketsLib.Bucket.BucketMapWithSeq(Lit(Map#Empty(): Map Box Box), 
            Lit(Seq#Empty(): Seq Box), 
            Lit(Seq#Empty(): Seq Box))); 
      b#2);

// definition axiom for BucketsLib.__default.EmptyBucket for all literals(revealed)
axiom true
   ==> 
  true
   ==> BucketsLib.__default.EmptyBucket()
     == (var b#3 := Lit(#BucketsLib.Bucket.BucketMapWithSeq(Lit(Map#Empty(): Map Box Box), 
            Lit(Seq#Empty(): Seq Box), 
            Lit(Seq#Empty(): Seq Box))); 
      b#3);

// function declaration for BucketsLib._default.SingletonBucket
function BucketsLib.__default.SingletonBucket(key#0: Seq Box, msg#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.SingletonBucket#canCall(key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.SingletonBucket
axiom true
   ==> (forall key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.SingletonBucket(key#0, msg#0) } 
    BucketsLib.__default.SingletonBucket#canCall(key#0, msg#0)
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.PreWFBucket(BucketsLib.__default.SingletonBucket(key#0, msg#0))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SingletonBucket(key#0, msg#0))
         && (!ValueMessage.Message#Equal(msg#0, ValueMessage.__default.IdentityMessage())
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.SingletonBucket(key#0, msg#0)))
         && $Is(BucketsLib.__default.SingletonBucket(key#0, msg#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.SingletonBucket#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.SingletonBucket
axiom (forall key#0: Seq Box, msg#0: DatatypeType :: 
  { BucketsLib.__default.SingletonBucket#requires(key#0, msg#0) } 
  $Is(key#0, Tclass.KeyType.Key()) && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketsLib.__default.SingletonBucket#requires(key#0, msg#0) == true);

// definition axiom for BucketsLib.__default.SingletonBucket(revealed)
axiom true
   ==> (forall key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.SingletonBucket(key#0, msg#0) } 
    BucketsLib.__default.SingletonBucket#canCall(key#0, msg#0)
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.SingletonBucket(key#0, msg#0)
         == #BucketsLib.Bucket.BucketMapWithSeq(Map#Build(Map#Empty(): Map Box Box, $Box(key#0), $Box(msg#0)), 
          Seq#Build(Seq#Empty(): Seq Box, $Box(key#0)), 
          Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))));

// definition axiom for BucketsLib.__default.SingletonBucket for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.SingletonBucket(Lit(key#0), Lit(msg#0)) } 
    BucketsLib.__default.SingletonBucket#canCall(Lit(key#0), Lit(msg#0))
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.SingletonBucket(Lit(key#0), Lit(msg#0))
         == Lit(#BucketsLib.Bucket.BucketMapWithSeq(Lit(Map#Build(Map#Empty(): Map Box Box, $Box(Lit(key#0)), $Box(Lit(msg#0)))), 
            Lit(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(key#0)))), 
            Lit(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(msg#0)))))));

// function declaration for BucketsLib._default.BucketDropLast
function BucketsLib.__default.BucketDropLast(bucket#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.BucketDropLast#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketDropLast
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.BucketDropLast(bucket#0) } 
    BucketsLib.__default.BucketDropLast#canCall(bucket#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && 
          BucketsLib.__default.PreWFBucket(bucket#0)
           && BucketsLib.__default.BucketWellMarshalled(bucket#0)
           && 0 < Seq#Length(BucketsLib.Bucket.keys(bucket#0)))
       ==> $Is(BucketsLib.__default.BucketDropLast(bucket#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketDropLast#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketDropLast
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.BucketDropLast#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.BucketDropLast#requires(bucket#0)
       == (
        BucketsLib.__default.PreWFBucket(bucket#0)
         && BucketsLib.__default.BucketWellMarshalled(bucket#0)
         && 0 < Seq#Length(BucketsLib.Bucket.keys(bucket#0))));

// definition axiom for BucketsLib.__default.BucketDropLast(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.BucketDropLast(bucket#0) } 
    BucketsLib.__default.BucketDropLast#canCall(bucket#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && 
          BucketsLib.__default.PreWFBucket(bucket#0)
           && BucketsLib.__default.BucketWellMarshalled(bucket#0)
           && 0 < Seq#Length(BucketsLib.Bucket.keys(bucket#0)))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && Sequences.__default.Last#canCall(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0))
         && Maps.__default.MapRemove1#canCall(Tclass.KeyType.Key(), 
          Tclass.ValueMessage.Message(), 
          BucketsLib.Bucket.b(bucket#0), 
          Sequences.__default.Last(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0)))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), BucketsLib.Bucket.msgs(bucket#0))
         && BucketsLib.__default.BucketDropLast(bucket#0)
           == (var submap#2 := Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapRemove1, 
                BucketsLib.Bucket.b(bucket#0), 
                Sequences.__default.Last(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0))); 
            #BucketsLib.Bucket.BucketMapWithSeq(submap#2, 
              Sequences.__default.DropLast(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0)), 
              Sequences.__default.DropLast(Tclass.ValueMessage.Message(), BucketsLib.Bucket.msgs(bucket#0)))));

// definition axiom for BucketsLib.__default.BucketDropLast for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketDropLast(Lit(bucket#0)) } 
    BucketsLib.__default.BucketDropLast#canCall(Lit(bucket#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && 
          Lit(BucketsLib.__default.PreWFBucket(Lit(bucket#0)))
           && Lit(BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0)))
           && 0 < Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
         && Maps.__default.MapRemove1#canCall(Tclass.KeyType.Key(), 
          Tclass.ValueMessage.Message(), 
          Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
          $Box(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))): Seq Box)))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
         && BucketsLib.__default.BucketDropLast(Lit(bucket#0))
           == (var submap#3 := Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapRemove1, 
                Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
                $Box(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))): Seq Box))); 
            #BucketsLib.Bucket.BucketMapWithSeq(submap#3, 
              Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))), 
              Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))))));

// function declaration for BucketsLib._default.WFBucketAt
function BucketsLib.__default.WFBucketAt(bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int) : bool;

function BucketsLib.__default.WFBucketAt#canCall(bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for BucketsLib.__default.WFBucketAt
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.WFBucketAt(bucket#0, pivots#0, i#0) } 
    BucketsLib.__default.WFBucketAt#canCall(bucket#0, pivots#0, i#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> true);

function BucketsLib.__default.WFBucketAt#requires(DatatypeType, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.WFBucketAt
axiom (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
  { BucketsLib.__default.WFBucketAt#requires(bucket#0, pivots#0, i#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.WFBucketAt#requires(bucket#0, pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketsLib.__default.WFBucketAt(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.WFBucketAt(bucket#0, pivots#0, i#0) } 
    BucketsLib.__default.WFBucketAt#canCall(bucket#0, pivots#0, i#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> BucketsLib.__default.WFBucket#canCall(bucket#0)
         && (BucketsLib.__default.WFBucket(bucket#0)
           ==> (forall key#4: Seq Box :: 
            { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]): DatatypeType } 
              { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)] } 
            $Is(key#4, TSeq(Tclass.NativeTypes.byte()))
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                 && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]
                   ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]): DatatypeType)
                     && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                     && 
                    BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                     && ValueMessage.__default.IdentityMessage#canCall())))
         && ((forall key#4: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)] } 
              $Is(key#4, TSeq(Tclass.NativeTypes.byte()))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]
                     ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]): DatatypeType)
                       && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                       && 
                      BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                       && ValueMessage.__default.IdentityMessage#canCall()))
             && (forall key#4: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)] } 
              $Is(key#4, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage()))
           ==> (forall key#5: Seq Box :: 
            { PivotsLib.__default.Route(pivots#0, key#5) } 
              { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#5)] } 
            $Is(key#5, Tclass.KeyType.Key())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                 && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#5)]
                   ==> PivotsLib.__default.Route#canCall(pivots#0, key#5))))
         && BucketsLib.__default.WFBucketAt(bucket#0, pivots#0, i#0)
           == (
            BucketsLib.__default.WFBucket(bucket#0)
             && (forall key#4: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)] } 
              $Is(key#4, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#4)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage()))
             && (forall key#5: Seq Box :: 
              { PivotsLib.__default.Route(pivots#0, key#5) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#5)] } 
              $Is(key#5, Tclass.KeyType.Key())
                   && Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#5)]
                 ==> PivotsLib.__default.Route(pivots#0, key#5) == i#0)));

// definition axiom for BucketsLib.__default.WFBucketAt for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketsLib.__default.WFBucketAt(Lit(bucket#0), Lit(pivots#0), LitInt(i#0)) } 
    BucketsLib.__default.WFBucketAt#canCall(Lit(bucket#0), Lit(pivots#0), LitInt(i#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> BucketsLib.__default.WFBucket#canCall(Lit(bucket#0))
         && (Lit(BucketsLib.__default.WFBucket(Lit(bucket#0)))
           ==> (forall key#6: Seq Box :: 
            { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#6)]): DatatypeType } 
              { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#6)] } 
            $Is(key#6, TSeq(Tclass.NativeTypes.byte()))
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                 && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#6)]
                   ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#6)]): DatatypeType)
                     && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                     && 
                    BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                     && ValueMessage.__default.IdentityMessage#canCall())))
         && ((forall key#6: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#6)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#6)] } 
              $Is(key#6, TSeq(Tclass.NativeTypes.byte()))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                   && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#6)]
                     ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#6)]): DatatypeType)
                       && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                       && 
                      BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                       && ValueMessage.__default.IdentityMessage#canCall()))
             && (forall key#6: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#6)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#6)] } 
              $Is(key#6, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#6)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#6)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage()))
           ==> (forall key#7: Seq Box :: 
            { PivotsLib.__default.Route(pivots#0, key#7) } 
              { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#7)] } 
            $Is(key#7, Tclass.KeyType.Key())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                 && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#7)]
                   ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), key#7))))
         && BucketsLib.__default.WFBucketAt(Lit(bucket#0), Lit(pivots#0), LitInt(i#0))
           == (
            BucketsLib.__default.WFBucket(Lit(bucket#0))
             && (forall key#6: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#6)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#6)] } 
              $Is(key#6, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#6)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#6)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage()))
             && (forall key#7: Seq Box :: 
              { PivotsLib.__default.Route(pivots#0, key#7) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#7)] } 
              $Is(key#7, Tclass.KeyType.Key())
                   && Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#7)]
                 ==> PivotsLib.__default.Route(Lit(pivots#0), key#7) == LitInt(i#0))));

// function declaration for BucketsLib._default.WFBucketList
function BucketsLib.__default.WFBucketList(blist#0: Seq Box, pivots#0: Seq Box) : bool;

function BucketsLib.__default.WFBucketList#canCall(blist#0: Seq Box, pivots#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.WFBucketList
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.WFBucketList(blist#0, pivots#0) } 
    BucketsLib.__default.WFBucketList#canCall(blist#0, pivots#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> true);

function BucketsLib.__default.WFBucketList#requires(Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.WFBucketList
axiom (forall blist#0: Seq Box, pivots#0: Seq Box :: 
  { BucketsLib.__default.WFBucketList#requires(blist#0, pivots#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.WFBucketList#requires(blist#0, pivots#0) == true);

// definition axiom for BucketsLib.__default.WFBucketList(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.WFBucketList(blist#0, pivots#0) } 
    BucketsLib.__default.WFBucketList#canCall(blist#0, pivots#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> PivotsLib.__default.WFPivots#canCall(pivots#0)
         && (Seq#Length(blist#0) == Seq#Length(pivots#0) + 1
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(blist#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(blist#0)
               ==> BucketsLib.__default.WFBucket#canCall($Unbox(Seq#Index(blist#0, i#2)): DatatypeType)))
         && BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           == (
            PivotsLib.__default.WFPivots(pivots#0)
             && Seq#Length(blist#0) == Seq#Length(pivots#0) + 1
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(blist#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(blist#0)
                 ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(blist#0, i#2)): DatatypeType))));

// definition axiom for BucketsLib.__default.WFBucketList for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0)) } 
    BucketsLib.__default.WFBucketList#canCall(Lit(blist#0), Lit(pivots#0))
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> PivotsLib.__default.WFPivots#canCall(Lit(pivots#0))
         && (Seq#Length(Lit(blist#0)) == Seq#Length(Lit(pivots#0)) + 1
           ==> (forall i#3: int :: 
            { $Unbox(Seq#Index(blist#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(blist#0))
               ==> BucketsLib.__default.WFBucket#canCall($Unbox(Seq#Index(Lit(blist#0), i#3)): DatatypeType)))
         && BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0))
           == (
            PivotsLib.__default.WFPivots(Lit(pivots#0))
             && Seq#Length(Lit(blist#0)) == Seq#Length(Lit(pivots#0)) + 1
             && (forall i#3: int :: 
              { $Unbox(Seq#Index(blist#0, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(blist#0))
                 ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(Lit(blist#0), i#3)): DatatypeType))));

// function declaration for BucketsLib._default.WFBucketListProper
function BucketsLib.__default.WFBucketListProper(blist#0: Seq Box, pivots#0: Seq Box) : bool;

function BucketsLib.__default.WFBucketListProper#canCall(blist#0: Seq Box, pivots#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.WFBucketListProper
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.WFBucketListProper(blist#0, pivots#0) } 
    BucketsLib.__default.WFBucketListProper#canCall(blist#0, pivots#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> true);

function BucketsLib.__default.WFBucketListProper#requires(Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.WFBucketListProper
axiom (forall blist#0: Seq Box, pivots#0: Seq Box :: 
  { BucketsLib.__default.WFBucketListProper#requires(blist#0, pivots#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.WFBucketListProper#requires(blist#0, pivots#0) == true);

// definition axiom for BucketsLib.__default.WFBucketListProper(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.WFBucketListProper(blist#0, pivots#0) } 
    BucketsLib.__default.WFBucketListProper#canCall(blist#0, pivots#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.WFBucketList#canCall(blist#0, pivots#0)
         && (BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(blist#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(blist#0)
               ==> BucketsLib.__default.WFBucketAt#canCall($Unbox(Seq#Index(blist#0, i#2)): DatatypeType, pivots#0, i#2)))
         && BucketsLib.__default.WFBucketListProper(blist#0, pivots#0)
           == (BucketsLib.__default.WFBucketList(blist#0, pivots#0)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(blist#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(blist#0)
                 ==> BucketsLib.__default.WFBucketAt($Unbox(Seq#Index(blist#0, i#2)): DatatypeType, pivots#0, i#2))));

// definition axiom for BucketsLib.__default.WFBucketListProper for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.WFBucketListProper(Lit(blist#0), Lit(pivots#0)) } 
    BucketsLib.__default.WFBucketListProper#canCall(Lit(blist#0), Lit(pivots#0))
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.WFBucketList#canCall(Lit(blist#0), Lit(pivots#0))
         && (Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0)))
           ==> (forall i#3: int :: 
            { $Unbox(Seq#Index(blist#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(blist#0))
               ==> BucketsLib.__default.WFBucketAt#canCall($Unbox(Seq#Index(Lit(blist#0), i#3)): DatatypeType, Lit(pivots#0), i#3)))
         && BucketsLib.__default.WFBucketListProper(Lit(blist#0), Lit(pivots#0))
           == (BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0))
             && (forall i#3: int :: 
              { $Unbox(Seq#Index(blist#0, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(blist#0))
                 ==> BucketsLib.__default.WFBucketAt($Unbox(Seq#Index(Lit(blist#0), i#3)): DatatypeType, Lit(pivots#0), i#3))));

// function declaration for BucketsLib._default.BucketGet
function BucketsLib.__default.BucketGet(bucket#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.BucketGet#canCall(bucket#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketGet
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.BucketGet(bucket#0, key#0) } 
    BucketsLib.__default.BucketGet#canCall(bucket#0, key#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> $Is(BucketsLib.__default.BucketGet(bucket#0, key#0), Tclass.ValueMessage.Message()));

function BucketsLib.__default.BucketGet#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketGet
axiom (forall bucket#0: DatatypeType, key#0: Seq Box :: 
  { BucketsLib.__default.BucketGet#requires(bucket#0, key#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.BucketGet#requires(bucket#0, key#0) == true);

// definition axiom for BucketsLib.__default.BucketGet(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.BucketGet(bucket#0, key#0) } 
    BucketsLib.__default.BucketGet#canCall(bucket#0, key#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0))
         && (!Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
           ==> ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.BucketGet(bucket#0, key#0)
           == (if Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
             then $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType
             else ValueMessage.__default.IdentityMessage()));

// definition axiom for BucketsLib.__default.BucketGet for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0)) } 
    BucketsLib.__default.BucketGet#canCall(Lit(bucket#0), Lit(key#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0)))
         && (!Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
           ==> ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0))
           == (if Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
             then $Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(Lit(key#0))]): DatatypeType
             else ValueMessage.__default.IdentityMessage()));

// function declaration for BucketsLib._default.BucketListGet
function BucketsLib.__default.BucketListGet(blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.BucketListGet#canCall(blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketListGet
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.BucketListGet(blist#0, pivots#0, key#0) } 
    BucketsLib.__default.BucketListGet#canCall(blist#0, pivots#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucketList(blist#0, pivots#0))
       ==> $Is(BucketsLib.__default.BucketListGet(blist#0, pivots#0, key#0), 
        Tclass.ValueMessage.Message()));

function BucketsLib.__default.BucketListGet#requires(Seq Box, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketListGet
axiom (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.BucketListGet#requires(blist#0, pivots#0, key#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.BucketListGet#requires(blist#0, pivots#0, key#0)
       == BucketsLib.__default.WFBucketList(blist#0, pivots#0));

// definition axiom for BucketsLib.__default.BucketListGet(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.BucketListGet(blist#0, pivots#0, key#0) } 
    BucketsLib.__default.BucketListGet#canCall(blist#0, pivots#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucketList(blist#0, pivots#0))
       ==> PivotsLib.__default.Route#canCall(pivots#0, key#0)
         && BucketsLib.__default.BucketGet#canCall($Unbox(Seq#Index(blist#0, PivotsLib.__default.Route(pivots#0, key#0))): DatatypeType, 
          key#0)
         && BucketsLib.__default.BucketListGet(blist#0, pivots#0, key#0)
           == BucketsLib.__default.BucketGet($Unbox(Seq#Index(blist#0, PivotsLib.__default.Route(pivots#0, key#0))): DatatypeType, 
            key#0));

// definition axiom for BucketsLib.__default.BucketListGet for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketListGet(Lit(blist#0), Lit(pivots#0), Lit(key#0)) } 
    BucketsLib.__default.BucketListGet#canCall(Lit(blist#0), Lit(pivots#0), Lit(key#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0))))
       ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), Lit(key#0))
         && BucketsLib.__default.BucketGet#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(key#0))))): DatatypeType, 
          Lit(key#0))
         && BucketsLib.__default.BucketListGet(Lit(blist#0), Lit(pivots#0), Lit(key#0))
           == BucketsLib.__default.BucketGet($Unbox(Seq#Index(Lit(blist#0), LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(key#0))))): DatatypeType, 
            Lit(key#0)));

// function declaration for BucketsLib._default.BucketInsert
function BucketsLib.__default.BucketInsert(bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.BucketInsert#canCall(bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketInsert
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.BucketInsert(bucket#0, key#0, msg#0) } 
    BucketsLib.__default.BucketInsert#canCall(bucket#0, key#0, msg#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> $Is(BucketsLib.__default.BucketInsert(bucket#0, key#0, msg#0), 
        Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketInsert#requires(DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketInsert
axiom (forall bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
  { BucketsLib.__default.BucketInsert#requires(bucket#0, key#0, msg#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketsLib.__default.BucketInsert#requires(bucket#0, key#0, msg#0) == true);

// definition axiom for BucketsLib.__default.BucketInsert(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.BucketInsert(bucket#0, key#0, msg#0) } 
    BucketsLib.__default.BucketInsert#canCall(bucket#0, key#0, msg#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.BucketGet#canCall(bucket#0, key#0)
         && ValueMessage.__default.Merge#canCall(msg#0, BucketsLib.__default.BucketGet(bucket#0, key#0))
         && (var mergedMsg#2 := ValueMessage.__default.Merge(msg#0, BucketsLib.__default.BucketGet(bucket#0, key#0)); 
          $IsA#ValueMessage.Message(mergedMsg#2)
             && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
             && ValueMessage.__default.IdentityMessage#canCall()
             && (ValueMessage.Message#Equal(mergedMsg#2, ValueMessage.__default.IdentityMessage())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.KeyType.Key(), 
                  Tclass.ValueMessage.Message(), 
                  BucketsLib.Bucket.b(bucket#0), 
                  $Box(key#0))
                 && BucketsLib.__default.B#canCall(Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                    Tclass.ValueMessage.Message(), 
                    StartFuel_Maps._default.MapRemove1, 
                    BucketsLib.Bucket.b(bucket#0), 
                    $Box(key#0))))
             && (!ValueMessage.Message#Equal(mergedMsg#2, ValueMessage.__default.IdentityMessage())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                 && BucketsLib.__default.B#canCall(Map#Build(BucketsLib.Bucket.b(bucket#0), $Box(key#0), $Box(mergedMsg#2)))))
         && BucketsLib.__default.BucketInsert(bucket#0, key#0, msg#0)
           == (var mergedMsg#2 := ValueMessage.__default.Merge(msg#0, BucketsLib.__default.BucketGet(bucket#0, key#0)); 
            (if ValueMessage.Message#Equal(mergedMsg#2, ValueMessage.__default.IdentityMessage())
               then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                  Tclass.ValueMessage.Message(), 
                  StartFuel_Maps._default.MapRemove1, 
                  BucketsLib.Bucket.b(bucket#0), 
                  $Box(key#0)))
               else BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                Map#Build(BucketsLib.Bucket.b(bucket#0), $Box(key#0), $Box(mergedMsg#2))))));

// definition axiom for BucketsLib.__default.BucketInsert for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketInsert(Lit(bucket#0), Lit(key#0), Lit(msg#0)) } 
    BucketsLib.__default.BucketInsert#canCall(Lit(bucket#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.BucketGet#canCall(Lit(bucket#0), Lit(key#0))
         && ValueMessage.__default.Merge#canCall(Lit(msg#0), Lit(BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0))))
         && (var mergedMsg#3 := Lit(ValueMessage.__default.Merge(Lit(msg#0), Lit(BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0))))); 
          $IsA#ValueMessage.Message(mergedMsg#3)
             && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
             && ValueMessage.__default.IdentityMessage#canCall()
             && (ValueMessage.Message#Equal(mergedMsg#3, ValueMessage.__default.IdentityMessage())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.KeyType.Key(), 
                  Tclass.ValueMessage.Message(), 
                  Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
                  $Box(Lit(key#0)))
                 && BucketsLib.__default.B#canCall(Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                    Tclass.ValueMessage.Message(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
                    $Box(Lit(key#0)))))
             && (!ValueMessage.Message#Equal(mergedMsg#3, ValueMessage.__default.IdentityMessage())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                 && BucketsLib.__default.B#canCall(Map#Build(Lit(BucketsLib.Bucket.b(Lit(bucket#0))), $Box(Lit(key#0)), $Box(mergedMsg#3)))))
         && BucketsLib.__default.BucketInsert(Lit(bucket#0), Lit(key#0), Lit(msg#0))
           == (var mergedMsg#3 := Lit(ValueMessage.__default.Merge(Lit(msg#0), Lit(BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0))))); 
            (if ValueMessage.Message#Equal(mergedMsg#3, ValueMessage.__default.IdentityMessage())
               then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                  Tclass.ValueMessage.Message(), 
                  StartFuel_Maps._default.MapRemove1, 
                  Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
                  $Box(Lit(key#0))))
               else BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                Map#Build(Lit(BucketsLib.Bucket.b(Lit(bucket#0))), $Box(Lit(key#0)), $Box(mergedMsg#3))))));

// function declaration for BucketsLib._default.BucketListInsert
function BucketsLib.__default.BucketListInsert(blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType)
   : Seq Box;

function BucketsLib.__default.BucketListInsert#canCall(blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketListInsert
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.BucketListInsert(blist#0, pivots#0, key#0, msg#0) } 
    BucketsLib.__default.BucketListInsert#canCall(blist#0, pivots#0, key#0, msg#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && BucketsLib.__default.WFBucketList(blist#0, pivots#0))
       ==> $Is(BucketsLib.__default.BucketListInsert(blist#0, pivots#0, key#0, msg#0), 
        TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.BucketListInsert#requires(Seq Box, Seq Box, Seq Box, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketListInsert
axiom (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType :: 
  { BucketsLib.__default.BucketListInsert#requires(blist#0, pivots#0, key#0, msg#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketsLib.__default.BucketListInsert#requires(blist#0, pivots#0, key#0, msg#0)
       == BucketsLib.__default.WFBucketList(blist#0, pivots#0));

// definition axiom for BucketsLib.__default.BucketListInsert(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.BucketListInsert(blist#0, pivots#0, key#0, msg#0) } 
    BucketsLib.__default.BucketListInsert#canCall(blist#0, pivots#0, key#0, msg#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && BucketsLib.__default.WFBucketList(blist#0, pivots#0))
       ==> PivotsLib.__default.Route#canCall(pivots#0, key#0)
         && (var i#2 := PivotsLib.__default.Route(pivots#0, key#0); 
          BucketsLib.__default.BucketInsert#canCall($Unbox(Seq#Index(blist#0, i#2)): DatatypeType, key#0, msg#0))
         && BucketsLib.__default.BucketListInsert(blist#0, pivots#0, key#0, msg#0)
           == (var i#2 := PivotsLib.__default.Route(pivots#0, key#0); 
            Seq#Update(blist#0, 
              i#2, 
              $Box(BucketsLib.__default.BucketInsert($Unbox(Seq#Index(blist#0, i#2)): DatatypeType, key#0, msg#0)))));

// definition axiom for BucketsLib.__default.BucketListInsert for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketListInsert(Lit(blist#0), Lit(pivots#0), Lit(key#0), Lit(msg#0)) } 
    BucketsLib.__default.BucketListInsert#canCall(Lit(blist#0), Lit(pivots#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0))))
       ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), Lit(key#0))
         && (var i#3 := LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(key#0))); 
          BucketsLib.__default.BucketInsert#canCall($Unbox(Seq#Index(Lit(blist#0), i#3)): DatatypeType, Lit(key#0), Lit(msg#0)))
         && BucketsLib.__default.BucketListInsert(Lit(blist#0), Lit(pivots#0), Lit(key#0), Lit(msg#0))
           == (var i#3 := LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(key#0))); 
            Seq#Update(Lit(blist#0), 
              i#3, 
              $Box(BucketsLib.__default.BucketInsert($Unbox(Seq#Index(Lit(blist#0), i#3)): DatatypeType, Lit(key#0), Lit(msg#0))))));

// function declaration for BucketsLib._default.BucketListItemFlush
function BucketsLib.__default.BucketListItemFlush(parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int)
   : DatatypeType;

function BucketsLib.__default.BucketListItemFlush#canCall(parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int)
   : bool;

// consequence axiom for BucketsLib.__default.BucketListItemFlush
axiom true
   ==> (forall parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.BucketListItemFlush(parent#0, child#0, pivots#0, i#0) } 
    BucketsLib.__default.BucketListItemFlush#canCall(parent#0, child#0, pivots#0, i#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(child#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(BucketsLib.__default.BucketListItemFlush(parent#0, child#0, pivots#0, i#0), 
        Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketListItemFlush#requires(DatatypeType, DatatypeType, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.BucketListItemFlush
axiom (forall parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
  { BucketsLib.__default.BucketListItemFlush#requires(parent#0, child#0, pivots#0, i#0) } 
  $Is(parent#0, Tclass.BucketsLib.Bucket())
       && $Is(child#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketListItemFlush#requires(parent#0, child#0, pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketsLib.__default.BucketListItemFlush(revealed)
axiom true
   ==> (forall parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.BucketListItemFlush(parent#0, child#0, pivots#0, i#0) } 
    BucketsLib.__default.BucketListItemFlush#canCall(parent#0, child#0, pivots#0, i#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(child#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketGet(child#0, key#0) } 
            { BucketsLib.__default.BucketGet(parent#0, key#0) } 
            { PivotsLib.__default.Route(pivots#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(child#0)
               && BucketsLib.Bucket.BucketMapWithSeq_q(parent#0)
               && (Map#Domain(BucketsLib.Bucket.b(child#0))[$Box(key#0)]
                   || Map#Domain(BucketsLib.Bucket.b(parent#0))[$Box(key#0)]
                 ==> PivotsLib.__default.Route#canCall(pivots#0, key#0))
               && (PivotsLib.__default.Route#canCall(pivots#0, key#0)
                   && PivotsLib.__default.Route(pivots#0, key#0) == i#0
                 ==> $IsA#ValueMessage.Message(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, key#0), 
                      BucketsLib.__default.BucketGet(child#0, key#0)))
                   && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                   && 
                  BucketsLib.__default.BucketGet#canCall(parent#0, key#0)
                   && BucketsLib.__default.BucketGet#canCall(child#0, key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(parent#0, key#0), 
                    BucketsLib.__default.BucketGet(child#0, key#0))
                   && ValueMessage.__default.IdentityMessage#canCall())
               && ((Map#Domain(BucketsLib.Bucket.b(child#0))[$Box(key#0)]
                     || Map#Domain(BucketsLib.Bucket.b(parent#0))[$Box(key#0)])
                   && PivotsLib.__default.Route(pivots#0, key#0) == i#0
                   && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, key#0), 
                      BucketsLib.__default.BucketGet(child#0, key#0)), 
                    ValueMessage.__default.IdentityMessage())
                 ==> BucketsLib.__default.BucketGet#canCall(parent#0, key#0)
                   && BucketsLib.__default.BucketGet#canCall(child#0, key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(parent#0, key#0), 
                    BucketsLib.__default.BucketGet(child#0, key#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                (Map#Domain(BucketsLib.Bucket.b(child#0))[$w#4]
                   || Map#Domain(BucketsLib.Bucket.b(parent#0))[$w#4])
                 && PivotsLib.__default.Route(pivots#0, $Unbox($w#4): Seq Box) == i#0
                 && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, $Unbox($w#4): Seq Box), 
                    BucketsLib.__default.BucketGet(child#0, $Unbox($w#4): Seq Box)), 
                  ValueMessage.__default.IdentityMessage())), 
            (lambda $w#4: Box :: 
              $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, $Unbox($w#4): Seq Box), 
                  BucketsLib.__default.BucketGet(child#0, $Unbox($w#4): Seq Box)))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketListItemFlush(parent#0, child#0, pivots#0, i#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  (Map#Domain(BucketsLib.Bucket.b(child#0))[$w#5]
                     || Map#Domain(BucketsLib.Bucket.b(parent#0))[$w#5])
                   && PivotsLib.__default.Route(pivots#0, $Unbox($w#5): Seq Box) == i#0
                   && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, $Unbox($w#5): Seq Box), 
                      BucketsLib.__default.BucketGet(child#0, $Unbox($w#5): Seq Box)), 
                    ValueMessage.__default.IdentityMessage())), 
              (lambda $w#5: Box :: 
                $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, $Unbox($w#5): Seq Box), 
                    BucketsLib.__default.BucketGet(child#0, $Unbox($w#5): Seq Box)))), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.BucketListItemFlush for all literals(revealed)
axiom true
   ==> (forall parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketsLib.__default.BucketListItemFlush(Lit(parent#0), Lit(child#0), Lit(pivots#0), LitInt(i#0)) } 
    BucketsLib.__default.BucketListItemFlush#canCall(Lit(parent#0), Lit(child#0), Lit(pivots#0), LitInt(i#0))
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(child#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketGet(child#0, key#0) } 
            { BucketsLib.__default.BucketGet(parent#0, key#0) } 
            { PivotsLib.__default.Route(pivots#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(child#0))
               && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(parent#0))
               && (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(child#0)))))[$Box(key#0)]
                   || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(parent#0)))))[$Box(key#0)]
                 ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), key#0))
               && (PivotsLib.__default.Route#canCall(Lit(pivots#0), key#0)
                   && PivotsLib.__default.Route(Lit(pivots#0), key#0) == LitInt(i#0)
                 ==> $IsA#ValueMessage.Message(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), key#0), 
                      BucketsLib.__default.BucketGet(Lit(child#0), key#0)))
                   && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                   && 
                  BucketsLib.__default.BucketGet#canCall(Lit(parent#0), key#0)
                   && BucketsLib.__default.BucketGet#canCall(Lit(child#0), key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(Lit(parent#0), key#0), 
                    BucketsLib.__default.BucketGet(Lit(child#0), key#0))
                   && ValueMessage.__default.IdentityMessage#canCall())
               && ((Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(child#0)))))[$Box(key#0)]
                     || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(parent#0)))))[$Box(key#0)])
                   && PivotsLib.__default.Route(Lit(pivots#0), key#0) == LitInt(i#0)
                   && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), key#0), 
                      BucketsLib.__default.BucketGet(Lit(child#0), key#0)), 
                    ValueMessage.__default.IdentityMessage())
                 ==> BucketsLib.__default.BucketGet#canCall(Lit(parent#0), key#0)
                   && BucketsLib.__default.BucketGet#canCall(Lit(child#0), key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(Lit(parent#0), key#0), 
                    BucketsLib.__default.BucketGet(Lit(child#0), key#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(child#0)))))[$w#6]
                   || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(parent#0)))))[$w#6])
                 && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($w#6): Seq Box) == LitInt(i#0)
                 && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), $Unbox($w#6): Seq Box), 
                    BucketsLib.__default.BucketGet(Lit(child#0), $Unbox($w#6): Seq Box)), 
                  ValueMessage.__default.IdentityMessage())), 
            (lambda $w#6: Box :: 
              $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), $Unbox($w#6): Seq Box), 
                  BucketsLib.__default.BucketGet(Lit(child#0), $Unbox($w#6): Seq Box)))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketListItemFlush(Lit(parent#0), Lit(child#0), Lit(pivots#0), LitInt(i#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(child#0)))))[$w#7]
                     || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(parent#0)))))[$w#7])
                   && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($w#7): Seq Box) == LitInt(i#0)
                   && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), $Unbox($w#7): Seq Box), 
                      BucketsLib.__default.BucketGet(Lit(child#0), $Unbox($w#7): Seq Box)), 
                    ValueMessage.__default.IdentityMessage())), 
              (lambda $w#7: Box :: 
                $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), $Unbox($w#7): Seq Box), 
                    BucketsLib.__default.BucketGet(Lit(child#0), $Unbox($w#7): Seq Box)))), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.BucketListFlushPartial
function BucketsLib.__default.BucketListFlushPartial($ly: LayerType, 
    parent#0: DatatypeType, 
    children#0: Seq Box, 
    pivots#0: Seq Box, 
    i#0: int)
   : Seq Box;

function BucketsLib.__default.BucketListFlushPartial#canCall(parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    parent#0: DatatypeType, 
    children#0: Seq Box, 
    pivots#0: Seq Box, 
    i#0: int :: 
  { BucketsLib.__default.BucketListFlushPartial($LS($ly), parent#0, children#0, pivots#0, i#0) } 
  BucketsLib.__default.BucketListFlushPartial($LS($ly), parent#0, children#0, pivots#0, i#0)
     == BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    parent#0: DatatypeType, 
    children#0: Seq Box, 
    pivots#0: Seq Box, 
    i#0: int :: 
  { BucketsLib.__default.BucketListFlushPartial(AsFuelBottom($ly), parent#0, children#0, pivots#0, i#0) } 
  BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0)
     == BucketsLib.__default.BucketListFlushPartial($LZ, parent#0, children#0, pivots#0, i#0));

// consequence axiom for BucketsLib.__default.BucketListFlushPartial
axiom true
   ==> (forall $ly: LayerType, 
      parent#0: DatatypeType, 
      children#0: Seq Box, 
      pivots#0: Seq Box, 
      i#0: int :: 
    { BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0) } 
    BucketsLib.__default.BucketListFlushPartial#canCall(parent#0, children#0, pivots#0, i#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          PivotsLib.__default.WFPivots(pivots#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(children#0))
       ==> Seq#Length(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0))
           == i#0
         && (forall h#1: int :: 
          { $Unbox(Seq#Index(children#0, h#1)): DatatypeType } 
            { $Unbox(Seq#Index(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0), 
                h#1)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= h#1 && h#1 < i#0
             ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0), 
                  h#1)): DatatypeType, 
              BucketsLib.__default.BucketListItemFlush(parent#0, $Unbox(Seq#Index(children#0, h#1)): DatatypeType, pivots#0, h#1)))
         && $Is(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0), 
          TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.BucketListFlushPartial#requires(LayerType, DatatypeType, Seq Box, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.BucketListFlushPartial
axiom (forall $ly: LayerType, 
    parent#0: DatatypeType, 
    children#0: Seq Box, 
    pivots#0: Seq Box, 
    i#0: int :: 
  { BucketsLib.__default.BucketListFlushPartial#requires($ly, parent#0, children#0, pivots#0, i#0) } 
  $Is(parent#0, Tclass.BucketsLib.Bucket())
       && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketListFlushPartial#requires($ly, parent#0, children#0, pivots#0, i#0)
       == (PivotsLib.__default.WFPivots(pivots#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(children#0)));

// definition axiom for BucketsLib.__default.BucketListFlushPartial(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      parent#0: DatatypeType, 
      children#0: Seq Box, 
      pivots#0: Seq Box, 
      i#0: int :: 
    { BucketsLib.__default.BucketListFlushPartial($LS($ly), parent#0, children#0, pivots#0, i#0) } 
    BucketsLib.__default.BucketListFlushPartial#canCall(parent#0, children#0, pivots#0, i#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          PivotsLib.__default.WFPivots(pivots#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(children#0))
       ==> (i#0 != LitInt(0)
           ==> BucketsLib.__default.BucketListFlushPartial#canCall(parent#0, children#0, pivots#0, i#0 - 1)
             && BucketsLib.__default.BucketListItemFlush#canCall(parent#0, 
              $Unbox(Seq#Index(children#0, i#0 - 1)): DatatypeType, 
              pivots#0, 
              i#0 - 1))
         && BucketsLib.__default.BucketListFlushPartial($LS($ly), parent#0, children#0, pivots#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(BucketsLib.__default.BucketListItemFlush(parent#0, 
                    $Unbox(Seq#Index(children#0, i#0 - 1)): DatatypeType, 
                    pivots#0, 
                    i#0 - 1))))));

// definition axiom for BucketsLib.__default.BucketListFlushPartial for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      parent#0: DatatypeType, 
      children#0: Seq Box, 
      pivots#0: Seq Box, 
      i#0: int :: 
    {:weight 3} { BucketsLib.__default.BucketListFlushPartial($LS($ly), Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0)) } 
    BucketsLib.__default.BucketListFlushPartial#canCall(Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0))
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          Lit(PivotsLib.__default.WFPivots(Lit(pivots#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(children#0)))
       ==> (LitInt(i#0) != LitInt(0)
           ==> BucketsLib.__default.BucketListFlushPartial#canCall(Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0 - 1))
             && BucketsLib.__default.BucketListItemFlush#canCall(Lit(parent#0), 
              $Unbox(Seq#Index(Lit(children#0), LitInt(i#0 - 1))): DatatypeType, 
              Lit(pivots#0), 
              LitInt(i#0 - 1)))
         && BucketsLib.__default.BucketListFlushPartial($LS($ly), Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketsLib.__default.BucketListFlushPartial($LS($ly), Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(BucketsLib.__default.BucketListItemFlush(Lit(parent#0), 
                    $Unbox(Seq#Index(Lit(children#0), LitInt(i#0 - 1))): DatatypeType, 
                    Lit(pivots#0), 
                    LitInt(i#0 - 1)))))));

// function declaration for BucketsLib._default.BucketListFlush
function BucketsLib.__default.BucketListFlush(parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box) : Seq Box;

function BucketsLib.__default.BucketListFlush#canCall(parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketListFlush
axiom true
   ==> (forall parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0) } 
    BucketsLib.__default.BucketListFlush#canCall(parent#0, children#0, pivots#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> Seq#Length(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0))
           == Seq#Length(children#0)
         && BucketsLib.__default.BucketListWellMarshalled(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0))
         && (forall h#1: int :: 
          { $Unbox(Seq#Index(children#0, h#1)): DatatypeType } 
            { $Unbox(Seq#Index(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0), h#1)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= h#1
               && h#1
                 < Seq#Length(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0))
             ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0), h#1)): DatatypeType, 
              BucketsLib.__default.BucketListItemFlush(parent#0, $Unbox(Seq#Index(children#0, h#1)): DatatypeType, pivots#0, h#1)))
         && $Is(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0), 
          TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.BucketListFlush#requires(DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketListFlush
axiom (forall parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box :: 
  { BucketsLib.__default.BucketListFlush#requires(parent#0, children#0, pivots#0) } 
  $Is(parent#0, Tclass.BucketsLib.Bucket())
       && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketListFlush#requires(parent#0, children#0, pivots#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketsLib.__default.BucketListFlush(revealed)
axiom true
   ==> (forall parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0) } 
    BucketsLib.__default.BucketListFlush#canCall(parent#0, children#0, pivots#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> BucketsLib.__default.BucketListFlushPartial#canCall(parent#0, children#0, pivots#0, Seq#Length(children#0))
         && BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0)
           == BucketsLib.__default.BucketListFlushPartial($LS($LZ), parent#0, children#0, pivots#0, Seq#Length(children#0)));

// definition axiom for BucketsLib.__default.BucketListFlush for all literals(revealed)
axiom true
   ==> (forall parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketListFlush(Lit(parent#0), Lit(children#0), Lit(pivots#0)) } 
    BucketsLib.__default.BucketListFlush#canCall(Lit(parent#0), Lit(children#0), Lit(pivots#0))
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> BucketsLib.__default.BucketListFlushPartial#canCall(Lit(parent#0), Lit(children#0), Lit(pivots#0), Seq#Length(Lit(children#0)))
         && BucketsLib.__default.BucketListFlush(Lit(parent#0), Lit(children#0), Lit(pivots#0))
           == BucketsLib.__default.BucketListFlushPartial($LS($LZ), 
            Lit(parent#0), 
            Lit(children#0), 
            Lit(pivots#0), 
            Seq#Length(Lit(children#0))));

// function declaration for BucketsLib._default.JoinBucketList
function BucketsLib.__default.JoinBucketList($ly: LayerType, buckets#0: Seq Box) : DatatypeType;

function BucketsLib.__default.JoinBucketList#canCall(buckets#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.JoinBucketList($LS($ly), buckets#0) } 
  BucketsLib.__default.JoinBucketList($LS($ly), buckets#0)
     == BucketsLib.__default.JoinBucketList($ly, buckets#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.JoinBucketList(AsFuelBottom($ly), buckets#0) } 
  BucketsLib.__default.JoinBucketList($ly, buckets#0)
     == BucketsLib.__default.JoinBucketList($LZ, buckets#0));

// consequence axiom for BucketsLib.__default.JoinBucketList
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketsLib.__default.JoinBucketList($ly, buckets#0) } 
    BucketsLib.__default.JoinBucketList#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.__default.PreWFBucket(BucketsLib.__default.JoinBucketList($ly, buckets#0))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.JoinBucketList($ly, buckets#0))
         && ((forall i#1: int :: 
            { $Unbox(Seq#Index(buckets#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(buckets#0)
               ==> BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b($Unbox(Seq#Index(buckets#0, i#1)): DatatypeType)))
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.JoinBucketList($ly, buckets#0)))
         && $Is(BucketsLib.__default.JoinBucketList($ly, buckets#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.JoinBucketList#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.JoinBucketList
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.JoinBucketList#requires($ly, buckets#0) } 
  $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.JoinBucketList#requires($ly, buckets#0) == true);

// definition axiom for BucketsLib.__default.JoinBucketList(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketsLib.__default.JoinBucketList($LS($ly), buckets#0) } 
    BucketsLib.__default.JoinBucketList#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(buckets#0) == LitInt(0)
           ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && (Seq#Length(buckets#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.JoinBucketList#canCall(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(BucketsLib.__default.JoinBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0)))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType)
             && Maps.__default.MapUnion#canCall(Tclass.KeyType.Key(), 
              Tclass.ValueMessage.Message(), 
              BucketsLib.Bucket.b(BucketsLib.__default.JoinBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))), 
              BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType))
             && BucketsLib.__default.B#canCall(Maps.__default.MapUnion(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapUnion, 
                BucketsLib.Bucket.b(BucketsLib.__default.JoinBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))), 
                BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType))))
         && BucketsLib.__default.JoinBucketList($LS($ly), buckets#0)
           == (if Seq#Length(buckets#0) == LitInt(0)
             then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))
             else BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
              Maps.__default.MapUnion(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapUnion, 
                BucketsLib.Bucket.b(BucketsLib.__default.JoinBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))), 
                BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType)))));

// definition axiom for BucketsLib.__default.JoinBucketList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.JoinBucketList($LS($ly), Lit(buckets#0)) } 
    BucketsLib.__default.JoinBucketList#canCall(Lit(buckets#0))
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(Lit(buckets#0)) == LitInt(0)
           ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && (Seq#Length(Lit(buckets#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.JoinBucketList#canCall(Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(BucketsLib.__default.JoinBucketList($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))
             && Maps.__default.MapUnion#canCall(Tclass.KeyType.Key(), 
              Tclass.ValueMessage.Message(), 
              Lit(BucketsLib.Bucket.b(Lit(BucketsLib.__default.JoinBucketList($LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))))), 
              Lit(BucketsLib.Bucket.b(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))))
             && BucketsLib.__default.B#canCall(Maps.__default.MapUnion(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapUnion, 
                Lit(BucketsLib.Bucket.b(Lit(BucketsLib.__default.JoinBucketList($LS($ly), 
                        Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))))), 
                Lit(BucketsLib.Bucket.b(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))))))
         && BucketsLib.__default.JoinBucketList($LS($ly), Lit(buckets#0))
           == (if Seq#Length(Lit(buckets#0)) == LitInt(0)
             then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))
             else BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
              Maps.__default.MapUnion(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapUnion, 
                Lit(BucketsLib.Bucket.b(Lit(BucketsLib.__default.JoinBucketList($LS($ly), 
                        Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))))), 
                Lit(BucketsLib.Bucket.b(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType)))))));

// function declaration for BucketsLib._default.SplitBucketOnPivots
function BucketsLib.__default.SplitBucketOnPivots($ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box) : Seq Box;

function BucketsLib.__default.SplitBucketOnPivots#canCall(bucket#0: DatatypeType, pivots#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, pivots#0) } 
  BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, pivots#0)
     == BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketOnPivots(AsFuelBottom($ly), bucket#0, pivots#0) } 
  BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0)
     == BucketsLib.__default.SplitBucketOnPivots($LZ, bucket#0, pivots#0));

// consequence axiom for BucketsLib.__default.SplitBucketOnPivots
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0) } 
    BucketsLib.__default.SplitBucketOnPivots#canCall(bucket#0, pivots#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
           == Seq#Length(pivots#0) + 1
         && (forall i#5: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#5)): DatatypeType } 
          LitInt(0) <= i#5
               && i#5
                 < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
             ==> BucketsLib.__default.PreWFBucket($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#5)): DatatypeType))
         && BucketsLib.__default.BucketListWellMarshalled(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
         && (forall i#6: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#6)): DatatypeType } 
          LitInt(0) <= i#6
               && i#6
                 < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
             ==> Set#Subset(Map#Domain(BucketsLib.Bucket.b($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#6)): DatatypeType)), 
              Map#Domain(BucketsLib.Bucket.b(bucket#0))))
         && (forall i#7: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#7)): DatatypeType } 
          LitInt(0) <= i#7
               && i#7
                 < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
             ==> Set#Subset(Map#Values(BucketsLib.Bucket.b($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#7)): DatatypeType)), 
              Map#Values(BucketsLib.Bucket.b(bucket#0))))
         && (forall i#8: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#8)): DatatypeType } 
          LitInt(0) <= i#8
               && i#8
                 < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
             ==> Seq#Length(BucketsLib.Bucket.keys($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#8)): DatatypeType))
               == Seq#Length(BucketsLib.Bucket.msgs($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#8)): DatatypeType)))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> (forall i#9: int :: 
            { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#9)): DatatypeType } 
            LitInt(0) <= i#9
                 && i#9
                   < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#9)): DatatypeType)))
         && $Is(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), 
          TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.SplitBucketOnPivots#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketOnPivots
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketOnPivots#requires($ly, bucket#0, pivots#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.SplitBucketOnPivots#requires($ly, bucket#0, pivots#0)
       == true);

// definition axiom for BucketsLib.__default.SplitBucketOnPivots(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, pivots#0) } 
    BucketsLib.__default.SplitBucketOnPivots#canCall(bucket#0, pivots#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> (Seq#Length(pivots#0) == LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.B#canCall(BucketsLib.Bucket.b(bucket#0)))
         && (Seq#Length(pivots#0) != LitInt(0)
           ==> (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, Tclass.KeyType.Key())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                     ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), pivots#0)
                       && Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box))
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                       && Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box)
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
             && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#18: Box :: 
                  $Is($Unbox($w#18): Seq Box, Tclass.KeyType.Key())
                     && 
                    Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#18]
                     && Lexicographic__Byte__Order.__default.lt($Unbox($w#18): Seq Box, 
                      $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box)), 
                (lambda $w#18: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#18]), 
                TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
             && (var l#3 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#21: Box :: 
                      $Is($Unbox($w#21): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#21]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#21): Seq Box, 
                          $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box)), 
                    (lambda $w#21: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#21]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (forall key#1: Seq Box :: 
                  { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]): DatatypeType } 
                    { Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1) } 
                    { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)] } 
                  $Is(key#1, Tclass.KeyType.Key())
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                       && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                         ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), pivots#0)
                           && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1))
                       && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                           && Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1)
                         ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
                 && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#19: Box :: 
                      $Is($Unbox($w#19): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#19]
                         && Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, 
                          $Unbox($w#19): Seq Box)), 
                    (lambda $w#19: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#19]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
                 && 
                Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), pivots#0)
                 && BucketsLib.__default.SplitBucketOnPivots#canCall(l#3, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0))))
         && BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, pivots#0)
           == (if Seq#Length(pivots#0) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, BucketsLib.Bucket.b(bucket#0))))
             else (var l#3 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#22: Box :: 
                      $Is($Unbox($w#22): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#22]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#22): Seq Box, 
                          $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box)), 
                    (lambda $w#22: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#22]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (var r#3 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                    Map#Glue((lambda $w#23: Box :: 
                        $Is($Unbox($w#23): Seq Box, Tclass.KeyType.Key())
                           && 
                          Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#23]
                           && Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, 
                            $Unbox($w#23): Seq Box)), 
                      (lambda $w#23: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#23]), 
                      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
                Seq#Append(BucketsLib.__default.SplitBucketOnPivots($ly, l#3, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0)), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(r#3)))))));

// definition axiom for BucketsLib.__default.SplitBucketOnPivots for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, Lit(pivots#0)) } 
    BucketsLib.__default.SplitBucketOnPivots#canCall(bucket#0, Lit(pivots#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> (Seq#Length(Lit(pivots#0)) == LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.B#canCall(BucketsLib.Bucket.b(bucket#0)))
         && (Seq#Length(Lit(pivots#0)) != LitInt(0)
           ==> (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, Tclass.KeyType.Key())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                     ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                       && Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
                        Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box)))
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                       && Lexicographic__Byte__Order.__default.lt(key#0, 
                        Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
             && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#24: Box :: 
                  $Is($Unbox($w#24): Seq Box, Tclass.KeyType.Key())
                     && 
                    Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#24]
                     && Lexicographic__Byte__Order.__default.lt($Unbox($w#24): Seq Box, 
                      Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                (lambda $w#24: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#24]), 
                TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
             && (var l#4 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#27: Box :: 
                      $Is($Unbox($w#27): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#27]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#27): Seq Box, 
                          Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                    (lambda $w#27: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#27]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (forall key#1: Seq Box :: 
                  { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]): DatatypeType } 
                    { Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1) } 
                    { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)] } 
                  $Is(key#1, Tclass.KeyType.Key())
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                       && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                         ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                           && Lexicographic__Byte__Order.__default.lte#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            key#1))
                       && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                           && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            key#1)
                         ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
                 && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#25: Box :: 
                      $Is($Unbox($w#25): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#25]
                         && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                          $Unbox($w#25): Seq Box)), 
                    (lambda $w#25: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#25]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
                 && 
                Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                 && BucketsLib.__default.SplitBucketOnPivots#canCall(l#4, Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0))))))
         && BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, Lit(pivots#0))
           == (if Seq#Length(Lit(pivots#0)) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, BucketsLib.Bucket.b(bucket#0))))
             else (var l#4 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#28: Box :: 
                      $Is($Unbox($w#28): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#28]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#28): Seq Box, 
                          Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                    (lambda $w#28: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#28]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (var r#4 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                    Map#Glue((lambda $w#29: Box :: 
                        $Is($Unbox($w#29): Seq Box, Tclass.KeyType.Key())
                           && 
                          Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#29]
                           && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            $Unbox($w#29): Seq Box)), 
                      (lambda $w#29: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#29]), 
                      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
                Seq#Append(BucketsLib.__default.SplitBucketOnPivots($LS($ly), 
                    l#4, 
                    Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0)))), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(r#4)))))));

// definition axiom for BucketsLib.__default.SplitBucketOnPivots for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketOnPivots($LS($ly), Lit(bucket#0), Lit(pivots#0)) } 
    BucketsLib.__default.SplitBucketOnPivots#canCall(Lit(bucket#0), Lit(pivots#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> (Seq#Length(Lit(pivots#0)) == LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.B#canCall(Lit(BucketsLib.Bucket.b(Lit(bucket#0)))))
         && (Seq#Length(Lit(pivots#0)) != LitInt(0)
           ==> (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, Tclass.KeyType.Key())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                   && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                     ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                       && Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
                        Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box)))
                   && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                       && Lexicographic__Byte__Order.__default.lt(key#0, 
                        Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
             && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#30: Box :: 
                  $Is($Unbox($w#30): Seq Box, Tclass.KeyType.Key())
                     && 
                    Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#30]
                     && Lexicographic__Byte__Order.__default.lt($Unbox($w#30): Seq Box, 
                      Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                (lambda $w#30: Box :: 
                  Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#30]), 
                TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
             && (var l#5 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#33: Box :: 
                      $Is($Unbox($w#33): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#33]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#33): Seq Box, 
                          Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                    (lambda $w#33: Box :: 
                      Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#33]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (forall key#1: Seq Box :: 
                  { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]): DatatypeType } 
                    { Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1) } 
                    { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)] } 
                  $Is(key#1, Tclass.KeyType.Key())
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                       && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#1)]
                         ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                           && Lexicographic__Byte__Order.__default.lte#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            key#1))
                       && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#1)]
                           && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            key#1)
                         ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
                 && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#31: Box :: 
                      $Is($Unbox($w#31): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#31]
                         && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                          $Unbox($w#31): Seq Box)), 
                    (lambda $w#31: Box :: 
                      Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#31]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
                 && 
                Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                 && BucketsLib.__default.SplitBucketOnPivots#canCall(l#5, Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0))))))
         && BucketsLib.__default.SplitBucketOnPivots($LS($ly), Lit(bucket#0), Lit(pivots#0))
           == (if Seq#Length(Lit(pivots#0)) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(BucketsLib.Bucket.b(Lit(bucket#0))))))
             else (var l#5 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#34: Box :: 
                      $Is($Unbox($w#34): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#34]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#34): Seq Box, 
                          Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                    (lambda $w#34: Box :: 
                      Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#34]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (var r#5 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                    Map#Glue((lambda $w#35: Box :: 
                        $Is($Unbox($w#35): Seq Box, Tclass.KeyType.Key())
                           && 
                          Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#35]
                           && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            $Unbox($w#35): Seq Box)), 
                      (lambda $w#35: Box :: 
                        Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#35]), 
                      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
                Seq#Append(BucketsLib.__default.SplitBucketOnPivots($LS($ly), 
                    l#5, 
                    Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0)))), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(r#5)))))));

// function declaration for BucketsLib._default.ClampToSlot
function BucketsLib.__default.ClampToSlot(bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int) : DatatypeType;

function BucketsLib.__default.ClampToSlot#canCall(bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for BucketsLib.__default.ClampToSlot
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.ClampToSlot(bucket#0, pivots#0, i#0) } 
    BucketsLib.__default.ClampToSlot#canCall(bucket#0, pivots#0, i#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(BucketsLib.__default.ClampToSlot(bucket#0, pivots#0, i#0), 
        Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ClampToSlot#requires(DatatypeType, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.ClampToSlot
axiom (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
  { BucketsLib.__default.ClampToSlot#requires(bucket#0, pivots#0, i#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.ClampToSlot#requires(bucket#0, pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketsLib.__default.ClampToSlot(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.ClampToSlot(bucket#0, pivots#0, i#0) } 
    BucketsLib.__default.ClampToSlot#canCall(bucket#0, pivots#0, i#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { PivotsLib.__default.Route(pivots#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> PivotsLib.__default.Route#canCall(pivots#0, key#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && PivotsLib.__default.Route(pivots#0, key#0) == i#0
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                 && PivotsLib.__default.Route(pivots#0, $Unbox($w#4): Seq Box) == i#0), 
            (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampToSlot(bucket#0, pivots#0, i#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                   && PivotsLib.__default.Route(pivots#0, $Unbox($w#5): Seq Box) == i#0), 
              (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.ClampToSlot for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketsLib.__default.ClampToSlot(Lit(bucket#0), Lit(pivots#0), LitInt(i#0)) } 
    BucketsLib.__default.ClampToSlot#canCall(Lit(bucket#0), Lit(pivots#0), LitInt(i#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { PivotsLib.__default.Route(pivots#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), key#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && PivotsLib.__default.Route(Lit(pivots#0), key#0) == LitInt(i#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#6]
                 && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($w#6): Seq Box) == LitInt(i#0)), 
            (lambda $w#6: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#6]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampToSlot(Lit(bucket#0), Lit(pivots#0), LitInt(i#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#7]
                   && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($w#7): Seq Box) == LitInt(i#0)), 
              (lambda $w#7: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#7]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.BucketIntersect
function BucketsLib.__default.BucketIntersect($ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box) : DatatypeType;

function BucketsLib.__default.BucketIntersect#canCall(bucket#0: DatatypeType, keys#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketIntersect($LS($ly), bucket#0, keys#0) } 
  BucketsLib.__default.BucketIntersect($LS($ly), bucket#0, keys#0)
     == BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketIntersect(AsFuelBottom($ly), bucket#0, keys#0) } 
  BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0)
     == BucketsLib.__default.BucketIntersect($LZ, bucket#0, keys#0));

// consequence axiom for BucketsLib.__default.BucketIntersect
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    { BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0) } 
    BucketsLib.__default.BucketIntersect#canCall(bucket#0, keys#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0))
         && $Is(BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketIntersect#requires(LayerType, DatatypeType, Set Box) : bool;

// #requires axiom for BucketsLib.__default.BucketIntersect
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketIntersect#requires($ly, bucket#0, keys#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(keys#0, TSet(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketIntersect#requires($ly, bucket#0, keys#0) == true);

// definition axiom for BucketsLib.__default.BucketIntersect(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    { BucketsLib.__default.BucketIntersect($LS($ly), bucket#0, keys#0) } 
    BucketsLib.__default.BucketIntersect#canCall(bucket#0, keys#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { keys#0[$Box(key#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] && keys#0[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                 && keys#0[$w#4]), 
            (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketIntersect($LS($ly), bucket#0, keys#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                   && keys#0[$w#5]), 
              (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.BucketIntersect for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    {:weight 3} { BucketsLib.__default.BucketIntersect($LS($ly), Lit(bucket#0), Lit(keys#0)) } 
    BucketsLib.__default.BucketIntersect#canCall(Lit(bucket#0), Lit(keys#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { keys#0[$Box(key#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && Lit(keys#0)[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#6]
                 && Lit(keys#0)[$w#6]), 
            (lambda $w#6: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#6]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketIntersect($LS($ly), Lit(bucket#0), Lit(keys#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#7]
                   && Lit(keys#0)[$w#7]), 
              (lambda $w#7: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#7]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.BucketComplement
function BucketsLib.__default.BucketComplement($ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box) : DatatypeType;

function BucketsLib.__default.BucketComplement#canCall(bucket#0: DatatypeType, keys#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketComplement($LS($ly), bucket#0, keys#0) } 
  BucketsLib.__default.BucketComplement($LS($ly), bucket#0, keys#0)
     == BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketComplement(AsFuelBottom($ly), bucket#0, keys#0) } 
  BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0)
     == BucketsLib.__default.BucketComplement($LZ, bucket#0, keys#0));

// consequence axiom for BucketsLib.__default.BucketComplement
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    { BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0) } 
    BucketsLib.__default.BucketComplement#canCall(bucket#0, keys#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0))
         && $Is(BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketComplement#requires(LayerType, DatatypeType, Set Box) : bool;

// #requires axiom for BucketsLib.__default.BucketComplement
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketComplement#requires($ly, bucket#0, keys#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(keys#0, TSet(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketComplement#requires($ly, bucket#0, keys#0) == true);

// definition axiom for BucketsLib.__default.BucketComplement(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    { BucketsLib.__default.BucketComplement($LS($ly), bucket#0, keys#0) } 
    BucketsLib.__default.BucketComplement#canCall(bucket#0, keys#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { keys#0[$Box(key#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] && !keys#0[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                 && !keys#0[$w#4]), 
            (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketComplement($LS($ly), bucket#0, keys#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                   && !keys#0[$w#5]), 
              (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.BucketComplement for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    {:weight 3} { BucketsLib.__default.BucketComplement($LS($ly), Lit(bucket#0), Lit(keys#0)) } 
    BucketsLib.__default.BucketComplement#canCall(Lit(bucket#0), Lit(keys#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { keys#0[$Box(key#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && !Lit(keys#0)[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#6]
                 && !Lit(keys#0)[$w#6]), 
            (lambda $w#6: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#6]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketComplement($LS($ly), Lit(bucket#0), Lit(keys#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#7]
                   && !Lit(keys#0)[$w#7]), 
              (lambda $w#7: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#7]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.BucketsEquivalentForKey
function BucketsLib.__default.BucketsEquivalentForKey(a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box) : bool;

function BucketsLib.__default.BucketsEquivalentForKey#canCall(a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketsEquivalentForKey
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0) } 
    BucketsLib.__default.BucketsEquivalentForKey#canCall(a#0, b#0, key#0)
         || (
          $Is(a#0, Tclass.BucketsLib.Bucket())
           && $Is(b#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> true);

function BucketsLib.__default.BucketsEquivalentForKey#requires(DatatypeType, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketsEquivalentForKey
axiom (forall a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box :: 
  { BucketsLib.__default.BucketsEquivalentForKey#requires(a#0, b#0, key#0) } 
  $Is(a#0, Tclass.BucketsLib.Bucket())
       && $Is(b#0, Tclass.BucketsLib.Bucket())
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.BucketsEquivalentForKey#requires(a#0, b#0, key#0) == true);

// definition axiom for BucketsLib.__default.BucketsEquivalentForKey(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0) } 
    BucketsLib.__default.BucketsEquivalentForKey#canCall(a#0, b#0, key#0)
         || (
          $Is(a#0, Tclass.BucketsLib.Bucket())
           && $Is(b#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> $IsA#ValueMessage.Message(BucketsLib.__default.BucketGet(a#0, key#0))
         && $IsA#ValueMessage.Message(BucketsLib.__default.BucketGet(b#0, key#0))
         && 
        BucketsLib.__default.BucketGet#canCall(a#0, key#0)
         && BucketsLib.__default.BucketGet#canCall(b#0, key#0)
         && BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0)
           == ValueMessage.Message#Equal(BucketsLib.__default.BucketGet(a#0, key#0), 
            BucketsLib.__default.BucketGet(b#0, key#0)));

// definition axiom for BucketsLib.__default.BucketsEquivalentForKey for all literals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketsEquivalentForKey(Lit(a#0), Lit(b#0), Lit(key#0)) } 
    BucketsLib.__default.BucketsEquivalentForKey#canCall(Lit(a#0), Lit(b#0), Lit(key#0))
         || (
          $Is(a#0, Tclass.BucketsLib.Bucket())
           && $Is(b#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> $IsA#ValueMessage.Message(Lit(BucketsLib.__default.BucketGet(Lit(a#0), Lit(key#0))))
         && $IsA#ValueMessage.Message(Lit(BucketsLib.__default.BucketGet(Lit(b#0), Lit(key#0))))
         && 
        BucketsLib.__default.BucketGet#canCall(Lit(a#0), Lit(key#0))
         && BucketsLib.__default.BucketGet#canCall(Lit(b#0), Lit(key#0))
         && BucketsLib.__default.BucketsEquivalentForKey(Lit(a#0), Lit(b#0), Lit(key#0))
           == ValueMessage.Message#Equal(BucketsLib.__default.BucketGet(Lit(a#0), Lit(key#0)), 
            BucketsLib.__default.BucketGet(Lit(b#0), Lit(key#0))));

// function declaration for BucketsLib._default.BucketsEquivalent
function BucketsLib.__default.BucketsEquivalent(a#0: DatatypeType, b#0: DatatypeType) : bool;

function BucketsLib.__default.BucketsEquivalent#canCall(a#0: DatatypeType, b#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketsEquivalent
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { BucketsLib.__default.BucketsEquivalent(a#0, b#0) } 
    BucketsLib.__default.BucketsEquivalent#canCall(a#0, b#0)
         || ($Is(a#0, Tclass.BucketsLib.Bucket()) && $Is(b#0, Tclass.BucketsLib.Bucket()))
       ==> true);

function BucketsLib.__default.BucketsEquivalent#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketsEquivalent
axiom (forall a#0: DatatypeType, b#0: DatatypeType :: 
  { BucketsLib.__default.BucketsEquivalent#requires(a#0, b#0) } 
  $Is(a#0, Tclass.BucketsLib.Bucket()) && $Is(b#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.BucketsEquivalent#requires(a#0, b#0) == true);

// definition axiom for BucketsLib.__default.BucketsEquivalent(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { BucketsLib.__default.BucketsEquivalent(a#0, b#0) } 
    BucketsLib.__default.BucketsEquivalent#canCall(a#0, b#0)
         || ($Is(a#0, Tclass.BucketsLib.Bucket()) && $Is(b#0, Tclass.BucketsLib.Bucket()))
       ==> (forall key#2: Seq Box :: 
          { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#2) } 
          $Is(key#2, Tclass.KeyType.Key())
             ==> BucketsLib.__default.BucketsEquivalentForKey#canCall(a#0, b#0, key#2))
         && BucketsLib.__default.BucketsEquivalent(a#0, b#0)
           == (forall key#2: Seq Box :: 
            { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#2) } 
            $Is(key#2, Tclass.KeyType.Key())
               ==> BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#2)));

// definition axiom for BucketsLib.__default.BucketsEquivalent for all literals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketsEquivalent(Lit(a#0), Lit(b#0)) } 
    BucketsLib.__default.BucketsEquivalent#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, Tclass.BucketsLib.Bucket()) && $Is(b#0, Tclass.BucketsLib.Bucket()))
       ==> (forall key#3: Seq Box :: 
          { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#3) } 
          $Is(key#3, Tclass.KeyType.Key())
             ==> BucketsLib.__default.BucketsEquivalentForKey#canCall(Lit(a#0), Lit(b#0), key#3))
         && BucketsLib.__default.BucketsEquivalent(Lit(a#0), Lit(b#0))
           == (forall key#3: Seq Box :: 
            { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#3) } 
            $Is(key#3, Tclass.KeyType.Key())
               ==> BucketsLib.__default.BucketsEquivalentForKey(Lit(a#0), Lit(b#0), key#3)));

// function declaration for BucketsLib._default.Compose
function BucketsLib.__default.Compose($ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.Compose#canCall(top#0: DatatypeType, bot#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
  { BucketsLib.__default.Compose($LS($ly), top#0, bot#0) } 
  BucketsLib.__default.Compose($LS($ly), top#0, bot#0)
     == BucketsLib.__default.Compose($ly, top#0, bot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
  { BucketsLib.__default.Compose(AsFuelBottom($ly), top#0, bot#0) } 
  BucketsLib.__default.Compose($ly, top#0, bot#0)
     == BucketsLib.__default.Compose($LZ, top#0, bot#0));

// consequence axiom for BucketsLib.__default.Compose
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
    { BucketsLib.__default.Compose($ly, top#0, bot#0) } 
    BucketsLib.__default.Compose#canCall(top#0, bot#0)
         || ($Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bot#0, Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.Compose($ly, top#0, bot#0))
         && $Is(BucketsLib.__default.Compose($ly, top#0, bot#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.Compose#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.Compose
axiom (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
  { BucketsLib.__default.Compose#requires($ly, top#0, bot#0) } 
  $Is(top#0, Tclass.BucketsLib.Bucket()) && $Is(bot#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.Compose#requires($ly, top#0, bot#0) == true);

// definition axiom for BucketsLib.__default.Compose(revealed)
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
    { BucketsLib.__default.Compose($LS($ly), top#0, bot#0) } 
    BucketsLib.__default.Compose#canCall(top#0, bot#0)
         || ($Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bot#0, Tclass.BucketsLib.Bucket()))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketGet(bot#0, key#0) } 
            { BucketsLib.__default.BucketGet(top#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
               && BucketsLib.Bucket.BucketMapWithSeq_q(bot#0)
               && (Map#Domain(BucketsLib.Bucket.b(top#0))[$Box(key#0)]
                   || Map#Domain(BucketsLib.Bucket.b(bot#0))[$Box(key#0)]
                 ==> BucketsLib.__default.BucketGet#canCall(top#0, key#0)
                   && BucketsLib.__default.BucketGet#canCall(bot#0, key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(top#0, key#0), 
                    BucketsLib.__default.BucketGet(bot#0, key#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && (Map#Domain(BucketsLib.Bucket.b(top#0))[$w#4]
                   || Map#Domain(BucketsLib.Bucket.b(bot#0))[$w#4])), 
            (lambda $w#4: Box :: 
              $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(top#0, $Unbox($w#4): Seq Box), 
                  BucketsLib.__default.BucketGet(bot#0, $Unbox($w#4): Seq Box)))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.Compose($LS($ly), top#0, bot#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && (Map#Domain(BucketsLib.Bucket.b(top#0))[$w#5]
                     || Map#Domain(BucketsLib.Bucket.b(bot#0))[$w#5])), 
              (lambda $w#5: Box :: 
                $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(top#0, $Unbox($w#5): Seq Box), 
                    BucketsLib.__default.BucketGet(bot#0, $Unbox($w#5): Seq Box)))), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.Compose for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.Compose($LS($ly), Lit(top#0), Lit(bot#0)) } 
    BucketsLib.__default.Compose#canCall(Lit(top#0), Lit(bot#0))
         || ($Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bot#0, Tclass.BucketsLib.Bucket()))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketGet(bot#0, key#0) } 
            { BucketsLib.__default.BucketGet(top#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0))
               && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bot#0))
               && (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(top#0)))))[$Box(key#0)]
                   || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(bot#0)))))[$Box(key#0)]
                 ==> BucketsLib.__default.BucketGet#canCall(Lit(top#0), key#0)
                   && BucketsLib.__default.BucketGet#canCall(Lit(bot#0), key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(Lit(top#0), key#0), 
                    BucketsLib.__default.BucketGet(Lit(bot#0), key#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(top#0)))))[$w#6]
                   || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(bot#0)))))[$w#6])), 
            (lambda $w#6: Box :: 
              $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(top#0), $Unbox($w#6): Seq Box), 
                  BucketsLib.__default.BucketGet(Lit(bot#0), $Unbox($w#6): Seq Box)))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.Compose($LS($ly), Lit(top#0), Lit(bot#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(top#0)))))[$w#7]
                     || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(bot#0)))))[$w#7])), 
              (lambda $w#7: Box :: 
                $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(top#0), $Unbox($w#7): Seq Box), 
                    BucketsLib.__default.BucketGet(Lit(bot#0), $Unbox($w#7): Seq Box)))), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.ComposeSeq
function BucketsLib.__default.ComposeSeq($ly: LayerType, buckets#0: Seq Box) : DatatypeType;

function BucketsLib.__default.ComposeSeq#canCall(buckets#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.ComposeSeq($LS($ly), buckets#0) } 
  BucketsLib.__default.ComposeSeq($LS($ly), buckets#0)
     == BucketsLib.__default.ComposeSeq($ly, buckets#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.ComposeSeq(AsFuelBottom($ly), buckets#0) } 
  BucketsLib.__default.ComposeSeq($ly, buckets#0)
     == BucketsLib.__default.ComposeSeq($LZ, buckets#0));

// consequence axiom for BucketsLib.__default.ComposeSeq
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketsLib.__default.ComposeSeq($ly, buckets#0) } 
    BucketsLib.__default.ComposeSeq#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.ComposeSeq($ly, buckets#0))
         && $Is(BucketsLib.__default.ComposeSeq($ly, buckets#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ComposeSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.ComposeSeq
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.ComposeSeq#requires($ly, buckets#0) } 
  $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.ComposeSeq#requires($ly, buckets#0) == true);

// definition axiom for BucketsLib.__default.ComposeSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketsLib.__default.ComposeSeq($LS($ly), buckets#0) } 
    BucketsLib.__default.ComposeSeq#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(buckets#0) == LitInt(0)
           ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && (Seq#Length(buckets#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.ComposeSeq#canCall(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))
             && Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.Compose#canCall(BucketsLib.__default.ComposeSeq($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0)), 
              $Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType))
         && BucketsLib.__default.ComposeSeq($LS($ly), buckets#0)
           == (if Seq#Length(buckets#0) == LitInt(0)
             then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))
             else BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, 
              BucketsLib.__default.ComposeSeq($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0)), 
              $Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType)));

// definition axiom for BucketsLib.__default.ComposeSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.ComposeSeq($LS($ly), Lit(buckets#0)) } 
    BucketsLib.__default.ComposeSeq#canCall(Lit(buckets#0))
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(Lit(buckets#0)) == LitInt(0)
           ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && (Seq#Length(Lit(buckets#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.ComposeSeq#canCall(Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))
             && Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.Compose#canCall(BucketsLib.__default.ComposeSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0)))), 
              Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType)))
         && BucketsLib.__default.ComposeSeq($LS($ly), Lit(buckets#0))
           == (if Seq#Length(Lit(buckets#0)) == LitInt(0)
             then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))
             else BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, 
              BucketsLib.__default.ComposeSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0)))), 
              Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))));

// function declaration for BucketsLib._default.FlushEquivalentParentChild
function BucketsLib.__default.FlushEquivalentParentChild(oldparent#0: DatatypeType, 
    oldchild#0: DatatypeType, 
    newparent#0: DatatypeType, 
    newchild#0: DatatypeType)
   : bool;

function BucketsLib.__default.FlushEquivalentParentChild#canCall(oldparent#0: DatatypeType, 
    oldchild#0: DatatypeType, 
    newparent#0: DatatypeType, 
    newchild#0: DatatypeType)
   : bool;

// consequence axiom for BucketsLib.__default.FlushEquivalentParentChild
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchild#0: DatatypeType, 
      newparent#0: DatatypeType, 
      newchild#0: DatatypeType :: 
    { BucketsLib.__default.FlushEquivalentParentChild(oldparent#0, oldchild#0, newparent#0, newchild#0) } 
    BucketsLib.__default.FlushEquivalentParentChild#canCall(oldparent#0, oldchild#0, newparent#0, newchild#0)
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchild#0, Tclass.BucketsLib.Bucket())
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchild#0, Tclass.BucketsLib.Bucket()))
       ==> true);

function BucketsLib.__default.FlushEquivalentParentChild#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.FlushEquivalentParentChild
axiom (forall oldparent#0: DatatypeType, 
    oldchild#0: DatatypeType, 
    newparent#0: DatatypeType, 
    newchild#0: DatatypeType :: 
  { BucketsLib.__default.FlushEquivalentParentChild#requires(oldparent#0, oldchild#0, newparent#0, newchild#0) } 
  $Is(oldparent#0, Tclass.BucketsLib.Bucket())
       && $Is(oldchild#0, Tclass.BucketsLib.Bucket())
       && $Is(newparent#0, Tclass.BucketsLib.Bucket())
       && $Is(newchild#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.FlushEquivalentParentChild#requires(oldparent#0, oldchild#0, newparent#0, newchild#0)
       == true);

// definition axiom for BucketsLib.__default.FlushEquivalentParentChild(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchild#0: DatatypeType, 
      newparent#0: DatatypeType, 
      newchild#0: DatatypeType :: 
    { BucketsLib.__default.FlushEquivalentParentChild(oldparent#0, oldchild#0, newparent#0, newchild#0) } 
    BucketsLib.__default.FlushEquivalentParentChild#canCall(oldparent#0, oldchild#0, newparent#0, newchild#0)
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchild#0, Tclass.BucketsLib.Bucket())
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchild#0, Tclass.BucketsLib.Bucket()))
       ==> $IsA#BucketsLib.Bucket(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, oldparent#0, oldchild#0))
         && $IsA#BucketsLib.Bucket(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, newparent#0, newchild#0))
         && 
        BucketsLib.__default.Compose#canCall(oldparent#0, oldchild#0)
         && BucketsLib.__default.Compose#canCall(newparent#0, newchild#0)
         && BucketsLib.__default.FlushEquivalentParentChild(oldparent#0, oldchild#0, newparent#0, newchild#0)
           == BucketsLib.Bucket#Equal(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, oldparent#0, oldchild#0), 
            BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, newparent#0, newchild#0)));

// definition axiom for BucketsLib.__default.FlushEquivalentParentChild for all literals(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchild#0: DatatypeType, 
      newparent#0: DatatypeType, 
      newchild#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.FlushEquivalentParentChild(Lit(oldparent#0), Lit(oldchild#0), Lit(newparent#0), Lit(newchild#0)) } 
    BucketsLib.__default.FlushEquivalentParentChild#canCall(Lit(oldparent#0), Lit(oldchild#0), Lit(newparent#0), Lit(newchild#0))
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchild#0, Tclass.BucketsLib.Bucket())
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchild#0, Tclass.BucketsLib.Bucket()))
       ==> $IsA#BucketsLib.Bucket(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, Lit(oldparent#0), Lit(oldchild#0)))
         && $IsA#BucketsLib.Bucket(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, Lit(newparent#0), Lit(newchild#0)))
         && 
        BucketsLib.__default.Compose#canCall(Lit(oldparent#0), Lit(oldchild#0))
         && BucketsLib.__default.Compose#canCall(Lit(newparent#0), Lit(newchild#0))
         && BucketsLib.__default.FlushEquivalentParentChild(Lit(oldparent#0), Lit(oldchild#0), Lit(newparent#0), Lit(newchild#0))
           == BucketsLib.Bucket#Equal(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, Lit(oldparent#0), Lit(oldchild#0)), 
            BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, Lit(newparent#0), Lit(newchild#0))));

// function declaration for BucketsLib._default.FlushEquivalent
function BucketsLib.__default.FlushEquivalent(oldparent#0: DatatypeType, 
    oldchildren#0: Seq Box, 
    newparent#0: DatatypeType, 
    newchildren#0: Seq Box)
   : bool;

function BucketsLib.__default.FlushEquivalent#canCall(oldparent#0: DatatypeType, 
    oldchildren#0: Seq Box, 
    newparent#0: DatatypeType, 
    newchildren#0: Seq Box)
   : bool;

// consequence axiom for BucketsLib.__default.FlushEquivalent
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchildren#0: Seq Box, 
      newparent#0: DatatypeType, 
      newchildren#0: Seq Box :: 
    { BucketsLib.__default.FlushEquivalent(oldparent#0, oldchildren#0, newparent#0, newchildren#0) } 
    BucketsLib.__default.FlushEquivalent#canCall(oldparent#0, oldchildren#0, newparent#0, newchildren#0)
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchildren#0, TSeq(Tclass.BucketsLib.Bucket())))
       ==> true);

function BucketsLib.__default.FlushEquivalent#requires(DatatypeType, Seq Box, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.FlushEquivalent
axiom (forall oldparent#0: DatatypeType, 
    oldchildren#0: Seq Box, 
    newparent#0: DatatypeType, 
    newchildren#0: Seq Box :: 
  { BucketsLib.__default.FlushEquivalent#requires(oldparent#0, oldchildren#0, newparent#0, newchildren#0) } 
  $Is(oldparent#0, Tclass.BucketsLib.Bucket())
       && $Is(oldchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(newparent#0, Tclass.BucketsLib.Bucket())
       && $Is(newchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.FlushEquivalent#requires(oldparent#0, oldchildren#0, newparent#0, newchildren#0)
       == true);

// definition axiom for BucketsLib.__default.FlushEquivalent(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchildren#0: Seq Box, 
      newparent#0: DatatypeType, 
      newchildren#0: Seq Box :: 
    { BucketsLib.__default.FlushEquivalent(oldparent#0, oldchildren#0, newparent#0, newchildren#0) } 
    BucketsLib.__default.FlushEquivalent#canCall(oldparent#0, oldchildren#0, newparent#0, newchildren#0)
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchildren#0, TSeq(Tclass.BucketsLib.Bucket())))
       ==> (Seq#Length(oldchildren#0) == Seq#Length(newchildren#0)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(newchildren#0, i#2)): DatatypeType } 
              { $Unbox(Seq#Index(oldchildren#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(oldchildren#0)
               ==> BucketsLib.__default.FlushEquivalentParentChild#canCall(oldparent#0, 
                $Unbox(Seq#Index(oldchildren#0, i#2)): DatatypeType, 
                newparent#0, 
                $Unbox(Seq#Index(newchildren#0, i#2)): DatatypeType)))
         && BucketsLib.__default.FlushEquivalent(oldparent#0, oldchildren#0, newparent#0, newchildren#0)
           == (Seq#Length(oldchildren#0) == Seq#Length(newchildren#0)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(newchildren#0, i#2)): DatatypeType } 
                { $Unbox(Seq#Index(oldchildren#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(oldchildren#0)
                 ==> BucketsLib.__default.FlushEquivalentParentChild(oldparent#0, 
                  $Unbox(Seq#Index(oldchildren#0, i#2)): DatatypeType, 
                  newparent#0, 
                  $Unbox(Seq#Index(newchildren#0, i#2)): DatatypeType))));

// definition axiom for BucketsLib.__default.FlushEquivalent for all literals(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchildren#0: Seq Box, 
      newparent#0: DatatypeType, 
      newchildren#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.FlushEquivalent(Lit(oldparent#0), Lit(oldchildren#0), Lit(newparent#0), Lit(newchildren#0)) } 
    BucketsLib.__default.FlushEquivalent#canCall(Lit(oldparent#0), Lit(oldchildren#0), Lit(newparent#0), Lit(newchildren#0))
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchildren#0, TSeq(Tclass.BucketsLib.Bucket())))
       ==> (Seq#Length(Lit(oldchildren#0)) == Seq#Length(Lit(newchildren#0))
           ==> (forall i#3: int :: 
            { $Unbox(Seq#Index(newchildren#0, i#3)): DatatypeType } 
              { $Unbox(Seq#Index(oldchildren#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(oldchildren#0))
               ==> BucketsLib.__default.FlushEquivalentParentChild#canCall(Lit(oldparent#0), 
                $Unbox(Seq#Index(Lit(oldchildren#0), i#3)): DatatypeType, 
                Lit(newparent#0), 
                $Unbox(Seq#Index(Lit(newchildren#0), i#3)): DatatypeType)))
         && BucketsLib.__default.FlushEquivalent(Lit(oldparent#0), Lit(oldchildren#0), Lit(newparent#0), Lit(newchildren#0))
           == (Seq#Length(Lit(oldchildren#0)) == Seq#Length(Lit(newchildren#0))
             && (forall i#3: int :: 
              { $Unbox(Seq#Index(newchildren#0, i#3)): DatatypeType } 
                { $Unbox(Seq#Index(oldchildren#0, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(oldchildren#0))
                 ==> BucketsLib.__default.FlushEquivalentParentChild(Lit(oldparent#0), 
                  $Unbox(Seq#Index(Lit(oldchildren#0), i#3)): DatatypeType, 
                  Lit(newparent#0), 
                  $Unbox(Seq#Index(Lit(newchildren#0), i#3)): DatatypeType))));

// function declaration for BucketsLib._default.InterpretBucketStack
function BucketsLib.__default.InterpretBucketStack($ly: LayerType, buckets#0: Seq Box, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.InterpretBucketStack#canCall(buckets#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.InterpretBucketStack($LS($ly), buckets#0, key#0) } 
  BucketsLib.__default.InterpretBucketStack($LS($ly), buckets#0, key#0)
     == BucketsLib.__default.InterpretBucketStack($ly, buckets#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.InterpretBucketStack(AsFuelBottom($ly), buckets#0, key#0) } 
  BucketsLib.__default.InterpretBucketStack($ly, buckets#0, key#0)
     == BucketsLib.__default.InterpretBucketStack($LZ, buckets#0, key#0));

// consequence axiom for BucketsLib.__default.InterpretBucketStack
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.InterpretBucketStack($ly, buckets#0, key#0) } 
    BucketsLib.__default.InterpretBucketStack#canCall(buckets#0, key#0)
         || ($Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> $Is(BucketsLib.__default.InterpretBucketStack($ly, buckets#0, key#0), 
        Tclass.ValueMessage.Message()));

function BucketsLib.__default.InterpretBucketStack#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.InterpretBucketStack
axiom (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.InterpretBucketStack#requires($ly, buckets#0, key#0) } 
  $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.InterpretBucketStack#requires($ly, buckets#0, key#0)
       == true);

// definition axiom for BucketsLib.__default.InterpretBucketStack(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.InterpretBucketStack($LS($ly), buckets#0, key#0) } 
    BucketsLib.__default.InterpretBucketStack#canCall(buckets#0, key#0)
         || ($Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(buckets#0) == LitInt(0)
           ==> ValueMessage.__default.NopDelta#canCall())
         && (Seq#Length(buckets#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.InterpretBucketStack#canCall(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0), key#0)
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.BucketGet#canCall($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType, 
              key#0)
             && ValueMessage.__default.Merge#canCall(BucketsLib.__default.InterpretBucketStack($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0), key#0), 
              BucketsLib.__default.BucketGet($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType, 
                key#0)))
         && BucketsLib.__default.InterpretBucketStack($LS($ly), buckets#0, key#0)
           == (if Seq#Length(buckets#0) == LitInt(0)
             then #ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta()))
             else ValueMessage.__default.Merge(BucketsLib.__default.InterpretBucketStack($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0), key#0), 
              BucketsLib.__default.BucketGet($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType, 
                key#0))));

// definition axiom for BucketsLib.__default.InterpretBucketStack for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.InterpretBucketStack($LS($ly), Lit(buckets#0), Lit(key#0)) } 
    BucketsLib.__default.InterpretBucketStack#canCall(Lit(buckets#0), Lit(key#0))
         || ($Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(Lit(buckets#0)) == LitInt(0)
           ==> ValueMessage.__default.NopDelta#canCall())
         && (Seq#Length(Lit(buckets#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.InterpretBucketStack#canCall(Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))), 
              Lit(key#0))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.BucketGet#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType), 
              Lit(key#0))
             && ValueMessage.__default.Merge#canCall(Lit(BucketsLib.__default.InterpretBucketStack($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))), 
                  Lit(key#0))), 
              Lit(BucketsLib.__default.BucketGet(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType), 
                  Lit(key#0)))))
         && BucketsLib.__default.InterpretBucketStack($LS($ly), Lit(buckets#0), Lit(key#0))
           == (if Seq#Length(Lit(buckets#0)) == LitInt(0)
             then #ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta()))
             else ValueMessage.__default.Merge(Lit(BucketsLib.__default.InterpretBucketStack($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))), 
                  Lit(key#0))), 
              Lit(BucketsLib.__default.BucketGet(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType), 
                  Lit(key#0))))));

// function declaration for BucketsLib._default.ClampRange
function BucketsLib.__default.ClampRange($ly: LayerType, 
    bucket#0: DatatypeType, 
    start#0: DatatypeType, 
    end#0: DatatypeType)
   : DatatypeType;

function BucketsLib.__default.ClampRange#canCall(bucket#0: DatatypeType, start#0: DatatypeType, end#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    bucket#0: DatatypeType, 
    start#0: DatatypeType, 
    end#0: DatatypeType :: 
  { BucketsLib.__default.ClampRange($LS($ly), bucket#0, start#0, end#0) } 
  BucketsLib.__default.ClampRange($LS($ly), bucket#0, start#0, end#0)
     == BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    bucket#0: DatatypeType, 
    start#0: DatatypeType, 
    end#0: DatatypeType :: 
  { BucketsLib.__default.ClampRange(AsFuelBottom($ly), bucket#0, start#0, end#0) } 
  BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0)
     == BucketsLib.__default.ClampRange($LZ, bucket#0, start#0, end#0));

// consequence axiom for BucketsLib.__default.ClampRange
axiom true
   ==> (forall $ly: LayerType, 
      bucket#0: DatatypeType, 
      start#0: DatatypeType, 
      end#0: DatatypeType :: 
    { BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0) } 
    BucketsLib.__default.ClampRange#canCall(bucket#0, start#0, end#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0))
         && $Is(BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ClampRange#requires(LayerType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.ClampRange
axiom (forall $ly: LayerType, 
    bucket#0: DatatypeType, 
    start#0: DatatypeType, 
    end#0: DatatypeType :: 
  { BucketsLib.__default.ClampRange#requires($ly, bucket#0, start#0, end#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(start#0, Tclass.UI.RangeStart())
       && $Is(end#0, Tclass.UI.RangeEnd())
     ==> BucketsLib.__default.ClampRange#requires($ly, bucket#0, start#0, end#0) == true);

// definition axiom for BucketsLib.__default.ClampRange(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      bucket#0: DatatypeType, 
      start#0: DatatypeType, 
      end#0: DatatypeType :: 
    { BucketsLib.__default.ClampRange($LS($ly), bucket#0, start#0, end#0) } 
    BucketsLib.__default.ClampRange#canCall(bucket#0, start#0, end#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.InRange(start#0, key#0, end#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> MapSpec.__default.InRange#canCall(start#0, key#0, end#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && MapSpec.__default.InRange(start#0, key#0, end#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                 && MapSpec.__default.InRange(start#0, $Unbox($w#4): Seq Box, end#0)), 
            (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampRange($LS($ly), bucket#0, start#0, end#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                   && MapSpec.__default.InRange(start#0, $Unbox($w#5): Seq Box, end#0)), 
              (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.ClampRange for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      bucket#0: DatatypeType, 
      start#0: DatatypeType, 
      end#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.ClampRange($LS($ly), Lit(bucket#0), Lit(start#0), Lit(end#0)) } 
    BucketsLib.__default.ClampRange#canCall(Lit(bucket#0), Lit(start#0), Lit(end#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.InRange(start#0, key#0, end#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> MapSpec.__default.InRange#canCall(Lit(start#0), key#0, Lit(end#0)))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && MapSpec.__default.InRange(Lit(start#0), key#0, Lit(end#0))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#6]
                 && MapSpec.__default.InRange(Lit(start#0), $Unbox($w#6): Seq Box, Lit(end#0))), 
            (lambda $w#6: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#6]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampRange($LS($ly), Lit(bucket#0), Lit(start#0), Lit(end#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#7]
                   && MapSpec.__default.InRange(Lit(start#0), $Unbox($w#7): Seq Box, Lit(end#0))), 
              (lambda $w#7: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#7]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.ClampStart
function BucketsLib.__default.ClampStart($ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.ClampStart#canCall(bucket#0: DatatypeType, start#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
  { BucketsLib.__default.ClampStart($LS($ly), bucket#0, start#0) } 
  BucketsLib.__default.ClampStart($LS($ly), bucket#0, start#0)
     == BucketsLib.__default.ClampStart($ly, bucket#0, start#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
  { BucketsLib.__default.ClampStart(AsFuelBottom($ly), bucket#0, start#0) } 
  BucketsLib.__default.ClampStart($ly, bucket#0, start#0)
     == BucketsLib.__default.ClampStart($LZ, bucket#0, start#0));

// consequence axiom for BucketsLib.__default.ClampStart
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
    { BucketsLib.__default.ClampStart($ly, bucket#0, start#0) } 
    BucketsLib.__default.ClampStart#canCall(bucket#0, start#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.ClampStart($ly, bucket#0, start#0))
         && $Is(BucketsLib.__default.ClampStart($ly, bucket#0, start#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ClampStart#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.ClampStart
axiom (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
  { BucketsLib.__default.ClampStart#requires($ly, bucket#0, start#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(start#0, Tclass.UI.RangeStart())
     ==> BucketsLib.__default.ClampStart#requires($ly, bucket#0, start#0) == true);

// definition axiom for BucketsLib.__default.ClampStart(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
    { BucketsLib.__default.ClampStart($LS($ly), bucket#0, start#0) } 
    BucketsLib.__default.ClampStart#canCall(bucket#0, start#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.LowerBound(start#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> MapSpec.__default.LowerBound#canCall(start#0, key#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && MapSpec.__default.LowerBound(start#0, key#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                 && MapSpec.__default.LowerBound(start#0, $Unbox($w#4): Seq Box)), 
            (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampStart($LS($ly), bucket#0, start#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                   && MapSpec.__default.LowerBound(start#0, $Unbox($w#5): Seq Box)), 
              (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.ClampStart for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.ClampStart($LS($ly), Lit(bucket#0), Lit(start#0)) } 
    BucketsLib.__default.ClampStart#canCall(Lit(bucket#0), Lit(start#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.LowerBound(start#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> MapSpec.__default.LowerBound#canCall(Lit(start#0), key#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && MapSpec.__default.LowerBound(Lit(start#0), key#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#6]
                 && MapSpec.__default.LowerBound(Lit(start#0), $Unbox($w#6): Seq Box)), 
            (lambda $w#6: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#6]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampStart($LS($ly), Lit(bucket#0), Lit(start#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#7]
                   && MapSpec.__default.LowerBound(Lit(start#0), $Unbox($w#7): Seq Box)), 
              (lambda $w#7: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#7]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.ClampEnd
function BucketsLib.__default.ClampEnd($ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.ClampEnd#canCall(bucket#0: DatatypeType, end#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
  { BucketsLib.__default.ClampEnd($LS($ly), bucket#0, end#0) } 
  BucketsLib.__default.ClampEnd($LS($ly), bucket#0, end#0)
     == BucketsLib.__default.ClampEnd($ly, bucket#0, end#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
  { BucketsLib.__default.ClampEnd(AsFuelBottom($ly), bucket#0, end#0) } 
  BucketsLib.__default.ClampEnd($ly, bucket#0, end#0)
     == BucketsLib.__default.ClampEnd($LZ, bucket#0, end#0));

// consequence axiom for BucketsLib.__default.ClampEnd
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
    { BucketsLib.__default.ClampEnd($ly, bucket#0, end#0) } 
    BucketsLib.__default.ClampEnd#canCall(bucket#0, end#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.ClampEnd($ly, bucket#0, end#0))
         && $Is(BucketsLib.__default.ClampEnd($ly, bucket#0, end#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ClampEnd#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.ClampEnd
axiom (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
  { BucketsLib.__default.ClampEnd#requires($ly, bucket#0, end#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(end#0, Tclass.UI.RangeEnd())
     ==> BucketsLib.__default.ClampEnd#requires($ly, bucket#0, end#0) == true);

// definition axiom for BucketsLib.__default.ClampEnd(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
    { BucketsLib.__default.ClampEnd($LS($ly), bucket#0, end#0) } 
    BucketsLib.__default.ClampEnd#canCall(bucket#0, end#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.UpperBound(key#0, end#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> MapSpec.__default.UpperBound#canCall(key#0, end#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && MapSpec.__default.UpperBound(key#0, end#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                 && MapSpec.__default.UpperBound($Unbox($w#4): Seq Box, end#0)), 
            (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampEnd($LS($ly), bucket#0, end#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                   && MapSpec.__default.UpperBound($Unbox($w#5): Seq Box, end#0)), 
              (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.ClampEnd for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.ClampEnd($LS($ly), Lit(bucket#0), Lit(end#0)) } 
    BucketsLib.__default.ClampEnd#canCall(Lit(bucket#0), Lit(end#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.UpperBound(key#0, end#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> MapSpec.__default.UpperBound#canCall(key#0, Lit(end#0)))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && MapSpec.__default.UpperBound(key#0, Lit(end#0))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#6]
                 && MapSpec.__default.UpperBound($Unbox($w#6): Seq Box, Lit(end#0))), 
            (lambda $w#6: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#6]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampEnd($LS($ly), Lit(bucket#0), Lit(end#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#7]
                   && MapSpec.__default.UpperBound($Unbox($w#7): Seq Box, Lit(end#0))), 
              (lambda $w#7: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#7]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.KeyValueMapOfBucket
function BucketsLib.__default.KeyValueMapOfBucket($ly: LayerType, bucket#0: DatatypeType) : Map Box Box;

function BucketsLib.__default.KeyValueMapOfBucket#canCall(bucket#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType :: 
  { BucketsLib.__default.KeyValueMapOfBucket($LS($ly), bucket#0) } 
  BucketsLib.__default.KeyValueMapOfBucket($LS($ly), bucket#0)
     == BucketsLib.__default.KeyValueMapOfBucket($ly, bucket#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType :: 
  { BucketsLib.__default.KeyValueMapOfBucket(AsFuelBottom($ly), bucket#0) } 
  BucketsLib.__default.KeyValueMapOfBucket($ly, bucket#0)
     == BucketsLib.__default.KeyValueMapOfBucket($LZ, bucket#0));

// consequence axiom for BucketsLib.__default.KeyValueMapOfBucket
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType :: 
    { BucketsLib.__default.KeyValueMapOfBucket($ly, bucket#0) } 
    BucketsLib.__default.KeyValueMapOfBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> $Is(BucketsLib.__default.KeyValueMapOfBucket($ly, bucket#0), 
        TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value())));

function BucketsLib.__default.KeyValueMapOfBucket#requires(LayerType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.KeyValueMapOfBucket
axiom (forall $ly: LayerType, bucket#0: DatatypeType :: 
  { BucketsLib.__default.KeyValueMapOfBucket#requires($ly, bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.KeyValueMapOfBucket#requires($ly, bucket#0) == true);

// definition axiom for BucketsLib.__default.KeyValueMapOfBucket(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType :: 
    { BucketsLib.__default.KeyValueMapOfBucket($LS($ly), bucket#0) } 
    BucketsLib.__default.KeyValueMapOfBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && ValueMessage.__default.DefineDefault#canCall()
                   && ValueMessage.__default.Merge#canCall($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))
                   && ValueMessage.__default.DefaultValue#canCall())
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && !Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
                        Lit(ValueMessage.__default.DefineDefault()))), 
                    ValueMessage.__default.DefaultValue())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && ValueMessage.__default.DefineDefault#canCall()
                   && ValueMessage.__default.Merge#canCall($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))))
         && BucketsLib.__default.KeyValueMapOfBucket($LS($ly), bucket#0)
           == Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#2]
                 && !Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#2]): DatatypeType, 
                      Lit(ValueMessage.__default.DefineDefault()))), 
                  ValueMessage.__default.DefaultValue())), 
            (lambda $w#2: Box :: 
              $Box(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#2]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value())));

// definition axiom for BucketsLib.__default.KeyValueMapOfBucket for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.KeyValueMapOfBucket($LS($ly), Lit(bucket#0)) } 
    BucketsLib.__default.KeyValueMapOfBucket#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                   && ValueMessage.__default.DefineDefault#canCall()
                   && ValueMessage.__default.Merge#canCall($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#0)]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))
                   && ValueMessage.__default.DefaultValue#canCall())
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && !Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#0)]): DatatypeType, 
                        Lit(ValueMessage.__default.DefineDefault()))), 
                    ValueMessage.__default.DefaultValue())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                   && ValueMessage.__default.DefineDefault#canCall()
                   && ValueMessage.__default.Merge#canCall($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#0)]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))))
         && BucketsLib.__default.KeyValueMapOfBucket($LS($ly), Lit(bucket#0))
           == Map#Glue((lambda $w#3: Box :: 
              $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                 && !Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]): DatatypeType, 
                      Lit(ValueMessage.__default.DefineDefault()))), 
                  ValueMessage.__default.DefaultValue())), 
            (lambda $w#3: Box :: 
              $Box(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value())));

// function declaration for BucketsLib._default.SortedSeqOfKeyValueMap
function BucketsLib.__default.SortedSeqOfKeyValueMap($ly: LayerType, m#0: Map Box Box) : Seq Box;

function BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(m#0: Map Box Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), m#0) } 
  BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), m#0)
     == BucketsLib.__default.SortedSeqOfKeyValueMap($ly, m#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.SortedSeqOfKeyValueMap(AsFuelBottom($ly), m#0) } 
  BucketsLib.__default.SortedSeqOfKeyValueMap($ly, m#0)
     == BucketsLib.__default.SortedSeqOfKeyValueMap($LZ, m#0));

// consequence axiom for BucketsLib.__default.SortedSeqOfKeyValueMap
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.SortedSeqOfKeyValueMap($ly, m#0) } 
    BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> $Is(BucketsLib.__default.SortedSeqOfKeyValueMap($ly, m#0), 
        TSeq(Tclass.UI.SuccResult())));

function BucketsLib.__default.SortedSeqOfKeyValueMap#requires(LayerType, Map Box Box) : bool;

// #requires axiom for BucketsLib.__default.SortedSeqOfKeyValueMap
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.SortedSeqOfKeyValueMap#requires($ly, m#0) } 
  $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
     ==> BucketsLib.__default.SortedSeqOfKeyValueMap#requires($ly, m#0) == true);

// definition axiom for BucketsLib.__default.SortedSeqOfKeyValueMap(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), m#0) } 
    BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> Lexicographic__Byte__Order.__default.maximumOpt#canCall(Map#Domain(m#0))
         && (var max#2 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, Map#Domain(m#0)); 
          !Options.Option.None_q(max#2)
             ==> Maps.__default.MapRemove1#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueType.Value(), 
                m#0, 
                Options.Option.value(max#2))
               && BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                  Tclass.ValueType.Value(), 
                  StartFuel_Maps._default.MapRemove1, 
                  m#0, 
                  Options.Option.value(max#2))))
         && BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), m#0)
           == (var max#2 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, Map#Domain(m#0)); 
            (if Options.Option.None_q(max#2)
               then Seq#Empty(): Seq Box
               else Seq#Append(BucketsLib.__default.SortedSeqOfKeyValueMap($ly, 
                  Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                    Tclass.ValueType.Value(), 
                    StartFuel_Maps._default.MapRemove1, 
                    m#0, 
                    Options.Option.value(max#2))), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(#UI.SuccResult.SuccResult($Unbox(Options.Option.value(max#2)): Seq Box, 
                      $Unbox(Map#Elements(m#0)[Options.Option.value(max#2)]): Seq Box)))))));

// definition axiom for BucketsLib.__default.SortedSeqOfKeyValueMap for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    {:weight 3} { BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), Lit(m#0)) } 
    BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(Lit(m#0))
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> Lexicographic__Byte__Order.__default.maximumOpt#canCall(Lit(Map#Domain(Lit(m#0))))
         && (var max#3 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, 
              Lit(Map#Domain(Lit(m#0)))); 
          !Options.Option.None_q(max#3)
             ==> Maps.__default.MapRemove1#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueType.Value(), 
                Lit(m#0), 
                Options.Option.value(max#3))
               && BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                  Tclass.ValueType.Value(), 
                  StartFuel_Maps._default.MapRemove1, 
                  Lit(m#0), 
                  Options.Option.value(max#3))))
         && BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), Lit(m#0))
           == (var max#3 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, 
                Lit(Map#Domain(Lit(m#0)))); 
            (if Options.Option.None_q(max#3)
               then Seq#Empty(): Seq Box
               else Seq#Append(BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), 
                  Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                    Tclass.ValueType.Value(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(m#0), 
                    Options.Option.value(max#3))), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(#UI.SuccResult.SuccResult($Unbox(Options.Option.value(max#3)): Seq Box, 
                      $Unbox(Map#Elements(Lit(m#0))[Options.Option.value(max#3)]): Seq Box)))))));

// function declaration for BucketsLib._default.SplitBucketLeft
function BucketsLib.__default.SplitBucketLeft($ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box) : DatatypeType;

function BucketsLib.__default.SplitBucketLeft#canCall(bucket#0: DatatypeType, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketLeft($LS($ly), bucket#0, pivot#0) } 
  BucketsLib.__default.SplitBucketLeft($LS($ly), bucket#0, pivot#0)
     == BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketLeft(AsFuelBottom($ly), bucket#0, pivot#0) } 
  BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0)
     == BucketsLib.__default.SplitBucketLeft($LZ, bucket#0, pivot#0));

// consequence axiom for BucketsLib.__default.SplitBucketLeft
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0) } 
    BucketsLib.__default.SplitBucketLeft#canCall(bucket#0, pivot#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0))
         && Seq#Length(BucketsLib.Bucket.keys(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0)))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0)))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0))
         && $Is(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.SplitBucketLeft#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketLeft
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketLeft#requires($ly, bucket#0, pivot#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketLeft#requires($ly, bucket#0, pivot#0) == true);

// definition axiom for BucketsLib.__default.SplitBucketLeft(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketLeft($LS($ly), bucket#0, pivot#0) } 
    BucketsLib.__default.SplitBucketLeft#canCall(bucket#0, pivot#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Lexicographic__Byte__Order.__default.lt(key#0, pivot#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, pivot#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && Lexicographic__Byte__Order.__default.lt(key#0, pivot#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                 && Lexicographic__Byte__Order.__default.lt($Unbox($w#4): Seq Box, pivot#0)), 
            (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.SplitBucketLeft($LS($ly), bucket#0, pivot#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                   && Lexicographic__Byte__Order.__default.lt($Unbox($w#5): Seq Box, pivot#0)), 
              (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.SplitBucketLeft for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketLeft($LS($ly), Lit(bucket#0), Lit(pivot#0)) } 
    BucketsLib.__default.SplitBucketLeft#canCall(Lit(bucket#0), Lit(pivot#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Lexicographic__Byte__Order.__default.lt(key#0, pivot#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, Lit(pivot#0)))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && Lexicographic__Byte__Order.__default.lt(key#0, Lit(pivot#0))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#6]
                 && Lexicographic__Byte__Order.__default.lt($Unbox($w#6): Seq Box, Lit(pivot#0))), 
            (lambda $w#6: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#6]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.SplitBucketLeft($LS($ly), Lit(bucket#0), Lit(pivot#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#7]
                   && Lexicographic__Byte__Order.__default.lt($Unbox($w#7): Seq Box, Lit(pivot#0))), 
              (lambda $w#7: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#7]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.SplitBucketRight
function BucketsLib.__default.SplitBucketRight($ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box) : DatatypeType;

function BucketsLib.__default.SplitBucketRight#canCall(bucket#0: DatatypeType, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketRight($LS($ly), bucket#0, pivot#0) } 
  BucketsLib.__default.SplitBucketRight($LS($ly), bucket#0, pivot#0)
     == BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketRight(AsFuelBottom($ly), bucket#0, pivot#0) } 
  BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0)
     == BucketsLib.__default.SplitBucketRight($LZ, bucket#0, pivot#0));

// consequence axiom for BucketsLib.__default.SplitBucketRight
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0) } 
    BucketsLib.__default.SplitBucketRight#canCall(bucket#0, pivot#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0))
         && Seq#Length(BucketsLib.Bucket.keys(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0)))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0)))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0))
         && $Is(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.SplitBucketRight#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketRight
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketRight#requires($ly, bucket#0, pivot#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketRight#requires($ly, bucket#0, pivot#0) == true);

// definition axiom for BucketsLib.__default.SplitBucketRight(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketRight($LS($ly), bucket#0, pivot#0) } 
    BucketsLib.__default.SplitBucketRight#canCall(bucket#0, pivot#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Lexicographic__Byte__Order.__default.lte(pivot#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, key#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && Lexicographic__Byte__Order.__default.lte(pivot#0, key#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                 && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($w#4): Seq Box)), 
            (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.SplitBucketRight($LS($ly), bucket#0, pivot#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                   && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($w#5): Seq Box)), 
              (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.SplitBucketRight for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketRight($LS($ly), Lit(bucket#0), Lit(pivot#0)) } 
    BucketsLib.__default.SplitBucketRight#canCall(Lit(bucket#0), Lit(pivot#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Lexicographic__Byte__Order.__default.lte(pivot#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), key#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), key#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
              $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#6]
                 && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($w#6): Seq Box)), 
            (lambda $w#6: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#6]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.SplitBucketRight($LS($ly), Lit(bucket#0), Lit(pivot#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#7]
                   && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($w#7): Seq Box)), 
              (lambda $w#7: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#7]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.SplitBucketListLeft
function BucketsLib.__default.SplitBucketListLeft(blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box) : Seq Box;

function BucketsLib.__default.SplitBucketListLeft#canCall(blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.SplitBucketListLeft
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketListLeft(blist#0, pivots#0, cLeft#0, key#0) } 
    BucketsLib.__default.SplitBucketListLeft#canCall(blist#0, pivots#0, cLeft#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           && PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, pivots#0, key#0)
             == cLeft#0)
       ==> $Is(BucketsLib.__default.SplitBucketListLeft(blist#0, pivots#0, cLeft#0, key#0), 
        TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.SplitBucketListLeft#requires(Seq Box, Seq Box, int, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketListLeft
axiom (forall blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketListLeft#requires(blist#0, pivots#0, cLeft#0, key#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketListLeft#requires(blist#0, pivots#0, cLeft#0, key#0)
       == (BucketsLib.__default.WFBucketList(blist#0, pivots#0)
         && PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, pivots#0, key#0)
           == cLeft#0));

// definition axiom for BucketsLib.__default.SplitBucketListLeft(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketListLeft(blist#0, pivots#0, cLeft#0, key#0) } 
    BucketsLib.__default.SplitBucketListLeft#canCall(blist#0, pivots#0, cLeft#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           && PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, pivots#0, key#0)
             == cLeft#0)
       ==> BucketsLib.__default.SplitBucketLeft#canCall($Unbox(Seq#Index(blist#0, cLeft#0)): DatatypeType, key#0)
         && BucketsLib.__default.SplitBucketListLeft(blist#0, pivots#0, cLeft#0, key#0)
           == Seq#Append(Seq#Take(blist#0, cLeft#0), 
            Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
                  $Unbox(Seq#Index(blist#0, cLeft#0)): DatatypeType, 
                  key#0)))));

// definition axiom for BucketsLib.__default.SplitBucketListLeft for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketListLeft(Lit(blist#0), Lit(pivots#0), LitInt(cLeft#0), Lit(key#0)) } 
    BucketsLib.__default.SplitBucketListLeft#canCall(Lit(blist#0), Lit(pivots#0), LitInt(cLeft#0), Lit(key#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0)))
           && PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, Lit(pivots#0), Lit(key#0))
             == LitInt(cLeft#0))
       ==> BucketsLib.__default.SplitBucketLeft#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(cLeft#0))): DatatypeType, Lit(key#0))
         && BucketsLib.__default.SplitBucketListLeft(Lit(blist#0), Lit(pivots#0), LitInt(cLeft#0), Lit(key#0))
           == Seq#Append(Seq#Take(Lit(blist#0), LitInt(cLeft#0)), 
            Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
                  $Unbox(Seq#Index(Lit(blist#0), LitInt(cLeft#0))): DatatypeType, 
                  Lit(key#0))))));

// function declaration for BucketsLib._default.SplitBucketListRight
function BucketsLib.__default.SplitBucketListRight(blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box) : Seq Box;

function BucketsLib.__default.SplitBucketListRight#canCall(blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.SplitBucketListRight
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketListRight(blist#0, pivots#0, cRight#0, key#0) } 
    BucketsLib.__default.SplitBucketListRight#canCall(blist#0, pivots#0, cRight#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           && PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, pivots#0, key#0)
             == cRight#0)
       ==> $Is(BucketsLib.__default.SplitBucketListRight(blist#0, pivots#0, cRight#0, key#0), 
        TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.SplitBucketListRight#requires(Seq Box, Seq Box, int, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketListRight
axiom (forall blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketListRight#requires(blist#0, pivots#0, cRight#0, key#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketListRight#requires(blist#0, pivots#0, cRight#0, key#0)
       == (BucketsLib.__default.WFBucketList(blist#0, pivots#0)
         && PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, pivots#0, key#0)
           == cRight#0));

// definition axiom for BucketsLib.__default.SplitBucketListRight(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketListRight(blist#0, pivots#0, cRight#0, key#0) } 
    BucketsLib.__default.SplitBucketListRight#canCall(blist#0, pivots#0, cRight#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           && PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, pivots#0, key#0)
             == cRight#0)
       ==> BucketsLib.__default.SplitBucketRight#canCall($Unbox(Seq#Index(blist#0, cRight#0)): DatatypeType, key#0)
         && BucketsLib.__default.SplitBucketListRight(blist#0, pivots#0, cRight#0, key#0)
           == Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
                  $Unbox(Seq#Index(blist#0, cRight#0)): DatatypeType, 
                  key#0))), 
            Seq#Drop(blist#0, cRight#0 + 1)));

// definition axiom for BucketsLib.__default.SplitBucketListRight for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketListRight(Lit(blist#0), Lit(pivots#0), LitInt(cRight#0), Lit(key#0)) } 
    BucketsLib.__default.SplitBucketListRight#canCall(Lit(blist#0), Lit(pivots#0), LitInt(cRight#0), Lit(key#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0)))
           && PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, Lit(pivots#0), Lit(key#0))
             == LitInt(cRight#0))
       ==> BucketsLib.__default.SplitBucketRight#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(cRight#0))): DatatypeType, Lit(key#0))
         && BucketsLib.__default.SplitBucketListRight(Lit(blist#0), Lit(pivots#0), LitInt(cRight#0), Lit(key#0))
           == Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
                  $Unbox(Seq#Index(Lit(blist#0), LitInt(cRight#0))): DatatypeType, 
                  Lit(key#0)))), 
            Seq#Drop(Lit(blist#0), LitInt(cRight#0 + 1))));

// function declaration for BucketsLib._default.SplitBucketInList
function BucketsLib.__default.SplitBucketInList($ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box) : Seq Box;

function BucketsLib.__default.SplitBucketInList#canCall(blist#0: Seq Box, slot#0: int, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketInList($LS($ly), blist#0, slot#0, pivot#0) } 
  BucketsLib.__default.SplitBucketInList($LS($ly), blist#0, slot#0, pivot#0)
     == BucketsLib.__default.SplitBucketInList($ly, blist#0, slot#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketInList(AsFuelBottom($ly), blist#0, slot#0, pivot#0) } 
  BucketsLib.__default.SplitBucketInList($ly, blist#0, slot#0, pivot#0)
     == BucketsLib.__default.SplitBucketInList($LZ, blist#0, slot#0, pivot#0));

// consequence axiom for BucketsLib.__default.SplitBucketInList
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketInList($ly, blist#0, slot#0, pivot#0) } 
    BucketsLib.__default.SplitBucketInList#canCall(blist#0, slot#0, pivot#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= slot#0
           && slot#0 < Seq#Length(blist#0))
       ==> $Is(BucketsLib.__default.SplitBucketInList($ly, blist#0, slot#0, pivot#0), 
        TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.SplitBucketInList#requires(LayerType, Seq Box, int, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketInList
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketInList#requires($ly, blist#0, slot#0, pivot#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketInList#requires($ly, blist#0, slot#0, pivot#0)
       == (LitInt(0) <= slot#0 && slot#0 < Seq#Length(blist#0)));

// definition axiom for BucketsLib.__default.SplitBucketInList(revealed)
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketInList($LS($ly), blist#0, slot#0, pivot#0) } 
    BucketsLib.__default.SplitBucketInList#canCall(blist#0, slot#0, pivot#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= slot#0
           && slot#0 < Seq#Length(blist#0))
       ==> BucketsLib.__default.SplitBucketLeft#canCall($Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, pivot#0)
         && BucketsLib.__default.SplitBucketRight#canCall($Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, pivot#0)
         && Sequences.__default.replace1with2#canCall(Tclass.BucketsLib.Bucket(), 
          blist#0, 
          $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
              $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
              pivot#0)), 
          $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
              $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
              pivot#0)), 
          slot#0)
         && BucketsLib.__default.SplitBucketInList($LS($ly), blist#0, slot#0, pivot#0)
           == Sequences.__default.replace1with2(Tclass.BucketsLib.Bucket(), 
            StartFuel_Sequences._default.replace1with2, 
            blist#0, 
            $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
                $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
                pivot#0)), 
            $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
                $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
                pivot#0)), 
            slot#0));

// definition axiom for BucketsLib.__default.SplitBucketInList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketInList($LS($ly), Lit(blist#0), LitInt(slot#0), Lit(pivot#0)) } 
    BucketsLib.__default.SplitBucketInList#canCall(Lit(blist#0), LitInt(slot#0), Lit(pivot#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= LitInt(slot#0)
           && slot#0 < Seq#Length(Lit(blist#0)))
       ==> BucketsLib.__default.SplitBucketLeft#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, Lit(pivot#0))
         && BucketsLib.__default.SplitBucketRight#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, Lit(pivot#0))
         && Sequences.__default.replace1with2#canCall(Tclass.BucketsLib.Bucket(), 
          Lit(blist#0), 
          $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
              $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
              Lit(pivot#0))), 
          $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
              $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
              Lit(pivot#0))), 
          LitInt(slot#0))
         && BucketsLib.__default.SplitBucketInList($LS($ly), Lit(blist#0), LitInt(slot#0), Lit(pivot#0))
           == Sequences.__default.replace1with2(Tclass.BucketsLib.Bucket(), 
            StartFuel_Sequences._default.replace1with2, 
            Lit(blist#0), 
            $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
                $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
                Lit(pivot#0))), 
            $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
                $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
                Lit(pivot#0))), 
            LitInt(slot#0)));

// function declaration for BucketsLib._default.MergeBuckets
function BucketsLib.__default.MergeBuckets($ly: LayerType, left#0: DatatypeType, right#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.MergeBuckets#canCall(left#0: DatatypeType, right#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
  { BucketsLib.__default.MergeBuckets($LS($ly), left#0, right#0) } 
  BucketsLib.__default.MergeBuckets($LS($ly), left#0, right#0)
     == BucketsLib.__default.MergeBuckets($ly, left#0, right#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
  { BucketsLib.__default.MergeBuckets(AsFuelBottom($ly), left#0, right#0) } 
  BucketsLib.__default.MergeBuckets($ly, left#0, right#0)
     == BucketsLib.__default.MergeBuckets($LZ, left#0, right#0));

// consequence axiom for BucketsLib.__default.MergeBuckets
axiom true
   ==> (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
    { BucketsLib.__default.MergeBuckets($ly, left#0, right#0) } 
    BucketsLib.__default.MergeBuckets#canCall(left#0, right#0)
         || ($Is(left#0, Tclass.BucketsLib.Bucket())
           && $Is(right#0, Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.MergeBuckets($ly, left#0, right#0))
         && BucketsLib.__default.PreWFBucket(BucketsLib.__default.MergeBuckets($ly, left#0, right#0))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(left#0))
             && BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(right#0))
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.MergeBuckets($ly, left#0, right#0)))
         && $Is(BucketsLib.__default.MergeBuckets($ly, left#0, right#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.MergeBuckets#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.MergeBuckets
axiom (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
  { BucketsLib.__default.MergeBuckets#requires($ly, left#0, right#0) } 
  $Is(left#0, Tclass.BucketsLib.Bucket())
       && $Is(right#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.MergeBuckets#requires($ly, left#0, right#0) == true);

// definition axiom for BucketsLib.__default.MergeBuckets(revealed)
axiom true
   ==> (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
    { BucketsLib.__default.MergeBuckets($LS($ly), left#0, right#0) } 
    BucketsLib.__default.MergeBuckets#canCall(left#0, right#0)
         || ($Is(left#0, Tclass.BucketsLib.Bucket())
           && $Is(right#0, Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(left#0)
         && BucketsLib.Bucket.BucketMapWithSeq_q(right#0)
         && Maps.__default.MapUnionPreferA#canCall(Tclass.KeyType.Key(), 
          Tclass.ValueMessage.Message(), 
          BucketsLib.Bucket.b(left#0), 
          BucketsLib.Bucket.b(right#0))
         && BucketsLib.__default.B#canCall(Maps.__default.MapUnionPreferA(Tclass.KeyType.Key(), 
            Tclass.ValueMessage.Message(), 
            StartFuel_Maps._default.MapUnionPreferA, 
            BucketsLib.Bucket.b(left#0), 
            BucketsLib.Bucket.b(right#0)))
         && BucketsLib.__default.MergeBuckets($LS($ly), left#0, right#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Maps.__default.MapUnionPreferA(Tclass.KeyType.Key(), 
              Tclass.ValueMessage.Message(), 
              StartFuel_Maps._default.MapUnionPreferA, 
              BucketsLib.Bucket.b(left#0), 
              BucketsLib.Bucket.b(right#0))));

// definition axiom for BucketsLib.__default.MergeBuckets for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.MergeBuckets($LS($ly), Lit(left#0), Lit(right#0)) } 
    BucketsLib.__default.MergeBuckets#canCall(Lit(left#0), Lit(right#0))
         || ($Is(left#0, Tclass.BucketsLib.Bucket())
           && $Is(right#0, Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(left#0))
         && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(right#0))
         && Maps.__default.MapUnionPreferA#canCall(Tclass.KeyType.Key(), 
          Tclass.ValueMessage.Message(), 
          Lit(BucketsLib.Bucket.b(Lit(left#0))), 
          Lit(BucketsLib.Bucket.b(Lit(right#0))))
         && BucketsLib.__default.B#canCall(Maps.__default.MapUnionPreferA(Tclass.KeyType.Key(), 
            Tclass.ValueMessage.Message(), 
            StartFuel_Maps._default.MapUnionPreferA, 
            Lit(BucketsLib.Bucket.b(Lit(left#0))), 
            Lit(BucketsLib.Bucket.b(Lit(right#0)))))
         && BucketsLib.__default.MergeBuckets($LS($ly), Lit(left#0), Lit(right#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Maps.__default.MapUnionPreferA(Tclass.KeyType.Key(), 
              Tclass.ValueMessage.Message(), 
              StartFuel_Maps._default.MapUnionPreferA, 
              Lit(BucketsLib.Bucket.b(Lit(left#0))), 
              Lit(BucketsLib.Bucket.b(Lit(right#0))))));

// function declaration for BucketsLib._default.MergeBucketsInList
function BucketsLib.__default.MergeBucketsInList($ly: LayerType, blist#0: Seq Box, slot#0: int) : Seq Box;

function BucketsLib.__default.MergeBucketsInList#canCall(blist#0: Seq Box, slot#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
  { BucketsLib.__default.MergeBucketsInList($LS($ly), blist#0, slot#0) } 
  BucketsLib.__default.MergeBucketsInList($LS($ly), blist#0, slot#0)
     == BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
  { BucketsLib.__default.MergeBucketsInList(AsFuelBottom($ly), blist#0, slot#0) } 
  BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0)
     == BucketsLib.__default.MergeBucketsInList($LZ, blist#0, slot#0));

// consequence axiom for BucketsLib.__default.MergeBucketsInList
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
    { BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0) } 
    BucketsLib.__default.MergeBucketsInList#canCall(blist#0, slot#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          LitInt(0) <= slot#0
           && slot#0 < Seq#Length(blist#0) - 1)
       ==> Seq#Length(BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0))
           == Seq#Length(blist#0) - 1
         && BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0), slot#0)): DatatypeType)
         && $Is(BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0), 
          TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.MergeBucketsInList#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.MergeBucketsInList
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
  { BucketsLib.__default.MergeBucketsInList#requires($ly, blist#0, slot#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.MergeBucketsInList#requires($ly, blist#0, slot#0)
       == (LitInt(0) <= slot#0 && slot#0 < Seq#Length(blist#0) - 1));

// definition axiom for BucketsLib.__default.MergeBucketsInList(revealed)
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
    { BucketsLib.__default.MergeBucketsInList($LS($ly), blist#0, slot#0) } 
    BucketsLib.__default.MergeBucketsInList#canCall(blist#0, slot#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          LitInt(0) <= slot#0
           && slot#0 < Seq#Length(blist#0) - 1)
       ==> BucketsLib.__default.MergeBuckets#canCall($Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
          $Unbox(Seq#Index(blist#0, slot#0 + 1)): DatatypeType)
         && Sequences.__default.replace2with1#canCall(Tclass.BucketsLib.Bucket(), 
          blist#0, 
          $Box(BucketsLib.__default.MergeBuckets(StartFuel_BucketsLib._default.MergeBuckets, 
              $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
              $Unbox(Seq#Index(blist#0, slot#0 + 1)): DatatypeType)), 
          slot#0)
         && BucketsLib.__default.MergeBucketsInList($LS($ly), blist#0, slot#0)
           == Sequences.__default.replace2with1(Tclass.BucketsLib.Bucket(), 
            StartFuel_Sequences._default.replace2with1, 
            blist#0, 
            $Box(BucketsLib.__default.MergeBuckets(StartFuel_BucketsLib._default.MergeBuckets, 
                $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
                $Unbox(Seq#Index(blist#0, slot#0 + 1)): DatatypeType)), 
            slot#0));

// definition axiom for BucketsLib.__default.MergeBucketsInList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
    {:weight 3} { BucketsLib.__default.MergeBucketsInList($LS($ly), Lit(blist#0), LitInt(slot#0)) } 
    BucketsLib.__default.MergeBucketsInList#canCall(Lit(blist#0), LitInt(slot#0))
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          LitInt(0) <= LitInt(slot#0)
           && slot#0 < Seq#Length(Lit(blist#0)) - 1)
       ==> BucketsLib.__default.MergeBuckets#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
          $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0 + 1))): DatatypeType)
         && Sequences.__default.replace2with1#canCall(Tclass.BucketsLib.Bucket(), 
          Lit(blist#0), 
          $Box(BucketsLib.__default.MergeBuckets(StartFuel_BucketsLib._default.MergeBuckets, 
              $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
              $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0 + 1))): DatatypeType)), 
          LitInt(slot#0))
         && BucketsLib.__default.MergeBucketsInList($LS($ly), Lit(blist#0), LitInt(slot#0))
           == Sequences.__default.replace2with1(Tclass.BucketsLib.Bucket(), 
            StartFuel_Sequences._default.replace2with1, 
            Lit(blist#0), 
            $Box(BucketsLib.__default.MergeBuckets(StartFuel_BucketsLib._default.MergeBuckets, 
                $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
                $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0 + 1))): DatatypeType)), 
            LitInt(slot#0)));

// function declaration for BucketsLib._default.emptyList
function BucketsLib.__default.emptyList($ly: LayerType, n#0: int) : Seq Box;

function BucketsLib.__default.emptyList#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { BucketsLib.__default.emptyList($LS($ly), n#0) } 
  BucketsLib.__default.emptyList($LS($ly), n#0)
     == BucketsLib.__default.emptyList($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { BucketsLib.__default.emptyList(AsFuelBottom($ly), n#0) } 
  BucketsLib.__default.emptyList($ly, n#0)
     == BucketsLib.__default.emptyList($LZ, n#0));

// consequence axiom for BucketsLib.__default.emptyList
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { BucketsLib.__default.emptyList($ly, n#0) } 
    BucketsLib.__default.emptyList#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(BucketsLib.__default.emptyList($ly, n#0)) == n#0
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.emptyList($ly, n#0), i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(BucketsLib.__default.emptyList($ly, n#0))
             ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(BucketsLib.__default.emptyList($ly, n#0), i#1)): DatatypeType, 
              BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))))
         && $Is(BucketsLib.__default.emptyList($ly, n#0), TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.emptyList#requires(LayerType, int) : bool;

// #requires axiom for BucketsLib.__default.emptyList
axiom (forall $ly: LayerType, n#0: int :: 
  { BucketsLib.__default.emptyList#requires($ly, n#0) } 
  BucketsLib.__default.emptyList#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for BucketsLib.__default.emptyList(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { BucketsLib.__default.emptyList($LS($ly), n#0) } 
    BucketsLib.__default.emptyList#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0)
           ==> BucketsLib.__default.emptyList#canCall(n#0 - 1)
             && BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && BucketsLib.__default.emptyList($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketsLib.__default.emptyList($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)))))));

// definition axiom for BucketsLib.__default.emptyList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { BucketsLib.__default.emptyList($LS($ly), LitInt(n#0)) } 
    BucketsLib.__default.emptyList#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> BucketsLib.__default.emptyList#canCall(LitInt(n#0 - 1))
             && BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && BucketsLib.__default.emptyList($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketsLib.__default.emptyList($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)))))));

// function declaration for BucketsLib._default.binarySearch
function BucketsLib.__default.binarySearch($ly: LayerType, keys#0: Seq Box, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.binarySearch#canCall(keys#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.binarySearch($LS($ly), keys#0, key#0) } 
  BucketsLib.__default.binarySearch($LS($ly), keys#0, key#0)
     == BucketsLib.__default.binarySearch($ly, keys#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.binarySearch(AsFuelBottom($ly), keys#0, key#0) } 
  BucketsLib.__default.binarySearch($ly, keys#0, key#0)
     == BucketsLib.__default.binarySearch($LZ, keys#0, key#0));

// consequence axiom for BucketsLib.__default.binarySearch
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.binarySearch($ly, keys#0, key#0) } 
    BucketsLib.__default.binarySearch#canCall(keys#0, key#0)
         || ($Is(keys#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, keys#0)
           ==> 
          Options.Option.None_q(BucketsLib.__default.binarySearch($ly, keys#0, key#0))
           ==> !Seq#Contains(keys#0, $Box(key#0)))
         && (Options.Option.Some_q(BucketsLib.__default.binarySearch($ly, keys#0, key#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(BucketsLib.__default.binarySearch($ly, keys#0, key#0))): int
             && $Unbox(Options.Option.value(BucketsLib.__default.binarySearch($ly, keys#0, key#0))): int
               < Seq#Length(keys#0)
             && Seq#Equal(key#0, 
              $Unbox(Seq#Index(keys#0, 
                  $Unbox(Options.Option.value(BucketsLib.__default.binarySearch($ly, keys#0, key#0))): int)): Seq Box))
         && $Is(BucketsLib.__default.binarySearch($ly, keys#0, key#0), 
          Tclass.Options.Option(Tclass._System.nat())));

function BucketsLib.__default.binarySearch#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.binarySearch
axiom (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.binarySearch#requires($ly, keys#0, key#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.binarySearch#requires($ly, keys#0, key#0) == true);

// definition axiom for BucketsLib.__default.binarySearch(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.binarySearch($LS($ly), keys#0, key#0) } 
    BucketsLib.__default.binarySearch#canCall(keys#0, key#0)
         || ($Is(keys#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(keys#0) != LitInt(0)
           ==> (var mid#2 := Div(Seq#Length(keys#0), LitInt(2)); 
            Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(keys#0, mid#2)): Seq Box)
               && (Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(keys#0, mid#2)): Seq Box)
                 ==> BucketsLib.__default.binarySearch#canCall(Seq#Take(keys#0, mid#2), key#0))
               && (!Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(keys#0, mid#2)): Seq Box)
                 ==> 
                !Seq#Equal($Unbox(Seq#Index(keys#0, mid#2)): Seq Box, key#0)
                 ==> BucketsLib.__default.binarySearch#canCall(Seq#Drop(keys#0, mid#2 + 1), key#0))))
         && BucketsLib.__default.binarySearch($LS($ly), keys#0, key#0)
           == (if Seq#Length(keys#0) == LitInt(0)
             then #Options.Option.None()
             else (var mid#2 := Div(Seq#Length(keys#0), LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(keys#0, mid#2)): Seq Box)
                 then BucketsLib.__default.binarySearch($ly, Seq#Take(keys#0, mid#2), key#0)
                 else (if Seq#Equal($Unbox(Seq#Index(keys#0, mid#2)): Seq Box, key#0)
                   then #Options.Option.Some($Box(mid#2))
                   else (var sub#2 := BucketsLib.__default.binarySearch($ly, Seq#Drop(keys#0, mid#2 + 1), key#0); 
                    (if Options.Option.Some_q(sub#2)
                       then #Options.Option.Some($Box(mid#2 + 1 + $Unbox(Options.Option.value(sub#2)): int))
                       else #Options.Option.None())))))));

// definition axiom for BucketsLib.__default.binarySearch for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.binarySearch($LS($ly), Lit(keys#0), Lit(key#0)) } 
    BucketsLib.__default.binarySearch#canCall(Lit(keys#0), Lit(key#0))
         || ($Is(keys#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(Lit(keys#0)) != LitInt(0)
           ==> (var mid#3 := Div(Seq#Length(Lit(keys#0)), LitInt(2)); 
            Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), $Unbox(Seq#Index(Lit(keys#0), mid#3)): Seq Box)
               && (Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(keys#0), mid#3)): Seq Box)
                 ==> BucketsLib.__default.binarySearch#canCall(Seq#Take(Lit(keys#0), mid#3), Lit(key#0)))
               && (!Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(keys#0), mid#3)): Seq Box)
                 ==> 
                !Seq#Equal($Unbox(Seq#Index(Lit(keys#0), mid#3)): Seq Box, key#0)
                 ==> BucketsLib.__default.binarySearch#canCall(Seq#Drop(Lit(keys#0), mid#3 + 1), Lit(key#0)))))
         && BucketsLib.__default.binarySearch($LS($ly), Lit(keys#0), Lit(key#0))
           == (if Seq#Length(Lit(keys#0)) == LitInt(0)
             then #Options.Option.None()
             else (var mid#3 := Div(Seq#Length(Lit(keys#0)), LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(keys#0), mid#3)): Seq Box)
                 then BucketsLib.__default.binarySearch($LS($ly), Seq#Take(Lit(keys#0), mid#3), Lit(key#0))
                 else (if Seq#Equal($Unbox(Seq#Index(Lit(keys#0), mid#3)): Seq Box, key#0)
                   then #Options.Option.Some($Box(mid#3))
                   else (var sub#3 := BucketsLib.__default.binarySearch($LS($ly), Seq#Drop(Lit(keys#0), mid#3 + 1), Lit(key#0)); 
                    (if Options.Option.Some_q(sub#3)
                       then #Options.Option.Some($Box(mid#3 + 1 + $Unbox(Options.Option.value(sub#3)): int))
                       else #Options.Option.None())))))));

// function declaration for BucketsLib._default.bucketBinarySearchLookup
function BucketsLib.__default.bucketBinarySearchLookup(bucket#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.bucketBinarySearchLookup#canCall(bucket#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.bucketBinarySearchLookup
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0) } 
    BucketsLib.__default.bucketBinarySearchLookup#canCall(bucket#0, key#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucket(bucket#0))
       ==> (BucketsLib.__default.BucketWellMarshalled(bucket#0)
           ==> 
          Options.Option.None_q(BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0))
           ==> !Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)])
         && (BucketsLib.__default.BucketWellMarshalled(bucket#0)
           ==> 
          Options.Option.Some_q(BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0))
           ==> Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
             && ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
              $Unbox(Options.Option.value(BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0))): DatatypeType))
         && $Is(BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0), 
          Tclass.Options.Option(Tclass.ValueMessage.Message())));

function BucketsLib.__default.bucketBinarySearchLookup#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.bucketBinarySearchLookup
axiom (forall bucket#0: DatatypeType, key#0: Seq Box :: 
  { BucketsLib.__default.bucketBinarySearchLookup#requires(bucket#0, key#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.bucketBinarySearchLookup#requires(bucket#0, key#0)
       == BucketsLib.__default.WFBucket(bucket#0));

// definition axiom for BucketsLib.__default.bucketBinarySearchLookup(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0) } 
    BucketsLib.__default.bucketBinarySearchLookup#canCall(bucket#0, key#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucket(bucket#0))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && BucketsLib.__default.binarySearch#canCall(BucketsLib.Bucket.keys(bucket#0), key#0)
         && (var i#2 := BucketsLib.__default.binarySearch($LS($LZ), BucketsLib.Bucket.keys(bucket#0), key#0); 
          Options.Option.Some_q(i#2)
             ==> BucketsLib.__default.BucketWellMarshalled#canCall(bucket#0)
               && (BucketsLib.__default.BucketWellMarshalled(bucket#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0))
               && (!BucketsLib.__default.BucketWellMarshalled(bucket#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0)
           == (var i#2 := BucketsLib.__default.binarySearch($LS($LZ), BucketsLib.Bucket.keys(bucket#0), key#0); 
            (if Options.Option.Some_q(i#2)
               then (if BucketsLib.__default.BucketWellMarshalled(bucket#0)
                 then #Options.Option.Some(Seq#Index(BucketsLib.Bucket.msgs(bucket#0), $Unbox(Options.Option.value(i#2)): int))
                 else #Options.Option.Some(Seq#Index(BucketsLib.Bucket.msgs(bucket#0), $Unbox(Options.Option.value(i#2)): int)))
               else #Options.Option.None())));

// definition axiom for BucketsLib.__default.bucketBinarySearchLookup for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.bucketBinarySearchLookup(Lit(bucket#0), Lit(key#0)) } 
    BucketsLib.__default.bucketBinarySearchLookup#canCall(Lit(bucket#0), Lit(key#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(BucketsLib.__default.WFBucket(Lit(bucket#0))))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && BucketsLib.__default.binarySearch#canCall(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), Lit(key#0))
         && (var i#3 := Lit(BucketsLib.__default.binarySearch($LS($LZ), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), Lit(key#0))); 
          Options.Option.Some_q(i#3)
             ==> BucketsLib.__default.BucketWellMarshalled#canCall(Lit(bucket#0))
               && (Lit(BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0)))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0)))
               && (!Lit(BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0)))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.bucketBinarySearchLookup(Lit(bucket#0), Lit(key#0))
           == (var i#3 := Lit(BucketsLib.__default.binarySearch($LS($LZ), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), Lit(key#0))); 
            (if Options.Option.Some_q(i#3)
               then (if BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0))
                 then #Options.Option.Some(Seq#Index(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))), 
                    LitInt($Unbox(Options.Option.value(i#3)): int)))
                 else #Options.Option.Some(Seq#Index(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))), 
                    LitInt($Unbox(Options.Option.value(i#3)): int))))
               else #Options.Option.None())));

// function declaration for BucketsLib._default.getMiddleKey
function BucketsLib.__default.getMiddleKey(bucket#0: DatatypeType) : Seq Box;

function BucketsLib.__default.getMiddleKey#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.getMiddleKey
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.getMiddleKey(bucket#0) } 
    BucketsLib.__default.getMiddleKey#canCall(bucket#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && BucketsLib.__default.WFBucket(bucket#0))
       ==> $Is(BucketsLib.__default.getMiddleKey(bucket#0), Tclass.KeyType.Key()));

function BucketsLib.__default.getMiddleKey#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.getMiddleKey
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.getMiddleKey#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.getMiddleKey#requires(bucket#0)
       == BucketsLib.__default.WFBucket(bucket#0));

// definition axiom for BucketsLib.__default.getMiddleKey(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.getMiddleKey(bucket#0) } 
    BucketsLib.__default.getMiddleKey#canCall(bucket#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && BucketsLib.__default.WFBucket(bucket#0))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && (Seq#Length(BucketsLib.Bucket.keys(bucket#0)) != LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0))
         && BucketsLib.__default.getMiddleKey(bucket#0)
           == (if Seq#Length(BucketsLib.Bucket.keys(bucket#0)) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(0)))
             else (var key#2 := $Unbox(Seq#Index(BucketsLib.Bucket.keys(bucket#0), 
                    Div(Seq#Length(BucketsLib.Bucket.keys(bucket#0)), LitInt(2)))): Seq Box; 
              (if Seq#Length(key#2) == LitInt(0)
                 then Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(0)))
                 else key#2))));

// definition axiom for BucketsLib.__default.getMiddleKey for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.getMiddleKey(Lit(bucket#0)) } 
    BucketsLib.__default.getMiddleKey#canCall(Lit(bucket#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && Lit(BucketsLib.__default.WFBucket(Lit(bucket#0))))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && (Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))) != LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0)))
         && BucketsLib.__default.getMiddleKey(Lit(bucket#0))
           == (if Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(0)))
             else (var key#3 := $Unbox(Seq#Index(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), 
                    Div(Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))), LitInt(2)))): Seq Box; 
              (if Seq#Length(key#3) == LitInt(0)
                 then Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(0)))
                 else key#3))));

const unique class.Integer__Order.__default: ClassName;

function Tclass.Integer__Order.__default() : Ty;

// Tclass.Integer__Order.__default Tag
axiom Tag(Tclass.Integer__Order.__default()) == Tagclass.Integer__Order.__default;

const unique Tagclass.Integer__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Integer__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Integer__Order.__default()) } 
  $IsBox(bx, Tclass.Integer__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Integer__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Integer__Order.__default()) } 
  $Is($o, Tclass.Integer__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Integer__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Integer__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Integer__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Integer_Order._default.SomeElement
function Integer__Order.__default.SomeElement() : int;

function Integer__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Integer__Order.__default.SomeElement
axiom true ==> true ==> true;

function Integer__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Integer__Order.__default.SomeElement
axiom Integer__Order.__default.SomeElement#requires() == true;

// definition axiom for Integer__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Integer__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Integer__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Integer__Order.__default.SomeElement() == LitInt(0);

// function declaration for Integer_Order._default.lte
function Integer__Order.__default.lte(a#0: int, b#0: int) : bool;

function Integer__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.lte
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lte(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
           || Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0))
         && (forall a#3: int, b#3: int, c#2: int :: 
          { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#3, c#2), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#3, c#2) } 
            { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#3, c#2), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#3, b#3) } 
          true
             ==> 
            Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#3, b#3)
               && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#3, c#2)
             ==> Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#3, c#2))
         && Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
           || Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0))
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
             && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#4: int, b#4: int, c#3: int :: 
          { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#4, c#3), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#4, c#3) } 
            { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#4, c#3), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#4, b#4) } 
          true
             ==> 
            Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#4, b#4)
               && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#4, c#3)
             ==> Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#4, c#3)));

function Integer__Order.__default.lte#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.lte
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.lte#requires(a#0, b#0) } 
  Integer__Order.__default.lte#requires(a#0, b#0) == true);

const MoreFuel_Integer_Order._default.ltedef2: LayerType;

// definition axiom for Integer__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lte(a#0, b#0) } 
    true
       ==> Integer__Order.__default.ltedef#canCall(a#0, b#0)
         && 
        StartFuel_Integer_Order._default.ltedef
           == $LS(MoreFuel_Integer_Order._default.ltedef2)
         && StartFuelAssert_Integer_Order._default.ltedef
           == $LS($LS(MoreFuel_Integer_Order._default.ltedef2))
         && AsFuelBottom(MoreFuel_Integer_Order._default.ltedef2)
           == MoreFuel_Integer_Order._default.ltedef2
         && Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0));

const MoreFuel_Integer_Order._default.ltedef3: LayerType;

// definition axiom for Integer__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         && 
        StartFuel_Integer_Order._default.ltedef
           == $LS(MoreFuel_Integer_Order._default.ltedef3)
         && StartFuelAssert_Integer_Order._default.ltedef
           == $LS($LS(MoreFuel_Integer_Order._default.ltedef3))
         && AsFuelBottom(MoreFuel_Integer_Order._default.ltedef3)
           == MoreFuel_Integer_Order._default.ltedef3
         && Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0))
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, LitInt(a#0), LitInt(b#0)));

// function declaration for Integer_Order._default.ltedef
function Integer__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Integer__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Integer__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Integer__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Integer__Order.__default.ltedef($ly, a#0, b#0)
     == Integer__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Integer__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Integer__Order.__default.ltedef($ly, a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Integer__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  Integer__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Integer__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Integer__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    true ==> Integer__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Integer__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Integer_Order._default.LargestLte
function Integer__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Integer__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLte($ly, run#0, needle#0)
     == Integer__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Integer__Order.__default.LargestLte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
         && Integer__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Integer__Order.__default.LargestLte($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Integer__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Integer__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted8: LayerType;

// definition axiom for Integer__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.LargestLte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Integer__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Integer__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted8)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted8))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted8)
           == MoreFuel_Integer_Order._default.IsSorted8
         && Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Integer_Order._default.IsSorted9: LayerType;

// definition axiom for Integer__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Integer__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Integer__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Integer__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted9)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted9))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted9)
           == MoreFuel_Integer_Order._default.IsSorted9
         && Integer__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Integer__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Integer_Order._default.LargestLt
function Integer__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Integer__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLt($ly, run#0, needle#0)
     == Integer__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Integer__Order.__default.LargestLt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Integer__Order.__default.LargestLt($ly, run#0, needle#0)
         && Integer__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Integer__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Integer__Order.__default.LargestLt($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Integer__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Integer__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Integer__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted10: LayerType;

// definition axiom for Integer__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.LargestLt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Integer__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Integer__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted10)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted10))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted10)
           == MoreFuel_Integer_Order._default.IsSorted10
         && Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Integer_Order._default.IsSorted11: LayerType;

// definition axiom for Integer__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Integer__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Integer__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Integer__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted11)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted11))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted11)
           == MoreFuel_Integer_Order._default.IsSorted11
         && Integer__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Integer__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Integer_Order._default.IndexOfFirstGte
function Integer__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Integer__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted12: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, run#0)
             && Integer__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
             && (!Integer__Order.__default.lt($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               ==> Sequences.__default.DropLast#canCall(TInt, run#0)
                 && Integer__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(TInt, run#0), needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted12)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted12))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted12)
           == MoreFuel_Integer_Order._default.IsSorted12
         && Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lt($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               then Seq#Length(run#0)
               else Integer__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(TInt, run#0), needle#0))));

const MoreFuel_Integer_Order._default.IsSorted13: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, Lit(run#0))
             && Integer__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Integer__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TInt, Lit(run#0))
                 && Integer__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0))))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted13)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted13))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted13)
           == MoreFuel_Integer_Order._default.IsSorted13
         && Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0)))));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGteIter
function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#3, hi#0)
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Integer__Order.__default.lte(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, LitInt(key#0))
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGte
function Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Integer_Order._default.IndexOfFirstGt
function Integer__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Integer__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted14: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, run#0)
             && Integer__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
             && (!Integer__Order.__default.lte($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               ==> Sequences.__default.DropLast#canCall(TInt, run#0)
                 && Integer__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(TInt, run#0), needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted14)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted14))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted14)
           == MoreFuel_Integer_Order._default.IsSorted14
         && Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lte($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               then Seq#Length(run#0)
               else Integer__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(TInt, run#0), needle#0))));

const MoreFuel_Integer_Order._default.IsSorted15: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, Lit(run#0))
             && Integer__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Integer__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TInt, Lit(run#0))
                 && Integer__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0))))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted15)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted15))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted15)
           == MoreFuel_Integer_Order._default.IsSorted15
         && Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0)))));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGtIter
function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#3, hi#0)
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Integer__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, LitInt(key#0))
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGt
function Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Integer_Order._default.SetAllLte
function Integer__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Integer__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Integer__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLte(a#0, b#0) } 
    Integer__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> true);

function Integer__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Integer__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Integer__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt))
     ==> Integer__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLte(a#0, b#0) } 
    Integer__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#2: int, y#2: int :: 
          { Integer__Order.__default.lte(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          b#0[$Box(y#2)] ==> Integer__Order.__default.lte#canCall(x#2, y#2))
         && Integer__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Integer__Order.__default.lte(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            true
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Integer__Order.__default.lte(x#2, y#2)));

// definition axiom for Integer__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Integer__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#3: int, y#3: int :: 
          { Integer__Order.__default.lte(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          Lit(b#0)[$Box(y#3)] ==> Integer__Order.__default.lte#canCall(x#3, y#3))
         && Integer__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Integer__Order.__default.lte(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            true
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Integer__Order.__default.lte(x#3, y#3)));

// function declaration for Integer_Order._default.SetAllLt
function Integer__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Integer__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Integer__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLt(a#0, b#0) } 
    Integer__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> true);

function Integer__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Integer__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Integer__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt))
     ==> Integer__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLt(a#0, b#0) } 
    Integer__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#2: int, y#2: int :: 
          { Integer__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          b#0[$Box(y#2)] ==> Integer__Order.__default.lt#canCall(x#2, y#2))
         && Integer__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Integer__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            true
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Integer__Order.__default.lt(x#2, y#2)));

// definition axiom for Integer__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Integer__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#3: int, y#3: int :: 
          { Integer__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          Lit(b#0)[$Box(y#3)] ==> Integer__Order.__default.lt#canCall(x#3, y#3))
         && Integer__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Integer__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            true
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Integer__Order.__default.lt(x#3, y#3)));

// function declaration for Integer_Order._default.NotMinimum
function Integer__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Integer__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum($LS($ly), a#0) } 
  Integer__Order.__default.NotMinimum($LS($ly), a#0)
     == Integer__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Integer__Order.__default.NotMinimum($ly, a#0)
     == Integer__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Integer__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Integer__Order.__default.NotMinimum($ly, a#0) } 
    true ==> true);

function Integer__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Integer__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum#requires($ly, a#0) } 
  Integer__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Integer__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Integer__Order.__default.NotMinimum($LS($ly), a#0) } 
    true
       ==> (forall b#2: int :: 
          { Integer__Order.__default.lt(b#2, a#0) } 
          Integer__Order.__default.lt#canCall(b#2, a#0))
         && Integer__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#2: int :: 
            { Integer__Order.__default.lt(b#2, a#0) } 
            Integer__Order.__default.lt(b#2, a#0)));

// definition axiom for Integer__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Integer__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    true
       ==> (forall b#3: int :: 
          { Integer__Order.__default.lt(b#3, a#0) } 
          Integer__Order.__default.lt#canCall(b#3, LitInt(a#0)))
         && Integer__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#3: int :: 
            { Integer__Order.__default.lt(b#3, a#0) } 
            Integer__Order.__default.lt(b#3, LitInt(a#0))));

// function declaration for Integer_Order._default.MapPivotedUnion
function Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Integer__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)));

function Integer__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Integer__Order.__default.MapPivotedUnion
axiom (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Integer__Order.__default.MapPivotedUnion#requires(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
       && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
     ==> Integer__Order.__default.MapPivotedUnion#requires(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Integer__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#4: int :: 
          { Integer__Order.__default.lt(k#4, pivot#0) } 
          Integer__Order.__default.lt#canCall(k#4, pivot#0))
         && Maps.__default.MapIRestrict#canCall(TInt, 
          Integer_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#12: Box :: 
            $IsBox($y#12, TInt) && Integer__Order.__default.lt($Unbox($y#12): int, pivot#0)))
         && (var restricted_left#2 := Maps.__default.MapIRestrict(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#15: Box :: 
                $IsBox($y#15, TInt) && Integer__Order.__default.lt($Unbox($y#15): int, pivot#0))); 
          (forall k#5: int :: 
              { Integer__Order.__default.lte(pivot#0, k#5) } 
              Integer__Order.__default.lte#canCall(pivot#0, k#5))
             && Maps.__default.MapIRestrict#canCall(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#13: Box :: 
                $IsBox($y#13, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#13): int)))
             && (var restricted_right#2 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#14: Box :: 
                    $IsBox($y#14, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#14): int))); 
              Maps.__default.MapDisjointUnion#canCall(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                restricted_left#2, 
                restricted_right#2)))
         && Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#2 := Maps.__default.MapIRestrict(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#16: Box :: 
                  $IsBox($y#16, TInt) && Integer__Order.__default.lt($Unbox($y#16): int, pivot#0))); 
            (var restricted_right#2 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#17: Box :: 
                    $IsBox($y#17, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#17): int))); 
              Maps.__default.MapDisjointUnion(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#2, 
                restricted_right#2))));

// definition axiom for Integer__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#6: int :: 
          { Integer__Order.__default.lt(k#6, pivot#0) } 
          Integer__Order.__default.lt#canCall(k#6, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(TInt, 
          Integer_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#18: Box :: 
            $IsBox($y#18, TInt)
               && Integer__Order.__default.lt($Unbox($y#18): int, LitInt(pivot#0))))
         && (var restricted_left#3 := Maps.__default.MapIRestrict(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#21: Box :: 
                $IsBox($y#21, TInt)
                   && Integer__Order.__default.lt($Unbox($y#21): int, LitInt(pivot#0)))); 
          (forall k#7: int :: 
              { Integer__Order.__default.lte(pivot#0, k#7) } 
              Integer__Order.__default.lte#canCall(LitInt(pivot#0), k#7))
             && Maps.__default.MapIRestrict#canCall(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#19: Box :: 
                $IsBox($y#19, TInt)
                   && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#19): int)))
             && (var restricted_right#3 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#20: Box :: 
                    $IsBox($y#20, TInt)
                       && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#20): int))); 
              Maps.__default.MapDisjointUnion#canCall(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                restricted_left#3, 
                restricted_right#3)))
         && Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#3 := Maps.__default.MapIRestrict(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#22: Box :: 
                  $IsBox($y#22, TInt)
                     && Integer__Order.__default.lt($Unbox($y#22): int, LitInt(pivot#0)))); 
            (var restricted_right#3 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#23: Box :: 
                    $IsBox($y#23, TInt)
                       && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#23): int))); 
              Maps.__default.MapDisjointUnion(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#3, 
                restricted_right#3))));

// function declaration for Integer_Order._default.SetSuccessor
function Integer__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Integer__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Integer__Order.__default.SetSuccessor(m#0, key#0) } 
    Integer__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSet(TInt))
       ==> $Is(Integer__Order.__default.SetSuccessor(m#0, key#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Integer__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Integer__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(m#0, TSet(TInt))
     ==> Integer__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#34_next(m: Set Box, key: int) : int;

function $let#34$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#34_next(m, key) } 
  $let#34$canCall(m, key)
     ==> m[$Box($let#34_next(m, key))]
       && Integer__Order.__default.lt(key, $let#34_next(m, key))
       && (forall other#4: int :: 
        { Integer__Order.__default.lt($let#34_next(m, key), other#4) } 
          { Integer__Order.__default.lt(key, other#4) } 
          { m[$Box(other#4)] } 
        true
           ==> 
          m[$Box(other#4)]
             && other#4 != $let#34_next(m, key)
             && Integer__Order.__default.lt(key, other#4)
           ==> Integer__Order.__default.lt($let#34_next(m, key), other#4)));

// definition axiom for Integer__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Integer__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($IsGoodHeap($Heap) && $Is(m#0, TSet(TInt)))
       ==> (forall next#4: int :: 
          { Integer__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
          (m#0[$Box(next#4)] ==> Integer__Order.__default.lt#canCall(key#0, next#4))
             && (Integer__Order.__default.lt#canCall(key#0, next#4)
                 && Integer__Order.__default.lt(key#0, next#4)
               ==> (forall other#3: int :: 
                { Integer__Order.__default.lt(next#4, other#3) } 
                  { Integer__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                (other#3 != next#4 ==> Integer__Order.__default.lt#canCall(key#0, other#3))
                   && (Integer__Order.__default.lt#canCall(key#0, other#3)
                       && Integer__Order.__default.lt(key#0, other#3)
                     ==> Integer__Order.__default.lt#canCall(next#4, other#3)))))
         && ((exists next#4: int :: 
            { Integer__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
            m#0[$Box(next#4)]
               && Integer__Order.__default.lt(key#0, next#4)
               && (forall other#3: int :: 
                { Integer__Order.__default.lt(next#4, other#3) } 
                  { Integer__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                true
                   ==> 
                  m#0[$Box(other#3)]
                     && other#3 != next#4
                     && Integer__Order.__default.lt(key#0, other#3)
                   ==> Integer__Order.__default.lt(next#4, other#3)))
           ==> $let#34$canCall(m#0, key#0))
         && Integer__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#4: int :: 
              { Integer__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
              m#0[$Box(next#4)]
                 && Integer__Order.__default.lt(key#0, next#4)
                 && (forall other#3: int :: 
                  { Integer__Order.__default.lt(next#4, other#3) } 
                    { Integer__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  true
                     ==> 
                    m#0[$Box(other#3)]
                       && other#3 != next#4
                       && Integer__Order.__default.lt(key#0, other#3)
                     ==> Integer__Order.__default.lt(next#4, other#3)))
             then (var next#5 := $let#34_next(m#0, key#0); #Options.Option.Some($Box(next#5)))
             else #Options.Option.None()));

// definition axiom for Integer__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($IsGoodHeap($Heap) && $Is(m#0, TSet(TInt)))
       ==> (forall next#6: int :: 
          { Integer__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
          (Lit(m#0)[$Box(next#6)]
               ==> Integer__Order.__default.lt#canCall(LitInt(key#0), next#6))
             && (Integer__Order.__default.lt#canCall(LitInt(key#0), next#6)
                 && Integer__Order.__default.lt(LitInt(key#0), next#6)
               ==> (forall other#5: int :: 
                { Integer__Order.__default.lt(next#6, other#5) } 
                  { Integer__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                (other#5 != next#6
                     ==> Integer__Order.__default.lt#canCall(LitInt(key#0), other#5))
                   && (Integer__Order.__default.lt#canCall(LitInt(key#0), other#5)
                       && Integer__Order.__default.lt(LitInt(key#0), other#5)
                     ==> Integer__Order.__default.lt#canCall(next#6, other#5)))))
         && ((exists next#6: int :: 
            { Integer__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
            Lit(m#0)[$Box(next#6)]
               && Integer__Order.__default.lt(LitInt(key#0), next#6)
               && (forall other#5: int :: 
                { Integer__Order.__default.lt(next#6, other#5) } 
                  { Integer__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                true
                   ==> 
                  Lit(m#0)[$Box(other#5)]
                     && other#5 != next#6
                     && Integer__Order.__default.lt(LitInt(key#0), other#5)
                   ==> Integer__Order.__default.lt(next#6, other#5)))
           ==> $let#34$canCall(Lit(m#0), LitInt(key#0)))
         && Integer__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#6: int :: 
              { Integer__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
              Lit(m#0)[$Box(next#6)]
                 && Integer__Order.__default.lt(LitInt(key#0), next#6)
                 && (forall other#5: int :: 
                  { Integer__Order.__default.lt(next#6, other#5) } 
                    { Integer__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  true
                     ==> 
                    Lit(m#0)[$Box(other#5)]
                       && other#5 != next#6
                       && Integer__Order.__default.lt(LitInt(key#0), other#5)
                     ==> Integer__Order.__default.lt(next#6, other#5)))
             then (var next#7 := $let#34_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#7)))
             else #Options.Option.None()));

// function declaration for Integer_Order._default.MapSuccessor
function Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.MapSuccessor
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, m#0, key#0)
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> $Is(Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(TInt)));

function Integer__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Integer__Order.__default.MapSuccessor
axiom (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Integer__Order.__default.MapSuccessor#requires(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
     ==> Integer__Order.__default.MapSuccessor#requires(Integer_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, m#0, key#0)
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> Integer__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0)
           == Integer__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Integer__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> Integer__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Integer__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Integer_Order._default.SeqSuccessor
function Integer__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Integer__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.SeqSuccessor(m#0, key#0) } 
    Integer__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSeq(TInt))
       ==> $Is(Integer__Order.__default.SeqSuccessor(m#0, key#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(TInt))
     ==> Integer__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Integer__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.SeqSuccessor(m#0, key#0) } 
    Integer__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSeq(TInt))
       ==> Integer__Order.__default.SetSuccessor#canCall((lambda $y#4: Box :: $IsBox($y#4, TInt) && Seq#Contains(m#0, $y#4)), key#0)
         && Integer__Order.__default.SeqSuccessor(m#0, key#0)
           == Integer__Order.__default.SetSuccessor((lambda $y#5: Box :: $IsBox($y#5, TInt) && Seq#Contains(m#0, $y#5)), key#0));

// definition axiom for Integer__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Integer__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || $Is(m#0, TSeq(TInt))
       ==> Integer__Order.__default.SetSuccessor#canCall((lambda $y#6: Box :: $IsBox($y#6, TInt) && Seq#Contains(m#0, $y#6)), 
          LitInt(key#0))
         && Integer__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Integer__Order.__default.SetSuccessor((lambda $y#7: Box :: $IsBox($y#7, TInt) && Seq#Contains(m#0, $y#7)), 
            LitInt(key#0)));

// function declaration for Integer_Order._default.SortedSeqForMap
function Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Integer__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> true);

function Integer__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Integer__Order.__default.SortedSeqForMap
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap#requires(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V))
     ==> Integer__Order.__default.SortedSeqForMap#requires(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Integer__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TInt, Integer_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TInt, 
            Integer_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Integer__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                Integer_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                  Integer_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#4: int :: 
            { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
            (i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                 ==> 
                i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))))
         && ((forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              (i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                   ==> 
                  i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
           ==> (forall key#2: int :: 
            { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
            Map#Domain(m#0)[$Box(key#2)]
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                (i#5 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                         == key#2
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)))))
         && Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                    Integer_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall key#2: int :: 
              { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
              true
                 ==> 
                Map#Domain(m#0)[$Box(key#2)]
                 ==> (exists i#5: int :: 
                  { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                  LitInt(0) <= i#5
                     && i#5 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                       == key#2
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#2)]))));

// definition axiom for Integer__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TInt, Integer_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TInt, 
            Integer_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Integer__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                Integer_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                  Integer_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#6: int :: 
            { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
            (i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                 ==> 
                i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))))
         && ((forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              (i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                   ==> 
                  i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
           ==> (forall key#3: int :: 
            { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
            Map#Domain(m#0)[$Box(key#3)]
               ==> (forall i#7: int :: 
                { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                (i#7 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                         == key#3
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)))))
         && Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                    Integer_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall key#3: int :: 
              { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
              true
                 ==> 
                Map#Domain(m#0)[$Box(key#3)]
                 ==> (exists i#7: int :: 
                  { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                  LitInt(0) <= i#7
                     && i#7 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                       == key#3
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#3)]))));

// function declaration for Integer_Order._default.minimum
function Integer__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Integer__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimum($LS($ly), s#0) } 
  Integer__Order.__default.minimum($LS($ly), s#0)
     == Integer__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.minimum($ly, s#0)
     == Integer__Order.__default.minimum($LZ, s#0));

// consequence axiom for Integer__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimum($ly, s#0) } 
    Integer__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Integer__Order.__default.minimum($ly, s#0))]
         && (forall y#1: int :: 
          { Integer__Order.__default.lte(Integer__Order.__default.minimum($ly, s#0), y#1) } 
            { s#0[$Box(y#1)] } 
          s#0[$Box(y#1)]
             ==> Integer__Order.__default.lte(Integer__Order.__default.minimum($ly, s#0), y#1)));

function Integer__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Integer__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#37_a(s: Set Box) : int;

function $let#37$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#37_a(s) } 
  $let#37$canCall(s) ==> s[$Box($let#37_a(s))]);

// definition axiom for Integer__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Integer__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.minimum#canCall(s#0)
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> $let#37$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#37_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Integer__Order.__default.minimum#canCall(s'#4)
               && (var m'#4 := Integer__Order.__default.minimum($ly, s'#4); 
                Integer__Order.__default.lt#canCall($let#37_a(s#0), m'#4)))
         && Integer__Order.__default.minimum($LS($ly), s#0)
           == (var a#2 := $let#37_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Integer__Order.__default.minimum($ly, s'#5); 
                  (if Integer__Order.__default.lt(a#2, m'#5) then a#2 else m'#5))))));

// definition axiom for Integer__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.minimum#canCall(Lit(s#0))
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#37$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#37_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Integer__Order.__default.minimum#canCall(s'#6)
               && (var m'#6 := Integer__Order.__default.minimum($LS($ly), s'#6); 
                Integer__Order.__default.lt#canCall($let#37_a(Lit(s#0)), m'#6)))
         && Integer__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#3 := $let#37_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Integer__Order.__default.minimum($LS($ly), s'#7); 
                  (if Integer__Order.__default.lt(a#3, m'#7) then a#3 else m'#7))))));

// function declaration for Integer_Order._default.minimumOpt
function Integer__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Integer__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt($LS($ly), s#0) } 
  Integer__Order.__default.minimumOpt($LS($ly), s#0)
     == Integer__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.minimumOpt($ly, s#0)
     == Integer__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Integer__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimumOpt($ly, s#0) } 
    Integer__Order.__default.minimumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (Options.Option.Some_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Integer__Order.__default.lte($Unbox(Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1) } 
              { s#0[$Box(y#1)] } 
            s#0[$Box(y#1)]
               ==> Integer__Order.__default.lte($Unbox(Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1)))
         && (Options.Option.None_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Integer__Order.__default.minimumOpt($ly, s#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Integer__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimumOpt($LS($ly), s#0) } 
    Integer__Order.__default.minimumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.minimum#canCall(s#0))
         && Integer__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.minimum(StartFuel_Integer_Order._default.minimum, s#0)))));

// definition axiom for Integer__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Integer__Order.__default.minimumOpt#canCall(Lit(s#0)) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.minimum#canCall(Lit(s#0)))
         && Integer__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.minimum(StartFuel_Integer_Order._default.minimum, Lit(s#0))))));

// function declaration for Integer_Order._default.maximum
function Integer__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Integer__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximum($LS($ly), s#0) } 
  Integer__Order.__default.maximum($LS($ly), s#0)
     == Integer__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.maximum($ly, s#0)
     == Integer__Order.__default.maximum($LZ, s#0));

// consequence axiom for Integer__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximum($ly, s#0) } 
    Integer__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Integer__Order.__default.maximum($ly, s#0))]
         && (forall y#1: int :: 
          { Integer__Order.__default.lte(y#1, Integer__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#1)] } 
          s#0[$Box(y#1)]
             ==> Integer__Order.__default.lte(y#1, Integer__Order.__default.maximum($ly, s#0))));

function Integer__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Integer__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#40_a(s: Set Box) : int;

function $let#40$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#40_a(s) } 
  $let#40$canCall(s) ==> s[$Box($let#40_a(s))]);

// definition axiom for Integer__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Integer__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.maximum#canCall(s#0)
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> $let#40$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#40_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Integer__Order.__default.maximum#canCall(s'#4)
               && (var m'#4 := Integer__Order.__default.maximum($ly, s'#4); 
                Integer__Order.__default.lt#canCall(m'#4, $let#40_a(s#0))))
         && Integer__Order.__default.maximum($LS($ly), s#0)
           == (var a#2 := $let#40_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Integer__Order.__default.maximum($ly, s'#5); 
                  (if Integer__Order.__default.lt(m'#5, a#2) then a#2 else m'#5))))));

// definition axiom for Integer__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.maximum#canCall(Lit(s#0))
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#40$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#40_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Integer__Order.__default.maximum#canCall(s'#6)
               && (var m'#6 := Integer__Order.__default.maximum($LS($ly), s'#6); 
                Integer__Order.__default.lt#canCall(m'#6, $let#40_a(Lit(s#0)))))
         && Integer__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#3 := $let#40_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Integer__Order.__default.maximum($LS($ly), s'#7); 
                  (if Integer__Order.__default.lt(m'#7, a#3) then a#3 else m'#7))))));

// function declaration for Integer_Order._default.maximumOpt
function Integer__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Integer__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt($LS($ly), s#0) } 
  Integer__Order.__default.maximumOpt($LS($ly), s#0)
     == Integer__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.maximumOpt($ly, s#0)
     == Integer__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Integer__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximumOpt($ly, s#0) } 
    Integer__Order.__default.maximumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (Options.Option.Some_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Integer__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#1)] } 
            s#0[$Box(y#1)]
               ==> Integer__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Integer__Order.__default.maximumOpt($ly, s#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Integer__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximumOpt($LS($ly), s#0) } 
    Integer__Order.__default.maximumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.maximum#canCall(s#0))
         && Integer__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.maximum(StartFuel_Integer_Order._default.maximum, s#0)))));

// definition axiom for Integer__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Integer__Order.__default.maximumOpt#canCall(Lit(s#0)) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.maximum#canCall(Lit(s#0)))
         && Integer__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.maximum(StartFuel_Integer_Order._default.maximum, Lit(s#0))))));

// function declaration for Integer_Order._default.lt
function Integer__Order.__default.lt(a#0: int, b#0: int) : bool;

function Integer__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lt(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.lt#requires(a#0, b#0) } 
  Integer__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lt(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.lt(a#0, b#0)
           == (Integer__Order.__default.lte(a#0, b#0) && a#0 != b#0));

// definition axiom for Integer__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == Lit(Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) && a#0 != b#0));

// function declaration for Integer_Order._default.Min
function Integer__Order.__default.Min(a#0: int, b#0: int) : int;

function Integer__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Min(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.Min#requires(a#0, b#0) } 
  Integer__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Min(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.Min(a#0, b#0)
           == (if Integer__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Integer__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then a#0 else b#0));

// function declaration for Integer_Order._default.Max
function Integer__Order.__default.Max(a#0: int, b#0: int) : int;

function Integer__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Max(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.Max#requires(a#0, b#0) } 
  Integer__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Max(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.Max(a#0, b#0)
           == (if Integer__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Integer__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then b#0 else a#0));

// function declaration for Integer_Order._default.IsSorted
function Integer__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Integer__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted($LS($ly), run#0) } 
  Integer__Order.__default.IsSorted($LS($ly), run#0)
     == Integer__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Integer__Order.__default.IsSorted($ly, run#0)
     == Integer__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Integer__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsSorted($ly, run#0) } 
    Integer__Order.__default.IsSorted#canCall(run#0) || $Is(run#0, TSeq(TInt))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Integer__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Integer__Order.__default.IsSorted($ly, run#0)));

function Integer__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Integer__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsSorted($LS($ly), run#0) } 
    Integer__Order.__default.IsSorted#canCall(run#0) || $Is(run#0, TSeq(TInt))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Integer__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 <= j#2 && j#2 < Seq#Length(run#0)
               ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Integer__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Integer__Order.__default.IsSorted#canCall(Lit(run#0)) || $Is(run#0, TSeq(TInt))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Integer__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Integer__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 <= j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Integer__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Integer_Order._default.IsStrictlySortedInternal
function Integer__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Integer__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySortedInternal(run#0) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> true);

function Integer__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Integer__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySortedInternal(run#0) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Integer__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(run#0)
               ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Integer__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TInt))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Integer__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Integer__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Integer_Order._default.IsStrictlySorted
function Integer__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Integer__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Integer__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Integer__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Integer__Order.__default.IsStrictlySorted($ly, run#0)
     == Integer__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Integer__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySorted($ly, run#0) } 
    Integer__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Integer__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Integer__Order.__default.IsStrictlySorted($ly, run#0))
         && (Integer__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0)));

function Integer__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Integer__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Integer__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Integer__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#2 := Integer__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#2 then b#2 else b#2)));

// definition axiom for Integer__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Integer__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TInt))
       ==> Integer__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Integer__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#3 := Lit(Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#3 then b#3 else b#3)));

// Constructor function declaration
function #PackedKV.Pkv.Pkv(DatatypeType, DatatypeType) : DatatypeType;

const unique ##PackedKV.Pkv.Pkv: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#PackedKV.Pkv.Pkv(a#0#0#0, a#0#1#0)) == ##PackedKV.Pkv.Pkv);

function PackedKV.Pkv.Pkv_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PackedKV.Pkv.Pkv_q(d) } 
  PackedKV.Pkv.Pkv_q(d) <==> DatatypeCtorId(d) == ##PackedKV.Pkv.Pkv);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PackedKV.Pkv.Pkv_q(d) } 
  PackedKV.Pkv.Pkv_q(d)
     ==> (exists a#1#0#0: DatatypeType, a#1#1#0: DatatypeType :: 
      d == #PackedKV.Pkv.Pkv(a#1#0#0, a#1#1#0)));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType, a#2#1#0: DatatypeType :: 
  { $Is(#PackedKV.Pkv.Pkv(a#2#0#0, a#2#1#0), Tclass.PackedKV.Pkv()) } 
  $Is(#PackedKV.Pkv.Pkv(a#2#0#0, a#2#1#0), Tclass.PackedKV.Pkv())
     <==> $Is(a#2#0#0, Tclass.PackedStringArray.Psa())
       && $Is(a#2#1#0, Tclass.PackedStringArray.Psa()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, a#3#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PackedKV.Pkv.Pkv(a#3#0#0, a#3#1#0), Tclass.PackedKV.Pkv(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PackedKV.Pkv.Pkv(a#3#0#0, a#3#1#0), Tclass.PackedKV.Pkv(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.PackedStringArray.Psa(), $h)
         && $IsAlloc(a#3#1#0, Tclass.PackedStringArray.Psa(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedKV.Pkv.keys(d), Tclass.PackedStringArray.Psa(), $h) } 
  $IsGoodHeap($h)
       && 
      PackedKV.Pkv.Pkv_q(d)
       && $IsAlloc(d, Tclass.PackedKV.Pkv(), $h)
     ==> $IsAlloc(PackedKV.Pkv.keys(d), Tclass.PackedStringArray.Psa(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedKV.Pkv.messages(d), Tclass.PackedStringArray.Psa(), $h) } 
  $IsGoodHeap($h)
       && 
      PackedKV.Pkv.Pkv_q(d)
       && $IsAlloc(d, Tclass.PackedKV.Pkv(), $h)
     ==> $IsAlloc(PackedKV.Pkv.messages(d), Tclass.PackedStringArray.Psa(), $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType, a#4#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #PackedKV.Pkv.Pkv(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#PackedKV.Pkv.Pkv(a#4#0#0, a#4#1#0)));

function PackedKV.Pkv.keys(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType, a#5#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#5#0#0, a#5#1#0) } 
  PackedKV.Pkv.keys(#PackedKV.Pkv.Pkv(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType, a#6#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#6#0#0, a#6#1#0) } 
  DtRank(a#6#0#0) < DtRank(#PackedKV.Pkv.Pkv(a#6#0#0, a#6#1#0)));

function PackedKV.Pkv.messages(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#7#0#0: DatatypeType, a#7#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#7#0#0, a#7#1#0) } 
  PackedKV.Pkv.messages(#PackedKV.Pkv.Pkv(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: DatatypeType, a#8#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#8#0#0, a#8#1#0) } 
  DtRank(a#8#1#0) < DtRank(#PackedKV.Pkv.Pkv(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#PackedKV.Pkv(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PackedKV.Pkv(d) } 
  $IsA#PackedKV.Pkv(d) ==> PackedKV.Pkv.Pkv_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PackedKV.Pkv.Pkv_q(d), $Is(d, Tclass.PackedKV.Pkv()) } 
  $Is(d, Tclass.PackedKV.Pkv()) ==> PackedKV.Pkv.Pkv_q(d));

// Datatype extensional equality declaration
function PackedKV.Pkv#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PackedKV.Pkv.Pkv
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedKV.Pkv#Equal(a, b) } 
  true
     ==> (PackedKV.Pkv#Equal(a, b)
       <==> PackedStringArray.Psa#Equal(PackedKV.Pkv.keys(a), PackedKV.Pkv.keys(b))
         && PackedStringArray.Psa#Equal(PackedKV.Pkv.messages(a), PackedKV.Pkv.messages(b))));

// Datatype extensionality axiom: PackedKV.Pkv
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedKV.Pkv#Equal(a, b) } 
  PackedKV.Pkv#Equal(a, b) <==> a == b);

const unique class.PackedKV.Pkv: ClassName;

const unique class.PackedKV.__default: ClassName;

function Tclass.PackedKV.__default() : Ty;

// Tclass.PackedKV.__default Tag
axiom Tag(Tclass.PackedKV.__default()) == Tagclass.PackedKV.__default;

const unique Tagclass.PackedKV.__default: TyTag;

// Box/unbox axiom for Tclass.PackedKV.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedKV.__default()) } 
  $IsBox(bx, Tclass.PackedKV.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.PackedKV.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedKV.__default()) } 
  $Is($o, Tclass.PackedKV.__default())
     <==> $o == null || dtype($o) == Tclass.PackedKV.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedKV.__default(), $h) } 
  $IsAlloc($o, Tclass.PackedKV.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PackedKV._default.ValidKeyByteString
function PackedKV.__default.ValidKeyByteString(s#0: Seq Box) : bool;

function PackedKV.__default.ValidKeyByteString#canCall(s#0: Seq Box) : bool;

// consequence axiom for PackedKV.__default.ValidKeyByteString
axiom true
   ==> (forall s#0: Seq Box :: 
    { PackedKV.__default.ValidKeyByteString(s#0) } 
    PackedKV.__default.ValidKeyByteString#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function PackedKV.__default.ValidKeyByteString#requires(Seq Box) : bool;

// #requires axiom for PackedKV.__default.ValidKeyByteString
axiom (forall s#0: Seq Box :: 
  { PackedKV.__default.ValidKeyByteString#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedKV.__default.ValidKeyByteString#requires(s#0) == true);

// definition axiom for PackedKV.__default.ValidKeyByteString(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { PackedKV.__default.ValidKeyByteString(s#0) } 
    PackedKV.__default.ValidKeyByteString#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> KeyType.__default.MaxLen#canCall()
         && PackedKV.__default.ValidKeyByteString(s#0)
           == (Seq#Length(s#0) <= LitInt(KeyType.__default.MaxLen())));

// definition axiom for PackedKV.__default.ValidKeyByteString for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.ValidKeyByteString(Lit(s#0)) } 
    PackedKV.__default.ValidKeyByteString#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> KeyType.__default.MaxLen#canCall()
         && PackedKV.__default.ValidKeyByteString(Lit(s#0))
           == (Seq#Length(Lit(s#0)) <= LitInt(KeyType.__default.MaxLen())));

// function declaration for PackedKV._default.ValidStringLens
function PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int)
   : bool;

function PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int)
   : bool;

// consequence axiom for PackedKV.__default.ValidStringLens
axiom true
   ==> (forall PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int :: 
    { PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0) } 
    PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0)
         || ($Is(strs#0, TSeq(TSeq(PackedKV._default.ValidStringLens$A)))
           && LitInt(0) <= upper_bound#0)
       ==> true);

function PackedKV.__default.ValidStringLens#requires(Ty, Seq Box, int) : bool;

// #requires axiom for PackedKV.__default.ValidStringLens
axiom (forall PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int :: 
  { PackedKV.__default.ValidStringLens#requires(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0) } 
  $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidStringLens$A)))
       && LitInt(0) <= upper_bound#0
     ==> PackedKV.__default.ValidStringLens#requires(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0)
       == true);

// definition axiom for PackedKV.__default.ValidStringLens(revealed)
axiom true
   ==> (forall PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int :: 
    { PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0) } 
    PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0)
         || ($Is(strs#0, TSeq(TSeq(PackedKV._default.ValidStringLens$A)))
           && LitInt(0) <= upper_bound#0)
       ==> PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0)
         == (forall i#4: int :: 
          { $Unbox(Seq#Index(strs#0, i#4)): Seq Box } 
          LitInt(0) <= i#4 && i#4 < Seq#Length(strs#0)
             ==> Seq#Length($Unbox(Seq#Index(strs#0, i#4)): Seq Box) <= upper_bound#0));

// definition axiom for PackedKV.__default.ValidStringLens for all literals(revealed)
axiom true
   ==> (forall PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int :: 
    {:weight 3} { PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, Lit(strs#0), LitInt(upper_bound#0)) } 
    PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidStringLens$A, Lit(strs#0), LitInt(upper_bound#0))
         || ($Is(strs#0, TSeq(TSeq(PackedKV._default.ValidStringLens$A)))
           && LitInt(0) <= upper_bound#0)
       ==> PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, Lit(strs#0), LitInt(upper_bound#0))
         == (forall i#5: int :: 
          { $Unbox(Seq#Index(strs#0, i#5)): Seq Box } 
          LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(strs#0))
             ==> Seq#Length($Unbox(Seq#Index(Lit(strs#0), i#5)): Seq Box)
               <= LitInt(upper_bound#0)));

// function declaration for PackedKV._default.ValidKeyLens
function PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box) : bool;

function PackedKV.__default.ValidKeyLens#canCall(PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box) : bool;

// consequence axiom for PackedKV.__default.ValidKeyLens
axiom true
   ==> (forall PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box :: 
    { PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, strs#0) } 
    PackedKV.__default.ValidKeyLens#canCall(PackedKV._default.ValidKeyLens$A, strs#0)
         || $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidKeyLens$A)))
       ==> true);

function PackedKV.__default.ValidKeyLens#requires(Ty, Seq Box) : bool;

// #requires axiom for PackedKV.__default.ValidKeyLens
axiom (forall PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box :: 
  { PackedKV.__default.ValidKeyLens#requires(PackedKV._default.ValidKeyLens$A, strs#0) } 
  $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidKeyLens$A)))
     ==> PackedKV.__default.ValidKeyLens#requires(PackedKV._default.ValidKeyLens$A, strs#0)
       == true);

// definition axiom for PackedKV.__default.ValidKeyLens(revealed)
axiom true
   ==> (forall PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box :: 
    { PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, strs#0) } 
    PackedKV.__default.ValidKeyLens#canCall(PackedKV._default.ValidKeyLens$A, strs#0)
         || $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidKeyLens$A)))
       ==> KeyType.__default.MaxLen#canCall()
         && PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidKeyLens$A, strs#0, LitInt(KeyType.__default.MaxLen()))
         && PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, strs#0)
           == PackedKV.__default.ValidStringLens(PackedKV._default.ValidKeyLens$A, strs#0, LitInt(KeyType.__default.MaxLen())));

// definition axiom for PackedKV.__default.ValidKeyLens for all literals(revealed)
axiom true
   ==> (forall PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, Lit(strs#0)) } 
    PackedKV.__default.ValidKeyLens#canCall(PackedKV._default.ValidKeyLens$A, Lit(strs#0))
         || $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidKeyLens$A)))
       ==> KeyType.__default.MaxLen#canCall()
         && PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidKeyLens$A, 
          Lit(strs#0), 
          LitInt(KeyType.__default.MaxLen()))
         && PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, Lit(strs#0))
           == Lit(PackedKV.__default.ValidStringLens(PackedKV._default.ValidKeyLens$A, 
              Lit(strs#0), 
              LitInt(KeyType.__default.MaxLen()))));

// function declaration for PackedKV._default.IKeys
function PackedKV.__default.IKeys(psa#0: DatatypeType) : Seq Box;

function PackedKV.__default.IKeys#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.IKeys
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedKV.__default.IKeys(psa#0) } 
    PackedKV.__default.IKeys#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(psa#0), 
            LitInt(KeyType.__default.MaxLen())))
       ==> $Is(PackedKV.__default.IKeys(psa#0), TSeq(Tclass.KeyType.Key())));

function PackedKV.__default.IKeys#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.IKeys
axiom (forall psa#0: DatatypeType :: 
  { PackedKV.__default.IKeys#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedKV.__default.IKeys#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(psa#0), 
          LitInt(KeyType.__default.MaxLen()))));

// definition axiom for PackedKV.__default.IKeys(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedKV.__default.IKeys(psa#0) } 
    PackedKV.__default.IKeys#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(psa#0), 
            LitInt(KeyType.__default.MaxLen())))
       ==> PackedStringArray.__default.I#canCall(psa#0)
         && PackedKV.__default.IKeys(psa#0) == PackedStringArray.__default.I(psa#0));

// definition axiom for PackedKV.__default.IKeys for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.IKeys(Lit(psa#0)) } 
    PackedKV.__default.IKeys#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              Lit(PackedStringArray.__default.I(Lit(psa#0))), 
              LitInt(KeyType.__default.MaxLen()))))
       ==> PackedStringArray.__default.I#canCall(Lit(psa#0))
         && PackedKV.__default.IKeys(Lit(psa#0))
           == Lit(PackedStringArray.__default.I(Lit(psa#0))));

// function declaration for PackedKV._default.psaSeq_Messages
function PackedKV.__default.psaSeq__Messages($ly: LayerType, psa#0: DatatypeType, i#0: int) : Seq Box;

function PackedKV.__default.psaSeq__Messages#canCall(psa#0: DatatypeType, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.psaSeq__Messages($LS($ly), psa#0, i#0) } 
  PackedKV.__default.psaSeq__Messages($LS($ly), psa#0, i#0)
     == PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.psaSeq__Messages(AsFuelBottom($ly), psa#0, i#0) } 
  PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0)
     == PackedKV.__default.psaSeq__Messages($LZ, psa#0, i#0));

// consequence axiom for PackedKV.__default.psaSeq__Messages
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0) } 
    PackedKV.__default.psaSeq__Messages#canCall(psa#0, i#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> Seq#Length(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0)) == i#0
         && (forall j#3: int :: 
          { $Unbox(Seq#Index(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0), j#3)): DatatypeType } 
          LitInt(0) <= j#3 && j#3 < i#0
             ==> ValueMessage.Message#Equal($Unbox(Seq#Index(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0), j#3)): DatatypeType, 
              ValueMessage.__default.bytestring__to__Message(PackedStringArray.__default.psaElement(psa#0, j#3))))
         && $Is(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0), 
          TSeq(Tclass.ValueMessage.Message())));

function PackedKV.__default.psaSeq__Messages#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for PackedKV.__default.psaSeq__Messages
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.psaSeq__Messages#requires($ly, psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedKV.__default.psaSeq__Messages#requires($ly, psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedKV.__default.psaSeq__Messages(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.psaSeq__Messages($LS($ly), psa#0, i#0) } 
    PackedKV.__default.psaSeq__Messages#canCall(psa#0, i#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> (i#0 != LitInt(0)
           ==> PackedKV.__default.psaSeq__Messages#canCall(psa#0, i#0 - 1)
             && 
            PackedStringArray.__default.psaElement#canCall(psa#0, i#0 - 1)
             && ValueMessage.__default.bytestring__to__Message#canCall(PackedStringArray.__default.psaElement(psa#0, i#0 - 1)))
         && PackedKV.__default.psaSeq__Messages($LS($ly), psa#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(ValueMessage.__default.bytestring__to__Message(PackedStringArray.__default.psaElement(psa#0, i#0 - 1)))))));

// definition axiom for PackedKV.__default.psaSeq__Messages for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedKV.__default.psaSeq__Messages($LS($ly), Lit(psa#0), LitInt(i#0)) } 
    PackedKV.__default.psaSeq__Messages#canCall(Lit(psa#0), LitInt(i#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> (LitInt(i#0) != LitInt(0)
           ==> PackedKV.__default.psaSeq__Messages#canCall(Lit(psa#0), LitInt(i#0 - 1))
             && 
            PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(i#0 - 1))
             && ValueMessage.__default.bytestring__to__Message#canCall(Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0 - 1)))))
         && PackedKV.__default.psaSeq__Messages($LS($ly), Lit(psa#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedKV.__default.psaSeq__Messages($LS($ly), Lit(psa#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(ValueMessage.__default.bytestring__to__Message(Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0 - 1))))))))));

// function declaration for PackedKV._default.IMessages
function PackedKV.__default.IMessages(psa#0: DatatypeType) : Seq Box;

function PackedKV.__default.IMessages#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.IMessages
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedKV.__default.IMessages(psa#0) } 
    PackedKV.__default.IMessages#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> $Is(PackedKV.__default.IMessages(psa#0), TSeq(Tclass.ValueMessage.Message())));

function PackedKV.__default.IMessages#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.IMessages
axiom (forall psa#0: DatatypeType :: 
  { PackedKV.__default.IMessages#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedKV.__default.IMessages#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedKV.__default.IMessages(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedKV.__default.IMessages(psa#0) } 
    PackedKV.__default.IMessages#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedKV.__default.psaSeq__Messages#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
         && PackedKV.__default.IMessages(psa#0)
           == PackedKV.__default.psaSeq__Messages(StartFuel_PackedKV._default.psaSeq_Messages, 
            psa#0, 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedKV.__default.IMessages for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.IMessages(Lit(psa#0)) } 
    PackedKV.__default.IMessages#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedKV.__default.psaSeq__Messages#canCall(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
         && PackedKV.__default.IMessages(Lit(psa#0))
           == PackedKV.__default.psaSeq__Messages(StartFuel_PackedKV._default.psaSeq_Messages, 
            Lit(psa#0), 
            Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))));

// function declaration for PackedKV._default.WF
function PackedKV.__default.WF(pkv#0: DatatypeType) : bool;

function PackedKV.__default.WF#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.WF
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.WF(pkv#0) } 
    PackedKV.__default.WF#canCall(pkv#0) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> true);

function PackedKV.__default.WF#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.WF
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.WF#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.WF#requires(pkv#0) == true);

// definition axiom for PackedKV.__default.WF(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.WF(pkv#0) } 
    PackedKV.__default.WF#canCall(pkv#0) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         && (PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0)))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
             && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0))
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.messages(pkv#0)))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0))
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.messages(pkv#0))
             && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
             && PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0))))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
             && PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
             && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0))
             && ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0))))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0))
             && ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
             && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           ==> ValueMessage.__default.IdentityMessage#canCall()
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0)))
         && PackedKV.__default.WF(pkv#0)
           == (
            PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
             && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
             && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
             && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
             && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
              $Box(ValueMessage.__default.IdentityMessage()))));

// definition axiom for PackedKV.__default.WF for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.WF(Lit(pkv#0)) } 
    PackedKV.__default.WF#canCall(Lit(pkv#0)) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.WF#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && (Lit(PackedStringArray.__default.WF(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.WF#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.WF#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && Lit(PackedStringArray.__default.WF(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
               == Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             && Lit(PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && ValueType.__default.ValidMessageBytestrings#canCall(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && ValueType.__default.ValidMessageBytestrings#canCall(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
             && Lit(ValueType.__default.ValidMessageBytestrings(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))
           ==> ValueMessage.__default.IdentityMessage#canCall()
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedKV.__default.IMessages#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))
         && PackedKV.__default.WF(Lit(pkv#0))
           == (
            PackedStringArray.__default.WF(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && PackedStringArray.__default.WF(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
               == Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
             && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             && ValueType.__default.ValidMessageBytestrings(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
             && !Seq#Contains(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))), 
              $Box(ValueMessage.__default.IdentityMessage()))));

// function declaration for PackedKV._default.IMap
function PackedKV.__default.IMap(pkv#0: DatatypeType) : Map Box Box;

function PackedKV.__default.IMap#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.IMap
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.IMap(pkv#0) } 
    PackedKV.__default.IMap#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> BucketsLib.__default.WFBucketMap(PackedKV.__default.IMap(pkv#0))
         && $Is(PackedKV.__default.IMap(pkv#0), 
          TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

function PackedKV.__default.IMap#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.IMap
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.IMap#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.IMap#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.IMap(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.IMap(pkv#0) } 
    PackedKV.__default.IMap#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
         && BucketsLib.__default.BucketMapOfSeq#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), 
          PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)))
         && PackedKV.__default.IMap(pkv#0)
           == BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
            PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0))));

// definition axiom for PackedKV.__default.IMap for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.IMap(Lit(pkv#0)) } 
    PackedKV.__default.IMap#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IKeys#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IMessages#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && BucketsLib.__default.BucketMapOfSeq#canCall(Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))), 
          Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
         && PackedKV.__default.IMap(Lit(pkv#0))
           == BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
            Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))), 
            Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))));

// function declaration for PackedKV._default.SortedKeys
function PackedKV.__default.SortedKeys(pkv#0: DatatypeType) : bool;

function PackedKV.__default.SortedKeys#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.SortedKeys
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SortedKeys(pkv#0) } 
    PackedKV.__default.SortedKeys#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> true);

function PackedKV.__default.SortedKeys#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.SortedKeys
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.SortedKeys#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.SortedKeys#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.SortedKeys(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SortedKeys(pkv#0) } 
    PackedKV.__default.SortedKeys#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)))
         && PackedKV.__default.SortedKeys(pkv#0)
           == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0))));

// definition axiom for PackedKV.__default.SortedKeys for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.SortedKeys(Lit(pkv#0)) } 
    PackedKV.__default.SortedKeys#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IKeys#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
         && PackedKV.__default.SortedKeys(Lit(pkv#0))
           == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))));

// function declaration for PackedKV._default.I
function PackedKV.__default.I(pkv#0: DatatypeType) : DatatypeType;

function PackedKV.__default.I#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.I
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.I(pkv#0) } 
    PackedKV.__default.I#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> BucketsLib.__default.WFBucket(PackedKV.__default.I(pkv#0))
         && $Is(PackedKV.__default.I(pkv#0), Tclass.BucketsLib.Bucket()));

function PackedKV.__default.I#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.I
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.I#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.I#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.I(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.I(pkv#0) } 
    PackedKV.__default.I#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.__default.IMap#canCall(pkv#0)
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
         && PackedKV.__default.I(pkv#0)
           == #BucketsLib.Bucket.BucketMapWithSeq(PackedKV.__default.IMap(pkv#0), 
            PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0))));

// definition axiom for PackedKV.__default.I for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.I(Lit(pkv#0)) } 
    PackedKV.__default.I#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.__default.IMap#canCall(Lit(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IKeys#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IMessages#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKV.__default.I(Lit(pkv#0))
           == Lit(#BucketsLib.Bucket.BucketMapWithSeq(Lit(PackedKV.__default.IMap(Lit(pkv#0))), 
              Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))), 
              Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))));

// function declaration for PackedKV._default.EmptyPkv
function PackedKV.__default.EmptyPkv() : DatatypeType;

function PackedKV.__default.EmptyPkv#canCall() : bool;

// consequence axiom for PackedKV.__default.EmptyPkv
axiom true
   ==> 
  true
   ==> PackedKV.__default.WF(PackedKV.__default.EmptyPkv())
     && Map#Equal(PackedKV.__default.IMap(PackedKV.__default.EmptyPkv()), Map#Empty(): Map Box Box)
     && $Is(PackedKV.__default.EmptyPkv(), Tclass.PackedKV.Pkv());

function PackedKV.__default.EmptyPkv#requires() : bool;

// #requires axiom for PackedKV.__default.EmptyPkv
axiom PackedKV.__default.EmptyPkv#requires() == true;

// definition axiom for PackedKV.__default.EmptyPkv(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.EmptyPsa#canCall()
     && PackedKV.__default.EmptyPkv()
       == Lit(#PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.EmptyPsa()), 
          Lit(PackedStringArray.__default.EmptyPsa())));

// definition axiom for PackedKV.__default.EmptyPkv for all literals(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.EmptyPsa#canCall()
     && PackedKV.__default.EmptyPkv()
       == Lit(#PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.EmptyPsa()), 
          Lit(PackedStringArray.__default.EmptyPsa())));

// function declaration for PackedKV._default.NumKVPairs
function PackedKV.__default.NumKVPairs(pkv#0: DatatypeType) : int;

function PackedKV.__default.NumKVPairs#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.NumKVPairs
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.NumKVPairs(pkv#0) } 
    PackedKV.__default.NumKVPairs#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> LitInt(0) <= PackedKV.__default.NumKVPairs(pkv#0)
         && PackedKV.__default.NumKVPairs(pkv#0) < 18446744073709551616);

function PackedKV.__default.NumKVPairs#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.NumKVPairs
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.NumKVPairs#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.NumKVPairs#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.NumKVPairs(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.NumKVPairs(pkv#0) } 
    PackedKV.__default.NumKVPairs#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaNumStrings#canCall(PackedKV.Pkv.keys(pkv#0))
         && PackedKV.__default.NumKVPairs(pkv#0)
           == PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0)));

// definition axiom for PackedKV.__default.NumKVPairs for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.NumKVPairs(Lit(pkv#0)) } 
    PackedKV.__default.NumKVPairs#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaNumStrings#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && PackedKV.__default.NumKVPairs(Lit(pkv#0))
           == LitInt(PackedStringArray.__default.psaNumStrings(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))));

// function declaration for PackedKV._default.SizeOfPkv
function PackedKV.__default.SizeOfPkv(pkv#0: DatatypeType) : int;

function PackedKV.__default.SizeOfPkv#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.SizeOfPkv
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SizeOfPkv(pkv#0) } 
    PackedKV.__default.SizeOfPkv#canCall(pkv#0) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> true);

function PackedKV.__default.SizeOfPkv#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.SizeOfPkv
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.SizeOfPkv#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.SizeOfPkv#requires(pkv#0) == true);

// definition axiom for PackedKV.__default.SizeOfPkv(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SizeOfPkv(pkv#0) } 
    PackedKV.__default.SizeOfPkv#canCall(pkv#0) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.SizeOfPsa#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.SizeOfPsa#canCall(PackedKV.Pkv.messages(pkv#0))
         && PackedKV.__default.SizeOfPkv(pkv#0)
           == PackedStringArray.__default.SizeOfPsa(PackedKV.Pkv.keys(pkv#0))
             + PackedStringArray.__default.SizeOfPsa(PackedKV.Pkv.messages(pkv#0)));

// definition axiom for PackedKV.__default.SizeOfPkv for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.SizeOfPkv(Lit(pkv#0)) } 
    PackedKV.__default.SizeOfPkv#canCall(Lit(pkv#0))
         || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.SizeOfPsa#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.SizeOfPsa#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKV.__default.SizeOfPkv(Lit(pkv#0))
           == LitInt(PackedStringArray.__default.SizeOfPsa(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
               + PackedStringArray.__default.SizeOfPsa(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))));

// function declaration for PackedKV._default.SizeOfPkvUint64
function PackedKV.__default.SizeOfPkvUint64(pkv#0: DatatypeType) : int;

function PackedKV.__default.SizeOfPkvUint64#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.SizeOfPkvUint64
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SizeOfPkvUint64(pkv#0) } 
    PackedKV.__default.SizeOfPkvUint64#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> LitInt(0) <= PackedKV.__default.SizeOfPkvUint64(pkv#0)
         && PackedKV.__default.SizeOfPkvUint64(pkv#0) < 18446744073709551616);

function PackedKV.__default.SizeOfPkvUint64#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.SizeOfPkvUint64
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.SizeOfPkvUint64#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.SizeOfPkvUint64#requires(pkv#0)
       == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.SizeOfPkvUint64(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SizeOfPkvUint64(pkv#0) } 
    PackedKV.__default.SizeOfPkvUint64#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.SizeOfPsaUint64#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.SizeOfPsaUint64#canCall(PackedKV.Pkv.messages(pkv#0))
         && PackedKV.__default.SizeOfPkvUint64(pkv#0)
           == PackedStringArray.__default.SizeOfPsaUint64(PackedKV.Pkv.keys(pkv#0))
             + PackedStringArray.__default.SizeOfPsaUint64(PackedKV.Pkv.messages(pkv#0)));

// definition axiom for PackedKV.__default.SizeOfPkvUint64 for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.SizeOfPkvUint64(Lit(pkv#0)) } 
    PackedKV.__default.SizeOfPkvUint64#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.SizeOfPsaUint64#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.SizeOfPsaUint64#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKV.__default.SizeOfPkvUint64(Lit(pkv#0))
           == LitInt(PackedStringArray.__default.SizeOfPsaUint64(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
               + PackedStringArray.__default.SizeOfPsaUint64(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))));

// function declaration for PackedKV._default.WeightPkv
function PackedKV.__default.WeightPkv(pkv#0: DatatypeType) : int;

function PackedKV.__default.WeightPkv#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.WeightPkv
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.WeightPkv(pkv#0) } 
    PackedKV.__default.WeightPkv#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> LitInt(0) <= PackedKV.__default.WeightPkv(pkv#0)
         && PackedKV.__default.WeightPkv(pkv#0) < 18446744073709551616);

function PackedKV.__default.WeightPkv#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.WeightPkv
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.WeightPkv#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.WeightPkv#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.WeightPkv(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.WeightPkv(pkv#0) } 
    PackedKV.__default.WeightPkv#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.messages(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.messages(pkv#0))
         && PackedKV.__default.WeightPkv(pkv#0)
           == Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))))
             + Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
             + Mul(LitInt(4), 
              Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))))
             + Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0))));

// definition axiom for PackedKV.__default.WeightPkv for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.WeightPkv(Lit(pkv#0)) } 
    PackedKV.__default.WeightPkv#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKV.__default.WeightPkv(Lit(pkv#0))
           == Mul(LitInt(4), 
              Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             + Mul(LitInt(4), 
              Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))));

// function declaration for PackedKV._default.FirstKey
function PackedKV.__default.FirstKey(pkv#0: DatatypeType) : Seq Box;

function PackedKV.__default.FirstKey#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.FirstKey
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.FirstKey(pkv#0) } 
    PackedKV.__default.FirstKey#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0)
       ==> $Is(PackedKV.__default.FirstKey(pkv#0), Tclass.KeyType.Key()));

function PackedKV.__default.FirstKey#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.FirstKey
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.FirstKey#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.FirstKey#requires(pkv#0)
       == (PackedKV.__default.WF(pkv#0)
         && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0));

// definition axiom for PackedKV.__default.FirstKey(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.FirstKey(pkv#0) } 
    PackedKV.__default.FirstKey#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0)
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.FirstElement#canCall(PackedKV.Pkv.keys(pkv#0))
         && PackedKV.__default.FirstKey(pkv#0)
           == PackedStringArray.__default.FirstElement(PackedKV.Pkv.keys(pkv#0)));

// definition axiom for PackedKV.__default.FirstKey for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.FirstKey(Lit(pkv#0)) } 
    PackedKV.__default.FirstKey#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             > 0)
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.FirstElement#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && PackedKV.__default.FirstKey(Lit(pkv#0))
           == Lit(PackedStringArray.__default.FirstElement(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))));

// function declaration for PackedKV._default.LastKey
function PackedKV.__default.LastKey(pkv#0: DatatypeType) : Seq Box;

function PackedKV.__default.LastKey#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.LastKey
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.LastKey(pkv#0) } 
    PackedKV.__default.LastKey#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0)
       ==> $Is(PackedKV.__default.LastKey(pkv#0), Tclass.KeyType.Key()));

function PackedKV.__default.LastKey#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.LastKey
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.LastKey#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.LastKey#requires(pkv#0)
       == (PackedKV.__default.WF(pkv#0)
         && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0));

// definition axiom for PackedKV.__default.LastKey(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.LastKey(pkv#0) } 
    PackedKV.__default.LastKey#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0)
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.LastElement#canCall(PackedKV.Pkv.keys(pkv#0))
         && PackedKV.__default.LastKey(pkv#0)
           == PackedStringArray.__default.LastElement(PackedKV.Pkv.keys(pkv#0)));

// definition axiom for PackedKV.__default.LastKey for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.LastKey(Lit(pkv#0)) } 
    PackedKV.__default.LastKey#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             > 0)
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.LastElement#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && PackedKV.__default.LastKey(Lit(pkv#0))
           == Lit(PackedStringArray.__default.LastElement(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))));

// function declaration for PackedKV._default.GetKey
function PackedKV.__default.GetKey(pkv#0: DatatypeType, i#0: int) : Seq Box;

function PackedKV.__default.GetKey#canCall(pkv#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedKV.__default.GetKey
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.GetKey(pkv#0, i#0) } 
    PackedKV.__default.GetKey#canCall(pkv#0, i#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))))
       ==> $Is(PackedKV.__default.GetKey(pkv#0, i#0), Tclass.KeyType.Key()));

function PackedKV.__default.GetKey#requires(DatatypeType, int) : bool;

// #requires axiom for PackedKV.__default.GetKey
axiom (forall pkv#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.GetKey#requires(pkv#0, i#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedKV.__default.GetKey#requires(pkv#0, i#0)
       == (PackedKV.__default.WF(pkv#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))));

// definition axiom for PackedKV.__default.GetKey(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.GetKey(pkv#0, i#0) } 
    PackedKV.__default.GetKey#canCall(pkv#0, i#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaElement#canCall(PackedKV.Pkv.keys(pkv#0), i#0)
         && PackedKV.__default.GetKey(pkv#0, i#0)
           == PackedStringArray.__default.psaElement(PackedKV.Pkv.keys(pkv#0), i#0));

// definition axiom for PackedKV.__default.GetKey for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedKV.__default.GetKey(Lit(pkv#0), LitInt(i#0)) } 
    PackedKV.__default.GetKey#canCall(Lit(pkv#0), LitInt(i#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0
             < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaElement#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(i#0))
         && PackedKV.__default.GetKey(Lit(pkv#0), LitInt(i#0))
           == Lit(PackedStringArray.__default.psaElement(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(i#0))));

// function declaration for PackedKV._default.GetMessage
function PackedKV.__default.GetMessage(pkv#0: DatatypeType, i#0: int) : DatatypeType;

function PackedKV.__default.GetMessage#canCall(pkv#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedKV.__default.GetMessage
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.GetMessage(pkv#0, i#0) } 
    PackedKV.__default.GetMessage#canCall(pkv#0, i#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))))
       ==> $Is(PackedKV.__default.GetMessage(pkv#0, i#0), Tclass.ValueMessage.Message()));

function PackedKV.__default.GetMessage#requires(DatatypeType, int) : bool;

// #requires axiom for PackedKV.__default.GetMessage
axiom (forall pkv#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.GetMessage#requires(pkv#0, i#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedKV.__default.GetMessage#requires(pkv#0, i#0)
       == (PackedKV.__default.WF(pkv#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))));

// definition axiom for PackedKV.__default.GetMessage(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.GetMessage(pkv#0, i#0) } 
    PackedKV.__default.GetMessage#canCall(pkv#0, i#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaElement#canCall(PackedKV.Pkv.messages(pkv#0), i#0)
         && ValueMessage.__default.bytestring__to__Message#canCall(PackedStringArray.__default.psaElement(PackedKV.Pkv.messages(pkv#0), i#0))
         && PackedKV.__default.GetMessage(pkv#0, i#0)
           == ValueMessage.__default.bytestring__to__Message(PackedStringArray.__default.psaElement(PackedKV.Pkv.messages(pkv#0), i#0)));

// definition axiom for PackedKV.__default.GetMessage for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedKV.__default.GetMessage(Lit(pkv#0), LitInt(i#0)) } 
    PackedKV.__default.GetMessage#canCall(Lit(pkv#0), LitInt(i#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0
             < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaElement#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(i#0))
         && ValueMessage.__default.bytestring__to__Message#canCall(Lit(PackedStringArray.__default.psaElement(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(i#0))))
         && PackedKV.__default.GetMessage(Lit(pkv#0), LitInt(i#0))
           == Lit(ValueMessage.__default.bytestring__to__Message(Lit(PackedStringArray.__default.psaElement(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(i#0))))));

// function declaration for PackedKV._default.binarySearchPostProc
function PackedKV.__default.binarySearchPostProc(lo#0: int, sub#0: DatatypeType) : DatatypeType;

function PackedKV.__default.binarySearchPostProc#canCall(lo#0: int, sub#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.binarySearchPostProc
axiom true
   ==> (forall lo#0: int, sub#0: DatatypeType :: 
    { PackedKV.__default.binarySearchPostProc(lo#0, sub#0) } 
    PackedKV.__default.binarySearchPostProc#canCall(lo#0, sub#0)
         || (LitInt(0) <= lo#0 && $Is(sub#0, Tclass.Options.Option(Tclass._System.nat())))
       ==> $Is(PackedKV.__default.binarySearchPostProc(lo#0, sub#0), 
        Tclass.Options.Option(Tclass._System.nat())));

function PackedKV.__default.binarySearchPostProc#requires(int, DatatypeType) : bool;

// #requires axiom for PackedKV.__default.binarySearchPostProc
axiom (forall lo#0: int, sub#0: DatatypeType :: 
  { PackedKV.__default.binarySearchPostProc#requires(lo#0, sub#0) } 
  LitInt(0) <= lo#0 && $Is(sub#0, Tclass.Options.Option(Tclass._System.nat()))
     ==> PackedKV.__default.binarySearchPostProc#requires(lo#0, sub#0) == true);

// definition axiom for PackedKV.__default.binarySearchPostProc(revealed)
axiom true
   ==> (forall lo#0: int, sub#0: DatatypeType :: 
    { PackedKV.__default.binarySearchPostProc(lo#0, sub#0) } 
    PackedKV.__default.binarySearchPostProc#canCall(lo#0, sub#0)
         || (LitInt(0) <= lo#0 && $Is(sub#0, Tclass.Options.Option(Tclass._System.nat())))
       ==> PackedKV.__default.binarySearchPostProc(lo#0, sub#0)
         == (if Options.Option.Some_q(sub#0)
           then #Options.Option.Some($Box(lo#0 + $Unbox(Options.Option.value(sub#0)): int))
           else #Options.Option.None()));

// definition axiom for PackedKV.__default.binarySearchPostProc for all literals(revealed)
axiom true
   ==> (forall lo#0: int, sub#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.binarySearchPostProc(LitInt(lo#0), Lit(sub#0)) } 
    PackedKV.__default.binarySearchPostProc#canCall(LitInt(lo#0), Lit(sub#0))
         || (LitInt(0) <= lo#0 && $Is(sub#0, Tclass.Options.Option(Tclass._System.nat())))
       ==> PackedKV.__default.binarySearchPostProc(LitInt(lo#0), Lit(sub#0))
         == (if Options.Option.Some_q(Lit(sub#0))
           then #Options.Option.Some($Box(LitInt(lo#0 + $Unbox(Options.Option.value(Lit(sub#0))): int)))
           else #Options.Option.None()));

// function declaration for PackedKV._default.canAppend
function PackedKV.__default.canAppend(pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box) : bool;

function PackedKV.__default.canAppend#canCall(pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box) : bool;

// consequence axiom for PackedKV.__default.canAppend
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    { PackedKV.__default.canAppend(pkv#0, key#0, msg#0) } 
    PackedKV.__default.canAppend#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedKV.__default.WF(pkv#0))
       ==> true);

function PackedKV.__default.canAppend#requires(DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for PackedKV.__default.canAppend
axiom (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
  { PackedKV.__default.canAppend#requires(pkv#0, key#0, msg#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedKV.__default.canAppend#requires(pkv#0, key#0, msg#0)
       == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.canAppend(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    { PackedKV.__default.canAppend(pkv#0, key#0, msg#0) } 
    PackedKV.__default.canAppend#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.keys(pkv#0), key#0)
         && (PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(pkv#0), key#0)
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(pkv#0), msg#0))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(pkv#0), msg#0)
             && PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(pkv#0), msg#0)
           ==> ValueType.__default.ValidMessageBytestring#canCall(msg#0))
         && PackedKV.__default.canAppend(pkv#0, key#0, msg#0)
           == (
            PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(pkv#0), key#0)
             && PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(pkv#0), msg#0)
             && ValueType.__default.ValidMessageBytestring(msg#0)));

// definition axiom for PackedKV.__default.canAppend for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.canAppend(Lit(pkv#0), Lit(key#0), Lit(msg#0)) } 
    PackedKV.__default.canAppend#canCall(Lit(pkv#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaCanAppend#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0))
         && (Lit(PackedStringArray.__default.psaCanAppend(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0)))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaCanAppend#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0)))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaCanAppend#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0))
             && Lit(PackedStringArray.__default.psaCanAppend(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0)))
           ==> ValueType.__default.ValidMessageBytestring#canCall(Lit(msg#0)))
         && PackedKV.__default.canAppend(Lit(pkv#0), Lit(key#0), Lit(msg#0))
           == Lit(PackedStringArray.__default.psaCanAppend(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0))
               && PackedStringArray.__default.psaCanAppend(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0))
               && ValueType.__default.ValidMessageBytestring(Lit(msg#0))));

// function declaration for PackedKV._default.AppendEncodedMessage
function PackedKV.__default.AppendEncodedMessage(pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box) : DatatypeType;

function PackedKV.__default.AppendEncodedMessage#canCall(pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box) : bool;

// consequence axiom for PackedKV.__default.AppendEncodedMessage
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    { PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0) } 
    PackedKV.__default.AppendEncodedMessage#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedKV.__default.WF(pkv#0)
           && PackedKV.__default.canAppend(pkv#0, key#0, msg#0))
       ==> PackedKV.__default.WF(PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0))
         && Seq#Equal(PackedKV.__default.IKeys(PackedKV.Pkv.keys(PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0))), 
          Seq#Append(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), 
            Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
         && $Is(PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0), 
          Tclass.PackedKV.Pkv()));

function PackedKV.__default.AppendEncodedMessage#requires(DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for PackedKV.__default.AppendEncodedMessage
axiom (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
  { PackedKV.__default.AppendEncodedMessage#requires(pkv#0, key#0, msg#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedKV.__default.AppendEncodedMessage#requires(pkv#0, key#0, msg#0)
       == (PackedKV.__default.WF(pkv#0)
         && PackedKV.__default.canAppend(pkv#0, key#0, msg#0)));

// definition axiom for PackedKV.__default.AppendEncodedMessage(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    { PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0) } 
    PackedKV.__default.AppendEncodedMessage#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedKV.__default.WF(pkv#0)
           && PackedKV.__default.canAppend(pkv#0, key#0, msg#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaAppend#canCall(PackedKV.Pkv.keys(pkv#0), key#0)
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaAppend#canCall(PackedKV.Pkv.messages(pkv#0), msg#0)
         && PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0)
           == #PackedKV.Pkv.Pkv(PackedStringArray.__default.psaAppend(PackedKV.Pkv.keys(pkv#0), key#0), 
            PackedStringArray.__default.psaAppend(PackedKV.Pkv.messages(pkv#0), msg#0)));

// definition axiom for PackedKV.__default.AppendEncodedMessage for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.AppendEncodedMessage(Lit(pkv#0), Lit(key#0), Lit(msg#0)) } 
    PackedKV.__default.AppendEncodedMessage#canCall(Lit(pkv#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Lit(PackedKV.__default.canAppend(Lit(pkv#0), Lit(key#0), Lit(msg#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaAppend#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaAppend#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0))
         && PackedKV.__default.AppendEncodedMessage(Lit(pkv#0), Lit(key#0), Lit(msg#0))
           == Lit(#PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.psaAppend(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0))), 
              Lit(PackedStringArray.__default.psaAppend(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0))))));

// function declaration for PackedKV._default.Append
function PackedKV.__default.Append(pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : DatatypeType;

function PackedKV.__default.Append#canCall(pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.Append
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { PackedKV.__default.Append(pkv#0, key#0, msg#0) } 
    PackedKV.__default.Append#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && 
          PackedKV.__default.WF(pkv#0)
           && ValueMessage.Message.Define_q(msg#0)
           && PackedKV.__default.canAppend(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0)))
       ==> PackedKV.__default.WF(PackedKV.__default.Append(pkv#0, key#0, msg#0))
         && $Is(PackedKV.__default.Append(pkv#0, key#0, msg#0), Tclass.PackedKV.Pkv()));

function PackedKV.__default.Append#requires(DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for PackedKV.__default.Append
axiom (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
  { PackedKV.__default.Append#requires(pkv#0, key#0, msg#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> PackedKV.__default.Append#requires(pkv#0, key#0, msg#0)
       == (
        PackedKV.__default.WF(pkv#0)
         && ValueMessage.Message.Define_q(msg#0)
         && PackedKV.__default.canAppend(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0))));

// definition axiom for PackedKV.__default.Append(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { PackedKV.__default.Append(pkv#0, key#0, msg#0) } 
    PackedKV.__default.Append#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && 
          PackedKV.__default.WF(pkv#0)
           && ValueMessage.Message.Define_q(msg#0)
           && PackedKV.__default.canAppend(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0)))
       ==> ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         && PackedKV.__default.AppendEncodedMessage#canCall(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0))
         && PackedKV.__default.Append(pkv#0, key#0, msg#0)
           == PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0)));

// definition axiom for PackedKV.__default.Append for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.Append(Lit(pkv#0), Lit(key#0), Lit(msg#0)) } 
    PackedKV.__default.Append#canCall(Lit(pkv#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Lit(ValueMessage.Message.Define_q(Lit(msg#0)))
           && Lit(PackedKV.__default.canAppend(Lit(pkv#0), 
              Lit(key#0), 
              Lit(ValueMessage.__default.Message__to__bytestring(Lit(msg#0))))))
       ==> ValueMessage.__default.Message__to__bytestring#canCall(Lit(msg#0))
         && PackedKV.__default.AppendEncodedMessage#canCall(Lit(pkv#0), 
          Lit(key#0), 
          Lit(ValueMessage.__default.Message__to__bytestring(Lit(msg#0))))
         && PackedKV.__default.Append(Lit(pkv#0), Lit(key#0), Lit(msg#0))
           == Lit(PackedKV.__default.AppendEncodedMessage(Lit(pkv#0), 
              Lit(key#0), 
              Lit(ValueMessage.__default.Message__to__bytestring(Lit(msg#0))))));

// function declaration for PackedKV._default.subPkv
function PackedKV.__default.subPkv(pkv#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function PackedKV.__default.subPkv#canCall(pkv#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for PackedKV.__default.subPkv
axiom true
   ==> (forall pkv#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedKV.__default.subPkv(pkv#0, from#0, to#0) } 
    PackedKV.__default.subPkv#canCall(pkv#0, from#0, to#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0)))
       ==> PackedKV.__default.WF(PackedKV.__default.subPkv(pkv#0, from#0, to#0))
         && (BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(pkv#0))
           ==> BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(PackedKV.__default.subPkv(pkv#0, from#0, to#0))))
         && $Is(PackedKV.__default.subPkv(pkv#0, from#0, to#0), Tclass.PackedKV.Pkv()));

function PackedKV.__default.subPkv#requires(DatatypeType, int, int) : bool;

// #requires axiom for PackedKV.__default.subPkv
axiom (forall pkv#0: DatatypeType, from#0: int, to#0: int :: 
  { PackedKV.__default.subPkv#requires(pkv#0, from#0, to#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedKV.__default.subPkv#requires(pkv#0, from#0, to#0)
       == (PackedKV.__default.WF(pkv#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0))));

// definition axiom for PackedKV.__default.subPkv(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedKV.__default.subPkv(pkv#0, from#0, to#0) } 
    PackedKV.__default.subPkv#canCall(pkv#0, from#0, to#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0)))
       ==> PackedKV.__default.I#canCall(pkv#0)
         && BucketsLib.__default.BucketWellMarshalled#canCall(PackedKV.__default.I(pkv#0))
         && (BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(pkv#0))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaSubSeq#canCall(PackedKV.Pkv.keys(pkv#0), from#0, to#0)
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaSubSeq#canCall(PackedKV.Pkv.messages(pkv#0), from#0, to#0))
         && (!BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(pkv#0))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaSubSeq#canCall(PackedKV.Pkv.keys(pkv#0), from#0, to#0)
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaSubSeq#canCall(PackedKV.Pkv.messages(pkv#0), from#0, to#0))
         && PackedKV.__default.subPkv(pkv#0, from#0, to#0)
           == (if BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(pkv#0))
             then #PackedKV.Pkv.Pkv(PackedStringArray.__default.psaSubSeq(PackedKV.Pkv.keys(pkv#0), from#0, to#0), 
              PackedStringArray.__default.psaSubSeq(PackedKV.Pkv.messages(pkv#0), from#0, to#0))
             else #PackedKV.Pkv.Pkv(PackedStringArray.__default.psaSubSeq(PackedKV.Pkv.keys(pkv#0), from#0, to#0), 
              PackedStringArray.__default.psaSubSeq(PackedKV.Pkv.messages(pkv#0), from#0, to#0))));

// definition axiom for PackedKV.__default.subPkv for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { PackedKV.__default.subPkv(Lit(pkv#0), LitInt(from#0), LitInt(to#0)) } 
    PackedKV.__default.subPkv#canCall(Lit(pkv#0), LitInt(from#0), LitInt(to#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0)
             <= LitInt(PackedStringArray.__default.psaNumStrings(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
       ==> PackedKV.__default.I#canCall(Lit(pkv#0))
         && BucketsLib.__default.BucketWellMarshalled#canCall(Lit(PackedKV.__default.I(Lit(pkv#0))))
         && (Lit(BucketsLib.__default.BucketWellMarshalled(Lit(PackedKV.__default.I(Lit(pkv#0)))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaSubSeq#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaSubSeq#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(from#0), LitInt(to#0)))
         && (!Lit(BucketsLib.__default.BucketWellMarshalled(Lit(PackedKV.__default.I(Lit(pkv#0)))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaSubSeq#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaSubSeq#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(from#0), LitInt(to#0)))
         && PackedKV.__default.subPkv(Lit(pkv#0), LitInt(from#0), LitInt(to#0))
           == (if BucketsLib.__default.BucketWellMarshalled(Lit(PackedKV.__default.I(Lit(pkv#0))))
             then #PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.psaSubSeq(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))), 
              Lit(PackedStringArray.__default.psaSubSeq(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))))
             else #PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.psaSubSeq(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))), 
              Lit(PackedStringArray.__default.psaSubSeq(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))))));

procedure CheckWellformed$$PackedKV.__default.SubPkv(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(result#0, Tclass.PackedKV.Pkv(), $Heap));
  free requires 38 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$PackedKV.__default.SubPkv(pkv#0: DatatypeType
       where $Is(pkv#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(pkv#0, Tclass.PackedKV.Pkv(), $Heap)
         && $IsA#PackedKV.Pkv(pkv#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedKV.Pkv())
         && $IsAlloc(result#0, Tclass.PackedKV.Pkv(), $Heap));
  // user-defined preconditions
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0))) == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
             < 4294967296);
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == LitInt(0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || (0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             ==> Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0)))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)), 
                  Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))) - 1)): int));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
         ==> PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
         == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
         ==> PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           || (PackedKV.__default.ValidStringLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
              LitInt(KeyType.__default.MaxLen()))
             ==> PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
                PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), 
                LitInt(KeyType.__default.MaxLen()))
               || (forall i#6: int :: 
                { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#6)): Seq Box } 
                LitInt(0) <= i#6
                     && i#6 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
                   ==> Seq#Length($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)), i#6)): Seq Box)
                     <= LitInt(KeyType.__default.MaxLen()))));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || (ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
         ==> ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           || (forall i#7: int :: 
            { $Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#7)): Seq Box } 
            LitInt(0) <= i#7
                 && i#7 < Seq#Length(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)), i#7)): Seq Box)));
  requires PackedKV.__default.WF#canCall(pkv#0)
     ==> PackedKV.__default.WF(pkv#0)
       || !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
        $Box(ValueMessage.__default.IdentityMessage()));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#PackedKV.Pkv(result#0)
     && $IsA#PackedKV.Pkv(PackedKV.__default.subPkv(pkv#0, from#0, to#0))
     && PackedKV.__default.subPkv#canCall(pkv#0, from#0, to#0);
  ensures PackedKV.Pkv#Equal(result#0, PackedKV.__default.subPkv(pkv#0, from#0, to#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// function declaration for PackedKV._default.DropLast
function PackedKV.__default.DropLast(pkv#0: DatatypeType) : DatatypeType;

function PackedKV.__default.DropLast#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.DropLast
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.DropLast(pkv#0) } 
    PackedKV.__default.DropLast#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && 0 < PackedKV.__default.NumKVPairs(pkv#0))
       ==> PackedKV.__default.WF(PackedKV.__default.DropLast(pkv#0))
         && $Is(PackedKV.__default.DropLast(pkv#0), Tclass.PackedKV.Pkv()));

function PackedKV.__default.DropLast#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.DropLast
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.DropLast#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.DropLast#requires(pkv#0)
       == (PackedKV.__default.WF(pkv#0) && 0 < PackedKV.__default.NumKVPairs(pkv#0)));

// definition axiom for PackedKV.__default.DropLast(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.DropLast(pkv#0) } 
    PackedKV.__default.DropLast#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && 0 < PackedKV.__default.NumKVPairs(pkv#0))
       ==> PackedKV.__default.NumKVPairs#canCall(pkv#0)
         && PackedKV.__default.subPkv#canCall(pkv#0, LitInt(0), PackedKV.__default.NumKVPairs(pkv#0) - 1)
         && PackedKV.__default.DropLast(pkv#0)
           == PackedKV.__default.subPkv(pkv#0, LitInt(0), PackedKV.__default.NumKVPairs(pkv#0) - 1));

// definition axiom for PackedKV.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.DropLast(Lit(pkv#0)) } 
    PackedKV.__default.DropLast#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Lit(0 < PackedKV.__default.NumKVPairs(Lit(pkv#0))))
       ==> PackedKV.__default.NumKVPairs#canCall(Lit(pkv#0))
         && PackedKV.__default.subPkv#canCall(Lit(pkv#0), LitInt(0), LitInt(PackedKV.__default.NumKVPairs(Lit(pkv#0)) - 1))
         && PackedKV.__default.DropLast(Lit(pkv#0))
           == Lit(PackedKV.__default.subPkv(Lit(pkv#0), LitInt(0), LitInt(PackedKV.__default.NumKVPairs(Lit(pkv#0)) - 1))));

// function declaration for PackedKV._default.pivotIndexes
function PackedKV.__default.pivotIndexes($ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box) : Seq Box;

function PackedKV.__default.pivotIndexes#canCall(keys#0: Seq Box, pivots#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
  { PackedKV.__default.pivotIndexes($LS($ly), keys#0, pivots#0) } 
  PackedKV.__default.pivotIndexes($LS($ly), keys#0, pivots#0)
     == PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
  { PackedKV.__default.pivotIndexes(AsFuelBottom($ly), keys#0, pivots#0) } 
  PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0)
     == PackedKV.__default.pivotIndexes($LZ, keys#0, pivots#0));

// consequence axiom for PackedKV.__default.pivotIndexes
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
    { PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0) } 
    PackedKV.__default.pivotIndexes#canCall(keys#0, pivots#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, keys#0))
       ==> Seq#Length(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0))
           == Seq#Length(pivots#0)
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(pivots#0, i#3)): Seq Box } 
            { $Unbox(Seq#Index(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0), i#3)): int } 
          LitInt(0) <= i#3
               && i#3 < Seq#Length(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0))
             ==> $Unbox(Seq#Index(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0), i#3)): int
               == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), keys#0, $Unbox(Seq#Index(pivots#0, i#3)): Seq Box))
         && $Is(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0), 
          TSeq(Tclass._System.nat())));

function PackedKV.__default.pivotIndexes#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for PackedKV.__default.pivotIndexes
axiom (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
  { PackedKV.__default.pivotIndexes#requires($ly, keys#0, pivots#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> PackedKV.__default.pivotIndexes#requires($ly, keys#0, pivots#0)
       == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, keys#0));

// definition axiom for PackedKV.__default.pivotIndexes(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
    { PackedKV.__default.pivotIndexes($LS($ly), keys#0, pivots#0) } 
    PackedKV.__default.pivotIndexes#canCall(keys#0, pivots#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, keys#0))
       ==> (Seq#Length(pivots#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), pivots#0)
             && PackedKV.__default.pivotIndexes#canCall(keys#0, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), pivots#0)
             && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(keys#0, 
              $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box))
         && PackedKV.__default.pivotIndexes($LS($ly), keys#0, pivots#0)
           == (if Seq#Length(pivots#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedKV.__default.pivotIndexes($ly, keys#0, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
                    keys#0, 
                    $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box))))));

// definition axiom for PackedKV.__default.pivotIndexes for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.pivotIndexes($LS($ly), Lit(keys#0), Lit(pivots#0)) } 
    PackedKV.__default.pivotIndexes#canCall(Lit(keys#0), Lit(pivots#0))
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, Lit(keys#0)))
       ==> (Seq#Length(Lit(pivots#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
             && PackedKV.__default.pivotIndexes#canCall(Lit(keys#0), 
              Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
             && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(keys#0), 
              Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box)))
         && PackedKV.__default.pivotIndexes($LS($ly), Lit(keys#0), Lit(pivots#0))
           == (if Seq#Length(Lit(pivots#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedKV.__default.pivotIndexes($LS($ly), 
                Lit(keys#0), 
                Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(LitInt(Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
                      Lit(keys#0), 
                      Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))))))));

const unique class.Uint64__Order.__default: ClassName;

function Tclass.Uint64__Order.__default() : Ty;

// Tclass.Uint64__Order.__default Tag
axiom Tag(Tclass.Uint64__Order.__default()) == Tagclass.Uint64__Order.__default;

const unique Tagclass.Uint64__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Uint64__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Uint64__Order.__default()) } 
  $IsBox(bx, Tclass.Uint64__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Uint64__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Uint64__Order.__default()) } 
  $Is($o, Tclass.Uint64__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Uint64__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Uint64__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Uint64__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Uint64_Order._default.SomeElement
function Uint64__Order.__default.SomeElement() : int;

function Uint64__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Uint64__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> LitInt(0) <= Uint64__Order.__default.SomeElement()
     && Uint64__Order.__default.SomeElement() < 18446744073709551616;

function Uint64__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Uint64__Order.__default.SomeElement
axiom Uint64__Order.__default.SomeElement#requires() == true;

// definition axiom for Uint64__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Uint64__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Uint64__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Uint64__Order.__default.SomeElement() == LitInt(0);

// function declaration for Uint64_Order._default.lte
function Uint64__Order.__default.lte(a#0: int, b#0: int) : bool;

function Uint64__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint64__Order.__default.lte
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint64__Order.__default.lte(a#0, b#0) } 
    Uint64__Order.__default.lte#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.lte(a#0, b#0)
           == Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#0, b#0)
         && (Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#0, b#0)
           || Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#0, a#0))
         && (forall a#1: int, b#1: int, c#0: int :: 
          { Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#1, c#0), Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#1, c#0) } 
            { Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#1, c#0), Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#1, b#1) } 
          LitInt(0) <= a#1
               && a#1 < 18446744073709551616
               && 
              LitInt(0) <= b#1
               && b#1 < 18446744073709551616
               && 
              LitInt(0) <= c#0
               && c#0 < 18446744073709551616
             ==> 
            Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#1, b#1)
               && Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#1, c#0)
             ==> Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#1, c#0))
         && Uint64__Order.__default.lte(a#0, b#0)
           == Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#0, b#0)
         && (Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#0, b#0)
           || Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#0, a#0))
         && (Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#0, b#0)
             && Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#2: int, b#2: int, c#1: int :: 
          { Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#2, c#1), Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#2, c#1) } 
            { Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#2, c#1), Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#2, b#2) } 
          LitInt(0) <= a#2
               && a#2 < 18446744073709551616
               && 
              LitInt(0) <= b#2
               && b#2 < 18446744073709551616
               && 
              LitInt(0) <= c#1
               && c#1 < 18446744073709551616
             ==> 
            Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#2, b#2)
               && Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, b#2, c#1)
             ==> Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#2, c#1)));

function Uint64__Order.__default.lte#requires(int, int) : bool;

// #requires axiom for Uint64__Order.__default.lte
axiom (forall a#0: int, b#0: int :: 
  { Uint64__Order.__default.lte#requires(a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> Uint64__Order.__default.lte#requires(a#0, b#0) == true);

const MoreFuel_Uint64_Order._default.ltedef0: LayerType;

// definition axiom for Uint64__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint64__Order.__default.lte(a#0, b#0) } 
    Uint64__Order.__default.lte#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.ltedef#canCall(a#0, b#0)
         && 
        StartFuel_Uint64_Order._default.ltedef
           == $LS(MoreFuel_Uint64_Order._default.ltedef0)
         && StartFuelAssert_Uint64_Order._default.ltedef
           == $LS($LS(MoreFuel_Uint64_Order._default.ltedef0))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.ltedef0)
           == MoreFuel_Uint64_Order._default.ltedef0
         && Uint64__Order.__default.lte(a#0, b#0)
           == Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, a#0, b#0));

const MoreFuel_Uint64_Order._default.ltedef1: LayerType;

// definition axiom for Uint64__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint64__Order.__default.lte(LitInt(a#0), LitInt(b#0)) } 
    Uint64__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         && 
        StartFuel_Uint64_Order._default.ltedef
           == $LS(MoreFuel_Uint64_Order._default.ltedef1)
         && StartFuelAssert_Uint64_Order._default.ltedef
           == $LS($LS(MoreFuel_Uint64_Order._default.ltedef1))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.ltedef1)
           == MoreFuel_Uint64_Order._default.ltedef1
         && Uint64__Order.__default.lte(LitInt(a#0), LitInt(b#0))
           == Uint64__Order.__default.ltedef(StartFuel_Uint64_Order._default.ltedef, LitInt(a#0), LitInt(b#0)));

// function declaration for Uint64_Order._default.ltedef
function Uint64__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Uint64__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint64__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Uint64__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Uint64__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint64__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Uint64__Order.__default.ltedef($ly, a#0, b#0)
     == Uint64__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Uint64__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Uint64__Order.__default.ltedef($ly, a#0, b#0) } 
    Uint64__Order.__default.ltedef#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> true);

function Uint64__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Uint64__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint64__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> Uint64__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Uint64__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Uint64__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    Uint64__Order.__default.ltedef#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Uint64__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Uint64__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Uint64__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Uint64_Order._default.LargestLte
function Uint64__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint64__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Uint64__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Uint64__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Uint64__Order.__default.LargestLte($ly, run#0, needle#0)
     == Uint64__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Uint64__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint64__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Uint64__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Uint64__Order.__default.LargestLte($ly, run#0, needle#0)
         && Uint64__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Uint64__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Uint64__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Uint64__Order.__default.LargestLte($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint64__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Uint64__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Uint64__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Uint64__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint64__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 18446744073709551616
     ==> Uint64__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0));

const MoreFuel_Uint64_Order._default.IsSorted0: LayerType;

// definition axiom for Uint64__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint64__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Uint64__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Uint64__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Uint64__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Uint64__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Uint64_Order._default.IsSorted
           == $LS(MoreFuel_Uint64_Order._default.IsSorted0)
         && StartFuelAssert_Uint64_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint64_Order._default.IsSorted0))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.IsSorted0)
           == MoreFuel_Uint64_Order._default.IsSorted0
         && Uint64__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Uint64__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint64__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Uint64_Order._default.IsSorted1: LayerType;

// definition axiom for Uint64__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint64__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint64__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Uint64__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Uint64__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Uint64__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Uint64_Order._default.IsSorted
           == $LS(MoreFuel_Uint64_Order._default.IsSorted1)
         && StartFuelAssert_Uint64_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint64_Order._default.IsSorted1))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.IsSorted1)
           == MoreFuel_Uint64_Order._default.IsSorted1
         && Uint64__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Uint64__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint64__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Uint64_Order._default.LargestLt
function Uint64__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint64__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Uint64__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Uint64__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Uint64__Order.__default.LargestLt($ly, run#0, needle#0)
     == Uint64__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Uint64__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint64__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Uint64__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Uint64__Order.__default.LargestLt($ly, run#0, needle#0)
         && Uint64__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Uint64__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Uint64__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Uint64__Order.__default.LargestLt($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint64__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Uint64__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Uint64__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Uint64__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint64__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 18446744073709551616
     ==> Uint64__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0));

const MoreFuel_Uint64_Order._default.IsSorted2: LayerType;

// definition axiom for Uint64__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint64__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Uint64__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Uint64__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Uint64__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Uint64__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Uint64_Order._default.IsSorted
           == $LS(MoreFuel_Uint64_Order._default.IsSorted2)
         && StartFuelAssert_Uint64_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint64_Order._default.IsSorted2))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.IsSorted2)
           == MoreFuel_Uint64_Order._default.IsSorted2
         && Uint64__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Uint64__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Uint64__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Uint64_Order._default.IsSorted3: LayerType;

// definition axiom for Uint64__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint64__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint64__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Uint64__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Uint64__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Uint64__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Uint64_Order._default.IsSorted
           == $LS(MoreFuel_Uint64_Order._default.IsSorted3)
         && StartFuelAssert_Uint64_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint64_Order._default.IsSorted3))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.IsSorted3)
           == MoreFuel_Uint64_Order._default.IsSorted3
         && Uint64__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Uint64__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint64__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Uint64_Order._default.IndexOfFirstGte
function Uint64__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint64__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Uint64__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Uint64__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Uint64__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Uint64__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Uint64__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint64__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Uint64__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0))
       ==> Uint64__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Uint64__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Uint64__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Uint64__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint64__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Uint64__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Uint64__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint64__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 18446744073709551616
     ==> Uint64__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0));

const MoreFuel_Uint64_Order._default.IsSorted4: LayerType;

// definition axiom for Uint64__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint64__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Uint64__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), run#0)
             && Uint64__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), run#0)): int, 
              needle#0)
             && (!Uint64__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), run#0)
                 && Uint64__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), run#0), needle#0)))
         && 
        StartFuel_Uint64_Order._default.IsSorted
           == $LS(MoreFuel_Uint64_Order._default.IsSorted4)
         && StartFuelAssert_Uint64_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint64_Order._default.IsSorted4))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.IsSorted4)
           == MoreFuel_Uint64_Order._default.IsSorted4
         && Uint64__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Uint64__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Uint64__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), run#0), needle#0))));

const MoreFuel_Uint64_Order._default.IsSorted5: LayerType;

// definition axiom for Uint64__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint64__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint64__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(run#0))
             && Uint64__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Uint64__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), Lit(run#0))
                 && Uint64__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Uint64_Order._default.IsSorted
           == $LS(MoreFuel_Uint64_Order._default.IsSorted5)
         && StartFuelAssert_Uint64_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint64_Order._default.IsSorted5))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.IsSorted5)
           == MoreFuel_Uint64_Order._default.IsSorted5
         && Uint64__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Uint64__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Uint64__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Uint64_Order._default.binarySearchIndexOfFirstKeyGteIter
function Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint64__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Uint64__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Uint64__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint64__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Uint64__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#0, hi#0)
                 else Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Uint64__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint64__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Uint64__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Uint64__Order.__default.lte(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint64__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Uint64__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Uint64__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint64__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Uint64_Order._default.binarySearchIndexOfFirstKeyGte
function Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Uint64__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> LitInt(0)
           <= Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Uint64__Order.__default.lt($Unbox(Seq#Index(s#0, Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Uint64__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Uint64__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Uint64__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Uint64_Order._default.IndexOfFirstGt
function Uint64__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint64__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Uint64__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Uint64__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Uint64__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Uint64__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Uint64__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint64__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Uint64__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0))
       ==> Uint64__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Uint64__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Uint64__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Uint64__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint64__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Uint64__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Uint64__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint64__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint64__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 18446744073709551616
     ==> Uint64__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0));

const MoreFuel_Uint64_Order._default.IsSorted6: LayerType;

// definition axiom for Uint64__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint64__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Uint64__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), run#0)
             && Uint64__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), run#0)): int, 
              needle#0)
             && (!Uint64__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), run#0)
                 && Uint64__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), run#0), needle#0)))
         && 
        StartFuel_Uint64_Order._default.IsSorted
           == $LS(MoreFuel_Uint64_Order._default.IsSorted6)
         && StartFuelAssert_Uint64_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint64_Order._default.IsSorted6))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.IsSorted6)
           == MoreFuel_Uint64_Order._default.IsSorted6
         && Uint64__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Uint64__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Uint64__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), run#0), needle#0))));

const MoreFuel_Uint64_Order._default.IsSorted7: LayerType;

// definition axiom for Uint64__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint64__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint64__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 18446744073709551616
           && Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(run#0))
             && Uint64__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Uint64__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), Lit(run#0))
                 && Uint64__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Uint64_Order._default.IsSorted
           == $LS(MoreFuel_Uint64_Order._default.IsSorted7)
         && StartFuelAssert_Uint64_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint64_Order._default.IsSorted7))
         && AsFuelBottom(MoreFuel_Uint64_Order._default.IsSorted7)
           == MoreFuel_Uint64_Order._default.IsSorted7
         && Uint64__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Uint64__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Uint64__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Uint64_Order._default.binarySearchIndexOfFirstKeyGtIter
function Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint64__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Uint64__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Uint64__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint64__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Uint64__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#0, hi#0)
                 else Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Uint64__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint64__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Uint64__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Uint64__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint64__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Uint64__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Uint64__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint64__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Uint64_Order._default.binarySearchIndexOfFirstKeyGt
function Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Uint64__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> LitInt(0)
           <= Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Uint64__Order.__default.lte($Unbox(Seq#Index(s#0, Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Uint64__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Uint64__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint64__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Uint64__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Uint64__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Uint64__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Uint64__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Uint64_Order._default.SetAllLte
function Uint64__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Uint64__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Uint64__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint64__Order.__default.SetAllLte(a#0, b#0) } 
    Uint64__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint64()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint64())))
       ==> true);

function Uint64__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Uint64__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Uint64__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.uint64()))
       && $Is(b#0, TSet(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Uint64__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint64__Order.__default.SetAllLte(a#0, b#0) } 
    Uint64__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint64()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint64())))
       ==> (forall x#0: int, y#0: int :: 
          { Uint64__Order.__default.lte(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0
               && x#0 < 18446744073709551616
               && 
              LitInt(0) <= y#0
               && y#0 < 18446744073709551616
             ==> 
            b#0[$Box(y#0)]
             ==> Uint64__Order.__default.lte#canCall(x#0, y#0))
         && Uint64__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Uint64__Order.__default.lte(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0
                 && x#0 < 18446744073709551616
                 && 
                LitInt(0) <= y#0
                 && y#0 < 18446744073709551616
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Uint64__Order.__default.lte(x#0, y#0)));

// definition axiom for Uint64__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Uint64__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Uint64__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint64()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint64())))
       ==> (forall x#1: int, y#1: int :: 
          { Uint64__Order.__default.lte(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1
               && x#1 < 18446744073709551616
               && 
              LitInt(0) <= y#1
               && y#1 < 18446744073709551616
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Uint64__Order.__default.lte#canCall(x#1, y#1))
         && Uint64__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Uint64__Order.__default.lte(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1
                 && x#1 < 18446744073709551616
                 && 
                LitInt(0) <= y#1
                 && y#1 < 18446744073709551616
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Uint64__Order.__default.lte(x#1, y#1)));

// function declaration for Uint64_Order._default.SetAllLt
function Uint64__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Uint64__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Uint64__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint64__Order.__default.SetAllLt(a#0, b#0) } 
    Uint64__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint64()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint64())))
       ==> true);

function Uint64__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Uint64__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Uint64__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.uint64()))
       && $Is(b#0, TSet(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Uint64__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint64__Order.__default.SetAllLt(a#0, b#0) } 
    Uint64__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint64()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint64())))
       ==> (forall x#0: int, y#0: int :: 
          { Uint64__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0
               && x#0 < 18446744073709551616
               && 
              LitInt(0) <= y#0
               && y#0 < 18446744073709551616
             ==> 
            b#0[$Box(y#0)]
             ==> Uint64__Order.__default.lt#canCall(x#0, y#0))
         && Uint64__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Uint64__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0
                 && x#0 < 18446744073709551616
                 && 
                LitInt(0) <= y#0
                 && y#0 < 18446744073709551616
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Uint64__Order.__default.lt(x#0, y#0)));

// definition axiom for Uint64__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Uint64__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Uint64__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint64()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint64())))
       ==> (forall x#1: int, y#1: int :: 
          { Uint64__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1
               && x#1 < 18446744073709551616
               && 
              LitInt(0) <= y#1
               && y#1 < 18446744073709551616
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Uint64__Order.__default.lt#canCall(x#1, y#1))
         && Uint64__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Uint64__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1
                 && x#1 < 18446744073709551616
                 && 
                LitInt(0) <= y#1
                 && y#1 < 18446744073709551616
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Uint64__Order.__default.lt(x#1, y#1)));

// function declaration for Uint64_Order._default.NotMinimum
function Uint64__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Uint64__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint64__Order.__default.NotMinimum($LS($ly), a#0) } 
  Uint64__Order.__default.NotMinimum($LS($ly), a#0)
     == Uint64__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint64__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Uint64__Order.__default.NotMinimum($ly, a#0)
     == Uint64__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Uint64__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Uint64__Order.__default.NotMinimum($ly, a#0) } 
    Uint64__Order.__default.NotMinimum#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 18446744073709551616)
       ==> true);

function Uint64__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Uint64__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint64__Order.__default.NotMinimum#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 18446744073709551616
     ==> Uint64__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Uint64__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Uint64__Order.__default.NotMinimum($LS($ly), a#0) } 
    Uint64__Order.__default.NotMinimum#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 18446744073709551616)
       ==> (forall b#0: int :: 
          { Uint64__Order.__default.lt(b#0, a#0) } 
          LitInt(0) <= b#0 && b#0 < 18446744073709551616
             ==> Uint64__Order.__default.lt#canCall(b#0, a#0))
         && Uint64__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#0: int :: 
            { Uint64__Order.__default.lt(b#0, a#0) } 
            LitInt(0) <= b#0
               && b#0 < 18446744073709551616
               && Uint64__Order.__default.lt(b#0, a#0)));

// definition axiom for Uint64__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Uint64__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    Uint64__Order.__default.NotMinimum#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 18446744073709551616)
       ==> (forall b#1: int :: 
          { Uint64__Order.__default.lt(b#1, a#0) } 
          LitInt(0) <= b#1 && b#1 < 18446744073709551616
             ==> Uint64__Order.__default.lt#canCall(b#1, LitInt(a#0)))
         && Uint64__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#1: int :: 
            { Uint64__Order.__default.lt(b#1, a#0) } 
            LitInt(0) <= b#1
               && b#1 < 18446744073709551616
               && Uint64__Order.__default.lt(b#1, LitInt(a#0))));

// function declaration for Uint64_Order._default.MapPivotedUnion
function Uint64__Order.__default.MapPivotedUnion(Uint64_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Uint64__Order.__default.MapPivotedUnion#canCall(Uint64_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Uint64__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Uint64_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Uint64__Order.__default.MapPivotedUnion(Uint64_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Uint64__Order.__default.MapPivotedUnion#canCall(Uint64_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 18446744073709551616
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Uint64__Order.__default.MapPivotedUnion(Uint64_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value)));

function Uint64__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Uint64__Order.__default.MapPivotedUnion
axiom (forall Uint64_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Uint64__Order.__default.MapPivotedUnion#requires(Uint64_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, 
        TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value))
       && 
      LitInt(0) <= pivot#0
       && pivot#0 < 18446744073709551616
       && $Is(right#0, 
        TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value))
     ==> Uint64__Order.__default.MapPivotedUnion#requires(Uint64_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Uint64__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Uint64_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Uint64__Order.__default.MapPivotedUnion(Uint64_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Uint64__Order.__default.MapPivotedUnion#canCall(Uint64_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 18446744073709551616
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#0: int :: 
          { Uint64__Order.__default.lt(k#0, pivot#0) } 
          LitInt(0) <= k#0 && k#0 < 18446744073709551616
             ==> Uint64__Order.__default.lt#canCall(k#0, pivot#0))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint64(), 
          Uint64_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.uint64())
               && Uint64__Order.__default.lt($Unbox($y#0): int, pivot#0)))
         && (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint64(), 
              Uint64_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#3: Box :: 
                $IsBox($y#3, Tclass.NativeTypes.uint64())
                   && Uint64__Order.__default.lt($Unbox($y#3): int, pivot#0))); 
          (forall k#1: int :: 
              { Uint64__Order.__default.lte(pivot#0, k#1) } 
              LitInt(0) <= k#1 && k#1 < 18446744073709551616
                 ==> Uint64__Order.__default.lte#canCall(pivot#0, k#1))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint64(), 
              Uint64_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#1: Box :: 
                $IsBox($y#1, Tclass.NativeTypes.uint64())
                   && Uint64__Order.__default.lte(pivot#0, $Unbox($y#1): int)))
             && (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint64(), 
                  Uint64_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#2: Box :: 
                    $IsBox($y#2, Tclass.NativeTypes.uint64())
                       && Uint64__Order.__default.lte(pivot#0, $Unbox($y#2): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.uint64(), 
                Uint64_Order._default.MapPivotedUnion$Value, 
                restricted_left#0, 
                restricted_right#0)))
         && Uint64__Order.__default.MapPivotedUnion(Uint64_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint64(), 
                Uint64_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#4: Box :: 
                  $IsBox($y#4, Tclass.NativeTypes.uint64())
                     && Uint64__Order.__default.lt($Unbox($y#4): int, pivot#0))); 
            (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint64(), 
                  Uint64_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#5: Box :: 
                    $IsBox($y#5, Tclass.NativeTypes.uint64())
                       && Uint64__Order.__default.lte(pivot#0, $Unbox($y#5): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.uint64(), 
                Uint64_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#0, 
                restricted_right#0))));

// definition axiom for Uint64__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Uint64_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Uint64__Order.__default.MapPivotedUnion(Uint64_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Uint64__Order.__default.MapPivotedUnion#canCall(Uint64_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 18446744073709551616
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#2: int :: 
          { Uint64__Order.__default.lt(k#2, pivot#0) } 
          LitInt(0) <= k#2 && k#2 < 18446744073709551616
             ==> Uint64__Order.__default.lt#canCall(k#2, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint64(), 
          Uint64_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#6: Box :: 
            $IsBox($y#6, Tclass.NativeTypes.uint64())
               && Uint64__Order.__default.lt($Unbox($y#6): int, LitInt(pivot#0))))
         && (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint64(), 
              Uint64_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#9: Box :: 
                $IsBox($y#9, Tclass.NativeTypes.uint64())
                   && Uint64__Order.__default.lt($Unbox($y#9): int, LitInt(pivot#0)))); 
          (forall k#3: int :: 
              { Uint64__Order.__default.lte(pivot#0, k#3) } 
              LitInt(0) <= k#3 && k#3 < 18446744073709551616
                 ==> Uint64__Order.__default.lte#canCall(LitInt(pivot#0), k#3))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint64(), 
              Uint64_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#7: Box :: 
                $IsBox($y#7, Tclass.NativeTypes.uint64())
                   && Uint64__Order.__default.lte(LitInt(pivot#0), $Unbox($y#7): int)))
             && (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint64(), 
                  Uint64_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#8: Box :: 
                    $IsBox($y#8, Tclass.NativeTypes.uint64())
                       && Uint64__Order.__default.lte(LitInt(pivot#0), $Unbox($y#8): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.uint64(), 
                Uint64_Order._default.MapPivotedUnion$Value, 
                restricted_left#1, 
                restricted_right#1)))
         && Uint64__Order.__default.MapPivotedUnion(Uint64_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint64(), 
                Uint64_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#10: Box :: 
                  $IsBox($y#10, Tclass.NativeTypes.uint64())
                     && Uint64__Order.__default.lt($Unbox($y#10): int, LitInt(pivot#0)))); 
            (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint64(), 
                  Uint64_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#11: Box :: 
                    $IsBox($y#11, Tclass.NativeTypes.uint64())
                       && Uint64__Order.__default.lte(LitInt(pivot#0), $Unbox($y#11): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.uint64(), 
                Uint64_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#1, 
                restricted_right#1))));

// function declaration for Uint64_Order._default.SetSuccessor
function Uint64__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Uint64__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Uint64__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Uint64__Order.__default.SetSuccessor(m#0, key#0) } 
    Uint64__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> $Is(Uint64__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint64())));

function Uint64__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Uint64__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Uint64__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> Uint64__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#43_next(m: Set Box, key: int) : int;

function $let#43$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#43_next(m, key) } 
  $let#43$canCall(m, key)
     ==> LitInt(0) <= $let#43_next(m, key)
       && $let#43_next(m, key) < 18446744073709551616
       && 
      m[$Box($let#43_next(m, key))]
       && Uint64__Order.__default.lt(key, $let#43_next(m, key))
       && (forall other#1: int :: 
        { Uint64__Order.__default.lt($let#43_next(m, key), other#1) } 
          { Uint64__Order.__default.lt(key, other#1) } 
          { m[$Box(other#1)] } 
        LitInt(0) <= other#1 && other#1 < 18446744073709551616
           ==> 
          m[$Box(other#1)]
             && other#1 != $let#43_next(m, key)
             && Uint64__Order.__default.lt(key, other#1)
           ==> Uint64__Order.__default.lt($let#43_next(m, key), other#1)));

// definition axiom for Uint64__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Uint64__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Uint64__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> (forall next#0: int :: 
          { Uint64__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
          LitInt(0) <= next#0 && next#0 < 18446744073709551616
             ==> (m#0[$Box(next#0)] ==> Uint64__Order.__default.lt#canCall(key#0, next#0))
               && (Uint64__Order.__default.lt#canCall(key#0, next#0)
                   && Uint64__Order.__default.lt(key#0, next#0)
                 ==> (forall other#0: int :: 
                  { Uint64__Order.__default.lt(next#0, other#0) } 
                    { Uint64__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 18446744073709551616
                     ==> (other#0 != next#0 ==> Uint64__Order.__default.lt#canCall(key#0, other#0))
                       && (Uint64__Order.__default.lt#canCall(key#0, other#0)
                           && Uint64__Order.__default.lt(key#0, other#0)
                         ==> Uint64__Order.__default.lt#canCall(next#0, other#0)))))
         && ((exists next#0: int :: 
            { Uint64__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
            LitInt(0) <= next#0
               && next#0 < 18446744073709551616
               && 
              m#0[$Box(next#0)]
               && Uint64__Order.__default.lt(key#0, next#0)
               && (forall other#0: int :: 
                { Uint64__Order.__default.lt(next#0, other#0) } 
                  { Uint64__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                LitInt(0) <= other#0 && other#0 < 18446744073709551616
                   ==> 
                  m#0[$Box(other#0)]
                     && other#0 != next#0
                     && Uint64__Order.__default.lt(key#0, other#0)
                   ==> Uint64__Order.__default.lt(next#0, other#0)))
           ==> $let#43$canCall(m#0, key#0))
         && Uint64__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#0: int :: 
              { Uint64__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
              LitInt(0) <= next#0
                 && next#0 < 18446744073709551616
                 && 
                m#0[$Box(next#0)]
                 && Uint64__Order.__default.lt(key#0, next#0)
                 && (forall other#0: int :: 
                  { Uint64__Order.__default.lt(next#0, other#0) } 
                    { Uint64__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 18446744073709551616
                     ==> 
                    m#0[$Box(other#0)]
                       && other#0 != next#0
                       && Uint64__Order.__default.lt(key#0, other#0)
                     ==> Uint64__Order.__default.lt(next#0, other#0)))
             then (var next#1 := $let#43_next(m#0, key#0); #Options.Option.Some($Box(next#1)))
             else #Options.Option.None()));

// definition axiom for Uint64__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Uint64__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Uint64__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> (forall next#2: int :: 
          { Uint64__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
          LitInt(0) <= next#2 && next#2 < 18446744073709551616
             ==> (Lit(m#0)[$Box(next#2)]
                 ==> Uint64__Order.__default.lt#canCall(LitInt(key#0), next#2))
               && (Uint64__Order.__default.lt#canCall(LitInt(key#0), next#2)
                   && Uint64__Order.__default.lt(LitInt(key#0), next#2)
                 ==> (forall other#2: int :: 
                  { Uint64__Order.__default.lt(next#2, other#2) } 
                    { Uint64__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 18446744073709551616
                     ==> (other#2 != next#2
                         ==> Uint64__Order.__default.lt#canCall(LitInt(key#0), other#2))
                       && (Uint64__Order.__default.lt#canCall(LitInt(key#0), other#2)
                           && Uint64__Order.__default.lt(LitInt(key#0), other#2)
                         ==> Uint64__Order.__default.lt#canCall(next#2, other#2)))))
         && ((exists next#2: int :: 
            { Uint64__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
            LitInt(0) <= next#2
               && next#2 < 18446744073709551616
               && 
              Lit(m#0)[$Box(next#2)]
               && Uint64__Order.__default.lt(LitInt(key#0), next#2)
               && (forall other#2: int :: 
                { Uint64__Order.__default.lt(next#2, other#2) } 
                  { Uint64__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                LitInt(0) <= other#2 && other#2 < 18446744073709551616
                   ==> 
                  Lit(m#0)[$Box(other#2)]
                     && other#2 != next#2
                     && Uint64__Order.__default.lt(LitInt(key#0), other#2)
                   ==> Uint64__Order.__default.lt(next#2, other#2)))
           ==> $let#43$canCall(Lit(m#0), LitInt(key#0)))
         && Uint64__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#2: int :: 
              { Uint64__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
              LitInt(0) <= next#2
                 && next#2 < 18446744073709551616
                 && 
                Lit(m#0)[$Box(next#2)]
                 && Uint64__Order.__default.lt(LitInt(key#0), next#2)
                 && (forall other#2: int :: 
                  { Uint64__Order.__default.lt(next#2, other#2) } 
                    { Uint64__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 18446744073709551616
                     ==> 
                    Lit(m#0)[$Box(other#2)]
                       && other#2 != next#2
                       && Uint64__Order.__default.lt(LitInt(key#0), other#2)
                     ==> Uint64__Order.__default.lt(next#2, other#2)))
             then (var next#3 := $let#43_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#3)))
             else #Options.Option.None()));

// function declaration for Uint64_Order._default.MapSuccessor
function Uint64__Order.__default.MapSuccessor(Uint64_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Uint64__Order.__default.MapSuccessor#canCall(Uint64_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Uint64__Order.__default.MapSuccessor
axiom true
   ==> (forall Uint64_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Uint64__Order.__default.MapSuccessor(Uint64_Order._default.MapSuccessor$V, m#0, key#0) } 
    Uint64__Order.__default.MapSuccessor#canCall(Uint64_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> $Is(Uint64__Order.__default.MapSuccessor(Uint64_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint64())));

function Uint64__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Uint64__Order.__default.MapSuccessor
axiom (forall Uint64_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Uint64__Order.__default.MapSuccessor#requires(Uint64_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapSuccessor$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> Uint64__Order.__default.MapSuccessor#requires(Uint64_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Uint64__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Uint64_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Uint64__Order.__default.MapSuccessor(Uint64_Order._default.MapSuccessor$V, m#0, key#0) } 
    Uint64__Order.__default.MapSuccessor#canCall(Uint64_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> Uint64__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Uint64__Order.__default.MapSuccessor(Uint64_Order._default.MapSuccessor$V, m#0, key#0)
           == Uint64__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Uint64__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Uint64_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Uint64__Order.__default.MapSuccessor(Uint64_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Uint64__Order.__default.MapSuccessor#canCall(Uint64_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> Uint64__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Uint64__Order.__default.MapSuccessor(Uint64_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Uint64__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Uint64_Order._default.SeqSuccessor
function Uint64__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Uint64__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Uint64__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Uint64__Order.__default.SeqSuccessor(m#0, key#0) } 
    Uint64__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> $Is(Uint64__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint64())));

function Uint64__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Uint64__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Uint64__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> Uint64__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Uint64__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Uint64__Order.__default.SeqSuccessor(m#0, key#0) } 
    Uint64__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> Uint64__Order.__default.SetSuccessor#canCall((lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.uint64()) && Seq#Contains(m#0, $y#0)), 
          key#0)
         && Uint64__Order.__default.SeqSuccessor(m#0, key#0)
           == Uint64__Order.__default.SetSuccessor((lambda $y#1: Box :: 
              $IsBox($y#1, Tclass.NativeTypes.uint64()) && Seq#Contains(m#0, $y#1)), 
            key#0));

// definition axiom for Uint64__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint64__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Uint64__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616)
       ==> Uint64__Order.__default.SetSuccessor#canCall((lambda $y#2: Box :: 
            $IsBox($y#2, Tclass.NativeTypes.uint64()) && Seq#Contains(m#0, $y#2)), 
          LitInt(key#0))
         && Uint64__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Uint64__Order.__default.SetSuccessor((lambda $y#3: Box :: 
              $IsBox($y#3, Tclass.NativeTypes.uint64()) && Seq#Contains(m#0, $y#3)), 
            LitInt(key#0)));

// function declaration for Uint64_Order._default.SortedSeqForMap
function Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Uint64__Order.__default.SortedSeqForMap#canCall(Uint64_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Uint64_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Uint64_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Uint64__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Uint64_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Uint64__Order.__default.SortedSeqForMap#canCall(Uint64_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V)))
       ==> true);

function Uint64__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Uint64__Order.__default.SortedSeqForMap
axiom (forall Uint64_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint64__Order.__default.SortedSeqForMap#requires(Uint64_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V))
     ==> Uint64__Order.__default.SortedSeqForMap#requires(Uint64_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Uint64__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Uint64_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Uint64__Order.__default.SortedSeqForMap#canCall(Uint64_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.uint64(), 
            Uint64_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Uint64__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint64(), 
                Uint64_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Uint64__Order.__default.IsStrictlySorted(StartFuel_Uint64_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint64(), 
                  Uint64_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            (i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                 ==> 
                i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              (i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                   ==> 
                  i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
           ==> (forall key#0: int :: 
            { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
            LitInt(0) <= key#0 && key#0 < 18446744073709551616
               ==> 
              Map#Domain(m#0)[$Box(key#0)]
               ==> (forall i#1: int :: 
                { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                (i#1 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                         == key#0
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)))))
         && Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Uint64__Order.__default.IsStrictlySorted(StartFuel_Uint64_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint64(), 
                    Uint64_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall key#0: int :: 
              { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
              LitInt(0) <= key#0 && key#0 < 18446744073709551616
                 ==> 
                Map#Domain(m#0)[$Box(key#0)]
                 ==> (exists i#1: int :: 
                  { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                  LitInt(0) <= i#1
                     && i#1 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                       == key#0
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#0)]))));

// definition axiom for Uint64__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Uint64_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Uint64__Order.__default.SortedSeqForMap#canCall(Uint64_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.uint64(), Uint64_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.uint64(), 
            Uint64_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Uint64__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint64(), 
                Uint64_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Uint64__Order.__default.IsStrictlySorted(StartFuel_Uint64_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint64(), 
                  Uint64_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            (i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                 ==> 
                i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              (i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                   ==> 
                  i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
           ==> (forall key#1: int :: 
            { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
            LitInt(0) <= key#1 && key#1 < 18446744073709551616
               ==> 
              Map#Domain(m#0)[$Box(key#1)]
               ==> (forall i#3: int :: 
                { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                (i#3 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                         == key#1
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))))
         && Uint64__Order.__default.SortedSeqForMap(Uint64_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Uint64__Order.__default.IsStrictlySorted(StartFuel_Uint64_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint64(), 
                    Uint64_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall key#1: int :: 
              { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
              LitInt(0) <= key#1 && key#1 < 18446744073709551616
                 ==> 
                Map#Domain(m#0)[$Box(key#1)]
                 ==> (exists i#3: int :: 
                  { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                  LitInt(0) <= i#3
                     && i#3 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                       == key#1
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#1)]))));

// function declaration for Uint64_Order._default.minimum
function Uint64__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Uint64__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.minimum($LS($ly), s#0) } 
  Uint64__Order.__default.minimum($LS($ly), s#0)
     == Uint64__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Uint64__Order.__default.minimum($ly, s#0)
     == Uint64__Order.__default.minimum($LZ, s#0));

// consequence axiom for Uint64__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint64__Order.__default.minimum($ly, s#0) } 
    Uint64__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.uint64())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Uint64__Order.__default.minimum($ly, s#0))]
         && (forall y#0: int :: 
          { Uint64__Order.__default.lte(Uint64__Order.__default.minimum($ly, s#0), y#0) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 18446744073709551616 && s#0[$Box(y#0)]
             ==> Uint64__Order.__default.lte(Uint64__Order.__default.minimum($ly, s#0), y#0))
         && 
        LitInt(0) <= Uint64__Order.__default.minimum($ly, s#0)
         && Uint64__Order.__default.minimum($ly, s#0) < 18446744073709551616);

function Uint64__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint64__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Uint64__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#46_a(s: Set Box) : int;

function $let#46$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#46_a(s) } 
  $let#46$canCall(s)
     ==> LitInt(0) <= $let#46_a(s)
       && $let#46_a(s) < 18446744073709551616
       && s[$Box($let#46_a(s))]);

// definition axiom for Uint64__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Uint64__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Uint64__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#46$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#46_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Uint64__Order.__default.minimum#canCall(s'#0)
               && (var m'#0 := Uint64__Order.__default.minimum($ly, s'#0); 
                Uint64__Order.__default.lt#canCall($let#46_a(s#0), m'#0)))
         && Uint64__Order.__default.minimum($LS($ly), s#0)
           == (var a#0 := $let#46_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Uint64__Order.__default.minimum($ly, s'#1); 
                  (if Uint64__Order.__default.lt(a#0, m'#1) then a#0 else m'#1))))));

// definition axiom for Uint64__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Uint64__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Uint64__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#46$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#46_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Uint64__Order.__default.minimum#canCall(s'#2)
               && (var m'#2 := Uint64__Order.__default.minimum($LS($ly), s'#2); 
                Uint64__Order.__default.lt#canCall($let#46_a(Lit(s#0)), m'#2)))
         && Uint64__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#1 := $let#46_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Uint64__Order.__default.minimum($LS($ly), s'#3); 
                  (if Uint64__Order.__default.lt(a#1, m'#3) then a#1 else m'#3))))));

// function declaration for Uint64_Order._default.minimumOpt
function Uint64__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Uint64__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.minimumOpt($LS($ly), s#0) } 
  Uint64__Order.__default.minimumOpt($LS($ly), s#0)
     == Uint64__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Uint64__Order.__default.minimumOpt($ly, s#0)
     == Uint64__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Uint64__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint64__Order.__default.minimumOpt($ly, s#0) } 
    Uint64__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
       ==> (Options.Option.Some_q(Uint64__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Uint64__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Uint64__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Uint64__Order.__default.lte($Unbox(Options.Option.value(Uint64__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 18446744073709551616 && s#0[$Box(y#0)]
               ==> Uint64__Order.__default.lte($Unbox(Options.Option.value(Uint64__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0)))
         && (Options.Option.None_q(Uint64__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Uint64__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint64())));

function Uint64__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint64__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Uint64__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint64__Order.__default.minimumOpt($LS($ly), s#0) } 
    Uint64__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint64__Order.__default.minimum#canCall(s#0))
         && Uint64__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint64__Order.__default.minimum(StartFuel_Uint64_Order._default.minimum, s#0)))));

// definition axiom for Uint64__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Uint64__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Uint64__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint64__Order.__default.minimum#canCall(Lit(s#0)))
         && Uint64__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint64__Order.__default.minimum(StartFuel_Uint64_Order._default.minimum, Lit(s#0))))));

// function declaration for Uint64_Order._default.maximum
function Uint64__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Uint64__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.maximum($LS($ly), s#0) } 
  Uint64__Order.__default.maximum($LS($ly), s#0)
     == Uint64__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Uint64__Order.__default.maximum($ly, s#0)
     == Uint64__Order.__default.maximum($LZ, s#0));

// consequence axiom for Uint64__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint64__Order.__default.maximum($ly, s#0) } 
    Uint64__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.uint64())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Uint64__Order.__default.maximum($ly, s#0))]
         && (forall y#0: int :: 
          { Uint64__Order.__default.lte(y#0, Uint64__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 18446744073709551616 && s#0[$Box(y#0)]
             ==> Uint64__Order.__default.lte(y#0, Uint64__Order.__default.maximum($ly, s#0)))
         && 
        LitInt(0) <= Uint64__Order.__default.maximum($ly, s#0)
         && Uint64__Order.__default.maximum($ly, s#0) < 18446744073709551616);

function Uint64__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint64__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Uint64__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#49_a(s: Set Box) : int;

function $let#49$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#49_a(s) } 
  $let#49$canCall(s)
     ==> LitInt(0) <= $let#49_a(s)
       && $let#49_a(s) < 18446744073709551616
       && s[$Box($let#49_a(s))]);

// definition axiom for Uint64__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Uint64__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Uint64__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#49$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#49_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Uint64__Order.__default.maximum#canCall(s'#0)
               && (var m'#0 := Uint64__Order.__default.maximum($ly, s'#0); 
                Uint64__Order.__default.lt#canCall(m'#0, $let#49_a(s#0))))
         && Uint64__Order.__default.maximum($LS($ly), s#0)
           == (var a#0 := $let#49_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Uint64__Order.__default.maximum($ly, s'#1); 
                  (if Uint64__Order.__default.lt(m'#1, a#0) then a#0 else m'#1))))));

// definition axiom for Uint64__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Uint64__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Uint64__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#49$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#49_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Uint64__Order.__default.maximum#canCall(s'#2)
               && (var m'#2 := Uint64__Order.__default.maximum($LS($ly), s'#2); 
                Uint64__Order.__default.lt#canCall(m'#2, $let#49_a(Lit(s#0)))))
         && Uint64__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#1 := $let#49_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Uint64__Order.__default.maximum($LS($ly), s'#3); 
                  (if Uint64__Order.__default.lt(m'#3, a#1) then a#1 else m'#3))))));

// function declaration for Uint64_Order._default.maximumOpt
function Uint64__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Uint64__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.maximumOpt($LS($ly), s#0) } 
  Uint64__Order.__default.maximumOpt($LS($ly), s#0)
     == Uint64__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Uint64__Order.__default.maximumOpt($ly, s#0)
     == Uint64__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Uint64__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint64__Order.__default.maximumOpt($ly, s#0) } 
    Uint64__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
       ==> (Options.Option.Some_q(Uint64__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Uint64__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Uint64__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Uint64__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Uint64__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 18446744073709551616 && s#0[$Box(y#0)]
               ==> Uint64__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Uint64__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Uint64__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Uint64__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint64())));

function Uint64__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint64__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint64__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Uint64__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint64__Order.__default.maximumOpt($LS($ly), s#0) } 
    Uint64__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint64__Order.__default.maximum#canCall(s#0))
         && Uint64__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint64__Order.__default.maximum(StartFuel_Uint64_Order._default.maximum, s#0)))));

// definition axiom for Uint64__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Uint64__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Uint64__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint64__Order.__default.maximum#canCall(Lit(s#0)))
         && Uint64__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint64__Order.__default.maximum(StartFuel_Uint64_Order._default.maximum, Lit(s#0))))));

// function declaration for Uint64_Order._default.lt
function Uint64__Order.__default.lt(a#0: int, b#0: int) : bool;

function Uint64__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint64__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint64__Order.__default.lt(a#0, b#0) } 
    Uint64__Order.__default.lt#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> true);

function Uint64__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Uint64__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Uint64__Order.__default.lt#requires(a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> Uint64__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Uint64__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint64__Order.__default.lt(a#0, b#0) } 
    Uint64__Order.__default.lt#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.lte#canCall(a#0, b#0)
         && Uint64__Order.__default.lt(a#0, b#0)
           == (Uint64__Order.__default.lte(a#0, b#0) && a#0 != b#0));

// definition axiom for Uint64__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint64__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    Uint64__Order.__default.lt#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint64__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == Lit(Uint64__Order.__default.lte(LitInt(a#0), LitInt(b#0)) && a#0 != b#0));

// function declaration for Uint64_Order._default.Min
function Uint64__Order.__default.Min(a#0: int, b#0: int) : int;

function Uint64__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint64__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint64__Order.__default.Min(a#0, b#0) } 
    Uint64__Order.__default.Min#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> LitInt(0) <= Uint64__Order.__default.Min(a#0, b#0)
         && Uint64__Order.__default.Min(a#0, b#0) < 18446744073709551616);

function Uint64__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Uint64__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Uint64__Order.__default.Min#requires(a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> Uint64__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Uint64__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint64__Order.__default.Min(a#0, b#0) } 
    Uint64__Order.__default.Min#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.lte#canCall(a#0, b#0)
         && Uint64__Order.__default.Min(a#0, b#0)
           == (if Uint64__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Uint64__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint64__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    Uint64__Order.__default.Min#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint64__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Uint64__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then a#0 else b#0));

// function declaration for Uint64_Order._default.Max
function Uint64__Order.__default.Max(a#0: int, b#0: int) : int;

function Uint64__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint64__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint64__Order.__default.Max(a#0, b#0) } 
    Uint64__Order.__default.Max#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> LitInt(0) <= Uint64__Order.__default.Max(a#0, b#0)
         && Uint64__Order.__default.Max(a#0, b#0) < 18446744073709551616);

function Uint64__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Uint64__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Uint64__Order.__default.Max#requires(a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> Uint64__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Uint64__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint64__Order.__default.Max(a#0, b#0) } 
    Uint64__Order.__default.Max#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.lte#canCall(a#0, b#0)
         && Uint64__Order.__default.Max(a#0, b#0)
           == (if Uint64__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Uint64__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint64__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    Uint64__Order.__default.Max#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> Uint64__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint64__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Uint64__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then b#0 else a#0));

// function declaration for Uint64_Order._default.IsSorted
function Uint64__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Uint64__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint64__Order.__default.IsSorted($LS($ly), run#0) } 
  Uint64__Order.__default.IsSorted($LS($ly), run#0)
     == Uint64__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint64__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Uint64__Order.__default.IsSorted($ly, run#0)
     == Uint64__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Uint64__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint64__Order.__default.IsSorted($ly, run#0) } 
    Uint64__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Uint64__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Uint64__Order.__default.IsSorted($ly, run#0)));

function Uint64__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Uint64__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint64__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Uint64__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint64__Order.__default.IsSorted($LS($ly), run#0) } 
    Uint64__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Uint64__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Uint64__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 <= j#0 && j#0 < Seq#Length(run#0)
               ==> Uint64__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Uint64__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Uint64__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Uint64__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Uint64__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Uint64__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 <= j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Uint64__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Uint64_Order._default.IsStrictlySortedInternal
function Uint64__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Uint64__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Uint64__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Uint64__Order.__default.IsStrictlySortedInternal(run#0) } 
    Uint64__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> true);

function Uint64__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Uint64__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Uint64__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Uint64__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Uint64__Order.__default.IsStrictlySortedInternal(run#0) } 
    Uint64__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Uint64__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Uint64__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(run#0)
               ==> Uint64__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Uint64__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Uint64__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Uint64__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Uint64__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Uint64__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Uint64__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Uint64_Order._default.IsStrictlySorted
function Uint64__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Uint64__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint64__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Uint64__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Uint64__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint64__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Uint64__Order.__default.IsStrictlySorted($ly, run#0)
     == Uint64__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Uint64__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint64__Order.__default.IsStrictlySorted($ly, run#0) } 
    Uint64__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Uint64__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Uint64__Order.__default.IsStrictlySorted($ly, run#0))
         && (Uint64__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Uint64__Order.__default.IsSorted(StartFuel_Uint64_Order._default.IsSorted, run#0)));

function Uint64__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Uint64__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint64__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> Uint64__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Uint64__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint64__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Uint64__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> Uint64__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Uint64__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#0 := Uint64__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#0 then b#0 else b#0)));

// definition axiom for Uint64__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Uint64__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Uint64__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> Uint64__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Uint64__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#1 := Lit(Uint64__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#1 then b#1 else b#1)));

const unique class.Sets.__default: ClassName;

function Tclass.Sets.__default() : Ty;

// Tclass.Sets.__default Tag
axiom Tag(Tclass.Sets.__default()) == Tagclass.Sets.__default;

const unique Tagclass.Sets.__default: TyTag;

// Box/unbox axiom for Tclass.Sets.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sets.__default()) } 
  $IsBox(bx, Tclass.Sets.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Sets.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sets.__default()) } 
  $Is($o, Tclass.Sets.__default())
     <==> $o == null || dtype($o) == Tclass.Sets.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sets.__default(), $h) } 
  $IsAlloc($o, Tclass.Sets.__default(), $h) <==> $o == null || read($h, $o, alloc));

// function declaration for Sets._default.SetRange
function Sets.__default.SetRange(n#0: int) : Set Box;

function Sets.__default.SetRange#canCall(n#0: int) : bool;

// consequence axiom for Sets.__default.SetRange
axiom true
   ==> (forall n#0: int :: 
    { Sets.__default.SetRange(n#0) } 
    true ==> $Is(Sets.__default.SetRange(n#0), TSet(TInt)));

function Sets.__default.SetRange#requires(int) : bool;

// #requires axiom for Sets.__default.SetRange
axiom (forall n#0: int :: 
  { Sets.__default.SetRange#requires(n#0) } 
  Sets.__default.SetRange#requires(n#0) == true);

// definition axiom for Sets.__default.SetRange(revealed)
axiom true
   ==> (forall n#0: int :: 
    { Sets.__default.SetRange(n#0) } 
    true
       ==> Sets.__default.SetRange(n#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, TInt) && LitInt(0) <= $Unbox($y#0): int && $Unbox($y#0): int < n#0));

// definition axiom for Sets.__default.SetRange for all literals(revealed)
axiom true
   ==> (forall n#0: int :: 
    {:weight 3} { Sets.__default.SetRange(LitInt(n#0)) } 
    true
       ==> Sets.__default.SetRange(LitInt(n#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, TInt) && LitInt(0) <= $Unbox($y#1): int && $Unbox($y#1): int < n#0));

const unique class.BucketWeights.__default: ClassName;

function Tclass.BucketWeights.__default() : Ty;

// Tclass.BucketWeights.__default Tag
axiom Tag(Tclass.BucketWeights.__default()) == Tagclass.BucketWeights.__default;

const unique Tagclass.BucketWeights.__default: TyTag;

// Box/unbox axiom for Tclass.BucketWeights.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketWeights.__default()) } 
  $IsBox(bx, Tclass.BucketWeights.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BucketWeights.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BucketWeights.__default()) } 
  $Is($o, Tclass.BucketWeights.__default())
     <==> $o == null || dtype($o) == Tclass.BucketWeights.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BucketWeights.__default(), $h) } 
  $IsAlloc($o, Tclass.BucketWeights.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BucketWeights._default.WeightKey
function BucketWeights.__default.WeightKey(key#0: Seq Box) : int;

function BucketWeights.__default.WeightKey#canCall(key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightKey
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.WeightKey(key#0) } 
    BucketWeights.__default.WeightKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKey(key#0) >= LitInt(0)
         && LitInt(0) <= BucketWeights.__default.WeightKey(key#0));

function BucketWeights.__default.WeightKey#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKey
axiom (forall key#0: Seq Box :: 
  { BucketWeights.__default.WeightKey#requires(key#0) } 
  $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.WeightKey#requires(key#0) == true);

// definition axiom for BucketWeights.__default.WeightKey(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.WeightKey(key#0) } 
    BucketWeights.__default.WeightKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKey(key#0) == 4 + Seq#Length(key#0));

// definition axiom for BucketWeights.__default.WeightKey for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightKey(Lit(key#0)) } 
    BucketWeights.__default.WeightKey#canCall(Lit(key#0))
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKey(Lit(key#0)) == 4 + Seq#Length(Lit(key#0)));

// function declaration for BucketWeights._default.WeightMessage
function BucketWeights.__default.WeightMessage(msg#0: DatatypeType) : int;

function BucketWeights.__default.WeightMessage#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for BucketWeights.__default.WeightMessage
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { BucketWeights.__default.WeightMessage(msg#0) } 
    BucketWeights.__default.WeightMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> BucketWeights.__default.WeightMessage(msg#0) >= LitInt(0)
         && LitInt(0) <= BucketWeights.__default.WeightMessage(msg#0));

function BucketWeights.__default.WeightMessage#requires(DatatypeType) : bool;

// #requires axiom for BucketWeights.__default.WeightMessage
axiom (forall msg#0: DatatypeType :: 
  { BucketWeights.__default.WeightMessage#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketWeights.__default.WeightMessage#requires(msg#0) == true);

// definition axiom for BucketWeights.__default.WeightMessage(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { BucketWeights.__default.WeightMessage(msg#0) } 
    BucketWeights.__default.WeightMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> (ValueMessage.Message.Define_q(msg#0)
           ==> (var value#0 := ValueMessage.Message.value(msg#0); 
            ValueType.__default.Len#canCall(value#0)))
         && BucketWeights.__default.WeightMessage(msg#0)
           == (if ValueMessage.Message.Define_q(msg#0)
             then (var value#1 := ValueMessage.Message.value(msg#0); 
              4 + ValueType.__default.Len(value#1))
             else (var delta#1 := ValueMessage.Message.delta(msg#0); LitInt(0))));

// definition axiom for BucketWeights.__default.WeightMessage for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { BucketWeights.__default.WeightMessage(Lit(msg#0)) } 
    BucketWeights.__default.WeightMessage#canCall(Lit(msg#0))
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> (Lit(ValueMessage.Message.Define_q(Lit(msg#0)))
           ==> (var value#2 := Lit(ValueMessage.Message.value(Lit(msg#0))); 
            ValueType.__default.Len#canCall(value#2)))
         && BucketWeights.__default.WeightMessage(Lit(msg#0))
           == (if ValueMessage.Message.Define_q(Lit(msg#0))
             then (var value#3 := Lit(ValueMessage.Message.value(Lit(msg#0))); 
              LitInt(4 + ValueType.__default.Len(value#3)))
             else (var delta#3 := Lit(ValueMessage.Message.delta(Lit(msg#0))); LitInt(0))));

// function declaration for BucketWeights._default.WeightKeyUint64
function BucketWeights.__default.WeightKeyUint64(key#0: Seq Box) : int;

function BucketWeights.__default.WeightKeyUint64#canCall(key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightKeyUint64
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.WeightKeyUint64(key#0) } 
    BucketWeights.__default.WeightKeyUint64#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKeyUint64(key#0)
           == BucketWeights.__default.WeightKey(key#0)
         && 
        LitInt(0) <= BucketWeights.__default.WeightKeyUint64(key#0)
         && BucketWeights.__default.WeightKeyUint64(key#0) < 18446744073709551616);

function BucketWeights.__default.WeightKeyUint64#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKeyUint64
axiom (forall key#0: Seq Box :: 
  { BucketWeights.__default.WeightKeyUint64#requires(key#0) } 
  $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.WeightKeyUint64#requires(key#0) == true);

// definition axiom for BucketWeights.__default.WeightKeyUint64(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.WeightKeyUint64(key#0) } 
    BucketWeights.__default.WeightKeyUint64#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKeyUint64(key#0) == 4 + Seq#Length(key#0));

// definition axiom for BucketWeights.__default.WeightKeyUint64 for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightKeyUint64(Lit(key#0)) } 
    BucketWeights.__default.WeightKeyUint64#canCall(Lit(key#0))
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKeyUint64(Lit(key#0))
         == 4 + Seq#Length(Lit(key#0)));

// function declaration for BucketWeights._default.WeightMessageUint64
function BucketWeights.__default.WeightMessageUint64(msg#0: DatatypeType) : int;

function BucketWeights.__default.WeightMessageUint64#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for BucketWeights.__default.WeightMessageUint64
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { BucketWeights.__default.WeightMessageUint64(msg#0) } 
    BucketWeights.__default.WeightMessageUint64#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> BucketWeights.__default.WeightMessageUint64(msg#0)
           == BucketWeights.__default.WeightMessage(msg#0)
         && 
        LitInt(0) <= BucketWeights.__default.WeightMessageUint64(msg#0)
         && BucketWeights.__default.WeightMessageUint64(msg#0) < 18446744073709551616);

function BucketWeights.__default.WeightMessageUint64#requires(DatatypeType) : bool;

// #requires axiom for BucketWeights.__default.WeightMessageUint64
axiom (forall msg#0: DatatypeType :: 
  { BucketWeights.__default.WeightMessageUint64#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketWeights.__default.WeightMessageUint64#requires(msg#0) == true);

// definition axiom for BucketWeights.__default.WeightMessageUint64(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { BucketWeights.__default.WeightMessageUint64(msg#0) } 
    BucketWeights.__default.WeightMessageUint64#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> BucketWeights.__default.WeightMessageUint64(msg#0)
         == (if ValueMessage.Message.Define_q(msg#0)
           then (var value#1 := ValueMessage.Message.value(msg#0); 4 + Seq#Length(value#1))
           else (var delta#1 := ValueMessage.Message.delta(msg#0); LitInt(0))));

// definition axiom for BucketWeights.__default.WeightMessageUint64 for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { BucketWeights.__default.WeightMessageUint64(Lit(msg#0)) } 
    BucketWeights.__default.WeightMessageUint64#canCall(Lit(msg#0))
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> BucketWeights.__default.WeightMessageUint64(Lit(msg#0))
         == (if ValueMessage.Message.Define_q(Lit(msg#0))
           then (var value#3 := Lit(ValueMessage.Message.value(Lit(msg#0))); 
            4 + Seq#Length(value#3))
           else (var delta#3 := Lit(ValueMessage.Message.delta(Lit(msg#0))); LitInt(0))));

// function declaration for BucketWeights._default.WeightKeyMultiset
function BucketWeights.__default.WeightKeyMultiset($ly: LayerType, keys#0: MultiSet Box) : int;

function BucketWeights.__default.WeightKeyMultiset#canCall(keys#0: MultiSet Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: MultiSet Box :: 
  { BucketWeights.__default.WeightKeyMultiset($LS($ly), keys#0) } 
  BucketWeights.__default.WeightKeyMultiset($LS($ly), keys#0)
     == BucketWeights.__default.WeightKeyMultiset($ly, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: MultiSet Box :: 
  { BucketWeights.__default.WeightKeyMultiset(AsFuelBottom($ly), keys#0) } 
  BucketWeights.__default.WeightKeyMultiset($ly, keys#0)
     == BucketWeights.__default.WeightKeyMultiset($LZ, keys#0));

// consequence axiom for BucketWeights.__default.WeightKeyMultiset
axiom true
   ==> (forall $ly: LayerType, keys#0: MultiSet Box :: 
    { BucketWeights.__default.WeightKeyMultiset($ly, keys#0) } 
    BucketWeights.__default.WeightKeyMultiset#canCall(keys#0)
         || $Is(keys#0, TMultiSet(Tclass.KeyType.Key()))
       ==> (MultiSet#Card(keys#0) == LitInt(0)
           ==> BucketWeights.__default.WeightKeyMultiset($ly, keys#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightKeyMultiset($ly, keys#0));

function BucketWeights.__default.WeightKeyMultiset#requires(LayerType, MultiSet Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKeyMultiset
axiom (forall $ly: LayerType, $Heap: Heap, keys#0: MultiSet Box :: 
  { BucketWeights.__default.WeightKeyMultiset#requires($ly, keys#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(keys#0, TMultiSet(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.WeightKeyMultiset#requires($ly, keys#0) == true);

function BucketWeights.__default.WeightKey#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Apply1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0) } 
  Apply1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0)
     == $Box(BucketWeights.__default.WeightKey($Unbox($fh$0x#0): Seq Box)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Requires1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0) } 
  Requires1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0)
     == BucketWeights.__default.WeightKey#requires($Unbox($fh$0x#0): Seq Box));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: 
  { Reads1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0)[$bx] } 
  Reads1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: Seq Box :: 
  { BucketWeights.__default.WeightKey($fh$0x#0), $IsGoodHeap($heap) } 
  BucketWeights.__default.WeightKey($fh$0x#0)
     == $Unbox(Apply1(Tclass.KeyType.Key(), 
        Tclass._System.nat(), 
        $heap, 
        BucketWeights.__default.WeightKey#Handle(), 
        $Box($fh$0x#0))): int);

function Multisets.__default.AddNat#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Apply2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1) } 
  Apply2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)
     == $Box(Multisets.__default.AddNat($Unbox($fh$0x#0): int, $Unbox($fh$0x#1): int)));

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Requires2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1) } 
  Requires2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)
     == Multisets.__default.AddNat#requires($Unbox($fh$0x#0): int, $Unbox($fh$0x#1): int));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Reads2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)[$bx] } 
  Reads2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: int, $fh$0x#1: int :: 
  { Multisets.__default.AddNat($fh$0x#0, $fh$0x#1), $IsGoodHeap($heap) } 
  Multisets.__default.AddNat($fh$0x#0, $fh$0x#1)
     == $Unbox(Apply2(Tclass._System.nat(), 
        Tclass._System.nat(), 
        Tclass._System.nat(), 
        $heap, 
        Multisets.__default.AddNat#Handle(), 
        $Box($fh$0x#0), 
        $Box($fh$0x#1))): int);

// definition axiom for BucketWeights.__default.WeightKeyMultiset(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, keys#0: MultiSet Box :: 
    { BucketWeights.__default.WeightKeyMultiset($LS($ly), keys#0), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightKeyMultiset#canCall(keys#0)
         || ($IsGoodHeap($Heap) && $Is(keys#0, TMultiSet(Tclass.KeyType.Key())))
       ==> Multisets.__default.Apply#canCall(Tclass.KeyType.Key(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightKey#Handle(), 
          keys#0)
         && (var weights#0 := Multisets.__default.Apply(Tclass.KeyType.Key(), 
              Tclass._System.nat(), 
              StartFuel_Multisets._default.Apply, 
              $Heap, 
              BucketWeights.__default.WeightKey#Handle(), 
              keys#0); 
          Multisets.__default.FoldSimple#canCall(Tclass._System.nat(), 
            $Box(LitInt(0)), 
            Multisets.__default.AddNat#Handle(), 
            weights#0))
         && BucketWeights.__default.WeightKeyMultiset($LS($ly), keys#0)
           == (var weights#0 := Multisets.__default.Apply(Tclass.KeyType.Key(), 
                Tclass._System.nat(), 
                StartFuel_Multisets._default.Apply, 
                $Heap, 
                BucketWeights.__default.WeightKey#Handle(), 
                keys#0); 
            $Unbox(Multisets.__default.FoldSimple(Tclass._System.nat(), 
                $Box(LitInt(0)), 
                Multisets.__default.AddNat#Handle(), 
                weights#0)): int));

// definition axiom for BucketWeights.__default.WeightKeyMultiset for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, keys#0: MultiSet Box :: 
    {:weight 3} { BucketWeights.__default.WeightKeyMultiset($LS($ly), Lit(keys#0)), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightKeyMultiset#canCall(Lit(keys#0))
         || ($IsGoodHeap($Heap) && $Is(keys#0, TMultiSet(Tclass.KeyType.Key())))
       ==> Multisets.__default.Apply#canCall(Tclass.KeyType.Key(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightKey#Handle(), 
          Lit(keys#0))
         && (var weights#1 := Multisets.__default.Apply(Tclass.KeyType.Key(), 
              Tclass._System.nat(), 
              StartFuel_Multisets._default.Apply, 
              $Heap, 
              BucketWeights.__default.WeightKey#Handle(), 
              Lit(keys#0)); 
          Multisets.__default.FoldSimple#canCall(Tclass._System.nat(), 
            $Box(LitInt(0)), 
            Multisets.__default.AddNat#Handle(), 
            weights#1))
         && BucketWeights.__default.WeightKeyMultiset($LS($ly), Lit(keys#0))
           == (var weights#1 := Multisets.__default.Apply(Tclass.KeyType.Key(), 
                Tclass._System.nat(), 
                StartFuel_Multisets._default.Apply, 
                $Heap, 
                BucketWeights.__default.WeightKey#Handle(), 
                Lit(keys#0)); 
            $Unbox(Multisets.__default.FoldSimple(Tclass._System.nat(), 
                $Box(LitInt(0)), 
                Multisets.__default.AddNat#Handle(), 
                weights#1)): int));

// function declaration for BucketWeights._default.WeightKeySeq
function BucketWeights.__default.WeightKeySeq($ly: LayerType, keys#0: Seq Box) : int;

function BucketWeights.__default.WeightKeySeq#canCall(keys#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box :: 
  { BucketWeights.__default.WeightKeySeq($LS($ly), keys#0) } 
  BucketWeights.__default.WeightKeySeq($LS($ly), keys#0)
     == BucketWeights.__default.WeightKeySeq($ly, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box :: 
  { BucketWeights.__default.WeightKeySeq(AsFuelBottom($ly), keys#0) } 
  BucketWeights.__default.WeightKeySeq($ly, keys#0)
     == BucketWeights.__default.WeightKeySeq($LZ, keys#0));

// consequence axiom for BucketWeights.__default.WeightKeySeq
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box :: 
    { BucketWeights.__default.WeightKeySeq($ly, keys#0) } 
    BucketWeights.__default.WeightKeySeq#canCall(keys#0)
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> LitInt(0) <= BucketWeights.__default.WeightKeySeq($ly, keys#0));

function BucketWeights.__default.WeightKeySeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKeySeq
axiom (forall $ly: LayerType, $Heap: Heap, keys#0: Seq Box :: 
  { BucketWeights.__default.WeightKeySeq#requires($ly, keys#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(keys#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.WeightKeySeq#requires($ly, keys#0) == true);

// definition axiom for BucketWeights.__default.WeightKeySeq(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, keys#0: Seq Box :: 
    { BucketWeights.__default.WeightKeySeq($LS($ly), keys#0), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightKeySeq#canCall(keys#0)
         || ($IsGoodHeap($Heap) && $Is(keys#0, TSeq(Tclass.KeyType.Key())))
       ==> Sequences.__default.ApplyOpaque#canCall(Tclass.KeyType.Key(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightKey#Handle(), 
          keys#0)
         && (var weights#0 := Sequences.__default.ApplyOpaque(Tclass.KeyType.Key(), 
              Tclass._System.nat(), 
              StartFuel_Sequences._default.ApplyOpaque, 
              $Heap, 
              BucketWeights.__default.WeightKey#Handle(), 
              keys#0); 
          Sequences.__default.FoldFromRight#canCall(Tclass._System.nat(), 
            Tclass._System.nat(), 
            Multisets.__default.AddNat#Handle(), 
            $Box(LitInt(0)), 
            weights#0))
         && BucketWeights.__default.WeightKeySeq($LS($ly), keys#0)
           == (var weights#0 := Sequences.__default.ApplyOpaque(Tclass.KeyType.Key(), 
                Tclass._System.nat(), 
                StartFuel_Sequences._default.ApplyOpaque, 
                $Heap, 
                BucketWeights.__default.WeightKey#Handle(), 
                keys#0); 
            $Unbox(Sequences.__default.FoldFromRight(Tclass._System.nat(), 
                Tclass._System.nat(), 
                $LS($LZ), 
                Multisets.__default.AddNat#Handle(), 
                $Box(LitInt(0)), 
                weights#0)): int));

// definition axiom for BucketWeights.__default.WeightKeySeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, keys#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightKeySeq($LS($ly), Lit(keys#0)), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightKeySeq#canCall(Lit(keys#0))
         || ($IsGoodHeap($Heap) && $Is(keys#0, TSeq(Tclass.KeyType.Key())))
       ==> Sequences.__default.ApplyOpaque#canCall(Tclass.KeyType.Key(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightKey#Handle(), 
          Lit(keys#0))
         && (var weights#1 := Sequences.__default.ApplyOpaque(Tclass.KeyType.Key(), 
              Tclass._System.nat(), 
              StartFuel_Sequences._default.ApplyOpaque, 
              $Heap, 
              BucketWeights.__default.WeightKey#Handle(), 
              Lit(keys#0)); 
          Sequences.__default.FoldFromRight#canCall(Tclass._System.nat(), 
            Tclass._System.nat(), 
            Multisets.__default.AddNat#Handle(), 
            $Box(LitInt(0)), 
            weights#1))
         && BucketWeights.__default.WeightKeySeq($LS($ly), Lit(keys#0))
           == (var weights#1 := Sequences.__default.ApplyOpaque(Tclass.KeyType.Key(), 
                Tclass._System.nat(), 
                StartFuel_Sequences._default.ApplyOpaque, 
                $Heap, 
                BucketWeights.__default.WeightKey#Handle(), 
                Lit(keys#0)); 
            $Unbox(Sequences.__default.FoldFromRight(Tclass._System.nat(), 
                Tclass._System.nat(), 
                $LS($LZ), 
                Multisets.__default.AddNat#Handle(), 
                $Box(LitInt(0)), 
                weights#1)): int));

// function declaration for BucketWeights._default.WeightMessageMultiset
function BucketWeights.__default.WeightMessageMultiset($ly: LayerType, msgs#0: MultiSet Box) : int;

function BucketWeights.__default.WeightMessageMultiset#canCall(msgs#0: MultiSet Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: MultiSet Box :: 
  { BucketWeights.__default.WeightMessageMultiset($LS($ly), msgs#0) } 
  BucketWeights.__default.WeightMessageMultiset($LS($ly), msgs#0)
     == BucketWeights.__default.WeightMessageMultiset($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: MultiSet Box :: 
  { BucketWeights.__default.WeightMessageMultiset(AsFuelBottom($ly), msgs#0) } 
  BucketWeights.__default.WeightMessageMultiset($ly, msgs#0)
     == BucketWeights.__default.WeightMessageMultiset($LZ, msgs#0));

// consequence axiom for BucketWeights.__default.WeightMessageMultiset
axiom true
   ==> (forall $ly: LayerType, msgs#0: MultiSet Box :: 
    { BucketWeights.__default.WeightMessageMultiset($ly, msgs#0) } 
    BucketWeights.__default.WeightMessageMultiset#canCall(msgs#0)
         || $Is(msgs#0, TMultiSet(Tclass.ValueMessage.Message()))
       ==> (MultiSet#Card(msgs#0) == LitInt(0)
           ==> BucketWeights.__default.WeightMessageMultiset($ly, msgs#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightMessageMultiset($ly, msgs#0));

function BucketWeights.__default.WeightMessageMultiset#requires(LayerType, MultiSet Box) : bool;

// #requires axiom for BucketWeights.__default.WeightMessageMultiset
axiom (forall $ly: LayerType, $Heap: Heap, msgs#0: MultiSet Box :: 
  { BucketWeights.__default.WeightMessageMultiset#requires($ly, msgs#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(msgs#0, TMultiSet(Tclass.ValueMessage.Message()))
     ==> BucketWeights.__default.WeightMessageMultiset#requires($ly, msgs#0) == true);

function BucketWeights.__default.WeightMessage#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Apply1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0) } 
  Apply1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0)
     == $Box(BucketWeights.__default.WeightMessage($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Requires1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0) } 
  Requires1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0)
     == BucketWeights.__default.WeightMessage#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: 
  { Reads1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0)[$bx] } 
  Reads1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: 
  { BucketWeights.__default.WeightMessage($fh$0x#0), $IsGoodHeap($heap) } 
  BucketWeights.__default.WeightMessage($fh$0x#0)
     == $Unbox(Apply1(Tclass.ValueMessage.Message(), 
        Tclass._System.nat(), 
        $heap, 
        BucketWeights.__default.WeightMessage#Handle(), 
        $Box($fh$0x#0))): int);

// definition axiom for BucketWeights.__default.WeightMessageMultiset(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, msgs#0: MultiSet Box :: 
    { BucketWeights.__default.WeightMessageMultiset($LS($ly), msgs#0), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightMessageMultiset#canCall(msgs#0)
         || ($IsGoodHeap($Heap) && $Is(msgs#0, TMultiSet(Tclass.ValueMessage.Message())))
       ==> Multisets.__default.Apply#canCall(Tclass.ValueMessage.Message(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightMessage#Handle(), 
          msgs#0)
         && (var weights#0 := Multisets.__default.Apply(Tclass.ValueMessage.Message(), 
              Tclass._System.nat(), 
              StartFuel_Multisets._default.Apply, 
              $Heap, 
              BucketWeights.__default.WeightMessage#Handle(), 
              msgs#0); 
          Multisets.__default.FoldSimple#canCall(Tclass._System.nat(), 
            $Box(LitInt(0)), 
            Multisets.__default.AddNat#Handle(), 
            weights#0))
         && BucketWeights.__default.WeightMessageMultiset($LS($ly), msgs#0)
           == (var weights#0 := Multisets.__default.Apply(Tclass.ValueMessage.Message(), 
                Tclass._System.nat(), 
                StartFuel_Multisets._default.Apply, 
                $Heap, 
                BucketWeights.__default.WeightMessage#Handle(), 
                msgs#0); 
            $Unbox(Multisets.__default.FoldSimple(Tclass._System.nat(), 
                $Box(LitInt(0)), 
                Multisets.__default.AddNat#Handle(), 
                weights#0)): int));

// definition axiom for BucketWeights.__default.WeightMessageMultiset for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, msgs#0: MultiSet Box :: 
    {:weight 3} { BucketWeights.__default.WeightMessageMultiset($LS($ly), Lit(msgs#0)), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightMessageMultiset#canCall(Lit(msgs#0))
         || ($IsGoodHeap($Heap) && $Is(msgs#0, TMultiSet(Tclass.ValueMessage.Message())))
       ==> Multisets.__default.Apply#canCall(Tclass.ValueMessage.Message(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightMessage#Handle(), 
          Lit(msgs#0))
         && (var weights#1 := Multisets.__default.Apply(Tclass.ValueMessage.Message(), 
              Tclass._System.nat(), 
              StartFuel_Multisets._default.Apply, 
              $Heap, 
              BucketWeights.__default.WeightMessage#Handle(), 
              Lit(msgs#0)); 
          Multisets.__default.FoldSimple#canCall(Tclass._System.nat(), 
            $Box(LitInt(0)), 
            Multisets.__default.AddNat#Handle(), 
            weights#1))
         && BucketWeights.__default.WeightMessageMultiset($LS($ly), Lit(msgs#0))
           == (var weights#1 := Multisets.__default.Apply(Tclass.ValueMessage.Message(), 
                Tclass._System.nat(), 
                StartFuel_Multisets._default.Apply, 
                $Heap, 
                BucketWeights.__default.WeightMessage#Handle(), 
                Lit(msgs#0)); 
            $Unbox(Multisets.__default.FoldSimple(Tclass._System.nat(), 
                $Box(LitInt(0)), 
                Multisets.__default.AddNat#Handle(), 
                weights#1)): int));

// function declaration for BucketWeights._default.WeightMessageSeq
function BucketWeights.__default.WeightMessageSeq($ly: LayerType, msgs#0: Seq Box) : int;

function BucketWeights.__default.WeightMessageSeq#canCall(msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { BucketWeights.__default.WeightMessageSeq($LS($ly), msgs#0) } 
  BucketWeights.__default.WeightMessageSeq($LS($ly), msgs#0)
     == BucketWeights.__default.WeightMessageSeq($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { BucketWeights.__default.WeightMessageSeq(AsFuelBottom($ly), msgs#0) } 
  BucketWeights.__default.WeightMessageSeq($ly, msgs#0)
     == BucketWeights.__default.WeightMessageSeq($LZ, msgs#0));

// consequence axiom for BucketWeights.__default.WeightMessageSeq
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { BucketWeights.__default.WeightMessageSeq($ly, msgs#0) } 
    BucketWeights.__default.WeightMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> LitInt(0) <= BucketWeights.__default.WeightMessageSeq($ly, msgs#0));

function BucketWeights.__default.WeightMessageSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightMessageSeq
axiom (forall $ly: LayerType, $Heap: Heap, msgs#0: Seq Box :: 
  { BucketWeights.__default.WeightMessageSeq#requires($ly, msgs#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketWeights.__default.WeightMessageSeq#requires($ly, msgs#0) == true);

// definition axiom for BucketWeights.__default.WeightMessageSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, msgs#0: Seq Box :: 
    { BucketWeights.__default.WeightMessageSeq($LS($ly), msgs#0), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightMessageSeq#canCall(msgs#0)
         || ($IsGoodHeap($Heap) && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message())))
       ==> Sequences.__default.ApplyOpaque#canCall(Tclass.ValueMessage.Message(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightMessage#Handle(), 
          msgs#0)
         && (var weights#0 := Sequences.__default.ApplyOpaque(Tclass.ValueMessage.Message(), 
              Tclass._System.nat(), 
              StartFuel_Sequences._default.ApplyOpaque, 
              $Heap, 
              BucketWeights.__default.WeightMessage#Handle(), 
              msgs#0); 
          Sequences.__default.FoldFromRight#canCall(Tclass._System.nat(), 
            Tclass._System.nat(), 
            Multisets.__default.AddNat#Handle(), 
            $Box(LitInt(0)), 
            weights#0))
         && BucketWeights.__default.WeightMessageSeq($LS($ly), msgs#0)
           == (var weights#0 := Sequences.__default.ApplyOpaque(Tclass.ValueMessage.Message(), 
                Tclass._System.nat(), 
                StartFuel_Sequences._default.ApplyOpaque, 
                $Heap, 
                BucketWeights.__default.WeightMessage#Handle(), 
                msgs#0); 
            $Unbox(Sequences.__default.FoldFromRight(Tclass._System.nat(), 
                Tclass._System.nat(), 
                $LS($LZ), 
                Multisets.__default.AddNat#Handle(), 
                $Box(LitInt(0)), 
                weights#0)): int));

// definition axiom for BucketWeights.__default.WeightMessageSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, msgs#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightMessageSeq($LS($ly), Lit(msgs#0)), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightMessageSeq#canCall(Lit(msgs#0))
         || ($IsGoodHeap($Heap) && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message())))
       ==> Sequences.__default.ApplyOpaque#canCall(Tclass.ValueMessage.Message(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightMessage#Handle(), 
          Lit(msgs#0))
         && (var weights#1 := Sequences.__default.ApplyOpaque(Tclass.ValueMessage.Message(), 
              Tclass._System.nat(), 
              StartFuel_Sequences._default.ApplyOpaque, 
              $Heap, 
              BucketWeights.__default.WeightMessage#Handle(), 
              Lit(msgs#0)); 
          Sequences.__default.FoldFromRight#canCall(Tclass._System.nat(), 
            Tclass._System.nat(), 
            Multisets.__default.AddNat#Handle(), 
            $Box(LitInt(0)), 
            weights#1))
         && BucketWeights.__default.WeightMessageSeq($LS($ly), Lit(msgs#0))
           == (var weights#1 := Sequences.__default.ApplyOpaque(Tclass.ValueMessage.Message(), 
                Tclass._System.nat(), 
                StartFuel_Sequences._default.ApplyOpaque, 
                $Heap, 
                BucketWeights.__default.WeightMessage#Handle(), 
                Lit(msgs#0)); 
            $Unbox(Sequences.__default.FoldFromRight(Tclass._System.nat(), 
                Tclass._System.nat(), 
                $LS($LZ), 
                Multisets.__default.AddNat#Handle(), 
                $Box(LitInt(0)), 
                weights#1)): int));

// function declaration for BucketWeights._default.WeightKeyList
function BucketWeights.__default.WeightKeyList(keys#0: Seq Box) : int;

function BucketWeights.__default.WeightKeyList#canCall(keys#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightKeyList
axiom true
   ==> (forall keys#0: Seq Box :: 
    { BucketWeights.__default.WeightKeyList(keys#0) } 
    BucketWeights.__default.WeightKeyList#canCall(keys#0)
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> (Seq#Length(keys#0) == LitInt(0)
           ==> BucketWeights.__default.WeightKeyList(keys#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightKeyList(keys#0));

function BucketWeights.__default.WeightKeyList#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKeyList
axiom (forall keys#0: Seq Box :: 
  { BucketWeights.__default.WeightKeyList#requires(keys#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.WeightKeyList#requires(keys#0) == true);

// definition axiom for BucketWeights.__default.WeightKeyList(revealed)
axiom true
   ==> (forall keys#0: Seq Box :: 
    { BucketWeights.__default.WeightKeyList(keys#0) } 
    BucketWeights.__default.WeightKeyList#canCall(keys#0)
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> BucketWeights.__default.WeightKeyMultiset#canCall(MultiSet#FromSeq(keys#0))
         && BucketWeights.__default.WeightKeyList(keys#0)
           == BucketWeights.__default.WeightKeyMultiset(StartFuel_BucketWeights._default.WeightKeyMultiset, MultiSet#FromSeq(keys#0)));

// definition axiom for BucketWeights.__default.WeightKeyList for all literals(revealed)
axiom true
   ==> (forall keys#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightKeyList(Lit(keys#0)) } 
    BucketWeights.__default.WeightKeyList#canCall(Lit(keys#0))
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> BucketWeights.__default.WeightKeyMultiset#canCall(MultiSet#FromSeq(Lit(keys#0)))
         && BucketWeights.__default.WeightKeyList(Lit(keys#0))
           == BucketWeights.__default.WeightKeyMultiset(StartFuel_BucketWeights._default.WeightKeyMultiset, 
            MultiSet#FromSeq(Lit(keys#0))));

// function declaration for BucketWeights._default.WeightMessageList
function BucketWeights.__default.WeightMessageList(msgs#0: Seq Box) : int;

function BucketWeights.__default.WeightMessageList#canCall(msgs#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightMessageList
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { BucketWeights.__default.WeightMessageList(msgs#0) } 
    BucketWeights.__default.WeightMessageList#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (Seq#Length(msgs#0) == LitInt(0)
           ==> BucketWeights.__default.WeightMessageList(msgs#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightMessageList(msgs#0));

function BucketWeights.__default.WeightMessageList#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightMessageList
axiom (forall msgs#0: Seq Box :: 
  { BucketWeights.__default.WeightMessageList#requires(msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketWeights.__default.WeightMessageList#requires(msgs#0) == true);

// definition axiom for BucketWeights.__default.WeightMessageList(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { BucketWeights.__default.WeightMessageList(msgs#0) } 
    BucketWeights.__default.WeightMessageList#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> BucketWeights.__default.WeightMessageMultiset#canCall(MultiSet#FromSeq(msgs#0))
         && BucketWeights.__default.WeightMessageList(msgs#0)
           == BucketWeights.__default.WeightMessageMultiset(StartFuel_BucketWeights._default.WeightMessageMultiset, MultiSet#FromSeq(msgs#0)));

// definition axiom for BucketWeights.__default.WeightMessageList for all literals(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightMessageList(Lit(msgs#0)) } 
    BucketWeights.__default.WeightMessageList#canCall(Lit(msgs#0))
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> BucketWeights.__default.WeightMessageMultiset#canCall(MultiSet#FromSeq(Lit(msgs#0)))
         && BucketWeights.__default.WeightMessageList(Lit(msgs#0))
           == BucketWeights.__default.WeightMessageMultiset(StartFuel_BucketWeights._default.WeightMessageMultiset, 
            MultiSet#FromSeq(Lit(msgs#0))));

// function declaration for BucketWeights._default.WeightBucket
function BucketWeights.__default.WeightBucket(bucket#0: DatatypeType) : int;

function BucketWeights.__default.WeightBucket#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketWeights.__default.WeightBucket
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketWeights.__default.WeightBucket(bucket#0) } 
    BucketWeights.__default.WeightBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> (Seq#Length(BucketsLib.Bucket.keys(bucket#0))
               == Seq#Length(BucketsLib.Bucket.msgs(bucket#0))
             && Seq#Length(BucketsLib.Bucket.msgs(bucket#0)) == LitInt(0)
           ==> BucketWeights.__default.WeightBucket(bucket#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightBucket(bucket#0));

function BucketWeights.__default.WeightBucket#requires(DatatypeType) : bool;

// #requires axiom for BucketWeights.__default.WeightBucket
axiom (forall bucket#0: DatatypeType :: 
  { BucketWeights.__default.WeightBucket#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketWeights.__default.WeightBucket#requires(bucket#0) == true);

// definition axiom for BucketWeights.__default.WeightBucket(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketWeights.__default.WeightBucket(bucket#0) } 
    BucketWeights.__default.WeightBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && BucketWeights.__default.WeightKeyList#canCall(BucketsLib.Bucket.keys(bucket#0))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && BucketWeights.__default.WeightMessageList#canCall(BucketsLib.Bucket.msgs(bucket#0))
         && BucketWeights.__default.WeightBucket(bucket#0)
           == BucketWeights.__default.WeightKeyList(BucketsLib.Bucket.keys(bucket#0))
             + BucketWeights.__default.WeightMessageList(BucketsLib.Bucket.msgs(bucket#0)));

// definition axiom for BucketWeights.__default.WeightBucket for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketWeights.__default.WeightBucket(Lit(bucket#0)) } 
    BucketWeights.__default.WeightBucket#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && BucketWeights.__default.WeightKeyList#canCall(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && BucketWeights.__default.WeightMessageList#canCall(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
         && BucketWeights.__default.WeightBucket(Lit(bucket#0))
           == LitInt(BucketWeights.__default.WeightKeyList(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
               + BucketWeights.__default.WeightMessageList(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))));

// function declaration for BucketWeights._default.WeightBucketList
function BucketWeights.__default.WeightBucketList($ly: LayerType, buckets#0: Seq Box) : int;

function BucketWeights.__default.WeightBucketList#canCall(buckets#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketWeights.__default.WeightBucketList($LS($ly), buckets#0) } 
  BucketWeights.__default.WeightBucketList($LS($ly), buckets#0)
     == BucketWeights.__default.WeightBucketList($ly, buckets#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketWeights.__default.WeightBucketList(AsFuelBottom($ly), buckets#0) } 
  BucketWeights.__default.WeightBucketList($ly, buckets#0)
     == BucketWeights.__default.WeightBucketList($LZ, buckets#0));

// consequence axiom for BucketWeights.__default.WeightBucketList
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketWeights.__default.WeightBucketList($ly, buckets#0) } 
    BucketWeights.__default.WeightBucketList#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> LitInt(0) <= BucketWeights.__default.WeightBucketList($ly, buckets#0));

function BucketWeights.__default.WeightBucketList#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightBucketList
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketWeights.__default.WeightBucketList#requires($ly, buckets#0) } 
  $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketWeights.__default.WeightBucketList#requires($ly, buckets#0) == true);

// definition axiom for BucketWeights.__default.WeightBucketList(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketWeights.__default.WeightBucketList($LS($ly), buckets#0) } 
    BucketWeights.__default.WeightBucketList#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(buckets#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketWeights.__default.WeightBucketList#canCall(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketWeights.__default.WeightBucket#canCall($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType))
         && BucketWeights.__default.WeightBucketList($LS($ly), buckets#0)
           == (if Seq#Length(buckets#0) == LitInt(0)
             then 0
             else BucketWeights.__default.WeightBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))
               + BucketWeights.__default.WeightBucket($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType)));

// definition axiom for BucketWeights.__default.WeightBucketList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightBucketList($LS($ly), Lit(buckets#0)) } 
    BucketWeights.__default.WeightBucketList#canCall(Lit(buckets#0))
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(Lit(buckets#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketWeights.__default.WeightBucket#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType)))
         && BucketWeights.__default.WeightBucketList($LS($ly), Lit(buckets#0))
           == (if Seq#Length(Lit(buckets#0)) == LitInt(0)
             then 0
             else BucketWeights.__default.WeightBucketList($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))
               + BucketWeights.__default.WeightBucket(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))));

// function declaration for BucketWeights._default.AllKeys
function BucketWeights.__default.AllKeys() : ISet Box;

function BucketWeights.__default.AllKeys#canCall() : bool;

// consequence axiom for BucketWeights.__default.AllKeys
axiom true
   ==> 
  true
   ==> $Is(BucketWeights.__default.AllKeys(), TISet(Tclass.KeyType.Key()));

function BucketWeights.__default.AllKeys#requires() : bool;

// #requires axiom for BucketWeights.__default.AllKeys
axiom BucketWeights.__default.AllKeys#requires() == true;

// definition axiom for BucketWeights.__default.AllKeys(revealed)
axiom true
   ==> 
  true
   ==> BucketWeights.__default.AllKeys()
     == (lambda $y#0: Box :: $IsBox($y#0, Tclass.KeyType.Key()) && Lit(true));

// definition axiom for BucketWeights.__default.AllKeys for all literals(revealed)
axiom true
   ==> 
  true
   ==> BucketWeights.__default.AllKeys()
     == (lambda $y#1: Box :: $IsBox($y#1, Tclass.KeyType.Key()) && Lit(true));

// function declaration for BucketWeights._default.IncludeKey
function BucketWeights.__default.IncludeKey(key#0: Seq Box) : ISet Box;

function BucketWeights.__default.IncludeKey#canCall(key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.IncludeKey
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.IncludeKey(key#0) } 
    BucketWeights.__default.IncludeKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> $Is(BucketWeights.__default.IncludeKey(key#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.IncludeKey#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.IncludeKey
axiom (forall key#0: Seq Box :: 
  { BucketWeights.__default.IncludeKey#requires(key#0) } 
  $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.IncludeKey#requires(key#0) == true);

// definition axiom for BucketWeights.__default.IncludeKey(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.IncludeKey(key#0) } 
    BucketWeights.__default.IncludeKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.IncludeKey(key#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Tclass.KeyType.Key()) && Seq#Equal($Unbox($y#0): Seq Box, key#0)));

// definition axiom for BucketWeights.__default.IncludeKey for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.IncludeKey(Lit(key#0)) } 
    BucketWeights.__default.IncludeKey#canCall(Lit(key#0))
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.IncludeKey(Lit(key#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Tclass.KeyType.Key()) && Seq#Equal($Unbox($y#1): Seq Box, key#0)));

// function declaration for BucketWeights._default.ExcludeKey
function BucketWeights.__default.ExcludeKey(key#0: Seq Box) : ISet Box;

function BucketWeights.__default.ExcludeKey#canCall(key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.ExcludeKey
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.ExcludeKey(key#0) } 
    BucketWeights.__default.ExcludeKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> $Is(BucketWeights.__default.ExcludeKey(key#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.ExcludeKey#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.ExcludeKey
axiom (forall key#0: Seq Box :: 
  { BucketWeights.__default.ExcludeKey#requires(key#0) } 
  $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.ExcludeKey#requires(key#0) == true);

// definition axiom for BucketWeights.__default.ExcludeKey(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.ExcludeKey(key#0) } 
    BucketWeights.__default.ExcludeKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.ExcludeKey(key#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Tclass.KeyType.Key()) && !Seq#Equal($Unbox($y#0): Seq Box, key#0)));

// definition axiom for BucketWeights.__default.ExcludeKey for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.ExcludeKey(Lit(key#0)) } 
    BucketWeights.__default.ExcludeKey#canCall(Lit(key#0))
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.ExcludeKey(Lit(key#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Tclass.KeyType.Key()) && !Seq#Equal($Unbox($y#1): Seq Box, key#0)));

// function declaration for BucketWeights._default.Image
function BucketWeights.__default.Image($ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box) : DatatypeType;

function BucketWeights.__default.Image#canCall(bucket#0: DatatypeType, filter#0: ISet Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
  { BucketWeights.__default.Image($LS($ly), bucket#0, filter#0) } 
  BucketWeights.__default.Image($LS($ly), bucket#0, filter#0)
     == BucketWeights.__default.Image($ly, bucket#0, filter#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
  { BucketWeights.__default.Image(AsFuelBottom($ly), bucket#0, filter#0) } 
  BucketWeights.__default.Image($ly, bucket#0, filter#0)
     == BucketWeights.__default.Image($LZ, bucket#0, filter#0));

// consequence axiom for BucketWeights.__default.Image
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
    { BucketWeights.__default.Image($ly, bucket#0, filter#0) } 
    BucketWeights.__default.Image#canCall(bucket#0, filter#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(filter#0, TISet(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketWeights.__default.Image($ly, bucket#0, filter#0))
         && BucketsLib.__default.PreWFBucket(BucketWeights.__default.Image($ly, bucket#0, filter#0))
         && Seq#Length(BucketsLib.Bucket.keys(BucketWeights.__default.Image($ly, bucket#0, filter#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketWeights.__default.Image($ly, bucket#0, filter#0)))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> BucketsLib.__default.WFBucket(BucketWeights.__default.Image($ly, bucket#0, filter#0)))
         && $Is(BucketWeights.__default.Image($ly, bucket#0, filter#0), 
          Tclass.BucketsLib.Bucket()));

function BucketWeights.__default.Image#requires(LayerType, DatatypeType, ISet Box) : bool;

// #requires axiom for BucketWeights.__default.Image
axiom (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
  { BucketWeights.__default.Image#requires($ly, bucket#0, filter#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(filter#0, TISet(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.Image#requires($ly, bucket#0, filter#0) == true);

// definition axiom for BucketWeights.__default.Image(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
    { BucketWeights.__default.Image($LS($ly), bucket#0, filter#0) } 
    BucketWeights.__default.Image#canCall(bucket#0, filter#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(filter#0, TISet(Tclass.KeyType.Key())))
       ==> (forall k#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)]): DatatypeType } 
            { filter#0[$Box(k#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)] } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)] && filter#0[$Box(k#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && filter#0[$w#0]), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketWeights.__default.Image($LS($ly), bucket#0, filter#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && filter#0[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketWeights.__default.Image for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
    {:weight 3} { BucketWeights.__default.Image($LS($ly), Lit(bucket#0), filter#0) } 
    BucketWeights.__default.Image#canCall(Lit(bucket#0), filter#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(filter#0, TISet(Tclass.KeyType.Key())))
       ==> (forall k#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)]): DatatypeType } 
            { filter#0[$Box(k#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)] } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(k#0)] && filter#0[$Box(k#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && filter#0[$w#2]), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketWeights.__default.Image($LS($ly), Lit(bucket#0), filter#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && filter#0[$w#3]), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketWeights.__default.Image for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
    {:weight 3} { BucketWeights.__default.Image($LS($ly), Lit(bucket#0), Lit(filter#0)) } 
    BucketWeights.__default.Image#canCall(Lit(bucket#0), Lit(filter#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(filter#0, TISet(Tclass.KeyType.Key())))
       ==> (forall k#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)]): DatatypeType } 
            { filter#0[$Box(k#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)] } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(k#0)]
                   && Lit(filter#0)[$Box(k#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#4]
                 && Lit(filter#0)[$w#4]), 
            (lambda $w#4: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketWeights.__default.Image($LS($ly), Lit(bucket#0), Lit(filter#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#5]
                   && Lit(filter#0)[$w#5]), 
              (lambda $w#5: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketWeights._default.WeightOneKey
function BucketWeights.__default.WeightOneKey(bucket#0: DatatypeType, key#0: Seq Box) : int;

function BucketWeights.__default.WeightOneKey#canCall(bucket#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightOneKey
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketWeights.__default.WeightOneKey(bucket#0, key#0) } 
    BucketWeights.__default.WeightOneKey#canCall(bucket#0, key#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.PreWFBucket(bucket#0)
           && BucketsLib.__default.BucketWellMarshalled(bucket#0))
       ==> true);

function BucketWeights.__default.WeightOneKey#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightOneKey
axiom (forall bucket#0: DatatypeType, key#0: Seq Box :: 
  { BucketWeights.__default.WeightOneKey#requires(bucket#0, key#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.WeightOneKey#requires(bucket#0, key#0)
       == (BucketsLib.__default.PreWFBucket(bucket#0)
         && BucketsLib.__default.BucketWellMarshalled(bucket#0)));

// definition axiom for BucketWeights.__default.WeightOneKey(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketWeights.__default.WeightOneKey(bucket#0, key#0) } 
    BucketWeights.__default.WeightOneKey#canCall(bucket#0, key#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.PreWFBucket(bucket#0)
           && BucketsLib.__default.BucketWellMarshalled(bucket#0))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
           ==> BucketWeights.__default.WeightKey#canCall(key#0)
             && 
            BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketWeights.__default.WeightMessage#canCall($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType))
         && BucketWeights.__default.WeightOneKey(bucket#0, key#0)
           == (if Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
             then BucketWeights.__default.WeightKey(key#0)
               + BucketWeights.__default.WeightMessage($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType)
             else 0));

// definition axiom for BucketWeights.__default.WeightOneKey for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightOneKey(Lit(bucket#0), Lit(key#0)) } 
    BucketWeights.__default.WeightOneKey#canCall(Lit(bucket#0), Lit(key#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Lit(BucketsLib.__default.PreWFBucket(Lit(bucket#0)))
           && Lit(BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0))))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
           ==> BucketWeights.__default.WeightKey#canCall(Lit(key#0))
             && 
            BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketWeights.__default.WeightMessage#canCall($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(Lit(key#0))]): DatatypeType))
         && BucketWeights.__default.WeightOneKey(Lit(bucket#0), Lit(key#0))
           == (if Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
             then BucketWeights.__default.WeightKey(Lit(key#0))
               + BucketWeights.__default.WeightMessage($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(Lit(key#0))]): DatatypeType)
             else 0));

// function declaration for BucketWeights._default.ILeftKeys
function BucketWeights.__default.ILeftKeys(pivot#0: Seq Box) : ISet Box;

function BucketWeights.__default.ILeftKeys#canCall(pivot#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.ILeftKeys
axiom true
   ==> (forall pivot#0: Seq Box :: 
    { BucketWeights.__default.ILeftKeys(pivot#0) } 
    BucketWeights.__default.ILeftKeys#canCall(pivot#0)
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> $Is(BucketWeights.__default.ILeftKeys(pivot#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.ILeftKeys#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.ILeftKeys
axiom (forall pivot#0: Seq Box :: 
  { BucketWeights.__default.ILeftKeys#requires(pivot#0) } 
  $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.ILeftKeys#requires(pivot#0) == true);

// definition axiom for BucketWeights.__default.ILeftKeys(revealed)
axiom true
   ==> (forall pivot#0: Seq Box :: 
    { BucketWeights.__default.ILeftKeys(pivot#0) } 
    BucketWeights.__default.ILeftKeys#canCall(pivot#0)
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> (forall k#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#0, pivot#0) } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#0, pivot#0))
         && BucketWeights.__default.ILeftKeys(pivot#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#0): Seq Box, pivot#0)));

// definition axiom for BucketWeights.__default.ILeftKeys for all literals(revealed)
axiom true
   ==> (forall pivot#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.ILeftKeys(Lit(pivot#0)) } 
    BucketWeights.__default.ILeftKeys#canCall(Lit(pivot#0))
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> (forall k#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#1, pivot#0) } 
          $Is(k#1, Tclass.KeyType.Key())
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#1, Lit(pivot#0)))
         && BucketWeights.__default.ILeftKeys(Lit(pivot#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#1): Seq Box, Lit(pivot#0))));

// function declaration for BucketWeights._default.IRightKeys
function BucketWeights.__default.IRightKeys(pivot#0: Seq Box) : ISet Box;

function BucketWeights.__default.IRightKeys#canCall(pivot#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.IRightKeys
axiom true
   ==> (forall pivot#0: Seq Box :: 
    { BucketWeights.__default.IRightKeys(pivot#0) } 
    BucketWeights.__default.IRightKeys#canCall(pivot#0)
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> $Is(BucketWeights.__default.IRightKeys(pivot#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.IRightKeys#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.IRightKeys
axiom (forall pivot#0: Seq Box :: 
  { BucketWeights.__default.IRightKeys#requires(pivot#0) } 
  $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.IRightKeys#requires(pivot#0) == true);

// definition axiom for BucketWeights.__default.IRightKeys(revealed)
axiom true
   ==> (forall pivot#0: Seq Box :: 
    { BucketWeights.__default.IRightKeys(pivot#0) } 
    BucketWeights.__default.IRightKeys#canCall(pivot#0)
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> (forall k#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(pivot#0, k#0) } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, k#0))
         && BucketWeights.__default.IRightKeys(pivot#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#0): Seq Box)));

// definition axiom for BucketWeights.__default.IRightKeys for all literals(revealed)
axiom true
   ==> (forall pivot#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.IRightKeys(Lit(pivot#0)) } 
    BucketWeights.__default.IRightKeys#canCall(Lit(pivot#0))
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> (forall k#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(pivot#0, k#1) } 
          $Is(k#1, Tclass.KeyType.Key())
             ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), k#1))
         && BucketWeights.__default.IRightKeys(Lit(pivot#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#1): Seq Box)));

procedure {:_induction left#0, right#0} CheckWellformed$$BucketWeights.__default.WeightBucketListConcat(left#0: Seq Box
       where $Is(left#0, TSeq(Tclass.BucketsLib.Bucket()))
         && $IsAlloc(left#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap), 
    right#0: Seq Box
       where $Is(right#0, TSeq(Tclass.BucketsLib.Bucket()))
         && $IsAlloc(right#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap));
  free requires 60 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction left#0, right#0} Call$$BucketWeights.__default.WeightBucketListConcat(left#0: Seq Box
       where $Is(left#0, TSeq(Tclass.BucketsLib.Bucket()))
         && $IsAlloc(left#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap), 
    right#0: Seq Box
       where $Is(right#0, TSeq(Tclass.BucketsLib.Bucket()))
         && $IsAlloc(right#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightBucketList#canCall(Seq#Append(left#0, right#0))
     && 
    BucketWeights.__default.WeightBucketList#canCall(left#0)
     && BucketWeights.__default.WeightBucketList#canCall(right#0);
  ensures BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      Seq#Append(left#0, right#0))
     == BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, left#0)
       + BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, right#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction blist#0} CheckWellformed$$BucketWeights.__default.WeightBucketListSlice(blist#0: Seq Box
       where $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
         && $IsAlloc(blist#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap), 
    a#0: int, 
    b#0: int);
  free requires 62 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction blist#0} Call$$BucketWeights.__default.WeightBucketListSlice(blist#0: Seq Box
       where $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
         && $IsAlloc(blist#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap), 
    a#0: int, 
    b#0: int);
  // user-defined preconditions
  requires LitInt(0) <= a#0;
  requires a#0 <= b#0;
  requires b#0 <= Seq#Length(blist#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightBucketList#canCall(Seq#Drop(Seq#Take(blist#0, b#0), a#0))
     && BucketWeights.__default.WeightBucketList#canCall(blist#0);
  ensures BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, 
      Seq#Drop(Seq#Take(blist#0, b#0), a#0))
     <= BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, blist#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for BucketWeights._default.RouteRange
function BucketWeights.__default.RouteRange(pivots#0: Seq Box, i#0: int) : ISet Box;

function BucketWeights.__default.RouteRange#canCall(pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for BucketWeights.__default.RouteRange
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { BucketWeights.__default.RouteRange(pivots#0, i#0) } 
    BucketWeights.__default.RouteRange#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(BucketWeights.__default.RouteRange(pivots#0, i#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.RouteRange#requires(Seq Box, int) : bool;

// #requires axiom for BucketWeights.__default.RouteRange
axiom (forall pivots#0: Seq Box, i#0: int :: 
  { BucketWeights.__default.RouteRange#requires(pivots#0, i#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.RouteRange#requires(pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketWeights.__default.RouteRange(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { BucketWeights.__default.RouteRange(pivots#0, i#0) } 
    BucketWeights.__default.RouteRange#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall k#0: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, k#0) } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(pivots#0, k#0))
         && BucketWeights.__default.RouteRange(pivots#0, i#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(pivots#0, $Unbox($y#0): Seq Box) == i#0));

// definition axiom for BucketWeights.__default.RouteRange for all literals(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketWeights.__default.RouteRange(Lit(pivots#0), LitInt(i#0)) } 
    BucketWeights.__default.RouteRange#canCall(Lit(pivots#0), LitInt(i#0))
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall k#1: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, k#1) } 
          $Is(k#1, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), k#1))
         && BucketWeights.__default.RouteRange(Lit(pivots#0), LitInt(i#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($y#1): Seq Box) == LitInt(i#0)));

// function declaration for BucketWeights._default.RouteRanges
function BucketWeights.__default.RouteRanges(pivots#0: Seq Box, i#0: int) : ISet Box;

function BucketWeights.__default.RouteRanges#canCall(pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for BucketWeights.__default.RouteRanges
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { BucketWeights.__default.RouteRanges(pivots#0, i#0) } 
    BucketWeights.__default.RouteRanges#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(BucketWeights.__default.RouteRanges(pivots#0, i#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.RouteRanges#requires(Seq Box, int) : bool;

// #requires axiom for BucketWeights.__default.RouteRanges
axiom (forall pivots#0: Seq Box, i#0: int :: 
  { BucketWeights.__default.RouteRanges#requires(pivots#0, i#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.RouteRanges#requires(pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketWeights.__default.RouteRanges(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { BucketWeights.__default.RouteRanges(pivots#0, i#0) } 
    BucketWeights.__default.RouteRanges#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall k#0: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, k#0) } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(pivots#0, k#0))
         && BucketWeights.__default.RouteRanges(pivots#0, i#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(pivots#0, $Unbox($y#0): Seq Box) < i#0));

// definition axiom for BucketWeights.__default.RouteRanges for all literals(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketWeights.__default.RouteRanges(Lit(pivots#0), LitInt(i#0)) } 
    BucketWeights.__default.RouteRanges#canCall(Lit(pivots#0), LitInt(i#0))
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall k#1: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, k#1) } 
          $Is(k#1, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), k#1))
         && BucketWeights.__default.RouteRanges(Lit(pivots#0), LitInt(i#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($y#1): Seq Box) < i#0));

procedure {:_induction blist#0} CheckWellformed$$BucketWeights.__default.WeightBucketLeBucketList(blist#0: Seq Box
       where $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
         && $IsAlloc(blist#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap), 
    i#0: int);
  free requires 91 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction blist#0} Call$$BucketWeights.__default.WeightBucketLeBucketList(blist#0: Seq Box
       where $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
         && $IsAlloc(blist#0, TSeq(Tclass.BucketsLib.Bucket()), $Heap), 
    i#0: int);
  // user-defined preconditions
  requires LitInt(0) <= i#0;
  requires i#0 < Seq#Length(blist#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(blist#0, i#0)): DatatypeType)
     && BucketWeights.__default.WeightBucketList#canCall(blist#0);
  ensures BucketWeights.__default.WeightBucket($Unbox(Seq#Index(blist#0, i#0)): DatatypeType)
     <= BucketWeights.__default.WeightBucketList(StartFuelAssert_BucketWeights._default.WeightBucketList, blist#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$BucketWeights.__default.WeightKeyListPushFront(key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    keys#0: Seq Box
       where $Is(keys#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(keys#0, TSeq(Tclass.KeyType.Key()), $Heap));
  free requires 98 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$BucketWeights.__default.WeightKeyListPushFront(key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap), 
    keys#0: Seq Box
       where $Is(keys#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(keys#0, TSeq(Tclass.KeyType.Key()), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightKeyList#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(key#0)), keys#0))
     && 
    BucketWeights.__default.WeightKey#canCall(key#0)
     && BucketWeights.__default.WeightKeyList#canCall(keys#0);
  ensures BucketWeights.__default.WeightKeyList(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(key#0)), keys#0))
     == BucketWeights.__default.WeightKey(key#0)
       + BucketWeights.__default.WeightKeyList(keys#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$BucketWeights.__default.WeightMessageListPushFront(msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0), 
    msgs#0: Seq Box
       where $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
         && $IsAlloc(msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap));
  free requires 99 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$BucketWeights.__default.WeightMessageListPushFront(msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0), 
    msgs#0: Seq Box
       where $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
         && $IsAlloc(msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightMessageList#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0)), msgs#0))
     && 
    BucketWeights.__default.WeightMessage#canCall(msg#0)
     && BucketWeights.__default.WeightMessageList#canCall(msgs#0);
  ensures BucketWeights.__default.WeightMessageList(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0)), msgs#0))
     == BucketWeights.__default.WeightMessage(msg#0)
       + BucketWeights.__default.WeightMessageList(msgs#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$BucketWeights.__default.WeightKeyListPushBack(keys#0: Seq Box
       where $Is(keys#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(keys#0, TSeq(Tclass.KeyType.Key()), $Heap), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap));
  free requires 100 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$BucketWeights.__default.WeightKeyListPushBack(keys#0: Seq Box
       where $Is(keys#0, TSeq(Tclass.KeyType.Key()))
         && $IsAlloc(keys#0, TSeq(Tclass.KeyType.Key()), $Heap), 
    key#0: Seq Box
       where $Is(key#0, Tclass.KeyType.Key()) && $IsAlloc(key#0, Tclass.KeyType.Key(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightKeyList#canCall(Seq#Append(keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
     && 
    BucketWeights.__default.WeightKey#canCall(key#0)
     && BucketWeights.__default.WeightKeyList#canCall(keys#0);
  ensures BucketWeights.__default.WeightKeyList(Seq#Append(keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
     == BucketWeights.__default.WeightKey(key#0)
       + BucketWeights.__default.WeightKeyList(keys#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$BucketWeights.__default.WeightMessageListPushBack(msgs#0: Seq Box
       where $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
         && $IsAlloc(msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap), 
    msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0));
  free requires 101 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$BucketWeights.__default.WeightMessageListPushBack(msgs#0: Seq Box
       where $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
         && $IsAlloc(msgs#0, TSeq(Tclass.ValueMessage.Message()), $Heap), 
    msg#0: DatatypeType
       where $Is(msg#0, Tclass.ValueMessage.Message())
         && $IsAlloc(msg#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(msg#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BucketWeights.__default.WeightMessageList#canCall(Seq#Append(msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))))
     && 
    BucketWeights.__default.WeightMessage#canCall(msg#0)
     && BucketWeights.__default.WeightMessageList#canCall(msgs#0);
  ensures BucketWeights.__default.WeightMessageList(Seq#Append(msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))))
     == BucketWeights.__default.WeightMessage(msg#0)
       + BucketWeights.__default.WeightMessageList(msgs#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$BucketWeights.__default.reveal__WeightBucketList();
  free requires 109 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_BucketWeights._default.WeightBucketList0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$BucketWeights.__default.reveal__WeightBucketList();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_BucketWeights._default.WeightBucketList
     == $LS(MoreFuel_BucketWeights._default.WeightBucketList0);
  free ensures StartFuelAssert_BucketWeights._default.WeightBucketList
     == $LS($LS(MoreFuel_BucketWeights._default.WeightBucketList0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_BucketWeights._default.WeightBucketList0)
     == MoreFuel_BucketWeights._default.WeightBucketList0;



const unique class.Bounds.__default: ClassName;

function Tclass.Bounds.__default() : Ty;

// Tclass.Bounds.__default Tag
axiom Tag(Tclass.Bounds.__default()) == Tagclass.Bounds.__default;

const unique Tagclass.Bounds.__default: TyTag;

// Box/unbox axiom for Tclass.Bounds.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Bounds.__default()) } 
  $IsBox(bx, Tclass.Bounds.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Bounds.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Bounds.__default()) } 
  $Is($o, Tclass.Bounds.__default())
     <==> $o == null || dtype($o) == Tclass.Bounds.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Bounds.__default(), $h) } 
  $IsAlloc($o, Tclass.Bounds.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Bounds._default.NodeBlockSizeUint64
function Bounds.__default.NodeBlockSizeUint64() : int;

function Bounds.__default.NodeBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.NodeBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.NodeBlockSizeUint64()
     && Bounds.__default.NodeBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.NodeBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.NodeBlockSizeUint64
axiom Bounds.__default.NodeBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.NodeBlockSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)));

// definition axiom for Bounds.__default.NodeBlockSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)));

// function declaration for Bounds._default.MinNodeBlockIndexUint64
function Bounds.__default.MinNodeBlockIndexUint64() : int;

function Bounds.__default.MinNodeBlockIndexUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MinNodeBlockIndexUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MinNodeBlockIndexUint64()
     && Bounds.__default.MinNodeBlockIndexUint64() < 18446744073709551616;

function Bounds.__default.MinNodeBlockIndexUint64#requires() : bool;

// #requires axiom for Bounds.__default.MinNodeBlockIndexUint64
axiom Bounds.__default.MinNodeBlockIndexUint64#requires() == true;

// definition axiom for Bounds.__default.MinNodeBlockIndexUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && 
    Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.MinNodeBlockIndexUint64()
       == LitInt(Div(Mul(LitInt(2), LitInt(Bounds.__default.SuperblockSizeUint64()))
               + Mul(LitInt(Bounds.__default.DiskNumJournalBlocksUint64()), 
                LitInt(Bounds.__default.JournalBlockSizeUint64()))
               + Mul(LitInt(2), LitInt(Bounds.__default.IndirectionTableBlockSizeUint64()))
               + Bounds.__default.NodeBlockSizeUint64()
             - 1, 
          LitInt(Bounds.__default.NodeBlockSizeUint64())));

// definition axiom for Bounds.__default.MinNodeBlockIndexUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && 
    Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.MinNodeBlockIndexUint64()
       == LitInt(Div(Mul(LitInt(2), LitInt(Bounds.__default.SuperblockSizeUint64()))
               + Mul(LitInt(Bounds.__default.DiskNumJournalBlocksUint64()), 
                LitInt(Bounds.__default.JournalBlockSizeUint64()))
               + Mul(LitInt(2), LitInt(Bounds.__default.IndirectionTableBlockSizeUint64()))
               + Bounds.__default.NodeBlockSizeUint64()
             - 1, 
          LitInt(Bounds.__default.NodeBlockSizeUint64())));

// function declaration for Bounds._default.SuperblockSizeUint64
function Bounds.__default.SuperblockSizeUint64() : int;

function Bounds.__default.SuperblockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.SuperblockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.SuperblockSizeUint64()
     && Bounds.__default.SuperblockSizeUint64() < 18446744073709551616;

function Bounds.__default.SuperblockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.SuperblockSizeUint64
axiom Bounds.__default.SuperblockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.SuperblockSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.SuperblockSizeUint64() == LitInt(4096);

// definition axiom for Bounds.__default.SuperblockSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.SuperblockSizeUint64() == LitInt(4096);

// function declaration for Bounds._default.JournalBlockSizeUint64
function Bounds.__default.JournalBlockSizeUint64() : int;

function Bounds.__default.JournalBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.JournalBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.JournalBlockSizeUint64()
     && Bounds.__default.JournalBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.JournalBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.JournalBlockSizeUint64
axiom Bounds.__default.JournalBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.JournalBlockSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.JournalBlockSizeUint64() == LitInt(4096);

// definition axiom for Bounds.__default.JournalBlockSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.JournalBlockSizeUint64() == LitInt(4096);

// function declaration for Bounds._default.DiskNumJournalBlocksUint64
function Bounds.__default.DiskNumJournalBlocksUint64() : int;

function Bounds.__default.DiskNumJournalBlocksUint64#canCall() : bool;

// consequence axiom for Bounds.__default.DiskNumJournalBlocksUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.DiskNumJournalBlocksUint64()
     && Bounds.__default.DiskNumJournalBlocksUint64() < 18446744073709551616;

function Bounds.__default.DiskNumJournalBlocksUint64#requires() : bool;

// #requires axiom for Bounds.__default.DiskNumJournalBlocksUint64
axiom Bounds.__default.DiskNumJournalBlocksUint64#requires() == true;

// definition axiom for Bounds.__default.DiskNumJournalBlocksUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64()
     == LitInt(Mul(LitInt(64), LitInt(1024)));

// definition axiom for Bounds.__default.DiskNumJournalBlocksUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64()
     == LitInt(Mul(LitInt(64), LitInt(1024)));

// function declaration for Bounds._default.IndirectionTableBlockSizeUint64
function Bounds.__default.IndirectionTableBlockSizeUint64() : int;

function Bounds.__default.IndirectionTableBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.IndirectionTableBlockSizeUint64()
     && Bounds.__default.IndirectionTableBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.IndirectionTableBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableBlockSizeUint64
axiom Bounds.__default.IndirectionTableBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableBlockSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(24), LitInt(1024))), LitInt(1024)));

// definition axiom for Bounds.__default.IndirectionTableBlockSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(24), LitInt(1024))), LitInt(1024)));

// function declaration for Bounds._default.LargestBlockSizeOfAnyTypeUint64
function Bounds.__default.LargestBlockSizeOfAnyTypeUint64() : int;

function Bounds.__default.LargestBlockSizeOfAnyTypeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64
axiom true
   ==> 
  true
   ==> LitInt(Bounds.__default.IndirectionTableBlockSizeUint64())
       <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && LitInt(Bounds.__default.NodeBlockSizeUint64())
       <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && 
    LitInt(0) <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64() < 18446744073709551616;

function Bounds.__default.LargestBlockSizeOfAnyTypeUint64#requires() : bool;

// #requires axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64
axiom Bounds.__default.LargestBlockSizeOfAnyTypeUint64#requires() == true;

// definition axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// definition axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// function declaration for Bounds._default.MaxTotalBucketWeightUint64
function Bounds.__default.MaxTotalBucketWeightUint64() : int;

function Bounds.__default.MaxTotalBucketWeightUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxTotalBucketWeightUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxTotalBucketWeightUint64()
     && Bounds.__default.MaxTotalBucketWeightUint64() < 18446744073709551616;

function Bounds.__default.MaxTotalBucketWeightUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxTotalBucketWeightUint64
axiom Bounds.__default.MaxTotalBucketWeightUint64#requires() == true;

// definition axiom for Bounds.__default.MaxTotalBucketWeightUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)) - 65536);

// definition axiom for Bounds.__default.MaxTotalBucketWeightUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)) - 65536);

// function declaration for Bounds._default.MaxCacheSizeUint64
function Bounds.__default.MaxCacheSizeUint64() : int;

function Bounds.__default.MaxCacheSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxCacheSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxCacheSizeUint64()
     && Bounds.__default.MaxCacheSizeUint64() < 18446744073709551616;

function Bounds.__default.MaxCacheSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxCacheSizeUint64
axiom Bounds.__default.MaxCacheSizeUint64#requires() == true;

// definition axiom for Bounds.__default.MaxCacheSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.MaxCacheSizeUint64() == LitInt(100);

// definition axiom for Bounds.__default.MaxCacheSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.MaxCacheSizeUint64() == LitInt(100);

// function declaration for Bounds._default.MaxNumChildrenUint64
function Bounds.__default.MaxNumChildrenUint64() : int;

function Bounds.__default.MaxNumChildrenUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxNumChildrenUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxNumChildrenUint64()
     && Bounds.__default.MaxNumChildrenUint64() < 18446744073709551616;

function Bounds.__default.MaxNumChildrenUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxNumChildrenUint64
axiom Bounds.__default.MaxNumChildrenUint64#requires() == true;

// definition axiom for Bounds.__default.MaxNumChildrenUint64(revealed)
axiom true ==> true ==> Bounds.__default.MaxNumChildrenUint64() == LitInt(8);

// definition axiom for Bounds.__default.MaxNumChildrenUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.MaxNumChildrenUint64() == LitInt(8);

// function declaration for Bounds._default.FlushTriggerWeightUint64
function Bounds.__default.FlushTriggerWeightUint64() : int;

function Bounds.__default.FlushTriggerWeightUint64#canCall() : bool;

// consequence axiom for Bounds.__default.FlushTriggerWeightUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.FlushTriggerWeightUint64()
     && Bounds.__default.FlushTriggerWeightUint64() < 18446744073709551616;

function Bounds.__default.FlushTriggerWeightUint64#requires() : bool;

// #requires axiom for Bounds.__default.FlushTriggerWeightUint64
axiom Bounds.__default.FlushTriggerWeightUint64#requires() == true;

// definition axiom for Bounds.__default.FlushTriggerWeightUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeightUint64()
       == LitInt(Div(Bounds.__default.MaxTotalBucketWeightUint64(), LitInt(8)));

// definition axiom for Bounds.__default.FlushTriggerWeightUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeightUint64()
       == LitInt(Div(Bounds.__default.MaxTotalBucketWeightUint64(), LitInt(8)));

// function declaration for Bounds._default.NumBlocksUint64
function Bounds.__default.NumBlocksUint64() : int;

function Bounds.__default.NumBlocksUint64#canCall() : bool;

// consequence axiom for Bounds.__default.NumBlocksUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.NumBlocksUint64()
     && Bounds.__default.NumBlocksUint64() < 18446744073709551616;

function Bounds.__default.NumBlocksUint64#requires() : bool;

// #requires axiom for Bounds.__default.NumBlocksUint64
axiom Bounds.__default.NumBlocksUint64#requires() == true;

// definition axiom for Bounds.__default.NumBlocksUint64(revealed)
axiom true ==> true ==> Bounds.__default.NumBlocksUint64() == LitInt(1048576);

// definition axiom for Bounds.__default.NumBlocksUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.NumBlocksUint64() == LitInt(1048576);

// function declaration for Bounds._default.IndirectionTableMaxSizeUint64
function Bounds.__default.IndirectionTableMaxSizeUint64() : int;

function Bounds.__default.IndirectionTableMaxSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableMaxSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.IndirectionTableMaxSizeUint64()
     && Bounds.__default.IndirectionTableMaxSizeUint64() < 18446744073709551616;

function Bounds.__default.IndirectionTableMaxSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableMaxSizeUint64
axiom Bounds.__default.IndirectionTableMaxSizeUint64#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableMaxSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64() == LitInt(4294967296);

// definition axiom for Bounds.__default.IndirectionTableMaxSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64() == LitInt(4294967296);

// function declaration for Bounds._default.SuperblockSize
function Bounds.__default.SuperblockSize() : int;

function Bounds.__default.SuperblockSize#canCall() : bool;

// consequence axiom for Bounds.__default.SuperblockSize
axiom true ==> true ==> true;

function Bounds.__default.SuperblockSize#requires() : bool;

// #requires axiom for Bounds.__default.SuperblockSize
axiom Bounds.__default.SuperblockSize#requires() == true;

// definition axiom for Bounds.__default.SuperblockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && Bounds.__default.SuperblockSize()
       == LitInt(Bounds.__default.SuperblockSizeUint64());

// definition axiom for Bounds.__default.SuperblockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && Bounds.__default.SuperblockSize()
       == LitInt(Bounds.__default.SuperblockSizeUint64());

// function declaration for Bounds._default.IndirectionTableBlockSize
function Bounds.__default.IndirectionTableBlockSize() : int;

function Bounds.__default.IndirectionTableBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableBlockSize
axiom true ==> true ==> true;

function Bounds.__default.IndirectionTableBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableBlockSize
axiom Bounds.__default.IndirectionTableBlockSize#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSize()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// definition axiom for Bounds.__default.IndirectionTableBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSize()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// function declaration for Bounds._default.NodeBlockSize
function Bounds.__default.NodeBlockSize() : int;

function Bounds.__default.NodeBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.NodeBlockSize
axiom true ==> true ==> true;

function Bounds.__default.NodeBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.NodeBlockSize
axiom Bounds.__default.NodeBlockSize#requires() == true;

// definition axiom for Bounds.__default.NodeBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSize()
       == LitInt(Bounds.__default.NodeBlockSizeUint64());

// definition axiom for Bounds.__default.NodeBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSize()
       == LitInt(Bounds.__default.NodeBlockSizeUint64());

// function declaration for Bounds._default.MinNodeBlockIndex
function Bounds.__default.MinNodeBlockIndex() : int;

function Bounds.__default.MinNodeBlockIndex#canCall() : bool;

// consequence axiom for Bounds.__default.MinNodeBlockIndex
axiom true ==> true ==> true;

function Bounds.__default.MinNodeBlockIndex#requires() : bool;

// #requires axiom for Bounds.__default.MinNodeBlockIndex
axiom Bounds.__default.MinNodeBlockIndex#requires() == true;

// definition axiom for Bounds.__default.MinNodeBlockIndex(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MinNodeBlockIndexUint64#canCall()
     && Bounds.__default.MinNodeBlockIndex()
       == LitInt(Bounds.__default.MinNodeBlockIndexUint64());

// definition axiom for Bounds.__default.MinNodeBlockIndex for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MinNodeBlockIndexUint64#canCall()
     && Bounds.__default.MinNodeBlockIndex()
       == LitInt(Bounds.__default.MinNodeBlockIndexUint64());

// function declaration for Bounds._default.MaxNumChildren
function Bounds.__default.MaxNumChildren() : int;

function Bounds.__default.MaxNumChildren#canCall() : bool;

// consequence axiom for Bounds.__default.MaxNumChildren
axiom true ==> true ==> true;

function Bounds.__default.MaxNumChildren#requires() : bool;

// #requires axiom for Bounds.__default.MaxNumChildren
axiom Bounds.__default.MaxNumChildren#requires() == true;

// definition axiom for Bounds.__default.MaxNumChildren(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxNumChildrenUint64#canCall()
     && Bounds.__default.MaxNumChildren()
       == LitInt(Bounds.__default.MaxNumChildrenUint64());

// definition axiom for Bounds.__default.MaxNumChildren for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxNumChildrenUint64#canCall()
     && Bounds.__default.MaxNumChildren()
       == LitInt(Bounds.__default.MaxNumChildrenUint64());

// function declaration for Bounds._default.MaxTotalBucketWeight
function Bounds.__default.MaxTotalBucketWeight() : int;

function Bounds.__default.MaxTotalBucketWeight#canCall() : bool;

// consequence axiom for Bounds.__default.MaxTotalBucketWeight
axiom true ==> true ==> true;

function Bounds.__default.MaxTotalBucketWeight#requires() : bool;

// #requires axiom for Bounds.__default.MaxTotalBucketWeight
axiom Bounds.__default.MaxTotalBucketWeight#requires() == true;

// definition axiom for Bounds.__default.MaxTotalBucketWeight(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.MaxTotalBucketWeight()
       == LitInt(Bounds.__default.MaxTotalBucketWeightUint64());

// definition axiom for Bounds.__default.MaxTotalBucketWeight for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.MaxTotalBucketWeight()
       == LitInt(Bounds.__default.MaxTotalBucketWeightUint64());

// function declaration for Bounds._default.MaxCacheSize
function Bounds.__default.MaxCacheSize() : int;

function Bounds.__default.MaxCacheSize#canCall() : bool;

// consequence axiom for Bounds.__default.MaxCacheSize
axiom true ==> true ==> true;

function Bounds.__default.MaxCacheSize#requires() : bool;

// #requires axiom for Bounds.__default.MaxCacheSize
axiom Bounds.__default.MaxCacheSize#requires() == true;

// definition axiom for Bounds.__default.MaxCacheSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxCacheSizeUint64#canCall()
     && Bounds.__default.MaxCacheSize() == LitInt(Bounds.__default.MaxCacheSizeUint64());

// definition axiom for Bounds.__default.MaxCacheSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxCacheSizeUint64#canCall()
     && Bounds.__default.MaxCacheSize() == LitInt(Bounds.__default.MaxCacheSizeUint64());

// function declaration for Bounds._default.FlushTriggerWeight
function Bounds.__default.FlushTriggerWeight() : int;

function Bounds.__default.FlushTriggerWeight#canCall() : bool;

// consequence axiom for Bounds.__default.FlushTriggerWeight
axiom true ==> true ==> true;

function Bounds.__default.FlushTriggerWeight#requires() : bool;

// #requires axiom for Bounds.__default.FlushTriggerWeight
axiom Bounds.__default.FlushTriggerWeight#requires() == true;

// definition axiom for Bounds.__default.FlushTriggerWeight(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.FlushTriggerWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeight()
       == LitInt(Bounds.__default.FlushTriggerWeightUint64());

// definition axiom for Bounds.__default.FlushTriggerWeight for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.FlushTriggerWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeight()
       == LitInt(Bounds.__default.FlushTriggerWeightUint64());

// function declaration for Bounds._default.NumBlocks
function Bounds.__default.NumBlocks() : int;

function Bounds.__default.NumBlocks#canCall() : bool;

// consequence axiom for Bounds.__default.NumBlocks
axiom true ==> true ==> true;

function Bounds.__default.NumBlocks#requires() : bool;

// #requires axiom for Bounds.__default.NumBlocks
axiom Bounds.__default.NumBlocks#requires() == true;

// definition axiom for Bounds.__default.NumBlocks(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NumBlocksUint64#canCall()
     && Bounds.__default.NumBlocks() == LitInt(Bounds.__default.NumBlocksUint64());

// definition axiom for Bounds.__default.NumBlocks for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NumBlocksUint64#canCall()
     && Bounds.__default.NumBlocks() == LitInt(Bounds.__default.NumBlocksUint64());

// function declaration for Bounds._default.IndirectionTableMaxSize
function Bounds.__default.IndirectionTableMaxSize() : int;

function Bounds.__default.IndirectionTableMaxSize#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableMaxSize
axiom true ==> true ==> true;

function Bounds.__default.IndirectionTableMaxSize#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableMaxSize
axiom Bounds.__default.IndirectionTableMaxSize#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableMaxSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64#canCall()
     && Bounds.__default.IndirectionTableMaxSize()
       == LitInt(Bounds.__default.IndirectionTableMaxSizeUint64());

// definition axiom for Bounds.__default.IndirectionTableMaxSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64#canCall()
     && Bounds.__default.IndirectionTableMaxSize()
       == LitInt(Bounds.__default.IndirectionTableMaxSizeUint64());

// function declaration for Bounds._default.JournalBlockSize
function Bounds.__default.JournalBlockSize() : int;

function Bounds.__default.JournalBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.JournalBlockSize
axiom true ==> true ==> true;

function Bounds.__default.JournalBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.JournalBlockSize
axiom Bounds.__default.JournalBlockSize#requires() == true;

// definition axiom for Bounds.__default.JournalBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.JournalBlockSize()
       == LitInt(Bounds.__default.JournalBlockSizeUint64());

// definition axiom for Bounds.__default.JournalBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.JournalBlockSize()
       == LitInt(Bounds.__default.JournalBlockSizeUint64());

// function declaration for Bounds._default.DiskNumJournalBlocks
function Bounds.__default.DiskNumJournalBlocks() : int;

function Bounds.__default.DiskNumJournalBlocks#canCall() : bool;

// consequence axiom for Bounds.__default.DiskNumJournalBlocks
axiom true ==> true ==> true;

function Bounds.__default.DiskNumJournalBlocks#requires() : bool;

// #requires axiom for Bounds.__default.DiskNumJournalBlocks
axiom Bounds.__default.DiskNumJournalBlocks#requires() == true;

// definition axiom for Bounds.__default.DiskNumJournalBlocks(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.DiskNumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// definition axiom for Bounds.__default.DiskNumJournalBlocks for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.DiskNumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// Constructor function declaration
function #BucketModel.singleMergeResult.MergeCompleted(Seq Box, Seq Box, int) : DatatypeType;

const unique ##BucketModel.singleMergeResult.MergeCompleted: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box, a#0#1#0: Seq Box, a#0#2#0: int :: 
  { #BucketModel.singleMergeResult.MergeCompleted(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#BucketModel.singleMergeResult.MergeCompleted(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##BucketModel.singleMergeResult.MergeCompleted);

function BucketModel.singleMergeResult.MergeCompleted_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BucketModel.singleMergeResult.MergeCompleted_q(d) } 
  BucketModel.singleMergeResult.MergeCompleted_q(d)
     <==> DatatypeCtorId(d) == ##BucketModel.singleMergeResult.MergeCompleted);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BucketModel.singleMergeResult.MergeCompleted_q(d) } 
  BucketModel.singleMergeResult.MergeCompleted_q(d)
     ==> (exists a#1#0#0: Seq Box, a#1#1#0: Seq Box, a#1#2#0: int :: 
      d == #BucketModel.singleMergeResult.MergeCompleted(a#1#0#0, a#1#1#0, a#1#2#0)));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box, a#2#1#0: Seq Box, a#2#2#0: int :: 
  { $Is(#BucketModel.singleMergeResult.MergeCompleted(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.BucketModel.singleMergeResult()) } 
  $Is(#BucketModel.singleMergeResult.MergeCompleted(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.BucketModel.singleMergeResult())
     <==> $Is(a#2#0#0, TSeq(Tclass.KeyType.Key()))
       && $Is(a#2#1#0, TSeq(Tclass.ValueMessage.Message()))
       && $Is(a#2#2#0, Tclass._System.nat()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, a#3#1#0: Seq Box, a#3#2#0: int, $h: Heap :: 
  { $IsAlloc(#BucketModel.singleMergeResult.MergeCompleted(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.BucketModel.singleMergeResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BucketModel.singleMergeResult.MergeCompleted(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.BucketModel.singleMergeResult(), 
        $h)
       <==> $IsAlloc(a#3#0#0, TSeq(Tclass.KeyType.Key()), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.ValueMessage.Message()), $h)
         && $IsAlloc(a#3#2#0, Tclass._System.nat(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.singleMergeResult.keys(d), TSeq(Tclass.KeyType.Key()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.singleMergeResult.MergeCompleted_q(d)
       && $IsAlloc(d, Tclass.BucketModel.singleMergeResult(), $h)
     ==> $IsAlloc(BucketModel.singleMergeResult.keys(d), TSeq(Tclass.KeyType.Key()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.singleMergeResult.msgs(d), TSeq(Tclass.ValueMessage.Message()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.singleMergeResult.MergeCompleted_q(d)
       && $IsAlloc(d, Tclass.BucketModel.singleMergeResult(), $h)
     ==> $IsAlloc(BucketModel.singleMergeResult.msgs(d), TSeq(Tclass.ValueMessage.Message()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.singleMergeResult.slack(d), Tclass._System.nat(), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.singleMergeResult.MergeCompleted_q(d)
       && $IsAlloc(d, Tclass.BucketModel.singleMergeResult(), $h)
     ==> $IsAlloc(BucketModel.singleMergeResult.slack(d), Tclass._System.nat(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box, a#4#1#0: Seq Box, a#4#2#0: int :: 
  { #BucketModel.singleMergeResult.MergeCompleted(Lit(a#4#0#0), Lit(a#4#1#0), LitInt(a#4#2#0)) } 
  #BucketModel.singleMergeResult.MergeCompleted(Lit(a#4#0#0), Lit(a#4#1#0), LitInt(a#4#2#0))
     == Lit(#BucketModel.singleMergeResult.MergeCompleted(a#4#0#0, a#4#1#0, a#4#2#0)));

function BucketModel.singleMergeResult.keys(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box, a#5#1#0: Seq Box, a#5#2#0: int :: 
  { #BucketModel.singleMergeResult.MergeCompleted(a#5#0#0, a#5#1#0, a#5#2#0) } 
  BucketModel.singleMergeResult.keys(#BucketModel.singleMergeResult.MergeCompleted(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

// Inductive seq element rank
axiom (forall a#6#0#0: Seq Box, a#6#1#0: Seq Box, a#6#2#0: int, i: int :: 
  { Seq#Index(a#6#0#0, i), #BucketModel.singleMergeResult.MergeCompleted(a#6#0#0, a#6#1#0, a#6#2#0) } 
  0 <= i && i < Seq#Length(a#6#0#0)
     ==> DtRank($Unbox(Seq#Index(a#6#0#0, i)): DatatypeType)
       < DtRank(#BucketModel.singleMergeResult.MergeCompleted(a#6#0#0, a#6#1#0, a#6#2#0)));

// Inductive seq rank
axiom (forall a#7#0#0: Seq Box, a#7#1#0: Seq Box, a#7#2#0: int :: 
  { #BucketModel.singleMergeResult.MergeCompleted(a#7#0#0, a#7#1#0, a#7#2#0) } 
  Seq#Rank(a#7#0#0)
     < DtRank(#BucketModel.singleMergeResult.MergeCompleted(a#7#0#0, a#7#1#0, a#7#2#0)));

function BucketModel.singleMergeResult.msgs(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#8#0#0: Seq Box, a#8#1#0: Seq Box, a#8#2#0: int :: 
  { #BucketModel.singleMergeResult.MergeCompleted(a#8#0#0, a#8#1#0, a#8#2#0) } 
  BucketModel.singleMergeResult.msgs(#BucketModel.singleMergeResult.MergeCompleted(a#8#0#0, a#8#1#0, a#8#2#0))
     == a#8#1#0);

// Inductive seq element rank
axiom (forall a#9#0#0: Seq Box, a#9#1#0: Seq Box, a#9#2#0: int, i: int :: 
  { Seq#Index(a#9#1#0, i), #BucketModel.singleMergeResult.MergeCompleted(a#9#0#0, a#9#1#0, a#9#2#0) } 
  0 <= i && i < Seq#Length(a#9#1#0)
     ==> DtRank($Unbox(Seq#Index(a#9#1#0, i)): DatatypeType)
       < DtRank(#BucketModel.singleMergeResult.MergeCompleted(a#9#0#0, a#9#1#0, a#9#2#0)));

// Inductive seq rank
axiom (forall a#10#0#0: Seq Box, a#10#1#0: Seq Box, a#10#2#0: int :: 
  { #BucketModel.singleMergeResult.MergeCompleted(a#10#0#0, a#10#1#0, a#10#2#0) } 
  Seq#Rank(a#10#1#0)
     < DtRank(#BucketModel.singleMergeResult.MergeCompleted(a#10#0#0, a#10#1#0, a#10#2#0)));

function BucketModel.singleMergeResult.slack(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#11#0#0: Seq Box, a#11#1#0: Seq Box, a#11#2#0: int :: 
  { #BucketModel.singleMergeResult.MergeCompleted(a#11#0#0, a#11#1#0, a#11#2#0) } 
  BucketModel.singleMergeResult.slack(#BucketModel.singleMergeResult.MergeCompleted(a#11#0#0, a#11#1#0, a#11#2#0))
     == a#11#2#0);

// Constructor function declaration
function #BucketModel.singleMergeResult.SlackExhausted(Seq Box, Seq Box, int, int) : DatatypeType;

const unique ##BucketModel.singleMergeResult.SlackExhausted: DtCtorId;

// Constructor identifier
axiom (forall a#12#0#0: Seq Box, a#12#1#0: Seq Box, a#12#2#0: int, a#12#3#0: int :: 
  { #BucketModel.singleMergeResult.SlackExhausted(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0) } 
  DatatypeCtorId(#BucketModel.singleMergeResult.SlackExhausted(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0))
     == ##BucketModel.singleMergeResult.SlackExhausted);

function BucketModel.singleMergeResult.SlackExhausted_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BucketModel.singleMergeResult.SlackExhausted_q(d) } 
  BucketModel.singleMergeResult.SlackExhausted_q(d)
     <==> DatatypeCtorId(d) == ##BucketModel.singleMergeResult.SlackExhausted);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BucketModel.singleMergeResult.SlackExhausted_q(d) } 
  BucketModel.singleMergeResult.SlackExhausted_q(d)
     ==> (exists a#13#0#0: Seq Box, a#13#1#0: Seq Box, a#13#2#0: int, a#13#3#0: int :: 
      d
         == #BucketModel.singleMergeResult.SlackExhausted(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0)));

// Constructor $Is
axiom (forall a#14#0#0: Seq Box, a#14#1#0: Seq Box, a#14#2#0: int, a#14#3#0: int :: 
  { $Is(#BucketModel.singleMergeResult.SlackExhausted(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0), 
      Tclass.BucketModel.singleMergeResult()) } 
  $Is(#BucketModel.singleMergeResult.SlackExhausted(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0), 
      Tclass.BucketModel.singleMergeResult())
     <==> $Is(a#14#0#0, TSeq(Tclass.KeyType.Key()))
       && $Is(a#14#1#0, TSeq(Tclass.ValueMessage.Message()))
       && $Is(a#14#2#0, Tclass._System.nat())
       && $Is(a#14#3#0, Tclass._System.nat()));

// Constructor $IsAlloc
axiom (forall a#15#0#0: Seq Box, a#15#1#0: Seq Box, a#15#2#0: int, a#15#3#0: int, $h: Heap :: 
  { $IsAlloc(#BucketModel.singleMergeResult.SlackExhausted(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0), 
      Tclass.BucketModel.singleMergeResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BucketModel.singleMergeResult.SlackExhausted(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0), 
        Tclass.BucketModel.singleMergeResult(), 
        $h)
       <==> $IsAlloc(a#15#0#0, TSeq(Tclass.KeyType.Key()), $h)
         && $IsAlloc(a#15#1#0, TSeq(Tclass.ValueMessage.Message()), $h)
         && $IsAlloc(a#15#2#0, Tclass._System.nat(), $h)
         && $IsAlloc(a#15#3#0, Tclass._System.nat(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.singleMergeResult.keys(d), TSeq(Tclass.KeyType.Key()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.singleMergeResult.SlackExhausted_q(d)
       && $IsAlloc(d, Tclass.BucketModel.singleMergeResult(), $h)
     ==> $IsAlloc(BucketModel.singleMergeResult.keys(d), TSeq(Tclass.KeyType.Key()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.singleMergeResult.msgs(d), TSeq(Tclass.ValueMessage.Message()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.singleMergeResult.SlackExhausted_q(d)
       && $IsAlloc(d, Tclass.BucketModel.singleMergeResult(), $h)
     ==> $IsAlloc(BucketModel.singleMergeResult.msgs(d), TSeq(Tclass.ValueMessage.Message()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.singleMergeResult.end(d), Tclass._System.nat(), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.singleMergeResult.SlackExhausted_q(d)
       && $IsAlloc(d, Tclass.BucketModel.singleMergeResult(), $h)
     ==> $IsAlloc(BucketModel.singleMergeResult.end(d), Tclass._System.nat(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.singleMergeResult.slack(d), Tclass._System.nat(), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.singleMergeResult.SlackExhausted_q(d)
       && $IsAlloc(d, Tclass.BucketModel.singleMergeResult(), $h)
     ==> $IsAlloc(BucketModel.singleMergeResult.slack(d), Tclass._System.nat(), $h));

// Constructor literal
axiom (forall a#16#0#0: Seq Box, a#16#1#0: Seq Box, a#16#2#0: int, a#16#3#0: int :: 
  { #BucketModel.singleMergeResult.SlackExhausted(Lit(a#16#0#0), Lit(a#16#1#0), LitInt(a#16#2#0), LitInt(a#16#3#0)) } 
  #BucketModel.singleMergeResult.SlackExhausted(Lit(a#16#0#0), Lit(a#16#1#0), LitInt(a#16#2#0), LitInt(a#16#3#0))
     == Lit(#BucketModel.singleMergeResult.SlackExhausted(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0)));

// Constructor injectivity
axiom (forall a#17#0#0: Seq Box, a#17#1#0: Seq Box, a#17#2#0: int, a#17#3#0: int :: 
  { #BucketModel.singleMergeResult.SlackExhausted(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0) } 
  BucketModel.singleMergeResult.keys(#BucketModel.singleMergeResult.SlackExhausted(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0))
     == a#17#0#0);

// Inductive seq element rank
axiom (forall a#18#0#0: Seq Box, a#18#1#0: Seq Box, a#18#2#0: int, a#18#3#0: int, i: int :: 
  { Seq#Index(a#18#0#0, i), #BucketModel.singleMergeResult.SlackExhausted(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0) } 
  0 <= i && i < Seq#Length(a#18#0#0)
     ==> DtRank($Unbox(Seq#Index(a#18#0#0, i)): DatatypeType)
       < DtRank(#BucketModel.singleMergeResult.SlackExhausted(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0)));

// Inductive seq rank
axiom (forall a#19#0#0: Seq Box, a#19#1#0: Seq Box, a#19#2#0: int, a#19#3#0: int :: 
  { #BucketModel.singleMergeResult.SlackExhausted(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0) } 
  Seq#Rank(a#19#0#0)
     < DtRank(#BucketModel.singleMergeResult.SlackExhausted(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0)));

// Constructor injectivity
axiom (forall a#20#0#0: Seq Box, a#20#1#0: Seq Box, a#20#2#0: int, a#20#3#0: int :: 
  { #BucketModel.singleMergeResult.SlackExhausted(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0) } 
  BucketModel.singleMergeResult.msgs(#BucketModel.singleMergeResult.SlackExhausted(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0))
     == a#20#1#0);

// Inductive seq element rank
axiom (forall a#21#0#0: Seq Box, a#21#1#0: Seq Box, a#21#2#0: int, a#21#3#0: int, i: int :: 
  { Seq#Index(a#21#1#0, i), #BucketModel.singleMergeResult.SlackExhausted(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0) } 
  0 <= i && i < Seq#Length(a#21#1#0)
     ==> DtRank($Unbox(Seq#Index(a#21#1#0, i)): DatatypeType)
       < DtRank(#BucketModel.singleMergeResult.SlackExhausted(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0)));

// Inductive seq rank
axiom (forall a#22#0#0: Seq Box, a#22#1#0: Seq Box, a#22#2#0: int, a#22#3#0: int :: 
  { #BucketModel.singleMergeResult.SlackExhausted(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0) } 
  Seq#Rank(a#22#1#0)
     < DtRank(#BucketModel.singleMergeResult.SlackExhausted(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0)));

function BucketModel.singleMergeResult.end(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#23#0#0: Seq Box, a#23#1#0: Seq Box, a#23#2#0: int, a#23#3#0: int :: 
  { #BucketModel.singleMergeResult.SlackExhausted(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0) } 
  BucketModel.singleMergeResult.end(#BucketModel.singleMergeResult.SlackExhausted(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0))
     == a#23#2#0);

// Constructor injectivity
axiom (forall a#24#0#0: Seq Box, a#24#1#0: Seq Box, a#24#2#0: int, a#24#3#0: int :: 
  { #BucketModel.singleMergeResult.SlackExhausted(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0) } 
  BucketModel.singleMergeResult.slack(#BucketModel.singleMergeResult.SlackExhausted(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0))
     == a#24#3#0);

// Depth-one case-split function
function $IsA#BucketModel.singleMergeResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BucketModel.singleMergeResult(d) } 
  $IsA#BucketModel.singleMergeResult(d)
     ==> BucketModel.singleMergeResult.MergeCompleted_q(d)
       || BucketModel.singleMergeResult.SlackExhausted_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BucketModel.singleMergeResult.SlackExhausted_q(d), $Is(d, Tclass.BucketModel.singleMergeResult()) } 
    { BucketModel.singleMergeResult.MergeCompleted_q(d), $Is(d, Tclass.BucketModel.singleMergeResult()) } 
  $Is(d, Tclass.BucketModel.singleMergeResult())
     ==> BucketModel.singleMergeResult.MergeCompleted_q(d)
       || BucketModel.singleMergeResult.SlackExhausted_q(d));

// Datatype extensional equality declaration
function BucketModel.singleMergeResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BucketModel.singleMergeResult.MergeCompleted
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketModel.singleMergeResult#Equal(a, b), BucketModel.singleMergeResult.MergeCompleted_q(a) } 
    { BucketModel.singleMergeResult#Equal(a, b), BucketModel.singleMergeResult.MergeCompleted_q(b) } 
  BucketModel.singleMergeResult.MergeCompleted_q(a)
       && BucketModel.singleMergeResult.MergeCompleted_q(b)
     ==> (BucketModel.singleMergeResult#Equal(a, b)
       <==> Seq#Equal(BucketModel.singleMergeResult.keys(a), BucketModel.singleMergeResult.keys(b))
         && Seq#Equal(BucketModel.singleMergeResult.msgs(a), BucketModel.singleMergeResult.msgs(b))
         && BucketModel.singleMergeResult.slack(a) == BucketModel.singleMergeResult.slack(b)));

// Datatype extensional equality definition: #BucketModel.singleMergeResult.SlackExhausted
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketModel.singleMergeResult#Equal(a, b), BucketModel.singleMergeResult.SlackExhausted_q(a) } 
    { BucketModel.singleMergeResult#Equal(a, b), BucketModel.singleMergeResult.SlackExhausted_q(b) } 
  BucketModel.singleMergeResult.SlackExhausted_q(a)
       && BucketModel.singleMergeResult.SlackExhausted_q(b)
     ==> (BucketModel.singleMergeResult#Equal(a, b)
       <==> Seq#Equal(BucketModel.singleMergeResult.keys(a), BucketModel.singleMergeResult.keys(b))
         && Seq#Equal(BucketModel.singleMergeResult.msgs(a), BucketModel.singleMergeResult.msgs(b))
         && BucketModel.singleMergeResult.end(a) == BucketModel.singleMergeResult.end(b)
         && BucketModel.singleMergeResult.slack(a) == BucketModel.singleMergeResult.slack(b)));

// Datatype extensionality axiom: BucketModel.singleMergeResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketModel.singleMergeResult#Equal(a, b) } 
  BucketModel.singleMergeResult#Equal(a, b) <==> a == b);

const unique class.BucketModel.singleMergeResult: ClassName;

// function declaration for BucketModel.singleMergeResult.bucketMap
function BucketModel.singleMergeResult.bucketMap(this: DatatypeType) : Map Box Box;

function BucketModel.singleMergeResult.bucketMap#canCall(this: DatatypeType) : bool;

// consequence axiom for BucketModel.singleMergeResult.bucketMap
axiom true
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { BucketModel.singleMergeResult.bucketMap(this), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.bucketMap#canCall(this)
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && Seq#Length(BucketModel.singleMergeResult.keys(this))
             == Seq#Length(BucketModel.singleMergeResult.msgs(this)))
       ==> $Is(BucketModel.singleMergeResult.bucketMap(this), 
        TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

function BucketModel.singleMergeResult.bucketMap#requires(DatatypeType) : bool;

// #requires axiom for BucketModel.singleMergeResult.bucketMap
axiom (forall $Heap: Heap, this: DatatypeType :: 
  { BucketModel.singleMergeResult.bucketMap#requires(this), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.BucketModel.singleMergeResult())
       && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
     ==> BucketModel.singleMergeResult.bucketMap#requires(this)
       == 
      (Seq#Length(BucketModel.singleMergeResult.keys(this))
       == Seq#Length(BucketModel.singleMergeResult.msgs(this))));

// definition axiom for BucketModel.singleMergeResult.bucketMap(revealed)
axiom true
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    { BucketModel.singleMergeResult.bucketMap(this), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.bucketMap#canCall(this)
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && Seq#Length(BucketModel.singleMergeResult.keys(this))
             == Seq#Length(BucketModel.singleMergeResult.msgs(this)))
       ==> (BucketModel.singleMergeResult.MergeCompleted_q(this)
           || BucketModel.singleMergeResult.SlackExhausted_q(this))
         && (BucketModel.singleMergeResult.MergeCompleted_q(this)
           || BucketModel.singleMergeResult.SlackExhausted_q(this))
         && BucketsLib.__default.BucketMapOfSeq#canCall(BucketModel.singleMergeResult.keys(this), 
          BucketModel.singleMergeResult.msgs(this))
         && BucketModel.singleMergeResult.bucketMap(this)
           == BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
            BucketModel.singleMergeResult.keys(this), 
            BucketModel.singleMergeResult.msgs(this)));

// definition axiom for BucketModel.singleMergeResult.bucketMap for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, this: DatatypeType :: 
    {:weight 3} { BucketModel.singleMergeResult.bucketMap(Lit(this)), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.bucketMap#canCall(Lit(this))
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && Seq#Length(Lit(BucketModel.singleMergeResult.keys(Lit(this))))
             == Seq#Length(Lit(BucketModel.singleMergeResult.msgs(Lit(this)))))
       ==> (BucketModel.singleMergeResult.MergeCompleted_q(Lit(this))
           || BucketModel.singleMergeResult.SlackExhausted_q(Lit(this)))
         && (BucketModel.singleMergeResult.MergeCompleted_q(Lit(this))
           || BucketModel.singleMergeResult.SlackExhausted_q(Lit(this)))
         && BucketsLib.__default.BucketMapOfSeq#canCall(Lit(BucketModel.singleMergeResult.keys(Lit(this))), 
          Lit(BucketModel.singleMergeResult.msgs(Lit(this))))
         && BucketModel.singleMergeResult.bucketMap(Lit(this))
           == BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
            Lit(BucketModel.singleMergeResult.keys(Lit(this))), 
            Lit(BucketModel.singleMergeResult.msgs(Lit(this)))));

// function declaration for BucketModel.singleMergeResult.flushedKeys
function BucketModel.singleMergeResult.flushedKeys(this: DatatypeType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int)
   : Set Box;

function BucketModel.singleMergeResult.flushedKeys#canCall(this: DatatypeType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int)
   : bool;

// consequence axiom for BucketModel.singleMergeResult.flushedKeys
axiom true
   ==> (forall $Heap: Heap, 
      this: DatatypeType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int :: 
    { BucketModel.singleMergeResult.flushedKeys(this, top_keys#0, top_msgs#0, from#0, to#0), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.flushedKeys#canCall(this, top_keys#0, top_msgs#0, from#0, to#0)
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(top_keys#0)
           && Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
           && (BucketModel.singleMergeResult.SlackExhausted_q(this)
             ==> from#0 <= BucketModel.singleMergeResult.end(this)
               && BucketModel.singleMergeResult.end(this) <= Seq#Length(top_keys#0)))
       ==> $Is(BucketModel.singleMergeResult.flushedKeys(this, top_keys#0, top_msgs#0, from#0, to#0), 
        TSet(Tclass.KeyType.Key())));

function BucketModel.singleMergeResult.flushedKeys#requires(DatatypeType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for BucketModel.singleMergeResult.flushedKeys
axiom (forall $Heap: Heap, 
    this: DatatypeType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int :: 
  { BucketModel.singleMergeResult.flushedKeys#requires(this, top_keys#0, top_msgs#0, from#0, to#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.BucketModel.singleMergeResult())
       && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
       && $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
       && LitInt(0) <= from#0
       && LitInt(0) <= to#0
     ==> BucketModel.singleMergeResult.flushedKeys#requires(this, top_keys#0, top_msgs#0, from#0, to#0)
       == (
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= Seq#Length(top_keys#0)
         && Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
         && (BucketModel.singleMergeResult.SlackExhausted_q(this)
           ==> from#0 <= BucketModel.singleMergeResult.end(this)
             && BucketModel.singleMergeResult.end(this) <= Seq#Length(top_keys#0))));

// definition axiom for BucketModel.singleMergeResult.flushedKeys(revealed)
axiom true
   ==> (forall $Heap: Heap, 
      this: DatatypeType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int :: 
    { BucketModel.singleMergeResult.flushedKeys(this, top_keys#0, top_msgs#0, from#0, to#0), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.flushedKeys#canCall(this, top_keys#0, top_msgs#0, from#0, to#0)
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(top_keys#0)
           && Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
           && (BucketModel.singleMergeResult.SlackExhausted_q(this)
             ==> from#0 <= BucketModel.singleMergeResult.end(this)
               && BucketModel.singleMergeResult.end(this) <= Seq#Length(top_keys#0)))
       ==> BucketModel.singleMergeResult.flushedKeys(this, top_keys#0, top_msgs#0, from#0, to#0)
         == (if BucketModel.singleMergeResult.MergeCompleted_q(this)
           then (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && Seq#Contains(Seq#Drop(Seq#Take(top_keys#0, to#0), from#0), $y#0))
           else (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && Seq#Contains(Seq#Drop(Seq#Take(top_keys#0, BucketModel.singleMergeResult.end(this)), from#0), 
                $y#1))));

// definition axiom for BucketModel.singleMergeResult.flushedKeys for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, 
      this: DatatypeType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int :: 
    {:weight 3} { BucketModel.singleMergeResult.flushedKeys(Lit(this), Lit(top_keys#0), Lit(top_msgs#0), LitInt(from#0), LitInt(to#0)), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.flushedKeys#canCall(Lit(this), Lit(top_keys#0), Lit(top_msgs#0), LitInt(from#0), LitInt(to#0))
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= Seq#Length(Lit(top_keys#0))
           && Seq#Length(Lit(top_keys#0)) == Seq#Length(Lit(top_msgs#0))
           && (BucketModel.singleMergeResult.SlackExhausted_q(Lit(this))
             ==> LitInt(from#0) <= LitInt(BucketModel.singleMergeResult.end(Lit(this)))
               && LitInt(BucketModel.singleMergeResult.end(Lit(this)))
                 <= Seq#Length(Lit(top_keys#0))))
       ==> BucketModel.singleMergeResult.flushedKeys(Lit(this), Lit(top_keys#0), Lit(top_msgs#0), LitInt(from#0), LitInt(to#0))
         == (if BucketModel.singleMergeResult.MergeCompleted_q(Lit(this))
           then (lambda $y#2: Box :: 
            $IsBox($y#2, Tclass.KeyType.Key())
               && Seq#Contains(Seq#Drop(Seq#Take(Lit(top_keys#0), LitInt(to#0)), LitInt(from#0)), $y#2))
           else (lambda $y#3: Box :: 
            $IsBox($y#3, Tclass.KeyType.Key())
               && Seq#Contains(Seq#Drop(Seq#Take(Lit(top_keys#0), LitInt(BucketModel.singleMergeResult.end(Lit(this)))), 
                  LitInt(from#0)), 
                $y#3))));

// function declaration for BucketModel.singleMergeResult.flushedMap
function BucketModel.singleMergeResult.flushedMap(this: DatatypeType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int)
   : Map Box Box;

function BucketModel.singleMergeResult.flushedMap#canCall(this: DatatypeType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int)
   : bool;

// consequence axiom for BucketModel.singleMergeResult.flushedMap
axiom true
   ==> (forall $Heap: Heap, 
      this: DatatypeType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int :: 
    { BucketModel.singleMergeResult.flushedMap(this, top_keys#0, top_msgs#0, from#0, to#0), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.flushedMap#canCall(this, top_keys#0, top_msgs#0, from#0, to#0)
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(top_keys#0)
           && Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
           && (BucketModel.singleMergeResult.SlackExhausted_q(this)
             ==> from#0 <= BucketModel.singleMergeResult.end(this)
               && BucketModel.singleMergeResult.end(this) <= Seq#Length(top_keys#0)))
       ==> $Is(BucketModel.singleMergeResult.flushedMap(this, top_keys#0, top_msgs#0, from#0, to#0), 
        TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

function BucketModel.singleMergeResult.flushedMap#requires(DatatypeType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for BucketModel.singleMergeResult.flushedMap
axiom (forall $Heap: Heap, 
    this: DatatypeType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int :: 
  { BucketModel.singleMergeResult.flushedMap#requires(this, top_keys#0, top_msgs#0, from#0, to#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && 
      $Is(this, Tclass.BucketModel.singleMergeResult())
       && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
       && $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
       && LitInt(0) <= from#0
       && LitInt(0) <= to#0
     ==> BucketModel.singleMergeResult.flushedMap#requires(this, top_keys#0, top_msgs#0, from#0, to#0)
       == (
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= Seq#Length(top_keys#0)
         && Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
         && (BucketModel.singleMergeResult.SlackExhausted_q(this)
           ==> from#0 <= BucketModel.singleMergeResult.end(this)
             && BucketModel.singleMergeResult.end(this) <= Seq#Length(top_keys#0))));

// definition axiom for BucketModel.singleMergeResult.flushedMap(revealed)
axiom true
   ==> (forall $Heap: Heap, 
      this: DatatypeType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int :: 
    { BucketModel.singleMergeResult.flushedMap(this, top_keys#0, top_msgs#0, from#0, to#0), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.flushedMap#canCall(this, top_keys#0, top_msgs#0, from#0, to#0)
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(top_keys#0)
           && Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
           && (BucketModel.singleMergeResult.SlackExhausted_q(this)
             ==> from#0 <= BucketModel.singleMergeResult.end(this)
               && BucketModel.singleMergeResult.end(this) <= Seq#Length(top_keys#0)))
       ==> BucketsLib.__default.BucketMapOfSeq#canCall(Seq#Drop(Seq#Take(top_keys#0, to#0), from#0), 
          Seq#Drop(Seq#Take(top_msgs#0, to#0), from#0))
         && (var top#0 := BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
              Seq#Drop(Seq#Take(top_keys#0, to#0), from#0), 
              Seq#Drop(Seq#Take(top_msgs#0, to#0), from#0)); 
          (forall key#0: Seq Box :: 
            { $Unbox(Map#Elements(top#0)[$Box(key#0)]): DatatypeType } 
              { BucketModel.singleMergeResult.flushedKeys(this, top_keys#0, top_msgs#0, from#0, to#0)[$Box(key#0)] } 
              { Map#Domain(top#0)[$Box(key#0)] } 
            $Is(key#0, Tclass.KeyType.Key())
               ==> 
              Map#Domain(top#0)[$Box(key#0)]
               ==> BucketModel.singleMergeResult.flushedKeys#canCall(this, top_keys#0, top_msgs#0, from#0, to#0)))
         && BucketModel.singleMergeResult.flushedMap(this, top_keys#0, top_msgs#0, from#0, to#0)
           == (var top#0 := BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
                Seq#Drop(Seq#Take(top_keys#0, to#0), from#0), 
                Seq#Drop(Seq#Take(top_msgs#0, to#0), from#0)); 
            Map#Glue((lambda $w#0: Box :: 
                $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(top#0)[$w#0]
                   && BucketModel.singleMergeResult.flushedKeys(this, top_keys#0, top_msgs#0, from#0, to#0)[$w#0]), 
              (lambda $w#0: Box :: Map#Elements(top#0)[$w#0]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketModel.singleMergeResult.flushedMap for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, 
      this: DatatypeType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int :: 
    {:weight 3} { BucketModel.singleMergeResult.flushedMap(Lit(this), Lit(top_keys#0), Lit(top_msgs#0), LitInt(from#0), LitInt(to#0)), $IsGoodHeap($Heap) } 
    BucketModel.singleMergeResult.flushedMap#canCall(Lit(this), Lit(top_keys#0), Lit(top_msgs#0), LitInt(from#0), LitInt(to#0))
         || (
          $IsGoodHeap($Heap)
           && 
          $Is(this, Tclass.BucketModel.singleMergeResult())
           && $IsAlloc(this, Tclass.BucketModel.singleMergeResult(), $Heap)
           && $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= Seq#Length(Lit(top_keys#0))
           && Seq#Length(Lit(top_keys#0)) == Seq#Length(Lit(top_msgs#0))
           && (BucketModel.singleMergeResult.SlackExhausted_q(Lit(this))
             ==> LitInt(from#0) <= LitInt(BucketModel.singleMergeResult.end(Lit(this)))
               && LitInt(BucketModel.singleMergeResult.end(Lit(this)))
                 <= Seq#Length(Lit(top_keys#0))))
       ==> BucketsLib.__default.BucketMapOfSeq#canCall(Lit(Seq#Drop(Seq#Take(Lit(top_keys#0), LitInt(to#0)), LitInt(from#0))), 
          Lit(Seq#Drop(Seq#Take(Lit(top_msgs#0), LitInt(to#0)), LitInt(from#0))))
         && (var top#1 := BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
              Lit(Seq#Drop(Seq#Take(Lit(top_keys#0), LitInt(to#0)), LitInt(from#0))), 
              Lit(Seq#Drop(Seq#Take(Lit(top_msgs#0), LitInt(to#0)), LitInt(from#0)))); 
          (forall key#0: Seq Box :: 
            { $Unbox(Map#Elements(top#1)[$Box(key#0)]): DatatypeType } 
              { BucketModel.singleMergeResult.flushedKeys(this, top_keys#0, top_msgs#0, from#0, to#0)[$Box(key#0)] } 
              { Map#Domain(top#1)[$Box(key#0)] } 
            $Is(key#0, Tclass.KeyType.Key())
               ==> 
              Map#Domain(top#1)[$Box(key#0)]
               ==> BucketModel.singleMergeResult.flushedKeys#canCall(Lit(this), Lit(top_keys#0), Lit(top_msgs#0), LitInt(from#0), LitInt(to#0))))
         && BucketModel.singleMergeResult.flushedMap(Lit(this), Lit(top_keys#0), Lit(top_msgs#0), LitInt(from#0), LitInt(to#0))
           == (var top#1 := BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
                Lit(Seq#Drop(Seq#Take(Lit(top_keys#0), LitInt(to#0)), LitInt(from#0))), 
                Lit(Seq#Drop(Seq#Take(Lit(top_msgs#0), LitInt(to#0)), LitInt(from#0)))); 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(top#1)[$w#1]
                   && Lit(BucketModel.singleMergeResult.flushedKeys(Lit(this), Lit(top_keys#0), Lit(top_msgs#0), LitInt(from#0), LitInt(to#0)))[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(top#1)[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// Constructor function declaration
function #BucketModel.mergeResult.mergeResult(DatatypeType, Seq Box, int) : DatatypeType;

const unique ##BucketModel.mergeResult.mergeResult: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: Seq Box, a#0#2#0: int :: 
  { #BucketModel.mergeResult.mergeResult(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#BucketModel.mergeResult.mergeResult(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##BucketModel.mergeResult.mergeResult);

function BucketModel.mergeResult.mergeResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BucketModel.mergeResult.mergeResult_q(d) } 
  BucketModel.mergeResult.mergeResult_q(d)
     <==> DatatypeCtorId(d) == ##BucketModel.mergeResult.mergeResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BucketModel.mergeResult.mergeResult_q(d) } 
  BucketModel.mergeResult.mergeResult_q(d)
     ==> (exists a#1#0#0: DatatypeType, a#1#1#0: Seq Box, a#1#2#0: int :: 
      d == #BucketModel.mergeResult.mergeResult(a#1#0#0, a#1#1#0, a#1#2#0)));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType, a#2#1#0: Seq Box, a#2#2#0: int :: 
  { $Is(#BucketModel.mergeResult.mergeResult(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.BucketModel.mergeResult()) } 
  $Is(#BucketModel.mergeResult.mergeResult(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.BucketModel.mergeResult())
     <==> $Is(a#2#0#0, Tclass.BucketsLib.Bucket())
       && $Is(a#2#1#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(a#2#2#0, Tclass._System.nat()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Seq Box, a#3#2#0: int, $h: Heap :: 
  { $IsAlloc(#BucketModel.mergeResult.mergeResult(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.BucketModel.mergeResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BucketModel.mergeResult.mergeResult(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.BucketModel.mergeResult(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.BucketsLib.Bucket(), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.BucketsLib.Bucket()), $h)
         && $IsAlloc(a#3#2#0, Tclass._System.nat(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.mergeResult.top(d), Tclass.BucketsLib.Bucket(), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.mergeResult.mergeResult_q(d)
       && $IsAlloc(d, Tclass.BucketModel.mergeResult(), $h)
     ==> $IsAlloc(BucketModel.mergeResult.top(d), Tclass.BucketsLib.Bucket(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.mergeResult.bots(d), TSeq(Tclass.BucketsLib.Bucket()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.mergeResult.mergeResult_q(d)
       && $IsAlloc(d, Tclass.BucketModel.mergeResult(), $h)
     ==> $IsAlloc(BucketModel.mergeResult.bots(d), TSeq(Tclass.BucketsLib.Bucket()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.mergeResult.slack(d), Tclass._System.nat(), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.mergeResult.mergeResult_q(d)
       && $IsAlloc(d, Tclass.BucketModel.mergeResult(), $h)
     ==> $IsAlloc(BucketModel.mergeResult.slack(d), Tclass._System.nat(), $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Seq Box, a#4#2#0: int :: 
  { #BucketModel.mergeResult.mergeResult(Lit(a#4#0#0), Lit(a#4#1#0), LitInt(a#4#2#0)) } 
  #BucketModel.mergeResult.mergeResult(Lit(a#4#0#0), Lit(a#4#1#0), LitInt(a#4#2#0))
     == Lit(#BucketModel.mergeResult.mergeResult(a#4#0#0, a#4#1#0, a#4#2#0)));

function BucketModel.mergeResult.top(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Seq Box, a#5#2#0: int :: 
  { #BucketModel.mergeResult.mergeResult(a#5#0#0, a#5#1#0, a#5#2#0) } 
  BucketModel.mergeResult.top(#BucketModel.mergeResult.mergeResult(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Seq Box, a#6#2#0: int :: 
  { #BucketModel.mergeResult.mergeResult(a#6#0#0, a#6#1#0, a#6#2#0) } 
  DtRank(a#6#0#0)
     < DtRank(#BucketModel.mergeResult.mergeResult(a#6#0#0, a#6#1#0, a#6#2#0)));

function BucketModel.mergeResult.bots(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Seq Box, a#7#2#0: int :: 
  { #BucketModel.mergeResult.mergeResult(a#7#0#0, a#7#1#0, a#7#2#0) } 
  BucketModel.mergeResult.bots(#BucketModel.mergeResult.mergeResult(a#7#0#0, a#7#1#0, a#7#2#0))
     == a#7#1#0);

// Inductive seq element rank
axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Seq Box, a#8#2#0: int, i: int :: 
  { Seq#Index(a#8#1#0, i), #BucketModel.mergeResult.mergeResult(a#8#0#0, a#8#1#0, a#8#2#0) } 
  0 <= i && i < Seq#Length(a#8#1#0)
     ==> DtRank($Unbox(Seq#Index(a#8#1#0, i)): DatatypeType)
       < DtRank(#BucketModel.mergeResult.mergeResult(a#8#0#0, a#8#1#0, a#8#2#0)));

// Inductive seq rank
axiom (forall a#9#0#0: DatatypeType, a#9#1#0: Seq Box, a#9#2#0: int :: 
  { #BucketModel.mergeResult.mergeResult(a#9#0#0, a#9#1#0, a#9#2#0) } 
  Seq#Rank(a#9#1#0)
     < DtRank(#BucketModel.mergeResult.mergeResult(a#9#0#0, a#9#1#0, a#9#2#0)));

function BucketModel.mergeResult.slack(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#10#0#0: DatatypeType, a#10#1#0: Seq Box, a#10#2#0: int :: 
  { #BucketModel.mergeResult.mergeResult(a#10#0#0, a#10#1#0, a#10#2#0) } 
  BucketModel.mergeResult.slack(#BucketModel.mergeResult.mergeResult(a#10#0#0, a#10#1#0, a#10#2#0))
     == a#10#2#0);

// Depth-one case-split function
function $IsA#BucketModel.mergeResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BucketModel.mergeResult(d) } 
  $IsA#BucketModel.mergeResult(d) ==> BucketModel.mergeResult.mergeResult_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BucketModel.mergeResult.mergeResult_q(d), $Is(d, Tclass.BucketModel.mergeResult()) } 
  $Is(d, Tclass.BucketModel.mergeResult())
     ==> BucketModel.mergeResult.mergeResult_q(d));

// Datatype extensional equality declaration
function BucketModel.mergeResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BucketModel.mergeResult.mergeResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketModel.mergeResult#Equal(a, b) } 
  true
     ==> (BucketModel.mergeResult#Equal(a, b)
       <==> BucketsLib.Bucket#Equal(BucketModel.mergeResult.top(a), BucketModel.mergeResult.top(b))
         && Seq#Equal(BucketModel.mergeResult.bots(a), BucketModel.mergeResult.bots(b))
         && BucketModel.mergeResult.slack(a) == BucketModel.mergeResult.slack(b)));

// Datatype extensionality axiom: BucketModel.mergeResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketModel.mergeResult#Equal(a, b) } 
  BucketModel.mergeResult#Equal(a, b) <==> a == b);

const unique class.BucketModel.mergeResult: ClassName;

// Constructor function declaration
function #BucketModel.partialFlushResult.partialFlushResult(DatatypeType, Seq Box) : DatatypeType;

const unique ##BucketModel.partialFlushResult.partialFlushResult: DtCtorId;

// Constructor identifier
axiom (forall a#11#0#0: DatatypeType, a#11#1#0: Seq Box :: 
  { #BucketModel.partialFlushResult.partialFlushResult(a#11#0#0, a#11#1#0) } 
  DatatypeCtorId(#BucketModel.partialFlushResult.partialFlushResult(a#11#0#0, a#11#1#0))
     == ##BucketModel.partialFlushResult.partialFlushResult);

function BucketModel.partialFlushResult.partialFlushResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BucketModel.partialFlushResult.partialFlushResult_q(d) } 
  BucketModel.partialFlushResult.partialFlushResult_q(d)
     <==> DatatypeCtorId(d) == ##BucketModel.partialFlushResult.partialFlushResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BucketModel.partialFlushResult.partialFlushResult_q(d) } 
  BucketModel.partialFlushResult.partialFlushResult_q(d)
     ==> (exists a#12#0#0: DatatypeType, a#12#1#0: Seq Box :: 
      d == #BucketModel.partialFlushResult.partialFlushResult(a#12#0#0, a#12#1#0)));

// Constructor $Is
axiom (forall a#13#0#0: DatatypeType, a#13#1#0: Seq Box :: 
  { $Is(#BucketModel.partialFlushResult.partialFlushResult(a#13#0#0, a#13#1#0), 
      Tclass.BucketModel.partialFlushResult()) } 
  $Is(#BucketModel.partialFlushResult.partialFlushResult(a#13#0#0, a#13#1#0), 
      Tclass.BucketModel.partialFlushResult())
     <==> $Is(a#13#0#0, Tclass.BucketsLib.Bucket())
       && $Is(a#13#1#0, TSeq(Tclass.BucketsLib.Bucket())));

// Constructor $IsAlloc
axiom (forall a#14#0#0: DatatypeType, a#14#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#BucketModel.partialFlushResult.partialFlushResult(a#14#0#0, a#14#1#0), 
      Tclass.BucketModel.partialFlushResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BucketModel.partialFlushResult.partialFlushResult(a#14#0#0, a#14#1#0), 
        Tclass.BucketModel.partialFlushResult(), 
        $h)
       <==> $IsAlloc(a#14#0#0, Tclass.BucketsLib.Bucket(), $h)
         && $IsAlloc(a#14#1#0, TSeq(Tclass.BucketsLib.Bucket()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.partialFlushResult.top(d), Tclass.BucketsLib.Bucket(), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.partialFlushResult.partialFlushResult_q(d)
       && $IsAlloc(d, Tclass.BucketModel.partialFlushResult(), $h)
     ==> $IsAlloc(BucketModel.partialFlushResult.top(d), Tclass.BucketsLib.Bucket(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketModel.partialFlushResult.bots(d), TSeq(Tclass.BucketsLib.Bucket()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketModel.partialFlushResult.partialFlushResult_q(d)
       && $IsAlloc(d, Tclass.BucketModel.partialFlushResult(), $h)
     ==> $IsAlloc(BucketModel.partialFlushResult.bots(d), TSeq(Tclass.BucketsLib.Bucket()), $h));

// Constructor literal
axiom (forall a#15#0#0: DatatypeType, a#15#1#0: Seq Box :: 
  { #BucketModel.partialFlushResult.partialFlushResult(Lit(a#15#0#0), Lit(a#15#1#0)) } 
  #BucketModel.partialFlushResult.partialFlushResult(Lit(a#15#0#0), Lit(a#15#1#0))
     == Lit(#BucketModel.partialFlushResult.partialFlushResult(a#15#0#0, a#15#1#0)));

function BucketModel.partialFlushResult.top(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#16#0#0: DatatypeType, a#16#1#0: Seq Box :: 
  { #BucketModel.partialFlushResult.partialFlushResult(a#16#0#0, a#16#1#0) } 
  BucketModel.partialFlushResult.top(#BucketModel.partialFlushResult.partialFlushResult(a#16#0#0, a#16#1#0))
     == a#16#0#0);

// Inductive rank
axiom (forall a#17#0#0: DatatypeType, a#17#1#0: Seq Box :: 
  { #BucketModel.partialFlushResult.partialFlushResult(a#17#0#0, a#17#1#0) } 
  DtRank(a#17#0#0)
     < DtRank(#BucketModel.partialFlushResult.partialFlushResult(a#17#0#0, a#17#1#0)));

function BucketModel.partialFlushResult.bots(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#18#0#0: DatatypeType, a#18#1#0: Seq Box :: 
  { #BucketModel.partialFlushResult.partialFlushResult(a#18#0#0, a#18#1#0) } 
  BucketModel.partialFlushResult.bots(#BucketModel.partialFlushResult.partialFlushResult(a#18#0#0, a#18#1#0))
     == a#18#1#0);

// Inductive seq element rank
axiom (forall a#19#0#0: DatatypeType, a#19#1#0: Seq Box, i: int :: 
  { Seq#Index(a#19#1#0, i), #BucketModel.partialFlushResult.partialFlushResult(a#19#0#0, a#19#1#0) } 
  0 <= i && i < Seq#Length(a#19#1#0)
     ==> DtRank($Unbox(Seq#Index(a#19#1#0, i)): DatatypeType)
       < DtRank(#BucketModel.partialFlushResult.partialFlushResult(a#19#0#0, a#19#1#0)));

// Inductive seq rank
axiom (forall a#20#0#0: DatatypeType, a#20#1#0: Seq Box :: 
  { #BucketModel.partialFlushResult.partialFlushResult(a#20#0#0, a#20#1#0) } 
  Seq#Rank(a#20#1#0)
     < DtRank(#BucketModel.partialFlushResult.partialFlushResult(a#20#0#0, a#20#1#0)));

// Depth-one case-split function
function $IsA#BucketModel.partialFlushResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BucketModel.partialFlushResult(d) } 
  $IsA#BucketModel.partialFlushResult(d)
     ==> BucketModel.partialFlushResult.partialFlushResult_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BucketModel.partialFlushResult.partialFlushResult_q(d), $Is(d, Tclass.BucketModel.partialFlushResult()) } 
  $Is(d, Tclass.BucketModel.partialFlushResult())
     ==> BucketModel.partialFlushResult.partialFlushResult_q(d));

// Datatype extensional equality declaration
function BucketModel.partialFlushResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BucketModel.partialFlushResult.partialFlushResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketModel.partialFlushResult#Equal(a, b) } 
  true
     ==> (BucketModel.partialFlushResult#Equal(a, b)
       <==> BucketsLib.Bucket#Equal(BucketModel.partialFlushResult.top(a), BucketModel.partialFlushResult.top(b))
         && Seq#Equal(BucketModel.partialFlushResult.bots(a), BucketModel.partialFlushResult.bots(b))));

// Datatype extensionality axiom: BucketModel.partialFlushResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketModel.partialFlushResult#Equal(a, b) } 
  BucketModel.partialFlushResult#Equal(a, b) <==> a == b);

const unique class.BucketModel.partialFlushResult: ClassName;

const unique class.BucketModel.__default: ClassName;

function Tclass.BucketModel.__default() : Ty;

// Tclass.BucketModel.__default Tag
axiom Tag(Tclass.BucketModel.__default()) == Tagclass.BucketModel.__default;

const unique Tagclass.BucketModel.__default: TyTag;

// Box/unbox axiom for Tclass.BucketModel.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketModel.__default()) } 
  $IsBox(bx, Tclass.BucketModel.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BucketModel.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BucketModel.__default()) } 
  $Is($o, Tclass.BucketModel.__default())
     <==> $o == null || dtype($o) == Tclass.BucketModel.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BucketModel.__default(), $h) } 
  $IsAlloc($o, Tclass.BucketModel.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BucketModel._default.mergeToOneChild
function BucketModel.__default.mergeToOneChild($ly: LayerType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int, 
    bot_keys#0: Seq Box, 
    bot_msgs#0: Seq Box, 
    bot_from#0: int, 
    acc_keys#0: Seq Box, 
    acc_msgs#0: Seq Box, 
    slack#0: int)
   : DatatypeType;

function BucketModel.__default.mergeToOneChild#canCall(top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int, 
    bot_keys#0: Seq Box, 
    bot_msgs#0: Seq Box, 
    bot_from#0: int, 
    acc_keys#0: Seq Box, 
    acc_msgs#0: Seq Box, 
    slack#0: int)
   : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int, 
    bot_keys#0: Seq Box, 
    bot_msgs#0: Seq Box, 
    bot_from#0: int, 
    acc_keys#0: Seq Box, 
    acc_msgs#0: Seq Box, 
    slack#0: int :: 
  { BucketModel.__default.mergeToOneChild($LS($ly), 
      top_keys#0, 
      top_msgs#0, 
      from#0, 
      to#0, 
      bot_keys#0, 
      bot_msgs#0, 
      bot_from#0, 
      acc_keys#0, 
      acc_msgs#0, 
      slack#0) } 
  BucketModel.__default.mergeToOneChild($LS($ly), 
      top_keys#0, 
      top_msgs#0, 
      from#0, 
      to#0, 
      bot_keys#0, 
      bot_msgs#0, 
      bot_from#0, 
      acc_keys#0, 
      acc_msgs#0, 
      slack#0)
     == BucketModel.__default.mergeToOneChild($ly, 
      top_keys#0, 
      top_msgs#0, 
      from#0, 
      to#0, 
      bot_keys#0, 
      bot_msgs#0, 
      bot_from#0, 
      acc_keys#0, 
      acc_msgs#0, 
      slack#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int, 
    bot_keys#0: Seq Box, 
    bot_msgs#0: Seq Box, 
    bot_from#0: int, 
    acc_keys#0: Seq Box, 
    acc_msgs#0: Seq Box, 
    slack#0: int :: 
  { BucketModel.__default.mergeToOneChild(AsFuelBottom($ly), 
      top_keys#0, 
      top_msgs#0, 
      from#0, 
      to#0, 
      bot_keys#0, 
      bot_msgs#0, 
      bot_from#0, 
      acc_keys#0, 
      acc_msgs#0, 
      slack#0) } 
  BucketModel.__default.mergeToOneChild($ly, 
      top_keys#0, 
      top_msgs#0, 
      from#0, 
      to#0, 
      bot_keys#0, 
      bot_msgs#0, 
      bot_from#0, 
      acc_keys#0, 
      acc_msgs#0, 
      slack#0)
     == BucketModel.__default.mergeToOneChild($LZ, 
      top_keys#0, 
      top_msgs#0, 
      from#0, 
      to#0, 
      bot_keys#0, 
      bot_msgs#0, 
      bot_from#0, 
      acc_keys#0, 
      acc_msgs#0, 
      slack#0));

// consequence axiom for BucketModel.__default.mergeToOneChild
axiom true
   ==> (forall $ly: LayerType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int, 
      bot_keys#0: Seq Box, 
      bot_msgs#0: Seq Box, 
      bot_from#0: int, 
      acc_keys#0: Seq Box, 
      acc_msgs#0: Seq Box, 
      slack#0: int :: 
    { BucketModel.__default.mergeToOneChild($ly, 
        top_keys#0, 
        top_msgs#0, 
        from#0, 
        to#0, 
        bot_keys#0, 
        bot_msgs#0, 
        bot_from#0, 
        acc_keys#0, 
        acc_msgs#0, 
        slack#0) } 
    BucketModel.__default.mergeToOneChild#canCall(top_keys#0, 
          top_msgs#0, 
          from#0, 
          to#0, 
          bot_keys#0, 
          bot_msgs#0, 
          bot_from#0, 
          acc_keys#0, 
          acc_msgs#0, 
          slack#0)
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && $Is(bot_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bot_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= bot_from#0
           && $Is(acc_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(acc_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= slack#0
           && 
          Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
           && Seq#Length(bot_keys#0) == Seq#Length(bot_msgs#0)
           && Seq#Length(acc_keys#0) == Seq#Length(acc_msgs#0)
           && 
          from#0 <= to#0
           && to#0 <= Seq#Length(top_keys#0)
           && bot_from#0 <= Seq#Length(bot_keys#0))
       ==> Seq#Length(BucketModel.singleMergeResult.keys(BucketModel.__default.mergeToOneChild($ly, 
                top_keys#0, 
                top_msgs#0, 
                from#0, 
                to#0, 
                bot_keys#0, 
                bot_msgs#0, 
                bot_from#0, 
                acc_keys#0, 
                acc_msgs#0, 
                slack#0)))
           == Seq#Length(BucketModel.singleMergeResult.msgs(BucketModel.__default.mergeToOneChild($ly, 
                top_keys#0, 
                top_msgs#0, 
                from#0, 
                to#0, 
                bot_keys#0, 
                bot_msgs#0, 
                bot_from#0, 
                acc_keys#0, 
                acc_msgs#0, 
                slack#0)))
         && (BucketModel.singleMergeResult.SlackExhausted_q(BucketModel.__default.mergeToOneChild($ly, 
              top_keys#0, 
              top_msgs#0, 
              from#0, 
              to#0, 
              bot_keys#0, 
              bot_msgs#0, 
              bot_from#0, 
              acc_keys#0, 
              acc_msgs#0, 
              slack#0))
           ==> from#0
               <= BucketModel.singleMergeResult.end(BucketModel.__default.mergeToOneChild($ly, 
                  top_keys#0, 
                  top_msgs#0, 
                  from#0, 
                  to#0, 
                  bot_keys#0, 
                  bot_msgs#0, 
                  bot_from#0, 
                  acc_keys#0, 
                  acc_msgs#0, 
                  slack#0))
             && BucketModel.singleMergeResult.end(BucketModel.__default.mergeToOneChild($ly, 
                  top_keys#0, 
                  top_msgs#0, 
                  from#0, 
                  to#0, 
                  bot_keys#0, 
                  bot_msgs#0, 
                  bot_from#0, 
                  acc_keys#0, 
                  acc_msgs#0, 
                  slack#0))
               <= to#0)
         && $Is(BucketModel.__default.mergeToOneChild($ly, 
            top_keys#0, 
            top_msgs#0, 
            from#0, 
            to#0, 
            bot_keys#0, 
            bot_msgs#0, 
            bot_from#0, 
            acc_keys#0, 
            acc_msgs#0, 
            slack#0), 
          Tclass.BucketModel.singleMergeResult()));

function BucketModel.__default.mergeToOneChild#requires(LayerType, 
    Seq Box, 
    Seq Box, 
    int, 
    int, 
    Seq Box, 
    Seq Box, 
    int, 
    Seq Box, 
    Seq Box, 
    int)
   : bool;

// #requires axiom for BucketModel.__default.mergeToOneChild
axiom (forall $ly: LayerType, 
    top_keys#0: Seq Box, 
    top_msgs#0: Seq Box, 
    from#0: int, 
    to#0: int, 
    bot_keys#0: Seq Box, 
    bot_msgs#0: Seq Box, 
    bot_from#0: int, 
    acc_keys#0: Seq Box, 
    acc_msgs#0: Seq Box, 
    slack#0: int :: 
  { BucketModel.__default.mergeToOneChild#requires($ly, 
      top_keys#0, 
      top_msgs#0, 
      from#0, 
      to#0, 
      bot_keys#0, 
      bot_msgs#0, 
      bot_from#0, 
      acc_keys#0, 
      acc_msgs#0, 
      slack#0) } 
  $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
       && LitInt(0) <= from#0
       && LitInt(0) <= to#0
       && $Is(bot_keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(bot_msgs#0, TSeq(Tclass.ValueMessage.Message()))
       && LitInt(0) <= bot_from#0
       && $Is(acc_keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(acc_msgs#0, TSeq(Tclass.ValueMessage.Message()))
       && LitInt(0) <= slack#0
     ==> BucketModel.__default.mergeToOneChild#requires($ly, 
        top_keys#0, 
        top_msgs#0, 
        from#0, 
        to#0, 
        bot_keys#0, 
        bot_msgs#0, 
        bot_from#0, 
        acc_keys#0, 
        acc_msgs#0, 
        slack#0)
       == (
        Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
         && Seq#Length(bot_keys#0) == Seq#Length(bot_msgs#0)
         && Seq#Length(acc_keys#0) == Seq#Length(acc_msgs#0)
         && 
        from#0 <= to#0
         && to#0 <= Seq#Length(top_keys#0)
         && bot_from#0 <= Seq#Length(bot_keys#0)));

// definition axiom for BucketModel.__default.mergeToOneChild(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int, 
      bot_keys#0: Seq Box, 
      bot_msgs#0: Seq Box, 
      bot_from#0: int, 
      acc_keys#0: Seq Box, 
      acc_msgs#0: Seq Box, 
      slack#0: int :: 
    { BucketModel.__default.mergeToOneChild($LS($ly), 
        top_keys#0, 
        top_msgs#0, 
        from#0, 
        to#0, 
        bot_keys#0, 
        bot_msgs#0, 
        bot_from#0, 
        acc_keys#0, 
        acc_msgs#0, 
        slack#0) } 
    BucketModel.__default.mergeToOneChild#canCall(top_keys#0, 
          top_msgs#0, 
          from#0, 
          to#0, 
          bot_keys#0, 
          bot_msgs#0, 
          bot_from#0, 
          acc_keys#0, 
          acc_msgs#0, 
          slack#0)
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && $Is(bot_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bot_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= bot_from#0
           && $Is(acc_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(acc_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= slack#0
           && 
          Seq#Length(top_keys#0) == Seq#Length(top_msgs#0)
           && Seq#Length(bot_keys#0) == Seq#Length(bot_msgs#0)
           && Seq#Length(acc_keys#0) == Seq#Length(acc_msgs#0)
           && 
          from#0 <= to#0
           && to#0 <= Seq#Length(top_keys#0)
           && bot_from#0 <= Seq#Length(bot_keys#0))
       ==> (from#0 != to#0
           ==> (bot_from#0 < Seq#Length(bot_keys#0)
                 && Seq#Equal($Unbox(Seq#Index(top_keys#0, from#0)): Seq Box, 
                  $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box)
               ==> (var key#0 := $Unbox(Seq#Index(top_keys#0, from#0)): Seq Box; 
                (var topmsg#0 := $Unbox(Seq#Index(top_msgs#0, from#0)): DatatypeType; 
                  (var botmsg#0 := $Unbox(Seq#Index(bot_msgs#0, bot_from#0)): DatatypeType; 
                    ValueMessage.__default.Merge#canCall(topmsg#0, botmsg#0)
                       && (var msg#0 := ValueMessage.__default.Merge(topmsg#0, botmsg#0); 
                        $IsA#ValueMessage.Message(msg#0)
                           && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                           && ValueMessage.__default.IdentityMessage#canCall()
                           && (ValueMessage.Message#Equal(msg#0, ValueMessage.__default.IdentityMessage())
                             ==> BucketWeights.__default.WeightKey#canCall(key#0)
                               && BucketWeights.__default.WeightMessage#canCall(botmsg#0)
                               && BucketModel.__default.mergeToOneChild#canCall(top_keys#0, 
                                top_msgs#0, 
                                from#0 + 1, 
                                to#0, 
                                bot_keys#0, 
                                bot_msgs#0, 
                                bot_from#0 + 1, 
                                acc_keys#0, 
                                acc_msgs#0, 
                                slack#0
                                   + BucketWeights.__default.WeightKey(key#0)
                                   + BucketWeights.__default.WeightMessage(botmsg#0)))
                           && (!ValueMessage.Message#Equal(msg#0, ValueMessage.__default.IdentityMessage())
                             ==> BucketWeights.__default.WeightMessage#canCall(msg#0)
                               && BucketWeights.__default.WeightMessage#canCall(botmsg#0)
                               && (var delta#0 := BucketWeights.__default.WeightMessage(msg#0)
                                     - BucketWeights.__default.WeightMessage(botmsg#0); 
                                slack#0 >= delta#0
                                   ==> BucketModel.__default.mergeToOneChild#canCall(top_keys#0, 
                                    top_msgs#0, 
                                    from#0 + 1, 
                                    to#0, 
                                    bot_keys#0, 
                                    bot_msgs#0, 
                                    bot_from#0 + 1, 
                                    Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))), 
                                    Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))), 
                                    slack#0 - delta#0))))))))
             && (!(bot_from#0 < Seq#Length(bot_keys#0)
                 && Seq#Equal($Unbox(Seq#Index(top_keys#0, from#0)): Seq Box, 
                  $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box))
               ==> (bot_from#0 != Seq#Length(bot_keys#0)
                   ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(top_keys#0, from#0)): Seq Box, 
                    $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box))
                 && (bot_from#0 == Seq#Length(bot_keys#0)
                     || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(top_keys#0, from#0)): Seq Box, 
                      $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box)
                   ==> (var key#1 := $Unbox(Seq#Index(top_keys#0, from#0)): Seq Box; 
                    (var msg#1 := $Unbox(Seq#Index(top_msgs#0, from#0)): DatatypeType; 
                      BucketWeights.__default.WeightKey#canCall(key#1)
                         && BucketWeights.__default.WeightMessage#canCall(msg#1)
                         && (var delta#1 := BucketWeights.__default.WeightKey(key#1)
                               + BucketWeights.__default.WeightMessage(msg#1); 
                          slack#0 >= delta#1
                             ==> BucketModel.__default.mergeToOneChild#canCall(top_keys#0, 
                              top_msgs#0, 
                              from#0 + 1, 
                              to#0, 
                              bot_keys#0, 
                              bot_msgs#0, 
                              bot_from#0, 
                              Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#1))), 
                              Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#1))), 
                              slack#0 - delta#1)))))
                 && (!(bot_from#0 == Seq#Length(bot_keys#0)
                     || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(top_keys#0, from#0)): Seq Box, 
                      $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box))
                   ==> (var key#2 := $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box; 
                    (var msg#2 := $Unbox(Seq#Index(bot_msgs#0, bot_from#0)): DatatypeType; 
                      BucketModel.__default.mergeToOneChild#canCall(top_keys#0, 
                        top_msgs#0, 
                        from#0, 
                        to#0, 
                        bot_keys#0, 
                        bot_msgs#0, 
                        bot_from#0 + 1, 
                        Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#2))), 
                        Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#2))), 
                        slack#0))))))
         && BucketModel.__default.mergeToOneChild($LS($ly), 
            top_keys#0, 
            top_msgs#0, 
            from#0, 
            to#0, 
            bot_keys#0, 
            bot_msgs#0, 
            bot_from#0, 
            acc_keys#0, 
            acc_msgs#0, 
            slack#0)
           == (if from#0 == to#0
             then #BucketModel.singleMergeResult.MergeCompleted(Seq#Append(acc_keys#0, Seq#Drop(bot_keys#0, bot_from#0)), 
              Seq#Append(acc_msgs#0, Seq#Drop(bot_msgs#0, bot_from#0)), 
              slack#0)
             else (if bot_from#0 < Seq#Length(bot_keys#0)
                 && Seq#Equal($Unbox(Seq#Index(top_keys#0, from#0)): Seq Box, 
                  $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box)
               then (var key#0 := $Unbox(Seq#Index(top_keys#0, from#0)): Seq Box; 
                (var topmsg#0 := $Unbox(Seq#Index(top_msgs#0, from#0)): DatatypeType; 
                  (var botmsg#0 := $Unbox(Seq#Index(bot_msgs#0, bot_from#0)): DatatypeType; 
                    (var msg#0 := ValueMessage.__default.Merge(topmsg#0, botmsg#0); 
                      (if ValueMessage.Message#Equal(msg#0, ValueMessage.__default.IdentityMessage())
                         then BucketModel.__default.mergeToOneChild($ly, 
                          top_keys#0, 
                          top_msgs#0, 
                          from#0 + 1, 
                          to#0, 
                          bot_keys#0, 
                          bot_msgs#0, 
                          bot_from#0 + 1, 
                          acc_keys#0, 
                          acc_msgs#0, 
                          slack#0
                             + BucketWeights.__default.WeightKey(key#0)
                             + BucketWeights.__default.WeightMessage(botmsg#0))
                         else (var delta#0 := BucketWeights.__default.WeightMessage(msg#0)
                               - BucketWeights.__default.WeightMessage(botmsg#0); 
                          (if delta#0 > slack#0
                             then #BucketModel.singleMergeResult.SlackExhausted(Seq#Append(acc_keys#0, Seq#Drop(bot_keys#0, bot_from#0)), 
                              Seq#Append(acc_msgs#0, Seq#Drop(bot_msgs#0, bot_from#0)), 
                              from#0, 
                              slack#0)
                             else BucketModel.__default.mergeToOneChild($ly, 
                              top_keys#0, 
                              top_msgs#0, 
                              from#0 + 1, 
                              to#0, 
                              bot_keys#0, 
                              bot_msgs#0, 
                              bot_from#0 + 1, 
                              Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))), 
                              Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))), 
                              slack#0 - delta#0))))))))
               else (if bot_from#0 == Seq#Length(bot_keys#0)
                   || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(top_keys#0, from#0)): Seq Box, 
                    $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box)
                 then (var key#1 := $Unbox(Seq#Index(top_keys#0, from#0)): Seq Box; 
                  (var msg#1 := $Unbox(Seq#Index(top_msgs#0, from#0)): DatatypeType; 
                    (var delta#1 := BucketWeights.__default.WeightKey(key#1)
                           + BucketWeights.__default.WeightMessage(msg#1); 
                      (if delta#1 > slack#0
                         then #BucketModel.singleMergeResult.SlackExhausted(Seq#Append(acc_keys#0, Seq#Drop(bot_keys#0, bot_from#0)), 
                          Seq#Append(acc_msgs#0, Seq#Drop(bot_msgs#0, bot_from#0)), 
                          from#0, 
                          slack#0)
                         else BucketModel.__default.mergeToOneChild($ly, 
                          top_keys#0, 
                          top_msgs#0, 
                          from#0 + 1, 
                          to#0, 
                          bot_keys#0, 
                          bot_msgs#0, 
                          bot_from#0, 
                          Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#1))), 
                          Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#1))), 
                          slack#0 - delta#1)))))
                 else (var key#2 := $Unbox(Seq#Index(bot_keys#0, bot_from#0)): Seq Box; 
                  (var msg#2 := $Unbox(Seq#Index(bot_msgs#0, bot_from#0)): DatatypeType; 
                    BucketModel.__default.mergeToOneChild($ly, 
                      top_keys#0, 
                      top_msgs#0, 
                      from#0, 
                      to#0, 
                      bot_keys#0, 
                      bot_msgs#0, 
                      bot_from#0 + 1, 
                      Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#2))), 
                      Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#2))), 
                      slack#0)))))));

// definition axiom for BucketModel.__default.mergeToOneChild for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int, 
      bot_keys#0: Seq Box, 
      bot_msgs#0: Seq Box, 
      bot_from#0: int, 
      acc_keys#0: Seq Box, 
      acc_msgs#0: Seq Box, 
      slack#0: int :: 
    {:weight 3} { BucketModel.__default.mergeToOneChild($LS($ly), 
        Lit(top_keys#0), 
        top_msgs#0, 
        LitInt(from#0), 
        to#0, 
        Lit(bot_keys#0), 
        bot_msgs#0, 
        LitInt(bot_from#0), 
        acc_keys#0, 
        acc_msgs#0, 
        slack#0) } 
    BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
          top_msgs#0, 
          LitInt(from#0), 
          to#0, 
          Lit(bot_keys#0), 
          bot_msgs#0, 
          LitInt(bot_from#0), 
          acc_keys#0, 
          acc_msgs#0, 
          slack#0)
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && $Is(bot_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bot_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= bot_from#0
           && $Is(acc_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(acc_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= slack#0
           && 
          Seq#Length(Lit(top_keys#0)) == Seq#Length(top_msgs#0)
           && Seq#Length(Lit(bot_keys#0)) == Seq#Length(bot_msgs#0)
           && Seq#Length(acc_keys#0) == Seq#Length(acc_msgs#0)
           && 
          LitInt(from#0) <= to#0
           && to#0 <= Seq#Length(Lit(top_keys#0))
           && LitInt(bot_from#0) <= Seq#Length(Lit(bot_keys#0)))
       ==> (LitInt(from#0) != to#0
           ==> (bot_from#0 < Seq#Length(Lit(bot_keys#0))
                 && Seq#Equal($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                  $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box)
               ==> (var key#3 := $Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box; 
                (var topmsg#1 := $Unbox(Seq#Index(top_msgs#0, LitInt(from#0))): DatatypeType; 
                  (var botmsg#1 := $Unbox(Seq#Index(bot_msgs#0, LitInt(bot_from#0))): DatatypeType; 
                    ValueMessage.__default.Merge#canCall(topmsg#1, botmsg#1)
                       && (var msg#3 := ValueMessage.__default.Merge(topmsg#1, botmsg#1); 
                        $IsA#ValueMessage.Message(msg#3)
                           && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                           && ValueMessage.__default.IdentityMessage#canCall()
                           && (ValueMessage.Message#Equal(msg#3, ValueMessage.__default.IdentityMessage())
                             ==> BucketWeights.__default.WeightKey#canCall(key#3)
                               && BucketWeights.__default.WeightMessage#canCall(botmsg#1)
                               && BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
                                top_msgs#0, 
                                LitInt(from#0 + 1), 
                                to#0, 
                                Lit(bot_keys#0), 
                                bot_msgs#0, 
                                LitInt(bot_from#0 + 1), 
                                acc_keys#0, 
                                acc_msgs#0, 
                                slack#0
                                   + BucketWeights.__default.WeightKey(key#3)
                                   + BucketWeights.__default.WeightMessage(botmsg#1)))
                           && (!ValueMessage.Message#Equal(msg#3, ValueMessage.__default.IdentityMessage())
                             ==> BucketWeights.__default.WeightMessage#canCall(msg#3)
                               && BucketWeights.__default.WeightMessage#canCall(botmsg#1)
                               && (var delta#2 := BucketWeights.__default.WeightMessage(msg#3)
                                     - BucketWeights.__default.WeightMessage(botmsg#1); 
                                slack#0 >= delta#2
                                   ==> BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
                                    top_msgs#0, 
                                    LitInt(from#0 + 1), 
                                    to#0, 
                                    Lit(bot_keys#0), 
                                    bot_msgs#0, 
                                    LitInt(bot_from#0 + 1), 
                                    Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#3))), 
                                    Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#3))), 
                                    slack#0 - delta#2))))))))
             && (!(bot_from#0 < Seq#Length(Lit(bot_keys#0))
                 && Seq#Equal($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                  $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box))
               ==> (LitInt(bot_from#0) != Seq#Length(Lit(bot_keys#0))
                   ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                    $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box))
                 && (LitInt(bot_from#0) == Seq#Length(Lit(bot_keys#0))
                     || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                      $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box)
                   ==> (var key#4 := $Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box; 
                    (var msg#4 := $Unbox(Seq#Index(top_msgs#0, LitInt(from#0))): DatatypeType; 
                      BucketWeights.__default.WeightKey#canCall(key#4)
                         && BucketWeights.__default.WeightMessage#canCall(msg#4)
                         && (var delta#3 := BucketWeights.__default.WeightKey(key#4)
                               + BucketWeights.__default.WeightMessage(msg#4); 
                          slack#0 >= delta#3
                             ==> BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
                              top_msgs#0, 
                              LitInt(from#0 + 1), 
                              to#0, 
                              Lit(bot_keys#0), 
                              bot_msgs#0, 
                              LitInt(bot_from#0), 
                              Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#4))), 
                              Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#4))), 
                              slack#0 - delta#3)))))
                 && (!(LitInt(bot_from#0) == Seq#Length(Lit(bot_keys#0))
                     || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                      $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box))
                   ==> (var key#5 := $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box; 
                    (var msg#5 := $Unbox(Seq#Index(bot_msgs#0, LitInt(bot_from#0))): DatatypeType; 
                      BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
                        top_msgs#0, 
                        LitInt(from#0), 
                        to#0, 
                        Lit(bot_keys#0), 
                        bot_msgs#0, 
                        LitInt(bot_from#0 + 1), 
                        Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#5))), 
                        Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#5))), 
                        slack#0))))))
         && BucketModel.__default.mergeToOneChild($LS($ly), 
            Lit(top_keys#0), 
            top_msgs#0, 
            LitInt(from#0), 
            to#0, 
            Lit(bot_keys#0), 
            bot_msgs#0, 
            LitInt(bot_from#0), 
            acc_keys#0, 
            acc_msgs#0, 
            slack#0)
           == (if LitInt(from#0) == to#0
             then #BucketModel.singleMergeResult.MergeCompleted(Seq#Append(acc_keys#0, Seq#Drop(Lit(bot_keys#0), LitInt(bot_from#0))), 
              Seq#Append(acc_msgs#0, Seq#Drop(bot_msgs#0, LitInt(bot_from#0))), 
              slack#0)
             else (if bot_from#0 < Seq#Length(Lit(bot_keys#0))
                 && Seq#Equal($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                  $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box)
               then (var key#3 := $Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box; 
                (var topmsg#1 := $Unbox(Seq#Index(top_msgs#0, LitInt(from#0))): DatatypeType; 
                  (var botmsg#1 := $Unbox(Seq#Index(bot_msgs#0, LitInt(bot_from#0))): DatatypeType; 
                    (var msg#3 := ValueMessage.__default.Merge(topmsg#1, botmsg#1); 
                      (if ValueMessage.Message#Equal(msg#3, ValueMessage.__default.IdentityMessage())
                         then BucketModel.__default.mergeToOneChild($LS($ly), 
                          Lit(top_keys#0), 
                          top_msgs#0, 
                          LitInt(from#0 + 1), 
                          to#0, 
                          Lit(bot_keys#0), 
                          bot_msgs#0, 
                          LitInt(bot_from#0 + 1), 
                          acc_keys#0, 
                          acc_msgs#0, 
                          slack#0
                             + BucketWeights.__default.WeightKey(key#3)
                             + BucketWeights.__default.WeightMessage(botmsg#1))
                         else (var delta#2 := BucketWeights.__default.WeightMessage(msg#3)
                               - BucketWeights.__default.WeightMessage(botmsg#1); 
                          (if delta#2 > slack#0
                             then #BucketModel.singleMergeResult.SlackExhausted(Seq#Append(acc_keys#0, Seq#Drop(Lit(bot_keys#0), LitInt(bot_from#0))), 
                              Seq#Append(acc_msgs#0, Seq#Drop(bot_msgs#0, LitInt(bot_from#0))), 
                              LitInt(from#0), 
                              slack#0)
                             else BucketModel.__default.mergeToOneChild($LS($ly), 
                              Lit(top_keys#0), 
                              top_msgs#0, 
                              LitInt(from#0 + 1), 
                              to#0, 
                              Lit(bot_keys#0), 
                              bot_msgs#0, 
                              LitInt(bot_from#0 + 1), 
                              Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#3))), 
                              Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#3))), 
                              slack#0 - delta#2))))))))
               else (if LitInt(bot_from#0) == Seq#Length(Lit(bot_keys#0))
                   || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                    $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box)
                 then (var key#4 := $Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box; 
                  (var msg#4 := $Unbox(Seq#Index(top_msgs#0, LitInt(from#0))): DatatypeType; 
                    (var delta#3 := BucketWeights.__default.WeightKey(key#4)
                           + BucketWeights.__default.WeightMessage(msg#4); 
                      (if delta#3 > slack#0
                         then #BucketModel.singleMergeResult.SlackExhausted(Seq#Append(acc_keys#0, Seq#Drop(Lit(bot_keys#0), LitInt(bot_from#0))), 
                          Seq#Append(acc_msgs#0, Seq#Drop(bot_msgs#0, LitInt(bot_from#0))), 
                          LitInt(from#0), 
                          slack#0)
                         else BucketModel.__default.mergeToOneChild($LS($ly), 
                          Lit(top_keys#0), 
                          top_msgs#0, 
                          LitInt(from#0 + 1), 
                          to#0, 
                          Lit(bot_keys#0), 
                          bot_msgs#0, 
                          LitInt(bot_from#0), 
                          Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#4))), 
                          Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#4))), 
                          slack#0 - delta#3)))))
                 else (var key#5 := $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box; 
                  (var msg#5 := $Unbox(Seq#Index(bot_msgs#0, LitInt(bot_from#0))): DatatypeType; 
                    BucketModel.__default.mergeToOneChild($LS($ly), 
                      Lit(top_keys#0), 
                      top_msgs#0, 
                      LitInt(from#0), 
                      to#0, 
                      Lit(bot_keys#0), 
                      bot_msgs#0, 
                      LitInt(bot_from#0 + 1), 
                      Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#5))), 
                      Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#5))), 
                      slack#0)))))));

// definition axiom for BucketModel.__default.mergeToOneChild for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      top_keys#0: Seq Box, 
      top_msgs#0: Seq Box, 
      from#0: int, 
      to#0: int, 
      bot_keys#0: Seq Box, 
      bot_msgs#0: Seq Box, 
      bot_from#0: int, 
      acc_keys#0: Seq Box, 
      acc_msgs#0: Seq Box, 
      slack#0: int :: 
    {:weight 3} { BucketModel.__default.mergeToOneChild($LS($ly), 
        Lit(top_keys#0), 
        Lit(top_msgs#0), 
        LitInt(from#0), 
        LitInt(to#0), 
        Lit(bot_keys#0), 
        Lit(bot_msgs#0), 
        LitInt(bot_from#0), 
        Lit(acc_keys#0), 
        Lit(acc_msgs#0), 
        LitInt(slack#0)) } 
    BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
          Lit(top_msgs#0), 
          LitInt(from#0), 
          LitInt(to#0), 
          Lit(bot_keys#0), 
          Lit(bot_msgs#0), 
          LitInt(bot_from#0), 
          Lit(acc_keys#0), 
          Lit(acc_msgs#0), 
          LitInt(slack#0))
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(top_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= from#0
           && LitInt(0) <= to#0
           && $Is(bot_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bot_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= bot_from#0
           && $Is(acc_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(acc_msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && LitInt(0) <= slack#0
           && 
          Seq#Length(Lit(top_keys#0)) == Seq#Length(Lit(top_msgs#0))
           && Seq#Length(Lit(bot_keys#0)) == Seq#Length(Lit(bot_msgs#0))
           && Seq#Length(Lit(acc_keys#0)) == Seq#Length(Lit(acc_msgs#0))
           && 
          LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= Seq#Length(Lit(top_keys#0))
           && LitInt(bot_from#0) <= Seq#Length(Lit(bot_keys#0)))
       ==> (LitInt(from#0) != LitInt(to#0)
           ==> (bot_from#0 < Seq#Length(Lit(bot_keys#0))
                 && Seq#Equal($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                  $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box)
               ==> (var key#6 := $Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box; 
                (var topmsg#2 := $Unbox(Seq#Index(Lit(top_msgs#0), LitInt(from#0))): DatatypeType; 
                  (var botmsg#2 := $Unbox(Seq#Index(Lit(bot_msgs#0), LitInt(bot_from#0))): DatatypeType; 
                    ValueMessage.__default.Merge#canCall(topmsg#2, botmsg#2)
                       && (var msg#6 := ValueMessage.__default.Merge(topmsg#2, botmsg#2); 
                        $IsA#ValueMessage.Message(msg#6)
                           && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                           && ValueMessage.__default.IdentityMessage#canCall()
                           && (ValueMessage.Message#Equal(msg#6, ValueMessage.__default.IdentityMessage())
                             ==> BucketWeights.__default.WeightKey#canCall(key#6)
                               && BucketWeights.__default.WeightMessage#canCall(botmsg#2)
                               && BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
                                Lit(top_msgs#0), 
                                LitInt(from#0 + 1), 
                                LitInt(to#0), 
                                Lit(bot_keys#0), 
                                Lit(bot_msgs#0), 
                                LitInt(bot_from#0 + 1), 
                                Lit(acc_keys#0), 
                                Lit(acc_msgs#0), 
                                slack#0
                                   + BucketWeights.__default.WeightKey(key#6)
                                   + BucketWeights.__default.WeightMessage(botmsg#2)))
                           && (!ValueMessage.Message#Equal(msg#6, ValueMessage.__default.IdentityMessage())
                             ==> BucketWeights.__default.WeightMessage#canCall(msg#6)
                               && BucketWeights.__default.WeightMessage#canCall(botmsg#2)
                               && (var delta#4 := BucketWeights.__default.WeightMessage(msg#6)
                                     - BucketWeights.__default.WeightMessage(botmsg#2); 
                                slack#0 >= delta#4
                                   ==> BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
                                    Lit(top_msgs#0), 
                                    LitInt(from#0 + 1), 
                                    LitInt(to#0), 
                                    Lit(bot_keys#0), 
                                    Lit(bot_msgs#0), 
                                    LitInt(bot_from#0 + 1), 
                                    Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#6))), 
                                    Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#6))), 
                                    slack#0 - delta#4))))))))
             && (!(bot_from#0 < Seq#Length(Lit(bot_keys#0))
                 && Seq#Equal($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                  $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box))
               ==> (LitInt(bot_from#0) != Seq#Length(Lit(bot_keys#0))
                   ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                    $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box))
                 && (LitInt(bot_from#0) == Seq#Length(Lit(bot_keys#0))
                     || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                      $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box)
                   ==> (var key#7 := $Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box; 
                    (var msg#7 := $Unbox(Seq#Index(Lit(top_msgs#0), LitInt(from#0))): DatatypeType; 
                      BucketWeights.__default.WeightKey#canCall(key#7)
                         && BucketWeights.__default.WeightMessage#canCall(msg#7)
                         && (var delta#5 := BucketWeights.__default.WeightKey(key#7)
                               + BucketWeights.__default.WeightMessage(msg#7); 
                          slack#0 >= delta#5
                             ==> BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
                              Lit(top_msgs#0), 
                              LitInt(from#0 + 1), 
                              LitInt(to#0), 
                              Lit(bot_keys#0), 
                              Lit(bot_msgs#0), 
                              LitInt(bot_from#0), 
                              Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#7))), 
                              Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#7))), 
                              slack#0 - delta#5)))))
                 && (!(LitInt(bot_from#0) == Seq#Length(Lit(bot_keys#0))
                     || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                      $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box))
                   ==> (var key#8 := $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box; 
                    (var msg#8 := $Unbox(Seq#Index(Lit(bot_msgs#0), LitInt(bot_from#0))): DatatypeType; 
                      BucketModel.__default.mergeToOneChild#canCall(Lit(top_keys#0), 
                        Lit(top_msgs#0), 
                        LitInt(from#0), 
                        LitInt(to#0), 
                        Lit(bot_keys#0), 
                        Lit(bot_msgs#0), 
                        LitInt(bot_from#0 + 1), 
                        Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#8))), 
                        Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#8))), 
                        LitInt(slack#0)))))))
         && BucketModel.__default.mergeToOneChild($LS($ly), 
            Lit(top_keys#0), 
            Lit(top_msgs#0), 
            LitInt(from#0), 
            LitInt(to#0), 
            Lit(bot_keys#0), 
            Lit(bot_msgs#0), 
            LitInt(bot_from#0), 
            Lit(acc_keys#0), 
            Lit(acc_msgs#0), 
            LitInt(slack#0))
           == (if LitInt(from#0) == LitInt(to#0)
             then #BucketModel.singleMergeResult.MergeCompleted(Seq#Append(acc_keys#0, Seq#Drop(Lit(bot_keys#0), LitInt(bot_from#0))), 
              Seq#Append(acc_msgs#0, Seq#Drop(Lit(bot_msgs#0), LitInt(bot_from#0))), 
              LitInt(slack#0))
             else (if bot_from#0 < Seq#Length(Lit(bot_keys#0))
                 && Seq#Equal($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                  $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box)
               then (var key#6 := $Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box; 
                (var topmsg#2 := $Unbox(Seq#Index(Lit(top_msgs#0), LitInt(from#0))): DatatypeType; 
                  (var botmsg#2 := $Unbox(Seq#Index(Lit(bot_msgs#0), LitInt(bot_from#0))): DatatypeType; 
                    (var msg#6 := ValueMessage.__default.Merge(topmsg#2, botmsg#2); 
                      (if ValueMessage.Message#Equal(msg#6, ValueMessage.__default.IdentityMessage())
                         then BucketModel.__default.mergeToOneChild($LS($ly), 
                          Lit(top_keys#0), 
                          Lit(top_msgs#0), 
                          LitInt(from#0 + 1), 
                          LitInt(to#0), 
                          Lit(bot_keys#0), 
                          Lit(bot_msgs#0), 
                          LitInt(bot_from#0 + 1), 
                          Lit(acc_keys#0), 
                          Lit(acc_msgs#0), 
                          slack#0
                             + BucketWeights.__default.WeightKey(key#6)
                             + BucketWeights.__default.WeightMessage(botmsg#2))
                         else (var delta#4 := BucketWeights.__default.WeightMessage(msg#6)
                               - BucketWeights.__default.WeightMessage(botmsg#2); 
                          (if delta#4 > slack#0
                             then #BucketModel.singleMergeResult.SlackExhausted(Seq#Append(acc_keys#0, Seq#Drop(Lit(bot_keys#0), LitInt(bot_from#0))), 
                              Seq#Append(acc_msgs#0, Seq#Drop(Lit(bot_msgs#0), LitInt(bot_from#0))), 
                              LitInt(from#0), 
                              LitInt(slack#0))
                             else BucketModel.__default.mergeToOneChild($LS($ly), 
                              Lit(top_keys#0), 
                              Lit(top_msgs#0), 
                              LitInt(from#0 + 1), 
                              LitInt(to#0), 
                              Lit(bot_keys#0), 
                              Lit(bot_msgs#0), 
                              LitInt(bot_from#0 + 1), 
                              Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#6))), 
                              Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#6))), 
                              slack#0 - delta#4))))))))
               else (if LitInt(bot_from#0) == Seq#Length(Lit(bot_keys#0))
                   || Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box, 
                    $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box)
                 then (var key#7 := $Unbox(Seq#Index(Lit(top_keys#0), LitInt(from#0))): Seq Box; 
                  (var msg#7 := $Unbox(Seq#Index(Lit(top_msgs#0), LitInt(from#0))): DatatypeType; 
                    (var delta#5 := BucketWeights.__default.WeightKey(key#7)
                           + BucketWeights.__default.WeightMessage(msg#7); 
                      (if delta#5 > slack#0
                         then #BucketModel.singleMergeResult.SlackExhausted(Seq#Append(acc_keys#0, Seq#Drop(Lit(bot_keys#0), LitInt(bot_from#0))), 
                          Seq#Append(acc_msgs#0, Seq#Drop(Lit(bot_msgs#0), LitInt(bot_from#0))), 
                          LitInt(from#0), 
                          LitInt(slack#0))
                         else BucketModel.__default.mergeToOneChild($LS($ly), 
                          Lit(top_keys#0), 
                          Lit(top_msgs#0), 
                          LitInt(from#0 + 1), 
                          LitInt(to#0), 
                          Lit(bot_keys#0), 
                          Lit(bot_msgs#0), 
                          LitInt(bot_from#0), 
                          Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#7))), 
                          Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#7))), 
                          slack#0 - delta#5)))))
                 else (var key#8 := $Unbox(Seq#Index(Lit(bot_keys#0), LitInt(bot_from#0))): Seq Box; 
                  (var msg#8 := $Unbox(Seq#Index(Lit(bot_msgs#0), LitInt(bot_from#0))): DatatypeType; 
                    BucketModel.__default.mergeToOneChild($LS($ly), 
                      Lit(top_keys#0), 
                      Lit(top_msgs#0), 
                      LitInt(from#0), 
                      LitInt(to#0), 
                      Lit(bot_keys#0), 
                      Lit(bot_msgs#0), 
                      LitInt(bot_from#0 + 1), 
                      Seq#Append(acc_keys#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#8))), 
                      Seq#Append(acc_msgs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(msg#8))), 
                      LitInt(slack#0))))))));

// function declaration for BucketModel._default.topBotAccMergeForKey
function BucketModel.__default.topBotAccMergeForKey(top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box, key#0: Seq Box)
   : DatatypeType;

function BucketModel.__default.topBotAccMergeForKey#canCall(top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box, key#0: Seq Box)
   : bool;

// consequence axiom for BucketModel.__default.topBotAccMergeForKey
axiom true
   ==> (forall top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box, key#0: Seq Box :: 
    { BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, key#0) } 
    BucketModel.__default.topBotAccMergeForKey#canCall(top#0, bot#0, acc#0, key#0)
         || (
          $Is(top#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(bot#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(acc#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> $Is(BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, key#0), 
        Tclass.ValueMessage.Message()));

function BucketModel.__default.topBotAccMergeForKey#requires(Map Box Box, Map Box Box, Map Box Box, Seq Box) : bool;

// #requires axiom for BucketModel.__default.topBotAccMergeForKey
axiom (forall top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box, key#0: Seq Box :: 
  { BucketModel.__default.topBotAccMergeForKey#requires(top#0, bot#0, acc#0, key#0) } 
  $Is(top#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       && $Is(bot#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       && $Is(acc#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketModel.__default.topBotAccMergeForKey#requires(top#0, bot#0, acc#0, key#0)
       == true);

// definition axiom for BucketModel.__default.topBotAccMergeForKey(revealed)
axiom true
   ==> (forall top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box, key#0: Seq Box :: 
    { BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, key#0) } 
    BucketModel.__default.topBotAccMergeForKey#canCall(top#0, bot#0, acc#0, key#0)
         || (
          $Is(top#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(bot#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(acc#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> (!Map#Domain(top#0)[$Box(key#0)]
           ==> ValueMessage.__default.IdentityMessage#canCall())
         && (var topmsg#0 := (if Map#Domain(top#0)[$Box(key#0)]
               then $Unbox(Map#Elements(top#0)[$Box(key#0)]): DatatypeType
               else ValueMessage.__default.IdentityMessage()); 
          (!Map#Domain(acc#0)[$Box(key#0)]
               ==> 
              !Map#Domain(bot#0)[$Box(key#0)]
               ==> ValueMessage.__default.IdentityMessage#canCall())
             && (var botmsg#0 := (if Map#Domain(acc#0)[$Box(key#0)]
                   then $Unbox(Map#Elements(acc#0)[$Box(key#0)]): DatatypeType
                   else (if Map#Domain(bot#0)[$Box(key#0)]
                     then $Unbox(Map#Elements(bot#0)[$Box(key#0)]): DatatypeType
                     else ValueMessage.__default.IdentityMessage())); 
              ValueMessage.__default.Merge#canCall(topmsg#0, botmsg#0)))
         && BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, key#0)
           == (var topmsg#0 := (if Map#Domain(top#0)[$Box(key#0)]
                 then $Unbox(Map#Elements(top#0)[$Box(key#0)]): DatatypeType
                 else ValueMessage.__default.IdentityMessage()); 
            (var botmsg#0 := (if Map#Domain(acc#0)[$Box(key#0)]
                   then $Unbox(Map#Elements(acc#0)[$Box(key#0)]): DatatypeType
                   else (if Map#Domain(bot#0)[$Box(key#0)]
                     then $Unbox(Map#Elements(bot#0)[$Box(key#0)]): DatatypeType
                     else ValueMessage.__default.IdentityMessage())); 
              ValueMessage.__default.Merge(topmsg#0, botmsg#0))));

// definition axiom for BucketModel.__default.topBotAccMergeForKey for all literals(revealed)
axiom true
   ==> (forall top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box, key#0: Seq Box :: 
    {:weight 3} { BucketModel.__default.topBotAccMergeForKey(Lit(top#0), Lit(bot#0), Lit(acc#0), Lit(key#0)) } 
    BucketModel.__default.topBotAccMergeForKey#canCall(Lit(top#0), Lit(bot#0), Lit(acc#0), Lit(key#0))
         || (
          $Is(top#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(bot#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(acc#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> (!Map#Domain(top#0)[$Box(key#0)]
           ==> ValueMessage.__default.IdentityMessage#canCall())
         && (var topmsg#1 := (if Map#Domain(top#0)[$Box(key#0)]
               then $Unbox(Map#Elements(Lit(top#0))[$Box(Lit(key#0))]): DatatypeType
               else ValueMessage.__default.IdentityMessage()); 
          (!Map#Domain(acc#0)[$Box(key#0)]
               ==> 
              !Map#Domain(bot#0)[$Box(key#0)]
               ==> ValueMessage.__default.IdentityMessage#canCall())
             && (var botmsg#1 := (if Map#Domain(acc#0)[$Box(key#0)]
                   then $Unbox(Map#Elements(Lit(acc#0))[$Box(Lit(key#0))]): DatatypeType
                   else (if Map#Domain(bot#0)[$Box(key#0)]
                     then $Unbox(Map#Elements(Lit(bot#0))[$Box(Lit(key#0))]): DatatypeType
                     else ValueMessage.__default.IdentityMessage())); 
              ValueMessage.__default.Merge#canCall(topmsg#1, botmsg#1)))
         && BucketModel.__default.topBotAccMergeForKey(Lit(top#0), Lit(bot#0), Lit(acc#0), Lit(key#0))
           == (var topmsg#1 := (if Map#Domain(top#0)[$Box(key#0)]
                 then $Unbox(Map#Elements(Lit(top#0))[$Box(Lit(key#0))]): DatatypeType
                 else ValueMessage.__default.IdentityMessage()); 
            (var botmsg#1 := (if Map#Domain(acc#0)[$Box(key#0)]
                   then $Unbox(Map#Elements(Lit(acc#0))[$Box(Lit(key#0))]): DatatypeType
                   else (if Map#Domain(bot#0)[$Box(key#0)]
                     then $Unbox(Map#Elements(Lit(bot#0))[$Box(Lit(key#0))]): DatatypeType
                     else ValueMessage.__default.IdentityMessage())); 
              ValueMessage.__default.Merge(topmsg#1, botmsg#1))));

// function declaration for BucketModel._default.topBotAccMerge
function BucketModel.__default.topBotAccMerge(top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box) : Map Box Box;

function BucketModel.__default.topBotAccMerge#canCall(top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box) : bool;

// consequence axiom for BucketModel.__default.topBotAccMerge
axiom true
   ==> (forall top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box :: 
    { BucketModel.__default.topBotAccMerge(top#0, bot#0, acc#0) } 
    BucketModel.__default.topBotAccMerge#canCall(top#0, bot#0, acc#0)
         || (
          $Is(top#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(bot#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(acc#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
       ==> $Is(BucketModel.__default.topBotAccMerge(top#0, bot#0, acc#0), 
        TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

function BucketModel.__default.topBotAccMerge#requires(Map Box Box, Map Box Box, Map Box Box) : bool;

// #requires axiom for BucketModel.__default.topBotAccMerge
axiom (forall top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box :: 
  { BucketModel.__default.topBotAccMerge#requires(top#0, bot#0, acc#0) } 
  $Is(top#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       && $Is(bot#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       && $Is(acc#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
     ==> BucketModel.__default.topBotAccMerge#requires(top#0, bot#0, acc#0) == true);

// definition axiom for BucketModel.__default.topBotAccMerge(revealed)
axiom true
   ==> (forall top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box :: 
    { BucketModel.__default.topBotAccMerge(top#0, bot#0, acc#0) } 
    BucketModel.__default.topBotAccMerge#canCall(top#0, bot#0, acc#0)
         || (
          $Is(top#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(bot#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(acc#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
       ==> (forall key#0: Seq Box :: 
          { BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> (Map#Domain(top#0)[$Box(key#0)]
                   || Map#Domain(bot#0)[$Box(key#0)]
                   || Map#Domain(acc#0)[$Box(key#0)]
                 ==> $IsA#ValueMessage.Message(BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, key#0))
                   && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                   && 
                  BucketModel.__default.topBotAccMergeForKey#canCall(top#0, bot#0, acc#0, key#0)
                   && ValueMessage.__default.IdentityMessage#canCall())
               && ((
                    Map#Domain(top#0)[$Box(key#0)]
                     || Map#Domain(bot#0)[$Box(key#0)]
                     || Map#Domain(acc#0)[$Box(key#0)])
                   && !ValueMessage.Message#Equal(BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, key#0), 
                    ValueMessage.__default.IdentityMessage())
                 ==> BucketModel.__default.topBotAccMergeForKey#canCall(top#0, bot#0, acc#0, key#0)))
         && BucketModel.__default.topBotAccMerge(top#0, bot#0, acc#0)
           == Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                (Map#Domain(top#0)[$w#0] || Map#Domain(bot#0)[$w#0] || Map#Domain(acc#0)[$w#0])
                 && !ValueMessage.Message#Equal(BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, $Unbox($w#0): Seq Box), 
                  ValueMessage.__default.IdentityMessage())), 
            (lambda $w#0: Box :: 
              $Box(BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, $Unbox($w#0): Seq Box))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

// definition axiom for BucketModel.__default.topBotAccMerge for all literals(revealed)
axiom true
   ==> (forall top#0: Map Box Box, bot#0: Map Box Box, acc#0: Map Box Box :: 
    {:weight 3} { BucketModel.__default.topBotAccMerge(Lit(top#0), Lit(bot#0), Lit(acc#0)) } 
    BucketModel.__default.topBotAccMerge#canCall(Lit(top#0), Lit(bot#0), Lit(acc#0))
         || (
          $Is(top#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(bot#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
           && $Is(acc#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
       ==> (forall key#0: Seq Box :: 
          { BucketModel.__default.topBotAccMergeForKey(top#0, bot#0, acc#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> (Lit(Map#Domain(Lit(top#0)))[$Box(key#0)]
                   || Lit(Map#Domain(Lit(bot#0)))[$Box(key#0)]
                   || Lit(Map#Domain(Lit(acc#0)))[$Box(key#0)]
                 ==> $IsA#ValueMessage.Message(BucketModel.__default.topBotAccMergeForKey(Lit(top#0), Lit(bot#0), Lit(acc#0), key#0))
                   && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                   && 
                  BucketModel.__default.topBotAccMergeForKey#canCall(Lit(top#0), Lit(bot#0), Lit(acc#0), key#0)
                   && ValueMessage.__default.IdentityMessage#canCall())
               && ((
                    Lit(Map#Domain(Lit(top#0)))[$Box(key#0)]
                     || Lit(Map#Domain(Lit(bot#0)))[$Box(key#0)]
                     || Lit(Map#Domain(Lit(acc#0)))[$Box(key#0)])
                   && !ValueMessage.Message#Equal(BucketModel.__default.topBotAccMergeForKey(Lit(top#0), Lit(bot#0), Lit(acc#0), key#0), 
                    ValueMessage.__default.IdentityMessage())
                 ==> BucketModel.__default.topBotAccMergeForKey#canCall(Lit(top#0), Lit(bot#0), Lit(acc#0), key#0)))
         && BucketModel.__default.topBotAccMerge(Lit(top#0), Lit(bot#0), Lit(acc#0))
           == Map#Glue((lambda $w#1: Box :: 
              $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                 && 
                (
                  Lit(Map#Domain(Lit(top#0)))[$w#1]
                   || Lit(Map#Domain(Lit(bot#0)))[$w#1]
                   || Lit(Map#Domain(Lit(acc#0)))[$w#1])
                 && !ValueMessage.Message#Equal(BucketModel.__default.topBotAccMergeForKey(Lit(top#0), Lit(bot#0), Lit(acc#0), $Unbox($w#1): Seq Box), 
                  ValueMessage.__default.IdentityMessage())), 
            (lambda $w#1: Box :: 
              $Box(BucketModel.__default.topBotAccMergeForKey(Lit(top#0), Lit(bot#0), Lit(acc#0), $Unbox($w#1): Seq Box))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

// function declaration for BucketModel._default.seq_lt
function BucketModel.__default.seq__lt(a#0: Seq Box, b#0: Seq Box, start#0: int) : bool;

function BucketModel.__default.seq__lt#canCall(a#0: Seq Box, b#0: Seq Box, start#0: int) : bool;

// consequence axiom for BucketModel.__default.seq__lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box, start#0: int :: 
    { BucketModel.__default.seq__lt(a#0, b#0, start#0) } 
    BucketModel.__default.seq__lt#canCall(a#0, b#0, start#0)
         || (
          $Is(a#0, TSeq(Tclass.KeyType.Key()))
           && $Is(b#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= start#0
           && start#0 <= Seq#Length(b#0))
       ==> true);

function BucketModel.__default.seq__lt#requires(Seq Box, Seq Box, int) : bool;

// #requires axiom for BucketModel.__default.seq__lt
axiom (forall a#0: Seq Box, b#0: Seq Box, start#0: int :: 
  { BucketModel.__default.seq__lt#requires(a#0, b#0, start#0) } 
  $Is(a#0, TSeq(Tclass.KeyType.Key())) && $Is(b#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketModel.__default.seq__lt#requires(a#0, b#0, start#0)
       == (LitInt(0) <= start#0 && start#0 <= Seq#Length(b#0)));

// definition axiom for BucketModel.__default.seq__lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box, start#0: int :: 
    { BucketModel.__default.seq__lt(a#0, b#0, start#0) } 
    BucketModel.__default.seq__lt#canCall(a#0, b#0, start#0)
         || (
          $Is(a#0, TSeq(Tclass.KeyType.Key()))
           && $Is(b#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= start#0
           && start#0 <= Seq#Length(b#0))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(b#0, j#0)): Seq Box, $Unbox(Seq#Index(a#0, i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0 < Seq#Length(a#0)
               && 
              start#0 <= j#0
               && j#0 < Seq#Length(b#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(a#0, i#0)): Seq Box, $Unbox(Seq#Index(b#0, j#0)): Seq Box))
         && BucketModel.__default.seq__lt(a#0, b#0, start#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(b#0, j#0)): Seq Box, $Unbox(Seq#Index(a#0, i#0)): Seq Box } 
            LitInt(0) <= i#0
                 && i#0 < Seq#Length(a#0)
                 && 
                start#0 <= j#0
                 && j#0 < Seq#Length(b#0)
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(a#0, i#0)): Seq Box, $Unbox(Seq#Index(b#0, j#0)): Seq Box)));

// definition axiom for BucketModel.__default.seq__lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box, start#0: int :: 
    {:weight 3} { BucketModel.__default.seq__lt(Lit(a#0), Lit(b#0), LitInt(start#0)) } 
    BucketModel.__default.seq__lt#canCall(Lit(a#0), Lit(b#0), LitInt(start#0))
         || (
          $Is(a#0, TSeq(Tclass.KeyType.Key()))
           && $Is(b#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= LitInt(start#0)
           && LitInt(start#0) <= Seq#Length(Lit(b#0)))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(b#0, j#1)): Seq Box, $Unbox(Seq#Index(a#0, i#1)): Seq Box } 
          LitInt(0) <= i#1
               && i#1 < Seq#Length(Lit(a#0))
               && 
              LitInt(start#0) <= j#1
               && j#1 < Seq#Length(Lit(b#0))
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(a#0), i#1)): Seq Box, 
              $Unbox(Seq#Index(Lit(b#0), j#1)): Seq Box))
         && BucketModel.__default.seq__lt(Lit(a#0), Lit(b#0), LitInt(start#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(b#0, j#1)): Seq Box, $Unbox(Seq#Index(a#0, i#1)): Seq Box } 
            LitInt(0) <= i#1
                 && i#1 < Seq#Length(Lit(a#0))
                 && 
                LitInt(start#0) <= j#1
                 && j#1 < Seq#Length(Lit(b#0))
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(a#0), i#1)): Seq Box, 
                $Unbox(Seq#Index(Lit(b#0), j#1)): Seq Box)));

// function declaration for BucketModel._default.bucketStartIdx
function BucketModel.__default.bucketStartIdx(top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int) : int;

function BucketModel.__default.bucketStartIdx#canCall(top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int) : bool;

// consequence axiom for BucketModel.__default.bucketStartIdx
axiom true
   ==> (forall top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int :: 
    { BucketModel.__default.bucketStartIdx(top_keys#0, pivots#0, r#0) } 
    BucketModel.__default.bucketStartIdx#canCall(top_keys#0, pivots#0, r#0)
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= r#0
           && r#0 <= Seq#Length(pivots#0))
       ==> true);

function BucketModel.__default.bucketStartIdx#requires(Seq Box, Seq Box, int) : bool;

// #requires axiom for BucketModel.__default.bucketStartIdx
axiom (forall top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int :: 
  { BucketModel.__default.bucketStartIdx#requires(top_keys#0, pivots#0, r#0) } 
  $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketModel.__default.bucketStartIdx#requires(top_keys#0, pivots#0, r#0)
       == (LitInt(0) <= r#0 && r#0 <= Seq#Length(pivots#0)));

// definition axiom for BucketModel.__default.bucketStartIdx(revealed)
axiom true
   ==> (forall top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int :: 
    { BucketModel.__default.bucketStartIdx(top_keys#0, pivots#0, r#0) } 
    BucketModel.__default.bucketStartIdx#canCall(top_keys#0, pivots#0, r#0)
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= r#0
           && r#0 <= Seq#Length(pivots#0))
       ==> (r#0 != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(top_keys#0, $Unbox(Seq#Index(pivots#0, r#0 - 1)): Seq Box))
         && BucketModel.__default.bucketStartIdx(top_keys#0, pivots#0, r#0)
           == (if r#0 == LitInt(0)
             then 0
             else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
              top_keys#0, 
              $Unbox(Seq#Index(pivots#0, r#0 - 1)): Seq Box)));

// definition axiom for BucketModel.__default.bucketStartIdx for all literals(revealed)
axiom true
   ==> (forall top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int :: 
    {:weight 3} { BucketModel.__default.bucketStartIdx(Lit(top_keys#0), Lit(pivots#0), LitInt(r#0)) } 
    BucketModel.__default.bucketStartIdx#canCall(Lit(top_keys#0), Lit(pivots#0), LitInt(r#0))
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= LitInt(r#0)
           && LitInt(r#0) <= Seq#Length(Lit(pivots#0)))
       ==> (LitInt(r#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(top_keys#0), $Unbox(Seq#Index(Lit(pivots#0), LitInt(r#0 - 1))): Seq Box))
         && BucketModel.__default.bucketStartIdx(Lit(top_keys#0), Lit(pivots#0), LitInt(r#0))
           == (if LitInt(r#0) == LitInt(0)
             then 0
             else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
              Lit(top_keys#0), 
              $Unbox(Seq#Index(Lit(pivots#0), LitInt(r#0 - 1))): Seq Box)));

// function declaration for BucketModel._default.bucketEndIdx
function BucketModel.__default.bucketEndIdx(top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int) : int;

function BucketModel.__default.bucketEndIdx#canCall(top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int) : bool;

// consequence axiom for BucketModel.__default.bucketEndIdx
axiom true
   ==> (forall top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int :: 
    { BucketModel.__default.bucketEndIdx(top_keys#0, pivots#0, r#0) } 
    BucketModel.__default.bucketEndIdx#canCall(top_keys#0, pivots#0, r#0)
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= r#0
           && r#0 <= Seq#Length(pivots#0))
       ==> true);

function BucketModel.__default.bucketEndIdx#requires(Seq Box, Seq Box, int) : bool;

// #requires axiom for BucketModel.__default.bucketEndIdx
axiom (forall top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int :: 
  { BucketModel.__default.bucketEndIdx#requires(top_keys#0, pivots#0, r#0) } 
  $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketModel.__default.bucketEndIdx#requires(top_keys#0, pivots#0, r#0)
       == (LitInt(0) <= r#0 && r#0 <= Seq#Length(pivots#0)));

// definition axiom for BucketModel.__default.bucketEndIdx(revealed)
axiom true
   ==> (forall top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int :: 
    { BucketModel.__default.bucketEndIdx(top_keys#0, pivots#0, r#0) } 
    BucketModel.__default.bucketEndIdx#canCall(top_keys#0, pivots#0, r#0)
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= r#0
           && r#0 <= Seq#Length(pivots#0))
       ==> (r#0 < Seq#Length(pivots#0)
           ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(top_keys#0, $Unbox(Seq#Index(pivots#0, r#0)): Seq Box))
         && BucketModel.__default.bucketEndIdx(top_keys#0, pivots#0, r#0)
           == (if r#0 < Seq#Length(pivots#0)
             then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
              top_keys#0, 
              $Unbox(Seq#Index(pivots#0, r#0)): Seq Box)
             else Seq#Length(top_keys#0)));

// definition axiom for BucketModel.__default.bucketEndIdx for all literals(revealed)
axiom true
   ==> (forall top_keys#0: Seq Box, pivots#0: Seq Box, r#0: int :: 
    {:weight 3} { BucketModel.__default.bucketEndIdx(Lit(top_keys#0), Lit(pivots#0), LitInt(r#0)) } 
    BucketModel.__default.bucketEndIdx#canCall(Lit(top_keys#0), Lit(pivots#0), LitInt(r#0))
         || (
          $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(0) <= LitInt(r#0)
           && LitInt(r#0) <= Seq#Length(Lit(pivots#0)))
       ==> (r#0 < Seq#Length(Lit(pivots#0))
           ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(top_keys#0), $Unbox(Seq#Index(Lit(pivots#0), LitInt(r#0))): Seq Box))
         && BucketModel.__default.bucketEndIdx(Lit(top_keys#0), Lit(pivots#0), LitInt(r#0))
           == (if r#0 < Seq#Length(Lit(pivots#0))
             then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
              Lit(top_keys#0), 
              $Unbox(Seq#Index(Lit(pivots#0), LitInt(r#0))): Seq Box)
             else Seq#Length(Lit(top_keys#0))));

// function declaration for BucketModel._default.pivotIndexes
function BucketModel.__default.pivotIndexes($ly: LayerType, top_keys#0: Seq Box, pivots#0: Seq Box) : Seq Box;

function BucketModel.__default.pivotIndexes#canCall(top_keys#0: Seq Box, pivots#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, top_keys#0: Seq Box, pivots#0: Seq Box :: 
  { BucketModel.__default.pivotIndexes($LS($ly), top_keys#0, pivots#0) } 
  BucketModel.__default.pivotIndexes($LS($ly), top_keys#0, pivots#0)
     == BucketModel.__default.pivotIndexes($ly, top_keys#0, pivots#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, top_keys#0: Seq Box, pivots#0: Seq Box :: 
  { BucketModel.__default.pivotIndexes(AsFuelBottom($ly), top_keys#0, pivots#0) } 
  BucketModel.__default.pivotIndexes($ly, top_keys#0, pivots#0)
     == BucketModel.__default.pivotIndexes($LZ, top_keys#0, pivots#0));

// consequence axiom for BucketModel.__default.pivotIndexes
axiom true
   ==> (forall $ly: LayerType, top_keys#0: Seq Box, pivots#0: Seq Box :: 
    { BucketModel.__default.pivotIndexes($ly, top_keys#0, pivots#0) } 
    BucketModel.__default.pivotIndexes#canCall(top_keys#0, pivots#0)
         || ($Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> Seq#Length(BucketModel.__default.pivotIndexes($ly, top_keys#0, pivots#0))
           == Seq#Length(pivots#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(pivots#0, i#0)): Seq Box } 
            { $Unbox(Seq#Index(BucketModel.__default.pivotIndexes($ly, top_keys#0, pivots#0), i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Seq#Length(BucketModel.__default.pivotIndexes($ly, top_keys#0, pivots#0))
             ==> $Unbox(Seq#Index(BucketModel.__default.pivotIndexes($ly, top_keys#0, pivots#0), i#0)): int
               == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
                top_keys#0, 
                $Unbox(Seq#Index(pivots#0, i#0)): Seq Box))
         && $Is(BucketModel.__default.pivotIndexes($ly, top_keys#0, pivots#0), TSeq(TInt)));

function BucketModel.__default.pivotIndexes#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketModel.__default.pivotIndexes
axiom (forall $ly: LayerType, top_keys#0: Seq Box, pivots#0: Seq Box :: 
  { BucketModel.__default.pivotIndexes#requires($ly, top_keys#0, pivots#0) } 
  $Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketModel.__default.pivotIndexes#requires($ly, top_keys#0, pivots#0) == true);

// definition axiom for BucketModel.__default.pivotIndexes(revealed)
axiom true
   ==> (forall $ly: LayerType, top_keys#0: Seq Box, pivots#0: Seq Box :: 
    { BucketModel.__default.pivotIndexes($LS($ly), top_keys#0, pivots#0) } 
    BucketModel.__default.pivotIndexes#canCall(top_keys#0, pivots#0)
         || ($Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> (Seq#Length(pivots#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), pivots#0)
             && BucketModel.__default.pivotIndexes#canCall(top_keys#0, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), pivots#0)
             && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(top_keys#0, 
              $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box))
         && BucketModel.__default.pivotIndexes($LS($ly), top_keys#0, pivots#0)
           == (if Seq#Length(pivots#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketModel.__default.pivotIndexes($ly, top_keys#0, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
                    top_keys#0, 
                    $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box))))));

// definition axiom for BucketModel.__default.pivotIndexes for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, top_keys#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { BucketModel.__default.pivotIndexes($LS($ly), Lit(top_keys#0), Lit(pivots#0)) } 
    BucketModel.__default.pivotIndexes#canCall(Lit(top_keys#0), Lit(pivots#0))
         || ($Is(top_keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> (Seq#Length(Lit(pivots#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
             && BucketModel.__default.pivotIndexes#canCall(Lit(top_keys#0), 
              Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
             && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(top_keys#0), 
              Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box)))
         && BucketModel.__default.pivotIndexes($LS($ly), Lit(top_keys#0), Lit(pivots#0))
           == (if Seq#Length(Lit(pivots#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketModel.__default.pivotIndexes($LS($ly), 
                Lit(top_keys#0), 
                Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
                    Lit(top_keys#0), 
                    Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box)))))));

// function declaration for BucketModel._default.mergeToChildrenIter
function BucketModel.__default.mergeToChildrenIter($ly: LayerType, 
    top#0: DatatypeType, 
    bots#0: Seq Box, 
    idxs#0: Seq Box, 
    tmp#0: DatatypeType, 
    i#0: int, 
    results#0: Seq Box)
   : DatatypeType;

function BucketModel.__default.mergeToChildrenIter#canCall(top#0: DatatypeType, 
    bots#0: Seq Box, 
    idxs#0: Seq Box, 
    tmp#0: DatatypeType, 
    i#0: int, 
    results#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    top#0: DatatypeType, 
    bots#0: Seq Box, 
    idxs#0: Seq Box, 
    tmp#0: DatatypeType, 
    i#0: int, 
    results#0: Seq Box :: 
  { BucketModel.__default.mergeToChildrenIter($LS($ly), top#0, bots#0, idxs#0, tmp#0, i#0, results#0) } 
  BucketModel.__default.mergeToChildrenIter($LS($ly), top#0, bots#0, idxs#0, tmp#0, i#0, results#0)
     == BucketModel.__default.mergeToChildrenIter($ly, top#0, bots#0, idxs#0, tmp#0, i#0, results#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    top#0: DatatypeType, 
    bots#0: Seq Box, 
    idxs#0: Seq Box, 
    tmp#0: DatatypeType, 
    i#0: int, 
    results#0: Seq Box :: 
  { BucketModel.__default.mergeToChildrenIter(AsFuelBottom($ly), top#0, bots#0, idxs#0, tmp#0, i#0, results#0) } 
  BucketModel.__default.mergeToChildrenIter($ly, top#0, bots#0, idxs#0, tmp#0, i#0, results#0)
     == BucketModel.__default.mergeToChildrenIter($LZ, top#0, bots#0, idxs#0, tmp#0, i#0, results#0));

// consequence axiom for BucketModel.__default.mergeToChildrenIter
axiom true
   ==> (forall $ly: LayerType, 
      top#0: DatatypeType, 
      bots#0: Seq Box, 
      idxs#0: Seq Box, 
      tmp#0: DatatypeType, 
      i#0: int, 
      results#0: Seq Box :: 
    { BucketModel.__default.mergeToChildrenIter($ly, top#0, bots#0, idxs#0, tmp#0, i#0, results#0) } 
    BucketModel.__default.mergeToChildrenIter#canCall(top#0, bots#0, idxs#0, tmp#0, i#0, results#0)
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(idxs#0, TSeq(TInt))
           && $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
           && $Is(results#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          BucketsLib.__default.WFBucket(top#0)
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#1)): DatatypeType))
           && 0 < Seq#Length(bots#0)
           && Seq#Length(results#0) == i#0
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(bots#0)
           && Seq#Length(idxs#0) == Seq#Length(bots#0) - 1
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(idxs#0, i#2)): int } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(idxs#0)
               ==> LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#2)): int
                 && $Unbox(Seq#Index(idxs#0, i#2)): int <= Seq#Length(BucketsLib.Bucket.keys(top#0)))
           && (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
             ==> LitInt(0) <= BucketModel.singleMergeResult.end(tmp#0)
               && BucketModel.singleMergeResult.end(tmp#0)
                 <= Seq#Length(BucketsLib.Bucket.keys(top#0))))
       ==> Seq#Length(BucketModel.mergeResult.bots(BucketModel.__default.mergeToChildrenIter($ly, top#0, bots#0, idxs#0, tmp#0, i#0, results#0)))
           == Seq#Length(bots#0)
         && $Is(BucketModel.__default.mergeToChildrenIter($ly, top#0, bots#0, idxs#0, tmp#0, i#0, results#0), 
          Tclass.BucketModel.mergeResult()));

function BucketModel.__default.mergeToChildrenIter#requires(LayerType, DatatypeType, Seq Box, Seq Box, DatatypeType, int, Seq Box) : bool;

// #requires axiom for BucketModel.__default.mergeToChildrenIter
axiom (forall $ly: LayerType, 
    top#0: DatatypeType, 
    bots#0: Seq Box, 
    idxs#0: Seq Box, 
    tmp#0: DatatypeType, 
    i#0: int, 
    results#0: Seq Box :: 
  { BucketModel.__default.mergeToChildrenIter#requires($ly, top#0, bots#0, idxs#0, tmp#0, i#0, results#0) } 
  $Is(top#0, Tclass.BucketsLib.Bucket())
       && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(idxs#0, TSeq(TInt))
       && $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
       && $Is(results#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketModel.__default.mergeToChildrenIter#requires($ly, top#0, bots#0, idxs#0, tmp#0, i#0, results#0)
       == (
        BucketsLib.__default.WFBucket(top#0)
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(bots#0, i#3)): DatatypeType } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(bots#0)
             ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#3)): DatatypeType))
         && 0 < Seq#Length(bots#0)
         && Seq#Length(results#0) == i#0
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(bots#0)
         && Seq#Length(idxs#0) == Seq#Length(bots#0) - 1
         && (forall i#4: int :: 
          { $Unbox(Seq#Index(idxs#0, i#4)): int } 
          LitInt(0) <= i#4 && i#4 < Seq#Length(idxs#0)
             ==> LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#4)): int
               && $Unbox(Seq#Index(idxs#0, i#4)): int <= Seq#Length(BucketsLib.Bucket.keys(top#0)))
         && (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
           ==> LitInt(0) <= BucketModel.singleMergeResult.end(tmp#0)
             && BucketModel.singleMergeResult.end(tmp#0)
               <= Seq#Length(BucketsLib.Bucket.keys(top#0)))));

// definition axiom for BucketModel.__default.mergeToChildrenIter(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      top#0: DatatypeType, 
      bots#0: Seq Box, 
      idxs#0: Seq Box, 
      tmp#0: DatatypeType, 
      i#0: int, 
      results#0: Seq Box :: 
    { BucketModel.__default.mergeToChildrenIter($LS($ly), top#0, bots#0, idxs#0, tmp#0, i#0, results#0) } 
    BucketModel.__default.mergeToChildrenIter#canCall(top#0, bots#0, idxs#0, tmp#0, i#0, results#0)
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(idxs#0, TSeq(TInt))
           && $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
           && $Is(results#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          BucketsLib.__default.WFBucket(top#0)
           && (forall i#3: int :: 
            { $Unbox(Seq#Index(bots#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(bots#0)
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#3)): DatatypeType))
           && 0 < Seq#Length(bots#0)
           && Seq#Length(results#0) == i#0
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(bots#0)
           && Seq#Length(idxs#0) == Seq#Length(bots#0) - 1
           && (forall i#4: int :: 
            { $Unbox(Seq#Index(idxs#0, i#4)): int } 
            LitInt(0) <= i#4 && i#4 < Seq#Length(idxs#0)
               ==> LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#4)): int
                 && $Unbox(Seq#Index(idxs#0, i#4)): int <= Seq#Length(BucketsLib.Bucket.keys(top#0)))
           && (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
             ==> LitInt(0) <= BucketModel.singleMergeResult.end(tmp#0)
               && BucketModel.singleMergeResult.end(tmp#0)
                 <= Seq#Length(BucketsLib.Bucket.keys(top#0))))
       ==> (i#0 == Seq#Length(bots#0)
           ==> (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
                 && BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
                 && BucketsLib.__default.BucketOfSeq#canCall(Seq#Drop(BucketsLib.Bucket.keys(top#0), BucketModel.singleMergeResult.end(tmp#0)), 
                  Seq#Drop(BucketsLib.Bucket.msgs(top#0), BucketModel.singleMergeResult.end(tmp#0)))
                 && (BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
                   || BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)))
             && (!BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
               ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box))
                 && (BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
                   || BucketModel.singleMergeResult.SlackExhausted_q(tmp#0))))
         && (i#0 != Seq#Length(bots#0)
           ==> (BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
               ==> (var from#0 := (if i#0 == LitInt(0) then 0 else $Unbox(Seq#Index(idxs#0, i#0 - 1)): int); 
                (i#0 == Seq#Length(idxs#0) ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0))
                   && (var to1#0 := (if i#0 == Seq#Length(idxs#0)
                         then Seq#Length(BucketsLib.Bucket.keys(top#0))
                         else $Unbox(Seq#Index(idxs#0, i#0)): int); 
                    (var to#0 := (if to1#0 < from#0 then from#0 else to1#0); 
                      BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
                         && BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
                         && BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)
                         && BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Seq#Index(bots#0, i#0)): DatatypeType)
                         && (BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
                           || BucketModel.singleMergeResult.SlackExhausted_q(tmp#0))
                         && BucketModel.__default.mergeToOneChild#canCall(BucketsLib.Bucket.keys(top#0), 
                          BucketsLib.Bucket.msgs(top#0), 
                          from#0, 
                          to#0, 
                          BucketsLib.Bucket.keys($Unbox(Seq#Index(bots#0, i#0)): DatatypeType), 
                          BucketsLib.Bucket.msgs($Unbox(Seq#Index(bots#0, i#0)): DatatypeType), 
                          LitInt(0), 
                          Lit(Seq#Empty(): Seq Box), 
                          Lit(Seq#Empty(): Seq Box), 
                          BucketModel.singleMergeResult.slack(tmp#0))
                         && (var tmp'#0 := BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                              BucketsLib.Bucket.keys(top#0), 
                              BucketsLib.Bucket.msgs(top#0), 
                              from#0, 
                              to#0, 
                              BucketsLib.Bucket.keys($Unbox(Seq#Index(bots#0, i#0)): DatatypeType), 
                              BucketsLib.Bucket.msgs($Unbox(Seq#Index(bots#0, i#0)): DatatypeType), 
                              LitInt(0), 
                              Lit(Seq#Empty(): Seq Box), 
                              Lit(Seq#Empty(): Seq Box), 
                              BucketModel.singleMergeResult.slack(tmp#0)); 
                          (BucketModel.singleMergeResult.MergeCompleted_q(tmp'#0)
                               || BucketModel.singleMergeResult.SlackExhausted_q(tmp'#0))
                             && (BucketModel.singleMergeResult.MergeCompleted_q(tmp'#0)
                               || BucketModel.singleMergeResult.SlackExhausted_q(tmp'#0))
                             && BucketsLib.__default.BucketOfSeq#canCall(BucketModel.singleMergeResult.keys(tmp'#0), 
                              BucketModel.singleMergeResult.msgs(tmp'#0))
                             && (var results'#0 := Seq#Append(results#0, 
                                  Seq#Build(Seq#Empty(): Seq Box, 
                                    $Box(BucketsLib.__default.BucketOfSeq(BucketModel.singleMergeResult.keys(tmp'#0), 
                                        BucketModel.singleMergeResult.msgs(tmp'#0))))); 
                              BucketModel.__default.mergeToChildrenIter#canCall(top#0, bots#0, idxs#0, tmp'#0, i#0 + 1, results'#0)))))))
             && (!BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
               ==> (var results'#1 := Seq#Append(results#0, Seq#Build(Seq#Empty(): Seq Box, Seq#Index(bots#0, i#0))); 
                BucketModel.__default.mergeToChildrenIter#canCall(top#0, bots#0, idxs#0, tmp#0, i#0 + 1, results'#1))))
         && BucketModel.__default.mergeToChildrenIter($LS($ly), top#0, bots#0, idxs#0, tmp#0, i#0, results#0)
           == (if i#0 == Seq#Length(bots#0)
             then (if BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
               then (var leftover_top#0 := BucketsLib.__default.BucketOfSeq(Seq#Drop(BucketsLib.Bucket.keys(top#0), BucketModel.singleMergeResult.end(tmp#0)), 
                    Seq#Drop(BucketsLib.Bucket.msgs(top#0), BucketModel.singleMergeResult.end(tmp#0))); 
                #BucketModel.mergeResult.mergeResult(leftover_top#0, results#0, BucketModel.singleMergeResult.slack(tmp#0)))
               else #BucketModel.mergeResult.mergeResult(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)), 
                results#0, 
                BucketModel.singleMergeResult.slack(tmp#0)))
             else (if BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
               then (var from#0 := (if i#0 == LitInt(0) then 0 else $Unbox(Seq#Index(idxs#0, i#0 - 1)): int); 
                (var to1#0 := (if i#0 == Seq#Length(idxs#0)
                       then Seq#Length(BucketsLib.Bucket.keys(top#0))
                       else $Unbox(Seq#Index(idxs#0, i#0)): int); 
                  (var to#0 := (if to1#0 < from#0 then from#0 else to1#0); 
                    (var tmp'#0 := BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                          BucketsLib.Bucket.keys(top#0), 
                          BucketsLib.Bucket.msgs(top#0), 
                          from#0, 
                          to#0, 
                          BucketsLib.Bucket.keys($Unbox(Seq#Index(bots#0, i#0)): DatatypeType), 
                          BucketsLib.Bucket.msgs($Unbox(Seq#Index(bots#0, i#0)): DatatypeType), 
                          LitInt(0), 
                          Lit(Seq#Empty(): Seq Box), 
                          Lit(Seq#Empty(): Seq Box), 
                          BucketModel.singleMergeResult.slack(tmp#0)); 
                      (var results'#0 := Seq#Append(results#0, 
                            Seq#Build(Seq#Empty(): Seq Box, 
                              $Box(BucketsLib.__default.BucketOfSeq(BucketModel.singleMergeResult.keys(tmp'#0), 
                                  BucketModel.singleMergeResult.msgs(tmp'#0))))); 
                        BucketModel.__default.mergeToChildrenIter($ly, top#0, bots#0, idxs#0, tmp'#0, i#0 + 1, results'#0))))))
               else (var results'#1 := Seq#Append(results#0, Seq#Build(Seq#Empty(): Seq Box, Seq#Index(bots#0, i#0))); 
                BucketModel.__default.mergeToChildrenIter($ly, top#0, bots#0, idxs#0, tmp#0, i#0 + 1, results'#1)))));

// definition axiom for BucketModel.__default.mergeToChildrenIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      top#0: DatatypeType, 
      bots#0: Seq Box, 
      idxs#0: Seq Box, 
      tmp#0: DatatypeType, 
      i#0: int, 
      results#0: Seq Box :: 
    {:weight 3} { BucketModel.__default.mergeToChildrenIter($LS($ly), top#0, Lit(bots#0), idxs#0, tmp#0, LitInt(i#0), results#0) } 
    BucketModel.__default.mergeToChildrenIter#canCall(top#0, Lit(bots#0), idxs#0, tmp#0, LitInt(i#0), results#0)
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(idxs#0, TSeq(TInt))
           && $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
           && $Is(results#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          BucketsLib.__default.WFBucket(top#0)
           && (forall i#5: int :: 
            { $Unbox(Seq#Index(bots#0, i#5)): DatatypeType } 
            LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(bots#0))
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(Lit(bots#0), i#5)): DatatypeType))
           && 0 < Seq#Length(Lit(bots#0))
           && Seq#Length(results#0) == LitInt(i#0)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(bots#0))
           && Seq#Length(idxs#0) == Seq#Length(Lit(bots#0)) - 1
           && (forall i#6: int :: 
            { $Unbox(Seq#Index(idxs#0, i#6)): int } 
            LitInt(0) <= i#6 && i#6 < Seq#Length(idxs#0)
               ==> LitInt(0) <= $Unbox(Seq#Index(idxs#0, i#6)): int
                 && $Unbox(Seq#Index(idxs#0, i#6)): int <= Seq#Length(BucketsLib.Bucket.keys(top#0)))
           && (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
             ==> LitInt(0) <= BucketModel.singleMergeResult.end(tmp#0)
               && BucketModel.singleMergeResult.end(tmp#0)
                 <= Seq#Length(BucketsLib.Bucket.keys(top#0))))
       ==> (LitInt(i#0) == Seq#Length(Lit(bots#0))
           ==> (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
                 && BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
                 && BucketsLib.__default.BucketOfSeq#canCall(Seq#Drop(BucketsLib.Bucket.keys(top#0), BucketModel.singleMergeResult.end(tmp#0)), 
                  Seq#Drop(BucketsLib.Bucket.msgs(top#0), BucketModel.singleMergeResult.end(tmp#0)))
                 && (BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
                   || BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)))
             && (!BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
               ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box))
                 && (BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
                   || BucketModel.singleMergeResult.SlackExhausted_q(tmp#0))))
         && (LitInt(i#0) != Seq#Length(Lit(bots#0))
           ==> (BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
               ==> (var from#1 := (if LitInt(i#0) == LitInt(0)
                     then 0
                     else $Unbox(Seq#Index(idxs#0, LitInt(i#0 - 1))): int); 
                (LitInt(i#0) == Seq#Length(idxs#0)
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0))
                   && (var to1#1 := (if LitInt(i#0) == Seq#Length(idxs#0)
                         then Seq#Length(BucketsLib.Bucket.keys(top#0))
                         else $Unbox(Seq#Index(idxs#0, LitInt(i#0))): int); 
                    (var to#1 := (if to1#1 < from#1 then from#1 else to1#1); 
                      BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
                         && BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
                         && BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType)
                         && BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType)
                         && (BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
                           || BucketModel.singleMergeResult.SlackExhausted_q(tmp#0))
                         && BucketModel.__default.mergeToOneChild#canCall(BucketsLib.Bucket.keys(top#0), 
                          BucketsLib.Bucket.msgs(top#0), 
                          from#1, 
                          to#1, 
                          BucketsLib.Bucket.keys($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                          BucketsLib.Bucket.msgs($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                          LitInt(0), 
                          Lit(Seq#Empty(): Seq Box), 
                          Lit(Seq#Empty(): Seq Box), 
                          BucketModel.singleMergeResult.slack(tmp#0))
                         && (var tmp'#1 := BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                              BucketsLib.Bucket.keys(top#0), 
                              BucketsLib.Bucket.msgs(top#0), 
                              from#1, 
                              to#1, 
                              BucketsLib.Bucket.keys($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                              BucketsLib.Bucket.msgs($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                              LitInt(0), 
                              Lit(Seq#Empty(): Seq Box), 
                              Lit(Seq#Empty(): Seq Box), 
                              BucketModel.singleMergeResult.slack(tmp#0)); 
                          (BucketModel.singleMergeResult.MergeCompleted_q(tmp'#1)
                               || BucketModel.singleMergeResult.SlackExhausted_q(tmp'#1))
                             && (BucketModel.singleMergeResult.MergeCompleted_q(tmp'#1)
                               || BucketModel.singleMergeResult.SlackExhausted_q(tmp'#1))
                             && BucketsLib.__default.BucketOfSeq#canCall(BucketModel.singleMergeResult.keys(tmp'#1), 
                              BucketModel.singleMergeResult.msgs(tmp'#1))
                             && (var results'#2 := Seq#Append(results#0, 
                                  Seq#Build(Seq#Empty(): Seq Box, 
                                    $Box(BucketsLib.__default.BucketOfSeq(BucketModel.singleMergeResult.keys(tmp'#1), 
                                        BucketModel.singleMergeResult.msgs(tmp'#1))))); 
                              BucketModel.__default.mergeToChildrenIter#canCall(top#0, Lit(bots#0), idxs#0, tmp'#1, LitInt(i#0 + 1), results'#2)))))))
             && (!BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
               ==> (var results'#3 := Seq#Append(results#0, Seq#Build(Seq#Empty(): Seq Box, Seq#Index(Lit(bots#0), LitInt(i#0)))); 
                BucketModel.__default.mergeToChildrenIter#canCall(top#0, Lit(bots#0), idxs#0, tmp#0, LitInt(i#0 + 1), results'#3))))
         && BucketModel.__default.mergeToChildrenIter($LS($ly), top#0, Lit(bots#0), idxs#0, tmp#0, LitInt(i#0), results#0)
           == (if LitInt(i#0) == Seq#Length(Lit(bots#0))
             then (if BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
               then (var leftover_top#1 := BucketsLib.__default.BucketOfSeq(Seq#Drop(BucketsLib.Bucket.keys(top#0), BucketModel.singleMergeResult.end(tmp#0)), 
                    Seq#Drop(BucketsLib.Bucket.msgs(top#0), BucketModel.singleMergeResult.end(tmp#0))); 
                #BucketModel.mergeResult.mergeResult(leftover_top#1, results#0, BucketModel.singleMergeResult.slack(tmp#0)))
               else #BucketModel.mergeResult.mergeResult(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)), 
                results#0, 
                BucketModel.singleMergeResult.slack(tmp#0)))
             else (if BucketModel.singleMergeResult.MergeCompleted_q(tmp#0)
               then (var from#1 := (if LitInt(i#0) == LitInt(0)
                     then 0
                     else $Unbox(Seq#Index(idxs#0, LitInt(i#0 - 1))): int); 
                (var to1#1 := (if LitInt(i#0) == Seq#Length(idxs#0)
                       then Seq#Length(BucketsLib.Bucket.keys(top#0))
                       else $Unbox(Seq#Index(idxs#0, LitInt(i#0))): int); 
                  (var to#1 := (if to1#1 < from#1 then from#1 else to1#1); 
                    (var tmp'#1 := BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                          BucketsLib.Bucket.keys(top#0), 
                          BucketsLib.Bucket.msgs(top#0), 
                          from#1, 
                          to#1, 
                          BucketsLib.Bucket.keys($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                          BucketsLib.Bucket.msgs($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                          LitInt(0), 
                          Lit(Seq#Empty(): Seq Box), 
                          Lit(Seq#Empty(): Seq Box), 
                          BucketModel.singleMergeResult.slack(tmp#0)); 
                      (var results'#2 := Seq#Append(results#0, 
                            Seq#Build(Seq#Empty(): Seq Box, 
                              $Box(BucketsLib.__default.BucketOfSeq(BucketModel.singleMergeResult.keys(tmp'#1), 
                                  BucketModel.singleMergeResult.msgs(tmp'#1))))); 
                        BucketModel.__default.mergeToChildrenIter($LS($ly), top#0, Lit(bots#0), idxs#0, tmp'#1, LitInt(i#0 + 1), results'#2))))))
               else (var results'#3 := Seq#Append(results#0, Seq#Build(Seq#Empty(): Seq Box, Seq#Index(Lit(bots#0), LitInt(i#0)))); 
                BucketModel.__default.mergeToChildrenIter($LS($ly), top#0, Lit(bots#0), idxs#0, tmp#0, LitInt(i#0 + 1), results'#3)))));

// definition axiom for BucketModel.__default.mergeToChildrenIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      top#0: DatatypeType, 
      bots#0: Seq Box, 
      idxs#0: Seq Box, 
      tmp#0: DatatypeType, 
      i#0: int, 
      results#0: Seq Box :: 
    {:weight 3} { BucketModel.__default.mergeToChildrenIter($LS($ly), 
        Lit(top#0), 
        Lit(bots#0), 
        Lit(idxs#0), 
        Lit(tmp#0), 
        LitInt(i#0), 
        Lit(results#0)) } 
    BucketModel.__default.mergeToChildrenIter#canCall(Lit(top#0), Lit(bots#0), Lit(idxs#0), Lit(tmp#0), LitInt(i#0), Lit(results#0))
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(idxs#0, TSeq(TInt))
           && $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
           && $Is(results#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          Lit(BucketsLib.__default.WFBucket(Lit(top#0)))
           && (forall i#7: int :: 
            { $Unbox(Seq#Index(bots#0, i#7)): DatatypeType } 
            LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(bots#0))
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(Lit(bots#0), i#7)): DatatypeType))
           && 0 < Seq#Length(Lit(bots#0))
           && Seq#Length(Lit(results#0)) == LitInt(i#0)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(bots#0))
           && Seq#Length(Lit(idxs#0)) == Seq#Length(Lit(bots#0)) - 1
           && (forall i#8: int :: 
            { $Unbox(Seq#Index(idxs#0, i#8)): int } 
            LitInt(0) <= i#8 && i#8 < Seq#Length(Lit(idxs#0))
               ==> LitInt(0) <= $Unbox(Seq#Index(Lit(idxs#0), i#8)): int
                 && $Unbox(Seq#Index(Lit(idxs#0), i#8)): int
                   <= Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(top#0)))))
           && (BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0))
             ==> LitInt(0) <= LitInt(BucketModel.singleMergeResult.end(Lit(tmp#0)))
               && LitInt(BucketModel.singleMergeResult.end(Lit(tmp#0)))
                 <= Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(top#0))))))
       ==> (LitInt(i#0) == Seq#Length(Lit(bots#0))
           ==> (Lit(BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0)))
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0))
                 && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0))
                 && BucketsLib.__default.BucketOfSeq#canCall(Lit(Seq#Drop(Lit(BucketsLib.Bucket.keys(Lit(top#0))), 
                      LitInt(BucketModel.singleMergeResult.end(Lit(tmp#0))))), 
                  Lit(Seq#Drop(Lit(BucketsLib.Bucket.msgs(Lit(top#0))), 
                      LitInt(BucketModel.singleMergeResult.end(Lit(tmp#0))))))
                 && (BucketModel.singleMergeResult.MergeCompleted_q(Lit(tmp#0))
                   || BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0))))
             && (!Lit(BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0)))
               ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box))
                 && (BucketModel.singleMergeResult.MergeCompleted_q(Lit(tmp#0))
                   || BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0)))))
         && (LitInt(i#0) != Seq#Length(Lit(bots#0))
           ==> (Lit(BucketModel.singleMergeResult.MergeCompleted_q(Lit(tmp#0)))
               ==> (var from#2 := (if LitInt(i#0) == LitInt(0)
                     then 0
                     else $Unbox(Seq#Index(Lit(idxs#0), LitInt(i#0 - 1))): int); 
                (LitInt(i#0) == Seq#Length(Lit(idxs#0))
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0)))
                   && (var to1#2 := (if LitInt(i#0) == Seq#Length(Lit(idxs#0))
                         then Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(top#0))))
                         else $Unbox(Seq#Index(Lit(idxs#0), LitInt(i#0))): int); 
                    (var to#2 := (if to1#2 < from#2 then from#2 else to1#2); 
                      BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0))
                         && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0))
                         && BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType)
                         && BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType)
                         && (BucketModel.singleMergeResult.MergeCompleted_q(Lit(tmp#0))
                           || BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0)))
                         && BucketModel.__default.mergeToOneChild#canCall(Lit(BucketsLib.Bucket.keys(Lit(top#0))), 
                          Lit(BucketsLib.Bucket.msgs(Lit(top#0))), 
                          from#2, 
                          to#2, 
                          BucketsLib.Bucket.keys($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                          BucketsLib.Bucket.msgs($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                          LitInt(0), 
                          Lit(Seq#Empty(): Seq Box), 
                          Lit(Seq#Empty(): Seq Box), 
                          LitInt(BucketModel.singleMergeResult.slack(Lit(tmp#0))))
                         && (var tmp'#2 := BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                              Lit(BucketsLib.Bucket.keys(Lit(top#0))), 
                              Lit(BucketsLib.Bucket.msgs(Lit(top#0))), 
                              from#2, 
                              to#2, 
                              BucketsLib.Bucket.keys($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                              BucketsLib.Bucket.msgs($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                              LitInt(0), 
                              Lit(Seq#Empty(): Seq Box), 
                              Lit(Seq#Empty(): Seq Box), 
                              LitInt(BucketModel.singleMergeResult.slack(Lit(tmp#0)))); 
                          (BucketModel.singleMergeResult.MergeCompleted_q(tmp'#2)
                               || BucketModel.singleMergeResult.SlackExhausted_q(tmp'#2))
                             && (BucketModel.singleMergeResult.MergeCompleted_q(tmp'#2)
                               || BucketModel.singleMergeResult.SlackExhausted_q(tmp'#2))
                             && BucketsLib.__default.BucketOfSeq#canCall(BucketModel.singleMergeResult.keys(tmp'#2), 
                              BucketModel.singleMergeResult.msgs(tmp'#2))
                             && (var results'#4 := Seq#Append(results#0, 
                                  Seq#Build(Seq#Empty(): Seq Box, 
                                    $Box(BucketsLib.__default.BucketOfSeq(BucketModel.singleMergeResult.keys(tmp'#2), 
                                        BucketModel.singleMergeResult.msgs(tmp'#2))))); 
                              BucketModel.__default.mergeToChildrenIter#canCall(Lit(top#0), Lit(bots#0), Lit(idxs#0), tmp'#2, LitInt(i#0 + 1), results'#4)))))))
             && (!Lit(BucketModel.singleMergeResult.MergeCompleted_q(Lit(tmp#0)))
               ==> (var results'#5 := Seq#Append(results#0, Seq#Build(Seq#Empty(): Seq Box, Seq#Index(Lit(bots#0), LitInt(i#0)))); 
                BucketModel.__default.mergeToChildrenIter#canCall(Lit(top#0), Lit(bots#0), Lit(idxs#0), Lit(tmp#0), LitInt(i#0 + 1), results'#5))))
         && BucketModel.__default.mergeToChildrenIter($LS($ly), 
            Lit(top#0), 
            Lit(bots#0), 
            Lit(idxs#0), 
            Lit(tmp#0), 
            LitInt(i#0), 
            Lit(results#0))
           == (if LitInt(i#0) == Seq#Length(Lit(bots#0))
             then (if BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0))
               then (var leftover_top#2 := Lit(BucketsLib.__default.BucketOfSeq(Lit(Seq#Drop(Lit(BucketsLib.Bucket.keys(Lit(top#0))), 
                          LitInt(BucketModel.singleMergeResult.end(Lit(tmp#0))))), 
                      Lit(Seq#Drop(Lit(BucketsLib.Bucket.msgs(Lit(top#0))), 
                          LitInt(BucketModel.singleMergeResult.end(Lit(tmp#0))))))); 
                Lit(#BucketModel.mergeResult.mergeResult(leftover_top#2, 
                    Lit(results#0), 
                    LitInt(BucketModel.singleMergeResult.slack(Lit(tmp#0))))))
               else #BucketModel.mergeResult.mergeResult(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)), 
                Lit(results#0), 
                LitInt(BucketModel.singleMergeResult.slack(Lit(tmp#0)))))
             else (if BucketModel.singleMergeResult.MergeCompleted_q(Lit(tmp#0))
               then (var from#2 := (if LitInt(i#0) == LitInt(0)
                     then 0
                     else $Unbox(Seq#Index(Lit(idxs#0), LitInt(i#0 - 1))): int); 
                (var to1#2 := (if LitInt(i#0) == Seq#Length(Lit(idxs#0))
                       then Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(top#0))))
                       else $Unbox(Seq#Index(Lit(idxs#0), LitInt(i#0))): int); 
                  (var to#2 := (if to1#2 < from#2 then from#2 else to1#2); 
                    (var tmp'#2 := BucketModel.__default.mergeToOneChild(StartFuel_BucketModel._default.mergeToOneChild, 
                          Lit(BucketsLib.Bucket.keys(Lit(top#0))), 
                          Lit(BucketsLib.Bucket.msgs(Lit(top#0))), 
                          from#2, 
                          to#2, 
                          BucketsLib.Bucket.keys($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                          BucketsLib.Bucket.msgs($Unbox(Seq#Index(Lit(bots#0), LitInt(i#0))): DatatypeType), 
                          LitInt(0), 
                          Lit(Seq#Empty(): Seq Box), 
                          Lit(Seq#Empty(): Seq Box), 
                          LitInt(BucketModel.singleMergeResult.slack(Lit(tmp#0)))); 
                      (var results'#4 := Seq#Append(results#0, 
                            Seq#Build(Seq#Empty(): Seq Box, 
                              $Box(BucketsLib.__default.BucketOfSeq(BucketModel.singleMergeResult.keys(tmp'#2), 
                                  BucketModel.singleMergeResult.msgs(tmp'#2))))); 
                        BucketModel.__default.mergeToChildrenIter($LS($ly), 
                          Lit(top#0), 
                          Lit(bots#0), 
                          Lit(idxs#0), 
                          tmp'#2, 
                          LitInt(i#0 + 1), 
                          results'#4))))))
               else (var results'#5 := Seq#Append(results#0, Seq#Build(Seq#Empty(): Seq Box, Seq#Index(Lit(bots#0), LitInt(i#0)))); 
                BucketModel.__default.mergeToChildrenIter($LS($ly), 
                  Lit(top#0), 
                  Lit(bots#0), 
                  Lit(idxs#0), 
                  Lit(tmp#0), 
                  LitInt(i#0 + 1), 
                  results'#5)))));

// function declaration for BucketModel._default.mergeToChildren
function BucketModel.__default.mergeToChildren($ly: LayerType, 
    top#0: DatatypeType, 
    pivots#0: Seq Box, 
    bots#0: Seq Box, 
    slack#0: int)
   : DatatypeType;

function BucketModel.__default.mergeToChildren#canCall(top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box, slack#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    top#0: DatatypeType, 
    pivots#0: Seq Box, 
    bots#0: Seq Box, 
    slack#0: int :: 
  { BucketModel.__default.mergeToChildren($LS($ly), top#0, pivots#0, bots#0, slack#0) } 
  BucketModel.__default.mergeToChildren($LS($ly), top#0, pivots#0, bots#0, slack#0)
     == BucketModel.__default.mergeToChildren($ly, top#0, pivots#0, bots#0, slack#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    top#0: DatatypeType, 
    pivots#0: Seq Box, 
    bots#0: Seq Box, 
    slack#0: int :: 
  { BucketModel.__default.mergeToChildren(AsFuelBottom($ly), top#0, pivots#0, bots#0, slack#0) } 
  BucketModel.__default.mergeToChildren($ly, top#0, pivots#0, bots#0, slack#0)
     == BucketModel.__default.mergeToChildren($LZ, top#0, pivots#0, bots#0, slack#0));

// consequence axiom for BucketModel.__default.mergeToChildren
axiom true
   ==> (forall $ly: LayerType, 
      top#0: DatatypeType, 
      pivots#0: Seq Box, 
      bots#0: Seq Box, 
      slack#0: int :: 
    { BucketModel.__default.mergeToChildren($ly, top#0, pivots#0, bots#0, slack#0) } 
    BucketModel.__default.mergeToChildren#canCall(top#0, pivots#0, bots#0, slack#0)
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && LitInt(0) <= slack#0
           && 
          BucketsLib.__default.WFBucket(top#0)
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(bots#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(bots#0)
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#0)): DatatypeType))
           && 
          0 < Seq#Length(bots#0)
           && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1)
       ==> Seq#Length(BucketModel.mergeResult.bots(BucketModel.__default.mergeToChildren($ly, top#0, pivots#0, bots#0, slack#0)))
           == Seq#Length(bots#0)
         && $Is(BucketModel.__default.mergeToChildren($ly, top#0, pivots#0, bots#0, slack#0), 
          Tclass.BucketModel.mergeResult()));

function BucketModel.__default.mergeToChildren#requires(LayerType, DatatypeType, Seq Box, Seq Box, int) : bool;

// #requires axiom for BucketModel.__default.mergeToChildren
axiom (forall $ly: LayerType, 
    top#0: DatatypeType, 
    pivots#0: Seq Box, 
    bots#0: Seq Box, 
    slack#0: int :: 
  { BucketModel.__default.mergeToChildren#requires($ly, top#0, pivots#0, bots#0, slack#0) } 
  $Is(top#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
       && LitInt(0) <= slack#0
     ==> BucketModel.__default.mergeToChildren#requires($ly, top#0, pivots#0, bots#0, slack#0)
       == (
        BucketsLib.__default.WFBucket(top#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
             ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#1)): DatatypeType))
         && 
        0 < Seq#Length(bots#0)
         && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1));

// definition axiom for BucketModel.__default.mergeToChildren(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      top#0: DatatypeType, 
      pivots#0: Seq Box, 
      bots#0: Seq Box, 
      slack#0: int :: 
    { BucketModel.__default.mergeToChildren($LS($ly), top#0, pivots#0, bots#0, slack#0) } 
    BucketModel.__default.mergeToChildren#canCall(top#0, pivots#0, bots#0, slack#0)
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && LitInt(0) <= slack#0
           && 
          BucketsLib.__default.WFBucket(top#0)
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#1)): DatatypeType))
           && 
          0 < Seq#Length(bots#0)
           && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1)
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
         && BucketModel.__default.pivotIndexes#canCall(BucketsLib.Bucket.keys(top#0), pivots#0)
         && (var idxs#0 := BucketModel.__default.pivotIndexes($LS($LZ), BucketsLib.Bucket.keys(top#0), pivots#0); 
          (var tmp#0 := #BucketModel.singleMergeResult.MergeCompleted(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box), slack#0); 
            BucketModel.__default.mergeToChildrenIter#canCall(top#0, bots#0, idxs#0, tmp#0, LitInt(0), Lit(Seq#Empty(): Seq Box))))
         && BucketModel.__default.mergeToChildren($LS($ly), top#0, pivots#0, bots#0, slack#0)
           == (var idxs#0 := BucketModel.__default.pivotIndexes($LS($LZ), BucketsLib.Bucket.keys(top#0), pivots#0); 
            (var tmp#0 := #BucketModel.singleMergeResult.MergeCompleted(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box), slack#0); 
              BucketModel.__default.mergeToChildrenIter($LS($LZ), top#0, bots#0, idxs#0, tmp#0, LitInt(0), Lit(Seq#Empty(): Seq Box)))));

// definition axiom for BucketModel.__default.mergeToChildren for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      top#0: DatatypeType, 
      pivots#0: Seq Box, 
      bots#0: Seq Box, 
      slack#0: int :: 
    {:weight 3} { BucketModel.__default.mergeToChildren($LS($ly), Lit(top#0), Lit(pivots#0), Lit(bots#0), LitInt(slack#0)) } 
    BucketModel.__default.mergeToChildren#canCall(Lit(top#0), Lit(pivots#0), Lit(bots#0), LitInt(slack#0))
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && LitInt(0) <= slack#0
           && 
          Lit(BucketsLib.__default.WFBucket(Lit(top#0)))
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(bots#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(bots#0))
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(Lit(bots#0), i#2)): DatatypeType))
           && 
          0 < Seq#Length(Lit(bots#0))
           && Seq#Length(Lit(bots#0)) == Seq#Length(Lit(pivots#0)) + 1)
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0))
         && BucketModel.__default.pivotIndexes#canCall(Lit(BucketsLib.Bucket.keys(Lit(top#0))), Lit(pivots#0))
         && (var idxs#1 := Lit(BucketModel.__default.pivotIndexes($LS($LZ), Lit(BucketsLib.Bucket.keys(Lit(top#0))), Lit(pivots#0))); 
          (var tmp#1 := Lit(#BucketModel.singleMergeResult.MergeCompleted(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box), LitInt(slack#0))); 
            BucketModel.__default.mergeToChildrenIter#canCall(Lit(top#0), Lit(bots#0), idxs#1, tmp#1, LitInt(0), Lit(Seq#Empty(): Seq Box))))
         && BucketModel.__default.mergeToChildren($LS($ly), Lit(top#0), Lit(pivots#0), Lit(bots#0), LitInt(slack#0))
           == (var idxs#1 := Lit(BucketModel.__default.pivotIndexes($LS($LZ), Lit(BucketsLib.Bucket.keys(Lit(top#0))), Lit(pivots#0))); 
            (var tmp#1 := Lit(#BucketModel.singleMergeResult.MergeCompleted(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box), LitInt(slack#0))); 
              Lit(BucketModel.__default.mergeToChildrenIter($LS($LZ), 
                  Lit(top#0), 
                  Lit(bots#0), 
                  idxs#1, 
                  tmp#1, 
                  LitInt(0), 
                  Lit(Seq#Empty(): Seq Box))))));

// function declaration for BucketModel._default.getFlushedKeys
function BucketModel.__default.getFlushedKeys(tmp#0: DatatypeType, top#0: DatatypeType) : Set Box;

function BucketModel.__default.getFlushedKeys#canCall(tmp#0: DatatypeType, top#0: DatatypeType) : bool;

// consequence axiom for BucketModel.__default.getFlushedKeys
axiom true
   ==> (forall tmp#0: DatatypeType, top#0: DatatypeType :: 
    { BucketModel.__default.getFlushedKeys(tmp#0, top#0) } 
    BucketModel.__default.getFlushedKeys#canCall(tmp#0, top#0)
         || (
          $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
           && $Is(top#0, Tclass.BucketsLib.Bucket())
           && (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
             ==> BucketModel.singleMergeResult.end(tmp#0)
               <= Seq#Length(BucketsLib.Bucket.keys(top#0))))
       ==> $Is(BucketModel.__default.getFlushedKeys(tmp#0, top#0), TSet(Tclass.KeyType.Key())));

function BucketModel.__default.getFlushedKeys#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketModel.__default.getFlushedKeys
axiom (forall tmp#0: DatatypeType, top#0: DatatypeType :: 
  { BucketModel.__default.getFlushedKeys#requires(tmp#0, top#0) } 
  $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
       && $Is(top#0, Tclass.BucketsLib.Bucket())
     ==> BucketModel.__default.getFlushedKeys#requires(tmp#0, top#0)
       == (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
         ==> BucketModel.singleMergeResult.end(tmp#0)
           <= Seq#Length(BucketsLib.Bucket.keys(top#0))));

// definition axiom for BucketModel.__default.getFlushedKeys(revealed)
axiom true
   ==> (forall tmp#0: DatatypeType, top#0: DatatypeType :: 
    { BucketModel.__default.getFlushedKeys(tmp#0, top#0) } 
    BucketModel.__default.getFlushedKeys#canCall(tmp#0, top#0)
         || (
          $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
           && $Is(top#0, Tclass.BucketsLib.Bucket())
           && (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
             ==> BucketModel.singleMergeResult.end(tmp#0)
               <= Seq#Length(BucketsLib.Bucket.keys(top#0))))
       ==> (BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(BucketsLib.Bucket.keys(top#0), i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < BucketModel.singleMergeResult.end(tmp#0)
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0)))
         && (!BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(BucketsLib.Bucket.keys(top#0), i#1)): Seq Box } 
            (LitInt(0) <= i#1 ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0))
               && (LitInt(0) <= i#1 && i#1 < Seq#Length(BucketsLib.Bucket.keys(top#0))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0))))
         && BucketModel.__default.getFlushedKeys(tmp#0, top#0)
           == (if BucketModel.singleMergeResult.SlackExhausted_q(tmp#0)
             then (lambda $y#0: Box :: 
              (exists i#0: int :: 
                { $Unbox(Seq#Index(BucketsLib.Bucket.keys(top#0), i#0)): Seq Box } 
                LitInt(0) <= i#0
                   && i#0 < BucketModel.singleMergeResult.end(tmp#0)
                   && $y#0 == Seq#Index(BucketsLib.Bucket.keys(top#0), i#0)))
             else (lambda $y#1: Box :: 
              (exists i#1: int :: 
                { $Unbox(Seq#Index(BucketsLib.Bucket.keys(top#0), i#1)): Seq Box } 
                LitInt(0) <= i#1
                   && i#1 < Seq#Length(BucketsLib.Bucket.keys(top#0))
                   && $y#1 == Seq#Index(BucketsLib.Bucket.keys(top#0), i#1)))));

// definition axiom for BucketModel.__default.getFlushedKeys for all literals(revealed)
axiom true
   ==> (forall tmp#0: DatatypeType, top#0: DatatypeType :: 
    {:weight 3} { BucketModel.__default.getFlushedKeys(Lit(tmp#0), Lit(top#0)) } 
    BucketModel.__default.getFlushedKeys#canCall(Lit(tmp#0), Lit(top#0))
         || (
          $Is(tmp#0, Tclass.BucketModel.singleMergeResult())
           && $Is(top#0, Tclass.BucketsLib.Bucket())
           && (BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0))
             ==> LitInt(BucketModel.singleMergeResult.end(Lit(tmp#0)))
               <= Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(top#0))))))
       ==> (Lit(BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0)))
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(BucketsLib.Bucket.keys(top#0), i#2)): Seq Box } 
            LitInt(0) <= i#2 && i#2 < BucketModel.singleMergeResult.end(Lit(tmp#0))
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0))))
         && (!Lit(BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0)))
           ==> (forall i#3: int :: 
            { $Unbox(Seq#Index(BucketsLib.Bucket.keys(top#0), i#3)): Seq Box } 
            (LitInt(0) <= i#3 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0)))
               && (LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(top#0))))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0)))))
         && BucketModel.__default.getFlushedKeys(Lit(tmp#0), Lit(top#0))
           == (if BucketModel.singleMergeResult.SlackExhausted_q(Lit(tmp#0))
             then (lambda $y#2: Box :: 
              (exists i#2: int :: 
                { $Unbox(Seq#Index(BucketsLib.Bucket.keys(top#0), i#2)): Seq Box } 
                LitInt(0) <= i#2
                   && i#2 < BucketModel.singleMergeResult.end(Lit(tmp#0))
                   && $y#2 == Seq#Index(Lit(BucketsLib.Bucket.keys(Lit(top#0))), i#2)))
             else (lambda $y#3: Box :: 
              (exists i#3: int :: 
                { $Unbox(Seq#Index(BucketsLib.Bucket.keys(top#0), i#3)): Seq Box } 
                LitInt(0) <= i#3
                   && i#3 < Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(top#0))))
                   && $y#3 == Seq#Index(Lit(BucketsLib.Bucket.keys(Lit(top#0))), i#3)))));

// function declaration for BucketModel._default.partialFlush
function BucketModel.__default.partialFlush($ly: LayerType, top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box)
   : DatatypeType;

function BucketModel.__default.partialFlush#canCall(top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box :: 
  { BucketModel.__default.partialFlush($LS($ly), top#0, pivots#0, bots#0) } 
  BucketModel.__default.partialFlush($LS($ly), top#0, pivots#0, bots#0)
     == BucketModel.__default.partialFlush($ly, top#0, pivots#0, bots#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box :: 
  { BucketModel.__default.partialFlush(AsFuelBottom($ly), top#0, pivots#0, bots#0) } 
  BucketModel.__default.partialFlush($ly, top#0, pivots#0, bots#0)
     == BucketModel.__default.partialFlush($LZ, top#0, pivots#0, bots#0));

// consequence axiom for BucketModel.__default.partialFlush
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box :: 
    { BucketModel.__default.partialFlush($ly, top#0, pivots#0, bots#0) } 
    BucketModel.__default.partialFlush#canCall(top#0, pivots#0, bots#0)
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          BucketsLib.__default.WFBucket(top#0)
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(bots#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(bots#0)
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#0)): DatatypeType))
           && 
          0 < Seq#Length(bots#0)
           && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1
           && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, bots#0)
             <= LitInt(Bounds.__default.MaxTotalBucketWeight()))
       ==> Seq#Length(BucketModel.partialFlushResult.bots(BucketModel.__default.partialFlush($ly, top#0, pivots#0, bots#0)))
           == Seq#Length(bots#0)
         && $Is(BucketModel.__default.partialFlush($ly, top#0, pivots#0, bots#0), 
          Tclass.BucketModel.partialFlushResult()));

function BucketModel.__default.partialFlush#requires(LayerType, DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketModel.__default.partialFlush
axiom (forall $ly: LayerType, top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box :: 
  { BucketModel.__default.partialFlush#requires($ly, top#0, pivots#0, bots#0) } 
  $Is(top#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketModel.__default.partialFlush#requires($ly, top#0, pivots#0, bots#0)
       == (
        BucketsLib.__default.WFBucket(top#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
             ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#1)): DatatypeType))
         && 
        0 < Seq#Length(bots#0)
         && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1
         && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, bots#0)
           <= LitInt(Bounds.__default.MaxTotalBucketWeight())));

// definition axiom for BucketModel.__default.partialFlush(revealed)
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box :: 
    { BucketModel.__default.partialFlush($LS($ly), top#0, pivots#0, bots#0) } 
    BucketModel.__default.partialFlush#canCall(top#0, pivots#0, bots#0)
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          BucketsLib.__default.WFBucket(top#0)
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(bots#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(bots#0)
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(bots#0, i#1)): DatatypeType))
           && 
          0 < Seq#Length(bots#0)
           && Seq#Length(bots#0) == Seq#Length(pivots#0) + 1
           && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, bots#0)
             <= LitInt(Bounds.__default.MaxTotalBucketWeight()))
       ==> Bounds.__default.MaxTotalBucketWeight#canCall()
         && BucketWeights.__default.WeightBucketList#canCall(bots#0)
         && BucketModel.__default.mergeToChildren#canCall(top#0, 
          pivots#0, 
          bots#0, 
          Bounds.__default.MaxTotalBucketWeight()
             - BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, bots#0))
         && (var res#0 := BucketModel.__default.mergeToChildren(StartFuel_BucketModel._default.mergeToChildren, 
              top#0, 
              pivots#0, 
              bots#0, 
              Bounds.__default.MaxTotalBucketWeight()
                 - BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, bots#0)); 
          BucketModel.mergeResult.mergeResult_q(res#0)
             && BucketModel.mergeResult.mergeResult_q(res#0))
         && BucketModel.__default.partialFlush($LS($ly), top#0, pivots#0, bots#0)
           == (var res#0 := BucketModel.__default.mergeToChildren(StartFuel_BucketModel._default.mergeToChildren, 
                top#0, 
                pivots#0, 
                bots#0, 
                Bounds.__default.MaxTotalBucketWeight()
                   - BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, bots#0)); 
            #BucketModel.partialFlushResult.partialFlushResult(BucketModel.mergeResult.top(res#0), BucketModel.mergeResult.bots(res#0))));

// definition axiom for BucketModel.__default.partialFlush for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, pivots#0: Seq Box, bots#0: Seq Box :: 
    {:weight 3} { BucketModel.__default.partialFlush($LS($ly), Lit(top#0), Lit(pivots#0), Lit(bots#0)) } 
    BucketModel.__default.partialFlush#canCall(Lit(top#0), Lit(pivots#0), Lit(bots#0))
         || (
          $Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(bots#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          Lit(BucketsLib.__default.WFBucket(Lit(top#0)))
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(bots#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(bots#0))
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(Lit(bots#0), i#2)): DatatypeType))
           && 
          0 < Seq#Length(Lit(bots#0))
           && Seq#Length(Lit(bots#0)) == Seq#Length(Lit(pivots#0)) + 1
           && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, Lit(bots#0))
             <= LitInt(Bounds.__default.MaxTotalBucketWeight()))
       ==> Bounds.__default.MaxTotalBucketWeight#canCall()
         && BucketWeights.__default.WeightBucketList#canCall(Lit(bots#0))
         && BucketModel.__default.mergeToChildren#canCall(Lit(top#0), 
          Lit(pivots#0), 
          Lit(bots#0), 
          Bounds.__default.MaxTotalBucketWeight()
             - BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, Lit(bots#0)))
         && (var res#1 := BucketModel.__default.mergeToChildren(StartFuel_BucketModel._default.mergeToChildren, 
              Lit(top#0), 
              Lit(pivots#0), 
              Lit(bots#0), 
              Bounds.__default.MaxTotalBucketWeight()
                 - BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, Lit(bots#0))); 
          BucketModel.mergeResult.mergeResult_q(res#1)
             && BucketModel.mergeResult.mergeResult_q(res#1))
         && BucketModel.__default.partialFlush($LS($ly), Lit(top#0), Lit(pivots#0), Lit(bots#0))
           == (var res#1 := BucketModel.__default.mergeToChildren(StartFuel_BucketModel._default.mergeToChildren, 
                Lit(top#0), 
                Lit(pivots#0), 
                Lit(bots#0), 
                Bounds.__default.MaxTotalBucketWeight()
                   - BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, Lit(bots#0))); 
            #BucketModel.partialFlushResult.partialFlushResult(BucketModel.mergeResult.top(res#1), BucketModel.mergeResult.bots(res#1))));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$BucketModel.__default.reveal__mergeToOneChild();
  free requires 44 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_BucketModel._default.mergeToOneChild0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$BucketModel.__default.reveal__mergeToOneChild();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_BucketModel._default.mergeToOneChild
     == $LS(MoreFuel_BucketModel._default.mergeToOneChild0);
  free ensures StartFuelAssert_BucketModel._default.mergeToOneChild
     == $LS($LS(MoreFuel_BucketModel._default.mergeToOneChild0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_BucketModel._default.mergeToOneChild0)
     == MoreFuel_BucketModel._default.mergeToOneChild0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$BucketModel.__default.reveal__mergeToChildren();
  free requires 45 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_BucketModel._default.mergeToChildren0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$BucketModel.__default.reveal__mergeToChildren();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_BucketModel._default.mergeToChildren
     == $LS(MoreFuel_BucketModel._default.mergeToChildren0);
  free ensures StartFuelAssert_BucketModel._default.mergeToChildren
     == $LS($LS(MoreFuel_BucketModel._default.mergeToChildren0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_BucketModel._default.mergeToChildren0)
     == MoreFuel_BucketModel._default.mergeToChildren0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$BucketModel.__default.reveal__partialFlush();
  free requires 46 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_BucketModel._default.partialFlush0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$BucketModel.__default.reveal__partialFlush();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_BucketModel._default.partialFlush
     == $LS(MoreFuel_BucketModel._default.partialFlush0);
  free ensures StartFuelAssert_BucketModel._default.partialFlush
     == $LS($LS(MoreFuel_BucketModel._default.partialFlush0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_BucketModel._default.partialFlush0)
     == MoreFuel_BucketModel._default.partialFlush0;



const unique field$keys: NameFamily;

const unique field$messages: NameFamily;

const unique field$Repr: NameFamily;

const unique field$offsets: NameFamily;

const unique field$data: NameFamily;

const unique field$nstrings: NameFamily;
